import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

ALBERRYUS_LETTER = 964
EVERGREEN_AMULET = 965
DRYAD_TEARS = 966
ALBERRYUS_LIST = 746
COBS_MEDICINE1 = 1130
COBS_MEDICINE2 = 1131
COBS_MEDICINE3 = 1132
COBS_MEDICINE4 = 1133
COBS_MEDICINE5 = 1134
SWORD_OF_SENTINEL = 743
STAFF_OF_SENTINEL = 744

def check(st):
  if st.getQuestItemsCount(COBS_MEDICINE2) == 0 and st.getQuestItemsCount(COBS_MEDICINE3) == 0 and st.getQuestItemsCount(COBS_MEDICINE4) == 0 and st.getQuestItemsCount(COBS_MEDICINE5) == 0 :
    st.set("cond","6")

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30284-02.htm" :
        st.set("cond","1")
        st.setState(STARTED)
        st.giveItems(ALBERRYUS_LETTER,1)
        st.playSound("ItemSound.quest_accept")
    return htmltext

 def onTalk (Self,npc,st):
   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30284 :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getRace().ordinal() != 1 :
               htmltext = "30284-00.htm"
            elif st.getPlayer().getLevel() >= 12 :
               htmltext = "30284-07.htm"
               return htmltext
            else:
               htmltext = "30284-08.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 1 and st.getQuestItemsCount(ALBERRYUS_LETTER) == 1 :
         htmltext = "30284-03.htm"
      elif cond == 2 and st.getQuestItemsCount(EVERGREEN_AMULET) == 1 :
        htmltext = "30284-09.htm"
      elif cond == 4 and st.getQuestItemsCount(COBS_MEDICINE1) == 1 :
        st.set("cond","5")
        st.takeItems(COBS_MEDICINE1,1)
        st.giveItems(ALBERRYUS_LIST,1)
        htmltext = "30284-04.htm"
      elif cond == 5 :
        htmltext = "30284-05.htm"
      elif cond == 6 and st.getQuestItemsCount(ALBERRYUS_LIST) == 1 :
        st.takeItems(ALBERRYUS_LIST,1)
        st.set("cond","0")
        st.setState(COMPLETED)
        st.playSound("ItemSound.quest_finish")
        htmltext = "30284-06.htm"
        st.giveItems(1060,100)
        for item in range(4412,4416) :
          st.giveItems(item,10)
        if st.getPlayer().getClassId().isMage() :
          st.giveItems(5790,3000)
          st.giveItems(STAFF_OF_SENTINEL,1)
        else :
          st.giveItems(5789,6000)
          st.giveItems(SWORD_OF_SENTINEL,1)
   elif npcId == 30156 :
      if cond == 1 and st.getQuestItemsCount(ALBERRYUS_LETTER) == 1 :
         st.takeItems(ALBERRYUS_LETTER,1)
         st.giveItems(EVERGREEN_AMULET,1)
         st.set("cond","2")
         htmltext = "30156-03.htm"
      elif cond == 2 and st.getQuestItemsCount(EVERGREEN_AMULET) > 0 and st.getQuestItemsCount(DRYAD_TEARS) < 10 :
         htmltext = "30156-04.htm"
      elif cond > 3 and st.getQuestItemsCount(ALBERRYUS_LIST) > 0 :
         htmltext = "30156-07.htm"
      elif cond == 3 and st.getQuestItemsCount(EVERGREEN_AMULET) > 0 and st.getQuestItemsCount(DRYAD_TEARS) >= 10 :
         st.takeItems(EVERGREEN_AMULET,1)
         st.takeItems(DRYAD_TEARS,-1)
         st.giveItems(COBS_MEDICINE1,1)
         st.giveItems(COBS_MEDICINE2,1)
         st.giveItems(COBS_MEDICINE3,1)
         st.giveItems(COBS_MEDICINE4,1)
         st.giveItems(COBS_MEDICINE5,1)
         st.set("cond","4")
         htmltext = "30156-05.htm"
      elif cond == 4 :
         htmltext = "30156-06.htm"
   elif npcId == 30217 and cond == 5 and st.getQuestItemsCount(ALBERRYUS_LIST) == 1 and st.getQuestItemsCount(COBS_MEDICINE2) == 1 :
     st.takeItems(COBS_MEDICINE2,1)
     htmltext = "30217-01.htm"
     check(st)
   elif npcId == 30219 and cond == 5 and st.getQuestItemsCount(ALBERRYUS_LIST) == 1 and st.getQuestItemsCount(COBS_MEDICINE3) == 1 :
     st.takeItems(COBS_MEDICINE3,1)
     htmltext = "30219-01.htm"
     check(st)
   elif npcId == 30221 and cond == 5 and st.getQuestItemsCount(ALBERRYUS_LIST) == 1 and st.getQuestItemsCount(COBS_MEDICINE4) == 1 :
     st.takeItems(COBS_MEDICINE4,1)
     htmltext = "30221-01.htm"
     check(st)
   elif npcId == 30285 and cond == 5 and st.getQuestItemsCount(ALBERRYUS_LIST) == 1 and st.getQuestItemsCount(COBS_MEDICINE5) == 1 :
     st.takeItems(COBS_MEDICINE5,1)
     htmltext = "30285-01.htm"
     check(st)
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   if npcId == 20013 or npcId == 20019 and st.getRandom(10) < 3 :
      if st.getQuestItemsCount(EVERGREEN_AMULET) > 0 and st.getQuestItemsCount(DRYAD_TEARS) < 10 :
         st.giveItems(DRYAD_TEARS,1)
         if st.getQuestItemsCount(DRYAD_TEARS) == 10 :
            st.set("cond","3")
            st.playSound("ItemSound.quest_middle")
         else:
            st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(102,"102_SeaofSporesFever","Sea of Spores Fever")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30284)

QUEST.addTalkId(30284)

QUEST.addTalkId(30156)
QUEST.addTalkId(30217)
QUEST.addTalkId(30219)
QUEST.addTalkId(30221)
QUEST.addTalkId(30284)
QUEST.addTalkId(30285)

QUEST.addKillId(20013)
QUEST.addKillId(20019)

STARTED.addQuestDrop(30284,ALBERRYUS_LETTER,1)
STARTED.addQuestDrop(30156,EVERGREEN_AMULET,1)
STARTED.addQuestDrop(20013,DRYAD_TEARS,1)
STARTED.addQuestDrop(20019,DRYAD_TEARS,1)
STARTED.addQuestDrop(30156,COBS_MEDICINE1,1)
STARTED.addQuestDrop(30156,COBS_MEDICINE2,1)
STARTED.addQuestDrop(30156,COBS_MEDICINE3,1)
STARTED.addQuestDrop(30156,COBS_MEDICINE4,1)
STARTED.addQuestDrop(30156,COBS_MEDICINE5,1)
STARTED.addQuestDrop(30284,ALBERRYUS_LIST,1)

print "importing quests: 102: Sea of Spores Fever"