import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

GOUPHS_CONTRACT = 1559
REEPS_CONTRACT = 1560
ELVEN_WINE = 1561
BRONPS_DICE = 1562
BRONPS_CONTRACT = 1563
AQUAMARINE = 1564
CHRYSOBERYL = 1565
GEM_BOX1 = 1566
COAL_PIECE = 1567
BRONPS_LETTER = 1568
BERRY_TART = 1569
BAT_DIAGRAM = 1570
STAR_DIAMOND = 1571
SILVERSMITH_HAMMER = 1511

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30523-03.htm" :
          st.set("cond","1")
          st.setState(STARTED)
          st.giveItems(GOUPHS_CONTRACT,1)
          st.playSound("ItemSound.quest_accept")
    elif event == "30555-02.htm" :
          st.takeItems(REEPS_CONTRACT,1)
          st.giveItems(ELVEN_WINE,1)
          st.set("cond","3")
    elif event == "30526-02.htm" :
          st.takeItems(BRONPS_DICE,1)
          st.giveItems(BRONPS_CONTRACT,1)
          st.set("cond","5")
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30523 :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getRace().ordinal() != 4 :
               htmltext = "30523-00.htm"
               st.exitCurrentQuest(True)
            elif st.getPlayer().getLevel() >= 10 :
               htmltext = "30523-02.htm"
            else:
               htmltext = "30523-01.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 0 and st.getQuestItemsCount(GOUPHS_CONTRACT) :
         htmltext = "30523-04.htm"
      elif cond > 1 and cond < 7 and (st.getQuestItemsCount(REEPS_CONTRACT) or st.getQuestItemsCount(ELVEN_WINE) or st.getQuestItemsCount(BRONPS_DICE) or st.getQuestItemsCount(BRONPS_CONTRACT)) :
          htmltext = "30523-05.htm"
      elif cond == 7 and st.getQuestItemsCount(GEM_BOX1) :
          htmltext = "30523-06.htm"
          st.takeItems(GEM_BOX1,1)
          st.giveItems(COAL_PIECE,1)
          st.set("cond","8")
      elif cond > 7 and cond < 12 and (st.getQuestItemsCount(BRONPS_LETTER) or st.getQuestItemsCount(COAL_PIECE) or st.getQuestItemsCount(BERRY_TART) or st.getQuestItemsCount(BAT_DIAGRAM)) :
          htmltext = "30523-07.htm"
      elif cond == 12 and st.getQuestItemsCount(STAR_DIAMOND) :
          htmltext = "30523-08.htm"
          st.takeItems(STAR_DIAMOND,1)
          for item in range(4412,4417) :
             st.giveItems(item,10)
          st.giveItems(1060,100)
          if st.getPlayer().getLevel() < 25 :
             if st.getPlayer().getClassId().isMage() :
                st.playTutorialVoice("tutorial_voice_027")
                st.giveItems(5790,3000)
             else :
                st.playTutorialVoice("tutorial_voice_026")
                st.giveItems(5789,6000)
          st.giveItems(SILVERSMITH_HAMMER,1)
          st.playSound("ItemSound.quest_finish")
          st.unset("cond")
          st.setState(COMPLETED)
   elif npcId == 30516 :
      if cond == 1 and st.getQuestItemsCount(GOUPHS_CONTRACT) :
          htmltext = "30516-01.htm"
          st.giveItems(REEPS_CONTRACT,1)
          st.takeItems(GOUPHS_CONTRACT,1)
          st.set("cond","2")
      elif cond >= 2 :
          htmltext = "30516-02.htm"
   elif npcId == 30555 :
      if cond == 2 and st.getQuestItemsCount(REEPS_CONTRACT) == 1 :
          htmltext = "30555-01.htm"
      elif cond == 3 and st.getQuestItemsCount(ELVEN_WINE) :
          htmltext = "30555-03.htm"
      elif cond == 7 and st.getQuestItemsCount(GEM_BOX1) == 1 :
          htmltext = "30555-04.htm"
      else :
          htmltext = "30555-05.htm"
   elif npcId == 30529 :
      if cond == 3 and st.getQuestItemsCount(ELVEN_WINE) :
          st.takeItems(ELVEN_WINE,1)
          st.giveItems(BRONPS_DICE,1)
          htmltext = "30529-01.htm"
          st.set("cond","4")
      elif cond == 4 :
          htmltext = "30529-02.htm"
      else :
          htmltext = "30529-03.htm"
   elif npcId == 30526 :
      if cond == 4 and st.getQuestItemsCount(BRONPS_DICE) :
          htmltext = "30526-01.htm"
      elif cond == 5 and st.getQuestItemsCount(BRONPS_CONTRACT) and (st.getQuestItemsCount(AQUAMARINE) < 10 or st.getQuestItemsCount(CHRYSOBERYL) < 10) :
          htmltext = "30526-03.htm"
      elif cond == 6 and st.getQuestItemsCount(BRONPS_CONTRACT) and st.getQuestItemsCount(AQUAMARINE) == 10 and st.getQuestItemsCount(CHRYSOBERYL) == 10 :
          htmltext = "30526-04.htm"
          st.takeItems(BRONPS_CONTRACT,-1)
          st.takeItems(AQUAMARINE,-1)
          st.takeItems(CHRYSOBERYL,-1)
          st.giveItems(GEM_BOX1,1)
          st.set("cond","7")
      elif cond == 7 and st.getQuestItemsCount(GEM_BOX1) :
          htmltext = "30526-05.htm"
      elif cond == 8 and st.getQuestItemsCount(COAL_PIECE) :
          htmltext = "30526-06.htm"
          st.takeItems(COAL_PIECE,1)
          st.giveItems(BRONPS_LETTER,1)
          st.set("cond","9")
      elif cond == 9 and st.getQuestItemsCount(BRONPS_LETTER) :
          htmltext = "30526-07.htm"
      else :
          htmltext = "30526-08.htm"
   elif npcId == 30521 :
      if cond == 9 and st.getQuestItemsCount(BRONPS_LETTER) :
          htmltext = "30521-01.htm"
          st.takeItems(BRONPS_LETTER,1)
          st.giveItems(BERRY_TART,1)
          st.set("cond","10")
      elif cond == 10 and st.getQuestItemsCount(BERRY_TART) :
          htmltext = "30521-02.htm"
      else :
          htmltext = "30521-03.htm"
   elif npcId == 30522 :
      if cond == 10 and st.getQuestItemsCount(BERRY_TART) :
          htmltext = "30522-01.htm"
          st.takeItems(BERRY_TART,1)
          st.giveItems(BAT_DIAGRAM,1)
          st.set("cond","11")
      elif cond == 11 and st.getQuestItemsCount(BAT_DIAGRAM) :
          htmltext = "30522-02.htm"
      elif cond == 12 and st.getQuestItemsCount(STAR_DIAMOND) :
          htmltext = "30522-03.htm"
      else :
          htmltext = "30522-04.htm"

   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   rand = st.getRandom(100)
   cond = st.getInt("cond")
   if npcId == 20323 or npcId == 20324 :
        if cond == 5 and st.getQuestItemsCount(BRONPS_CONTRACT) :
          if rand < 25 :
            if st.getQuestItemsCount(AQUAMARINE) < 10 :
                st.giveItems(AQUAMARINE,1)
                if rand < 10 and st.getQuestItemsCount(CHRYSOBERYL) < 10 :
                   st.giveItems(CHRYSOBERYL,1)
                if st.getQuestItemsCount(AQUAMARINE) < 10 :
                   st.playSound("ItemSound.quest_itemget")
                else :
                   st.playSound("ItemSound.quest_middle")
                   if st.getQuestItemsCount(AQUAMARINE) == 10 and st.getQuestItemsCount(CHRYSOBERYL) == 10 :
                      st.set("cond","6")
          elif rand > 70 :
            if st.getQuestItemsCount(CHRYSOBERYL) < 10 :
                st.giveItems(CHRYSOBERYL,1)
                if rand > 90 and st.getQuestItemsCount(AQUAMARINE) < 10 :
                   st.giveItems(AQUAMARINE,1)
                if st.getQuestItemsCount(CHRYSOBERYL) < 10 :
                   st.playSound("ItemSound.quest_itemget")
                else :
                   st.playSound("ItemSound.quest_middle")
                   if st.getQuestItemsCount(AQUAMARINE) == 10 and st.getQuestItemsCount(CHRYSOBERYL) == 10 :
                      st.set("cond","6")
   elif npcId == 20480 :
        if cond == 11 and st.getQuestItemsCount(BAT_DIAGRAM) and st.getQuestItemsCount(STAR_DIAMOND) == 0 :
          if st.getRandom(10) < 2 :
            st.takeItems(BAT_DIAGRAM,1)
            st.giveItems(STAR_DIAMOND,1)
            st.set("cond","12")
            st.playSound("ItemSound.quest_middle")
   return

QUEST       = Quest(108,"108_JumbleTumbleDiamondFuss","JumbleTumbleDiamondFuss")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30523)

QUEST.addTalkId(30523)
QUEST.addTalkId(30523)

QUEST.addTalkId(30516)
QUEST.addTalkId(30521)
QUEST.addTalkId(30522)
QUEST.addTalkId(30523)
QUEST.addTalkId(30526)
QUEST.addTalkId(30529)
QUEST.addTalkId(30555)

QUEST.addKillId(20323)
QUEST.addKillId(20324)
QUEST.addKillId(20480)

STARTED.addQuestDrop(30526,GEM_BOX1,1)
STARTED.addQuestDrop(20480,STAR_DIAMOND,1)
STARTED.addQuestDrop(30523,GOUPHS_CONTRACT,1)
STARTED.addQuestDrop(30516,REEPS_CONTRACT,1)
STARTED.addQuestDrop(30555,ELVEN_WINE,1)
STARTED.addQuestDrop(30526,BRONPS_CONTRACT,1)
STARTED.addQuestDrop(20323,AQUAMARINE,1)
STARTED.addQuestDrop(20324,AQUAMARINE,1)
STARTED.addQuestDrop(20323,CHRYSOBERYL,1)
STARTED.addQuestDrop(20324,CHRYSOBERYL,1)
STARTED.addQuestDrop(30523,COAL_PIECE,1)
STARTED.addQuestDrop(30529,BRONPS_DICE,1)
STARTED.addQuestDrop(30526,BRONPS_LETTER,1)
STARTED.addQuestDrop(30521,BERRY_TART,1)
STARTED.addQuestDrop(30522,BAT_DIAGRAM,1)

print "importing quests: 108: Jumble, Tumble, Diamond Fuss"
