import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

PINTER = 30298
MAILLE_LIZARDMAN = 20919
BLOOD_OF_MAILLE_LIZARDMAN = 8062
KING_OF_THE_ARANEID = 20927
KING_OF_THE_ARANEID_LEG = 8063
D_CRY = 1458
D_CRY_COUNT_HEAVY = 922
D_CRY_COUNT_LIGHT_MAGIC = 771

CLAN_OATH_HELM = 7850

CLAN_OATH_ARMOR = 7851
CLAN_OATH_GAUNTLETS = 7852
CLAN_OATH_SABATON = 7853

CLAN_OATH_BRIGANDINE = 7854
CLAN_OATH_LEATHER_GLOVES = 7855
CLAN_OATH_BOOTS = 7856

CLAN_OATH_AKETON = 7857
CLAN_OATH_PADDED_GLOVES = 7858
CLAN_OATH_SANDALS = 7859

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30298-03.htm" :
        st.set("cond","1")
        st.setState(STARTED)
        st.playSound("ItemSound.quest_accept")
    elif event == "30298-05.htm" :
        st.set("choose","1")
        st.set("cond","3")
    elif event == "30298-06.htm" :
        st.set("choose","2")
        st.set("cond","4")
    elif event == "30298-07.htm" :
        st.set("choose","3")
        st.set("cond","5")
    elif event == "30298-08.htm" :
        choose = st.getInt("choose")
        D_CRY_COUNT = D_CRY_COUNT_LIGHT_MAGIC
        if choose == 1 :
            D_CRY_COUNT = D_CRY_COUNT_HEAVY
        if st.getQuestItemsCount(D_CRY) >= D_CRY_COUNT :
            st.set("cond","7")
            st.takeItems(D_CRY,D_CRY_COUNT)
        else :
            htmltext = "<html><body>771 D Cry!</body></html>"
    return htmltext

 def onTalk (Self,npc,st) :
    npcId = npc.getNpcId()
    htmltext = "<html><body>I have nothing to say you</body></html>"
    id = st.getState()
    cond = st.getInt("cond")
    if cond == 0 :
        if id == COMPLETED :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
            return htmltext
        elif st.getPlayer().getLevel() < 19 :
            htmltext = "<html><body>Your level is too low</body></html>"
            return htmltext
        elif st.getPlayer().getClanId() == 0 :
            htmltext = "<html><body>You are not in clan</body></html>"
            return htmltext
        elif st.getPlayer().getSponsor() == 0 :
            htmltext = "<html><body>You have no sponsor</body></html>"
            return htmltext
        else :
            htmltext = "30298-00.htm"
    elif cond == 1 :
        htmltext = "<html><body>Bring me 10 Bruin Lizardmen blood.</body></html>"
    elif cond == 2 :
        st.takeItems(BLOOD_OF_MAILLE_LIZARDMAN,10)
        htmltext = "30298-04.htm"
    elif cond == 3 :
        htmltext = "30298-05.htm"
    elif cond == 4 :
        htmltext = "30298-06.htm"
    elif cond == 5 :
        htmltext = "30298-07.htm"
    elif cond == 7 :
        htmltext = "<html><body>Bring me 8 Picot Legs.</body></html>"
    elif cond == 8 :
        st.takeItems(KING_OF_THE_ARANEID_LEG,8)
        choose = st.getInt("choose")
        st.giveItems(CLAN_OATH_HELM,1)
        if choose == 1 :
            st.giveItems(CLAN_OATH_ARMOR,1)
            st.giveItems(CLAN_OATH_GAUNTLETS,1)
            st.giveItems(CLAN_OATH_SABATON,1)
        elif choose == 2 :
            st.giveItems(CLAN_OATH_BRIGANDINE,1)
            st.giveItems(CLAN_OATH_LEATHER_GLOVES,1)
            st.giveItems(CLAN_OATH_BOOTS,1)
        elif choose == 3 :
            st.giveItems(CLAN_OATH_AKETON,1)
            st.giveItems(CLAN_OATH_PADDED_GLOVES,1)
            st.giveItems(CLAN_OATH_SANDALS,1)
        st.set("cond","0")
        st.setState(COMPLETED)
        st.playSound("ItemSound.quest_finish")
        htmltext = "<html><body>OK!</body></html>"
    return htmltext

 def onKill (self,npc,st):
    npcId = npc.getNpcId()
    cond = st.getInt("cond")
    if npcId == MAILLE_LIZARDMAN :
        if st.getQuestItemsCount(BLOOD_OF_MAILLE_LIZARDMAN) < 10 and cond == 1 :
            if st.getRandom(2) == 0 :
                st.giveItems(BLOOD_OF_MAILLE_LIZARDMAN,1)
                if st.getQuestItemsCount(BLOOD_OF_MAILLE_LIZARDMAN) == 10 :
                    st.playSound("ItemSound.quest_middle")
                    st.set("cond","2")
    elif npcId == KING_OF_THE_ARANEID :
        if st.getQuestItemsCount(KING_OF_THE_ARANEID_LEG) < 8 and cond == 7 :
            if st.getRandom(2) == 0 :
                st.giveItems(KING_OF_THE_ARANEID_LEG,1)
                if st.getQuestItemsCount(KING_OF_THE_ARANEID_LEG) == 8 :
                    st.playSound("ItemSound.quest_middle")
                    st.set("cond","8")
    return

QUEST       = Quest(118,"118_ToLeadAndBeLed","To Lead and Be Led")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(PINTER)
QUEST.addTalkId(PINTER)
QUEST.addTalkId(PINTER)
QUEST.addTalkId(PINTER)

QUEST.addKillId(MAILLE_LIZARDMAN)
QUEST.addKillId(KING_OF_THE_ARANEID)

STARTED.addQuestDrop(MAILLE_LIZARDMAN,BLOOD_OF_MAILLE_LIZARDMAN,1)
STARTED.addQuestDrop(KING_OF_THE_ARANEID,KING_OF_THE_ARANEID_LEG,1)

print "importing quests: 118: To Lead and Be Led"
