import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

NEWYEAR = 31961
BRUIN_LIZARDMEN = 27321
BRUIN_BLOOD = 8549
PICOT_ARANEID = 27322
PICOT_LEG = 8550
D_CRY = 1458
D_CRY_COUNT_HEAVY = 922
D_CRY_COUNT_LIGHT_MAGIC = 771

CLAN_OATH_HELM = 7850

CLAN_OATH_ARMOR = 7851
CLAN_OATH_GAUNTLETS = 7852
CLAN_OATH_SABATON = 7853

CLAN_OATH_BRIGANDINE = 7854
CLAN_OATH_LEATHER_GLOVES = 7855
CLAN_OATH_BOOTS = 7856

CLAN_OATH_AKETON = 7857
CLAN_OATH_PADDED_GLOVES = 7858
CLAN_OATH_SANDALS = 7859

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31961-03.htm" :
        st.set("cond","1")
        st.setState(STARTED)
        st.playSound("ItemSound.quest_accept")
    elif event == "31961-05.htm" :
        st.set("choose","1")
        st.set("cond","3")
    elif event == "31961-06.htm" :
        st.set("choose","2")
        st.set("cond","4")
    elif event == "31961-07.htm" :
        st.set("choose","3")
        st.set("cond","5")
    elif event == "31961-08.htm" :
        choose = st.getInt("choose")
        D_CRY_COUNT = D_CRY_COUNT_LIGHT_MAGIC
        if choose == 1 :
            D_CRY_COUNT = D_CRY_COUNT_HEAVY
        if st.getQuestItemsCount(D_CRY) >= D_CRY_COUNT :
            st.set("cond","7")
            st.takeItems(D_CRY,D_CRY_COUNT)
        else :
            htmltext = "<html><body>771 D Cry!</body></html>"
    return htmltext

 def onTalk (Self,npc,st) :
    npcId = npc.getNpcId()
    htmltext = "<html><body>I have nothing to say you</body></html>"
    id = st.getState()
    cond = st.getInt("cond")
    if cond == 0 :
        if id == COMPLETED :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
            return htmltext
        elif st.getPlayer().getLevel() < 19 :
            htmltext = "<html><body>Your level is too low</body></html>"
            return htmltext
        elif st.getPlayer().getClanId() == 0 :
            htmltext = "<html><body>You are not in clan</body></html>"
            return htmltext
        elif st.getPlayer().getSponsor() == 0 :
            htmltext = "<html><body>You have no sponsor</body></html>"
            return htmltext
        else :
            htmltext = "31961-00.htm"
    elif cond == 1 :
        htmltext = "<html><body>Bring me 10 Bruin Lizardmen blood.</body></html>"
    elif cond == 2 :
        st.takeItems(BRUIN_BLOOD,10)
        htmltext = "31961-04.htm"
    elif cond == 3 :
        htmltext = "31961-05.htm"
    elif cond == 4 :
        htmltext = "31961-06.htm"
    elif cond == 5 :
        htmltext = "31961-07.htm"
    elif cond == 7 :
        htmltext = "<html><body>Bring me 8 Picot Legs.</body></html>"
    elif cond == 8 :
        st.takeItems(PICOT_LEG,8)
        choose = st.getInt("choose")
        st.giveItems(CLAN_OATH_HELM,1)
        if choose == 1 :
            st.giveItems(CLAN_OATH_ARMOR,1)
            st.giveItems(CLAN_OATH_GAUNTLETS,1)
            st.giveItems(CLAN_OATH_SABATON,1)
        elif choose == 2 :
            st.giveItems(CLAN_OATH_BRIGANDINE,1)
            st.giveItems(CLAN_OATH_LEATHER_GLOVES,1)
            st.giveItems(CLAN_OATH_BOOTS,1)
        elif choose == 3 :
            st.giveItems(CLAN_OATH_AKETON,1)
            st.giveItems(CLAN_OATH_PADDED_GLOVES,1)
            st.giveItems(CLAN_OATH_SANDALS,1)
        st.set("cond","0")
        st.setState(COMPLETED)
        st.playSound("ItemSound.quest_finish")
        htmltext = "<html><body>OK!</body></html>"
    return htmltext

 def onKill (self,npc,st):
    npcId = npc.getNpcId()
    cond = st.getInt("cond")
    if npcId == BRUIN_LIZARDMEN :
        if st.getQuestItemsCount(BRUIN_BLOOD) < 10 and cond == 1 :
            if st.getRandom(2) == 0 :
                st.giveItems(BRUIN_BLOOD,1)
                if st.getQuestItemsCount(BRUIN_BLOOD) == 10 :
                    st.playSound("ItemSound.quest_middle")
                    st.set("cond","2")
    elif npcId == PICOT_ARANEID :
        if st.getQuestItemsCount(PICOT_LEG) < 8 and cond == 7 :
            if st.getRandom(2) == 0 :
                st.giveItems(PICOT_LEG,1)
                if st.getQuestItemsCount(PICOT_LEG) == 8 :
                    st.playSound("ItemSound.quest_middle")
                    st.set("cond","8")
    return

QUEST       = Quest(123,"123_TheLeaderAndTheFollower","The Leader and the Follower")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(NEWYEAR)
QUEST.addTalkId(NEWYEAR)
QUEST.addTalkId(NEWYEAR)
QUEST.addTalkId(NEWYEAR)

QUEST.addKillId(BRUIN_LIZARDMEN)
QUEST.addKillId(PICOT_ARANEID)

STARTED.addQuestDrop(BRUIN_LIZARDMEN,BRUIN_BLOOD,1)
STARTED.addQuestDrop(PICOT_ARANEID,PICOT_LEG,1)

print "importing quests: 123: The Leader and the Follower"
