import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

POISON_SAC = 703
FEVER_MEDICINE = 704
ROUND_SHIELD = 102

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30050-03.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30050 :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getLevel() >= 15 :
               htmltext = "30050-02.htm"
               return htmltext
            else:
               htmltext = "30050-01.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 3 and st.getQuestItemsCount(FEVER_MEDICINE) == 1 :
         st.giveItems(ROUND_SHIELD,1)
         st.takeItems(FEVER_MEDICINE,-1)
         htmltext = "30050-06.htm"
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
      elif cond == 1 and st.getQuestItemsCount(POISON_SAC)==1 :
         htmltext = "30050-05.htm"
      elif cond == 1 and st.getQuestItemsCount(POISON_SAC) == 0 and st.getQuestItemsCount(FEVER_MEDICINE) == 0 :
         htmltext = "30050-04.htm"
   elif npcId == 30032 :
      if cond == 2 and st.getQuestItemsCount(POISON_SAC) > 0 :
         st.giveItems(FEVER_MEDICINE,1)
         st.takeItems(POISON_SAC,-1)
         st.set("cond","3")
         htmltext = "30032-01.htm"
      elif cond == 3 and st.getQuestItemsCount(FEVER_MEDICINE) > 0 :
         htmltext = "30032-02.htm"
   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   if npcId in [20103,20106,20108] and st.getQuestItemsCount(POISON_SAC) == 0 and st.getInt("cond") == 1 :
      if st.getRandom(5) == 0 :
         st.set("cond","2")
         st.giveItems(POISON_SAC,1)
         st.playSound("ItemSound.quest_middle")
   return

QUEST       = Quest(151,"151_SaveMySister","Save My Sister")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30050)

QUEST.addTalkId(30050)
QUEST.addTalkId(30032)
QUEST.addTalkId(30050)
QUEST.addTalkId(30050)

QUEST.addKillId(20103)
QUEST.addKillId(20106)
QUEST.addKillId(20108)

STARTED.addQuestDrop(30032,FEVER_MEDICINE,1)
STARTED.addQuestDrop(20103,POISON_SAC,1)
STARTED.addQuestDrop(20106,POISON_SAC,1)
STARTED.addQuestDrop(20108,POISON_SAC,1)

print "importing quests: 151: Save My Sister"