import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

LILITHS_LETTER = 1022
THEONS_DIARY = 1023
GR_COMP_PACKAGE_SS = 5250
GR_COMP_PACKAGE_SPS = 5256

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30368-06.htm" :
       if st.getPlayer().getLevel() >= 15 :
          st.giveItems(LILITHS_LETTER,1)
          st.set("cond","1")
          st.setState(STARTED)
          st.playSound("ItemSound.quest_accept")
       else:
          htmltext = "30368-05.htm"
    elif event == "156_1" :
       st.takeItems(LILITHS_LETTER,-1)
       if st.getQuestItemsCount(THEONS_DIARY) == 0 :
          st.giveItems(THEONS_DIARY,1)
          st.set("cond","2")
       htmltext = "30369-03.htm"
    elif event == "156_2" :
       st.takeItems(LILITHS_LETTER,-1)
       st.addExpAndSp(3000,0)
       st.set("cond","0")
       st.setState(COMPLETED)
       st.playSound("ItemSound.quest_finish")
       st.set("onlyone","1")
       htmltext = "30369-04.htm"
    return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30368 :
      if cond == 0 :
         if id != COMPLETED :
            htmltext = "30368-02.htm"
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 1 and st.getQuestItemsCount(LILITHS_LETTER) == 1 :
         htmltext = "30368-07.htm"
      elif cond == 2 and st.getQuestItemsCount(THEONS_DIARY) == 1 :
         st.takeItems(THEONS_DIARY,-1)
         if st.getPlayer().getClassId().isMage() :
            st.giveItems(GR_COMP_PACKAGE_SPS,1)
         else :
            st.giveItems(GR_COMP_PACKAGE_SS,1)
         st.addExpAndSp(6000,0)
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
         htmltext = "30368-08.htm"
   elif npcId == 30369 :
      if cond == 1 and st.getQuestItemsCount(LILITHS_LETTER) == 1 :
         htmltext = "30369-02.htm"
      elif cond == 2 and st.getQuestItemsCount(THEONS_DIARY) == 1 :
         htmltext = "30369-05.htm"
   return htmltext

QUEST       = Quest(156,"156_MillenniumLove","Millennium Love")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30368)

QUEST.addTalkId(30368)
QUEST.addTalkId(30368)
QUEST.addTalkId(30368)
QUEST.addTalkId(30369)

STARTED.addQuestDrop(30368,LILITHS_LETTER,1)
STARTED.addQuestDrop(30369,THEONS_DIARY,1)

print "importing quests: 156: Millennium Love"