import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

BONE_FRAGMENT3 = 1158
ELF_SKULL = 1159
BONE_SHIELD = 625

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30147-04.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
      htmltext = "30147-04.htm"
    return htmltext


 def onTalk (Self,npc,st):
   npcId = npc.getNpcId()
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if cond == 0 :
      if id != COMPLETED :
         if st.getPlayer().getRace().ordinal() == 2 :
            htmltext = "30147-00.htm"
         elif st.getPlayer().getLevel() >= 12 :
            htmltext = "30147-02.htm"
         else:
            htmltext = "30147-01.htm"
            st.exitCurrentQuest(True)
      else :
         htmltext = "<html><head><body>This quest have already been completed.</body></html>"
   elif cond == 1 and (st.getQuestItemsCount(ELF_SKULL) + st.getQuestItemsCount(BONE_FRAGMENT3)) < 13 :
        htmltext = "30147-05.htm"
   elif cond == 2 and (st.getQuestItemsCount(ELF_SKULL) + st.getQuestItemsCount(BONE_FRAGMENT3)) >= 13 and id != COMPLETED :
      htmltext = "30147-06.htm"
      st.giveItems(BONE_SHIELD,1)
      st.giveItems(57,24000)
      st.takeItems(ELF_SKULL,-1)
      st.takeItems(BONE_FRAGMENT3,-1)
      st.set("cond","0")
      st.setState(COMPLETED)
      st.playSound("ItemSound.quest_finish")
   return htmltext

 def onKill (self,npc,st):

   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if npcId in [20463,20464,20504] and cond == 1 :
      if st.getRandom(4) == 1 and st.getQuestItemsCount(BONE_FRAGMENT3) < 10 :
         st.giveItems(BONE_FRAGMENT3,1)
         if st.getQuestItemsCount(BONE_FRAGMENT3) == 10 :
            st.playSound("ItemSound.quest_middle")
         else:
            st.playSound("ItemSound.quest_itemget")
   elif npcId in [20033,20345,20371] and cond == 1 :
      if st.getRandom(4) == 1 and st.getQuestItemsCount(ELF_SKULL) < 3 :
         st.giveItems(ELF_SKULL,1)
         if st.getQuestItemsCount(ELF_SKULL) == 3 :
            st.playSound("ItemSound.quest_middle")
         else:
            st.playSound("ItemSound.quest_itemget")
   if st.getQuestItemsCount(BONE_FRAGMENT3) == 10 and st.getQuestItemsCount(ELF_SKULL) == 3 :
      st.set("cond","2")
   return

QUEST       = Quest(162,"162_CurseOfUndergroundFortress","Curse Of Underground Fortress")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)


QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30147)

QUEST.addTalkId(30147)
QUEST.addTalkId(30147)
QUEST.addTalkId(30147)

QUEST.addKillId(20033)
QUEST.addKillId(20345)
QUEST.addKillId(20371)
QUEST.addKillId(20463)
QUEST.addKillId(20464)
QUEST.addKillId(20504)

STARTED.addQuestDrop(20371,ELF_SKULL,1)
STARTED.addQuestDrop(20345,ELF_SKULL,1)
STARTED.addQuestDrop(20033,ELF_SKULL,1)
STARTED.addQuestDrop(20464,BONE_FRAGMENT3,1)
STARTED.addQuestDrop(20463,BONE_FRAGMENT3,1)
STARTED.addQuestDrop(20504,BONE_FRAGMENT3,1)

print "importing quests: 162: Curse Of Underground Fortress"