import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

MARK_OF_PROSPERITY = 3238
RING_OF_TESTIMONY1 = 3239
RING_OF_TESTIMONY2 = 3240
OLD_ACCOUNT_BOOK = 3241
BLESSED_SEED = 3242
RECIPE_OF_EMILLY = 3243
LILITH_ELVEN_WAFER = 3244
MAPHR_TABLET_FRAGMENT = 3245
COLLECTION_LICENSE = 3246
LOCKIRINS_NOTICE1 = 3247
LOCKIRINS_NOTICE2 = 3248
LOCKIRINS_NOTICE3 = 3249
LOCKIRINS_NOTICE4 = 3250
LOCKIRINS_NOTICE5 = 3251
CONTRIBUTION_OF_CHALI = 3252
CONTRIBUTION_OF_MION = 3253
CONTRIBUTION_OF_MARIFE = 3254
MARIFES_REQUEST = 3255
CONTRIBUTION_OF_TOMA = 3256
RECEIPT_OF_BOLTER = 3257
RECEIPT_OF_CONTRIBUTION1 = 3258
RECEIPT_OF_CONTRIBUTION2 = 3259
RECEIPT_OF_CONTRIBUTION3 = 3260
RECEIPT_OF_CONTRIBUTION4 = 3261
RECEIPT_OF_CONTRIBUTION5 = 3262
PROCURATION_OF_TOROCCO = 3263
BRIGHTS_LIST = 3264
MANDRAGORA_PETAL = 3265
CRIMSON_MOSS = 3266
MANDRAGORA_BOUQUET = 3267
PARMANS_INSTRUCTIONS = 3268
PARMANS_LETTER = 3269
CLAY_DOUGH = 3270
PATTERN_OF_KEYHOLE = 3271
NIKOLAS_LIST = 3272
STAKATO_SHELL = 3273
TOAD_LORD_SAC = 3274
SPIDER_THORN = 3275
CRYSTAL_BROOCH = 3428
ADENA = 57
ANIMAL_SKIN = 1867
RP_TITAN_KEY = 3023
KEY_OF_TITAN = 3030
DIMENSION_DIAMOND = 7562

def checkProofs(st) :
   if st.getQuestItemsCount(OLD_ACCOUNT_BOOK) and st.getQuestItemsCount(BLESSED_SEED) and st.getQuestItemsCount(RECIPE_OF_EMILLY) and st.getQuestItemsCount(LILITH_ELVEN_WAFER) :
      st.set("cond","2")

def checkIngr(st) :
   if st.getQuestItemsCount(STAKATO_SHELL) == 20 and st.getQuestItemsCount(TOAD_LORD_SAC) == 10 and st.getQuestItemsCount(SPIDER_THORN) == 10 :
      st.set("cond","8")

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "1" :
       htmltext = "30104-04.htm"
#       if st.getStateId() != "Aborted" :
#           st.giveItems(DIMENSION_DIAMOND,50)
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
       st.giveItems(RING_OF_TESTIMONY1,1)
    elif event == "30104_1" :
       if st.getPlayer().getLevel() < 38 :
          htmltext = "30104-07.htm"
          st.takeItems(RING_OF_TESTIMONY1,-1)
          st.takeItems(OLD_ACCOUNT_BOOK,-1)
          st.takeItems(BLESSED_SEED,-1)
          st.takeItems(RECIPE_OF_EMILLY,-1)
          st.takeItems(LILITH_ELVEN_WAFER,-1)
          st.set("cond","3")
          st.giveItems(PARMANS_INSTRUCTIONS,1)
       else:
          htmltext = "30104-08.htm"
          st.takeItems(RING_OF_TESTIMONY1,-1)
          st.takeItems(OLD_ACCOUNT_BOOK,-1)
          st.takeItems(BLESSED_SEED,-1)
          st.takeItems(RECIPE_OF_EMILLY,-1)
          st.takeItems(LILITH_ELVEN_WAFER,-1)
          st.giveItems(RING_OF_TESTIMONY2,1)
          st.set("cond","4")
          st.giveItems(PARMANS_LETTER,1)
    elif event == "30531_1" and st.getQuestItemsCount(COLLECTION_LICENSE) :
       htmltext = "30531-04.htm"
    elif event == "30531_1" :
       htmltext = "30531-02.htm"
    elif event == "30531_2" and st.getQuestItemsCount(COLLECTION_LICENSE) == 0 :
       htmltext = "30531-03.htm"
       st.giveItems(COLLECTION_LICENSE,1)
       st.giveItems(LOCKIRINS_NOTICE1,1)
       st.giveItems(LOCKIRINS_NOTICE2,1)
       st.giveItems(LOCKIRINS_NOTICE3,1)
       st.giveItems(LOCKIRINS_NOTICE4,1)
       st.giveItems(LOCKIRINS_NOTICE5,1)
    elif event == "30534_1" :
       if st.getQuestItemsCount(ADENA) < 5000 :
          htmltext = "30534-03a.htm"
       else:
          htmltext = "30534-03b.htm"
          st.takeItems(ADENA,5000)
          st.takeItems(PROCURATION_OF_TOROCCO,-1)
          st.giveItems(RECEIPT_OF_CONTRIBUTION3,1)
    elif event == "30555_1" :
       htmltext = "30555-02.htm"
       st.giveItems(PROCURATION_OF_TOROCCO,1)
    elif event == "30597_1" :
       htmltext = "30597-02.htm"
       st.giveItems(BLESSED_SEED,1)
       checkProofs(st)
    elif event == "30005_1" :
       htmltext = "30005-02.htm"
    elif event == "30005_2" :
       htmltext = "30005-03.htm"
    elif event == "30005_3" :
       htmltext = "30005-04.htm"
       st.giveItems(CRYSTAL_BROOCH,1)
    elif event == "30368_1" :
       htmltext = "30368-02.htm"
    elif event == "30368_2" :
       htmltext = "30368-03.htm"
       st.takeItems(CRYSTAL_BROOCH,-1)
       st.giveItems(LILITH_ELVEN_WAFER,1)
       checkProofs(st)
    elif event == "30466_1" :
       htmltext = "30466-02.htm"
    elif event == "30466_2" :
       htmltext = "30466-03.htm"
       st.giveItems(BRIGHTS_LIST,1)
    elif event == "30620_1" :
       htmltext = "30620-02.htm"
    elif event == "30620_2" :
       htmltext = "30620-03.htm"
       st.takeItems(MANDRAGORA_BOUQUET,-1)
       st.giveItems(RECIPE_OF_EMILLY,1)
       checkProofs(st)
    elif event == "30621_1" :
       htmltext = "30621-02.htm"
    elif event == "30621_2" :
       htmltext = "30621-03.htm"
    elif event == "30621_3" :
       htmltext = "30621-04.htm"
       st.giveItems(CLAY_DOUGH,1)
       st.set("cond","5")
    elif event == "30622_1" :
       htmltext = "30622-02.htm"
       st.takeItems(CLAY_DOUGH,-1)
       st.giveItems(PATTERN_OF_KEYHOLE,1)
       st.set("cond","6")
    elif event == "30622_2" :
       htmltext = "30622-04.htm"
       st.takeItems(NIKOLAS_LIST,-1)
       st.takeItems(KEY_OF_TITAN,1)
       st.giveItems(MAPHR_TABLET_FRAGMENT,1)
       st.set("cond","9")
    return htmltext

 def onTalk (Self,npc,st):
   npcId = npc.getNpcId()
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30104 :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getRace().ordinal() == 4 :
               if st.getPlayer().getLevel() >= 37 :
                  htmltext = "30104-03.htm"
               else:
                  htmltext = "30104-02.htm"
                  st.exitCurrentQuest(True)
            else:
               htmltext = "30104-01.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><head><body>This quest have already been completed.</body></html>"
      elif cond in [1,2] and st.getQuestItemsCount(RING_OF_TESTIMONY1) :
         if st.getQuestItemsCount(OLD_ACCOUNT_BOOK) and st.getQuestItemsCount(BLESSED_SEED) and st.getQuestItemsCount(RECIPE_OF_EMILLY) and st.getQuestItemsCount(LILITH_ELVEN_WAFER) :
            htmltext = "30104-06.htm"
         else:
            htmltext = "30104-05.htm"
      elif cond == 3 and st.getQuestItemsCount(PARMANS_INSTRUCTIONS) :
         if st.getPlayer().getLevel() < 38 :
            htmltext = "30104-09.htm"
         else:
            htmltext = "30104-10.htm"
            st.takeItems(PARMANS_INSTRUCTIONS,-1)
            st.giveItems(RING_OF_TESTIMONY2,1)
            st.giveItems(PARMANS_LETTER,1)
            st.set("cond","4")
      elif cond == 4 and st.getQuestItemsCount(RING_OF_TESTIMONY2) and st.getQuestItemsCount(PARMANS_LETTER) and st.getQuestItemsCount(MAPHR_TABLET_FRAGMENT) == 0 :
         htmltext = "30104-11.htm"
      elif cond in [5,6,7] and (st.getQuestItemsCount(CLAY_DOUGH) or st.getQuestItemsCount(PATTERN_OF_KEYHOLE) or st.getQuestItemsCount(NIKOLAS_LIST)) and st.getQuestItemsCount(RING_OF_TESTIMONY2) :
         htmltext = "30104-12.htm"
      elif cond == 9 and st.getQuestItemsCount(RING_OF_TESTIMONY2) and st.getQuestItemsCount(MAPHR_TABLET_FRAGMENT) and id != COMPLETED :
         st.addExpAndSp(25000,3100)
         st.takeItems(RING_OF_TESTIMONY2,-1)
         st.takeItems(MAPHR_TABLET_FRAGMENT,-1)
         st.giveItems(MARK_OF_PROSPERITY,1)
         htmltext = "30104-13.htm"
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
   elif npcId == 30531 :
      if cond >= 1 and st.getQuestItemsCount(OLD_ACCOUNT_BOOK) == 0 and st.getQuestItemsCount(COLLECTION_LICENSE) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) :
         htmltext = "30531-01.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) :
         if st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION1) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION2) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION3) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION4) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION5) :
            htmltext = "30531-05.htm"
            st.takeItems(COLLECTION_LICENSE,-1)
            st.takeItems(RECEIPT_OF_CONTRIBUTION1,-1)
            st.takeItems(RECEIPT_OF_CONTRIBUTION2,-1)
            st.takeItems(RECEIPT_OF_CONTRIBUTION3,-1)
            st.takeItems(RECEIPT_OF_CONTRIBUTION4,-1)
            st.takeItems(RECEIPT_OF_CONTRIBUTION5,-1)
            st.giveItems(OLD_ACCOUNT_BOOK,1)
            checkProofs(st)
         else:
            htmltext = "30531-04.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(OLD_ACCOUNT_BOOK) and st.getQuestItemsCount(COLLECTION_LICENSE) == 0 :
         htmltext = "30531-06.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY2) :
         htmltext = "30531-07.htm"
   elif npcId == 30532 :
      if cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(LOCKIRINS_NOTICE1) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION1) == 0 and st.getQuestItemsCount(CONTRIBUTION_OF_CHALI) == 0 :
         htmltext = "30532-01.htm"
         st.takeItems(LOCKIRINS_NOTICE1,-1)
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION1) == 0 and st.getQuestItemsCount(CONTRIBUTION_OF_CHALI) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE1) == 0 :
         htmltext = "30532-02.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(CONTRIBUTION_OF_CHALI) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION1) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE1) == 0 :
         htmltext = "30532-03.htm"
         st.takeItems(CONTRIBUTION_OF_CHALI,-1)
         st.giveItems(RECEIPT_OF_CONTRIBUTION1,1)
      elif cond >= 1 and st.getQuestItemsCount(CONTRIBUTION_OF_CHALI) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE1) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION1) :
         htmltext = "30532-04.htm"
   elif npcId == 30533 :
      if cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(LOCKIRINS_NOTICE2) and st.getQuestItemsCount(LOCKIRINS_NOTICE2) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION2)==0 and (st.getQuestItemsCount(CONTRIBUTION_OF_MION)+st.getQuestItemsCount(CONTRIBUTION_OF_MARIFE)<2) :
         htmltext = "30533-01.htm"
         st.takeItems(LOCKIRINS_NOTICE2,-1)
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(LOCKIRINS_NOTICE2)==0 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION2)==0 and (st.getQuestItemsCount(CONTRIBUTION_OF_MION)+st.getQuestItemsCount(CONTRIBUTION_OF_MARIFE)<2) :
         htmltext = "30533-02.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION2) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE2) == 0 and (st.getQuestItemsCount(CONTRIBUTION_OF_MION)+st.getQuestItemsCount(CONTRIBUTION_OF_MARIFE)>=2) :
         htmltext = "30533-03.htm"
         st.takeItems(CONTRIBUTION_OF_MARIFE,-1)
         st.takeItems(CONTRIBUTION_OF_MION,-1)
         st.giveItems(RECEIPT_OF_CONTRIBUTION2,1)
      elif cond >= 1 and st.getQuestItemsCount(LOCKIRINS_NOTICE2)==0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION2) and (st.getQuestItemsCount(CONTRIBUTION_OF_MION)+st.getQuestItemsCount(CONTRIBUTION_OF_MARIFE)<2) :
         htmltext = "30533-04.htm"
   elif npcId == 30534 :
      if cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(LOCKIRINS_NOTICE3) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION3) == 0 and st.getQuestItemsCount(PROCURATION_OF_TOROCCO) == 0 :
         htmltext = "30534-01.htm"
         st.takeItems(LOCKIRINS_NOTICE3,-1)
      elif cond >= 1 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION3) == 0 and st.getQuestItemsCount(PROCURATION_OF_TOROCCO) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE3) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) :
         htmltext = "30534-02.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(PROCURATION_OF_TOROCCO) and st.getQuestItemsCount(LOCKIRINS_NOTICE3) == 0 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION3) == 0 :
         htmltext = "30534-03.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION3) and st.getQuestItemsCount(PROCURATION_OF_TOROCCO) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE3) == 0 :
         htmltext = "30534-04.htm"
   elif npcId == 30535 :
      if cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(LOCKIRINS_NOTICE4) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION4) == 0 and st.getQuestItemsCount(RECEIPT_OF_BOLTER) == 0 :
         htmltext = "30535-01.htm"
         st.takeItems(LOCKIRINS_NOTICE4,-1)
      elif cond >= 1 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION4) == 0 and st.getQuestItemsCount(RECEIPT_OF_BOLTER) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE4) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) :
         htmltext = "30535-02.htm"
      elif cond >=1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(RECEIPT_OF_BOLTER) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION4) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE4) == 0 :
         htmltext = "30535-03.htm"
         st.takeItems(RECEIPT_OF_BOLTER,-1)
         st.giveItems(RECEIPT_OF_CONTRIBUTION4,1)
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION4) and st.getQuestItemsCount(RECEIPT_OF_BOLTER) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE4) == 0 :
         htmltext = "30535-04.htm"
   elif npcId == 30536 :
      if cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(LOCKIRINS_NOTICE5) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION5) == 0 and st.getQuestItemsCount(CONTRIBUTION_OF_TOMA) == 0 :
         htmltext = "30536-01.htm"
         st.takeItems(LOCKIRINS_NOTICE5,-1)
      elif cond >= 1 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION5) == 0 and st.getQuestItemsCount(CONTRIBUTION_OF_TOMA) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE5) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) :
         htmltext = "30536-02.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(CONTRIBUTION_OF_TOMA) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION5) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE5) == 0 :
         htmltext = "30536-03.htm"
         st.takeItems(CONTRIBUTION_OF_TOMA,-1)
         st.giveItems(RECEIPT_OF_CONTRIBUTION5,1)
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION5) and st.getQuestItemsCount(CONTRIBUTION_OF_TOMA) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE5) == 0 :
         htmltext = "30536-04.htm"
   elif npcId == 30517 :
      if cond >= 1 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION1) == 0 and st.getQuestItemsCount(CONTRIBUTION_OF_CHALI) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE1) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) :
         htmltext = "30517-01.htm"
         st.giveItems(CONTRIBUTION_OF_CHALI,1)
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(CONTRIBUTION_OF_CHALI) and st.getQuestItemsCount(LOCKIRINS_NOTICE1) == 0 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION1) == 0 :
         htmltext = "30517-02.htm"
   elif npcId == 30519 :
      if cond >= 1 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION2) == 0 and st.getQuestItemsCount(CONTRIBUTION_OF_MION) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE2) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) :
         htmltext = "30519-01.htm"
         st.giveItems(CONTRIBUTION_OF_MION,1)
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(CONTRIBUTION_OF_MION) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION2) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE2) == 0 :
         htmltext = "30519-02.htm"
   elif npcId == 30553 :
      if cond >= 1 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION2) == 0 and st.getQuestItemsCount(CONTRIBUTION_OF_MARIFE) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE2) == 0 and st.getQuestItemsCount(MARIFES_REQUEST) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) :
         htmltext = "30553-01.htm"
         st.giveItems(MARIFES_REQUEST,1)
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(MARIFES_REQUEST) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION2) == 0 and st.getQuestItemsCount(CONTRIBUTION_OF_MARIFE) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE2) == 0 :
         if st.getQuestItemsCount(ANIMAL_SKIN) < 100 :
            htmltext = "30553-02.htm"
         else:
            htmltext = "30553-03.htm"
            st.takeItems(ANIMAL_SKIN,100)
            st.takeItems(MARIFES_REQUEST,-1)
            st.giveItems(CONTRIBUTION_OF_MARIFE,1)
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(CONTRIBUTION_OF_MARIFE) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION2) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE2) == 0 and st.getQuestItemsCount(MARIFES_REQUEST) == 0 :
         htmltext = "30553-04.htm"
   elif npcId == 30555 :
      if cond >= 1 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION3) == 0 and st.getQuestItemsCount(PROCURATION_OF_TOROCCO) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE3) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) :
         htmltext = "30555-01.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(PROCURATION_OF_TOROCCO) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION3) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE3) == 0 :
         htmltext = "30555-03.htm"
   elif npcId == 30554 :
      if cond >= 1 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION4) == 0 and st.getQuestItemsCount(RECEIPT_OF_BOLTER) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE4) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) :
         htmltext = "30554-01.htm"
         st.giveItems(RECEIPT_OF_BOLTER,1)
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(RECEIPT_OF_BOLTER) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION4) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE4) == 0 :
         htmltext = "30554-02.htm"
   elif npcId == 30556 :
      if cond >= 1 and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION5) == 0 and st.getQuestItemsCount(CONTRIBUTION_OF_TOMA) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE5) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) :
         htmltext = "30556-01.htm"
         st.giveItems(CONTRIBUTION_OF_TOMA,1)
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(COLLECTION_LICENSE) and st.getQuestItemsCount(CONTRIBUTION_OF_TOMA) and st.getQuestItemsCount(RECEIPT_OF_CONTRIBUTION5) == 0 and st.getQuestItemsCount(LOCKIRINS_NOTICE5) == 0 :
         htmltext = "30556-02.htm"
   elif npcId == 30597 :
      if cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(BLESSED_SEED) == 0 :
         htmltext = "30597-01.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(BLESSED_SEED) :
         htmltext = "30597-03.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY2) :
         htmltext = "30597-04.htm"
   elif npcId == 30005 :
      if cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(LILITH_ELVEN_WAFER) == 0 and st.getQuestItemsCount(CRYSTAL_BROOCH) == 0 :
         htmltext = "30005-01.htm"
      elif cond >= 1 and st.getQuestItemsCount(LILITH_ELVEN_WAFER) == 0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(CRYSTAL_BROOCH) :
         htmltext = "30005-05.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(LILITH_ELVEN_WAFER) :
         htmltext = "30005-06.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY2) :
         htmltext = "30005-07.htm"
   elif npcId == 30368 :
      if cond >= 1 and st.getQuestItemsCount(CRYSTAL_BROOCH) and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(LILITH_ELVEN_WAFER)==0 :
         htmltext = "30368-01.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(LILITH_ELVEN_WAFER) and st.getQuestItemsCount(CRYSTAL_BROOCH)==0 :
        htmltext = "30368-04.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY2) :
        htmltext = "30368-05.htm"
   elif npcId == 30466 :
      if cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(RECIPE_OF_EMILLY) == 0 and st.getQuestItemsCount(BRIGHTS_LIST) == 0 and st.getQuestItemsCount(MANDRAGORA_BOUQUET) == 0 :
         htmltext = "30466-01.htm"
      elif cond >= 1 and st.getQuestItemsCount(RECIPE_OF_EMILLY)==0 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(BRIGHTS_LIST) :
         if st.getQuestItemsCount(MANDRAGORA_PETAL) < 20 or st.getQuestItemsCount(CRIMSON_MOSS) < 10 :
            htmltext = "30466-04.htm"
         else:
            htmltext = "30466-05.htm"
            st.takeItems(MANDRAGORA_PETAL,-1)
            st.takeItems(CRIMSON_MOSS,-1)
            st.takeItems(BRIGHTS_LIST,-1)
            st.giveItems(MANDRAGORA_BOUQUET,1)
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(MANDRAGORA_BOUQUET) and st.getQuestItemsCount(RECIPE_OF_EMILLY) == 0 and st.getQuestItemsCount(BRIGHTS_LIST) == 0 :
         htmltext = "30466-06.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(RECIPE_OF_EMILLY) :
         htmltext = "30466-07.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY2) :
         htmltext = "30466-08.htm"
   elif npcId == 30620 :
      if cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(MANDRAGORA_BOUQUET) and st.getQuestItemsCount(RECIPE_OF_EMILLY) == 0 and st.getQuestItemsCount(BRIGHTS_LIST) == 0 :
         htmltext = "30620-01.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY1) and st.getQuestItemsCount(RECIPE_OF_EMILLY) :
         htmltext = "30620-04.htm"
      elif cond >= 1 and st.getQuestItemsCount(RING_OF_TESTIMONY2) :
         htmltext = "30620-05.htm"
   elif npcId == 30621 :
      if cond == 4 and st.getQuestItemsCount(RING_OF_TESTIMONY2) and st.getQuestItemsCount(CLAY_DOUGH) == 0 and st.getQuestItemsCount(PATTERN_OF_KEYHOLE) == 0 and st.getQuestItemsCount(NIKOLAS_LIST) == 0 and st.getQuestItemsCount(MAPHR_TABLET_FRAGMENT) == 0 :
         htmltext = "30621-01.htm"
      elif cond == 5 and st.getQuestItemsCount(RING_OF_TESTIMONY2) and st.getQuestItemsCount(CLAY_DOUGH) and st.getQuestItemsCount(PATTERN_OF_KEYHOLE) == 0 and st.getQuestItemsCount(NIKOLAS_LIST) == 0 and st.getQuestItemsCount(MAPHR_TABLET_FRAGMENT) == 0 :
         htmltext = "30621-05.htm"
      elif cond == 6 and st.getQuestItemsCount(RING_OF_TESTIMONY2) and st.getQuestItemsCount(PATTERN_OF_KEYHOLE) and st.getQuestItemsCount(CLAY_DOUGH) == 0 and st.getQuestItemsCount(NIKOLAS_LIST) == 0 and st.getQuestItemsCount(MAPHR_TABLET_FRAGMENT) == 0 :
         htmltext = "30621-06.htm"
         st.takeItems(PATTERN_OF_KEYHOLE,-1)
         st.giveItems(NIKOLAS_LIST,1)
         st.giveItems(RP_TITAN_KEY,1)
         st.set("cond","7")
      elif cond == 7 and st.getQuestItemsCount(RING_OF_TESTIMONY2) and st.getQuestItemsCount(NIKOLAS_LIST) and st.getQuestItemsCount(CLAY_DOUGH) == 0 and st.getQuestItemsCount(PATTERN_OF_KEYHOLE) == 0 and st.getQuestItemsCount(MAPHR_TABLET_FRAGMENT) == 0 and st.getQuestItemsCount(KEY_OF_TITAN) == 0 :
         htmltext = "30621-07.htm"
      elif cond == 8 and st.getQuestItemsCount(RING_OF_TESTIMONY2) and st.getQuestItemsCount(NIKOLAS_LIST) and st.getQuestItemsCount(KEY_OF_TITAN) and st.getQuestItemsCount(CLAY_DOUGH) == 0 and st.getQuestItemsCount(PATTERN_OF_KEYHOLE) == 0 and st.getQuestItemsCount(MAPHR_TABLET_FRAGMENT) == 0 :
         htmltext = "30621-08.htm"
      elif cond == 9 and st.getQuestItemsCount(RING_OF_TESTIMONY2) and st.getQuestItemsCount(MAPHR_TABLET_FRAGMENT) and st.getQuestItemsCount(CLAY_DOUGH) == 0 and st.getQuestItemsCount(PATTERN_OF_KEYHOLE) == 0 and st.getQuestItemsCount(NIKOLAS_LIST) == 0 :
         htmltext = "30621-09.htm"
   elif npcId == 30622 :
      if cond == 5 and st.getQuestItemsCount(RING_OF_TESTIMONY2) and st.getQuestItemsCount(CLAY_DOUGH) and st.getQuestItemsCount(PATTERN_OF_KEYHOLE)==0 :
         htmltext = "30622-01.htm"
      elif cond == 8 and st.getQuestItemsCount(RING_OF_TESTIMONY2) and st.getQuestItemsCount(KEY_OF_TITAN) and st.getQuestItemsCount(MAPHR_TABLET_FRAGMENT)==0 :
         htmltext = "30622-03.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if cond == 1 :
      if npcId == 20223 :
         if st.getQuestItemsCount(BRIGHTS_LIST) and st.getQuestItemsCount(MANDRAGORA_PETAL)<20 :
            if st.getRandom(100) < 30 :
               st.giveItems(MANDRAGORA_PETAL,1)
               if st.getQuestItemsCount(MANDRAGORA_PETAL) == 20 :
                  st.playSound("ItemSound.quest_middle")
               else:
                  st.playSound("ItemSound.quest_itemget")      
      elif npcId == 20154 :
        if st.getQuestItemsCount(BRIGHTS_LIST) and st.getQuestItemsCount(MANDRAGORA_PETAL)<20 :
           if st.getRandom(100) < 60 :
               st.giveItems(MANDRAGORA_PETAL,1)
               if st.getQuestItemsCount(MANDRAGORA_PETAL) == 20 :
                  st.playSound("ItemSound.quest_middle")
               else:
                  st.playSound("ItemSound.quest_itemget")      
      elif npcId == 20155 :
        if st.getQuestItemsCount(BRIGHTS_LIST) and st.getQuestItemsCount(MANDRAGORA_PETAL)<20 :
           if st.getRandom(100) < 80 :
               st.giveItems(MANDRAGORA_PETAL,1)
               if st.getQuestItemsCount(MANDRAGORA_PETAL) == 20 :
                  st.playSound("ItemSound.quest_middle")
               else:
                  st.playSound("ItemSound.quest_itemget")      
      elif npcId == 20156 :
        if st.getQuestItemsCount(BRIGHTS_LIST) and st.getQuestItemsCount(MANDRAGORA_PETAL)<20 :
           st.giveItems(MANDRAGORA_PETAL,1)
           if st.getQuestItemsCount(MANDRAGORA_PETAL) == 20 :
              st.playSound("ItemSound.quest_middle")
           else:
              st.playSound("ItemSound.quest_itemget")      
      elif npcId == 20228 :
         if st.getQuestItemsCount(BRIGHTS_LIST) and st.getQuestItemsCount(CRIMSON_MOSS) < 10 :
            st.giveItems(CRIMSON_MOSS,1)
            if st.getQuestItemsCount(CRIMSON_MOSS) == 10 :
               st.playSound("ItemSound.quest_middle")
            else :
               st.playSound("ItemSound.quest_itemget")
   elif cond == 7 :
      if npcId == 20157 :
         if st.getQuestItemsCount(NIKOLAS_LIST) and st.getQuestItemsCount(KEY_OF_TITAN) == 0 and st.getQuestItemsCount(STAKATO_SHELL) < 20 :
            if st.getRandom(100) < 20 :
               st.giveItems(STAKATO_SHELL,1)
               if st.getQuestItemsCount(STAKATO_SHELL) == 20 :
                  checkIngr(st)
                  st.playSound("ItemSound.quest_middle")
               else :
                  st.playSound("ItemSound.quest_itemget")
      elif npcId == 20230 :
         if st.getQuestItemsCount(NIKOLAS_LIST) and st.getQuestItemsCount(KEY_OF_TITAN) == 0 and st.getQuestItemsCount(STAKATO_SHELL) < 20 :
            if st.getRandom(100) < 30 :
               st.giveItems(STAKATO_SHELL,1)
               if st.getQuestItemsCount(STAKATO_SHELL) == 20 :
                  checkIngr(st)
                  st.playSound("ItemSound.quest_middle")
               else :
                  st.playSound("ItemSound.quest_itemget")
      elif npcId == 20232 :
         if st.getQuestItemsCount(NIKOLAS_LIST) and st.getQuestItemsCount(KEY_OF_TITAN) == 0 and st.getQuestItemsCount(STAKATO_SHELL) < 20 :
            if st.getRandom(100) < 50 :
               st.giveItems(STAKATO_SHELL,1)
               if st.getQuestItemsCount(STAKATO_SHELL) == 20 :
                  checkIngr(st)
                  st.playSound("ItemSound.quest_middle")
               else :
                  st.playSound("ItemSound.quest_itemget")
      elif npcId == 20234 :
         if st.getQuestItemsCount(NIKOLAS_LIST) and st.getQuestItemsCount(KEY_OF_TITAN) == 0 and st.getQuestItemsCount(STAKATO_SHELL) < 20 :
            if st.getRandom(100) < 60 :
               st.giveItems(STAKATO_SHELL,1)
               if st.getQuestItemsCount(STAKATO_SHELL) == 20 :
                  checkIngr(st)
                  st.playSound("ItemSound.quest_middle")
               else :
                  st.playSound("ItemSound.quest_itemget")
      elif npcId == 20231 :
         if st.getQuestItemsCount(NIKOLAS_LIST) and st.getQuestItemsCount(KEY_OF_TITAN) == 0 and st.getQuestItemsCount(TOAD_LORD_SAC) < 10 :
            if st.getRandom(100) < 50 :
               st.giveItems(TOAD_LORD_SAC,1)
               if st.getQuestItemsCount(TOAD_LORD_SAC) == 10 :
                  checkIngr(st)
                  st.playSound("ItemSound.quest_middle")
               else :
                  st.playSound("ItemSound.quest_itemget")
      elif npcId == 20233 :
         if st.getQuestItemsCount(NIKOLAS_LIST) and st.getQuestItemsCount(KEY_OF_TITAN) == 0 and st.getQuestItemsCount(SPIDER_THORN) < 10 :
            if st.getRandom(100) < 50 :
               st.giveItems(SPIDER_THORN,1)
               if st.getQuestItemsCount(SPIDER_THORN) == 10 :
                  checkIngr(st)
                  st.playSound("ItemSound.quest_middle")
               else :
                  st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(221,"221_TestimonyOfProsperity","Testimony Of Prosperity")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)
ABORTED     = State('Aborted', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30104)

QUEST.addTalkId(30104)
QUEST.addTalkId(30104)

QUEST.addTalkId(30005)
QUEST.addTalkId(30104)
QUEST.addTalkId(30368)
QUEST.addTalkId(30466)
QUEST.addTalkId(30517)
QUEST.addTalkId(30519)
QUEST.addTalkId(30531)
QUEST.addTalkId(30532)
QUEST.addTalkId(30533)
QUEST.addTalkId(30534)
QUEST.addTalkId(30535)
QUEST.addTalkId(30536)
QUEST.addTalkId(30553)
QUEST.addTalkId(30554)
QUEST.addTalkId(30555)
QUEST.addTalkId(30556)
QUEST.addTalkId(30597)
QUEST.addTalkId(30620)
QUEST.addTalkId(30621)
QUEST.addTalkId(30622)

QUEST.addKillId(20154)
QUEST.addKillId(20155)
QUEST.addKillId(20156)
QUEST.addKillId(20157)
QUEST.addKillId(20223)
QUEST.addKillId(20228)
QUEST.addKillId(20230)
QUEST.addKillId(20231)
QUEST.addKillId(20232)
QUEST.addKillId(20233)
QUEST.addKillId(20234)

STARTED.addQuestDrop(30104,RING_OF_TESTIMONY1,1)
STARTED.addQuestDrop(30531,OLD_ACCOUNT_BOOK,1)
STARTED.addQuestDrop(30597,BLESSED_SEED,1)
STARTED.addQuestDrop(30620,RECIPE_OF_EMILLY,1)
STARTED.addQuestDrop(30368,LILITH_ELVEN_WAFER,1)
STARTED.addQuestDrop(30104,PARMANS_INSTRUCTIONS,1)
STARTED.addQuestDrop(30104,RING_OF_TESTIMONY2,1)
STARTED.addQuestDrop(30622,MAPHR_TABLET_FRAGMENT,1)
STARTED.addQuestDrop(30531,COLLECTION_LICENSE,1)
STARTED.addQuestDrop(30532,RECEIPT_OF_CONTRIBUTION1,1)
STARTED.addQuestDrop(30533,RECEIPT_OF_CONTRIBUTION2,1)
STARTED.addQuestDrop(30534,RECEIPT_OF_CONTRIBUTION3,1)
STARTED.addQuestDrop(30535,RECEIPT_OF_CONTRIBUTION4,1)
STARTED.addQuestDrop(30536,RECEIPT_OF_CONTRIBUTION5,1)
STARTED.addQuestDrop(30531,LOCKIRINS_NOTICE1,1)
STARTED.addQuestDrop(30517,CONTRIBUTION_OF_CHALI,1)
STARTED.addQuestDrop(30531,LOCKIRINS_NOTICE2,1)
STARTED.addQuestDrop(30553,CONTRIBUTION_OF_MARIFE,1)
STARTED.addQuestDrop(30519,CONTRIBUTION_OF_MION,1)
STARTED.addQuestDrop(30531,LOCKIRINS_NOTICE3,1)
STARTED.addQuestDrop(30555,PROCURATION_OF_TOROCCO,1)
STARTED.addQuestDrop(30531,LOCKIRINS_NOTICE4,1)
STARTED.addQuestDrop(30554,RECEIPT_OF_BOLTER,1)
STARTED.addQuestDrop(30531,LOCKIRINS_NOTICE5,1)
STARTED.addQuestDrop(30556,CONTRIBUTION_OF_TOMA,1)
STARTED.addQuestDrop(30553,MARIFES_REQUEST,1)
STARTED.addQuestDrop(30005,CRYSTAL_BROOCH,1)
STARTED.addQuestDrop(30466,BRIGHTS_LIST,1)
STARTED.addQuestDrop(30466,MANDRAGORA_BOUQUET,1)
STARTED.addQuestDrop(30622,PATTERN_OF_KEYHOLE,1)
STARTED.addQuestDrop(30621,CLAY_DOUGH,1)
STARTED.addQuestDrop(30621,NIKOLAS_LIST,1)
STARTED.addQuestDrop(30621,RP_TITAN_KEY,1)

print "importing quests: 221: Testimony Of Prosperity"