# ~~~~ Made by ValianT ~~~~ #
# ~~~~~~~~~~~~~~~~~~~~~~~~~ #
# ~~~~~~~~~ Info: ~~~~~~~~~ #
#   Ghost of Priest spawn   #
#      only for 2 min!      #
# Attack Soul of Well 2 min #
#  Wait Innocentin 10 min,  #
#        next 5 min         #
# ~~~~~~~~~~~~~~~~~~~~~~~~~ #

import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

# ~~~~~~ Npc list: ~~~~~~
Well              = 31527
Tifaren           = 31334
Innocentin        = 31328
SoulofWell        = 31217
Ghostofpriest     = 31528
GhostofAdventurer = 31529
# ~~~~~~~~~~~~~~~~~~~~~~~

# ~~~~~~~~ Item list ~~~~~~~~
ReportBox              = 7147
LostSkullofElf         = 7142
CrossofEinhasad        = 7141
SealedReportBox        = 7146
LetterofInnocentin     = 7143
JewelofAdventurerRed   = 7145
JewelofAdventurerGreen = 7144
CrossofEinhasad        = 7141
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~

# ~~~~ Monster list: ~~~~
Mobs = range(21547,21578)
# ~~~~~~~~~~~~~~~~~~~~~~~

class Quest (JQuest) :

    def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

    def onEvent (self,event,st):
        htmltext = event
        if event == "31334-03.htm":
            st.setState(STARTED)
            st.set("cond","3")
            st.takeItems(CrossofEinhasad,-1)
        elif event == "31334-06.htm":
            st.set("cond","4")
        elif event == "31334-09.htm":
            st.set("cond","6")
            st.takeItems(LostSkullofElf,1)
            st.getPcSpawn().addSpawn(Ghostofpriest, 120000)
        elif event == "31528-07.htm":
            st.set("cond","7")
        elif event == "31328-06.htm":
            st.set("cond","8")
            st.giveItems(LetterofInnocentin,1)
        elif event == "31529-09.htm":
            st.set("cond","9")
            st.takeItems(LetterofInnocentin,1)
        elif event == "explore":
            st.getPcSpawn().addSpawn(SoulofWell)
            st.set("cond","10")
            st.giveItems(JewelofAdventurerGreen,1)
            htmltext = "Attack Soul of Well but do not kill while stone will not change colour..."
        elif event == "attack_timer":
            st.giveItems(JewelofAdventurerRed,1)
            st.takeItems(JewelofAdventurerGreen,1)
            st.set("cond","11")
        elif event == "31328-08.htm":
            st.startQuestTimer("wait_timer",600000)
            st.set("cond","15")
            st.takeItems(ReportBox,1)
        elif event == "wait_timer":
            st.set("cond","16")
            htmltext = "Innocentin wants with you to speak..."
        elif event == "31328-16.htm":
            st.startQuestTimer("next_wait_timer",300000)
            st.set("cond","17")
        elif event == "next_wait_timer":
            st.set("cond","18")
        return htmltext

    def onTalk (Self,npc,st):
        htmltext = "<html><head><body>I have nothing to say you...</body></html>"
        npcId = npc.getNpcId()
        cond = st.getInt("cond")
        onlyone = st.getInt("onlyone")
        if npcId == Tifaren:
            if cond == 0 and onlyone == 0:
                hiddenTruth=st.getPlayer().getQuestState("_21_HiddenTruth")
                if not hiddenTruth is None:
                    if hiddenTruth.get("onlyone") == "1":
                        htmltext = "31334-01.htm"
                    else:
                        htmltext = "<html><head><body>You not complite quest Hidden Truth...</body></html>"
                else:
                    htmltext = "<html><head><body>You not complite quest Hidden Truth...</body></html>"
            elif cond == 0 and onlyone == 1:
                htmltext = "<html><head><body>This quest have already been completed.</body></html>"
            elif cond == 3 and onlyone == 0:
                if st.getQuestItemsCount(CrossofEinhasad) != 0:
                    htmltext = "31334-04.htm"
                else:
                    htmltext = "You have no Cross of Einhasad! Are they Please returned to High Priest Innocentin..."
            elif cond == 4 and onlyone == 0:
                htmltext = "31334-06.htm"
            elif cond == 5 and onlyone == 0:
                if st.getQuestItemsCount(LostSkullofElf) != 0:
                    htmltext = "31334-07.htm"
                else:
                    st.set("cond","4")
                    htmltext = "31334-06.htm"
            elif cond == 6 and onlyone == 0:
                htmltext = "31334-09.htm"
        elif npcId == Ghostofpriest:
            if cond == 6 and onlyone == 0:
                htmltext = "31528-00.htm"
            elif cond == 7 and onlyone == 0:
                htmltext == "31528-07.htm"
        elif npcId == Innocentin:
            if cond == 0 and onlyone == 1:
                htmltext = "31328-17.htm"
            if cond == 7 and onlyone == 0:
                htmltext = "31328-00.htm"
            elif cond == 8 and onlyone == 0:
                htmltext = "31328-06.htm"
            elif cond == 14 and onlyone == 0:
                if st.getQuestItemsCount(ReportBox) != 0:
                    htmltext = "31328-07.htm"
                else:
                    st.set("cond","13")
                    htmltext = "Go away!"
            elif cond == 15 and onlyone == 0:
                htmltext = "31328-09.htm"
            elif cond == 16 and onlyone == 0:
                htmltext = "31328-08a.htm"
            elif cond == 17 and onlyone == 0:
                htmltext = "31328-16a.htm"
            elif cond == 18 and onlyone == 0:
                htmltext = "31328-17.htm"
                st.unset("cond")
                st.set("onlyone","1")
                st.setState(COMPLETED)
        elif npcId == GhostofAdventurer:
            if cond == 8 and onlyone == 0:
                if st.getQuestItemsCount(LetterofInnocentin) != 0:
                    htmltext = "31529-00.htm"
                else:
                    htmltext = "You have no Letter of Innocentin! Are they Please returned to High Priest Innocentin..."
            elif cond == 9 and onlyone == 0:
                htmltext = "31529-09.htm"
            elif cond == 11 and onlyone == 0:
                if st.getQuestItemsCount(JewelofAdventurerRed) != 0:
                    htmltext = "31529-10.htm"
                    st.takeItems(JewelofAdventurerRed,1)
                    st.set("cond","12")
                else :
                    st.set("cond","9")
                    htmltext = "31529-09.htm"
            elif cond == 13 and onlyone == 0:
                if st.getQuestItemsCount(SealedReportBox) != 0:
                    htmltext = "31529-11.htm"
                    st.set("cond","14")
                    st.takeItems(SealedReportBox,1)
                    st.giveItems(ReportBox,1)
                else :
                    st.set("cond","12")
                    htmltext = "31529-10.htm"
        elif npcId == Well:
            if cond == 9 and onlyone == 0:
                htmltext = "31527-00.htm"
            elif cond == 12 and onlyone == 0:
                htmltext = "31527-01.htm"
                st.set("cond","13")
                st.giveItems(SealedReportBox,1)
        return htmltext

    def onAttack(self, npc, st):
        npcId = npc.getNpcId()
        cond = st.getInt("cond")
        if npcId == SoulofWell:
            if cond == 10:
                st.startQuestTimer("attack_timer",300000)
        return

    def onKill (self,npc,st):
        npcId = npc.getNpcId()
        cond = st.getInt("cond")
        if npcId in Mobs:
            if cond == 4 and st.getRandom(100)>90:
                st.giveItems(LostSkullofElf,1)
                st.playSound("ItemSound.quest_middle")
                st.set("cond","5")
        if npcId == SoulofWell:
            if cond == 10:
                st.set("cond","9")
                st.takeItems(JewelofAdventurerGreen,1)
                st.getQuestTimer("attack_timer").cancel()
        return
        
QUEST     = Quest(22,"22_TragedyInVonHellmannForest","Tragedy In Von Hellmann Forest")
CREATED   = State('Start',     QUEST)
STARTED   = State('Started',   QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(Tifaren)

QUEST.addTalkId(Tifaren)
QUEST.addTalkId(Ghostofpriest)
QUEST.addTalkId(Innocentin)
QUEST.addTalkId(GhostofAdventurer)
QUEST.addTalkId(Well)

QUEST.addAttackId(SoulofWell)

QUEST.addKillId(SoulofWell)

for npcId in Mobs:
    QUEST.addKillId(npcId)
    STARTED.addQuestDrop(npcId,LostSkullofElf,1)

print "importing quests: 22: Tragedy in von Hellmann Forest"
