import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

LEGENG_OF_SEVENTEEN = 7587
MALRUK_SUCCUBUS_CLAW = 7597
ECHO_CRYSTAL = 7589
FADED_POETRY_BOOK = 7588
CRIMSON_MOSS = 7598
MEDICINE = 7599
LUNARGENT = 6029
HELLFIRE_OIL = 6033
VIRGILS_LETTER = 7677

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31739-02.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "30753-02.htm" :
       st.set("cond","2")
    elif event == "30754-02.htm" :
       st.set("cond","3")
    elif event == "31739-04.htm" :
       st.takeItems(LEGENG_OF_SEVENTEEN,-1)
       st.set("cond","5")
    elif event == "31042-02.htm" :
       st.set("cond","6")
    elif event == "31042-04.htm" :
       st.takeItems(MALRUK_SUCCUBUS_CLAW,-1)
       st.giveItems(ECHO_CRYSTAL,1)
       st.set("cond","8")
    elif event == "31739-06.htm" :
       st.takeItems(ECHO_CRYSTAL,-1)
       st.set("cond","9")
    elif event == "30692-02.htm" :
       st.giveItems(FADED_POETRY_BOOK,1)
       st.set("cond","10")
    elif event == "31739-08.htm" :
       st.takeItems(FADED_POETRY_BOOK,-1)
       st.set("cond","11")
    elif event == "31742-02.htm" :
       st.set("cond","12")
    elif event == "31744-02.htm" :
       st.set("cond","13")
    elif event == "31336-02.htm" :
       st.set("cond","14")
    elif event == "31336-04.htm" :
       st.takeItems(CRIMSON_MOSS,-1)
       st.giveItems(MEDICINE,1)
       st.set("cond","16")
    elif event == "31743-02.htm" :
       st.takeItems(MEDICINE,-1)
       st.set("cond","17")
    elif event == "31742-04.htm" :
       st.set("cond","18")
    elif event == "31740-02.htm" :
       st.set("cond","19")
    elif event == "31272-02.htm" :
       st.set("cond","20")
    elif event == "31272-04.htm" :
       st.takeItems(LUNARGENT,-1)
       st.takeItems(HELLFIRE_OIL,-1)
       st.set("cond","21")
    elif event == "31740-04.htm" :
       st.giveItems(VIRGILS_LETTER,1)
       st.addExpAndSp(263043,0)
       st.setState(COMPLETED)
       st.unset("cond")
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if npcId == 31739 :
      if cond == 0 :
         if st.getPlayer().isSubClassActive() and st.getPlayer().getLevel() >= 50 :
            if id != COMPLETED :
               htmltext = "31739-01.htm"
            elif id == COMPLETED :
               htmltext = "<html><head><body>You have already complete this quest.</body></html>"
         else :
            htmltext = "31739-00.htm"
            st.exitCurrentQuest(True)
      elif cond == 1 and st.getPlayer().isSubClassActive() :
         htmltext = "31739-02r.htm"
      elif cond == 4 and st.getQuestItemsCount(LEGENG_OF_SEVENTEEN) >= 1 and st.getPlayer().isSubClassActive() :
         htmltext = "31739-03.htm"
      elif cond < 8 and st.getQuestItemsCount(ECHO_CRYSTAL) < 1 and st.getPlayer().isSubClassActive() :
         htmltext = "31739-04r.htm"
      elif cond == 8 and st.getQuestItemsCount(ECHO_CRYSTAL) == 1 and st.getPlayer().isSubClassActive() :
         htmltext = "31739-05.htm"
      elif cond < 10 and st.getQuestItemsCount(FADED_POETRY_BOOK) < 1 and st.getPlayer().isSubClassActive() :
         htmltext = "31739-06r.htm"
      elif cond == 10 and st.getQuestItemsCount(FADED_POETRY_BOOK) == 1 and st.getPlayer().isSubClassActive() :
         htmltext = "31739-07.htm"
      elif cond == 11 :
         htmltext = "31739-08r.htm"
   elif npcId == 30753 and st.getPlayer().isSubClassActive() :
      if cond == 1 :
         htmltext = "30753-01.htm"
      elif cond == 2 :
         htmltext = "30753-02r.htm"
   elif npcId == 30754 and st.getPlayer().isSubClassActive() :
      if cond == 2 :
         htmltext = "30754-01.htm"
      elif cond == 3 and st.getQuestItemsCount(LEGENG_OF_SEVENTEEN) < 1 :
         htmltext = "30754-02r.htm"
   elif npcId == 31042 and st.getPlayer().isSubClassActive() :
      if cond == 5 :
         htmltext = "31042-01.htm"
      elif cond == 6 and st.getQuestItemsCount(MALRUK_SUCCUBUS_CLAW) < 10 :
         htmltext = "31042-02r.htm"
      elif cond == 7 and st.getQuestItemsCount(MALRUK_SUCCUBUS_CLAW) == 10 :
         htmltext = "31042-03.htm"
      elif cond == 8 and st.getQuestItemsCount(ECHO_CRYSTAL) >= 1 :
         htmltext = "31042-04r.htm"
      elif cond == 8 and st.getQuestItemsCount(ECHO_CRYSTAL) == 0 :
         st.giveItems(ECHO_CRYSTAL,1)
         htmltext = "31042-04r.htm"
   elif npcId == 30692 and st.getPlayer().isSubClassActive() :
      if cond == 9 :
         htmltext = "30692-01.htm"
      elif cond == 10 :
         htmltext = "30692-02r.htm"
   elif npcId == 31742 and st.getPlayer().isSubClassActive() :
      if cond == 11 :
         htmltext = "31742-01.htm"
      elif cond == 12 :
         htmltext = "31742-02r.htm"
      elif cond == 17 :
         htmltext = "31742-03.htm"
      elif cond >= 18 :
         htmltext = "31742-04r.htm"
   elif npcId == 31744 and st.getPlayer().isSubClassActive() :
      if cond == 12 :
         htmltext = "31744-01.htm"
   elif npcId == 31336 and st.getPlayer().isSubClassActive() :
      if cond == 13 :
         htmltext = "31336-01.htm"
      elif cond == 14 and st.getQuestItemsCount(CRIMSON_MOSS) < 5 :
         htmltext = "31336-02r.htm"
      elif cond == 15 and st.getQuestItemsCount(CRIMSON_MOSS) >= 5 :
         htmltext = "31336-03.htm"
      elif cond == 16 and st.getQuestItemsCount(MEDICINE) >= 1 :
         htmltext = "31336-04r.htm"
   elif npcId == 31743 and st.getPlayer().isSubClassActive() :
      if cond == 16 and st.getQuestItemsCount(MEDICINE) >= 1 :
         htmltext = "31743-01.htm"
   elif npcId == 31740 and st.getPlayer().isSubClassActive() :
      if cond == 18 :
         htmltext = "31740-01.htm"
      elif cond == 19 and st.getPlayer().isSubClassActive() :
         htmltext = "31740-02r.htm"
      elif cond == 21 :
         htmltext = "31740-03.htm"
   elif npcId == 31272 and st.getPlayer().isSubClassActive() :
      if cond == 19 :
         htmltext = "31272-01.htm"
      elif cond == 20 and st.getQuestItemsCount(LUNARGENT) < 5 and st.getQuestItemsCount(HELLFIRE_OIL) < 1 :
         htmltext = "31272-02r.htm"
      elif cond == 20 and st.getQuestItemsCount(LUNARGENT) >= 5 and st.getQuestItemsCount(HELLFIRE_OIL) >= 1 :
         htmltext = "31272-03.htm"
      elif cond == 21 :
         htmltext = "31272-04r.htm"

   return htmltext

 def onKill (self,npc,st):
    npcId = npc.getNpcId()
    cond = st.getInt(("cond"))
    if cond == 3 and st.getPlayer().isSubClassActive() :
       if npcId == 21154 and st.getRandom(100) < 10 :
          st.getPcSpawn().addSpawn(27113)
       elif npcId == 27113 and st.getQuestItemsCount(LEGENG_OF_SEVENTEEN) == 0 :
          st.giveItems(LEGENG_OF_SEVENTEEN,1)
          st.set("cond","4")
          st.playSound("ItemSound.quest_itemget")
    elif cond == 6 and st.getPlayer().isSubClassActive() :
       if (npcId == 20244 or npcId == 20245) and st.getRandom(100) < 10 :
          if st.getQuestItemsCount(MALRUK_SUCCUBUS_CLAW) <= 9 :
             st.giveItems(MALRUK_SUCCUBUS_CLAW,1)
             if st.getQuestItemsCount(MALRUK_SUCCUBUS_CLAW) == 10 :
                st.playSound("ItemSound.quest_middle")
                st.set("cond","7")
             else :
                st.playSound("ItemSound.quest_itemget")
    elif cond == 14 and st.getPlayer().isSubClassActive() :
       if npcId in range (21508,21512) and st.getRandom(100) < 10 :
          if st.getQuestItemsCount(CRIMSON_MOSS) <= 4 :
             st.giveItems(CRIMSON_MOSS,1)
             if st.getQuestItemsCount(CRIMSON_MOSS) == 5 :
                st.playSound("ItemSound.quest_middle")
                st.set("cond","15")
             else :
                st.playSound("ItemSound.quest_itemget")
    return

QUEST       = Quest(241,"241_PossessorOfaPreciousSoul1","Possessor of a Precious Soul - 1",True)
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31739)

QUEST.addTalkId(31739)
QUEST.addTalkId(31739)

QUEST.addTalkId(30753)
QUEST.addTalkId(30754)
QUEST.addTalkId(31042)
QUEST.addTalkId(30692)
QUEST.addTalkId(31742)
QUEST.addTalkId(31744)
QUEST.addTalkId(31336)
QUEST.addTalkId(31743)
QUEST.addTalkId(31740)
QUEST.addTalkId(31272)

QUEST.addKillId(21154)
QUEST.addKillId(27113)
QUEST.addKillId(20244)
QUEST.addKillId(20245)
QUEST.addKillId(21511)

STARTED.addQuestDrop(27113,LEGENG_OF_SEVENTEEN,1)
STARTED.addQuestDrop(20244,MALRUK_SUCCUBUS_CLAW,1)
STARTED.addQuestDrop(20245,MALRUK_SUCCUBUS_CLAW,1)
STARTED.addQuestDrop(30692,FADED_POETRY_BOOK,1)
STARTED.addQuestDrop(31042,ECHO_CRYSTAL,1)
STARTED.addQuestDrop(31336,MEDICINE,1)
STARTED.addQuestDrop(21511,CRIMSON_MOSS,1)
STARTED.addQuestDrop(21512,CRIMSON_MOSS,1)

print "importing quests: 241: Possessor of a Precious Soul - 1"
