import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

VIRGILS_LETTER_1_PART = 7677
BLONDE_STRAND = 7590
SORCERY_INGREDIENT = 7596
CARADINE_LETTER = 7678
ORB_OF_BINDING = 7595

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31742-2.htm" :
       st.set("cond","1")
       st.set("CoRObjId","0")
       st.takeItems(VIRGILS_LETTER_1_PART,1)
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "31743-5.htm" :
       st.set("cond","2")
       st.playSound("ItemSound.quest_middle")
    elif event == "31744-2.htm" :
       st.set("cond","3")
       st.playSound("ItemSound.quest_middle")
    elif event == "31751-2.htm" :
       st.set("cond","4")
       st.playSound("ItemSound.quest_middle")
    elif event == "30759-2.htm" :
       st.takeItems(BLONDE_STRAND,1)
       st.set("cond","7")
       st.playSound("ItemSound.quest_middle")
    elif event == "30759-4.htm" :
       st.set("cond","9")
       st.playSound("ItemSound.quest_middle")
    elif event == "30738-2.htm" :
       st.set("cond","8")
       st.giveItems(SORCERY_INGREDIENT,1)
       st.playSound("ItemSound.quest_middle")
    elif event == "31748-2.htm" :
       st.takeItems(ORB_OF_BINDING,1)
       st.killNpcByObjectId(st.getInt("CoRObjId"))
       st.set("talk","0")
       if st.getInt("prog") < 4 :
          st.set("prog", str(st.getInt("prog")+1))
          st.playSound("ItemSound.quest_middle")
       if st.getInt("prog") == 4 :
         st.set("cond","10")
         st.playSound("ItemSound.quest_middle")
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if npcId == 31742 :
      if cond == 0 :
        if id == COMPLETED :
          htmltext = "<html><head><body>You have already complete this quest.</body></html>"
        else :
          if st.getQuestItemsCount(VIRGILS_LETTER_1_PART) >= 1 and st.getPlayer().isSubClassActive() and st.getPlayer().getLevel() >= 60 :
            htmltext = "31742-1.htm"
          else :
            htmltext = "31742-0.htm"
            st.exitCurrentQuest(True)
      elif cond == 1 :
         htmltext = "31742-2r.htm"
   elif npcId == 31743 and st.getPlayer().isSubClassActive() :
      if cond == 1 :
         htmltext = "31743-1.htm"
      elif cond == 2 :
         htmltext = "31743-2r.htm"
      elif cond == 11 :
         htmltext = "31743-6.htm"
         st.giveItems(CARADINE_LETTER,1)
         st.setState(COMPLETED)
         st.unset("cond")
         st.unset("CoRObjId")
         st.unset("prog")
         st.unset("talk")
         st.playSound("ItemSound.quest_finish")
   elif npcId == 31744 and st.getPlayer().isSubClassActive() :
      if cond == 2 :
         htmltext = "31744-1.htm"
      elif cond == 3 :
         htmltext = "31744-2r.htm"
   elif npcId == 31751 and st.getPlayer().isSubClassActive() :
      if cond == 3 :
         htmltext = "31751-1.htm"
      elif cond == 4 :
         htmltext = "31751-2r.htm"
      elif cond == 5 and st.getQuestItemsCount(BLONDE_STRAND) == 1 :
         st.set("cond","6")
         htmltext = "31751-3.htm"
      elif cond == 6 and st.getQuestItemsCount(BLONDE_STRAND) == 1 :
         htmltext = "31751-3r.htm"
   elif npcId == 31752 and st.getPlayer().isSubClassActive() :
      if cond == 4 :
         st.giveItems(BLONDE_STRAND,1)
         st.playSound("ItemSound.quest_itemget")
         st.set("cond","5")
         htmltext = "31752-2.htm"
      else:
         htmltext = "31752-n.htm"
   elif npcId == 30759 and st.getPlayer().isSubClassActive() :
      if cond == 6 and st.getQuestItemsCount(BLONDE_STRAND) == 1 :
         htmltext = "30759-1.htm"
      elif cond == 7 :
         htmltext = "30759-2r.htm"
      elif cond == 8 and st.getQuestItemsCount(SORCERY_INGREDIENT) == 1 :
         htmltext = "30759-3.htm"
   elif npcId == 30738 and st.getPlayer().isSubClassActive() :
      if cond == 7 :
         htmltext = "30738-1.htm"
      elif cond == 8 :
         htmltext = "30738-2r.htm"
   elif npcId == 31748 and st.getPlayer().isSubClassActive() :
      if cond == 9 :
         if st.getQuestItemsCount(ORB_OF_BINDING) >= 1 :
            if npc.getObjectId() != st.getInt("CoRObjId") :
              st.set("CoRObjId",str(npc.getObjectId()))
              st.set("talk","1")
              htmltext = "31748-1.htm"
            else:
              if st.getInt("talk") == 1 :
                htmltext = "31748-1.htm"
              else :
                htmltext = "<html><head><body>I have nothing to say you</body></html>"
         else:
            htmltext = "31748-0.htm"
   elif npcId == 31746 and st.getPlayer().isSubClassActive() : 
      if st.getInt("cond") == 9 :
         htmltext = "31746-1.htm"
      elif st.getInt("cond") == 10 :
         htmltext = "31746-1.htm"
         npc.doDie(npc)
         if not st.getPcSpawn().isSpawnExists(31747) :
           st.getPcSpawn().addSpawn(31747,npc.getX()+10,npc.getY(),npc.getZ(),120000)
      else:
         htmltext = "<html><head><body>I have nothing to say you</body></html>"
   elif npcId == 31747 and st.getPlayer().isSubClassActive() :
      if st.getInt("cond") == 10 :
        htmltext = "31747-1.htm"
        st.set("cond","11")
      elif st.getInt("cond") == 11 :
        htmltext = "31747-2.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   if npcId == 27317 :
    if st.getInt("cond") == 9 and st.getQuestItemsCount(ORB_OF_BINDING) < 4 and st.getPlayer().isSubClassActive() :
      st.giveItems(ORB_OF_BINDING,1)
      if st.getQuestItemsCount(ORB_OF_BINDING) < 4 :
        st.playSound("ItemSound.quest_itemget")
      else:
        st.playSound("ItemSound.quest_middle")
   return 

QUEST           = Quest(242,"242_PossessorOfaPreciousSoul2","Possessor Of a Precious Soul - 2",True)
CREATED         = State('Start', QUEST)
STARTED         = State('Started', QUEST)
COMPLETED       = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31742)

QUEST.addTalkId(31742)
QUEST.addTalkId(31742)

QUEST.addTalkId(31743)
QUEST.addTalkId(31751)
QUEST.addTalkId(31752)
QUEST.addTalkId(30759)
QUEST.addTalkId(30738)
QUEST.addTalkId(31744)
QUEST.addTalkId(31748)
QUEST.addTalkId(31747)
QUEST.addTalkId(31746)

QUEST.addKillId(27317)

STARTED.addQuestDrop(27317,ORB_OF_BINDING,1)
STARTED.addQuestDrop(27317,SORCERY_INGREDIENT,1)
STARTED.addQuestDrop(27317,CARADINE_LETTER,1)
STARTED.addQuestDrop(27317,BLONDE_STRAND,1)

print "importing quests: 242: Possessor of a Precious Soul - 2"