# Made by Mr. - Version 0.3 by DrLecter
import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

PREDATORS_FANG = 1334
EMERALD = 1337
BLUE_ONYX = 1338
ONYX = 1339
GLASS_SHARD = 1336
REC_LEATHER_BOOT = 2176
REC_SPIRITSHOT = 3032

DROP={20530:[[0,8,1]],20534:[[4,10,1],[0,4,2]],20537:[[0,10,2]],20525:[[5,10,2],[0,5,3]]}

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31852-03.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if cond == 0 :
     if st.getPlayer().getRace().ordinal() != 1 :
       htmltext = "31852-00.htm"
       st.exitCurrentQuest(True)
     elif st.getPlayer().getLevel() < 3 :
       htmltext = "31852-01.htm"
       st.exitCurrentQuest(True)
     else :
          htmltext = "31852-02.htm"
   else :
     if st.getQuestItemsCount(PREDATORS_FANG) < 100 :
       htmltext = "31852-04.htm"
     else :
       st.takeItems(PREDATORS_FANG,-1)
       n = st.getRandom(100)
       if n < 2 :
          st.giveItems(EMERALD,1)
          st.giveItems(REC_SPIRITSHOT,1)
          st.playSound("ItemSound.quest_jackpot")
       elif n < 20 :
          st.giveItems(BLUE_ONYX,1)
          st.giveItems(REC_LEATHER_BOOT,1)
       elif n < 45 :
          st.giveItems(ONYX,1)
       else:
          st.giveItems(GLASS_SHARD,1)
       htmltext = "31852-05.htm"
       st.set("cond","0")
       st.setState(COMPLETED)
       st.exitCurrentQuest(True)
       st.playSound("ItemSound.quest_finish")
   return htmltext

 def onKill (self,npc,st):
   if st.getInt("cond") == 1:
      npcId = npc.getNpcId()
      count = st.getQuestItemsCount(PREDATORS_FANG)
      chance = st.getRandom(10)
      qty = 0
      for i in DROP[npcId] :
         if i[0] <= chance < i[1] :
            qty = i[2]
      if qty :
        if count + qty > 100 :
          qty = 100 - count
        if count + qty == 100 :
          st.playSound("ItemSound.quest_middle")
          st.set("cond","2")
        else :
          st.playSound("ItemSound.quest_itemget")
        st.giveItems(PREDATORS_FANG,qty)
   return

QUEST       = Quest(266,"266_PleaOfPixies","Plea Of Pixies")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31852)

QUEST.addTalkId(31852)
QUEST.addTalkId(31852)
QUEST.addTalkId(31852)

for mobs in [20525,20530,20534,20537] :
   QUEST.addKillId(mobs)
   STARTED.addQuestDrop(mobs,PREDATORS_FANG,1)

print "importing quests: 266: Plea Of Pixies"