import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

MARAKU_WEREWOLF_HEAD = 1477
NECKLACE_OF_VALOR = 1507
NECKLACE_OF_COURAGE = 1506
ADENA_ID = 57
MARAKU_WOLFMEN_TOTEM = 1501

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30569-03.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
    return htmltext

 def onTalk (Self,npc,st):
   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   id2 = st.getStateId()
   cond = st.getInt("cond")
   if npcId == 30569 :
      if id == CREATED or id == COMPLETED or id2 == "Aborted" :
         if st.getPlayer().getRace().ordinal() != 3 :
            htmltext = "30569-00.htm"
            st.exitCurrentQuest(True)
         elif st.getPlayer().getLevel() < 9 :
            htmltext = "30569-01.htm"
            st.exitCurrentQuest(True)
         elif st.getQuestItemsCount(NECKLACE_OF_VALOR) or st.getQuestItemsCount(NECKLACE_OF_COURAGE) :
            htmltext = "30569-02.htm"
            return htmltext
         else:
            htmltext = "30569-07.htm"
      elif cond == 1 :
        if st.getQuestItemsCount(MARAKU_WEREWOLF_HEAD) < 40 :
          htmltext = "30569-04.htm"
        else :
          st.takeItems(MARAKU_WEREWOLF_HEAD,-1)
          st.giveItems(ADENA_ID,3500)
          if st.getQuestItemsCount(MARAKU_WOLFMEN_TOTEM) >= 1 :
             st.giveItems(ADENA_ID,st.getQuestItemsCount(MARAKU_WOLFMEN_TOTEM)*600)
             st.takeItems(MARAKU_WOLFMEN_TOTEM,-1)
          htmltext = "30569-05.htm"
          st.unset("cond")
          st.setState(COMPLETED)
          st.playSound("ItemSound.quest_finish")

   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   if npcId == 20363 or npcId == 20364 :
      if st.getInt("cond") == 1 and st.getQuestItemsCount(MARAKU_WEREWOLF_HEAD) < 40 :
        if st.getQuestItemsCount(MARAKU_WEREWOLF_HEAD) < 39 :
          st.playSound("ItemSound.quest_itemget")
        else:
          st.playSound("ItemSound.quest_middle")
        st.giveItems(MARAKU_WEREWOLF_HEAD,1)
        if st.getRandom(100) <= 5 :
          st.giveItems(MARAKU_WOLFMEN_TOTEM,1)
   return

QUEST       = Quest(274,"274_SkirmishWithTheWerewolves","Skirmish with the Werewolves")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)


QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30569)

QUEST.addTalkId(30569)
QUEST.addTalkId(30569)

QUEST.addKillId(20363)
QUEST.addKillId(20364)

STARTED.addQuestDrop(20363,MARAKU_WEREWOLF_HEAD,1)
STARTED.addQuestDrop(20364,MARAKU_WEREWOLF_HEAD,1)

print "importing quests: 274: Skirmish with the Werewolves"
