# Last fix 16/04/07 by ValianT
import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

StartNpc = 30553
Monster  = 20317

BlackWolfPelt = 1482
Reward        = [736,1502,1503,1504,1505]

class Quest (JQuest) :

    def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

    def onEvent (self,event,st) :
        htmltext = event
        if event == "30553-03.htm" :
            st.set("cond","1")
            st.setState(STARTED)
            st.playSound("ItemSound.quest_accept")
        return htmltext

    def onTalk (Self,npc,st):
        htmltext = "<html><head><body>I have nothing to say you</body></html>"
        id  = st.getState()
        id2 = st.getStateId()
        if id in [CREATED,COMPLETED] or id2 == "Aborted" :
            if st.getPlayer().getLevel() < 4 :
                htmltext = "30553-01.htm"
                st.exitCurrentQuest(True)
            else:
                htmltext = "30553-02.htm"
        else :
            if st.getQuestItemsCount(BlackWolfPelt) < 40 :
                htmltext = "30553-04.htm"
            else:
                n = st.getRandom(100)
                st.takeItems(BlackWolfPelt,-1)
                if n <= 2 :
                    st.giveItems(Reward[1],1)
                elif n <= 20 :
                    st.giveItems(Reward[2],1)
                elif n <= 45 :
                    st.giveItems(Reward[3],1)
                else :
                    st.giveItems(Reward[4],1)
                    st.giveItems(Reward[0],1)
                htmltext = "30553-05.htm"
                st.unset("cond")
                st.playSound("ItemSound.quest_finish")
                st.setState(COMPLETED)
        return htmltext

    def onKill (self,npc,st):
        BlackWolfPeltCount = st.getQuestItemsCount(BlackWolfPelt)
        if BlackWolfPeltCount <= 39 :
            st.giveItems(BlackWolfPelt,1)
            if BlackWolfPeltCount == 39 :
                st.playSound("ItemSound.quest_middle")
                st.set("cond","2")
            else :
                st.playSound("ItemSound.quest_itemget")
        return

QUEST = Quest(291,"291_RedBonnetsRevenge","Red Bonnets Revenge")
CREATED = State('Start', QUEST)
STARTED = State('Started', QUEST)
ABORTED = State('Aborted', QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(StartNpc)

QUEST.addTalkId(StartNpc)
QUEST.addTalkId(StartNpc)
QUEST.addTalkId(StartNpc)
QUEST.addTalkId(StartNpc)

QUEST.addKillId(Monster)
STARTED.addQuestDrop(Monster,BlackWolfPelt,1)

print "importing quests: 291: Red Bonnets Revenge"
