# Made by Mr. Have fun! - Version 0.3 by DrLecter
import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

ZOMBIE_HEAD = 1350
ZOMBIE_HEART = 1351
ZOMBIE_LIVER = 1352
SKULL = 1353
RIB_BONE = 1354
SPINE = 1355
ARM_BONE = 1356
THIGH_BONE = 1357
COMPLETE_SKELETON = 1358
ANATOMY_DIAGRAM = 1349
ADENA = 57

def pieces(st):
    return st.getQuestItemsCount(ZOMBIE_HEAD)+\
           st.getQuestItemsCount(SPINE)+\
           st.getQuestItemsCount(ARM_BONE)+\
           st.getQuestItemsCount(ZOMBIE_HEART)+\
           st.getQuestItemsCount(ZOMBIE_LIVER)+\
           st.getQuestItemsCount(SKULL)+\
           st.getQuestItemsCount(RIB_BONE)+\
           st.getQuestItemsCount(THIGH_BONE)+\
           st.getQuestItemsCount(COMPLETE_SKELETON)

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30336-03.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
    elif event == "30434-03.htm" :
      st.giveItems(ANATOMY_DIAGRAM,1)
    elif event == "30434-06.htm" :
      if pieces(st) > 0 :  
         st.giveItems(ADENA,30*st.getQuestItemsCount(ZOMBIE_HEAD)+20*st.getQuestItemsCount(ZOMBIE_HEART)+20*st.getQuestItemsCount(ZOMBIE_LIVER)+50*st.getQuestItemsCount(SKULL)+15*st.getQuestItemsCount(RIB_BONE)+10*st.getQuestItemsCount(SPINE)+10*st.getQuestItemsCount(ARM_BONE)+10*st.getQuestItemsCount(THIGH_BONE)+2000*st.getQuestItemsCount(COMPLETE_SKELETON))
         st.takeItems(ZOMBIE_HEAD,-1)
         st.takeItems(ZOMBIE_HEART,-1)
         st.takeItems(ZOMBIE_LIVER,-1)
         st.takeItems(SKULL,-1)
         st.takeItems(RIB_BONE,-1)
         st.takeItems(SPINE,-1)
         st.takeItems(ARM_BONE,-1)
         st.takeItems(THIGH_BONE,-1)
         st.takeItems(COMPLETE_SKELETON,-1)
      st.takeItems(ANATOMY_DIAGRAM,-1)
      st.playSound("ItemSound.quest_finish")
      st.exitCurrentQuest(True)
    elif event == "30434-07.htm" :
      if pieces(st) > 0 :  
         st.giveItems(ADENA,30*st.getQuestItemsCount(ZOMBIE_HEAD)+20*st.getQuestItemsCount(ZOMBIE_HEART)+20*st.getQuestItemsCount(ZOMBIE_LIVER)+50*st.getQuestItemsCount(SKULL)+15*st.getQuestItemsCount(RIB_BONE)+10*st.getQuestItemsCount(SPINE)+10*st.getQuestItemsCount(ARM_BONE)+10*st.getQuestItemsCount(THIGH_BONE)+2000*st.getQuestItemsCount(COMPLETE_SKELETON))
         st.takeItems(ZOMBIE_HEAD,-1)
         st.takeItems(ZOMBIE_HEART,-1)
         st.takeItems(ZOMBIE_LIVER,-1)
         st.takeItems(SKULL,-1)
         st.takeItems(RIB_BONE,-1)
         st.takeItems(SPINE,-1)
         st.takeItems(ARM_BONE,-1)
         st.takeItems(THIGH_BONE,-1)
         st.takeItems(COMPLETE_SKELETON,-1)
    elif event == "30434-09.htm" :
      st.giveItems(ADENA,2000*st.getQuestItemsCount(COMPLETE_SKELETON))
      st.takeItems(COMPLETE_SKELETON,-1)
    elif event == "30342-03.htm" :
      if st.getQuestItemsCount(SPINE) and st.getQuestItemsCount(ARM_BONE) and st.getQuestItemsCount(SKULL) and st.getQuestItemsCount(RIB_BONE) and st.getQuestItemsCount(THIGH_BONE) :
         st.takeItems(SPINE,1)
         st.takeItems(SKULL,1)
         st.takeItems(ARM_BONE,1)
         st.takeItems(RIB_BONE,1)
         st.takeItems(THIGH_BONE,1) 
         if st.getRandom(5) < 4 :
            st.giveItems(COMPLETE_SKELETON,1)
         else:
            htmltext = "30342-04.htm"
      else:
         htmltext = "30342-02.htm"
    return htmltext

 def onTalk (Self,npc,st):
   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   id2 = st.getStateId()
   if id == CREATED or id2 == "Aborted" :
     st.set("cond","0")
   if npcId == 30336 and st.getInt(("cond"))==0 :
      if st.getPlayer().getLevel() >= 15 :
         htmltext = "30336-02.htm"
         return htmltext
      else:
         htmltext = "30336-01.htm"
         st.exitCurrentQuest(True)
   elif npcId == 30336 and st.getInt(("cond")) :
      if st.getQuestItemsCount(ANATOMY_DIAGRAM) == 0 :
         htmltext = "30336-04.htm"
      else :
         htmltext = "30336-05.htm"
   elif npcId == 30434 and st.getInt(("cond")) :
      if st.getQuestItemsCount(ANATOMY_DIAGRAM) == 0 :
         htmltext = "30434-01.htm"
      elif st.getQuestItemsCount(ANATOMY_DIAGRAM) and not pieces(st) :
         htmltext = "30434-04.htm"
      elif st.getQuestItemsCount(ANATOMY_DIAGRAM) and pieces(st) and not st.getQuestItemsCount(COMPLETE_SKELETON):
         htmltext = "30434-05.htm"
      elif st.getQuestItemsCount(ANATOMY_DIAGRAM) and pieces(st) and st.getQuestItemsCount(COMPLETE_SKELETON) :
         htmltext = "30434-08.htm"
   elif npcId == 30342 and st.getInt(("cond")) and st.getQuestItemsCount(ANATOMY_DIAGRAM) :
      htmltext = "30342-01.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   if st.getQuestItemsCount(ANATOMY_DIAGRAM) :
    n = st.getRandom(100)
    if npcId == 20026 :
     if n<90 :
      st.playSound("ItemSound.quest_itemget")   
      if n<40 :
         st.giveItems(ZOMBIE_HEAD,1)
      elif n<60 :
         st.giveItems(ZOMBIE_HEART,1)
      else :
         st.giveItems(ZOMBIE_LIVER,1)
    elif npcId == 20029 :
      st.playSound("ItemSound.quest_itemget")  
      if n<44 :
         st.giveItems(ZOMBIE_HEAD,1)
      elif n<66 :
         st.giveItems(ZOMBIE_HEART,1)
      else :
        st.giveItems(ZOMBIE_LIVER,1)
    elif npcId == 20035 :
     if n<79 :
      st.playSound("ItemSound.quest_itemget")
      if n<5 :
        st.giveItems(SKULL,1)
      elif n<15 :
         st.giveItems(RIB_BONE,1)
      elif n<29 :
         st.giveItems(SPINE,1)
      else :
         st.giveItems(THIGH_BONE,1)
    elif npcId == 20042 :
     if n<86 :
      st.playSound("ItemSound.quest_itemget")   
      if n<6 :
         st.giveItems(SKULL,1)
      elif n<19 :
         st.giveItems(RIB_BONE,1)
      elif n<69 :
         st.giveItems(ARM_BONE,1)
      else :
         st.giveItems(THIGH_BONE,1)
    elif npcId == 20045 :
     if n<97 :
      st.playSound("ItemSound.quest_itemget")
      if n<9 :
         st.giveItems(SKULL,1)
      elif n<59 :
         st.giveItems(SPINE,1)
      elif n<77 :
         st.giveItems(ARM_BONE,1)
      else :
         st.giveItems(THIGH_BONE,1)
    elif npcId == 20051 :
     if n<99 :
      st.playSound("ItemSound.quest_itemget")
      if n<9 :
         st.giveItems(SKULL,1)
      elif n<59 :
         st.giveItems(RIB_BONE,1)
      elif n<79 :
         st.giveItems(SPINE,1)
      else :
         st.giveItems(ARM_BONE,1)
    elif npcId == 20514 :
     if n<51 :
      st.playSound("ItemSound.quest_itemget")
      if n<2 :
         st.giveItems(SKULL,1)
      elif n<8 :
         st.giveItems(RIB_BONE,1)
      elif n<17 :
         st.giveItems(SPINE,1)
      elif n<18 :
         st.giveItems(ARM_BONE,1)
      else :
         st.giveItems(THIGH_BONE,1)
    elif npcId == 20515 :
     if n<60 :
      st.playSound("ItemSound.quest_itemget")   
      if n<3 :
         st.giveItems(SKULL,1)
      elif n<11 :
         st.giveItems(RIB_BONE,1)
      elif n<22 :
         st.giveItems(SPINE,1)
      elif n<24 :
         st.giveItems(ARM_BONE,1)
      else :
         st.giveItems(THIGH_BONE,1)
    elif npcId == 20457 or npcId == 20458 :
      st.playSound("ItemSound.quest_itemget")
      if n<42 :
         st.giveItems(ZOMBIE_HEAD,1)
      elif n<67 :
         st.giveItems(ZOMBIE_HEART,1)
      else :
         st.giveItems(ZOMBIE_LIVER,1)

   return

QUEST       = Quest(325,"325_GrimCollector","Grim Collector",True)
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)
ABORTED     = State('Aborted', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30336)

QUEST.addTalkId(30336)
QUEST.addTalkId(30336)
QUEST.addTalkId(30342)
QUEST.addTalkId(30434)

for i in [20026,20029,20035,20042,20045,20457,20458,20051,20514,20515] :
    QUEST.addKillId(i)

for j in [20026,20029,20457,20458]:
   STARTED.addQuestDrop(j,ZOMBIE_HEAD,1)
   STARTED.addQuestDrop(j,ZOMBIE_HEART,1)
   STARTED.addQuestDrop(j,ZOMBIE_LIVER,1)
for k in [20035,20042,20045,20051,20514,20515]:
   STARTED.addQuestDrop(k,SKULL,1)
for l in [20035,20042,20051,20514,20515]:
   STARTED.addQuestDrop(l,RIB_BONE,1)
for m in [20035,20045,20051,20514,20515]:
   STARTED.addQuestDrop(m,SPINE,1)
for n in [20042,20045,20051,20515]:
   STARTED.addQuestDrop(n,ARM_BONE,1)
for o in [20035,20042,20045]:
   STARTED.addQuestDrop(o,THIGH_BONE,1)

STARTED.addQuestDrop(30342,COMPLETE_SKELETON,1)
STARTED.addQuestDrop(30434,ANATOMY_DIAGRAM,1)
STARTED.addQuestDrop(30434,ADENA,1)

print "importing quests: 325: Grim Collector"