import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

LEATHER = 1882
THREAD = 1868
ADENA = 57
DRESS_SHOES_BOX = 7113

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "30838-1.htm" :
     st.set("cond","1")
     st.setState(STARTED)
     st.playSound("ItemSound.quest_accept")
   elif event == "31520-1.htm" :
     st.set("cond","2")
   elif event == "30838-3.htm" :
     st.set("cond","3")
   elif event == "30838-5.htm" :
     if st.getQuestItemsCount(LEATHER) >= 200 and st.getQuestItemsCount(THREAD) >= 600 and st.getQuestItemsCount(ADENA) >= 200000 :
       st.takeItems(LEATHER,200)
       st.takeItems(THREAD,600)
       st.takeItems(ADENA,200000)
       st.set("cond","4")
     else :
       htmltext = "You don't have enough materials"
   elif event == "30164-1.htm" :
     if st.getQuestItemsCount(ADENA) >= 300000 :
       st.takeItems(ADENA,300000)
       st.set("cond","5")
     else :
       htmltext = "30164-havent.htm"
   elif event == "30838-7.htm" :
     st.giveItems(DRESS_SHOES_BOX,1)
     st.playSound("ItemSound.quest_finish")
     st.exitCurrentQuest(True)
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30838 :
      if cond == 0 and st.getQuestItemsCount(DRESS_SHOES_BOX) == 0 :
         if st.getPlayer().getLevel() >= 60 :
            fwear = st.getPlayer().getQuestState("37_PleaseMakeMeFormalWear")
            if fwear :
               if fwear.get("cond") == "7" :
                  htmltext = "30838-0.htm"
               else:
                  st.exitCurrentQuest(True)
            else:
               st.exitCurrentQuest(True)
         else :
            htmltext = "30838-00.htm"
      elif cond == 1 :
         htmltext = "30838-1.htm"
      elif cond == 2 :
         htmltext = "30838-2.htm"
      elif cond == 3 and st.getQuestItemsCount(LEATHER) >= 200 and st.getQuestItemsCount(THREAD) >= 600 and st.getQuestItemsCount(ADENA) >= 200000 :
         htmltext = "30838-4.htm"
      elif cond == 3 and (st.getQuestItemsCount(LEATHER) < 200 or st.getQuestItemsCount(THREAD) < 600 or st.getQuestItemsCount(ADENA) < 200000) :
         htmltext = "30838-4r.htm"
      elif cond == 4 :
         htmltext = "30838-5r.htm"
      elif cond == 5 :
         htmltext = "30838-6.htm"
   elif npcId == 31520 :
      if cond == 1 :
         htmltext = "31520-0.htm"
      elif cond == 2 :
         htmltext = "31520-1r.htm"
   elif npcId == 30164 :
      if cond == 4 :
         htmltext = "30164-0.htm"
      elif cond == 5 :
         htmltext = "30164-2.htm"
   return htmltext

QUEST       = Quest(33,"33_MakeAPairOfDressShoes","Make A Pair Of Dress Shoes",True)
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30838)
QUEST.addTalkId(30838)
QUEST.addTalkId(30838)
QUEST.addTalkId(30164)
QUEST.addTalkId(31520)

print "importing quests: 33: Make A Pair Of Dress Shoes"
