# Made by disKret
import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

#NPC
COLEMAN = 30873

#MOBS
TAIK_SEEKER = 20666
TAIK_LEADER = 20669

#QUEST ITEMS
SUPPLY_ITEM = 5872
SUSPICIOUS_DOCUMENT = 5871
RECIPE_OF_SUPPLY = 5870
ADENA = 57

#DROP CHANCES
ITEM_DROP_SEEKER = 50
ITEM_DROP_LEADER = 65
DOCUMENT_DROP = 5

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st):
   if event == "30873-2.htm" :
     st.set("cond","1")
     st.setState(STARTED)
     st.playSound("ItemSound.quest_accept")
   elif event == "30873-6.htm" :
     st.playSound("ItemSound.quest_finish")
     st.exitCurrentQuest(True)
   return event

 def onTalk (Self,npc,st):
   docs = st.getQuestItemsCount(RECIPE_OF_SUPPLY)
   supplies = st.getQuestItemsCount(SUPPLY_ITEM)
   if st.getState() != STARTED :
     if st.getPlayer().getLevel() >= 52 :
       htmltext = "30873-0.htm"
     else:
       htmltext = "30873-7.htm"
   elif docs or supplies :
     reward = 6000 + (supplies * 100) + (docs * 6000)
     st.takeItems(SUPPLY_ITEM,-1)
     st.takeItems(RECIPE_OF_SUPPLY,-1)
     st.giveItems(ADENA,reward)
     htmltext = "30873-5.htm"
   else:
     htmltext = "30873-3.htm"
   return htmltext

 def onKill (self,npc,st):
   random = st.getRandom(100)
   npcId = npc.getNpcId()
   if ( npcId == TAIK_SEEKER and random < ITEM_DROP_SEEKER ) or ( npcId == TAIK_LEADER and random < ITEM_DROP_LEADER ) :
     st.giveItems(SUPPLY_ITEM,1)
     st.playSound("ItemSound.quest_itemget")
   if random < DOCUMENT_DROP :
     if st.getQuestItemsCount(SUSPICIOUS_DOCUMENT) < 4 :    
       st.giveItems(SUSPICIOUS_DOCUMENT,1)
     else:
       st.takeItems(SUSPICIOUS_DOCUMENT,-1)
       st.giveItems(RECIPE_OF_SUPPLY,1)
     st.playSound("ItemSound.quest_itemget")
   return

QUEST       = Quest(360,"360_PlunderTheirSupplies","Plunder Their Supplies")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(COLEMAN)
QUEST.addTalkId(COLEMAN)
QUEST.addTalkId(COLEMAN)

QUEST.addKillId(TAIK_SEEKER)
QUEST.addKillId(TAIK_LEADER)

STARTED.addQuestDrop(COLEMAN,RECIPE_OF_SUPPLY,1)
STARTED.addQuestDrop(COLEMAN,SUPPLY_ITEM,1)
STARTED.addQuestDrop(COLEMAN,SUSPICIOUS_DOCUMENT,1)

print "importing quests: 360: Plunder Their Supplies"
