import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

SAIRONS_SILVER_HAIR = 5874

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30111-02.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
    elif event == "30111-quit.htm" :
      st.takeItems(SAIRONS_SILVER_HAIR,-1)
      st.playSound("ItemSound.quest_finish")
      st.exitCurrentQuest(True)
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   if id == CREATED :
     st.set("cond","0")
   else
     cond = st.getInt("cond")
   if npcId == 30111 :
      if cond == 0 :
         if st.getPlayer().getLevel() >= 48 :
            htmltext = "30111-01.htm"
         else :
            htmltext = "30111-00.htm"
            st.exitCurrentQuest(True)
      elif cond == 1 and st.getQuestItemsCount(SAIRONS_SILVER_HAIR) == 0 :
         htmltext = "30111-03.htm"
      elif cond == 1 and st.getQuestItemsCount(SAIRONS_SILVER_HAIR) >= 1 :
         st.giveItems(57, (st.getQuestItemsCount(SAIRONS_SILVER_HAIR)*5 + 12070))
         st.takeItems(SAIRONS_SILVER_HAIR,-1)
         htmltext = "30111-have.htm"
   return htmltext

 def onKill(self,npc,st):
   cond = st.getInt("cond")
   if cond == 1 and st.getRandom(100) < 66 :
      st.giveItems(SAIRONS_SILVER_HAIR,1)
      st.playSound("ItemSound.quest_middle")
   return

QUEST       = Quest(366,"366_SilverHairedShaman","Silver Haired Shaman",True)
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30111)

QUEST.addTalkId(30111)
QUEST.addTalkId(30111)
QUEST.addTalkId(30111)

for mob in range(20986,20989):
   QUEST.addKillId(mob)
   STARTED.addQuestDrop(mob,SAIRONS_SILVER_HAIR,1)

print "importing quests: 366: Silver Haired Shaman"