# Made by HellSinger
import sys
from L2jFT import Config
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

#Spellbook Page drop rate in %
DROP_RATE=int(min(15*Config.RATE_QUESTS_REWARD,100))
#npc
CASIAN = 30612
#mobs
MOBS = [20082,20084,20086,20089,20090]
#items
SPB_PAGE = 5916
#Collection Kranvel's Spellbooks
CHAPTERS = [5917, 5918, 5919, 5920]

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "30612-1.htm" :
     st.set("cond","1")
     st.setState(STARTED)
     st.playSound("ItemSound.quest_accept")
   elif event == "30612-6.htm" :
     if st.getQuestItemsCount(CHAPTERS[0]) and st.getQuestItemsCount(CHAPTERS[1]) and st.getQuestItemsCount(CHAPTERS[2]) and st.getQuestItemsCount(CHAPTERS[3]) :
       maxcount = 0
       for i in range(len(CHAPTERS)) :
         count = st.getQuestItemsCount(CHAPTERS[i])
         if maxcount < count :
           maxcount = count
       mincount = maxcount
       for i in range(len(CHAPTERS)) :
         count = st.getQuestItemsCount(CHAPTERS[i])
         if mincount > count :
           mincount = count
       for i in range(len(CHAPTERS)) :
         st.takeItems(CHAPTERS[i],mincount)
       st.giveItems(57,3600*mincount)
       htmltext = "30612-8.htm"
     else : htmltext = "30612-4.htm"
   elif event == "30612-9.htm" :
     st.playSound("ItemSound.quest_finish")
     st.exitCurrentQuest(True)
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond=st.getInt("cond")
   if id == CREATED or id == ABORTED or id == COMPLETED :
      if st.getPlayer().getLevel() < 28 :
         htmltext = "30612-0a.htm"
         st.exitCurrentQuest(True)
      else:
         htmltext = "30612-0.htm"
   elif cond == 1 :
      htmltext = "30612-4.htm"
   return htmltext

 def onKill (self,npc,st):
   if st.getRandom(100) < DROP_RATE :
      st.giveItems(SPB_PAGE,1)
      st.playSound("ItemSound.quest_itemget")
   return

QUEST           = Quest(370,"370_AnElderSowsSeeds","An Elder Sows Seeds")
CREATED         = State('Start', QUEST)
STARTED         = State('Started', QUEST)
ABORTED         = State('Aborted', QUEST)
COMPLETED       = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(CASIAN)
QUEST.addTalkId(CASIAN)
QUEST.addTalkId(CASIAN)

for mob in MOBS :
   QUEST.addKillId(mob)
   STARTED.addQuestDrop(mob,SPB_PAGE,1)



print "importing quests: 370: An Elder Sows Seeds"