# Made by disKret
import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

MYSTERIOUS_CLOTH = 7076
JEWEL_BOX = 7077
SEWING_KIT = 7078
DRESS_SHOES_BOX = 7113
FORMAL_WEAR = 6408
SIGNET_RING = 7164
ICE_WINE = 7160
BOX_OF_COOKIES = 7159

class Quest (JQuest) :

 def __init__(self,id,name,descr,party): JQuest.__init__(self,id,name,descr,party)

 def onEvent (self,event,st) :
   htmltext = event
   cond = st.getInt("cond")
   if st.getState() <> COMPLETED :
    if event == "30842-1.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")
    elif event == "31520-1.htm" :
      st.giveItems(SIGNET_RING,1)
      st.set("cond","2")
    elif event == "31521-1.htm" :
      st.takeItems(SIGNET_RING,1)  
      st.giveItems(ICE_WINE,1)
      st.set("cond","3")
    elif event == "31627-1.htm" :
      if st.getQuestItemsCount(ICE_WINE) :
         st.takeItems(ICE_WINE,1)
         st.set("cond","4")
      else:
         htmltext = "You don't have enough materials"
    elif event == "31521-3.htm" :
       st.giveItems(BOX_OF_COOKIES,1)
       st.set("cond","5")
    elif event == "31520-3.htm" :
       st.takeItems(BOX_OF_COOKIES,1)
       st.set("cond","6")       
    elif event == "31520-5.htm" :
         st.takeItems(MYSTERIOUS_CLOTH,1)
         st.takeItems(JEWEL_BOX,1)
         st.takeItems(SEWING_KIT,1)
         st.set("cond","7")
    elif event == "31520-7.htm" :
       if st.getQuestItemsCount(DRESS_SHOES_BOX) :
         st.takeItems(DRESS_SHOES_BOX,1)
         st.giveItems(FORMAL_WEAR,1)
         st.setState(COMPLETED)
         st.unset("cond")
         st.playSound("ItemSound.quest_finish")
       else :
         htmltext = "You don't have enough materials"
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30842 :
     if cond == 0 :
        if id != COMPLETED :
          if st.getPlayer().getLevel() >= 60 :
            htmltext = "30842-0.htm"            
          else :
            htmltext = "30842-2.htm"
            st.exitCurrentQuest(True)              
        else :
          htmltext = "<html><head><body>This quest has already been completed.</body></html>"
     elif cond == 1 :
        htmltext = "30842-1.htm"          
   elif npcId == 31520 : 
       if cond == 1 :
           htmltext = "31520-0.htm"
       elif cond == 2 :
           htmltext = "31520-1.htm"           
       elif cond == 5 or cond == 6 :
          if st.getQuestItemsCount(MYSTERIOUS_CLOTH) and st.getQuestItemsCount(JEWEL_BOX) and st.getQuestItemsCount(SEWING_KIT) :
            htmltext = "31520-4.htm"
          elif st.getQuestItemsCount(BOX_OF_COOKIES) :
             htmltext = "31520-2.htm"
          else :
             htmltext = "31520-3.htm"
       elif cond == 7 :
           if st.getQuestItemsCount(DRESS_SHOES_BOX) :
              htmltext = "31520-6.htm"
           else :
              htmltext = "31520-5.htm"                  
   elif npcId == 31521 :
       if st.getQuestItemsCount(SIGNET_RING) :     
          htmltext = "31521-0.htm"
       elif cond == 3 :
          htmltext = "31521-1.htm"
       elif cond == 4 :
           htmltext = "31521-2.htm"
       elif cond == 5 :
           htmltext = "31521-3.htm"
   elif npcId == 31627 :
     htmltext = "31627-0.htm"


   return htmltext

QUEST       = Quest(37,"37_PleaseMakeMeFormalWear","Please Make Me Formal Wear",True)
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30842)
QUEST.addTalkId(30842)
QUEST.addTalkId(31520)
QUEST.addTalkId(31521)
QUEST.addTalkId(31627)

print "importing quests: 37: Please Make Me Formal Wear"
