import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

BBN = 7178
RBN = 7179
IP = 7180
GML = 7181
REW = [6521,6529,6535]

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "30334-02.htm" :
      st.set("cond","1")
      st.setState(STARTED)
      st.playSound("ItemSound.quest_accept")

    elif event == "30332-02.htm" :
      st.set("cond","2")
      st.playSound("ItemSound.quest_accept")

    elif event == "30332-04.htm" :
       if st.getQuestItemsCount(BBN) == 100 and st.getQuestItemsCount(RBN) == 100 :
          st.set("cond","4")
          st.takeItems(BBN,-1)
          st.takeItems(RBN,-1)
          st.playSound("ItemSound.quest_accept")
       else :
          htmltext = "30332-02r.htm"

    elif event == "30332-06.htm" :
      if st.getQuestItemsCount(IP) == 30 and st.getQuestItemsCount(GML) == 30 :
         st.takeItems(IP,-1)
         st.takeItems(GML,-1)
         st.giveItems(REW[0],60)
         st.giveItems(REW[1],1)
         st.giveItems(REW[2],500)
         st.set("cond","0")
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
      else :
         htmltext = "30332-04r.htm"

    return htmltext

 def onTalk (Self,npc,st) :

   npcId = npc.getNpcId()
   htmltext = "<html><body>I have nothing to say you</body></html>"
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == 30334 :
      if cond == 0 :
         if id != COMPLETED:
            if st.getPlayer().getLevel() < 20 :
               htmltext = "30334-00.htm"
               st.exitCurrentQuest(True)
            elif st.getPlayer().getLevel() >= 20 :
               htmltext = "30334-01.htm"
         else :
            htmltext = "<html><body>This quest have already been completed.</body></html>"
      elif cond == 1 :
         htmltext = "30334-02r.htm"

   elif npcId == 30332 :
      if cond == 1 :
         htmltext = "30332-01.htm"
      elif cond == 2 and (st.getQuestItemsCount(BBN) < 100 or st.getQuestItemsCount(RBN) < 100) :
         htmltext = "30332-02r.htm"
      elif cond == 3 and st.getQuestItemsCount(BBN) == 100 and st.getQuestItemsCount(RBN) == 100 :
         htmltext = "30332-03.htm"
      elif cond == 4 and (st.getQuestItemsCount(IP) < 30 or st.getQuestItemsCount(GML) < 30) :
         htmltext = "30332-04r.htm"
      elif cond == 5 and st.getQuestItemsCount(IP) == 30 and st.getQuestItemsCount(GML) == 30 :
         htmltext = "30332-05.htm"

   return htmltext


 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if cond == 2 and st.getRandom(10) < 6 :
      if (npcId == 20919 or npcId == 20920) and st.getQuestItemsCount(BBN) <= 99 :
         st.giveItems(BBN,1)
      elif npcId == 20921 and st.getQuestItemsCount(RBN) <= 99  :
         st.giveItems(RBN,1)
      st.playSound("ItemSound.quest_itemget")
      if (st.getQuestItemsCount(BBN) + st.getQuestItemsCount(RBN)) == 200 :
         st.set("cond","3")
         st.playSound("ItemSound.quest_middle")

   if cond == 4 and st.getRandom(10) < 6 :
      if npcId == 20920 and st.getQuestItemsCount(IP) <= 29 :
         st.giveItems(IP,1)
      elif npcId == 20925 and st.getQuestItemsCount(GML) <= 29 :
         st.giveItems(GML,1)
      st.playSound("ItemSound.quest_itemget")
      if (st.getQuestItemsCount(IP) + st.getQuestItemsCount(GML)) == 60 :
         st.set("cond","5")
         st.playSound("ItemSound.quest_middle")

   return

QUEST       = Quest(39,"39_RedEyedInvaders","Red-Eyed Invaders")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(30334)

QUEST.addTalkId(30334)
QUEST.addTalkId(30334)
QUEST.addTalkId(30332)
QUEST.addTalkId(30334)

QUEST.addKillId(20919)
QUEST.addKillId(20920)
QUEST.addKillId(20921)
QUEST.addKillId(20925)

STARTED.addQuestDrop(20919,BBN,1)
STARTED.addQuestDrop(20920,BBN,1)
STARTED.addQuestDrop(20920,IP,1)
STARTED.addQuestDrop(20921,RBN,1)
STARTED.addQuestDrop(20921,IP,1)
STARTED.addQuestDrop(20925,GML,1)
STARTED.addQuestDrop(30332,REW[0],1)
STARTED.addQuestDrop(30332,REW[1],1)
STARTED.addQuestDrop(30332,REW[2],1)

print "importing quests: 39: Red Eyed Invaders"