import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

# NPC
MELODY_MAESTRO_OCTAVIA = 31043

# MOB
ROUGH_HEWN_ROCK_GOLEMS = 21103

# Quest items
RED_CRYSTALS = 7541
BIRTHDAY_ECHO_CRYSTAL = 7061

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)
 
 def onEvent (self,event,st) :
     htmltext = event
     if event == "31043-02.htm" :
        st.set("cond","1")
        st.setState(STARTED)
        st.playSound("ItemSound.quest_accept")
     elif event == "31043-05.htm" :
        if st.getQuestItemsCount(RED_CRYSTALS) == 50 :
           st.takeItems(RED_CRYSTALS,-1)
           st.giveItems(BIRTHDAY_ECHO_CRYSTAL,25)
           st.playSound("ItemSound.quest_finish")
           st.set("cond","0")
        else :
           htmltext = "31043-06.htm"
     return htmltext
 
 def onTalk (Self,npc,st):
     npcId = npc.getNpcId()
     htmltext = "<html><head><body>I have nothing to say you</body></html>"
     id = st.getState()
     cond = st.getInt("cond")
     if cond == 0 :
        if st.getPlayer().getLevel() >= 31 :
           htmltext = "31043-01.htm"
        else :
           htmltext = "31043-00.htm"
     elif cond == 1 :
        htmltext = "31043-03.htm"
     elif cond == 2 and st.getQuestItemsCount(RED_CRYSTALS) == 50 :
        htmltext = "31043-04.htm"
     return htmltext
 
 def onKill(self,npc,st):
    if st.getInt("cond") == 1 and st.getQuestItemsCount(RED_CRYSTALS) < 50 :
       st.giveItems(RED_CRYSTALS,1)
       if st.getQuestItemsCount(RED_CRYSTALS) == 50 :
          st.playSound("ItemSound.quest_middle")
          st.set("cond","2")
       else :
          st.playSound("ItemSound.quest_itemget")
    return
 
QUEST       = Quest(432,"432_BirthdayPartySong","Birthday Party Song")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31043)

QUEST.addTalkId(31043)
QUEST.addTalkId(31043)

QUEST.addKillId(21103)
STARTED.addQuestDrop(21103,RED_CRYSTALS,1)

print "importing quests: 432: Birthday Party Song"