# Made by ValianT
# Edit by ValianT. Update 26/02/07. Updated 28062007 by HellSinger
import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest
# NPC
Willie = 31574
TarlkBasilisks = [20573,20574]
# Items
EyeOfTarlkBasilisk = 7623
EarthFishingLure = 7612
# Skill
FishSkill = 1315

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "31574-04.htm" :
      st.setState(STARTED)
      st.set("cond","1")
      st.playSound("ItemSound.quest_accept")
   elif event == "31574-07.htm" :
      if st.getQuestItemsCount(EyeOfTarlkBasilisk) < 100 :
         htmltext = "31574-08.htm"
      else :
         st.unset("cond")
         st.takeItems(EyeOfTarlkBasilisk,-1)
         st.giveItems(EarthFishingLure,4)
         st.setState(COMPLETED)
         st.playSound("ItemSound.quest_finish")
   return htmltext

 def onTalk (Self,npc,st):
   npcId = npc.getNpcId()
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   cond = st.getInt("cond")
   id = st.getState()
   if npcId == Willie :
      if id == COMPLETED :
         htmltext = "<html><head><body>This quest have already been completed.</body></html>"
      elif id == CREATED or id == ABORTED :
         if st.getPlayer().getLevel() < 48 :
            htmltext = "31574-03.htm"
            st.exitCurrentQuest(True)
         elif st.getPlayer().getSkillLevel(FishSkill)!= None and st.getPlayer().getSkillLevel(FishSkill) >= 16 :
            htmltext = "31574-01.htm"
         else : 
            htmltext = "31574-02.htm"
            st.exitCurrentQuest(True)
      elif cond in [1,2] :
         if st.getQuestItemsCount(EyeOfTarlkBasilisk) < 100 :
            htmltext = "31574-06.htm"
            st.set("cond","1")
         else : htmltext = "31574-05.htm"
   return htmltext

 def onKill (self,npc,st):
   npcId = npc.getNpcId()
   if npcId in TarlkBasilisks and st.getInt(("cond")) == 1 :
      if st.getQuestItemsCount(EyeOfTarlkBasilisk) < 100 and st.getRandom(100) <= 30 :
         st.giveItems(EyeOfTarlkBasilisk,1)
         if st.getQuestItemsCount(EyeOfTarlkBasilisk) == 100 :
            st.playSound("ItemSound.quest_middle")
            st.set("cond","2")
         else :
            st.playSound("ItemSound.quest_itemget")
   return
QUEST       = Quest(52,"52_WilliesSpecialBait","Willie's Special Bait")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
ABORTED     = State('Aborted', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(Willie)

QUEST.addTalkId(Willie)
QUEST.addTalkId(Willie)
QUEST.addTalkId(Willie)

for mob in TarlkBasilisks :
   QUEST.addKillId(mob)
   STARTED.addQuestDrop(mob,EyeOfTarlkBasilisk,1)

print "importing quests: 52: Willie's Special Bait"
