import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

# NPC
KADUN_ZU_KETRA = 31370
KETRA_FIRST_NPC = 21324
KETRA_LAST_NPC = 21350

VARKAS_HERO_SHADITH = 25309

# Quest Items
HEAD_OF_SHADITH = 7235
TOTEM_OF_VALOR = 7219

# etc
MARK_OF_KETRA_ALLIANCE1 = 7211
MARK_OF_KETRA_ALLIANCE2 = 7212
MARK_OF_KETRA_ALLIANCE3 = 7213
MARK_OF_KETRA_ALLIANCE4 = 7214
MARK_OF_KETRA_ALLIANCE5 = 7215

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31370-2.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "31370-4.htm" :
       if st.getQuestItemsCount(HEAD_OF_SHADITH) >= 1 :
          st.takeItems(HEAD_OF_SHADITH,-1)
          st.giveItems(TOTEM_OF_VALOR,1)
          st.addExpAndSp(0,10000)
          st.unset("cond")
          st.setState(COMPLETED)
          st.playSound("ItemSound.quest_finish")
       else :
          htmltext = "31370-2r.htm"
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if cond == 0 :
      if id != COMPLETED :
         if st.getPlayer().getLevel() >= 75 :
            if st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) == 1 or st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) == 1 or st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) == 1 :
               htmltext = "31370-1.htm"
            else :
               htmltext = "31370-00.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "31370-0.htm"
            st.exitCurrentQuest(True)
      else :
         htmltext = "<html><head><body>This quest have already been completed.</body></html>"
   elif cond == 1 and st.getQuestItemsCount(HEAD_OF_SHADITH) == 0 :
      htmltext = "31370-2r.htm"
   elif cond == 2 and st.getQuestItemsCount(HEAD_OF_SHADITH) >= 1 :
      htmltext = "31370-3.htm"
   return htmltext

# "However, if you ever harm a Varka Silenos while carrying out this mission, the mission will be cancelled automatically." (c) NCSoft

 def onKill (Self,npc,st):
   npcId = npc.getNpcId()
   if npcId == VARKAS_HERO_SHADITH and st.getInt("cond") == 1 :
      st.giveItems(HEAD_OF_SHADITH,1)
      st.set("cond","2")
      st.playSound("ItemSound.quest_itemget")
   elif npcId in range(KETRA_FIRST_NPC,KETRA_LAST_NPC) :
      if st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE5,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE4,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE4,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE3,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE3,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE2,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE2,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE1,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE1,-1)
      st.getPlayer().setVarka(st.getPlayer().getVarka()-1)
      st.exitQuest(int(605))
      st.exitQuest(int(606))
      st.exitQuest(int(607))
      st.exitQuest(int(608))
      st.exitQuest(int(609))
      st.exitQuest(int(610))
   return 

QUEST		= Quest(607,"607_ProveYourCourage","Prove your courage!")
CREATED		= State('Start', QUEST)
STARTED		= State('Started', QUEST)
COMPLETED	= State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(KADUN_ZU_KETRA)
QUEST.addTalkId(KADUN_ZU_KETRA)
QUEST.addTalkId(KADUN_ZU_KETRA)
QUEST.addTalkId(KADUN_ZU_KETRA)

for mobs in range(KETRA_FIRST_NPC,KETRA_LAST_NPC) :
   QUEST.addKillId(mobs)

QUEST.addKillId(VARKAS_HERO_SHADITH)

STARTED.addQuestDrop(VARKAS_HERO_SHADITH,HEAD_OF_SHADITH,1)

print "importing quests: 607: Prove your courage!"