import sys
from L2jFT.game.tables import SkillTable
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestPcSpawn
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

# NPC
ASEFA = 31372
VARKAS_HOLY_ALTAR = 31560
SOUL_OF_WATER_ASHUTAR = 25316

KETRA_FIRST_NPC = 21324
KETRA_LAST_NPC = 21350
VARKA_FIRST_NPC = 21350
VARKA_LAST_NPC = 21376

# Quest items
GREEN_TOTEM = 7238
ICE_HEART_OF_ASHUTAR = 7239

# etc
MARK_OF_KETRA_ALLIANCE1 = 7211
MARK_OF_KETRA_ALLIANCE2 = 7212
MARK_OF_KETRA_ALLIANCE3 = 7213
MARK_OF_KETRA_ALLIANCE4 = 7214
MARK_OF_KETRA_ALLIANCE5 = 7215

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "31372-2.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "use_totem" :
       if st.getQuestItemsCount(GREEN_TOTEM) >= 1 and not st.getPcSpawn().isSpawnExists(25316) :
          st.takeItems(GREEN_TOTEM,-1)
          st.getPcSpawn().addSpawn(25316,104825,-36926,-1136)
          st.getPcSpawn().addSpawn(25317,104925,-36926,-1120)
          st.getPcSpawn().addSpawn(25318,104725,-36926,-1120)
          st.playSound("ItemSound.quest_middle")
       else :
          htmltext = "31560-havenot.htm"
    elif event == "31372-4.htm" :
       if st.getQuestItemsCount(ICE_HEART_OF_ASHUTAR) >= 1 :
          st.takeItems(ICE_HEART_OF_ASHUTAR,-1)
          st.set("cond","0")
          st.setState(COMPLETED)
          st.playSound("ItemSound.quest_finish")
          htmltext = "31561-2.htm"
       else :
          htmltext = "31372-havenot.htm"
    return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   id = st.getState()
   npcId = npc.getNpcId()
   cond = st.getInt("cond")
   if npcId == ASEFA :
      if cond == 0 :
         if id != COMPLETED :
            if st.getPlayer().getLevel() >= 75 :
               if st.getQuestItemsCount(GREEN_TOTEM) == 1 :
                  htmltext = "31372-1.htm"
               else :
                  htmltext = "31372-00.htm"
                  st.exitCurrentQuest(True)
            else :
               htmltext = "31372-0.htm"
               st.exitCurrentQuest(True)
         else :
            htmltext = "<html><head><body>This quest have already been completed.</body></html>"
      elif cond == 1 :
         htmltext = "31372-2r.htm"
      elif cond == 2 :
         htmltext = "31372-2rr.htm"
      elif cond == 3 and st.getQuestItemsCount(ICE_HEART_OF_ASHUTAR) == 1 :
         htmltext = "31372-3.htm"
   elif npcId == VARKAS_HOLY_ALTAR :
      if not npc.isBusy():
         if cond == 1 :
            htmltext = "31560-1.htm"
         elif cond == 2 and not st.isSpawnExists(25316) :
            st.getPcSpawn().addSpawn(25316,104825,-36926,-1136)
            st.getPcSpawn().addSpawn(25317,104925,-36926,-1120)
            st.getPcSpawn().addSpawn(25318,104725,-36926,-1120)
            htmltext = "31560-3.htm"
      else :
         htmltext = "31560-busy.htm"
   return htmltext

# "However, if you ever harm a Ketra Orc while carrying out this mission, the mission will be cancelled automatically." (c) NCSoft

 def onKill (Self,npc,st):
   npcId = npc.getNpcId()
   if npcId in range(KETRA_FIRST_NPC,KETRA_LAST_NPC) :
      if st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE5,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE4,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE4,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE3,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE3,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE2,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE2,-1)
         st.giveItems(MARK_OF_KETRA_ALLIANCE1,1)
      elif st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) :
         st.takeItems(MARK_OF_KETRA_ALLIANCE1,-1)
      st.getPlayer().setKetra(st.getPlayer().getKetra()-1)
      st.exitQuest(int(605))
      st.exitQuest(int(606))
      st.exitQuest(int(607))
      st.exitQuest(int(608))
      st.exitQuest(int(609))
      st.exitQuest(int(610))
   else :
      if st.getQuestItemsCount(ICE_HEART_OF_ASHUTAR) == 0 :
         st.giveItems(ICE_HEART_OF_ASHUTAR,1)
         st.set("cond","3")
         st.getPcSpawn().removeAllSpawn()
   return 

QUEST		= Quest(610,"610_MagicalPowerofWater2","Magical Power of Water - Part 2")
CREATED		= State('Start', QUEST)
STARTED		= State('Started', QUEST)
COMPLETED	= State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(ASEFA)
QUEST.addTalkId(ASEFA)
QUEST.addTalkId(ASEFA)
QUEST.addTalkId(ASEFA)

QUEST.addTalkId(VARKAS_HOLY_ALTAR)

for mobs in range(KETRA_FIRST_NPC,KETRA_LAST_NPC) :
   QUEST.addKillId(mobs)

QUEST.addKillId(SOUL_OF_WATER_ASHUTAR)

STARTED.addQuestDrop(SOUL_OF_WATER_ASHUTAR,ICE_HEART_OF_ASHUTAR,1)

print "importing quests: 610: Magical Power of Water - Part 2"