# Made by disKret
import sys
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

#NPC
M_NECROMANCER = 31518
ENFEUX = 31519

#ITEMS
SEAL_OF_LIGHT = 7170
GEM_OF_SUBMISSION = 7171
GEM_OF_SAINTS = 7172

#REWARDS
ADENA = 57
MOLD_HARDENER = 4041
ENRIA = 4042
ASOFE = 4043
THONS = 4044

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
   htmltext = event
   if event == "31518-1.htm" :
     st.set("cond","1")
     st.setState(STARTED)
     st.playSound("ItemSound.quest_accept")
   elif event == "31518-3.htm" :
     st.takeItems(GEM_OF_SUBMISSION,300)
     st.giveItems(SEAL_OF_LIGHT,1)
     st.set("cond","3")
   elif event == "31519-1.htm" :
     st.takeItems(SEAL_OF_LIGHT,1)
     st.giveItems(GEM_OF_SAINTS,1)
     st.set("cond","4")
   elif event == "31518-5.htm" :
     st.takeItems(GEM_OF_SAINTS,1)
   else :
     if event == "31518-6.htm" :
       st.giveItems(ADENA,100000)
     elif event == "31518-7.htm" :
       st.giveItems(ASOFE,13)
       st.giveItems(ADENA,6400)
     elif event == "31518-8.htm" :
       st.giveItems(THONS,13)
       st.giveItems(ADENA,6400)
     elif event == "31518-9.htm" :
       st.giveItems(ENRIA,6)
       st.giveItems(ADENA,13600)
     elif event == "31518-10.htm" :
       st.giveItems(MOLD_HARDENER,3)
       st.giveItems(ADENA,17200)
     st.set("cond","0")
     st.playSound("ItemSound.quest_finish")
     st.exitCurrentQuest(True)
   return htmltext

 def onTalk (Self,npc,st):
   htmltext = "<html><head><body>I have nothing to say you</body></html>"
   npcId = npc.getNpcId()
   id = st.getState()
   cond = st.getInt("cond")
   if npcId == M_NECROMANCER :
      if cond == 0 :
        if st.getPlayer().getLevel() >= 60 : # and st.getPlayer().getLevel() <= 71
          htmltext = "31518-0.htm"
        else:
          htmltext = "31518-0a.htm"
          st.exitCurrentQuest(True)
      elif cond == 1 :
        htmltext = "31518-1a.htm"
      elif st.getQuestItemsCount(GEM_OF_SUBMISSION) == 300 :
        htmltext = "31518-2.htm"
      elif st.getQuestItemsCount(GEM_OF_SAINTS) :
        htmltext = "31518-4.htm"
   elif npcId == ENFEUX and st.getQuestItemsCount(SEAL_OF_LIGHT) :
     htmltext = "31519-0.htm"
   return htmltext

 def onKill (self,npc,st):
  count = st.getQuestItemsCount(GEM_OF_SUBMISSION)
  if st.getInt("cond") == 1 and count < 300 :
     st.giveItems(GEM_OF_SUBMISSION,1)
     if count == 299 :
       st.playSound("ItemSound.quest_middle")
       st.set("cond","2")
     else:
       st.playSound("ItemSound.quest_itemget")	
  return

QUEST       = Quest(627,"627_HeartInSearchOfPower","Heart In Search Of Power")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
ABORTED     = State('Aborted', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(31518)

QUEST.addTalkId(31518)
QUEST.addTalkId(31518)
QUEST.addTalkId(31518)
QUEST.addTalkId(31519)

for mobs in range(21520,21541):
  QUEST.addKillId(mobs)
  STARTED.addQuestDrop(mobs,GEM_OF_SUBMISSION,1)
print "importing quests: 627: Heart In Search Of Power"
