import sys
from L2jFT import Config
from L2jFT.game.model.quest import State
from L2jFT.game.model.quest import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

#Settings: drop chance in %
DROP_CHANCE=60
#Set this to non-zero to use 100% recipes as reward instead of default 60%
ALT_RP_100=0

#QUEST ITEMS
DESTROYED_GOLEM_SHARD = 8100

#REWARDS
RECIPES_60= [4963,4964,4965,4966,4967,4968,4969,4970,4971,4972,5000,5001,5002,5003,5004,5005,5006,5007,5008]+[8298, 8306, 8310, 8312, 8322, 8324]
RECIPES_100= range(4181,4200)+[8297, 8305, 8309, 8311, 8321, 8323]


class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st) :
    htmltext = event
    if event == "32069-02.htm" :
       st.set("cond","1")
       st.setState(STARTED)
       st.playSound("ItemSound.quest_accept")
    elif event == "32069-06.htm" :
       if st.getQuestItemsCount(DESTROYED_GOLEM_SHARD) >= 500:
          st.takeItems(DESTROYED_GOLEM_SHARD,500)
          if ALT_RP_100 :
            item = RECIPES_60[st.getRandom(len(RECIPES_60))]
          else :
            item = RECIPES_100[st.getRandom(len(RECIPES_100))]
          st.giveItems(item,1)
          st.playSound("ItemSound.quest_finish")
          st.set("cond","0")
          st.setState(COMPLETED)
       else:
          htmltext = "32069-04.htm"
    return htmltext

 def onTalk (Self,npc,st):
    npcId = npc.getNpcId()
    htmltext = "<html><head><body>I have nothing to say you</body></html>"
    cond = st.getInt("cond")
    count = st.getQuestItemsCount(DESTROYED_GOLEM_SHARD)
    if cond == 0 :
       if st.getPlayer().getLevel() >= 46 :
          htmltext = "32069-01.htm"
       else:
          htmltext = "32069-03.htm"
          st.exitCurrentQuest(True)
    elif cond==1 or count < 500 :
       htmltext = "32069-04.htm"
    elif cond==2 and count >= 500 :
       htmltext = "32069-05.htm"
    return htmltext

 def onKill (self,npc,st):
    npcId = npc.getNpcId()
    cond = st.getInt("cond")
    count = st.getQuestItemsCount(DESTROYED_GOLEM_SHARD)
    if cond == 1 and count < 500:
       chance = DROP_CHANCE*Config.RATE_QUESTS_REWARD
       numItems, chance = divmod(chance,100)
       if st.getRandom(100) < chance : 
          numItems += 1
       if numItems :
          if count + numItems >= 500 :
             numItems = 500 - count
             st.playSound("ItemSound.quest_middle")
             st.set("cond","2")
          else:
             st.playSound("ItemSound.quest_itemget")
          st.giveItems(DESTROYED_GOLEM_SHARD,int(numItems))
    return

QUEST       = Quest(647,"647_InfluxOfMachines","Influx of Machines")
CREATED     = State('Start', QUEST)
STARTED     = State('Started', QUEST)
COMPLETED   = State('Completed', QUEST)

QUEST.setInitialState(CREATED)
QUEST.addStartNpc(32069)

QUEST.addTalkId(32069)
QUEST.addTalkId(32069)
QUEST.addTalkId(32069)

for i in range(22052,22079):
   QUEST.addKillId(i)

STARTED.addQuestDrop(8100,DESTROYED_GOLEM_SHARD,1)

print "importing quests: 647: Influx of Machines"