#
# Created by DraX on 2005.08.15
#

import sys

from L2jFT.game.model.quest        import State
from L2jFT.game.model.quest        import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

RING_OF_RAVEN_ID        = 1642
WAREHOUSE_CHIEF_MOKE    = 30498

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st):
   
   htmltext = "No Quest"
   
   Race     = st.getPlayer().getRace()
   ClassId  = st.getPlayer().getClassId()
   Level    = st.getPlayer().getLevel()

   if event == "30498-01.htm":
     return "30498-01.htm"

   if event == "30498-02.htm":
     return "30498-02.htm"

   if event == "30498-03.htm":
     return "30498-03.htm"

   if event == "30498-04.htm":
     return "30498-04.htm"

   if event == "class_change_54":
     if ClassId in [ClassId.dwarvenFighter]:
        if Level <= 19 and st.getQuestItemsCount(RING_OF_RAVEN_ID) == 0:
          htmltext = "30498-05.htm"
        if Level <= 19 and st.getQuestItemsCount(RING_OF_RAVEN_ID) >= 1:
          htmltext = "30498-06.htm"
        if Level >= 20 and st.getQuestItemsCount(RING_OF_RAVEN_ID) == 0:
          htmltext = "30498-07.htm"
        if Level >= 20 and st.getQuestItemsCount(RING_OF_RAVEN_ID) >= 1:
          st.takeItems(RING_OF_RAVEN_ID,1)
          st.player.setClassId(54,False)
          st.player.broadcastUserInfo()
          st.playSound("ItemSound.quest_fanfare_2")
          htmltext = "30498-08.htm"
          
   st.setState(COMPLETED)
   st.exitCurrentQuest(True)
   return htmltext


 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()
   
   Race    = st.getPlayer().getRace()
   ClassId = st.getPlayer().getClassId()
   
   # Dwarfs got accepted
   if npcId == WAREHOUSE_CHIEF_MOKE and Race in [Race.Dwarf]:
     if ClassId in [ClassId.dwarvenFighter]:
       st.setState(STARTED)
       return "30498-01.htm"
     if ClassId in [ClassId.scavenger, ClassId.artisan]:
       st.setState(COMPLETED)
       st.exitCurrentQuest(True)
       return "30498-09.htm"
     if ClassId in [ClassId.bountyHunter, ClassId.warsmith]:
       st.setState(COMPLETED)
       st.exitCurrentQuest(True)
       return "30498-10.htm"

   # All other Races must be out
   if npcId == WAREHOUSE_CHIEF_MOKE and Race in [Race.Elf, Race.DarkElf, Race.Orc, Race.Human]:
     st.setState(COMPLETED)
     st.exitCurrentQuest(True)
     return "30498-11.htm"

QUEST     = Quest(30498,"30498_moke_occupation_change","village_master")
CREATED   = State('Start',     QUEST)
STARTED   = State('Started',   QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)

QUEST.addStartNpc(30498)

QUEST.addTalkId(30498)
