#
# Created by DraX on 2005.08.13 modified by Ariakas on 2005.09.19
#

import sys

from L2jFT.game.model.quest        import State
from L2jFT.game.model.quest        import QuestState
from L2jFT.game.model.quest import QuestJython as JQuest

PASS_FINAL_ID           = 1635
HEAD_BLACKSMITH_OPIX    = 30595

class Quest (JQuest) :

 def __init__(self,id,name,descr): JQuest.__init__(self,id,name,descr)

 def onEvent (self,event,st):

   htmltext = "No Quest"

   Race     = st.getPlayer().getRace()
   ClassId  = st.getPlayer().getClassId()
   Level    = st.getPlayer().getLevel()

   if event == "30595-01.htm":
     return "30595-01.htm"

   if event == "30595-02.htm":
     return "30595-02.htm"

   if event == "30595-03.htm":
     return "30595-03.htm"

   if event == "30595-04.htm":
     return "30595-04.htm"

   if event == "class_change_56":
     if ClassId in [ClassId.dwarvenFighter]:
        if Level <= 19 and st.getQuestItemsCount(PASS_FINAL_ID) == 0:
          htmltext = "30595-05.htm"
        if Level <= 19 and st.getQuestItemsCount(PASS_FINAL_ID) >= 1:
          htmltext = "30595-06.htm"
        if Level >= 20 and st.getQuestItemsCount(PASS_FINAL_ID) == 0:
          htmltext = "30595-07.htm"
        if Level >= 20 and st.getQuestItemsCount(PASS_FINAL_ID) >= 1:
          st.takeItems(PASS_FINAL_ID,1)
          st.player.setClassId(56,False)
          st.player.broadcastUserInfo()
          st.playSound("ItemSound.quest_fanfare_2")
          htmltext = "30595-08.htm"

   st.setState(COMPLETED)
   st.exitCurrentQuest(True)
   return htmltext

 def onTalk (Self,npc,st):

   npcId = npc.getNpcId()

   Race    = st.getPlayer().getRace()
   ClassId = st.getPlayer().getClassId()
   
   # Dwarfs got accepted
   if npcId == HEAD_BLACKSMITH_OPIX and Race in [Race.Dwarf]:
     if ClassId in [ClassId.dwarvenFighter]:
       htmltext = "30595-01.htm"
       st.setState(STARTED)
       return htmltext
     if ClassId in [ClassId.scavenger, ClassId.artisan]:
       htmltext = "30595-09.htm"
       st.setState(COMPLETED)
       st.exitCurrentQuest(True)
       return htmltext
     if ClassId in [ClassId.bountyHunter, ClassId.warsmith]:
       htmltext = "30595-10.htm"
       st.setState(COMPLETED)
       st.exitCurrentQuest(True)
       return htmltext

   # All other Races must be out
   if npcId == HEAD_BLACKSMITH_OPIX and Race in [Race.Elf, Race.DarkElf, Race.Orc, Race.Human]:
     st.setState(COMPLETED)
     st.exitCurrentQuest(True)
     return "30595-11.htm"

QUEST   = Quest(30595,"30595_opix_occupation_change","village_master")
CREATED   = State('Start',     QUEST)
STARTED   = State('Started',   QUEST)
COMPLETED = State('Completed', QUEST)

QUEST.setInitialState(CREATED)

QUEST.addStartNpc(30595)

QUEST.addTalkId(30595)
