package actions;

import commands.admin.AdminEditChar;

import L2jFT.Config;
import L2jFT.extensions.scripts.Functions;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.cache.InfoCache;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2DoorInstance;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.skills.Stats;
import L2jFT.util.Files;

public class OnActionShift extends Functions implements ScriptFile
{
	public static L2Object self;
	public static L2NpcInstance npc;

	public void onLoad()
	{
		System.out.println("OnActionShift Loaded");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public static boolean OnActionShift_L2NpcInstance(L2Player player, L2Object object)
	{
		if(player == null || object == null)
			return false;
		if(object instanceof L2NpcInstance)
		{
			String dialog;
			L2NpcInstance npc = (L2NpcInstance) object;

			if(Config.ALT_FULL_NPC_STATS_PAGE)
			{
				dialog = Files.read("data/scripts/actions/player.L2NpcInstance.onActionShift.full.htm");
				dialog = dialog.replaceFirst("%class%", String.valueOf(npc.getClass().getSimpleName().replaceFirst("L2", "").replaceFirst("Instance", "")));
				dialog = dialog.replaceFirst("%id%", String.valueOf(npc.getNpcId()));
				dialog = dialog.replaceFirst("%spawn%", String.valueOf(npc.getSpawn() != null ? npc.getSpawn().getId() : "0"));
				dialog = dialog.replaceFirst("%walkSpeed%", String.valueOf(npc.getWalkSpeed()));
				dialog = dialog.replaceFirst("%evs%", String.valueOf(npc.getEvasionRate(null)));
				dialog = dialog.replaceFirst("%acc%", String.valueOf(npc.getEvasionRate(null)));
				dialog = dialog.replaceFirst("%crt%", String.valueOf(npc.getCriticalHit(null, null)));
				dialog = dialog.replaceFirst("%aspd%", String.valueOf(npc.getPAtkSpd()));
				dialog = dialog.replaceFirst("%cspd%", String.valueOf(npc.getMAtkSpd()));
				dialog = dialog.replaceFirst("%loc%", String.valueOf(npc.getSpawn() != null ? npc.getSpawn().getLocation() : "0"));
				dialog = dialog.replaceFirst("%dist%", String.valueOf((int) npc.getDistance3D(player)));
				dialog = dialog.replaceFirst("%killed%", String.valueOf(npc.getTemplate().killscount));
				dialog = dialog.replaceFirst("%spReward%", String.valueOf(npc.getSpReward()));
				dialog = dialog.replaceFirst("%STR%", String.valueOf(npc.getSTR()));
				dialog = dialog.replaceFirst("%DEX%", String.valueOf(npc.getDEX()));
				dialog = dialog.replaceFirst("%CON%", String.valueOf(npc.getCON()));
				dialog = dialog.replaceFirst("%INT%", String.valueOf(npc.getINT()));
				dialog = dialog.replaceFirst("%WIT%", String.valueOf(npc.getWIT()));
				dialog = dialog.replaceFirst("%MEN%", String.valueOf(npc.getMEN()));
			}
			else
				dialog = Files.read("data/scripts/actions/player.L2NpcInstance.onActionShift.htm");

			dialog = dialog.replaceFirst("%name%", npc.getName());
			dialog = dialog.replaceFirst("%level%", String.valueOf(npc.getLevel()));
			dialog = dialog.replaceFirst("%factionId%", npc.getFactionId().equals("") ? "none" : npc.getFactionId());
			dialog = dialog.replaceFirst("%aggro%", String.valueOf(npc.getAggroRange()));
			dialog = dialog.replaceFirst("%maxHp%", String.valueOf(npc.getMaxHp()));
			dialog = dialog.replaceFirst("%maxMp%", String.valueOf(npc.getMaxMp()));
			dialog = dialog.replaceFirst("%pDef%", String.valueOf(npc.getPDef(null)));
			dialog = dialog.replaceFirst("%mDef%", String.valueOf(npc.getMDef(null, null)));
			dialog = dialog.replaceFirst("%pAtk%", String.valueOf(npc.getPAtk(null)));
			dialog = dialog.replaceFirst("%mAtk%", String.valueOf(npc.getMAtk(null, null)));
			dialog = dialog.replaceFirst("%expReward%", String.valueOf(npc.getExpReward()));
			dialog = dialog.replaceFirst("%runSpeed%", String.valueOf(npc.getRunSpeed()));

			// Дополнительная инфа для ГМов
			if(player.getPlayerAccess().IsGM)
				dialog = dialog.replaceFirst("%AI%", String.valueOf(npc.getAI()) + ",<br1>active: " + npc.getAI().isActive() + ",<br1>intention: " + npc.getAI().getIntention());
			else
				dialog = dialog.replaceFirst("%AI%", "");

			show(dialog, player);
		}
		return false;
	}

	public static String getNpcRaceById(short raceId)
	{
		switch(raceId)
		{
			case 1:
				return "Undead";
			case 2:
				return "Magic Creatures";
			case 3:
				return "Beasts";
			case 4:
				return "Animals";
			case 5:
				return "Plants";
			case 6:
				return "Humanoids";
			case 7:
				return "Spirits";
			case 8:
				return "Angels";
			case 9:
				return "Demons";
			case 10:
				return "Dragons";
			case 11:
				return "Giants";
			case 12:
				return "Bugs";
			case 13:
				return "Fairies";
			case 14:
				return "Humans";
			case 15:
				return "Elves";
			case 16:
				return "Dark Elves";
			case 17:
				return "Orcs";
			case 18:
				return "Dwarves";
			case 19:
				return "Others";
			case 20:
				return "Non-living Beings";
			case 21:
				return "Siege Weapons";
			case 22:
				return "Defending Army";
			case 23:
				return "Mercenaries";
			case 24:
				return "Unknown Creature";
			default:
				return "Not defined";
		}
	}

	public static void droplist()
	{
		if(npc == null || self == null)
			return;
		show(InfoCache.getFromDroplistCache(npc.getNpcId()), (L2Player) self);
	}

	public static void stats()
	{
		if(npc == null || self == null)
			return;
		L2Player player = (L2Player) self;
		String dialog = Files.read("data/scripts/actions/player.L2NpcInstance.stats.htm");
		dialog = dialog.replaceFirst("%name%", npc.getName());
		dialog = dialog.replaceFirst("%level%", String.valueOf(npc.getLevel()));
		dialog = dialog.replaceFirst("%factionId%", npc.getFactionId());
		dialog = dialog.replaceFirst("%aggro%", String.valueOf(npc.getAggroRange()));
		dialog = dialog.replaceFirst("%race%", getNpcRaceById(npc.getTemplate().getRace()));
		dialog = dialog.replaceFirst("%herbs%", String.valueOf(npc.getTemplate().isDropHerbs));
		dialog = dialog.replaceFirst("%maxHp%", String.valueOf(npc.getMaxHp()));
		dialog = dialog.replaceFirst("%maxMp%", String.valueOf(npc.getMaxMp()));
		dialog = dialog.replaceFirst("%pDef%", String.valueOf(npc.getPDef(null)));
		dialog = dialog.replaceFirst("%mDef%", String.valueOf(npc.getMDef(null, null)));
		dialog = dialog.replaceFirst("%pAtk%", String.valueOf(npc.getPAtk(null)));
		dialog = dialog.replaceFirst("%mAtk%", String.valueOf(npc.getMAtk(null, null)));
		dialog = dialog.replaceFirst("%accuracy%", String.valueOf(npc.getAccuracy()));
		dialog = dialog.replaceFirst("%evasionRate%", String.valueOf(npc.getEvasionRate(null)));
		dialog = dialog.replaceFirst("%criticalHit%", String.valueOf(npc.getCriticalHit(null, null)));
		dialog = dialog.replaceFirst("%runSpeed%", String.valueOf(npc.getRunSpeed()));
		dialog = dialog.replaceFirst("%walkSpeed%", String.valueOf(npc.getWalkSpeed()));
		dialog = dialog.replaceFirst("%pAtkSpd%", String.valueOf(npc.getPAtkSpd()));
		dialog = dialog.replaceFirst("%mAtkSpd%", String.valueOf(npc.getMAtkSpd()));
		dialog = dialog.replaceFirst("%STR%", String.valueOf(npc.getSTR()));
		dialog = dialog.replaceFirst("%DEX%", String.valueOf(npc.getDEX()));
		dialog = dialog.replaceFirst("%CON%", String.valueOf(npc.getCON()));
		dialog = dialog.replaceFirst("%INT%", String.valueOf(npc.getINT()));
		dialog = dialog.replaceFirst("%WIT%", String.valueOf(npc.getWIT()));
		dialog = dialog.replaceFirst("%MEN%", String.valueOf(npc.getMEN()));
		show(dialog, player);
	}

	public static void resists()
	{
		if(npc == null || self == null)
			return;
		L2Player player = (L2Player) self;
		StringBuilder dialog = new StringBuilder("<html><body><table width=\"40%\">");

		int FIRE_RECEPTIVE = 100 - (int) npc.calcStat(Stats.FIRE_RECEPTIVE, 100, null, null);
		if(FIRE_RECEPTIVE != 0)
			dialog.append("<tr><td>Fire</td><td>").append(FIRE_RECEPTIVE).append("%</td></tr>");

		int WIND_RECEPTIVE = 100 - (int) npc.calcStat(Stats.WIND_RECEPTIVE, 100, null, null);
		if(WIND_RECEPTIVE != 0)
			dialog.append("<tr><td>Wind</td><td>").append(WIND_RECEPTIVE).append("%</td></tr>");

		int WATER_RECEPTIVE = 100 - (int) npc.calcStat(Stats.WATER_RECEPTIVE, 100, null, null);
		if(WATER_RECEPTIVE != 0)
			dialog.append("<tr><td>Water</td><td>").append(WATER_RECEPTIVE).append("%</td></tr>");

		int EARTH_RECEPTIVE = 100 - (int) npc.calcStat(Stats.EARTH_RECEPTIVE, 100, null, null);
		if(EARTH_RECEPTIVE != 0)
			dialog.append("<tr><td>Earth</td><td>").append(EARTH_RECEPTIVE).append("%</td></tr>");

		int BLEED_RECEPTIVE = 100 - (int) npc.calcStat(Stats.BLEED_RECEPTIVE, 100, null, null);
		if(BLEED_RECEPTIVE != 0)
			dialog.append("<tr><td>Bleed</td><td>").append(BLEED_RECEPTIVE).append("%</td></tr>");

		int POISON_RECEPTIVE = 100 - (int) npc.calcStat(Stats.POISON_RECEPTIVE, 100, null, null);
		if(POISON_RECEPTIVE != 0)
			dialog.append("<tr><td>Poison</td><td>").append(POISON_RECEPTIVE).append("%</td></tr>");

		int UNHOLY_RECEPTIVE = 100 - (int) npc.calcStat(Stats.UNHOLY_RECEPTIVE, 100, null, null);
		if(UNHOLY_RECEPTIVE != 0)
			dialog.append("<tr><td>Darkness</td><td>").append(UNHOLY_RECEPTIVE).append("%</td></tr>");

		int SACRED_RECEPTIVE = 100 - (int) npc.calcStat(Stats.SACRED_RECEPTIVE, 100, null, null);
		if(SACRED_RECEPTIVE != 0)
			dialog.append("<tr><td>Light</td><td>").append(SACRED_RECEPTIVE).append("%</td></tr>");

		int DEATH_RECEPTIVE = 100 - (int) npc.calcStat(Stats.DEATH_RECEPTIVE, 100, null, null);
		if(DEATH_RECEPTIVE != 0)
			dialog.append("<tr><td>Death</td><td>").append(DEATH_RECEPTIVE).append("%</td></tr>");

		int STUN_RECEPTIVE = 100 - (int) npc.calcStat(Stats.STUN_RECEPTIVE, 100, null, null);
		if(STUN_RECEPTIVE != 0)
			dialog.append("<tr><td>Stun</td><td>").append(STUN_RECEPTIVE).append("%</td></tr>");

		int ROOT_RECEPTIVE = 100 - (int) npc.calcStat(Stats.ROOT_RECEPTIVE, 100, null, null);
		if(ROOT_RECEPTIVE != 0)
			dialog.append("<tr><td>Root</td><td>").append(ROOT_RECEPTIVE).append("%</td></tr>");

		int SLEEP_RECEPTIVE = 100 - (int) npc.calcStat(Stats.SLEEP_RECEPTIVE, 100, null, null);
		if(SLEEP_RECEPTIVE != 0)
			dialog.append("<tr><td>Sleep</td><td>").append(SLEEP_RECEPTIVE).append("%</td></tr>");

		int PARALYZE_RECEPTIVE = 100 - (int) npc.calcStat(Stats.PARALYZE_RECEPTIVE, 100, null, null);
		if(PARALYZE_RECEPTIVE != 0)
			dialog.append("<tr><td>Paralyze</td><td>").append(PARALYZE_RECEPTIVE).append("%</td></tr>");

		int FEAR_RECEPTIVE = 100 - (int) npc.calcStat(Stats.FEAR_RECEPTIVE, 100, null, null);
		if(FEAR_RECEPTIVE != 0)
			dialog.append("<tr><td>Fear</td><td>").append(FEAR_RECEPTIVE).append("%</td></tr>");

		int DEBUFF_RECEPTIVE = 100 - (int) npc.calcStat(Stats.DEBUFF_RECEPTIVE, 100, null, null);
		if(DEBUFF_RECEPTIVE != 0)
			dialog.append("<tr><td>Debuff</td><td>").append(DEBUFF_RECEPTIVE).append("%</td></tr>");

		int CANCEL_RECEPTIVE = 100 - (int) npc.calcStat(Stats.CANCEL_RECEPTIVE, 100, null, null);
		if(CANCEL_RECEPTIVE != 0)
			dialog.append("<tr><td>Cancel</td><td>").append(CANCEL_RECEPTIVE).append("%</td></tr>");

		int SWORD_WPN_RECEPTIVE = 100 - (int) npc.calcStat(Stats.SWORD_WPN_RECEPTIVE, 100, null, null);
		if(SWORD_WPN_RECEPTIVE != 0)
			dialog.append("<tr><td>Sword</td><td>").append(SWORD_WPN_RECEPTIVE).append("%</td></tr>");

		int DUAL_WPN_RECEPTIVE = 100 - (int) npc.calcStat(Stats.DUAL_WPN_RECEPTIVE, 100, null, null);
		if(DUAL_WPN_RECEPTIVE != 0)
			dialog.append("<tr><td>Dual Sword</td><td>").append(DUAL_WPN_RECEPTIVE).append("%</td></tr>");

		int BLUNT_WPN_RECEPTIVE = 100 - (int) npc.calcStat(Stats.BLUNT_WPN_RECEPTIVE, 100, null, null);
		if(BLUNT_WPN_RECEPTIVE != 0)
			dialog.append("<tr><td>Blunt</td><td>").append(BLUNT_WPN_RECEPTIVE).append("%</td></tr>");

		int DAGGER_WPN_RECEPTIVE = 100 - (int) npc.calcStat(Stats.DAGGER_WPN_RECEPTIVE, 100, null, null);
		if(DAGGER_WPN_RECEPTIVE != 0)
			dialog.append("<tr><td>Dagger</td><td>").append(DAGGER_WPN_RECEPTIVE).append("%</td></tr>");

		int BOW_WPN_RECEPTIVE = 100 - (int) npc.calcStat(Stats.BOW_WPN_RECEPTIVE, 100, null, null);
		if(BOW_WPN_RECEPTIVE != 0)
			dialog.append("<tr><td>Bow</td><td>").append(BOW_WPN_RECEPTIVE).append("%</td></tr>");

		int POLE_WPN_RECEPTIVE = 100 - (int) npc.calcStat(Stats.POLE_WPN_RECEPTIVE, 100, null, null);
		if(POLE_WPN_RECEPTIVE != 0)
			dialog.append("<tr><td>Polearm</td><td>").append(POLE_WPN_RECEPTIVE).append("%</td></tr>");
		if(dialog.length() == 31)
			dialog.append("</table>No resists</body></html>");
		else
			dialog.append("</table></body></html>");
		show(dialog.toString(), player);

	}

	public static boolean OnActionShift_L2DoorInstance(L2Player player, L2Object object)
	{
		if(player == null || object == null || !player.getPlayerAccess().Door)
			return false;
		if(object instanceof L2DoorInstance)
		{
			String dialog;
			L2DoorInstance door = (L2DoorInstance) object;
			dialog = Files.read("data/scripts/actions/admin.L2DoorInstance.onActionShift.htm");
			dialog = dialog.replaceFirst("%CurrentHp%", String.valueOf(door.getCurrentHp()));
			dialog = dialog.replaceFirst("%MaxHp%", String.valueOf(door.getMaxHp()));
			dialog = dialog.replaceFirst("%ObjectId%", String.valueOf(door.getObjectId()));
			dialog = dialog.replaceFirst("%doorId%", String.valueOf(door.getDoorId()));
			dialog = dialog.replaceFirst("%class%", door.getL2ClassShortName());
			show(dialog, player);
		}
		return false;
	}

	public static boolean OnActionShift_L2Player(L2Player player, L2Object object)
	{
		if(player == null || object == null || !player.getPlayerAccess().CanViewChar)
			return false;
		if(object instanceof L2Player)
			AdminEditChar.showCharacterList(player, (L2Player) object);
		return false;
	}

	public static boolean OnActionShift_L2Summon(L2Player player, L2Object object)
	{
		if(player == null || object == null || !player.getPlayerAccess().CanViewChar)
			return false;
		if(object.isSummon || object.isPet)
			return false; //TODO: показывать страничку со статами пета/саммона
		return false;
	}

	public static boolean OnActionShift_L2FeedableBeastInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2TamedBeastInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2AdventurerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2MonsterInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2MinionInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2TeleporterInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2BossInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2RaidBossInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2Merchant(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2GuardInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2TrainerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2MerchantInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2VillageMasterInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2ChestInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2ManorManagerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2OlympiadManagerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2SignsPriestInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2CastleDoormenInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2ClanHallDoormenInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2WyvernManagerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2WeddingManagerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2WarehouseInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2SymbolMakerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2SiegeNpcInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2SiegeGuardInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2PenaltyMonsterInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2ObservationInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2NpcFriendInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2MercManagerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2FestivalMonsterInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2FestivalGuideInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2DeadManInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2ControlTowerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2FlameControlTowerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2ClassMasterInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2ClanHallManagerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2CastleChamberlain(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2CabaleBufferInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2AuctioneerInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2ArtefactInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2XmassTreeInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}

	public static boolean OnActionShift_L2CastleChamberlainInstance(L2Player player, L2Object object)
	{
		return OnActionShift_L2NpcInstance(player, object);
	}
}
