package ai;

import L2jFT.extensions.scripts.Functions;
import L2jFT.game.ai.DefaultAI;
import L2jFT.game.model.L2Character;
import L2jFT.util.Location;
import L2jFT.util.Rnd;

public class Alhena extends DefaultAI
{
	private Location[] points = new Location[14];
	private int current_point = -1;
	private long wait_timeout = 0;
	private boolean wait = false;

	public Alhena(L2Character actor)
	{
		super(actor);
		_globalAI = true;
		points[0] = new Location(10968, 14620, -4248);
		points[1] = new Location(11308, 15847, -4584);
		points[2] = new Location(12119, 16441, -4584);
		points[3] = new Location(15104, 15661, -4376);
		points[4] = new Location(15265, 16288, -4376);
		points[5] = new Location(12292, 16934, -4584);
		points[6] = new Location(11777, 17669, -4584);
		points[7] = new Location(11229, 17650, -4576);
		points[8] = new Location(10641, 17282, -4584);
		points[9] = new Location(7683, 18034, -4376);
		points[10] = new Location(10551, 16775, -4584);
		points[11] = new Location(11004, 15942, -4584);
		points[12] = new Location(10827, 14757, -4248);
		points[13] = new Location(10968, 14620, -4248);
	}

	@Override
	protected boolean thinkActive()
	{
		if(_thisActor.isDead())
			return true;

		if(_def_think)
		{
			doTask();
			return true;
		}

		if(System.currentTimeMillis() - wait_timeout > 0 && (current_point > -1 || Rnd.chance(5)))
		{
			if(!wait)
				switch(current_point)
				{
					case 3:
						wait_timeout = System.currentTimeMillis() + 15000;
						wait = true;
						return true;
					case 4:
						wait_timeout = System.currentTimeMillis() + 15000;
						Functions.npcShout(_thisActor, "You're a hard worker, Rayla!");
						wait = true;
						return true;
					case 9:
						wait_timeout = System.currentTimeMillis() + 15000;
						Functions.npcShout(_thisActor, "You're a hard worker!");
						wait = true;
						return true;
					case 12:
						wait_timeout = System.currentTimeMillis() + 60000;
						wait = true;
						return true;
				}

			wait_timeout = 0;
			wait = false;

			if(current_point >= points.length - 1)
				current_point = -1;

			current_point++;

			int x = points[current_point].x;
			int y = points[current_point].y;
			int z = points[current_point].z;

			// Добавить новое задание
			Task task = new Task();
			task.type = TaskType.MOVE;
			task.x = x;
			task.y = y;
			task.z = z;
			_task_list.add(task);
			_def_think = true;
			return true;
		}

		if(randomAnimation())
			return true;

		return false;
	}
}