package ai;

import L2jFT.game.ai.DefaultAI;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2World;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.util.Rnd;

public class EdwinFollower extends DefaultAI
{
	private static int EDWIN_ID = 32072;
	private static int DRIFT_DISTANCE = 500;
	private L2NpcInstance _edwin;
	private long wait_timeout = 15000;

	public EdwinFollower(L2Character actor)
	{
		super(actor);
		_globalAI = true;
	}

	@Override
	protected boolean randomAnimation()
	{
		return false;
	}

	@Override
	protected boolean randomWalk()
	{
		return false;
	}

	@Override
	protected boolean thinkActive()
	{
		if(_edwin == null)
		{
			// Ищем преследуемого не чаще, чем раз в 15 секунд, если по каким-то причинам его нету
			if(System.currentTimeMillis() - wait_timeout > 0)
				for(L2NpcInstance npc : L2World.getAroundNpc(_thisActor))
					if(npc.getNpcId() == EDWIN_ID)
					{
						_edwin = npc;
						return true;
					}
		}
		else if(!_thisActor.isMoving)
		{
			int x = _edwin.getX() + Rnd.get(2 * DRIFT_DISTANCE) - DRIFT_DISTANCE;
			int y = _edwin.getY() + Rnd.get(2 * DRIFT_DISTANCE) - DRIFT_DISTANCE;
			int z = _edwin.getZ();

			_thisActor.setRunning(); // всегда бегают
			_thisActor.moveToLocation(x, y, z, 0, true);
			return true;
		}
		return false;
	}
}