package ai;

import L2jFT.extensions.scripts.Functions;
import L2jFT.game.ai.Mystic;
import L2jFT.game.geodata.GeoData;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Playable;

/**
 * AI охраны входа в Pagan Temple.<br>
 * Эти мобы кидаются на всех игроков, у которых в кармане нету предмета 8064 или 8067
 * @author SYS
 */
public class GatekeeperZombie extends Mystic
{
	public GatekeeperZombie(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected boolean autoAttackCondition(L2Playable target)
	{
		if(!_aggressive)
			return false;
		if(target.getNonAggroTime() > System.currentTimeMillis())
			return false;
		if(target.isAlikeDead())
			return false;
		if(!_thisActor.isInRange(target, _aggroRange))
			return false;
		if(Math.abs(target.getZ() - _actor.getZ()) > 400)
			return false;
		if(target.isInvul() || !target.isVisible())
			return false;
		if(!GeoData.getInstance().canSeeTarget(_actor, target))
			return false;
		if(Functions.getItemCount(target, 8067) != 0 || Functions.getItemCount(target, 8064) != 0)
			return false;
		return _aggressive;
	}

	@Override
	protected boolean randomWalk()
	{
		return false;
	}
}