package ai;

import L2jFT.game.ai.DefaultAI;
import L2jFT.game.model.L2Character;
import L2jFT.extensions.scripts.Functions;
import L2jFT.util.Location;
import L2jFT.util.Rnd;

public class Kasiel extends DefaultAI
{
	private Location[] points = new Location[10];
	private int current_point = -1;
	private long wait_timeout = 0;
	private boolean wait = false;

	public Kasiel(L2Character actor)
	{
		super(actor);
		_globalAI = true;
		points[0] = new Location(43932, 51096, -2992);
		points[1] = new Location(43304, 50364, -2992);
		points[2] = new Location(43041, 49312, -2992);
		points[3] = new Location(43612, 48322, -2992);
		points[4] = new Location(44009, 47645, -2992);
		points[5] = new Location(45309, 47341, -2992);
		points[6] = new Location(46726, 47762, -2992);
		points[7] = new Location(47509, 49004, -2992);
		points[8] = new Location(47443, 50456, -2992);
		points[9] = new Location(47013, 51287, -2992);
	}

	@Override
	protected boolean thinkActive()
	{
		if(_thisActor.isDead())
			return true;

		if(_def_think)
		{
			doTask();
			return true;
		}

		if(System.currentTimeMillis() - wait_timeout > 0 && (current_point > -1 || Rnd.chance(5)))
		{
			if(!wait)
				switch(current_point)
				{
					case 5:
						wait_timeout = System.currentTimeMillis() + 15000;
						Functions.npcShout(_thisActor, "The Mother Tree is always so gorgeous!");
						wait = true;
						return true;
					case 9:
						wait_timeout = System.currentTimeMillis() + 60000;
						Functions.npcShout(_thisActor, "Lady Mirabel, may the peace of the lake be with you!");
						wait = true;
						return true;
				}

			wait_timeout = 0;
			wait = false;

			if(current_point >= points.length - 1)
				current_point = -1;

			current_point++;

			int x = points[current_point].x;
			int y = points[current_point].y;
			int z = points[current_point].z;

			// Добавить новое задание
			Task task = new Task();
			task.type = TaskType.MOVE;
			task.x = x;
			task.y = y;
			task.z = z;
			_task_list.add(task);
			_def_think = true;
			return true;
		}

		if(randomAnimation())
			return true;

		return false;
	}
}