package ai;

import L2jFT.game.ai.Fighter;
import L2jFT.game.geodata.GeoData;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Playable;
import L2jFT.util.Rnd;

/**
 * This class manages AI of L2SiegeGuard.<BR><BR>
 */
public class L2DCSiegeMonsterAI extends Fighter
{
	public L2DCSiegeMonsterAI(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected boolean thinkActive()
	{
		if(super.thinkActive())
			return true;

		return false;
	}

	@Override
	protected boolean isSilentMoveNotVisible(L2Playable target)
	{
		// Осадные гварды могут видеть игроков в режиме Silent Move с вероятностью 1%
		return target.isSilentMoving() && Rnd.chance(99);
	}

	@Override
	protected boolean autoAttackCondition(L2Playable target)
	{
		if(target == null || !target.isPlayer || target.isInvul() || !target.isVisible())
			return false;
		if(target.isAlikeDead() || isSilentMoveNotVisible(target))
			return false;
		if(!GeoData.getInstance().canSeeTarget(_actor, target))
			return false;
		return _thisActor.isAutoAttackable(target);
	}
}