package ai;

import L2jFT.game.ai.DefaultAI;
import L2jFT.game.model.L2Character;
import L2jFT.extensions.scripts.Functions;
import L2jFT.util.Location;
import L2jFT.util.Rnd;

public class Leandro extends DefaultAI
{
	private Location[] points = new Location[11];
	private int current_point = -1;
	private long wait_timeout = 0;
	private boolean wait = false;

	public Leandro(L2Character actor)
	{
		super(actor);
		_globalAI = true;
		points[0] = new Location(-82428, 245204, -3720);
		points[1] = new Location(-82422, 245448, -3704);
		points[2] = new Location(-82080, 245401, -3720);
		points[3] = new Location(-82108, 244974, -3720);
		points[4] = new Location(-83595, 244051, -3728);
		points[5] = new Location(-83898, 242776, -3728);
		points[6] = new Location(-85966, 241371, -3728);
		points[7] = new Location(-86079, 240868, -3720);
		points[8] = new Location(-86076, 240392, -3712);
		points[9] = new Location(-86519, 240706, -3712);
		points[10] = new Location(-86343, 241130, -3720);
	}

	@Override
	protected boolean thinkActive()
	{
		if(_thisActor.isDead())
			return true;

		if(_def_think)
		{
			doTask();
			return true;
		}

		if(System.currentTimeMillis() - wait_timeout > 0 && (current_point > -1 || Rnd.chance(5)))
		{
			if(!wait)
				switch(current_point)
				{
					case 5:
						wait_timeout = System.currentTimeMillis() + 30000;
						Functions.npcShout(_thisActor, "Where has he gone?");
						wait = true;
						return true;
					case 10:
						wait_timeout = System.currentTimeMillis() + 60000;
						Functions.npcShout(_thisActor, "Have you seen Windawood?");
						wait = true;
						return true;
				}

			wait_timeout = 0;
			wait = false;

			if(current_point >= points.length - 1)
				current_point = -1;

			current_point++;

			int x = points[current_point].x;
			int y = points[current_point].y;
			int z = points[current_point].z;

			// Добавить новое задание
			Task task = new Task();
			task.type = TaskType.MOVE;
			task.x = x;
			task.y = y;
			task.z = z;
			_task_list.add(task);
			_def_think = true;
			return true;
		}

		if(randomAnimation())
			return true;

		return false;
	}
}