package ai;

import L2jFT.game.ai.Fighter;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Spawn;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.tables.NpcTable;

/**
 * AI полиморфного шамана ID: 21258, превращающегося в тигра ID: 21259 при ударе
 * @author SYS
 */
public class PolimorphingShaman extends Fighter
{
	private static final int TIGER_ID = 21259;

	public PolimorphingShaman(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, Boolean canBeAttackedByMob)
	{
		try
		{
			L2Spawn spawn = new L2Spawn(NpcTable.getTemplate(TIGER_ID));
			spawn.setLocx(_thisActor.getX());
			spawn.setLocy(_thisActor.getY());
			spawn.setLocz(_thisActor.getZ());
			L2NpcInstance npc = spawn.doSpawn(true);
			npc.addDamageHate(attacker, 1, 100);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}

		_thisActor.decayMe();
		_thisActor.doDie(_thisActor);
	}
}