package ai;

import L2jFT.game.ai.DefaultAI;
import L2jFT.game.model.L2Character;
import L2jFT.util.Location;
import L2jFT.util.Rnd;

public class Rokar extends DefaultAI
{
	private Location[] points = new Location[6];
	private int current_point = -1;
	private long wait_timeout = 0;
	private boolean wait = false;

	public Rokar(L2Character actor)
	{
		super(actor);
		_globalAI = true;
		points[0] = new Location(-46516, -117700, -264);
		points[1] = new Location(-45550, -115420, -256);
		points[2] = new Location(-44052, -114575, -256);
		points[3] = new Location(-44024, -112688, -256);
		points[4] = new Location(-45748, -111665, -256);
		points[5] = new Location(-46512, -109390, -232);
	}

	@Override
	protected boolean thinkActive()
	{
		if(_thisActor.isDead())
			return true;

		if(_def_think)
		{
			doTask();
			return true;
		}

		if(System.currentTimeMillis() - wait_timeout > 0 && (current_point > -1 || Rnd.chance(5)))
		{
			if(!wait)
				switch(current_point)
				{
					case 5:
						wait_timeout = System.currentTimeMillis() + 30000;
						wait = true;
						return true;
				}

			wait_timeout = 0;
			wait = false;

			if(current_point >= points.length - 1)
				current_point = -1;

			current_point++;

			int x = points[current_point].x;
			int y = points[current_point].y;
			int z = points[current_point].z;

			// Добавить новое задание
			Task task = new Task();
			task.type = TaskType.MOVE;
			task.x = x;
			task.y = y;
			task.z = z;
			_task_list.add(task);
			_def_think = true;
			return true;
		}

		if(randomAnimation())
			return true;

		return false;
	}
}