package ai;

import L2jFT.game.ai.DefaultAI;
import L2jFT.game.model.L2Character;
import L2jFT.extensions.scripts.Functions;
import L2jFT.game.network.serverpackets.MagicSkillUse;
import L2jFT.util.Location;
import L2jFT.util.Rnd;

public class Taurin extends DefaultAI
{
	private Location[] points = new Location[41];
	private int current_point = -1;
	private long wait_timeout = 0;
	private boolean wait = false;

	public Taurin(L2Character actor)
	{
		super(actor);
		_globalAI = true;
		points[0] = new Location(80752, 146400, -3533);
		points[1] = new Location(80250, 146988, -3559);
		points[2] = new Location(80070, 146942, -3559);
		points[3] = new Location(80048, 146705, -3547);
		points[4] = new Location(79784, 146561, -3546);
		points[5] = new Location(79476, 146800, -3547);
		points[6] = new Location(79490, 147480, -3559);
		points[7] = new Location(79812, 148310, -3559);
		points[8] = new Location(79692, 148564, -3559);
		points[9] = new Location(77569, 148495, -3623);
		points[10] = new Location(77495, 148191, -3622);
		points[11] = new Location(77569, 148495, -3623);
		points[12] = new Location(79819, 148740, -3559);
		points[13] = new Location(79773, 149110, -3559);
		points[14] = new Location(79291, 149523, -3559);
		points[15] = new Location(79569, 150214, -3548);
		points[16] = new Location(79679, 150717, -3543);
		points[17] = new Location(80106, 150630, -3547);
		points[18] = new Location(81207, 150276, -3559);
		points[19] = new Location(81820, 150666, -3559);
		points[20] = new Location(82038, 150589, -3559);
		points[21] = new Location(82394, 149943, -3559);
		points[22] = new Location(82038, 150589, -3559);
		points[23] = new Location(81820, 150666, -3559);
		points[24] = new Location(81582, 150590, -3559);
		points[25] = new Location(81535, 149653, -3495);
		points[26] = new Location(83814, 148630, -3420);
		points[27] = new Location(87001, 148637, -3428);
		points[28] = new Location(83814, 148630, -3420);
		points[29] = new Location(82921, 148467, -3495);
		points[30] = new Location(82060, 148070, -3495);
		points[31] = new Location(82060, 148070, -3495);
		points[32] = new Location(82060, 148070, -3495);
		points[33] = new Location(82060, 148070, -3495);
		points[34] = new Location(81544, 147514, -3491);
		points[35] = new Location(81691, 146578, -3559);
		points[36] = new Location(83190, 146687, -3491);
		points[37] = new Location(81691, 146578, -3559);
		points[38] = new Location(81331, 146915, -3559);
		points[39] = new Location(81067, 146925, -3559);
		points[40] = new Location(80752, 146400, -3533);
	}

	@Override
	protected boolean thinkActive()
	{
		if(_thisActor.isDead())
			return true;

		if(_def_think)
		{
			doTask();
			return true;
		}

		if(System.currentTimeMillis() - wait_timeout > 0 && (current_point > -1 || Rnd.chance(5)))
		{
			if(!wait)
				switch(current_point)
				{
					// Это паузы на определеных точках в милисекундах
					// (case 3:) Это номер точки на которой делать паузу
					// npcSayInRange - сказать в Зону
					// npcSayToAll - Сказать всем
					// npcSayToPlayer - Сказать определеному игроку
					// npcShout - просто сказать всем видимым
					// пользовать вот так например
					// Functions.npcShout(_thisActor, "Всем лежать, у меня бомба!");
					// Использывание скиллов //
					// _thisActor.broadcastPacket(new MagicSkillUse(_thisActor, _thisActor, _skillId, skilllevel, castTime, 0));
					// На примере  2025  Large Firework //
					//_thisActor.broadcastPacket(new MagicSkillUse(_thisActor, _thisActor, 2025, 1, 500, 0));
					case 4:
						wait_timeout = System.currentTimeMillis() + 10000;
						wait = true;
						return true;
					case 10:
						wait_timeout = System.currentTimeMillis() + 10000;
						wait = true;
						return true;
					case 14:
						wait_timeout = System.currentTimeMillis() + 10000;
						wait = true;
						return true;
					case 16:
						wait_timeout = System.currentTimeMillis() + 10000;
						wait = true;
						return true;
					case 21:
						wait_timeout = System.currentTimeMillis() + 10000;
						wait = true;
						return true;
					case 27:
						wait_timeout = System.currentTimeMillis() + 10000;
						wait = true;
						return true;
					case 30:
						wait_timeout = System.currentTimeMillis() + 10000;
						Functions.npcShout(_thisActor, "Всем лежать, у меня бомба!");
						wait = true;
						return true;
					case 31:
						wait_timeout = System.currentTimeMillis() + 15000;
						Functions.npcShout(_thisActor, "Я больной, за себя не ручаюсь!!!!");
						wait = true;
						return true;
					case 32:
						wait_timeout = System.currentTimeMillis() + 15000;
						Functions.npcShout(_thisActor, "Вы все еще тут? Я вас предупреждал!!!!!");
						wait = true;
						return true;
					case 33:
						_thisActor.broadcastPacket(new MagicSkillUse(_thisActor, _thisActor, 2025, 1, 500, 0));
						wait_timeout = System.currentTimeMillis() + 1000;
						wait = true;
						return true;
					case 35:
						wait_timeout = System.currentTimeMillis() + 10000;
						wait = true;
						return true;
					case 37:
						wait_timeout = System.currentTimeMillis() + 30000000;
						wait = true;
						return true;
				}

			wait_timeout = 0;
			wait = false;

			if(current_point >= points.length - 1)
				current_point = -1;

			current_point++;

			int x = points[current_point].x;
			int y = points[current_point].y;
			int z = points[current_point].z;

			// Добавить новое задание
			Task task = new Task();
			task.type = TaskType.MOVE;
			task.x = x;
			task.y = y;
			task.z = z;
			_task_list.add(task);
			_def_think = true;
			return true;
		}

		if(randomAnimation())
			return true;

		return false;
	}
}
