package commands.admin;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.LoginServerThread;
import L2jFT.game.handler.AdminCommandHandler;
import L2jFT.game.handler.IAdminCommandHandler;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2World;
import L2jFT.util.AutoBan;

import java.util.StringTokenizer;

/**
 * This class handles following admin commands: - kill = kills target
 * L2Character
 */
public class AdminBan implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = {
			"admin_ban", "admin_unban", "admin_charban", "admin_chatban",
			"admin_ckarma", "admin_cban" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().CanBan)
			return false;
		if(command.startsWith("admin_ban"))
		{
			StringTokenizer st = new StringTokenizer(command);
			if(st.countTokens() > 1)
			{
				st.nextToken();
				String player = st.nextToken();
				int banTime = -1;
				if(st.hasMoreTokens())
					banTime = Integer.parseInt(st.nextToken());
				String reason = "";
				while(st.hasMoreTokens())
					reason += " " + st.nextToken();
				L2Player plyr = L2World.getPlayer(player);
				if(plyr != null && !plyr.getPlayerAccess().IsGM)
				{
					LoginServerThread.getInstance().sendAccessLevel(plyr.getAccountName(), -100, "command admin_ban by " + activeChar.getName() + " from " + activeChar.getIP() + " reason:" + reason, banTime);
					plyr.kick(false);
				}
			}
		}
		else if(command.startsWith("admin_unban"))
		{
			StringTokenizer st = new StringTokenizer(command);
			if(st.countTokens() > 1)
			{
				st.nextToken();
				String player = st.nextToken();
				L2Player plyr = L2World.getPlayer(player);
				if(plyr != null)
					LoginServerThread.getInstance().sendAccessLevel(plyr.getAccountName(), 0, "command admin_unban", 0);
			}
		}
		else if(command.startsWith("admin_charban"))
		{
			StringTokenizer st = new StringTokenizer(command);
			try
			{
				st.nextToken();
				String player = st.nextToken();
				String srok = st.nextToken();
				String bmsg = "admin_charban " + player + " " + srok + " ";
				String msg = command.substring(bmsg.length(), command.length());

				L2Player plyr = L2World.getPlayer(player);
				if(plyr != null)
				{
					plyr.sendMessage("You are banned by GM " + activeChar.getName(), "Вас забанил ГМ " + activeChar.getName());
					plyr.setAccessLevel(-100);
					AutoBan.Banned(plyr, Integer.parseInt(srok), msg, activeChar.getName());
					plyr.logout(false, false);
					activeChar.sendMessage("You banned " + plyr.getName(), "Вы забанили " + plyr.getName());
				}
				else if(AutoBan.Banned(player, -100, Integer.parseInt(srok), msg, activeChar.getName()))
					activeChar.sendMessage("You banned " + player, "Вы забанили " + player);
				else
					activeChar.sendMessage("Can't find char: " + player, "Игрок " + player + " не найден");
			}
			catch(Exception e)
			{
				activeChar.sendMessage("Command syntax: //charban char_name period msg", "Формат команды: //charban <имя_чара> <срок_бана> <причина>");
			}
		}
		else if(command.startsWith("admin_chatban"))
		{
			StringTokenizer st = new StringTokenizer(command);
			try
			{
				st.nextToken();
				String player = st.nextToken();
				String srok = st.nextToken();
				String bmsg = "admin_chatban " + player + " " + srok + " ";
				String msg = command.substring(bmsg.length(), command.length());

				if(AutoBan.ChatBan(player, Integer.parseInt(srok), msg, activeChar.getName()))
					activeChar.sendMessage("You ban chat for " + player + ".", "Вы забанили чат персонажу " + player + ".");
				else
					activeChar.sendMessage("Can't find char " + player + ".", "Игрок " + player + " не найден");
			}
			catch(Exception e)
			{
				activeChar.sendMessage("Command syntax: //chatban char_name period msg", "Формат команды: //chatban <имя_чара> <срок_бана> <причина>");
				e.printStackTrace();
			}
		}
		else if(command.startsWith("admin_ckarma"))
		{
			StringTokenizer st = new StringTokenizer(command);
			try
			{
				st.nextToken();
				String player = st.nextToken();
				String srok = st.nextToken();
				String bmsg = "admin_ckarma " + player + " " + srok + " ";
				String msg = command.substring(bmsg.length(), command.length());

				L2Player plyr = L2World.getPlayer(player);
				if(plyr != null)
				{
					int newKarma = Integer.parseInt(srok) + plyr.getKarma();

					// update karma
					plyr.setKarma(newKarma);
					
					plyr.sendMessage("You get karma(" + srok + ") by GM " + activeChar.getName());
					AutoBan.Karma(plyr, Integer.parseInt(srok), msg, activeChar.getName());
					activeChar.sendMessage("You set karma(" + srok + ") " + plyr.getName(), "Вы установили персонажу " + plyr.getName() + " карму " + srok + ".");
				}
				else if(AutoBan.Karma(player, Integer.parseInt(srok), msg, activeChar.getName()))
					activeChar.sendMessage("You set karma(" + srok + ") " + player, "Вы установили персонажу " + player + " карму " + srok + ".");
				else
					activeChar.sendMessage("Can't find char: " + player, "Игрок " + player + " не найден");
			}
			catch(Exception e)
			{
				activeChar.sendMessage("Command syntax: //ckarma char_name karma msg", "Формат команды: //ckarma <имя_чара> <карма> <причина>");
			}
		}
		else if(command.startsWith("admin_cban"))
			try
			{
				AdminHelpPage.showHelpPage(activeChar, "cban.htm");
			}
			catch(StringIndexOutOfBoundsException e)
			{}

		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] {
				"file://com_ban.htm", "file://com_unban.htm", "file://com_charban.htm",
				"file://com_chatban.htm", "file://com_ckarma.htm",
				"file://com_cban.htm" };

	}

	public String[] getCommandGroup()
	{
		return new String[] {
				AdminCommandHandler.GROUP_BANS, AdminCommandHandler.GROUP_BANS,
				AdminCommandHandler.GROUP_BANS, AdminCommandHandler.GROUP_BANS,
				AdminCommandHandler.GROUP_BANS, AdminCommandHandler.GROUP_BANS };
	}
}