package commands.admin;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.AdminCommandHandler;
import L2jFT.game.handler.IAdminCommandHandler;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.CameraMode;
import L2jFT.game.network.serverpackets.SpecialCamera;

public class AdminCamera implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = {
			"admin_freelook", "admin_cinematic" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().Menu)
			return false;
		if(command.startsWith("admin_freelook"))
		{
			if(command.length() > _adminCommands[0].length() + 1)
				command = command.substring(_adminCommands[0].length() + 1);
			else
			{
				activeChar.sendMessage("Usage: //freelook 1 or //freelook 0");
				return false;
			}

			int mode = Integer.parseInt(command);
			if(mode == 1)
			{
				activeChar.setInvisible(true);
				activeChar.setIsInvul(true);
				activeChar.setNoChannel(-1);
				activeChar.setFlying(true);
			}
			else
			{
				activeChar.setInvisible(false);
				activeChar.setIsInvul(false);
				activeChar.setNoChannel(0);
				activeChar.setFlying(false);
			}
			activeChar.sendPacket(new CameraMode(mode));
			return true;
		}
		else if(command.startsWith("admin_cinematic"))
		{
			command = command.substring(_adminCommands[1].length() + 1);

			String[] params = command.split(" ");

			int id = Integer.parseInt(params[0]);
			int dist = Integer.parseInt(params[1]);
			int yaw = Integer.parseInt(params[2]);
			int pitch = Integer.parseInt(params[3]);
			int time = Integer.parseInt(params[4]);
			int duration = Integer.parseInt(params[5]);

			activeChar.sendPacket(new SpecialCamera(id, dist, yaw, pitch, time, duration));
		}
		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "file://com_freelook.htm", "file://com_cinematic.htm" };
	}

	public String[] getCommandGroup()
	{
		return new String[] {
				AdminCommandHandler.GROUP_MANAGESERVER,
				AdminCommandHandler.GROUP_MANAGESERVER };
	}
}
