package commands.admin;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.AdminCommandHandler;
import L2jFT.game.handler.IAdminCommandHandler;
import L2jFT.game.model.L2Player;

/**
 * This class handles following admin commands:
 * - events = shows events managment menu
 */
public class AdminEvents implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_events" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().IsEventGm)
			return false;
		if(command.startsWith("admin_events"))
			AdminHelpPage.showHelpPage(activeChar, "events.htm");

		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "Отображает страницу управления эвентами" };
	}

	public String[] getCommandGroup()
	{
		return new String[] { AdminCommandHandler.GROUP_MANAGESERVER2 };
	}
}