package commands.admin;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.AdminCommandHandler;
import L2jFT.game.handler.IAdminCommandHandler;
import L2jFT.game.model.L2Player;
import L2jFT.util.Log;

/**
 * This class handles following admin commands: - gm = turns gm mode on/off
 */
public class AdminGm implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_gm" };

	// TODO: remove from gm list etc etc
	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(true)
			return false;
		if(!activeChar.getPlayerAccess().CanEditChar)
			return false;
		if(command.equals("admin_gm"))
			handleGm(activeChar);
		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	private void handleGm(L2Player activeChar)
	{
		if(activeChar.getPlayerAccess().IsGM)
		{
			activeChar.getPlayerAccess().IsGM = false;
			activeChar.sendMessage("You no longer have GM status.");
			Log.add("GM: " + activeChar.getName() + "(" + activeChar.getObjectId() + ") turned his GM status off", "gm_ext_actions", activeChar);
		}
		else
		{
			activeChar.getPlayerAccess().IsGM = true;
			activeChar.sendMessage("You have GM status now.");
			Log.add("GM: " + activeChar.getName() + "(" + activeChar.getObjectId() + ") turned his GM status on", "gm_ext_actions", activeChar);
		}
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "Описание команды gm" };
	}

	public String[] getCommandGroup()
	{
		return new String[] { AdminCommandHandler.GROUP_MANAGESERVER3 };
	}
}