package commands.admin;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.AdminCommandHandler;
import L2jFT.game.handler.IAdminCommandHandler;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.CreatureSay;
import L2jFT.game.tables.GmListTable;

/**
 * This class handles following admin commands: - gmchat text = sends text to
 * all online GM's
 */
public class AdminGmChat implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_gmchat", "admin_snoop" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().CanAnnounce)
			return false;
		if(command.startsWith("admin_gmchat"))
			handleGmChat(command, activeChar);
		else if(command.startsWith("admin_snoop"))
			snoop(command, activeChar);
		return true;
	}

	private void snoop(@SuppressWarnings("unused")
	String command, L2Player activeChar)
	{
		L2Object target = activeChar.getTarget();
		if(target == null)
		{
			activeChar.sendMessage("You must select a target.");
			return;
		}
		if(!target.isPlayer)
		{
			activeChar.sendMessage("Target must be a player.");
			return;
		}
		L2Player player = (L2Player) target;
		player.addSnooper(activeChar);
		activeChar.addSnooped(player);
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	private void handleGmChat(String command, L2Player activeChar)
	{
		try
		{
			String text = command.substring(13);
			CreatureSay cs = new CreatureSay(0, 9, activeChar.getName(), text);
			GmListTable.broadcastToGMs(cs);
		}
		catch(StringIndexOutOfBoundsException e)
		{
			// empty message.. ignore
		}
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "admin_gmchat", "admin_snoop" };
	}

	public String[] getCommandGroup()
	{
		return new String[] {
				AdminCommandHandler.GROUP_MANAGESERVER3,
				AdminCommandHandler.GROUP_EDITCHAR };
	}
}