package commands.admin;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.Announcements;
import L2jFT.game.handler.AdminCommandHandler;
import L2jFT.game.handler.IAdminCommandHandler;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2World;
import L2jFT.util.Log;

import java.util.StringTokenizer;

public class AdminNochannel implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_nochannel" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().CanBanChat)
			return false;

		if(command.startsWith("admin_nochannel"))
		{
			StringTokenizer st = new StringTokenizer(command);

			if(st.countTokens() > 1)
			{
				st.nextToken();
				String player = st.nextToken();
				L2Player plr = L2World.getPlayer(player);

				if(plr != null)
				{
					int timeval = 30; // if no args, then 30 min default.
					String reason = "Флуд"; // if no args, then "Флуд" default.

					if(st.countTokens() >= 1)
					{
						String time = st.nextToken();
						timeval = Integer.parseInt(time);
					}

					if(st.countTokens() >= 1)
					{
						reason = st.nextToken();
						while(st.hasMoreTokens())
							reason += " " + st.nextToken();
					}

					Announcements sys = new Announcements();
					if(timeval == 0)
					{
						sys.announceToAll(activeChar.getName() + " снял бан чата с игрока " + plr.getName() + ".");
						activeChar.sendMessage("Вы сняли бан чата с игрока " + plr.getName() + ".");
						Log.add(activeChar.getName() + " снял бан чата с игрока " + plr.getName() + ".", "banchat", activeChar);
					}
					else if(timeval < 0)
					{
						sys.announceToAll(activeChar.getName() + " забанил чат игроку " + plr.getName() + " на бессрочный период, причина: " + reason + ".");
						activeChar.sendMessage("Вы забанили чат игроку " + plr.getName() + " на бессрочный период, причина: " + reason + ".");
						Log.add(activeChar.getName() + " забанил чат игроку " + plr.getName() + " на бессрочный период, причина: " + reason + ".", "banchat", activeChar);
					}
					else
					{
						sys.announceToAll(activeChar.getName() + " забанил чат игроку " + plr.getName() + " на " + timeval + " минут, причина: " + reason + ".");
						activeChar.sendMessage("Вы забанили чат игроку " + plr.getName() + " на " + timeval + " минут, причина: " + reason + ".");
						Log.add(activeChar.getName() + " забанил чат игроку " + plr.getName() + " на " + timeval + " минут, причина: " + reason + ".", "banchat", activeChar);
					}
					update_NoChannel(plr, timeval);
				}
				else
					activeChar.sendMessage("Игрок " + player + " не найден.");
			}
		}
		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	private void update_NoChannel(L2Player player, int time)
	{
		player.updateNoChannel(time * 60000);
		if(time == 0)
			player.sendMessage("You are unbanned all chats.", "Бан чата снят.");
		else if(time > 0)
			player.sendMessage("You are banned in all chats for a " + time + " minutes.", "Ваш чат забанен на " + time + " минут.");
		else
			player.sendMessage("You are banned in all chats permanently.", "Ваш чат забанен на бессрочный период.");
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "admin_nochannel" };
	}

	public String[] getCommandGroup()
	{
		return new String[] { AdminCommandHandler.GROUP_EDITCHAR };
	}
}
