package commands.admin;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.TradeController;
import L2jFT.game.handler.AdminCommandHandler;
import L2jFT.game.handler.IAdminCommandHandler;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2TradeList;
import L2jFT.game.network.serverpackets.BuyList;

/**
 * This class handles following admin commands: - gmshop = shows menu - buy id =
 * shows shop with respective id
 * 
 * @version $Revision: 1.2.4.4 $ $Date: 2005/04/11 10:06:06 $
 */
public class AdminShop implements IAdminCommandHandler, ScriptFile
{
	private static String[] _adminCommands = { "admin_buy", "admin_gmshop" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(!activeChar.getPlayerAccess().UseGMShop)
			return false;

		if(command.startsWith("admin_buy"))
			try
			{
				handleBuyRequest(activeChar, command.substring(10));
			}
			catch(IndexOutOfBoundsException e)
			{
				activeChar.sendMessage("Please specify buylist.");
			}
		else if(command.equals("admin_gmshop"))
			AdminHelpPage.showHelpPage(activeChar, "gmshops.htm");

		return true;
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	private void handleBuyRequest(L2Player activeChar, String command)
	{
		int val = -1;

		try
		{
			val = Integer.parseInt(command);
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}

		L2TradeList list = TradeController.getInstance().getBuyList(val);

		if(list != null)
		{
			BuyList bl = new BuyList(list, activeChar.getAdena());
			activeChar.sendPacket(bl);
		}

		activeChar.sendActionFailed();
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "Описание команды buy", "Описание команды gmshop" };
	}

	public String[] getCommandGroup()
	{
		return new String[] {
				AdminCommandHandler.GROUP_MANAGESERVER5,
				AdminCommandHandler.GROUP_MANAGESERVER5 };
	}
}