package commands.admin;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.AdminCommandHandler;
import L2jFT.game.handler.IAdminCommandHandler;
import L2jFT.game.idfactory.IdFactory;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2Territory;
import L2jFT.game.model.L2World;
import L2jFT.game.model.instances.L2ItemInstance;

import java.util.StringTokenizer;

public class AdminZone implements IAdminCommandHandler, ScriptFile
{
	public static final String[] ADMIN_ZONE_COMMANDS = {
			"admin_zone_check", "admin_region", "admin_loc" };

	/*
	 * (non-Javadoc)
	 * 
	 * @see L2jFT.game.handler.IAdminCommandHandler#useAdminCommand(java.lang.String,
	 *      L2jFT.game.model.L2Player)
	 */
	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(activeChar == null)
			return false;

		if(!activeChar.getPlayerAccess().CanTeleport)
			return false;

		StringTokenizer st = new StringTokenizer(command, " ");
		String actualCommand = st.nextToken();

		if(actualCommand.equalsIgnoreCase("admin_zone_check"))
		{
			if(activeChar.getTerritories() != null)
				for(L2Territory terr : activeChar.getTerritories())
				{
					activeChar.sendMessage("Territory: " + terr.getName());
					if(terr.getZone() != null)
						activeChar.sendMessage("Zone: " + terr.getZone().getType().toString() + ", id: " + terr.getZone().getId());
				}
		}
		else if(actualCommand.equalsIgnoreCase("admin_region"))
		{
			activeChar.sendMessage("Current region: " + activeChar.getCurrentRegion().getName());
			activeChar.sendMessage("Objects list:");
			for(L2Object obj : activeChar.getCurrentRegion().getObjects().values())
				activeChar.sendMessage(obj.toString());
			if(L2World.getRegion(activeChar) != null)
			{
				activeChar.sendMessage("World region: " + L2World.getRegion(activeChar).getName());
				activeChar.sendMessage("Objects list:");
				for(L2Object obj : L2World.getRegion(activeChar).getObjects().values())
					activeChar.sendMessage(obj.toString());
			}
		}
		/*
		 * Пишет в консоль текущую точку для локации, оформляем в виде SQL запроса
		 * пример: (8699,'loc_8699',111104,-112528,-1400,-1200),
		 * Удобно для рисования локаций под спавн, разброс z +100/-10
		 * необязательные параметры: id локации и название локации
		 * Бросает бутылку, чтобы не запутаццо :) 
		 */
		else if(actualCommand.equalsIgnoreCase("admin_loc"))
		{
			String loc_id = "0";
			String loc_name;
			if(st.hasMoreTokens())
				loc_id = st.nextToken();
			if(st.hasMoreTokens())
				loc_name = st.nextToken();
			else
				loc_name = "loc_" + loc_id;
			System.out.println("(" + loc_id + ",'" + loc_name + "'," + activeChar.getX() + "," + activeChar.getY() + "," + (activeChar.getZ() - 10) + "," + (activeChar.getZ() + 100) + "),");
			activeChar.sendMessage("Point saved.", "Точка сохранена.");
			L2ItemInstance temp = new L2ItemInstance(IdFactory.getInstance().getNextId(), 1060, 1, 1, "");
			temp.dropMe(activeChar, activeChar.getX(), activeChar.getY(), activeChar.getZ());
		}
		return true;
	}

	public String[] getAdminCommandList()
	{
		return ADMIN_ZONE_COMMANDS;
	}

	public void onLoad()
	{
		AdminCommandHandler.getInstance().registerAdminCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public String[] getDescription()
	{
		return new String[] { "admin_zone_check", "admin_region", "admin_loc" };
	}

	public String[] getCommandGroup()
	{
		return new String[] {
				AdminCommandHandler.GROUP_MANAGESERVER6,
				AdminCommandHandler.GROUP_MANAGESERVER6,
				AdminCommandHandler.GROUP_MANAGESERVER6 };
	}
}