package commands.user;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.IUserCommandHandler;
import L2jFT.game.handler.UserCommandHandler;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.game.tables.MapRegionTable;

/**
 * Support for /loc command
 */
public class Loc implements IUserCommandHandler, ScriptFile
{
	private static final int[] COMMAND_IDS = { 0 };

	public boolean useUserCommand(int id, L2Player activeChar)
	{
		if(COMMAND_IDS[0] != id)
			return false;

		int _nearestTown = MapRegionTable.getInstance().getClosestTownNumber(activeChar);
		int msg;
		switch(_nearestTown)
		{
			case 0:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_TALKING_ISLAND_VILLAGE;
				break;
			case 1:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_ELVEN_VILLAGE;
				break;
			case 2:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_DARK_ELVEN_VILLAGE;
				break;
			case 3:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_ORC_VILLAGE;
				break;
			case 4:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_DWARVEN_VILLAGE;
				break;
			case 5:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_GLUDIO_CASTLE_TOWN;
				break;
			case 6:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_GLUDIN_VILLAGE;
				break;
			case 7:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_DION_CASTLE_TOWN;
				break;
			case 8:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_GIRAN_CASTLE_TOWN;
				break;
			case 9:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_THE_TOWN_OF_OREN;
				break;
			case 10:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_ADEN_CASTLE_TOWN;
				break;
			case 11:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_HUNTERS_VILLAGE;
				break;
			case 12:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_GIRAN_HARBOR;
				break;
			case 13:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_HEINE;
				break;
			case 14:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_RUNE_VILLAGE;
				break;
			case 15:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_GODDARD_CASTLE_TOWN;
				break;
			default:
				msg = SystemMessage.CURRENT_LOCATION__S1_S2_S3_NEAR_ADEN_CASTLE_TOWN;
		}
		SystemMessage sm = new SystemMessage(msg);
		sm.addNumber(activeChar.getX());
		sm.addNumber(activeChar.getY());
		sm.addNumber(activeChar.getZ());
		activeChar.sendPacket(sm);
		return true;
	}

	public final int[] getUserCommandList()
	{
		return COMMAND_IDS;
	}

	public void onLoad()
	{
		UserCommandHandler.getInstance().registerUserCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}
