package commands.user;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.IUserCommandHandler;
import L2jFT.game.handler.UserCommandHandler;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.entity.Olympiad;
import L2jFT.game.network.serverpackets.SystemMessage;

/**
 * Support for /olympiadstat command
 */
public class OlympiadStat implements IUserCommandHandler, ScriptFile
{
	private static final int[] COMMAND_IDS = { 109 };

	public boolean useUserCommand(int id, L2Player activeChar)
	{
		if(id != COMMAND_IDS[0])
			return false;

		SystemMessage sm;

		if(!activeChar.isNoble())
			sm = new SystemMessage(SystemMessage.THIS_COMMAND_CAN_ONLY_BE_USED_BY_A_NOBLESSE);
		else
		{
			sm = new SystemMessage(SystemMessage.THE_CURRENT_FOR_THIS_OLYMPIAD_IS_S1_WINS_S2_DEFEATS_S3_YOU_HAVE_EARNED_S4_OLYMPIAD_POINTS);
			sm.addNumber(Olympiad.getInstance().getCompetitionDone(activeChar.getObjectId()));
			sm.addNumber(Olympiad.getInstance().getCompetitionWin(activeChar.getObjectId()));
			sm.addNumber(Olympiad.getInstance().getCompetitionLoose(activeChar.getObjectId()));
			sm.addNumber(Olympiad.getInstance().getNoblePoints(activeChar.getObjectId()));
		}
		activeChar.sendPacket(sm);
		return true;
	}

	public int[] getUserCommandList()
	{
		return COMMAND_IDS;
	}

	public void onLoad()
	{
		UserCommandHandler.getInstance().registerUserCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}
