package commands.voiced;

import L2jFT.extensions.scripts.Functions;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.IVoicedCommandHandler;
import L2jFT.game.handler.VoicedCommandHandler;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.util.Files;

/**
 * @Author: Abaddon
 */
public class Help extends Functions implements IVoicedCommandHandler, ScriptFile
{
	public static L2Object self;
	public static L2NpcInstance npc;

	private String[] _commandList = new String[] { "help", "whoami" };

	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public boolean useVoicedCommand(String command, L2Player activeChar, String args)
	{
		if(command.equalsIgnoreCase("help"))
		{
			String dialog = Files.read("data/scripts/commands/voiced/help.htm");
			show(dialog, activeChar);
			return true;
		}
		if(command.equalsIgnoreCase("whoami"))
		{
			activeChar.sendMessage(activeChar.getName() + ", level " + activeChar.getLevel() + " " + activeChar.getClassId().name());
			activeChar.sendMessage("object id " + activeChar.getObjectId() + ", ip " + activeChar.getNetConnection().getIpAddr() + " login " + activeChar.getAccountName());
			return true;
		}
		return false;
	}

	public String[] getVoicedCommandList()
	{
		return _commandList;
	}
}