package commands.voiced;

import L2jFT.extensions.scripts.Functions;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.IVoicedCommandHandler;
import L2jFT.game.handler.VoicedCommandHandler;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.util.Files;

/**
 * @Author: Diamond
 * @Date: 10/07/2007
 * @Time: 15:07:08
 */
public class Lang extends Functions implements IVoicedCommandHandler, ScriptFile
{
	public static L2Object self;
	public static L2NpcInstance npc;

	private String[] _commandList = new String[] {
			"lang", "translit", "fromTranslit" };

	public boolean useVoicedCommand(String command, L2Player activeChar, String args)
	{
		if(command.equals("lang"))
		{
			if(args != null)
				if(args.equalsIgnoreCase("en"))
					activeChar.setVar("lang@", "en");
				else if(args.equalsIgnoreCase("ru"))
					activeChar.setVar("lang@", "ru");
				else
					show(Files.read("data/scripts/commands/voiced/lang.htm", activeChar), activeChar);
			return true;
		}
		else if(command.equals("translit"))
		{
			if(args != null)
				if(args.equalsIgnoreCase("on"))
					activeChar.setVar("translit", "1");
				else if(args.equalsIgnoreCase("off"))
					activeChar.setVar("translit", "0");
				else
					show(Files.read("data/scripts/commands/voiced/lang.htm", activeChar), activeChar);
			return true;
		}
		else if(command.equals("fromTranslit"))
		{
			if(args != null)
				if(args.equalsIgnoreCase("on"))
					activeChar.setVar("fromTranslit", "1");
				else if(args.equalsIgnoreCase("off"))
					activeChar.setVar("fromTranslit", "0");
				else
					show(Files.read("data/scripts/commands/voiced/lang.htm", activeChar), activeChar);
			return true;
		}
		show(Files.read("data/scripts/commands/voiced/lang.htm", activeChar), activeChar);
		return true;
	}

	public String[] getVoicedCommandList()
	{
		return _commandList;
	}

	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}
