package commands.voiced;

import L2jFT.database.mysql;
import L2jFT.extensions.scripts.Functions;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.IVoicedCommandHandler;
import L2jFT.game.handler.VoicedCommandHandler;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;

public class Repair extends Functions implements IVoicedCommandHandler, ScriptFile
{
	public static L2Object self;
	public static L2Object npc;

	private final String[] _commandList = new String[] { "repair" };

	public String[] getVoicedCommandList()
	{
		return _commandList;
	}

	public boolean useVoicedCommand(String command, L2Player activeChar, String target)
	{
		show("data/scripts/commands/voiced/repair.htm", activeChar);
		return true;
	}

	public void repair(String[] var)
	{
		if(var.length == 1)
		{
			String name = var[0];
			L2Player activeChar = (L2Player) self;
			if(!activeChar.getAccountChars().containsValue(name))
			{
				show("You can't repair character not on same account!", activeChar);
				return;
			}
			if(activeChar.getName().equalsIgnoreCase(name))
			{
				show("You can't repair yourself!", activeChar);
				return;
			}
			int id = mysql.simple_get_int("obj_Id", "characters", "`char_name`='" + name + "'");
			mysql.set("UPDATE `characters` SET `x`='0', `y`='0', `z`='0', `heading`='0' WHERE `obj_Id`='" + id + "' LIMIT 1");
			mysql.set("UPDATE `items` SET `loc`='WAREHOUSE' WHERE `loc`='PAPERDOLL' AND `owner_id`=" + id);
			show("Sucessfully repaired. All inventory moved to warehouse.", activeChar);
		}
	}

	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}