package commands.voiced;

import javolution.text.TextBuilder;
import L2jFT.extensions.scripts.Functions;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.IVoicedCommandHandler;
import L2jFT.game.handler.VoicedCommandHandler;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2World;
import L2jFT.game.Shutdown;

public class Status extends Functions implements IVoicedCommandHandler, ScriptFile
{
	private final String[] _commandList = new String[] { "status" };

	public String[] getVoicedCommandList()
	{
		return _commandList;
	}

	public boolean useVoicedCommand(String command, L2Player activeChar, String target)
	{
		TextBuilder ret = TextBuilder.newInstance();
		boolean en = activeChar.getVar("lang@").equalsIgnoreCase("en");
		if(en)
			ret.append("<center><font color=\"LEVEL\">Server status:</font></center><br>Total online: ");
		else
			ret.append("<center><font color=\"LEVEL\">Статус сервера:</font></center><br>Онлайн сервера: ");
		ret.append(L2World.getAllPlayersCount());
		if(activeChar.getPlayerAccess().CanRestart)
			ret.append("<br1>Memory usage: ").append((100 - Runtime.getRuntime().freeMemory() * 100 / Runtime.getRuntime().maxMemory())).append("%");
		int mtc = Shutdown.getInstance().get_seconds();
		if(mtc > 0)
		{
			if(en)
				ret.append("<br1>Time to restart: ");
			else
				ret.append("<br1>До рестарта: ");
			int numDays = mtc / 86400;
			mtc -= numDays * 86400;
			int numHours = mtc / 3600;
			mtc -= numHours * 3600;
			int numMins = mtc / 60;
			mtc -= numMins * 60;
			int numSeconds = mtc;
			if(numDays > 0)
				ret.append(numDays + "d ");
			if(numHours > 0)
				ret.append(numHours + "h ");
			if(numMins > 0)
				ret.append(numMins + "m ");
			if(numSeconds > 0)
				ret.append(numSeconds + "s");
		}
		else
			ret.append("<br1>Restart task not launched.");

		ret.append("<br><center><button value=\"");
		if(en)
			ret.append("Refresh");
		else
			ret.append("Обновить");
		ret.append("\" action=\"bypass -h user_status\" width=100 height=15 back=\"sek.cbui94\" fore=\"sek.cbui92\" /></center>");

		show(ret.toString(), activeChar);
		TextBuilder.recycle(ret);
		return true;
	}

	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}