package commands.voiced;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.IVoicedCommandHandler;
import L2jFT.game.handler.VoicedCommandHandler;
import L2jFT.game.instancemanager.CastleManager;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.entity.Castle;
import L2jFT.game.model.instances.L2DoorInstance;
import L2jFT.game.network.serverpackets.Ride;

public class castle implements IVoicedCommandHandler, ScriptFile
{
	private static String[] _voicedCommands = {
			"open doors", "close doors", "ride wyvern" };

	public boolean useVoicedCommand(String command, L2Player activeChar, String target)
	{
		if(command.startsWith("open doors") && target.equals("castle") && activeChar.isClanLeader())
		{
			L2DoorInstance door = (L2DoorInstance) activeChar.getTarget();
			Castle castle = CastleManager.getInstance().getCastleByIndex(activeChar.getClan().getHasCastle());
			if(door == null || castle == null)
				return false;
			if(castle.checkIfInZone(door.getX(), door.getY()))
				door.openMe();

		}
		else if(command.startsWith("close doors") && target.equals("castle") && activeChar.isClanLeader())
		{
			L2DoorInstance door = (L2DoorInstance) activeChar.getTarget();
			Castle castle = CastleManager.getInstance().getCastleByIndex(activeChar.getClan().getHasCastle());
			if(door == null || castle == null)
				return false;
			if(castle.checkIfInZone(door.getX(), door.getY()))
				door.closeMe();

		}
		else if(command.startsWith("ride wyvern") && target.equals("castle"))
			if(activeChar.getClan().getHasCastle() > 0 && activeChar.isClanLeader())
			{
				Ride mount = new Ride(activeChar, Ride.ACTION_MOUNT, 12621);
				activeChar.sendPacket(mount);
				activeChar.broadcastPacket(mount);
				activeChar.setMountType(mount.getMountType());
			}
		return true;
	}

	public String[] getVoicedCommandList()
	{
		return _voicedCommands;
	}

	public void onLoad()
	{
		VoicedCommandHandler.getInstance().registerVoicedCommandHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}
