package events.NPCBuffer;

import L2jFT.extensions.scripts.Functions;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.extensions.multilang.CustomMessage;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2Skill;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.entity.siege.Siege;
import L2jFT.game.model.entity.Castle;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.tables.SkillTable;
import L2jFT.game.ThreadPoolManager;
import L2jFT.game.Announcements;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.game.cache.Msg;
import L2jFT.game.instancemanager.TownManager;
import L2jFT.Config;
import L2jFT.util.Files;
import L2jFT.util.Util;
import L2jFT.database.mysql;

public class Buffer extends Functions implements ScriptFile
{
	private int min_level = Config.EVENT_Min_lvl;
	private int max_level = Config.EVENT_Max_lvl;
	private int type_buffer = Config.EVENT_type_buffer;
	private static String dp = String.valueOf(Config.EVENT_dp);
	private static String dpay = String.valueOf(Config.EVENT_dpay);
	private static boolean Buffer_Siege = Config.EVENT_Buffer_Siege;
	public static L2NpcInstance npc;
	private static boolean _active = false;
	public static int summa_m;
	public static int summa_w;

	private static String buffs[][] = {
			//id, lvl, price, id item, name, group
			{ "4342", "2", dp, dpay, "Wind Walk Lv.2", "0" },
			{ "4343", "3", dp, dpay, "Decrease Weight", "0" },
			{ "1059", "1", dp, dpay, "Greater Empower", "0" },
			{ "1062", "1", dp, dpay, "Berserker Spirit", "0" },
			{ "4346", "1", dp, dpay, "Mental Shield", "0" },
			{ "1085", "1", dp, dpay, "Acumen", "0" },
			{ "1078", "1", dp, dpay, "Concentration", "0" },
			{ "1204", "1", dp, dpay, "Wind Walk", "0" },
			{ "1045", "1", dp, dpay, "Bless the Body", "0" },
			{ "1048", "1", dp, dpay, "Bless the Soul", "0" },
			{ "1303", "1", dp, dpay, "Wild Magic", "0" },
			{ "1068", "1", dp, dpay, "Might", "0" },
			{ "1040", "1", dp, dpay, "Shield", "0" },
			{ "1388", "1", dp, dpay, "Greater Might", "0" },
			{ "1086", "1", dp, dpay, "Haste", "0" },
			{ "1077", "1", dp, dpay, "Focus", "0" },
			{ "1240", "1", dp, dpay, "Guidance", "0" },
			{ "1242", "1", dp, dpay, "Death Whisper", "0" },
			{ "1268", "1", dp, dpay, "Vampiric Rage", "0" },
			// Группа для магов 2
			{ "1059", "1", dp, dpay, "Greater Empower", "2" },
			{ "1062", "1", dp, dpay, "Berserker Spirit", "2" },
			{ "4346", "1", dp, dpay, "Mental Shield", "2" },
			{ "1085", "1", dp, dpay, "Acumen", "2" },
			{ "1078", "1", dp, dpay, "Concentration", "2" },
			{ "1204", "1", dp, dpay, "Wind Walk", "2" },
			{ "1045", "1", dp, dpay, "Bless the Body", "2" },
			{ "1048", "1", dp, dpay, "Bless the Soul", "2" },
			{ "1303", "1", dp, dpay, "Wild Magic", "2" },
			{ "1040", "1", dp, dpay, "Shield", "2" },
			//Группа для воинов 1
			{ "1068", "1", dp, dpay, "Might", "1" },
			{ "1040", "1", dp, dpay, "Shield", "1" },
			{ "1062", "1", dp, dpay, "Berserker Spirit", "1" },
			{ "1388", "1", dp, dpay, "Greater Might", "1" },
			{ "1204", "1", dp, dpay, "Wind Walk", "1" },
			{ "1086", "1", dp, dpay, "Haste", "1" },
			{ "1077", "1", dp, dpay, "Focus", "1" },
			{ "1240", "1", dp, dpay, "Guidance", "1" },
			{ "1242", "1", dp, dpay, "Death Whisper", "1" },
			{ "1268", "1", dp, dpay, "Vampiric Rage", "1" } };

	public void onLoad()
	{
		if(isActive())
		{
			System.out.println("Loaded Event: NPCBuffer [state: activated]");
			summa_m = 0;
			summa_w = 0;
			for(String[] buff : buffs)
			{
				if(Integer.parseInt(buff[5]) == 1)
					summa_m++;
				if(Integer.parseInt(buff[5]) == 2)
					summa_w++;
			}
		}
		else
			System.out.println("Loaded Event: NPCBuffer [state: deactivated]");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	/**
	 * Читает статус эвента из базы.
	 * @return status
	 */
	private static boolean isActive()
	{
		Object eventStatus = mysql.get("SELECT value FROM `server_variables` WHERE `name`=\"NPCBuffer\"");
		return eventStatus != null && eventStatus.toString().equalsIgnoreCase("on");
	}

	/**
	* Запускает эвент
	*/
	public void startEvent()
	{
		L2Player player = (L2Player) self;
		if(!player.getPlayerAccess().IsEventGm)
			return;

		if(!isActive())
		{
			if(!mysql.set("INSERT INTO `server_variables` (`name`, `type`, `value`) VALUES (\"NPCBuffer\", \"event\", \"on\")"))
			{
				player.sendMessage("Can't start event. See server log files for details.");
				return;
			}
			_active = true;
			System.out.println("Event: NPCBuffer started.");
			Announcements.getInstance().announceByCustomMessage("scripts.events.NPCBuffer.AnnounceEventStarted", null);
		}
		else
			player.sendMessage("Event 'NPCBuffer' already started.");
		_active = true;
		show(Files.read("data/html/admin/events.htm", player), player);
	}

	/**
	* Останавливает эвент
	*/
	public void stopEvent()
	{
		L2Player player = (L2Player) self;
		if(!player.getPlayerAccess().IsEventGm)
			return;
		if(isActive())
		{
			if(!mysql.set("DELETE FROM `server_variables` WHERE `name`=\"NPCBuffer\""))
			{
				player.sendMessage("Can't stop event. See server log files for details.");
				return;
			}
			System.out.println("Event: NPCBuffer stopped.");
			Announcements.getInstance().announceByCustomMessage("scripts.events.NPCBuffer.AnnounceEventStoped", null);
		}
		else
			player.sendMessage("Event 'NPCBuffer' not started.");
		_active = false;
		show(Files.read("data/html/admin/events.htm", player), player);
	}

	private class doBuff implements Runnable
	{
		L2Character _actor;
		L2Skill _skill;
		L2Player _target;

		doBuff(L2Character actor, L2Skill skill, L2Player target)
		{
			_actor = actor;
			_skill = skill;
			_target = target;
		}

		public void run()
		{
			_actor.doCast(_skill, _target, true);
		}
	}

	private void runBuff(Integer id, Integer lvl, Integer price_id, Integer price, @SuppressWarnings("unused")
	int group)
	{
		if(!_active)
			return;
		L2Player player = (L2Player) self;
		L2Skill skill;
		if(type_buffer == 1)
			try
			{
				skill = SkillTable.getInstance().getInfo(id, lvl);
				player.altUseSkill(skill, player);
			}
			catch(Exception e)
			{
				player.sendMessage("Invalid skill");
			}
		else if(type_buffer == 2)
		{
			if(npc == null || !npc.isNpc)
			{
				show("Hacker? :) " + npc, player);
				return;
			}
			int time = 0;
			skill = SkillTable.getInstance().getInfo(id, lvl);
			time += 1000;
			ThreadPoolManager.getInstance().scheduleGeneral(new doBuff(npc, skill, player), time);
		}
		removeItem(player, price_id, price);
	}

	public void Buff(String[] args)
	{
		int id = Integer.valueOf(args[0]);
		int lvl = Integer.valueOf(args[1]);
		int price_id = Integer.valueOf(args[2]);
		int price = Integer.valueOf(args[3]);
		int group = Integer.valueOf(args[4]);
		L2Player player = (L2Player) self;
		if(player == null)
			return;
		if(player.isActionsDisabled() || player.isSitting() || player.getLastNpc().getDistance(player) > 300)
			return;
		// Проверяем по уровню
		if(player.getLevel() > max_level || player.getLevel() < min_level)
		{
			show(new CustomMessage("scripts.events.NPCBuffer.levelRestrict", player).addNumber(min_level).addNumber(max_level), player);
			return;
		}

		//Проверка на курсен вепон.
		if(player.isCursedWeaponEquipped())
		{
			show(new CustomMessage("scripts.events.NPCBuffer.cursed", player), player);
			return;
		}
		//Можно ли юзать бафера во время осады?
		if(!Buffer_Siege)
		{
			Castle castle = TownManager.getInstance().getClosestTown(self).getCastle();
			Siege siege = castle.getSiege();
			if(siege != null && siege.isInProgress())
			{
				show(new CustomMessage("scripts.events.NPCBuffer.siege", player), player);
				return;
			}
		}
		if(group == 0)
		{
			// Проверяем есть ли деньги у чара
			if(getItemCount(player, price_id) < price)
			{
				if(price_id == 57)
					player.sendPacket(Msg.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
				else
					player.sendPacket(Msg.INCORRECT_ITEM_COUNT);
				return;
			}
			runBuff(id, lvl, price_id, price, 0); // Если группа = 0, то бафаем 1 бафф, иначе группу
			player.sendPacket(new SystemMessage(SystemMessage.S2_S1_HAS_DISAPPEARED).addItemName(price_id).addNumber(price));
		}
		else
		{
			//Вначале подсчитаем хватит ли денег на все бафы в группе
			int summa = 0;
			for(String[] buff : buffs)
				if(Integer.parseInt(buff[5]) == group)
					summa++;
			if(getItemCount(player, price_id) < summa)
			{
				if(price_id == 57)
					player.sendPacket(Msg.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
				else
					player.sendPacket(Msg.INCORRECT_ITEM_COUNT);
				return;
			}
			for(String[] buff1 : buffs)
				if(Integer.parseInt(buff1[5]) == group)
					runBuff(Integer.parseInt(buff1[0]), Integer.parseInt(buff1[1]), Integer.parseInt(buff1[3]), Integer.parseInt(buff1[2]), 0);
			player.sendPacket(new SystemMessage(SystemMessage.S2_S1_HAS_DISAPPEARED).addItemName(price_id).addNumber(summa));
		}
	}

	public static String OutDia()
	{
		if(!_active)
			return "";
		String append = "<br><a action=\"bypass -h scripts_events.NPCBuffer.Buffer:Buff 1 1 57 " + summa_m + " 2\">";
		append += new CustomMessage("scripts.events.NPCBuffer.Buffer.buffmagic", self);
		append += Util.formatAdena(summa_m) + "</a>";
		append += "<br1><a action=\"bypass -h scripts_events.NPCBuffer.Buffer:Buff 1 1 57 " + summa_w + " 1\">";
		append += new CustomMessage("scripts.events.NPCBuffer.Buffer.buffwarrior", self);
		append += Util.formatAdena(summa_w) + "</a><br>";
		for(String[] buff : buffs)
			if(buff[5].equals("0"))
			{
				append += "<br1><a action=\"bypass -h scripts_events.NPCBuffer.Buffer:Buff " + buff[0] + " " + buff[1] + " " + buff[3] + " " + buff[2] + " " + buff[5] + "\">";
				append += new CustomMessage("scripts.events.NPCBuffer.Buffer.buffs", self).addString(buff[4]).addString(buff[2]);
				append += "</a>";
			}
		return append;
	}

	public static String DialogAppend_31212(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31213(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31214(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31215(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31216(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31217(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31218(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31219(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31220(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31221(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31222(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31223(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31224(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31767(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_32048(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}

	public static String DialogAppend_31768(Integer val)
	{
		if(val != 0)
			return "";
		return OutDia();
	}
}