package events.TheFlowOfTheHorror;

import java.util.ArrayList;

import L2jFT.game.ai.CtrlIntention;
import L2jFT.game.ai.Fighter;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2World;
import L2jFT.util.Location;
import L2jFT.util.Rnd;

public class MonstersAI extends Fighter
{
	private ArrayList<Location> _points = new ArrayList<Location>();
	private int current_point = -1;

	public void setPoints(ArrayList<Location> points)
	{
		_points = points;
	}

	public MonstersAI(L2Character actor)
	{
		super(actor);
		_globalAI = true;
	}

	@Override
	protected boolean thinkActive()
	{
		if(_thisActor.isDead())
			return true;

		if(_globalAggro < 0)
			_globalAggro++;
		else if(_globalAggro > 0)
			_globalAggro--;

		L2Character target = findTarget();
		if(target != null)
		{
			_def_think = false;
			_thisActor.setRunning();
			setIntention(CtrlIntention.AI_INTENTION_ATTACK, target);
			return true;
		}

		if(_def_think)
		{
			doTask();
			return true;
		}

		if(current_point > -1 || Rnd.chance(5))
		{
			if(current_point >= _points.size() - 1)
			{
				target = L2World.findNpcByNpcId(30754);
				if(target != null && !target.isDead())
				{
					_def_step = 0;
					_def_think = false;
					_task_list.clear();
					_thisActor.setRunning();
					_thisActor.addDamageHate(target, 0, 1);
					setIntention(CtrlIntention.AI_INTENTION_ATTACK, target);
					return true;
				}
				return true;
			}

			current_point++;

			int x = _points.get(current_point).x;
			int y = _points.get(current_point).y;
			int z = _points.get(current_point).z;

			_thisActor.setRunning();

			// Добавить новое задание
			Task task = new Task();
			task.type = TaskType.MOVE;
			task.x = x;
			task.y = y;
			task.z = z;
			_def_step = 0;
			_task_list.clear();
			_task_list.add(task);
			_def_think = true;
			return true;
		}

		if(randomAnimation())
			return true;

		return false;
	}
}