package events.arena;

import L2jFT.Config;
import L2jFT.extensions.listeners.L2ZoneEnterLeaveListener;
import L2jFT.extensions.scripts.Functions;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.cache.Msg;
import L2jFT.game.instancemanager.ZoneManager;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Playable;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2Skill;
import L2jFT.game.model.L2Zone;
import L2jFT.game.model.L2Zone.ZoneType;
import L2jFT.game.model.base.Experience;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.network.serverpackets.ValidateLocation;
import L2jFT.game.tables.SkillTable;
import L2jFT.util.Files;
import L2jFT.util.Location;

import java.util.ArrayList;

public class Arena extends Functions implements ScriptFile
{
	// Эти переменные выставляются автоматически
	public static L2Object self; // Тот, от чьего имени выполняется код
	public static L2NpcInstance npc; // npc, с которым мы разговариваем

	private static L2Player _creator;
	private static L2NpcInstance _manager;
	private static int _status = 0;
	private static int _battle_type = 1;
	private static int _team1_exp = 0;
	private static int _team2_exp = 0;
	private static int _price = 10000;
	private static int _team1_count = 1;
	private static int _team2_count = 1;
	private static int _team1_min = 1;
	private static int _team1_max = 80;
	private static int _team2_min = 1;
	private static int _team2_max = 80;
	private static int _time_to_start = 10;
	private static boolean _timeOutTask = false;

	private static ArrayList<Location> team1_points = new ArrayList<Location>();
	private static ArrayList<Location> team2_points = new ArrayList<Location>();
	private static ArrayList<L2Player> team1_list = new ArrayList<L2Player>();
	private static ArrayList<L2Player> team2_list = new ArrayList<L2Player>();
	private static ArrayList<L2Player> team1_live = new ArrayList<L2Player>();
	private static ArrayList<L2Player> team2_live = new ArrayList<L2Player>();

	private static L2Zone _zone = ZoneManager.getInstance().getZoneByIndex(ZoneType.battle_zone, 1, true);
	ZoneListener _zoneListener = new ZoneListener();

	// Настройки
	// private static Integer jail_items = 30;

	public static String DialogAppend_31225(Integer val)
	{
		if(val == 0)
		{
			L2Player player = (L2Player) self;
			if(player.isGM())
				return Files.read("data/scripts/events/arena/31225.html", player) + Files.read("data/scripts/events/arena/31225-4.html", player);
			return Files.read("data/scripts/events/arena/31225.html", player);
		}
		return "";
	}

	public void onLoad()
	{
		_status = 0;
		_zone.getListenerEngine().addMethodInvokedListener(_zoneListener);
		team1_points.clear();
		team2_points.clear();
		team1_points.add(new Location(12053, 183101, -3563));
		team1_points.add(new Location(12253, 183101, -3563));
		team1_points.add(new Location(12459, 183101, -3563));
		team1_points.add(new Location(12659, 183101, -3563));
		team1_points.add(new Location(12851, 183101, -3563));
		team2_points.add(new Location(12851, 183941, -3563));
		team2_points.add(new Location(12659, 183941, -3563));
		team2_points.add(new Location(12459, 183941, -3563));
		team2_points.add(new Location(12253, 183941, -3563));
		team2_points.add(new Location(12053, 183941, -3563));
		System.out.println("Loaded Event: Arena");
	}

	public void onReload()
	{
		if(_status > 0)
			stop();
		_zone.getListenerEngine().removeMethodInvokedListener(_zoneListener);
	}

	public void onShutdown()
	{
		onReload();
	}

	public static void stop()
	{
		npcSayToAll(_manager, "Бой прерван по техническим причинам, деньги возвращены");
		if(_battle_type == 1)
			returnAdenaToTeams();
		else if(_battle_type == 2)
			returnExpToTeams();
		unParalyzeTeams();
		clearTeams();
		_status = 0;
		_timeOutTask = false;
	}

	public static void create1()
	{
		if(_status > 0)
			show("Дождитесь окончания боя", (L2Player) self);
		else
			show("data/scripts/events/arena/31225-1.html", (L2Player) self);
	}

	public static void create2()
	{
		if(_status > 0)
			show("Дождитесь окончания боя", (L2Player) self);
		else
			show("data/scripts/events/arena/31225-2.html", (L2Player) self);
	}

	public static void register()
	{
		if(_status > 1)
			show("Дождитесь окончания боя", (L2Player) self);
		else
			show("data/scripts/events/arena/31225-3.html", (L2Player) self);
	}

	public static void check1(String[] var)
	{
		L2Player player = (L2Player) self;

		if(var.length != 8)
		{
			show("Некорректные данные", player);
			return;
		}

		if(_status > 0)
		{
			show("Дождитесь окончания боя", player);
			return;
		}
		if(npc == null || !npc.isNpc)
		{
			show("Hacker? :) " + npc, player);
			return;
		}
		_manager = npc;
		try
		{
			_price = Integer.valueOf(var[0]);
			_team1_count = Integer.valueOf(var[1]);
			_team2_count = Integer.valueOf(var[2]);
			_team1_min = Integer.valueOf(var[3]);
			_team1_max = Integer.valueOf(var[4]);
			_team2_min = Integer.valueOf(var[5]);
			_team2_max = Integer.valueOf(var[6]);
			_time_to_start = Integer.valueOf(var[7]);
		}
		catch(Exception e)
		{
			show("Некорректные данные", player);
			return;
		}
		if(_price < 10000 || _price > 100000000)
		{
			show("Неправильная ставка", player);
			return;
		}
		if(_team1_count < 1 || _team1_count > 5 || _team2_count < 1 || _team2_count > 5)
		{
			show("Неправильный размер команды", player);
			return;
		}
		if(_team1_min < 1 || _team1_min > 80 || _team2_min < 1 || _team2_min > 80 || _team1_max < 1 || _team1_max > 80 || _team2_max < 1 || _team2_max > 80 || _team1_min > _team1_max || _team2_min > _team2_max)
		{
			show("Неправильный уровень", player);
			return;
		}
		if(player.getLevel() < _team1_min || player.getLevel() > _team1_max)
		{
			show("Неправильный уровень", player);
			return;
		}
		if(_time_to_start < 1 || _time_to_start > 10)
		{
			show("Неправильное время", player);
			return;
		}
		if(player.getAdena() < _price)
		{
			player.sendPacket(Msg.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
			return;
		}
		_battle_type = 1;
		_creator = (L2Player) self;
		_creator.reduceAdena(_price);
		_creator.setTeam(1);
		_status = 1;
		team1_list.clear();
		team2_list.clear();
		team1_live.clear();
		team2_live.clear();
		team1_list.add((L2Player) self);
		npcSayToAll(_manager, _creator.getName() + " создал бой " + _team1_count + "х" + _team2_count + ", " + _team1_min + "-" + _team1_max + "lv vs " + _team2_min + "-" + _team2_max + "lv, ставка " + _price + "а, начало через " + _time_to_start + " мин");
		executeTask(_manager, "events.arena.Arena", "announce", new Object[0], 60000);
	}

	public static void check2(String[] var)
	{
		L2Player player = (L2Player) self;

		if(var.length != 7)
		{
			show("Некорректные данные", player);
			return;
		}

		if(_status > 0)
		{
			show("Дождитесь окончания боя", player);
			return;
		}
		if(npc == null || !npc.isNpc)
		{
			show("Hacker? :) " + npc, player);
			return;
		}
		_manager = npc;
		try
		{
			_team1_count = Integer.valueOf(var[0]);
			_team2_count = Integer.valueOf(var[1]);
			_team1_min = Integer.valueOf(var[2]);
			_team1_max = Integer.valueOf(var[3]);
			_team2_min = Integer.valueOf(var[4]);
			_team2_max = Integer.valueOf(var[5]);
			_time_to_start = Integer.valueOf(var[6]);
		}
		catch(Exception e)
		{
			show("Некорректные данные", player);
			return;
		}
		if(_team1_count < 1 || _team1_count > 5 || _team2_count < 1 || _team2_count > 5)
		{
			show("Неправильный размер команды", player);
			return;
		}
		if(_team1_min < 1 || _team1_min > 80 || _team2_min < 1 || _team2_min > 80 || _team1_max < 1 || _team1_max > 80 || _team2_max < 1 || _team2_max > 80 || _team1_min > _team1_max || _team2_min > _team2_max)
		{
			show("Неправильный уровень", player);
			return;
		}
		if(player.getLevel() - _team1_min > 10 || _team1_max - player.getLevel() > 10 || player.getLevel() - _team2_min > 10 || _team2_max - player.getLevel() > 10)
		{
			show("Разница в уровнях не может быть более 10", player);
			return;
		}
		if(player.getLevel() < _team1_min || player.getLevel() > _team1_max)
		{
			show("Неправильный уровень", player);
			return;
		}
		if(_time_to_start < 1 || _time_to_start > 10)
		{
			show("Неправильное время", player);
			return;
		}

		_battle_type = 2;
		_creator = (L2Player) self;
		_team1_exp = 0;
		_team2_exp = 0;

		removeExp(_creator, 1);

		_creator.setTeam(1);
		_status = 1;
		team1_list.clear();
		team2_list.clear();
		team1_live.clear();
		team2_live.clear();
		team1_list.add((L2Player) self);
		npcSayToAll(_manager, _creator.getName() + " создал бой " + _team1_count + "х" + _team2_count + ", " + _team1_min + "-" + _team1_max + "lv vs " + _team2_min + "-" + _team2_max + "lv, ставка " + "опыт, начало через " + _time_to_start + " мин");
		executeTask(_manager, "events.arena.Arena", "announce", new Object[0], 60000);
	}

	public static void register_check(String[] var)
	{
		L2Player player = (L2Player) self;

		if(_status > 1)
		{
			show("Дождитесь окончания боя", player);
			return;
		}

		if(var.length != 1)
		{
			show("Некорректные данные", player);
			return;
		}

		int _regTeam;
		try
		{
			_regTeam = Integer.valueOf(var[0]);
		}
		catch(Exception e)
		{
			show("Некорректные данные", player);
			return;
		}

		if(_regTeam != 1 && _regTeam != 2)
		{
			show("Неправильный номер команды, введите 1 или 2", player);
			return;
		}
		if(team1_list.contains(player) || team2_list.contains(player))
		{
			show("Вы уже зарегистрированы", player);
			return;
		}
		if(_battle_type == 1 && player.getAdena() < _price)
		{
			player.sendPacket(Msg.YOU_DO_NOT_HAVE_ENOUGH_ADENA);
			return;
		}
		if(_regTeam == 1)
		{
			if(player.getLevel() < _team1_min || player.getLevel() > _team1_max)
			{
				show("Вы не подходите по уровню", player);
				return;
			}
			if(team1_list.size() >= _team1_count)
			{
				show("Команда 1 переполнена", player);
				return;
			}

			if(_battle_type == 1)
				player.reduceAdena(_price);
			else if(_battle_type == 2)
				removeExp(player, 1);

			team1_list.add(player);
			player.setTeam(1);
			npcSayToAll(_manager, player.getName() + " зарегистрировался за 1 команду");
			if(team1_list.size() >= _team1_count && team2_list.size() >= _team2_count)
			{
				npcSayToAll(_manager, "Команды готовы, старт через 1 минуту.");
				_time_to_start = 1;
			}
		}
		else
		{
			if(player.getLevel() < _team2_min || player.getLevel() > _team2_max)
			{
				show("Вы не подходите по уровню", player);
				return;
			}
			if(team2_list.size() >= _team2_count)
			{
				show("Команда 2 переполнена", player);
				return;
			}

			if(_battle_type == 1)
				player.reduceAdena(_price);
			else if(_battle_type == 2)
				removeExp(player, 2);

			team2_list.add(player);
			player.setTeam(2);
			npcSayToAll(_manager, player.getName() + " зарегистрировался за 2 команду");
			if(team1_list.size() >= _team1_count && team2_list.size() >= _team2_count)
			{
				npcSayToAll(_manager, "Команды готовы, старт через 1 минуту.");
				_time_to_start = 1;
			}
		}
	}

	public static void announce()
	{
		if(_status != 1)
			return;

		if(_time_to_start > 1)
		{
			_time_to_start--;
			npcSayToAll(_manager, _creator.getName() + " создал бой " + _team1_count + "х" + _team2_count + ", " + _team1_min + "-" + _team1_max + "lv vs " + _team2_min + "-" + _team2_max + "lv, ставка " + (_battle_type == 1 ? _price + "а" : "опыт") + ", начало через " + _time_to_start + " мин");
			executeTask(_manager, "events.arena.Arena", "announce", new Object[0], 60000);
		}
		else if(team2_list.size() > 0)
		{
			npcSayToAll(_manager, "Подготовка к бою");
			executeTask(_manager, "events.arena.Arena", "prepare", new Object[0], 5000);
		}
		else
		{
			npcSayToAll(_manager, "Бой не состоялся, нет противников");
			_status = 0;
			if(_battle_type == 1)
				returnAdenaToTeams();
			else if(_battle_type == 2)
				returnExpToTeams();
			clearTeams();
		}
	}

	public static void prepare()
	{
		if(_status != 1)
			return;

		_status = 2;
		for(L2Player player : team1_list)
			if(player != null && !player.isDead())
				team1_live.add(player);
		for(L2Player player : team2_list)
			if(player != null && !player.isDead())
				team2_live.add(player);
		if(!checkTeams())
			return;
		clearArena();
		paralyzeTeams();
		teleportTeamsToArena();
		npcSayToAll(_manager, "Бой начнется через 15 секунд");
		executeTask(_manager, "events.arena.Arena", "start", new Object[0], 15000);
	}

	public static void start()
	{
		if(_status != 2)
			return;

		if(!checkTeams())
			return;
		npcSayToAll(_manager, "Go!!!");
		unParalyzeTeams();
		_status = 3;
		executeTask(_manager, "events.arena.Arena", "timeOut", new Object[0], 120000);
		_timeOutTask = true;
	}

	public static void clearArena()
	{
		for(L2Player player : _manager.getAroundPlayers(1500))
			if(player.isInZone(ZoneType.battle_zone))
				teleportToArenaSpawn(player);
	}

	public static boolean checkTeams()
	{
		if(team1_live.size() == 0)
		{
			teamHasLost(1);
			return false;
		}
		else if(team2_live.size() == 0)
		{
			teamHasLost(2);
			return false;
		}
		return true;
	}

	public static void paralyzeTeams()
	{
		L2Skill revengeSkill = SkillTable.getInstance().getInfo(4515, 1);
		for(L2Player player : team1_live)
			if(player != null)
			{
				revengeSkill.getEffects(player, player, false);
				if(player.getPet() != null)
					revengeSkill.getEffects(player, player.getPet(), false);
			}
		for(L2Player player : team2_live)
			if(player != null)
			{
				revengeSkill.getEffects(player, player, false);
				if(player.getPet() != null)
					revengeSkill.getEffects(player, player.getPet(), false);
			}
	}

	public static void unParalyzeTeams()
	{
		for(L2Player player : team1_list)
			if(player != null)
			{
				player.stopEffect((short) 4515);
				if(player.getPet() != null)
					player.getPet().stopEffect((short) 4515);
			}
		for(L2Player player : team2_list)
			if(player != null)
			{
				player.stopEffect((short) 4515);
				if(player.getPet() != null)
					player.getPet().stopEffect((short) 4515);
			}
	}

	public static void teleportTeamsToArena()
	{
		Integer n = 0;
		for(L2Player player : team1_live)
		{
			if(player != null)
			{
				player.teleToLocation(team1_points.get(n));
				if(player.getPet() != null)
					player.getPet().teleToLocation(team1_points.get(n));
			}
			n++;
		}
		n = 0;
		for(L2Player player : team2_live)
		{
			if(player != null)
			{
				player.teleToLocation(team2_points.get(n));
				if(player.getPet() != null)
					player.getPet().teleToLocation(team1_points.get(n));
			}
			n++;
		}
	}

	public static void teleportToArenaSpawn(L2Character cha)
	{
		cha.teleToLocation(_zone.getSpawn());
	}

	public static boolean playerHasLost(L2Player player)
	{
		if(player.getTeam() == 1)
			team1_live.remove(player);
		else
			team2_live.remove(player);
		L2Skill revengeSkill = SkillTable.getInstance().getInfo(4515, 1);
		revengeSkill.getEffects(player, player, false);
		return !checkTeams();
	}

	public static void teamHasLost(Integer team_id)
	{
		if(team_id == 1)
		{
			npcSayToAll(_manager, "Команда 2 победила");
			if(_battle_type == 1)
				payAdenaToTeam(2);
			else if(_battle_type == 2)
				payExpToTeam(2);
		}
		else
		{
			npcSayToAll(_manager, "Команда 1 победила");
			if(_battle_type == 1)
				payAdenaToTeam(1);
			else if(_battle_type == 2)
				payExpToTeam(1);
		}
		unParalyzeTeams();
		clearTeams();
		_status = 0;
		_timeOutTask = false;
	}

	public static void timeOut()
	{
		if(_timeOutTask && _status == 3)
		{
			npcSayToAll(_manager, "Время истекло, ничья!");
			if(_battle_type == 1)
				returnAdenaToTeams();
			else if(_battle_type == 2)
				returnExpToTeams();
			unParalyzeTeams();
			clearTeams();
			_status = 0;
			_timeOutTask = false;
		}
	}

	@SuppressWarnings("cast")
	public static void payAdenaToTeam(Integer team_id)
	{
		if(team_id == 1)
			for(L2Player player : team1_list)
			{
				if(player != null)
					player.addAdena(_price + team2_list.size() * _price / team1_list.size());
			}
		else
			for(L2Player player : team2_list)
				if(player != null)
					player.addAdena(_price + team1_list.size() * _price / team2_list.size());
	}

	@SuppressWarnings("cast")
	public static void payExpToTeam(Integer team_id)
	{
		if(team_id == 1)
		{
			for(L2Player player : team1_list)
				if(player != null)
				{
					returnExp(player);
					addExp(player, _team2_exp / team1_list.size() / 2);
					if(Config.ALT_HONOR_SYSTEM)
						player.getInventory().addItem(4674, 3, 0, "Arena");
				}
			if(Config.ALT_HONOR_SYSTEM)
				for(L2Player player : team2_list)
					if(player != null)
						player.getInventory().addItem(4674, 1, 0, "Arena");
		}
		else
		{
			for(L2Player player : team2_list)
				if(player != null)
				{
					returnExp(player);
					addExp(player, _team1_exp / team2_list.size() / 2);
					if(Config.ALT_HONOR_SYSTEM)
						player.getInventory().addItem(4674, 3, 0, "Arena");
				}
			if(Config.ALT_HONOR_SYSTEM)
				for(L2Player player : team1_list)
					if(player != null)
						player.getInventory().addItem(4674, 1, 0, "Arena");
		}
	}

	public static void returnAdenaToTeams()
	{
		for(L2Player player : team1_list)
			if(player != null)
				player.addAdena(_price);
		for(L2Player player : team2_list)
			if(player != null)
				player.addAdena(_price);
	}

	public static void returnExpToTeams()
	{
		for(L2Player player : team1_list)
			if(player != null)
				returnExp(player);
		for(L2Player player : team2_list)
			if(player != null)
				returnExp(player);
	}

	public static void clearTeams()
	{
		for(L2Player player : team1_list)
			player.setTeam(0);
		for(L2Player player : team2_list)
			player.setTeam(0);
		team1_list.clear();
		team2_list.clear();
		team1_live.clear();
		team2_live.clear();
	}

	public static void removeExp(L2Player player, int team)
	{
		double percentLost = 4.0;
		int lvl = player.getLevel();
		int _lostExp = (int) Math.round((Experience.LEVEL[lvl + 1] - Experience.LEVEL[lvl]) * percentLost / 100);

		if(team == 1)
			_team1_exp += _lostExp;
		else if(team == 2)
			_team2_exp += _lostExp;

		player.setExp(player.getExp() - _lostExp);
		if(player.getExp() < Experience.LEVEL[lvl])
			player.decreaseLevel();
		player.sendChanges();
	}

	public static void returnExp(L2Player player)
	{
		double percentAdd = 4.0;
		int lvl = player.getLevel();
		int _addExp = (int) Math.round((Experience.LEVEL[lvl + 1] - Experience.LEVEL[lvl]) * percentAdd / 100);
		player.setExp(player.getExp() + _addExp);
		if(player.getExp() >= Experience.LEVEL[lvl + 1] && player.getExp() < Experience.LEVEL[80])
			player.increaseLevel();
		player.sendChanges();
	}

	public static void addExp(L2Player player, int exp)
	{
		int lvl = player.getLevel();
		player.setExp(player.getExp() + exp);
		if(player.getExp() >= Experience.LEVEL[lvl + 1] && player.getExp() < Experience.LEVEL[80])
			player.increaseLevel();
		player.sendChanges();
	}

	public static void onDie(L2Object self, L2Character killer)
	{
		if(_status >= 2 && self != null && self.isPlayer && (team1_list.contains(self) || team2_list.contains(self)))
		{
			L2Player player = self.getPlayer();
			L2Player kplayer = killer.getPlayer();
			// TODO реализовать тюрьму
			if(kplayer != null)
			{
				npcSayToAll(_manager, kplayer.getName() + " убил " + player.getName());
				if(player.getTeam() == kplayer.getTeam() || !team1_list.contains(kplayer) && !team2_list.contains(kplayer))
				{
					npcSayToAll(_manager, "Нарушение правил, игрок " + kplayer.getName() + " оштрафован на " + _price);
					kplayer.reduceAdena(_price);
				}
				playerHasLost(player);
				if(Config.ALT_HONOR_SYSTEM)
					kplayer.getInventory().addItem(4674, 1, self.getObjectId(), "Arena");
			}
			else
			{
				npcSayToAll(_manager, player.getName() + " убит");
				playerHasLost(player);
			}
		}
	}

	public static void OnPlayerExit(L2Player player)
	{
		if(player != null && _status > 0 && (team1_list.contains(player) || team2_list.contains(player)))
			switch(_status)
			{
				case 1:
					player.setTeam(0);
					team1_list.remove(player);
					team2_list.remove(player);
					npcSayToAll(_manager, player.getName() + " дисквалифицирован");
					if(player.equals(_creator))
					{
						npcSayToAll(_manager, "Бой прерван, деньги возвращены");
						if(_battle_type == 1)
							returnAdenaToTeams();
						else if(_battle_type == 2)
							returnExpToTeams();
						unParalyzeTeams();
						clearTeams();
						_status = 0;
						_timeOutTask = false;
					}
					break;
				case 2:
					player.setTeam(0);
					team1_list.remove(player);
					team2_list.remove(player);
					team1_live.remove(player);
					team2_live.remove(player);
					npcSayToAll(_manager, player.getName() + " дисквалифицирован");
					checkTeams();
					break;
				case 3:
					player.setTeam(0);
					team1_list.remove(player);
					team2_list.remove(player);
					team1_live.remove(player);
					team2_live.remove(player);
					npcSayToAll(_manager, player.getName() + " дисквалифицирован");
					checkTeams();
					break;
			}
	}

	public static Location onEscape(L2Player player)
	{
		if(player != null && _status > 1 && player.isInZone(_zone))
			OnPlayerExit(player);
		return null;
	}

	private class ZoneListener extends L2ZoneEnterLeaveListener
	{
		@Override
		public void objectEntered(L2Zone zone, L2Object object)
		{
			L2Player player = object.getPlayer();
			if(_status >= 2 && player != null && !(team1_list.contains(player) || team2_list.contains(player)))
				teleportToArenaSpawn(player);
		}

		@Override
		public void objectLeaved(L2Zone zone, L2Object object)
		{
			L2Player player = object.getPlayer();
			if(_status >= 2 && player != null && (team1_list.contains(player) || team2_list.contains(player)))
			{
				L2Playable playable = (L2Playable) object;
				playable.stopMove(null);
				int heading = playable.getHeading();
				if(heading <= 16384)
					playable.setXYZ(playable.getX() - 50, playable.getY() - 50, playable.getZ());
				else if(heading > 16384 && heading <= 32768)
					playable.setXYZ(playable.getX() + 50, playable.getY() - 50, playable.getZ());
				else if(heading > 32768 && heading <= 49152)
					playable.setXYZ(playable.getX() + 50, playable.getY() + 50, playable.getZ());
				else if(heading > 49152)
					playable.setXYZ(playable.getX() - 50, playable.getY() + 50, playable.getZ());
				playable.broadcastPacket(new ValidateLocation(playable));
			}
		}
	}
}
