package events.tournament;

import javolution.util.FastList;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2World;

import java.util.List;

public class Team
{
	private Integer _id;
	private String _name;
	private Integer _leader;
	private Integer _member1;
	private Integer _member2;
	private Integer _category;

	public String getName()
	{
		return _name;
	}

	public void setName(String name)
	{
		_name = name;
	}

	public boolean addMember(Integer member)
	{
		if(_member1 == null)
		{
			_member1 = member;
			return true;
		}
		else if(_member2 == null)
		{
			_member2 = member;
			return true;
		}
		else
			return false;
	}

	public boolean removeMember(Integer member)
	{
		if(_member1 == member)
		{
			_member1 = null;
			return true;
		}
		else if(_member2 == member)
		{
			_member2 = null;
			return true;
		}
		else
			return false;
	}

	public Integer getLeader()
	{
		return _leader;
	}

	public void setLeader(Integer leader)
	{
		_leader = leader;
	}

	public List<Integer> getMembers()
	{
		List<Integer> result = new FastList<Integer>();
		result.add(_leader);
		if(_member1 != null)
			result.add(_member1);
		if(_member2 != null)
			result.add(_member2);
		return result;
	}

	public List<L2Player> getOnlineMembers()
	{
		List<L2Player> result = new FastList<L2Player>();
		for(Integer obj_id : getMembers())
		{
			L2Object obj = L2World.findObject(obj_id);
			if(obj != null && obj.isPlayer)
				result.add((L2Player) L2World.findObject(obj_id));
		}
		return result;
	}

	public Integer getCount()
	{
		return getMembers().size();
	}

	public Integer getOnlineCount()
	{
		return getOnlineMembers().size();
	}

	public Integer getCategory()
	{
		return _category;
	}

	public void setCategory(Integer category)
	{
		_category = category;
	}

	public Integer getId()
	{
		return _id;
	}

	public void setId(Integer id)
	{
		_id = id;
	}
}
