package events.tournament;

import java.util.ArrayList;

import L2jFT.database.mysql;
import L2jFT.extensions.scripts.Functions;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.instancemanager.ZoneManager;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2World;
import L2jFT.game.model.L2Zone;
import L2jFT.game.model.L2Zone.ZoneType;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.network.serverpackets.Revive;
import L2jFT.game.network.serverpackets.SocialAction;
import L2jFT.util.Files;
import L2jFT.util.Location;

@SuppressWarnings("unused")
public class Tournament_battle extends Functions implements ScriptFile
{
	public static L2Object self;
	public static L2NpcInstance npc;
	public static L2NpcInstance _manager;

	private static L2Zone _zone = ZoneManager.getInstance().getZoneByIndex(ZoneType.battle_zone, 4, true);

	private static boolean _zone_hooks = false;
	private static boolean _die_hooks = false;
	private static boolean _intention_hooks = false;

	private static int _current_cycle;
	private static int _category;

	private static int _status = 0;
	private static int _time_to_start;

	private static ArrayList<Location> team1_points = new ArrayList<Location>();
	private static ArrayList<Location> team2_points = new ArrayList<Location>();

	public static Team team1;
	public static Team team2;

	public static ArrayList<L2Player> team1_live_list;
	public static ArrayList<L2Player> team2_live_list;

	public static String DialogAppend_31851(Integer val)
	{
		L2Player player = (L2Player) self;
		if(val == 0)
		{
			if(player.isGM())
				return Files.read("data/scripts/events/tournament/31851.html", player) + Files.read("data/scripts/events/tournament/31851-gm.html", player);
			return Files.read("data/scripts/events/tournament/31851.html", player);
		}
		return "";
	}

	public static void bypass_begin(String[] var)
	{
		if(var.length != 8)
		{
			show("Некорректные данные", (L2Player) self);
			return;
		}
		if(npc == null || !npc.isNpc)
		{
			show("Hacker? :) " + npc, (L2Player) self);
			return;
		}
		try
		{
			_category = Integer.valueOf(var[0]);
		}
		catch(Exception e)
		{
			show("Некорректные данные", (L2Player) self);
			return;
		}

		_manager = npc;
		_time_to_start = 10;
		_status = 1;
		_current_cycle = 1;

		Tournament_register.endRegistration();

		mysql.set("UPDATE tournament_teams SET status = 1");

		npcSayToAll(_manager, "Регистрация на турнир окончена.");

		if(Tournament_data.createTournamentTable(_category))
			return;

		npcSayToAll(_manager, "Турнир для категории " + _category + " начнется через 10 минут!");

		addAnnounce("Турнир начнется через 9 минут.", 60000);
		addAnnounce("Турнир начнется через 8 минут.", 120000);
		addAnnounce("Турнир начнется через 7 минут.", 180000);
		addAnnounce("Турнир начнется через 6 минут.", 240000);
		addAnnounce("Турнир начнется через 5 минут.", 300000);
		addAnnounce("Турнир начнется через 4 минуты.", 360000);
		addAnnounce("Турнир начнется через 3 минуты.", 420000);
		addAnnounce("Турнир начнется через 2 минуты.", 480000);
		addAnnounce("Турнир начнется через 1 минуту.", 540000);

		addAnnounce("Турнир проводится в колизее.", 121000);
		addAnnounce("Все желающие могут наблюдать за боями через обзорные кристаллы, либо купив места на трибуне. Места продаются у Arena Director.", 181000);
		addAnnounce("Команды будут вызываться по-очереди, в порядке, указанном в турнирной таблице. Просьба заранее приготовиться.", 241000);
		addAnnounce("На каждый бой отводится 3 минуты. Если за 3 минуты не определился победитель, проигравшей считается команда с меньшим количеством жизней.", 301000);
		addAnnounce("Если весь состав команды отсутствует в игре, команде засчитывается поражение.", 361000);
		addAnnounce("Рекомендуется всем участникам заранее прийти в колизей, чтобы в начале боя телепортация не заняла много времени.", 421000);

		addTask("nextBattle", 600000);
	}

	public static void addAnnounce(String text, Integer time)
	{
		Object[] args = new Object[1];
		args[0] = text;
		executeTask(_manager, "events.tournament.Tournament_battle", "announce", args, time);
	}

	public static void addTask(String task, Integer time)
	{
		executeTask(_manager, "events.tournament.Tournament_battle", task, new Object[0], time);
	}

	public static void announce(String text)
	{
		if(_status == 0)
			return;
		npcSayToAll(_manager, text);
	}

	public static void nextBattle()
	{
		if(!fillNextTeams())
			return;

		team1_live_list.clear();
		team2_live_list.clear();

		team1_live_list.addAll(team1.getOnlineMembers());
		team2_live_list.addAll(team2.getOnlineMembers());

		_zone_hooks = true;
		_status = 2;
		clearArena();
		teleportTeams();
		addTask("deBuffTeams", 60000);
		addTask("resurrectTeams", 60000);
		addTask("healTeams", 60000);
		addTask("root", 60000);
		addAnnounce("Бой начнется через 1 минуту.", 60000);
		addTask("startBattle", 120000);
		addTask("endBattle", 300000);
	}

	public static void startBattle()
	{
		endRoot();
		npcSayToAll(_manager, "FIGHT!!!");
	}

	public static void endBattle()
	{
		_zone_hooks = false;
		npcSayToAll(_manager, "Время истекло.");
		calculateWinner();
		npcSayToAll(_manager, "Следующий бой начнется через 1 минуту.");
		executeTask(_manager, "events.tournament.Tournament_battle", "nextBattle", new Object[0], 60000);
	}

	public static boolean fillNextTeams()
	{
		npcSayToAll(_manager, _current_cycle + " этап.");
		while(!Tournament_data.fillNextTeams(_category))
		{
			// начало следующего цикла
			if(!Tournament_data.createTournamentTable(_category))
				return false;
			_current_cycle++;
			npcSayToAll(_manager, _current_cycle + " этап.");
		}
		return true;
	}

	public static void endTournament()
	{

	}

	public static void calculateWinner()
	{
		int hp1 = 0;
		int hp2 = 0;

		for(L2Player player : team1_live_list)
			if(player != null && !player.isDead())
				hp1 += player.getCurrentHp();

		for(L2Player player : team2_live_list)
			if(player != null && !player.isDead())
				hp2 += player.getCurrentHp();

		if(hp2 > hp1)
		{
			announce("Команда " + team2.getName() + " выиграла бой.");
			mysql.set("DELETE FROM tournament_table WHERE team1id = " + team1.getId());
			mysql.set("UPDATE tournament_teams SET status = 0 WHERE team_id = " + team1.getId());
			mysql.set("UPDATE tournament_teams SET losts = losts + 1 WHERE team_id = " + team1.getId());
			mysql.set("UPDATE tournament_teams SET wins = wins + 1 WHERE team_id = " + team2.getId());
		}
		else
		{
			announce("Команда " + team1.getName() + " выиграла бой.");
			mysql.set("DELETE FROM tournament_table WHERE team1id = " + team1.getId());
			mysql.set("UPDATE tournament_teams SET status = 0 WHERE team_id = " + team2.getId());
			mysql.set("UPDATE tournament_teams SET losts = losts + 1 WHERE team_id = " + team2.getId());
			mysql.set("UPDATE tournament_teams SET wins = wins + 1 WHERE team_id = " + team1.getId());
		}
	}

	public static void clearArena()
	{
		for(L2Player player : L2World.getAllPlayers())
			if(player != null && _zone.getLoc1().isInside(player.getX(), player.getY()))
				teleportToColiseumSpawn(player);
	}

	public static void teleportToColiseumSpawn(L2Player player)
	{
		player.teleToLocation(_zone.getSpawn());
	}

	public static void teleportTeams()
	{
		int i = 0;
		for(L2Player player : team1_live_list)
			if(player != null)
			{
				player.teleToLocation(team1_points.get(i));
				i++;
			}
		i = 0;
		for(L2Player player : team2_live_list)
			if(player != null)
			{
				player.teleToLocation(team2_points.get(i));
				i++;
			}
	}

	public static void resurrectTeams()
	{
		for(L2Player player : team1_live_list)
			if(player != null)
			{
				player.restoreExp();
				player.broadcastPacket(new SocialAction(player.getObjectId(), 15));
				player.broadcastPacket(new Revive(player));
				player.doRevive();
			}
		for(L2Player player : team2_live_list)
			if(player != null)
			{
				player.restoreExp();
				player.broadcastPacket(new SocialAction(player.getObjectId(), 15));
				player.broadcastPacket(new Revive(player));
				player.doRevive();
			}
	}

	public static void healTeams()
	{
		for(L2Player player : team1_live_list)
			if(player != null)
			{
				player.setCurrentHpMp(player.getMaxHp(), player.getMaxMp());
				player.setCurrentCp(player.getMaxCp());
				if(player.getPet() != null)
				{
					player.getPet().setCurrentHpMp(player.getPet().getMaxHp(), player.getPet().getMaxMp());
					player.getPet().setCurrentCp(player.getPet().getMaxCp());
				}
			}
		for(L2Player player : team2_live_list)
			if(player != null)
			{
				player.setCurrentHpMp(player.getMaxHp(), player.getMaxMp());
				player.setCurrentCp(player.getMaxCp());
				if(player.getPet() != null)
				{
					player.getPet().setCurrentHpMp(player.getPet().getMaxHp(), player.getPet().getMaxMp());
					player.getPet().setCurrentCp(player.getPet().getMaxCp());
				}
			}
	}

	public static void deBuffTeams()
	{
		for(L2Player player : team1_live_list)
			if(player != null)
			{
				player.stopAllEffects();
				if(player.getPet() != null)
					player.getPet().stopAllEffects();
			}
		for(L2Player player : team2_live_list)
			if(player != null)
			{
				player.stopAllEffects();
				if(player.getPet() != null)
					player.getPet().stopAllEffects();
			}
	}

	public static void root()
	{
		for(L2Player player : team1_live_list)
			if(player != null)
			{
				player.setImobilised(true);
				if(player.getPet() != null)
					player.getPet().setImobilised(true);
			}
		for(L2Player player : team2_live_list)
			if(player != null)
			{
				player.setImobilised(true);
				if(player.getPet() != null)
					player.getPet().setImobilised(true);
			}
	}

	public static void endRoot()
	{
		for(L2Player player : team1_live_list)
			if(player != null)
			{
				player.setImobilised(true);
				if(player.getPet() != null)
					player.getPet().setImobilised(false);
			}
		for(L2Player player : team2_live_list)
			if(player != null)
			{
				player.setImobilised(true);
				if(player.getPet() != null)
					player.getPet().setImobilised(false);
			}
	}

	public static void giveItemsToWinner(Team team)
	{

	}

	public void onLoad()
	{
		team1_points.add(new Location(12053, 183101, -3563));
		team1_points.add(new Location(12253, 183101, -3563));
		team1_points.add(new Location(12459, 183101, -3563));
		team2_points.add(new Location(12851, 183941, -3563));
		team2_points.add(new Location(12659, 183941, -3563));
		team2_points.add(new Location(12459, 183941, -3563));
		System.out.println("Loaded Event: Tournament");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}
