package items;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.handler.IItemHandler;
import L2jFT.game.handler.ItemHandler;
import L2jFT.game.model.L2Playable;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.network.serverpackets.ShowMiniMap;

public class WorldMap implements IItemHandler, ScriptFile
{
	// all the items ids that this handler knowns
	private static final short[] _itemIds = { 1665, 1863 };

	public void useItem(L2Playable playable, L2ItemInstance item)
	{
		if(playable == null || !playable.isPlayer)
			return;
		L2Player player = (L2Player) playable;

		player.sendPacket(new ShowMiniMap(item.getItemId()));
	}

	public final short[] getItemIds()
	{
		return _itemIds;
	}

	public void onLoad()
	{
		ItemHandler.getInstance().registerItemHandler(this);
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}