package npc.model;

import events.clanhall.CHSiegeManager;
import L2jFT.game.ai.CtrlIntention;
import L2jFT.game.instancemanager.ClanHallManager;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.entity.ClanHall;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.network.serverpackets.NpcHtmlMessage;
import L2jFT.game.network.serverpackets.SiegeInfo;
import L2jFT.game.templates.L2NpcTemplate;

import java.util.logging.Logger;

public class L2DCSiegeMessengerInstance extends L2NpcInstance
{
	@SuppressWarnings("unused")
	private static final Logger _log = Logger.getLogger(L2DCSiegeMessengerInstance.class.getName());

	public L2DCSiegeMessengerInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	@Override
	public void onBypassFeedback(L2Player player, String command)
	{
		if(!isInRange(player, INTERACTION_DISTANCE))
		{
			player.getAI().setIntention(CtrlIntention.AI_INTENTION_ATTACK, this);
			player.sendActionFailed();
		}
		/*else
			try
			{
				if(command.equalsIgnoreCase("Register"))
				{
					boolean registered = false;
					if(player.getClan() == null)
					{
						player.sendMessage("Can't register to ClanHall Siege. You are not a clan member.");
						return;
					}
					else if(!player.isClanLeader())
					{
						player.sendMessage("Can't register to ClanHall Siege. You are not a clan leader.");
						return;
					}

					if(player.getClan().getHasHideout() != 0)
					{
						player.sendPacket(new SystemMessage(SystemMessage. A_CLAN_THAT_OWNS_A_CLAN_HALL_MAY_NOT_PARTICIPATE_IN_A_CLAN_HALL_SIEGE));
						return;
					}

					if(!DCSiege.getInstance().isRegistrationAvaliable())
					{
						player.sendPacket(new SystemMessage(SystemMessage.YOU_ARE_TOO_LATE_THE_REGISTRATION_PERIOD_IS_OVER));
						return;
					}

					for(Castle castle : CastleManager.getInstance().getCastles().values())
					{
						if(SiegeManager.getInstance().checkIsRegisteredForSiege(player.getClan(), castle.getCastleId()))
						{
							registered = true;
							break;
						}
					}
					if(DCSiege.getInstance().getAttackers().contains(player.getClan()))
						registered = true;

					if(registered)
						player.sendMessage("Can't register to ClanHall Siege. You are registered for another siege.");
					else
					{
						DCSiege.getInstance().addAttacker(player.getClan());
						player.getClan().sendMessageToAll("Your clan has been registered to Devastated Castle Siege.");
					}
				}
			}
			catch(StringIndexOutOfBoundsException sioobe)
			{
				_log.info("Incorrect htm bypass! npcId=" + getTemplate().npcId + " command=[" + command + "]");
			}
			catch(NumberFormatException nfe)
			{
				_log.info("Invalid bypass to Server command parameter! npcId=" + getTemplate().npcId + " command=[" + command + "]");
			} */
		super.onBypassFeedback(player, command);
	}

	@Override
	public void showChatWindow(L2Player player, int val)
	{
		ClanHall ch = ClanHallManager.getInstance().findNearestClanHall(this);
		if(validateCondition(player))
			player.sendPacket(new SiegeInfo(ch, CHSiegeManager.getInstance().getSiege(ch.getId()).getStartTime()));
		else
			player.sendPacket(new NpcHtmlMessage(player, this, "data/html/chsiege/" + getTemplate().npcId + "-busy.htm", val));
	}

	private boolean validateCondition(@SuppressWarnings("unused")
	L2Player player)
	{
		if(CHSiegeManager.getInstance().getSiege(ClanHallManager.getInstance().findNearestClanHall(this).getId()).isInProgress())
			return false; // Busy because of siege
		if(!CHSiegeManager.getInstance().getSiege(ClanHallManager.getInstance().findNearestClanHall(this).getId()).isRegistrationAvaliable())
			return false;
		return true;
	}
}
