package quests.MagicalPowerofFire1;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.game.tables.SkillTable;

public class MagicalPowerofFire1 extends Quest implements ScriptFile
{
	// NPC
	private final int NARAN = 31378;
	private final int UDAN = 31379;
	private final int BOX_OF_ASEFA = 31559;

	private final int KETRA_FIRST_NPC = 21324;
	private final int KETRA_LAST_NPC = 21350;
	private final int VARKA_FIRST_NPC = 21350;
	private final int VARKA_LAST_NPC = 21376;

	// Quest items
	private final short STOLEN_RED_TOTEM = 7242;
	private final short DIVINE_STONE_OF_WISDOM = 7081;
	private final short RED_TOTEM = 7243;

	// etc
	private final short MARK_OF_VARKA_ALLIANCE1 = 7221;
	private final short MARK_OF_VARKA_ALLIANCE2 = 7222;
	private final short MARK_OF_VARKA_ALLIANCE3 = 7223;
	private final short MARK_OF_VARKA_ALLIANCE4 = 7224;
	private final short MARK_OF_VARKA_ALLIANCE5 = 7225;
	private final short THIEF_KEY = 1661;

	private State CREATED = new State("Start", this);
	private State STARTED = new State("Started", this);
	private State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 615: Magical Power of Fire 1");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public MagicalPowerofFire1()
	{
		super(615, "MagicalPowerofFire1", "Magical Power of Fire 1", false);

		setInitialState(CREATED);
		addStartNpc(NARAN);
		addTalkId(NARAN);
		addTalkId(NARAN);
		addTalkId(NARAN);
		addTalkId(UDAN);
		addTalkId(BOX_OF_ASEFA);

		for(int i = KETRA_FIRST_NPC; i <= KETRA_LAST_NPC; i++)
			addAttackId(i);

		for(int i = VARKA_FIRST_NPC; i <= VARKA_LAST_NPC; i++)
			addKillId(i);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31378-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("open") && st.getInt("cond") == 2)
			if(st.getQuestItemsCount(THIEF_KEY) < 1)
				htmltext = "31559-2.htm";
			else if(st.getInt("proval") == 1)
			{
				htmltext = "31559-4.htm";
				st.takeItems(THIEF_KEY, 1);
			}
			else
			{
				st.takeItems(THIEF_KEY, 1);
				st.giveItems(STOLEN_RED_TOTEM, 1);
				htmltext = "31559-3.htm";
				st.set("cond", "3");
			}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");
		int proval = st.getInt("proval");
		switch(npcId)
		{
			case NARAN:
				if(cond == 0)
					if(!id.equals(COMPLETED))
						if(st.getPlayer().getLevel() >= 74)
							if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) == 1 || st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) == 1 || st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) == 1 || st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) == 1)
								htmltext = "31378-1.htm";
							else
							{
								htmltext = "31378-00.htm";
								st.exitCurrentQuest(true);
							}
						else
						{
							htmltext = "31378-0.htm";
							st.exitCurrentQuest(true);
						}
					else
						htmltext = "<html><head><body>This quest have already been completed.</body></html>";
				else if(cond == 1)
					htmltext = "31378-2r.htm";
				break;
			case UDAN:
				if(cond == 1)
				{
					htmltext = "31379-1.htm";
					st.set("cond", "2");
				}
				else if(cond == 2 && proval == 1)
				{
					htmltext = "31379-3.htm";
					npc.doCast(SkillTable.getInstance().getInfo(4548, 1), st.getPlayer(), true);
					st.set("proval", "0");
				}
				else if(cond == 3 && st.getQuestItemsCount(STOLEN_RED_TOTEM) == 1)
				{
					htmltext = "31379-4.htm";
					st.takeItems(STOLEN_RED_TOTEM, -1);
					st.giveItems(RED_TOTEM, 1);
					st.giveItems(DIVINE_STONE_OF_WISDOM, 1);
					st.set("cond", "0");
					st.setState(COMPLETED);
					st.playSound("ItemSound.quest_finish");
				}
				break;
			case BOX_OF_ASEFA:
				if(cond == 2)
					htmltext = "31559-1.htm";
				break;
		}
		return htmltext;
	}

	@Override
	public String onAttack(L2NpcInstance npc, QuestState st)
	{
		int cond = st.getInt("cond");
		int proval = st.getInt("proval");
		if(cond == 2 && proval == 0)
		{
			npc.doCast(SkillTable.getInstance().getInfo(4547, 1), st.getPlayer(), true);
			st.set("proval", "1");
		}
		return null;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) > 0)
		{
			st.takeItems(MARK_OF_VARKA_ALLIANCE5, -1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE4, 1);
		}
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) > 0)
		{
			st.takeItems(MARK_OF_VARKA_ALLIANCE4, -1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE3, 1);
		}
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) > 0)
		{
			st.takeItems(MARK_OF_VARKA_ALLIANCE3, -1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE2, 1);
		}
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) > 0)
		{
			st.takeItems(MARK_OF_VARKA_ALLIANCE2, -1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE1, 1);
		}
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) > 0)
			st.takeItems(MARK_OF_VARKA_ALLIANCE1, -1);
		st.getPlayer().setVarka(st.getPlayer().getVarka() - 1);
		st.exitQuest(611);
		st.exitQuest(612);
		st.exitQuest(613);
		st.exitQuest(614);
		st.exitQuest(615);
		st.exitQuest(616);
		return null;
	}
}