package quests.MagicalPowerofFire2;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class MagicalPowerofFire2 extends Quest implements ScriptFile
{
	// NPC
	private final int KETRAS_HOLY_ALTAR = 31558;
	private final int UDAN = 31379;
	private final int SOUL_OF_FIRE_NASTRON = 25306;

	private final int KETRA_FIRST_NPC = 21324;
	private final int KETRA_LAST_NPC = 21350;
	private final int VARKA_FIRST_NPC = 21350;
	private final int VARKA_LAST_NPC = 21376;

	// Quest items
	private final short FIRE_HEART_OF_NASTRON = 7244;
	private final short RED_TOTEM = 7243;

	// etc
	private final short MARK_OF_VARKA_ALLIANCE1 = 7221;
	private final short MARK_OF_VARKA_ALLIANCE2 = 7222;
	private final short MARK_OF_VARKA_ALLIANCE3 = 7223;
	private final short MARK_OF_VARKA_ALLIANCE4 = 7224;
	private final short MARK_OF_VARKA_ALLIANCE5 = 7225;

	private State CREATED = new State("Start", this);
	private State STARTED = new State("Started", this);
	private State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 616: Magical Power of Fire 2");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public MagicalPowerofFire2()
	{
		super(616, "MagicalPowerofFire2", "Magical Power of Fire 2", false);

		setInitialState(CREATED);
		addStartNpc(UDAN);

		addTalkId(UDAN);
		addTalkId(UDAN);
		addTalkId(UDAN);
		addTalkId(KETRAS_HOLY_ALTAR);

		for(int i = VARKA_FIRST_NPC; i <= VARKA_LAST_NPC; i++)
			addKillId(i);

		addKillId(SOUL_OF_FIRE_NASTRON);
		STARTED.addQuestDrop(SOUL_OF_FIRE_NASTRON, FIRE_HEART_OF_NASTRON, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31379-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("use_totem"))
			if(st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) >= 1 && !st.getPcSpawn().isSpawnExists(25306))
			{
				st.takeItems(RED_TOTEM, -1);
				st.getPcSpawn().addSpawn(25306, 142528, -82528, -6496);
				st.getPcSpawn().addSpawn(25307, 142628, -82528, -6490);
				st.getPcSpawn().addSpawn(25308, 142428, -82528, -6490);
				st.playSound("ItemSound.quest_middle");
			}
			else
				htmltext = "31558-havenot.htm";
		else if(event.equalsIgnoreCase("31379-4.htm"))
			if(st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) >= 1)
			{
				st.takeItems(FIRE_HEART_OF_NASTRON, -1);
				st.set("cond", "0");
				st.setState(COMPLETED);
				st.playSound("ItemSound.quest_finish");
				htmltext = "31379-2.htm";
			}
			else
				htmltext = "31379-havenot.htm";
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");
		switch(npcId)
		{
			case UDAN:
				if(cond == 0)
					if(!id.equals(COMPLETED))
						if(st.getPlayer().getLevel() >= 75)
							if(st.getQuestItemsCount(RED_TOTEM) == 1)
								htmltext = "31379-1.htm";
							else
							{
								htmltext = "31379-00.htm";
								st.exitCurrentQuest(true);
							}
						else
						{
							htmltext = "31379-0.htm";
							st.exitCurrentQuest(true);
						}
					else
						htmltext = "<html><head><body>This quest have already been completed.</body></html>";
				else if(cond == 1)
					htmltext = "31379-2r.htm";
				else if(cond == 2)
					htmltext = "31379-2rr.htm";
				else if(cond == 3 && st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) == 1)
					htmltext = "31379-3.htm";
				break;
			case KETRAS_HOLY_ALTAR:
				if(npc.isBusy())
					htmltext = "31558-busy.htm";
				else if(cond == 1)
					htmltext = "31558-1.htm";
				else if(cond == 2 && !st.getPcSpawn().isSpawnExists(25306))
				{
					st.getPcSpawn().addSpawn(25306, 142528, -82528, -6496);
					st.getPcSpawn().addSpawn(25307, 142628, -82528, -6490);
					st.getPcSpawn().addSpawn(25308, 142428, -82528, -6490);
					htmltext = "31558-3.htm";
				}
				break;
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(npcId >= KETRA_FIRST_NPC && npcId <= KETRA_LAST_NPC)
		{
			if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE5, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE4, 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE4, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE3, 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE3, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE2, 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE2, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE1, 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) > 0)
				st.takeItems(MARK_OF_VARKA_ALLIANCE1, -1);
			st.getPlayer().setKetra(st.getPlayer().getVarka() - 1);
			st.exitQuest(611);
			st.exitQuest(612);
			st.exitQuest(613);
			st.exitQuest(614);
			st.exitQuest(615);
			st.exitQuest(616);
		}
		else if(st.getQuestItemsCount(FIRE_HEART_OF_NASTRON) == 0)
		{
			st.giveItems(FIRE_HEART_OF_NASTRON, 1);
			st.set("cond", "3");
			st.getPcSpawn().removeAllSpawn();
		}
		return null;
	}
}