package quests._002_WhatWomenWant;

// version = Unknown

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _002_WhatWomenWant extends Quest implements ScriptFile
{
	int ARUJIEN = 30223;
	int MIRABEL = 30146;
	int HERBIEL = 30150;
	int GREENIS = 30157;

	int ARUJIENS_LETTER1 = 1092;
	int ARUJIENS_LETTER2 = 1093;
	int ARUJIENS_LETTER3 = 1094;
	int POETRY_BOOK = 689;
	int GREENIS_LETTER = 693;

	int ADENA = 57;
	int BEGINNERS_POTION = 1073;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 002: What Women Want");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _002_WhatWomenWant()
	{
		super(2, "_002_WhatWomenWant", "What Women Want", false);
		setInitialState(CREATED);
		addStartNpc(ARUJIEN);

		addTalkId(ARUJIEN);
		addTalkId(MIRABEL);
		addTalkId(HERBIEL);
		addTalkId(GREENIS);

		STARTED.addQuestDrop(GREENIS, GREENIS_LETTER, 1);
		STARTED.addQuestDrop(HERBIEL, ARUJIENS_LETTER3, 1);
		STARTED.addQuestDrop(ARUJIEN, ARUJIENS_LETTER1, 1);
		STARTED.addQuestDrop(MIRABEL, ARUJIENS_LETTER2, 1);
		STARTED.addQuestDrop(ARUJIEN, POETRY_BOOK, 1);
		STARTED.addQuestDrop(ARUJIEN, BEGINNERS_POTION, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30223-04.htm"))
		{
			st.giveItems(ARUJIENS_LETTER1, 1);
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("30223-08.htm"))
		{
			st.takeItems(ARUJIENS_LETTER3, -1);
			st.giveItems(POETRY_BOOK, 1);
			st.set("cond", "4");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30223-10.htm"))
		{
			st.takeItems(ARUJIENS_LETTER3, -1);
			st.giveItems(ADENA, 450);
			st.set("cond", "0");
			st.setState(COMPLETED);
			st.playSound("ItemSound.quest_finish");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");
		if(npcId == ARUJIEN)
		{
			if(cond == 0)
			{
				if(!id.equals(COMPLETED))
					if(st.getPlayer().getRace().ordinal() != 1 && st.getPlayer().getRace().ordinal() != 0)
						htmltext = "30223-00.htm";
					else if(st.getPlayer().getLevel() >= 2)
						htmltext = "30223-02.htm";
					else
					{
						htmltext = "30223-01.htm";
						st.exitCurrentQuest(true);
					}
				else
					htmltext = "<html><body>This quest have already been completed.</body></html>";
			}
			else if(cond == 1 && st.getQuestItemsCount(ARUJIENS_LETTER1) > 0)
				htmltext = "30223-05.htm";
			else if(cond == 2 && st.getQuestItemsCount(ARUJIENS_LETTER2) > 0)
				htmltext = "30223-06.htm";
			else if(cond == 3 && st.getQuestItemsCount(ARUJIENS_LETTER3) > 0)
				htmltext = "30223-07.htm";
			else if(cond == 4 && st.getQuestItemsCount(POETRY_BOOK) > 0)
				htmltext = "30223-11.htm";
			else if(cond == 5 && st.getQuestItemsCount(GREENIS_LETTER) > 0)
			{
				htmltext = "30223-10.htm";
				st.takeItems(GREENIS_LETTER, -1);
				st.giveItems(BEGINNERS_POTION, 5);
				st.unset("cond");
				st.setState(COMPLETED);
				st.playSound("ItemSound.quest_finish");
			}
		}
		else if(npcId == MIRABEL)
		{
			if(cond == 1 && st.getQuestItemsCount(ARUJIENS_LETTER1) > 0)
			{
				htmltext = "30146-01.htm";
				st.takeItems(ARUJIENS_LETTER1, -1);
				st.giveItems(ARUJIENS_LETTER2, 1);
				st.set("cond", "2");
				st.playSound("ItemSound.quest_middle");
			}
			else if(cond == 2)
				htmltext = "30146-02.htm";
		}
		else if(npcId == HERBIEL)
		{
			if(cond == 2 && st.getQuestItemsCount(ARUJIENS_LETTER2) > 0)
			{
				htmltext = "30150-01.htm";
				st.takeItems(ARUJIENS_LETTER2, -1);
				st.giveItems(ARUJIENS_LETTER3, 1);
				st.set("cond", "3");
				st.playSound("ItemSound.quest_middle");
			}
			else if(cond == 3)
				htmltext = "30150-02.htm";
		}
		else if(npcId == GREENIS)
			if(cond == 4 && st.getQuestItemsCount(POETRY_BOOK) > 0)
			{
				htmltext = "30157-02.htm";
				st.takeItems(POETRY_BOOK, -1);
				st.giveItems(GREENIS_LETTER, 1);
				st.set("cond", "5");
				st.playSound("ItemSound.quest_middle");
			}
			else if(cond == 5 && st.getQuestItemsCount(GREENIS_LETTER) > 0)
				htmltext = "30157-03.htm";
			else
				htmltext = "30157-01.htm";
		return htmltext;
	}
}
