package quests._003_WilltheSealbeBroken;

// version = Unknown

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _003_WilltheSealbeBroken extends Quest implements ScriptFile
{
	int StartNpc = 30141;
	int[] Monster = { 20031, 20041, 20046, 20048, 20052, 20057 };

	int OnyxBeastEye = 1081;
	int TaintStone = 1082;
	int SuccubusBlood = 1083;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State ABORTED = new State("Aborted", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 003: Will the Seal be Broken?");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _003_WilltheSealbeBroken()
	{
		super(3, "_003_WilltheSealbeBroken", "Will the Seal be Broken", false);
		setInitialState(CREATED);
		addStartNpc(StartNpc);

		addTalkId(StartNpc);
		addTalkId(StartNpc);
		addTalkId(StartNpc);

		for(int npcId : Monster)
			addKillId(npcId);

		STARTED.addQuestDrop(Monster[0], OnyxBeastEye, 1);
		STARTED.addQuestDrop(Monster[1], TaintStone, 1);
		STARTED.addQuestDrop(Monster[2], TaintStone, 1);
		STARTED.addQuestDrop(Monster[3], SuccubusBlood, 1);
		STARTED.addQuestDrop(Monster[4], SuccubusBlood, 1);
		STARTED.addQuestDrop(Monster[5], SuccubusBlood, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30141-03.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		State id = st.getState();
		if(id.equals(CREATED) || id.equals(ABORTED))
			if(st.getPlayer().getRace().ordinal() != 2)
			{
				htmltext = "30141-00.htm";
				st.exitCurrentQuest(true);
			}
			else if(st.getPlayer().getLevel() >= 16)
			{
				htmltext = "30141-02.htm";
				return htmltext;
			}
			else
			{
				htmltext = "30141-01.htm";
				st.exitCurrentQuest(true);
			}
		else if(id.equals(STARTED))
			if(st.getQuestItemsCount(OnyxBeastEye) > 0 && st.getQuestItemsCount(TaintStone) > 0 && st.getQuestItemsCount(SuccubusBlood) > 0)
			{
				htmltext = "30141-06.htm";
				st.takeItems(OnyxBeastEye, -1);
				st.takeItems(TaintStone, -1);
				st.takeItems(SuccubusBlood, -1);
				st.giveItems(57, 4900);
				st.addExpAndSp(5000, 0);
				st.unset("cond");
				st.setState(COMPLETED);
				st.playSound("ItemSound.quest_finish");
			}
			else
				htmltext = "30141-04.htm";
		else if(id.equals(COMPLETED))
			htmltext = "<html><body>This quest have already been completed.</body></html>";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		State id = st.getState();
		if(id.equals(STARTED))
		{
			if(npcId == Monster[0] && st.getQuestItemsCount(OnyxBeastEye) == 0)
			{
				st.giveItems(OnyxBeastEye, 1);
				st.playSound("ItemSound.quest_itemget");
			}
			else if((npcId == Monster[1] || npcId == Monster[2]) && st.getQuestItemsCount(TaintStone) == 0)
			{
				st.giveItems(TaintStone, 1);
				st.playSound("ItemSound.quest_itemget");
			}
			else if((npcId == Monster[3] || npcId == Monster[4] || npcId == Monster[5]) && st.getQuestItemsCount(SuccubusBlood) == 0)
			{
				st.giveItems(SuccubusBlood, 1);
				st.playSound("ItemSound.quest_itemget");
			}
			if(st.getQuestItemsCount(OnyxBeastEye) > 0 && st.getQuestItemsCount(TaintStone) > 0 && st.getQuestItemsCount(SuccubusBlood) > 0)
			{
				st.set("cond", "2");
				st.playSound("ItemSound.quest_middle");
			}
		}
		return null;
	}
}