package quests._004_LongLivethePaagrioLord;

// version = Unknown

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _004_LongLivethePaagrioLord extends Quest implements ScriptFile
{
	int HONEY_KHANDAR = 1541;
	int BEAR_FUR_CLOAK = 1542;
	int BLOODY_AXE = 1543;
	int ANCESTOR_SKULL = 1544;
	int SPIDER_DUST = 1545;
	int DEEP_SEA_ORB = 1546;

	int[][] NPC_GIFTS = {
			{ 30585, BEAR_FUR_CLOAK }, { 30566, HONEY_KHANDAR },
			{ 30562, BLOODY_AXE }, { 30560, ANCESTOR_SKULL }, { 30559, SPIDER_DUST },
			{ 30587, DEEP_SEA_ORB } };

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State ABORTED = new State("Aborted", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 004: Long Live the Paagrio Lord");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _004_LongLivethePaagrioLord()
	{
		super(4, "_004_LongLivethePaagrioLord", "Long Live the Paagrio Lord", false);
		setInitialState(CREATED);
		addStartNpc(30578);

		addTalkId(30578);
		addTalkId(30578);

		addTalkId(30559);
		addTalkId(30560);
		addTalkId(30562);
		addTalkId(30566);
		addTalkId(30578);
		addTalkId(30585);
		addTalkId(30587);

		STARTED.addQuestDrop(30559, SPIDER_DUST, 1);
		STARTED.addQuestDrop(30560, ANCESTOR_SKULL, 1);
		STARTED.addQuestDrop(30562, BLOODY_AXE, 1);
		STARTED.addQuestDrop(30566, HONEY_KHANDAR, 1);
		STARTED.addQuestDrop(30585, BEAR_FUR_CLOAK, 1);
		STARTED.addQuestDrop(30587, DEEP_SEA_ORB, 1);
		STARTED.addQuestDrop(30578, 4, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30578-03.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		State id = st.getState();
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == 30578)
		{
			if(cond == 0)
			{
				if(!id.equals(COMPLETED))
				{
					if(st.getPlayer().getRace().ordinal() != 3)
					{
						htmltext = "30578-00.htm";
						st.exitCurrentQuest(true);
					}
					else if(st.getPlayer().getLevel() >= 2)
						htmltext = "30578-02.htm";
					else
					{
						htmltext = "30578-01.htm";
						st.exitCurrentQuest(true);
					}
				}
				else
					htmltext = "<html><body>This quest have already been completed.</body></html>";
			}
			else if(cond == 1)
				htmltext = "30578-04.htm";
			else if(cond == 2)
			{
				htmltext = "30578-06.htm";
				for(int[] item : NPC_GIFTS)
					st.takeItems(item[1], -1);
				st.giveItems(4, 1);
				st.unset("cond");
				st.setState(COMPLETED);
				st.playSound("ItemSound.quest_finish");
			}
		}
		else if(cond == 1)
			for(int Id[] : NPC_GIFTS)
				if(Id[0] == npcId)
				{
					int item = Id[1];
					if(st.getQuestItemsCount(item) > 0)
						htmltext = npc + "-02.htm";
					else
					{
						st.giveItems(item, 1);
						htmltext = npc + "-01.htm";
						int count = 0;
						for(int[] item1 : NPC_GIFTS)
							count += st.getQuestItemsCount(item1[1]);
						if(count == 6)
						{
							st.set("cond", "2");
							st.playSound("ItemSound.quest_middle");
						}
						else
							st.playSound("ItemSound.quest_itemget");
					}
					return htmltext;
				}
		return htmltext;
	}
}