package quests._006_StepIntoTheFuture;

// version = Unknown

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _006_StepIntoTheFuture extends Quest implements ScriptFile
{
	int ROXXY = 30006;
	int BAULRO = 30033;
	int SIR_COLLIN = 30311;

	int BAULRO_LETTER = 7571;

	int SCROLL_OF_ESCAPE_GIRAN = 7126;
	int MARK_OF_TRAVELER = 7570;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State ABORTED = new State("Aborted", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 006: Step Into The Future");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _006_StepIntoTheFuture()
	{
		super(6, "_006_StepIntoTheFuture", "Step Into The Future", false);
		setInitialState(CREATED);
		addStartNpc(ROXXY);

		addTalkId(ROXXY);
		addTalkId(ROXXY);

		addTalkId(ROXXY);
		addTalkId(BAULRO);
		addTalkId(SIR_COLLIN);

		STARTED.addQuestDrop(ROXXY, BAULRO_LETTER, 1);
		STARTED.addQuestDrop(ROXXY, SCROLL_OF_ESCAPE_GIRAN, 1);
		STARTED.addQuestDrop(ROXXY, MARK_OF_TRAVELER, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30006-03.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("30033-02.htm"))
		{
			st.giveItems(BAULRO_LETTER, 1);
			st.set("cond", "2");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30311-03.htm"))
		{
			st.takeItems(BAULRO_LETTER, -1);
			st.set("cond", "3");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30006-06.htm"))
		{
			st.giveItems(SCROLL_OF_ESCAPE_GIRAN, 1);
			st.giveItems(MARK_OF_TRAVELER, 1);
			st.unset("cond");
			st.setState(COMPLETED);
			st.playSound("ItemSound.quest_finish");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		State id = st.getState();
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == ROXXY)
		{
			if(cond == 0)
				if(!id.equals(COMPLETED))
					if(st.getPlayer().getRace().ordinal() == 0 && st.getPlayer().getLevel() >= 3)
						htmltext = "30006-02.htm";
					else
					{
						htmltext = "30006-01.htm";
						st.exitCurrentQuest(true);
					}
				else
					htmltext = "<html><body>I can't supply you with another Giran Scroll of Escape. Sorry traveller.</body></html>";
			else if(cond == 1)
				htmltext = "30006-04.htm";
			else if(cond == 3)
				htmltext = "30006-05.htm";
		}
		else if(npcId == BAULRO)
		{
			if(cond == 1)
				htmltext = "30033-01.htm";
			else if(cond == 2 && st.getQuestItemsCount(BAULRO_LETTER) > 0)
				htmltext = "30033-03.htm";
		}
		else if(npcId == SIR_COLLIN)
			if(cond == 2 && st.getQuestItemsCount(BAULRO_LETTER) > 0)
				htmltext = "30311-02.htm";
			else if(cond == 2 && st.getQuestItemsCount(BAULRO_LETTER) == 0)
				htmltext = "30311-havent.htm";
			else if(cond == 3)
				htmltext = "30311-03r.htm";
		return htmltext;
	}
}