package quests._007_ATripBegins;

// version = Unknown

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _007_ATripBegins extends Quest implements ScriptFile
{
	int MIRABEL = 30146;
	int ARIEL = 30148;
	int ASTERIOS = 30154;

	int ARIELS_RECOMMENDATION = 7572;

	int SCROLL_OF_ESCAPE_GIRAN = 7126;
	int MARK_OF_TRAVELER = 7570;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State ABORTED = new State("Aborted", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 007: A Trip Begins");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _007_ATripBegins()
	{
		super(7, "_007_ATripBegins", "A Trip Begins", false);
		setInitialState(CREATED);
		addStartNpc(MIRABEL);

		addTalkId(MIRABEL);
		addTalkId(MIRABEL);

		addTalkId(MIRABEL);
		addTalkId(ARIEL);
		addTalkId(ASTERIOS);

		STARTED.addQuestDrop(ARIEL, ARIELS_RECOMMENDATION, 1);
		STARTED.addQuestDrop(MIRABEL, SCROLL_OF_ESCAPE_GIRAN, 1);
		STARTED.addQuestDrop(MIRABEL, MARK_OF_TRAVELER, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30146-03.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("30148-02.htm"))
		{
			st.giveItems(ARIELS_RECOMMENDATION, 1);
			st.set("cond", "2");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30154-02.htm"))
		{
			st.takeItems(ARIELS_RECOMMENDATION, -1);
			st.set("cond", "3");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30146-06.htm"))
		{
			st.giveItems(SCROLL_OF_ESCAPE_GIRAN, 1);
			st.giveItems(MARK_OF_TRAVELER, 1);
			st.set("cond", "0");
			st.setState(COMPLETED);
			st.playSound("ItemSound.quest_finish");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		State id = st.getState();
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == MIRABEL)
		{
			if(cond == 0)
				if(!id.equals(COMPLETED))
					if(st.getPlayer().getRace().ordinal() == 1 && st.getPlayer().getLevel() >= 3)
						htmltext = "30146-02.htm";
					else
					{
						htmltext = "30146-01.htm";
						st.exitCurrentQuest(true);
					}
				else
					htmltext = "<html><body>I can't supply you with another Giran Scroll of Escape. Sorry traveller.</body></html>";
			else if(cond == 1)
				htmltext = "30146-04.htm";
			else if(cond == 3)
				htmltext = "30146-05.htm";
		}
		else if(npcId == ARIEL)
		{
			if(cond == 1 && st.getQuestItemsCount(ARIELS_RECOMMENDATION) == 0)
				htmltext = "30148-01.htm";
			else if(cond == 2)
				htmltext = "30148-03.htm";
		}
		else if(npcId == ASTERIOS)
			if(cond == 2 && st.getQuestItemsCount(ARIELS_RECOMMENDATION) > 0)
				htmltext = "30154-01.htm";
			else if(cond == 2 && st.getQuestItemsCount(ARIELS_RECOMMENDATION) == 0)
				htmltext = "30154-havent.htm";
			else if(cond == 3)
				htmltext = "30154-02r.htm";
		return htmltext;
	}
}