package quests._008_AnAdventureBegins;

// version = Unknown

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _008_AnAdventureBegins extends Quest implements ScriptFile
{
	int JASMINE = 30134;
	int ROSELYN = 30355;
	int HARNE = 30144;

	int ROSELYNS_NOTE = 7573;

	int SCROLL_OF_ESCAPE_GIRAN = 7126;
	int MARK_OF_TRAVELER = 7570;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State ABORTED = new State("Aborted", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 008: An Adventure Begins");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _008_AnAdventureBegins()
	{
		super(8, "_008_AnAdventureBegins", "An Adventure Begins", false);
		setInitialState(CREATED);
		addStartNpc(JASMINE);

		addTalkId(JASMINE);
		addTalkId(JASMINE);

		addTalkId(JASMINE);
		addTalkId(ROSELYN);
		addTalkId(HARNE);

		STARTED.addQuestDrop(ROSELYN, ROSELYNS_NOTE, 1);
		STARTED.addQuestDrop(JASMINE, SCROLL_OF_ESCAPE_GIRAN, 1);
		STARTED.addQuestDrop(JASMINE, MARK_OF_TRAVELER, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30134-03.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("30355-02.htm"))
		{
			st.giveItems(ROSELYNS_NOTE, 1);
			st.set("cond", "2");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30144-02.htm"))
		{
			st.takeItems(ROSELYNS_NOTE, -1);
			st.set("cond", "3");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30134-06.htm"))
		{
			st.giveItems(SCROLL_OF_ESCAPE_GIRAN, 1);
			st.giveItems(MARK_OF_TRAVELER, 1);
			st.set("cond", "0");
			st.setState(COMPLETED);
			st.playSound("ItemSound.quest_finish");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		State id = st.getState();
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == JASMINE)
		{
			if(cond == 0 && st.getPlayer().getRace().ordinal() == 2)
				if(!id.equals(COMPLETED))
					if(st.getPlayer().getLevel() >= 3)
						htmltext = "30134-02.htm";
					else
					{
						htmltext = "30134-01.htm";
						st.exitCurrentQuest(true);
					}
				else
					htmltext = "<html><body>I can't supply you with another Giran Scroll of Escape. Sorry traveller.</body></html>";
			else if(cond == 1)
				htmltext = "30134-04.htm";
			else if(cond == 3)
				htmltext = "30134-05.htm";
		}
		else if(npcId == ROSELYN)
		{
			if(st.getQuestItemsCount(ROSELYNS_NOTE) == 0)
				htmltext = "30355-01.htm";
			else
				htmltext = "30355-03.htm";
		}
		else if(npcId == HARNE)
			if(cond == 2 && st.getQuestItemsCount(ROSELYNS_NOTE) > 0)
				htmltext = "30144-01.htm";
			else if(cond == 2 && st.getQuestItemsCount(ROSELYNS_NOTE) == 0)
				htmltext = "30144-havent.htm";
			else if(cond == 3)
				htmltext = "30144-02r.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}
}