package quests._009_IntoTheCityOfHumans;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _009_IntoTheCityOfHumans extends Quest implements ScriptFile
{
	//NPC
	public final int PETUKAI = 30583;
	public final int TANAPI = 30571;
	public final int TAMIL = 30576;
	//Items
	public final int SCROLL_OF_ESCAPE_GIRAN = 7126;
	//Quest Item
	public final int MARK_OF_TRAVELER = 7570;
	//Main
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 009: Into the City of Humans");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _009_IntoTheCityOfHumans()
	{
		super(9, "_009_IntoTheCityOfHumans", "Into the City of Humans", false);
		setInitialState(CREATED);
		addStartNpc(PETUKAI);

		addTalkId(PETUKAI);
		addTalkId(TANAPI);
		addTalkId(TAMIL);

		STARTED.addQuestDrop(TAMIL, SCROLL_OF_ESCAPE_GIRAN, 1);
		STARTED.addQuestDrop(TAMIL, MARK_OF_TRAVELER, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30583-03.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("30571-02.htm"))
		{
			st.set("cond", "2");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30576-02.htm"))
		{
			st.giveItems(SCROLL_OF_ESCAPE_GIRAN, 1);
			st.giveItems(MARK_OF_TRAVELER, 1);
			st.unset("cond");
			st.setState(COMPLETED);
			st.playSound("ItemSound.quest_finish");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		State id = st.getState();
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == PETUKAI)
		{
			if(cond == 0)
			{
				if(!id.equals(COMPLETED))
				{
					if(st.getPlayer().getRace().ordinal() == 3 && st.getPlayer().getLevel() >= 3)
						htmltext = "30583-02.htm";
					else
					{
						htmltext = "30583-01.htm";
						st.exitCurrentQuest(true);
					}
				}
				else
					htmltext = "<html><body>I can't supply you with another Giran Scroll of Escape. Sorry traveller.</body></html>";
			}
			else if(cond == 1)
				htmltext = "30583-04.htm";
		}
		else if(npcId == TANAPI)
		{
			if(cond == 1)
				htmltext = "30571-01.htm";
			else if(cond == 2)
				htmltext = "30571-03.htm";
		}
		else if(npcId == TAMIL)
			if(cond == 2)
				htmltext = "30576-01.htm";
		return htmltext;
	}
}
