package quests._012_SecretMeetingWithVarkaSilenos;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _012_SecretMeetingWithVarkaSilenos extends Quest implements ScriptFile
{
	int CADMON = 31296;
	int HELMUT = 31258;
	int NARAN_ASHANUK = 31378;

	int MUNITIONS_BOX = 7232;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State ABORTED = new State("Aborted", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 012: Secret Meeting with Varka Silenos");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _012_SecretMeetingWithVarkaSilenos()
	{
		super(12, "_012_SecretMeetingWithVarkaSilenos", "Secret Meeting with Varka Silenos", false);
		setInitialState(CREATED);
		addStartNpc(CADMON);

		addTalkId(CADMON);
		addTalkId(HELMUT);
		addTalkId(NARAN_ASHANUK);

		STARTED.addQuestDrop(HELMUT, MUNITIONS_BOX, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31296-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("31258-2.htm"))
		{
			st.giveItems(MUNITIONS_BOX, 1);
			st.set("cond", "2");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("31378-2.htm"))
		{
			st.takeItems(MUNITIONS_BOX, 1);
			st.addExpAndSp(79761, 0);
			st.unset("cond");
			st.setState(COMPLETED);
			st.playSound("ItemSound.quest_finish");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		State id = st.getState();
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == CADMON)
		{
			if(cond == 0)
			{
				if(!id.equals(COMPLETED))
				{
					if(st.getPlayer().getLevel() >= 74)
						htmltext = "31296-1.htm";
					else
					{
						htmltext = "31296-00.htm";
						st.exitCurrentQuest(true);
					}
				}
				else
					htmltext = "<html><body>This quest have already been completed.</body></html>";
			}
			else if(cond == 1)
				htmltext = "31296-2r.htm";
		}
		else if(npcId == HELMUT)
		{
			if(cond == 1)
				htmltext = "31258-1.htm";
			else if(cond == 2)
				htmltext = "31258-2r.htm";
		}
		else if(npcId == NARAN_ASHANUK)
			if(cond == 2 && st.getQuestItemsCount(MUNITIONS_BOX) > 0)
				htmltext = "31378-1.htm";
		return htmltext;
	}
}
