package quests._014_WhereaboutsoftheArchaeologist;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _014_WhereaboutsoftheArchaeologist extends Quest implements ScriptFile
{
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	private static final int LETTER_TO_ARCHAEOLOGIST = 7253;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 014: Whereabouts of the Archaeologist");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _014_WhereaboutsoftheArchaeologist()
	{
		super(14, "_014_WhereaboutsoftheArchaeologist", "Whereabouts of the Archaeologist", false);
		setInitialState(CREATED);

		addStartNpc(31263);
		addTalkId(31263);
		addTalkId(31263);
		addTalkId(31263);
		addTalkId(31538);
		STARTED.addQuestDrop(31263, LETTER_TO_ARCHAEOLOGIST, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31263-2.htm"))
		{
			st.set("cond", "1");
			st.giveItems(LETTER_TO_ARCHAEOLOGIST, 1);
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("31538-2.htm"))
		{
			st.takeItems(LETTER_TO_ARCHAEOLOGIST, -1);
			st.giveItems(57, 113228);
			st.set("cond", "0");
			st.setState(COMPLETED);
			st.playSound("ItemSound.quest_finish");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");
		if(npcId == 31263)
		{
			if(cond == 0)
				if(id != COMPLETED)
					if(st.getPlayer().getLevel() >= 74)
						htmltext = "31263-1.htm";
					else
					{
						htmltext = "31263-00.htm";
						st.exitCurrentQuest(true);
					}
				else
					htmltext = "<html><body>This quest have already been completed.</body></html>";
			else if(cond == 1)
				htmltext = "31263-2.htm";
		}
		else if(npcId == 31538)
			if(cond == 1 && st.getQuestItemsCount(LETTER_TO_ARCHAEOLOGIST) == 1)
				htmltext = "31538-1.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}
}