package quests._015_SweetWhispers;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _015_SweetWhispers extends Quest implements ScriptFile
{
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 015: Sweet Whispers");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _015_SweetWhispers()
	{
		super(15, "_015_SweetWhispers", "Sweet Whispers", false);
		setInitialState(CREATED);

		addStartNpc(31302);

		addTalkId(31302);
		addTalkId(31517);
		addTalkId(31518);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31302-02.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("31518-02.htm"))
			st.set("cond", "2");
		else if(event.equalsIgnoreCase("31517-02.htm"))
		{
			st.addExpAndSp(88000, 0);
			st.set("cond", "0");
			st.setState(COMPLETED);
			st.playSound("ItemSound.quest_finish");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");
		if(npcId == 31302)
		{
			if(cond == 0)
				if(id != COMPLETED)
					if(st.getPlayer().getLevel() >= 60)
						htmltext = "31302-01.htm";
					else
					{
						htmltext = "31302-00.htm";
						st.exitCurrentQuest(true);
					}
				else
					htmltext = "<html><body>This quest have already been completed.</body></html>";
			else if(cond >= 1)
				htmltext = "31302-02r.htm";
		}
		else if(npcId == 31518)
		{
			if(cond == 1)
				htmltext = "31518-01.htm";
			else if(cond == 2)
				htmltext = "31518-02r.htm";
		}
		else if(npcId == 31517)
			if(cond == 2)
				htmltext = "31517-01.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}
}