package quests._016_TheComingDarkness;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _016_TheComingDarkness extends Quest implements ScriptFile
{
	//npc
	public final int HIERARCH = 31517;
	//ALTAR_LIST (MOB_ID, cond)
	public final int[][] ALTAR_LIST = {
			{ 31512, 1 }, { 31513, 2 }, { 31514, 3 }, { 31515, 4 }, { 31516, 5 } };
	//items
	public final int CRYSTAL_OF_SEAL = 7167;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 16: The Coming Darkness");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _016_TheComingDarkness()
	{
		super(16, "_016_TheComingDarkness", "The Coming Darkness", false);
		setInitialState(CREATED);
		addStartNpc(HIERARCH);
		addTalkId(HIERARCH);
		for(int[] element : ALTAR_LIST)
			addTalkId(element[0]);

		STARTED.addQuestDrop(HIERARCH, CRYSTAL_OF_SEAL, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;

		if(event.equalsIgnoreCase("31517-02.htm"))
		{
			st.setState(STARTED);
			st.set("cond", "1");
			st.giveItems(CRYSTAL_OF_SEAL, 5);
			st.playSound("ItemSound.quest_accept");
		}
		for(int[] element : ALTAR_LIST)
			if(event.equalsIgnoreCase(String.valueOf(element[0]) + "-02.htm"))
			{
				st.takeItems(CRYSTAL_OF_SEAL, 1);
				st.set("cond", String.valueOf(element[1] + 1));
				st.playSound("ItemSound.quest_middle");
			}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");
		if(npcId == 31517)
			if(cond < 1)
			{
				if(id != COMPLETED)
				{
					if(st.getPlayer().getLevel() < 61)
					{
						htmltext = "31517-00.htm";
						st.exitCurrentQuest(true);
					}
					else
						htmltext = "31517-01.htm";
				}
				else
					htmltext = "<html><body>This quest have already been completed.</body></html>";
			}
			else if(cond > 0 && cond < 6 && st.getQuestItemsCount(CRYSTAL_OF_SEAL) > 0)
				htmltext = "31517-02r.htm";
			else if(cond > 0 && cond < 6 && st.getQuestItemsCount(CRYSTAL_OF_SEAL) < 1)
			{
				htmltext = "31517-proeb.htm";
				st.unset("cond");
				st.setState(COMPLETED);
			}
			else if(cond > 5 && st.getQuestItemsCount(CRYSTAL_OF_SEAL) < 1)
			{
				htmltext = "31517-03.htm";
				st.addExpAndSp(221958, 0);
				st.unset("cond");
				st.setState(COMPLETED);
				st.playSound("ItemSound.quest_finish");
			}
		for(int[] element : ALTAR_LIST)
			if(npcId == element[0])
				if(cond == element[1])
				{
					if(st.getQuestItemsCount(CRYSTAL_OF_SEAL) > 0)
						htmltext = String.valueOf(element[0]) + "-01.htm";
					else
						htmltext = String.valueOf(element[0]) + "-03.htm";
				}
				else if(cond == element[1] + 1)
					htmltext = String.valueOf(element[0]) + "-04.htm";
		return htmltext;
	}
}