package quests._021_HiddenTruth;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2Spawn;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.game.network.serverpackets.CreatureSay;
import L2jFT.util.Location;
import L2jFT.util.Rnd;

public class _021_HiddenTruth extends Quest implements ScriptFile
{
	public final int DARIN = 30048;
	public final int ROXXY = 30006;
	public final int BAULRO = 30033;

	// ~~~~~~~~ npcId list: ~~~~~~~~
	public final int MysteriousWizard = 31522;
	public final int Tombstone = 31523;
	public final int GhostofvonHellmann = 31524;
	public final int GhostofvonHellmannsPage = 31525;
	public final int BrokenBookshelf = 31526;
	public final int Agripel = 31348;
	public final int Dominic = 31350;
	public final int Benedict = 31349;
	public final int Innocentin = 31328;
	// ~~~~~~~~~~~~ END ~~~~~~~~~~~~

	// ~~~~~~~~ itemId list: ~~~~~~~~
	public final int CrossofEinhasad = 7140;
	public final int CrossofEinhasadNextQuest = 7141;
	// ~~~~~~~~~~~~ END ~~~~~~~~~~~~~

	String[] NPCtext = new String[] {
			" follow me...", " this where that here...", " I want to speak to you..." };

	// --------- Move Pain ----------
	Location[] move = new Location[] {
			new Location(51400, -54400, -3151), new Location(51500, -54400, -3151),
			new Location(51600, -54400, -3151), new Location(51700, -54400, -3151),
			new Location(51800, -54400, -3151), new Location(51900, -54400, -3151),
			new Location(52000, -54400, -3151), new Location(52100, -54400, -3151),
			new Location(52200, -54400, -3158), new Location(52200, -54300, -3158),
			new Location(52200, -54200, -3158), new Location(52200, -54100, -3158),
			new Location(52200, -54000, -3158), new Location(52200, -53900, -3158),
			new Location(52200, -53800, -3158), new Location(52200, -53700, -3158),
			new Location(52200, -53600, -3158), new Location(52200, -53500, -3158),
			new Location(52200, -53400, -3158), new Location(52200, -53300, -3158),
			new Location(52200, -53200, -3158), new Location(52200, -53100, -3158),
			new Location(52200, -53000, -3158), new Location(52200, -52900, -3158),
			new Location(52200, -52800, -3158), new Location(52200, -52700, -3158),
			new Location(52200, -52600, -3158), new Location(52200, -52500, -3158),
			new Location(52200, -52400, -3101), new Location(52100, -52400, -3100),
			new Location(52100, -52300, -3100), new Location(52100, -52200, -3100),
			new Location(52100, -52100, -3100), new Location(52100, -52000, -3086),
			new Location(52100, -51900, -3086), new Location(52100, -51800, -3086),
			new Location(52100, -51700, -3095), new Location(52000, -51700, -3095),
			new Location(51900, -51700, -3095), new Location(51800, -51700, -3100),
			new Location(51800, -51600, -3100), new Location(51800, -51500, -3102) };

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 021: Hidden Truth");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _021_HiddenTruth()
	{
		super(21, "_021_HiddenTruth", "Hidden Truth", false);
		setInitialState(CREATED);
		addStartNpc(MysteriousWizard);

		addTalkId(MysteriousWizard);
		addTalkId(MysteriousWizard);
		addTalkId(Tombstone);
		addTalkId(GhostofvonHellmann);
		addTalkId(GhostofvonHellmannsPage);
		addTalkId(BrokenBookshelf);
		addTalkId(Agripel);
		addTalkId(Dominic);
		addTalkId(Benedict);
		addTalkId(Innocentin);

		addTalkId(Innocentin);
		addTalkId(MysteriousWizard);
	}

	private void autochat(L2NpcInstance npc, String text)
	{
		for(L2Player player : npc.getAroundPlayers(600))
			if(player != null)
				player.sendPacket(new CreatureSay(npc.getObjectId(), 0, npc.getName(), text));
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31522-02.htm"))
		{
			st.setState(STARTED);
			st.set("cond", "1");
		}
		else if(event.equalsIgnoreCase("html"))
			htmltext = "31328-05.htm";
		else if(event.equalsIgnoreCase("31328-05.htm"))
		{
			st.unset("cond");
			st.set("onlyone", "1");
			st.setState(COMPLETED);
			st.takeItems(CrossofEinhasad, -1);
			if(st.getQuestItemsCount(CrossofEinhasadNextQuest) == 0)
				st.giveItems(CrossofEinhasadNextQuest, 1);
			st.playSound("ItemSound.quest_finish");
			st.startQuestTimer("html", 1);
			htmltext = "Congratulations! You are completed this quest!<br>The Quest \"Tragedy In Von Hellmann Forest\" become available.<br>Show Cross of Einhasad to High Priest Tifaren.";
		}
		else if(event.equalsIgnoreCase("31523-03.htm"))
		{
			st.playSound("SkillSound5.horror_02");
			st.set("cond", "2");
			st.getPcSpawn().addSpawn(GhostofvonHellmann, 51432, -54570, -3136, 120000);
		}
		else if(event.equalsIgnoreCase("31524-06.htm"))
		{
			st.set("cond", "3");
			Location loc = move[st.getInt("move")];
			st.getPcSpawn().addSpawn(GhostofvonHellmannsPage, loc.x, loc.y, loc.z);
		}
		else if(event.equalsIgnoreCase("31526-03.htm"))
			st.playSound("ItemSound.item_drop_equip_armor_cloth");
		else if(event.equalsIgnoreCase("31526-08.htm"))
		{
			st.playSound("AmdSound.ed_chimes_05");
			st.set("cond", "5");
		}
		else if(event.equalsIgnoreCase("31526-14.htm"))
		{
			st.giveItems(CrossofEinhasad, 1);
			st.set("cond", "6");
		}
		else if(event.startsWith("checkMove"))
		{
			L2Spawn spawn = st.getPcSpawn().getSpawn(GhostofvonHellmannsPage);
			if(spawn != null)
			{
				L2NpcInstance npc = spawn.getLastSpawn();
				if(npc.isMoving)
				{
					st.startQuestTimer("checkMove" + st.getInt("i") + 1, 300);
					st.set("i", "" + st.getInt("i") + 1);
				}
				else
				{
					int Move = st.getInt("move") + 1;
					st.set("move", "" + Move);
					if(Move >= 0 && Move <= 41)
					{
						Location loc = move[Move];
						npc.moveToLocation(loc.x, loc.y, loc.z, 0, false);
						st.startQuestTimer("checkMove" + st.getInt("i") + 1, 300);
						st.set("i", "" + st.getInt("i") + 1);
						if(Rnd.chance(10))
							autochat(npc, st.getPlayer().getName() + NPCtext[Rnd.get(3)]);
					}
					else
					{
						autochat(npc, st.getPlayer().getName() + NPCtext[2]);
						st.startQuestTimer("checkMove" + st.getInt("i") + 1, 10000);
					}
				}
			}
			return null;
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "This person inaccessible and does not want with you to talk!<br>Are they please returned later...";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		int onlyone = st.getInt("onlyone");
		int id = st.getInt("id");

		if(npcId == MysteriousWizard && onlyone == 0)
		{
			if(cond == 0 && onlyone == 0)
			{
				if(st.getPlayer().getLevel() >= 63)
					htmltext = "31522-01.htm";
				else
				{
					htmltext = "31522-03.htm";
					st.exitCurrentQuest(true);
				}
			}
			else if(cond == 0 && onlyone == 1)
				htmltext = "This quest have already been completed.";
			else if(cond == 1)
				htmltext = "31522-05.htm";
		}
		else if(npcId == Tombstone && onlyone == 0)
		{
			if(cond == 1)
				htmltext = "31523-01.htm";
			else if(cond == 2 || cond == 3)
			{
				htmltext = "31523-04.htm";
				st.playSound("SkillSound5.horror_02");
				if(st.getPcSpawn().getSpawn(GhostofvonHellmann) == null)
					st.getPcSpawn().addSpawn(GhostofvonHellmann, 51432, -54570, -3136, 120000);
			}
		}
		else if(npcId == GhostofvonHellmann && onlyone == 0)
		{
			if(cond == 2)
				htmltext = "31524-01.htm";
			else if(cond == 3)
				htmltext = "31524-07b.htm";
			else if(cond == 4)
				htmltext = "31524-07c.htm";
		}
		else if(npcId == GhostofvonHellmannsPage && onlyone == 0)
		{
			if(cond == 3)
			{
				htmltext = "31525-01.htm";
				L2Spawn spawn = st.getPcSpawn().getSpawn(GhostofvonHellmannsPage);
				if(spawn != null && spawn == npc.getSpawn())
					if(npc.isMoving)
					{
						int i = st.getInt("i") + 1;
						st.startQuestTimer("checkMove" + i, 300);
						st.set("i", "" + i);
					}
					else
					{
						int Move = st.getInt("move") + 1;
						st.set("move", "" + Move);
						if(Move >= 0 && Move <= 41)
						{
							Location loc = move[Move];
							npc.moveToLocation(loc.x, loc.y, loc.z, 0, false);
							String text = st.getPlayer().getName() + NPCtext[0];
							autochat(npc, text);
							st.startQuestTimer("checkMove" + st.getInt("i") + 1, 300);
							st.set("i", "" + st.getInt("i") + 1);
						}
						else
						{
							st.set("cond", "4");
							htmltext = "31525-02.htm";
							st.unset("move");
							if(st.getQuestTimer("checkMove" + st.getInt("i")) != null)
								st.getQuestTimer("checkMove" + st.getInt("i")).cancel();
							st.unset("i");
							st.getPcSpawn().removeAllSpawn();
						}
					}
			}
			else if(cond == 4)
			{
				htmltext = "31525-02.htm";
				st.unset("move");
				st.unset("i");
				st.getPcSpawn().removeAllSpawn();
			}
		}
		else if(npcId == BrokenBookshelf && onlyone == 0)
		{
			if(cond == 4)
			{
				st.set("cond", "5");
				htmltext = "31526-01.htm";
			}
			else if(cond == 5)
			{
				if(id == 0)
				{
					htmltext = "31526-10.htm";
					st.playSound("AmdSound.ed_chimes_05");
				}
				else if(id == 1)
					htmltext = "31526-11.htm";
			}
			else if(cond == 6)
				htmltext = "31526-15.htm";
		}
		else if(npcId == Agripel && onlyone == 0 && st.getQuestItemsCount(CrossofEinhasad) >= 1)
		{
			if(cond == 6)
			{
				int n = Rnd.get(3);
				htmltext = "31348-0" + n + ".htm";
				if(id > 1 && id < 4)
					id = id + 1;
				else if(id >= 5)
				{
					htmltext = "31348-02.htm";
					st.unset("id");
					st.set("cond", "7");
				}
			}
			else if(cond == 7)
				htmltext = "31348-03.htm";
		}
		else if(npcId == Dominic && st.getQuestItemsCount(CrossofEinhasad) >= 1)
		{
			if(cond == 6)
			{
				int n = Rnd.get(3);
				htmltext = "31350-0" + n + ".htm";
				if(id < 2)
					id = id + 2;
				else if(id >= 4)
				{
					htmltext = "31350-02.htm";
					st.unset("id");
					st.set("cond", "7");
				}
			}
			else if(cond == 7)
				htmltext = "31350-03.htm";
		}
		else if(npcId == Benedict && st.getQuestItemsCount(CrossofEinhasad) >= 1)
		{
			if(cond == 6)
			{
				int n = Rnd.get(3);
				htmltext = "31349-0" + n + ".htm";
				st.set("cond", "7");
				if(id != 3 && id < 5)
					id = id + 3;
				else if(id > 3)
				{
					htmltext = "31349-02.htm";
					st.unset("id");
					st.set("cond", "7");
				}
			}
			else if(cond == 7)
				htmltext = "31349-03.htm";
		}
		else if(npcId == Innocentin)
			if(cond == 7 && onlyone == 0)
			{
				if(st.getQuestItemsCount(CrossofEinhasad) != 0)
					htmltext = "31328-01.htm";
			}
			else if(cond == 0 && onlyone == 1)
				htmltext = "31328-06.htm";
		return htmltext;
	}
}