package quests._072_SagaOfTheSwordMuse;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.game.tables.SkillTable;

public class _072_SagaOfTheSwordMuse extends Quest implements ScriptFile
{
	//NPC

	public final int START = 30853;
	public final int NPC1 = 31583;
	public final int DONATH = 31624;
	public final int TABLET_1 = 31646;
	public final int TABLET_2 = 31649;
	public final int TABLET_3 = 31652;
	public final int TABLET_4 = 31654;
	public final int TABLET_5 = 31655;
	public final int TABLET_6 = 31659;
	public final int DIVINE_STONE_MOB = 31537;
	public final int ARCHON_NPC = 31281;
	public final int NPC_TABLET6 = 31618;

	//Mobs
	public final int FORBIDDEN_KNOWLEDGE = 27216;
	public final int KILL_TABL3 = 27288;
	public final int ARCHON_MOB = 27221;
	public final int FINAL_KILL = 27280;

	//Item
	public final int BOOK1 = 7095;
	public final int BOOK2 = 6622;
	public final int ICE_CRYSTAL = 7080;
	public final int FAT_WHITE_FISH = 6482;
	public final int BITTER_COLD_BEER = 7536;
	public final int RESONANCE_AMULET_1 = 7270;
	public final int RESONANCE_AMULET_2 = 7301;
	public final int RESONANCE_AMULET_3 = 7332;
	public final int RESONANCE_AMULET_4 = 7363;
	public final int RESONANCE_AMULET_5 = 7394;
	public final int RESONANCE_AMULET_6 = 7425;
	public final int DIVINE_STONE_OF_WISDOM = 7081;
	public final int HALISHA_MARK = 7487;
	public final int ADEN = 57;

	//Chance
	public final int DROP_CHANCE = 100;

	boolean True = true;
	short newclass = 100;

	//Main
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 72 Saga Of The Sword Muse");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _072_SagaOfTheSwordMuse()
	{
		super(72, "_072_SagaOfTheSwordMuse", "Saga Of The Sword Muse", false);
		setInitialState(CREATED);
		addStartNpc(START);
		addTalkId(START);
		addTalkId(START);
		addTalkId(NPC1);
		addTalkId(DONATH);
		addTalkId(TABLET_1);
		addTalkId(TABLET_2);
		addTalkId(TABLET_3);
		addTalkId(DIVINE_STONE_MOB);
		addTalkId(TABLET_4);
		addTalkId(ARCHON_NPC);
		addTalkId(TABLET_5);
		addTalkId(TABLET_6);
		addTalkId(NPC_TABLET6);

		///
		addAttackId(KILL_TABL3);
		addAttackId(FINAL_KILL);

		addKillId(FORBIDDEN_KNOWLEDGE);
		addKillId(KILL_TABL3);
		for(int i = 21646; i <= 21652; i++)
		{
			addKillId(i);
			STARTED.addQuestDrop(i, HALISHA_MARK, 1);
		}

		addKillId(ARCHON_MOB);
		addKillId(FINAL_KILL);

		STARTED.addQuestDrop(FORBIDDEN_KNOWLEDGE, RESONANCE_AMULET_2, 1);
		STARTED.addQuestDrop(KILL_TABL3, RESONANCE_AMULET_3, 1);
		STARTED.addQuestDrop(ARCHON_MOB, RESONANCE_AMULET_5, 1);

	}

	////

	/*	
		public boolean checkIngr(QuestState st)
		{
			if ((BOOK1==1)&& (st.getPlayer().getLevel()>= 76))
			{
				st.set("cond", "20");
				return true;
			}
			st.set("cond", "19");
			return false;
			
			if(st.getQuestItemsCount(AMBER_SCALE_ID) == 1 && st.getQuestItemsCount(WIND_SOULSTONE_ID) == 1 && st.getQuestItemsCount(GLASS_EYE_ID) == 1 && st.getQuestItemsCount(HORROR_ECTOPLASM_ID) == 1 && st.getQuestItemsCount(SILENOS_HORN_ID) == 1 && st.getQuestItemsCount(ANT_SOLDIER_APHID_ID) == 1 && st.getQuestItemsCount(TYRANTS_CHITIN_ID) == 1 && st.getQuestItemsCount(BUGBEAR_BLOOD_ID) == 1)
			{
				st.set("cond", "4");
				return true;
			}
			st.set("cond", "3");
			return false;
		}
	*/
	@Override
	public String onEvent(String event, QuestState st)
	{
		int timer = st.getInt("timer");
		int cond = st.getInt("cond");
		int kill = st.getInt("kill");
		String htmltext = event;
		if(event.equalsIgnoreCase("30853-05.htm"))
			return htmltext;
		if(event.equalsIgnoreCase("30853-03.htm"))
		{
			st.setState(STARTED);
			st.giveItems(BOOK1, 1);
			st.set("cond", "1");
			st.set("kill", "0");
			st.playSound("ItemSound.quest_accept");

		}
		//NPC1         
		if(event.equalsIgnoreCase("31583-05.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "2");
		}
		if(event.equalsIgnoreCase("31583-06.htm"))
		{
			st.set("cond", "5");
			st.playSound("ItemSound.quest_middle");
			st.takeItems(BITTER_COLD_BEER, 1);
			st.giveItems(RESONANCE_AMULET_1, 1);
		}
		//DONATH
		if(event.equalsIgnoreCase("31624-05.htm"))
		{
			st.set("cond", "3");
			st.playSound("ItemSound.quest_middle");
		}
		if(event.equalsIgnoreCase("31624-06.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "4");
			st.takeItems(FAT_WHITE_FISH, 1);
			st.takeItems(ICE_CRYSTAL, 1);
			st.giveItems(BITTER_COLD_BEER, 1);
		}
		//Tablet1        
		if(event.equalsIgnoreCase("31646-02.htm"))
		{
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), True);
			st.set("cond", "6");
			st.playSound("ItemSound.quest_middle");
			st.takeItems(RESONANCE_AMULET_1, 1);
		}
		//Tablet2        
		if(event.equalsIgnoreCase("31649-03.htm"))
		{
			st.set("cond", "8");
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), True);
			st.playSound("ItemSound.quest_middle");
			st.takeItems(RESONANCE_AMULET_2, 1);
		}
		//Tablet3          
		if(event.equalsIgnoreCase("tablet3_1"))
			if(st.getPcSpawn().isSpawnExists(KILL_TABL3) != True)
			{
				htmltext = "31652-02.htm";
				st.set("cond", "9");
				st.set("timer", "0");
				st.set("kill", "1");
				st.getPcSpawn().getSpawn(st.getPcSpawn().addSpawn(KILL_TABL3, 161719, -92823, -1893, 300000)).getLastSpawn().addDamageHate(st.getPlayer(), 1, 100);
				st.startQuestTimer("chat_timer", 500);
			}
			else if(kill == 1)
				htmltext = "31652-03.htm";
			else
				htmltext = "31652-04.htm";
		if(event.equalsIgnoreCase("31652-06.htm"))
		{
			st.set("cond", "10");
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), True);
			st.set("timer", "0");
			st.set("kill", "0");
			st.playSound("ItemSound.quest_middle");
			st.takeItems(RESONANCE_AMULET_3, 1);
		}
		//DIVINE STONE OF WISDOM        
		if(event.equalsIgnoreCase("31537-07.htm"))
			return htmltext;
		if(event.equalsIgnoreCase("31537-02.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "11");
		}
		if(event.equalsIgnoreCase("31537-03.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "12");
		}
		if(event.equalsIgnoreCase("31537-08.htm"))
		{
			st.set("cond", "13");
			st.playSound("ItemSound.quest_middle");
			st.takeItems(DIVINE_STONE_OF_WISDOM, 1);
			st.giveItems(RESONANCE_AMULET_4, 1);
		}

		//Tablet4
		if(event.equalsIgnoreCase("31654-02.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), True);
			st.set("cond", "14");
			st.takeItems(RESONANCE_AMULET_4, 1);
		}

		//ARCHON NPC  
		if(event.equalsIgnoreCase("31281-03.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "15");
		}

		//Tablet5                    
		if(event.equalsIgnoreCase("31655-03.htm"))
		{
			st.set("cond", "17");
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), True);
			st.playSound("ItemSound.quest_middle");
			st.takeItems(RESONANCE_AMULET_5, 1);
		}

		//Tablet6         
		if(event.equalsIgnoreCase("tablet_6_1"))
			if(st.getPcSpawn().isSpawnExists(NPC_TABLET6) != true)
			{
				htmltext = "31659-02.htm";
				st.getPcSpawn().addSpawn(NPC_TABLET6, 124376, 82127, -2796, 300000);
				st.getPcSpawn().addSpawn(FINAL_KILL, 124355, 82155, -2803, 300000);
				st.set("cond", "17");
				st.set("kill", "1");
				st.set("timer", "0");
				st.startQuestTimer("unspawn_timer", 60000);
				st.startQuestTimer("chat_timer", 500);
			}
			else
				htmltext = "31659-03.htm";
		if(event.equalsIgnoreCase("31659-06.htm"))
		{
			st.set("cond", "19");
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), True);
			st.playSound("ItemSound.quest_middle");
			st.takeItems(RESONANCE_AMULET_6, 1);
		}
		//NPC TABLET 6
		if(event.equalsIgnoreCase("complite"))
		{
			st.giveItems(RESONANCE_AMULET_6, 1);
			st.playSound("ItemSound.quest_middle");
			st.getPlayer().sendMessage("Moonvoice Airin: the song is and the sound Is sings together Do not forget oh...");
			st.getPcSpawn().removeAllSpawn();
			st.set("timer", "0");
			st.set("kill", "0");
			return "";
		}
		if(event.equalsIgnoreCase("31618-10.htm"))
			return htmltext;

		//Finall       
		if(event.equalsIgnoreCase("30853-06.htm"))
			return htmltext;
		if(event.equalsIgnoreCase("finish"))
			if(st.getPlayer().getLevel() >= 76)
			{
				st.addExpAndSp(2299404, 0);
				htmltext = "30853-09.htm";
				st.getPlayer().doCast(SkillTable.getInstance().getInfo(4339, 1), st.getPlayer(), True);
				st.takeItems(BOOK1, 1);
				st.giveItems(ADEN, 5000000);
				st.giveItems(BOOK2, 1);
				st.getPlayer().setClassId(newclass, True);
				st.exitCurrentQuest(True);
				st.set("cond", "0");
				st.setState(COMPLETED);
			}
			else
			{
				st.set("cond", "20");
				st.playSound("ItemSound.quest_middle");
				st.takeItems(BOOK1, 1);
				htmltext = "30853-08.htm";
			}
		if(event.equalsIgnoreCase("chat_timer"))
		{
			if(cond == 9)
			{
				if(timer == 0)
				{
					st.getPlayer().sendMessage("Sword Player Baiel: " + st.getPlayer().getName() + "s, best listens attentively to my singing sound.");
					st.set("timer", "1");
					st.getQuestTimer("chat_timer").cancel();
					st.startQuestTimer("chat_timer", 290000);
					return "";
				}
				st.getPlayer().sendMessage("Sword Player Baiel: hey, to conclusion time The money has not received.");
				return "";
			}
			if(cond == 17)
			{
				if(timer == 0)
				{
					st.set("timer", "1");
					st.getQuestTimer("chat_timer").cancel();
					st.getPlayer().sendMessage("Fallen Angel Narsis: sings All people can conquer by yours singing sound.");
					st.getPlayer().sendMessage("Moonvoice Airin: had found, cannot let off! West the devil natrium forces Si!");
					st.startQuestTimer("chat_timer", 1500);
					return "";
				}
				if(timer == 1)
				{
					st.set("timer", "2");
					st.getPlayer().sendMessage("Moonvoice Airin: attack. Inadequate? " + st.getPlayer().getName() + "s! Helps me!");
					st.startQuestTimer("chat_timer", 10000);
					return "";
				}
				if(timer == 2)
				{
					st.set("timer", "3");
					st.getPlayer().sendMessage("Moonvoice Airin: sings " + st.getPlayer().getName() + "s together! Did not consider audience's singing sound, sang also is sings in vain!");
					st.startQuestTimer("chat_timer", 13000);
					return "";
				}
				if(timer == 3)
				{
					if(kill > 1 && kill < 15)
					{
						st.getPlayer().sendMessage("Moonvoice Airin: refuels! " + st.getPlayer().getName() + "s, diligently could win again!");
						return "";
					}
					if(kill == 1)
					{
						st.startQuestTimer("chat_timer", 13000);
						return "";
					}
				}
				return "";
			}
		}

		if(event.equalsIgnoreCase("unspawn_timer"))
		{
			if(kill != 1)
			{
				st.getQuestTimer("unspawn_timer").cancel();
				return "";
			}
			st.getPlayer().sendMessage("Fallen Angel Narsis: you do not have qualifications to accept my blessing.");
			st.getPlayer().sendMessage("Moonvoice Airin: my singing sound had ended Also arrived the time which I left.");
			st.getPcSpawn().removeAllSpawn();
			return "";
		}
		return htmltext;

	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><head><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int kill = st.getInt("kill");
		int cond = st.getInt("cond");
		if(cond == 0)
			if(npcId == START && id == COMPLETED)
				htmltext = "<html><head><body>You have already complete this quest.</body></html>";
			else if(st.getPlayer().getClassId().getId() == 21 && st.getPlayer().getLevel() >= 76)
				htmltext = "30853-01.htm";
			else
			{
				htmltext = "30853-02.htm";
				st.exitCurrentQuest(True);
			}
		if(cond == 1)
		{
			if(npcId == START)
				htmltext = "30853-04.htm";
			if(npcId == NPC1)
				htmltext = "31583-01.htm";
		}
		if(cond >= 2 && cond <= 4)
		{
			if(npcId == NPC1)
				if(st.getQuestItemsCount(BITTER_COLD_BEER) == 0)
					htmltext = "31583-02.htm";
				else
					htmltext = "31583-03.htm";
			if(npcId == DONATH)
			{
				if(cond == 2)
					htmltext = "31624-01.htm";
				if(cond == 3)
					if(npcId == DONATH && st.getQuestItemsCount(ICE_CRYSTAL) >= 1 && st.getQuestItemsCount(FAT_WHITE_FISH) >= 1)
						htmltext = "31624-03.htm";
					else
						htmltext = "31624-02.htm";
				if(cond == 4)
					htmltext = "31624-04.htm";
			}
		}
		if(cond == 5)
		{
			if(npcId == NPC1)
				htmltext = "31583-04.htm";
			if(npcId == TABLET_1 && st.getQuestItemsCount(RESONANCE_AMULET_1) >= 1)
				htmltext = "31646-01.htm";
		}
		if(cond == 6)
		{
			if(npcId == TABLET_1)
				htmltext = "31646-03.htm";
			if(npcId == TABLET_2 && st.getQuestItemsCount(RESONANCE_AMULET_2) == 0)
				htmltext = "31649-01.htm";
		}
		if(cond == 7)
			if(npcId == TABLET_2 && st.getQuestItemsCount(RESONANCE_AMULET_2) == 1)
				htmltext = "31649-02.htm";
		if(cond == 8 || cond == 9)
		{
			if(npcId == TABLET_2)
				htmltext = "31649-04.htm";
			if(npcId == TABLET_3)
				if(st.getQuestItemsCount(RESONANCE_AMULET_3) == 0)
					htmltext = "31652-01.htm";
				else
					htmltext = "31652-05.htm";
		}
		if(cond == 10)
		{
			if(npcId == TABLET_3)
				htmltext = "31652-07.htm";
			if(npcId == DIVINE_STONE_MOB)
				htmltext = "31537-01.htm";
		}
		if(cond == 11 || cond == 12)
			if(npcId == DIVINE_STONE_MOB)
				if(st.getQuestItemsCount(DIVINE_STONE_OF_WISDOM) == 0)
					htmltext = "31537-04.htm";
				else
					htmltext = "31537-05.htm";
		if(cond == 13)
		{
			if(npcId == DIVINE_STONE_MOB)
				htmltext = "31537-06.htm";
			if(npcId == TABLET_4 && st.getQuestItemsCount(RESONANCE_AMULET_4) == 1)
				htmltext = "31654-01.htm";
		}
		if(cond == 14)
		{
			if(npcId == TABLET_4)
				htmltext = "31654-03.htm";
			if(npcId == ARCHON_NPC)
				htmltext = "31281-01.htm";
		}
		if(cond == 15)
		{
			if(npcId == ARCHON_NPC)
				htmltext = "31281-02.htm";
			if(npcId == TABLET_5)
				htmltext = "31655-01.htm";
		}
		if(cond == 16)
			if(npcId == TABLET_5 && st.getQuestItemsCount(RESONANCE_AMULET_5) == 1)
				htmltext = "31655-02.htm";
		if(cond == 17 || cond == 18)
		{
			if(npcId == TABLET_5)
				htmltext = "31655-04.htm";
			if(npcId == TABLET_6)
				if(st.getQuestItemsCount(RESONANCE_AMULET_6) == 0)
					htmltext = "31659-01.htm";
				else
					htmltext = "31659-05.htm";
			if(npcId == NPC_TABLET6)
				if(kill > 0)
					htmltext = "31618-04.htm";
				else
					htmltext = "31618-06.htm";
		}
		if(cond == 19)
		{
			if(npcId == TABLET_6)
				htmltext = "31659-07.htm";
			if(npcId == START)
				htmltext = "30853-06.htm";
		}
		if(cond == 20)
			if(npcId == START)
				if(st.getPlayer().getLevel() >= 76)
				{
					st.addExpAndSp(2299404, 0);
					st.getPlayer().doCast(SkillTable.getInstance().getInfo(4339, 1), st.getPlayer(), True);
					//st.getPlayer().doCast(SkillTable.getInstance().getInfo(4339,1),st.getPlayer());
					st.giveItems(ADEN, 5000000);
					st.giveItems(BOOK2, 1);
					st.getPlayer().setClassId(newclass, True);
					st.set("cond", "0");
					st.set("kill", "0");
					htmltext = "30853-09.htm";
					st.setState(COMPLETED);
				}
				else
					htmltext = "30853-10.htm";
		return htmltext;
	}

	@Override
	public String onAttack(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		int kill = st.getInt("kill");
		if(npcId == KILL_TABL3)
			st.set("kill", "2");
		if(npcId == FINAL_KILL && cond == 17)
			if(kill <= 15)
			{
				st.set("kill", Integer.toString(kill + 1));
				if(kill == 15)
					st.getPlayer().sendMessage("Fallen Angel Narsis: " + st.getPlayer().getName() + "s? Also rejects my blessing including you?");
			}
			else
			{
				st.getPlayer().sendMessage("Fallen Angel Narsis: .. " + st.getPlayer().getName() + "s why, why.... can all people eulogize you...");
				st.set("cond", "18");
				st.set("kill", "0");
				st.getPcSpawn().removeSpawn(FINAL_KILL);
			}
		return "";
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int kill = st.getInt("kill");
		int cond = st.getInt("cond");
		int npcId = npc.getNpcId();
		if(npcId == FORBIDDEN_KNOWLEDGE)
			if(cond >= 6 && cond < 8 && st.getQuestItemsCount(RESONANCE_AMULET_2) == 0)
				if(kill > 8)
				{
					st.playSound("ItemSound.quest_middle");
					st.giveItems(RESONANCE_AMULET_2, 1);
					st.set("kill", "0");
					st.set("cond", "7");
				}
				else
					st.set("kill", Integer.toString(kill + 1));
		if(npcId == KILL_TABL3)
			if(cond == 9 && st.getQuestItemsCount(RESONANCE_AMULET_3) == 0)
			{
				st.giveItems(RESONANCE_AMULET_3, 1);
				st.getPlayer().sendMessage("Sword Player Baiel: .. My stage...!");
				st.playSound("ItemSound.quest_middle");
			}
		if(npcId == 21646 || npcId == 21647 || npcId == 21648 || npcId == 21649 || npcId == 21650 || npcId == 21651 || npcId == 21652)
			if(st.getPcSpawn().isSpawnExists(ARCHON_MOB) != True)
				if(cond == 15 && st.getQuestItemsCount(HALISHA_MARK) < 700)
				{
					st.giveItems(HALISHA_MARK, 1);
					if(st.getQuestItemsCount(HALISHA_MARK) >= 700)
					{
						st.playSound("Itemsound.quest_before_battle");
						st.getPcSpawn().getSpawn(st.getPcSpawn().addSpawn(ARCHON_MOB, 600000)).getLastSpawn().addDamageHate(st.getPlayer(), 1, 100);
						st.takeItems(HALISHA_MARK, 20);
					}
					else
						st.playSound("ItemSound.quest_itemget");
				}
		if(npcId == ARCHON_MOB)
			if(cond == 15 && st.getQuestItemsCount(RESONANCE_AMULET_5) == 0)
			{
				st.set("cond", "16");
				st.playSound("ItemSound.quest_middle");
				st.getPlayer().sendMessage("Archon of Halisha: the present, my soul extricates from millennium fetter, returns the Harry summer side...");
				st.takeItems(HALISHA_MARK, 700);
				st.giveItems(RESONANCE_AMULET_5, 1);
			}
		if(npcId == FINAL_KILL)
			if(cond == 17)
			{
				st.getPlayer().sendMessage("Fallen Angel Narsis: .. " + st.getPlayer().getName() + "s why, why.... can all people eulogize you...");
				st.set("cond", "18");
				st.set("kill", "0");
			}
		return "";
	}
}