package quests._082_SagaoftheSagittarius;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.game.tables.SkillTable;
import L2jFT.util.Rnd;

public class _082_SagaoftheSagittarius extends Quest implements ScriptFile
{
	static int SPAWNED = 0;
	//NPC

	public final int ICE_CRYSTAL_ID = 7080;
	public final int ICECREAM_ID = 7520;
	public final int RESONANCE_AMULET_1_ID = 7280;
	public final int RESONANCE_AMULET_2_ID = 7311;
	public final int RESONANCE_AMULET_3_ID = 7342;
	public final int RESONANCE_AMULET_4_ID = 7373;
	public final int RESONANCE_AMULET_5_ID = 7404;
	public final int RESONANCE_AMULET_6_ID = 7435;
	public final int DIVINE_STONE_OF_WISDOM_ID = 7081;
	public final int HALISHA_MARK_ID = 7513;
	public final int ADEN_ID = 57;
	public final int BOOK_ID = 6622;

	//NPC
	public final int Bernard = 30702;//(7702)
	public final int Grimst = 31604; //(8604) 
	public final int Mist = 31627; //(8627)
	public final int Winter_Hunter_Kadyth = 31633; //(8633)
	public final int Pilgrim_of_Darkness1 = 31640;//(8640)
	public final int Pilgrim_of_Darkness2 = 31641;//(8641)
	public final int Tablet_of_Vision1 = 31646;//(8646)
	public final int Tablet_of_Vision2 = 31647;//(8647)
	public final int Tablet_of_Vision3 = 31650;//(8650)
	public final int Tablet_of_Vision4 = 31654;//(8654)
	public final int Tablet_of_Vision5 = 31655;//(8655)
	public final int Tablet_of_Vision6 = 31657;//(8657)

	//Main
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 82 Saga of the Sagittarius");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public int getSPAWNED()
	{
		return SPAWNED;
	}

	public void setSPAWNED(int val)
	{
		SPAWNED = val;
	}

	public _082_SagaoftheSagittarius()
	{
		super(82, "_082_SagaoftheSagittarius", "Saga of the Sagittarius", false);
		setInitialState(CREATED);
		//First NPC
		addStartNpc(30702);
		addTalkId(30702);
		//Second NPC
		addTalkId(31604);

		addTalkId(31627);
		//Tablet 1
		addTalkId(31646);
		//Tablet 2
		addTalkId(31647);
		//Tablet 3
		addTalkId(31650);
		//Pilgrim of Darkness - 1
		addTalkId(31640);
		//Tablet 4
		addTalkId(31654);
		//Pilgrim of Darkness - 2
		addTalkId(31641);
		//Tablet 5
		addTalkId(31655);
		//Tablet 6
		addTalkId(31657);
		//Kadyth
		addTalkId(31633);

		addKillId(27214);
		addKillId(27296);
		addKillId(21646);
		addKillId(21647);
		addKillId(21648);
		addKillId(21649);
		addKillId(21650);
		addKillId(21651);
		addKillId(27247);
		addKillId(27302);

		STARTED.addQuestDrop(27214, RESONANCE_AMULET_2_ID, 1);
		STARTED.addQuestDrop(27270, RESONANCE_AMULET_3_ID, 1);
		STARTED.addQuestDrop(27247, RESONANCE_AMULET_5_ID, 1);

		for(int i = 21646; i <= 21652; i++)
		{
			addKillId(i);
			STARTED.addQuestDrop(i, HALISHA_MARK_ID, 1);
		}
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		//	Bernard
		if(event.equalsIgnoreCase("30702-03.htm"))
			if(st.getPlayer().getClassId().getId() == 9 && st.getPlayer().getLevel() >= 76)
			{
				st.set("id", "1");
				st.set("cond", "1");
				st.set("count", "0");
				st.playSound("ItemSound.quest_accept");
				st.setState(STARTED);
			}
		if(event.equalsIgnoreCase("31604-05.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "2");
		}
		else if(event.equalsIgnoreCase("31604-06.htm"))
		{
			st.set("cond", "5");
			st.playSound("ItemSound.quest_middle");
			st.takeItems(ICECREAM_ID, 1);
			st.giveItems(RESONANCE_AMULET_1_ID, 1);
		}
		else if(event.equalsIgnoreCase("31627-05.htm"))
			st.set("cond", "3");
		else if(event.equalsIgnoreCase("31627-04.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "4");
			st.takeItems(ICE_CRYSTAL_ID, 1);
			st.giveItems(ICECREAM_ID, 1);
		}
		//Tablet1        
		else if(event.equalsIgnoreCase("31646-02.htm"))
		{
			st.set("cond", "6");
			st.playSound("ItemSound.quest_middle");
			st.takeItems(RESONANCE_AMULET_1_ID, 1);
		}
		//Tablet2        
		else if(event.equalsIgnoreCase("31647-03.htm"))
		{
			st.set("cond", "8");
			st.playSound("ItemSound.quest_middle");
			st.takeItems(RESONANCE_AMULET_2_ID, 1);
		}
		//Tablet3          
		else if(event.equalsIgnoreCase("31650-02.htm"))
		{
			st.set("cond", "9");
			st.getPlayer().sendMessage("Prepare to die, Hawkeye....");
			st.getPcSpawn().getSpawn(st.getPcSpawn().addSpawn(27296, 191057, -40550, -3052)).getLastSpawn().addDamageHate(st.getPlayer(), 1, 100);
			setSPAWNED(1);
			st.startQuestTimer("chat_timer", 500);
			st.startQuestTimer("despawn_timer", 300000);
			st.playSound("Itemsound.quest_before_battle");
		}

		else if(event.equalsIgnoreCase("31650-06.htm"))
		{
			st.set("cond", "10");
			st.playSound("ItemSound.quest_middle");
			st.takeItems(RESONANCE_AMULET_3_ID, 1);
		}

		//Pilgrim of Darknes
		else if(event.equalsIgnoreCase("31640-03.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "11");
		}
		else if(event.equalsIgnoreCase("31640-04.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "12");
		}
		else if(event.equalsIgnoreCase("31640-08.htm"))
		{
			st.set("cond", "13");
			st.playSound("ItemSound.quest_middle");
			st.takeItems(DIVINE_STONE_OF_WISDOM_ID, 1);
			st.giveItems(RESONANCE_AMULET_4_ID, 1);
		}
		//4 Tablet    
		else if(event.equalsIgnoreCase("31654-02.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "14");
			st.takeItems(RESONANCE_AMULET_4_ID, 1);
		}
		//Pilgrim Darknes 2
		else if(event.equalsIgnoreCase("31641-02.htm"))
		{
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "15");
		}
		//5 Tablet          
		else if(event.equalsIgnoreCase("31655-03.htm"))
		{
			st.set("cond", "17");
			st.playSound("ItemSound.quest_middle");
			st.takeItems(RESONANCE_AMULET_5_ID, 1);
		}
		//6 Tablet         
		else if(event.equalsIgnoreCase("31657-02.htm"))
		{
			st.getPcSpawn().removeAllSpawn();
			st.getPcSpawn().addSpawn(31633, 46058, -36802, -1680);
			st.getPcSpawn().addSpawn(27302, 46258, -37172, -1676);
			st.playSound("Itemsound.quest_before_battle");
			st.set("cond", "18");
		}
		else if(event.equalsIgnoreCase("31633-10.htm"))
		{
			st.giveItems(RESONANCE_AMULET_6_ID, 1);
			st.playSound("ItemSound.quest_middle");
			st.set("id", "0");
		}
		else if(event.equalsIgnoreCase("31657-06.htm"))
		{
			if(st.getQuestItemsCount(RESONANCE_AMULET_6_ID) == 1)
			{
				st.getPcSpawn().removeAllSpawn();
				st.playSound("ItemSound.quest_middle");
				st.takeItems(RESONANCE_AMULET_6_ID, 1);
				st.set("cond", "19");
			}
			else
				return "31657-03.htm";
		}
		else if(event.equalsIgnoreCase("30702-07.htm"))
		{
			short clId = 92;
			st.addExpAndSp(2299404, 0);
			st.giveItems(ADEN_ID, 5000000);
			st.giveItems(BOOK_ID, 1);
			st.getPlayer().setClassId(clId);
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4339, 1), st.getPlayer(), true);
			st.getPlayer().setBaseClass(92);
			st.playSound("ItemSound.quest_fanfare_2");
			st.set("cond", "0");
			st.set("onlyone", "1");
			st.setState(COMPLETED);
		}
		return htmltext;
	}//onEvent

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><head><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		//	Bernard
		if(id.equals(COMPLETED))
		{
			htmltext = "You have been allready copleted this quest!";
			return htmltext;
		}
		if(st.getPlayer().getClassId().getId() == 9 && st.getPlayer().getLevel() >= 76 && id != STARTED)
			htmltext = "30702-01.htm";
		else if(!id.equals(STARTED))
			htmltext = "30702-02.htm";
		////
		if(id.equals(CREATED))
		{
			st.set("cond", "0");
			st.set("id", "0");
			st.set("onlyone", "0");
		}
		if(npcId == Bernard && st.getInt("cond") == 0 && st.getInt("onlyone") == 0)
			htmltext = "30702-01.htm";
		else if(npcId == 30702 && st.getInt("cond") == 1)
			htmltext = "30702-04.htm";
		else if(npcId == 30702 && st.getInt("cond") == 19)
			htmltext = "30702-05.htm";
		//Grimst
		else if(npcId == Grimst && st.getInt("cond") == 1)
			htmltext = "31604-01.htm";
		else if(npcId == Grimst && st.getInt("cond") == 2 && st.getQuestItemsCount(ICECREAM_ID) == 0)
			htmltext = "31604-02.htm";
		else if(npcId == Grimst && st.getInt("cond") == 4 && st.getQuestItemsCount(ICECREAM_ID) == 1)
			htmltext = "31604-03.htm";
		else if(npcId == Grimst && st.getInt("cond") == 5 && st.getQuestItemsCount(RESONANCE_AMULET_1_ID) == 1)
			htmltext = "31604-04.htm";
		//Mist
		else if(npcId == Mist && st.getInt("cond") == 2 && st.getQuestItemsCount(ICE_CRYSTAL_ID) == 0)
			htmltext = "31627-01.htm";
		else if(npcId == Mist && st.getInt("cond") == 3 && st.getQuestItemsCount(ICE_CRYSTAL_ID) == 0)
			htmltext = "31627-02.htm";
		else if(npcId == Mist && st.getInt("cond") == 3 && st.getQuestItemsCount(ICE_CRYSTAL_ID) == 1)
			htmltext = "31627-03.htm";
		else if(npcId == Mist && st.getInt("cond") == 4 && st.getQuestItemsCount(ICECREAM_ID) == 1)
			htmltext = "31627-06.htm";
		//Tablet_of_Vision1	      
		else if(npcId == Tablet_of_Vision1 && st.getInt("cond") == 5 && st.getQuestItemsCount(RESONANCE_AMULET_1_ID) == 1)
			htmltext = "31646-01.htm";
		else if(npcId == Tablet_of_Vision1 && st.getInt("cond") == 6)
			htmltext = "31646-03.htm";
		//Tablet_of_Vision2	      
		else if(npcId == Tablet_of_Vision2 && st.getInt("cond") == 6 && st.getQuestItemsCount(RESONANCE_AMULET_2_ID) == 0)
			htmltext = "31647-01.htm";
		else if(npcId == Tablet_of_Vision2 && st.getInt("cond") == 7 && st.getQuestItemsCount(RESONANCE_AMULET_2_ID) == 1)
			htmltext = "31647-02.htm";
		else if(npcId == Tablet_of_Vision2 && st.getInt("cond") == 8)
			htmltext = "31647-04.htm";
		//Tablet_of_Vision3	      
		else if(npcId == Tablet_of_Vision3 && st.getInt("cond") == 8 && st.getQuestItemsCount(RESONANCE_AMULET_3_ID) == 0)
			htmltext = "31650-01.htm";
		else if(npcId == Tablet_of_Vision3 && st.getInt("cond") == 9 && st.getQuestItemsCount(RESONANCE_AMULET_3_ID) == 0)
		{
			htmltext = "31650-03.htm";
			st.getPcSpawn().removeAllSpawn();
			st.playSound("Itemsound.quest_before_battle");
			st.getPcSpawn().addSpawn(27296);
		}
		else if(npcId == Tablet_of_Vision3 && st.getInt("cond") == 9 && st.getQuestItemsCount(RESONANCE_AMULET_3_ID) == 1)
			htmltext = "31650-05.htm";
		else if(npcId == Tablet_of_Vision3 && st.getInt("cond") == 10)
			htmltext = "31650-07.htm";
		//Pilgrim_of_Darkness1	  
		else if(npcId == Pilgrim_of_Darkness1 && st.getInt("cond") == 10)
			htmltext = "31640-01.htm";
		else if(npcId == Pilgrim_of_Darkness1 && st.getQuestItemsCount(DIVINE_STONE_OF_WISDOM_ID) == 0 && st.getInt("cond") >= 11 && st.getInt("cond") <= 12)
			htmltext = "31640-07.htm";
		else if(npcId == Pilgrim_of_Darkness1 && st.getQuestItemsCount(DIVINE_STONE_OF_WISDOM_ID) == 1 && st.getInt("cond") >= 11 && st.getInt("cond") <= 12)
			htmltext = "31640-05.htm";
		else if(npcId == Pilgrim_of_Darkness1 && st.getInt("cond") == 13)
			htmltext = "31640-06.htm";

		//Tablet 4
		else if(npcId == Tablet_of_Vision4 && st.getInt("cond") == 13 && st.getQuestItemsCount(RESONANCE_AMULET_4_ID) == 1)
			htmltext = "31654-01.htm";
		else if(npcId == Tablet_of_Vision4 && st.getInt("cond") == 14)
			htmltext = "31654-03.htm";
		//Pilgrim Darknes 2
		else if(npcId == Pilgrim_of_Darkness2 && st.getInt("cond") == 14)
			htmltext = "31641-01.htm";
		else if(npcId == Pilgrim_of_Darkness2 && st.getInt("cond") == 15)
			htmltext = "31641-03.htm";
		//Tablet 5
		else if(npcId == Tablet_of_Vision5 && st.getInt("cond") == 15)
			htmltext = "31655-01.htm";
		else if(npcId == Tablet_of_Vision5 && st.getInt("cond") == 16 && st.getQuestItemsCount(RESONANCE_AMULET_5_ID) == 1)
			htmltext = "31655-02.htm";
		else if(npcId == Tablet_of_Vision5 && st.getInt("cond") == 17)
			htmltext = "31655-04.htm";

		//Tablet 6
		else if(npcId == Tablet_of_Vision6 && st.getInt("cond") == 17)
			htmltext = "31657-01.htm";
		else if(npcId == Tablet_of_Vision6 && st.getInt("cond") == 18 && st.getQuestItemsCount(RESONANCE_AMULET_6_ID) == 0 && st.getInt("id") < 10)
		{
			htmltext = "31657-03.htm";
			st.set("cond", "17");
		}
		else if(npcId == Tablet_of_Vision6 && st.getInt("cond") == 18 || st.getInt("cond") == 17 && st.getQuestItemsCount(RESONANCE_AMULET_6_ID) == 1)
			htmltext = "31657-05.htm";
		else if(npcId == Tablet_of_Vision6 && st.getInt("cond") == 19)
			htmltext = "31657-07.htm";
		else if(npcId == Winter_Hunter_Kadyth && st.getQuestItemsCount(RESONANCE_AMULET_6_ID) == 0 && st.getInt("id") == 0)
		{
			htmltext = "31633-01.htm";
			st.set("id", "1");
		}
		else if(npcId == Winter_Hunter_Kadyth && st.getQuestItemsCount(RESONANCE_AMULET_6_ID) == 0 && st.getInt("id") == 1)
			htmltext = "31633-03.htm";
		else if(npcId == Winter_Hunter_Kadyth && st.getQuestItemsCount(RESONANCE_AMULET_6_ID) == 0 && st.getInt("id") == 10)
			htmltext = "31633-07.htm";
		else if(npcId == Winter_Hunter_Kadyth && st.getQuestItemsCount(RESONANCE_AMULET_6_ID) == 1)
			htmltext = "31633-11.htm";

		return htmltext;
	}//onTalk

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();

		if(npcId == 27214)
		{
			if(st.getInt("cond") == 6 && st.getQuestItemsCount(RESONANCE_AMULET_2_ID) == 0)
				if(st.getInt("id") > 8)
				{
					if(Rnd.get(9) <= (st.getInt("id") - 8) * 10)
					{
						st.playSound("ItemSound.quest_itemget");
						st.giveItems(RESONANCE_AMULET_2_ID, 1);
						st.set("id", "0");
						st.set("cond", "7");
					}
					else
						st.set("id", Integer.toString(st.getInt("id") + 1));
				}
				else
					st.set("id", Integer.toString(st.getInt("id") + 1));
		}
		else if(npcId == 27296)
			if(st.getInt("cond") == 9 && st.getQuestItemsCount(RESONANCE_AMULET_3_ID) == 0)
			{
				st.giveItems(RESONANCE_AMULET_3_ID, 1);
				st.playSound("ItemSound.quest_middle");
			}
		if(npcId == 21646 || npcId == 21647 || npcId == 21648 || npcId == 21649 || npcId == 21650 || npcId == 21651)
		{
			if(st.getInt("cond") == 15 && st.getQuestItemsCount(HALISHA_MARK_ID) < 701)
			{
				st.giveItems(HALISHA_MARK_ID, 1);
				if(st.getQuestItemsCount(HALISHA_MARK_ID) == 701)
				{
					st.playSound("Itemsound.quest_before_battle");
					st.getPlayer().sendMessage("Prepare to die, Hawkeye....");
					st.getPcSpawn().addSpawn(27247);
					st.takeItems(HALISHA_MARK_ID, 701);
				}
				else
					st.playSound("ItemSound.quest_itemget");
			}
		}
		else if(npcId == 27247)
		{
			if(st.getInt("cond") == 15 && st.getQuestItemsCount(RESONANCE_AMULET_5_ID) == 0)
			{
				st.set("cond", "16");
				st.playSound("ItemSound.quest_middle");
				st.giveItems(RESONANCE_AMULET_5_ID, 1);
			}
		}
		else if(npcId == 27302)
			if((st.getInt("cond") == 18 || st.getInt("cond") == 17) && st.getInt("id") < 10)
			{
				st.set("id", "10");
				st.playSound("ItemSound.quest_middle");
			}
		return "";
	}//onKill
}