package quests._095_SagaOfTheHellKnight;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.game.tables.SkillTable;
import L2jFT.util.Rnd;

public class _095_SagaOfTheHellKnight extends Quest implements ScriptFile
{
	//PARAMETRS
	static int SPAWNED = 0;
	static int HITED = 0;
	static int HITS = 0;
	//NPC
	//TODO: поднять сюда имена нпс и определить в переменных
	//items
	public final int ICE_CRYSTAL_ID = 7080;
	public final int REPORT_ID = 7532;
	public final int RESONANCE_AMULET_1_ID = 7293;
	public final int RESONANCE_AMULET_2_ID = 7324;
	public final int RESONANCE_AMULET_3_ID = 7355;
	public final int RESONANCE_AMULET_4_ID = 7386;
	public final int RESONANCE_AMULET_5_ID = 7417;
	public final int RESONANCE_AMULET_6_ID = 7448;
	public final int DIVINE_STONE_OF_WISDOM_ID = 7081;
	public final int HALISHA_MARK_ID = 7510;
	public final int ADEN_ID = 57;
	public final int BOOK_ID = 6622;

	//Mobs kill
	public final int KILL_TABL3 = 27258;

	short newclass = 100;

	//Main
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 95 SagaOfTheHellKnight");
	}

	public void onReload()
	{
	//System.out.println("Reloaded Quest: 95 SagaOfTheHellKnight");
	}

	public void onShutdown()
	{}

	public int getSPAWNED()
	{
		return SPAWNED;
	}

	public void setSPAWNED(int val)
	{
		SPAWNED = val;
	}

	public int getHITED()
	{
		return HITED;
	}

	public void setHITED(int val)
	{
		HITED = val;
	}

	public _095_SagaOfTheHellKnight()
	{
		super(95, "_095_SagaOfTheHellKnight", "Saga Of The Hell Knight", false);
		setInitialState(CREATED);
		//Fist NPC
		addStartNpc(31582);
		addTalkId(31582);
		//addTalkId(31582);
		//addTalkId(31582);
		//Bavarin
		addTalkId(31623);
		///Bayard
		addTalkId(31297);
		//Tablet 1
		addTalkId(31646);
		//Tablet 2
		addTalkId(31647);
		//Tablet 3
		addTalkId(31653);
		//Tablet 4
		addTalkId(31654);
		//Tablet 5
		addTalkId(31655);
		//Tablet 6
		addTalkId(31656);
		//NPC TABLET 6
		addTalkId(31599);

		addAttackId(KILL_TABL3);
		addAttackId(27263);

		addKillId(27214);
		addKillId(KILL_TABL3);
		addKillId(27244);
		addKillId(21646);
		addKillId(21647);
		addKillId(21648);
		addKillId(21649);
		addKillId(21650);
		addKillId(21651);

		STARTED.addQuestDrop(27214, RESONANCE_AMULET_2_ID, 1);
		STARTED.addQuestDrop(KILL_TABL3, RESONANCE_AMULET_3_ID, 1);
		STARTED.addQuestDrop(27244, RESONANCE_AMULET_5_ID, 1);
		STARTED.addQuestDrop(21646, HALISHA_MARK_ID, 1);
		STARTED.addQuestDrop(21647, HALISHA_MARK_ID, 1);
		STARTED.addQuestDrop(21648, HALISHA_MARK_ID, 1);
		STARTED.addQuestDrop(21649, HALISHA_MARK_ID, 1);
		STARTED.addQuestDrop(21650, HALISHA_MARK_ID, 1);
		STARTED.addQuestDrop(21651, HALISHA_MARK_ID, 1);
	}

	///////////////////////////
	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		//Mordred
		if(event.equalsIgnoreCase("31582-03.htm"))
		{
			if(st.getPlayer().getClassId().getId() == 6 && st.getPlayer().getLevel() >= 76)
			{
				st.giveItems(7086, 1);
				st.set("id", "1");
				st.set("cond", "1");
				st.set("count", "0");
				st.playSound("ItemSound.quest_accept");
				st.setState(STARTED);
			}
		}
		else if(event.equalsIgnoreCase("31582-07.htm"))
		{
			if(st.getPlayer().getLevel() >= 76)
			{
				short clId = 91;
				st.takeItems(7086, -1);
				st.addExpAndSp(2299404, 0);
				st.giveItems(ADEN_ID, 5000000);
				st.giveItems(BOOK_ID, 1);
				st.getPlayer().setClassId(clId);
				st.getPlayer().doCast(SkillTable.getInstance().getInfo(4339, 1), st.getPlayer(), true);
				st.playSound("ItemSound.quest_fanfare_2");
				st.exitCurrentQuest(true);
				st.setState(COMPLETED);
			}
			else
			{
				htmltext = "31582-08.htm";
				st.takeItems(7086, -1);
				st.set("id", "16");
				st.set("cond", "20");
				st.playSound("ItemSound.quest_middle");
			}
		}
		//Bavarin
		else if(event.equalsIgnoreCase("31623-15.htm"))
		{
			st.set("id", "3");
			st.set("cond", "3");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("31623-16.htm"))
		{
			st.giveItems(REPORT_ID, 1);
			st.takeItems(ICE_CRYSTAL_ID, -1);
			st.set("id", "4");
			st.set("cond", "4");
			st.playSound("ItemSound.quest_middle");
		}
		//Bayard
		else if(event.equalsIgnoreCase("31297-05.htm"))
		{
			st.set("id", "2");
			st.set("cond", "2");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("31297-06.htm"))
		{
			st.giveItems(RESONANCE_AMULET_1_ID, 1);
			st.takeItems(REPORT_ID, -1);
			st.set("id", "5");
			st.set("cond", "5");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("31297-22.htm"))
		{
			st.set("id", "9");
			st.set("cond", "11");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("31297-23.htm"))
		{
			st.set("id", "9");
			st.set("cond", "12");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("31297-28.htm"))
		{
			st.giveItems(RESONANCE_AMULET_4_ID, 1);
			st.takeItems(DIVINE_STONE_OF_WISDOM_ID, -1);
			st.set("id", "10");
			st.set("cond", "13");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("31297-33.htm"))
		{
			st.set("id", "12");
			st.set("cond", "15");
			st.playSound("ItemSound.quest_middle");
		}
		//Tablet1      
		else if(event.equalsIgnoreCase("31646-02.htm"))
		{
			st.takeItems(RESONANCE_AMULET_1_ID, 1);
			st.set("cond", "6");
			st.set("id", "6");
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), true);
			st.playSound("ItemSound.quest_middle");
		}
		//Tablet2        
		else if(event.equalsIgnoreCase("31647-03.htm"))
		{
			st.takeItems(RESONANCE_AMULET_2_ID, -1);
			st.set("id", "7");
			st.set("cond", "8");
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), true);
			st.playSound("ItemSound.quest_middle");
		}
		//tablet3
		else if(event.equalsIgnoreCase("31653-02.htm"))
		{
			if(getSPAWNED() > 0)
			{
				if(getHITED() > 0)
					htmltext = "31653-04.htm";
				else
					htmltext = "31653-03.htm";
			}
			else
			{
				st.playSound("Itemsound.quest_before_battle");
				st.getPcSpawn().getSpawn(st.getPcSpawn().addSpawn(KILL_TABL3, 165079, -74173, -2763)).getLastSpawn().addDamageHate(st.getPlayer(), 1, 100);
				setSPAWNED(1);
				st.startQuestTimer("chat_timer", 500);
				st.startQuestTimer("despawn_timer", 300000);
			}
		}
		else if(event.equalsIgnoreCase("31653-06.htm"))
		{
			st.takeItems(RESONANCE_AMULET_3_ID, -1);
			st.set("id", "8");
			st.set("cond", "10");
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), true);
			st.playSound("ItemSound.quest_middle");
		}
		//Timers
		else if(event.equalsIgnoreCase("chat_timer"))
			st.getPlayer().sendMessage("Archangel Iconoclasis: Your this fellow... " + st.getPlayer().getName() + "? Cannot become Hunt always collaborate rests the tower sound!");
		else if(event.equalsIgnoreCase("despawn_timer"))
		{
			if(getSPAWNED() > 0)
				st.getPlayer().sendMessage("Archangel Iconoclasis: Cuts Compared to imagines has the endurance oh This stops");
			st.getPcSpawn().removeAllSpawn();
			setSPAWNED(0);
		}
		else if(event.equalsIgnoreCase("halette_chat"))
			st.getPlayer().sendMessage("Death Lord Hallate: any, is betrays Always thought somewhat strangely... cuts, this secondary retreated.");
		else if(event.equalsIgnoreCase("halette_unspawn"))
		{
			if(getSPAWNED() > 0)
				st.getPlayer().sendMessage("Death Lord Hallate: shouts, then I first walk step...");
			st.getPcSpawn().removeSpawn(27263);
			st.set("i_quest", "2");
		}
		else if(event.equalsIgnoreCase("waldstein_chat"))
		{
			st.getPlayer().sendMessage("Disgraced Knight Waldstein: you cannot and the mystical flagstone cross coupling! Hands over the cross coupling stone!");
			st.startQuestTimer("waldstein_chat1", 1500);
		}
		else if(event.equalsIgnoreCase("waldstein_chat1"))
		{
			st.getPlayer().sendMessage("Disgraced Knight Waldstein: this, a person still somewhat impolite... " + st.getPlayer().getName() + "! Helps me!");
			st.startQuestTimer("waldstein_chat2", 10000);
		}
		else if(event.equalsIgnoreCase("waldstein_chat2"))
		{
			if(HITS <= 15)
			{
				if(Rnd.chance(50))
					st.getPlayer().sendMessage("Disgraced Knight Waldstein: " + st.getPlayer().getName() + "! Grasps Otherwise had to slip away.");
				else
					st.getPlayer().sendMessage("Disgraced Knight Waldstein: " + st.getPlayer().getName() + "! A bit faster grasps.");
				st.startQuestTimer("waldstein_chat2", 13000);
			}
		}
		else if(event.equalsIgnoreCase("waldstein_unspawn"))
		{
			if(st.getInt("i_quest") == 2)
			{
				st.getPlayer().sendMessage("Disgraced Knight Waldstein: cuts Wants to escape Does not halt!");
				st.getPcSpawn().removeSpawn(31599);
			}
		}
		else if(event.equalsIgnoreCase("halisha_unspawn"))
		{
			st.getPlayer().sendMessage("Archon of Halisha: stops, please return.");
			st.getPcSpawn().removeSpawn(27244);
		}
		//Tablet4
		else if(event.equalsIgnoreCase("31654-02.htm"))
		{
			st.takeItems(RESONANCE_AMULET_4_ID, 1);
			st.set("id", "11");
			st.set("cond", "14");
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), true);
			st.playSound("ItemSound.quest_middle");
		}
		//Tablet5
		else if(event.equalsIgnoreCase("31655-03.htm"))
		{
			st.takeItems(RESONANCE_AMULET_5_ID, -1);
			st.set("cond", "17");
			st.set("id", "13");
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), true);
			st.playSound("ItemSound.quest_middle");
		}
		//Tablet6         
		else if(event.equalsIgnoreCase("31656-02.htm"))
		{
			if(getSPAWNED() > 0)
			{
				if(HITED > 0)
					htmltext = "31656-04.htm";
				else
					htmltext = "31656-03.htm";
			}
			else
			{
				st.getPcSpawn().removeAllSpawn();
				st.getPcSpawn().addSpawn(31599, 47429, -56923, -2383);
				st.getPcSpawn().addSpawn(27263, 47391, -56929, -2370);
				setSPAWNED(1);
				st.startQuestTimer("halette_chat", 500);
				st.startQuestTimer("halette_unspawn", 59000);
				st.startQuestTimer("waldstein_chat", 500);
				st.startQuestTimer("waldstein_unspawn", 60000);
				st.set("i_quest", "0");
				st.playSound("Itemsound.quest_before_battle");
			}
		}
		else if(event.equalsIgnoreCase("31656-06.htm"))
		{
			st.getPcSpawn().removeAllSpawn();
			st.set("id", "15");
			st.set("cond", "19");
			st.takeItems(RESONANCE_AMULET_6_ID, -1);
			st.getPlayer().doCast(SkillTable.getInstance().getInfo(4546, 1), st.getPlayer(), true);
			st.playSound("ItemSound.quest_middle");
		}
		//Disgraced Knight Waldstein
		else if(event.equalsIgnoreCase("final"))
		{
			st.giveItems(RESONANCE_AMULET_6_ID, 1);
			st.set("cond", "18");
			st.playSound("ItemSound.quest_middle");
			st.getPlayer().sendMessage("Disgraced Knight Waldstein: that next time goodbye.");
			st.getPcSpawn().removeSpawn(31599);
			st.set("i_quest", "0");
		}

		return htmltext;

	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><head><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		//Mordred
		if(id == COMPLETED)
			htmltext = "You have been allready copleted this quest!";
		if(npcId == 31582 && id == CREATED)
		{
			if(st.getPlayer().getClassId().getId() == 6 && st.getPlayer().getLevel() >= 76)
				htmltext = "31582-01.htm";
			else
				htmltext = "31582-02.htm";
		}
		else if(npcId == 31582 && st.getInt("id") == 1)
			htmltext = "31582-04.htm";
		else if(npcId == 31582 && st.getInt("id") == 15)
			htmltext = "31582-06.htm";
		else if(npcId == 31582 && st.getInt("id") == 16)
		{
			if(st.getPlayer().getLevel() >= 76)
			{
				short clId = 91;
				st.addExpAndSp(2299404, 0);
				st.giveItems(ADEN_ID, 5000000);
				st.giveItems(BOOK_ID, 1);
				st.getPlayer().setClassId(clId);
				st.getPlayer().setBaseClass(91);
				st.getPlayer().doCast(SkillTable.getInstance().getInfo(4339, 1), st.getPlayer(), true);
				st.playSound("ItemSound.quest_fanfare_2");
				st.exitCurrentQuest(true);
				st.setState(COMPLETED);
				htmltext = "31582-09.htm";
			}
			else
				htmltext = "31582-10.htm";
		}
		//Bavarin   
		else if(npcId == 31623 && st.getInt("id") == 2)
			htmltext = "31623-11.htm";
		else if(npcId == 31623 && st.getInt("id") == 3)
		{
			if(st.getQuestItemsCount(ICE_CRYSTAL_ID) >= 1)
				htmltext = "31623-13.htm";
			else
				htmltext = "31623-12.htm";
		}
		else if(npcId == 31623 && st.getInt("id") == 4)
			htmltext = "31623-14.htm";
		//Bayard
		else if(npcId == 31297 && st.getInt("id") == 1)
			htmltext = "31297-01.htm";
		else if(npcId == 31297 && st.getInt("id") >= 2 && st.getInt("id") <= 4 && st.getQuestItemsCount(REPORT_ID) == 0)
			htmltext = "31297-02.htm";
		else if(npcId == 31297 && st.getInt("id") >= 2 && st.getInt("id") <= 4 && st.getQuestItemsCount(REPORT_ID) >= 1)
			htmltext = "31297-03.htm";
		else if(npcId == 31297 && st.getInt("id") == 5)
			htmltext = "31297-04.htm";
		else if(npcId == 31297 && st.getInt("id") == 8)
			htmltext = "31297-21.htm";
		else if(npcId == 31297 && st.getInt("id") == 9 && st.getQuestItemsCount(DIVINE_STONE_OF_WISDOM_ID) == 0)
			htmltext = "31297-24.htm";
		else if(npcId == 31297 && st.getInt("id") == 9 && st.getQuestItemsCount(DIVINE_STONE_OF_WISDOM_ID) >= 1)
			htmltext = "31297-25.htm";
		else if(npcId == 31297 && st.getInt("id") == 10)
			htmltext = "31297-26.htm";
		else if(npcId == 31297 && st.getInt("id") == 11)
			htmltext = "31297-31.htm";
		else if(npcId == 31297 && st.getInt("id") == 12)
			htmltext = "31297-32.htm";
		//Tablet1       
		else if(npcId == 31646 && st.getInt("id") == 5 && st.getQuestItemsCount(RESONANCE_AMULET_1_ID) >= 1)
			htmltext = "31646-01.htm";
		else if(npcId == 31646 && st.getInt("id") == 6)
			htmltext = "31646-03.htm";
		//Tablet2 
		else if(npcId == 31647 && st.getInt("id") == 6 && st.getQuestItemsCount(RESONANCE_AMULET_2_ID) == 0)
			htmltext = "31647-01.htm";
		else if(npcId == 31647 && st.getInt("id") == 6 && st.getQuestItemsCount(RESONANCE_AMULET_2_ID) >= 1)
			htmltext = "31647-02.htm";
		else if(npcId == 31647 && st.getInt("id") == 7)
			htmltext = "31647-04.htm";
		//Tablet3
		else if(npcId == 31653 && st.getInt("id") == 7 && st.getQuestItemsCount(RESONANCE_AMULET_3_ID) == 0)
			htmltext = "31653-01.htm";
		else if(npcId == 31653 && st.getInt("id") == 7 && st.getQuestItemsCount(RESONANCE_AMULET_3_ID) >= 0)
			htmltext = "31653-05.htm";
		else if(npcId == 31653 && st.getInt("id") == 8)
			htmltext = "31653-07.htm";
		//Tablet 4
		else if(npcId == 31654 && st.getInt("id") == 10 && st.getQuestItemsCount(RESONANCE_AMULET_4_ID) >= 1)
			htmltext = "31654-01.htm";
		else if(npcId == 31654 && st.getInt("id") == 11)
			htmltext = "31654-03.htm";
		//Tablet 5
		else if(npcId == 31655 && st.getInt("id") == 12 && st.getQuestItemsCount(RESONANCE_AMULET_5_ID) == 0)
			htmltext = "31655-01.htm";
		else if(npcId == 31655 && st.getInt("id") == 12 && st.getQuestItemsCount(RESONANCE_AMULET_5_ID) >= 1)
			htmltext = "31655-02.htm";
		else if(npcId == 31655 && st.getInt("id") == 13)
			htmltext = "31655-04.htm";
		//Tablet 6
		else if(npcId == 31656 && (st.getInt("id") == 13 || st.getInt("id") == 14) && st.getQuestItemsCount(RESONANCE_AMULET_6_ID) == 0)
			htmltext = "31656-01.htm";
		else if(npcId == 31656 && st.getInt("id") == 14 && st.getQuestItemsCount(RESONANCE_AMULET_6_ID) >= 1)
			htmltext = "31656-05.htm";
		else if(npcId == 31656 && st.getInt("id") == 15)
			htmltext = "31656-07.htm";
		//Disgraced Knight Waldstein
		else if(npcId == 31599 && st.getInt("id") == 13)
		{
			if(st.getInt("i_quest") == 0)
				htmltext = "31599-01.htm";
			else if(st.getInt("i_quest") == 1)
				htmltext = "31599-03.htm";
		}
		else if(npcId == 31599 && st.getQuestItemsCount(RESONANCE_AMULET_6_ID) == 0 && st.getInt("id") == 14)
		{
			if(st.getInt("i_quest") == 0)
				htmltext = "31599-04.htm";
			else if(st.getInt("i_quest") == 1)
				htmltext = "31599-06.htm";
		}
		else if(npcId == 31599 && st.getQuestItemsCount(RESONANCE_AMULET_6_ID) >= 1 && st.getInt("id") == 14)
			if(st.getInt("i_quest") == 0)
				htmltext = "31599-08.htm";
			else if(st.getInt("i_quest") == 1)
				htmltext = "31599-09.htm";
		return htmltext;

	}

	@Override
	public String onAttack(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(npcId == KILL_TABL3)
			setHITED(1);
		else if(npcId == 27263)
		{
			setHITED(1);
			HITS = HITS + 1;
			if(HITS <= 15)
			{
				if(HITS == 1)
					st.getPlayer().sendMessage("Death Lord Hallate: your this fellow... " + st.getPlayer().getName() + "? Became two people, thought could block my escape route?");
			}
			else
			{
				st.set("id", "14");
				st.set("i_quest", "1");
				st.getPlayer().sendMessage("Death Lord Hallate: this! My cross coupling stone... " + st.getPlayer().getName() + ", I can remember always.");
				st.getPcSpawn().removeSpawn(27263);
			}
		}
		return "";
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int count = st.getInt("count");
		int npcId = npc.getNpcId();

		if(npcId == 27214 && st.getInt("id") == 6)
		{
			if(count > 8)
			{
				st.giveItems(RESONANCE_AMULET_2_ID, 1);
				st.set("cond", "7");
				st.playSound("ItemSound.quest_middle");
			}
			else
				st.set("count", String.valueOf(count + 1));
		}
		else if(npcId == KILL_TABL3)
			if(st.getInt("id") == 7 && st.getQuestItemsCount(RESONANCE_AMULET_3_ID) == 0)
			{
				st.getPlayer().sendMessage("Archangel Iconoclasis: I unexpectedly can lose...");
				st.giveItems(RESONANCE_AMULET_3_ID, 1);
				st.set("cond", "9");
				st.playSound("ItemSound.quest_middle");
			}
		if(npcId == 21646 || npcId == 21647 || npcId == 21648 || npcId == 21649 || npcId == 21650 || npcId == 21651)
		{
			if(st.getInt("id") == 12 && st.getQuestItemsCount(HALISHA_MARK_ID) < 701)
			{
				st.giveItems(HALISHA_MARK_ID, 1);
				if(st.getQuestItemsCount(HALISHA_MARK_ID) == 701)
				{
					st.playSound("Itemsound.quest_before_battle");
					st.getPcSpawn().getSpawn(st.getPcSpawn().addSpawn(27244, npc.getX(), npc.getY(), npc.getZ())).getLastSpawn().addDamageHate(st.getPlayer(), 1, 100);
					st.takeItems(HALISHA_MARK_ID, 20);
					st.getPlayer().sendMessage("Archon of Halisha: " + st.getPlayer().getName() + ", recently suffered under our unit the person was your this fellow?");
					st.startQuestTimer("halisha_unspawn", 600000);
				}
				else
					st.playSound("ItemSound.quest_itemget");
			}
		}
		else if(npcId == 27244)
		{
			if(st.getInt("id") == 12 && st.getQuestItemsCount(RESONANCE_AMULET_5_ID) == 0)
				st.playSound("ItemSound.quest_middle");
			st.giveItems(RESONANCE_AMULET_5_ID, 1);
			st.takeItems(HALISHA_MARK_ID, -1);
			st.getPlayer().sendMessage("Archon of Halisha: Strives to excel Arab League...");
			st.set("cond", "16");
		}
		return "";
	}
}