package quests._127_KamaelAWindowtotheFuture;

// version = Interlude

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.game.network.serverpackets.ExShowSlideshowKamael;

public class _127_KamaelAWindowtotheFuture extends Quest implements ScriptFile
{
	public final int DOMINIC = 31350;
	public final int KLAUS = 30187;
	public final int ALDER = 32092;
	public final int AKLAN = 31288;
	public final int OLTLIN = 30862;
	public final int JURIS = 30113;
	public final int KRISTOF = 30756;

	// Items
	public final int DOMINIC_MARK = 8939;
	public final int MARK_HUMAN = 8940;
	public final int MARK_DWARF = 8941;
	public final int MARK_ELF = 8942;
	public final int MARK_DE = 8943;
	public final int MARK_ORC = 8944;
	public final int ADENA = 57;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 127: Kamael: A Window to the Future");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _127_KamaelAWindowtotheFuture()
	{
		super(127, "_127_KamaelAWindowtotheFuture", "Kamael: A Window to the Future", false);
		setInitialState(CREATED);
		addStartNpc(DOMINIC);
		addTalkId(DOMINIC);
		addTalkId(DOMINIC);
		addTalkId(KLAUS);
		addTalkId(ALDER);
		addTalkId(AKLAN);
		addTalkId(OLTLIN);
		addTalkId(JURIS);
		addTalkId(KRISTOF);
		addTalkId(DOMINIC);

		STARTED.addQuestDrop(DOMINIC, DOMINIC_MARK, 1);
		STARTED.addQuestDrop(KLAUS, MARK_HUMAN, 1);
		STARTED.addQuestDrop(ALDER, MARK_DWARF, 1);
		STARTED.addQuestDrop(AKLAN, MARK_ORC, 1);
		STARTED.addQuestDrop(OLTLIN, MARK_DE, 1);
		STARTED.addQuestDrop(JURIS, MARK_ELF, 1);
	}

	@Override
	public String onEvent(String event, QuestState qs)
	{
		if(event.equalsIgnoreCase("31350-04.htm"))
		{
			qs.set("cond", "1");
			qs.setState(STARTED);
			qs.giveItems(DOMINIC_MARK, 1);
			qs.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("30187-02.htm"))
			qs.set("cond", "2");
		else if(event.equalsIgnoreCase("30187-08.htm"))
		{
			qs.set("cond", "3");
			qs.setState(STARTED);
			qs.giveItems(MARK_HUMAN, 1);
			qs.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("32092-05.htm"))
		{
			qs.set("cond", "4");
			qs.setState(STARTED);
			qs.giveItems(MARK_DWARF, 1);
			qs.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("31288-04.htm"))
		{
			qs.set("cond", "5");
			qs.setState(STARTED);
			qs.giveItems(MARK_ORC, 1);
			qs.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30862-04.htm"))
		{
			qs.set("cond", "6");
			qs.setState(STARTED);
			qs.giveItems(MARK_DE, 1);
			qs.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30113-04.htm"))
		{
			qs.set("cond", "7");
			qs.setState(STARTED);
			qs.giveItems(MARK_ELF, 1);
			qs.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30756-04.htm"))
		{
			qs.set("cond", "8");
			// play movie
			qs.getPlayer().sendPacket(new ExShowSlideshowKamael());
			qs.set("cond", "9");
		}
		else if(event.equalsIgnoreCase("31350-06.htm"))
		{
			qs.giveItems(ADENA, 159100);
			qs.takeItems(MARK_HUMAN, -1);
			qs.takeItems(MARK_DWARF, -1);
			qs.takeItems(MARK_ELF, -1);
			qs.takeItems(MARK_DE, -1);
			qs.takeItems(MARK_ORC, -1);
			qs.set("cond", "0");
			qs.setState(COMPLETED);
			qs.playSound("ItemSound.quest_finish");
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");
		switch(npcId)
		{
			case DOMINIC:
				if(cond == 0)
				{
					if(!id.equals(COMPLETED))
						htmltext = "31350-01.htm";
					else
						htmltext = "<html><body>This quest have already been completed.</body></html>";
				}
				else if(cond == 1)
					htmltext = "31350-04.htm";
				else if(cond == 9)
					htmltext = "31350-05.htm";
				break;
			case KLAUS:
				if(cond == 1)
				{
					htmltext = "30187-01.htm";
					st.takeItems(DOMINIC_MARK, -1);
				}
				else if(cond == 2)
					htmltext = "30187-02.htm";
				else if(cond == 3)
					htmltext = "30187-08.htm";
				break;
			case ALDER:
				if(cond == 3)
					htmltext = "32092-01.htm";
				else if(cond == 4)
					htmltext = "32092-05.htm";
				break;
			case AKLAN:
				if(cond == 4)
					htmltext = "31288-01.htm";
				else if(cond == 5)
					htmltext = "31288-04.htm";
				break;
			case OLTLIN:
				if(cond == 5)
					htmltext = "30862-01.htm";
				else if(cond == 6)
					htmltext = "30862-04.htm";
				break;
			case JURIS:
				if(cond == 6)
					htmltext = "30113-01.htm";
				else if(cond == 7)
					htmltext = "30113-04.htm";
				break;
			case KRISTOF:
				if(cond == 7)
					htmltext = "30756-01.htm";
				else if(cond == 8 || cond == 9)
					htmltext = "30756-04.htm";
				break;
		}
		return htmltext;
	}
}