package quests._13_ParcelDelivery;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _013_ParcelDelivery extends Quest implements ScriptFile
{
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	private static final int PACKAGE = 7263;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 013: Parcel Delivery");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _013_ParcelDelivery()
	{
		super(13, "_013_ParcelDelivery", "Parcel Delivery", false);
		setInitialState(CREATED);
		addStartNpc(31274);
		addTalkId(31274);
		addTalkId(31274);
		addTalkId(31274);
		addTalkId(31539);

		STARTED.addQuestDrop(31274, PACKAGE, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31274-2.htm"))
		{
			st.set("cond", "1");
			st.giveItems(PACKAGE, 1);
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("31539-2.htm"))
		{
			st.takeItems(PACKAGE, -1);
			st.giveItems(57, 82656);
			st.set("cond", "0");
			st.setState(COMPLETED);
			st.playSound("ItemSound.quest_finish");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");
		if(npcId == 31274)
		{
			if(cond == 0)
				if(id != COMPLETED)
					if(st.getPlayer().getLevel() >= 74)
						htmltext = "31274-1.htm";
					else
					{
						htmltext = "31274-00.htm";
						st.exitCurrentQuest(true);
					}
				else
					htmltext = "<html><body>This quest have already been completed.</body></html>";
			else if(cond == 1)
				htmltext = "31274-2r.htm";
		}
		else if(npcId == 31539)
			if(cond == 1 && st.getQuestItemsCount(PACKAGE) == 1)
				htmltext = "31539-1.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}
}