package quests._216_TrialoftheGuildsman;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _216_TrialoftheGuildsman extends Quest implements ScriptFile
{
	//NPC
	public final int VALKON = 30103;
	public final int NORMAN = 30210;
	public final int ALTRAN = 30283;
	public final int PINTER = 30298;
	public final int DUNING = 30688;
	//Quest Item
	public final int MARK_OF_GUILDSMAN = 3119;
	public final int VALKONS_RECOMMEND = 3120;
	public final int MANDRAGORA_BERRY = 3121;
	public final int ALLTRANS_INSTRUCTIONS = 3122;
	public final int ALLTRANS_RECOMMEND1 = 3123;
	public final int ALLTRANS_RECOMMEND2 = 3124;
	public final int NORMANS_INSTRUCTIONS = 3125;
	public final int NORMANS_RECEIPT = 3126;
	public final int DUNINGS_INSTRUCTIONS = 3127;
	public final int DUNINGS_KEY = 3128;
	public final int NORMANS_LIST = 3129;
	public final int GRAY_BONE_POWDER = 3130;
	public final int GRANITE_WHETSTONE = 3131;
	public final int RED_PIGMENT = 3132;
	public final int BRAIDED_YARN = 3133;
	public final int JOURNEYMAN_GEM = 3134;
	public final int PINTERS_INSTRUCTIONS = 3135;
	public final int AMBER_BEAD = 3136;
	public final int AMBER_LUMP = 3137;
	public final int JOURNEYMAN_DECO_BEADS = 3138;
	public final int JOURNEYMAN_RING = 3139;
	public final int RP_JOURNEYMAN_RING = 3024;
	public final int DIMENSION_DIAMOND = 7562;
	public final int RP_AMBER_BEAD = 3025;
	//Item
	public final int ADENA = 57;
	//Drop Cond
	//# [COND, NEWCOND, ID, REQUIRED, ITEM, NEED_COUNT, CHANCE, DROP]	
	public final int[][] DROPLIST_COND = {
			{ 3, 4, 20223, VALKONS_RECOMMEND, MANDRAGORA_BERRY, 1, 20, 1 },
			{ 3, 4, 20154, VALKONS_RECOMMEND, MANDRAGORA_BERRY, 1, 50, 1 },
			{ 3, 4, 20155, VALKONS_RECOMMEND, MANDRAGORA_BERRY, 1, 50, 1 },
			{ 3, 4, 20156, VALKONS_RECOMMEND, MANDRAGORA_BERRY, 1, 50, 1 },
			{ 5, 0, 20267, DUNINGS_INSTRUCTIONS, DUNINGS_KEY, 30, 30, 1 },
			{ 5, 0, 20268, DUNINGS_INSTRUCTIONS, DUNINGS_KEY, 30, 30, 1 },
			{ 5, 0, 20269, DUNINGS_INSTRUCTIONS, DUNINGS_KEY, 30, 30, 1 },
			{ 5, 0, 20270, DUNINGS_INSTRUCTIONS, DUNINGS_KEY, 30, 30, 1 },
			{ 5, 0, 20271, DUNINGS_INSTRUCTIONS, DUNINGS_KEY, 30, 30, 1 },
			{ 5, 0, 20200, NORMANS_LIST, GRAY_BONE_POWDER, 70, 100, 2 },
			{ 5, 0, 20201, NORMANS_LIST, GRAY_BONE_POWDER, 70, 100, 2 },
			{ 5, 0, 20202, NORMANS_LIST, RED_PIGMENT, 70, 100, 2 },
			{ 5, 0, 20083, NORMANS_LIST, GRANITE_WHETSTONE, 70, 100, 2 },
			{ 5, 0, 20168, NORMANS_LIST, BRAIDED_YARN, 70, 100, 2 } };
	//Main
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 216: Trial of the Guildsman");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _216_TrialoftheGuildsman()
	{
		super(216, "_216_TrialoftheGuildsman", "Trial of the Guildsman", false);
		setInitialState(CREATED);
		addStartNpc(VALKON);
		addTalkId(VALKON);
		addTalkId(NORMAN);
		addTalkId(ALTRAN);
		addTalkId(PINTER);
		addTalkId(DUNING);
		//Mob Drop
		for(int i = 0; i < DROPLIST_COND.length; i++)
		{
			addKillId(DROPLIST_COND[i][2]);
			STARTED.addQuestDrop(DROPLIST_COND[i][2], DROPLIST_COND[i][4], 1);
		}
		//Npc DROP	
		STARTED.addQuestDrop(30283, RP_JOURNEYMAN_RING, 1);
		STARTED.addQuestDrop(30283, ALLTRANS_INSTRUCTIONS, 1);
		STARTED.addQuestDrop(30283, RP_JOURNEYMAN_RING, 1);
		STARTED.addQuestDrop(30103, VALKONS_RECOMMEND, 1);
		STARTED.addQuestDrop(30283, ALLTRANS_RECOMMEND1, 1);
		STARTED.addQuestDrop(30210, NORMANS_INSTRUCTIONS, 1);
		STARTED.addQuestDrop(30210, NORMANS_LIST, 1);
		STARTED.addQuestDrop(30210, NORMANS_RECEIPT, 1);
		STARTED.addQuestDrop(30283, ALLTRANS_RECOMMEND2, 1);
		STARTED.addQuestDrop(30298, PINTERS_INSTRUCTIONS, 1);
		STARTED.addQuestDrop(30298, RP_AMBER_BEAD, 1);
		STARTED.addQuestDrop(30688, DUNINGS_INSTRUCTIONS, 1);
		STARTED.addQuestDrop(VALKON, JOURNEYMAN_GEM, 1);
		STARTED.addQuestDrop(VALKON, JOURNEYMAN_DECO_BEADS, 1);
		STARTED.addQuestDrop(VALKON, JOURNEYMAN_RING, 1);

		//Addon
		addKillId(20079);
		addKillId(20080);
		addKillId(20081);
		STARTED.addQuestDrop(20079, AMBER_BEAD, 1);
		STARTED.addQuestDrop(20080, AMBER_BEAD, 1);
		STARTED.addQuestDrop(20081, AMBER_BEAD, 1);
		STARTED.addQuestDrop(20079, AMBER_LUMP, 1);
		STARTED.addQuestDrop(20080, AMBER_LUMP, 1);
		STARTED.addQuestDrop(20081, AMBER_LUMP, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30103-06.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
			st.giveItems(VALKONS_RECOMMEND, 1);
			st.takeItems(ADENA, 2000);
		}
		else if(event.equalsIgnoreCase("30103-07c.htm"))
			st.set("cond", "3");
		else if(event.equalsIgnoreCase("30103-05.htm") && st.getQuestItemsCount(ADENA) < 2000)
			htmltext = "30103-05a.htm";
		else if(event.equalsIgnoreCase("30103_3") || event.equalsIgnoreCase("30103_4"))
		{
			if(event.equalsIgnoreCase("30103_3"))
				htmltext = "30103-09a.htm";
			else
				htmltext = "30103-09b.htm";
			st.addExpAndSp(80993, 12250);
			st.takeItems(JOURNEYMAN_RING, -1);
			st.takeItems(ALLTRANS_INSTRUCTIONS, 1);
			st.takeItems(RP_JOURNEYMAN_RING, 1);
			st.giveItems(MARK_OF_GUILDSMAN, 1);
			st.exitCurrentQuest(true);
			st.playSound("ItemSound.quest_finish");
		}
		else if(event.equalsIgnoreCase("30283-03.htm"))
		{
			st.takeItems(VALKONS_RECOMMEND, -1);
			st.takeItems(MANDRAGORA_BERRY, 1);
			st.giveItems(ALLTRANS_INSTRUCTIONS, 1);
			st.giveItems(RP_JOURNEYMAN_RING, 1);
			st.giveItems(ALLTRANS_RECOMMEND1, 1);
			st.giveItems(ALLTRANS_RECOMMEND2, 1);
			st.set("cond", "5");
		}
		else if(event.equalsIgnoreCase("30210-04.htm"))
		{
			st.takeItems(ALLTRANS_RECOMMEND1, 1);
			st.giveItems(NORMANS_INSTRUCTIONS, 1);
			st.giveItems(NORMANS_RECEIPT, 1);
		}
		else if(event.equalsIgnoreCase("30210-10.htm"))
		{
			st.takeItems(DUNINGS_KEY, -1);
			st.takeItems(NORMANS_INSTRUCTIONS, 1);
			st.giveItems(NORMANS_LIST, 1);
		}
		else if(event.equalsIgnoreCase("30688-02.htm"))
		{
			st.takeItems(NORMANS_RECEIPT, 1);
			st.giveItems(DUNINGS_INSTRUCTIONS, 1);
		}
		else if(event.equalsIgnoreCase("30298_2"))
		{
			if(st.getPlayer().getClassId().getId() == 0x36)
			{
				htmltext = "30298-04.htm";
				st.takeItems(ALLTRANS_RECOMMEND2, 1);
				st.giveItems(PINTERS_INSTRUCTIONS, 1);
			}
			else
			{
				htmltext = "30298-05.htm";
				st.takeItems(ALLTRANS_RECOMMEND2, 1);
				st.giveItems(RP_AMBER_BEAD, 1);
				st.giveItems(PINTERS_INSTRUCTIONS, 1);
			}
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		String htmltext = "no_quest.htm";
		State id = st.getState();
		int cond = 0;
		if(!id.equals(CREATED))
			cond = st.getInt("cond");
		if(npcId == VALKON)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getClassId().getId() == 0x36 || st.getPlayer().getClassId().getId() == 0x38)
				{
					if(st.getPlayer().getLevel() >= 35)
						if(st.getQuestItemsCount(MARK_OF_GUILDSMAN) > 0)
						{
							htmltext = "<html><body>This quest have already been completed.</body></html>";
							st.exitCurrentQuest(true);
						}
						else
							htmltext = "30103-03.htm";
					else
					{
						htmltext = "30103-02.htm";
						st.exitCurrentQuest(true);
					}
				}
				else
				{
					htmltext = "30103-01.htm";
					st.exitCurrentQuest(true);
				}
			}
			else if(cond == 2 && st.getQuestItemsCount(VALKONS_RECOMMEND) > 0)
				htmltext = "30103-07.htm";
			else if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) > 0)
				if(st.getQuestItemsCount(JOURNEYMAN_RING) < 7)
					htmltext = "30103-08.htm";
				else
					htmltext = "30103-09.htm";
		}
		else if(npcId == ALTRAN)
		{
			if(cond == 1 && st.getQuestItemsCount(VALKONS_RECOMMEND) > 0)
			{
				htmltext = "30283-01.htm";
				st.set("cond", "2");
			}
			else if(cond == 4 && st.getQuestItemsCount(VALKONS_RECOMMEND) > 0 && st.getQuestItemsCount(MANDRAGORA_BERRY) == 1)
				htmltext = "30283-02.htm";
			else if(cond < 6 && st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1 && st.getQuestItemsCount(JOURNEYMAN_RING) < 7)
				htmltext = "30283-04.htm";
			else if(cond == 6 && st.getQuestItemsCount(JOURNEYMAN_RING) == 7)
				htmltext = "30283-05.htm";
		}
		else if(npcId == NORMAN && cond >= 5)
		{
			if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1 && st.getQuestItemsCount(ALLTRANS_RECOMMEND1) == 1)
				htmltext = "30210-01.htm";
			else if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(NORMANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(NORMANS_RECEIPT) > 0)
				htmltext = "30210-05.htm";
			else if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(NORMANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(DUNINGS_INSTRUCTIONS) > 0)
				htmltext = "30210-06.htm";
			else if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(NORMANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(DUNINGS_KEY) >= 30)
				htmltext = "30210-07.htm";
			else if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(NORMANS_LIST) > 0)
			{
				if(st.getQuestItemsCount(GRAY_BONE_POWDER) >= 70 && st.getQuestItemsCount(GRANITE_WHETSTONE) >= 70 && st.getQuestItemsCount(RED_PIGMENT) >= 70 && st.getQuestItemsCount(BRAIDED_YARN) >= 70)
				{
					htmltext = "30210-12.htm";
					st.takeItems(NORMANS_LIST, 1);
					st.takeItems(GRAY_BONE_POWDER, -1);
					st.takeItems(GRANITE_WHETSTONE, -1);
					st.takeItems(RED_PIGMENT, -1);
					st.takeItems(BRAIDED_YARN, -1);
					st.giveItems(JOURNEYMAN_GEM, 7);
					if(st.getQuestItemsCount(JOURNEYMAN_DECO_BEADS) == 7 && st.getQuestItemsCount(JOURNEYMAN_GEM) == 7)
						st.set("cond", "6");
				}
				else
					htmltext = "30210-11.htm";
			}
			else if(st.getQuestItemsCount(NORMANS_INSTRUCTIONS) == 0 && st.getQuestItemsCount(NORMANS_LIST) == 0 && st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1 && (st.getQuestItemsCount(JOURNEYMAN_GEM) > 0 || st.getQuestItemsCount(JOURNEYMAN_RING) > 0))
				htmltext = "30210-13.htm";
		}
		else if(npcId == DUNING && cond >= 5)
		{
			if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(NORMANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(NORMANS_RECEIPT) > 0)
				htmltext = "30688-01.htm";
			else if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(NORMANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(DUNINGS_INSTRUCTIONS) > 0)
				htmltext = "30688-03.htm";
			else if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(NORMANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(DUNINGS_KEY) == 30)
				htmltext = "30688-04.htm";
			else if(st.getQuestItemsCount(NORMANS_RECEIPT) == 0 && st.getQuestItemsCount(DUNINGS_INSTRUCTIONS) == 0 && st.getQuestItemsCount(DUNINGS_KEY) == 0 && st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1)
				htmltext = "30688-01.htm";
		}
		else if(npcId == PINTER && cond >= 5)
		{
			if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(ALLTRANS_RECOMMEND2) > 0)
				if(st.getPlayer().getLevel() < 36)
					htmltext = "30298-01.htm";
				else
					htmltext = "30298-02.htm";
			else if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(PINTERS_INSTRUCTIONS) > 0)
				if(st.getQuestItemsCount(AMBER_BEAD) < 70)
					htmltext = "30298-06.htm";
				else
				{
					htmltext = "30298-07.htm";
					st.takeItems(PINTERS_INSTRUCTIONS, 1);
					st.takeItems(AMBER_BEAD, -1);
					st.takeItems(RP_AMBER_BEAD, -1);
					st.takeItems(AMBER_LUMP, -1);
					st.giveItems(JOURNEYMAN_DECO_BEADS, 7);
					if(st.getQuestItemsCount(JOURNEYMAN_DECO_BEADS) == 7 && st.getQuestItemsCount(JOURNEYMAN_GEM) == 7)
						st.set("cond", "6");
				}
			else if(st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) == 1 && st.getQuestItemsCount(PINTERS_INSTRUCTIONS) == 0 && (st.getQuestItemsCount(JOURNEYMAN_DECO_BEADS) > 0 || st.getQuestItemsCount(JOURNEYMAN_RING) > 0))
				htmltext = "30298-08.htm";
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		for(int i = 0; i < DROPLIST_COND.length; i++)
		{
			if(cond == DROPLIST_COND[i][0] && npcId == DROPLIST_COND[i][2])
				if((DROPLIST_COND[i][3] == 0) || (st.getQuestItemsCount(DROPLIST_COND[i][3]) > 0))
				{
					int count = st.getQuestItemsCount(DROPLIST_COND[i][4]);
					if(DROPLIST_COND[i][5] > count && Rnd.chance(DROPLIST_COND[i][6]))
					{
						int random = 0;
						if(DROPLIST_COND[i][7] > 1)
						{
							random = Rnd.get(DROPLIST_COND[i][7]) + 1;
							if(count + random > DROPLIST_COND[i][5])
								random = DROPLIST_COND[i][5] - count;
						}
						else
							random = 1;
						st.giveItems(DROPLIST_COND[i][4], random);
						if(count + random == DROPLIST_COND[i][5])
						{
							if(DROPLIST_COND[i][4] == DUNINGS_KEY)
								st.takeItems(DUNINGS_INSTRUCTIONS, 1);
							st.playSound("Itemsound.quest_middle");
							if(DROPLIST_COND[i][1] != 0)
							{
								st.setState(STARTED);
								st.set("cond", String.valueOf(DROPLIST_COND[i][1]));
							}
						}
						else
							st.playSound("Itemsound.quest_itemget");
					}
				}
		}
		if(cond == 5 && (npcId == 20079 || npcId == 20080 || npcId == 20081))
			if(Rnd.chance(50) && st.getQuestItemsCount(ALLTRANS_INSTRUCTIONS) > 0 && st.getQuestItemsCount(PINTERS_INSTRUCTIONS) > 0)
			{
				int count = st.getQuestItemsCount(AMBER_BEAD) + st.getQuestItemsCount(AMBER_LUMP) * 5;
				if(count < 70 && st.getPlayer().getClassId().getId() == 0x36)
				{
					st.giveItems(AMBER_BEAD, 1);
					if(st.getQuestItemsCount(AMBER_BEAD) == 70)
						st.playSound("Itemsound.quest_middle");
					else
						st.playSound("Itemsound.quest_itemget");
				}
				if(count < 70 && st.getPlayer().getClassId().getId() == 0x38)
				{
					st.giveItems(AMBER_LUMP, 1);
					count = st.getQuestItemsCount(AMBER_BEAD) + st.getQuestItemsCount(AMBER_LUMP) * 5;
					if(count == 70)
						st.playSound("Itemsound.quest_middle");
					else
						st.playSound("Itemsound.quest_itemget");
				}
			}
		return null;
	}
}
