package quests._271_ProofofValor;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _271_ProofofValor extends Quest implements ScriptFile
{
	//NPC
	public final int RUKAIN = 30577;
	//Quest Item
	public final int KASHA_WOLF_FANG_ID = 1473;
	public final int NECKLACE_OF_VALOR_ID = 1507;
	public final int NECKLACE_OF_COURAGE_ID = 1506;
	//Drop Cond
	//# [COND, NEWCOND, ID, REQUIRED, ITEM, NEED_COUNT, CHANCE, DROP]	
	public final int[][] DROPLIST_COND = { {
			1, 2, 20475, 0, KASHA_WOLF_FANG_ID, 50, 25, 2 } };

	//Main
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 271: Proof of Valor");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _271_ProofofValor()
	{
		super(271, "_271_ProofofValor", "Proof of Valor", false);
		setInitialState(CREATED);
		addStartNpc(RUKAIN);
		addTalkId(RUKAIN);
		addTalkId(RUKAIN);
		addTalkId(RUKAIN);

		//Mob Drop
		for(int i = 0; i < DROPLIST_COND.length; i++)
		{
			addKillId(DROPLIST_COND[i][2]);
			STARTED.addQuestDrop(DROPLIST_COND[i][2], DROPLIST_COND[i][4], 1);
		}
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("1"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
			if(st.getQuestItemsCount(NECKLACE_OF_COURAGE_ID) > 0 || st.getQuestItemsCount(NECKLACE_OF_VALOR_ID) > 0)
				htmltext = "30577-07.htm";
			else
				htmltext = "30577-03.htm";
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		String htmltext = "no_quest.htm";
		State id = st.getState();
		int cond = 0;
		if(!id.equals(CREATED))
			cond = st.getInt("cond");
		if(npcId == RUKAIN)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getRace().ordinal() != 3)
				{
					htmltext = "30577-00.htm";
					st.exitCurrentQuest(true);
				}
				else if(st.getPlayer().getLevel() < 4)
				{
					htmltext = "30577-01.htm";
					st.exitCurrentQuest(true);
				}
				else if(st.getQuestItemsCount(NECKLACE_OF_COURAGE_ID) > 0 || st.getQuestItemsCount(NECKLACE_OF_VALOR_ID) > 0)
				{
					htmltext = "30577-06.htm";
					st.exitCurrentQuest(true);
				}
				else
					htmltext = "30577-02.htm";
			}
			else if(cond == 1)
				htmltext = "30577-04.htm";
			else if(cond == 2 && st.getQuestItemsCount(KASHA_WOLF_FANG_ID) == 50)
			{
				st.takeItems(KASHA_WOLF_FANG_ID, -1);
				if(Rnd.chance(13))
					st.giveItems(NECKLACE_OF_VALOR_ID, 1);
				else
					st.giveItems(NECKLACE_OF_COURAGE_ID, 1);
				htmltext = "30577-05.htm";
				st.exitCurrentQuest(true);
			}
			else if(cond == 2 && st.getQuestItemsCount(KASHA_WOLF_FANG_ID) < 50)
			{
				htmltext = "30577-04.htm";
				st.set("cond", "1");
				st.setState(STARTED);
			}
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		for(int i = 0; i < DROPLIST_COND.length; i++)
		{
			if(cond == DROPLIST_COND[i][0] && npcId == DROPLIST_COND[i][2])
				if((DROPLIST_COND[i][3] == 0) || (st.getQuestItemsCount(DROPLIST_COND[i][3]) > 0))
				{
					int count = st.getQuestItemsCount(DROPLIST_COND[i][4]);
					if(DROPLIST_COND[i][5] > count && Rnd.chance(DROPLIST_COND[i][6]))
					{
						int random = 0;
						if(DROPLIST_COND[i][7] > 1)
						{
							random = Rnd.get(DROPLIST_COND[i][7]) + 1;
							if(count + random > DROPLIST_COND[i][5])
								random = DROPLIST_COND[i][5] - count;
						}
						else
							random = 1;
						st.giveItems(DROPLIST_COND[i][4], random);
						if(count + random == DROPLIST_COND[i][5])
						{
							st.playSound("Itemsound.quest_middle");
							if(DROPLIST_COND[i][1] != 0)
							{
								st.setState(STARTED);
								st.set("cond", String.valueOf(DROPLIST_COND[i][1]));
							}
						}
						else
							st.playSound("Itemsound.quest_itemget");
					}
				}
		}
		return null;
	}
}
