package quests._295_DreamsOfTheSkies;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _295_DreamsOfTheSkies extends Quest implements ScriptFile
{
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);

	public static int FLOATING_STONE = 1492;
	public static int RING_OF_FIREFLY = 1509;
	public static int ADENA = 57;

	public static int Arin = 30536;
	public static int MagicalWeaver = 20153;

	public void onLoad()
	{
		System.out.println("Loaded Quest: 295: Dreams Of The Skies");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _295_DreamsOfTheSkies()
	{
		super(295, "_295_DreamsOfTheSkies", "Dreams Of The Skies", false);
		setInitialState(CREATED);

		addStartNpc(Arin);
		addTalkId(Arin);
		addKillId(MagicalWeaver);

		STARTED.addQuestDrop(MagicalWeaver, FLOATING_STONE, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30536-03.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		State id = st.getState();

		if(id.equals(CREATED))
			st.set("cond", "0");
		int cond = st.getInt("cond");
		if(cond == 0)
		{
			if(st.getPlayer().getLevel() >= 11)
			{
				htmltext = "30536-02.htm";
				return htmltext;
			}
			htmltext = "30536-01.htm";
			st.exitCurrentQuest(true);
		}
		else if(cond == 1 || st.getQuestItemsCount(FLOATING_STONE) < 50)
			htmltext = "30536-04.htm";
		else if(cond == 2 && st.getQuestItemsCount(FLOATING_STONE) == 50)
		{
			st.addExpAndSp(0, 500);
			st.playSound("ItemSound.quest_finish");
			st.exitCurrentQuest(true);
			if(st.getQuestItemsCount(RING_OF_FIREFLY) < 1)
			{
				htmltext = "30536-05.htm";
				st.giveItems(RING_OF_FIREFLY, 1);
			}
			else
			{
				htmltext = "30536-06.htm";
				st.giveItems(ADENA, 2400);
			}
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getInt("cond") == 1 && st.getQuestItemsCount(FLOATING_STONE) < 50)
		{
			if(Rnd.get(100) > 25)
			{
				st.giveItems(FLOATING_STONE, 1);
				if(st.getQuestItemsCount(FLOATING_STONE) == 50)
				{
					st.playSound("ItemSound.quest_middle");
					st.set("cond", "2");
				}
				else
					st.playSound("ItemSound.quest_itemget");
			}
			else
			{
				if(st.getQuestItemsCount(FLOATING_STONE) >= 48)
				{
					st.giveItems(FLOATING_STONE, 50 - st.getQuestItemsCount(FLOATING_STONE));
					st.playSound("ItemSound.quest_middle");
					st.set("cond", "2");
				}
				else
				{
					st.giveItems(FLOATING_STONE, 2);
					st.playSound("ItemSound.quest_itemget");
				}
			}
		}
		return null;
	}
}