package quests._303_CollectArrowheads;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _303_CollectArrowheads extends Quest implements ScriptFile
{
	int ORCISH_ARROWHEAD = 963;
	int ADENA = 57;

	public State CREATED = new State("Start", this);
	public State STARTING = new State("Starting", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);
	public State ABORTED = new State("Aborted", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 303: Collect Arrowheads");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _303_CollectArrowheads()
	{
		super(303, "_303_CollectArrowheads", "Collect Arrowheads", false);
		setInitialState(CREATED);
		addStartNpc(30029);

		addTalkId(30029);
		addTalkId(30029);
		addTalkId(30029);

		addKillId(20361);
		STARTED.addQuestDrop(20361, ORCISH_ARROWHEAD, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30029-04.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "no_quest.htm";
		int cond = st.getInt("cond");

		if(cond == 0)
			if(st.getPlayer().getLevel() >= 10)
				htmltext = "30029-03.htm";
			else
			{
				htmltext = "30029-02.htm";
				st.exitCurrentQuest(true);
			}
		else if(st.getQuestItemsCount(ORCISH_ARROWHEAD) < 10)
			htmltext = "30029-05.htm";
		else
		{
			st.takeItems(ORCISH_ARROWHEAD, -1);
			st.giveItems(ADENA, 1000);
			st.addExpAndSp(2000, 200);
			st.set("kolq", String.valueOf(st.getInt("kolq") + 1));
			st.set("cond", "0");
			st.setState(COMPLETED);
			htmltext = "30029-06.htm";
			st.playSound("ItemSound.quest_finish");
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getQuestItemsCount(ORCISH_ARROWHEAD) < 10 && Rnd.chance(40))
		{
			st.giveItems(ORCISH_ARROWHEAD, 1);
			if(st.getQuestItemsCount(ORCISH_ARROWHEAD) == 10)
			{
				st.set("cond", "2");
				st.playSound("ItemSound.quest_middle");
			}
			else
				st.playSound("ItemSound.quest_itemget");
		}
		return null;
	}
}