package quests._363_SorrowfulSoundofFlute;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _363_SorrowfulSoundofFlute extends Quest implements ScriptFile
{
	//NPC
	public final int NANARIN = 30956;
	public final int BARBADO = 30959;
	public final int POITAN = 30458;
	public final int HOLVAS = 30058;
	//Mobs

	//Quest Item
	public final int MUSICAL_SCORE = 4420;
	public final int EVENT_CLOTHES = 4318;
	public final int NANARINS_FLUTE = 4319;
	public final int SABRINS_BLACK_BEER = 4320;
	public final int Musical_Score = 4420;
	//Item

	//Main
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 363: Sorrowful Sound of Flute");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _363_SorrowfulSoundofFlute()
	{
		super(363, "_363_SorrowfulSoundofFlute", "Sorrowful Sound of Flute ", false);
		setInitialState(CREATED);
		addStartNpc(NANARIN);
		addTalkId(NANARIN);
		addTalkId(NANARIN);
		addTalkId(POITAN);
		addTalkId(HOLVAS);
		addTalkId(BARBADO);
		addTalkId(NANARIN);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30956_2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
			st.takeItems(EVENT_CLOTHES, -1);
			st.takeItems(NANARINS_FLUTE, -1);
			st.takeItems(SABRINS_BLACK_BEER, -1);
		}
		else if(event.equalsIgnoreCase("30956_4.htm"))
		{
			st.giveItems(NANARINS_FLUTE, 1);
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "3");
		}
		else if(event.equalsIgnoreCase("answer1"))
		{
			st.giveItems(EVENT_CLOTHES, 1);
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "3");
			htmltext = "30956_6.htm";
		}
		else if(event.equalsIgnoreCase("answer2"))
		{
			st.giveItems(SABRINS_BLACK_BEER, 1);
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "3");
			htmltext = "30956_6.htm";
		}
		else if(event.equalsIgnoreCase("30956_7.htm"))
		{
			st.giveItems(Musical_Score, 1);
			st.playSound("ItemSound.quest_finish");
			st.exitCurrentQuest(true);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		String htmltext = "no_quest.htm";
		State id = st.getState();
		int cond = 0;
		if(!id.equals(CREATED))
			cond = st.getInt("cond");
		if(npcId == NANARIN)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() < 20)
				{
					htmltext = "30956-00.htm";
					st.exitCurrentQuest(true);
				}
				else
					htmltext = "30956_1.htm";
			}
			else if(cond == 1)
				htmltext = "30956_8.htm";
			else if(cond == 2)
				htmltext = "30956_3.htm";
			else if(cond == 3)
				htmltext = "30956_6.htm";
			else if(cond == 4)
				htmltext = "30956_5.htm";
		}
		else if(npcId == BARBADO)
		{
			if(cond == 3)
			{
				if(st.getQuestItemsCount(EVENT_CLOTHES) > 0)
				{
					st.takeItems(EVENT_CLOTHES, -1);
					htmltext = "30959_2.htm";
					st.exitCurrentQuest(true);
				}
				else if(st.getQuestItemsCount(SABRINS_BLACK_BEER) > 0)
				{
					st.takeItems(SABRINS_BLACK_BEER, -1);
					htmltext = "30959_2.htm";
					st.exitCurrentQuest(true);
				}
				else
				{
					st.takeItems(NANARINS_FLUTE, -1);
					st.set("cond", "4");
					st.playSound("ItemSound.quest_middle");
					htmltext = "30959_1.htm";
				}
			}
			else if(cond == 4)
				htmltext = "30959_3.htm";
		}
		else if(npcId == HOLVAS && (cond == 1 || cond == 2))
		{
			st.set("cond", "2");
			if(Rnd.chance(5))
				htmltext = "30058_2.htm";
			else
				htmltext = "30058_1.htm";
		}
		else if(npcId == POITAN && (cond == 1 || cond == 2))
		{
			st.set("cond", "2");
			if(Rnd.chance(5))
				htmltext = "30458_2.htm";
			else
				htmltext = "30458_1.htm";
		}
		return htmltext;
	}

}
