package quests._375_WhisperOfDreams2;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;
import L2jFT.Config;

public class _375_WhisperOfDreams2 extends Quest implements ScriptFile
{
	private State CREATED = new State("Start", this);
	private State STARTED = new State("Started", this);
	int ALT_RP_100 = 0; //alternative rewards ? o_O
	public int CfgRate = (int) Config.RATE_QUESTS_REWARD;
	public int DROP_RATE = 20 * CfgRate;
	//NPCs
	int MANAKIA = 30515;
	//Quest items
	int MSTONE = 5887;
	int K_HORN = 5888;
	int CH_SKULL = 5889;
	//Quest collections
	int[] REWARDS = { 5348, 5352, 5350 };

	//Mobs & Drop
	int[][] DROPLIST = { { 20624, CH_SKULL }, { 20629, K_HORN } };

	//Messages
	String _default = "<html><head><body>I have nothing to say to you.</body></html>";

	public _375_WhisperOfDreams2()
	{
		super(375, "_375_WhisperOfDreams2", "Whisper Of Dreams 2", true);
		setInitialState(CREATED);
		addStartNpc(MANAKIA);
		addTalkId(MANAKIA);
		addTalkId(MANAKIA);
		if(DROP_RATE > 100)
			DROP_RATE = 100;
		addKillId(20624);
		addKillId(20629);
		STARTED.addQuestDrop(20624, DROPLIST[0][1], 1);
		STARTED.addQuestDrop(20629, DROPLIST[1][1], 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		if(event.equalsIgnoreCase("30515-6.htm"))
		{
			st.takeItems(MSTONE, 1);
			st.setState(STARTED);
			st.set("cond", "1");
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("30515-7.htm"))
		{
			st.playSound("ItemSound.quest_finish");
			st.exitCurrentQuest(true);
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = _default;
		State id = st.getState();
		if(id.equals(CREATED))
		{
			st.set("cond", "0");
			htmltext = "30515-1.htm";
			if(st.getPlayer().getLevel() < 60)
			{
				htmltext = "30515-2.htm";
				st.exitCurrentQuest(true);
			}
			else if(st.getQuestItemsCount(MSTONE) < 1)
			{
				htmltext = "30515-3.htm";
				st.exitCurrentQuest(true);
			}
		}
		else if(id.equals(STARTED))
			if(st.getQuestItemsCount(CH_SKULL) == st.getQuestItemsCount(K_HORN) && st.getQuestItemsCount(CH_SKULL) == 100)
			{
				st.takeItems(CH_SKULL, -1);
				st.takeItems(K_HORN, -1);
				int item = REWARDS[Rnd.get(REWARDS.length)];
				if(ALT_RP_100 > 0)
					item += 1;
				st.giveItems(item, 1);
				htmltext = "30515-4.htm";
				st.exitCurrentQuest(true);
			}
			else
				htmltext = "30515-5.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcid = npc.getNpcId();
		int item = 0;
		for(int[] element : DROPLIST)
			if(npcid == element[0])
				item = element[1];
		int count = st.getQuestItemsCount(item);
		if(count < 100 && Rnd.chance(DROP_RATE))
		{
			st.giveItems(item, 1);
			if(count + 1 >= 100)
				st.playSound("ItemSound.quest_middle");
			else
				st.playSound("ItemSound.quest_itemget");
		}
		return null;
	}

	public void onLoad()
	{
		System.out.println("Loaded Quest: 375: Whisper Of Dreams 2");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}