package quests._401_PathToWarrior;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _401_PathToWarrior extends Quest implements ScriptFile
{

	int AURON = 30010;
	int SIMPLON = 30253;

	int TRACKER_SKELETON = 20035;
	int POISON_SPIDER = 20038;
	int TRACKER_SKELETON_LD = 20042;
	int ARACHNID_TRACKER = 20043;

	int EINS_LETTER_ID = 1138;
	int WARRIOR_GUILD_MARK_ID = 1139;
	int RUSTED_BRONZE_SWORD1_ID = 1140;
	int RUSTED_BRONZE_SWORD2_ID = 1141;
	int SIMPLONS_LETTER_ID = 1143;
	int POISON_SPIDER_LEG2_ID = 1144;
	int MEDALLION_OF_WARRIOR_ID = 1145;
	int RUSTED_BRONZE_SWORD3_ID = 1142;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 401: Path to Warrior");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _401_PathToWarrior()
	{
		super(401, "_401_PathToWarrior", "Path to Warrior", false);
		setInitialState(CREATED);
		setInitialState(CREATED);
		addStartNpc(AURON);

		addTalkId(AURON);

		addTalkId(AURON);
		addTalkId(SIMPLON);

		addKillId(TRACKER_SKELETON);
		addKillId(POISON_SPIDER);
		addKillId(TRACKER_SKELETON_LD);
		addKillId(ARACHNID_TRACKER);

		STARTED.addQuestDrop(SIMPLON, SIMPLONS_LETTER_ID, 1);
		STARTED.addQuestDrop(SIMPLON, RUSTED_BRONZE_SWORD2_ID, 1);
		STARTED.addQuestDrop(AURON, EINS_LETTER_ID, 1);
		STARTED.addQuestDrop(SIMPLON, WARRIOR_GUILD_MARK_ID, 1);
		STARTED.addQuestDrop(TRACKER_SKELETON, RUSTED_BRONZE_SWORD1_ID, 1);
		STARTED.addQuestDrop(TRACKER_SKELETON_LD, RUSTED_BRONZE_SWORD1_ID, 1);
		STARTED.addQuestDrop(ARACHNID_TRACKER, POISON_SPIDER_LEG2_ID, 1);
		STARTED.addQuestDrop(POISON_SPIDER, POISON_SPIDER_LEG2_ID, 1);
		STARTED.addQuestDrop(AURON, RUSTED_BRONZE_SWORD3_ID, 1);

	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("401_1"))
		{
			if(st.getPlayer().getClassId().getId() == 0x00)
			{
				if(st.getPlayer().getLevel() >= 19)
				{
					if(st.getQuestItemsCount(MEDALLION_OF_WARRIOR_ID) > 0)
						htmltext = "30010-04.htm";
					else
						htmltext = "30010-05.htm";
				}
				else
					htmltext = "30010-02.htm";
			}
			else if(st.getPlayer().getClassId().getId() == 0x01)
				htmltext = "30010-02a.htm";
			else
				htmltext = "30010-03.htm";
		}
		else if(event.equalsIgnoreCase("401_2"))
			htmltext = "30010-10.htm";
		else if(event.equalsIgnoreCase("401_3"))
		{
			htmltext = "30010-11.htm";
			st.takeItems(SIMPLONS_LETTER_ID, 1);
			st.takeItems(RUSTED_BRONZE_SWORD2_ID, 1);
			st.giveItems(RUSTED_BRONZE_SWORD3_ID, 1);
			st.set("cond", "5");
		}
		else if(event.equalsIgnoreCase("1"))
		{
			if(st.getQuestItemsCount(EINS_LETTER_ID) == 0)
			{
				st.set("cond", "1");
				st.setState(STARTED);
				st.playSound("ItemSound.quest_accept");
				st.giveItems(EINS_LETTER_ID, 1);
				htmltext = "30010-06.htm";
			}
		}
		else if(event.equalsIgnoreCase("30253_1"))
		{
			htmltext = "30253-02.htm";
			st.takeItems(EINS_LETTER_ID, 1);
			st.giveItems(WARRIOR_GUILD_MARK_ID, 1);
			st.set("cond", "2");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		int cond = st.getInt("cond");
		if(id.equals(CREATED))
		{
			st.setState(STARTED);
			st.set("cond", "0");
		}
		if(npcId == AURON && cond == 0)
			htmltext = "30010-01.htm";
		else if(npcId == AURON && st.getQuestItemsCount(EINS_LETTER_ID) > 0)
			htmltext = "30010-07.htm";
		else if(npcId == AURON && st.getQuestItemsCount(WARRIOR_GUILD_MARK_ID) == 1)
			htmltext = "30010-08.htm";
		else if(npcId == SIMPLON && st.getQuestItemsCount(EINS_LETTER_ID) > 0)
			htmltext = "30253-01.htm";
		else if(npcId == SIMPLON && st.getQuestItemsCount(WARRIOR_GUILD_MARK_ID) > 0)
		{
			if(st.getQuestItemsCount(RUSTED_BRONZE_SWORD1_ID) < 1)
				htmltext = "30253-03.htm";
			else if(st.getQuestItemsCount(RUSTED_BRONZE_SWORD1_ID) < 10)
				htmltext = "30253-04.htm";
			else if(st.getQuestItemsCount(RUSTED_BRONZE_SWORD1_ID) >= 10)
			{
				st.takeItems(WARRIOR_GUILD_MARK_ID, -1);
				st.takeItems(RUSTED_BRONZE_SWORD1_ID, -1);
				st.giveItems(RUSTED_BRONZE_SWORD2_ID, 1);
				st.giveItems(SIMPLONS_LETTER_ID, 1);
				st.set("cond", "4");
				htmltext = "30253-05.htm";
			}
		}
		else if(npcId == SIMPLON && st.getQuestItemsCount(SIMPLONS_LETTER_ID) > 0)
			htmltext = "30253-06.htm";
		else if(npcId == AURON && st.getQuestItemsCount(SIMPLONS_LETTER_ID) > 0 && st.getQuestItemsCount(RUSTED_BRONZE_SWORD2_ID) > 0 && st.getQuestItemsCount(WARRIOR_GUILD_MARK_ID) == 0 && st.getQuestItemsCount(EINS_LETTER_ID) == 0)
			htmltext = "30010-09.htm";
		else if(npcId == AURON && st.getQuestItemsCount(RUSTED_BRONZE_SWORD3_ID) > 0 && st.getQuestItemsCount(WARRIOR_GUILD_MARK_ID) == 0 && st.getQuestItemsCount(EINS_LETTER_ID) == 0)
			if(st.getQuestItemsCount(POISON_SPIDER_LEG2_ID) < 20)
				htmltext = "30010-12.htm";
			else if(st.getQuestItemsCount(POISON_SPIDER_LEG2_ID) > 19)
			{
				st.takeItems(POISON_SPIDER_LEG2_ID, -1);
				st.takeItems(RUSTED_BRONZE_SWORD3_ID, -1);
				st.giveItems(MEDALLION_OF_WARRIOR_ID, 1);
				htmltext = "30010-13.htm";
				st.playSound("ItemSound.quest_finish");
				st.exitCurrentQuest(true);
			}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == TRACKER_SKELETON | npcId == TRACKER_SKELETON_LD)
		{
			if(cond == 2 && st.getQuestItemsCount(RUSTED_BRONZE_SWORD1_ID) < 10)
				if(Rnd.chance(40))
				{
					st.giveItems(RUSTED_BRONZE_SWORD1_ID, 1);
					if(st.getQuestItemsCount(RUSTED_BRONZE_SWORD1_ID) == 10)
					{
						st.playSound("ItemSound.quest_middle");
						st.set("cond", "3");
					}
					else
						st.playSound("ItemSound.quest_itemget");
				}
		}
		else if(npcId == ARACHNID_TRACKER | npcId == POISON_SPIDER)
			if(st.getQuestItemsCount(POISON_SPIDER_LEG2_ID) < 20 && st.getQuestItemsCount(RUSTED_BRONZE_SWORD3_ID) == 1 && st.getItemEquipped(7) == RUSTED_BRONZE_SWORD3_ID)
			{
				st.giveItems(POISON_SPIDER_LEG2_ID, 1);
				if(st.getQuestItemsCount(POISON_SPIDER_LEG2_ID) == 20)
				{
					st.playSound("ItemSound.quest_middle");
					st.set("cond", "6");
				}
				else
					st.playSound("ItemSound.quest_itemget");
			}
		return null;
	}
}