package quests._407_PathToElvenScout;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _407_PathToElvenScout extends Quest implements ScriptFile
{

	public final int REISA = 30328;
	public final int MORETTI = 30337;
	public final int PIPPEN = 30426;

	public final int OL_MAHUM_SENTRY = 27031;
	public final int OL_MAHUM_PATROL = 20053;

	public final short REORIA_LETTER2_ID = 1207;
	public final short PRIGUNS_TEAR_LETTER1_ID = 1208;
	public final short PRIGUNS_TEAR_LETTER2_ID = 1209;
	public final short PRIGUNS_TEAR_LETTER3_ID = 1210;
	public final short PRIGUNS_TEAR_LETTER4_ID = 1211;
	public final short MORETTIS_HERB_ID = 1212;
	public final short MORETTIS_LETTER_ID = 1214;
	public final short PRIGUNS_LETTER_ID = 1215;
	public final short MONORARY_GUARD_ID = 1216;
	public final short REORIA_RECOMMENDATION_ID = 1217;
	public final short RUSTED_KEY_ID = 1293;
	public final short HONORARY_GUARD_ID = 1216;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);
	public State ABORTED = new State("Aborted", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 407: Path to Elven Scout");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _407_PathToElvenScout()
	{
		super(407, "_407_PathToElvenScout", "Path To Elven Scout", false);
		setInitialState(CREATED);
		addStartNpc(REISA);
		addTalkId(REISA);
		addTalkId(REISA);
		addTalkId(MORETTI);
		addTalkId(PIPPEN);
		addTalkId(REISA);

		addKillId(OL_MAHUM_SENTRY);
		addKillId(OL_MAHUM_PATROL);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("1"))
		{
			if(st.getPlayer().getClassId().getId() == 0x12)
			{
				if(st.getPlayer().getLevel() >= 19)
				{
					if(st.getQuestItemsCount(REORIA_RECOMMENDATION_ID) > 0)
					{
						htmltext = "30328-04.htm";
						st.exitCurrentQuest(true);
					}
					else
					{
						htmltext = "30328-05.htm";
						st.giveItems(REORIA_LETTER2_ID, 1);
						st.set("cond", "1");
						st.setState(STARTED);
						st.playSound("ItemSound.quest_accept");
					}
				}
				else
				{
					htmltext = "30328-03.htm";
					st.exitCurrentQuest(true);
				}
			}
			else if(st.getPlayer().getClassId().getId() == 0x16)
			{
				htmltext = "30328-02a.htm";
				st.exitCurrentQuest(true);
			}
			else
			{
				htmltext = "30328-02.htm";
				st.exitCurrentQuest(true);
			}
		}
		else if(event.equalsIgnoreCase("30337_1"))
		{
			st.takeItems(REORIA_LETTER2_ID, 1);
			st.set("cond", "2");
			htmltext = "30337-03.htm";
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		String htmltext = "no_quest.htm";
		State id = st.getState();
		int cond = 0;
		if(!id.equals(CREATED))
			cond = st.getInt("cond");
		if(npcId == REISA)
		{
			if(cond == 0)
				htmltext = "30328-01.htm";
			else if(cond == 1)
				htmltext = "30328-06.htm";
			else if(cond > 1 && st.getQuestItemsCount(HONORARY_GUARD_ID) == 0)
				htmltext = "30328-08.htm";
			else if(cond == 8 && st.getQuestItemsCount(HONORARY_GUARD_ID) == 1)
			{
				htmltext = "30328-07.htm";
				st.takeItems(HONORARY_GUARD_ID, 1);
				st.giveItems(REORIA_RECOMMENDATION_ID, 1);
				st.playSound("ItemSound.quest_finish");
				st.exitCurrentQuest(true);
			}
		}
		else if(npcId == MORETTI)
		{
			if(cond == 1)
				htmltext = "30337-01.htm";
			else if(cond == 2)
				htmltext = "30337-04.htm";
			else if(cond == 3)
			{
				if(st.getQuestItemsCount(PRIGUNS_TEAR_LETTER1_ID) == 1 && st.getQuestItemsCount(PRIGUNS_TEAR_LETTER2_ID) == 1 && st.getQuestItemsCount(PRIGUNS_TEAR_LETTER3_ID) == 1 && st.getQuestItemsCount(PRIGUNS_TEAR_LETTER4_ID) == 1)
				{
					htmltext = "30337-06.htm";
					st.takeItems(PRIGUNS_TEAR_LETTER1_ID, 1);
					st.takeItems(PRIGUNS_TEAR_LETTER2_ID, 1);
					st.takeItems(PRIGUNS_TEAR_LETTER3_ID, 1);
					st.takeItems(PRIGUNS_TEAR_LETTER4_ID, 1);
					st.giveItems(MORETTIS_HERB_ID, 1);
					st.giveItems(MORETTIS_LETTER_ID, 1);
					st.set("cond", "4");
				}
				else
					htmltext = "30337-05.htm";
			}
			else if(cond == 7 && st.getQuestItemsCount(PRIGUNS_LETTER_ID) == 1)
			{
				htmltext = "30337-07.htm";
				st.takeItems(PRIGUNS_LETTER_ID, 1);
				st.giveItems(HONORARY_GUARD_ID, 1);
				st.set("cond", "8");
			}
			else if(cond > 8)
				htmltext = "30337-08.htm";
		}
		else if(npcId == PIPPEN)
			if(cond == 4)
			{
				htmltext = "30426-01.htm";
				st.set("cond", "5");
			}
			else if(cond == 5)
				htmltext = "30426-01.htm";
			else if(cond == 6 && st.getQuestItemsCount(RUSTED_KEY_ID) == 1 && st.getQuestItemsCount(MORETTIS_HERB_ID) == 1 && st.getQuestItemsCount(MORETTIS_LETTER_ID) == 1)
			{
				htmltext = "30426-02.htm";
				st.takeItems(RUSTED_KEY_ID, 1);
				st.takeItems(MORETTIS_HERB_ID, 1);
				st.takeItems(MORETTIS_LETTER_ID, 1);
				st.giveItems(PRIGUNS_LETTER_ID, 1);
				st.set("cond", "7");
			}
			else if(cond == 7)
				htmltext = "30426-04.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == OL_MAHUM_PATROL && cond == 2)
		{
			if(st.getQuestItemsCount(PRIGUNS_TEAR_LETTER1_ID) == 0)
			{
				st.giveItems(PRIGUNS_TEAR_LETTER1_ID, 1);
				st.playSound("ItemSound.quest_itemget");
				return null;
			}
			if(st.getQuestItemsCount(PRIGUNS_TEAR_LETTER2_ID) == 0)
			{
				st.giveItems(PRIGUNS_TEAR_LETTER2_ID, 1);
				st.playSound("ItemSound.quest_itemget");
				return null;
			}
			if(st.getQuestItemsCount(PRIGUNS_TEAR_LETTER3_ID) == 0)
			{
				st.giveItems(PRIGUNS_TEAR_LETTER3_ID, 1);
				st.playSound("ItemSound.quest_itemget");
				return null;
			}
			if(st.getQuestItemsCount(PRIGUNS_TEAR_LETTER4_ID) == 0)
			{
				st.giveItems(PRIGUNS_TEAR_LETTER4_ID, 1);
				st.playSound("ItemSound.quest_middle");
				st.set("cond", "3");
				return null;
			}
		}
		else if(npcId == OL_MAHUM_SENTRY && cond == 5 && Rnd.chance(5))
		{
			st.giveItems(RUSTED_KEY_ID, 1);
			st.playSound("ItemSound.quest_middle");
			st.set("cond", "6");

		}
		return null;
	}
}
