package quests._408_PathToElvenwizard;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _408_PathToElvenwizard extends Quest implements ScriptFile
{
	//npc
	public final int GREENIS = 30157;
	public final int THALIA = 30371;
	public final int ROSELLA = 30414;
	public final int NORTHWIND = 30423;
	//mobs
	public final int DRYAD_ELDER = 20019;
	public final int PINCER_SPIDER = 20466;
	public final int SUKAR_WERERAT_LEADER = 20047;
	//items
	public final int ROGELLIAS_LETTER_ID = 1218;
	public final int RED_DOWN_ID = 1219;
	public final int MAGICAL_POWERS_RUBY_ID = 1220;
	public final int PURE_AQUAMARINE_ID = 1221;
	public final int APPETIZING_APPLE_ID = 1222;
	public final int GOLD_LEAVES_ID = 1223;
	public final int IMMORTAL_LOVE_ID = 1224;
	public final int AMETHYST_ID = 1225;
	public final int NOBILITY_AMETHYST_ID = 1226;
	public final int FERTILITY_PERIDOT_ID = 1229;
	public final int ETERNITY_DIAMOND_ID = 1230;
	public final int CHARM_OF_GRAIN_ID = 1272;
	public final int SAP_OF_WORLD_TREE_ID = 1273;
	public final int LUCKY_POTPOURI_ID = 1274;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 408: Path to Elven Wizard");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _408_PathToElvenwizard()
	{
		super(408, "_408_PathToElvenwizard", "Path to Elven Wizard", false);
		setInitialState(CREATED);
		addStartNpc(ROSELLA);

		addTalkId(GREENIS);
		addTalkId(THALIA);
		addTalkId(ROSELLA);
		addTalkId(NORTHWIND);

		addKillId(DRYAD_ELDER);
		addKillId(PINCER_SPIDER);
		addKillId(SUKAR_WERERAT_LEADER);

		STARTED.addQuestDrop(ROSELLA, ROGELLIAS_LETTER_ID, 1);
		STARTED.addQuestDrop(ROSELLA, FERTILITY_PERIDOT_ID, 1);
		STARTED.addQuestDrop(ROSELLA, IMMORTAL_LOVE_ID, 1);
		STARTED.addQuestDrop(ROSELLA, APPETIZING_APPLE_ID, 1);
		STARTED.addQuestDrop(GREENIS, CHARM_OF_GRAIN_ID, 1);
		STARTED.addQuestDrop(GREENIS, MAGICAL_POWERS_RUBY_ID, 1);
		STARTED.addQuestDrop(THALIA, SAP_OF_WORLD_TREE_ID, 1);
		STARTED.addQuestDrop(THALIA, PURE_AQUAMARINE_ID, 1);
		STARTED.addQuestDrop(NORTHWIND, LUCKY_POTPOURI_ID, 1);
		STARTED.addQuestDrop(NORTHWIND, NOBILITY_AMETHYST_ID, 1);
		STARTED.addQuestDrop(DRYAD_ELDER, GOLD_LEAVES_ID, 1);
		STARTED.addQuestDrop(PINCER_SPIDER, RED_DOWN_ID, 1);
		STARTED.addQuestDrop(SUKAR_WERERAT_LEADER, AMETHYST_ID, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("1"))
		{
			if(st.getPlayer().getClassId().getId() != 0x19)
			{
				if(st.getPlayer().getClassId().getId() == 0x1a)
					htmltext = "30414-02a.htm";
				else
					htmltext = "30414-03.htm";
			}
			else if(st.getPlayer().getLevel() < 19)
				htmltext = "30414-04.htm";
			else if(st.getQuestItemsCount(ETERNITY_DIAMOND_ID) > 0)
				htmltext = "30414-05.htm";
			else
			{
				st.setState(STARTED);
				st.set("cond", "1");
				st.playSound("ItemSound.quest_accept");
				st.giveItems(FERTILITY_PERIDOT_ID, 1);
				htmltext = "30414-06.htm";
			}
		}
		else if(event.equalsIgnoreCase("408_1"))
		{
			if(st.getQuestItemsCount(MAGICAL_POWERS_RUBY_ID) > 0)
				htmltext = "30414-10.htm";
			else if(st.getQuestItemsCount(MAGICAL_POWERS_RUBY_ID) < 1 && st.getQuestItemsCount(FERTILITY_PERIDOT_ID) > 0)
			{
				st.giveItems(ROGELLIAS_LETTER_ID, 1);
				htmltext = "30414-07.htm";
			}
		}
		else if(event.equalsIgnoreCase("408_4"))
		{
			if(st.getQuestItemsCount(ROGELLIAS_LETTER_ID) > 0)
			{
				st.takeItems(ROGELLIAS_LETTER_ID, -1);
				st.giveItems(CHARM_OF_GRAIN_ID, 1);
				htmltext = "30157-02.htm";
			}
		}
		else if(event.equalsIgnoreCase("408_2"))
		{
			if(st.getQuestItemsCount(PURE_AQUAMARINE_ID) > 0)
				htmltext = "30414-13.htm";
			else if(st.getQuestItemsCount(PURE_AQUAMARINE_ID) < 1 && st.getQuestItemsCount(FERTILITY_PERIDOT_ID) > 0)
			{
				st.giveItems(APPETIZING_APPLE_ID, 1);
				htmltext = "30414-14.htm";
			}
		}
		else if(event.equalsIgnoreCase("408_5"))
		{
			if(st.getQuestItemsCount(APPETIZING_APPLE_ID) > 0)
			{
				st.takeItems(APPETIZING_APPLE_ID, -1);
				st.giveItems(SAP_OF_WORLD_TREE_ID, 1);
				htmltext = "30371-02.htm";
			}
		}
		else if(event.equalsIgnoreCase("408_3"))
			if(st.getQuestItemsCount(NOBILITY_AMETHYST_ID) > 0)
				htmltext = "30414-17.htm";
			else if(st.getQuestItemsCount(NOBILITY_AMETHYST_ID) < 1 && st.getQuestItemsCount(FERTILITY_PERIDOT_ID) > 0)
			{
				st.giveItems(IMMORTAL_LOVE_ID, 1);
				htmltext = "30414-18.htm";
			}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == ROSELLA)
		{
			if(cond < 1)
				htmltext = "30414-01.htm";
			else if(st.getQuestItemsCount(CHARM_OF_GRAIN_ID) > 0)
			{
				if(st.getQuestItemsCount(RED_DOWN_ID) < 5)
					htmltext = "30414-09.htm";
				else if(st.getQuestItemsCount(RED_DOWN_ID) > 4)
					htmltext = "30414-25.htm";
				else if(st.getQuestItemsCount(GOLD_LEAVES_ID) > 4)
					htmltext = "30414-26.htm";
			}
			else if(st.getQuestItemsCount(APPETIZING_APPLE_ID) > 0)
				htmltext = "30414-15.htm";
			else if(st.getQuestItemsCount(IMMORTAL_LOVE_ID) > 0)
				htmltext = "30414-19.htm";
			else if(st.getQuestItemsCount(SAP_OF_WORLD_TREE_ID) > 0 && st.getQuestItemsCount(GOLD_LEAVES_ID) < 5)
				htmltext = "30414-16.htm";
			else if(st.getQuestItemsCount(LUCKY_POTPOURI_ID) > 0)
			{
				if(st.getQuestItemsCount(AMETHYST_ID) < 2)
					htmltext = "30414-20.htm";
				else
					htmltext = "30414-27.htm";
			}
			else if(st.getQuestItemsCount(ROGELLIAS_LETTER_ID) > 0)
				htmltext = "30414-08.htm";
			else if(st.getQuestItemsCount(ROGELLIAS_LETTER_ID) < 1 && st.getQuestItemsCount(APPETIZING_APPLE_ID) < 1 && st.getQuestItemsCount(IMMORTAL_LOVE_ID) < 1 && st.getQuestItemsCount(CHARM_OF_GRAIN_ID) < 1 && st.getQuestItemsCount(SAP_OF_WORLD_TREE_ID) < 1 && st.getQuestItemsCount(LUCKY_POTPOURI_ID) < 1 && st.getQuestItemsCount(FERTILITY_PERIDOT_ID) > 0)
				if(st.getQuestItemsCount(MAGICAL_POWERS_RUBY_ID) < 1 | st.getQuestItemsCount(NOBILITY_AMETHYST_ID) < 1 | st.getQuestItemsCount(PURE_AQUAMARINE_ID) < 1)
					htmltext = "30414-11.htm";
				else if(st.getQuestItemsCount(MAGICAL_POWERS_RUBY_ID) > 0 && st.getQuestItemsCount(NOBILITY_AMETHYST_ID) > 0 && st.getQuestItemsCount(PURE_AQUAMARINE_ID) > 0)
				{
					st.takeItems(MAGICAL_POWERS_RUBY_ID, -1);
					st.takeItems(PURE_AQUAMARINE_ID, st.getQuestItemsCount(PURE_AQUAMARINE_ID));
					st.takeItems(NOBILITY_AMETHYST_ID, st.getQuestItemsCount(NOBILITY_AMETHYST_ID));
					st.takeItems(FERTILITY_PERIDOT_ID, st.getQuestItemsCount(FERTILITY_PERIDOT_ID));
					htmltext = "30414-24.htm";
					st.playSound("ItemSound.quest_finish");
					st.exitCurrentQuest(true);
					st.giveItems(ETERNITY_DIAMOND_ID, 1);
				}
		}
		else if(npcId == GREENIS && cond > 0)
		{
			if(st.getQuestItemsCount(ROGELLIAS_LETTER_ID) > 0)
				htmltext = "30157-01.htm";
			else if(st.getQuestItemsCount(CHARM_OF_GRAIN_ID) > 0)
				if(st.getQuestItemsCount(RED_DOWN_ID) < 5)
					htmltext = "30157-03.htm";
				else
				{
					st.takeItems(RED_DOWN_ID, -1);
					st.takeItems(CHARM_OF_GRAIN_ID, -1);
					st.giveItems(MAGICAL_POWERS_RUBY_ID, 1);
					htmltext = "30157-04.htm";
				}
		}
		else if(npcId == THALIA && cond > 0)
		{
			if(st.getQuestItemsCount(APPETIZING_APPLE_ID) > 0)
				htmltext = "30371-01.htm";
			else if(st.getQuestItemsCount(SAP_OF_WORLD_TREE_ID) > 0)
				if(st.getQuestItemsCount(GOLD_LEAVES_ID) < 5)
					htmltext = "30371-03.htm";
				else
				{
					st.takeItems(GOLD_LEAVES_ID, -1);
					st.takeItems(SAP_OF_WORLD_TREE_ID, -1);
					st.giveItems(PURE_AQUAMARINE_ID, 1);
					htmltext = "30371-04.htm";
				}
		}
		else if(npcId == NORTHWIND && cond > 0)
			if(st.getQuestItemsCount(IMMORTAL_LOVE_ID) > 0)
			{
				st.takeItems(IMMORTAL_LOVE_ID, -1);
				st.giveItems(LUCKY_POTPOURI_ID, 1);
				htmltext = "30423-01.htm";
			}
			else if(st.getQuestItemsCount(LUCKY_POTPOURI_ID) > 0)
				if(st.getQuestItemsCount(AMETHYST_ID) < 2)
					htmltext = "30423-02.htm";
				else
				{
					st.takeItems(AMETHYST_ID, -1);
					st.takeItems(LUCKY_POTPOURI_ID, -1);
					st.giveItems(NOBILITY_AMETHYST_ID, 1);
					htmltext = "30423-03.htm";
				}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == PINCER_SPIDER)
		{
			if(cond > 0 && st.getQuestItemsCount(CHARM_OF_GRAIN_ID) > 0 && st.getQuestItemsCount(RED_DOWN_ID) < 5 && Rnd.chance(7))
			{
				st.giveItems(RED_DOWN_ID, 1);
				if(st.getQuestItemsCount(RED_DOWN_ID) < 5)
					st.playSound("ItemSound.quest_itemget");
				else
					st.playSound("ItemSound.quest_middle");
			}
		}
		else if(npcId == DRYAD_ELDER)
		{
			if(cond > 0 && st.getQuestItemsCount(SAP_OF_WORLD_TREE_ID) > 0 && st.getQuestItemsCount(GOLD_LEAVES_ID) < 5 && Rnd.chance(4))
			{
				st.giveItems(GOLD_LEAVES_ID, 1);
				if(st.getQuestItemsCount(GOLD_LEAVES_ID) < 5)
					st.playSound("ItemSound.quest_itemget");
				else
					st.playSound("ItemSound.quest_middle");
			}
		}
		else if(npcId == SUKAR_WERERAT_LEADER)
			if(cond > 0 && st.getQuestItemsCount(LUCKY_POTPOURI_ID) > 0 && st.getQuestItemsCount(AMETHYST_ID) < 2 && Rnd.chance(4))
			{
				st.giveItems(AMETHYST_ID, 1);
				if(st.getQuestItemsCount(AMETHYST_ID) < 2)
					st.playSound("ItemSound.quest_itemget");
				else
					st.playSound("ItemSound.quest_middle");
			}
		return null;
	}
}