package quests._411_PathToAssassin;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _411_PathToAssassin extends Quest implements ScriptFile
{
	//npc
	public final int TRISKEL = 30416;
	public final int LEIKAN = 30382;
	public final int ARKENIA = 30419;
	//mobs
	public final int MOONSTONE_BEAST = 20369;
	public final int CALPICO = 27036;
	//items
	public final int SHILENS_CALL_ID = 1245;
	public final int ARKENIAS_LETTER_ID = 1246;
	public final int LEIKANS_NOTE_ID = 1247;
	public final int ONYX_BEASTS_MOLAR_ID = 1248;
	public final int LEIKANS_KNIFE_ID = 1249;
	public final int SHILENS_TEARS_ID = 1250;
	public final int ARKENIA_RECOMMEND_ID = 1251;
	public final int IRON_HEART_ID = 1252;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 411: Path to Assassin");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _411_PathToAssassin()
	{
		super(411, "_411_PathToAssassin", "Path to Assassin", false);
		setInitialState(CREATED);
		addStartNpc(TRISKEL);

		addTalkId(LEIKAN);
		addTalkId(TRISKEL);
		addTalkId(ARKENIA);

		addKillId(MOONSTONE_BEAST);
		addKillId(CALPICO);

		STARTED.addQuestDrop(TRISKEL, SHILENS_CALL_ID, 1);
		STARTED.addQuestDrop(LEIKAN, LEIKANS_NOTE_ID, 1);
		STARTED.addQuestDrop(LEIKAN, LEIKANS_KNIFE_ID, 1);
		STARTED.addQuestDrop(ARKENIA, ARKENIA_RECOMMEND_ID, 1);
		STARTED.addQuestDrop(ARKENIA, ARKENIAS_LETTER_ID, 1);
		STARTED.addQuestDrop(MOONSTONE_BEAST, ONYX_BEASTS_MOLAR_ID, 1);
		STARTED.addQuestDrop(CALPICO, SHILENS_TEARS_ID, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("1"))
		{
			if(st.getPlayer().getLevel() > 18 && st.getPlayer().getClassId().getId() == 0x1f && st.getQuestItemsCount(IRON_HEART_ID) < 1)
			{
				st.set("cond", "1");
				st.setState(STARTED);
				st.playSound("ItemSound.quest_accept");
				st.giveItems(SHILENS_CALL_ID, 1);
				htmltext = "30416-05.htm";
			}
			else if(st.getPlayer().getClassId().getId() != 0x1f)
			{
				if(st.getPlayer().getClassId().getId() == 0x23)
					htmltext = "30416-02a.htm";
				else
				{
					htmltext = "30416-02.htm";
					st.exitCurrentQuest(true);
				}
			}
			else if(st.getPlayer().getLevel() < 19 && st.getPlayer().getClassId().getId() == 0x1f)
			{
				htmltext = "30416-03.htm";
				st.exitCurrentQuest(true);
			}
			else if(st.getPlayer().getLevel() > 18 && st.getPlayer().getClassId().getId() == 0x1f && st.getQuestItemsCount(IRON_HEART_ID) > 0)
				htmltext = "30416-04.htm";
		}
		else if(event.equalsIgnoreCase("30419_1"))
		{
			htmltext = "30419-05.htm";
			st.takeItems(SHILENS_CALL_ID, -1);
			st.giveItems(ARKENIAS_LETTER_ID, 1);
			st.set("cond", "2");
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("30382_1"))
		{
			htmltext = "30382-03.htm";
			st.takeItems(ARKENIAS_LETTER_ID, -1);
			st.giveItems(LEIKANS_NOTE_ID, 1);
			st.set("cond", "3");
			st.playSound("ItemSound.quest_middle");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == TRISKEL)
		{
			if(cond < 1)
			{
				if(st.getQuestItemsCount(IRON_HEART_ID) < 1)
					htmltext = "30416-01.htm";
				else
					htmltext = "30416-04.htm";
			}
			else if(cond == 7)
			{
				htmltext = "30416-06.htm";
				st.takeItems(ARKENIA_RECOMMEND_ID, -1);
				st.exitCurrentQuest(true);
				st.giveItems(IRON_HEART_ID, 1);
				st.playSound("ItemSound.quest_finish");
			}
			else if(cond == 2)
				htmltext = "30416-07.htm";
			else if(cond == 1)
				htmltext = "30416-11.htm";
			else if(cond > 2 && cond < 7)
				if(cond > 2 && cond < 5)
					htmltext = "30416-08.htm";
				else if(cond > 4 && cond < 7)
					if(st.getQuestItemsCount(SHILENS_TEARS_ID) < 1)
						htmltext = "30416-09.htm";
					else
						htmltext = "30416-10.htm";
		}
		else if(npcId == ARKENIA)
		{
			if(cond == 1 && st.getQuestItemsCount(SHILENS_CALL_ID) > 0)
				htmltext = "30419-01.htm";
			else if(cond == 2 && st.getQuestItemsCount(ARKENIAS_LETTER_ID) > 0)
				htmltext = "30419-07.htm";
			else if(cond > 2 && cond < 5 && st.getQuestItemsCount(LEIKANS_NOTE_ID) > 0)
				htmltext = "30419-10.htm";
			else if(cond == 5 && st.getQuestItemsCount(LEIKANS_KNIFE_ID) > 0)
				htmltext = "30419-11.htm";
			else if(cond == 6 && st.getQuestItemsCount(SHILENS_TEARS_ID) > 0)
			{
				htmltext = "30419-08.htm";
				st.takeItems(SHILENS_TEARS_ID, -1);
				st.takeItems(LEIKANS_KNIFE_ID, -1);
				st.giveItems(ARKENIA_RECOMMEND_ID, 1);
				st.set("cond", "7");
				st.playSound("ItemSound.quest_middle");
			}
			else if(cond == 7)
				htmltext = "30419-09.htm";
		}
		else if(npcId == LEIKAN)
			if(cond == 2 && st.getQuestItemsCount(ARKENIAS_LETTER_ID) > 0)
				htmltext = "30382-01.htm";
			else if(cond > 2 && cond < 4 && st.getQuestItemsCount(ONYX_BEASTS_MOLAR_ID) < 1)
			{
				htmltext = "30382-05.htm";
				if(cond == 4)
					st.set("cond", "3");
			}
			else if(cond > 2 && cond < 4 && st.getQuestItemsCount(ONYX_BEASTS_MOLAR_ID) < 10)
			{
				htmltext = "30382-06.htm";
				if(cond == 4)
					st.set("cond", "3");
			}
			else if(cond == 4 && st.getQuestItemsCount(ONYX_BEASTS_MOLAR_ID) > 9)
			{
				htmltext = "30382-07.htm";
				st.takeItems(ONYX_BEASTS_MOLAR_ID, -1);
				st.takeItems(LEIKANS_NOTE_ID, -1);
				st.giveItems(LEIKANS_KNIFE_ID, 1);
				st.set("cond", "5");
				st.playSound("ItemSound.quest_middle");
			}
			else if(cond > 4 && cond < 7 && st.getQuestItemsCount(SHILENS_TEARS_ID) < 1)
			{
				htmltext = "30382-09.htm";
				if(cond == 6)
					st.set("cond", "5");
			}
			else if(cond == 6 && st.getQuestItemsCount(SHILENS_TEARS_ID) > 0)
				htmltext = "30382-08.htm";

		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == CALPICO)
		{
			if(cond == 5 && st.getQuestItemsCount(LEIKANS_KNIFE_ID) > 0 && st.getQuestItemsCount(SHILENS_TEARS_ID) < 1)
			{
				st.giveItems(SHILENS_TEARS_ID, 1);
				st.playSound("ItemSound.quest_middle");
				st.set("cond", "6");
			}
		}
		else if(npcId == MOONSTONE_BEAST)
			if(cond == 3 && st.getQuestItemsCount(LEIKANS_NOTE_ID) > 0 && st.getQuestItemsCount(ONYX_BEASTS_MOLAR_ID) < 10)
			{
				st.giveItems(ONYX_BEASTS_MOLAR_ID, 1);
				if(st.getQuestItemsCount(ONYX_BEASTS_MOLAR_ID) > 9)
				{
					st.playSound("ItemSound.quest_middle");
					st.set("cond", "4");
				}
				else
					st.playSound("ItemSound.quest_itemget");
			}
		return null;
	}
}