package quests._419_GetaPet;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _419_GetaPet extends Quest implements ScriptFile
{
	//NPC
	public final int PET_MANAGER_MARTIN = 30731;
	public final int GK_BELLA = 30256;
	public final int MC_ELLIE = 30091;
	public final int GD_METTY = 30072;

	//Mobs
	//1 humans
	public final int SPIDER_H1 = 20103; // Giant Spider
	public final int SPIDER_H2 = 20106; // Talon Spider
	public final int SPIDER_H3 = 20108; // Blade Spider
	//2 elves
	public final int SPIDER_LE1 = 20460; // Crimson Spider
	public final int SPIDER_LE2 = 20308; // Hook Spider
	public final int SPIDER_LE3 = 20466; // Pincer Spider
	//3 dark elves
	public final int SPIDER_DE1 = 20025; //Lesser Dark Horror
	public final int SPIDER_DE2 = 20105; // Dark Horror 
	public final int SPIDER_DE3 = 20034; // Prowler
	//4 orcs
	public final int SPIDER_O1 = 20474; // Kasha Spider
	public final int SPIDER_O2 = 20476; // Kasha Fang Spider
	public final int SPIDER_O3 = 20478; // Kasha Blade Spider
	//5 dwarves
	public final int SPIDER_D1 = 20403; // Hunter Tarantula
	public final int SPIDER_D2 = 20508; // Plunder Tarantula

	//Quest Item
	public final int REQUIRED_SPIDER_LEGS = 50;

	public final int ANIMAL_LOVERS_LIST1 = 3417;

	public final int ANIMAL_SLAYER_LIST1 = 3418;
	public final int ANIMAL_SLAYER_LIST2 = 3419;
	public final int ANIMAL_SLAYER_LIST3 = 3420;
	public final int ANIMAL_SLAYER_LIST4 = 3421;
	public final int ANIMAL_SLAYER_LIST5 = 3422;
	public final int SPIDER_LEG1 = 3423;
	public final int SPIDER_LEG2 = 3424;
	public final int SPIDER_LEG3 = 3425;
	public final int SPIDER_LEG4 = 3426;
	public final int SPIDER_LEG5 = 3427;

	public final int WOLF_COLLAR = 2375;

	//Chance
	public final int DROP_CHANCE_BUGBEAR_BLOOD_ID = 25;
	public final int DROP_CHANCE_FORBIDDEN_LOVE_SCROLL_ID = 3;
	public final int DROP_CHANCE_NECKLACE_OF_GRACE_ID = 4;
	public final int DROP_CHANCE_GOLD_BAR_ID = 10;

	//Drop Cond
	//# [COND, NEWCOND, ID, REQUIRED, ITEM, NEED_COUNT, CHANCE, DROP]	
	public final int[][] DROPLIST_COND = {
			{ 1, 0, SPIDER_H1, ANIMAL_SLAYER_LIST1, SPIDER_LEG1, 50, 100, 1 },
			{ 1, 0, SPIDER_H2, ANIMAL_SLAYER_LIST1, SPIDER_LEG1, 50, 100, 1 },
			{ 1, 0, SPIDER_H3, ANIMAL_SLAYER_LIST1, SPIDER_LEG1, 50, 100, 1 },
			{ 1, 0, SPIDER_LE1, ANIMAL_SLAYER_LIST2, SPIDER_LEG2, 50, 100, 1 },
			{ 1, 0, SPIDER_LE2, ANIMAL_SLAYER_LIST2, SPIDER_LEG2, 50, 100, 1 },
			{ 1, 0, SPIDER_LE3, ANIMAL_SLAYER_LIST2, SPIDER_LEG2, 50, 100, 1 },
			{ 1, 0, SPIDER_DE1, ANIMAL_SLAYER_LIST3, SPIDER_LEG3, 50, 100, 1 },
			{ 1, 0, SPIDER_DE2, ANIMAL_SLAYER_LIST3, SPIDER_LEG3, 50, 100, 1 },
			{ 1, 0, SPIDER_DE3, ANIMAL_SLAYER_LIST3, SPIDER_LEG3, 50, 100, 1 },
			{ 1, 0, SPIDER_O1, ANIMAL_SLAYER_LIST4, SPIDER_LEG4, 50, 100, 1 },
			{ 1, 0, SPIDER_O2, ANIMAL_SLAYER_LIST4, SPIDER_LEG4, 50, 100, 1 },
			{ 1, 0, SPIDER_O3, ANIMAL_SLAYER_LIST4, SPIDER_LEG4, 50, 100, 1 },
			{ 1, 0, SPIDER_D1, ANIMAL_SLAYER_LIST5, SPIDER_LEG5, 50, 100, 1 },
			{ 1, 0, SPIDER_D2, ANIMAL_SLAYER_LIST5, SPIDER_LEG5, 50, 100, 1 } };

	//Main
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 419: Get a Pet");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _419_GetaPet()
	{
		super(419, "_419_GetaPet", "Get a Pet", false);
		setInitialState(CREATED);
		addStartNpc(PET_MANAGER_MARTIN);
		addTalkId(PET_MANAGER_MARTIN);
		addTalkId(GK_BELLA);
		addTalkId(MC_ELLIE);
		addTalkId(GD_METTY);

		STARTED.addQuestDrop(PET_MANAGER_MARTIN, ANIMAL_LOVERS_LIST1, 1);
		STARTED.addQuestDrop(PET_MANAGER_MARTIN, ANIMAL_SLAYER_LIST1, 1);
		STARTED.addQuestDrop(PET_MANAGER_MARTIN, ANIMAL_SLAYER_LIST2, 1);
		STARTED.addQuestDrop(PET_MANAGER_MARTIN, ANIMAL_SLAYER_LIST3, 1);
		STARTED.addQuestDrop(PET_MANAGER_MARTIN, ANIMAL_SLAYER_LIST4, 1);
		STARTED.addQuestDrop(PET_MANAGER_MARTIN, ANIMAL_SLAYER_LIST5, 1);

		for(int i = 0; i < DROPLIST_COND.length; i++)
		{
			addKillId(DROPLIST_COND[i][2]);
			STARTED.addQuestDrop(DROPLIST_COND[i][2], DROPLIST_COND[i][4], 1);
		}
	}

	public int getCount_proof(QuestState st)
	{
		int race = st.getPlayer().getRace().ordinal();
		int counts = 0;
		if(race == 0)
			counts = st.getQuestItemsCount(SPIDER_LEG1);
		else if(race == 1)
			counts = st.getQuestItemsCount(SPIDER_LEG2);
		else if(race == 2)
			counts = st.getQuestItemsCount(SPIDER_LEG3);
		else if(race == 3)
			counts = st.getQuestItemsCount(SPIDER_LEG4);
		else if(race == 4)
			counts = st.getQuestItemsCount(SPIDER_LEG5);
		return counts;
	}

	public String check_questions(QuestState st)
	{
		String htmltext = "";
		int answers = st.getInt("answers");
		int question = st.getInt("question");
		if(question > 0)
		{
			htmltext = "419_q" + String.valueOf(question) + ".htm";
		}
		else if(answers < 10)
		{
			String[] ANS = st.get("quiz").toString().split(" ");
			int GetQuestion = Rnd.get(ANS.length);
			String index = ANS[GetQuestion];
			st.set("question", index);
			String quiz = "";
			if(GetQuestion + 1 == ANS.length)
			{
				for(int i = 0; i < ANS.length - 2; i++)
				{
					quiz = quiz + ANS[i] + " ";
				}
				quiz = quiz + ANS[ANS.length - 2];
			}
			else
			{
				for(int i = 0; i < ANS.length - 1; i++)
				{
					if(i != GetQuestion)
						quiz = quiz + ANS[i] + " ";
				}
				quiz = quiz + ANS[ANS.length - 1];
			}
			st.set("quiz", quiz);
			htmltext = "419_q" + index + ".htm";
		}
		else
		{
			st.giveItems(WOLF_COLLAR, 1);
			st.setState(COMPLETED);
			st.exitCurrentQuest(true);
			st.playSound("ItemSound.quest_finish");
			htmltext = "Completed.htm";
		}
		return htmltext;
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		int StateId = 0;
		State id = st.getState();
		if(!id.equals(CREATED))
			StateId = st.getInt("id");
		if(event.equalsIgnoreCase("details"))
		{
			htmltext = "419_confirm.htm";
		}
		else if(event.equalsIgnoreCase("agree"))
		{
			st.setState(STARTED);
			st.set("cond", "1");
			int race = st.getPlayer().getRace().ordinal();
			if(race == 0)
			{
				st.giveItems(ANIMAL_SLAYER_LIST1, 1);
				htmltext = "419_slay_0.htm";
			}
			else if(race == 1)
			{
				st.giveItems(ANIMAL_SLAYER_LIST2, 1);
				htmltext = "419_slay_1.htm";
			}
			else if(race == 2)
			{
				st.giveItems(ANIMAL_SLAYER_LIST3, 1);
				htmltext = "419_slay_2.htm";
			}
			else if(race == 3)
			{
				st.giveItems(ANIMAL_SLAYER_LIST4, 1);
				htmltext = "419_slay_3.htm";
			}
			else if(race == 4)
			{
				st.giveItems(ANIMAL_SLAYER_LIST5, 1);
				htmltext = "419_slay_4.htm";
			}
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("disagree"))
		{
			htmltext = "419_cancelled.htm";
			st.exitCurrentQuest(true);
		}
		else if(StateId == 1)
		{
			if(event.equalsIgnoreCase("talk"))
			{
				htmltext = "419_talk.htm";
			}
			else if(event.equalsIgnoreCase("talk1"))
				htmltext = "419_bella_2.htm";
			else if(event.equalsIgnoreCase("talk2"))
			{
				st.set("progress", String.valueOf(st.getInt("progress") | 1));
				htmltext = "419_bella_3.htm";
			}
			else if(event.equalsIgnoreCase("talk3"))
			{
				st.set("progress", String.valueOf(st.getInt("progress") | 2));
				htmltext = "419_ellie_2.htm";
			}
			else if(event.equalsIgnoreCase("talk4"))
			{
				st.set("progress", String.valueOf(st.getInt("progress") | 4));
				htmltext = "419_metty_2.htm";
			}
		}
		else if(StateId == 2)
		{
			if(event.equalsIgnoreCase("tryme"))
			{
				htmltext = check_questions(st);
			}
			else if(event.equalsIgnoreCase("wrong"))
			{
				st.set("id", "1");
				st.set("progress", "0");
				st.unset("quiz");
				st.unset("answers");
				st.unset("question");
				st.giveItems(ANIMAL_LOVERS_LIST1, 1);
				htmltext = "419_failed.htm";
			}
			else if(event.equalsIgnoreCase("right"))
			{
				st.set("answers", String.valueOf(st.getInt("answers") + 1));
				st.set("question", "0");
				htmltext = check_questions(st);
			}

		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		String htmltext = "no_quest.htm";
		State id = st.getState();
		int cond = 0;
		int StateId = 0;
		if(!id.equals(CREATED))
		{
			cond = st.getInt("cond");
			StateId = st.getInt("id");
		}
		if(cond == 0)
		{
			if(npcId == PET_MANAGER_MARTIN)
			{
				if(st.getPlayer().getLevel() < 15)
				{
					htmltext = "419_low_level.htm";
					st.exitCurrentQuest(true);
				}
				else
				{
					htmltext = "Start.htm";
				}
			}
		}
		else if(cond == 1)
		{
			if(npcId == PET_MANAGER_MARTIN)
			{
				if(StateId == 0)
				{
					int counts = getCount_proof(st);
					if(counts == 0)
						htmltext = "419_no_slay.htm";
					else if(counts < REQUIRED_SPIDER_LEGS)
						htmltext = "419_pending_slay.htm";
					else
					{
						int race = st.getPlayer().getRace().ordinal();
						if(race == 0)
						{
							st.takeItems(ANIMAL_SLAYER_LIST1, -1);
							st.takeItems(SPIDER_LEG1, -1);
						}
						else if(race == 1)
						{
							st.takeItems(ANIMAL_SLAYER_LIST2, -1);
							st.takeItems(SPIDER_LEG2, -1);
						}
						else if(race == 2)
						{
							st.takeItems(ANIMAL_SLAYER_LIST3, -1);
							st.takeItems(SPIDER_LEG3, -1);
						}
						else if(race == 3)
						{
							st.takeItems(ANIMAL_SLAYER_LIST4, -1);
							st.takeItems(SPIDER_LEG4, -1);
						}
						else if(race == 4)
						{
							st.takeItems(ANIMAL_SLAYER_LIST5, -1);
							st.takeItems(SPIDER_LEG5, -1);
						}
						st.set("id", "1");
						st.giveItems(ANIMAL_LOVERS_LIST1, 1);
						htmltext = "Slayed.htm";
					}
				}
				if(StateId == 1)
				{
					if(st.getInt("progress") == 7)
					{
						st.takeItems(ANIMAL_LOVERS_LIST1, -1);
						st.set("quiz", "1 2 3 4 5 6 7 8 9 10 11 12 13 14 15");
						st.set("answers", "0");
						st.set("id", "2");
						htmltext = "Talked.htm";
					}
					else
						htmltext = "419_pending_talk.htm";
				}
			}
			else if(StateId == 1)
			{
				if(npcId == GK_BELLA)
				{
					htmltext = "419_bella_1.htm";
				}
				else if(npcId == MC_ELLIE)
				{
					htmltext = "419_ellie_1.htm";
				}
				else if(npcId == GD_METTY)
				{
					htmltext = "419_metty_1.htm";
				}
			}
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		//Описание в 602 квесте.
		for(int i = 0; i < DROPLIST_COND.length; i++)
		{
			if(cond == DROPLIST_COND[i][0] && npcId == DROPLIST_COND[i][2])
				if((DROPLIST_COND[i][3] == 0) || (st.getQuestItemsCount(DROPLIST_COND[i][3]) > 0))
				{
					int count = st.getQuestItemsCount(DROPLIST_COND[i][4]);
					if((DROPLIST_COND[i][5] > count || DROPLIST_COND[i][5] == 0) && Rnd.chance(DROPLIST_COND[i][6]))
					{
						int random = 0;
						if(DROPLIST_COND[i][7] > 1)
						{
							random = Rnd.get(DROPLIST_COND[i][7]) + 1;
							if(count + random > DROPLIST_COND[i][5])
								random = DROPLIST_COND[i][5] - count;
						}
						else
							random = 1;
						st.giveItems(DROPLIST_COND[i][4], random);
						if(count + random == DROPLIST_COND[i][5])
						{
							st.playSound("Itemsound.quest_middle");
							if(DROPLIST_COND[i][1] != 0)
							{
								st.setState(STARTED);
								st.set("cond", String.valueOf(DROPLIST_COND[i][1]));
							}
						}
						else
							st.playSound("Itemsound.quest_itemget");
					}
				}
		}
		return null;
	}

}