package quests._422_RepentYourSins;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.game.model.L2Summon;
import L2jFT.util.Rnd;

public class _422_RepentYourSins extends Quest implements ScriptFile
{
	//Items
	int SCAVENGER_WERERAT_SKULL = 4326;
	int TUREK_WARHOUND_TAIL = 4327;
	int TYRANT_KINGPIN_HEART = 4328;
	int TRISALIM_TARANTULAS_VENOM_SAC = 4329;
	int MANUAL_OF_MANACLES = 4331;
	int PENITENTS_MANACLES = 4425;
	int PENITENTS_MANACLES1 = 4330;
	int PENITENTS_MANACLES2 = 4426;
	int SILVER_NUGGET = 1873;
	int ADAMANTINE_NUGGET = 1877;
	int BLACKSMITHS_FRAME = 1892;
	int COKES = 1879;
	int STEEL = 1880;

	//Mobs
	int SCAVENGER_WERERAT = 20039;
	int TUREK_WARHOUND = 20494;
	int TYRANT_KINGPIN = 20193;
	int TRISALIM_TARANTULA = 20561;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);

	public int findPetLvl(QuestState st)
	{
		L2ItemInstance item = st.getPlayer().getInventory().getItemByItemId(PENITENTS_MANACLES);
		if(item == null)
			return 0;
		L2Summon pet = st.getPlayer().getPet();
		if(pet == null)
			return item.getEnchantLevel();
		if(pet.getNpcId() != 12564)
			return 0;
		return pet.getLevel();
	}

	public void onLoad()
	{
		System.out.println("Loaded Quest: 422: Repent Your Sins");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _422_RepentYourSins()
	{
		super(422, "_422_RepentYourSins", "Repent Your Sins", false);
		setInitialState(CREATED);
		addStartNpc(30981);
		addTalkId(30981);
		addTalkId(30668);
		addTalkId(30597);
		addTalkId(30612);
		addTalkId(30718);
		addTalkId(30300);

		addKillId(SCAVENGER_WERERAT);
		addKillId(TUREK_WARHOUND);
		addKillId(TYRANT_KINGPIN);
		addKillId(TRISALIM_TARANTULA);

		STARTED.addQuestDrop(SCAVENGER_WERERAT, SCAVENGER_WERERAT_SKULL, 1);
		STARTED.addQuestDrop(TUREK_WARHOUND, TUREK_WARHOUND_TAIL, 1);
		STARTED.addQuestDrop(TYRANT_KINGPIN, TYRANT_KINGPIN_HEART, 1);
		STARTED.addQuestDrop(TRISALIM_TARANTULA, TRISALIM_TARANTULAS_VENOM_SAC, 1);
		STARTED.addQuestDrop(30981, MANUAL_OF_MANACLES, 1);
		STARTED.addQuestDrop(30981, PENITENTS_MANACLES, 1);
		STARTED.addQuestDrop(30981, PENITENTS_MANACLES2, 1);
		STARTED.addQuestDrop(30300, PENITENTS_MANACLES1, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(st.getState() == null)
			return null;
		int Pk_remove;
		if(event.equalsIgnoreCase("Start"))
		{
			st.playSound("ItemSound.quest_accept");
			st.setState(STARTED);
			if(st.getPlayer().getLevel() <= 20)
			{
				htmltext = "30981-03.htm";
				st.set("cond", "1");
				st.set("cond", "2");
				return htmltext;
			}
			if(st.getPlayer().getLevel() <= 30)
			{
				htmltext = "30981-04.htm";
				st.set("cond", "3");
				return htmltext;
			}
			if(st.getPlayer().getLevel() <= 40)
			{
				htmltext = "30981-05.htm";
				st.set("cond", "4");
				return htmltext;
			}
			htmltext = "30981-06.htm";
			st.set("cond", "5");
			return htmltext;

		}
		if(event.equalsIgnoreCase("1"))
		{
			if(st.getQuestItemsCount(PENITENTS_MANACLES1) >= 1)
				st.takeItems(PENITENTS_MANACLES1, -1);
			if(st.getQuestItemsCount(PENITENTS_MANACLES2) >= 1)
				st.takeItems(PENITENTS_MANACLES2, -1);
			if(st.getQuestItemsCount(PENITENTS_MANACLES) >= 1)
				st.takeItems(PENITENTS_MANACLES, -1);
			htmltext = "30981-11.htm";
			st.set("cond", "16");
			st.set("level", String.valueOf(st.getPlayer().getLevel()));
			st.giveItems(PENITENTS_MANACLES, 1);
			return htmltext;
		}
		if(event.equalsIgnoreCase("2"))
		{
			htmltext = "30981-14.htm";
			return htmltext;
		}
		if(event.equalsIgnoreCase("3"))
		{
			int plevel = findPetLvl(st);
			int level = st.getPlayer().getLevel();
			int olevel = st.getInt("level");
			L2Summon pet = st.getPlayer().getPet();
			if(pet != null)
			{
				if(pet.getNpcId() == 12564)
				{
					htmltext = "30981-16.htm";
					return htmltext;
				}
			}
			else
			{
				if(level > olevel)
					Pk_remove = plevel - level;
				else
					Pk_remove = plevel - olevel;
				if(Pk_remove < 0)
					Pk_remove = 0;
				Pk_remove = Rnd.get(10 + Pk_remove) + 1;
				if(st.getPlayer().getPkKills() <= Pk_remove)
				{
					htmltext = "30981-15.htm";
					st.getPlayer().setPkKills(0);
					st.playSound("ItemSound.quest_finished");
					st.exitCurrentQuest(true);
					// Даем итем _после_ окончания квеста, если хотим его оставить. 
					st.giveItems(PENITENTS_MANACLES2, 1);
					return htmltext;
				}
				st.giveItems(PENITENTS_MANACLES2, 1);
				st.takeItems(PENITENTS_MANACLES, 1);
				htmltext = "30981-17.htm";
				int Pk_new = st.getPlayer().getPkKills() - Pk_remove;
				st.getPlayer().setPkKills(Pk_new);
				st.set("level", "0");
				return htmltext;
			}
		}
		if(event.equalsIgnoreCase("4"))
		{
			htmltext = "30981-19.htm";
			return htmltext;
		}
		if(event.equalsIgnoreCase("Quit"))
		{
			htmltext = "30981-20.htm";
			st.playSound("ItemSound.quest_finished");
			st.exitCurrentQuest(true);
			return htmltext;
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>You are either not carrying out your quest or don't meet the criteria.</body></html>";
		if(st.getState() == null)
			return htmltext;
		int condition = st.getInt("cond");
		int npcId = npc.getNpcId();
		State id = st.getState();
		if(npcId == 30981) //Black Judge
		{
			if(id.equals(CREATED))
			{
				if(st.getPlayer().getPkKills() >= 1 && st.getPlayer().getLevel() < 80)
				{
					htmltext = "30981-02.htm";
					return htmltext;
				}
				htmltext = "30981-01.htm";
				st.exitCurrentQuest(true);
				return htmltext;
			}
			if(condition <= 9)
			{
				htmltext = "30981-07.htm";
				return htmltext;
			}
			if(condition == 13 && st.getQuestItemsCount(MANUAL_OF_MANACLES) < 1)
			{
				htmltext = "30981-08.htm";
				st.set("cond", "14");
				st.giveItems(MANUAL_OF_MANACLES, 1);
				return htmltext;
			}
			if(condition == 14 && st.getQuestItemsCount(MANUAL_OF_MANACLES) > 0)
			{
				htmltext = "30981-09.htm";
				return htmltext;
			}
			if(condition == 15 && st.getQuestItemsCount(PENITENTS_MANACLES1) > 0)
			{
				htmltext = "30981-10.htm";
				return htmltext;
			}
			if(condition >= 16)
			{
				if(st.getQuestItemsCount(PENITENTS_MANACLES) > 0)
				{
					int plevel = findPetLvl(st);
					int level = st.getPlayer().getLevel();
					if(st.getInt("level") > level)
						level = st.getInt("level");
					if(plevel > 0)
					{
						if(plevel > level)
						{
							htmltext = "30981-13.htm";
							return htmltext;
						}
						htmltext = "30981-12.htm";
						return htmltext;
					}
					htmltext = "30981-12.htm";
					return htmltext;
				}
				htmltext = "30981-18.htm";
				return htmltext;
			}
		}
		if(npcId == 30668) // Katari
		{
			if(condition == 2)
			{
				st.set("cond", "6");
				htmltext = "30668-01.htm";
				return htmltext;
			}
			if(condition == 6)
				if(st.getQuestItemsCount(SCAVENGER_WERERAT_SKULL) < 10)
				{
					htmltext = "30668-02.htm";
					return htmltext;
				}
			if(condition == 10)
			{
				htmltext = "30668-04.htm";
				return htmltext;
			}
			st.set("cond", "10");
			htmltext = "30668-03.htm";
			st.takeItems(SCAVENGER_WERERAT_SKULL, -1);
			return htmltext;
		}
		if(npcId == 30597) // Piotur
		{
			if(condition == 3)
			{
				st.set("cond", "7");
				htmltext = "30597-01.htm";
				return htmltext;
			}
			if(condition == 7 && st.getQuestItemsCount(TUREK_WARHOUND_TAIL) < 10)
			{
				htmltext = "30597-02.htm";
				return htmltext;
			}
			if(condition == 11)
			{
				htmltext = "30597-04.htm";
				return htmltext;
			}
			st.set("cond", "11");
			htmltext = "30597-03.htm";
			st.takeItems(TUREK_WARHOUND_TAIL, -1);
			return htmltext;
		}
		if(npcId == 30612) // Casian
		{
			if(condition == 4)
			{
				st.set("cond", "8");
				htmltext = "30612-01.htm";
				return htmltext;
			}
			if(condition == 8)
			{
				if(st.getQuestItemsCount(TYRANT_KINGPIN_HEART) < 1)
				{
					htmltext = "30612-02.htm";
					return htmltext;
				}
				st.set("cond", "12");
				htmltext = "30612-03.htm";
				st.takeItems(TYRANT_KINGPIN_HEART, -1);
				return htmltext;
			}
			if(condition == 12)
			{
				htmltext = "30612-04.htm";
				return htmltext;
			}
		}
		if(npcId == 30718) // Joan
		{
			if(condition == 5)
			{
				st.set("cond", "9");
				htmltext = "30718-01.htm";
				return htmltext;
			}
			if(condition == 9)
				if(st.getQuestItemsCount(TRISALIM_TARANTULAS_VENOM_SAC) < 3)
				{
					htmltext = "30718-02.htm";
					return htmltext;
				}
			if(st.getQuestItemsCount(TRISALIM_TARANTULAS_VENOM_SAC) >= 3)
			{
				st.set("cond", "13");
				htmltext = "30718-03.htm";
				st.takeItems(TRISALIM_TARANTULAS_VENOM_SAC, -1);
				return htmltext;
			}
			if(condition == 13)
			{
				htmltext = "30718-04.htm";
				return htmltext;
			}
		}
		if(npcId == 30300)
			if(condition >= 14)
			{
				if(st.getQuestItemsCount(MANUAL_OF_MANACLES) == 1)
				{
					if(st.getQuestItemsCount(SILVER_NUGGET) < 10 || st.getQuestItemsCount(STEEL) < 5 || st.getQuestItemsCount(ADAMANTINE_NUGGET) < 2 || st.getQuestItemsCount(COKES) < 10 || st.getQuestItemsCount(BLACKSMITHS_FRAME) < 1)
					{
						htmltext = "30300-02.htm";
						return htmltext;
					}
					if(st.getQuestItemsCount(SILVER_NUGGET) >= 10 && st.getQuestItemsCount(STEEL) >= 5 && st.getQuestItemsCount(ADAMANTINE_NUGGET) >= 2 && st.getQuestItemsCount(COKES) >= 10 && st.getQuestItemsCount(BLACKSMITHS_FRAME) >= 1)
					{
						htmltext = "30300-02.htm";
						st.set("cond", "15");
						st.takeItems(MANUAL_OF_MANACLES, 1);
						st.takeItems(SILVER_NUGGET, 10);
						st.takeItems(ADAMANTINE_NUGGET, 2);
						st.takeItems(COKES, 10);
						st.takeItems(STEEL, 5);
						st.takeItems(BLACKSMITHS_FRAME, 1);
						st.giveItems(PENITENTS_MANACLES1, 1);
						st.playSound("ItemSound.quest_middle");
						return htmltext;
					}
				}
				if(st.getQuestItemsCount(PENITENTS_MANACLES1) > 0 || st.getQuestItemsCount(PENITENTS_MANACLES) > 0 || st.getQuestItemsCount(PENITENTS_MANACLES2) > 0)
				{
					htmltext = "30300-03.htm";
					return htmltext;
				}
			}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		if(st.getState() == null || st.getState() != STARTED)
			return null;
		int condition = st.getInt("cond");
		int npcId = npc.getNpcId();
		int skulls = st.getQuestItemsCount(SCAVENGER_WERERAT_SKULL);
		int tails = st.getQuestItemsCount(TUREK_WARHOUND_TAIL);
		int heart = st.getQuestItemsCount(TYRANT_KINGPIN_HEART);
		int sacs = st.getQuestItemsCount(TRISALIM_TARANTULAS_VENOM_SAC);
		if(npcId == SCAVENGER_WERERAT)
			if(condition == 6 && skulls < 10)
			{
				st.giveItems(SCAVENGER_WERERAT_SKULL, 1);
				if(skulls == 10)
					st.playSound("ItemSound.quest_middle");
				else
					st.playSound("ItemSound.quest_itemget");
			}
		if(npcId == TUREK_WARHOUND)
			if(condition == 7 && tails < 10)
			{
				st.giveItems(TUREK_WARHOUND_TAIL, 1);
				if(tails == 10)
					st.playSound("ItemSound.quest_middle");
				else
					st.playSound("ItemSound.quest_itemget");
			}
		if(npcId == TYRANT_KINGPIN)
			if(condition == 8 && heart < 1)
			{
				st.giveItems(TYRANT_KINGPIN_HEART, 1);
				st.playSound("ItemSound.quest_middle");
			}
		if(npcId == TRISALIM_TARANTULA)
			if(condition == 9 && sacs < 3)
			{
				st.giveItems(TRISALIM_TARANTULAS_VENOM_SAC, 1);
				if(skulls == 3)
					st.playSound("ItemSound.quest_middle");
				else
					st.playSound("ItemSound.quest_itemget");
			}
		return null;
	}
}