package quests._602_ShadowofLight;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _602_ShadowofLight extends Quest implements ScriptFile
{
	//NPC
	public final int ARGOS = 31683;
	//Items
	public final int ADENA = 57;
	//Quest Item
	public final int EYE_OF_DARKNESS = 7189;
	//Bonus
	public final int[][] REWARDS = {
			{ 6699, 40000, 120000, 20000, 1, 19 },
			{ 6698, 60000, 110000, 15000, 20, 39 },
			{ 6700, 40000, 150000, 10000, 40, 49 },
			{ 0, 100000, 140000, 11250, 50, 100 } };
	//Drop Cond
	//# [COND, NEWCOND, ID, REQUIRED, ITEM, NEED_COUNT, CHANCE, DROP]
	public final int[][] DROPLIST_COND = {
			{ 1, 2, 21304, 0, EYE_OF_DARKNESS, 100, 40, 1 },
			{ 1, 2, 21299, 0, EYE_OF_DARKNESS, 100, 35, 1 } };
	//Main
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 602: Shadowof Light");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _602_ShadowofLight()
	{
		super(602, "_602_ShadowofLight", "Shadowof Light", false);
		setInitialState(CREATED);
		addStartNpc(ARGOS);
		addTalkId(ARGOS);
		addTalkId(ARGOS);
		addTalkId(ARGOS);

		for(int i = 0; i < DROPLIST_COND.length; i++)
			addKillId(DROPLIST_COND[i][2]);

		STARTED.addQuestDrop(20223, EYE_OF_DARKNESS, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31683-02.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("31683-04.htm"))
		{
			st.takeItems(EYE_OF_DARKNESS, -1);
			int random = Rnd.get(100) + 1;
			for(int i = 0; i < REWARDS.length; i++)
			{
				if(REWARDS[i][4] <= random && random <= REWARDS[i][5])
				{
					st.giveItems(ADENA, REWARDS[i][1]);
					st.addExpAndSp(REWARDS[i][2], REWARDS[i][3]);
					if(REWARDS[i][0] != 0)
						st.giveItems(REWARDS[i][0], 3);
				}
			}
			st.playSound("ItemSound.quest_finish");
			st.exitCurrentQuest(true);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		String htmltext = "no_quest.htm";
		State id = st.getState();
		int cond = 0;
		if(!id.equals(CREATED))
			cond = st.getInt("cond");
		if(npcId == ARGOS)
			if(cond == 0)
				if(st.getPlayer().getLevel() < 69)
				{
					htmltext = "31683-00.htm";
					st.exitCurrentQuest(true);
				}
				else
					htmltext = "31683-01.htm";
			else if(cond == 1)
				htmltext = "31683-02r.htm";
			else if(cond == 2 && st.getQuestItemsCount(EYE_OF_DARKNESS) == 100)
				htmltext = "31683-03.htm";
			else
			{
				htmltext = "31683-02r.htm";
				st.set("cond", "1");
			}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		for(int i = 0; i < DROPLIST_COND.length; i++)
		{
			if(cond == DROPLIST_COND[i][0] && npcId == DROPLIST_COND[i][2]) //Проверяем конд и соответсвие убитого моба
				if((DROPLIST_COND[i][3] == 0) || (st.getQuestItemsCount(DROPLIST_COND[i][3]) > 0)) //Проверяем наличине необходимого квест айтема
				{
					int count = st.getQuestItemsCount(DROPLIST_COND[i][4]); //Определяем текущее количество выбиваемых квест айтемов.
					if((DROPLIST_COND[i][5] > count || DROPLIST_COND[i][5] == 0) && Rnd.chance(DROPLIST_COND[i][6])) //Если не максимальное значение выбиваемых айтемов и шанс удачный
					{
						int random = 0; // Загадываем число количества дропа
						if(DROPLIST_COND[i][7] > 1)
						{
							random = Rnd.get(DROPLIST_COND[i][7]) + 1;
							if(count + random > DROPLIST_COND[i][5])
								random = DROPLIST_COND[i][5] - count;
						}
						else
							random = 1;
						st.giveItems(DROPLIST_COND[i][4], random);
						if(count + random == DROPLIST_COND[i][5]) //Проверяем не набралось ли максимум квест айтемов.
						{
							st.playSound("Itemsound.quest_middle");
							if(DROPLIST_COND[i][1] != 0)
							{
								st.setState(STARTED);
								st.set("cond", String.valueOf(DROPLIST_COND[i][1]));
							}
						}
						else
							st.playSound("Itemsound.quest_itemget");
					}
				}
		}
		return null;
	}

}
