package quests._605_AllianceWithKetraOrcs;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _605_AllianceWithKetraOrcs extends Quest implements ScriptFile
{
	// items
	private final int MARK_OF_KETRA_ALLIANCE1 = 7211;
	private final int MARK_OF_KETRA_ALLIANCE2 = 7212;
	private final int MARK_OF_KETRA_ALLIANCE3 = 7213;
	private final int MARK_OF_KETRA_ALLIANCE4 = 7214;
	private final int MARK_OF_KETRA_ALLIANCE5 = 7215;
	private final int VB_SOLDIER = 7216;
	private final int VB_CAPTAIN = 7217;
	private final int VB_GENERAL = 7218;
	private final int TOTEM_OF_VALOR = 7219;
	private final int TOTEM_OF_WISDOM = 7220;

	// hunt for soldier
	private final int RECRUIT = 21350;
	private final int FOOTMAN = 21351;
	private final int SCOUT = 21353;
	private final int HUNTER = 21354;
	private final int SHAMAN = 21355;

	// hunt for captain
	private final int PRIEST = 21357;
	private final int WARRIOR = 21358;
	private final int MEDIUM = 21360;
	private final int MAGUS = 21361;
	private final int OFFICIER = 21362;
	private final int COMMANDER = 21369;
	private final int ELITE_GUARD = 21370;

	// hunt for general
	private final int GREAT_MAGUS = 21365;
	private final int GENERAL = 21366;
	private final int GREAT_SEER = 21368;
	private final int VARKA_PROPHET = 21373;
	private final int DISCIPLE_OF_PROPHET = 21375;
	private final int PROPHET_GUARDS = 21374;
	private final int HEAD_MAGUS = 21371;
	private final int HEAD_GUARDS = 21372;
	private final int Wahkan = 31371;

	private final State CREATED = new State("Start", this);
	private final State STARTED = new State("Started", this);
	private final State COMPLETED = new State("Completed", this);

	public _605_AllianceWithKetraOrcs()
	{
		super(605, "_605_AllianceWithKetraOrcs", "Alliance With Ketra Orcs", true);
		setInitialState(CREATED);
		addStartNpc(Wahkan);
		addTalkId(Wahkan);
		addTalkId(Wahkan);

		//hunt for soldier
		addKillId(RECRUIT);
		addKillId(FOOTMAN);
		addKillId(SCOUT);
		addKillId(HUNTER);
		addKillId(SHAMAN);

		//hunt for captain
		addKillId(PRIEST);
		addKillId(WARRIOR);
		addKillId(MEDIUM);
		addKillId(MAGUS);
		addKillId(OFFICIER);
		addKillId(COMMANDER);
		addKillId(ELITE_GUARD);

		//hunt for general
		addKillId(GREAT_MAGUS);
		addKillId(GENERAL);
		addKillId(GREAT_SEER);
		addKillId(VARKA_PROPHET);
		addKillId(DISCIPLE_OF_PROPHET);
		addKillId(PROPHET_GUARDS);
		addKillId(HEAD_MAGUS);
		addKillId(HEAD_GUARDS);

		//hunt for soldier
		STARTED.addQuestDrop(RECRUIT, VB_SOLDIER, 1);
		STARTED.addQuestDrop(FOOTMAN, VB_SOLDIER, 1);
		STARTED.addQuestDrop(SCOUT, VB_SOLDIER, 1);
		STARTED.addQuestDrop(HUNTER, VB_SOLDIER, 1);
		STARTED.addQuestDrop(SHAMAN, VB_SOLDIER, 1);

		//hunt for captain
		STARTED.addQuestDrop(PRIEST, VB_CAPTAIN, 1);
		STARTED.addQuestDrop(WARRIOR, VB_CAPTAIN, 1);
		STARTED.addQuestDrop(MEDIUM, VB_CAPTAIN, 1);
		STARTED.addQuestDrop(MAGUS, VB_CAPTAIN, 1);
		STARTED.addQuestDrop(OFFICIER, VB_CAPTAIN, 1);
		STARTED.addQuestDrop(COMMANDER, VB_CAPTAIN, 1);
		STARTED.addQuestDrop(ELITE_GUARD, VB_CAPTAIN, 1);

		//hunt for general
		STARTED.addQuestDrop(GREAT_MAGUS, VB_GENERAL, 1);
		STARTED.addQuestDrop(GENERAL, VB_GENERAL, 1);
		STARTED.addQuestDrop(GREAT_SEER, VB_GENERAL, 1);
		STARTED.addQuestDrop(VARKA_PROPHET, VB_GENERAL, 1);
		STARTED.addQuestDrop(DISCIPLE_OF_PROPHET, VB_GENERAL, 1);
		STARTED.addQuestDrop(PROPHET_GUARDS, VB_GENERAL, 1);
		STARTED.addQuestDrop(HEAD_MAGUS, VB_GENERAL, 1);
		STARTED.addQuestDrop(HEAD_GUARDS, VB_GENERAL, 1);
	}

	public void onLoad()
	{
		System.out.println("Loaded Quest: 605: Alliance With Ketra Orcs");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	private String checkMarks(QuestState st)
	{
		if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) < 0 && st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) < 0 && st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) < 0 && st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) < 0 && st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) < 0)
			return null;
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5) > 0)
			st.set("cond", "6");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4) > 0)
			st.set("cond", "5");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3) > 0)
			st.set("cond", "4");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2) > 0)
			st.set("cond", "3");
		else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1) > 0)
			st.set("cond", "2");
		return null;
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("first-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("first-have-2.htm"))
		{
			st.takeItems(VB_SOLDIER, 100);
			st.giveItems(MARK_OF_KETRA_ALLIANCE1, 1);
			st.set("cond", "2");
			st.getPlayer().setKetra(1);
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("second-have-2.htm"))
		{
			st.takeItems(VB_SOLDIER, 200);
			st.takeItems(VB_CAPTAIN, 100);
			st.takeItems(MARK_OF_KETRA_ALLIANCE1, 1);
			st.giveItems(MARK_OF_KETRA_ALLIANCE2, 1);
			st.set("cond", "3");
			st.getPlayer().setKetra(2);
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("third-have-2.htm"))
		{
			st.takeItems(VB_SOLDIER, 300);
			st.takeItems(VB_CAPTAIN, 200);
			st.takeItems(VB_GENERAL, 100);
			st.takeItems(MARK_OF_KETRA_ALLIANCE2, 1);
			st.giveItems(MARK_OF_KETRA_ALLIANCE3, 1);
			st.set("cond", "4");
			st.getPlayer().setKetra(3);
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("fourth-have-2.htm"))
		{
			st.takeItems(VB_SOLDIER, 300);
			st.takeItems(VB_CAPTAIN, 300);
			st.takeItems(VB_GENERAL, 200);
			st.takeItems(TOTEM_OF_VALOR, 1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE3, 1);
			st.giveItems(MARK_OF_KETRA_ALLIANCE4, 1);
			st.set("cond", "5");
			st.getPlayer().setKetra(4);
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("fifth-have-2.htm"))
		{
			st.takeItems(VB_SOLDIER, 400);
			st.takeItems(VB_CAPTAIN, 400);
			st.takeItems(VB_GENERAL, 200);
			st.takeItems(TOTEM_OF_WISDOM, 1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE4, 1);
			st.giveItems(MARK_OF_KETRA_ALLIANCE5, 1);
			st.set("cond", "6");
			st.getPlayer().setKetra(5);
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("quit-2.htm"))
		{
			st.takeItems(MARK_OF_KETRA_ALLIANCE1, -1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE2, -1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE3, -1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE4, -1);
			st.takeItems(MARK_OF_KETRA_ALLIANCE5, -1);
			st.set("cond", "0");
			st.setState(COMPLETED);
			st.getPlayer().setKetra(0);
			st.playSound("ItemSound.quest_middle");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><head><body>I have nothing to say you!</body></html>";
		if(st.getPlayer().getVarka() > 0)
		{
			htmltext = "isvarka.htm";
			st.exitCurrentQuest(true);
			return htmltext;
		}
		String id = String.valueOf(st.getState());
		if(id.equals("CREATED"))
			st.set("cond", "0");
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		checkMarks(st);
		if(npcId == 31371)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() >= 74)
				{
					if(id.equals("COMPLETED"))
						htmltext = "<html><head>body>You have already complete this quest.</body></html>";
					else
						htmltext = "first.htm";
				}
				else
				{
					htmltext = "no-level.htm";
					st.exitCurrentQuest(true);
				}
			}
			else
			{
				if(cond == 1)
				{
					if(st.getQuestItemsCount(VB_SOLDIER) >= 100)
						htmltext = "first-have.htm";
					else
						htmltext = "first-havenot.htm";
				}
				else if(cond == 2)
				{
					if(st.getQuestItemsCount(VB_SOLDIER) >= 200 && st.getQuestItemsCount(VB_CAPTAIN) >= 100)
						htmltext = "second-have.htm";
					else
						htmltext = "second.htm";
				}
				else if(cond == 3)
				{
					if(st.getQuestItemsCount(VB_SOLDIER) >= 300 && st.getQuestItemsCount(VB_CAPTAIN) >= 200 && st.getQuestItemsCount(VB_GENERAL) >= 100)
						htmltext = "third-have.htm";
					else
						htmltext = "third.htm";
				}
				else if(cond == 4)
				{
					if(st.getQuestItemsCount(VB_SOLDIER) >= 300 && st.getQuestItemsCount(VB_CAPTAIN) >= 200 && st.getQuestItemsCount(VB_GENERAL) >= 200 && st.getQuestItemsCount(TOTEM_OF_VALOR) == 1)
						htmltext = "fourth-have.htm";
					else
						htmltext = "fourth.htm";
				}
				else if(cond == 5)
				{
					if(st.getQuestItemsCount(VB_SOLDIER) >= 300 && st.getQuestItemsCount(VB_CAPTAIN) >= 200 && st.getQuestItemsCount(VB_GENERAL) >= 200 && st.getQuestItemsCount(TOTEM_OF_WISDOM) == 1)
						htmltext = "fifth-have.htm";
					else
						htmltext = "fifth.htm";
				}
				else if(cond == 6)
					htmltext = "high.htm";
				return htmltext;
			}
		}
		else
		{
			st.exitCurrentQuest(true);
			return htmltext;
		}
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(npcId == PRIEST || npcId == WARRIOR || npcId == MEDIUM || npcId == MAGUS || npcId == OFFICIER || npcId == COMMANDER || npcId == ELITE_GUARD)
		{
			if(st.getInt("cond") > 1)
			{
				st.giveItems(VB_CAPTAIN, 1);
				st.playSound("ItemSound.quest_middle");
			}
		}
		else if(npcId == RECRUIT || npcId == FOOTMAN || npcId == SCOUT || npcId == HUNTER || npcId == SHAMAN)
		{
			if(st.getInt("cond") > 0)
				if(Rnd.chance(40))
				{
					st.giveItems(VB_SOLDIER, 1);
					st.playSound("ItemSound.quest_middle");
				}
		}
		else if(npcId == GREAT_MAGUS || npcId == GENERAL || npcId == GREAT_SEER || npcId == VARKA_PROPHET || npcId == DISCIPLE_OF_PROPHET || npcId == PROPHET_GUARDS || npcId == HEAD_MAGUS || npcId == HEAD_GUARDS)
			if(st.getInt("cond") > 2)
				if(Rnd.chance(40))
				{
					st.giveItems(VB_GENERAL, 1);
					st.playSound("ItemSound.quest_middle");
				}
		return null;
	}
}
