package quests._606_WarwithVarkaSilenos;

import javolution.util.FastList;
import javolution.util.FastMap;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _606_WarwithVarkaSilenos extends Quest implements ScriptFile
{
	public void onLoad()
	{
		System.out.println("Loaded Quest: 606: War with Varka Silenos");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

    //NPC
    public static int KADUN_ZU_KETRA = 31370;
    public static int KETRA_FIRST_NPC = 21324;
    public static int KETRA_LAST_NPC = 21350;

    //Quest items
    public static short VARKAS_MANE = 7233;
    public static short HORN_OF_BUFFALO = 7186;

    //etc
    public static int MARK_OF_KETRA_ALLIANCE1 = 7211;
    public static int MARK_OF_KETRA_ALLIANCE2 = 7212;
    public static int MARK_OF_KETRA_ALLIANCE3 = 7213;
    public static int MARK_OF_KETRA_ALLIANCE4 = 7214;
    public static int MARK_OF_KETRA_ALLIANCE5 = 7215;

    private final State CREATED = new State("Start", this);
	private final State STARTED = new State("Started", this);

    private final FastMap<Integer, Quest.Drop> DROPLIST = new FastMap<Integer, Quest.Drop>();

	public _606_WarwithVarkaSilenos()
	{
		super(606, "_606_WarwithVarkaSilenos", "War with Varka Silenos", false);

		setInitialState(CREATED);
		addStartNpc(KADUN_ZU_KETRA);
		addTalkId(KADUN_ZU_KETRA);
                                    //cond max_count chance
        Quest.Drop drop = new Quest.Drop(2, 10, 50);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21350, drop);
        drop = new Quest.Drop(1, 10, 51);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21353, drop);
        drop = new Quest.Drop(1, 10, 52);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21354, drop);
        drop = new Quest.Drop(1, 10, 52);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21355, drop);
        drop = new Quest.Drop(1, 10, 53);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21357, drop);
        drop = new Quest.Drop(1, 10, 53);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21358, drop);
        drop = new Quest.Drop(1, 10, 54);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21360, drop);
        drop = new Quest.Drop(1, 10, 55);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21362, drop);
        drop = new Quest.Drop(1, 10, 56);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21364, drop);
        drop = new Quest.Drop(1, 10, 57);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21365, drop);
        drop = new Quest.Drop(1, 10, 57);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21366, drop);
        drop = new Quest.Drop(1, 10, 57);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21368, drop);
        drop = new Quest.Drop(1, 10, 56);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21369, drop);
        drop = new Quest.Drop(1, 10, 70);
		drop.addItem(VARKAS_MANE);
		DROPLIST.put(21371, drop);

        for(int i=KETRA_FIRST_NPC;i==KETRA_LAST_NPC;i++)
			addKillId(i);

		for(Integer mobId : DROPLIST.keySet())
		{
			addKillId(mobId);
			STARTED.addQuestDrop(mobId, VARKAS_MANE, 1);
		}
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
        String htmltext = event;
        if(event.equals("31370-2.htm"))
        {
            st.set("cond","1");
            st.setState(STARTED);
            st.playSound("ItemSound.quest_accept");
        }
        else
        if(event.equals("31370-4.htm"))
        {
           if(st.getQuestItemsCount(VARKAS_MANE) >= 100)
           {
               st.takeItems(VARKAS_MANE,100);
               st.giveItems(HORN_OF_BUFFALO,20);
           }
           else htmltext = "31370-havenot.htm";
        }
        else if(event.equals("31370-quit.htm"))
        {
            st.takeItems(VARKAS_MANE,-1);
            st.playSound("ItemSound.quest_finish");
            st.exitCurrentQuest(true);
        }
        return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
        String htmltext = "<html><head><body>I have nothing to say you</body></html>";
        int cond = st.getInt("cond");
        if(cond == 0)
        {
           if(st.getPlayer().getLevel() >= 74)
              htmltext = "31370-1.htm";
           else
           {
               htmltext = "31370-0.htm";
               st.exitCurrentQuest(true);
           }
        }
        else 
        if((cond == 1) && (st.getQuestItemsCount(VARKAS_MANE) == 0 ))
            htmltext = "31370-2r.htm";
        else if((cond == 1) && (st.getQuestItemsCount(VARKAS_MANE) > 0))
           htmltext = "31370-3.htm";
        return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
        int npcId = npc.getNpcId();
        Quest.Drop drop = DROPLIST.get(npcId);
		if(drop == null)
			return null;
		int chance = 0;
		if(drop.chance != null)
			chance = drop.chance;
		FastList<Short> itemList = drop.itemList;
		int cond = st.getInt("cond");
	    if(itemList.size() > 0)
        {
            if(cond == 1 && Rnd.chance(chance))
			{
                st.giveItems(VARKAS_MANE, 1);
				st.playSound("ItemSound.quest_itemget");
			}
        }
        else
        for(int mobid=KETRA_FIRST_NPC;mobid==KETRA_LAST_NPC;mobid++)
        {
            if(npcId==mobid)
            {
                if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE5)>0)
                {
                    st.takeItems(MARK_OF_KETRA_ALLIANCE5,-1);
                    st.giveItems(MARK_OF_KETRA_ALLIANCE4,1);
                }
                else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE4)>0)
                {
                    st.takeItems(MARK_OF_KETRA_ALLIANCE4,-1);
                    st.giveItems(MARK_OF_KETRA_ALLIANCE3,1);
                }
                else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE3)>0)
                {
                    st.takeItems(MARK_OF_KETRA_ALLIANCE3,-1);
                    st.giveItems(MARK_OF_KETRA_ALLIANCE2,1);
                }
                else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE2)>0)
                {
                    st.takeItems(MARK_OF_KETRA_ALLIANCE2,-1);
                    st.giveItems(MARK_OF_KETRA_ALLIANCE1,1);
                }
                else if(st.getQuestItemsCount(MARK_OF_KETRA_ALLIANCE1)>0)
                {
                    st.takeItems(MARK_OF_KETRA_ALLIANCE1,-1);
                }
                st.getPlayer().setKetra(st.getPlayer().getKetra()-1);
                st.exitQuest(605);
                st.exitQuest(606);
                st.exitQuest(607);
                st.exitQuest(608);
                st.exitQuest(609);
                st.exitQuest(610);
            }
		}
	return null;
	}
}