package quests._611_AllianceWithVarkaSilenos;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _611_AllianceWithVarkaSilenos extends Quest implements ScriptFile
{
	public void onLoad()
	{
		System.out.println("Loaded Quest: 611: Alliance With Varka Silenos");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	// Items
	private final int MARK_OF_VARKA_ALLIANCE1 = 7221;
	private final int MARK_OF_VARKA_ALLIANCE2 = 7222;
	private final int MARK_OF_VARKA_ALLIANCE3 = 7223;
	private final int MARK_OF_VARKA_ALLIANCE4 = 7224;
	private final int MARK_OF_VARKA_ALLIANCE5 = 7225;
	private final int KB_SOLDIER = 7226;
	private final int KB_CAPTAIN = 7227;
	private final int KB_GENERAL = 7228;
	private final int TOTEM_OF_VALOR = 7229;
	private final int TOTEM_OF_WISDOM = 7230;

	//hunt for soldier
	private final int RAIDER = 21327;
	private final int FOOTMAN = 21324;
	private final int SCOUT = 21328;
	private final int WAR_HOUND = 21325;
	private final int SHAMAN = 2132;

	//hunt for captain
	private final int SEER = 21338;
	private final int WARRIOR = 21331;
	private final int LIEUTENANT = 21332;
	private final int ELITE_SOLDIER = 21335;
	private final int MEDIUM = 21334;
	private final int COMMAND = 21343;
	private final int ELITE_GUARD = 21344;
	private final int WHITE_CAPTAIN = 21336;

	//hunt for general
	private final int BATTALION_COMMANDER_SOLDIER = 21340;
	private final int GENERAL = 21339;
	private final int GREAT_SEER = 21342;
	private final int KETRA_PROPHET = 21347;
	private final int DISCIPLE_OF_PROPHET = 21375;
	private final int PROPHET_GUARDS = 21348;
	private final int PROPHET_AIDE = 21349;
	private final int HEAD_SHAMAN = 21345;
	private final int HEAD_GUARDS = 21346;

	private final State CREATED = new State("Start", this);
	private final State STARTED = new State("Started", this);
	private final State COMPLETED = new State("Completed", this);

	public _611_AllianceWithVarkaSilenos()
	{
		super(611, "_611_AllianceWithVarkaSilenos", "Alliace With Varka Silenos", false);

		setInitialState(CREATED);
		addStartNpc(31378);
		addTalkId(31378);

		//hunt for soldier
		addKillId(RAIDER);
		addKillId(FOOTMAN);
		addKillId(SCOUT);
		addKillId(WAR_HOUND);
		addKillId(SHAMAN);

		//hunt for captain
		addKillId(SEER);
		addKillId(WARRIOR);
		addKillId(LIEUTENANT);
		addKillId(ELITE_SOLDIER);
		addKillId(MEDIUM);
		addKillId(COMMAND);
		addKillId(ELITE_GUARD);
		addKillId(WHITE_CAPTAIN);

		//hunt for general
		addKillId(BATTALION_COMMANDER_SOLDIER);
		addKillId(GENERAL);
		addKillId(GREAT_SEER);
		addKillId(KETRA_PROPHET);
		addKillId(PROPHET_AIDE);
		addKillId(PROPHET_GUARDS);
		addKillId(HEAD_SHAMAN);
		addKillId(HEAD_GUARDS);

		//hunt for soldier
		STARTED.addQuestDrop(RAIDER, KB_SOLDIER, 1);
		STARTED.addQuestDrop(FOOTMAN, KB_SOLDIER, 1);
		STARTED.addQuestDrop(SCOUT, KB_SOLDIER, 1);
		STARTED.addQuestDrop(WAR_HOUND, KB_SOLDIER, 1);
		STARTED.addQuestDrop(SHAMAN, KB_SOLDIER, 1);

		//hunt for captain
		STARTED.addQuestDrop(SEER, KB_CAPTAIN, 1);
		STARTED.addQuestDrop(WARRIOR, KB_CAPTAIN, 1);
		STARTED.addQuestDrop(LIEUTENANT, KB_CAPTAIN, 1);
		STARTED.addQuestDrop(ELITE_SOLDIER, KB_CAPTAIN, 1);
		STARTED.addQuestDrop(MEDIUM, KB_CAPTAIN, 1);
		STARTED.addQuestDrop(COMMAND, KB_CAPTAIN, 1);
		STARTED.addQuestDrop(ELITE_GUARD, KB_CAPTAIN, 1);
		STARTED.addQuestDrop(WHITE_CAPTAIN, KB_CAPTAIN, 1);

		//hunt for general
		STARTED.addQuestDrop(BATTALION_COMMANDER_SOLDIER, KB_GENERAL, 1);
		STARTED.addQuestDrop(GENERAL, KB_GENERAL, 1);
		STARTED.addQuestDrop(GREAT_SEER, KB_GENERAL, 1);
		STARTED.addQuestDrop(KETRA_PROPHET, KB_GENERAL, 1);
		STARTED.addQuestDrop(PROPHET_AIDE, KB_GENERAL, 1);
		STARTED.addQuestDrop(PROPHET_GUARDS, KB_GENERAL, 1);
		STARTED.addQuestDrop(HEAD_SHAMAN, KB_GENERAL, 1);
		STARTED.addQuestDrop(HEAD_GUARDS, KB_GENERAL, 1);
	}

	private String checkMarks(QuestState st)
	{
		if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) < 0 && st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) < 0 && st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) < 0 && st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) < 0 && st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) < 0)
			return null;
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) > 0)
			st.set("cond", "2");
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) > 0)
			st.set("cond", "3");
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) > 0)
			st.set("cond", "4");
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) > 0)
			st.set("cond", "5");
		else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) > 0)
			st.set("cond", "6");
		return null;
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		if(event.equalsIgnoreCase("first-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("first-have-2.htm"))
		{
			st.takeItems(KB_SOLDIER, 100);
			st.giveItems(MARK_OF_VARKA_ALLIANCE1, 1);
			st.set("cond", "2");
			st.getPlayer().setVarka(1);
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("second-have-2.htm"))
		{
			st.takeItems(KB_SOLDIER, 200);
			st.takeItems(KB_CAPTAIN, 100);
			st.takeItems(MARK_OF_VARKA_ALLIANCE1, 1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE2, 1);
			st.set("cond", "3");
			st.getPlayer().setVarka(2);
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("third-have-2.htm"))
		{
			st.takeItems(KB_SOLDIER, 300);
			st.takeItems(KB_CAPTAIN, 200);
			st.takeItems(KB_GENERAL, 100);
			st.takeItems(MARK_OF_VARKA_ALLIANCE2, 1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE3, 1);
			st.set("cond", "4");
			st.getPlayer().setVarka(3);
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("fourth-have-2.htm"))
		{
			st.takeItems(KB_SOLDIER, 300);
			st.takeItems(KB_CAPTAIN, 300);
			st.takeItems(KB_GENERAL, 200);
			st.takeItems(TOTEM_OF_VALOR, 1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE3, 1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE4, 1);
			st.set("cond", "5");
			st.getPlayer().setVarka(4);
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("fifth-have-2.htm"))
		{
			st.takeItems(KB_SOLDIER, 400);
			st.takeItems(KB_CAPTAIN, 400);
			st.takeItems(KB_GENERAL, 200);
			st.takeItems(TOTEM_OF_WISDOM, 1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE4, 1);
			st.giveItems(MARK_OF_VARKA_ALLIANCE5, 1);
			st.set("cond", "6");
			st.getPlayer().setVarka(5);
			st.playSound("ItemSound.quest_middle");
		}
		else if(event.equalsIgnoreCase("quit-2.htm"))
		{
			st.takeItems(MARK_OF_VARKA_ALLIANCE1, -1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE2, -1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE3, -1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE4, -1);
			st.takeItems(MARK_OF_VARKA_ALLIANCE5, -1);
			st.set("cond", "0");
			st.setState(COMPLETED);
			st.getPlayer().setVarka(0);
			st.playSound("ItemSound.quest_finish");
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		if(st.getPlayer().getKetra() > 0)
		{
			htmltext = "ketra.htm";
			st.exitCurrentQuest(true);
			return htmltext;
		}
		String id = String.valueOf(st.getState());
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		checkMarks(st);
		if(npcId == 31378)
		{
			if(cond == 0)
			{
				if(st.getPlayer().getLevel() >= 74)
				{
					if(id.equals("COMPLETED"))
						htmltext = "<html><body>You have already complete this quest.</body></html>";
					else
						htmltext = "first.htm";
				}
				else
				{
					htmltext = "no-level.htm";
					st.exitCurrentQuest(true);
				}
			}
			else if(cond == 1)
			{
				if(st.getQuestItemsCount(KB_SOLDIER) >= 100)
					htmltext = "first-have.htm";
				else
					htmltext = "first-havenot.htm";
			}
			else if(cond == 2)
			{
				if(st.getQuestItemsCount(KB_SOLDIER) >= 200 && st.getQuestItemsCount(KB_CAPTAIN) >= 100)
					htmltext = "second-have.htm";
				else
					htmltext = "second.htm";
			}
			else if(cond == 3)
			{
				if(st.getQuestItemsCount(KB_SOLDIER) >= 300 && st.getQuestItemsCount(KB_CAPTAIN) >= 200 && st.getQuestItemsCount(KB_GENERAL) >= 100)
					htmltext = "third-have.htm";
				else
					htmltext = "third.htm";
			}
			else if(cond == 4)
			{
				if(st.getQuestItemsCount(KB_SOLDIER) >= 300 && st.getQuestItemsCount(KB_CAPTAIN) >= 200 && st.getQuestItemsCount(KB_GENERAL) >= 200 && st.getQuestItemsCount(TOTEM_OF_VALOR) == 1)
					htmltext = "fourth-have.htm";
				else
					htmltext = "fourth.htm";
			}
			else if(cond == 5)
			{
				if(st.getQuestItemsCount(KB_SOLDIER) >= 400 && st.getQuestItemsCount(KB_CAPTAIN) >= 400 && st.getQuestItemsCount(KB_GENERAL) >= 200 && st.getQuestItemsCount(TOTEM_OF_WISDOM) == 1)
					htmltext = "fifth-have.htm";
				else
					htmltext = "fifth.htm";
			}
			else if(cond == 6)
				htmltext = "high.htm";
			return htmltext;
		}
		st.exitCurrentQuest(true);
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(npcId == SEER || npcId == WARRIOR || npcId == LIEUTENANT || npcId == ELITE_SOLDIER || npcId == MEDIUM || npcId == COMMAND || npcId == ELITE_GUARD || npcId == WHITE_CAPTAIN)
		{
			if(st.getInt("cond") > 1)
				if(Rnd.chance(40))
				{
					st.giveItems(KB_CAPTAIN, 1);
					st.playSound("ItemSound.quest_middle");
				}
		}
		else if(npcId == RAIDER || npcId == FOOTMAN || npcId == SCOUT || npcId == WAR_HOUND || npcId == SHAMAN)
		{
			if(st.getInt("cond") > 0)
				if(Rnd.chance(40))
				{
					st.giveItems(KB_SOLDIER, 1);
					st.playSound("ItemSound.quest_middle");
				}

		}
		else if(npcId == BATTALION_COMMANDER_SOLDIER || npcId == GENERAL || npcId == GREAT_SEER || npcId == KETRA_PROPHET || npcId == DISCIPLE_OF_PROPHET || npcId == PROPHET_GUARDS || npcId == HEAD_SHAMAN || npcId == HEAD_GUARDS)
			if(st.getInt("cond") > 2)
				if(Rnd.chance(40))
				{
					st.giveItems(KB_GENERAL, 1);
					st.playSound("ItemSound.quest_middle");
				}
		return null;

	}
}