package quests._612_WarwithKetraOrcs;

import javolution.util.FastList;
import javolution.util.FastMap;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _612_WarwithKetraOrcs extends Quest implements ScriptFile
{
	public void onLoad()
	{
		System.out.println("Loaded Quest: 612: War with Ketra Orc");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	//NPC
	private final int DURAI = 31377;
	
	// Quest items
	private final int MOLAR_OF_KETRA_ORC = 7234;
	private final int NEPENTHES_SEED = 7187;

	// etc
	private final int MARK_OF_VARKA_ALLIANCE1 = 7221;
	private final int MARK_OF_VARKA_ALLIANCE2 = 7222;
	private final int MARK_OF_VARKA_ALLIANCE3 = 7223;
	private final int MARK_OF_VARKA_ALLIANCE4 = 7224;
	private final int MARK_OF_VARKA_ALLIANCE5 = 7225;

	// items
	private final short i500 = 500;
	private final short i510 = 510;
	private final short i522 = 522;
	private final short i519 = 519;
	private final short i529 = 529;
	private final short i539 = 539;
	private final short i664 = 664;
	private final short i568 = 568;
	private final short i578 = 578;
	private final short i713 = 713;
	private final short i738 = 738;

	private final State CREATED = new State("Start", this);
	private final State STARTED = new State("Started", this);

	private final FastMap<Integer, Quest.Drop> DROPLIST = new FastMap<Integer, Quest.Drop>();
	
	private final int[] VARKA_NPC_LIST = new int[20];

	public _612_WarwithKetraOrcs()
	{
		super(612, "_612_WarwithKetraOrcs", "War with Ketra Orcs", false);
		Quest.Drop drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i500);
		DROPLIST.put(21324, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i510);
		DROPLIST.put(21327, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i522);
		DROPLIST.put(21328, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i519);
		DROPLIST.put(21329, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i529);
		DROPLIST.put(21331, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i529);
		DROPLIST.put(21332, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i539);
		DROPLIST.put(21334, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i664);
		DROPLIST.put(21343, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i568);
		DROPLIST.put(21339, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i568);
		DROPLIST.put(21340, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i578);
		DROPLIST.put(21342, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i713);
		DROPLIST.put(21345, drop);

		drop = new Quest.Drop(2, 10, 100);
		drop.addItem(i738);
		DROPLIST.put(21347, drop);

		setInitialState(CREATED);
		addStartNpc(DURAI);
		addTalkId(DURAI);
		
		VARKA_NPC_LIST[0] = 21350;
		VARKA_NPC_LIST[1] = 21351;
		VARKA_NPC_LIST[2] = 21353;
		VARKA_NPC_LIST[3] = 21354;
		VARKA_NPC_LIST[4] = 21355;
		VARKA_NPC_LIST[5] = 21357;
		VARKA_NPC_LIST[6] = 21358;
		VARKA_NPC_LIST[7] = 21360;
		VARKA_NPC_LIST[8] = 21361;
		VARKA_NPC_LIST[9] = 21362;
		VARKA_NPC_LIST[10] = 21364;
		VARKA_NPC_LIST[11] = 21365;
		VARKA_NPC_LIST[12] = 21366;
		VARKA_NPC_LIST[13] = 21368;
		VARKA_NPC_LIST[14] = 21369;
		VARKA_NPC_LIST[15] = 21370;
		VARKA_NPC_LIST[16] = 21371;
		VARKA_NPC_LIST[17] = 21372;
		VARKA_NPC_LIST[18] = 21373;
		VARKA_NPC_LIST[19] = 21374;
		
		for(int i : VARKA_NPC_LIST)
			addKillId(i);

		for(Integer mobId : DROPLIST.keySet())
		{
			addKillId(mobId);
			STARTED.addQuestDrop(mobId, MOLAR_OF_KETRA_ORC, 1);
		}
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31377-2.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("31377-4.htm"))
		{
			if(st.getQuestItemsCount(MOLAR_OF_KETRA_ORC) >= 100)
			{
				st.takeItems(MOLAR_OF_KETRA_ORC, 100);
				st.giveItems(NEPENTHES_SEED, 20);
			}
			else
				htmltext = "31377-havenot.htm";
		}
		else if(event.equalsIgnoreCase("31377-quit.htm"))
		{
			st.takeItems(MOLAR_OF_KETRA_ORC, -1);
			st.playSound("ItemSound.quest_finish");
			st.exitCurrentQuest(true);
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><head><body>I have nothing to say you</body></html>";
		int cond = st.getInt("cond");
		if(cond == 0)
		{
			if(st.getPlayer().getLevel() >= 74)
				htmltext = "31377-1.htm";
			else
			{
				htmltext = "31377-0.htm";
				st.exitCurrentQuest(true);
			}
		}
		else if(cond == 1 && st.getQuestItemsCount(MOLAR_OF_KETRA_ORC) == 0)
			htmltext = "31377-2r.htm";
		else if(cond == 1 && st.getQuestItemsCount(MOLAR_OF_KETRA_ORC) > 0)
			htmltext = "31377-3.htm";
		return htmltext;
	}

	public boolean isVarkaNpc(int npc)
	{
		for(int i : VARKA_NPC_LIST)
			if(npc == i)
				return true;
		return false;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		Quest.Drop drop = DROPLIST.get(npcId);
		if(drop == null)
			return null;
		int chance = 0;
		if(drop.chance != null)
			chance = drop.chance;
		FastList<Short> itemList = drop.itemList;
		int cond = st.getInt("cond");
		if(itemList.size() > 0)
		{
			if(cond == 1 && Rnd.chance(chance))
			{
				st.giveItems(MOLAR_OF_KETRA_ORC, 1);
				st.playSound("ItemSound.quest_itemget");
			}
		}
		else if(isVarkaNpc(npcId))
		{
			if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE5) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE5, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE4, 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE4) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE4, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE3, 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE3) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE3, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE2, 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE2) > 0)
			{
				st.takeItems(MARK_OF_VARKA_ALLIANCE2, -1);
				st.giveItems(MARK_OF_VARKA_ALLIANCE1, 1);
			}
			else if(st.getQuestItemsCount(MARK_OF_VARKA_ALLIANCE1) > 0)
				st.takeItems(MARK_OF_VARKA_ALLIANCE1, -1);
			st.getPlayer().setVarka(st.getPlayer().getVarka() - 1);
			st.exitQuest(605);
			st.exitQuest(606);
			st.exitQuest(607);
			st.exitQuest(608);
			st.exitQuest(609);
			st.exitQuest(610);
		}
		return null;
	}
}