package quests._617_GatherTheFlames;

import L2jFT.Config;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _617_GatherTheFlames extends Quest implements ScriptFile
{
	//Variables
	public int RATE = (int) Config.RATE_QUESTS_REWARD;
	//npc
	public final int VULCAN = 31539;
	//items
	public final int TORCH = 7264;
	//DROPLIST (MOB_ID, CHANCE)
	public final int[][] DROPLIST = {
			{ 21376, 48 }, { 21377, 48 }, { 21378, 48 }, { 21652, 48 },
			{ 21380, 48 }, { 21381, 51 }, { 21653, 51 }, { 21383, 51 },
			{ 21394, 51 }, { 21385, 51 }, { 21386, 51 }, { 21388, 53 },
			{ 21655, 53 }, { 21387, 53 }, { 21390, 56 }, { 21656, 56 },
			{ 21395, 56 }, { 21389, 56 }, { 21391, 56 }, { 21392, 56 },
			{ 21393, 58 }, { 21657, 58 }, { 21382, 60 }, { 21379, 60 },
			{ 21654, 64 }, { 21384, 64 } };

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 617: Gather the Flames");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _617_GatherTheFlames()
	{
		super(617, "_617_GatherTheFlames", "Gather the Flames", false);
		setInitialState(CREATED);
		addStartNpc(VULCAN);

		addTalkId(VULCAN);

		for(int[] element : DROPLIST)
			addKillId(element[0]);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31539-03.htm"))
		{
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
			st.set("cond", "1");
		}
		else if(event.equalsIgnoreCase("31539-08.htm"))
		{
			st.playSound("ItemSound.quest_finish");
			st.takeItems(TORCH, -1);
			st.exitCurrentQuest(true);
		}
		else if(event.equalsIgnoreCase("31539-07.htm"))
			if(st.getQuestItemsCount(TORCH) > 999)
			{
				st.takeItems(TORCH, 1000);
				int item = Rnd.get(10);
				if(item == 0)
					st.giveItems(6881, 1);
				else if(item == 1)
					st.giveItems(6883, 1);
				else if(item == 2)
					st.giveItems(6885, 1);
				else if(item == 3)
					st.giveItems(6887, 1);
				else if(item == 4)
					st.giveItems(7580, 1);
				else if(item == 5)
					st.giveItems(6891, 1);
				else if(item == 6)
					st.giveItems(6893, 1);
				else if(item == 7)
					st.giveItems(6895, 1);
				else if(item == 8)
					st.giveItems(6897, 1);
				else if(item == 9)
					st.giveItems(6899, 1);
				st.playSound("ItemSound.quest_middle");
			}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(npcId == VULCAN)
			if(cond < 1)
			{
				if(st.getPlayer().getLevel() < 74)
					htmltext = "31539-02.htm";
				else
					htmltext = "31539-01.htm";
			}
			else if(st.getQuestItemsCount(TORCH) < 1000)
				htmltext = "31539-05.htm";
			else
				htmltext = "31539-04.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		for(int[] element : DROPLIST)
			if(npc.getNpcId() == element[0])
				if(Rnd.chance(element[1]))
				{
					st.giveItems(TORCH, Rnd.get(RATE) + 1);
					st.playSound("ItemSound.quest_itemget");
				}
		return null;
	}
}