package quests._623_TheFinestFood;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _623_TheFinestFood extends Quest implements ScriptFile
{
	public final int JEREMY = 31521;

	public final int HOT_SPRINGS_BUFFALO = 21315;
	public final int HOT_SPRINGS_FLAVA = 21316;
	public final int HOT_SPRINGS_ANTELOPE = 21318;

	public final int LEAF_OF_FLAVA = 7199;
	public final int BUFFALO_MEAT = 7200;
	public final int ANTELOPE_HORN = 7201;
	public final int ADENA = 57;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 623: The Finest Food");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _623_TheFinestFood()
	{
		super(623, "_623_TheFinestFood", "The Finest Food", false);

		setInitialState(CREATED);
		addStartNpc(JEREMY);

		addTalkId(JEREMY);
		addTalkId(JEREMY);
		addTalkId(JEREMY);

		addKillId(HOT_SPRINGS_BUFFALO);
		addKillId(HOT_SPRINGS_FLAVA);
		addKillId(HOT_SPRINGS_ANTELOPE);

		STARTED.addQuestDrop(HOT_SPRINGS_BUFFALO, BUFFALO_MEAT, 1);
		STARTED.addQuestDrop(HOT_SPRINGS_FLAVA, LEAF_OF_FLAVA, 1);
		STARTED.addQuestDrop(HOT_SPRINGS_ANTELOPE, ANTELOPE_HORN, 1);
		STARTED.addQuestDrop(JEREMY, ADENA, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31521-02.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("31521-04.htm"))
		{
			st.takeItems(LEAF_OF_FLAVA, -1);
			st.takeItems(BUFFALO_MEAT, -1);
			st.takeItems(ANTELOPE_HORN, -1);
			st.giveItems(ADENA, 73000);
			st.addExpAndSp(230000, 18250);
			st.set("cond", "0");
			st.setState(COMPLETED);
			st.playSound("ItemSound.quest_finish");
		}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int npcId = npc.getNpcId();
		State id = st.getState();
		if(id.equals(CREATED))
			st.set("cond", "0");
		// На случай любых ошибок, если предметы есть - квест все равно пройдется.
		if(summ(st) >= 300)
			st.set("cond", "2");
		int cond = st.getInt("cond");
		if(npcId == JEREMY)
			if(cond == 0)
			{
				if(!id.equals(COMPLETED))
				{
					if(st.getPlayer().getLevel() >= 71)
						htmltext = "31521-01.htm";
					else
					{
						htmltext = "31521-00.htm";
						st.exitCurrentQuest(true);
					}
				}
				else
					htmltext = "<html><body>This quest have already been completed.</body></html>";
			}
			else if(cond == 1 && summ(st) < 300)
				htmltext = "31521-02r.htm";
			else if(cond == 2 && summ(st) >= 300)
				htmltext = "31521-03.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int cond = st.getInt("cond");
		int npcId = npc.getNpcId();
		if(cond == 1 && Rnd.chance(5))
			if(npcId == HOT_SPRINGS_BUFFALO)
			{
				if(st.getQuestItemsCount(BUFFALO_MEAT) < 100)
				{
					st.giveItems(BUFFALO_MEAT, 1);
					if(st.getQuestItemsCount(BUFFALO_MEAT) == 100)
					{
						if(summ(st) >= 300)
							st.set("cond", "2");
						st.playSound("ItemSound.quest_middle");
					}
					else
						st.playSound("ItemSound.quest_itemget");
				}
			}
			else if(npcId == HOT_SPRINGS_FLAVA)
			{
				if(st.getQuestItemsCount(LEAF_OF_FLAVA) < 100)
				{
					st.giveItems(LEAF_OF_FLAVA, 1);
					if(st.getQuestItemsCount(LEAF_OF_FLAVA) == 100)
					{
						if(summ(st) >= 300)
							st.set("cond", "2");
						st.playSound("ItemSound.quest_middle");
					}
					else
						st.playSound("ItemSound.quest_itemget");
				}
			}
			else if(npcId == HOT_SPRINGS_ANTELOPE)
				if(st.getQuestItemsCount(ANTELOPE_HORN) < 100)
				{
					st.giveItems(ANTELOPE_HORN, 1);
					if(st.getQuestItemsCount(ANTELOPE_HORN) == 100)
					{
						if(summ(st) >= 300)
							st.set("cond", "2");
						st.playSound("ItemSound.quest_middle");
					}
					else
						st.playSound("ItemSound.quest_itemget");
				}
		return null;
	}

	private int summ(QuestState st)
	{
		return st.getQuestItemsCount(LEAF_OF_FLAVA) + st.getQuestItemsCount(BUFFALO_MEAT) + st.getQuestItemsCount(ANTELOPE_HORN);
	}
}