package quests._631_DeliciousTopChoiceMeat;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;
import L2jFT.Config;

public class _631_DeliciousTopChoiceMeat extends Quest implements ScriptFile
{
	//NPC
	public final int TUNATUN = 31537;
	//MOBS
	public final int MOB_LIST[] = {
			21460, 21461, 21462, 21463, 21464, 21465, 21466, 21467, 21468, 21469, //Alpen Kookaburra
			21479, 21480, 21481, 21482, 21483, 21484, 21485, 21486, 21487, 21488, //Alpen Buffalo
			21498, 21499, 21500, 21501, 21502, 21503, 21504, 21505, 21506, 21507 };//Alpen Cougar
	//ITEMS
	public final int TOP_QUALITY_MEAT = 7546;
	//REWARDS
	public final int MOLD_GLUE = 4039;
	public final int MOLD_LUBRICANT = 4040;
	public final int MOLD_HARDENER = 4041;
	public final int ENRIA = 4042;
	public final int ASOFE = 4043;
	public final int THONS = 4044;
	public final int[][] REWARDS = {
			{ 1, MOLD_GLUE, 15 }, { 2, ASOFE, 15 }, { 3, THONS, 15 },
			{ 4, MOLD_LUBRICANT, 10 }, { 5, ENRIA, 10 }, { 6, MOLD_HARDENER, 5 } };

	public int CfgRate = (int) Config.RATE_QUESTS_REWARD;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 631: Delicious Top Choice Meat");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _631_DeliciousTopChoiceMeat()
	{
		super(631, "_631_DeliciousTopChoiceMeat", "Delicious Top Choice Meat", false);
		setInitialState(CREATED);
		addStartNpc(TUNATUN);

		addTalkId(TUNATUN);

		for(int i : MOB_LIST)
		{
			addKillId(i);
			STARTED.addQuestDrop(i, TOP_QUALITY_MEAT, 1);
		}
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("31537-03.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("31537-05.htm") && st.getQuestItemsCount(TOP_QUALITY_MEAT) >= 120)
			st.set("cond", "3");
		for(int[] element : REWARDS)
			if(event.equalsIgnoreCase(String.valueOf(element[0])))
				if(st.getInt("cond") == 3 && st.getQuestItemsCount(TOP_QUALITY_MEAT) >= 120)
				{
					htmltext = "31537-06.htm";
					st.takeItems(TOP_QUALITY_MEAT, -1);
					st.giveItems(element[1], element[2] * CfgRate);
					st.playSound("ItemSound.quest_finish");
					st.exitCurrentQuest(true);
				}
				else
				{
					htmltext = "31537-07.htm";
					st.set("cond", "1");
				}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you</body></html>";
		int cond = st.getInt("cond");
		if(cond < 1)
		{
			if(st.getPlayer().getLevel() < 65)
			{
				htmltext = "31537-02.htm";
				st.exitCurrentQuest(true);
			}
			else
				htmltext = "31537-01.htm";
		}
		else if(cond == 1)
			htmltext = "31537-01a.htm";
		else if(cond == 2)
		{
			if(st.getQuestItemsCount(TOP_QUALITY_MEAT) < 120)
			{
				htmltext = "31537-01a.htm";
				st.set("cond", "1");
			}
			else
				htmltext = "31537-04.htm";
		}
		else if(cond == 3)
			htmltext = "31537-05.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		if(st.getInt("cond") == 1)
			for(int i : MOB_LIST)
				if(Rnd.chance(8) && npcId == i)
				{
					st.giveItems(TOP_QUALITY_MEAT, 1);
					if(st.getQuestItemsCount(TOP_QUALITY_MEAT) < 120)
						st.playSound("ItemSound.quest_itemget");
					else
					{
						st.playSound("ItemSound.quest_middle");
						st.set("cond", "2");
					}
				}
		return null;
	}
}