package quests._636_TruthBeyond;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _636_TruthBeyond extends Quest implements ScriptFile
{
	public void onLoad()
	{
		System.out.println("Loaded Quest: 636: Truth Beyond");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	//Npc
	public final int ELIYAH = 31329;
	public final int FLAURON = 32010;

	//Items
	public final int MARK = 8067;
	public final int VISITORSMARK = 8064;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public _636_TruthBeyond()
	{
		super(636, "_636_TruthBeyond", "Truth Beyond", false);
		setInitialState(CREATED);
		addStartNpc(ELIYAH);
		addTalkId(ELIYAH);
		addTalkId(ELIYAH);
		addTalkId(FLAURON);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		if(event.equals("31329-04.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equals("32010-02.htm"))
		{
			st.playSound("ItemSound.quest_finish");
			st.giveItems(VISITORSMARK, 1);
			st.set("cond", "0");
			st.setState(COMPLETED);
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		String htmltext = "<html><head><body>I have nothing to say to you</body></html>";
		int cond = st.getInt("cond");
		if(npcId == ELIYAH && cond == 0)
		{
			if(st.getQuestItemsCount(VISITORSMARK) == 0 && st.getQuestItemsCount(MARK) == 0)
			{
				if(st.getPlayer().getLevel() > 72)
					htmltext = "31329-02.htm";
				else
				{
					htmltext = "31329-01.htm";
					st.exitCurrentQuest(true);
				}
			}
			else
				htmltext = "31329-05.htm";
		}
		else if(npcId == FLAURON)
			if(cond == 1)
			{
				htmltext = "32010-01.htm";
				st.set("cond", "2");
			}
			else
				htmltext = "32010-03.htm";
		return htmltext;
	}
}