package quests._637_ThroughOnceMore;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _637_ThroughOnceMore extends Quest implements ScriptFile
{
	public void onLoad()
	{
		System.out.println("Loaded Quest: 637: Through Once More");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	//Drop rate
	public final int CHANCE = 40;

	//Npc
	public final int FLAURON = 32010;

	//Items
	//public final int VISITORSMARK = 8064;
	public final int NECROHEART = 8066;
	public final int MARK = 8067;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public _637_ThroughOnceMore()
	{
		super(637, "_637_ThroughOnceMore", "Through Once More", false);
		setInitialState(CREATED);
		addStartNpc(FLAURON);
		addTalkId(FLAURON);
		addTalkId(FLAURON);
		addKillId(21565);
		addKillId(21568);
		STARTED.addQuestDrop(FLAURON, NECROHEART, 1);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		if(event.equals("32010-04.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			// Скорее всего эту марку на оффе забирают при первом посещении Pagan Temple,
			// поэтому проверяем на наличие выполненного квеста _636_TruthBeyond
			//st.takeItems(VISITORSMARK, 1);
			st.playSound("ItemSound.quest_accept");
		}
		return event;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext;
		int cond = st.getInt("cond");
		if(cond == 0)
		{
			//if(st.getPlayer().getLevel() > 72 && st.getQuestItemsCount(VISITORSMARK) > 0)
			QuestState qs = st.getPlayer().getQuestState("_636_TruthBeyond");
			if(st.getPlayer().getLevel() > 72 && qs != null && qs.isCompleted())
				htmltext = "32010-02.htm";
			else
			{
				htmltext = "32010-01.htm";
				st.exitCurrentQuest(true);
			}
		}
		else if(cond == 2 && st.getQuestItemsCount(NECROHEART) == 10)
		{
			htmltext = "32010-05.htm";
			st.takeItems(NECROHEART, 10);
			st.giveItems(MARK, 1);
			st.set("cond", "0");
			st.setState(COMPLETED);
			st.playSound("ItemSound.quest_finish");
		}
		else
			htmltext = "32010-04.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int count = st.getQuestItemsCount(NECROHEART);
		if(st.getInt("cond") == 1 && Rnd.chance(CHANCE) && count < 10)
		{
			st.giveItems(NECROHEART, 1);
			if(count == 9)
			{
				st.playSound("ItemSound.quest_middle");
				st.set("cond", "2");
			}
			else
				st.playSound("ItemSound.quest_itemget");
		}
		return null;
	}
}