package quests._659_IdRatherBeCollectingFairyBreath;

// Created by Artful

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;
import L2jFT.util.Rnd;

public class _659_IdRatherBeCollectingFairyBreath extends Quest implements ScriptFile
{
	//NPC
	public final int GALATEA = 30634;
	//Mobs
	public final int[] MOBS = { 20078, 21026, 21025, 21024, 21023 };
	//Quest Item
	public final int FAIRY_BREATH = 8286;
	//Item
	public final int ADENA = 57;
	//Main
	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("Loaded Quest: 659: I'd Rather Be Collecting Fairy Breath");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _659_IdRatherBeCollectingFairyBreath()
	{
		super(659, "_659_IdRatherBeCollectingFairyBreath", "I'd Rather Be Collecting Fairy Breath", false);
		setInitialState(CREATED);
		addStartNpc(GALATEA);
		addTalkId(GALATEA);
		addTalkId(GALATEA);
		addTalkId(GALATEA);

		for(int i : MOBS)
			addKillId(i);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = event;
		if(event.equalsIgnoreCase("30634-03.htm"))
		{
			st.set("cond", "1");
			st.setState(STARTED);
			st.playSound("ItemSound.quest_accept");
		}
		else if(event.equalsIgnoreCase("30634-06.htm"))
		{
			int count = st.getQuestItemsCount(FAIRY_BREATH);
			if(count > 0)
			{
				int reward = 0;
				if(count < 10)
					reward = count * 50;
				else
					reward = count * 50 + 5365;
				st.takeItems(FAIRY_BREATH, -1);
				st.giveItems(ADENA, reward);
			}
		}
		else if(event.equalsIgnoreCase("30634-08.htm"))
			st.exitCurrentQuest(true);
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		String htmltext = "no_quest.htm";
		State id = st.getState();
		int cond = 0;
		if(!id.equals(CREATED))
			cond = st.getInt("cond");
		if(npcId == GALATEA)
			if(st.getPlayer().getLevel() < 26)
			{
				htmltext = "30634-01.htm";
				st.exitCurrentQuest(true);
			}
			else if(cond == 0)
				htmltext = "30634-02.htm";
			else if(cond == 1)
				if(st.getQuestItemsCount(FAIRY_BREATH) == 0)
					htmltext = "30634-04.htm";
				else
					htmltext = "30634-05.htm";
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		int npcId = npc.getNpcId();
		int cond = st.getInt("cond");
		if(cond == 1)
			for(int i : MOBS)
				if(npcId == i && Rnd.chance(30))
				{
					st.giveItems(FAIRY_BREATH, 1);
					st.playSound("ItemSound.quest_itemget");
				}
		return null;
	}
}