package quests.village_master._30026_bitz_occupation_change;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.base.ClassId;
import L2jFT.game.model.base.Race;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _30026_bitz_occupation_change extends Quest implements ScriptFile
{
	public final int GRAND_MASTER_BITZ = 30026;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("importing village master data: Talking Island Village ...done");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _30026_bitz_occupation_change()
	{
		super(30026, "_30026_bitz_occupation_change", "GNOME occupation change", false);
		setInitialState(CREATED);
		addStartNpc(GRAND_MASTER_BITZ);
		addTalkId(GRAND_MASTER_BITZ);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = "No Quest";

		if(event.equalsIgnoreCase("30026-01.htm"))
			return "30026-01.htm";

		if(event.equalsIgnoreCase("30026-02.htm"))
			return "30026-02.htm";

		if(event.equalsIgnoreCase("30026-03.htm"))
			return "30026-03.htm";

		if(event.equalsIgnoreCase("30026-04.htm"))
			return "30026-04.htm";

		if(event.equalsIgnoreCase("30026-05.htm"))
			return "30026-05.htm";

		if(event.equalsIgnoreCase("30026-06.htm"))
			return "30026-06.htm";

		if(event.equalsIgnoreCase("30026-07.htm"))
			return "30026-07.htm";
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you Patty!</body></html>";
		int npcId = npc.getNpcId();
		final Race race = st.getPlayer().getRace();
		final ClassId classId = st.getPlayer().getClassId();
		System.out.println(" player " + st.getPlayer().getName() + "  npcId " + npcId + "race" + race + " classId " + classId);

		// Humans got accepted
		if(npcId == GRAND_MASTER_BITZ && race == Race.Human)
		{
			//fighter
			if(classId == ClassId.fighter)
				return "30026-01.htm";

			//warrior, knight, rogue
			if(classId == ClassId.warrior || classId == ClassId.knight || classId == ClassId.rogue)
				return "30026-08.htm";
			//warlord, paladin, treasureHunter
			if(classId == ClassId.warlord || classId == ClassId.paladin || classId == ClassId.treasureHunter)
				return "30026-09.htm";
			//gladiator, darkAvenger, hawkeye
			if(classId == ClassId.gladiator || classId == ClassId.darkAvenger || classId == ClassId.hawkeye)
				return "30026-09.htm";
			//mage, wizard, cleric]:
			if(classId == ClassId.mage || classId == ClassId.wizard || classId == ClassId.cleric)
				return "30026-10.htm";
			//sorceror, necromancer, warlock, bishop, prophet
			if(classId == ClassId.sorceror || classId == ClassId.necromancer || classId == ClassId.warlock || classId == ClassId.bishop || classId == ClassId.prophet)
				return "30026-10.htm";

			st.setState(STARTED);
			return htmltext;
		}

		/////		
		// All other Races must be out
		st.exitCurrentQuest(true);
		return "30026-10.htm";
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}

}
