package quests.village_master._30031_biotin_occupation_change;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.base.ClassId;
import L2jFT.game.model.base.Race;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _30031_biotin_occupation_change extends Quest implements ScriptFile
{
	public final int HIGH_PRIEST_BIOTIN = 30031;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
	//System.out.println("importing village master data: Town of Oren           ...done");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _30031_biotin_occupation_change()
	{
		super(30031, "_30031_biotin_occupation_change", "village_master", false);
		setInitialState(CREATED);
		addStartNpc(HIGH_PRIEST_BIOTIN);
		addTalkId(HIGH_PRIEST_BIOTIN);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = "No Quest";

		if(event.equalsIgnoreCase("30031-01.htm"))
			return "30031-01.htm";

		if(event.equalsIgnoreCase("30031-02.htm"))
			return "30031-02.htm";

		if(event.equalsIgnoreCase("30031-03.htm"))
			return "30031-03.htm";

		if(event.equalsIgnoreCase("30031-04.htm"))
			return "30031-04.htm";

		if(event.equalsIgnoreCase("30031-05.htm"))
			return "30031-05.htm";

		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you Patty!</body></html>";
		int npcId = npc.getNpcId();
		final Race race = st.getPlayer().getRace();
		final ClassId classId = st.getPlayer().getClassId();
		System.out.println(" player " + st.getPlayer().getName() + "  npcId " + npcId + "race" + race + " classId " + classId);

		if(npcId == HIGH_PRIEST_BIOTIN && race == Race.Human)
		{
			if(classId == ClassId.fighter || classId == ClassId.warrior || classId == ClassId.knight || classId == ClassId.rogue)
				return "30031-08.htm";

			if(classId == ClassId.warlord || classId == ClassId.paladin || classId == ClassId.treasureHunter)
				return "30031-08.htm";

			if(classId == ClassId.gladiator || classId == ClassId.darkAvenger || classId == ClassId.hawkeye)
				return "30031-08.htm";

			if(classId == ClassId.wizard || classId == ClassId.cleric)
				return "30031-06.htm";

			if(classId == ClassId.sorceror || classId == ClassId.necromancer || classId == ClassId.warlock || classId == ClassId.bishop || classId == ClassId.prophet)
				return "30031-07.htm";
			if(classId == ClassId.mage)
				return "30031-01.htm";

			// All other Races must be out
			st.exitCurrentQuest(true);
			return "30031-08.htm";
		}
		st.setState(STARTED);
		return htmltext;
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}

}
