package quests.village_master._30037_levian_occupation_change;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.base.ClassId;
import L2jFT.game.model.base.Race;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _30037_levian_occupation_change extends Quest implements ScriptFile
{
	public final short MARK_OF_FAITH_ID = 1201;
	public final short ETERNITY_DIAMOND_ID = 1230;
	public final short LEAF_OF_ORACLE_ID = 1235;
	public final short BEAD_OF_SEASON_ID = 1292;
	public final int HIGH_PRIESTESS_LEVIAN = 30037;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("importing village master data:            ...done");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _30037_levian_occupation_change()
	{
		super(30037, "_30037_levian_occupation_change", "GNOME occupation change", false);
		setInitialState(CREATED);
		addStartNpc(HIGH_PRIESTESS_LEVIAN);
		addTalkId(HIGH_PRIESTESS_LEVIAN);

	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = "No Quest";
		//		final Race race = st.getPlayer().getRace();
		//		final ClassId classId = st.getPlayer().getClassId();

		//		short race     = st.getPlayer().getRace();
		//		short ClassId  = st.getPlayer().getClassId();
		//	short NewClass = 55;
		int Level = st.getPlayer().getLevel();

		if(event.equalsIgnoreCase("30037-01.htm"))
			return "30037-01.htm";

		if(event.equalsIgnoreCase("30037-02.htm"))
			return "30037-02.htm";

		if(event.equalsIgnoreCase("30037-03.htm"))
			return "30037-03.htm";

		if(event.equalsIgnoreCase("30037-04.htm"))
			return "30037-04.htm";

		if(event.equalsIgnoreCase("30037-05.htm"))
			return "30037-05.htm";

		if(event.equalsIgnoreCase("30037-06.htm"))
			return "30037-06.htm";

		if(event.equalsIgnoreCase("30037-07.htm"))
			return "30037-07.htm";

		if(event.equalsIgnoreCase("30037-08.htm"))
			return "30037-08.htm";

		if(event.equalsIgnoreCase("30037-09.htm"))
			return "30037-09.htm";

		if(event.equalsIgnoreCase("30037-10.htm"))
			return "30037-10.htm";

		if(event.equalsIgnoreCase("30037-11.htm"))
			return "30037-11.htm";

		if(event.equalsIgnoreCase("30037-12.htm"))
			return "30037-12.htm";

		if(event.equalsIgnoreCase("30037-13.htm"))
			return "30037-13.htm";

		if(event.equalsIgnoreCase("30037-14.htm"))
			return "30037-14.htm";

		if(event.equalsIgnoreCase("class_change_26"))
			if(st.getPlayer().getClassId() == ClassId.elvenMage)
			{
				if(Level <= 19 && st.getQuestItemsCount(ETERNITY_DIAMOND_ID) == 0)
					return "30037-15.htm";
				if(Level <= 19 && st.getQuestItemsCount(ETERNITY_DIAMOND_ID) >= 1)
					return "30037-16.htm";
				if(Level >= 20 && st.getQuestItemsCount(ETERNITY_DIAMOND_ID) == 0)
					return "30037-17.htm";
				if(Level >= 20 && st.getQuestItemsCount(ETERNITY_DIAMOND_ID) >= 1)
				{
					boolean noban = false;
					short numClass = 26;
					st.takeItems(ETERNITY_DIAMOND_ID, 1);
					st.getPlayer().setClassId(numClass, noban);
					st.playSound("ItemSound.quest_fanfare_2");
					return "30037-18.htm";
				}
			}

		if(event.equalsIgnoreCase("class_change_29"))
			if(st.getPlayer().getClassId() == ClassId.elvenMage)
			{
				if(Level <= 19 && st.getQuestItemsCount(LEAF_OF_ORACLE_ID) == 0)
					return "30037-19.htm";
				if(Level <= 19 && st.getQuestItemsCount(LEAF_OF_ORACLE_ID) >= 1)
					return "30037-20.htm";
				if(Level >= 20 && st.getQuestItemsCount(LEAF_OF_ORACLE_ID) == 0)
					return "30037-21.htm";
				if(Level >= 20 && st.getQuestItemsCount(LEAF_OF_ORACLE_ID) >= 1)
				{

					boolean noban = false;
					short numClass = 29;
					st.takeItems(LEAF_OF_ORACLE_ID, 1);
					st.getPlayer().setClassId(numClass, noban);
					st.playSound("ItemSound.quest_fanfare_2");
					return "30037-22.htm";
				}
			}

		if(event.equalsIgnoreCase("class_change_11"))
			// ClassId.mage seems buggy !?
			if(st.getPlayer().getClassId() != ClassId.fighter)
			{
				if(Level <= 19 && st.getQuestItemsCount(BEAD_OF_SEASON_ID) == 0)
					return "30037-23.htm";
				if(Level <= 19 && st.getQuestItemsCount(BEAD_OF_SEASON_ID) >= 1)
					return "30037-24.htm";
				if(Level >= 20 && st.getQuestItemsCount(BEAD_OF_SEASON_ID) == 0)
					return "30037-25.htm";
				if(Level >= 20 && st.getQuestItemsCount(BEAD_OF_SEASON_ID) >= 1)
				{
					boolean noban = false;
					short numClass = 11;
					st.takeItems(BEAD_OF_SEASON_ID, 1);
					st.getPlayer().setClassId(numClass, noban);
					st.playSound("ItemSound.quest_fanfare_2");
					return "30037-26.htm";
				}
			}

		if(event.equalsIgnoreCase("class_change_15"))
			// ClassId.mage seems buggy !?
			if(st.getPlayer().getClassId() != ClassId.fighter)
			{
				if(Level <= 19 && st.getQuestItemsCount(MARK_OF_FAITH_ID) == 0)
					return "30037-27.htm";
				if(Level <= 19 && st.getQuestItemsCount(MARK_OF_FAITH_ID) >= 1)
					return "30037-28.htm";
				if(Level >= 20 && st.getQuestItemsCount(MARK_OF_FAITH_ID) == 0)
					return "30037-29.htm";
				if(Level >= 20 && st.getQuestItemsCount(MARK_OF_FAITH_ID) >= 1)
				{
					boolean noban = false;
					short numClass = 15;
					st.takeItems(MARK_OF_FAITH_ID, 1);
					st.getPlayer().setClassId(numClass, noban);
					st.playSound("ItemSound.quest_fanfare_2");
					return "30037-30.htm";
				}
			}

		st.setState(COMPLETED);
		st.exitCurrentQuest(true);
		return htmltext;

	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you Patty!</body></html>";
		int npcId = npc.getNpcId();
		final Race race = st.getPlayer().getRace();
		final ClassId classId = st.getPlayer().getClassId();
		System.out.println(" player " + st.getPlayer().getName() + "  npcId " + npcId + "race" + race + " classId " + classId);

		// Elfs and Humanss got accepted
		if(npcId == HIGH_PRIESTESS_LEVIAN && (race == Race.Elf || race == Race.Human))
		{
			if(classId == ClassId.elvenMage)
			{
				htmltext = "30037-01.htm";
				st.setState(STARTED);
				return htmltext;
			}
			if(classId == ClassId.wizard || classId == ClassId.cleric || classId == ClassId.elvenWizard || classId == ClassId.oracle)
				return "30037-31.htm";
			if(classId == ClassId.sorceror || classId == ClassId.necromancer || classId == ClassId.bishop || classId == ClassId.warlock || classId == ClassId.prophet)
				return "30037-32.htm";
			if(classId == ClassId.spellsinger || classId == ClassId.elder || classId == ClassId.elementalSummoner)
				return "30037-32.htm";
			if(classId == ClassId.warrior || classId == ClassId.knight || classId == ClassId.rogue || classId == ClassId.warlord || classId == ClassId.paladin)
				return "30037-33.htm";
			if(classId == ClassId.treasureHunter || classId == ClassId.gladiator || classId == ClassId.darkAvenger || classId == ClassId.hawkeye)
				return "30037-33.htm";
			// ClassId.mage seems buggy !?
			if(classId != ClassId.fighter)
			{
				htmltext = "30037-08.htm";
				st.setState(STARTED);
				return htmltext;
			}

			htmltext = "30037-33.htm";

			st.setState(COMPLETED);
			st.exitCurrentQuest(true);
			return htmltext;
		}
		// All other Races must be out
		if(npcId == HIGH_PRIESTESS_LEVIAN && (race == Race.Dwarf || race == Race.DarkElf || race == Race.Orc))
		{
			st.setState(COMPLETED);
			st.exitCurrentQuest(true);
			return "30037-33.htm";
		}
		return "";
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}

}
