package quests.village_master._30066_pabris_occupation_change;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.base.ClassId;
import L2jFT.game.model.base.Race;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _30066_pabris_occupation_change extends Quest implements ScriptFile
{
	public final short MEDALLION_OF_WARRIOR_ID = 1145;
	public final short SWORD_OF_RITUAL_ID = 1161;
	public final short BEZIQUES_RECOMMENDATION_ID = 1190;
	public final short ELVEN_KNIGHT_BROOCH_ID = 1204;
	public final short REORIA_RECOMMENDATION_ID = 1217;
	public final int GRAND_MASTER_PABRIS = 30066;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("importing village master data:            ...done");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _30066_pabris_occupation_change()
	{
		super(30066, "_30066_pabris_occupation_change", "occupation change", false);
		setInitialState(CREATED);
		addStartNpc(GRAND_MASTER_PABRIS);
		addTalkId(GRAND_MASTER_PABRIS);

	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = "No Quest";

		//short race     = st.getPlayer().getRace();
		//short ClassId  = st.getPlayer().getClassId();
		final ClassId classId = st.getPlayer().getClassId();
		//short NewClass = 55;
		int Level = st.getPlayer().getLevel();

		if(event.equalsIgnoreCase("30066-01.htm"))
			return "30066-01.htm";

		if(event.equalsIgnoreCase("30066-02.htm"))
			return "30066-02.htm";

		if(event.equalsIgnoreCase("30066-03.htm"))
			return "30066-03.htm";

		if(event.equalsIgnoreCase("30066-04.htm"))
			return "30066-04.htm";

		if(event.equalsIgnoreCase("30066-05.htm"))
			return "30066-05.htm";

		if(event.equalsIgnoreCase("30066-06.htm"))
			return "30066-06.htm";

		if(event.equalsIgnoreCase("30066-07.htm"))
			return "30066-07.htm";

		if(event.equalsIgnoreCase("30066-08.htm"))
			return "30066-08.htm";

		if(event.equalsIgnoreCase("30066-09.htm"))
			return "30066-09.htm";

		if(event.equalsIgnoreCase("30066-10.htm"))
			return "30066-10.htm";

		if(event.equalsIgnoreCase("30066-11.htm"))
			return "30066-11.htm";

		if(event.equalsIgnoreCase("30066-12.htm"))
			return "30066-12.htm";

		if(event.equalsIgnoreCase("30066-13.htm"))
			return "30066-13.htm";

		if(event.equalsIgnoreCase("30066-14.htm"))
			return "30066-14.htm";

		if(event.equalsIgnoreCase("30066-15.htm"))
			return "30066-15.htm";

		if(event.equalsIgnoreCase("30066-16.htm"))
			return "30066-16.htm";

		if(event.equalsIgnoreCase("30066-17.htm"))
			return "30066-17.htm";

		if(event.equalsIgnoreCase("class_change_19"))
			if(classId == ClassId.elvenFighter)
			{
				if(Level <= 19 && st.getQuestItemsCount(ELVEN_KNIGHT_BROOCH_ID) == 0)
					htmltext = "30066-18.htm";
				if(Level <= 19 && st.getQuestItemsCount(ELVEN_KNIGHT_BROOCH_ID) >= 1)
					htmltext = "30066-19.htm";
				if(Level >= 20 && st.getQuestItemsCount(ELVEN_KNIGHT_BROOCH_ID) == 0)
					htmltext = "30066-20.htm";
				if(Level >= 20 && st.getQuestItemsCount(ELVEN_KNIGHT_BROOCH_ID) >= 1)
				{
					boolean noban = false;
					short numClass = 19;
					st.takeItems(ELVEN_KNIGHT_BROOCH_ID, 1);
					st.getPlayer().setClassId(numClass, noban);
					st.playSound("ItemSound.quest_fanfare_2");
					htmltext = "30066-21.htm";
				}
			}

		if(event.equalsIgnoreCase("class_change_22"))
			if(classId == ClassId.elvenFighter)
			{
				if(Level <= 19 && st.getQuestItemsCount(REORIA_RECOMMENDATION_ID) == 0)
					htmltext = "30066-22.htm";
				if(Level <= 19 && st.getQuestItemsCount(REORIA_RECOMMENDATION_ID) >= 1)
					htmltext = "30066-23.htm";
				if(Level >= 20 && st.getQuestItemsCount(REORIA_RECOMMENDATION_ID) == 0)
					htmltext = "30066-24.htm";
				if(Level >= 20 && st.getQuestItemsCount(REORIA_RECOMMENDATION_ID) >= 1)
				{
					boolean noban = false;
					short numClass = 22;
					st.takeItems(REORIA_RECOMMENDATION_ID, 1);
					st.getPlayer().setClassId(numClass, noban);
					st.playSound("ItemSound.quest_fanfare_2");
					htmltext = "30066-25.htm";
				}
			}

		if(event.equalsIgnoreCase("сlass_change_1"))
			if(classId == ClassId.fighter)
			{
				if(Level <= 19 && st.getQuestItemsCount(MEDALLION_OF_WARRIOR_ID) == 0)
					htmltext = "30066-26.htm";
				if(Level <= 19 && st.getQuestItemsCount(MEDALLION_OF_WARRIOR_ID) >= 1)
					htmltext = "30066-27.htm";
				if(Level >= 20 && st.getQuestItemsCount(MEDALLION_OF_WARRIOR_ID) == 0)
					htmltext = "30066-28.htm";
				if(Level >= 20 && st.getQuestItemsCount(MEDALLION_OF_WARRIOR_ID) >= 1)
				{
					boolean noban = false;
					short numClass = 1;
					st.takeItems(MEDALLION_OF_WARRIOR_ID, 1);
					st.getPlayer().setClassId(numClass, noban);
					st.playSound("ItemSound.quest_fanfare_2");
					htmltext = "30066-29.htm";
				}
			}

		if(event.equalsIgnoreCase("class_change_4"))
			if(classId == ClassId.fighter)
			{
				if(Level <= 19 && st.getQuestItemsCount(SWORD_OF_RITUAL_ID) == 0)
					htmltext = "30066-30.htm";
				if(Level <= 19 && st.getQuestItemsCount(SWORD_OF_RITUAL_ID) >= 1)
					htmltext = "30066-31.htm";
				if(Level >= 20 && st.getQuestItemsCount(SWORD_OF_RITUAL_ID) == 0)
					htmltext = "30066-32.htm";
				if(Level >= 20 && st.getQuestItemsCount(SWORD_OF_RITUAL_ID) >= 1)
				{
					boolean noban = false;
					short numClass = 4;
					st.takeItems(SWORD_OF_RITUAL_ID, 1);
					st.getPlayer().setClassId(numClass, noban);
					st.playSound("ItemSound.quest_fanfare_2");
					htmltext = "30066-33.htm";
				}
			}

		if(event.equalsIgnoreCase("class_change_7"))
			if(classId == ClassId.fighter)
			{
				if(Level <= 19 && st.getQuestItemsCount(BEZIQUES_RECOMMENDATION_ID) == 0)
					htmltext = "30066-34.htm";
				if(Level <= 19 && st.getQuestItemsCount(BEZIQUES_RECOMMENDATION_ID) >= 1)
					htmltext = "30066-35.htm";
				if(Level >= 20 && st.getQuestItemsCount(BEZIQUES_RECOMMENDATION_ID) == 0)
					htmltext = "30066-36.htm";
				if(Level >= 20 && st.getQuestItemsCount(BEZIQUES_RECOMMENDATION_ID) >= 1)
				{
					boolean noban = false;
					short numClass = 7;
					st.takeItems(BEZIQUES_RECOMMENDATION_ID, 1);
					st.getPlayer().setClassId(numClass, noban);
					st.playSound("ItemSound.quest_fanfare_2");
					htmltext = "30066-37.htm";
				}
			}

		st.setState(COMPLETED);
		st.exitCurrentQuest(true);
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you Patty!</body></html>";
		int npcId = npc.getNpcId();
		final Race race = st.getPlayer().getRace();
		final ClassId classId = st.getPlayer().getClassId();
		System.out.println(" player " + st.getPlayer().getName() + "  npcId " + npcId + "race" + race + " classId " + classId);

		// Humans and Elfs got accepted
		if(npcId == GRAND_MASTER_PABRIS && (race == Race.Elf || race == Race.Human))
		{
			if(classId == ClassId.elvenFighter)
			{
				htmltext = "30066-01.htm";
				st.setState(STARTED);
				return htmltext;
				//st.setState(STARTED);
				//return "30066-01.htm";	       
			}

			if(classId == ClassId.fighter)
			{
				htmltext = "30066-08.htm";
				st.setState(STARTED);
				return htmltext;

				//st.setState(STARTED);
				//return "30066-08.htm";
			}
			if(classId == ClassId.elvenKnight || classId == ClassId.elvenScout || classId == ClassId.warrior || classId == ClassId.knight || classId == ClassId.rogue)
				htmltext = "30066-38.htm";
			if(classId == ClassId.templeKnight || classId == ClassId.plainsWalker || classId == ClassId.swordSinger || classId == ClassId.silverRanger)
				htmltext = "30066-39.htm";
			if(classId == ClassId.warlord || classId == ClassId.paladin || classId == ClassId.treasureHunter)
				htmltext = "30066-39.htm";
			if(classId == ClassId.gladiator || classId == ClassId.darkAvenger || classId == ClassId.hawkeye)
				htmltext = "30066-39.htm";
			else
				htmltext = "30066-40.htm";

			st.setState(COMPLETED);
			st.exitCurrentQuest(true);
			return htmltext;
		}
		// All other Races must be out
		if(npcId == GRAND_MASTER_PABRIS && (race == Race.Dwarf || race == Race.DarkElf || race == Race.Orc))
		{
			htmltext = "30066-40.htm";
			st.exitCurrentQuest(true);
			st.setState(COMPLETED);
			return htmltext;

			//st.setState(COMPLETED);
			//st.exitCurrentQuest(true); 
			//return "30066-40.htm";
		}

		return "";
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}

}
