package quests.village_master._30511_gesto_occupation_change;

import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.base.ClassId;
import L2jFT.game.model.base.Race;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.model.quest.State;

public class _30511_gesto_occupation_change extends Quest implements ScriptFile
{
	public final short MARK_OF_SEARCHER_ID = 2809;
	public final short MARK_OF_GUILDSMAN_ID = 3119;
	public final short MARK_OF_PROSPERITY_ID = 3238;
	public final int WAREHOUSE_CHIEF_GESTO = 30511;
	public final int WAREHOUSE_CHIEF_CROOP = 30676;
	public final int WAREHOUSE_CHIEF_BRAXT = 30685;
	public final int WAREHOUSE_CHIEF_KLUMP = 30845;
	public final int WAREHOUSE_CHIEF_NATOOLS = 30894;

	public State CREATED = new State("Start", this);
	public State STARTED = new State("Started", this);
	public State COMPLETED = new State("Completed", this);

	public void onLoad()
	{
		System.out.println("importing village master data: _30511_gesto_occupation_change");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public _30511_gesto_occupation_change()
	{
		super(30511, "_30511_gesto_occupation_change", "GNOME occupation change", false);
		setInitialState(CREATED);
		addStartNpc(WAREHOUSE_CHIEF_GESTO);
		addStartNpc(WAREHOUSE_CHIEF_CROOP);
		addStartNpc(WAREHOUSE_CHIEF_BRAXT);
		addStartNpc(WAREHOUSE_CHIEF_KLUMP);
		addStartNpc(WAREHOUSE_CHIEF_NATOOLS);
		addTalkId(WAREHOUSE_CHIEF_GESTO);
		addTalkId(WAREHOUSE_CHIEF_CROOP);
		addTalkId(WAREHOUSE_CHIEF_BRAXT);
		addTalkId(WAREHOUSE_CHIEF_KLUMP);
		addTalkId(WAREHOUSE_CHIEF_NATOOLS);
	}

	@Override
	public String onEvent(String event, QuestState st)
	{
		String htmltext = "No Quest";

		//short race     = st.getPlayer().getRace();
		//short ClassId  = st.getPlayer().getClassId();
		short NewClass = 55;
		int Level = st.getPlayer().getLevel();

		if(event.equalsIgnoreCase("30511-01.htm"))
			return "30511-01.htm";

		if(event.equalsIgnoreCase("30511-02.htm"))
			return "30511-02.htm";

		if(event.equalsIgnoreCase("30511-03.htm"))
			return "30511-03.htm";

		if(event.equalsIgnoreCase("30511-04.htm"))
			return "30511-04.htm";

		if(event.equalsIgnoreCase("class_change_55"))
			if(st.getPlayer().getClassId() == ClassId.scavenger)
				if(Level <= 39)
				{
					if(st.getQuestItemsCount(MARK_OF_SEARCHER_ID) == 0 || st.getQuestItemsCount(MARK_OF_GUILDSMAN_ID) == 0 || st.getQuestItemsCount(MARK_OF_PROSPERITY_ID) == 0)
						htmltext = "30511-05.htm";
					else
						htmltext = "30511-06.htm";
				}
				else if(st.getQuestItemsCount(MARK_OF_SEARCHER_ID) == 0 || st.getQuestItemsCount(MARK_OF_GUILDSMAN_ID) == 0 || st.getQuestItemsCount(MARK_OF_PROSPERITY_ID) == 0)
					htmltext = "30511-07.htm";
				else
				{
					boolean noban = false;
					st.takeItems(MARK_OF_SEARCHER_ID, 1);
					st.takeItems(MARK_OF_GUILDSMAN_ID, 1);
					st.takeItems(MARK_OF_PROSPERITY_ID, 1);
					st.getPlayer().setClassId(NewClass, noban);
					st.playSound("ItemSound.quest_fanfare_2");
					htmltext = "30511-08.htm";
					st.exitCurrentQuest(true);
				}
		return htmltext;
	}

	@Override
	public String onTalk(L2NpcInstance npc, QuestState st)
	{
		String htmltext = "<html><body>I have nothing to say you Patty!</body></html>";
		int npcId = npc.getNpcId();
		final Race race = st.getPlayer().getRace();
		final ClassId classId = st.getPlayer().getClassId();
		//System.out.println(" player " + st.getPlayer().getName() + "  npcId " + npcId + "race" + race + " classId " + classId);

		// Dwarfs got accepted
		if((npcId == WAREHOUSE_CHIEF_GESTO || npcId == WAREHOUSE_CHIEF_BRAXT || npcId == WAREHOUSE_CHIEF_CROOP || npcId == WAREHOUSE_CHIEF_KLUMP || npcId == WAREHOUSE_CHIEF_NATOOLS) && race == Race.Dwarf)
			if(classId == ClassId.scavenger)
			{
				htmltext = "30511-01.htm";
				st.setState(STARTED);
				return htmltext;
			}
			else if(classId == ClassId.dwarvenFighter)
			{
				htmltext = "30511-09.htm";
				st.exitCurrentQuest(true);
				return htmltext;
			}
			else if(classId == ClassId.bountyHunter || classId == ClassId.warsmith)
			{
				htmltext = "30511-10.htm";
				st.exitCurrentQuest(true);
				return htmltext;
			}
			else
			{
				htmltext = "30511-11.htm";
				st.exitCurrentQuest(true);
				return htmltext;
			}
		// All other Races must be out
		st.exitCurrentQuest(true);
		return "30511-11.htm";
	}

	@Override
	public String onKill(L2NpcInstance npc, QuestState st)
	{
		return null;
	}

}
