package services;

import L2jFT.extensions.scripts.Functions;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.tables.ItemTable;
import L2jFT.game.network.serverpackets.ItemList;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.util.Log;

public class HeroItems extends Functions implements ScriptFile
{
	public static L2Object self;
	public static L2Object npc;
	public static String[][] HERO_ITEMS = {
			{
					"6611",
					"weapon_the_sword_of_hero_i00",
					"Infinity Blade",
					"During a critical attack, decreases one's P. Def and increases de-buff casting ability, damage shield effect, Max HP, Max MP, Max CP, and shield defense power. Also enhances damage to target during PvP.",
					"297/137", "Sword" },
			{
					"6612",
					"weapon_the_two_handed_sword_of_hero_i00",
					"Infinity Cleaver",
					"Increases Max HP, Max CP, critical power and critical chance. Inflicts extra damage when a critical attack occurs and has possibility of reflecting the skill back on the player. Also enhances damage to target during PvP.",
					"361/137", "Two Handed Sword" },
			{
					"6613",
					"weapon_the_axe_of_hero_i00",
					"Infinity Axe",
					"During a critical attack, it bestows one the ability to cause internal conflict to one's opponent. Damage shield function, Max HP, Max MP, Max CP as well as one's shield defense rate are increased. It also enhances damage to one's opponent during PvP.",
					"297/137", "Blunt" },
			{
					"6614",
					"weapon_the_mace_of_hero_i00",
					"Infinity Rod",
					"When good magic is casted upon a target, increases MaxMP, MaxCP, Casting Spd, and MP regeneration rate. Also recovers HP 100% and enhances damage to target during PvP.",
					"238/182", "Blunt" },
			{
					"6615",
					"weapon_the_hammer_of_hero_i00",
					"Infinity Crusher",
					"Increases MaxHP, MaxCP, and Atk. Spd. Stuns a target when a critical attack occurs and has possibility of reflecting the skill back on the player. Also enhances damage to target during PvP.",
					"361/137", "Blunt" },
			{
					"6616",
					"weapon_the_staff_of_hero_i00",
					"Infinity Scepter",
					"When casting good magic, it can recover HP by 100% at a certain rate, increases MAX MP, MaxCP, M. Atk., lower MP Consumption, increases the Magic Critical rate, and reduce the Magic Cancel. Enhances damage to target during PvP.",
					"290/182", "Blunt" },
			{
					"6617",
					"weapon_the_dagger_of_hero_i00",
					"Infinity Stinger",
					"Increases MaxMP, MaxCP, Atk. Spd., MP regen rate, and the success rate of Mortal and Deadly Blow from the back of the target. Silences the target when a critical attack occurs and has Vampiric Rage effect. Also enhances damage to target during PvP.",
					"260/137", "Dagger" },
			{
					"6618",
					"weapon_the_fist_of_hero_i00",
					"Infinity Fang",
					"Increases MaxHP, MaxMP, MaxCP and evasion. Stuns a target when a critical attack occurs and has possibility of reflecting the skill back on the player at a certain probability rate. Also enhances damage to target during PvP.",
					"361/137", "Dual Fist" },
			{
					"6619",
					"weapon_the_bow_of_hero_i00",
					"Infinity Bow",
					"Increases MaxMP/MaxCP and decreases re-use delay of a bow. Slows target when a critical attack occurs and has Cheap Shot effect. Also enhances damage to target during PvP.",
					"614/137", "Bow" },
			{
					"6620",
					"weapon_the_dualsword_of_hero_i00",
					"Infinity Wing",
					"When a critical attack occurs, increases MaxHP, MaxMP, MaxCP and critical chance. Silences the target and has possibility of reflecting the skill back on the target. Also enhances damage to target during PvP.",
					"361/137", "Dual Sword" },
			{
					"6621",
					"weapon_the_pole_of_hero_i00",
					"Infinity Spear",
					"During a critical attack, increases MaxHP, Max CP, Atk. Spd. and Accuracy. Casts dispel on a target and has possibility of reflecting the skill back on the target. Also enhances damage to target during PvP.",
					"297/137", "Pole" } };

	public static void getweapon(String[] var)
	{
		L2Player player = (L2Player) self;
		int item = Integer.parseInt(var[0]);
		if(item < 6611 && item > 6621)
		{
			System.out.println(player.getName() + "Tried to obtain non hero weapon using this service. Ban him!");
			return;
		}
		if(player.getPlayer().isHero())
		{
			for(int i = 6611; i <= 6621; i++)
				if(player.getInventory().getItemByItemId(i) != null || player.getWarehouse().findItemId(i) != null)
					return;
			additem(item);
		}
	}

	public static void rendershop(String[] val)
	{
		String htmltext = "";
		if(val[0].equalsIgnoreCase("list"))
		{
			htmltext = "<html><body><font color=\"LEVEL\">List of Hero Weapons:</font><table border=0 width=270><tr><td>";
			for(int i = 0; i < HERO_ITEMS.length; i++)
			{
				htmltext += "<tr><td width=32 height=45 valign=top>";
				htmltext += "<img src=icon." + HERO_ITEMS[i][1] + " width=32 height=32></td>";
				htmltext += "<td valign=top>[<a action=\"bypass -h scripts_services.HeroItems:rendershop " + i + "\">" + HERO_ITEMS[i][2] + "</a>]<br1>";
				htmltext += "Type: " + HERO_ITEMS[i][5] + ", Patk/Matk: " + HERO_ITEMS[i][4];
				htmltext += "</td></tr>";
			}
			htmltext += "</table>";
		}
		else if(Integer.parseInt(val[0]) >= 0 && Integer.parseInt(val[0]) <= 10)
		{
			htmltext = "<html><body><font color=\"LEVEL\">Item Information:</font><table border=0 width=270><tr><td>";
			htmltext += "<img src=\"L2UI.SquareWhite\" width=270 height=1>";
			htmltext += "<table border=0 width=240>";
			htmltext += "<tr><td width=32 height=45 valign=top>";
			htmltext += "<img src=icon." + HERO_ITEMS[Integer.parseInt(val[0])][1] + " width=32 height=32></td>";
			htmltext += "<td valign=top>[<a action=\"bypass -h scripts_services.HeroItems:getweapon " + HERO_ITEMS[Integer.parseInt(val[0])][0] + "\" msg=\"1484\">" + HERO_ITEMS[Integer.parseInt(val[0])][2] + "</a>]<br1>";
			htmltext += "Type: " + HERO_ITEMS[Integer.parseInt(val[0])][5] + ", Patk/Matk: " + HERO_ITEMS[Integer.parseInt(val[0])][4] + "<br1>";
			htmltext += "</td></tr></table>";
			htmltext += "<font color=\"B09878\">" + HERO_ITEMS[Integer.parseInt(val[0])][3] + "</font>";
			htmltext += "</td></tr></table>";
			htmltext += "<img src=\"L2UI.SquareWhite\" width=270 height=1><br><br>";
			htmltext += "<CENTER><button value=Back action=\"bypass -h scripts_services.HeroItems:rendershop list\" width=40 height=15 back=sek.cbui94 fore=sek.cbui92></CENTER>";

		}
		show(htmltext, (L2Player) self);
	}

	public static void additem(int item)
	{
		L2Player player = (L2Player) self;
		L2ItemInstance createditem = ItemTable.getInstance().createItem(item, player.getObjectId(), 0, "HeroItems");
		createditem.setCount(1);
		player.getInventory().addItem(createditem);
		Log.LogItem(player, Log.GetItem, createditem);
		player.sendPacket(new ItemList(player, true));
		player.sendPacket(new SystemMessage(SystemMessage.EARNED_S1).addItemName(item));
	}

	public static String getcir()
	{
		L2Player player = (L2Player) self;
		if(player.getPlayer().isHero())
		{
			if(player.getInventory().getItemByItemId(6842) != null || player.getWarehouse().findItemId(6842) != null)
				return null;
			additem(6842);
		}
		return null;
	}

	public static String itemz()
	{
		String append = "";
		L2Player player = (L2Player) self;
		if(player.getPlayer().isHero())
		{
			String lang = player.getVar("lang@");
			if(player.getInventory().getItemByItemId(6842) == null && player.getWarehouse().findItemId(6842) == null)
				if(lang.equalsIgnoreCase("en"))
					append += "<a action=\"bypass -h scripts_services.HeroItems:getcir\">Get Hair Accessory.</a><br1>";
				else
					append += "<a action=\"bypass -h scripts_services.HeroItems:getcir\">Получить корону героя.</a><br1>";
			for(int i = 6611; i <= 6621; i++)
				if(player.getInventory().getItemByItemId(i) != null || player.getWarehouse().findItemId(i) != null)
					return append;
			if(lang.equalsIgnoreCase("en"))
				append += "<a action=\"bypass -h scripts_services.HeroItems:rendershop list\">Select a hero weapon.</a>";
			else
				append += "<a action=\"bypass -h scripts_services.HeroItems:rendershop list\">Выбрать оружие героя.</a>";

			if(lang.equalsIgnoreCase("en"))
				append = "<font color=\"LEVEL\">Hero rewards:</font><br1>" + append;
			else
				append = "<font color=\"LEVEL\">Награда героя:</font><br1>" + append;
		}

		return append;
	}

	public static String DialogAppend_31690(Integer val)
	{
		if(val != 0)
			return "";
		return itemz();
	}

	public static String DialogAppend_31769(Integer val)
	{
		if(val != 0)
			return "";
		return itemz();
	}

	public static String DialogAppend_31770(Integer val)
	{
		if(val != 0)
			return "";
		return itemz();
	}

	public static String DialogAppend_31771(Integer val)
	{
		if(val != 0)
			return "";
		return itemz();
	}

	public static String DialogAppend_31772(Integer val)
	{
		if(val != 0)
			return "";
		return itemz();
	}

	public static String DialogAppend_31773(Integer val)
	{
		if(val != 0)
			return "";
		return itemz();
	}

	public void onLoad()
	{
		System.out.println("Loaded Service: Hero Items");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}
}