package services;

import L2jFT.extensions.scripts.Functions;
import L2jFT.extensions.scripts.ScriptFile;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2DoorInstance;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.game.tables.DoorTable;
import L2jFT.util.Files;

/**
 * Используется в локации Pagan Temple
 * @Author: SYS
 */
public class PaganDoormans extends Functions implements ScriptFile
{
	public static L2Object self;
	public static L2Object npc;
	private static int MainDoorId = 19160001;
	private static int SecondDoor1Id = 19160011;
	private static int SecondDoor2Id = 19160010;

	public void onLoad()
	{
		System.out.println("Loaded Service: Pagan Doormans");
	}

	public void onReload()
	{}

	public void onShutdown()
	{}

	public static void openMainDoor()
	{
		L2Player player = (L2Player) self;

		if(player == null || player.isActionsDisabled() || player.isSitting() || player.getLastNpc().getDistance(player) > 300)
			return;

		int onePassMark = getItemCount(player, 8064); // Цветок

		if(onePassMark == 0 && getItemCount(player, 8067) == 0)
		{
			player.sendPacket(new SystemMessage(SystemMessage.YOU_DO_NOT_HAVE_ENOUGH_REQUIRED_ITEMS));
			return;
		}

		if(onePassMark != 0)
			removeItem(player, 8064, 1);

		openDoor(MainDoorId);
		show(Files.read("data/html/default/32034-1.htm", player), player);
	}

	public static void openSecondDoor()
	{
		L2Player player = (L2Player) self;

		if(player == null || player.isActionsDisabled() || player.isSitting() || player.getLastNpc().getDistance(player) > 300)
			return;

		if(getItemCount(player, 8067) == 0)
		{
			show(Files.read("data/html/default/32036-2.htm", player), player);
			return;
		}

		openDoor(SecondDoor1Id);
		openDoor(SecondDoor2Id);
		show(Files.read("data/html/default/32036-1.htm", player), player);
	}

	public static void pressSkull()
	{
		L2Player player = (L2Player) self;

		if(player == null || player.isActionsDisabled() || player.isSitting() || player.getLastNpc().getDistance(player) > 300)
			return;

		openDoor(MainDoorId);
		show(Files.read("data/html/default/32035-1.htm", player), player);
	}

	public static void press2ndSkull()
	{
		L2Player player = (L2Player) self;

		if(player == null || player.isActionsDisabled() || player.isSitting() || player.getLastNpc().getDistance(player) > 300)
			return;

		openDoor(SecondDoor1Id);
		openDoor(SecondDoor2Id);
		show(Files.read("data/html/default/32037-1.htm", player), player);
	}

	private static void openDoor(int doorId)
	{
		final int CLOSE_TIME = 10000; // 10 секунд
		L2DoorInstance door = DoorTable.getInstance().getDoor(doorId);
		if(!door.isOpen())
		{
			door.openMe();
			door.scheduleCloseMe(CLOSE_TIME);
		}
	}
}