package L2jFT.extensions;

import L2jFT.database.DatabaseUtils;
import L2jFT.database.FiltredStatement;
import L2jFT.database.L2DatabaseFactory;
import L2jFT.database.ThreadConnection;
import L2jFT.game.model.L2Player;

import java.lang.reflect.Field;
import java.sql.ResultSet;
import java.sql.SQLException;

public class Bonus
{
	L2Player _owner = null;
	/** Rate control */
	public float RATE_XP = 1;
	public float RATE_SP = 1;
	public float RATE_PARTY_XP = 1;
	public float RATE_PARTY_SP = 1;
	public float RATE_QUESTS_REWARD = 1;
	public float RATE_DROP_ADENA = 1;
	public float RATE_DROP_ITEMS = 1;
	public float RATE_DROP_SPOIL = 1;

	/** UNUSED */
	public float RATE_CONSUMABLE_COST = 1;
	/** UNUSED */
	public float RATE_KARMA_EXP_LOST = 1;
	/** UNUSED */
	public float RATE_SIEGE_GUARDS_PRICE = 1;

	public Bonus(L2Player player)
	{
		if(player.getNetConnection() == null) // игрок отвалился при входе
			return;

		_owner = player;
		restore();
		double accbonus = player.getNetConnection().getBonus();
		if(accbonus == 0)
			accbonus = 1;
		RATE_XP *= accbonus;
		RATE_SP *= accbonus;
		RATE_DROP_ADENA *= accbonus;
		RATE_DROP_ITEMS *= accbonus;
		RATE_DROP_SPOIL *= accbonus;
	}

	private void restore()
	{
		ThreadConnection con = null;
		FiltredStatement statement = null;
		ResultSet rset = null;
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			statement = con.createStatement();
			rset = statement.executeQuery("SELECT bonus_name,bonus_value from bonus where obj_id='" + _owner.getObjectId() + "' and (bonus_expire_time='-1' or bonus_expire_time > " + System.currentTimeMillis() / 1000 + ")");
			while(rset.next())
			{
				String bonus_name = rset.getString("bonus_name");
				float bonus_value = rset.getFloat("bonus_value");
				Class cls = getClass();
				try
				{
					Field fld = cls.getField(bonus_name);
					try
					{
						fld.setFloat(this, bonus_value);
					}
					catch(IllegalArgumentException e)
					{
						e.printStackTrace();
					}
					catch(IllegalAccessException e)
					{
						e.printStackTrace();
					}
				}
				catch(SecurityException e)
				{
					e.printStackTrace();
				}
				catch(NoSuchFieldException e)
				{
					e.printStackTrace();
				}
			}
		}
		catch(SQLException e)
		{
			e.printStackTrace();
		}
		finally
		{
			DatabaseUtils.closeDatabaseCSR(con, statement, rset);
		}
	}

	public void setRATE_CONSUMABLE_COST(double rate_consumable_cost)
	{
		RATE_CONSUMABLE_COST = (float) rate_consumable_cost;
	}

	public void setRATE_DROP_ADENA(double rate_drop_adena)
	{
		RATE_DROP_ADENA = (float) rate_drop_adena;
	}

	public void setRATE_DROP_ITEMS(double rate_drop_items)
	{
		RATE_DROP_ITEMS = (float) rate_drop_items;
	}

	public void setRATE_DROP_SPOIL(double rate_drop_spoil)
	{
		RATE_DROP_SPOIL = (float) rate_drop_spoil;
	}

	public void setRATE_KARMA_EXP_LOST(double rate_karma_exp_lost)
	{
		RATE_KARMA_EXP_LOST = (float) rate_karma_exp_lost;
	}

	public void setRATE_PARTY_SP(double rate_party_sp)
	{
		RATE_PARTY_SP = (float) rate_party_sp;
	}

	public void setRATE_PARTY_XP(double rate_party_xp)
	{
		RATE_PARTY_XP = (float) rate_party_xp;
	}

	public void setRATE_QUESTS_REWARD(double rate_quests_reward)
	{
		RATE_QUESTS_REWARD = (float) rate_quests_reward;
	}

	public void setRATE_SIEGE_GUARDS_PRICE(double rate_siege_guards_price)
	{
		RATE_SIEGE_GUARDS_PRICE = (float) rate_siege_guards_price;
	}

	public void setRATE_SP(double rate_sp)
	{
		RATE_SP = (float) rate_sp;
	}

	public void setRATE_XP(double rate_xp)
	{
		RATE_XP = (float) rate_xp;
	}
}