package L2jFT.extensions.listeners.events.L2Object;

import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Territory;
import L2jFT.extensions.listeners.events.PropertyEvent;
import L2jFT.extensions.listeners.PropertyCollection;

import java.util.List;

/**
 * @author Death
 * Date: 22/8/2007
 * Time: 12:57:10
 */
public class TerritoryChangeEvent implements PropertyEvent
{
	private final List<L2Territory> enter;
	private final List<L2Territory> exit;
	private final L2Object object;

	public TerritoryChangeEvent(List<L2Territory> enter, List<L2Territory> exit, L2Object object)
	{
		this.enter = enter;
		this.exit = exit;
		this.object = object;
	}

	public L2Object getObject()
	{
		return object;
	}

	/**
	 * Возврщает список территорий с которых вышел объект
	 * @return список удаленных территорий
	 */
	public List<L2Territory> getOldValue()
	{
		return exit;
	}

	/**
	 * Возвразает список территорой в которые вошол объект
	 * @return список добавленых территорий
	 */
	public List<L2Territory> getNewValue()
	{
		return enter;
	}

	public String getProperty()
	{
		return PropertyCollection.TerritoryChanged;
	}
}
