package L2jFT.extensions.scripts;

import java.util.StringTokenizer;

import L2jFT.game.handler.AdminCommandHandler;
import L2jFT.game.handler.IAdminCommandHandler;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestState;

public class AdminScripts implements IAdminCommandHandler
{
	private static String[] _adminCommands = {
			"admin_scripts_reload", "admin_sreload", "admin_sqreload" };

	public boolean useAdminCommand(String command, L2Player activeChar)
	{
		if(Scripts.JAR)
		{
			activeChar.sendMessage("This feature is avaliable only in full version.", "Данная фича доступна только в полной версии.");
			return false;
		}
		if(!activeChar.getPlayerAccess().IsGM)
			return false;
		if(command.startsWith("admin_scripts_reload") || command.startsWith("admin_sreload"))
		{
			StringTokenizer st = new StringTokenizer(command);
			if(!st.hasMoreTokens())
				return false;
			st.nextToken();
			String param = st.nextToken();
			if(param.equalsIgnoreCase("all"))
			{
				activeChar.sendMessage("Scripts reload starting...");
				if(Scripts.getInstance().reload())
					activeChar.sendMessage("Scripts reloaded with errors. Loaded " + Scripts.getInstance().getClasses().size() + " classes.", "Скрипты загружены с ошибками. Загужено " + Scripts.getInstance().getClasses().size() + " классов.");
				else
					activeChar.sendMessage("Scripts successfully reloaded. Loaded " + Scripts.getInstance().getClasses().size() + " classes.", "Скрипты успешно перезагружены. Загружено " + Scripts.getInstance().getClasses().size() + " классов.");
			}
			else if(Scripts.getInstance().reloadClass(param))
				activeChar.sendMessage("Scripts reloaded with errors. Loaded " + Scripts.getInstance().getClasses().size() + " classes.", "Скрипты загружены с ошибками. Загужено " + Scripts.getInstance().getClasses().size() + " классов.");
			else
				activeChar.sendMessage("Scripts successfully reloaded. Loaded " + Scripts.getInstance().getClasses().size() + " classes.", "Скрипты успешно перезагружены. Загружено " + Scripts.getInstance().getClasses().size() + " классов.");
		}
		else if(command.startsWith("admin_sqreload"))
		{
			StringTokenizer st = new StringTokenizer(command, " ");
			st.nextToken();
			String quest = st.nextToken();
			if(Scripts.getInstance().reloadQuest(quest))
				activeChar.sendMessage("Quest '" + quest + "' reloaded with errors.", "Квест '" + quest + "' перезагружен с ошибками.");
			else
				activeChar.sendMessage("Quest '" + quest + "' successfully reloaded.", "Квест '" + quest + "' успешно перезагружен.");
			reloadQuestStates(activeChar);
		}
		return true;
	}

	private void reloadQuestStates(L2Player p)
	{
		for(QuestState qs : p.getAllQuestsStates())
			p.delQuestState(qs.getQuest().getName());

		Quest.playerEnter(p);
	}

	public String[] getAdminCommandList()
	{
		return _adminCommands;
	}

	public String[] getDescription()
	{
		return new String[] {
				"Перезагрузка скриптов сервера на лету",
				"Перезагрузка скриптов сервера на лету", "Перезагрузка квестов на лету" };
	}

	public String[] getCommandGroup()
	{
		return new String[] {
				AdminCommandHandler.GROUP_MANAGESERVER,
				AdminCommandHandler.GROUP_MANAGESERVER,
				AdminCommandHandler.GROUP_MANAGESERVER };
	}
}