package L2jFT.extensions.scripts;

import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.util.Strings;

import java.util.logging.Logger;

public final class Events
{
	static Logger _log = Logger.getLogger(Events.class.getName());

	public final static boolean onAction(L2Player player, L2Object obj)
	{
		String instance = obj.getL2ClassShortName();
		String handler = Scripts.onAction.get(instance);
		if(handler == null)
			return false;
		String[] list = handler.split(":");
		String _class = list[0];
		String _method = list[1];
		return Strings.parseBoolean(player.callScripts(_class, _method, new Object[] {
				player, obj }));
	}

	public final static boolean onActionShift(L2Player player, L2Object obj)
	{
		String instance = obj.getL2ClassShortName();
		String handler = Scripts.onActionShift.get(instance);
		if(handler == null)
			return false;
		String[] list = handler.split(":");
		String _class = list[0];
		String _method = list[1];
		Object rez = player.callScripts(_class, _method, new Object[] { player, obj });
		return Strings.parseBoolean(rez);
	}
}
