package L2jFT.game.ai;

import L2jFT.Config;
import static L2jFT.game.ai.CtrlIntention.AI_INTENTION_ACTIVE;
import static L2jFT.game.ai.CtrlIntention.AI_INTENTION_ATTACK;
import L2jFT.game.geodata.GeoData;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2World;
import L2jFT.game.model.instances.L2GuardInstance;
import L2jFT.game.model.instances.L2MonsterInstance;

public class Guard extends Fighter implements Runnable
{
	public Guard(L2Character actor)
	{
		super(actor);
	}

	@Override
	protected boolean thinkActive()
	{
		if(_actor.isDead())
			return true;

		L2GuardInstance guard = (L2GuardInstance) _actor;

		if(getIntention() == AI_INTENTION_ACTIVE)
			for(L2Character cha : L2World.getAroundCharacters(_actor, 600, Config.PLAYER_VISIBILITY_Z))
			{
				if(Config.DEBUG)
					_log.fine(_actor + ": PK " + cha + " entered scan range");

				if(autoAttackCondition(cha))
				{
					guard.addDamageHate(cha, 0, 1);
					guard.setRunning();
					setIntention(AI_INTENTION_ATTACK, cha, null);
					return true;
				}
			}

		if(guard.noTarget())
		{
			returnHome();
			return true;
		}

		return false;
	}

	protected boolean autoAttackCondition(L2Character target)
	{
		if(target.isAlikeDead() || target.isInvul())
			return false;
		if(!GeoData.getInstance().canSeeTarget(_actor, target))
			return false;
		if(target.getKarma() > 0)
			return true;
		if(target.isMonster)
			return ((L2MonsterInstance) target).isAggressive();
		return false;
	}
}