package L2jFT.game.ai;

import static L2jFT.game.ai.CtrlIntention.AI_INTENTION_ATTACK;
import L2jFT.game.geodata.GeoData;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2Summon;

public class L2SummonAI extends L2PlayableAI
{
	private L2Summon _thisActor;

	public L2SummonAI(L2Character actor, L2Player owner)
	{
		super(actor, owner);
		_thisActor = (L2Summon) actor;
	}

	@Override
	protected void onIntentionIdle()
	{
		_thisActor.stopMove(null);
		clearNextAction();
		onIntentionActive();
	}

	@Override
	protected void onIntentionActive()
	{
		if(!_actor.isVisible())
			return;

		if(_thisActor.isPosessed())
		{
			_thisActor.setRunning();
			if(getIntention() != AI_INTENTION_ATTACK)
				setIntention(CtrlIntention.AI_INTENTION_ATTACK, _thisActor.getOwner(), null);
			return;
		}

		if(_thisActor.getFollowStatus())
			setIntention(CtrlIntention.AI_INTENTION_FOLLOW, _thisActor.getOwner(), 100);
		else
			super.onIntentionActive();
	}

	@Override
	protected void thinkAttack()
	{
		if(_thisActor.isPosessed())
			_attack_target = _thisActor.getOwner();

		if(_attack_target == null || !GeoData.getInstance().canSeeTarget(_actor, _attack_target) || _attack_target.isDead())
			_thisActor.setFollowStatus(true);
		else
			super.thinkAttack();
	}

	@Override
	protected void onEvtThink()
	{
		if(_thisActor.isPosessed())
		{
			_attack_target = _thisActor.getOwner();
			_intention = AI_INTENTION_ATTACK;
		}

		super.onEvtThink();
	}

	@Override
	protected void onEvtAttacked(L2Character attacker, Boolean canBeAttackedByMob)
	{
		if(attacker != null && ((L2Summon) _actor).getOwner().isDead())
			Attack(attacker, false);
		super.onEvtAttacked(attacker, canBeAttackedByMob);
	}

	@Override
	protected void onEvtFinishCasting()
	{
		if(_thisActor.getFollowStatus())
			setIntention(CtrlIntention.AI_INTENTION_FOLLOW, _thisActor.getOwner(), 100);
		super.onEvtFinishCasting();
	}
}
