package L2jFT.game.ai;

import L2jFT.util.Rnd;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Skill;
import L2jFT.game.model.L2Skill.SkillType;

import java.util.ArrayList;

public class SiegeGuardPriest extends SiegeGuard
{
	public SiegeGuardPriest(L2Character actor)
	{
		super(actor);
		_isMobile = false;
	}

	@Override
	protected boolean createNewTask()
	{
		if(!super.createNewTask())
			return false;

		L2Character _temp_attack_target = _attack_target;

		// Новая цель исходя из агрессивности
		L2Character hated = _thisActor.isConfused() ? _temp_attack_target : _thisActor.getMostHated();

		if(hated != null && hated != _thisActor)
		{
			_attack_target = hated;
			_temp_attack_target = hated;
		}
		else
		{
			returnHome();
			return false;
		}

		// Базовые параметры
		int phys_per = 25;
		int mdam_per = 50;

		int rnd_per = Rnd.get(100);

		_d_skill = new ArrayList<L2Skill>();
		_r_skill = null;

		double distance = _thisActor.getDistance(_temp_attack_target);

		if(!Rnd.chance(phys_per))
		{
			// MDAM
			if(rnd_per < mdam_per && _mdam.length > 0)
			{
				_t_skill.clear();
				for(L2Skill sk : _mdam)
				{
					if(sk == null || sk.getCastRange() > 200 && distance <= 200)
						continue;
					if(sk.getCastRange() <= 200 && distance > 200)
						continue;
					_t_skill.add(sk);
				}
				if(_t_skill.size() > 0)
					_d_skill.add(_t_skill.get(Rnd.get(_t_skill.size())));
			}

			// HEAL
			if(_heal.length > 0)
			{
				_t_skill.clear();
				for(L2Skill sk : _heal)
					_t_skill.add(sk);
				if(_t_skill.size() > 0)
					_d_skill.add(_t_skill.get(Rnd.get(_t_skill.size())));
			}

			// Выбрать 1 скилл из полученных
			if(_d_skill.size() > 0)
				_r_skill = _d_skill.get(Rnd.get(_d_skill.size()));

			// Смена цели для HEAL скиллов
			if(_r_skill != null && _r_skill.getSkillType() == SkillType.HEAL)
				if(_thisActor.getMaxHp() - _thisActor.getCurrentHp() > _r_skill.getPower())
					_temp_attack_target = _thisActor;
				else
					_r_skill = null;
		}

		// Использовать скилл если можно, иначе атаковать
		if(_r_skill != null && !(_thisActor.isMuted() && _r_skill.isMagic() || _thisActor.isPMuted() && !_r_skill.isMagic()) && _def_mp >= _r_skill.getMpConsume() && !_thisActor.isSkillDisabled(_r_skill.getId()))
		{
			// Проверка таргета
			if(_r_skill.getTargetType() == L2Skill.SkillTargetType.TARGET_SELF)
				_temp_attack_target = _thisActor;
			if(_r_skill.getTargetType() == L2Skill.SkillTargetType.TARGET_AURA)
				_temp_attack_target = _thisActor;

			// Добавить новое задание
			Task task = new Task();
			task.type = _r_skill.isOffensive() ? TaskType.CAST : TaskType.BUFF;
			task.target = _temp_attack_target;
			task.skill = _r_skill;
			_task_list.add(task);
			_def_think = true;
			return true;
		}

		// Добавить новое задание
		Task task = new Task();
		task.type = TaskType.ATTACK;
		task.target = _temp_attack_target;
		_task_list.add(task);
		_def_think = true;
		return true;
	}
}