package L2jFT.game.communitybbs;

import L2jFT.Config;
import L2jFT.game.communitybbs.Manager.ClanBBSManager;
import L2jFT.game.communitybbs.Manager.FriendsBBSManager;
import L2jFT.game.communitybbs.Manager.PostBBSManager;
import L2jFT.game.communitybbs.Manager.RegionBBSManager;
import L2jFT.game.communitybbs.Manager.TopBBSManager;
import L2jFT.game.communitybbs.Manager.TopicBBSManager;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.L2GameClient;
import L2jFT.game.network.serverpackets.ShowBoard;
import L2jFT.game.network.serverpackets.SystemMessage;

public class CommunityBoard
{
	private static CommunityBoard _instance;

	public static CommunityBoard getInstance()
	{
		if(_instance == null)
			_instance = new CommunityBoard();

		return _instance;
	}

	public void handleCommands(L2GameClient client, String command)
	{
		L2Player activeChar = client.getActiveChar();
		if(activeChar == null)
			return;
		if(Config.COMMUNITY_TYPE.equals("new"))
		{
			if(command.startsWith("_bbsclan"))
				ClanBBSManager.getInstance().parsecmd(command, activeChar);
			else if(command.startsWith("_bbsmemo"))
				TopicBBSManager.getInstance().parsecmd(command, activeChar);
			else if(command.startsWith("_bbstopics"))
				TopicBBSManager.getInstance().parsecmd(command, activeChar);
			else if(command.startsWith("_bbsposts"))
				PostBBSManager.getInstance().parsecmd(command, activeChar);
			else if(command.startsWith("_bbstop"))
				TopBBSManager.getInstance().parsecmd(command, activeChar);
			else if(command.startsWith("_bbshome"))
				TopBBSManager.getInstance().parsecmd(command, activeChar);
			else if(command.startsWith("_bbsloc"))
				RegionBBSManager.getInstance().parsecmd(command, activeChar);
			else if(command.startsWith("_bbsgetfav"))
				FriendsBBSManager.getInstance().parsecmd(command, activeChar);
			else
			{
				ShowBoard sb = new ShowBoard("<html><body><br><br><center>the command: " + command + " is not implemented yet</center><br><br></body></html>", "101");
				activeChar.sendPacket(sb);
				activeChar.sendPacket(new ShowBoard(null, "102"));
				activeChar.sendPacket(new ShowBoard(null, "103"));
			}
		}
		else if(Config.COMMUNITY_TYPE.equals("old"))
			RegionBBSManager.getInstance().parsecmd(command, activeChar);
		else
			activeChar.sendPacket(new SystemMessage(SystemMessage.THE_COMMUNITY_SERVER_IS_CURRENTLY_OFFLINE));
	}

	/**
	 * @param client
	 * @param url
	 * @param arg1
	 * @param arg2
	 * @param arg3
	 * @param arg4
	 * @param arg5
	 */
	public void handleWriteCommands(L2GameClient client, String url, String arg1, String arg2, String arg3, String arg4, String arg5)
	{
		L2Player activeChar = client.getActiveChar();
		if(activeChar == null)
			return;

		if(Config.COMMUNITY_TYPE.equals("new"))
		{
			if(url.equals("Topic"))
				TopicBBSManager.getInstance().parsewrite(arg1, arg2, arg3, arg4, arg5, activeChar);
			else if(url.equals("Post"))
				PostBBSManager.getInstance().parsewrite(arg1, arg2, arg3, arg4, arg5, activeChar);
			else if(url.equals("Region"))
				RegionBBSManager.getInstance().parsewrite(arg1, arg2, arg3, arg4, arg5, activeChar);
			else
			{
				ShowBoard sb = new ShowBoard("<html><body><br><br><center>the command: " + url + " is not implemented yet</center><br><br></body></html>", "101");
				activeChar.sendPacket(sb);
				activeChar.sendPacket(new ShowBoard(null, "102"));
				activeChar.sendPacket(new ShowBoard(null, "103"));
			}
		}
		else if(Config.COMMUNITY_TYPE.equals("old"))
			RegionBBSManager.getInstance().parsewrite(arg1, arg2, arg3, arg4, arg5, activeChar);
		else
		{
			ShowBoard sb = new ShowBoard("<html><body><br><br><center>The Community board is currently disable</center><br><br></body></html>", "101");
			activeChar.sendPacket(sb);
			activeChar.sendPacket(new ShowBoard(null, "102"));
			activeChar.sendPacket(new ShowBoard(null, "103"));
		}
	}
}
