package L2jFT.game.geodata;

import L2jFT.Config;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.util.Location;

import java.util.logging.Logger;

public class GeoData
{
	private static Logger _log = Logger.getLogger(GeoData.class.getName());
	private static GeoData _instance;

	public static boolean active = false;

	public static GeoData getInstance()
	{
		if(_instance == null || Config.GEODATA != active)
			if(Config.GEODATA && !active)
			{
				active = true;
				_instance = GeoEngine.getInstance();
				_log.info("Geodata Engine: Enabled.");
			}
			else
			{
				if(active)
				{
					active = false;
					GeoEngine.unloadGeodata();
				}
				_instance = new GeoData();
				_log.info("Geodata Engine: Disabled.");
			}
		return _instance;
	}

	// Public Methods
	/**
	 * @param x
	 * @param y
	 * @return Geo Block Type
	 */
	public short getType(int x, int y)
	{
		return 0;
	}

	@SuppressWarnings("unused")
	public int getHeight(int x, int y, int z)
	{
		return z;
	}

	@SuppressWarnings("unused")
	public int getSpawnHeight(int x, int y, int zmin, int zmax)
	{
		return zmin;
	}

	@SuppressWarnings("unused")
	public int getWaterLevel(int x, int y, int z)
	{
		return Short.MIN_VALUE;
	}

	@SuppressWarnings("unused")
	public boolean canSeeCoord(int x, int y, int z, int tx, int ty, int tz)
	{
		return Math.abs(tz - z) < 1000;
	}

	@SuppressWarnings("unused")
	public boolean canSeeTarget(L2Object cha, L2Object target)
	{
		return Math.abs(target.getZ() - cha.getZ()) < 1000;
	}

	@SuppressWarnings("unused")
	public boolean canMoveToCoord(int x, int y, int z, int tx, int ty, int tz)
	{
		return true;
	}

	@SuppressWarnings("unused")
	public boolean canMoveToCoordWithCollision(int x, int y, int z, int tx, int ty, int tz)
	{
		return true;
	}

	@SuppressWarnings("unused")
	public boolean canMoveToTarget(L2Object cha, L2Object target)
	{
		return true;
	}

	/**
	 * @param x
	 * @param y
	 * @param z
	 * @return Geo NSWE (0-15)
	 */
	public short getNSWE(int x, int y, int z)
	{
		return 15;
	}

	public Location moveCheck(L2Object cha, L2Object target)
	{
		return moveCheck(cha.getX(), cha.getY(), cha.getZ(), target.getX(), target.getY(), target.getZ());
	}

	/**
	 * @param x
	 * @param y
	 * @param z
	 * @param tx
	 * @param ty
	 * @param tz
	 * @return Last Location (x,y,z) where player can walk - just befor wall
	 */
	public Location moveCheck(int x, int y, int z, int tx, int ty, int tz)
	{
		return new Location(tx, ty, tz);
	}
	
	public Location moveCheckForAI(L2Object cha, L2Object target)
	{
		return moveCheckForAI(new Location(cha.getX(), cha.getY(), cha.getZ()), new Location(target.getX(), target.getY(), target.getZ()));
	}
	
	public Location moveCheckForAI(@SuppressWarnings("unused")
	Location loc1, Location loc2)
	{
		return loc2;
	}

	@SuppressWarnings("unused")
	public void addGeoDataBug(L2Player gm, String comment)
	{}

	@SuppressWarnings("unused")
	public static void unloadGeodataFile(byte rx, byte ry)
	{}

	public static void unloadGeodata()
	{}

	@SuppressWarnings("unused")
	public static boolean LoadGeodataFile(byte rx, byte ry)
	{
		return false;
	}

	@SuppressWarnings("unused")
	public void getInfo(L2Player activeChar, int x, int y, int z)
	{}
}
