package L2jFT.game.geodata;

import L2jFT.Config;
import L2jFT.game.geodata.PathFind.GeoNode;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2World;
import L2jFT.util.CharPosition;
import L2jFT.util.Location;

import java.util.Vector;

/**
 * @Author: Diamond
 * @Date: 20/5/2007
 * @Time: 9:57:48
 */
public class GeoMove
{
	//private final static Log _log = LogFactory.getLog(GeoMove.class);

	public static Vector<Location> checkMovement(L2Character actor, L2Character target)
	{
		return checkMovement(actor, new CharPosition(target.getX(), target.getY(), target.getZ(), 0));
	}

	public static Vector<Location> checkMovement(L2Character actor, CharPosition target)
	{
		boolean debug = false;
		if(actor.isPlayer)
			if(((L2Player) actor).getAccessLevel() >= 100 && Config.GEODATA_DEBUG)
				debug = true;
		PathFind n;
		long ti = System.currentTimeMillis();

		if(debug)
			actor.sendMessage("Ищем путь", "");

		Vector<Location> targetRecorder = new Vector<Location>();

		n = new PathFind(actor, target.x, target.y, target.z);

		if(n.path == null)
		{
			if(debug)
			{
				actor.sendMessage("Путь не найден, идем в FP", "");
				actor.sendMessage("Потраченное время: " + (System.currentTimeMillis() - ti) + "ms", "");
			}
			return targetRecorder;
		}

		if(!n.path.isEmpty())
		{
			// добавляем первую точку в список (начальная позиция чара)
			if(Config.PATHFINDING_BOOST)
				targetRecorder.add(new Location(actor.getX(), actor.getY(), actor.getZ()));

			for(GeoNode p : n.path)
				targetRecorder.add(new Location((p.location.x << 4) + L2World.MAP_MIN_X, (p.location.y << 4) + L2World.MAP_MIN_Y, p.location.z));

			// добавляем последнюю точку в список (цель)
			if(Config.PATHFINDING_BOOST)
				targetRecorder.add(new Location(target.x, target.y, target.z));

			if(debug)
			{
				actor.sendMessage("Найдено " + targetRecorder.size() + " точек", "");
				actor.sendMessage("Потраченное время: " + (System.currentTimeMillis() - ti) + "ms", "");
			}
		}

		return targetRecorder;
	}
}