package L2jFT.game.handler;

import L2jFT.game.model.L2Player;

public interface IAdminCommandHandler
{
	/**
	 * this is the worker method that is called when someone uses an admin command.
	 * @param activeChar
	 * @param command
	 * @return command success
	 */
	public boolean useAdminCommand(String command, L2Player activeChar);

	/**
	 * this method is called at initialization to register all the item ids automatically 
	 * @return all known itemIds
	 */
	public String[] getAdminCommandList();

	/**
	 * Этот набор стрингов отвечает за описание команды для возможности составления 
	 * автоматизированного хелпа по всем админ командам
	 */
	public String[] getDescription();

	/**
	 * Возвращает набор групп, к которым принадлежит команда
	 * @return
	 */
	public String[] getCommandGroup();
}
