package L2jFT.game.instancemanager;

import javolution.util.FastList;
import L2jFT.game.model.L2Zone;
import L2jFT.game.model.L2Zone.ZoneType;
import L2jFT.game.model.entity.OlympiadStadia;

import java.util.List;
import java.util.logging.Logger;

public class OlympiadStadiaManager
{
	protected static Logger _log = Logger.getLogger(OlympiadStadiaManager.class.getName());

	private static OlympiadStadiaManager _instance;

	public static final OlympiadStadiaManager getInstance()
	{
		if(_instance == null)
		{
			System.out.println("Initializing OlympiadStadiaManager");
			_instance = new OlympiadStadiaManager();
			_instance.load();
		}
		return _instance;
	}

	private List<OlympiadStadia> _olympiadStadias;

	public void reload()
	{
		getOlympiadStadias().clear();
		load();
	}

	private final void load()
	{
		FastList<L2Zone> zones = ZoneManager.getInstance().getZoneByType(ZoneType.OlympiadStadia);
		if(zones.size() == 0)
			System.out.println("Not found zones for Olympiad!!!");
		else
			for(L2Zone zone : zones)
				getOlympiadStadias().add(new OlympiadStadia(zone.getId()));
	}

	public final List<OlympiadStadia> getOlympiadStadias()
	{
		if(_olympiadStadias == null)
			_olympiadStadias = new FastList<OlympiadStadia>();
		return _olympiadStadias;
	}
}
