package L2jFT.game.model;

import java.util.Arrays;

public class L2DropData
{
	private short _itemId;
	private int _mindrop;
	private int _maxdrop;
	private boolean _sweep;
	private int _chance;
	private short _groupId;
	private int _groupChance;
	private byte _minLevel;
	private byte _maxLevel;
	private String _questID = null;
	private String[] _stateID = null;

	public L2DropData()
	{}

	public L2DropData(int id, int min, int max, int chance, int minLevel)
	{
		_itemId = (short) id;
		_mindrop = min;
		_maxdrop = max;
		_chance = chance;
		_minLevel = (byte) minLevel;
	}

	public L2DropData(int id, int min, int max, int chance, int minLevel, int maxLevel)
	{
		_itemId = (short) id;
		_mindrop = min;
		_maxdrop = max;
		_chance = chance;
		_minLevel = (byte) minLevel;
		_maxLevel = (byte) maxLevel;
	}

	public short getItemId()
	{
		return _itemId;
	}

	public void setItemId(short itemId)
	{
		_itemId = itemId;
	}

	public void setGroupId(short gId)
	{
		_groupId = gId;
	}

	public short getGroupId()
	{
		return _groupId;
	}

	public void setGroupChance(int chance)
	{
		_groupChance = chance;
	}

	public int getGroupChance()
	{
		return _groupChance;
	}

	public int getMinDrop()
	{
		return _mindrop;
	}

	public int getMaxDrop()
	{
		return _maxdrop;
	}

	public boolean isSweep()
	{
		return _sweep;
	}

	public int getChance()
	{
		return _chance;
	}

	public void setMinDrop(int mindrop)
	{
		_mindrop = mindrop;
	}

	public void setMaxDrop(int maxdrop)
	{
		_maxdrop = maxdrop;
	}

	public void setSweep(boolean sweep)
	{
		_sweep = sweep;
	}

	public void setChance(int chance)
	{
		_chance = chance;
	}

	public String[] getStateIDs()
	{
		return _stateID;
	}

	public void addStates(String[] list)
	{
		_stateID = list;
	}

	public String getQuestID()
	{
		return _questID;
	}

	public void setQuestID(String questID)
	{
		_questID = questID;
	}

	public boolean isQuestDrop()
	{
		return _questID != null && _stateID != null;
	}

	public byte getMinLevel()
	{
		return _minLevel;
	}

	public byte getMaxLevel()
	{
		return _maxLevel;
	}

	@Override
	public String toString()
	{
		String out = "ItemID: " + getItemId() + " Min: " + getMinDrop() + " Max: " + getMaxDrop() + " Chance: " + getChance() / 10000.0 + "%";
		if(isQuestDrop())
			out += " QuestID: " + getQuestID() + " StateID's: " + Arrays.toString(getStateIDs());

		return out;
	}

	@Override
	public boolean equals(Object o)
	{
		if(o instanceof L2DropData)
		{
			L2DropData drop = (L2DropData) o;
			return drop.getItemId() == getItemId();
		}
		return false;
	}

	@Override
	public int hashCode()
	{
		return _itemId;
	}
}