package L2jFT.game.model;

import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.tables.ClanTable;

public class L2SiegeClan
{
	private int _ClanId = 0;
	private L2NpcInstance _flag;

	public enum SiegeClanType
	{
		OWNER,
		DEFENDER,
		ATTACKER,
		DEFENDER_PENDING
	}

	private SiegeClanType _TypeId;

	public L2SiegeClan(int clanId, SiegeClanType typeId)
	{
		_ClanId = clanId;
		_TypeId = typeId;
	}

	public void setFlag(L2NpcInstance flag)
	{
		_flag = flag;
	}

	public boolean removeFlag()
	{
		if(_flag == null)
			return false;
		_flag.deleteMe();
		_flag = null;
		return true;
	}

	public final int getClanId()
	{
		return _ClanId;
	}

	public final L2Clan getClan()
	{
		return ClanTable.getInstance().getClan(_ClanId);
	}

	public L2NpcInstance getFlag()
	{
		return _flag;
	}

	public final SiegeClanType getTypeId()
	{
		return _TypeId;
	}

	public void setTypeId(SiegeClanType typeId)
	{
		_TypeId = typeId;
	}
}
