package L2jFT.game.model;

public final class L2SkillLearn
{
	public final short id;
	public final short skillLevel;
	public final int spCost;
	public final int _repCost;
	public final byte minLevel;
	public final short itemId;
	public final int itemCount;
	public final boolean common;
	public final boolean clan;

	// not needed, just for easier debug
	public final String name;

	public L2SkillLearn(short id, short lvl, byte minLvl, String name, int cost, short itemId, int itemCount, boolean common, boolean clan)
	{
		this.id = id;
		skillLevel = lvl;
		minLevel = minLvl;
		this.name = name.intern();
		if(clan)
		{
			spCost = 0;
			_repCost = cost;
		}
		else
		{
			_repCost = 0;
			spCost = cost;
		}
		this.itemId = itemId;
		this.itemCount = itemCount;
		this.common = common;
		this.clan = clan;
	}

	// need for jbf, i will tear off hands!!! (Styx)
	public short getId()
	{
		return id;
	}

	public short getLevel()
	{
		return skillLevel;
	}

	public byte getMinLevel()
	{
		return minLevel;
	}

	public String getName()
	{
		return name;
	}

	public int getSpCost()
	{
		return spCost;
	}

	public short getItemId()
	{
		return itemId;
	}

	public int getItemCount()
	{
		return itemCount;
	}

	public int getRepCost()
	{
		return _repCost;
	}
}
