package L2jFT.game.model.base;

/**
 * This class defines all classes (ex : human fighter, darkFighter...) that a player can chose.<BR><BR>
 *
 * Data :<BR><BR>
 * <li>id : The Identifier of the class</li>
 * <li>isMage : True if the class is a mage class</li>
 * <li>race : The race of this class</li>
 * <li>parent : The parent ClassId or null if this class is the root</li><BR><BR>
 */
@SuppressWarnings( { "nls", "unqualified-field-access", "boxing" })
public enum ClassId
{
	fighter((short) 0x00, false, Race.Human, null, 1),

	warrior((short) 0x01, false, Race.Human, fighter, 2),
	gladiator((short) 0x02, false, Race.Human, warrior, 3),
	warlord((short) 0x03, false, Race.Human, warrior, 3),
	knight((short) 0x04, false, Race.Human, fighter, 2),
	paladin((short) 0x05, false, Race.Human, knight, 3),
	darkAvenger((short) 0x06, false, Race.Human, knight, 3),
	rogue((short) 0x07, false, Race.Human, fighter, 2),
	treasureHunter((short) 0x08, false, Race.Human, rogue, 3),
	hawkeye((short) 0x09, false, Race.Human, rogue, 3),

	mage((short) 0x0a, true, Race.Human, null, 1),
	wizard((short) 0x0b, true, Race.Human, mage, 2),
	sorceror((short) 0x0c, true, Race.Human, wizard, 3),
	necromancer((short) 0x0d, true, Race.Human, wizard, 3),
	warlock((short) 0x0e, true, Race.Human, wizard, 3),
	cleric((short) 0x0f, true, Race.Human, mage, 2),
	bishop((short) 0x10, true, Race.Human, cleric, 3),
	prophet((short) 0x11, true, Race.Human, cleric, 3),

	elvenFighter((short) 0x12, false, Race.Elf, null, 1),
	elvenKnight((short) 0x13, false, Race.Elf, elvenFighter, 2),
	templeKnight((short) 0x14, false, Race.Elf, elvenKnight, 3),
	swordSinger((short) 0x15, false, Race.Elf, elvenKnight, 3),
	elvenScout((short) 0x16, false, Race.Elf, elvenFighter, 2),
	plainsWalker((short) 0x17, false, Race.Elf, elvenScout, 3),
	silverRanger((short) 0x18, false, Race.Elf, elvenScout, 3),

	elvenMage((short) 0x19, true, Race.Elf, null, 1),
	elvenWizard((short) 0x1a, true, Race.Elf, elvenMage, 2),
	spellsinger((short) 0x1b, true, Race.Elf, elvenWizard, 3),
	elementalSummoner((short) 0x1c, true, Race.Elf, elvenWizard, 3),
	oracle((short) 0x1d, true, Race.Elf, elvenMage, 2),
	elder((short) 0x1e, true, Race.Elf, oracle, 3),

	darkFighter((short) 0x1f, false, Race.DarkElf, null, 1),
	palusKnight((short) 0x20, false, Race.DarkElf, darkFighter, 2),
	shillienKnight((short) 0x21, false, Race.DarkElf, palusKnight, 3),
	bladedancer((short) 0x22, false, Race.DarkElf, palusKnight, 3),
	assassin((short) 0x23, false, Race.DarkElf, darkFighter, 2),
	abyssWalker((short) 0x24, false, Race.DarkElf, assassin, 3),
	phantomRanger((short) 0x25, false, Race.DarkElf, assassin, 3),

	darkMage((short) 0x26, true, Race.DarkElf, null, 1),
	darkWizard((short) 0x27, true, Race.DarkElf, darkMage, 2),
	spellhowler((short) 0x28, true, Race.DarkElf, darkWizard, 3),
	phantomSummoner((short) 0x29, true, Race.DarkElf, darkWizard, 3),
	shillienOracle((short) 0x2a, true, Race.DarkElf, darkMage, 2),
	shillienElder((short) 0x2b, true, Race.DarkElf, shillienOracle, 3),

	orcFighter((short) 0x2c, false, Race.Orc, null, 1),
	orcRaider((short) 0x2d, false, Race.Orc, orcFighter, 2),
	destroyer((short) 0x2e, false, Race.Orc, orcRaider, 3),
	orcMonk((short) 0x2f, false, Race.Orc, orcFighter, 2),
	tyrant((short) 0x30, false, Race.Orc, orcMonk, 3),

	orcMage((short) 0x31, true, Race.Orc, null, 1),
	orcShaman((short) 0x32, true, Race.Orc, orcMage, 2),
	overlord((short) 0x33, true, Race.Orc, orcShaman, 3),
	warcryer((short) 0x34, true, Race.Orc, orcShaman, 3),

	dwarvenFighter((short) 0x35, false, Race.Dwarf, null, 1),
	scavenger((short) 0x36, false, Race.Dwarf, dwarvenFighter, 2),
	bountyHunter((short) 0x37, false, Race.Dwarf, scavenger, 3),
	artisan((short) 0x38, false, Race.Dwarf, dwarvenFighter, 2),
	warsmith((short) 0x39, false, Race.Dwarf, artisan, 3),

	/*
	 * Dummy Entries (id's already in decimal format)
	 * btw FU NCSoft for the amount of work you put me
	 * through to do this!!
	 * <START>
	 */
	dummyEntry1((short) 58, false, null, null, 0),
	dummyEntry2((short) 59, false, null, null, 0),
	dummyEntry3((short) 60, false, null, null, 0),
	dummyEntry4((short) 61, false, null, null, 0),
	dummyEntry5((short) 62, false, null, null, 0),
	dummyEntry6((short) 63, false, null, null, 0),
	dummyEntry7((short) 64, false, null, null, 0),
	dummyEntry8((short) 65, false, null, null, 0),
	dummyEntry9((short) 66, false, null, null, 0),
	dummyEntry10((short) 67, false, null, null, 0),
	dummyEntry11((short) 68, false, null, null, 0),
	dummyEntry12((short) 69, false, null, null, 0),
	dummyEntry13((short) 70, false, null, null, 0),
	dummyEntry14((short) 71, false, null, null, 0),
	dummyEntry15((short) 72, false, null, null, 0),
	dummyEntry16((short) 73, false, null, null, 0),
	dummyEntry17((short) 74, false, null, null, 0),
	dummyEntry18((short) 75, false, null, null, 0),
	dummyEntry19((short) 76, false, null, null, 0),
	dummyEntry20((short) 77, false, null, null, 0),
	dummyEntry21((short) 78, false, null, null, 0),
	dummyEntry22((short) 79, false, null, null, 0),
	dummyEntry23((short) 80, false, null, null, 0),
	dummyEntry24((short) 81, false, null, null, 0),
	dummyEntry25((short) 82, false, null, null, 0),
	dummyEntry26((short) 83, false, null, null, 0),
	dummyEntry27((short) 84, false, null, null, 0),
	dummyEntry28((short) 85, false, null, null, 0),
	dummyEntry29((short) 86, false, null, null, 0),
	dummyEntry30((short) 87, false, null, null, 0),
	/*
	 * <END>
	 * Of Dummy entries
	 */

	duelist((short) 0x58, false, Race.Human, gladiator, 4),
	dreadnought((short) 0x59, false, Race.Human, warlord, 4),
	phoenixKnight((short) 0x5a, false, Race.Human, paladin, 4),
	hellKnight((short) 0x5b, false, Race.Human, darkAvenger, 4),
	sagittarius((short) 0x5c, false, Race.Human, hawkeye, 4),
	adventurer((short) 0x5d, false, Race.Human, treasureHunter, 4),
	archmage((short) 0x5e, true, Race.Human, sorceror, 4),
	soultaker((short) 0x5f, true, Race.Human, necromancer, 4),
	arcanaLord((short) 0x60, true, Race.Human, warlock, 4),
	cardinal((short) 0x61, true, Race.Human, bishop, 4),
	hierophant((short) 0x62, true, Race.Human, prophet, 4),

	evaTemplar((short) 0x63, false, Race.Elf, templeKnight, 4),
	swordMuse((short) 0x64, false, Race.Elf, swordSinger, 4),
	windRider((short) 0x65, false, Race.Elf, plainsWalker, 4),
	moonlightSentinel((short) 0x66, false, Race.Elf, silverRanger, 4),
	mysticMuse((short) 0x67, true, Race.Elf, spellsinger, 4),
	elementalMaster((short) 0x68, true, Race.Elf, elementalSummoner, 4),
	evaSaint((short) 0x69, true, Race.Elf, elder, 4),

	shillienTemplar((short) 0x6a, false, Race.DarkElf, shillienKnight, 4),
	spectralDancer((short) 0x6b, false, Race.DarkElf, bladedancer, 4),
	ghostHunter((short) 0x6c, false, Race.DarkElf, abyssWalker, 4),
	ghostSentinel((short) 0x6d, false, Race.DarkElf, phantomRanger, 4),
	stormScreamer((short) 0x6e, true, Race.DarkElf, spellhowler, 4),
	spectralMaster((short) 0x6f, true, Race.DarkElf, phantomSummoner, 4),
	shillienSaint((short) 0x70, true, Race.DarkElf, shillienElder, 4),

	titan((short) 0x71, false, Race.Orc, destroyer, 4),
	grandKhauatari((short) 0x72, false, Race.Orc, tyrant, 4),
	dominator((short) 0x73, true, Race.Orc, overlord, 4),
	doomcryer((short) 0x74, true, Race.Orc, warcryer, 4),

	fortuneSeeker((short) 0x75, false, Race.Dwarf, bountyHunter, 4),
	maestro((short) 0x76, false, Race.Dwarf, warsmith, 4),

	dummyEntry31((short) 119, false, null, null, 0),
	dummyEntry32((short) 120, false, null, null, 0),
	dummyEntry33((short) 121, false, null, null, 0),
	dummyEntry34((short) 122, false, null, null, 0),

	// test	
	maleSoldier((short) 0x7b, false, Race.Kamael, null, 1),
	femaleSoldier((short) 0x7c, false, Race.Kamael, null, 1),
	trooper((short) 0x7d, false, Race.Kamael, maleSoldier, 2),
	warder((short) 0x7e, false, Race.Kamael, femaleSoldier, 2),
	berserker((short) 0x7f, false, Race.Kamael, trooper, 3),
	maleSoulbreaker((short) 0x80, false, Race.Kamael, trooper, 3),
	femaleSoulbreaker((short) 0x81, false, Race.Kamael, warder, 3),
	arbalester((short) 0x82, false, Race.Kamael, warder, 3),
	inspector((short) 0x83, false, Race.Kamael, warder, 3),

	//test
	doombringer((short) 0x84, false, Race.Kamael, berserker, 4),
	maleSoulhound((short) 0x85, false, Race.Kamael, maleSoulbreaker, 4),
	femaleSoulhound((short) 0x86, false, Race.Kamael, femaleSoulbreaker, 4),
	trickster((short) 0x87, false, Race.Kamael, arbalester, 4),
	judicator((short) 0x88, false, Race.Kamael, inspector, 4);

	/** The Identifier of the Class */
	private final short id;

	/** True if the class is a mage class */
	private final boolean isMage;

	/** The Race object of the class */
	private final Race race;

	/** The parent ClassId or null if this class is a root */
	private final ClassId parent;

	private final int level;

	/**
	 * Constructor of ClassId.<BR><BR>
	 */
	private ClassId(short id, boolean isMage, Race race, ClassId parent, int level)
	{
		this.id = id;
		this.isMage = isMage;
		this.race = race;
		this.parent = parent;
		this.level = level;
	}

	/**
	 * Return the Identifier of the Class.<BR><BR>
	 */
	public final short getId()
	{
		return id;
	}

	/**
	 * Return True if the class is a mage class.<BR><BR>
	 */
	public final boolean isMage()
	{
		return isMage;
	}

	/**
	 * Return the Race object of the class.<BR><BR>
	 */
	public final Race getRace()
	{
		return race;
	}

	/**
	 * Return True if this Class is a child of the selected ClassId.<BR><BR>
	 *
	 * @param cid The parent ClassId to check
	 *
	 */
	public final boolean childOf(ClassId cid)
	{
		if(parent == null)
			return false;

		if(parent == cid)
			return true;

		return parent.childOf(cid);

	}

	/**
	 * Return True if this Class is equal to the selected ClassId or a child of the selected ClassId.<BR><BR>
	 *
	 * @param cid The parent ClassId to check
	 *
	 */
	public final boolean equalsOrChildOf(ClassId cid)
	{
		return this == cid || childOf(cid);
	}

	/**
	 * Return the child level of this Class (0=root, 1=child leve 1...).<BR><BR>
	 *
	 * @param cid The parent ClassId to check
	 *
	 */
	public final byte level()
	{
		if(parent == null)
			return 0;

		return (byte) (1 + parent.level());
	}

	public final ClassId getParent()
	{
		return parent;
	}

	public final int getLevel()
	{
		return level;
	}
}
