package L2jFT.game.model.base;

import static L2jFT.game.model.base.ClassLevel.First;
import static L2jFT.game.model.base.ClassLevel.Fourth;
import static L2jFT.game.model.base.ClassLevel.Second;
import static L2jFT.game.model.base.ClassLevel.Third;
import static L2jFT.game.model.base.ClassType.Fighter;
import static L2jFT.game.model.base.ClassType.Mystic;
import static L2jFT.game.model.base.ClassType.Priest;
import static L2jFT.game.model.base.Race.DarkElf;
import static L2jFT.game.model.base.Race.Dwarf;
import static L2jFT.game.model.base.Race.Human;
import static L2jFT.game.model.base.Race.Elf;
import static L2jFT.game.model.base.Race.Orc;
import static L2jFT.game.model.base.Race.Kamael;

import java.util.EnumMap;
import java.util.EnumSet;
import java.util.Set;

/**
 * This class ...
 *
 * @version $Revision: 1.2 $ $Date: 2004/06/27 08:12:59 $
 */
public enum PlayerClass
{
	HumanFighter(Human, Fighter, First), //0
	Warrior(Human, Fighter, Second), //1
	Gladiator(Human, Fighter, Third), //2
	Warlord(Human, Fighter, Third), //3
	HumanKnight(Human, Fighter, Second), //4
	Paladin(Human, Fighter, Third), //5
	DarkAvenger(Human, Fighter, Third), //6
	Rogue(Human, Fighter, Second), //7
	TreasureHunter(Human, Fighter, Third), //8
	Hawkeye(Human, Fighter, Third), //9
	HumanMystic(Human, Mystic, First), //10
	HumanWizard(Human, Mystic, Second), //11
	Sorceror(Human, Mystic, Third), //12
	Necromancer(Human, Mystic, Third), //13
	Warlock(Human, Mystic, Third), //14
	Cleric(Human, Priest, Second), //15
	Bishop(Human, Priest, Third), //16
	Prophet(Human, Priest, Third), //17

	ElvenFighter(Elf, Fighter, First), //18
	ElvenKnight(Elf, Fighter, Second), //19
	TempleKnight(Elf, Fighter, Third), //20
	Swordsinger(Elf, Fighter, Third), //21
	ElvenScout(Elf, Fighter, Second), //22
	Plainswalker(Elf, Fighter, Third), //23
	SilverRanger(Elf, Fighter, Third), //24
	ElvenMystic(Elf, Mystic, First), //25
	ElvenWizard(Elf, Mystic, Second), //26
	Spellsinger(Elf, Mystic, Third), //27
	ElementalSummoner(Elf, Mystic, Third), //28
	ElvenOracle(Elf, Priest, Second), //29
	ElvenElder(Elf, Priest, Third), //30

	DarkElvenFighter(DarkElf, Fighter, First), //31
	PalusKnight(DarkElf, Fighter, Second), //32
	ShillienKnight(DarkElf, Fighter, Third), //33
	Bladedancer(DarkElf, Fighter, Third), //34
	Assassin(DarkElf, Fighter, Second), //35
	AbyssWalker(DarkElf, Fighter, Third), //36
	PhantomRanger(DarkElf, Fighter, Third), //37
	DarkElvenMystic(DarkElf, Mystic, First), //38
	DarkElvenWizard(DarkElf, Mystic, Second), //39
	Spellhowler(DarkElf, Mystic, Third), //40
	PhantomSummoner(DarkElf, Mystic, Third), //41
	ShillienOracle(DarkElf, Priest, Second), //42
	ShillienElder(DarkElf, Priest, Third), //43

	OrcFighter(Orc, Fighter, First), //44
	OrcRaider(Orc, Fighter, Second), //45
	Destroyer(Orc, Fighter, Third), //46
	OrcMonk(Orc, Fighter, Second), //47
	Tyrant(Orc, Fighter, Third), //48
	OrcMystic(Orc, Mystic, First), //49
	OrcShaman(Orc, Mystic, Second), //50
	Overlord(Orc, Mystic, Third), //51
	Warcryer(Orc, Mystic, Third), //52

	DwarvenFighter(Dwarf, Fighter, First), //53
	DwarvenScavenger(Dwarf, Fighter, Second), //54
	BountyHunter(Dwarf, Fighter, Third), //55
	DwarvenArtisan(Dwarf, Fighter, Second), //56
	Warsmith(Dwarf, Fighter, Third), //57

	DummyEntry1(null, null, null), //58
	DummyEntry2(null, null, null), //59
	DummyEntry3(null, null, null), //60
	DummyEntry4(null, null, null), //61
	DummyEntry5(null, null, null), //62
	DummyEntry6(null, null, null), //63
	DummyEntry7(null, null, null), //64
	DummyEntry8(null, null, null), //65
	DummyEntry9(null, null, null), //66
	DummyEntry10(null, null, null), //67
	DummyEntry11(null, null, null), //68
	DummyEntry12(null, null, null), //69
	DummyEntry13(null, null, null), //70
	DummyEntry14(null, null, null), //71
	DummyEntry15(null, null, null), //72
	DummyEntry16(null, null, null), //73
	DummyEntry17(null, null, null), //74
	DummyEntry18(null, null, null), //75
	DummyEntry19(null, null, null), //76
	DummyEntry20(null, null, null), //77
	DummyEntry21(null, null, null), //78
	DummyEntry22(null, null, null), //79
	DummyEntry23(null, null, null), //80
	DummyEntry24(null, null, null), //81
	DummyEntry25(null, null, null), //82
	DummyEntry26(null, null, null), //83
	DummyEntry27(null, null, null), //84
	DummyEntry28(null, null, null), //85
	DummyEntry29(null, null, null), //86
	DummyEntry30(null, null, null), //87

	Duelist(Human, Fighter, Fourth), //88
	Dreadnought(Human, Fighter, Fourth), //89
	PhoenixKnight(Human, Fighter, Fourth), //90
	HellKnight(Human, Fighter, Fourth), //91
	Sagittarius(Human, Fighter, Fourth), //92
	Adventurer(Human, Fighter, Fourth), //93
	Archmage(Human, Mystic, Fourth), //94
	Soultaker(Human, Mystic, Fourth), //95
	ArcanaLord(Human, Mystic, Fourth), //96
	Cardinal(Human, Priest, Fourth), //97
	Hierophant(Human, Priest, Fourth), //98

	EvaTemplar(Elf, Fighter, Fourth), //99
	SwordMuse(Elf, Fighter, Fourth), //100
	WindRider(Elf, Fighter, Fourth), //101
	MoonlightSentinel(Elf, Fighter, Fourth), //102
	MysticMuse(Elf, Mystic, Fourth), //103
	ElementalMaster(Elf, Mystic, Fourth), //104
	EvaSaint(Elf, Priest, Fourth), //105

	ShillienTemplar(DarkElf, Fighter, Fourth), //106
	SpectralDancer(DarkElf, Fighter, Fourth), //107
	GhostHunter(DarkElf, Fighter, Fourth), //108
	GhostSentinel(DarkElf, Fighter, Fourth), //109
	StormScreamer(DarkElf, Mystic, Fourth), //110
	SpectralMaster(DarkElf, Mystic, Fourth), //111
	ShillienSaint(DarkElf, Priest, Fourth), //112

	Titan(Orc, Fighter, Fourth), //113
	GrandKhauatari(Orc, Fighter, Fourth), //114
	Dominator(Orc, Mystic, Fourth), //115
	Doomcryer(Orc, Mystic, Fourth), //116

	FortuneSeeker(Dwarf, Fighter, Fourth), //117
	Maestro(Dwarf, Fighter, Fourth), //118

	DummyEntry31(null, null, null), //119
	DummyEntry32(null, null, null), //120
	DummyEntry33(null, null, null), //121
	DummyEntry34(null, null, null), //122

	//test
	MaleSoldier(Kamael, Fighter, First), // 119
	FemaleSoldier(Kamael, Fighter, First), //120
	Troopier(Kamael, Fighter, Second), // 121
	Warder(Kamael, Fighter, Second), //122
	Berserker(Kamael, Fighter, Third), //123
	MaleSoulbreaker(Kamael, Fighter, Third), //124
	FemaleSoulbreaker(Kamael, Fighter, Third), //125
	Arbalester(Kamael, Fighter, Third), //126
	Inspector(Kamael, Fighter, Third), //127

	//test
	Doombringer(Kamael, Fighter, Fourth), //128
	MaleSoulHound(Kamael, Fighter, Fourth), //129
	FemaleSoulHound(Kamael, Fighter, Fourth), //130
	Trickster(Kamael, Fighter, Fourth), //131
	Judicator(Kamael, Fighter, Fourth); //132

	private Race race;
	private ClassLevel level;
	public ClassType type;

	private static final Set<PlayerClass> mainSubclassSet;
	private static final Set<PlayerClass> neverSubclassed = EnumSet.of(Overlord, Warsmith);

	private static final Set<PlayerClass> subclasseSet1 = EnumSet.of(DarkAvenger, Paladin, TempleKnight, ShillienKnight);
	private static final Set<PlayerClass> subclasseSet2 = EnumSet.of(TreasureHunter, AbyssWalker, Plainswalker);
	private static final Set<PlayerClass> subclasseSet3 = EnumSet.of(Hawkeye, SilverRanger, PhantomRanger);
	private static final Set<PlayerClass> subclasseSet4 = EnumSet.of(Warlock, ElementalSummoner, PhantomSummoner);
	private static final Set<PlayerClass> subclasseSet5 = EnumSet.of(Sorceror, Spellsinger, Spellhowler);

	private static final EnumMap<PlayerClass, Set<PlayerClass>> subclassSetMap = new EnumMap<PlayerClass, Set<PlayerClass>>(PlayerClass.class);

	static
	{
		Set<PlayerClass> subclasses = getSet(null, Third);
		subclasses.removeAll(neverSubclassed);

		mainSubclassSet = subclasses;

		subclassSetMap.put(DarkAvenger, subclasseSet1);
		subclassSetMap.put(HellKnight, subclasseSet1);
		subclassSetMap.put(Paladin, subclasseSet1);
		subclassSetMap.put(PhoenixKnight, subclasseSet1);
		subclassSetMap.put(TempleKnight, subclasseSet1);
		subclassSetMap.put(EvaTemplar, subclasseSet1);
		subclassSetMap.put(ShillienKnight, subclasseSet1);
		subclassSetMap.put(ShillienTemplar, subclasseSet1);

		subclassSetMap.put(TreasureHunter, subclasseSet2);
		subclassSetMap.put(Adventurer, subclasseSet2);
		subclassSetMap.put(AbyssWalker, subclasseSet2);
		subclassSetMap.put(GhostHunter, subclasseSet2);
		subclassSetMap.put(Plainswalker, subclasseSet2);
		subclassSetMap.put(WindRider, subclasseSet2);

		subclassSetMap.put(Hawkeye, subclasseSet3);
		subclassSetMap.put(Sagittarius, subclasseSet3);
		subclassSetMap.put(SilverRanger, subclasseSet3);
		subclassSetMap.put(MoonlightSentinel, subclasseSet3);
		subclassSetMap.put(PhantomRanger, subclasseSet3);
		subclassSetMap.put(GhostSentinel, subclasseSet3);

		subclassSetMap.put(Warlock, subclasseSet4);
		subclassSetMap.put(ArcanaLord, subclasseSet4);
		subclassSetMap.put(ElementalSummoner, subclasseSet4);
		subclassSetMap.put(ElementalMaster, subclasseSet4);
		subclassSetMap.put(PhantomSummoner, subclasseSet4);
		subclassSetMap.put(SpectralMaster, subclasseSet4);

		subclassSetMap.put(Sorceror, subclasseSet5);
		subclassSetMap.put(Archmage, subclasseSet5);
		subclassSetMap.put(Spellsinger, subclasseSet5);
		subclassSetMap.put(MysticMuse, subclasseSet5);
		subclassSetMap.put(Spellhowler, subclasseSet5);
		subclassSetMap.put(StormScreamer, subclasseSet5);

		subclassSetMap.put(Duelist, EnumSet.of(Gladiator));
		subclassSetMap.put(Dreadnought, EnumSet.of(Warlord));
		subclassSetMap.put(Soultaker, EnumSet.of(Necromancer));
		subclassSetMap.put(Cardinal, EnumSet.of(Bishop));
		subclassSetMap.put(Hierophant, EnumSet.of(Prophet));
		subclassSetMap.put(SwordMuse, EnumSet.of(Swordsinger));
		subclassSetMap.put(EvaSaint, EnumSet.of(ElvenElder));
		subclassSetMap.put(SpectralDancer, EnumSet.of(Bladedancer));
		subclassSetMap.put(Titan, EnumSet.of(Destroyer));
		subclassSetMap.put(GrandKhauatari, EnumSet.of(Tyrant));
		subclassSetMap.put(Dominator, EnumSet.of(Overlord));
		subclassSetMap.put(Doomcryer, EnumSet.of(Warcryer));
	}

	PlayerClass(Race race, ClassType type, ClassLevel level)
	{
		this.race = race;
		this.level = level;
		this.type = type;
	}

	public final Set<PlayerClass> getAvaliableSubclasses()
	{
		Set<PlayerClass> subclasses = null;

		if(level == Third || level == Fourth)
		{
			subclasses = EnumSet.copyOf(mainSubclassSet);

			subclasses.removeAll(neverSubclassed);
			subclasses.remove(this);

			switch(race)
			{
				case Elf:
					subclasses.removeAll(getSet(DarkElf, Third));
					break;
				case DarkElf:
					subclasses.removeAll(getSet(Elf, Third));
					break;
			}

			Set<PlayerClass> unavaliableClasses = subclassSetMap.get(this);

			if(unavaliableClasses != null)
				subclasses.removeAll(unavaliableClasses);
		}

		return subclasses;
	}

	public static final EnumSet<PlayerClass> getSet(Race race, ClassLevel level)
	{
		EnumSet<PlayerClass> allOf = EnumSet.noneOf(PlayerClass.class);

		for(PlayerClass playerClass : EnumSet.allOf(PlayerClass.class))
			if(race == null || playerClass.isOfRace(race))
				if(level == null || playerClass.isOfLevel(level))
					allOf.add(playerClass);

		return allOf;
	}

	public final boolean isOfRace(Race race)
	{
		return this.race == race;
	}

	public final boolean isOfType(ClassType type)
	{
		return this.type == type;
	}

	public final boolean isOfLevel(ClassLevel level)
	{
		return this.level == level;
	}
}
