package L2jFT.game.model.entity.sevensigns;

import L2jFT.game.model.L2Player;
import static L2jFT.game.model.entity.sevensigns.SevenSigns.SEAL_STONE_BLUE_ID;
import static L2jFT.game.model.entity.sevensigns.SevenSigns.SEAL_STONE_GREEN_ID;
import static L2jFT.game.model.entity.sevensigns.SevenSigns.SEAL_STONE_RED_ID;
import static L2jFT.game.model.entity.sevensigns.SevenSigns.SIDE_DAWN;
import static L2jFT.game.model.entity.sevensigns.SevenSigns.SIDE_DUSK;
import L2jFT.game.model.instances.L2ItemInstance;

public class Score
{
	public byte STONE_VALUE_RED = 10;
	public byte STONE_VALUE_GREED = 5;
	public byte STONE_VALUE_BLUE = 3;

	private int BLUE_STONE_DAWN = 0;
	private int BLUE_STONE_DUSK = 0;

	private int RED_STONE_DAWN = 0;
	private int RED_STONE_DUSK = 0;

	private int GREEN_STONE_DAWN = 0;
	private int GREEN_STONE_DUSK = 0;

	private int PLAYER_OBJECT_ID;

	private byte SIDE;
	private byte SEAL;

	public Score(int objId, byte side, byte seal)
	{
		PLAYER_OBJECT_ID = objId;
		SIDE = side;
		SEAL = seal;
	}

	public int getStoneCountGreen(byte side)
	{
		if(side == SIDE_DAWN)
			return GREEN_STONE_DAWN;
		return GREEN_STONE_DUSK;
	}

	public int getStoneCountRed(byte side)
	{
		if(side == SIDE_DAWN)
			return RED_STONE_DAWN;
		return RED_STONE_DUSK;
	}

	public int getStoneCountBlue(byte side)
	{
		if(side == SIDE_DAWN)
			return BLUE_STONE_DAWN;
		return BLUE_STONE_DUSK;
	}

	public int getPlayer()
	{
		return PLAYER_OBJECT_ID;
	}

	public void setStoneCountGreen(int count, byte side)
	{
		if(side == SIDE_DAWN)
			GREEN_STONE_DAWN = count;
		else
			GREEN_STONE_DUSK = count;
	}

	public void setStoneCountRed(int count, byte side)
	{
		if(side == SIDE_DAWN)
			RED_STONE_DAWN = count;
		else
			RED_STONE_DUSK = count;
	}

	public void setStoneCountBlue(int count, byte side)
	{
		if(side == SevenSigns.SIDE_DAWN)
			BLUE_STONE_DAWN = count;
		else
			BLUE_STONE_DUSK = count;
	}

	public void setSide(byte side)
	{
		SIDE = side;
	}

	public void setSeal(byte seal)
	{
		SEAL = seal;
	}

	public byte getSide()
	{
		return SIDE;
	}

	public byte getSeal()
	{
		return SEAL;
	}

	public void setStonesToZero(byte side)
	{
		if(side == SIDE_DAWN)
		{
			BLUE_STONE_DAWN = 0;
			RED_STONE_DAWN = 0;
			GREEN_STONE_DAWN = 0;
		}
		else
		{
			BLUE_STONE_DUSK = 0;
			RED_STONE_DUSK = 0;
			GREEN_STONE_DUSK = 0;
		}
	}

	public long getToalAdenaCount(byte side)
	{
		if(side == SIDE_DUSK)
			return BLUE_STONE_DUSK * 3 + RED_STONE_DUSK * 10 + GREEN_STONE_DUSK * 5;
		return BLUE_STONE_DAWN * 3 + RED_STONE_DAWN * 10 + GREEN_STONE_DAWN * 5;
	}

	public void makeContribution(short itemId, int count, L2Player player)
	{
		//Contribute all stones
		if(count == -1)
		{
			for(L2ItemInstance i : player.getInventory().getItems())
				if(i.getItemId() == SEAL_STONE_BLUE_ID)
				{
					if(getSide() == SIDE_DAWN)
						BLUE_STONE_DAWN += i.getCount();
					else
						BLUE_STONE_DUSK += i.getCount();
					player.getInventory().destroyItem(i, i.getCount(), true, true);
				}
				else if(i.getItemId() == SEAL_STONE_GREEN_ID)
				{
					if(getSide() == SIDE_DAWN)
						GREEN_STONE_DAWN += i.getCount();
					else
						GREEN_STONE_DUSK += i.getCount();
					player.getInventory().destroyItem(i, i.getCount(), true, true);
				}
				else if(i.getItemId() == SEAL_STONE_RED_ID)
				{
					if(getSide() == SIDE_DAWN)
						RED_STONE_DAWN += i.getCount();
					else
						RED_STONE_DUSK += i.getCount();
					player.getInventory().destroyItem(i, i.getCount(), true, true);
				}
		}
		else
		//Contribute specific stone
		{
			L2ItemInstance i = player.getInventory().getItemByItemId(itemId);

			if(i == null || i.getCount() < count)
				return;

			if(i.getItemId() == SEAL_STONE_BLUE_ID)
			{
				if(getSide() == SIDE_DAWN)
					BLUE_STONE_DAWN += count;
				else
					BLUE_STONE_DUSK += count;
				player.getInventory().destroyItem(i, count, true, true);
			}
			else if(i.getItemId() == SEAL_STONE_GREEN_ID)
			{
				if(getSide() == SIDE_DAWN)
					GREEN_STONE_DAWN += count;
				else
					GREEN_STONE_DUSK += count;
				player.getInventory().destroyItem(i, count, true, true);
			}
			else if(i.getItemId() == SEAL_STONE_RED_ID)
			{
				if(getSide() == SIDE_DAWN)
					RED_STONE_DAWN += count;
				else
					RED_STONE_DUSK += count;
				player.getInventory().destroyItem(i, count, true, true);
			}
		}
	}
}
