package L2jFT.game.model.instances;

import javolution.util.FastList;
import L2jFT.Config;
import L2jFT.util.Rnd;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.base.ItemToDrop;
import L2jFT.game.tables.NpcTable;
import L2jFT.game.templates.L2NpcTemplate;

public class L2ChestInstance extends L2MonsterInstance
{
	private boolean _fake;

	public L2ChestInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	@Override
	public void onSpawn()
	{
		_fake = Rnd.get() > Config.ALT_TRUE_CHESTS;
		super.onSpawn();
	}

	public void onOpen(L2Player opener)
	{
		if(!_fake)
		{
			setSpoiled(false);
			if(NpcTable.getTemplate(getNpcId() - 3536) != null && NpcTable.getTemplate(getNpcId() - 3536).getDropData() != null)
			{
				final FastList<ItemToDrop> drops = NpcTable.getTemplate(getNpcId() - 3536).getDropData().rollDrop(0, false, opener);
				for(final ItemToDrop drop : drops)
					dropItem(opener, drop.itemId, drop.count);
			}
			doDie(opener);
		}
		else
		{
			opener.sendMessage("Fake chest!", "Фальшивый сундук!");
			addDamageHate(opener, 0, 1);
		}
	}

	@Override
	public void reduceCurrentHp(final double damage, final L2Character attacker, final boolean awake, final boolean standUp, boolean directHp)
	{
		if(!_fake)
			doDie(attacker);
		else
			super.reduceCurrentHp(damage, attacker, awake, standUp, directHp);
	}

	public boolean isFake()
	{
		return _fake;
	}

	public void setFake(boolean _fake)
	{
		this._fake = _fake;
	}
}