package L2jFT.game.model.instances;

import L2jFT.game.ai.L2CharacterAI;
import L2jFT.game.model.L2Character;
import L2jFT.game.network.serverpackets.Die;
import L2jFT.game.taskmanager.DecayTaskManager;
import L2jFT.game.templates.L2NpcTemplate;

public class L2DeadManInstance extends L2MonsterInstance
{
	public L2DeadManInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	/**
	 * Return the L2CharacterAI of the L2Character and if its null create a new one.<BR><BR>
	 */
	@Override
	public L2CharacterAI getAI()
	{
		if(_ai == null)
			_ai = new L2CharacterAI(this);
		return _ai;
	}

	@Override
	public void onSpawn()
	{
		super.onSpawn();
		DecayTaskManager.getInstance().addDecayTask(this, Integer.MAX_VALUE);
		stopHpMpRegeneration();
		setCurrentHp(0);
		setDead(true);
		broadcastStatusUpdate();
		broadcastPacket(new Die(this));
		setWalking();
	}

	@Override
	public void reduceCurrentHp(double damage, L2Character attacker)
	{}

	@Override
	public void reduceCurrentHp(double damage, L2Character attacker, boolean awake, boolean standUp)
	{}

	@Override
	public void reduceCurrentHp(double damage, L2Character attacker, boolean awake, boolean standUp, boolean directHp)
	{}

	@Override
	public void doDie(L2Character killer)
	{}

	@Override
	public void addDamage(L2Character attacker, int damage)
	{}

	@Override
	public void addDamageHate(L2Character attacker, int damage, int aggro)
	{}

	@Override
	public boolean isAggressive()
	{
		return false;
	}
}