package L2jFT.game.model.instances;

import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Player;
import L2jFT.game.templates.L2NpcTemplate;

/**
 * @Author: Death
 * @Date: 17/9/2007
 * @Time: 19:11:50
 *
 * Этот инстанс просто для отрисовки умершей вышки на месте оригинальной на осаде
 * Фэйковый инстанс неуязвим.
 * @see L2jFT.game.model.instances.L2ControlTowerInstance#onSpawn()
 * @see L2jFT.game.model.instances.L2ControlTowerInstance#onDecay() 
 */
public class L2FakeTowerInstance extends L2NpcInstance
{
	public L2FakeTowerInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	/**
	 * Фэйковые вышки не атакуюццо
	 * @param player игрок
	 * @return false
	 */
	@Override
	public boolean isAutoAttackable(L2Character player)
	{
		return false;
	}

	/**
	 * Вышки не умеют говорить
	 * @param player пофиг что :)
	 * @param val пофиг что :)
	 */
	@Override
	public void showChatWindow(L2Player player, int val)
	{

	}

	/**
	 * Вышки не умеют говорить
	 * @param player пофиг что :)
	 * @param filename пофиг что :)
	 */
	@Override
	public void showChatWindow(L2Player player, String filename)
	{

	}

	@Override
	public boolean hasRandomAnimation()
	{
		return false;
	}

	/**
	 * Фэйковые вышки неуязвимы
	 * @return true
	 */
	@Override
	public boolean isInvul()
	{
		return true;
	}

	@Override
	public boolean isFearImmune()
	{
		return true;
	}

	@Override
	public boolean paralyzeImmune()
	{
		return true;
	}
}
