package L2jFT.game.model.instances;

import L2jFT.game.ai.CtrlIntention;
import L2jFT.game.network.clientpackets.Say2;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2Spawn;
import L2jFT.game.network.serverpackets.CreatureSay;
import L2jFT.game.tables.SpawnTable;
import L2jFT.game.templates.L2NpcTemplate;

import java.util.Random;

public final class L2PenaltyMonsterInstance extends L2MonsterInstance
{
	private L2Player _ptk;
	private final static Random _rnd = new Random();

	public L2PenaltyMonsterInstance(int objectId, L2NpcTemplate template)
	{
		super(objectId, template);
	}

	@Override
	public L2Character getMostHated()
	{
		return _ptk;
	}

	public void NotifyPlayerDead()
	{
		// Monster kill player and can by deleted
		deleteMe();

		L2Spawn spawn = getSpawn();
		if(spawn != null)
		{
			spawn.stopRespawn();
			SpawnTable.getInstance().deleteSpawn(spawn, false);
		}
	}

	public void SetPlayerToKill(L2Player ptk)
	{
		_ptk = ptk;
		if(_rnd.nextInt(100) <= 80)
			broadcastPacket(new CreatureSay(getObjectId(), Say2.ALL, getName(), "mmm your bait was delicious"));
		addDamage(ptk, 10);
		getAI().setIntention(CtrlIntention.AI_INTENTION_ATTACK, ptk);
	}

	@Override
	public void doDie(L2Character killer)
	{
		if(_rnd.nextInt(100) <= 75)
		{
			CreatureSay cs = new CreatureSay(getObjectId(), Say2.ALL, getName(), "I will tell fishes not to take your bait");
			broadcastPacket(cs);
		}
		super.doDie(killer);
	}

}
