package L2jFT.game.model.instances;

import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.NpcHtmlMessage;
import L2jFT.game.templates.L2NpcTemplate;

/**
 * This class ...
 *
 * @version $Revision$ $Date$
 */
public class L2SiegeNpcInstance extends L2NpcInstance
{
	//private static Logger _log = Logger.getLogger(L2SiegeNpcInstance.class.getName());

	@SuppressWarnings("unused")
	private static int Cond_All_False = 0;
	@SuppressWarnings("unused")
	private static int Cond_Busy_Because_Of_Siege = 1;
	@SuppressWarnings("unused")
	private static int Cond_Clan_Not_Registered = 2;
	@SuppressWarnings("unused")
	private static int Cond_Clan_Registered = 3;
	@SuppressWarnings("unused")
	private static int Cond_Clan_Withdraw = 4;

	/**
	 * @param template
	 */
	public L2SiegeNpcInstance(int objectID, L2NpcTemplate template)
	{
		super(objectID, template);
	}

	@Override
	public void onBypassFeedback(L2Player player, String command)
	{
		if(!isInRange(player.getX(), player.getY(), INTERACTION_DISTANCE))
			return;

		super.onBypassFeedback(player, command);
	}

	/**
	 * If siege is in progress shows the Busy HTML<BR>
	 * else Shows the SiegeInfo window
	 * @param player
	 */
	@Override
	public void showChatWindow(L2Player player, int val)
	{
		if(validateCondition(player))
			getCastle().getSiege().listRegisterClan(player);
		else
		{
			NpcHtmlMessage html = new NpcHtmlMessage(_objectId);
			html.setHtml("<html><body><font color=\"LEVEL\">Oh! Our castle is being attacked and I can't do anything for you right now.</font></body></html>");
			player.sendPacket(html);
		}
	}

	private boolean validateCondition(@SuppressWarnings("unused")
	L2Player player)
	{
		if(getCastle().getSiege().isInProgress())
			return false; // Busy because of siege
		return true;
	}
}
