package L2jFT.game.model.instances;

import L2jFT.Config;
import L2jFT.game.ThreadPoolManager;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2Skill;
import L2jFT.game.model.L2World;
import L2jFT.game.tables.SkillTable;

import java.util.Random;
import java.util.concurrent.ScheduledFuture;

public class L2XmassTreeInstance extends L2StaticObjectInstance
{
	ScheduledFuture aiTask;

	class XmassAI implements Runnable
	{
		L2XmassTreeInstance _caster;

		protected XmassAI(L2XmassTreeInstance caster)
		{
			_caster = caster;
		}

		public void run()
		{
			Random r = new Random();
			for(L2Player player : L2World.getAroundPlayers(_caster, 900, Config.PLAYER_VISIBILITY_Z))
			{
				int i = r.nextInt(3);
				handleCast(player, (4262 + i));
			}
		}

		private boolean handleCast(L2Player player, int skillId)
		{
			L2Skill skill = SkillTable.getInstance().getInfo(skillId, 1);

			if(player.getEffect(skill) == null)
			{
				player.altUseSkill(skill, player);
				return true;
			}

			return false;
		}
	}

	public L2XmassTreeInstance(int objectId)
	{
		super(objectId);
		aiTask = ThreadPoolManager.getInstance().scheduleGeneralAtFixedRate(new XmassAI(this), 3000, 20000);
	}

	@Override
	public void decayMe()
	{
		if(aiTask != null)
			aiTask.cancel(true);

		super.decayMe();
	}

	@Override
	public boolean isAttackable()
	{
		return false;
	}
}
