package L2jFT.game.model.inventory.listeners;

import L2jFT.game.model.Inventory;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.templates.L2Weapon.WeaponType;

public final class BowListener implements PaperdollListener
{
	Inventory _inv;

	public BowListener(Inventory inv)
	{
		_inv = inv;
	}

	public void notifyUnequipped(int slot, L2ItemInstance item)
	{
		if(slot != Inventory.PAPERDOLL_LRHAND)
			return;
		if(item.getItemType() == WeaponType.BOW)
		{
			L2ItemInstance arrow = _inv.getPaperdollItem(Inventory.PAPERDOLL_LHAND);
			if(arrow != null)
				_inv.setPaperdollItem(Inventory.PAPERDOLL_LHAND, null);
		}
		if(item.getItemType() == WeaponType.ROD)
		{
			L2ItemInstance bait = _inv.getPaperdollItem(Inventory.PAPERDOLL_LHAND);
			if(bait != null)
				_inv.setPaperdollItem(Inventory.PAPERDOLL_LHAND, null);
		}
	}

	public void notifyEquipped(int slot, L2ItemInstance item)
	{
		if(slot != Inventory.PAPERDOLL_LRHAND)
			return;
		if(item.getItemType() == WeaponType.BOW)
		{
			L2ItemInstance arrow = _inv.findArrowForBow(item.getItem());
			if(arrow != null)
				_inv.setPaperdollItem(Inventory.PAPERDOLL_LHAND, arrow);
		}
	}
}