package L2jFT.game.model.inventory.listeners;

import L2jFT.game.model.Inventory;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2ItemInstance;

/**
 * Собственно предложение использовать этот листенер для добавления\удаления
 * скилов итемам и прочих действий что делаются для разных предметов.
 * Будем соблюдать чистоту кода ;)
 */
public class CommonItemListener implements PaperdollListener
{
	private final Inventory _myInventory;

	public CommonItemListener(Inventory inventory)
	{
		_myInventory = inventory;
	}

	public void notifyEquipped(int slot, L2ItemInstance inst)
	{
		if(!_myInventory.isRefreshingListeners() && inst.isShadowItem())
			inst.notifyEquipped(true);

		if(_myInventory.getOwner().isPlayer)
		{
			L2Player owner = (L2Player) _myInventory.getOwner();
			owner.addItemSkills(inst);
		}
	}

	public void notifyUnequipped(int slot, L2ItemInstance inst)
	{
		if(!_myInventory.isRefreshingListeners() && inst.isShadowItem())
			inst.notifyEquipped(false);

		if(_myInventory.getOwner().isPlayer)
		{
			L2Player owner = (L2Player) _myInventory.getOwner();
			owner.removeItemSkills(inst);
		}
	}
}
