package L2jFT.game.model.inventory.listeners;

import L2jFT.game.model.Inventory;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2ItemInstance;

public final class ItemAugmentationListener implements PaperdollListener
{
	Inventory _inv;

	public ItemAugmentationListener(Inventory inv)
	{
		_inv = inv;
	}

	public void notifyUnequipped(int slot, L2ItemInstance item)
	{
		L2Player player;

		if(_inv.getOwner().isPlayer)
			player = (L2Player) _inv.getOwner();
		else
			return;

		if(item.isAugmented())
			item.getAugmentation().removeBoni(player);
	}

	public void notifyEquipped(int slot, L2ItemInstance item)
	{
		L2Player player;

		if(_inv.getOwner().isPlayer)
			player = (L2Player) _inv.getOwner();
		else
			return;

		if(item.isAugmented())
			item.getAugmentation().applyBoni(player);
	}
}