package L2jFT.game.model.inventory.listeners;

import L2jFT.game.model.Inventory;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2Skill;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.templates.L2Armor;
import L2jFT.game.templates.L2Item;
import L2jFT.game.templates.L2Weapon;

public final class ItemPassiveSkillsListener implements PaperdollListener
{
	Inventory _inv;

	public ItemPassiveSkillsListener(Inventory inv)
	{
		_inv = inv;
	}

	public void notifyUnequipped(int slot, L2ItemInstance item)
	{
		L2Player player;

		if(_inv.getOwner().isPlayer)
			player = (L2Player) _inv.getOwner();
		else
			return;

		L2Skill passiveSkill = null;
		L2Skill enchant4Skill = null;

		L2Item it = item.getItem();

		if(it instanceof L2Weapon)
		{
			passiveSkill = it.getSkill();
			enchant4Skill = ((L2Weapon) it).getEnchant4Skill();
		}
		else if(it instanceof L2Armor)
			passiveSkill = it.getSkill();

		if(passiveSkill != null)
			player.removeSkill(passiveSkill, false);
		if(enchant4Skill != null)
			player.removeSkill(enchant4Skill, false);
	}

	public void notifyEquipped(int slot, L2ItemInstance item)
	{
		L2Player player;

		if(_inv.getOwner().isPlayer)
			player = (L2Player) _inv.getOwner();
		else
			return;

		L2Skill passiveSkill = null;
		L2Skill enchant4Skill = null;

		L2Item it = item.getItem();

		if(it instanceof L2Weapon)
		{
			passiveSkill = it.getSkill();

			if(item.getEnchantLevel() >= 4)
				enchant4Skill = ((L2Weapon) it).getEnchant4Skill();
		}
		else if(it instanceof L2Armor)
			passiveSkill = it.getSkill();

		if(passiveSkill != null)
			player.addSkill(passiveSkill, false);
		if(enchant4Skill != null)
			player.addSkill(enchant4Skill, false);
	}
}