package L2jFT.game.model.quest;

import javolution.util.FastList;
import L2jFT.game.ThreadPoolManager;
import L2jFT.game.model.L2Player;

import java.util.List;

public class QuestStateManager
{
	public class ScheduleTimerTask implements Runnable
	{
		public void run()
		{
			try
			{
				cleanUp();
				ThreadPoolManager.getInstance().scheduleGeneral(new ScheduleTimerTask(), 60000);
			}
			catch(Throwable t)
			{}
		}
	}

	private static QuestStateManager _Instance;

	public static final QuestStateManager getInstance()
	{
		if(_Instance == null)
			_Instance = new QuestStateManager();
		return _Instance;
	}

	private List<QuestState> _QuestStates = new FastList<QuestState>();

	public QuestStateManager()
	{
		ThreadPoolManager.getInstance().scheduleGeneral(new ScheduleTimerTask(), 60000);
	}

	/**
	 * Add QuestState for the specified player instance
	 */
	public void addQuestState(Quest quest, L2Player player, State state)
	{
		QuestState qs = getQuestState(player);
		if(qs == null)
			qs = new QuestState(quest, player, state);
	}

	/**
	 * Remove all QuestState for all player instance that does not exist
	 */
	public void cleanUp()
	{
		for(int i = getQuestStates().size() - 1; i >= 0; i--)
			if(getQuestStates().get(i).getPlayer() == null)
			{
				removeQuestState(getQuestStates().get(i));
				getQuestStates().remove(i);
			}
	}

	/**
	 * Return QuestState for specified player instance
	 */
	public QuestState getQuestState(L2Player player)
	{
		for(int i = 0; i < getQuestStates().size(); i++)
			if(getQuestStates().get(i).getPlayer() != null && getQuestStates().get(i).getPlayer().getObjectId() == player.getObjectId())
				return getQuestStates().get(i);

		return null;
	}

	/**
	 * Return all QuestState
	 */
	public List<QuestState> getQuestStates()
	{
		if(_QuestStates == null)
			_QuestStates = new FastList<QuestState>();
		return _QuestStates;
	}

	/**
	 * Remove QuestState instance
	 */
	// TODO что за бред?!!
	private void removeQuestState(@SuppressWarnings("unused")
	QuestState qs)
	{
		qs = null;
	}
}
