package L2jFT.game.network.clientpackets;

import L2jFT.game.ThreadPoolManager;
import L2jFT.game.ai.CtrlIntention;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2World;
import L2jFT.game.network.serverpackets.UserInfo;
import L2jFT.util.Util;

/**
 * Appearing Packet Handler<p>
 * <p>
 * 0000: 30 <p>
 * <p>
 *
 * @version $Revision: 1.3.4.4 $ $Date: 2005/03/29 23:15:33 $
 */
public class Appearing extends L2GameClientPacket
{
	private static String _C__30_APPEARING = "[C] 30 Appearing";

	@Override
	public void readImpl()
	{}

	@Override
	public void runImpl()
	{
		final L2Player activeChar = getClient().getActiveChar();

		if(activeChar == null)
			return;

		if(activeChar.inObserverMode())
		{
			activeChar.appearObserverMode();
			return;
		}

		if(!activeChar.isTeleporting() && L2World.getAllPlayers().contains(activeChar))
			Util.handleIllegalPlayerAction(activeChar, "Packet Hack: hide", "Appearing[44]", 1);

		if(activeChar.isVisible())
			activeChar.decayMe();

		// 15 секунд после телепорта на персонажа не агрятся мобы
		activeChar.setNonAggroTime(System.currentTimeMillis() + 15000);

		// Персонаж появляется только после полной прогрузки
		ThreadPoolManager.getInstance().scheduleGeneral(new Runnable(){
			public void run()
			{
				if(activeChar.isTeleporting())
					activeChar.onTeleported();
				else
					activeChar.spawnMe(activeChar.getX(), activeChar.getY(), activeChar.getZ());

				sendPacket(new UserInfo(activeChar));
				activeChar.getAI().setIntention(CtrlIntention.AI_INTENTION_IDLE, null, null);
			}
		}, 2000);

	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__30_APPEARING;
	}
}
