package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2World;
import L2jFT.game.model.instances.L2ItemInstance;

@SuppressWarnings( { "nls", "unqualified-field-access", "boxing", "unused" })
public class AttackRequest extends L2GameClientPacket
{
	// cddddc
	private int _objectId;
	private int _originX;
	private int _originY;
	private int _originZ;
	private int _attackId;

	private static String _C__0A_ATTACKREQUEST = "[C] 0A AttackRequest";

	@Override
	public void readImpl()
	{
		_objectId = readD();
		_originX = readD();
		_originY = readD();
		_originZ = readD();
		_attackId = readC(); // 0 for simple click   1 for shift-click
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		if(System.currentTimeMillis() - activeChar.getLastPacket() < 100)
		{
			activeChar.sendActionFailed();
			return;
		}

		activeChar.setLastPacket();

		if(activeChar.isOutOfControl())
		{
			activeChar.sendActionFailed();
			return;
		}

		if(!activeChar.getPlayerAccess().CanAttack)
		{
			activeChar.sendActionFailed();
			return;
		}

		L2Object target = activeChar.getVisibleObject(_objectId);

		if(target == null)
		{
			// Для провалившихся предметов, чтобы можно было все равно поднять
			target = L2World.findObject(_objectId);
			if(target == null || !(target instanceof L2ItemInstance))
			{
				activeChar.sendActionFailed();
				return;
			}
		}

		if(activeChar.getTarget() != target)
		{
			target.onAction(activeChar);
			return;
		}

		//noinspection ConstantConditions
		if(target.isPlayer && (activeChar.isInBoat() || ((L2Player) target).isInBoat()))
		{
			activeChar.sendActionFailed();
			return;
		}

		if(target.getObjectId() != activeChar.getObjectId() && activeChar.getPrivateStoreType() == L2Player.STORE_PRIVATE_NONE && activeChar.getTransactionRequester() == null)
			target.onForcedAttack(activeChar);
	}

	@Override
	public String getType()
	{
		return _C__0A_ATTACKREQUEST;
	}
}