package L2jFT.game.network.clientpackets;

import L2jFT.Config;
import L2jFT.game.LoginServerThread;
import L2jFT.game.LoginServerThread.SessionKey;
import L2jFT.game.network.L2GameClient;

/**
 * This class ...
 *
 * @version $Revision: 1.9.2.3.2.4 $ $Date: 2005/03/27 15:29:30 $
 */
public class AuthLogin extends L2GameClientPacket
{
	private static String _C__08_AUTHLOGIN = "[C] 08 AuthLogin";

	// loginName + keys must match what the loginserver used.  
	private String _loginName;
	private int _playKey1;
	private int _playKey2;
	private int _loginKey1;
	private int _loginKey2;

	/**
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_loginName = readS().toLowerCase();
		_playKey2 = readD();
		_playKey1 = readD();
		_loginKey1 = readD();
		_loginKey2 = readD();
		// ignore the rest
		while(_buf.hasRemaining())
			_buf.get();
	}

	@Override
	public void runImpl()
	{
		SessionKey key = new SessionKey(_loginKey1, _loginKey2, _playKey1, _playKey2);

		L2GameClient client = getClient();
		client.setLoginName(_loginName);
		if(Config.GG_CHECK)
			LoginServerThread.getInstance().sendGameGuardQuery(client);

		LoginServerThread.getInstance().addGameServerLogin(_loginName, client);
		LoginServerThread.getInstance().sendCheckSessionKey(_loginName, key);
		client.setChecking(true);
		while(client.isChecking())
			try
			{
				Object lock = new Object();
				synchronized (lock)
				{
					lock.wait(100);
				}
			}
			catch(InterruptedException e)
			{
				e.printStackTrace();
			}
		if(Config.CHECK_SESSIONKEY && !client.isPassed())
		{
			_log.info("Cheater!!! Character Hack!!! IP:" + client.getIpAddr() + " Login:" + client.getLoginName());
			LoginServerThread.getInstance().removeAccount(_loginName);
			client.closeNow(false);
			return;
		}
		LoginServerThread.getInstance().addWaitingClientAndSendRequest(_loginName, client, key);
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__08_AUTHLOGIN;
	}
}
