package L2jFT.game.network.clientpackets;

import java.awt.Point;

import L2jFT.game.ai.CtrlEvent;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.PartyMemberPosition;
import L2jFT.util.CharPosition;

public class CannotMoveAnymore extends L2GameClientPacket
{
	private static String _C__36_STOPMOVE = "[C] 36 CannotMoveAnymore";

	private int _x;
	private int _y;
	private int _z;
	private int _heading;

	/**
	 * packet type id 0x36
	 *
	 * sample
	 *
	 * 36
	 * a8 4f 02 00 // x
	 * 17 85 01 00 // y
	 * a7 00 00 00 // z
	 * 98 90 00 00 // heading?
	 *
	 * format:		cdddd
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_x = readD();
		_y = readD();
		_z = readD();
		_heading = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();

		if(activeChar == null)
			return;

		activeChar.getAI().notifyEvent(CtrlEvent.EVT_ARRIVED_BLOCKED, new CharPosition(_x, _y, _z, _heading), null);

		if(activeChar.getParty() != null)
		{
			Point position = activeChar.getLastPartyPositionSent();
			if(activeChar.getDistance(position.x, position.y) > 500)
			{
				activeChar.getParty().broadcastToPartyMembers(activeChar, new PartyMemberPosition(activeChar));
				position.move(activeChar.getX(), activeChar.getY());
			}
		}
	}

	@Override
	public String getType()
	{
		return _C__36_STOPMOVE;
	}
}