package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.StopMoveInVehicle;
import L2jFT.util.Location;

/**
 * @author Maktakien
 *
 */
public class CannotMoveAnymoreInVehicle extends L2GameClientPacket
{
	private int _x;
	private int _y;
	private int _z;
	private int _heading;
	private int _boatid;

	/**
	 * @param buf
	 * @param client
	 */
	@Override
	public void readImpl()
	{
		_boatid = readD();
		_x = readD();
		_y = readD();
		_z = readD();
		_heading = readD();

	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		if(activeChar.isInBoat())
			if(activeChar.getBoat().getObjectId() == _boatid)
			{
				activeChar.setInBoatPosition(new Location(_x, _y, _z));
				activeChar.setHeading(_heading);
				StopMoveInVehicle msg = new StopMoveInVehicle(activeChar, _boatid);
				activeChar.broadcastPacket(msg);
			}
	}

	@Override
	public String getType()
	{
		return "[C] 5D CannotMoveAnymoreInVehicle";
	}

}
