package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Player;

/**
 * This class ...
 *
 * @version $Revision: 1.1.4.3 $ $Date: 2005/03/27 15:29:30 $
 */
public class ChangeWaitType2 extends L2GameClientPacket
{
	private static String _C__1D_CHANGEWAITTYPE2 = "[C] 1D ChangeWaitType2";

	private boolean _typeStand;

	/**
	 * packet type id 0x1d
	 *
	 * sample
	 *
	 * 1d
	 * 01 00 00 00 // type (0 = sit, 1 = stand)
	 *
	 * format:		cd
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_typeStand = readD() == 1;
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		if(_typeStand)
			activeChar.standUp();
		else
			activeChar.sitDown();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__1D_CHANGEWAITTYPE2;
	}
}
