package L2jFT.game.network.clientpackets;

import L2jFT.Config;
import L2jFT.database.mysql;
import L2jFT.game.network.serverpackets.CharDeleteFail;
import L2jFT.game.network.serverpackets.CharDeleteOk;
import L2jFT.game.network.serverpackets.CharSelectInfo;

import java.util.logging.Level;
import java.util.logging.Logger;

public class CharacterDelete extends L2GameClientPacket
{
	private static String _C__0C_CHARACTERDELETE = "[C] 0C CharacterDelete";
	private static Logger _log = Logger.getLogger(CharacterDelete.class.getName());

	// cd
	private int _charSlot;

	@Override
	public void readImpl()
	{
		_charSlot = readD();
	}

	@Override
	public void runImpl()
	{
		if(Config.DEBUG)
			_log.fine("deleting slot:" + _charSlot);

		int clan = clanStatus();
		if(clan > 0)
		{
			if(clan == 2)
				sendPacket(new CharDeleteFail(CharDeleteFail.REASON_CLAN_LEADERS_MAY_NOT_BE_DELETED));
			else if(clan == 1)
				sendPacket(new CharDeleteFail(CharDeleteFail.REASON_YOU_MAY_NOT_DELETE_CLAN_MEMBER));
			return;
		}

		try
		{
			if(Config.DELETE_DAYS == 0)
				getClient().deleteChar(_charSlot);
			else
				getClient().markToDeleteChar(_charSlot);
		}
		catch(Exception e)
		{
			_log.log(Level.SEVERE, "Error:", e);
		}

		sendPacket(new CharDeleteOk());

		CharSelectInfo cl = new CharSelectInfo(getClient().getLoginName(), getClient().getSessionId().playOkID1);
		sendPacket(cl);
		getClient().setCharSelection(cl.getCharInfo());
	}

	private int clanStatus()
	{
		int obj = getClient().getObjectIdForSlot(_charSlot);
		if(obj == -1)
			return 0;
		if(mysql.simple_get_int("clanid", "characters", "obj_Id=" + obj) > 0)
		{
			if(mysql.simple_get_int("leader_id", "clan_data", "leader_id=" + obj) > 0)
				return 2;
			return 1;
		}
		return 0;
	}

	@Override
	public String getType()
	{
		return _C__0C_CHARACTERDELETE;
	}
}
