package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.network.L2GameClient;
import L2jFT.game.network.L2GameClient.GameClientState;
import L2jFT.game.network.serverpackets.CharSelected;
import L2jFT.util.AutoBan;

public class CharacterSelected extends L2GameClientPacket
{
	private static String _C__0D_CHARACTERSELECTED = "[C] 0D CharacterSelected";
	private int _charSlot;

	/**
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_charSlot = readD();
	}

	@Override
	public void runImpl()
	{
		L2GameClient client = getClient();

		if(getClient().getActiveChar() != null)
			return;

		L2Player activeChar = client.loadCharFromDisk(_charSlot);
		if(activeChar == null)
			return;

		if(AutoBan.isBanned(activeChar.getObjectId()))
			return;

		if(activeChar.getAccessLevel() < 0)
			activeChar.setAccessLevel(0);

		getClient().setState(GameClientState.IN_GAME);

		sendPacket(new CharSelected(activeChar, client.getSessionId().playOkID1));
	}

	@Override
	public String getType()
	{
		return _C__0D_CHARACTERSELECTED;
	}
}