package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.StopRotation;

/**
 * This class ...
 *
 * @version $Revision: 1.1.4.3 $ $Date: 2005/03/27 15:29:30 $
 */
public class FinishRotating extends L2GameClientPacket
{
	private static String _C__4B_FINISHROTATING = "[C] 4B FinishRotating";

	private int _degree;
	@SuppressWarnings("unused")
	private int _unknown;

	/**
	 * packet type id 0x4a
	 *
	 * sample
	 *
	 * 4b
	 * d // unknown
	 * d // unknown
	 *
	 * format:		cdd
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_degree = readD();
		_unknown = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		activeChar.broadcastPacket(new StopRotation(activeChar, _degree));
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__4B_FINISHROTATING;
	}
}
