package L2jFT.game.network.clientpackets;

import L2jFT.Config;
import L2jFT.game.network.L2GameClient;
import L2jFT.game.network.serverpackets.L2GameServerPacket;

import java.util.logging.Logger;

import com.l2jserver.mmocore.network.ReceivablePacket;

/**
 * Packets received by the game server from clients
 * @author KenM
 */
public abstract class L2GameClientPacket extends ReceivablePacket<L2GameClient>
{
	protected static Logger _log = Logger.getLogger(L2GameClientPacket.class.getName());

	@Override
	protected boolean read()
	{
		//System.out.println(this.getType());
		try
		{
			readImpl();
			return true;
		}
		catch(Throwable t)
		{
			_log.severe("Client: " + getClient().toString() + "from IP: " + getClient().getIpAddr() + "- Failed reading: " + getType() + "(" + getClass().getName() + ") - L2J Server Version: " + Config.SERVER_VERSION);
			t.printStackTrace();
		}
		return false;
	}

	protected abstract void readImpl();

	@Override
	public void run()
	{
		try
		{
			runImpl();
		}
		catch(Throwable t)
		{
			_log.severe("Client: " + getClient().toString() + "from IP: " + getClient().getIpAddr() + " - Failed running: " + getType() + " - L2J Server Version: " + Config.SERVER_VERSION);
			t.printStackTrace();
		}
	}

	protected abstract void runImpl();

	protected void sendPacket(L2GameServerPacket gsp)
	{
		getClient().sendPacket(gsp);
	}

	/**
	 * @return A String with this packet name for debuging purposes
	 */
	public abstract String getType();
}
