package L2jFT.game.network.clientpackets;

import java.awt.Point;
import java.util.logging.Logger;

import L2jFT.Config;
import L2jFT.Config.L2WalkerAllowed;
import L2jFT.game.LoginServerThread;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.L2GameClient;
import L2jFT.game.network.serverpackets.PartyMemberPosition;
import L2jFT.util.Log;

public class MoveBackwardToLocation extends L2GameClientPacket
{
	private static Logger _log = Logger.getLogger(MoveBackwardToLocation.class.getName());
	// cdddddd
	private int _targetX;
	private int _targetY;
	private int _targetZ;
	@SuppressWarnings("unused")
	private int _originX;
	@SuppressWarnings("unused")
	private int _originY;
	@SuppressWarnings("unused")
	private int _originZ;
	private int _moveMovement;

	private static String _C__01_MOVEBACKWARDTOLOC = "[C] 01 MoveBackwardToLoc";

	/**
	 * packet type id 0x01
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_targetX = readD();
		_targetY = readD();
		_targetZ = readD();
		_originX = readD();
		_originY = readD();
		_originZ = readD();
		L2Player activeChar = getClient().getActiveChar();
		L2GameClient client = getClient();
		if(activeChar == null)
			return;

		if(_buf.hasRemaining())
			_moveMovement = readD();
		else if(Config.allowL2Walker(activeChar))
		{
			activeChar.setIsBot(2);
			_moveMovement = 1;
			if(Config.ALLOW_L2WALKER_CLIENT == L2WalkerAllowed.Peace)
				activeChar.startBotCheck();
		}
		else
		{
			_log.warning("Incompatible client found: L2Walker? " + client.getLoginName() + "/" + client.getIpAddr());

			if(Config.L2WALKER_PUNISHMENT != 0)
			{
				Log.LogChar(activeChar, Log.L2WalkerFound, client.getLoginName());
				if(Config.L2WALKER_PUNISHMENT == 2)
				{
					LoginServerThread.getInstance().sendAccessLevel(client.getLoginName(), -66, "Walker Autoban", -1);
					activeChar.setAccessLevel(-66);
				}
				activeChar.logout(false, false);
			}
		}
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();

		if(activeChar == null)
			return;

		if(System.currentTimeMillis() - activeChar.getLastPacket() < 100)
		{
			activeChar.sendActionFailed();
			return;
		}

		activeChar.setLastPacket();

		if(activeChar.inObserverMode())
		{
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isOutOfControl())
		{
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isInBoat())
			activeChar.setInBoat(false);

		if(activeChar.getTeleMode() > 0)
		{
			if(activeChar.getTeleMode() == 1)
				activeChar.setTeleMode(0);
			activeChar.sendActionFailed();
			activeChar.teleToLocation(_targetX, _targetY, _targetZ);
			return;
		}

		if(_moveMovement == 0 && !Config.GEODATA)
		{
			activeChar.sendActionFailed();
			return;
		}

		// Can't move if character is confused, or trying to move a huge distance
		if(activeChar.isOutOfControl())
		{
			activeChar.sendActionFailed();
			return;
		}

		activeChar.moveToLocation(_targetX, _targetY, _targetZ, 0, (_moveMovement != 0));

		if(activeChar.getParty() != null)
		{
			Point position = activeChar.getLastPartyPositionSent();
			if(activeChar.getDistance(position.x, position.y) > 500)
			{
				activeChar.getParty().broadcastToPartyMembers(activeChar, new PartyMemberPosition(activeChar));
				position.move(activeChar.getX(), activeChar.getY());
			}
		}
	}

	@Override
	public String getType()
	{
		return _C__01_MOVEBACKWARDTOLOC;
	}
}