package L2jFT.game.network.clientpackets;

import L2jFT.Config;
import L2jFT.game.cache.Msg;
import L2jFT.game.network.serverpackets.KeyPacket;

import java.util.logging.Logger;

/**
 * This class ...
 *
 * @version $Revision: 1.5.2.8.2.8 $ $Date: 2005/04/02 10:43:04 $
 * Пример пакета:
 * 00 EA 02 00 00 09 07 54 56 03 09 0B 01 07 02 54 54 56 07 00 02 55 56 00 51 00 53 57 04 07 55 08 54 01 07 01 53 00 56 55 56 01 06 05 04 51 03 08 51 08 51 56 04 54 06 55 08 02 09 51 56 01 53 06 55 04 53 00 56 56 53 01 09 02 09 01 51 54 51 09 55 56 09 03 04 07 05 55 04 06 55 04 06 09 04 51 01 08 08 06 05 52 06 04 01 07 54 03 06 52 55 06 55 55 51 01 02 04 54 03 55 54 01 57 51 55 05 52 05 54 07 51 51 55 07 02 53 53 00 52 05 52 07 01 54 00 03 05 05 08 06 05 05 06 03 00 0D 08 01 07 09 03 51 03 07 53 09 51 06 07 54 0A 50 56 02 52 04 05 55 51 02 53 00 08 54 04 52 56 06 02 09 00 08 03 53 56 01 05 00 55 06 08 56 04 0D 06 07 52 06 07 04 0A 06 01 04 54 04 00 05 02 04 54 00 09 52 53 05 04 01 04 05 05 01 52 51 52 0D 06 51 08 09 54 53 00 0D 01 02 03 54 53 01 05 03 08 56 54 07 02 54 0B 06 DC 4F 61 4F
 * где EA 02 00 00 = 746
 */
public class ProtocolVersion extends L2GameClientPacket
{
	private static String _C__00_PROTOCOLVERSION = "[C] 00 ProtocolVersion";
	static Logger _log = Logger.getLogger(ProtocolVersion.class.getName());

	private long _version;

	/**
	 * packet type id 0x00
	 * format:	cd
	 *
	 * @param rawPacket
	 */

	@Override
	public void readImpl()
	{
		try
		{
			_version = readD();
		}
		catch(Exception e)
		{
			// Проверки рейтинга типа l2top.in.ua
			// TODO: Разобратся какого хрена оно вообще пускает эго к даному этапу
			getClient().closeNow(true);
		}
		// ignore the rest
		while(_buf.hasRemaining())
			_buf.get();
	}

	@Override
	public void runImpl()
	{
		// this packet is never encrypted
		if(_version == -2)
		{
			if(Config.DEBUG)
				_log.info("Ping received");
			// this is just a ping attempt from the new C2 client
			getClient().closeNow(false);
			return;
		}
		if(_version < Config.MIN_PROTOCOL_REVISION)
		{
			_log.info("Client Protocol Revision:" + _version + " Account:" + getClient().getLoginName() + " from " + getClient().getIpAddr() + " is too low. only " + Config.MIN_PROTOCOL_REVISION + " and " + Config.MAX_PROTOCOL_REVISION + " are supported. closing connection.");
			getClient().sendPacket(Msg.PROTOCOL_VERSION_IS_DIFFERENT_PLEASE_QUIT_THE_PROGRAM);
			getClient().closeNow(false);
			return;
		}
		if(_version > Config.MAX_PROTOCOL_REVISION)
		{
			_log.info("Client Protocol Revision:" + _version + " Account:" + getClient().getLoginName() + " from " + getClient().getIpAddr() + " is too high. only " + Config.MIN_PROTOCOL_REVISION + " and " + Config.MAX_PROTOCOL_REVISION + " are supported. closing connection.");
			getClient().sendPacket(Msg.PROTOCOL_VERSION_IS_DIFFERENT_PLEASE_QUIT_THE_PROGRAM);
			getClient().closeNow(false);
			return;
		}
		getClient().setRevision((int) _version);
		if(Config.DEBUG)
			_log.fine("Client Protocol Revision is ok:" + _version);

		KeyPacket pk = new KeyPacket(getClient().enableCrypt());
		getClient().sendPacket(pk);
	}

	@Override
	public String getType()
	{
		return _C__00_PROTOCOLVERSION;
	}
}
