package L2jFT.game.network.clientpackets;

import L2jFT.Config;
import L2jFT.game.cache.CrestCache;
import L2jFT.game.network.serverpackets.AllyCrest;

import java.util.logging.Logger;

public class RequestAllyCrest extends L2GameClientPacket
{
	private static String _C__88_REQUESTALLYCREST = "[C] 88 RequestAllyCrest";
	private static Logger _log = Logger.getLogger(RequestAllyCrest.class.getName());

	private int _crestId;

	@Override
	public void readImpl()
	{
		_crestId = readD();
	}

	@Override
	public void runImpl()
	{
		if(_crestId == 0)
			return;
		if(Config.DEBUG)
			_log.fine("allycrestid " + _crestId + " requested");
		byte[] data = CrestCache.getAllyCrest(_crestId);
		if(data != null)
		{
			AllyCrest ac = new AllyCrest(_crestId, data);
			sendPacket(ac);
		}
		else if(Config.DEBUG)
			_log.fine("allycrest is missing:" + _crestId);
	}

	@Override
	public String getType()
	{
		return _C__88_REQUESTALLYCREST;
	}
}