package L2jFT.game.network.clientpackets;

import L2jFT.database.DatabaseUtils;
import L2jFT.database.FiltredPreparedStatement;
import L2jFT.database.L2DatabaseFactory;
import L2jFT.database.ThreadConnection;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.Friend;
import L2jFT.game.network.serverpackets.SystemMessage;

import java.util.logging.Logger;

/**
 *	sample
 *	5F 
 *	01 00 00 00
 *
 *	format	cdd
 *
 *
 * @version $Revision: 1.7.4.2 $ $Date: 2005/03/27 15:29:30 $
 */
public class RequestAnswerFriendInvite extends L2GameClientPacket
{
	private static String _C__5F_REQUESTANSWERFRIENDINVITE = "[C] 5F RequestAnswerFriendInvite";
	private static Logger _log = Logger.getLogger(RequestAnswerFriendInvite.class.getName());

	private int _response;

	@Override
	public void readImpl()
	{
		if(_buf.hasRemaining())
			_response = readD();
		else
			_response = 0;
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		L2Player requestor = activeChar.getTransactionRequester();
		if(requestor == null)
			return;

		if(_response == 1)
		{
			ThreadConnection con = null;
			FiltredPreparedStatement statement = null;
			try
			{
				con = L2DatabaseFactory.getInstance().getConnection();
				statement = con.prepareStatement("insert into character_friends (char_id,friend_id,friend_name) values(?,?,?)");
				statement.setInt(1, requestor.getObjectId());
				statement.setInt(2, activeChar.getObjectId());
				statement.setString(3, activeChar.getName());
				statement.execute();
				DatabaseUtils.closeStatement(statement);

				statement = con.prepareStatement("insert into character_friends (char_id,friend_id,friend_name) values(?,?,?)");
				statement.setInt(1, activeChar.getObjectId());
				statement.setInt(2, requestor.getObjectId());
				statement.setString(3, requestor.getName());
				statement.execute();

				requestor.sendPacket(new SystemMessage(SystemMessage.YOU_HAVE_SUCCEEDED_IN_INVITING_A_FRIEND));
				// Player added to your friendlist
				requestor.sendPacket(new SystemMessage(SystemMessage.S1_HAS_BEEN_ADDED_TO_YOUR_FRIEND_LIST).addString(activeChar.getName()));
				// has joined as friend.
				activeChar.sendPacket(new SystemMessage(SystemMessage.S1_HAS_JOINED_AS_A_FRIEND).addString(requestor.getName()));

				//Обновисть список друзей. Вообще-то здесь должен слатся пакет 0xfb Friend, а не 0xfa FriendList, но от греха подальше :)
				requestor.sendPacket(new Friend(activeChar, true));
				activeChar.sendPacket(new Friend(requestor, true));
			}
			catch(Exception e)
			{
				_log.warning("could not add friend objectid: " + e);
			}
			finally
			{
				DatabaseUtils.closeDatabaseCS(con, statement);
			}

		}
		else
			requestor.sendPacket(new SystemMessage(SystemMessage.YOU_HAVE_FAILED_TO_INVITE_A_FRIEND));

		activeChar.setTransactionRequester(null);
		requestor.setTransactionRequester(null);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__5F_REQUESTANSWERFRIENDINVITE;
	}
}
