package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Alliance;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.SystemMessage;

/**
 *  sample
 *  5F 
 *  01 00 00 00
 *
 *  format  cdd
 *
 *
 * @version $Revision: 1.7.4.2 $ $Date: 2005/03/27 15:29:30 $
 */
public class RequestAnswerJoinAlly extends L2GameClientPacket
{
	private static String _C__83_REQUESTANSWERJOINALLY = "[C] 83 RequestAnswerJoinAlly";
	//private static Logger _log = Logger.getLogger(RequestAnswerJoinAlly.class.getName());

	private int _response;

	@Override
	public void readImpl()
	{
		_response = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar != null)
		{
			L2Player requestor = activeChar.getTransactionRequester();
			if(requestor == null || requestor.getAlliance() == null)
				return;

			if(_response == 1)
			{
				L2Alliance ally = requestor.getAlliance();
				activeChar.sendPacket(new SystemMessage(SystemMessage.YOU_HAVE_ACCEPTED_THE_ALLIANCE));
				activeChar.getClan().setAllyId(requestor.getAllyId());
				activeChar.getClan().updateClanInDB();
				activeChar.getClan().broadcastClanStatus();
				ally.addAllyMember(activeChar.getClan(), true);
			}
			else
				requestor.sendPacket(new SystemMessage(SystemMessage.YOU_HAVE_FAILED_TO_INVITE_A_CLAN_INTO_THE_ALLIANCE));

			activeChar.setTransactionRequester(null);
			requestor.setTransactionRequester(null);
		}
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__83_REQUESTANSWERJOINALLY;
	}
}
