package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.network.serverpackets.AquireSkillInfo;
import L2jFT.game.tables.SkillTable;

public class RequestAquireSkillInfo extends L2GameClientPacket
{
	private static String _C__6B_REQUESTACQUIRESKILLINFO = "[C] 6B RequestAquireSkillInfo";
	private short _id;
	private byte _level;

	@SuppressWarnings("unused")
	private int _skillType;

	@Override
	public void readImpl()
	{
		_id = (short) readD();
		_level = (byte) readD();
		_skillType = readD();// normal(0) learn or fisherman(1) clan(2)
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null || SkillTable.getInstance().getInfo(_id, _level) == null)
			return;
		L2NpcInstance trainer = activeChar.getLastNpc();
		if((trainer == null || activeChar.getDistance(trainer.getX(), trainer.getY()) > L2Character.INTERACTION_DISTANCE) && !activeChar.isGM())
			return;
		sendPacket(new AquireSkillInfo(_id, _level, activeChar.getClassId()));
	}

	@Override
	public String getType()
	{
		return _C__6B_REQUESTACQUIRESKILLINFO;
	}
}