package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Summon;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.model.instances.L2PetInstance;
import L2jFT.game.network.serverpackets.InventoryUpdate;
import L2jFT.game.network.serverpackets.SystemMessage;

import java.nio.BufferUnderflowException;
import java.util.logging.Logger;

/**
 * This class ...
 *
 * @version $Revision: 1.3.4.4 $ $Date: 2005/04/06 16:13:48 $
 */
public class RequestChangePetName extends L2GameClientPacket
{
	private static String REQUESTCHANGEPETNAME__C__89 = "[C] 89 RequestChangePetName";
	private static Logger _log = Logger.getLogger(RequestChangePetName.class.getName());

	private String _name;

	@Override
	public void readImpl()
	{
		try
		{
			_name = readS();
		}
		catch(BufferUnderflowException e)
		{
			_log.warning("Packet not completed. Maybe cheater. IP:" + getClient().getIpAddr());
		}
	}

	@Override
	public void runImpl()
	{
		L2Summon pet = getClient().getActiveChar().getPet();
		if(pet != null && pet.getName() == null)
		{
			if(_name.length() > 8)
			{
				sendPacket(new SystemMessage(SystemMessage.YOUR_PETS_NAME_CAN_BE_UP_TO_8_CHARACTERS));
				return;
			}
			pet.setName(_name);
			pet.broadcastPetInfo();

			// Флаг, говорящий, установлено ли имя пета в инфе ошейника                                        
			if(pet instanceof L2PetInstance && pet.getControlItemId() != 0)
			{
				L2ItemInstance controlItem = pet.getOwner().getInventory().getItemByObjectId(pet.getControlItemId());
				if(controlItem != null)
				{
					controlItem.setCustomType2(1);
					controlItem.setPriceToSell(0); // Костыль, иначе CustomType2 = 1 не пишется в базу 
					controlItem.updateDatabase();
					getClient().getActiveChar().sendPacket(new InventoryUpdate().addModifiedItem(controlItem));
				}
			}

		}
	}

	@Override
	public String getType()
	{
		return REQUESTCHANGEPETNAME__C__89;
	}
}
