package L2jFT.game.network.clientpackets;

import L2jFT.game.instancemanager.CastleManager;
import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.entity.Castle;
import L2jFT.game.network.serverpackets.SiegeDefenderList;
import L2jFT.game.tables.ClanTable;

/**
 * This class ...
 *
 * @version $Revision: 1.3.4.2 $ $Date: 2005/03/27 15:29:30 $
 */
public class RequestConfirmSiegeWaitingList extends L2GameClientPacket
{

	private static String _C__a5_RequestConfirmSiegeWaitingList = "[C] a5 RequestConfirmSiegeWaitingList";
	//private static Logger _log = Logger.getLogger(RequestConfirmSiegeWaitingList.class.getName());

	private int _Approved;
	private int _CastleId;
	private int _ClanId;

	@Override
	public void readImpl()
	{
		_CastleId = readD();
		_ClanId = readD();
		_Approved = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		// Check if the player has a clan
		if(activeChar.getClan() == null)
			return;

		Castle castle = CastleManager.getInstance().getCastleByIndex(_CastleId);
		if(castle == null)
			return;

		// Check if leader of the clan who owns the castle?
		if(castle.getOwnerId() != activeChar.getClanId() || !activeChar.isClanLeader())
			return;

		L2Clan clan = ClanTable.getInstance().getClan(_ClanId);
		if(clan == null)
			return;

		if(!castle.getSiege().getIsRegistrationOver())
			if(_Approved == 1)
				if(castle.getSiege().checkIsDefenderWaiting(clan))
					castle.getSiege().approveSiegeDefenderClan(_ClanId);
				else
					return;
			else if(castle.getSiege().checkIsDefenderWaiting(clan) || castle.getSiege().checkIsDefender(clan))
				castle.getSiege().getDatabase().removeSiegeClan(_ClanId);

		//Update the defender list
		activeChar.sendPacket(new SiegeDefenderList(castle));

	}

	@Override
	public String getType()
	{
		return _C__a5_RequestConfirmSiegeWaitingList;
	}
}
