package L2jFT.game.network.clientpackets;

import javolution.util.FastList;
import L2jFT.game.instancemanager.CursedWeaponsManager;
import L2jFT.game.model.L2Character;
import L2jFT.game.network.serverpackets.ExCursedWeaponList;

import java.util.List;

/**
 * Format: (ch)
 * @author  -Wooden-
 */
public class RequestCursedWeaponList extends L2GameClientPacket
{
	private static String _C__D0_22_REQUESTCURSEDWEAPONLIST = "[C] D0:22 RequestCursedWeaponList";

	@Override
	public void readImpl()
	{}

	/**
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#runImpl()
	 */
	@Override
	public void runImpl()
	{
		L2Character activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		//send a ExCursedWeaponList :p
		List<Integer> list = new FastList<Integer>();
		for(int id : CursedWeaponsManager.getInstance().getCursedWeaponsIds())
			list.add(id);

		activeChar.sendPacket(new ExCursedWeaponList(list));
	}

	/**
	 * @see L2jFT.game.BasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__D0_22_REQUESTCURSEDWEAPONLIST;
	}

}
