package L2jFT.game.network.clientpackets;

import javolution.util.FastList;
import L2jFT.game.instancemanager.CursedWeaponsManager;
import L2jFT.game.model.CursedWeapon;
import L2jFT.game.model.L2Character;
import L2jFT.game.network.serverpackets.ExCursedWeaponLocation;
import L2jFT.game.network.serverpackets.ExCursedWeaponLocation.CursedWeaponInfo;
import L2jFT.util.Location;

import java.util.List;

/**
 * Format: (ch)
 * @author  -Wooden-
 */
public class RequestCursedWeaponLocation extends L2GameClientPacket
{
	// private static Logger _log = Logger.getLogger(CursedWeaponsManager.class.getName());

	private static String _C__D0_23_REQUESTCURSEDWEAPONLOCATION = "[C] D0:23 RequestCursedWeaponLocation";

	@Override
	public void readImpl()
	{}

	/**
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#runImpl()
	 */
	@Override
	public void runImpl()
	{
		L2Character activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		List<CursedWeaponInfo> list = new FastList<CursedWeaponInfo>();
		for(CursedWeapon cw : CursedWeaponsManager.getInstance().getCursedWeapons())
		{
			Location pos = cw.getWorldPosition();

			if(pos != null)
				list.add(new CursedWeaponInfo(pos, cw.getItemId(), cw.isActivated() ? 1 : 0));
		}

		//send the ExCursedWeaponLocation
		activeChar.sendPacket(new ExCursedWeaponLocation(list));
	}

	/**
	 * @see L2jFT.game.BasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__D0_23_REQUESTCURSEDWEAPONLOCATION;
	}
}