package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Player;

public class RequestDeleteMacro extends L2GameClientPacket
{
	private int _id;

	private static String _C__C2_REQUESTDELETEMACRO = "[C] C2 RequestDeleteMacro";

	/**
	 * packet type id 0xc2
	 *
	 * sample
	 *
	 * c2
	 * d // macro id
	 *
	 * format:		cd
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_id = readD();
		//System.out.println("Delete macro id="+_id);
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		activeChar.deleteMacro(_id);
		activeChar.sendMessage("Delete macro id=" + _id);
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__C2_REQUESTDELETEMACRO;
	}
}