package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.SystemMessage;

public class RequestExMPCCAcceptJoin extends L2GameClientPacket
{
	private static String _C__D0_0E_REQUESTEXMPCCASKJOIN = "[C] D0:0E RequestExMPCCAcceptJoin";
	private int _response;

	/**
	 * @param buf
	 * @param client
	 */
	@Override
	public void readImpl()
	{
		_response = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player player = getClient().getActiveChar();

		if(player == null)
			return;

		L2Player requestor = player.getTransactionRequester();

		if(requestor == null)
			return;

		if(!requestor.isInParty() || !player.isInParty() || !requestor.getParty().isInCommandChannel() || player.getParty().isInCommandChannel())
		{
			requestor.sendPacket(new SystemMessage(SystemMessage.NO_USER_HAS_BEEN_INVITED_TO_THE_COMMAND_CHANNEL));
			return;
		}

		if(_response == 1 && player.isTeleporting())
		{
			player.sendPacket(new SystemMessage(SystemMessage.YOU_CANNOT_JOIN_A_COMMAND_CHANNEL_WHILE_TELEPORTING));
			requestor.sendPacket(new SystemMessage(SystemMessage.NO_USER_HAS_BEEN_INVITED_TO_THE_COMMAND_CHANNEL));
			return;
		}

		if(_response == 1)
			requestor.getParty().getCommandChannel().addParty(player.getParty());
		else
			requestor.sendPacket(new SystemMessage(SystemMessage.S1_HAS_DECLINED_THE_CHANNEL_INVITATION).addString(player.getName()));

		player.setTransactionRequester(null);
		requestor.setTransactionRequester(null);

		requestor.sendPacket(new SystemMessage(SystemMessage.SINCE_S1_DID_NOT_RESPOND_YOUR_CHANNEL_INVITATION_HAS_FAILED).addString(player.getName()));
	}

	@Override
	public String getType()
	{
		return _C__D0_0E_REQUESTEXMPCCASKJOIN;
	}
}