package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Player;

/**
 * @author SYS
 * @date 08/9/2007
 * Format: cdddddd
 * 
 * Пример пакета:
 * D0
 * 2F 00
 * E4 35 00 00 x
 * 62 D1 02 00 y
 * 22 F2 FF FF z
 * 90 05 00 00 skill id
 * 00 00 00 00 ctrlPressed
 * 00 shiftPressed
 */
public class RequestExMagicSkillUseGround extends L2GameClientPacket
{
	private static String _C__D0_2F_REQUESTSEXMAGICSKILLGROUND = "[C] D0:2F RequestExMagicSkillUseGround";

	private int _coords[] = { 0, 0, 0 };
	private int _skillId;
	private int _ctrlPressed;
	private int _shiftPressed;

	/**
	 * packet type id 0xd0
	 */
	@Override
	public void readImpl()
	{
		_coords[0] = readD();
		_coords[1] = readD();
		_coords[2] = readD();
		_skillId = readD();
		_ctrlPressed = readD();
		_shiftPressed = readC();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		System.out.println("[C] D0:2F RequestSkillCoords, x: " + _coords[0] + ", y: " + _coords[1] + ", z: " + _coords[2] + ", skillId:" + _skillId + ", Ctrl Pressed: " + (_shiftPressed == 0 ? "No" : "Yes") + ", Shift Pressed: " + (_ctrlPressed == 0 ? "No" : "Yes"));
	}

	@Override
	public String getType()
	{
		return _C__D0_2F_REQUESTSEXMAGICSKILLGROUND;
	}
}