package L2jFT.game.network.clientpackets;

import javolution.util.FastList;
import javolution.util.FastMap;
import L2jFT.game.instancemanager.RaidBossSpawnManager;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.ExGetBossRecord;
import L2jFT.game.network.serverpackets.ExGetBossRecord.BossRecordInfo;

import java.util.List;

/**
 * Format: (ch) d
 * @author  -Wooden-
 *
 */
public class RequestGetBossRecord extends L2GameClientPacket
{
	private static String _C__D0_18_REQUESTGETBOSSRECORD = "[C] D0:18 RequestGetBossRecord";
	@SuppressWarnings("unused")
	private int _bossID;

	/**
	 * @param buf
	 * @param client
	 */
	@Override
	public void readImpl()
	{
		_bossID = readD(); // always 0?
	}

	/**
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#runImpl()
	 */
	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		int totalPoints = 0;
		int ranking = 0;

		if(activeChar == null)
			return;

		List<BossRecordInfo> list = new FastList<BossRecordInfo>();
		FastMap<Integer, Integer> points = RaidBossSpawnManager.getInstance().getPointsByOwnerId(activeChar.getObjectId());
		if(points != null && !points.isEmpty())
			for(int bossId : points.keySet())
				switch(bossId)
				{
					case -1:
						ranking = points.get(bossId);
						break;
					case 0:
						totalPoints = points.get(bossId);
						break;
					default:
						list.add(new BossRecordInfo(bossId, points.get(bossId), 0));
				}

		activeChar.sendPacket(new ExGetBossRecord(ranking, totalPoints, list));
	}

	/**
	 * @see L2jFT.game.BasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__D0_18_REQUESTGETBOSSRECORD;
	}
}