package L2jFT.game.network.clientpackets;

import L2jFT.game.instancemanager.BoatManager;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2BoatInstance;
import L2jFT.game.network.serverpackets.GetOffVehicle;
import L2jFT.game.network.serverpackets.VehicleInfo;

/**
 * @author Maktakien
 *
 */
public class RequestGetOffVehicle extends L2GameClientPacket
{
	private int _id, _x, _y, _z;

	/**
	 * @param buf
	 * @param client
	 */
	@Override
	public void readImpl()
	{
		_id = readD();
		_x = readD();
		_y = readD();
		_z = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		L2BoatInstance boat = BoatManager.getInstance().GetBoat(_id);
		GetOffVehicle Gon = new GetOffVehicle(activeChar, boat, _x, _y, _z);
		activeChar.broadcastPacket(Gon);
		activeChar.sendPacket(new VehicleInfo(boat));
	}

	@Override
	public String getType()
	{
		return "[S] 5d GetOffVehicle";
	}
}