package L2jFT.game.network.clientpackets;

import L2jFT.game.instancemanager.BoatManager;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2BoatInstance;
import L2jFT.game.network.serverpackets.GetOnVehicle;
import L2jFT.util.Location;

/**
 * This class ...
 *
 * @version $Revision: 1.1.4.3 $ $Date: 2005/03/27 15:29:30 $
 */
public class RequestGetOnVehicle extends L2GameClientPacket
{
	private static String _C__5C_GETONVEHICLE = "[C] 5C GetOnVehicle";

	private int _id, _x, _y, _z;

	/**
	 * packet type id 0x4a
	 *
	 * sample
	 *
	 * 4b
	 * d // unknown
	 * d // unknown
	 *
	 * format:      cdd
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_id = readD();
		_x = readD();
		_y = readD();
		_z = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		L2BoatInstance boat = BoatManager.getInstance().GetBoat(_id);
		if(boat == null)
			return;
		GetOnVehicle Gon = new GetOnVehicle(activeChar, boat, _x, _y, _z);
		activeChar.setInBoatPosition(new Location(_x, _y, _z));
		activeChar.setXYZ(boat.getX(), boat.getY(), boat.getZ());
		activeChar.broadcastPacket(Gon);
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__5C_GETONVEHICLE;
	}
}
