package L2jFT.game.network.clientpackets;

import L2jFT.Config;
import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2ClanMember;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.util.Util;

import java.util.logging.Logger;

/**
 * This class ...
 *
 * @version $Revision: 1.3.2.1.2.4 $ $Date: 2005/03/27 15:29:30 $
 */
public class RequestGiveNickName extends L2GameClientPacket
{
	private static String _C__55_REQUESTGIVENICKNAME = "[C] 55 RequestGiveNickName";
	static Logger _log = Logger.getLogger(RequestGiveNickName.class.getName());

	private String _target;
	private String _title;

	@Override
	public void readImpl()
	{
		_target = readS();
		_title = readS();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		if(_title.length() > 16)
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.YOUR_TITLE_CANNOT_EXCEED_16_CHARACTERS_IN_LENGHT));
			return;
		}

		if(!Util.isMatchingRegexp(_title, Config.CLAN_TITLE_TEMPLATE))
		{
			activeChar.sendMessage("Incorrect title.");
			return;
		}

		// Дворяне могут устанавливать/менять себе title
		if(activeChar.isNoble() && _target.matches(activeChar.getName()))
		{
			activeChar.setTitle(_title);
			activeChar.sendPacket(new SystemMessage(SystemMessage.TITLE_HAS_CHANGED));
			activeChar.broadcastUserInfo();
			return;
		}
		// Can the player change/give a title?
		else if((activeChar.getClanPrivileges() & L2Clan.CP_CL_GIVE_TITLE) != L2Clan.CP_CL_GIVE_TITLE)
			return;

		if(activeChar.getClan().getLevel() < 3)
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.TITLE_ENDOWMENT_IS_ONLY_POSSIBLE_WHEN_CLANS_SKILL_LEVELS_ARE_ABOVE_3));
			return;
		}

		L2ClanMember member = activeChar.getClan().getClanMember(_target);
		if(member != null)
		{
			member.setTitle(_title);
			if(member.isOnline())
			{
				member.getPlayer().sendPacket(new SystemMessage(SystemMessage.TITLE_HAS_CHANGED));
				member.getPlayer().broadcastUserInfo();
			}
		}
		else
			activeChar.sendMessage("Target does not belong to your clan.", "Цель не состоит в Вашем клане");

	}

	@Override
	public String getType()
	{
		return _C__55_REQUESTGIVENICKNAME;
	}
}
