package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.HennaEquipList;
import L2jFT.game.tables.HennaTreeTable;

/**
 * RequestHennaList - 0xba
 *
 * @author Tempy
 */
public class RequestHennaList extends L2GameClientPacket
{
	private static String _C__BA_RequestHennaList = "[C] ba RequestHennaList";

	// This is just a trigger packet...
	@SuppressWarnings("unused")
	private int _unknown;

	/**
	 * packet type id 0xba
	 * format:		cd
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_unknown = readD(); // ??
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		activeChar.sendPacket(new HennaEquipList(activeChar, HennaTreeTable.getInstance().getAvailableHenna(activeChar.getClassId())));
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__BA_RequestHennaList;
	}
}