package L2jFT.game.network.clientpackets;

import L2jFT.game.instancemanager.CastleManager;
import L2jFT.game.instancemanager.ClanHallManager;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.entity.Castle;
import L2jFT.game.model.entity.ClanHall;
import L2jFT.game.network.serverpackets.SiegeAttackerList;
import L2jFT.extensions.scripts.Functions;

/**
 * This class ...
 *
 * @version $Revision: 1.3.4.2 $ $Date: 2005/03/27 15:29:30 $
 */
public class RequestJoinSiege extends L2GameClientPacket
{

	private static String _C__a4_RequestJoinSiege = "[C] a4 RequestJoinSiege";
	//private static Logger _log = Logger.getLogger(RequestJoinSiege.class.getName());

	private int _castleId;
	private boolean _isAttacker;
	private boolean _isJoining;

	@Override
	public void readImpl()
	{
		_castleId = readD();
		_isAttacker = readD() == 1;
		_isJoining = readD() == 1;
	}

	@Override
	@SuppressWarnings("unchecked")
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null || !activeChar.isClanLeader())
			return;

		Castle castle = CastleManager.getInstance().getCastleByIndex(_castleId);
		ClanHall clanhall = ClanHallManager.getInstance().getClanHall(_castleId);
		if(castle != null)
		{
			if(_isJoining)
			{
				for(Castle tempcastle : CastleManager.getInstance().getCastles().values())
					if(tempcastle.getSiege().checkIsClanRegistered(activeChar.getClanId()))
					{
						activeChar.sendMessage("You already have registered to siege.", "Вы уже записаны на осаду");
						return;
					}

				if(_isAttacker)
					castle.getSiege().registerAttacker(activeChar);
				else
					castle.getSiege().registerDefender(activeChar);
			}
			else
				castle.getSiege().removeSiegeClan(activeChar);

			castle.getSiege().listRegisterClan(activeChar);
		}
		else
		{
			if(_isJoining)
			{
				if(_isAttacker)
					Functions.callScripts("events.clanhall.CHSiegeManager", "addAttackerForSiege", new Object[] {
							new Integer(clanhall.getId()), activeChar.getClan() }, null);
			}
			else
				Functions.callScripts("events.clanhall.CHSiegeManager", "removeAttackerForSiege", new Object[] {
						new Integer(clanhall.getId()), activeChar.getClan() }, null);

			activeChar.sendPacket(new SiegeAttackerList(clanhall));
		}
	}

	@Override
	public String getType()
	{
		return _C__a4_RequestJoinSiege;
	}
}
