package L2jFT.game.network.clientpackets;

import L2jFT.game.instancemanager.BoatManager;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2BoatInstance;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.util.CharPosition;
import L2jFT.util.Location;

public class RequestMoveToLocationInVehicle extends L2GameClientPacket
{
	private Location _pos = new Location(0, 0, 0);
	private Location _origin_pos = new Location(0, 0, 0);
	private int _BoatId;

	/**
	 * @param buf
	 * @param client
	 */
	@Override
	public void readImpl()
	{
		_BoatId = readD(); //objectId of boat
		_pos.x = readD();
		_pos.y = readD();
		_pos.z = readD();
		_origin_pos.x = readD();
		_origin_pos.y = readD();
		_origin_pos.z = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		if(activeChar.getPet() != null)
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.BECAUSE_PET_OR_SERVITOR_MAY_BE_DROWNED_WHILE_THE_BOAT_MOVES_PLEASE_RELEASE_THE_SUMMON_BEFORE_DEPARTURE));
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isMovementDisabled())
		{
			activeChar.sendActionFailed();
			return;
		}

		if(!activeChar.isInBoat())
			activeChar.setInBoat(true);

		L2BoatInstance boat = BoatManager.getInstance().GetBoat(_BoatId);
		activeChar.setBoat(boat);
		activeChar.setInBoatPosition(_pos);
		activeChar.moveToInABoat(new CharPosition(_pos.x, _pos.y, _pos.z, 0), new CharPosition(_origin_pos.x, _origin_pos.y, _origin_pos.z, 0));
	}

	@Override
	public String getType()
	{
		return null;
	}
}