package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2ClanMember;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.PledgeShowMemberListDelete;
import L2jFT.game.network.serverpackets.PledgeShowMemberListDeleteAll;
import L2jFT.game.network.serverpackets.SystemMessage;

import java.util.logging.Logger;

public class RequestOustPledgeMember extends L2GameClientPacket
{
	private static String _C__27_REQUESTOUSTPLEDGEMEMBER = "[C] 27 RequestOustPledgeMember";
	static Logger _log = Logger.getLogger(RequestOustPledgeMember.class.getName());

	private String _target;

	@Override
	public void readImpl()
	{
		_target = readS();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();

		if(activeChar == null || !((activeChar.getClanPrivileges() & L2Clan.CP_CL_DISMISS) == L2Clan.CP_CL_DISMISS))
			return;

		L2Clan clan = activeChar.getClan();
		L2ClanMember member = clan.getClanMember(_target);
		if(member == null)
		{
			_log.warning("target is not member of the clan");
			return;
		}

		if(member.isOnline() && member.getPlayer().isInCombat())
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.A_CLAN_MEMBER_MAY_NOT_BE_DISMISSED_DURING_COMBAT));
			return;
		}

		clan.removeClanMember(_target);
		clan.broadcastToOnlineMembers(new SystemMessage(SystemMessage.CLAN_MEMBER_S1_HAS_BEEN_EXPELLED).addString(_target));
		clan.broadcastToOnlineMembers(new PledgeShowMemberListDelete(_target));
		clan.setExpelledMember();

		if(member.isOnline())
		{
			L2Player player = member.getPlayer();
			player.setClan(null);
			if(!player.isNoble())
				player.setTitle("");
			player.sendPacket(new SystemMessage(SystemMessage.YOU_HAVE_RECENTLY_BEEN_DISMISSED_FROM_A_CLAN_YOU_ARE_NOT_ALLOWED_TO_JOIN_ANOTHER_CLAN_FOR_24_HOURS));
			player.setLeaveClanCurTime();

			player.broadcastUserInfo();

			// disable clan tab
			player.sendPacket(new PledgeShowMemberListDeleteAll());
		}
	}

	@Override
	public String getType()
	{
		return _C__27_REQUESTOUSTPLEDGEMEMBER;
	}
}
