package L2jFT.game.network.clientpackets;

import L2jFT.Config;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.PackageSendableList;

/**
 * Format: d
 * 
 * Пример пакета с оффа:
 * 9E D0 33 08 00
 *
 * @author SYS
 */
public class RequestPackageSendableItemList extends L2GameClientPacket
{
	private static String _C__9E_REQUESTPACKAGESENDABLEITEMLIST = "[C] 9E RequestPackageSendableItemList";
	private int _characterObjectId;

	@Override
	public void readImpl()
	{
		_characterObjectId = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null || !activeChar.getPlayerAccess().UseWarehouse)
			return;

		activeChar.tempInvetoryDisable();

		if(Config.DEBUG)
			_log.fine("Showing items to freight");

		activeChar.sendPacket(new PackageSendableList(activeChar, _characterObjectId));
	}

	@Override
	public String getType()
	{
		return _C__9E_REQUESTPACKAGESENDABLEITEMLIST;
	}
}
