package L2jFT.game.network.clientpackets;

import L2jFT.game.ai.CtrlIntention;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2World;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.model.instances.L2PetInstance;

/**
 * This class ...
 *
 * @version $Revision: 1.2.4.4 $ $Date: 2005/03/29 23:15:33 $
 */
public class RequestPetGetItem extends L2GameClientPacket
{

	//private static Logger _log = Logger.getLogger(RequestPetGetItem.class.getName());
	private static String _C__8f_REQUESTPETGETITEM = "[C] 8F RequestPetGetItem";

	private int _objectId;

	@Override
	public void readImpl()
	{
		_objectId = readD();
	}

	@Override
	public void runImpl()
	{
		L2ItemInstance item = (L2ItemInstance) L2World.findObject(_objectId);
		L2Player activeChar = getClient().getActiveChar();
		L2PetInstance pet = (L2PetInstance) activeChar.getPet();
		if(pet == null || pet.isDead() || pet.isOutOfControl())
		{
			activeChar.sendActionFailed();
			return;
		}
		pet.getAI().setIntention(CtrlIntention.AI_INTENTION_PICK_UP, item, null);
	}

	@Override
	public String getType()
	{
		return _C__8f_REQUESTPETGETITEM;
	}

}
