package L2jFT.game.network.clientpackets;

import L2jFT.Config;
import L2jFT.game.cache.CrestCache;
import L2jFT.game.network.serverpackets.PledgeCrest;

import java.util.logging.Logger;

public class RequestPledgeCrest extends L2GameClientPacket
{
	private static Logger _log = Logger.getLogger(RequestPledgeCrest.class.getName());
	private static String _C__68_REQUESTPLEDGECREST = "[C] 68 RequestPledgeCrest";

	private int _crestId;

	@Override
	public void readImpl()
	{
		_crestId = readD();
	}

	@Override
	public void runImpl()
	{
		if(_crestId == 0)
			return;
		if(Config.DEBUG)
			_log.fine("crestid " + _crestId + " requested");
		byte[] data = CrestCache.getPledgeCrest(_crestId);
		if(data != null)
		{
			PledgeCrest pc = new PledgeCrest(_crestId, data);
			sendPacket(pc);
		}
		else if(Config.DEBUG)
			_log.fine("crest is missing:" + _crestId);
	}

	@Override
	public String getType()
	{
		return _C__68_REQUESTPLEDGECREST;
	}
}