package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.PledgeInfo;
import L2jFT.game.tables.ClanTable;

import java.util.logging.Logger;

/**
 * This class ...
 *
 * @version $Revision: 1.5.4.3 $ $Date: 2005/03/27 15:29:30 $
 */
public class RequestPledgeInfo extends L2GameClientPacket
{
	private static String _C__66_REQUESTPLEDGEINFO = "[C] 66 RequestPledgeInfo";
	private static Logger _log = Logger.getLogger(RequestPledgeInfo.class.getName());

	private int _clanId;

	/**
	 * packet type id 0x66
	 * format:		cd
	 * @param rawPacket
	 */
	@Override
	public void readImpl()
	{
		_clanId = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		// незнаю откуда именно 114, но факт остается. Возможно читеры...
		if(_clanId == 114)
			return;
		L2Clan clan = ClanTable.getInstance().getClan(_clanId);
		if(clan == null)
		{
			_log.warning("Clan data for clanId " + _clanId + " is missing");
			_log.warning("Host " + getClient().getIpAddr() + " possibly sends fake packets");
			return; // we have no clan data ?!? should not happen
		}

		activeChar.sendPacket(new PledgeInfo(clan));

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see L2jFT.game.network.clientpackets.ClientBasePacket#getType()
	 */
	@Override
	public String getType()
	{
		return _C__66_REQUESTPLEDGEINFO;
	}
}
