package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.ManagePledgePower;

import java.util.logging.Logger;

public class RequestPledgePower extends L2GameClientPacket
{
	static Logger _log = Logger.getLogger(RequestPledgePower.class.getName());
	private static String _C__C0_REQUESTPLEDGEPOWER = "[C] C0 RequestPledgePower";
	private int _rank;
	private int _action;
	private int _privs;

	@Override
	public void readImpl()
	{
		_rank = readD();
		_action = readD();
		if(_action == 2)
			_privs = readD();
		else
			_privs = 0;
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		if(_action == 2)
		{
			if(_rank < 0 || _rank > 9)
				return;
			if(activeChar.getClan() != null && (activeChar.getClanPrivileges() & L2Clan.CP_CL_MANAGE_RANKS) == L2Clan.CP_CL_MANAGE_RANKS)
			{
				if(_rank == 9)
					_privs = (_privs & L2Clan.CP_CL_VIEW_WAREHOUSE) + (_privs & L2Clan.CP_CH_OPEN_DOOR) + (_privs & L2Clan.CP_CS_OPEN_DOOR);
				activeChar.getClan().setRankPrivs(_rank, _privs);
				activeChar.getClan().updatePrivsForRank(_rank);
			}
		}
		else
			activeChar.sendPacket(new ManagePledgePower(activeChar.getClanId(), _action, activeChar));
	}

	@Override
	public String getType()
	{
		return _C__C0_REQUESTPLEDGEPOWER;
	}
}