package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2ClanMember;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.UserInfo;

public class RequestPledgeSetMemberPowerGrade extends L2GameClientPacket
{
	private static String _C__D0_1C_REQUESTPLEDGESETMEMBERPOWERGRADE = "[C] D0:1C RequestPledgeSetMemberPowerGrade";

	private int _powerGrade;
	private String _name;

	@Override
	public void readImpl()
	{
		_name = readS();
		_powerGrade = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;
		L2Clan clan = activeChar.getClan();
		if(clan == null)
			return;

		if((activeChar.getClanPrivileges() & L2Clan.CP_CL_MANAGE_RANKS) == L2Clan.CP_CL_MANAGE_RANKS)
		{
			L2ClanMember member = activeChar.getClan().getClanMember(_name);
			if(member != null)
			{
				if(clan.isAcademy(member.getPledgeType()))
				{
					activeChar.sendMessage("You cannot change academy member grade");
					return;
				}
				if(_powerGrade > 5 && clan.getAffiliationRank(member.getPledgeType()) != _powerGrade)
					member.setPowerGrade(clan.getAffiliationRank(member.getPledgeType()));
				else
					member.setPowerGrade(_powerGrade);
				if(member.isOnline())
					member.getPlayer().sendPacket(new UserInfo(member.getPlayer()));
			}
			else
				activeChar.sendMessage("the target doesn't belong to your clan", "Игрок не является членом Вашего клана");
		}
		else
			activeChar.sendMessage("You don't have the authority to change this member's power grade", "Вы не имеете достаточно прав для изменения ранка этого игрока");
	}

	@Override
	public String getType()
	{
		return _C__D0_1C_REQUESTPLEDGESETMEMBERPOWERGRADE;
	}
}
