package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2TradeList;
import L2jFT.game.model.L2Zone;
import L2jFT.game.model.TradeItem;
import L2jFT.game.network.serverpackets.PrivateStoreManageListSell;
import L2jFT.game.network.serverpackets.SystemMessage;

import java.util.HashSet;

public class RequestPrivateStoreManage extends L2GameClientPacket
{
	private static String _C__73_REQUESTPRIVATESTOREMANAGE = "[C] 73 RequestPrivateStoreManage";

	//private static Logger _log = Logger.getLogger(RequestPrivateStoreManage.class.getName());

	@Override
	public void readImpl()
	{}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		if(!activeChar.getPlayerAccess().UseTrade)
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.THIS_ACCOUNT_CANOT_USE_PRIVATE_STORES));
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isActionBlocked(L2Zone.BLOCKED_ACTION_PRIVATE_STORE))
		{
			sendPacket(new SystemMessage(SystemMessage.A_PRIVATE_STORE_MAY_NOT_BE_OPENED_IN_THIS_AREA));
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isCastingNow())
		{
			sendPacket(new SystemMessage(SystemMessage.A_PRIVATE_STORE_MAY_NOT_BE_OPENED_WHILE_USING_A_SKILL));
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isInCombat())
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.WHILE_YOU_ARE_ENGAGED_IN_COMBAT_YOU_CANNOT_OPERATE_A_PRIVATE_STORE_OR_PRIVATE_WORKSHOP));
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isOutOfControl() || activeChar.isActionsDisabled() || activeChar.getMountType() != 0)
		{
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isInOlympiadMode())
		{
			activeChar.sendActionFailed();
			return;
		}

		switch(activeChar.getPrivateStoreType())
		{
			case L2Player.STORE_PRIVATE_NONE:
			{
				if(activeChar.isSitting())
					activeChar.standUp();
				if(activeChar.getTradeList() == null)
					activeChar.setTradeList(new L2TradeList(0));
				if(activeChar.getSellList() == null)
					activeChar.setSellList(new HashSet<TradeItem>());

				activeChar.getTradeList().updateSellList(activeChar, activeChar.getSellList());
				activeChar.setPrivateStoreType((short) 2);
				activeChar.sendPacket(new PrivateStoreManageListSell(getClient().getActiveChar()));
				activeChar.broadcastUserInfo();
				break;
			}
			case L2Player.STORE_PRIVATE_SELL:
			{
				activeChar.setInStoreMode(false);
				activeChar.standUp();
				activeChar.sendPacket(new PrivateStoreManageListSell(getClient().getActiveChar()));
				break;
			}
		}
	}

	@Override
	public String getType()
	{
		return _C__73_REQUESTPRIVATESTOREMANAGE;
	}
}