package L2jFT.game.network.clientpackets;

import L2jFT.game.instancemanager.QuestManager;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.quest.QuestState;
import L2jFT.game.network.serverpackets.SystemMessage;

public class RequestQuestAbort extends L2GameClientPacket
{
	private static String _C__64_REQUESTQUESTABORT = "[C] 64 RequestQuestAbort";
	//private static Logger _log = Logger.getLogger(RequestQuestAbort.class.getName());

	private int _QuestID;

	/**
	 * packet type id 0x64<p>
	 */
	@Override
	public void readImpl()
	{
		_QuestID = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null || QuestManager.getInstance().getQuest(_QuestID) == null)
			return;
		QuestState qs = activeChar.getQuestState(QuestManager.getInstance().getQuest(_QuestID).getName());
		if(qs != null)
		{
			qs.exitCurrentQuest(true);
			activeChar.sendPacket(new SystemMessage(SystemMessage.S1_IS_ABORTED).addString(QuestManager.getInstance().getQuest(_QuestID).getDescr()));
		}
	}

	@Override
	public String getType()
	{
		return _C__64_REQUESTQUESTABORT;
	}
}