package L2jFT.game.network.clientpackets;

import L2jFT.game.RecipeController;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2RecipeList;
import L2jFT.game.network.serverpackets.RecipeBookItemList;

public class RequestRecipeBookDestroy extends L2GameClientPacket
{
	private static String _C__AC_REQUESTRECIPEBOOKDESTROY = "[C] AD RequestRecipeBookDestroy";
	//private static Logger _log = Logger.getLogger(RequestSellItem.class.getName());

	private int _RecipeID;

	/**
	 * Packet:ad
	 * 0000: ad 02 00 00 00
	 */
	@Override
	public void readImpl()
	{
		_RecipeID = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		L2RecipeList rp = RecipeController.getInstance().getRecipeList(_RecipeID - 1);

		if(rp == null)
		{
			activeChar.sendActionFailed();
			return;
		}

		activeChar.unregisterRecipeList(_RecipeID);

		RecipeBookItemList response = new RecipeBookItemList(rp.isDwarvenRecipe(), (int) activeChar.getCurrentMp());

		response.setRecipes(activeChar.getDwarvenRecipeBook());

		activeChar.sendPacket(response);
	}

	@Override
	public String getType()
	{
		return _C__AC_REQUESTRECIPEBOOKDESTROY;
	}
}