package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2ManufactureItem;
import L2jFT.game.model.L2ManufactureList;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2Zone;
import L2jFT.game.network.serverpackets.RecipeShopMsg;
import L2jFT.game.network.serverpackets.SystemMessage;

/**
 * cd(dd)
 */
public class RequestRecipeShopListSet extends L2GameClientPacket
{
	private static String _C__B2_RequestRecipeShopListSet = "[C] b2 RequestRecipeShopListSet";

	private int _count;
	L2ManufactureList createList = new L2ManufactureList();

	@Override
	public void readImpl()
	{
		_count = readD();
		for(int x = 0; x < _count; x++)
			createList.add(new L2ManufactureItem(readD(), readD()));
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		if(activeChar.getDuel() != null)
		{
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isActionBlocked(L2Zone.BLOCKED_ACTION_PRIVATE_WORKSHOP))
		{
			sendPacket(new SystemMessage(SystemMessage.A_PRIVATE_WORKSHOP_MAY_NOT_BE_OPENED_IN_THIS_AREA));
			activeChar.sendActionFailed();
			return;
		}

		if(_count == 0)
		{
			activeChar.setPrivateStoreType(L2Player.STORE_PRIVATE_NONE);
			activeChar.broadcastUserInfo();
			activeChar.standUp();
		}
		else
		{
			createList.setStoreName(activeChar.getCreateList().getStoreName());
			activeChar.setCreateList(createList);

			activeChar.setPrivateStoreType(L2Player.STORE_PRIVATE_MANUFACTURE);
			activeChar.broadcastUserInfo();
			activeChar.broadcastPacket(new RecipeShopMsg(activeChar));
			activeChar.sitDown();
		}
	}

	@Override
	public String getType()
	{
		return _C__B2_RequestRecipeShopListSet;
	}
}