package L2jFT.game.network.clientpackets;

import L2jFT.game.cache.CrestCache;
import L2jFT.game.model.L2Alliance;
import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2Player;

import java.util.logging.Logger;

public class RequestSetAllyCrest extends L2GameClientPacket
{
	private static String _C__87_REQUESTSETALLYCREST = "[C] 87 RequestSetAllyCrest";
	static Logger _log = Logger.getLogger(RequestSetPledgeCrest.class.getName());

	private int _length;
	private byte[] _data;

	@Override
	public void readImpl()
	{
		_length = readD();
		_data = new byte[_length];
		readB(_data);
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		L2Clan clan = activeChar.getClan();
		L2Alliance ally = activeChar.getAlliance();
		if(ally != null && activeChar.isAllyLeader())
		{
			if(ally.hasAllyCrest())
				CrestCache.removeAllyCrest(ally);

			System.out.println("AC size: " + _length);
			if(_data.length != 0)
				CrestCache.saveAllyCrest(ally, _data);

			for(L2Clan temp : ally.getMembers())
			{
				for(L2Player member : temp.getOnlineMembers(""))
					member.broadcastUserInfo();
				clan.broadcastClanStatus();
			}
		}
	}

	@Override
	public String getType()
	{
		return _C__87_REQUESTSETALLYCREST;
	}
}