package L2jFT.game.network.clientpackets;

import L2jFT.game.cache.CrestCache;
import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.SystemMessage;

import java.util.logging.Logger;

public class RequestSetPledgeCrest extends L2GameClientPacket
{
	private static String _C__53_REQUESTSETPLEDGECREST = "[C] 53 RequestSetPledgeCrest";
	static Logger _log = Logger.getLogger(RequestSetPledgeCrest.class.getName());

	private int _length;
	private byte[] _data;

	@Override
	public void readImpl()
	{
		_length = readD();
		if(_length > 0)
		{
			_data = new byte[_length];
			readB(_data);
		}
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		L2Clan clan = activeChar.getClan();
		if((activeChar.getClanPrivileges() & L2Clan.CP_CL_REGISTER_CREST) == L2Clan.CP_CL_REGISTER_CREST)
		{
			if(clan.getLevel() < 3)
			{
				activeChar.sendPacket(new SystemMessage(SystemMessage.CLAN_CREST_REGISTRATION_IS_ONLY_POSSIBLE_WHEN_CLANS_SKILL_LEVELS_ARE_ABOVE_3));
				return;
			}

			if(clan.hasCrest())
				CrestCache.removePledgeCrest(clan);

			if(_length != 0)
				CrestCache.savePledgeCrest(clan, _data);

			for(L2Player member : clan.getOnlineMembers(""))
				member.broadcastUserInfo();
			clan.broadcastClanStatus();
		}
	}

	@Override
	public String getType()
	{
		return _C__53_REQUESTSETPLEDGECREST;
	}
}
