package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.network.serverpackets.InventoryUpdate;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.game.templates.L2Item;

public class RequestUnEquipItem extends L2GameClientPacket
{
	private static String _C__11_REQUESTUNEQUIPITEM = "[C] 11 RequestUnequipItem";
	private int _slot;

	/**
	 * packet type id 0x11
	 * format:		cd 
	 * @param decrypt
	 */
	@Override
	public void readImpl()
	{
		_slot = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		L2ItemInstance item = activeChar.getInventory().getPaperdollItemBySlot(_slot);
		if(item == null || item.isWear())
			return;

		// Нельзя снимать проклятое оружие
		if(_slot == L2Item.SLOT_LR_HAND && activeChar.isCursedWeaponEquipped())
			return;

		L2ItemInstance weapon = activeChar.getActiveWeaponInstance();
		L2ItemInstance[] unequipped = activeChar.getInventory().unEquipItemInBodySlotAndRecord(_slot, null);
		InventoryUpdate iu = new InventoryUpdate();

		for(L2ItemInstance uneq : unequipped)
		{
			if(uneq == null || uneq.isWear())
				continue;

			SystemMessage sm = null;

			if(item.getEnchantLevel() > 0)
			{
				sm = new SystemMessage(SystemMessage.EQUIPMENT_OF__S1_S2_HAS_BEEN_REMOVED);
				sm.addNumber(item.getEnchantLevel());
				sm.addItemName(item.getItemId());
			}
			else
				sm = new SystemMessage(SystemMessage.S1__HAS_BEEN_DISARMED).addItemName(item.getItemId());

			activeChar.sendPacket(sm);

			if(weapon != null && uneq == weapon)
			{
				uneq.setChargedSpiritshot(L2ItemInstance.CHARGED_NONE);
				uneq.setChargedSoulshot(L2ItemInstance.CHARGED_NONE);
				activeChar.abortAttack();
				activeChar.abortCast();
			}

			iu.addModifiedItem(uneq);
		}

		activeChar.sendPacket(iu);
		activeChar.refreshExpertisePenalty();
		activeChar.broadcastUserInfo();
	}

	@Override
	public String getType()
	{
		return _C__11_REQUESTUNEQUIPITEM;
	}
}