package L2jFT.game.network.clientpackets;

import L2jFT.game.handler.IUserCommandHandler;
import L2jFT.game.handler.UserCommandHandler;
import L2jFT.game.model.L2Player;

import java.util.logging.Logger;

/**
 * Пример пакета по команде /loc:
 * AA 00 00 00 00
 */
public class RequestUserCommand extends L2GameClientPacket
{
	private static String _C__AA_REQUESTUSERCOMMAND = "[C] aa RequestUserCommand";
	static Logger _log = Logger.getLogger(RequestUserCommand.class.getName());

	private int _command;

	/**
	 * packet type id 0xaa
	 * format:  cd
	 */
	@Override
	public void readImpl()
	{
		_command = readD();
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		IUserCommandHandler handler = UserCommandHandler.getInstance().getUserCommandHandler(_command);

		if(handler == null)
			activeChar.sendMessage("user commandID " + _command + " not implemented yet", "комманда " + _command + " еще не реализована");
		else
			handler.useUserCommand(_command, getClient().getActiveChar());
	}

	@Override
	public String getType()
	{
		return _C__AA_REQUESTUSERCOMMAND;
	}
}