package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2ClanMember;
import L2jFT.game.model.L2Player;
import L2jFT.game.network.serverpackets.PledgeShowMemberListDelete;
import L2jFT.game.network.serverpackets.PledgeShowMemberListDeleteAll;
import L2jFT.game.network.serverpackets.SystemMessage;

import java.util.logging.Logger;

public class RequestWithdrawalPledge extends L2GameClientPacket
{
	private static String _C__26_REQUESTWITHDRAWALPLEDGE = "[C] 26 RequestWithdrawalPledge";
	static Logger _log = Logger.getLogger(RequestWithdrawalPledge.class.getName());

	@Override
	public void readImpl()
	{}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		//is the guy in a clan  ?
		if(activeChar.getClanId() == 0)
		{
			activeChar.sendActionFailed();
			return;
		}

		if(activeChar.isInCombat())
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.ONE_CANNOT_LEAVE_ONES_CLAN_DURING_COMBAT));
			return;
		}

		L2Clan clan = activeChar.getClan();
		L2ClanMember member = clan.getClanMember(activeChar.getObjectId());

		if(member == null)
		{
			activeChar.sendActionFailed();
			return;
		}

		// this also updated the database
		clan.removeClanMember(activeChar.getObjectId());

		//player withdrawed.
		clan.broadcastToOnlineMembers(new SystemMessage(SystemMessage.S1_HAS_WITHDRAWN_FROM_THE_CLAN).addString(activeChar.getName()));
		// Remove the Player From the Member list

		clan.broadcastToOnlineMembers(new PledgeShowMemberListDelete(activeChar.getName()));
		activeChar.sendPacket(new SystemMessage(SystemMessage.YOU_HAVE_RECENTLY_BEEN_DISMISSED_FROM_A_CLAN_YOU_ARE_NOT_ALLOWED_TO_JOIN_ANOTHER_CLAN_FOR_24_HOURS));

		L2Player player = member.getPlayer();
		player.setClan(null);
		if(!player.isNoble())
			player.setTitle("");
		player.setLeaveClanCurTime();

		player.broadcastUserInfo();

		// disable clan tab
		player.sendPacket(new PledgeShowMemberListDeleteAll());
	}

	@Override
	public String getType()
	{
		return _C__26_REQUESTWITHDRAWALPLEDGE;
	}
}
