package L2jFT.game.network.clientpackets;

import L2jFT.Config;
import L2jFT.game.handler.AdminCommandHandler;
import L2jFT.game.handler.IAdminCommandHandler;
import L2jFT.game.model.L2Player;

import java.util.logging.Logger;

/**
 * This class handles all GM commands triggered by //command
 */
public class SendBypassBuildCmd extends L2GameClientPacket
{
	private static Logger _log = Logger.getLogger(SendBypassBuildCmd.class.getName());

	private static String _C__5B_SENDBYPASSBUILDCMD = "[C] 5b SendBypassBuildCmd";
	public static int GM_MESSAGE = 9;
	public static int ANNOUNCEMENT = 10;

	private String _command;

	@Override
	public void readImpl()
	{
		_command = readS();

		if(_command != null)
			_command = _command.trim();

	}

	@Override
	public void runImpl()
	{
		if(Config.DEBUG)
			_log.info("Got command '" + _command + "'");

		L2Player activeChar = getClient().getActiveChar();

		if(activeChar == null)
			return;

		String cmd = "admin_" + _command;
		IAdminCommandHandler ach = AdminCommandHandler.getInstance().getAdminCommandHandler(cmd);

		if(ach == null)
		{
			cmd = _command;
			ach = AdminCommandHandler.getInstance().getAdminCommandHandler(cmd);
		}

		if(ach != null)
		{
			if(!(activeChar.getPlayerAccess().IsGM || activeChar.getPlayerAccess().CanUseGMCommand))
			{
				activeChar.illegalAction(activeChar.getName() + " user use adm command admin_" + _command, 0);
				return;
			}
			ach.useAdminCommand(cmd, activeChar);
			return;
		}

		activeChar.sendMessage("No access to use command, or command '" + _command + "' not recognized", "Нет прав для использования команды, или команда '" + _command + "' не разпознана");
	}

	@Override
	public String getType()
	{
		return _C__5B_SENDBYPASSBUILDCMD;
	}
}