package L2jFT.game.network.clientpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.TradeItem;
import L2jFT.game.network.serverpackets.ChangeWaitType;
import L2jFT.game.network.serverpackets.PrivateStoreMsgBuy;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.util.Util;

import java.util.HashSet;

public class SetPrivateStoreListBuy extends L2GameClientPacket
{
	private static String _C__91_SETPRIVATESTORELISTBUY = "[C] 91 SetPrivateStoreListBuy";

	private int _count;
	private int[] _items; // count * 3

	@Override
	public void readImpl()
	{
		_count = readD();
		_items = new int[_count * 3];
		for(int i = 0; i < _count; i++)
		{
			_items[i * 3 + 0] = readD(); //item id
			readH();// don't know what this is
			readH();
			_items[i * 3 + 1] = readD(); //count
			_items[i * 3 + 2] = readD(); //price 
			if(_items[i * 3 + 1] < 0)
			{
				_items = null;
				break;
			}
		}
	}

	@Override
	public void runImpl()
	{
		L2Player activeChar = getClient().getActiveChar();
		if(activeChar == null)
			return;

		if(_items == null || _count <= 0)
			return;

		int maxSlots = activeChar.getTradeLimit();

		if(_count > maxSlots)
		{
			activeChar.sendPacket(new SystemMessage(SystemMessage.YOU_HAVE_EXCEEDED_THE_QUANTITY_THAT_CAN_BE_INPUTTED));
			activeChar.setPrivateStoreType(L2Player.STORE_PRIVATE_NONE);
			activeChar.setInStoreMode(false);
			activeChar.broadcastUserInfo();
			activeChar.standUp();
			return;
		}

		TradeItem temp;
		HashSet<TradeItem> listbuy = new HashSet<TradeItem>();
		int totalCost = 0;

		for(int x = 0; x < _count; x++)
		{
			temp = new TradeItem();
			temp.setItemId(_items[x * 3 + 0]);
			temp.setCount(_items[x * 3 + 1]);
			temp.setOwnersPrice(_items[x * 3 + 2]);
			totalCost += temp.getOwnersPrice() * temp.getCount();
			if(temp.getOwnersPrice() < 0 || temp.getCount() < 0)
			{
				Util.handleIllegalPlayerAction(activeChar, _C__91_SETPRIVATESTORELISTBUY, "Negative number inserted", 1);
				activeChar.sendActionFailed();
				return;
			}
			if(temp.getOwnersPrice() > activeChar.getAdena())
			{
				activeChar.sendPacket(new SystemMessage(SystemMessage.THE_PURCHASE_PRICE_IS_HIGHER_THAN_THE_AMOUNT_OF_MONEY_THAT_YOU_HAVE_AND_SO_YOU_CANNOT_OPEN_A_PERSONAL_STORE));
				activeChar.sendActionFailed();
				activeChar.setPrivateStoreType(L2Player.STORE_PRIVATE_NONE);
				activeChar.setInStoreMode(false);
				activeChar.broadcastUserInfo();
				return;
			}
			listbuy.add(temp);
		}

		if(_count != 0)
		{
			activeChar.setBuyList(listbuy);
			activeChar.setPrivateStoreType(L2Player.STORE_PRIVATE_BUY);
			activeChar.broadcastPacket(new ChangeWaitType(activeChar, ChangeWaitType.WT_SITTING));
			activeChar.broadcastUserInfo();
			activeChar.broadcastPacket(new PrivateStoreMsgBuy(activeChar));
			activeChar.sitDown();
			return;
		}

		activeChar.sendActionFailed();
		activeChar.setPrivateStoreType(L2Player.STORE_PRIVATE_NONE);
		activeChar.broadcastUserInfo();
		activeChar.standUp();
	}

	@Override
	public String getType()
	{
		return _C__91_SETPRIVATESTORELISTBUY;
	}
}