package L2jFT.game.network.serverpackets;

import java.util.logging.Logger;

import L2jFT.game.model.entity.ClanHall;

public class AgitDecoInfo extends L2GameServerPacket
{
	private static final String _S__F7_AGITDECOINFO = "[S] F7 AgitDecoInfo";
	private static final Logger _log = Logger.getLogger(AgitDecoInfo.class.getName());

	/**
	 * В коментах: Первое число = присланое сервером, второе  уровень установленый в кланхолле
	 * Пример: mp recovery: 0 = 0 значит что уровень 0 прислал 0,  уровни 5 и 15 прислали 1, уровни 25, 35, 50 прислали 2
	 *
	 * кажись нигде ничего не напутал...
	 */

	ClanHall _ch;

	private int[] _buff = { 0, 1, 1, 1, 2, 2, 2, 2, 2 };
	private int[] _itCr8 = { 0, 1, 2, 2 };

	public AgitDecoInfo(ClanHall ch)
	{
		if(ch == null)
		{
			_log.warning("Attemp to send decorations for null ClanHall");
			return;
		}
		_ch = ch;
	}

	@Override
	public void runImpl()
	{

	}

	/**
	 * Packet send, must be confirmed
	 * writeC(0xf7);
	 * writeD(0); // clanhall id
	 * writeC(0); // FUNC_RESTORE_HP (Fireplace)
	 * writeC(0); // FUNC_RESTORE_MP (Carpet)
	 * writeC(0); // FUNC_RESTORE_MP (Statue)
	 * writeC(0); // FUNC_RESTORE_EXP (Chandelier)
	 * writeC(0); // FUNC_TELEPORT (Mirror)
	 * writeC(0); // Crytal
	 * writeC(0); // Curtain
	 * writeC(0); // FUNC_ITEM_CREATE (Magic Curtain)
	 * writeC(0); // FUNC_SUPPORT
	 * writeC(0); // FUNC_SUPPORT (Flag)
	 * writeC(0); // Front Platform
	 * writeC(0); // FUNC_ITEM_CREATE
	 * writeD(0);
	 * writeD(0);
	 * writeD(0);
	 * writeD(0);
	 * writeD(0);
	 */
	@Override
	protected final void writeImpl()
	{
		writeC(0xf7);
		writeD(_ch.getId()); // clan hall id, во всяком случае всегда приходил 31.
		// hp recovery, 0 = 0, 1 = 80, 120, 180, 2 = 240, 300
		writeC(getHpRecovery(_ch.getFunction(ClanHall.FUNC_RESTORE_HP) != null ? _ch.getFunction(ClanHall.FUNC_RESTORE_HP).getLvl() : 0));
		// mp recovery, 0 = 0, 1 = 5, 15, 2 = 30, 40
		int mp = getMpRecovery(_ch.getFunction(ClanHall.FUNC_RESTORE_MP) != null ? _ch.getFunction(ClanHall.FUNC_RESTORE_MP).getLvl() : 0);
		writeC(mp); // Ковер
		writeC(mp); // Статуя
		writeC(getExpRecovery(_ch.getFunction(ClanHall.FUNC_RESTORE_EXP) != null ? _ch.getFunction(ClanHall.FUNC_RESTORE_EXP).getLvl() : 0)); // exp recovery, 0 = 0, 1= 15, 2 = 25, 35, 50
		writeC(_ch.getFunction(ClanHall.FUNC_TELEPORT) != null ? _ch.getFunction(ClanHall.FUNC_TELEPORT).getLvl() : 0); // teleport, 0, 1, 2
		writeC(0); // кристалл? Что за хрень то :)?
		writeC(_ch.getFunction(ClanHall.FUNC_CURTAIN) != null ? _ch.getFunction(ClanHall.FUNC_CURTAIN).getLvl() : 0); // curtains, 0 = 0, 1 = 1, 2 = 2
		// item creation 0 = 0, 1 = 1, 2 = 2, 3
		int itemCreate = _ch.getFunction(ClanHall.FUNC_ITEM_CREATE) != null ? _itCr8[_ch.getFunction(ClanHall.FUNC_ITEM_CREATE).getLvl()] : 0;
		writeC(itemCreate);
		// assist magic, 0 = 0, 1 = 3, 2 = 5, 7, 8
		int support = _ch.getFunction(ClanHall.FUNC_SUPPORT) != null ? _buff[_ch.getFunction(ClanHall.FUNC_SUPPORT).getLvl()] : 0;
		writeC(support);
		writeC(support); // Флаг
		writeC(_ch.getFunction(ClanHall.FUNC_PLATFORM) != null ? _ch.getFunction(ClanHall.FUNC_PLATFORM).getLvl() : 0); // front platform, 0 = 0, 1 = 1, 2 = 2
		writeC(itemCreate);
		writeD(0);
		writeD(0);
		writeD(0);
		writeD(0);
		writeD(0);
	}

	private int getHpRecovery(int percent)
	{
		switch(percent)
		{
			case 0:
				return 0;
			case 20:
			case 40:
			case 80:
			case 120:
			case 140:
				return 1;
			case 160:
			case 180:
			case 200:
			case 220:
			case 240:
			case 260:
			case 280:
			case 300:
				return 2;
			default:
				_log.warning("Unsupported percent " + percent + " in hp recovery");
				return 0;
		}
	}

	private int getMpRecovery(int percent)
	{
		switch(percent)
		{
			case 0:
				return 0;
			case 5:
			case 10:
			case 15:
			case 20:
				return 1;
			case 25:
			case 30:
			case 35:
			case 40:
			case 45:
			case 50:
				return 2;
			default:
				_log.warning("Unsupported percent " + percent + " in mp recovery");
				return 0;
		}
	}

	private int getExpRecovery(int percent)
	{
		switch(percent)
		{
			case 0:
				return 0;
			case 5:
			case 10:
			case 15:
			case 20:
				return 1;
			case 25:
			case 30:
			case 35:
			case 40:
			case 45:
			case 50:
				return 2;
			default:
				_log.warning("Unsupported percent " + percent + " in exp recovery");
				return 0;
		}
	}

	@Override
	public String getType()
	{
		return _S__F7_AGITDECOINFO;
	}
}