package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2SkillLearn;
import L2jFT.game.model.base.ClassId;
import L2jFT.game.tables.SkillSpellbookTable;
import L2jFT.game.tables.SkillTreeTable;

import java.util.ArrayList;

public class AquireSkillInfo extends L2GameServerPacket
{
	private static final String _S__8B_ACQUIRESKILLINFO = "[S] 8B AquireSkillInfo";
	private ArrayList<Req> _reqs;
	private short _id;
	private byte _level;
	private int _spCost;
	private int _mode;
	private ClassId _classId;

	class Req
	{
		public int id;
		public int count;
		public int type;
		public int unk;

		Req(int type, int id, int count, int unk)
		{
			this.id = id;
			this.type = type;
			this.count = count;
			this.unk = unk;
		}
	}

	public AquireSkillInfo(short id, byte level, ClassId classid)
	{
		_reqs = new ArrayList<Req>();
		_id = id;
		_level = level;
		_classId = classid;
	}

	private void fillRequirements()
	{
		L2SkillLearn SkillLearn = SkillTreeTable.getSkillLearn(_id, _level, _classId);
		if(SkillLearn == null)
			return;
		_spCost = SkillLearn.clan ? SkillLearn._repCost : SkillLearn.spCost;
		_mode = SkillLearn.common || SkillLearn.clan ? 1 : 0;

		Short spb_id = SkillSpellbookTable._skillSpellbooks.get(SkillSpellbookTable.hashCode(new short[] {
				_id, _level }));

		if(spb_id != null)
			_reqs.add(new Req(SkillLearn.common ? 4 : SkillLearn.clan ? 1 : 99, spb_id.intValue(), SkillLearn.clan ? 1 : SkillLearn.itemCount, SkillLearn.common || SkillLearn.clan ? 0 : 50));
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		fillRequirements();

		writeC(0x8b);
		writeD(_id);
		writeD(_level);
		writeD(_spCost);
		writeD(_mode);

		writeD(_reqs.size());

		for(Req temp : _reqs)
		{
			writeD(temp.type);
			writeD(temp.id);
			writeD(temp.count);
			writeD(temp.unk);
		}
	}

	@Override
	public String getType()
	{
		return _S__8B_ACQUIRESKILLINFO;
	}
}