package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Character;
import L2jFT.util.Location;

/**
 * 0000: 01  7a 73 10 4c  b2 0b 00 00  a3 fc 00 00  e8 f1 ff    .zs.L...........
 * 0010: ff  bd 0b 00 00  b3 fc 00 00  e8 f1 ff ff             .............

 *
 * ddddddd
 *
 * @version $Revision: 1.3.4.3 $ $Date: 2005/03/27 15:29:57 $
 */
public class CharMoveToLocation extends L2GameServerPacket
{
	private static final String _S__01_CHARMOVETOLOCATION = "[S] 01 CharMoveToLocation";
	private int _objectId, _x, _y, _z, _xDst, _yDst, _zDst;

	protected boolean logHandled()
	{
		return true;
	}

	public CharMoveToLocation(L2Character cha)
	{
		_objectId = cha.getObjectId();
		_x = cha.getX();
		_y = cha.getY();
		_z = cha.getZ();

		Location destination = cha.getDestination();

		_xDst = destination.x;
		_yDst = destination.y;
		_zDst = destination.z;

		//cha.sendMessage("CharMoveToLocation: (" + _x + "," + _y + "," + _z + ")-(" + _xDst + "," + _yDst + "," + _zDst + ")");

		// Иначе мобы иногда уходят "куда-то на север" :D
		// FIXME: Какой смысел в этом выражении о.О... Оно же ничего не делает
		if(_xDst == 0 && _yDst == 0)
			return;
	}

	@Override
	final public void runImpl()
	{
	// no long-running tasks
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x01);

		writeD(_objectId);

		writeD(_xDst);
		writeD(_yDst);
		writeD(_zDst);

		writeD(_x);
		writeD(_y);
		writeD(_z);
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.serverpackets.L2GameServerPacket#getType()
	 */
	@Override
	public String getType()
	{
		return _S__01_CHARMOVETOLOCATION;
	}

}
