package L2jFT.game.network.serverpackets;

/**
 * @author SYS Format: cdddsddddcdd
 * @Date: 07/8/2007
 */

/**
 * Пакет с подтверждением при саммоне персонажей скилом Summon Friend и подобных.
 * "Nemu wishes to summon you from Imperial Tomb. Do you accept?"
 * Время ответа на диалог лимитировано.
 * ED
 * 32 07 00 00 - Номер системного сообщения int 1842 "$s1 wishes to summon you from $s2. Do you accept?"
 * 02 00 00 00 00 00 00 - unknow
 * 00 4E 00 65 00 6D 00 75 00 00 - Имя персонажа, в данном случае Nemu
 * 00 07 00 00 - Тип 7 - есть полоска времени
 * 00 B5 C6 02 00 B0 B8 FE FF 00 E7 FF - координаты локации: x,y,z
 * FF - unknow
 * 30 75 00 00 - время, даваемое на ответ 30000мс (уменьшающаяся полоска).
 * EE DB 30 4B - Идентификатор запроса, после выбора ответа возвращается клиентом серверу
 * Название локации определяется клиентом по полученным координатам.
 * 
 * Пакет с подтверждением при ресуректе:
 * "Nemu is making an attempt at resurrection. Do you want to continue with this resurrection?" 
 * ED 
 * E6 05 00 00 - Номер системного сообщения int 1510 "$s1 is making an attempt at resurrection. Do you want to continue with this resurrection?"
 * 02 00 00 00 00 00 00 - unknown
 * 00 4E 00 65 00 6D 00 75 00 00 - Имя персонажа, в данном случае Nemu
 * 00 06 00 00 - Время ответа на диалог не лимитировано.
 * 00 00 00 00 00 00 00 00 00 00 00 00 - unused coods
 * 00 - unknown
 * BC 39 B6 1E - Идентификатор запроса, после выбора ответа возвращается клиентом серверу
 */
public class ConfirmDlg extends L2GameServerPacket
{
	private static final String _S__ED_CONFIRMDLG = "[S] ed ConfirmDlg";
	private int _messageId;
	private String _Name;
	private int _Time;
	private int[] _Loc;
	private int _requestId;

	public ConfirmDlg(int requestId, String requestorName, int time, int[] loc, int id)
	{
		_messageId = requestId;
		_Name = requestorName;
		_Time = time;
		_Loc = loc;
		_requestId = id;
	}

	@Override
	final public void runImpl()
	{
	// no long-running tasks
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0xed);
		writeD(_messageId);
		writeD(0x02); // ??
		writeD(0x00); // ??
		writeS(_Name);
		if(_Time != 0)
			writeD(0x07); // Time-limited dialog
		else
			writeD(0x06); // Not time-limited dialog
		if(_Loc == null)
		{
			writeD(0x00);
			writeD(0x00);
			writeD(0x00);
		}
		else
		{
			writeD(_Loc[0]);
			writeD(_Loc[1]);
			writeD(_Loc[2]);
		}
		if(_Time != 0)
			writeD(_Time);
		writeD(_requestId);
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.serverpackets.L2GameServerPacket#getType()
	 */
	@Override
	public String getType()
	{
		return _S__ED_CONFIRMDLG;
	}
}
