package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Object;
import L2jFT.game.model.L2World;

import java.util.logging.Logger;

/**
 * sample
 * 0000: 1e  9b da 12 40                                     ....@
 *
 * format  d 
 *
 * @version $Revision: 1.3.2.1.2.3 $ $Date: 2005/03/27 15:29:39 $
 */
public class DeleteObject extends L2GameServerPacket
{
	private static Logger _log = Logger.getLogger(DeleteObject.class.getName());

	private static final String _S__12_DELETEOBJECT = "[S] 12 DeleteObject";
	private int _objectId;

	protected boolean logHandled()
	{
		return true;
	}

	public DeleteObject(L2Object obj)
	{
		_objectId = 0;
		if(getClient() != null && getClient().getActiveChar() == obj)
		{
			_log.warning("Try self.DeleteObject for " + getClient().getActiveChar());
			Thread.dumpStack();
			return;
		}
		_objectId = obj.getObjectId();
	}

	public DeleteObject(Integer oid)
	{
		_objectId = 0;
		if(getClient() != null && getClient().getActiveChar().getObjectId() == oid)
		{
			_log.warning("Try self.DeleteObject for " + getClient().getActiveChar());
			Thread.dumpStack();
			return;
		}
		_objectId = oid;
	}

	@Override
	final public void runImpl()
	{
	// no long-running tasks
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x12);
		writeD(_objectId);
		writeD(0x00); //c2
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.serverpackets.L2GameServerPacket#getType()
	 */
	@Override
	public String getType()
	{
		return _S__12_DELETEOBJECT + " " + L2World.findObject(_objectId) + " (" + _objectId + ")";
	}

}
