package L2jFT.game.network.serverpackets;

import L2jFT.game.model.instances.L2DoorInstance;

/**
 * 60 
 * d6 6d c0 4b		door id 
 * 8f 14 00 00 		x
 * b7 f1 00 00 		y
 * 60 f2 ff ff 		z
 * 00 00 00 00 		??
 *
 * format  dddd    rev 377  ID:%d X:%d Y:%d Z:%d
 *         ddddd   rev 419
 *
 * @version $Revision: 1.3.2.2.2.3 $ $Date: 2005/03/27 15:29:57 $
 */
public class DoorInfo extends L2GameServerPacket
{
	private static final String _S__4C_DOORINFO = "[S] 4C DoorInfo";
	private L2DoorInstance _door;

	public DoorInfo(L2DoorInstance door)
	{
		_door = door;
	}

	@Override
	final public void runImpl()
	{
	// no long-running tasks
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x4C);
		writeD(_door.getObjectId());
		writeD(_door.getDoorId());
		writeD(_door.isHPVisible() ? 1 : 0); // отображать ли хп у двери или стены
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.serverpackets.L2GameServerPacket#getType()
	 */
	@Override
	public String getType()
	{
		return _S__4C_DOORINFO;
	}

}
