package L2jFT.game.network.serverpackets;

import javolution.util.FastList;

public class ExEnchantSkillInfo extends L2GameServerPacket
{
	private static final String _S__FE_18_EXENCHANTSKILLINFO = "[S] FE:18 ExEnchantSkillInfo";
	private FastList<Req> _reqs;
	private int _id;
	private int _level;
	private int _spCost;
	private long _xpCost;
	private int _rate;

	class Req
	{
		public int id;
		public int count;
		public int type;
		public int unk;

		Req(int type, int id, int count, int unk)
		{
			this.id = id;
			this.type = type;
			this.count = count;
			this.unk = unk;
		}
	}

	public ExEnchantSkillInfo(int id, int level, int spCost, long xpCost, int rate)
	{
		_reqs = new FastList<Req>();
		_id = id;
		_level = level;
		_spCost = spCost;
		_xpCost = xpCost;
		_rate = rate;
	}

	public void addRequirement(int type, int id, int count, int unk)
	{
		_reqs.add(new Req(type, id, count, unk));
	}

	@Override
	public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x18);

		writeD(_id);
		writeD(_level);
		writeD(_spCost);
		writeQ(_xpCost);
		writeD(_rate);

		writeD(_reqs.size());

		for(Req temp : _reqs)
		{
			writeD(temp.type);
			writeD(temp.id);
			writeD(temp.count);
			writeD(temp.unk);
		}
	}

	@Override
	public String getType()
	{
		return _S__FE_18_EXENCHANTSKILLINFO;
	}
}