package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Character;

/**
 * Format (ch)dddcccd
 * d: cahacter oid
 * d: time left
 * d: fish hp
 * c:
 * c:
 * c: 00 if fish gets damage 02 if fish regens
 * d:
 * @author -Wooden-
 *
 */
public class ExFishingHpRegen extends L2GameServerPacket
{
	private static final String _S__FE_16_EXFISHINGHPREGEN = "[S] FE:16 ExFishingHpRegen";
	private L2Character _character;
	private int _time, _fishHP, _HPmode, _Anim, _GoodUse, _Penalty, _hpBarColor;

	public ExFishingHpRegen(L2Character character, int time, int fishHP, int HPmode, int GoodUse, int anim, int penalty, int hpBarColor)
	{
		_character = character;
		_time = time;
		_fishHP = fishHP;
		_HPmode = HPmode;
		_GoodUse = GoodUse;
		_Anim = anim;
		_Penalty = penalty;
		_hpBarColor = hpBarColor;
	}

	@Override
	public void runImpl()
	{

	}

	@Override
	protected final void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x16);

		writeD(_character.getObjectId());
		writeD(_time);
		writeD(_fishHP);
		writeC(_HPmode); // 0 = HP stop, 1 = HP raise 
		writeC(_GoodUse); // 0 = none, 1 = success, 2 = failed
		writeC(_Anim); // Anim: 0 = none, 1 = reeling, 2 = pumping
		writeD(_Penalty); // Penalty	
		writeC(_hpBarColor); // 0 = normal hp bar, 1 = purple hp bar

	}

	@Override
	public String getType()
	{
		return _S__FE_16_EXFISHINGHPREGEN;
	}
}