package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;

/**
 * Format: ch d[Sdd]
 * @author SYS
 */
public class ExMPCCShowPartyMemberInfo extends L2GameServerPacket
{
	private static final String _S__FE_4A_EXMPCCSHOWPARTYMEMBERINFO = "[S] FE:4A ExMPCCShowPartyMemberInfo";
	private L2Player _partyLeader;

	public ExMPCCShowPartyMemberInfo(L2Player partyLeader)
	{
		_partyLeader = partyLeader;
	}

	@Override
	public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		if(!_partyLeader.isInParty() || !_partyLeader.getParty().isInCommandChannel())
			return;

		writeC(EXTENDED_PACKET);
		writeH(0x4a);
		writeD(_partyLeader.getParty().getMemberCount()); // Количество членов в пати
		for(L2Player partyMember : _partyLeader.getParty().getPartyMembers())
		{
			writeS(partyMember.getName()); // Имя члена пати
			writeD(partyMember.getObjectId()); // object Id члена пати
			writeD(partyMember.getClassId().getId()); // id класса члена пати
		}
	}

	@Override
	public String getType()
	{
		return _S__FE_4A_EXMPCCSHOWPARTYMEMBERINFO;
	}
}