package L2jFT.game.network.serverpackets;

import javolution.util.FastList;

/**
 * Format : (h) d [dS]
 * h  sub id
 * 
 * d: number of manors
 * [
 * d: id 
 * S: manor name
 * ]
 *
 */
public class ExSendManorList extends L2GameServerPacket
{
	private static final String _S__FE_1B_EXSENDMANORLIST = "[S] FE:1B ExSendManorList";

	private FastList<String> _manors;

	public ExSendManorList(FastList<String> manors)
	{
		_manors = manors;
	}

	@Override
	protected void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x1B);
		writeD(_manors.size());
		for(int i = 0; i < _manors.size(); i++)
		{
			int j = i + 1;
			writeD(j);
			writeS(_manors.get(i));
		}
	}

	@Override
	public String getType()
	{
		return _S__FE_1B_EXSENDMANORLIST;
	}
}