package L2jFT.game.network.serverpackets;

import L2jFT.game.model.Inventory;
import L2jFT.game.model.L2Player;

public class GMViewCharacterInfo extends L2GameServerPacket
{
	private static final String _S__8F_GMVIEWCHARACTERINFO = "[S] 8F GMViewCharacterInfo";
	private final L2Player _cha;

	public GMViewCharacterInfo(final L2Player cha)
	{
		_cha = cha;
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0x8F);

		writeD(_cha.getX());
		writeD(_cha.getY());
		writeD(_cha.getZ());
		writeD(_cha.getHeading());
		writeD(_cha.getObjectId());
		writeS(_cha.getName());
		writeD(_cha.getRace().ordinal());
		writeD(_cha.getSex());
		writeD(_cha.getClassId().getId());
		writeD(_cha.getLevel());
		writeQ(_cha.getExp());
		writeD(_cha.getSTR());
		writeD(_cha.getDEX());
		writeD(_cha.getCON());
		writeD(_cha.getINT());
		writeD(_cha.getWIT());
		writeD(_cha.getMEN());
		writeD(_cha.getMaxHp());
		writeD((int) _cha.getCurrentHp());
		writeD(_cha.getMaxMp());
		writeD((int) _cha.getCurrentMp());
		writeD(_cha.getSp());
		writeD(_cha.getCurrentLoad());
		writeD(_cha.getMaxLoad());
		writeD(0x28); // unknown
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_DHAIR));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_REAR));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_LEAR));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_NECK));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_RFINGER));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_LFINGER));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_HEAD));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_RHAND));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_LHAND));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_GLOVES));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_CHEST));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_LEGS));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_FEET));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_BACK));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_LRHAND));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_HAIR));
		writeD(_cha.getInventory().getPaperdollObjectId(Inventory.PAPERDOLL_FACE));

		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_DHAIR));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_REAR));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_LEAR));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_NECK));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_RFINGER));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_LFINGER));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_HEAD));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_RHAND));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_LHAND));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_GLOVES));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_CHEST));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_LEGS));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_FEET));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_BACK));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_LRHAND));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_HAIR));
		writeD(_cha.getInventory().getPaperdollItemId(Inventory.PAPERDOLL_FACE));

		for(int i = 0; i < 34; i++)
			writeH(0);

		writeD(_cha.getPAtk(null));
		writeD(_cha.getPAtkSpd());
		writeD(_cha.getPDef(null));
		writeD(_cha.getEvasionRate(null));
		writeD(_cha.getAccuracy());
		writeD(_cha.getCriticalHit(null, null));
		writeD(_cha.getMAtk(null, null));

		writeD(_cha.getMAtkSpd());
		writeD(_cha.getPAtkSpd());

		writeD(_cha.getMDef(null, null));

		writeD(_cha.getPvpFlag()); // 0-non-pvp  1-pvp = violett name
		writeD(_cha.getKarma());

		writeD(_cha.getRunSpeed());
		writeD(_cha.getWalkSpeed());
		writeD(_cha.getSwimSpeed()); // swimspeed
		writeD(_cha.getSwimSpeed()); // swimspeed
		writeD(_cha.getRunSpeed());
		writeD(_cha.getWalkSpeed());
		writeD(_cha.getRunSpeed());
		writeD(_cha.getWalkSpeed());
		writeF(_cha.getMovementSpeedMultiplier());
		writeF(_cha.getAttackSpeedMultiplier());

		if(_cha.getMountType() != 0 && _cha.getPet() != null)
		{
			writeF(_cha.getPet().getTemplate().collisionRadius);
			writeF(_cha.getPet().getTemplate().collisionHeight);
		}
		else
		{
			writeF(_cha.getTemplate().collisionRadius);
			writeF(_cha.getTemplate().collisionHeight);
		}

		writeD(_cha.getHairStyle());
		writeD(_cha.getHairColor());
		writeD(_cha.getFace());
		writeD(_cha.isGM() ? 1 : 0); // builder level

		writeS(_cha.getTitle());
		writeD(_cha.getClanId()); // pledge id
		writeD(_cha.getClanCrestId()); // pledge crest id
		writeD(_cha.getAllyId()); // ally id 
		writeC(_cha.getMountType()); // mount type
		writeC(_cha.getPrivateStoreType());
		writeC(Math.max(_cha.getSkillLevel((short) 1320), 0)); //_cha.getDwarvenCraftLevel() > 0 ? 1 : 0
		writeD(_cha.getPkKills());
		writeD(_cha.getPvpKills());

		writeH(_cha.getRecomLeft());
		writeH(_cha.getRecomHave()); //Blue value for name (0 = white, 255 = pure blue)
		writeD(_cha.getClassId().getId());
		writeD(0x00); // special effects? circles around player... 
		writeD(_cha.getMaxCp());
		writeD((int) _cha.getCurrentCp());

		writeC(_cha.isRunning() ? 1 : 0); //changes the Speed display on Status Window
		writeC(321);
		writeD(_cha.getPledgeClass()); //changes the text above CP on Status Window
		writeC(_cha.isNoble() ? 0x01 : 0x00);
		writeC(_cha.isHero() ? 0x01 : 0x00);
		writeD(_cha.getNameColor());
		writeD(_cha.getTitleColor());
	}

	@Override
	public String getType()
	{
		return _S__8F_GMVIEWCHARACTERINFO;
	}
}
