package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2ClanMember;
import L2jFT.game.model.L2Player;

public class GMViewPledgeInfo extends L2GameServerPacket
{
	private static final String _S__90_GMVIEWPLEDGEINFO = "[S] 90 GMViewPledgeInfo";
	private L2Clan _clan;
	private L2Player _activeChar;

	public GMViewPledgeInfo(L2Clan clan, L2Player activeChar)
	{
		_clan = clan;
		_activeChar = activeChar;
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0x90);
		writeS(_activeChar.getName());
		writeD(_clan.getClanId());
		writeD(0x00);
		writeS(_clan.getName());
		writeS(_clan.getLeaderName());
		writeD(_clan.getCrestId()); // no longer used?
		writeD(_clan.getLevel());
		writeD(_clan.getHasCastle());
		writeD(_clan.getHasHideout());
		writeD(_clan.getRank());
		writeD(_clan.getReputationScore());
		writeD(0);
		writeD(0);

		writeD(_clan.getAllyId());
		if(_clan.getAlliance() != null)
		{
			writeS(_clan.getAlliance().getAllyName());
			writeD(_clan.getAlliance().getAllyCrestId());
		}
		else
		{
			writeS("");
			writeD(0);
		}
		writeD(_clan.isAtWar());

		L2ClanMember[] members = _clan.getMembers();
		writeD(members.length);

		for(L2ClanMember member : members)
		{
			writeS(member.getName());
			writeD(member.getLevel());
			writeD(member.getClassId());
			writeD(0);
			writeD(1);
			writeD(member.isOnline() ? member.getObjectId() : 0);
			writeD(0);
		}
	}

	@Override
	public String getType()
	{
		return _S__90_GMVIEWPLEDGEINFO;
	}
}