package L2jFT.game.network.serverpackets;

import javolution.util.FastList;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestDropInfo;
import L2jFT.game.model.quest.QuestState;

@SuppressWarnings( { "nls", "unqualified-field-access", "boxing" })
public class GMViewQuestInfo extends L2GameServerPacket
{
	private static final String _S__93_GMVIEWQUESTINFO = "[S] 93 GMViewQuestInfo";

	private final L2Player _cha;

	public GMViewQuestInfo(L2Player cha)
	{
		_cha = cha;
	}

	@Override
	public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0x93);
		writeS(_cha.getName());

		Quest[] quests = _cha.getAllActiveQuests();
		if(quests.length == 0)
		{
			writeH(0);
			writeH(0);
			return;
		}

		writeH(quests.length);

		FastList<QuestDropInfo> questDrops = new FastList<QuestDropInfo>();
		int dropItemsCount = 0;
		for(Quest q : quests)
		{
			writeD(q.getQuestIntId());
			QuestState qs = _cha.getQuestState(q.getName());
			if(qs == null)
				continue;

			writeD(qs.getInt("cond"));

			QuestDropInfo newQDrop = new QuestDropInfo(_cha, q.getName());
			dropItemsCount += newQDrop.dropList.size();
			questDrops.add(newQDrop);
		}

		writeH(dropItemsCount);
		for(QuestDropInfo currQDropInfo : questDrops)
			for(QuestDropInfo.DropInfo itemDropInfo : currQDropInfo.dropList)
			{
				writeD(itemDropInfo.dropItemObjID);
				writeD(itemDropInfo.dropItemID);
				writeD(itemDropInfo.dropItemCount);
				writeD(5); // what is that?
			}
	}

	@Override
	public String getType()
	{
		return _S__93_GMVIEWQUESTINFO;
	}
}