package L2jFT.game.network.serverpackets;

import javolution.util.FastList;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.quest.Quest;
import L2jFT.game.model.quest.QuestDropInfo;
import L2jFT.game.model.quest.QuestState;

import java.util.List;

/**
 * Sh (dd) h (dddd)
 * @author Tempy
 */
public class GMViewQuestList extends L2GameServerPacket
{
	private static final String _S__AC_GMVIEWQUESTLIST = "[S] ac GMViewQuestList";

	private L2Player _activeChar;

	public GMViewQuestList(L2Player cha)
	{
		_activeChar = cha;
	}

	@Override
	public void runImpl()
	{

	}

	@Override
	protected final void writeImpl()
	{

		writeC(0x93);
		writeS(_activeChar.getName());

		Quest[] questList = _activeChar.getAllActiveQuests();

		if(questList.length == 0)
		{
			writeC(0);
			writeH(0);
			writeH(0);
			return;
		}

		writeH(questList.length); // quest count

		for(Quest q : questList)
		{
			writeD(q.getQuestIntId());

			QuestState qs = _activeChar.getQuestState(q.getName());

			if(qs == null)
			{
				writeD(0);
				continue;
			}

			writeD(qs.getInt("cond")); // stage of quest progress
		}

		//Prepare info about all quests
		List<QuestDropInfo> questDrops = new FastList<QuestDropInfo>();
		int FullCountDropItems = 0;

		for(Quest q : questList)
		{
			QuestDropInfo newQDrop = new QuestDropInfo(_activeChar, q.getName());
			//Calculate full count drop items
			FullCountDropItems += newQDrop.dropList.size();

			questDrops.add(newQDrop);
		}

		writeH(FullCountDropItems);

		for(QuestDropInfo currQDropInfo : questDrops)
			for(QuestDropInfo.DropInfo itemDropInfo : currQDropInfo.dropList)
			{
				writeD(itemDropInfo.dropItemObjID);
				writeD(itemDropInfo.dropItemID);
				writeD(itemDropInfo.dropItemCount);
				writeD(5); // ??                        
			}
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.serverpackets.L2GameServerPacket#getType()
	 */
	@Override
	public String getType()
	{
		return _S__AC_GMVIEWQUESTLIST;
	}
}
