package L2jFT.game.network.serverpackets;

import java.util.Collection;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2Skill;

public class GMViewSkillInfo extends L2GameServerPacket
{
	private static final String _S__91_GMViewSkillInfo = "[S] 91 GMViewSkillInfo";
	private L2Player _cha;
	private Collection<L2Skill> _skills;

	public GMViewSkillInfo(L2Player cha)
	{
		_cha = cha;
		_skills = _cha.getAllSkills();
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0x91);
		writeS(_cha.getName());
		writeD(_skills.size());

		for(L2Skill skill : _skills)
		{
			if(skill.getId() > 9000)
				continue; // fake skills to change base stats

			writeD((skill.isPassive() || skill.isOnAttack()) ? 1 : 0);
			writeD(skill.getLevel());
			writeD(skill.getId());
			writeC(0x00); //c5
		}
	}

	@Override
	public String getType()
	{
		return _S__91_GMViewSkillInfo;
	}
}