package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.model.instances.L2ItemInstance.ItemClass;
import L2jFT.game.templates.L2Item;
import L2jFT.game.templates.L2Weapon;

public class GMViewWarehouseWithdrawList extends L2GameServerPacket
{
	private static final String _S__95_GMViewWarehouseWithdrawList = "[S] 95 GMViewWarehouseWithdrawList";
	private final L2ItemInstance[] _items;
	private final L2Player _cha;

	public GMViewWarehouseWithdrawList(L2Player cha)
	{
		_cha = cha;
		_items = _cha.getWarehouse().listItems(ItemClass.ALL);
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0x95);
		writeS(_cha.getName());
		//writeH(0x01);
		writeD(_cha.getAdena());
		writeH(_items.length);

		for(L2ItemInstance temp : _items)
		{
			writeH(temp.getItem().getType1());
			writeD(temp.getObjectId());
			writeD(temp.getItemId());
			writeD(temp.getCount());
			writeH(temp.getItem().getType2());
			writeH(temp.getCustomType1());
			switch(temp.getItem().getType2())
			{
				case L2Item.TYPE2_WEAPON:
					writeD(temp.getBodyPart()); // ? 
					writeH(temp.getEnchantLevel()); // enchant level -confirmed 
					writeH(((L2Weapon) temp.getItem()).getSoulShotCount()); // ? 
					writeH(((L2Weapon) temp.getItem()).getSpiritShotCount()); // ? 
					break;
				case L2Item.TYPE2_SHIELD_ARMOR:
				case L2Item.TYPE2_ACCESSORY:
					writeD(temp.getItem().getBodyPart()); // ? 
					writeH(temp.getEnchantLevel()); // enchant level -confirmed 
					writeH(0x00); // ? 
					writeH(0x00); // ? 
					break;
			}
			writeD(temp.getObjectId());
			if(temp.isAugmented())
			{
				writeH(0);
				writeD(temp.getAugmentation().getAugmentationId());
				writeH(0);
			}
			else
			{
				writeD(0);
				writeD(temp.getLifeTimeRemaining());
			}
		}
	}

	@Override
	public String getType()
	{
		return _S__95_GMViewWarehouseWithdrawList;
	}
}