package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2BoatInstance;

/**
 * @author Maktakien
 *
 */
public class GetOffVehicle extends L2GameServerPacket
{
	private int _x;
	private int _y;
	private int _z;
	private L2Player _pci;
	private L2BoatInstance _boat;

	/**
	 * @param activeChar
	 * @param boat
	 * @param x
	 * @param y
	 * @param z
	 */
	public GetOffVehicle(L2Player activeChar, L2BoatInstance boat, int x, int y, int z)
	{
		_pci = activeChar;
		_boat = boat;
		_x = x;
		_y = y;
		_z = z;

		_pci.setInBoat(false);
		_pci.setBoat(null);
	}

	@Override
	public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0x5D);
		writeD(_pci.getObjectId());
		writeD(_boat.getObjectId());
		writeD(_x);
		writeD(_y);
		writeD(_z);

	}

	@Override
	public String getType()
	{
		return "[S] 5D GetOffVehicle";
	}

}
