package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2HennaInstance;

import java.util.HashSet;

public class HennaEquipList extends L2GameServerPacket
{
	private static final String _S__E2_HennaEquipList = "[S] E2 HennaEquipList";

	private L2Player _player;
	private L2HennaInstance[] _hennaEquipList;

	public HennaEquipList(L2Player player, L2HennaInstance[] hennaEquipList)
	{
		_player = player;
		_hennaEquipList = hennaEquipList;
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0xE2);
		writeD(_player.getAdena());
		writeD(_player.getHennaEmptySlots());

		HashSet<L2HennaInstance> availHenna = new HashSet<L2HennaInstance>();

		for(L2HennaInstance element : _hennaEquipList)
			if(_player.getInventory().findItemByItemId(element.getItemIdDye()) != null)
				availHenna.add(element);

		if(availHenna.size() != 0)
		{
			writeD(availHenna.size());
			for(L2HennaInstance henna : availHenna)
			{
				writeD(henna.getSymbolId()); //symbolid
				writeD(henna.getItemIdDye()); //itemid of dye
				writeD(henna.getAmountDyeRequire()); //amount of dye require
				writeD(henna.getPrice()); //amount of aden require
				writeD(1); //meet the requirement or not
			}
		}
		else
		{
			writeD(0x01);
			writeD(0x00);
			writeD(0x00);
			writeD(0x00);
			writeD(0x00);
			writeD(0x00);
		}
	}

	@Override
	public String getType()
	{
		return _S__E2_HennaEquipList;
	}
}
