package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2HennaInstance;

public class HennaInfo extends L2GameServerPacket
{

	private static final String _S__E4_HennaInfo = "[S] E4 HennaInfo";

	private final L2Player _player;
	private final L2HennaInstance[] _hennas = new L2HennaInstance[3];
	private int _count;

	public HennaInfo(L2Player player)
	{
		_player = player;

		int j = 0;
		for(int i = 0; i < 3; i++)
		{
			L2HennaInstance h = _player.getHenna(i + 1);
			if(h != null)
				_hennas[j++] = h;
		}
		_count = j;
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{

		writeC(0xE4);
		writeC(_player.getHennaStatINT()); //equip INT
		writeC(_player.getHennaStatSTR()); //equip STR
		writeC(_player.getHennaStatCON()); //equip CON
		writeC(_player.getHennaStatMEN()); //equip MEM
		writeC(_player.getHennaStatDEX()); //equip DEX
		writeC(_player.getHennaStatWIT()); //equip WIT

		writeD(3); //interlude, slots?

		writeD(_count);
		for(int i = 0; i < _count; i++)
			if(_hennas[i] != null)
			{
				writeD(_hennas[i].getSymbolId());
				writeD(_hennas[i].getSymbolId());
			}
	}

	@Override
	public String getType()
	{
		return _S__E4_HennaInfo;
	}
}