package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2HennaInstance;

public class HennaItemInfo extends L2GameServerPacket
{

	private static final String _S__E3_HennaItemInfo = "[S] E3 HennaItemInfo";

	private L2Player _player;
	private L2HennaInstance _henna;

	public HennaItemInfo(L2HennaInstance henna, L2Player player)
	{
		_henna = henna;
		_player = player;
	}

	@Override
	final public void runImpl()
	{
	// no long-running tasks
	}

	@Override
	protected final void writeImpl()
	{

		writeC(0xE3);
		writeD(_henna.getSymbolId()); //symbol Id
		writeD(_henna.getItemIdDye()); //item id of dye
		writeD(_henna.getAmountDyeRequire()); // total amount of dye require
		writeD(_henna.getPrice()); //total amount of aden require to draw symbol
		writeD(1); //able to draw or not 0 is false and 1 is true 
		writeD(_player.getAdena());

		writeD(_player.getINT()); //current INT
		writeC(_player.getINT() + _henna.getStatINT()); //equip INT
		writeD(_player.getSTR()); //current STR
		writeC(_player.getSTR() + _henna.getStatSTR()); //equip STR
		writeD(_player.getCON()); //current CON
		writeC(_player.getCON() + _henna.getStatCON()); //equip CON
		writeD(_player.getMEN()); //current MEM
		writeC(_player.getMEN() + _henna.getStatMEM()); //equip MEM
		writeD(_player.getDEX()); //current DEX
		writeC(_player.getDEX() + _henna.getStatDEX()); //equip DEX
		writeD(_player.getWIT()); //current WIT
		writeC(_player.getWIT() + _henna.getStatWIT()); //equip WIT
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.serverpackets.L2GameServerPacket#getType()
	 */
	@Override
	public String getType()
	{
		return _S__E3_HennaItemInfo;
	}
}
