package L2jFT.game.network.serverpackets;

import javolution.util.FastList;
import L2jFT.game.model.L2Character;

public class MagicSkillLaunched extends L2GameServerPacket
{
	private static final String _S__76_MAGICSKILLLAUNCHED = "[S] 76 MagicSkillLaunched";
	private final int _casterId;
	private final int _skillId;
	private final int _skillLevel;
	private final FastList<L2Character> _targets;

	public MagicSkillLaunched(int casterId, int skillId, int skillLevel, L2Character target)
	{
		_casterId = casterId;
		_skillId = skillId;
		_skillLevel = skillLevel;
		_targets = new FastList<L2Character>();
		_targets.add(target);
	}

	public MagicSkillLaunched(int casterId, int skillId, int skillLevel, FastList<L2Character> targets)
	{
		_casterId = casterId;
		_skillId = skillId;
		_skillLevel = skillLevel;
		_targets = targets;
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0x76);
		writeD(_casterId);
		writeD(_skillId);
		writeD(_skillLevel);
		writeD(_targets.size());
		for(FastList.Node<L2Character> n = _targets.head(), end = _targets.tail(); (n = n.getNext()) != end;)
			writeD(n.getValue().getObjectId());
	}

	@Override
	public String getType()
	{
		return _S__76_MAGICSKILLLAUNCHED;
	}
}
