package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Clan.RankPrivs;
import L2jFT.game.model.L2Player;

public class ManagePledgePower extends L2GameServerPacket
{
	private static final String _S__30_MANAGEPLEDGEPOWER = "[S] 30 ManagePledgePower";

	private int _action;
	private int _clanId;
	private L2Player _player;
	private int privs;

	public ManagePledgePower(int clanId, int action, L2Player player)
	{
		_clanId = clanId;
		_action = action;
		_player = player;
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x30);
		RankPrivs temp = _player.getClan().getRankPrivs(_clanId);
		if(temp != null)
			privs = temp.getPrivs();
		else
			privs = 0;
		writeD(_clanId);
		writeD(_action);
		writeD(privs);
		_player.sendPacket(new ExPledgeRankPrivilegies(privs));
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.serverpackets.L2GameServerPacket#getType()
	 */
	@Override
	public String getType()
	{
		return _S__30_MANAGEPLEDGEPOWER;
	}

}
