package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;

/**
 *
 * 0000: 76  7a 07 80 49  ea 01 00 00  c1 37 fe    uz..Ic'.J.....7. <p>
 * 0010: ff 9e c3 03 00 8f f3 ff ff                         .........<p>
 * <p>
 *
 * format   dddddd      (player id, target id, distance, startx, starty, startz)<p>
 *
 *
 * @version $Revision: 1.1.2.1.2.3 $ $Date: 2005/03/27 15:29:57 $
 */
public class MoveOnVehicle extends L2GameServerPacket
{
	private static final String _S__71_MOVEONVEICLE = "[S] 71 MoveOnVehicle";
	private int _id;
	private int _x, _y, _z;
	private L2Player _player;

	public MoveOnVehicle(int vehicleID, L2Player player, int x, int y, int z)
	{
		_id = vehicleID;
		_player = player;
		_x = x;
		_y = y;
		_z = z;
	}

	@Override
	final public void runImpl()
	{
	// no long-running tasks
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x71);

		writeD(_player.getObjectId());
		writeD(_id);
		writeD(_x);
		writeD(_y);
		writeD(_z);
		writeD(_player.getX());
		writeD(_player.getY());
		writeD(_player.getZ());
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.serverpackets.L2GameServerPacket#getType()
	 */
	@Override
	public String getType()
	{
		return _S__71_MOVEONVEICLE;
	}
}