package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Player;
import L2jFT.util.CharPosition;
import L2jFT.util.Util;

/**
 * @author Maktakien
 *
 */
public class MoveToLocationInVehicle extends L2GameServerPacket
{
	L2Player _pci;
	CharPosition _destination;
	CharPosition _origin;

	/**
	 * @param actor
	 * @param destination
	 * @param origin
	 */
	public MoveToLocationInVehicle(L2Character actor, CharPosition destination, CharPosition origin)
	{
		_pci = (L2Player) actor;
		if(_pci.getBoat() == null)
		{
			Util.handleIllegalPlayerAction(_pci, "MoveLocationInVehicle", " tried to move on non-exist boat. Maybe packet cheater.", 0);
			return;
		}
		_destination = destination;
		_origin = origin;
	}

	@Override
	public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		if(_pci == null || _pci.getBoat() == null)
			return;
		writeC(0x71);
		writeD(_pci.getObjectId());
		writeD(_pci.getBoat().getObjectId());
		writeD(_destination.x);
		writeD(_destination.y);
		writeD(_destination.z);
		writeD(_origin.x);
		writeD(_origin.y);
		writeD(_origin.z);
	}

	@Override
	public String getType()
	{
		return "[S] 71 MoveToLocationInVehicle";
	}
}