package L2jFT.game.network.serverpackets;

import javolution.util.FastList;
import L2jFT.Config;
import L2jFT.game.model.Inventory;
import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2Multisell;
import L2jFT.game.model.L2Multisell.MultiSellListContainer;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.base.MultiSellEntry;
import L2jFT.game.model.base.MultiSellIngredient;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.tables.ItemTable;
import L2jFT.game.templates.L2Item;
import L2jFT.game.templates.L2Weapon;
import L2jFT.game.templates.L2Weapon.WeaponType;

import java.util.HashSet;

public class MultiSellList extends L2GameServerPacket
{
	private static final String _S__D0_MULTISELLLIST = "[S] D0 MultiSellList";

	private int _listId;
	private final FastList<MultiSellEntry> _possiblelist = new FastList<MultiSellEntry>();

	public MultiSellList(final L2Player player, final int listId, final double taxRate)
	{
		if(player == null)
			return;

		// Hardcoded  - обмен вещей на равноценные
		HashSet<L2ItemInstance> _items;
		if(listId == 9999)
		{
			_listId = 9999;
			final Inventory inv = player.getInventory();
			_items = new HashSet<L2ItemInstance>();
			for(final L2ItemInstance itm : inv.getItems())
				if(!itm.isStackable() && itm.getItem().getType2() == 0 && itm.getItem().getCrystalType() > L2Item.CRYSTAL_NONE && itm.getItem().getCrystalType() <= Config.ALT_MAMMOTH_EXCHANGE && itm.getItem().getCrystalCount() > 0 && !itm.isShadowItem() && !itm.isEquipped())
					_items.add(itm);

			for(final L2ItemInstance itm : _items)
				for(L2Weapon i : ItemTable.getInstance().getAllWeapons())
					if(!i.isSa() && i.getItemId() != itm.getItemId() && i.getItemType() == WeaponType.DUAL == (itm.getItem().getItemType() == WeaponType.DUAL) && itm.getItem().getCrystalType() == i.getCrystalType() && itm.getItem().getCrystalCount() == i.getCrystalCount() && !i.isShadowItem())
					{
						final int entry = itm.getItemId() + i.getItemId() * 10000 + Math.min(itm.getEnchantLevel(), 20) * 100000000;
						MultiSellEntry possibleEntry = new MultiSellEntry(entry, i.getItemId(), 1, itm.getEnchantLevel());
						possibleEntry.addIngredient(new MultiSellIngredient(itm.getItemId(), 1, itm.getEnchantLevel()));
						_possiblelist.add(possibleEntry);
					}
		}
		// Hardcoded  - обмен вещей с доплатой за AA
		else if(listId == 9998)
		{
			_listId = 9998;
			final Inventory inv = player.getInventory();
			_items = new HashSet<L2ItemInstance>();
			for(final L2ItemInstance itm : inv.getItems())
				if(!itm.isStackable() && itm.getItem().getType2() == L2Item.TYPE2_WEAPON && itm.getItem().getCrystalType() > L2Item.CRYSTAL_NONE && itm.getItem().getCrystalType() <= Config.ALT_MAMMOTH_UPGRADE && itm.getItem().getCrystalCount() > 0 && !itm.isShadowItem() && !itm.isEquipped())
					_items.add(itm);

			for(final L2ItemInstance itemtosell : _items)
				for(final L2Weapon itemtobuy : ItemTable.getInstance().getAllWeapons())
					if(!itemtobuy.isSa() && itemtobuy.getType2() == L2Item.TYPE2_WEAPON && itemtobuy.getItemType() == WeaponType.DUAL == (itemtosell.getItem().getItemType() == WeaponType.DUAL) && itemtobuy.getCrystalType() >= itemtosell.getItem().getCrystalType() && itemtobuy.getCrystalType() <= Config.ALT_MAMMOTH_UPGRADE && itemtosell.getItem().getReferencePrice() < itemtobuy.getReferencePrice() && itemtosell.getReferencePrice() * 1.7 > itemtobuy.getReferencePrice() && !itemtobuy.isShadowItem())
					{
						final int entry = itemtosell.getItemId() + itemtobuy.getItemId() * 10000 + Math.min(itemtosell.getEnchantLevel(), 20) * 100000000;
						MultiSellEntry possibleEntry = new MultiSellEntry(entry, itemtobuy.getItemId(), 1, 0);
						possibleEntry.addIngredient(new MultiSellIngredient(itemtosell.getItemId(), 1, itemtosell.getEnchantLevel()));
						possibleEntry.addIngredient(new MultiSellIngredient((short) 5575, (int) ((itemtobuy.getReferencePrice() - itemtosell.getReferencePrice()) * 1.2), 0));
						_possiblelist.add(possibleEntry);
					}
		}
		// Hardcoded  - обмен вещей на кристаллы
		else if(listId == 9997)
		{
			_listId = 9997;
			final Inventory inv = player.getInventory();
			for(final L2ItemInstance itm : inv.getItems())
				if(!itm.isStackable() && itm.getItem().getCrystalType() != L2Item.CRYSTAL_NONE && itm.getItem().getCrystalCount() > 0 && !itm.isShadowItem() && !itm.isEquipped())
				{
					final L2Item crystal = ItemTable.getInstance().getTemplate(itm.getItem().getCrystalType() + 1457);
					final int entry = itm.getItemId() + Math.min(itm.getEnchantLevel(), 20) * 100000000;
					MultiSellEntry possibleEntry = new MultiSellEntry(entry, crystal.getItemId(), itm.getItem().getCrystalCount(), 0);
					possibleEntry.addIngredient(new MultiSellIngredient(itm.getItemId(), 1, itm.getEnchantLevel()));
					possibleEntry.addIngredient(new MultiSellIngredient((short) 57, (int) (itm.getItem().getCrystalCount() * crystal.getReferencePrice() * 0.1), 0));
					_possiblelist.add(possibleEntry);
				}
		}
		else
		{
			_listId = listId;
			MultiSellListContainer _container = L2Multisell.getInstance().getList(_listId);
			if(_container == null)
				return;
			FastList<MultiSellEntry> _fulllist = _container.getEntries();
			boolean _enchant = _container.getKeepEnchant();
			final Inventory inv = player.getInventory();

			for(FastList.Node<MultiSellEntry> n = _fulllist.head(), end = _fulllist.tail(); (n = n.getNext()) != end;)
			{
				MultiSellEntry ent = n.getValue();
				double tax = 0;

				// Обработка налога, если лист не безналоговый
				FastList<MultiSellIngredient> ingridients;
				if(!_container.getNoTax() && taxRate > 0.)
				{
					ingridients = new FastList<MultiSellIngredient>();
					for(FastList.Node<MultiSellIngredient> sn = ent.getIngredients().head(), send = ent.getIngredients().tail(); (sn = sn.getNext()) != send;)
					{
						MultiSellIngredient i = sn.getValue();

						if(i.getItemId() == 57)
						{
							tax += i.getItemCount() * (taxRate + 1);
							continue;
						}
						ingridients.add(i);
						if(i.getItemId() == L2Clan.CLAN_REPUTATION_SCORE_ITEM)
						{
							// hardcoded. Налог на клановую репутацию. Формула проверена на с6 и соответсвует на 100%.
							tax += i.getItemCount() / 120 * 1000 * taxRate * 100;
							continue;
						}

						final L2Item item = ItemTable.getInstance().getTemplate(i.getItemId());
						if(item.isStackable())
							tax += item.getReferencePrice() * i.getItemCount() * taxRate;
					}

					if(tax >= 1)
						ingridients.add(new MultiSellIngredient(57, (int) tax));
				}
				else
					ingridients = ent.getIngredients();

				// Если стоит флаг "показывать все" не проверять наличие ингридиентов
				if(_container.getShowAll())
				{
					MultiSellEntry possibleEntry = new MultiSellEntry(ent.getEntryId());
					for(MultiSellIngredient p : ent.getProduction())
						possibleEntry.addProduct(p);
					for(FastList.Node<MultiSellIngredient> sn = ingridients.head(), send = ingridients.tail(); (sn = sn.getNext()) != send;)
						possibleEntry.addIngredient(sn.getValue());
					_possiblelist.add(possibleEntry);
				}
				else
				{
					HashSet<Integer> _itm = new HashSet<Integer>();
					// Проверка наличия у игрока ингридиентов
					for(FastList.Node<MultiSellIngredient> sn = ingridients.head(), send = ingridients.tail(); (sn = sn.getNext()) != send;)
					{
						MultiSellIngredient i = sn.getValue();
						L2Item template = i.getItemId() == L2Clan.CLAN_REPUTATION_SCORE_ITEM ? null : ItemTable.getInstance().getTemplate(i.getItemId());
						if(i.getItemId() == L2Clan.CLAN_REPUTATION_SCORE_ITEM || template.getType2() <= L2Item.TYPE2_ACCESSORY || template.getType2() >= (_container.nokey ? L2Item.TYPE2_OTHER : L2Item.TYPE2_PET_WOLF)) // Экипировка
						{
							if(i.getItemId() == L2Clan.CLAN_REPUTATION_SCORE_ITEM)
							{
								//TODO: а мы должны тут сверять count?
								if(!_itm.contains(i.getItemId()) && player.getClan() != null && player.getClan().getReputationScore() >= i.getItemCount())
									_itm.add(i.getItemId());
								continue;
							}

							for(final L2ItemInstance item : inv.getItems())
								if(item.getItemId() == i.getItemId() && !item.isEquipped())
								{
									if(_itm.contains(_enchant ? i.getItemId() + i.getItemEnchant() * 10000 : i.getItemId())) // Не проверять одинаковые вещи
										continue;

									if(item.isStackable() && item.getCount() < i.getItemCount())
										break;

									_itm.add(_enchant ? i.getItemId() + i.getItemEnchant() * 10000 : i.getItemId());
									MultiSellEntry possibleEntry = new MultiSellEntry(_enchant ? ent.getEntryId() + item.getEnchantLevel() * 10000 : ent.getEntryId());

									for(MultiSellIngredient p : ent.getProduction())
										possibleEntry.addProduct(p);

									for(FastList.Node<MultiSellIngredient> ssn = ingridients.head(), ssend = ingridients.tail(); (ssn = ssn.getNext()) != ssend;)
									{
										MultiSellIngredient ig = ssn.getValue();

										if(template != null && template.getType2() <= L2Item.TYPE2_ACCESSORY)
											ig.setItemEnchant(item.getEnchantLevel());

										possibleEntry.addIngredient(ig);
									}
									_possiblelist.add(possibleEntry);
									break;
								}
						}
					}
				}
			}
		}
	}

	@Override
	public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		// [ddddd] [dchh] [hdhdh] [hhdh]

		writeC(0xD0);
		writeD(_listId); // list id
		writeD(1); // ?
		writeD(1); // ?
		writeD(0x1c); // ?
		writeD(_possiblelist != null ? _possiblelist.size() : 0); //list lenght

		if(_possiblelist == null)
			return;

		for(FastList.Node<MultiSellEntry> n = _possiblelist.head(), end = _possiblelist.tail(); (n = n.getNext()) != end;)
		{
			MultiSellEntry ent = n.getValue();
			writeD(ent.getEntryId());
			writeD(0x00); // C6
			writeD(0x00); // C6
			writeC(1);
			writeH(ent.getProduction().size());
			writeH(ent.getIngredients().size());

			for(MultiSellIngredient prod : ent.getProduction())
			{
				L2Item template = ItemTable.getInstance().getTemplate(prod.getItemId());
				if(template == null)
					continue;
				writeH(prod.getItemId());
				writeD(0);
				writeH(template.getType2());
				writeD(prod.getItemCount());
				writeH(prod.getItemEnchant());
				writeD(0x00); // C6
				writeD(0x00); // C6
			}

			for(FastList.Node<MultiSellIngredient> sn = ent.getIngredients().head(), send = ent.getIngredients().tail(); (sn = sn.getNext()) != send;)
			{
				MultiSellIngredient i = sn.getValue();
				int itemId = i.getItemId();
				final L2Item item = itemId != L2Clan.CLAN_REPUTATION_SCORE_ITEM ? ItemTable.getInstance().getTemplate(i.getItemId()) : null;
				writeH(itemId); //ID
				writeH(itemId != L2Clan.CLAN_REPUTATION_SCORE_ITEM ? item.getType2() : 0xffff);
				writeD(i.getItemCount()); //Count
				writeH((itemId != L2Clan.CLAN_REPUTATION_SCORE_ITEM ? item.getType2() : 0x00) <= L2Item.TYPE2_ACCESSORY ? i.getItemEnchant() : 0); //Enchant Level
				writeD(0x00); // C6
				writeD(0x00); // C6
			}
		}
	}

	@Override
	public String getType()
	{
		return _S__D0_MULTISELLLIST;
	}
}
