package L2jFT.game.network.serverpackets;

import java.util.HashMap;

/**
 * Format: (c) d[dS]
 * d: list size
 * [
 *   d: char ID
 *   S: char Name
 * ]
 *
 * Пример с оффа:
 * C2 02 00 00 00 D0 33 08 00 43 00 4B 00 4A 00 49 00 41 00 44 00 75 00 4B 00 00 00 D0 A7 09 00 53 00 65 00 6B 00 61 00 73 00 00 00
 */
public class PackageToList extends L2GameServerPacket
{
	private static final String _S__C2_PACKAGETOLIST = "[S] C2 PackageToList";

	@Override
	public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		HashMap<Integer, String> characters = getClient().getActiveChar().getAccountChars();

		// No other chars in the account of this player
		if(characters.size() < 1)
		{
			getClient().getActiveChar().sendPacket(new SystemMessage(SystemMessage.THAT_CHARACTER_DOES_NOT_EXIST));
			return;
		}

		writeC(0xC2);
		writeD(characters.size());
		for(Integer objectId : characters.keySet())
		{
			writeD(objectId); // Character object id
			writeS(characters.get(objectId)); // Character name
		}
	}

	@Override
	public String getType()
	{
		return _S__C2_PACKAGETOLIST;
	}
}