package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;

/**
 *
 *
 * sample
 * b0 
 * d8 a8 10 48  objectId 
 * 00 00 00 00 
 * 00 00 00 00 
 * 00 00  
 *
 * format   ddddS
 *
 * @version $Revision: 1.1.2.1.2.3 $ $Date: 2005/03/27 15:29:39 $
 */
public class PartyMatchDetail extends L2GameServerPacket
{
	private static final String _S__97_PARTYMATCHDETAIL = "[S] 97 PartyMatchDetail";
	private L2Player _player;

	/**
	 * @param allPlayers
	 */
	public PartyMatchDetail(L2Player player)
	{
		_player = player;
	}

	@Override
	final public void runImpl()
	{
	// no long-running tasks
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x97);

		writeD(_player.getObjectId());
		if(_player.isPartyMatchingShowLevel())
			writeD(1); // show level
		else
			writeD(0); // hide level 

		if(_player.isPartyMatchingShowClass())
			writeD(1); // show class
		else
			writeD(0); // hide class

		writeD(0); //c2

		writeS("  " + _player.getPartyMatchingMemo()); // seems to be bugged.. first 2 chars get stripped away
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.serverpackets.L2GameServerPacket#getType()
	 */
	@Override
	public String getType()
	{
		return _S__97_PARTYMATCHDETAIL;
	}
}
