package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;

import java.util.ArrayList;

/**
 *
 *
 * sample
 * 63 
 * 01 00 00 00  count 
 *
 * c1 b2 e0 4a  object id
 * 54 00 75 00 65 00 73 00 64 00 61 00 79 00 00 00  name
 * 5a 01 00 00  hp
 * 5a 01 00 00  hp max
 * 89 00 00 00  mp
 * 89 00 00 00  mp max
 * 0e 00 00 00  level 
 * 12 00 00 00  class
 * 00 00 00 00  
 * 01 00 00 00
 *
 *
 * format   d (dSdddddddd)
 *
 *
 * @version $Revision: 1.6.2.1.2.5 $ $Date: 2005/03/27 15:29:57 $
 */
public class PartySmallWindowAll extends L2GameServerPacket
{
	private static final String _S__4E_PARTYSMALLWINDOWALL = "[S] 4E PartySmallWindowAll";
	private ArrayList<L2Player> _partyMembers = new ArrayList<L2Player>();

	public PartySmallWindowAll setPartyList(ArrayList<L2Player> party)
	{
		_partyMembers = party;
		return this;
	}

	@Override
	final public void runImpl()
	{
	// no long-running tasks
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x4E);
		L2Player player = getClient().getActiveChar();
		writeD(_partyMembers.get(0).getObjectId()); // c3 party leader id
		writeD(_partyMembers.get(0).getParty().getLootDistribution());//c3 party loot type (0,1,2,....)
		writeD(_partyMembers.size() - 1);

		for(int i = 0; i < _partyMembers.size(); i++)
		{
			L2Player member = _partyMembers.get(i);
			if(!member.equals(player))
			{
				writeD(member.getObjectId());
				writeS(member.getName());
				writeD((int) member.getCurrentCp());
				writeD(member.getMaxCp());
				writeD((int) member.getCurrentHp());
				writeD(member.getMaxHp());
				writeD((int) member.getCurrentMp());
				writeD(member.getMaxMp());
				writeD(member.getLevel());
				writeD(member.getClassId().getId());
				writeD(0);//writeD(0x01); ??
				writeD(0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.serverpackets.L2GameServerPacket#getType()
	 */
	@Override
	public String getType()
	{
		return _S__4E_PARTYSMALLWINDOWALL;
	}
}
