package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Character;

import java.util.ArrayList;

public class PartySpelled extends L2GameServerPacket
{
	private static final String _S__EE_PartySpelled = "[S] EE PartySpelled";
	private final ArrayList<Effect> _effects;
	private final L2Character _activeChar;

	class Effect
	{
		final int _skillId;
		final int _level;
		final int _duration;

		public Effect(int skillId, int level, int duration)
		{
			_skillId = skillId;
			_level = level;
			_duration = duration;
		}
	}

	public PartySpelled(L2Character activeChar)
	{
		_activeChar = activeChar;
		_effects = new ArrayList<Effect>();
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		if(_activeChar == null)
			return;
		writeC(0xEE);

		if(_activeChar.isPet)
			writeD(1); // петы
		else if(_activeChar.isSummon)
			writeD(2); // саммоны
		else
			writeD(0); // L2Player

		writeD(_activeChar.getObjectId());
		writeD(_effects.size());
		for(Effect temp : _effects)
		{
			writeD(temp._skillId);
			writeH(temp._level);
			writeD(temp._duration);
		}
	}

	public void addPartySpelledEffect(int skillId, int level, int duration)
	{
		_effects.add(new Effect(skillId, level, duration));
	}

	@Override
	public String getType()
	{
		return _S__EE_PartySpelled;
	}
}