package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Summon;

public class PetInfo extends L2GameServerPacket
{
	//private static Logger _log = Logger.getLogger(PetInfo.class.getName());

	private static final String _S__B1_PETINFO = "[S] B1 PetInfo";
	private L2Summon _summon;
	private int _runSpd, _walkSpd, _swimRunSpd, _swimWalkSpd, _flRunSpd,
			_flWalkSpd, _flyRunSpd, _flyWalkSpd;

	/**
	 * rev 478  dddddddddddddddddddffffdddcccccSSdddddddddddddddddddddddddddhc
	 * @param _characters
	 */
	public PetInfo(L2Summon summon)
	{
		_summon = summon;
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		_runSpd = _summon.getRunSpeed();
		_walkSpd = _summon.getWalkSpeed();
		_swimRunSpd = _flRunSpd = _flyRunSpd = _runSpd;
		_swimWalkSpd = _flWalkSpd = _flyWalkSpd = _walkSpd;

		writeC(0xB1);
		writeD(_summon.getSummonType());
		writeD(_summon.getObjectId());
		writeD(_summon.getTemplate().npcId + 1000000);
		writeD(0); // 1=attackable 

		writeD(_summon.getX());
		writeD(_summon.getY());
		writeD(_summon.getZ());
		writeD(_summon.getHeading());
		writeD(0);
		writeD(_summon.getMAtkSpd());
		writeD(_summon.getPAtkSpd());
		writeD(_runSpd);
		writeD(_walkSpd);
		writeD(_swimRunSpd);
		writeD(_swimWalkSpd);
		writeD(_flRunSpd);
		writeD(_flWalkSpd);
		writeD(_flyRunSpd);
		writeD(_flyWalkSpd);

		writeF(1/*_cha.getProperMultiplier()*/);
		writeF(1/*_cha.getAttackSpeedMultiplier()*/);
		writeF(_summon.getTemplate().collisionRadius);
		writeF(_summon.getTemplate().collisionHeight);
		writeD(0); // right hand weapon
		writeD(0);
		writeD(0); // left hand weapon
		writeC(1); // name above char 1=true ... ??
		writeC(_summon.isRunning() ? 1 : 0); // running=1  
		writeC(_summon.isInCombat() ? 1 : 0); // attacking 1=true
		writeC(_summon.isAlikeDead() ? 1 : 0); // dead 1=true
		writeC(_summon.isShowSummonAnimation() ? 2 : 0); // invisible ?? 0=false  1=true   2=summoned (only works if model has a summon animation)
		writeS(_summon.getName());
		writeS(_summon.getTitle());
		writeD(1);
		writeD(_summon.getPvpFlag()); //0=white, 1=purple, 2=purpleblink, if its greater then karma = purple 
		writeD(_summon.getKarma()); // hmm karma ??
		writeD(_summon.getCurrentFed()); // how fed it is
		writeD(_summon.getMaxFed()); //max fed it can be
		writeD((int) _summon.getCurrentHp());//current hp
		writeD(_summon.getMaxHp());// max hp
		writeD((int) _summon.getCurrentMp());//current mp
		writeD(_summon.getMaxMp());//max mp
		writeD(_summon.getSp()); //sp
		writeD(_summon.getLevel());// lvl
		writeQ(_summon.getExp());
		writeQ(_summon.getExpForThisLevel());// 0%  absolute value	
		writeQ(_summon.getExpForNextLevel());// 100% absoulte value
		writeD(_summon.isPet ? _summon.getInventory().getTotalWeight() : 0);//weight
		writeD(_summon.getMaxLoad());//max weight it can carry
		writeD(_summon.getPAtk(null));//patk
		writeD(_summon.getPDef(null));//pdef
		writeD(_summon.getMAtk(null, null));//matk
		writeD(_summon.getMDef(null, null));//mdef
		writeD(_summon.getAccuracy());//accuracy
		writeD(_summon.getEvasionRate(null));//evasion
		writeD(_summon.getCriticalHit(null, null));//critical
		writeD(_runSpd);//speed
		writeD(_summon.getPAtkSpd());//atkspeed
		writeD(_summon.getMAtkSpd());//casting speed

		writeD(0);//c2  abnormal visual effect... bleed=1; poison=2; bleed?=4;
		int npcId = _summon.getTemplate().npcId;
		writeH(npcId == 12526 || npcId == 12527 || npcId == 12528 ? 1 : 0); //rideable
		writeC(0); // c2
		writeH(0); // ??
		writeC(_summon.getTeam()); // team aura (1 = blue, 2 = red)
		writeD(_summon.getSoulshotConsumeCount());
		writeD(_summon.getSpiritshotConsumeCount());
	}

	@Override
	public String getType()
	{
		return _S__B1_PETINFO;
	}

}
