package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2Clan.RankPrivs;
import L2jFT.game.model.L2ClanMember;

public class PledgeReceivePowerInfo extends L2GameServerPacket
{
	private static final String _S__FE_3C_PLEDGERECEIVEPOWERINFO = "[S] FE:3C PledgeReceivePowerInfo";
	private L2ClanMember _member;

	public PledgeReceivePowerInfo(L2ClanMember member)
	{
		_member = member;
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(EXTENDED_PACKET);
		writeH(0x3C);
		writeD(_member.getPowerGrade());
		writeS(_member.getName());
		if(_member.isClanLeader())
			writeD(L2Clan.CP_ALL);
		else
		{
			RankPrivs temp = _member.getClan().getRankPrivs(_member.getPowerGrade());
			if(temp != null)
				writeD(temp.getPrivs());
			else
				writeD(0);
		}
	}

	@Override
	public String getType()
	{
		return _S__FE_3C_PLEDGERECEIVEPOWERINFO;
	}
}
