package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Clan;
import L2jFT.game.model.L2Clan.SubPledge;
import L2jFT.game.model.L2ClanMember;
import L2jFT.game.model.L2Player;

public class PledgeShowMemberListAll extends L2GameServerPacket
{
	private static final String _S__53_PLEDGESHOWMEMBERLISTALL = "[S] 53 PledgeShowMemberListAll";
	private L2Clan _clan;
	private L2Player _activeChar;
	private L2ClanMember[] _members;
	private int _pledgeType;

	public PledgeShowMemberListAll(final L2Clan clan, final L2Player activeChar)
	{
		_clan = clan;
		_activeChar = activeChar;
		_members = _clan.getMembers();
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		_pledgeType = 0;
		writePledge(0); // main clan

		SubPledge[] subPledge = _clan.getAllSubPledges();
		for(SubPledge element : subPledge)
			_activeChar.sendPacket(new PledgeReceiveSubPledgeCreated(element));

		for(L2ClanMember m : _members)
		{
			if(m.getPledgeType() == 0)
				continue;
			_activeChar.sendPacket(new PledgeShowMemberListAdd(m));
		}

		_activeChar.sendPacket(new UserInfo(_activeChar)); // light on clan leader buttons
	}

	void writePledge(int mainOrSubpledge)
	{
		writeC(0x53);

		writeD(mainOrSubpledge); //c5 main clan 0 or any subpledge 1?
		writeD(_clan.getClanId());
		writeD(_pledgeType); //c5 - possibly pledge type?
		writeS(_clan.getName());
		writeS(_clan.getLeaderName());

		writeD(_clan.getCrestId()); // crest id .. is used again
		writeD(_clan.getLevel());
		writeD(_clan.getHasCastle());
		writeD(_clan.getHasHideout());
		writeD(_clan.getRank());
		writeD(_clan.getReputationScore());
		writeD(0);
		writeD(0);

		writeD(_clan.getAllyId());
		if(_clan.getAlliance() != null)
		{
			writeS(_clan.getAlliance().getAllyName());
			writeD(_clan.getAlliance().getAllyCrestId());
		}
		else
		{
			writeS("");
			writeD(0);
		}
		writeD(_clan.isAtWarOrUnderAttack());
		writeD(_clan.getSubPledgeMembersCount(_pledgeType));

		for(L2ClanMember m : _members)
		{
			if(m.getPledgeType() != _pledgeType)
				continue;
			writeS(m.getName());
			writeD(m.getLevel());
			writeD(m.getClassId());
			writeD(0); // no visible effect
			writeD(m.getObjectId()); //writeD(1);
			writeD(m.isOnline() ? 1 : 0); // 1=online 0=offline
			writeD(m.hasSponsor() ? 1 : 0);
		}
	}

	@Override
	public String getType()
	{
		return _S__53_PLEDGESHOWMEMBERLISTALL;
	}
}
