package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.TradeItem;
import L2jFT.game.tables.ItemTable;
import L2jFT.game.templates.L2Item;

import java.util.HashSet;

public class PrivateStoreListSell extends L2GameServerPacket
{
	private static final String _S__9B_PRIVATESTORELISTSELL = "[S] 9B PrivateStoreListSell";
	private final L2Player _seller;
	private final boolean _sellMode;
	private final int _buyerAdena;
	private HashSet<TradeItem> _sellList;

	/**
	 * Список вещей в личном магазине продажи, показываемый покупателю
	 * @param buyer
	 * @param seller
	 */
	public PrivateStoreListSell(L2Player buyer, L2Player seller)
	{
		_seller = seller;
		_sellMode = seller.getSellMode();
		_buyerAdena = buyer.getAdena();
		_sellList = seller.getSellList();
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0x9B);
		writeD(_seller.getObjectId());
		writeD(_sellMode ? 1 : 0);
		writeD(_buyerAdena);

		writeD(_sellList.size());
		for(TradeItem ti : _sellList)
		{
			L2Item tempItem = ItemTable.getInstance().getTemplate(ti.getItemId());
			writeD(tempItem.getType2());
			writeD(ti.getObjectId());
			writeD(ti.getItemId());
			writeD(ti.getCount());
			writeH(0);
			writeH(ti.getEnchantLevel());
			writeH(0x00);
			writeD(tempItem.getBodyPart());
			writeD(ti.getOwnersPrice());//your price
			writeD(ti.getStorePrice()); //store price
		}
	}

	@Override
	public String getType()
	{
		return _S__9B_PRIVATESTORELISTSELL;
	}
}