package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2TradeList;
import L2jFT.game.model.TradeItem;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.tables.ItemTable;
import L2jFT.game.templates.L2Item;

import java.util.HashSet;

public class PrivateStoreManageListBuy extends L2GameServerPacket
{
	private static final String _S__B7_PRIVATESTOREMANAGELISTBUY = "[S] B7 PrivateStoreManageListBuy";
	private L2Player _buyer;
	private int _buyerAdena;
	private L2TradeList _list;
	private TradeItem[] _buyList;

	/**
	 * Окно управления личным магазином продажи
	 * @param buyer
	 */
	public PrivateStoreManageListBuy(L2Player buyer)
	{
		_buyer = buyer;
		_buyerAdena = _buyer.getAdena();

		L2ItemInstance[] inventory = _buyer.getInventory().getItems();
		HashSet<TradeItem> buyList = _buyer.getBuyList();

		_list = new L2TradeList(0);
		_buyList = buyList.toArray(new TradeItem[buyList.size()]);
		for(L2ItemInstance item : inventory)
			if(item.getItem().getType2() != L2Item.TYPE2_QUEST && item.getItem().getType2() != L2Item.TYPE2_MONEY && item.canBeTraded(_buyer))
			{
				for(TradeItem ti : buyList)
					if(ti.getItemId() == item.getItemId())
						continue;
				_list.addItem(item);
			}
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0xB7);
		//section 1 
		writeD(_buyer.getObjectId());
		writeD(_buyerAdena);

		//section2 
		writeD(_list.getItems().size());//for potential sells
		for(L2ItemInstance temp : _list.getItems())
		{
			writeD(temp.getItemId());
			writeH(0); //show enchant lvl as 0, as you can't buy enchanted weapons
			writeD(temp.getCount());
			writeD(temp.getPriceToSell());
			writeH(0);
			writeD(temp.getBodyPart());
			writeH(temp.getItem().getType2());
		}

		//section 3
		writeD(_buyList.length);//count for any items already added for sell
		for(TradeItem temp2 : _buyList)
		{
			L2Item tempItem = ItemTable.getInstance().getTemplate(temp2.getItemId());
			writeD(temp2.getItemId());
			writeH(0);
			writeD(temp2.getCount());
			writeD(temp2.getStorePrice());
			writeH(0);
			writeD(tempItem.getBodyPart());
			writeH(tempItem.getType2());
			writeD(temp2.getOwnersPrice());//your price
			writeD(temp2.getStorePrice());//fixed store price
		}
	}

	@Override
	public String getType()
	{
		return _S__B7_PRIVATESTOREMANAGELISTBUY;
	}
}
