package L2jFT.game.network.serverpackets;

/**
 * Примеры пакетов:
 * 
 * Ставит флажок на карте и показывает стрелку на компасе:
 * EB 00 00 00 00 01 00 00 00 40 2B FF FF 8C 3C 02 00 A0 F6 FF FF
 * Убирает флажок и стрелку
 * EB 02 00 00 00 02 00 00 00 40 2B FF FF 8C 3C 02 00 A0 F6 FF FF
 */
public class RadarControl extends L2GameServerPacket
{
	private static final String _S__EB_RadarControl = "[S] EB RadarControl";
	private int _showRadar;
	private int _type;
	private int _X;
	private int _Y;
	private int _Z;

	/**
	 * 0xEB RadarControl         ddddd 
	 * @param _
	 */

	public RadarControl(int showRadar, int type, int x, int y, int z)
	{
		_showRadar = showRadar; // showRader?? 0 = showradar; 1 = delete radar;
		_type = type; // radar type??
		_X = x;
		_Y = y;
		_Z = z;
	}

	@Override
	final public void runImpl()
	{
	// no long-running tasks
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0xEB);
		writeD(_showRadar);
		writeD(_type); //maybe type
		writeD(_X); //x
		writeD(_Y); //y
		writeD(_Z); //z
	}

	@Override
	public String getType()
	{
		return _S__EB_RadarControl;
	}
}