package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2ManufactureItem;
import L2jFT.game.model.L2ManufactureList;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2RecipeList;

/**
 * dd d(dd) d(ddd)
 */
public class RecipeShopManageList extends L2GameServerPacket
{

	private static final String _S__D8_RecipeShopManageList = "[S] D8 RecipeShopManageList";
	private L2Player _seller;
	private L2RecipeList[] _recipes;
	private boolean _isDwarven;

	public RecipeShopManageList(L2Player seller, boolean isDvarvenCraft)
	{
		_seller = seller;
		_isDwarven = isDvarvenCraft;
		if(_isDwarven)
			_recipes = seller.getDwarvenRecipeBook();
		else
			_recipes = seller.getCommonRecipeBook();
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0xD8);
		writeD(_seller.getObjectId());
		writeD(_seller.getAdena());
		writeD(_isDwarven ? 0x00 : 0x01);

		if(_recipes == null)
			writeD(0);
		else
		{
			writeD(_recipes.length);//number of items in recipe book

			for(int i = 0; i < _recipes.length; i++)
			{
				L2RecipeList temp = _recipes[i];
				writeD(temp.getId());
				writeD(i + 1);
			}
		}

		if(_seller.getCreateList() == null)
			writeD(0);
		else
		{
			L2ManufactureList list = _seller.getCreateList();
			writeD(list.size());

			for(L2ManufactureItem item : list.getList())
			{
				writeD(item.getRecipeId());
				writeD(0x00);
				writeD(item.getCost());
			}
		}
	}

	@Override
	public String getType()
	{
		return _S__D8_RecipeShopManageList;
	}
}