package L2jFT.game.network.serverpackets;

import javolution.util.FastList;
import L2jFT.game.model.Inventory;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2ItemInstance;

public class Ride extends L2GameServerPacket
{
	private static final String _S__86_Ride = "[S] 86 Ride";
	public static final int ACTION_MOUNT = 1;
	public static final int ACTION_DISMOUNT = 0;
	private int _id = 0;
	private int _bRide = 0;
	private short _rideType = 0;
	private int _rideClassID = 0;

	/**
	 * 0x86 Ride dddd 
	 * @param _
	 */
	public Ride(L2Player cha, int action, int rideClassId)
	{
		if(cha == null)
			return;
		_id = cha.getObjectId();
		_bRide = action; // 1 for mount ; 2 for dismount
		_rideClassID = rideClassId + 1000000;
		_rideType = rideClassId == 12621 ? (short) 2 : (short) 1; // 2 for wyvern; 1 for other

		// TODO: это надо из пакета убрать и засунуть в L2Player.setMountType
		if(cha.isCursedWeaponEquipped())
			return;

		if(_bRide != 1)
			return;

		FastList<L2ItemInstance> modified = new FastList<L2ItemInstance>();

		//Check for slots that can have weapons
		L2ItemInstance wpn = cha.getInventory().getPaperdollItem(Inventory.PAPERDOLL_LHAND);
		if(wpn != null)
		{
			modified.add(wpn);
			sendDisarmMessage(wpn, cha);
		}
		cha.getInventory().unEquipItemInSlot(Inventory.PAPERDOLL_LHAND);

		wpn = cha.getInventory().getPaperdollItem(Inventory.PAPERDOLL_LRHAND);
		if(wpn != null)
		{
			modified.add(wpn);
			sendDisarmMessage(wpn, cha);
		}
		cha.getInventory().unEquipItemInSlot(Inventory.PAPERDOLL_LRHAND);

		wpn = cha.getInventory().getPaperdollItem(Inventory.PAPERDOLL_RHAND);
		if(wpn != null)
		{
			modified.add(wpn);
			sendDisarmMessage(wpn, cha);
		}
		cha.getInventory().unEquipItemInSlot(Inventory.PAPERDOLL_RHAND);

		cha.refreshExpertisePenalty();
		cha.abortAttack();
		cha.abortCast();
		cha.broadcastUserInfo();

		InventoryUpdate iu = new InventoryUpdate();
		for(L2ItemInstance i : modified)
			iu.addItem(i);
		cha.sendPacket(iu);
	}

	private void sendDisarmMessage(L2ItemInstance wpn, L2Player cha)
	{
		if(wpn.getEnchantLevel() > 0)
		{
			SystemMessage sm = new SystemMessage(SystemMessage.EQUIPMENT_OF__S1_S2_HAS_BEEN_REMOVED);
			sm.addNumber(wpn.getEnchantLevel());
			sm.addItemName(wpn.getItemId());
			cha.sendPacket(sm);
		}
		else
		{
			SystemMessage sm = new SystemMessage(SystemMessage.S1__HAS_BEEN_DISARMED);
			sm.addItemName(wpn.getItemId());
			cha.sendPacket(sm);
		}
	}

	public short getMountType()
	{
		return _rideType;
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{

		writeC(0x86);
		writeD(_id);
		writeD(_bRide);
		writeD(_rideType);
		writeD(_rideClassID);
	}

	@Override
	public String getType()
	{
		return _S__86_Ride;
	}
}
