package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2ItemInstance;

import java.util.ArrayList;

public class SellList extends L2GameServerPacket
{
	private static final String _S__10_SELLLIST = "[S] 10 SellList";
	private final L2Player _char;
	private int _money;
	private ArrayList<L2ItemInstance> _selllist = new ArrayList<L2ItemInstance>();

	/**
	 * Список вещей для продажи в обычный магазин 
	 * @param player
	 */
	public SellList(L2Player player)
	{
		_char = player;
		_money = _char.getAdena();

		for(L2ItemInstance item : _char.getInventory().getItems())
			if(!item.isEquipped() && item.getItem().isSellable() && item.canBeTraded(_char))
				_selllist.add(item);
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0x10);
		writeD(_money);
		writeD(0);
		writeH(_selllist.size());

		for(L2ItemInstance item : _selllist)
		{
			writeH(item.getItem().getType1());
			writeD(item.getObjectId());
			writeD(item.getItemId());
			writeD(item.getCount());
			writeH(item.getItem().getType2());
			writeH(0x00);
			writeD(item.getBodyPart());
			writeH(item.getEnchantLevel());
			writeH(0x00);
			writeH(0x00);
			writeD(item.getItem().getReferencePrice() / 2);
		}
	}

	@Override
	public String getType()
	{
		return _S__10_SELLLIST;
	}
}