package L2jFT.game.network.serverpackets;

import javolution.util.FastList;

import java.util.List;
import java.util.logging.Logger;

public class ShowBoard extends L2GameServerPacket
{
	private static Logger _log = Logger.getLogger(ShowBoard.class.getName());
	private static final String _S__6E_SHOWBOARD = "[S] 6E ShowBoard";
	private String _htmlCode;
	private String _id;
	private List<String> _arg;

	public ShowBoard(String htmlCode, String id)
	{
		if(htmlCode != null && htmlCode.length() > 8192)
		{
			_log.warning("Html '" + htmlCode + "' is too long! this will crash the client!");
			_htmlCode = "<html><body>Html was too long</body></html>";
			return;
		}
		_htmlCode = htmlCode; // html code must not exceed 8192 bytes
		_id = id;
	}

	public ShowBoard(List<String> arg)
	{
		_id = "1002";
		_htmlCode = null;
		_arg = arg;

	}

	private byte[] get1002()
	{
		FastList<byte[]> _argBytes = new FastList<byte[]>();
		byte[] htmlBytes = _id.getBytes();
		int len = htmlBytes.length * 2 + 2;
		for(String arg : _arg)
		{
			byte[] argBytes = arg.getBytes();
			len += (argBytes.length + 4) * 2;
			_argBytes.add(argBytes);
		}

		byte data[] = new byte[len];
		int i = 0;
		for(int j = 0; j < htmlBytes.length; j++, i += 2)
		{
			data[i] = htmlBytes[j];
			data[i + 1] = 0;
		}
		data[i] = 8;
		i++;
		data[i] = 0;
		i++;
		for(byte[] arg : _argBytes)
		{
			for(int j = 0; j < arg.length; j++, i += 2)
			{
				data[i] = arg[j];
				data[i + 1] = 0;
			}
			data[i] = 0x20;
			i++;
			data[i] = 0x0;
			i++;
			data[i] = 0x8;
			i++;
			data[i] = 0x0;
			i++;
		}
		return data;
	}

	@Override
	final public void runImpl()
	{
	// no long-running tasks
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0x6E);
		writeC(0x01); //c4 1 to show community 00 to hide
		writeS("bypass _bbstop"); // top
		writeS("bypass _bbsgetfav"); // favorite
		writeS("bypass _bbsregion"); // region
		writeS("bypass _bbsclan"); // clan
		writeS("bypass _bbsmemo"); // memo
		writeS("bypass _bbsmail"); // mail
		writeS("bypass _bbsfriends"); // friends
		writeS("bypass bbs_addfav"); // add fav.
		if(!_id.equals("1002"))
		{
			byte[] htmlBytes = _id.getBytes();
			byte data[] = new byte[2 + htmlBytes.length * 2];
			int i = 0;
			for(int j = 0; j < htmlBytes.length; j++, i += 2)
			{
				data[i] = htmlBytes[j];
				data[i + 1] = 0;
			}
			data[i] = 8;
			i++;
			data[i] = 0;
			writeB(data);
			writeS(_htmlCode); // current page
		}
		else
			writeB(get1002());
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.network.serverpackets.L2GameServerPacket#getType()
	 */
	@Override
	public String getType()
	{
		return _S__6E_SHOWBOARD;
	}
}
