package L2jFT.game.network.serverpackets;

import L2jFT.game.model.entity.SevenSigns;

/**
 * Changes the sky color depending on the outcome 
 * of the Seven Signs competition.
 *
 * packet type id 0xf8
 * format: c h
 *
 * @author Tempy
 */
public class SignsSky extends L2GameServerPacket
{
	private static final String _S__F8_SignsSky = "[S] F8 SignsSky";

	public SignsSky()
	{}

	public SignsSky(int state)
	{
		_state = state;
	}

	@Override
	final public void runImpl()
	{
	// no long-running tasks
	}

	@Override
	protected final void writeImpl()
	{
		writeC(0xF8);

		int compWinner = SevenSigns.getInstance().getCabalHighestScore();

		if(SevenSigns.getInstance().isSealValidationPeriod() || _state > 0)
			if(compWinner == SevenSigns.CABAL_DAWN && _state != 1)
				writeH(258);
			else
				writeH(257);
		//else
		//writeH(256);
	}

	@Override
	public String getType()
	{
		return _S__F8_SignsSky;
	}

	private static int _state = 0;
}