package L2jFT.game.network.serverpackets;

import java.util.Vector;

/**
 * Даные параметры актуальны для С6(Interlude), 04/10/2007, протокол 746
 */
public class StatusUpdate extends L2GameServerPacket
{
	private static final String _S__0E_STATUSUPDATE = "[S] 0E StatusUpdate";

	@Deprecated
	public final static int LEVEL = 0x01;
	@Deprecated
	public final static int EXP = 0x02;
	@Deprecated
	public final static int STR = 0x03;
	@Deprecated
	public final static int DEX = 0x04;
	@Deprecated
	public final static int CON = 0x05;
	@Deprecated
	public final static int INT = 0x06;
	@Deprecated
	public final static int WIT = 0x07;
	@Deprecated
	public final static int MEN = 0x08;

	/**
	 * Даный параметр отсылается оффом в паре с MAX_HP
	 * Сначала CUR_HP, потом MAX_HP
	 */
	public final static int CUR_HP = 0x09;
	public final static int MAX_HP = 0x0a;

	/**
	 * Даный параметр отсылается оффом в паре с MAX_MP
	 * Сначала CUR_MP, потом MAX_MP
	 */
	public final static int CUR_MP = 0x0b;
	public final static int MAX_MP = 0x0c;

	@Deprecated
	public final static int SP = 0x0d;

	/**
	 * Меняется отображение только в инвентаре, для статуса требуется UserInfo
	 */
	public final static int CUR_LOAD = 0x0e;

	/**
	 * Меняется отображение только в инвентаре, для статуса требуется UserInfo
	 */
	public final static int MAX_LOAD = 0x0f;

	@Deprecated
	public final static int P_ATK = 0x11;
	@Deprecated
	public final static int ATK_SPD = 0x12;
	@Deprecated
	public final static int P_DEF = 0x13;
	@Deprecated
	public final static int EVASION = 0x14;
	@Deprecated
	public final static int ACCURACY = 0x15;
	@Deprecated
	public final static int CRITICAL = 0x16;
	@Deprecated
	public final static int M_ATK = 0x17;
	@Deprecated
	public final static int CAST_SPD = 0x18;
	@Deprecated
	public final static int M_DEF = 0x19;

	public final static int PVP_FLAG = 0x1a;
	public final static int KARMA = 0x1b;

	/**
	 * Даный параметр отсылается оффом в паре с MAX_CP
	 * Сначала CUR_CP, потом MAX_CP
	 */
	public final static int CUR_CP = 0x21;
	public final static int MAX_CP = 0x22;

	private final int _objectId;
	private final Vector<Attribute> _attributes = new Vector<Attribute>();

	class Attribute
	{
		public final int id;
		public final int value;

		Attribute(int id, int value)
		{
			this.id = id;
			this.value = value;
		}
	}

	public StatusUpdate(int objectId)
	{
		_objectId = objectId;
	}

	public StatusUpdate addAttribute(int id, int level)
	{
		_attributes.add(new Attribute(id, level));
		return this;
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0x0E);
		writeD(_objectId);
		writeD(_attributes.size());

		for(Attribute temp : _attributes)
		{
			writeD(temp.id);
			writeD(temp.value);
		}
	}

	public boolean hasAttributes()
	{
		return !_attributes.isEmpty();
	}

	@Override
	public final String getType()
	{
		return _S__0E_STATUSUPDATE;
	}
}
