package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.instances.L2ItemInstance;

import java.util.ArrayList;

public class TradeStart extends L2GameServerPacket
{
	private static final String _S__1E_TRADESTART = "[S] 1E TradeStart";
	private L2Player _me;
	private ArrayList<L2ItemInstance> _tradelist = new ArrayList<L2ItemInstance>();

	public TradeStart(L2Player me)
	{
		_me = me;

		L2ItemInstance[] inventory = _me.getInventory().getItems();
		for(L2ItemInstance item : inventory)
			if(!item.isEquipped() && item.getItem().getType2() != 3 && item.canBeTraded(_me))
				_tradelist.add(item);

	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{//0x2e TradeStart   d h (h dddhh dhhh)
		if(_me == null || _me.getTransactionRequester() == null)
			return;

		writeC(0x1E);
		writeD(_me.getTransactionRequester().getObjectId());

		int count = _tradelist.size();
		writeH(count);//count??

		for(L2ItemInstance temp : _tradelist)
		{
			writeH(temp.getItem().getType1()); // item type1
			writeD(temp.getObjectId());
			writeD(temp.getItemId());
			writeD(temp.getCount());
			writeH(temp.getItem().getType2()); // item type2
			writeH(0x00); // ?

			writeD(temp.getBodyPart()); // rev 415  slot    0006-lr.ear  0008-neck  0030-lr.finger  0040-head  0080-??  0100-l.hand  0200-gloves  0400-chest  0800-pants  1000-feet  2000-??  4000-r.hand  8000-r.hand
			writeH(temp.getEnchantLevel()); // enchant level
			writeH(0x00); // ?
			writeH(0x00);
		}
	}

	@Override
	public String getType()
	{
		return _S__1E_TRADESTART;
	}
}