package L2jFT.game.network.serverpackets;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.Warehouse.WarehouseType;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.templates.L2Item;

import java.util.ArrayList;

public class WareHouseDepositList extends L2GameServerPacket
{
	private static final String _S__41_WAREHOUSEDEPOSITLIST = "[S] 41 WareHouseDepositList";
	private final L2Player _cha;
	private final int _whtype;
	private ArrayList<L2ItemInstance> _itemslist = new ArrayList<L2ItemInstance>();

	public WareHouseDepositList(L2Player cha, WarehouseType whtype)
	{
		_cha = cha;
		_whtype = whtype.getPacketValue();
		for(L2ItemInstance item : _cha.getInventory().getItems())
			if(!item.isEquipped() && item.getItem().getType2() != L2Item.TYPE2_QUEST && (_whtype == 1 || item.canBeStored(_cha)))
				_itemslist.add(item);
	}

	@Override
	final public void runImpl()
	{}

	@Override
	protected final void writeImpl()
	{
		writeC(0x41);
		writeH(_whtype);
		writeD(_cha.getAdena());
		writeH(_itemslist.size());
		for(L2ItemInstance temp : _itemslist)
		{
			L2Item item = temp.getItem();
			writeH(item.getType1());
			writeD(temp.getObjectId());
			writeD(temp.getItemId());
			writeD(temp.getCount());
			writeH(item.getType2());
			writeH(temp.getCustomType1());
			writeD(temp.getBodyPart());
			writeH(temp.getEnchantLevel());
			writeH(temp.getCustomType2());
			writeH(0x00); // ? 200
			writeD(temp.getObjectId()); // return value for define item (object_id)
			writeH(0); // Как-то относится к инкрустации
			writeD(temp.getAugmentationId());
			writeH(0); // Как-то относится к инкрустации
		}
	}

	@Override
	public String getType()
	{
		return _S__41_WAREHOUSEDEPOSITLIST;
	}
}