package L2jFT.game.skills.conditions;

import L2jFT.game.model.L2Effect;
import L2jFT.game.model.L2Effect.EffectType;
import L2jFT.game.skills.Env;
import L2jFT.game.skills.effects.EffectBattleForce;
import L2jFT.game.skills.effects.EffectSpellForce;

public class ConditionForceBuff extends Condition
{
	private int _battleForces;
	private int _spellForces;

	public ConditionForceBuff(int[] forces)
	{
		_battleForces = forces[0];
		_spellForces = forces[1];
	}

	public ConditionForceBuff(int battle, int spell)
	{
		_battleForces = battle;
		_spellForces = spell;
	}

	@Override
	public boolean testImpl(Env env)
	{
		if(_battleForces > 0)
		{
			L2Effect battleForce = env.character.getEffect(EffectType.BATTLE_FORCE);
			if(!(battleForce instanceof EffectBattleForce) || ((EffectBattleForce) battleForce).forces < _battleForces)
				return false;
		}
		if(_spellForces > 0)
		{
			L2Effect spellForce = env.character.getEffect(EffectType.SPELL_FORCE);
			if(!(spellForce instanceof EffectSpellForce) || ((EffectSpellForce) spellForce).forces < _spellForces)
				return false;
		}
		return true;
	}
}