package L2jFT.game.skills.effects;

import static L2jFT.game.ai.CtrlIntention.AI_INTENTION_ATTACK;
import static L2jFT.game.ai.CtrlIntention.AI_INTENTION_IDLE;
import L2jFT.game.model.L2Effect;
import L2jFT.game.model.L2Summon;
import L2jFT.game.skills.Env;

public class EffectBetray extends L2Effect
{
	public EffectBetray(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public void onStart()
	{
		if(_effected instanceof L2Summon)
		{
			L2Summon summon = (L2Summon) _effected;
			summon.setPossessed(true);
			summon.getAI().setAttackTarget(summon.getOwner());
			summon.getAI().setIntention(AI_INTENTION_ATTACK, summon.getOwner(), null);
		}
	}

	@Override
	public void onExit()
	{
		if(_effected instanceof L2Summon)
		{
			L2Summon summon = (L2Summon) _effected;
			summon.setPossessed(false);
			summon.getAI().setAttackTarget(null);
			summon.getAI().setIntention(AI_INTENTION_IDLE);
		}
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.BETRAY;
	}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}