package L2jFT.game.skills.effects;

import L2jFT.game.ai.CtrlIntention;
import L2jFT.game.cache.Msg;
import L2jFT.util.Rnd;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Effect;
import L2jFT.game.model.L2Object;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.skills.Env;

import java.util.ArrayList;

@SuppressWarnings( { "nls", "unqualified-field-access", "boxing" })
public class EffectConfuseMob extends L2Effect
{
	public EffectConfuseMob(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.CONFUSE_MOB_ONLY;
	}

	/** Notify started */
	@Override
	public void onStart()
	{
		if(_effected.isFearImmune())
		{
			_effector.sendPacket(Msg.TARGET_IS_INCORRECT);
			return;
		}

		if(_effected.isInZonePeace())
		{
			_effector.sendPacket(Msg.YOU_CANNOT_ATTACK_IN_THE_PEACE_ZONE);
			return;
		}

		_effected.startConfused();
		onActionTime();
	}

	/** Notify exited */
	@Override
	public void onExit()
	{
		getEffected().stopConfused();
	}

	@Override
	public boolean onActionTime()
	{
		ArrayList<L2Character> targetList = new ArrayList<L2Character>();

		for(L2Character character : getEffected().getKnownCharacters(900))
			if(character instanceof L2NpcInstance && character != getEffected())
				targetList.add(character);
		// if there is no target, exit function
		if(targetList.size() == 0)
			return true;

		// Choosing randomly a new target
		L2Object target = targetList.get(Rnd.get(targetList.size()));

		// Attacking the target
		//getEffected().setTarget(target);
		getEffected().setTarget(target);
		getEffected().getAI().setIntention(CtrlIntention.AI_INTENTION_ATTACK, target, null);

		return true;
	}
}
