package L2jFT.game.skills.effects;

import L2jFT.game.model.L2Effect;
import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2Skill.SkillTargetType;
import L2jFT.game.model.instances.L2NpcInstance;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.game.skills.Env;

class EffectDamOverTimeLethal extends L2Effect
{
	public EffectDamOverTimeLethal(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.DMG_OVER_TIME_LETHAL;
	}

	@Override
	public void onExit()
	{
		getEffected().sendPacket(new SystemMessage(SystemMessage.THE_EFFECT_OF_S1_HAS_WORN_OFF).addSkillName(_skill.getId(), _skill.getLevel()));
		super.onExit();
	}

	@Override
	public boolean onActionTime()
	{
		if(_effected.isDead())
			return false;

		double damage = calc();

		if(getEffected().isPlayer && _skill.getTargetType() != SkillTargetType.TARGET_SELF && ((L2Player) getEffected()).isSitting())
			((L2Player) getEffected()).standUp();

		if(_effected instanceof L2NpcInstance)
			_effected.reduceCurrentHp(damage, _effector, false, false, false);
		else if(_effected.isPlayer)
			_effected.reduceCurrentHp(damage, _effected, true, false, false);
		else
			_effected.reduceCurrentHp(damage, _effector, true, false, false);

		return true;
	}
}
