package L2jFT.game.skills.effects;

import L2jFT.game.cache.Msg;
import L2jFT.game.model.L2Effect;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.game.skills.Env;

final class EffectFakeDeath extends L2Effect
{
	public EffectFakeDeath(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.FAKE_DEATH;
	}

	/** Notify started */
	@Override
	public void onStart()
	{
		getEffected().startFakeDeath();
	}

	/** Notify exited */
	@Override
	public void onExit()
	{
		// 5 секунд после FakeDeath на персонажа не агрятся мобы
		getEffected().setNonAggroTime(System.currentTimeMillis() + 5000);
		getEffected().stopFakeDeath();
	}

	@Override
	public boolean onActionTime()
	{
		if(getEffected().isDead())
			return false;

		double manaDam = calc();

		if(manaDam > getEffected().getCurrentMp())
			if(getSkill().isToggle())
			{
				getEffected().sendPacket(Msg.NOT_ENOUGH_MP);
				getEffected().sendPacket(new SystemMessage(SystemMessage.THE_EFFECT_OF_S1_HAS_BEEN_REMOVED).addString(getSkill().getName()));
				return false;
			}

		getEffected().reduceCurrentMp(manaDam);
		return true;
	}
}
