package L2jFT.game.skills.effects;

import L2jFT.game.model.L2Effect;
import L2jFT.game.network.serverpackets.ExPotionEffectStatusBarHP;
import L2jFT.game.skills.Env;

class EffectHealOverTime extends L2Effect
{
	public EffectHealOverTime(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public void onStart()
	{
		super.onStart();

		if(getEffected().isPlayer)
			switch(getSkill().getId().intValue())
			{
				case 2031: // Lesser Healing Potion
					getEffected().sendPacket(new ExPotionEffectStatusBarHP(ExPotionEffectStatusBarHP.POTION_HEALING_LESSER));
					break;
				case 2032: // Healing Potion
					getEffected().sendPacket(new ExPotionEffectStatusBarHP(ExPotionEffectStatusBarHP.POTION_HEALING_MEDIUM));
					break;
				case 2037: // Greater Healing Potion
					getEffected().sendPacket(new ExPotionEffectStatusBarHP(ExPotionEffectStatusBarHP.POTION_HEALING_GREATER));
					break;
			}
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.HEAL_OVER_TIME;
	}

	@Override
	public boolean onActionTime()
	{
		if(getEffected().isDead())
			return false;

		getEffected().setCurrentHp(getEffected().getCurrentHp() + calc());
		return true;
	}
}
