package L2jFT.game.skills.effects;

import L2jFT.game.model.L2Effect;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.game.skills.Env;
import L2jFT.game.skills.Stats;

class EffectHealPercent extends L2Effect
{
	public EffectHealPercent(final Env env, final EffectTemplate template)
	{
		super(env, template);
		final double base = calc() * _effected.getMaxHp() / 100;
		final double newHp = base * _effected.calcStat(Stats.HEAL_EFFECTIVNESS, 100, null, null) / 100;
		_effected.sendPacket(new SystemMessage(SystemMessage.S1_HPS_HAVE_BEEN_RESTORED).addNumber((int) newHp));
		_effected.setCurrentHp(newHp + _effected.getCurrentHp());
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.HEAL_PERCENT;
	}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}