package L2jFT.game.skills.effects;

import L2jFT.game.cache.Msg;
import L2jFT.game.model.L2Effect;
import L2jFT.game.network.serverpackets.SystemMessage;
import L2jFT.game.skills.Env;

class EffectManaDamOverTime extends L2Effect
{
	public EffectManaDamOverTime(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.MANA_DMG_OVER_TIME;
	}

	@Override
	public boolean onActionTime()
	{
		if(_effected.isDead())
			return false;

		double manaDam = calc();

		if(manaDam > _effected.getCurrentMp() && getSkill().isToggle())
		{
			_effected.sendPacket(Msg.NOT_ENOUGH_MP);
			_effected.sendPacket(new SystemMessage(SystemMessage.THE_EFFECT_OF_S1_HAS_BEEN_REMOVED).addString(getSkill().getName()));
			return false;
		}

		_effected.reduceCurrentMp(manaDam);
		return true;
	}
}
