package L2jFT.game.skills.effects;

import L2jFT.game.model.L2Effect;
import L2jFT.game.skills.Env;

/**
 * Иммобилизует и парализует на время действия.
 * @author Diamond
 * @date 24.07.2007
 * @time 5:32:46
 */
final class EffectMeditation extends L2Effect
{
	public EffectMeditation(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.MEDITATION;
	}

	/** Notify started */
	@Override
	public void onStart()
	{
		_effected.setParalyzed(true);
		_effected.setMeditated(true);
		_effected.setImobilised(true);
	}

	/** Notify exited */
	@Override
	public void onExit()
	{
		_effected.setParalyzed(false);
		_effected.setMeditated(false);
		_effected.setImobilised(false);
		//_effected.removeEffectsBySkillExclude(_skill, this);
	}

	@Override
	public boolean onActionTime()
	{
		// just stop this effect
		return false;
	}
}
