package L2jFT.game.skills.effects;

import L2jFT.game.model.L2Effect;
import L2jFT.game.network.serverpackets.StopMove;
import L2jFT.game.skills.Env;

final class EffectParalyze extends L2Effect
{
	public EffectParalyze(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.PARALYZE;
	}

	@Override
	public void onStart()
	{
		if(_effected.paralyzeImmune())
			return;
		_effected.abortCast();
		_effected.abortAttack();
		_effected.sendActionFailed();
		_effected.broadcastPacket(new StopMove(_effected));
		_effected.setParalyzed(true);
	}

	@Override
	public void onExit()
	{
		_effected.setParalyzed(false);
	}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}