package L2jFT.game.skills.effects;

import L2jFT.game.ThreadPoolManager;
import L2jFT.game.geodata.GeoData;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Effect;
import L2jFT.game.network.serverpackets.StopMove;
import L2jFT.game.skills.Env;
import L2jFT.util.Location;

class EffectTurner extends L2Effect
{
	public EffectTurner(Env env, EffectTemplate template)
	{
		super(env, template);
	}

	@Override
	public EffectType getEffectType()
	{
		return EffectType.TURNER;
	}

	@Override
	public void onStart()
	{
		if(_effected.isDead())
			return;

		_effected.startFear();

		int posX = _effected.getX();
		int posY = _effected.getY();
		int posZ = _effected.getZ();
		int signx = -1;
		int signy = -1;
		if(_effected.getX() > _effector.getX())
			signx = 1;
		if(_effected.getY() > _effector.getY())
			signy = 1;

		_effected.broadcastPacket(new StopMove(_effected));

		_effected.setHeading(_effector, false);
		if(!_effected.isMonster)
			_effected.setTarget(null);
		_effected.setRunning();

		Location loc = GeoData.getInstance().moveCheck(_effected.getX(), _effected.getY(), _effected.getZ(), posX + signx * 40, posY + signy * 40, posZ);
		_effected.moveToLocation(loc.x, loc.y, loc.z, 0, false);

		_effected.sendMessage("You can feel Turner's effect");
		ThreadPoolManager.getInstance().scheduleGeneral(new StopFear(_effected), 2000);
	}

	public class StopFear implements Runnable
	{
		private L2Character _activeChar;

		public StopFear(L2Character activeChar)
		{
			_activeChar = activeChar;
		}

		public void run()
		{
			_activeChar.stopFear();
		}
	}

	@Override
	public void onExit()
	{}

	@Override
	public boolean onActionTime()
	{
		return false;
	}
}