package L2jFT.game.skills.skillclasses;

import javolution.util.FastList;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Skill;
import L2jFT.game.templates.StatsSet;

public class Balance extends L2Skill
{
	public Balance(StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		if(!isHandler())
			activeChar.unChargeShots(isMagic());

		double summaryCurrentHp = 0;
		int summaryMaximumHp = 0;

		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			if(target.isDead())
				continue;
			summaryCurrentHp += target.getCurrentHp();
			summaryMaximumHp += target.getMaxHp();
		}

		double percent = summaryCurrentHp / summaryMaximumHp;

		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			if(!target.isDead())
			{
				target.setCurrentHp(target.getMaxHp() * percent);
				getEffects(activeChar, target, getActivateRate() > 0);
			}
		}
	}
}
