package L2jFT.game.skills.skillclasses;

import javolution.util.FastList;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Skill;
import L2jFT.game.model.L2Summon;
import L2jFT.game.templates.StatsSet;
import L2jFT.util.Rnd;

public class DestroySummon extends L2Skill
{
	public DestroySummon(StatsSet set)
	{
		super(set);
	}

	@Override
	public boolean isOffensive()
	{
		return true;
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		if(!isHandler())
			activeChar.unChargeShots(isMagic());
		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			if(getActivateRate() > 0 && !Rnd.chance(getActivateRate()))
				continue;
			L2Character target = n.getValue();
			if(target instanceof L2Summon)
			{
				((L2Summon) target).unSummon();
				getEffects(activeChar, target, getActivateRate() > 0);
			}
		}
	}
}