package L2jFT.game.skills.skillclasses;

import javolution.util.FastList;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Effect;
import L2jFT.game.model.L2Skill;
import L2jFT.game.templates.L2Weapon;
import L2jFT.game.templates.StatsSet;

public class NegateSkill extends L2Skill
{
	private final short _negateSkill;

	public NegateSkill(StatsSet set)
	{
		super(set);
		_negateSkill = set.getShort("negateSkill", (short) 0);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		if(!isHandler())
			activeChar.unChargeShots(isMagic());
		L2Weapon weapon = activeChar.getActiveWeaponItem();
		for(FastList.Node<L2Character> n = targets.head(), end = targets.tail(); (n = n.getNext()) != end;)
		{
			L2Character target = n.getValue();
			for(L2Effect e : target.getAllEffects())
			{
				L2Skill skill = e.getSkill();
				if(skill.getId() == _negateSkill && skill.isCancelable())
					e.exit();
			}
			if(weapon != null)
				weapon.getEffect(false, activeChar, target, isOffensive());
			getEffects(activeChar, target, getActivateRate() > 0);
		}
	}
}