package L2jFT.game.skills.skillclasses;

import javolution.util.FastList;
import L2jFT.game.idfactory.IdFactory;
import L2jFT.game.model.L2Character;
import L2jFT.game.model.L2Skill;
import L2jFT.game.model.L2World;
import L2jFT.game.model.L2RoundTerritory;
import L2jFT.game.model.instances.L2ItemInstance;
import L2jFT.game.templates.StatsSet;

/** 
 * Заготовка для териториальных скиллов
 * На работе ипут мосх, не дают спокойно покодить...
 */
public class ZoneBuilder extends L2Skill
{
	public ZoneBuilder(StatsSet set)
	{
		super(set);
	}

	@Override
	public void useSkill(L2Character activeChar, FastList<L2Character> targets)
	{
		L2RoundTerritory test = new L2RoundTerritory("TRT", activeChar.getX(), activeChar.getY(), 600, activeChar.getZ() - 600, activeChar.getZ() + 600);
		L2World.addTerritory(test);
		test.setActive(true);

		for(int x = test.getXmin(); x < test.getXmax(); x = x + 50)
			for(int y = test.getYmin(); y < test.getYmax(); y = y + 50)
				if(test.isInside(x, y))
				{
					L2ItemInstance adena = new L2ItemInstance(IdFactory.getInstance().getNextId(), 57, 1, 1, "testZone");
					adena.dropMe(activeChar, x, y, activeChar.getZ());
				}

		activeChar.sendMessage("Created round territory with 600 radius and center at your position");
	}
}
