package L2jFT.game.tables;

import L2jFT.database.DatabaseUtils;
import L2jFT.database.FiltredPreparedStatement;
import L2jFT.database.L2DatabaseFactory;
import L2jFT.database.ThreadConnection;

import java.sql.ResultSet;
import java.util.HashMap;
import java.util.logging.Level;
import java.util.logging.Logger;

@SuppressWarnings( { "nls", "unqualified-field-access", "boxing" })
public class SkillSpellbookTable
{
	private static Logger _log = Logger.getLogger(SkillTreeTable.class.getName());
	private static final SkillSpellbookTable _instance = new SkillSpellbookTable();

	public static HashMap<Integer, Short> _skillSpellbooks;

	public static SkillSpellbookTable getInstance()
	{
		return _instance;
	}

	private SkillSpellbookTable()
	{
		_skillSpellbooks = new HashMap<Integer, Short>();
		ThreadConnection con = null;
		FiltredPreparedStatement statement = null;
		ResultSet spbooks = null;
		try
		{
			con = L2DatabaseFactory.getInstance().getConnection();
			statement = con.prepareStatement("SELECT skill_id, level, item_id FROM skill_spellbooks");
			spbooks = statement.executeQuery();

			while(spbooks.next())
				_skillSpellbooks.put(hashCode(new short[] {
						spbooks.getShort("skill_id"), spbooks.getShort("level") }), spbooks.getShort("item_id"));

			_log.config("SkillSpellbookTable: Loaded " + _skillSpellbooks.size() + " Spellbooks.");
		}
		catch(Exception e)
		{
			_log.log(Level.WARNING, "error while loading spellbooks	", e);
		}
		finally
		{
			DatabaseUtils.closeDatabaseCSR(con, statement, spbooks);
		}
	}

	public static int hashCode(short a[])
	{
		if(a == null)
			return 0;

		return a[1] + (a[0] << 16);
	}
}