package L2jFT.game.tables;

import L2jFT.game.model.L2Skill;
import L2jFT.game.skills.SkillsEngine;

import java.util.ArrayList;
import java.util.HashMap;

@SuppressWarnings( { "nls", "unqualified-field-access", "boxing" })
public class SkillTable
{
	private static SkillTable _instance = new SkillTable();

	private HashMap<Integer, L2Skill> _skills;
	private ArrayList<L2Skill> _pledgeskills;
	private boolean _initialized = true;

	public static SkillTable getInstance()
	{
		return _instance;
	}

	private SkillTable()
	{
		_skills = new HashMap<Integer, L2Skill>();
		_pledgeskills = new ArrayList<L2Skill>();
		SkillsEngine.getInstance().loadAllSkills(_skills, _pledgeskills);
	}

	public void reload()
	{
		_instance = new SkillTable();
		SkillTreeTable.getInstance().reloadEnchant();
	}

	public boolean isInitialized()
	{
		return _initialized;
	}

	public L2Skill getInfo(int magicId, int level)
	{
		return _skills.get(magicId * 200 + level);
	}

	public L2Skill[] getPledgeSkills()
	{
		return _pledgeskills.toArray(new L2Skill[_pledgeskills.size()]);
	}

	public int getMaxLevel(int magicId, int curlevel)
	{
		L2Skill temp;
		int level = curlevel;

		while(level < 200)
		{
			level++;
			temp = _skills.get(magicId * 200 + level);

			if(temp == null)
				return level - 1;
		}

		return level;
	}
}