/**
 *
 */
package L2jFT.game.taskmanager.tasks;

import L2jFT.game.model.L2Player;
import L2jFT.game.model.L2World;
import L2jFT.game.network.serverpackets.UserInfo;
import L2jFT.game.taskmanager.Task;
import L2jFT.game.taskmanager.TaskManager;
import L2jFT.game.taskmanager.TaskManager.ExecutedTask;
import L2jFT.game.taskmanager.TaskTypes;

import java.util.logging.Logger;

/**
 * @author Layane
 *
 */
public class TaskRecom extends Task
{
	private static final Logger _log = Logger.getLogger(TaskRecom.class.getName());
	private static final String NAME = "sp_recommendations";

	/* (non-Javadoc)
	 * @see L2jFT.game.taskmanager.Task#getName()
	 */
	@Override
	public String getName()
	{
		return NAME;
	}

	/* (non-Javadoc)
	 * @see L2jFT.game.taskmanager.Task#onTimeElapsed(L2jFT.game.taskmanager.TaskManager.ExecutedTask)
	 */
	@Override
	public void onTimeElapsed(ExecutedTask task)
	{
		_log.config("Recommendation Global Task: launched.");
		for(L2Player player : L2World.getAllPlayers())
		{
			player.restartRecom();
			player.sendPacket(new UserInfo(player));
		}
		_log.config("Recommendation Global Task: complited.");
	}

	@Override
	public void initializate()
	{
		super.initializate();
		TaskManager.addUniqueTask(NAME, TaskTypes.TYPE_GLOBAL_TASK, "1", "13:00:00", "");
	}

}
