package L2jFT.game.templates;

public class L2CharTemplate
{
	private StatsSet _set;

	// BaseStats
	public final byte baseSTR;
	public final byte baseCON;
	public final byte baseDEX;
	public final byte baseINT;
	public final byte baseWIT;
	public final byte baseMEN;
	public float baseHpMax;
	public final float baseCpMax;
	public final float baseMpMax;

	/** HP Regen base */
	public final float baseHpReg;

	/** MP Regen base */
	public final float baseMpReg;

	/** CP Regen base */
	public final float baseCpReg;

	public final int basePAtk;
	public final int baseMAtk;
	public int basePDef;
	public final int baseMDef;
	public final int basePAtkSpd;
	public final int baseMAtkSpd;
	public final float baseMReuseRate;
	public final int baseShldDef;
	public final int baseAtkRange;
	public final int baseShldRate;
	public final int baseCritRate;
	public final int baseRunSpd;
	public final int baseWalkSpd;
	// SpecialStats
	public final int baseBreath;
	public final int baseAggression;
	public final int baseBleed;
	public final int basePoison;
	public final int baseStun;
	public final int baseRoot;
	public final int baseMovement;
	public final int baseConfusion;
	public final int baseSleep;
	public final int baseFire;
	public final int baseWind;
	public final int baseWater;
	public final int baseEarth;
	public final int baseAggressionRes;
	public final int baseBleedRes;
	public final int basePoisonRes;
	public final int baseStunRes;
	public final int baseRootRes;
	public final int baseMovementRes;
	public final int baseConfusionRes;
	public final int baseSleepRes;
	public final int baseFireRes;
	public final int baseWindRes;
	public final int baseWaterRes;
	public final int baseEarthRes;

	public final int collisionRadius;
	public final int collisionHeight;

	public L2CharTemplate(StatsSet set)
	{
		_set = set;

		// Base stats
		baseSTR = set.getByte("baseSTR");
		baseCON = set.getByte("baseCON");
		baseDEX = set.getByte("baseDEX");
		baseINT = set.getByte("baseINT");
		baseWIT = set.getByte("baseWIT");
		baseMEN = set.getByte("baseMEN");
		baseHpMax = set.getFloat("baseHpMax");
		baseCpMax = set.getFloat("baseCpMax");
		baseMpMax = set.getFloat("baseMpMax");
		baseHpReg = set.getFloat("baseHpReg");
		baseCpReg = set.getFloat("baseCpReg");
		baseMpReg = set.getFloat("baseMpReg");
		basePAtk = set.getInteger("basePAtk");
		baseMAtk = set.getInteger("baseMAtk");
		basePDef = set.getInteger("basePDef");
		baseMDef = set.getInteger("baseMDef");
		basePAtkSpd = set.getInteger("basePAtkSpd");
		baseMAtkSpd = set.getInteger("baseMAtkSpd");
		baseMReuseRate = set.getFloat("baseMReuseDelay", 1.f);
		baseShldDef = set.getInteger("baseShldDef");
		baseAtkRange = set.getInteger("baseAtkRange");
		baseShldRate = set.getInteger("baseShldRate");
		baseCritRate = set.getInteger("baseCritRate");
		baseRunSpd = set.getInteger("baseRunSpd");
		baseWalkSpd = set.getInteger("baseWalkSpd");
		// SpecialStats
		baseBreath = set.getInteger("baseBreath", 100);
		baseAggression = set.getInteger("baseAggression", 0);
		baseBleed = set.getInteger("baseBleed", 0);
		basePoison = set.getInteger("basePoison", 0);
		baseStun = set.getInteger("baseStun", 0);
		baseRoot = set.getInteger("baseRoot", 0);
		baseMovement = set.getInteger("baseMovement", 0);
		baseConfusion = set.getInteger("baseConfusion", 0);
		baseSleep = set.getInteger("baseSleep", 0);
		baseFire = set.getInteger("baseFire", 0);
		baseWind = set.getInteger("baseWind", 0);
		baseWater = set.getInteger("baseWater", 0);
		baseEarth = set.getInteger("baseEarth", 0);
		baseAggressionRes = set.getInteger("baseAaggressionRes", 0);
		baseBleedRes = set.getInteger("baseBleedRes", 0);
		basePoisonRes = set.getInteger("basePoisonRes", 0);
		baseStunRes = set.getInteger("baseStunRes", 0);
		baseRootRes = set.getInteger("baseRootRes", 0);
		baseMovementRes = set.getInteger("baseMovementRes", 0);
		baseConfusionRes = set.getInteger("baseConfusionRes", 0);
		baseSleepRes = set.getInteger("baseSleepRes", 0);
		baseFireRes = set.getInteger("baseFireRes", 0);
		baseWindRes = set.getInteger("baseWindRes", 0);
		baseWaterRes = set.getInteger("baseWaterRes", 0);
		baseEarthRes = set.getInteger("baseEarthRes", 0);

		// Geometry
		collisionRadius = set.getInteger("collision_radius", 5);
		collisionHeight = set.getInteger("collision_height", 5);
	}

	public int getNpcId()
	{
		return 0;
	}

	public StatsSet getSet()
	{
		return _set;
	}

	public void setSet(StatsSet set)
	{
		_set = set;
	}
}
