package L2jFT.login.serverpackets;

public final class AccountKicked extends L2LoginServerPacket
{
	public static enum AccountKickedReason
	{
		REASON_DATA_STEALER(0x01),
		REASON_GENERIC_VIOLATION(0x08),
		REASON_7_DAYS_SUSPENDED(0x10),
		REASON_PERMANENTLY_BANNED(0x20);

		private final int _code;

		AccountKickedReason(int code)
		{
			_code = code;
		}

		public final int getCode()
		{
			return _code;
		}
	}

	private AccountKickedReason _reason;

	public AccountKicked(AccountKickedReason reason)
	{
		_reason = reason;
	}

	@Override
	protected void write()
	{
		writeC(0x02);
		writeD(_reason.getCode());
	}
}
