package L2jFT.util;

import L2jFT.game.model.L2Character;

/**
 * This class permit to pass (x, y, z, heading) position data to method.<BR><BR>
 */
public final class CharPosition extends Location
{
	public int objectId;

	/**
	 * Constructor of L2CharPosition.<BR><BR>
	 */
	public CharPosition(int x, int y, int z, int heading)
	{
		super(x, y, z, heading);
		objectId = (int) System.currentTimeMillis();
	}

	public CharPosition(L2Character obj)
	{
		super(obj.getX(), obj.getY(), obj.getZ(), obj.getHeading());
		objectId = (int) System.currentTimeMillis();
	}

	@Override
	public final String toString()
	{
		return "Coords(" + x + "," + y + "," + z + "," + h + ")";
	}

	public int getObjectId()
	{
		return objectId;
	}
}
