DROP TABLE IF EXISTS prices;
CREATE TABLE prices SELECT item_id, name, price, weight, crystal_type, item_type, consume_type, icon  FROM etcitem;
ALTER TABLE `prices` ENGINE = MEMORY;
ALTER TABLE `prices` ADD PRIMARY KEY (`item_id`), ADD KEY (`name`), ADD KEY(`price`), ADD KEY(`crystal_type`), ADD KEY(`item_type`);
INSERT INTO prices SELECT item_id, name, price, weight, crystal_type, 'weapon', 'normal', icon FROM weapon;
INSERT INTO prices SELECT item_id, name, price, weight, crystal_type, 'armor', 'normal', icon FROM armor;
ALTER TABLE `prices` CHANGE `item_type` `item_type` ENUM( 'armor', 'arrow', 'bait', 'dye', 'harvest', 'herb', 'lotto', 'material', 'mticket', 'none', 'pet_collar', 'potion', 'quest', 'race_ticket', 'recipe', 'scroll', 'seed', 'shot', 'spellbook', 'weapon' ) NOT NULL;
ALTER TABLE `prices` CHANGE `consume_type` `consume_type` ENUM( 'asset','normal','stackable' ) NOT NULL;
ALTER TABLE `prices` CHANGE `icon` `icon` VARCHAR(50) NOT NULL;
ALTER TABLE `prices` CHANGE `name` `name` VARCHAR(80) NOT NULL;
ALTER TABLE `prices` CHANGE `weight` `weight` SMALLINT(5) UNSIGNED NOT NULL;
ALTER TABLE `prices` ADD `class` ENUM( 'CONSUMABLE', 'MISC', 'EQUIPMENT', 'MATHERIALS', 'OTHER', 'PIECES', 'RECIPIES', 'SPELLBOOKS' ) NOT NULL DEFAULT 'OTHER' AFTER `consume_type`;
ALTER TABLE `prices` ADD INDEX ( `class` );
UPDATE `prices` SET `class` = 'EQUIPMENT' WHERE `item_type` IN ( 'armor', 'weapon', 'arrow', 'bait' );
UPDATE `prices` SET `class` = 'MATHERIALS' WHERE `item_type` = 'material' AND prices.weight < '60' AND `name` NOT LIKE '%Life Stone:%';
UPDATE `prices` SET `class` = 'CONSUMABLE' WHERE (`item_type`='potion' OR `name` IN ( 'Cursed Bone', 'Crystal: D-Grade', 'Crystal: C-Grade', 'Crystal: B-Grade', 'Crystal: A-Grade', 'Crystal: S Grade' ) OR `name` LIKE '%Soulshot:%' OR `name` LIKE '%Spiritshot:%' OR `name` LIKE '%Beast S%' OR `name` LIKE '%Scroll of Escape%' OR `name` LIKE '%Scroll of Resurrection%' OR `name` LIKE '%Waking Scroll%' OR `name` LIKE '%SP Scroll%' OR `name` LIKE '%L2Day%' OR `name` LIKE '%Charm of Courage:%') AND `item_type` NOT LIKE 'recipe';
UPDATE `prices` SET `class` = 'PIECES' WHERE `item_type` = 'material' AND weight >= '60';
UPDATE `prices` SET `class` = 'SPELLBOOKS' WHERE `item_type` = 'spellbook';
UPDATE `prices` SET `class` = 'RECIPIES' WHERE `item_type` = 'recipe';
UPDATE `prices` SET `class` = 'MISC' WHERE `item_type` = 'dye' OR `name` LIKE '%Life Stone:%';