DROP TABLE IF EXISTS `npc`;
CREATE TABLE `npc` (
  `ordinal` smallint(4) unsigned NOT NULL default '0',
  `id` int(11) unsigned NOT NULL default '0',
  `name` varchar(45) default NULL,
  `title` varchar(25) NOT NULL default '',
  `class` varchar(40) default NULL,
  `collision_radius` decimal(5,2) default NULL,
  `collision_height` decimal(5,2) default NULL,
  `level` int(11) default NULL,
  `sex` varchar(6) default NULL,
  `type` varchar(20) default NULL,
  `ai_type` varchar(20) default NULL,
  `attackrange` int(11) default NULL,
  `hp` int(11) default NULL,
  `base_hp_regen` double(11,3) NOT NULL default '0.000',
  `mp` int(11) default NULL,
  `base_mp_regen` double(11,3) NOT NULL default '0.000',
  `str` int(11) default NULL,
  `con` int(11) default NULL,
  `dex` int(11) default NULL,
  `int` int(11) default NULL,
  `wit` int(11) default NULL,
  `men` int(11) default NULL,
  `exp` int(11) default NULL,
  `sp` int(11) default NULL,
  `patk` int(11) default NULL,
  `pdef` int(11) default NULL,
  `matk` int(11) default NULL,
  `mdef` int(11) default NULL,
  `atkspd` int(11) default NULL,
  `aggro` int(11) default NULL,
  `matkspd` int(11) default NULL,
  `rhand` int(11) default NULL,
  `lhand` int(11) default NULL,
  `armor` int(11) default NULL,
  `walkspd` int(11) default NULL,
  `runspd` int(11) default NULL,
  `faction_id` varchar(40) default NULL,
  `faction_range` int(11) default NULL,
  `last_editor` varchar(50) default 'Local',
  `last_changed` varchar(20) default NULL,
  `displayId` int(11) NOT NULL default '0',
  `shield_defense_rate` int(11) default NULL,
  `shield_defense` int(11) default NULL,
  `corpse_time` int(11) default NULL,
  `base_rand_dam` int(11) default NULL,
  `base_critical` int(11) default NULL,
  `physical_hit_modify` int(11) default NULL,
  `base_reuse_delay` int(11) default NULL,
  `physical_avoid_modify` int(11) default NULL,
  `hit_time_factor` double(11,2) default '0.00',
  `isDropHerbs` enum('false','true') NOT NULL default 'true',
  `map_flag` tinyint(1) NOT NULL default '0',
  `boss_flag` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `map_flag` (`map_flag`,`boss_flag`)
) ENGINE=MyISAM;

INSERT INTO `npc` VALUES
(1,20001,'Gremlin','','gremlin','10.00','15.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,20,50,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(2,20002,'Rabbit','','rabbit','5.00','4.50',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,50,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','true',0,0),
(3,20003,'Goblin','','goblin','10.00','16.50',5,'male','L2Monster','Fighter',40,126,'2.000',77,'0.900',40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.32','true',1,0),
(4,20004,'Imp','','imp','10.00','24.00',6,'male','L2Monster','Fighter',40,147,'2.000',85,'0.900',40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(5,20005,'Imp Elder','','imp','10.00','24.00',7,'male','L2Monster','Fighter',40,171,'2.000',94,'0.900',40,43,30,21,20,10,249,8,18,48,6,43,278,0,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(6,20006,'Orc Archer','','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,'2.000',102,'0.900',40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(7,20007,'Green Fungus','','walking_fungus','15.00','22.50',9,'male','L2Monster','Fighter',40,226,'2.000',111,'0.900',40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(8,20008,'Felim Lizardman','','virud_lizardman','10.00','23.00',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,498,19,30,80,12,59,278,0,253,1,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(9,20009,'Vuku Orc','','orc','10.00','21.00',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,498,19,33,73,12,59,278,0,253,156,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',1,0),
(10,20010,'Felim Lizardman Scout','','virud_lizardman','10.00','23.00',15,'male','L2Monster','Ranger',40,390,'2.500',165,'1.200',40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,16,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(11,20011,'Vuku Orc Archer','','orc_archer','14.00','25.00',15,'male','L2Monster','Ranger',500,390,'2.500',165,'1.200',40,43,30,21,20,10,550,22,82,76,14,62,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(12,20012,'Gora Werewolf','','werewolf','10.00','26.00',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,582,23,44,72,15,64,278,500,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',1,0),
(13,20013,'Dryad','','dryad','9.00','20.00',13,'female','L2Monster','Fighter',40,339,'2.500',147,'1.200',40,43,30,21,20,10,462,18,27,77,11,56,278,0,253,0,0,0,40,110,'elemental1_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(14,20014,'Felim Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,605,25,48,75,17,67,278,0,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','true',1,0),
(15,20015,'Marsh Zombie','','zombie','13.00','21.00',13,'male','L2Monster','Mystic',40,339,'2.500',147,'1.200',40,43,30,21,20,10,654,26,33,63,11,56,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(16,20016,'Stone Golem','','stone_golem','20.00','31.00',13,'male','L2Monster','Mystic',40,339,'2.500',147,'1.200',40,43,30,21,20,10,654,26,30,70,11,56,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(17,20017,'Vuku Orc Fighter','','orc_fighter','12.00','22.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(18,20018,'Carnivorous Fungus','','walking_fungus','15.00','22.50',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,424,16,37,66,12,59,278,500,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',0,0),
(19,20019,'Dryad Elder','','dryad','9.00','20.00',14,'female','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,498,19,30,80,12,59,278,0,253,0,0,0,40,110,'elemental1_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(20,20020,'Marsh Zombie Lord','','zombie','13.00','21.00',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(21,20021,'Red Bear','','grizzly','21.00','40.00',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,498,19,37,66,12,59,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(22,20022,'Misery Skeleton','','skeleton','11.00','25.00',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,35,7,10,8,0,0,-6,'0.30','true',1,0),
(23,20023,'Shadow Beast','','onyx_beast','14.00','14.50',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(24,20024,'Langk Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,16,0,0,52,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','true',1,0),
(25,20025,'Lesser Dark Horror','','dark_horror','20.00','35.00',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,545,22,36,76,14,62,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(26,20026,'Ruin Zombie','','zombie','13.00','21.00',15,'male','L2Monster','Mystic',40,390,'2.500',165,'1.200',40,43,30,21,20,10,755,31,40,69,14,62,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(27,20027,'Langk Lizardman Scout','','virud_lizardman','10.00','23.00',16,'male','L2Monster','Ranger',40,417,'2.500',174,'1.200',40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,16,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(28,20028,'Pincher','','giant_spider','26.00','26.50',16,'male','L2Monster','Mystic',40,417,'2.500',174,'1.200',40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(29,20029,'Ruin Zombie Leader','','zombie','13.00','21.00',16,'male','L2Monster','Mystic',40,417,'2.500',174,'1.200',40,43,30,21,20,10,807,33,36,87,15,64,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(30,20030,'Langk Lizardman','','virud_lizardman','10.00','23.00',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,534,22,36,76,14,62,278,0,253,1,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(31,20031,'Omen Beast','','onyx_beast','14.00','14.50',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,504,21,48,75,17,67,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(32,20032,'Pinrul','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,'2.500',184,'1.200',40,43,30,21,20,10,605,25,48,75,17,67,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(33,20033,'Shade Horror','','dark_horror','20.00','35.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,504,21,48,75,17,67,278,0,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(34,20034,'Prowler','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,'2.500',184,'1.200',40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(35,20035,'Tracker Skeleton','','skeleton','11.00','25.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,605,25,42,75,17,67,317,0,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,39,7,10,8,0,0,-6,'0.30','true',1,0),
(36,20036,'Lirein','','sylph','11.00','35.00',18,'female','L2Monster','Mystic',40,476,'2.500',193,'1.200',40,43,30,21,20,10,652,28,53,79,19,70,278,500,253,0,0,0,60,60,'elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(37,20037,'Mana Seeker','','mana_vampire','11.00','20.00',18,'male','L2Monster','Mystic',40,476,'5.000',193,'1.200',40,43,30,21,20,10,496,21,44,95,19,70,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.39','false',0,0),
(38,20038,'Poison Spider','','poison_spider','27.00','25.50',18,'male','L2Monster','Mystic',40,476,'2.500',193,'1.200',40,43,30,21,20,10,704,31,53,79,19,70,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.65','true',1,0),
(39,20039,'Scavenger Wererat','','wererat','14.00','25.00',18,'male','L2Monster','Fighter',40,476,'2.500',193,'1.200',40,43,30,21,20,10,640,28,46,79,19,70,317,0,289,12,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.61','true',1,0),
(40,20040,'Sukar Wererat','','wererat','14.00','25.00',18,'male','L2Monster','Fighter',40,476,'2.500',193,'1.200',40,43,30,21,20,10,533,23,46,79,19,70,317,0,289,216,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.61','true',1,0),
(41,20041,'Tainted Zombie','','zombie','13.00','21.00',18,'male','L2Monster','Mystic',40,476,'2.500',193,'1.200',40,43,30,21,20,10,754,33,44,95,19,70,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(42,20042,'Tracker Skeleton Leader','','skeleton','11.00','25.00',18,'male','L2Monster','Fighter',40,476,'2.500',193,'1.200',40,43,30,21,20,10,652,28,46,79,19,70,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,40,7,10,8,0,0,-6,'0.30','true',1,0),
(43,20043,'Arachnid Tracker','','poison_spider','27.00','25.50',19,'male','L2Monster','Mystic',40,508,'2.500',203,'1.200',40,43,30,21,20,10,760,34,48,99,21,73,278,500,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.65','true',1,0),
(44,20044,'Lirein Elder','','sylph','11.00','35.00',19,'female','L2Monster','Mystic',40,508,'2.500',203,'1.200',40,43,30,21,20,10,691,31,58,82,21,73,278,500,253,0,0,0,60,60,'elemental1_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(45,20045,'Skeleton Scout','','skeleton_archer','11.00','27.00',19,'male','L2Monster','Ranger',500,508,'2.500',203,'1.200',40,43,30,21,20,10,698,31,107,99,21,73,249,0,227,275,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(46,20046,'Stink Zombie','','zombie','13.00','21.00',19,'male','L2Monster','Mystic',40,508,'2.500',203,'1.200',40,43,30,21,20,10,799,36,48,99,21,73,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(47,20047,'Sukar Wererat Leader','','wererat','14.00','25.00',19,'male','L2Monster','Fighter',40,508,'2.500',203,'1.200',40,43,30,21,20,10,576,26,42,99,21,73,317,500,289,216,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.61','true',1,0),
(48,20048,'Lesser Succubus','','succubus','10.00','36.00',20,'female','L2Monster','Mystic',40,541,'2.500',213,'1.200',40,43,30,21,20,10,605,27,57,94,23,76,278,500,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(49,20049,'Lycanthrope','','werewolf','10.00','26.00',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,726,32,63,86,23,76,278,500,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',1,0),
(50,20050,'Arachnid Predator','','poison_spider','27.00','25.50',20,'male','L2Monster','Mystic',40,541,'2.500',213,'1.200',40,43,30,21,20,10,799,35,63,86,23,76,278,500,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.65','true',1,0),
(51,20051,'Skeleton Bowman','','skeleton_archer','11.00','27.00',20,'male','L2Monster','Ranger',500,541,'2.500',213,'1.200',40,43,30,21,20,10,734,32,117,104,23,76,249,0,227,275,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(52,20052,'Lesser Succubus Turen','','succubus','10.00','36.00',21,'female','L2Monster','Mystic',40,575,'3.500',227,'1.500',40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(53,20053,'Ol Mahum Patrol','','ol_mahum_archer','14.00','25.00',21,'male','L2Monster','Ranger',500,575,'3.500',227,'1.500',40,43,30,21,20,10,787,36,140,98,25,80,249,0,227,14,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','true',1,0),
(54,20054,'Ruin Spartoi','','spartoi','11.00','27.00',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,764,35,57,108,25,80,278,0,253,73,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(55,20055,'Wandering Eye','','monster_eye','21.00','43.00',21,'male','L2Monster','Mystic',40,575,'3.500',227,'1.500',40,43,30,21,20,10,764,35,57,108,25,80,278,0,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(56,20056,'Dre Vanul Disposer','','dre_vanul','14.00','36.00',22,'male','L2Monster','Fighter',40,611,'3.500',242,'1.500',40,43,30,21,20,10,767,36,75,93,28,83,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.35','true',1,0),
(57,20057,'Lesser Succubus Tilfo','','succubus','10.00','36.00',22,'female','L2Monster','Mystic',40,611,'3.500',242,'1.500',40,43,30,21,20,10,698,33,75,93,28,83,278,500,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(58,20058,'Ol Mahum Guard','','ol_mahum','13.50','25.00',22,'male','L2Monster','Fighter',40,611,'3.500',242,'1.500',40,43,30,21,20,10,821,39,75,93,28,83,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(59,20059,'Hungry Eye','','monster_eye','21.00','43.00',22,'male','L2Monster','Mystic',40,611,'3.500',242,'1.500',40,43,30,21,20,10,821,39,75,93,28,83,278,0,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(60,20060,'Raging Spartoi','','spartoi','11.00','27.00',22,'male','L2Monster','Fighter',40,611,'3.500',242,'1.500',40,43,30,21,20,10,837,40,54,113,28,83,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,46,7,10,8,0,0,-6,'0.30','true',1,0),
(61,20061,'Ol Mahum Straggler','','ol_mahum','13.50','25.00',23,'male','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,895,43,75,107,31,87,278,500,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(62,20062,'Tumran Bugbear','','bugbear','17.00','35.00',23,'male','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,156,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(63,20063,'Ol Mahum Shooter','','ol_mahum_archer','14.00','25.00',24,'male','L2Monster','Ranger',500,687,'3.500',272,'1.500',40,43,30,21,20,10,963,47,181,111,34,90,249,0,227,14,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','true',1,0),
(64,20064,'Tumran Bugbear Warrior','','bugbear','17.00','35.00',24,'male','L2Monster','Fighter',40,687,'3.500',272,'1.500',40,43,30,21,20,10,954,47,89,101,34,90,278,500,253,88,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(65,20065,'Ol Mahum Patrolman','','ol_mahum','13.50','25.00',25,'male','L2Monster','Fighter',40,728,'3.500',287,'1.500',40,43,30,21,20,10,826,41,80,127,37,94,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(66,20066,'Ol Mahum Captain','','ol_mahum_champion','14.00','27.00',25,'male','L2Monster','Fighter',40,728,'3.500',287,'1.500',40,43,30,21,20,10,1052,53,97,105,37,94,278,500,253,69,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.63','true',1,0),
(67,20067,'Monster Eye Watcher','','monster_eye','21.00','43.00',25,'male','L2Monster','Mystic',40,728,'3.500',287,'1.500',40,43,30,21,20,10,992,50,80,127,37,94,278,0,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(68,20068,'Monster Eye Destroyer','','monster_eye','21.00','43.00',26,'male','L2Monster','Mystic',40,770,'3.500',303,'1.500',40,43,30,21,20,10,1078,54,87,132,41,98,278,500,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(69,20069,'Selu Lizardman Scout','','virud_lizardman','10.00','23.00',26,'male','L2Monster','Ranger',40,770,'3.500',303,'1.500',40,43,30,21,20,10,880,44,87,132,41,98,278,0,253,16,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(70,20070,'Lesser Basilisk','','lesser_basilisk','34.00','25.00',27,'male','L2Monster','Fighter',40,813,'3.500',318,'1.500',40,43,30,21,20,10,1124,58,114,114,45,102,278,500,253,0,0,0,35,131,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(71,20071,'Selu Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',27,'male','L2Monster','Fighter',40,813,'3.500',318,'1.500',40,43,30,21,20,10,946,48,114,114,45,102,278,500,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','true',0,0),
(72,20072,'Basilisk','','lesser_basilisk','34.00','25.00',28,'male','L2Monster','Fighter',40,859,'3.500',334,'1.500',40,43,30,21,20,10,1189,62,102,143,49,106,278,500,253,0,0,0,35,131,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(73,20073,'Ol Mahum Legionnaire','','ol_mahum','13.50','25.00',28,'male','L2Monster','Fighter',40,859,'3.500',334,'1.500',40,43,30,21,20,10,981,52,113,130,49,106,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(74,20074,'Androscorpio','','onyx_beast','14.00','14.50',29,'male','L2Monster','Fighter',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1243,67,122,135,53,110,278,0,253,0,0,0,30,120,'scropio_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(75,20075,'Ant Larva','','ant_larva','12.00','8.00',29,'male','L2Monster','Fighter',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1139,61,111,149,53,110,278,0,253,0,0,0,40,60,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',1,0),
(76,20076,'Ol Mahum Commander','','ol_mahum_champion','14.00','27.00',29,'male','L2Monster','Fighter',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1319,71,134,123,53,110,278,500,253,69,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.63','true',1,0),
(77,20077,'Androscorpio Hunter','','onyx_beast','14.00','14.50',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1308,72,145,128,58,114,278,0,253,0,0,0,30,120,'scropio_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(78,20078,'Whispering Wind','','sylph_100_bi','20.00','70.00',30,'female','L2Monster','Mystic',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1308,72,120,155,58,114,278,0,253,0,0,0,60,60,'elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(79,20079,'Ant','','ant','26.00','15.00',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1308,72,145,128,58,114,278,0,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(80,20080,'Ant Captain','','ant','26.00','15.00',31,'male','L2Monster','Fighter',40,1004,'4.500',381,'1.800',40,43,30,21,20,10,1425,79,157,133,64,118,278,500,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(81,20081,'Ant Overseer','','ant','26.00','15.00',32,'male','L2Monster','Fighter',40,1056,'9.000',397,'1.800',40,43,30,21,20,10,1200,67,169,138,69,123,278,0,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.26','false',1,0),
(82,20082,'Ant Recruit','','ant_soldier','35.00','17.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(83,20083,'Granite Golem','','stone_golem','20.00','31.00',33,'male','L2Monster','Mystic',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,2239,129,151,173,75,128,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(84,20084,'Ant Patrol','','ant_soldier','35.00','17.00',34,'male','L2Monster','Fighter',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1667,97,196,148,82,132,278,0,253,0,0,0,80,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(85,20085,'Puncher','','stone_golem','20.00','31.00',34,'male','L2Monster','Mystic',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,2424,142,196,148,82,132,278,500,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(86,20086,'Ant Guard','','ant_soldier','35.00','17.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1484,88,192,169,89,137,278,0,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(87,20087,'Ant Soldier','','ant_soldier','35.00','17.00',35,'male','L2Monster','Fighter',40,1220,'9.000',446,'1.800',40,43,30,21,20,10,1780,105,192,169,89,137,278,500,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(88,20088,'Ant Warrior Captain','','ant_soldier','35.00','17.00',36,'male','L2Monster','Fighter',40,1279,'9.000',463,'1.800',40,43,30,21,20,10,1984,120,227,159,96,142,278,500,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(89,20089,'Noble Ant','','noble_ant','20.00','48.00',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,1659,102,222,182,104,147,278,0,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(90,20090,'Noble Ant Leader','','noble_ant','20.00','48.00',38,'male','L2Monster','Fighter',40,1400,'9.000',497,'1.800',40,43,30,21,20,10,1829,114,261,171,112,153,278,500,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',1,0),
(91,20091,'Young Fox','','fox','9.50','10.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(92,20092,'Monster Eye','','monster_eye','21.00','43.00',10,'male','L2Monster','Mystic',40,257,'2.000',120,'0.900',40,43,30,21,20,10,294,10,22,61,8,49,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.30','true',1,0),
(93,20093,'Orc Fighter','','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,363,12,22,61,8,49,278,500,253,1,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(94,20094,'Orc Marksman','','orc_archer','14.00','25.00',10,'male','L2Monster','Ranger',500,257,'2.000',120,'0.900',40,43,30,21,20,10,305,10,56,55,8,49,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',0,0),
(95,20095,'Vampire Bat','','vampire_bat','10.00','33.50',10,'male','L2Monster','Mystic',40,257,'2.000',120,'0.900',40,43,30,21,20,10,296,10,22,61,8,49,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.50','true',1,0),
(96,20096,'Orc Lieutenant','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,391,15,23,70,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(97,20097,'Drill Bat','','vampire_bat','10.00','33.50',11,'male','L2Monster','Mystic',40,292,'2.500',129,'1.200',40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.50','true',1,0),
(98,20098,'Orc Fighter Leader','','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,447,17,30,60,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(99,20099,'Skeleton','','skeleton','11.00','25.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,33,7,10,8,0,0,-6,'0.30','true',1,0),
(100,20100,'Skeleton Archer','','skeleton_archer','11.00','27.00',13,'male','L2Monster','Ranger',500,339,'2.500',147,'1.200',40,43,30,21,20,10,405,16,74,63,11,56,249,500,227,14,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(101,20101,'Crasher','','stone_golem','20.00','31.00',14,'male','L2Monster','Mystic',40,364,'2.500',156,'1.200',40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(102,20102,'Skeleton Marksman','','skeleton_archer','11.00','27.00',14,'male','L2Monster','Ranger',500,364,'2.500',156,'1.200',40,43,30,21,20,10,428,17,82,66,12,59,249,0,227,14,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(103,20103,'Giant Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,'2.500',165,'1.200',40,43,30,21,20,10,545,22,40,69,14,62,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(104,20104,'Skeleton Lord','','skeleton','11.00','25.00',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,445,18,29,84,14,62,317,0,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,36,7,10,8,0,0,-6,'0.30','true',1,0),
(105,20105,'Dark Horror','','dark_horror','20.00','35.00',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,576,23,44,72,15,64,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(106,20106,'Talon Spider','','giant_spider','26.00','26.50',16,'male','L2Monster','Mystic',40,417,'2.500',174,'1.200',40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(107,20107,'Wererat','','wererat','14.00','25.00',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,475,19,40,79,15,64,278,0,253,0,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.61','true',1,0),
(108,20108,'Blade Spider','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,'2.500',184,'1.200',40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(109,20109,'Salamander','','salamander','16.00','6.80',17,'male','L2Monster','Fighter',40,446,'5.000',184,'1.200',40,43,30,21,20,10,494,21,44,83,17,67,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.20','false',1,0),
(110,20110,'Undine','','undine','12.00','27.00',17,'female','L2Monster','Mystic',40,446,'5.000',184,'1.200',40,43,30,21,20,10,479,20,44,83,17,67,278,500,253,0,0,0,60,60,'elemental4_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.35','false',1,0),
(111,20111,'Wererat Leader','','wererat','14.00','25.00',17,'male','L2Monster','Fighter',40,446,'5.000',184,'1.200',40,43,30,21,20,10,479,20,40,91,17,67,278,500,253,1,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(112,20112,'Salamander Elder','','salamander','16.00','6.80',18,'male','L2Monster','Fighter',40,476,'5.000',193,'1.200',40,43,30,21,20,10,496,21,53,79,19,70,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.20','false',1,0),
(113,20113,'Undine Elder','','undine','12.00','27.00',18,'female','L2Monster','Mystic',40,476,'5.000',193,'1.200',40,43,30,21,20,10,505,22,44,95,19,70,278,500,253,0,0,0,60,60,'elemental4_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.35','false',1,0),
(114,20114,'Salamander Noble','','salamander','16.00','6.80',19,'male','L2Monster','Fighter',40,508,'5.000',203,'1.200',40,43,30,21,20,10,525,23,58,82,21,73,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.20','false',1,0),
(115,20115,'Undine Noble','','undine','12.00','27.00',19,'female','L2Monster','Mystic',40,508,'5.000',203,'1.200',40,43,30,21,20,10,536,24,58,82,21,73,278,500,253,0,0,0,60,60,'elemental4_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.35','false',1,0),
(116,20116,'Fox','','fox','9.50','10.00',2,'male','L2Monster','Fighter',40,75,'2.000',52,'0.900',40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(117,20117,'Dre Vanul','','dre_vanul','14.00','36.00',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,666,29,63,86,23,76,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.35','true',1,0),
(118,20118,'Dre Vanul Scout','','dre_vanul','14.00','36.00',21,'male','L2Monster','Ranger',40,575,'3.500',227,'1.500',40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.35','true',1,0),
(119,20119,'Elder Fox','','fox','9.50','10.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(120,20120,'Wolf','','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,'2.000',68,'0.900',40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(121,20121,'Giant Toad','','poison_toad','20.00','10.00',5,'male','L2Monster','Fighter',40,126,'2.000',77,'0.900',40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,0,0,0,50,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',1,0),
(122,20130,'Orc','','orc','10.00','21.00',6,'male','L2Monster','Fighter',40,147,'2.000',85,'0.900',40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,156,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',1,0),
(123,20131,'Orc Grunt','','orc','10.00','21.00',7,'male','L2Monster','Fighter',40,171,'2.000',94,'0.900',40,43,30,21,20,10,249,8,17,53,6,43,278,0,253,4,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',1,0),
(124,20132,'Werewolf','','werewolf','10.00','26.00',9,'male','L2Monster','Fighter',40,226,'2.000',111,'0.900',40,43,30,21,20,10,321,11,20,58,7,47,278,0,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',1,0),
(125,20133,'Bugbear','','bugbear','17.00','35.00',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,649,30,63,98,25,80,278,500,253,4,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',0,0),
(126,20134,'Cave Maiden','','cave_maiden','25.00','65.00',59,'female','L2Monster','Fighter',40,2971,'6.500',1117,'2.400',40,43,30,21,20,10,5112,437,902,326,453,291,278,500,253,68,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(127,20135,'Alligator','','crocodile','28.00','11.50',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2373,153,300,183,131,164,278,500,253,0,0,0,70,174,'croc_clan2',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(128,20136,'Death Knight','','death_knight','12.00','30.00',50,'male','L2Monster','Fighter',40,2245,'11.000',830,'2.100',40,43,30,21,20,10,4651,350,616,230,264,226,278,500,253,75,0,0,27,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(129,20137,'Drake','','drake','30.00','100.00',57,'male','L2Monster','Mystic',40,2806,'6.500',1052,'2.400',40,43,30,21,20,10,4819,401,817,309,405,276,278,500,253,0,0,0,70,174,'dragon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(130,20138,'Gargoyle','','gargoyle','16.00','50.00',27,'male','L2Monster','Fighter',40,813,'3.500',318,'1.500',40,43,30,21,20,10,946,48,104,125,45,102,278,500,253,0,0,0,140,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(131,20139,'Giant Bee','','giant_bee','8.00','24.50',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,471,19,40,79,15,64,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',0,0),
(132,20140,'Giant Leech','','giant_leech','70.00','29.00',24,'male','L2Monster','Fighter',40,687,'3.500',272,'1.500',40,43,30,21,20,10,795,39,81,111,34,90,278,500,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.65','true',0,0),
(133,20141,'Giant Wild Hog','','giant_wild_hog','25.00','27.00',47,'male','L2Monster','Fighter',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,2730,196,427,253,216,206,278,500,253,0,0,0,35,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','true',0,0),
(134,20142,'Griffon','','griffin','20.00','44.00',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,593,26,57,94,23,76,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(135,20143,'Grizzly','','grizzly','21.00','40.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,436,16,27,66,10,54,278,500,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(136,20144,'Hangman Tree','','hanged_man_ripper','35.00','80.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1817,108,192,169,89,137,278,500,253,0,0,0,55,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(137,20145,'Harpy','','harpy','10.00','42.00',32,'female','L2Monster','Fighter',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,1504,84,154,151,69,123,278,500,253,0,0,0,60,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.65','true',1,0),
(138,20146,'Headless Knight','','headless_knight','21.00','31.00',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3708,279,463,306,264,226,278,500,253,124,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(139,20147,'Hobgoblin','','hobgoblin','12.00','24.00',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,4,0,0,45,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',1,0),
(140,20148,'Hungry Spirit','','hungry_spirit','13.00','40.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,1958,126,300,183,131,164,278,500,253,0,0,0,15,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',0,0),
(141,20149,'Iron Golem','','iron_golem','18.00','34.00',38,'male','L2Monster','Mystic',40,1400,'4.500',497,'1.800',40,43,30,21,20,10,2524,157,216,207,112,153,278,500,253,0,0,0,20,20,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',0,0),
(142,20150,'King Bugbear','','king_bugbear','15.00','40.00',32,'male','L2Monster','Fighter',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,1265,71,169,138,69,123,278,500,253,88,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',0,0),
(143,20151,'Kobold','','kobold','10.00','15.00',4,'male','L2Monster','Fighter',40,107,'2.000',68,'0.900',40,43,30,21,20,10,118,3,12,46,4,37,278,0,253,4,0,0,47,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.54','true',0,0),
(144,20152,'Lizardman','','virud_lizardman','10.00','23.00',19,'male','L2Monster','Fighter',40,508,'2.500',203,'1.200',40,43,30,21,20,10,565,25,53,90,21,73,278,0,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(145,20153,'Magical Weaver','','magical_weaver','11.00','20.00',11,'male','L2Monster','Mystic',40,292,'2.500',129,'1.200',40,43,30,21,20,10,391,15,27,58,9,52,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(146,20154,'Mandragora Sprout','','manadragora','14.00','17.80',21,'female','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,0,0,0,80,80,'mandragora_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','true',1,0),
(147,20155,'Mandragora Sapling','','mandragora_a','15.00','26.00',23,'female','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,895,43,82,97,31,87,278,500,253,0,0,0,80,120,'mandragora_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.20','true',1,0),
(148,20156,'Mandragora Blossom','','mandragora_b','12.00','25.50',25,'female','L2Monster','Fighter',40,728,'3.500',287,'1.500',40,43,30,21,20,10,1012,51,97,105,37,94,278,500,253,0,0,0,80,120,'mandragora_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.13','true',1,0),
(149,20157,'Marsh Stakato','','marsh_stakato','10.00','20.00',29,'male','L2Monster','Fighter',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1509,81,117,123,53,110,317,500,289,223,0,0,21,120,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.74','true',1,0),
(150,20158,'Medusa','','medusa','10.00','25.00',34,'female','L2Monster','Mystic',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1714,100,178,163,82,132,278,500,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(151,20159,'Minotaur','','minotaur','21.00','45.50',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,2263,153,365,202,163,181,278,500,253,300,0,0,40,120,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.59','true',0,0),
(152,20160,'Neer Crawler','','neer_crawler','14.00','22.00',28,'male','L2Monster','Fighter',40,859,'3.500',334,'1.500',40,43,30,21,20,10,1201,63,124,118,49,106,278,500,253,0,0,0,50,90,'neer_crawler_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(153,20161,'Oel Mahum','','oel_mahum','20.00','37.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4167,328,602,304,319,247,278,500,253,0,0,0,70,174,'oel_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(154,20162,'Ogre','','ogre','21.00','44.00',41,'male','L2Monster','Fighter',40,1593,'5.500',560,'2.100',40,43,30,21,20,10,2057,135,446,189,141,169,200,500,182,98,0,0,22,80,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','true',0,0),
(155,20163,'Ol Mahum','','ol_mahum','13.50','25.00',23,'male','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,731,35,82,97,31,87,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(156,20164,'Ol Mahum Archer','','ol_mahum_archer','14.00','25.00',25,'male','L2Monster','Ranger',500,728,'3.500',287,'1.500',40,43,30,21,20,10,868,44,216,105,37,94,249,500,227,14,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','true',0,0),
(157,20165,'Ol Mahum Champion','','ol_mahum_champion','14.00','27.00',29,'male','L2Monster','Fighter',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1257,67,134,123,53,110,278,500,253,69,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.63','true',0,0),
(158,20166,'Succubus','','succubus','10.00','36.00',32,'female','L2Monster','Mystic',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,1265,71,154,151,69,123,278,500,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',0,0),
(159,20167,'Serpent Slave','','serpent_slave','17.00','46.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,1977,128,273,201,131,164,278,500,253,73,0,0,70,110,'serpent_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(160,20168,'Silenos','','silenos','14.00','32.50',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1308,72,132,140,58,114,278,0,253,88,0,0,70,110,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.50','true',1,0),
(161,20169,'Skeleton Royal Guard','','skeleton_royal_guard','11.00','28.50',26,'male','L2Monster','Fighter',40,770,'3.500',303,'1.500',40,43,30,21,20,10,898,45,92,109,41,98,317,500,289,946,945,0,80,120,'skeleton_clan',300,'Local','',0,20,52,7,10,8,0,0,-6,'0.52','true',0,0),
(162,20170,'Spartoi','','spartoi','11.00','27.00',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,454,19,35,69,14,62,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,36,7,10,8,0,0,-6,'0.30','true',0,0),
(163,20171,'Specter','','dark_horror','20.00','35.00',26,'male','L2Monster','Fighter',40,770,'3.500',303,'1.500',40,43,30,21,20,10,1078,54,96,120,41,98,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(164,20172,'Sylph','','sylph','11.00','35.00',10,'female','L2Monster','Mystic',40,257,'2.000',120,'0.900',40,43,30,21,20,10,296,10,25,55,8,49,278,0,253,0,0,0,60,60,'elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',0,0),
(165,20173,'Troll','','troll','21.00','35.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1332,76,182,143,75,128,278,500,253,0,0,0,55,110,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.61','true',0,0),
(166,20174,'Two-Headed Giant','','twin_headed_giant','17.00','39.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1499,89,174,186,89,137,278,500,253,4,0,0,45,100,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',0,0),
(167,20175,'Walking Fungus','','walking_fungus','15.00','22.50',8,'male','L2Monster','Fighter',40,197,'2.000',102,'0.900',40,43,30,21,20,10,237,8,18,55,6,45,278,0,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',0,0),
(168,20176,'Wyrm','','wyrm','29.00','72.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1817,108,211,154,89,137,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.19','true',1,0),
(169,20177,'Zombie','','zombie','13.00','21.00',6,'male','L2Monster','Mystic',40,147,'2.000',85,'0.900',40,43,30,21,20,10,178,5,15,50,5,41,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',0,0),
(170,20189,'Puma','','onyx_beast','14.00','14.50',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,441,18,40,69,14,62,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',0,0),
(171,20190,'Skeleton Marauder','','skeleton_archer','11.00','27.00',29,'male','L2Monster','Ranger',500,906,'3.500',349,'1.500',40,43,30,21,20,10,1306,70,299,123,53,110,249,500,227,14,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(172,20191,'Skeleton Raider','','skeleton','11.00','25.00',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1335,73,127,128,58,114,317,500,289,946,945,0,60,140,'skeleton_clan',300,'Local','',0,20,59,7,10,8,0,0,-6,'0.30','true',1,0);
INSERT INTO `npc` VALUES
(173,20192,'Tyrant','','grave','15.00','29.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1781,105,211,154,89,137,278,0,253,0,0,0,70,174,'tyrant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(174,20193,'Tyrant Kingpin','','grave','15.00','29.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,1922,116,227,159,96,142,278,500,253,0,0,0,70,174,'tyrant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(175,20194,'Queen Undine','','undine','12.00','27.00',50,'female','L2Monster','Mystic',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3090,233,560,253,264,226,278,500,253,0,0,0,60,60,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',0,0),
(176,20197,'Sorrow Maiden','','sylph','11.00','35.00',27,'female','L2Monster','Mystic',40,813,'3.500',318,'1.500',40,43,30,21,20,10,1102,56,104,125,45,102,278,0,253,0,0,0,60,60,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(177,20198,'Neer Ghoul Berserker','','neer_crawler','14.00','22.00',29,'male','L2Monster','Fighter',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1268,68,134,123,53,110,278,500,253,0,0,0,50,90,'neer_crawler_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(178,20199,'Amber Basilisk','','lesser_basilisk','34.00','25.00',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1557,85,120,155,58,114,278,0,253,0,0,0,35,131,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(179,20200,'Strain','','hungry_spirit','13.00','40.00',31,'male','L2Monster','Fighter',40,1004,'4.500',381,'1.800',40,43,30,21,20,10,1383,77,157,133,64,118,278,0,253,0,0,0,15,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(180,20201,'Ghoul','','zombie','13.00','21.00',32,'male','L2Monster','Mystic',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,2085,117,169,138,69,123,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(181,20202,'Dead Seeker','','vampire_bat','10.00','33.50',34,'male','L2Monster','Mystic',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1664,97,178,163,82,132,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(182,20203,'Dion Grizzly','','grizzly','21.00','40.00',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,705,31,52,104,23,76,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(183,20204,'Bloody Bee','','giant_bee','8.00','24.50',23,'male','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,956,46,82,97,31,87,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(184,20205,'Dire Wolf','','dire_wolf','13.00','11.00',24,'male','L2Monster','Fighter',40,687,'3.500',272,'1.500',40,43,30,21,20,10,954,47,89,101,34,90,278,500,253,0,0,0,24,110,'wolf_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(185,20206,'Kadif Werewolf','','werewolf','10.00','26.00',25,'male','L2Monster','Fighter',40,728,'3.500',287,'1.500',40,43,30,21,20,10,982,49,97,105,37,94,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(186,20207,'Ol Mahum Guerilla','','ol_mahum','13.50','25.00',26,'male','L2Monster','Fighter',40,770,'7.000',303,'1.500',40,43,30,21,20,10,982,49,87,132,41,98,278,0,253,2,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,52,7,30,4,4,0,-6,'0.46','false',1,0),
(187,20208,'Ol Mahum Raider','','ol_mahum','13.50','25.00',27,'male','L2Monster','Fighter',40,813,'7.000',318,'1.500',40,43,30,21,20,10,1035,53,83,138,45,102,317,0,289,10,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','false',1,0),
(188,20209,'Ol Mahum Marksman','','ol_mahum_archer','14.00','25.00',28,'male','L2Monster','Ranger',500,859,'7.000',334,'1.500',40,43,30,21,20,10,1128,59,276,118,49,106,249,0,227,275,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','false',1,0),
(189,20210,'Ol Mahum Sergeant','','ol_mahum','13.50','25.00',29,'male','L2Monster','Fighter',40,906,'7.000',349,'1.500',40,43,30,21,20,10,1156,62,111,149,53,110,278,0,253,68,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,57,7,30,4,4,0,-6,'0.46','false',1,0),
(190,20211,'Ol Mahum Captain','','ol_mahum_champion','14.00','27.00',30,'male','L2Monster','Fighter',40,954,'7.000',365,'1.500',40,43,30,21,20,10,1241,68,145,128,58,114,278,500,253,123,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,59,7,30,4,4,0,-6,'0.63','false',1,0),
(191,20212,'Bloody Axe Turmak','Ol Mahum Lord','ol_mahum_champion','14.00','27.00',34,'male','L2Monster','Fighter',40,1164,'9.000',430,'1.800',40,43,30,21,20,10,1469,86,196,148,82,132,278,500,253,69,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,66,7,30,4,4,0,-6,'0.63','false',0,0),
(192,20213,'Porta','','stone_golem','20.00','31.00',40,'male','L2Monster','Mystic',40,1527,'9.000',531,'1.800',40,43,30,21,20,10,2364,152,248,222,131,164,278,0,253,0,0,0,23,23,'porta_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.41','false',1,0),
(193,20214,'Excuro','','mana_vampire','11.00','20.00',41,'male','L2Monster','Mystic',40,1593,'11.000',560,'2.100',40,43,30,21,20,10,2028,132,265,229,141,169,278,0,253,0,0,0,90,174,'porta_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.39','false',1,0),
(194,20215,'Mordeo','','onyx_beast','14.00','14.50',42,'male','L2Monster','Fighter',40,1660,'11.000',589,'2.100',40,43,30,21,20,10,2625,175,342,196,152,175,278,500,253,0,0,0,30,174,'beast_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.24','false',1,0),
(195,20216,'Ricenseo','','monster_eye','21.00','43.00',43,'male','L2Monster','Mystic',40,1728,'11.000',618,'2.100',40,43,30,21,20,10,2104,142,332,223,163,181,278,0,253,0,0,0,90,174,'porta_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.30','false',1,0),
(196,20217,'Krator','','stone_golem','20.00','31.00',44,'male','L2Monster','Mystic',40,1799,'11.000',648,'2.100',40,43,30,21,20,10,2688,184,322,253,176,187,278,500,253,0,0,0,23,23,'porta_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.41','false',1,0),
(197,20218,'Premo','','troll','21.00','35.00',45,'male','L2Monster','Fighter',40,1870,'11.000',677,'2.100',40,43,30,21,20,10,2812,195,415,216,188,193,278,0,253,0,0,0,55,174,'porta_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.61','false',1,0),
(198,20219,'Validus','','grave','15.00','29.00',46,'male','L2Monster','Fighter',40,1943,'11.000',707,'2.100',40,43,30,21,20,10,2408,170,365,270,202,199,278,0,253,0,0,0,70,174,'torfe_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.30','false',1,0),
(199,20220,'Dicor','','mandragora_b','12.00','25.50',47,'female','L2Monster','Fighter',40,2016,'11.000',738,'2.100',40,43,30,21,20,10,2867,205,469,230,216,206,278,500,253,0,0,0,80,174,'torfe_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.13','false',1,0),
(200,20221,'Perum','','iron_golem','18.00','34.00',48,'male','L2Monster','Mystic',40,2091,'11.000',768,'2.100',40,43,30,21,20,10,3438,251,412,288,231,212,278,500,253,0,0,0,20,20,'torfe_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.41','false',1,0),
(201,20222,'Torfe','','grave','15.00','29.00',49,'male','L2Monster','Fighter',40,2168,'11.000',799,'2.100',40,43,30,21,20,10,3025,223,529,245,247,219,278,0,253,0,0,0,70,174,'torfe_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.30','false',1,0),
(202,20223,'Mandragora Sprout','','manadragora','14.00','17.80',20,'female','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,783,35,63,86,23,76,278,0,253,0,0,0,80,80,'mandragora_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','true',1,0),
(203,20224,'Ol Mahum Ranger','','ol_mahum_archer','14.00','25.00',22,'male','L2Monster','Ranger',500,611,'3.500',242,'1.500',40,43,30,21,20,10,1059,50,139,113,28,83,249,0,227,13,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','true',1,0),
(204,20225,'Giant Mist Leech','','giant_leech','70.00','29.00',25,'male','L2Monster','Fighter',40,728,'3.500',287,'1.500',40,43,30,21,20,10,992,50,88,116,37,94,278,0,253,0,0,0,50,110,'giant_leech_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.65','true',1,0),
(205,20226,'Gray Ant','','ant','26.00','15.00',26,'male','L2Monster','Fighter',40,770,'3.500',303,'1.500',40,43,30,21,20,10,1056,53,87,132,41,98,278,0,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(206,20227,'Horror Mist Ripper','','dark_horror','20.00','35.00',27,'male','L2Monster','Fighter',40,813,'3.500',318,'1.500',40,43,30,21,20,10,1124,58,114,114,45,102,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(207,20228,'Giant Crimson Ant','','ant_soldier','35.00','17.00',28,'male','L2Monster','Fighter',40,859,'3.500',334,'1.500',40,43,30,21,20,10,1296,68,124,118,49,106,278,0,253,0,0,0,80,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(208,20229,'Stinger Wasp','','giant_bee','8.00','24.50',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1454,79,120,155,58,114,278,500,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(209,20230,'Marsh Stakato Worker','','marsh_stakato_worker','9.00','21.00',31,'male','L2Monster','Fighter',40,1004,'4.500',381,'1.800',40,43,30,21,20,10,1663,92,142,146,64,118,278,0,253,153,0,0,20,140,'stakato_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.59','true',1,0),
(210,20231,'Toad Lord','','poison_toad','20.00','10.00',32,'male','L2Monster','Fighter',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,1622,91,140,167,69,123,278,0,253,0,0,0,50,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',1,0),
(211,20232,'Marsh Stakato Soldier','','marsh_stakato_soldier','10.00','25.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1583,91,132,173,75,128,317,0,289,217,0,0,30,155,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.74','true',1,0),
(212,20233,'Marsh Spider','','poison_spider','27.00','25.50',34,'male','L2Monster','Mystic',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1867,109,178,163,82,132,278,500,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.65','true',1,0),
(213,20234,'Marsh Stakato Drone','','marsh_stakato_drone','9.00','24.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1889,112,185,154,89,137,317,500,289,219,0,0,80,174,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.39','true',1,0),
(214,20235,'Shackle','','hungry_spirit','13.00','40.00',45,'male','L2Monster','Mystic',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,2974,207,343,262,188,193,278,500,253,0,0,0,15,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(215,20236,'Cave Servant','','skeleton','11.00','25.00',46,'male','L2Monster','Fighter',40,1943,'5.500',707,'2.100',40,43,30,21,20,10,3077,218,365,270,202,199,278,0,253,79,945,0,60,174,'cave_servant_clan',300,'Local','',0,20,91,7,30,4,4,0,-6,'0.30','true',1,0),
(216,20237,'Cave Servant Archer','','skeleton_archer','11.00','27.00',47,'male','L2Monster','Ranger',500,2016,'5.500',738,'2.100',40,43,30,21,20,10,4143,297,1043,230,216,206,249,0,227,14,0,0,40,174,'cave_servant_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(217,20238,'Cave Servant Warrior','','skeleton','11.00','25.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,3987,291,498,238,231,212,278,0,253,77,2495,0,60,174,'cave_servant_clan',300,'Local','',0,20,95,7,30,4,4,0,-6,'0.30','true',1,0),
(218,20239,'Cave Servant Captain','','spartoi','11.00','27.00',49,'male','L2Monster','Fighter',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,4238,313,437,297,247,219,278,500,253,73,2495,0,60,174,'cave_servant_clan',300,'Local','',0,20,97,7,30,4,4,0,-6,'0.30','true',1,0),
(219,20240,'Royal Cave Servant','','skeleton_royal_guard','11.00','28.50',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,4546,347,429,315,281,232,317,0,289,946,945,0,80,174,'cave_servant_clan',400,'Local','',0,20,102,7,10,8,0,0,-6,'0.52','true',1,0),
(220,20241,'Hunter Gargoyle','','hunter_gargoyle','25.00','65.00',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,4633,358,627,268,300,239,278,0,253,0,0,0,100,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(221,20242,'Dustwind Gargoyle','','hunter_gargoyle','25.00','65.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4813,378,547,334,319,247,278,0,253,0,0,0,100,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(222,20243,'Thunder Wyrm','','wyrm','29.00','72.00',54,'male','L2Monster','Fighter',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,4283,341,699,284,339,254,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.19','true',1,0),
(223,20244,'Malruk Succubus','','succubus','10.00','36.00',55,'female','L2Monster','Mystic',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,4399,355,737,292,360,261,278,0,253,0,0,0,60,174,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(224,20245,'Malruk Succubus Turen','','succubus','10.00','36.00',56,'female','L2Monster','Mystic',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,4560,375,777,301,382,269,278,0,253,0,0,0,60,174,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(225,20246,'Cave Keeper','','serpent_slave','17.00','46.00',58,'male','L2Monster','Fighter',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'cave_servant_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',1,0),
(226,20248,'Turak Bugbear','','bugbear','17.00','35.00',31,'male','L2Monster','Fighter',40,1004,'4.500',381,'1.800',40,43,30,21,20,10,1397,78,129,161,64,118,278,0,253,88,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(227,20249,'Turak Bugbear Warrior','','bugbear','17.00','35.00',33,'male','L2Monster','Fighter',40,1109,'9.000',413,'1.800',40,43,30,21,20,10,1502,86,151,173,75,128,278,500,253,73,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',1,0),
(228,20250,'Glass Jaguar','','onyx_beast','14.00','14.50',27,'male','L2Monster','Fighter',40,813,'3.500',318,'1.500',40,43,30,21,20,10,1102,56,114,114,45,102,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(229,20251,'Delu Lizardman','','virud_lizardman','10.00','23.00',28,'male','L2Monster','Fighter',40,859,'3.500',334,'1.500',40,43,30,21,20,10,1166,61,102,143,49,106,278,0,253,1,19,0,43,130,'',0,'Local','',0,20,55,7,30,4,4,0,-6,'0.48','true',1,0),
(230,20252,'Delu Lizardman Scout','','virud_lizardman','10.00','23.00',29,'male','L2Monster','Ranger',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1231,66,134,123,53,110,278,0,253,123,0,0,43,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(231,20253,'Delu Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1321,72,120,155,58,114,278,500,253,16,0,0,52,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','true',1,0),
(232,20254,'Skeleton Axeman','','skeleton','11.00','25.00',28,'male','L2Monster','Fighter',40,859,'3.500',334,'1.500',40,43,30,21,20,10,1201,63,113,130,49,106,278,500,253,86,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.30','true',1,0),
(233,20255,'Batur Orc','','batur_orc','9.00','21.50',31,'male','L2Monster','Fighter',40,1004,'4.500',381,'1.800',40,43,30,21,20,10,1164,65,129,161,64,118,278,0,253,123,0,0,80,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(234,20256,'Batur Orc Archer','','batur_orc_archer','11.00','21.50',32,'male','L2Monster','Ranger',500,1056,'4.500',397,'1.800',40,43,30,21,20,10,1600,90,311,167,69,123,249,0,227,13,0,0,45,130,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.96','true',0,0),
(235,20257,'Batur Orc Warrior','','batur_orc_warrior','10.00','20.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1602,92,182,143,75,128,278,500,253,123,19,0,80,120,'orc_clan',300,'Local','',0,20,64,7,30,4,4,0,-6,'0.30','true',0,0),
(236,20258,'Batur Orc Shaman','','batur_orc_shaman','11.00','16.00',34,'male','L2Monster','Priest',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1401,82,196,148,82,132,278,0,253,7,0,0,50,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.30','true',0,0),
(237,20259,'Batur Orc Overlord','','batur_orc_overlord','12.00','24.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1802,107,211,154,89,137,278,500,253,79,0,0,80,140,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','true',0,0),
(238,20260,'Orc Champion','','orc_champion','10.00','23.00',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,435,17,30,80,12,59,278,500,253,2,0,0,45,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.76','true',0,0),
(239,20261,'Orc Shaman','','orc_shaman','9.00','22.00',17,'male','L2Monster','Priest',40,446,'2.500',184,'1.200',40,43,30,21,20,10,504,21,40,91,17,67,278,0,253,7,0,0,45,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.26','true',0,0),
(240,20265,'Monster Eye Searcher','','monster_eye','21.00','43.00',22,'male','L2Monster','Mystic',40,611,'7.000',242,'1.500',40,43,30,21,20,10,763,36,75,93,28,83,278,0,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.30','false',1,0),
(241,20266,'Monster Eye Gazer','','monster_eye','21.00','43.00',25,'male','L2Monster','Mystic',40,728,'3.500',287,'1.500',40,43,30,21,20,10,992,50,80,127,37,94,278,0,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(242,20267,'Breka Orc','','batur_orc','9.00','21.50',31,'male','L2Monster','Fighter',40,1004,'4.500',381,'1.800',40,43,30,21,20,10,1397,78,113,161,64,118,317,0,289,215,0,0,80,130,'orc_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',1,0),
(243,20268,'Breka Orc Archer','','batur_orc_archer','11.00','21.50',32,'male','L2Monster','Ranger',500,1056,'4.500',397,'1.800',40,43,30,21,20,10,1920,108,311,167,69,123,249,0,227,275,0,0,45,130,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.96','true',1,0),
(244,20269,'Breka Orc Shaman','','batur_orc_shaman','11.00','16.00',34,'male','L2Monster','Priest',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1681,98,162,179,82,132,278,0,253,7,0,0,50,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.30','true',1,0),
(245,20270,'Breka Orc Overlord','','batur_orc_overlord','12.00','24.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,2380,141,211,154,89,137,278,500,253,79,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','true',1,0),
(246,20271,'Breka Orc Warrior','','batur_orc_warrior','10.00','20.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1922,110,182,143,75,128,278,500,253,123,20,0,80,120,'orc_clan',300,'Local','',0,20,64,7,30,4,4,0,-6,'0.30','true',1,0),
(247,20272,'Cave Servant','','skeleton','11.00','25.00',46,'male','L2Monster','Fighter',40,1943,'5.500',707,'2.100',40,43,30,21,20,10,2564,182,365,270,202,199,278,0,253,79,945,0,60,140,'cave_servant_clan',300,'Local','',0,20,91,7,30,4,4,0,-6,'0.30','true',0,0),
(248,20273,'Cave Servant Archer','','skeleton_archer','11.00','27.00',47,'male','L2Monster','Ranger',500,2016,'5.500',738,'2.100',40,43,30,21,20,10,2757,198,1043,230,216,206,249,0,227,275,0,0,40,140,'cave_servant_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',0,0),
(249,20274,'Cave Servant Warrior','','skeleton','11.00','25.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,2792,204,498,238,231,212,278,0,253,77,0,0,60,140,'cave_servant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',0,0),
(250,20275,'Cave Servant Captain','','spartoi','11.00','27.00',49,'male','L2Monster','Fighter',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,2968,219,437,297,247,219,278,500,253,73,0,0,60,140,'cave_servant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',0,0),
(251,20276,'Royal Cave Servant','','skeleton_royal_guard','11.00','28.50',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3152,240,429,315,281,232,317,0,289,946,945,0,80,120,'cave_servant_clan',300,'Local','',0,20,102,7,10,8,0,0,-6,'0.52','true',0,0),
(252,20277,'Cave Keeper','','serpent_slave','17.00','46.00',58,'male','L2Monster','Fighter',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,4077,344,751,318,428,284,317,0,289,223,0,0,70,110,'cave_servant_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',0,0),
(253,20279,'Shackle','','hungry_spirit','13.00','40.00',45,'male','L2Monster','Mystic',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,2478,172,343,262,188,193,278,500,253,0,0,0,15,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',0,0),
(254,20280,'Headless Knight','','headless_knight','21.00','31.00',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3090,233,463,306,264,226,278,500,253,124,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',0,0),
(255,20281,'Dustwind Gargoyle','','hunter_gargoyle','25.00','65.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,3370,265,547,334,319,247,278,0,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(256,20282,'Thunder Wyrm','','wyrm','29.00','72.00',54,'male','L2Monster','Fighter',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,3569,285,699,284,339,254,278,500,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.19','true',0,0),
(257,20283,'Malruk Succubus','','succubus','10.00','36.00',55,'female','L2Monster','Mystic',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,3666,296,737,292,360,261,278,0,253,0,0,0,60,100,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',0,0),
(258,20284,'Malruk Succubus Turen','','succubus','10.00','36.00',56,'female','L2Monster','Mystic',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,3800,312,777,301,382,269,278,0,253,0,0,0,60,100,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',0,0),
(259,20285,'Drake','','drake','30.00','100.00',57,'male','L2Monster','Mystic',40,2806,'6.500',1052,'2.400',40,43,30,21,20,10,4016,334,817,309,405,276,278,500,253,0,0,0,70,70,'dragon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',0,0),
(260,20286,'Hunter Gargoyle','','hunter_gargoyle','25.00','65.00',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,3244,251,627,268,300,239,278,0,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(261,20287,'Cave Maiden','','cave_maiden','25.00','65.00',59,'female','L2Monster','Fighter',40,2971,'6.500',1117,'2.400',40,43,30,21,20,10,4260,364,902,326,453,291,278,500,253,68,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',0,0),
(262,20291,'Enku Orc Champion','','orc_champion','10.00','23.00',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,927,43,57,108,25,80,278,500,253,2,0,0,45,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.76','true',1,0),
(263,20292,'Enku Orc Shaman','','orc_shaman','9.00','22.00',20,'male','L2Monster','Priest',40,541,'2.500',213,'1.200',40,43,30,21,20,10,813,36,52,104,23,76,278,0,253,7,0,0,45,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.26','true',1,0),
(264,20293,'Virud Lizardman','','virud_lizardman','10.00','23.00',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,593,26,52,104,23,76,278,0,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(265,20294,'Virud Lizardman Matriarch','','virud_lizardman_matriarch','13.00','37.00',24,'male','L2Monster','Fighter',40,687,'3.500',272,'1.500',40,43,30,21,20,10,951,47,89,101,34,90,278,500,253,2,19,0,56,130,'lizardman_clan',300,'Local','',0,20,49,7,30,4,4,0,-6,'0.65','true',0,0),
(266,20295,'Virud Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',22,'male','L2Monster','Fighter',40,611,'3.500',242,'1.500',40,43,30,21,20,10,698,33,75,93,28,83,278,500,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','true',0,0),
(267,20296,'Virud Lizardman Scout','','virud_lizardman_scout','10.00','22.00',21,'male','L2Monster','Ranger',500,575,'3.500',227,'1.500',40,43,30,21,20,10,656,30,127,108,25,80,249,0,227,2507,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.72','true',0,0),
(268,20297,'Virud Lizardman Shaman','','virud_lizardman_shaman','10.00','29.00',23,'male','L2Monster','Priest',40,648,'3.500',257,'1.500',40,43,30,21,20,10,731,35,68,117,31,87,278,0,253,7,0,0,43,120,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',0,0),
(269,20298,'Virud Lizardman Shaman','','virud_lizardman_shaman','10.00','29.00',23,'male','L2Monster','Priest',40,648,'3.500',257,'1.500',40,43,30,21,20,10,731,35,68,117,31,87,278,0,253,7,0,0,43,120,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',0,0),
(270,20299,'Zenta Lizardman','','zenta_lizardman','11.00','32.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,1939,125,248,222,131,164,278,0,253,68,0,0,37,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','true',0,0),
(271,20300,'Zenta Lizardman Matriarch','','zenta_lizardman_matriarch','20.00','40.00',44,'male','L2Monster','Fighter',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,2848,195,341,209,176,187,317,500,289,221,0,0,53,140,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',0,0),
(272,20301,'Zenta Lizardman Scout','','zenta_lizardman_scout','11.00','30.00',41,'male','L2Monster','Ranger',500,1593,'5.500',560,'2.100',40,43,30,21,20,10,2098,137,589,229,141,169,249,0,227,14,0,0,37,150,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','true',0,0),
(273,20302,'Zenta Lizardman Warrior','','zenta_lizardman_warrior','13.00','35.00',42,'male','L2Monster','Fighter',40,1660,'5.500',589,'2.100',40,43,30,21,20,10,2180,145,342,196,152,175,278,500,253,16,0,0,40,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',0,0),
(274,20303,'Zenta Lizardman Shaman','','zenta_lizardman_shaman','13.00','35.00',43,'male','L2Monster','Priest',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,2240,152,302,245,163,181,278,0,253,7,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.63','true',0,0),
(275,20304,'Marsh Stakato Queen','','marsh_stakato_queen','15.00','37.00',36,'female','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,1906,115,227,159,96,142,278,500,253,74,0,0,130,130,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',0,0),
(276,20305,'Grave','','grave','15.00','29.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,1958,126,300,183,131,164,278,500,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',0,0),
(277,20307,'Garum Werewolf','','werewolf','10.00','26.00',9,'male','L2Monster','Fighter',40,226,'2.000',111,'0.900',40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,5,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',1,0),
(278,20308,'Hook Spider','','giant_spider','26.00','26.50',16,'male','L2Monster','Mystic',40,417,'2.500',174,'1.200',40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(279,20309,'Brown Fox','','fox','9.50','10.00',2,'male','L2Monster','Fighter',40,75,'2.000',52,'0.900',40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(280,20310,'Brown Bear','','grizzly_bi','21.00','50.00',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,576,23,36,87,15,64,278,500,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(281,20311,'Rakeclaw Imp','','imp','10.00','24.00',6,'male','L2Monster','Fighter',40,147,'2.000',85,'0.900',40,43,30,21,20,10,213,6,16,46,5,41,278,0,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(282,20312,'Rakeclaw Imp Hunter','','imp','10.00','24.00',7,'male','L2Monster','Fighter',40,171,'2.000',94,'0.900',40,43,30,21,20,10,249,8,18,48,6,43,278,0,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(283,20313,'Rakeclaw Imp Chieftain','','imp_bi','10.00','30.00',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,363,12,25,55,8,49,278,500,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(284,20314,'Great White Shark','','great_white_shark','20.00','7.00',42,'male','L2Monster','Fighter',40,1660,'5.500',589,'2.100',40,43,30,21,20,10,2180,145,342,196,152,175,278,500,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(285,20316,'Darkwing Bat','','vampire_bat','10.00','33.50',11,'male','L2Monster','Mystic',40,292,'2.500',129,'1.200',40,43,30,21,20,10,391,15,27,58,9,52,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(286,20317,'Black Wolf','','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,'2.000',68,'0.900',40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(287,20318,'Black Timber Wolf','','wolf_bi','13.00','10.80',6,'male','L2Monster','Fighter',40,147,'2.000',85,'0.900',40,43,30,21,20,10,211,6,15,50,5,41,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(288,20319,'Goblin Grave Robber','','goblin','10.00','16.50',5,'male','L2Monster','Fighter',40,126,'2.000',77,'0.900',40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.32','true',1,0),
(289,20320,'Goblin Tomb Raider Leader','','goblin_bi','10.00','21.40',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,427,16,24,66,10,54,317,0,289,12,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.32','true',1,0),
(290,20321,'Goblin Thief','','goblin_bi','10.00','21.40',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,356,12,20,61,8,49,317,0,289,217,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.32','true',1,0),
(291,20322,'Goblin Brigand','','goblin','10.00','16.50',8,'male','L2Monster','Fighter',40,197,'2.000',102,'0.900',40,43,30,21,20,10,284,10,18,55,6,45,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.32','true',1,0),
(292,20323,'Goblin Brigand Leader','','goblin_bi','10.00','21.40',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,508,20,29,73,12,59,317,500,289,217,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.32','true',1,0),
(293,20324,'Goblin Brigand Lieutenant','','goblin','10.00','16.50',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,363,12,20,61,8,49,317,500,289,10,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.32','true',1,0),
(294,20325,'Goblin Raider','','goblin','10.00','16.50',5,'male','L2Monster','Fighter',40,126,'2.000',77,'0.900',40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.32','true',1,0),
(295,20326,'Goblin Scout','','goblin','10.00','16.50',8,'male','L2Monster','Fighter',40,197,'2.000',102,'0.900',40,43,30,21,20,10,284,10,18,55,6,45,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.32','true',1,0),
(296,20327,'Goblin Snooper','','goblin','10.00','16.50',5,'male','L2Monster','Fighter',40,126,'2.000',77,'0.900',40,43,30,21,20,10,178,5,13,48,4,39,278,0,253,4,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.32','true',1,0),
(297,20328,'Goblin Lookout','','goblin','10.00','16.50',8,'male','L2Monster','Fighter',40,197,'2.000',102,'0.900',40,43,30,21,20,10,284,10,16,55,6,45,317,0,289,12,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.32','true',1,0),
(298,20329,'Ghost Guardian','','human_ghost','8.00','22.00',21,'male','L2Monster','Mystic',40,575,'3.500',227,'1.500',40,43,30,21,20,10,643,30,63,98,25,80,278,500,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(299,20330,'Mineshaft Bat','','vampire_bat','10.00','33.50',11,'male','L2Monster','Mystic',40,292,'2.500',129,'1.200',40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(300,20331,'Monster Eye Tracker','','monster_eye','21.00','43.00',10,'male','L2Monster','Mystic',40,257,'2.000',120,'0.900',40,43,30,21,20,10,296,10,20,67,8,49,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(301,20333,'Greystone Golem','','stone_golem','20.00','31.00',13,'male','L2Monster','Mystic',40,339,'2.500',147,'1.200',40,43,30,21,20,10,654,26,27,77,11,56,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(302,20334,'Gremlin Scavenger','','gremlin','10.00','15.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,20,50,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(303,20335,'Grizzly Bear','','grizzly_bi','21.00','50.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,599,25,40,91,17,67,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(304,20336,'Green Dryad','','dryad_sm','6.00','15.00',8,'female','L2Monster','Fighter',40,197,'2.000',102,'0.900',40,43,30,21,20,10,284,10,18,55,6,45,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(305,20337,'Longtail Fox','','fox','9.50','10.00',2,'male','L2Monster','Fighter',40,75,'2.000',52,'0.900',40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(306,20338,'Nightmare Weaver','','magical_weaver','11.00','20.00',21,'male','L2Monster','Mystic',40,575,'3.500',227,'1.500',40,43,30,21,20,10,707,33,69,89,25,80,278,500,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(307,20340,'Slave Skeleton','','skeleton','11.00','25.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(308,20341,'Undead Slave','','zombie','13.00','21.00',19,'male','L2Monster','Mystic',40,508,'2.500',203,'1.200',40,43,30,21,20,10,799,36,58,82,21,73,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(309,20342,'Werewolf Chieftain','','werewolf_bi','11.00','29.70',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,436,16,30,60,10,54,278,500,253,5,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',1,0),
(310,20343,'Werewolf Hunter','','werewolf','10.00','26.00',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,363,12,25,55,8,49,278,500,253,5,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',1,0),
(311,20345,'Dark Terror','','dark_horror','20.00','35.00',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,533,22,44,72,15,64,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(312,20346,'Darkstone Golem','','stone_golem','20.00','31.00',13,'male','L2Monster','Mystic',40,339,'2.500',147,'1.200',40,43,30,21,20,10,545,21,27,77,11,56,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(313,20347,'Death Wraith','','death_blader','15.00','45.00',55,'male','L2Monster','Fighter',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,3739,302,737,292,360,261,278,500,253,1472,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',0,0),
(314,20348,'Cave Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,'2.500',165,'1.200',40,43,30,21,20,10,445,18,40,69,14,62,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(315,20349,'Cave Bat','','vampire_bat','10.00','33.50',13,'male','L2Monster','Mystic',40,339,'2.500',147,'1.200',40,43,30,21,20,10,385,15,33,63,11,56,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(316,20350,'Cave Fang Spider','','giant_spider','26.00','26.50',16,'male','L2Monster','Mystic',40,417,'2.500',174,'1.200',40,43,30,21,20,10,485,20,44,72,15,64,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(317,20351,'Dre Vanul Tracker','','dre_vanul','14.00','36.00',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,605,27,63,86,23,76,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',1,0),
(318,20352,'Dre Vanul Slayer','','dre_vanul','14.00','36.00',22,'male','L2Monster','Fighter',40,611,'3.500',242,'1.500',40,43,30,21,20,10,767,36,75,93,28,83,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',0,0),
(319,20353,'Dre Vanul Beholder','','dre_vanul','14.00','36.00',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,80,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',1,0),
(320,20354,'Dwarf Ghost','','dwarf_ghost','9.00','16.50',20,'male','L2Monster','Mystic',40,541,'2.500',213,'1.200',40,43,30,21,20,10,605,27,63,86,23,76,278,500,253,0,0,0,80,140,'ghost_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',0,0),
(321,20356,'Langk Lizardman Leader','','virud_lizardman_warrior_bi','12.00','34.50',25,'male','L2Monster','Fighter',40,728,'3.500',287,'1.500',40,43,30,21,20,10,1012,51,80,127,37,94,278,500,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','true',1,0),
(322,20357,'Langk Lizardman Lieutenant','','virud_lizardman_warrior','12.00','30.00',22,'male','L2Monster','Fighter',40,611,'3.500',242,'1.500',40,43,30,21,20,10,821,39,62,113,28,83,278,0,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','true',1,0),
(323,20358,'Ratman Hunter','','wererat','14.00','25.00',18,'male','L2Monster','Fighter',40,476,'2.500',193,'1.200',40,43,30,21,20,10,640,28,38,95,19,70,317,0,289,11,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.61','true',1,0),
(324,20359,'Ratman Warrior','','wererat','14.00','25.00',19,'male','L2Monster','Fighter',40,508,'2.500',203,'1.200',40,43,30,21,20,10,678,30,58,82,21,73,278,0,253,2,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(325,20360,'Ratman Spy','','wererat_sm','14.00','18.70',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,570,23,39,72,15,64,317,0,289,12,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.61','true',1,0),
(326,20361,'Tunath Orc Marksman','','orc_archer','14.00','25.00',10,'male','L2Monster','Ranger',500,257,'2.000',120,'0.900',40,43,30,21,20,10,305,10,51,61,8,49,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(327,20362,'Tunath Orc Warrior','','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,363,13,25,73,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(328,20363,'Maraku Werewolf','','werewolf','10.00','26.00',9,'male','L2Monster','Fighter',40,226,'2.000',111,'0.900',40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(329,20364,'Maraku Werewolf Chieftain','','werewolf_bi','11.00','29.70',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,508,20,32,66,12,59,317,500,289,217,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.43','true',1,0),
(330,20365,'Mountain Fungus','','walking_fungus','15.00','22.50',8,'male','L2Monster','Fighter',40,197,'2.000',102,'0.900',40,43,30,21,20,10,284,10,20,50,6,45,278,0,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(331,20367,'Merkenis Escort','','spartoi','11.00','27.00',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,605,27,52,104,23,76,278,500,253,68,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(332,20368,'Grave Keeper','','stone_golem','20.00','31.00',13,'male','L2Monster','Mystic',40,339,'2.500',147,'1.200',40,43,30,21,20,10,545,21,27,77,11,56,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(333,20369,'Moonstone Beast','','onyx_beast','14.00','14.50',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,599,25,48,75,17,67,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(334,20370,'Barbed Bat','','vampire_bat','10.00','33.50',12,'male','L2Monster','Mystic',40,315,'2.500',138,'1.200',40,43,30,21,20,10,427,16,30,60,10,54,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(335,20371,'Mist Terror','','dark_horror','20.00','35.00',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,454,19,40,69,14,62,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(336,20372,'Baraq Orc Fighter','','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,302,10,25,55,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(337,20373,'Baraq Orc Warrior Leader','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(338,20374,'Baranka''s Guard','','spartoi','11.00','27.00',22,'male','L2Monster','Fighter',40,611,'3.500',242,'1.500',40,43,30,21,20,10,910,43,62,113,28,83,278,500,253,68,0,0,60,140,'skeleton_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(339,20375,'Baranka''s Escort','','spartoi','11.00','27.00',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,649,30,50,108,25,80,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local',NULL,0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(340,20376,'Varikan Brigand Leader','','goblin_bi','10.00','21.40',10,'male','L2Monster','Fighter',40,257,'4.000',120,'0.900',40,43,30,21,20,10,503,17,22,61,8,49,278,500,253,12,0,0,40,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.32','false',0,0);
INSERT INTO `npc` VALUES
(341,20377,'Varika''s Bandit','','goblin','10.00','16.50',7,'male','L2Monster','Fighter',40,171,'1.000',94,'0.900',40,43,30,21,20,10,334,12,20,44,6,43,278,0,253,0,0,0,40,110,'goblin_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,'0.32','true',0,0),
(342,20378,'Stone Giant','','stone_golem','20.00','31.00',13,'male','L2Monster','Mystic',40,339,'2.500',147,'1.200',40,43,30,21,20,10,545,21,27,77,11,56,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',1,0),
(343,20379,'Stone Soldier','','stone_golem','20.00','31.00',14,'male','L2Monster','Mystic',40,364,'2.500',156,'1.200',40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(344,20380,'Stone Guardian','','stone_golem','20.00','31.00',16,'male','L2Monster','Mystic',40,417,'2.500',174,'1.200',40,43,30,21,20,10,807,33,36,87,15,64,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(345,20381,'Vaiss Orc','','orc','10.00','21.00',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,296,10,22,61,8,49,278,0,253,156,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',1,0),
(346,20382,'Vaiss Orc Warrior Leader','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,326,12,27,58,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(347,20383,'Arachnid Hunter','','binding','12.00','21.00',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1223,67,120,155,58,114,278,500,253,0,0,0,10,140,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','true',0,0),
(348,20385,'Balor Orc Archer','','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,'2.000',102,'0.900',40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(349,20386,'Balor Orc Fighter','','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,363,12,25,55,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(350,20387,'Balor Orc Fighter Leader','','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,436,16,30,60,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(351,20388,'Balor Orc Lieutenant','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,391,15,27,58,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(352,20389,'Boogle Ratman','','wererat','14.00','25.00',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,475,19,39,72,15,64,317,0,289,12,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.61','true',1,0),
(353,20390,'Boogle Ratman Leader','','wererat','14.00','25.00',18,'male','L2Monster','Fighter',40,476,'2.500',193,'1.200',40,43,30,21,20,10,533,23,46,79,19,70,317,0,289,12,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.61','true',1,0),
(354,20391,'Red Fox','','fox','9.50','10.00',2,'male','L2Monster','Fighter',40,75,'2.000',52,'0.900',40,43,30,21,20,10,58,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(355,20392,'Redeye Bat','','vampire_bat_bi','10.00','42.00',15,'male','L2Monster','Mystic',40,390,'2.500',165,'1.200',40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(356,20393,'Red Scavenger Spider','','giant_spider','26.00','26.50',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(357,20394,'Crimson Tarantula','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,'2.500',165,'1.200',40,43,30,21,20,10,449,18,40,69,14,62,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',0,0),
(358,20398,'Vrykolakas','','werewolf_bi','11.00','29.70',15,'male','L2Monster','Fighter',40,390,'5.000',165,'1.200',40,43,30,21,20,10,692,28,40,69,14,62,278,500,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','false',0,1),
(359,20399,'Vrykolakas Wolfkin','','wolf_bi','13.00','10.80',9,'male','L2Monster','Fighter',40,226,'1.000',111,'0.900',40,43,30,21,20,10,354,12,25,48,7,47,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.39','true',0,0),
(360,20400,'Blood Fungus','','walking_fungus','15.00','22.50',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,427,16,30,60,10,54,278,0,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(361,20401,'Veelan Bugbear','','bugbear','17.00','35.00',23,'male','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,156,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(362,20402,'Veelan Bugbear Warrior','','bugbear','17.00','35.00',24,'male','L2Monster','Fighter',40,687,'3.500',272,'1.500',40,43,30,21,20,10,954,47,89,101,34,90,278,500,253,88,0,0,55,130,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(363,20403,'Hunter Tarantula','','giant_spider','26.00','26.50',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(364,20404,'Silent Horror','','dark_horror','20.00','35.00',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,485,20,44,72,15,64,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.37','true',1,0),
(365,20405,'Young Brown Fox','','fox','9.50','10.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,29,2,10,36,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(366,20406,'Young Red Fox','','fox','9.50','10.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,29,2,10,36,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(367,20407,'Young Crimson Fox','','fox','9.50','10.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,29,2,10,36,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(368,20410,'Scavenger Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,545,22,40,69,14,62,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(369,20411,'Scavenger Bat','','vampire_bat','10.00','33.50',18,'male','L2Monster','Fighter',40,476,'2.500',193,'1.200',40,43,30,21,20,10,640,28,53,79,19,70,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(370,20412,'Susceptor','','susceptor','20.00','35.00',49,'male','L2Monster','Fighter',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,2910,215,437,297,247,219,278,500,253,0,0,0,27,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',0,0),
(371,20415,'Scarlet Salamander','','salamander','16.00','6.80',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,555,23,48,75,17,67,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.20','true',1,0),
(372,20416,'Scarlet Salamander Elder','','salamander','16.00','6.80',18,'male','L2Monster','Fighter',40,476,'2.500',193,'1.200',40,43,30,21,20,10,586,26,53,79,19,70,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.20','true',1,0),
(373,20418,'Crystalline Beast','','onyx_beast','14.00','14.50',18,'male','L2Monster','Fighter',40,476,'2.500',193,'1.200',40,43,30,21,20,10,633,28,53,79,19,70,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(374,20419,'Akaste Succubus','','succubus','10.00','36.00',20,'female','L2Monster','Mystic',40,541,'2.500',213,'1.200',40,43,30,21,20,10,605,27,63,86,23,76,278,500,253,0,0,0,60,100,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',0,0),
(375,20420,'Akaste Succubus Turen','','succubus','10.00','36.00',21,'female','L2Monster','Mystic',40,575,'3.500',227,'1.500',40,43,30,21,20,10,649,30,69,89,25,80,278,500,253,0,0,0,60,100,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(376,20421,'Akaste Succubus Tilfo','','succubus_bi','10.00','43.20',22,'female','L2Monster','Mystic',40,611,'3.500',242,'1.500',40,43,30,21,20,10,698,33,75,93,28,83,278,500,253,0,0,0,60,100,'succubus_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(377,20422,'Akaste Bone Warlord','','skeleton','11.00','25.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,612,26,48,75,17,67,278,500,253,2,18,0,60,140,'skeleton_clan',300,'Local','',0,20,39,7,30,4,4,0,-6,'0.30','true',1,0),
(378,20423,'Akaste Bone Archer','','skeleton_archer','11.00','27.00',14,'male','L2Monster','Ranger',500,364,'2.500',156,'1.200',40,43,30,21,20,10,428,17,68,80,12,59,249,0,227,275,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(379,20424,'Akaste Bone Lord','','skeleton','11.00','25.00',19,'male','L2Monster','Fighter',40,508,'2.500',203,'1.200',40,43,30,21,20,10,592,26,58,82,21,73,278,500,253,68,19,0,60,140,'skeleton_clan',300,'Local','',0,20,42,7,30,4,4,0,-6,'0.30','true',1,0),
(380,20425,'Akaste Bone Soldier','','skeleton','11.00','25.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(381,20426,'Evil Eye','','monster_eye','21.00','43.00',10,'male','L2Monster','Mystic',40,257,'2.000',120,'0.900',40,43,30,21,20,10,356,12,20,67,8,49,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(382,20427,'Evil Eye Watcher','','monster_eye','21.00','43.00',10,'male','L2Monster','Mystic',40,257,'2.000',120,'0.900',40,43,30,21,20,10,296,10,20,67,8,49,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(383,20428,'Evil Eye Patroller','','monster_eye','21.00','43.00',14,'male','L2Monster','Mystic',40,364,'2.500',156,'1.200',40,43,30,21,20,10,498,19,30,80,12,59,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(384,20429,'Evil Eye Lookout','','monster_eye','21.00','43.00',14,'male','L2Monster','Mystic',40,364,'2.500',156,'1.200',40,43,30,21,20,10,415,16,30,80,12,59,278,0,253,0,0,0,90,134,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(385,20431,'Elf Ghost','','elf_ghost','7.00','21.00',20,'male','L2Monster','Mystic',40,541,'2.500',213,'1.200',40,43,30,21,20,10,605,27,52,104,23,76,278,500,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',0,0),
(386,20432,'Elpy','','elpy','5.00','4.50',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,50,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','true',1,0),
(387,20433,'Festering Bat','','vampire_bat','10.00','33.50',13,'male','L2Monster','Mystic',40,339,'2.500',147,'1.200',40,43,30,21,20,10,462,18,33,63,11,56,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(388,20435,'Opal Beast','','onyx_beast','14.00','14.50',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,449,18,40,69,14,62,278,500,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(389,20436,'Ol Mahum Supplier','','ol_mahum_bi','13.50','29.20',23,'male','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,2,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,47,7,30,4,4,0,-6,'0.46','true',1,0),
(390,20437,'Ol Mahum Recruit','','ol_mahum','13.50','25.00',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,764,35,57,108,25,80,278,0,253,68,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,44,7,30,4,4,0,-6,'0.46','true',1,0),
(391,20438,'Ol Mahum General','','ol_mahum_champion','14.00','27.00',26,'male','L2Monster','Fighter',40,770,'3.500',303,'1.500',40,43,30,21,20,10,1078,54,105,109,41,98,278,500,253,67,102,0,50,110,'ol_mahum_clan',300,'Local','',0,20,52,7,30,4,4,0,-6,'0.63','true',1,0),
(392,20439,'Ol Mahum Officer','','ol_mahum','13.50','25.00',24,'male','L2Monster','Fighter',40,687,'3.500',272,'1.500',40,43,30,21,20,10,935,46,74,122,34,90,278,0,253,66,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(393,20440,'Elder Brown Fox','','fox','9.50','10.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(394,20441,'Elder Longtail Fox','','fox','9.50','10.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(395,20442,'Elder Wolf','','wolf','13.00','9.00',5,'male','L2Monster','Fighter',40,126,'2.000',77,'0.900',40,43,30,21,20,10,176,5,13,48,4,39,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(396,20443,'Elder Red Fox','','fox','9.50','10.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(397,20444,'Elder Prairie Fox','','fox','9.50','10.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,88,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(398,20445,'Uthanka Pirate','','orc','10.00','21.00',7,'male','L2Monster','Fighter',40,171,'1.000',94,'0.900',40,43,30,21,20,10,307,10,20,44,6,43,278,0,253,3,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(399,20446,'Utuku Orc','','orc','10.00','21.00',6,'male','L2Monster','Fighter',40,147,'2.000',85,'0.900',40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,156,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',1,0),
(400,20447,'Utuku Orc Archer','','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,'2.000',102,'0.900',40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(401,20448,'Utuku Orc Grunt','','orc','10.00','21.00',7,'male','L2Monster','Fighter',40,171,'2.000',94,'0.900',40,43,30,21,20,10,249,8,17,53,6,43,278,0,253,3,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(402,20449,'Will-O-Wisp','','will_o_wisp','13.00','22.00',15,'male','L2Monster','Mystic',40,390,'2.500',165,'1.200',40,43,30,21,20,10,533,22,40,69,14,62,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.10','true',1,0),
(403,20450,'Relic Werewolf','','werewolf','10.00','26.00',9,'male','L2Monster','Fighter',40,226,'2.000',111,'0.900',40,43,30,21,20,10,267,9,22,53,7,47,278,0,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',1,0),
(404,20451,'Relic Spartoi','','spartoi','11.00','27.00',21,'male','L2Monster','Fighter',40,575,'7.000',227,'1.500',40,43,30,21,20,10,592,27,57,108,25,80,278,0,253,68,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(405,20453,'Human Ghost','','human_ghost','8.00','22.00',20,'male','L2Monster','Mystic',40,541,'2.500',213,'1.200',40,43,30,21,20,10,605,27,52,104,23,76,278,500,253,0,0,0,80,140,'ghost_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',0,0),
(406,20454,'Oblivion Watcher','','monster_eye','21.00','43.00',17,'male','L2Monster','Mystic',40,446,'1.250',184,'1.200',40,43,30,21,20,10,454,20,53,68,17,67,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.30','true',0,0),
(407,20455,'Doom Soldier','','skeleton','11.00','25.00',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(408,20456,'Ashen Wolf','','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,'2.000',68,'0.900',40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(409,20457,'Zombie Soldier','','zombie','13.00','21.00',19,'male','L2Monster','Mystic',40,508,'2.500',203,'1.200',40,43,30,21,20,10,958,43,58,82,21,73,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(410,20458,'Zombie Warrior','','zombie_bi','13.00','27.50',22,'male','L2Monster','Mystic',40,611,'3.500',242,'1.500',40,43,30,21,20,10,1184,56,75,93,28,83,278,500,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(411,20460,'Crimson Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,'2.500',165,'1.200',40,43,30,21,20,10,545,22,40,69,14,62,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(412,20461,'Dungeon Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,'2.500',165,'1.200',40,43,30,21,20,10,454,19,40,69,14,62,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.26','true',1,0),
(413,20462,'Cave Blade Spider','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,'2.500',184,'1.200',40,43,30,21,20,10,515,22,48,75,17,67,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.26','true',1,0),
(414,20463,'Dungeon Skeleton Archer','','skeleton_archer','11.00','27.00',13,'male','L2Monster','Ranger',500,339,'2.500',147,'1.200',40,43,30,21,20,10,397,16,61,77,11,56,249,0,227,275,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(415,20464,'Dungeon Skeleton','','skeleton','11.00','25.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(416,20465,'Prairie Fox','','fox','9.50','10.00',2,'male','L2Monster','Fighter',40,75,'2.000',52,'0.900',40,43,30,21,20,10,58,2,11,38,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(417,20466,'Pincer Spider','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,'2.500',184,'1.200',40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(418,20468,'Kaboo Orc','','orc','10.00','21.00',6,'male','L2Monster','Fighter',40,147,'2.000',85,'0.900',40,43,30,21,20,10,213,6,15,50,5,41,278,0,253,156,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',1,0),
(419,20469,'Kaboo Orc Archer','','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,'2.000',102,'0.900',40,43,30,21,20,10,293,10,41,55,6,45,249,0,227,14,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(420,20470,'Kaboo Orc Grunt','','orc','10.00','21.00',7,'male','L2Monster','Fighter',40,171,'2.000',94,'0.900',40,43,30,21,20,10,249,8,17,53,6,43,278,0,253,3,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(421,20471,'Kaboo Orc Fighter','','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,363,12,20,67,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(422,20472,'Kaboo Orc Fighter Leader','','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,436,16,25,73,10,54,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(423,20473,'Kaboo Orc Fighter Lieutenant','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,391,15,23,70,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(424,20474,'Kasha Spider','','giant_spider','26.00','26.50',15,'male','L2Monster','Mystic',40,390,'2.500',165,'1.200',40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(425,20475,'Kasha Wolf','','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,'2.000',68,'0.900',40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(426,20476,'Kasha Fang Spider','','giant_spider','26.00','26.50',16,'male','L2Monster','Mystic',40,417,'2.500',174,'1.200',40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(427,20477,'Kasha Timber Wolf','','wolf_bi','13.00','10.80',6,'male','L2Monster','Fighter',40,147,'2.000',85,'0.900',40,43,30,21,20,10,211,6,15,50,5,41,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(428,20478,'Kasha Blade Spider','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,'2.500',184,'1.200',40,43,30,21,20,10,666,28,48,75,17,67,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(429,20479,'Kasha Bear','','grizzly_bi','21.00','50.00',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,539,22,33,84,14,62,278,500,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(430,20480,'Blade Bat','','vampire_bat','10.00','33.50',10,'male','L2Monster','Mystic',40,257,'2.000',120,'0.900',40,43,30,21,20,10,356,12,25,55,8,49,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(431,20481,'Bearded Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(432,20483,'Corpse Candle','','will_o_wisp','13.00','22.00',17,'male','L2Monster','Mystic',40,446,'2.500',184,'1.200',40,43,30,21,20,10,604,25,40,91,17,67,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.10','true',1,0),
(433,20487,'Kuruka Ratman','','wererat','14.00','25.00',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,475,19,32,87,15,64,317,0,289,216,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.61','true',1,0),
(434,20488,'Kuruka Ratman Hunter','','wererat','14.00','25.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,504,21,40,91,17,67,278,0,253,3,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(435,20489,'Quicksilver Beast','','onyx_beast','14.00','14.50',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,449,18,40,69,14,62,278,500,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(436,20490,'Death Doll','','crimson_doll','15.00','38.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2175,141,300,183,131,164,278,500,253,0,0,0,60,150,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.67','true',0,0),
(437,20491,'Crypt Horror','','dark_horror','20.00','35.00',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,454,19,40,69,14,62,278,500,253,0,0,0,100,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(438,20492,'Kirunak''s Guards','','spartoi','11.00','27.00',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,636,29,57,108,25,80,278,0,253,68,0,0,60,140,'kirunak_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(439,20494,'Turek War Hound','','dire_wolf','13.00','11.00',24,'male','L2Monster','Fighter',40,687,'7.000',272,'1.500',40,43,30,21,20,10,869,43,89,101,34,90,278,0,253,0,0,0,24,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(440,20495,'Turek Orc Warlord','','orc_champion','10.00','23.00',30,'male','L2Monster','Fighter',40,954,'7.000',365,'1.500',40,43,30,21,20,10,1390,76,120,155,58,114,278,500,253,127,0,0,45,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',1,0),
(441,20496,'Turek Orc Archer','','orc_archer','14.00','25.00',27,'male','L2Monster','Ranger',500,813,'7.000',318,'1.500',40,43,30,21,20,10,1076,55,231,125,45,102,249,0,227,14,0,0,45,110,'orc_clan',400,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','false',1,0),
(442,20497,'Turek Orc Skirmisher','','orc_fighter','12.00','22.00',28,'male','L2Monster','Fighter',40,859,'7.000',334,'1.500',40,43,30,21,20,10,1117,58,102,143,49,106,278,500,253,121,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(443,20498,'Turek Orc Supplier','','orc_fighter','12.00','22.00',27,'male','L2Monster','Fighter',40,813,'7.000',318,'1.500',40,43,30,21,20,10,1035,53,83,138,45,102,317,0,289,11,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','false',1,0),
(444,20499,'Turek Orc Footman','','orc','10.00','21.00',26,'male','L2Monster','Fighter',40,770,'7.000',303,'1.500',40,43,30,21,20,10,982,49,96,120,41,98,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(445,20500,'Turek Orc Sentinel','','orc','10.00','21.00',25,'male','L2Monster','Fighter',40,728,'7.000',287,'1.500',40,43,30,21,20,10,922,46,88,116,37,94,278,0,253,3,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(446,20501,'Turek Orc Shaman','','orc_shaman','9.00','22.00',29,'male','L2Monster','Priest',40,906,'7.000',349,'1.500',40,43,30,21,20,10,1156,62,111,149,53,110,278,0,253,7,0,0,45,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.26','false',1,0),
(447,20502,'Twink Puma','','onyx_beast','14.00','14.50',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,539,22,40,69,14,62,278,500,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(448,20504,'Dread Soldier','','skeleton','11.00','25.00',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(449,20505,'Ruin Bat','','vampire_bat_bi','10.00','42.00',20,'male','L2Monster','Mystic',40,541,'2.500',213,'1.200',40,43,30,21,20,10,712,32,63,86,23,76,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(450,20506,'Ruin Imp','','imp_bi','10.00','30.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,605,25,48,75,17,67,278,0,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(451,20507,'Ruin Imp Elder','','imp_bi','10.00','30.00',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,779,36,69,89,25,80,278,500,253,0,0,0,60,80,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(452,20508,'Plunder Tarantula','','giant_spider','26.00','26.50',17,'male','L2Monster','Mystic',40,446,'2.500',184,'1.200',40,43,30,21,20,10,618,26,48,75,17,67,278,500,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(453,20509,'Spore Fungus','','walking_fungus','15.00','22.50',9,'male','L2Monster','Fighter',40,226,'2.000',111,'0.900',40,43,30,21,20,10,321,11,22,53,7,47,278,0,253,0,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(454,20510,'Puma','','onyx_beast','14.00','14.50',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,423,16,30,60,10,54,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(455,20511,'Pitchstone Golem','','stone_golem','20.00','31.00',19,'male','L2Monster','Mystic',40,508,'2.500',203,'1.200',40,43,30,21,20,10,799,36,48,99,21,73,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(456,20512,'Field Stalker','','field_stalker','15.00','30.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1812,107,211,154,89,137,278,500,253,0,0,0,70,110,'monster_eye_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',0,0),
(457,20513,'Skeleton Knight','','skeleton_knight','10.00','25.00',32,'male','L2Monster','Fighter',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,1265,71,140,167,69,123,278,500,253,150,0,0,40,160,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.17','true',0,0),
(458,20514,'Shield Skeleton','','skeleton','11.00','25.00',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,534,22,40,69,14,62,278,0,253,157,103,0,60,140,'skeleton_clan',300,'Local','',0,20,36,7,50,1,9,0,-6,'0.30','true',1,0),
(459,20515,'Skeleton Infantryman','','skeleton','11.00','25.00',16,'male','L2Monster','Fighter',40,417,'2.500',174,'1.200',40,43,30,21,20,10,570,23,44,72,15,64,278,0,253,157,18,0,60,140,'skeleton_clan',300,'Local','',0,20,38,7,50,1,9,0,-6,'0.30','true',1,0),
(460,20516,'Skeleton Sentinel','','skeleton_bi','11.00','31.00',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,424,16,32,66,12,59,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','true',0,0),
(461,20517,'Skeleton Hunter','','skeleton','11.00','25.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,363,13,26,60,10,54,317,500,289,946,0,0,60,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(462,20518,'Skeleton Hunter Archer','','skeleton_archer','11.00','27.00',13,'male','L2Monster','Fighter',500,339,'2.500',147,'1.200',40,43,30,21,20,10,397,16,61,77,11,56,249,0,227,275,0,0,40,140,'skeleton_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(463,20519,'Skeleton Pikeman','','skeleton_pikeman','10.00','28.00',27,'male','L2Monster','Fighter',40,813,'3.500',318,'1.500',40,43,30,21,20,10,946,48,114,114,45,102,278,500,253,299,0,0,50,155,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.21','true',0,0),
(464,20520,'Pirate Captain Uthanka','','orc_fighter_bi','12.00','26.40',10,'male','L2Monster','Fighter',40,257,'4.000',120,'0.900',40,43,30,21,20,10,463,16,20,67,8,49,278,500,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','false',0,0),
(465,20521,'Whinstone Golem','','stone_golem','20.00','31.00',14,'male','L2Monster','Mystic',40,364,'2.500',156,'1.200',40,43,30,21,20,10,705,27,30,80,12,59,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(466,20522,'White Fang','','wolf_bi','13.00','10.80',10,'male','L2Monster','Fighter',40,257,'4.000',120,'0.900',40,43,30,21,20,10,458,15,22,61,8,49,278,500,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.39','false',0,1),
(467,20524,'Grey Wolf Elder','','wolf','13.00','9.00',7,'male','L2Monster','Fighter',40,171,'1.000',94,'0.900',40,43,30,21,20,10,304,10,20,44,6,43,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.39','true',0,0),
(468,20525,'Gray Wolf','','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,'2.000',68,'0.900',40,43,30,21,20,10,141,4,12,46,4,37,278,0,253,0,0,0,24,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(469,20526,'Obsidian Golem','','stone_golem','20.00','31.00',15,'male','L2Monster','Mystic',40,390,'2.500',165,'1.200',40,43,30,21,20,10,755,31,33,84,14,62,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(470,20527,'White Wolf','','dire_wolf','13.00','11.00',4,'male','L2Monster','Fighter',40,107,'2.000',68,'0.900',40,43,30,21,20,10,121,3,13,42,4,37,278,500,253,0,0,0,24,110,'wolf_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',0,0),
(471,20528,'Goblin Lord','','goblin','10.00','16.50',13,'male','L2Monster','Fighter',40,339,'2.500',147,'1.200',40,43,30,21,20,10,458,18,29,63,11,56,317,0,289,217,0,0,40,110,'',0,'Local','',0,0,0,7,10,8,0,0,0,'0.32','true',1,0),
(472,20529,'Young Brown Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(473,20530,'Young Red Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(474,20531,'Young Prairie Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(475,20532,'Brown Keltir','','keltir','13.00','10.00',2,'male','L2Monster','Fighter',40,75,'2.000',52,'0.900',40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(476,20533,'Longtail Keltir','','keltir','13.00','10.00',2,'male','L2Monster','Fighter',40,75,'2.000',52,'0.900',40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(477,20534,'Red Keltir','','keltir','13.00','10.00',2,'male','L2Monster','Fighter',40,75,'2.000',52,'0.900',40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(478,20535,'Prairie Keltir','','keltir','13.00','10.00',2,'male','L2Monster','Fighter',40,75,'2.000',52,'0.900',40,43,30,21,20,10,70,2,10,42,3,34,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(479,20536,'Elder Brown Keltir','','keltir','13.00','10.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(480,20537,'Elder Red Keltir','','keltir','13.00','10.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(481,20538,'Elder Prairie Keltir','','keltir','13.00','10.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(482,20539,'Elder Longtail Keltir','','keltir','13.00','10.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,105,2,11,44,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(483,20540,'Gemstone Beast','','onyx_beast','14.00','14.50',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,352,13,25,73,10,54,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(484,20541,'Ore Bat','','vampire_bat','10.00','33.50',17,'male','L2Monster','Mystic',40,446,'2.500',184,'1.200',40,43,30,21,20,10,499,21,48,75,17,67,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(485,20542,'Skeleton Longbowman','','skeleton_archer','11.00','27.00',19,'male','L2Monster','Ranger',500,508,'2.500',203,'1.200',40,43,30,21,20,10,587,26,129,82,21,73,249,500,227,275,0,0,40,140,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(486,20543,'Ghost','','human_ghost','8.00','22.00',20,'male','L2Monster','Mystic',40,541,'2.500',213,'1.200',40,43,30,21,20,10,599,27,63,86,23,76,278,500,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(487,20544,'Elder Keltir','','keltir','13.00','10.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,105,2,12,40,3,35,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(488,20545,'Young Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,35,2,9,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(489,20546,'Turek Orc Elder','','orc_shaman','9.00','22.00',34,'male','L2Monster','Priest',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1714,100,162,179,82,132,278,500,253,7,0,0,45,120,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.26','true',1,0),
(490,20547,'Ol Mahum Reserve','','ol_mahum_bi','13.50','29.20',23,'male','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,878,42,68,117,31,87,278,0,253,2,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,47,7,30,4,4,0,-6,'0.46','true',1,0),
(491,20548,'Ol Mahum Deserter','','ol_mahum','13.50','25.00',23,'male','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,895,43,75,107,31,87,278,500,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(492,20549,'Ol Mahum Lord','','ol_mahum_champion','14.00','27.00',34,'male','L2Monster','Fighter',40,1164,'9.000',430,'1.800',40,43,30,21,20,10,1763,103,196,148,82,132,278,500,253,69,19,0,50,110,'ol_mahum_clan',300,'Local','',0,20,66,7,30,4,4,0,-6,'0.63','false',1,0),
(493,20550,'Guardian Basilisk','','lesser_basilisk','34.00','25.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,1960,118,206,175,96,142,278,0,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(494,20551,'Road Scavenger','','wererat','14.00','25.00',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,1991,122,194,154,104,147,317,0,289,221,0,0,80,174,'',0,'Local','',0,0,0,7,10,8,0,0,10,'0.61','true',1,0),
(495,20552,'Fettered Soul','','binding','12.00','21.00',38,'male','L2Monster','Fighter',40,1400,'9.000',497,'1.800',40,43,30,21,20,10,2146,134,238,188,112,153,278,0,253,0,0,0,10,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',1,0),
(496,20553,'Windsus','','giant_wild_hog','25.00','27.00',39,'male','L2Monster','Fighter',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,2212,141,255,195,121,158,278,0,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','true',1,0),
(497,20554,'Grandis','','twin_headed_giant','17.00','39.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2585,167,273,201,131,164,278,500,253,0,0,0,45,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(498,20555,'Giant Fungus','','walking_fungus_bi','15.00','31.30',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2327,150,273,201,131,164,278,0,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(499,20556,'Giant Monstereye','','monster_eye_bi','29.00','60.00',41,'male','L2Monster','Mystic',40,1593,'5.500',560,'2.100',40,43,30,21,20,10,2444,160,321,189,141,169,278,0,253,0,0,0,90,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(500,20557,'Dire Wyrm','','wyrm','29.00','72.00',42,'male','L2Monster','Fighter',40,1660,'5.500',589,'2.100',40,43,30,21,20,10,2590,173,283,237,152,175,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.19','true',1,0),
(501,20558,'Rotting tree','','hanged_man_ripper','35.00','80.00',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,2662,180,302,245,163,181,278,0,253,0,0,0,55,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(502,20559,'Rotting Golem','','stone_golem_bi_one','22.00','43.40',44,'male','L2Monster','Mystic',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,3942,270,322,253,176,187,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(503,20560,'Trisalim Spider','','giant_spider','26.00','26.50',45,'male','L2Monster','Mystic',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,2916,203,415,216,188,193,278,0,253,0,0,0,72,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(504,20561,'Trisalim Tarantula','','poison_spider','27.00','25.50',46,'male','L2Monster','Mystic',40,1943,'5.500',707,'2.100',40,43,30,21,20,10,3452,245,365,270,202,199,278,500,253,0,0,0,60,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.65','true',1,0),
(505,20562,'Spore Zombie','','zombie_bi','13.00','27.50',47,'male','L2Monster','Mystic',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,3591,257,469,230,216,206,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(506,20563,'Manashen Gargoyle','','gargoyle','16.00','50.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2769,179,300,183,131,164,278,0,253,0,0,0,140,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(507,20564,'Enchanted Monstereye','','monster_eye','21.00','43.00',41,'male','L2Monster','Mystic',40,1593,'5.500',560,'2.100',40,43,30,21,20,10,2493,163,321,189,141,169,278,500,253,0,0,0,90,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(508,20565,'Enchanted Stone Golem','','stone_golem_bi','20.00','40.30',42,'male','L2Monster','Mystic',40,1660,'5.500',589,'2.100',40,43,30,21,20,10,3627,242,342,196,152,175,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(509,20566,'Enchanted Iron Golem','','iron_golem','18.00','34.00',43,'male','L2Monster','Mystic',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,3802,257,302,245,163,181,278,0,253,0,0,0,20,20,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(510,20567,'Enchanted Gargoyle','','gargoyle','16.00','50.00',44,'male','L2Monster','Fighter',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,3350,229,390,209,176,187,278,0,253,0,0,0,140,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(511,20568,'Formor','','troll','21.00','35.00',45,'male','L2Monster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,2945,205,377,238,188,193,278,0,253,0,0,0,55,174,'beast_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(512,20569,'Formor Elder','','troll','21.00','35.00',46,'male','L2Monster','Fighter',40,1943,'5.500',707,'2.100',40,43,30,21,20,10,3200,227,401,245,202,199,278,0,253,0,0,0,55,174,'beast_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(513,20570,'Tarlk Bugbear','','bugbear','17.00','35.00',47,'male','L2Monster','Fighter',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,3212,230,427,253,216,206,278,0,253,88,0,0,55,174,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0);
INSERT INTO `npc` VALUES
(514,20571,'Tarlk Bugbear Warrior','','bugbear','17.00','35.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,3793,277,453,261,231,212,278,500,253,169,0,0,55,174,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(515,20572,'Tarlk Bugbear High Warrior','','king_bugbear','15.00','40.00',49,'male','L2Monster','Fighter',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,4155,307,529,245,247,219,278,0,253,160,0,0,55,174,'bugbear_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(516,20573,'Tarlk Basilisk','','lesser_basilisk','34.00','25.00',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3600,271,463,306,264,226,278,0,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(517,20574,'Elder Tarlk Basilisk','','lesser_basilisk','34.00','25.00',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3820,291,593,260,281,232,278,500,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(518,20575,'Oel Mahum Warrior','','oel_mahum_warrior','20.00','38.00',54,'male','L2Monster','Fighter',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,4241,338,699,284,339,254,278,0,253,72,0,0,70,174,'oel_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.65','true',1,0),
(519,20576,'Oel Mahum Witch Doctor','','oel_mahum_witch_doctor','15.00','34.00',55,'male','L2Monster','Mystic',40,2643,'13.000',987,'2.400',40,43,30,21,20,10,4401,355,609,354,360,261,278,0,253,201,0,0,70,174,'oel_mahum_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.26','false',1,0),
(520,20577,'Leto Lizardman','','zenta_lizardman','11.00','32.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1781,105,192,169,89,137,278,0,253,66,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','true',1,0),
(521,20578,'Leto Lizardman Archer','','zenta_lizardman_scout','11.00','30.00',36,'male','L2Monster','Ranger',500,1279,'4.500',463,'1.800',40,43,30,21,20,10,1941,117,417,193,96,142,249,0,227,14,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','true',1,0),
(522,20579,'Leto Lizardman Soldier','','zenta_lizardman','11.00','32.00',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,2030,125,222,182,104,147,278,500,253,68,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','true',1,0),
(523,20580,'Leto Lizardman Warrior','','zenta_lizardman_warrior','13.00','35.00',38,'male','L2Monster','Fighter',40,1400,'9.000',497,'1.800',40,43,30,21,20,10,1953,121,261,171,112,153,278,0,253,93,0,0,40,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(524,20581,'Leto Lizardman Shaman','','zenta_lizardman_shaman','13.00','35.00',39,'male','L2Monster','Priest',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,2212,141,280,177,121,158,278,0,253,159,0,0,43,174,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.63','true',1,0),
(525,20582,'Leto Lizardman Overlord','','zenta_lizardman_matriarch','20.00','40.00',40,'male','L2Monster','Fighter',40,1527,'9.000',531,'1.800',40,43,30,21,20,10,2207,142,217,222,131,164,317,500,289,221,0,0,53,174,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','false',1,0),
(526,20583,'Timak Orc','','batur_orc','9.00','21.50',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2327,150,300,183,131,164,278,0,253,2,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(527,20584,'Timak Orc Archer','','batur_orc_archer','11.00','21.50',41,'male','L2Monster','Ranger',500,1593,'5.500',560,'2.100',40,43,30,21,20,10,3152,206,589,229,141,169,249,0,227,14,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.96','true',1,0),
(528,20585,'Timak Orc Soldier','','batur_orc','9.00','21.50',42,'male','L2Monster','Fighter',40,1660,'5.500',589,'2.100',40,43,30,21,20,10,3114,207,311,215,152,175,278,500,253,66,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(529,20586,'Timak Orc Warrior','','batur_orc_warrior','10.00','20.00',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,2984,202,332,223,163,181,278,0,253,68,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(530,20587,'Timak Orc Shaman','','batur_orc_shaman','11.00','16.00',44,'male','L2Monster','Priest',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,2815,193,390,209,176,187,278,0,253,179,0,0,50,174,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.30','true',1,0),
(531,20588,'Timak Orc Overlord','','batur_orc_overlord','12.00','24.00',45,'male','L2Monster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,3701,257,415,216,188,193,278,500,253,127,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','true',1,0),
(532,20589,'Fline','','sylph','11.00','35.00',45,'female','L2Monster','Mystic',40,1870,'11.000',677,'2.100',40,43,30,21,20,10,2766,192,343,262,188,193,278,0,253,0,0,0,60,174,'elemental_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(533,20590,'Liele','','undine','12.00','27.00',46,'female','L2Monster','Mystic',40,1943,'11.000',707,'2.100',40,43,30,21,20,10,2862,203,365,270,202,199,278,0,253,0,0,0,60,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',1,0),
(534,20591,'Valley Treant','','ti_mi_tran','23.00','90.00',47,'male','L2Monster','Fighter',40,2016,'11.000',738,'2.100',40,43,30,21,20,10,4224,303,388,279,216,206,278,0,253,0,0,0,12,12,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(535,20592,'Satyr','','pan','14.00','35.00',48,'male','L2Monster','Fighter',40,2091,'16.500',768,'2.100',40,43,30,21,20,10,3076,224,412,288,231,212,278,500,253,291,0,0,45,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.58','false',1,0),
(536,20593,'Unicorn','','unicorn','14.00','30.00',49,'male','L2Monster','Mystic',40,2168,'16.500',799,'2.100',40,43,30,21,20,10,3299,244,437,297,247,219,278,0,253,0,0,0,46,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(537,20594,'Forest Runner','','mandragora_b','12.00','25.50',50,'female','L2Monster','Fighter',40,2245,'11.000',830,'2.100',40,43,30,21,20,10,3381,254,463,306,264,226,278,0,253,0,0,0,80,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.13','false',1,0),
(538,20595,'Fline Elder','','sylph','11.00','35.00',51,'female','L2Monster','Mystic',40,2323,'13.000',861,'2.400',40,43,30,21,20,10,3518,268,593,260,281,232,278,0,253,0,0,0,60,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(539,20596,'Liele Elder','','undine','12.00','27.00',52,'female','L2Monster','Mystic',40,2402,'13.000',892,'2.400',40,43,30,21,20,10,3730,288,627,268,300,239,278,500,253,0,0,0,60,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',1,0),
(540,20597,'Valley treant Elder','','ti_mi_tran','23.00','90.00',53,'male','L2Monster','Fighter',40,2481,'19.500',923,'2.400',40,43,30,21,20,10,5199,408,662,276,319,247,278,0,253,0,0,0,12,12,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(541,20598,'Satyr Elder','','pan','14.00','35.00',54,'male','L2Monster','Fighter',40,2562,'19.500',955,'2.400',40,43,30,21,20,10,3816,304,699,284,339,254,278,0,253,297,0,0,45,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.58','false',1,0),
(542,20599,'Unicorn Elder','','unicorn','14.00','30.00',55,'male','L2Monster','Mystic',40,2643,'19.500',987,'2.400',40,43,30,21,20,10,3959,319,737,292,360,261,278,0,253,0,0,0,46,174,'elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(543,20600,'Karul Bugbear','','bugbear','17.00','35.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2741,177,300,183,131,164,278,0,253,88,0,0,55,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(544,20601,'Tamlin Orc','','batur_orc','9.00','21.50',41,'male','L2Monster','Fighter',40,1593,'5.500',560,'2.100',40,43,30,21,20,10,2444,160,291,208,141,169,278,0,253,2,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(545,20602,'Tamlin Orc Archer','','batur_orc_archer','11.00','21.50',42,'male','L2Monster','Ranger',500,1660,'5.500',589,'2.100',40,43,30,21,20,10,3308,220,692,215,152,175,249,0,227,14,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.96','true',1,0),
(546,20603,'Kronbe Spider','','giant_spider','26.00','26.50',43,'male','L2Monster','Mystic',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,2715,184,302,245,163,181,278,500,253,0,0,0,72,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(547,20604,'Lakin','','twin_headed_giant','17.00','39.00',44,'male','L2Monster','Fighter',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,3317,227,390,209,176,187,278,0,253,89,0,0,45,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',1,0),
(548,20605,'Weird Drake','','drake','30.00','100.00',45,'male','L2Monster','Mystic',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(549,20606,'Kuran Kobold','','kobold','10.00','15.00',27,'male','L2Monster','Fighter',40,813,'7.000',318,'1.500',40,43,30,21,20,10,950,48,94,138,45,102,278,0,253,0,0,0,47,110,'kobold_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',1,0),
(550,20607,'Kuran Kobold Warrior','','kobold','10.00','15.00',28,'male','L2Monster','Fighter',40,859,'7.000',334,'1.500',40,43,30,21,20,10,1006,53,124,118,49,106,278,0,253,0,0,0,47,110,'kobold_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',1,0),
(551,20608,'Patin Archer','','skeleton_archer','11.00','27.00',29,'male','L2Monster','Ranger',500,906,'7.000',349,'1.500',40,43,30,21,20,10,1022,55,271,135,53,110,249,500,227,14,0,0,40,140,'',0,'DRIVER','',0,0,0,7,10,8,0,1500,0,'0.80','false',1,0),
(552,20609,'Lakin Salamander','','salamander','16.00','6.80',30,'male','L2Monster','Fighter',40,954,'7.000',365,'1.500',40,43,30,21,20,10,1068,58,120,155,58,114,278,0,253,0,0,0,64,96,'elemental_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,'0.20','false',1,0),
(553,20610,'Sentinel Of Water','','monster_eye','21.00','43.00',31,'male','L2Monster','Mystic',40,1004,'9.000',381,'1.800',40,43,30,21,20,10,1083,60,157,133,64,118,278,0,253,0,0,0,90,90,'elemental_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.30','false',1,0),
(554,20611,'Dre Vanul Warrior','','dre_vanul','14.00','36.00',32,'male','L2Monster','Fighter',40,1056,'9.000',397,'1.800',40,43,30,21,20,10,1154,65,169,138,69,123,278,0,253,0,0,0,80,80,'demonic_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.35','false',1,0),
(555,20612,'Salamander Rowin','','salamander','16.00','6.80',33,'male','L2Monster','Fighter',40,1109,'9.000',413,'1.800',40,43,30,21,20,10,1319,75,151,173,75,128,278,500,253,0,0,0,64,96,'elemental_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,'0.20','false',1,0),
(556,20613,'Lafi Lizardman','','virud_lizardman','10.00','23.00',27,'male','L2Monster','Fighter',40,813,'7.000',318,'1.500',40,43,30,21,20,10,950,48,104,125,45,102,278,0,253,291,0,0,43,130,'lizardman_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(557,20614,'Lafi Lizardman Scout','','virud_lizardman_scout','10.00','22.00',28,'male','L2Monster','Ranger',500,859,'7.000',334,'1.500',40,43,30,21,20,10,940,49,228,143,49,106,249,0,227,2507,0,0,43,130,'lizardman_clan',300,'DRIVER','',0,0,0,7,10,8,0,1500,0,'0.72','false',1,0),
(558,20615,'Ritmal Swordsman','','spartoi','11.00','27.00',29,'male','L2Monster','Fighter',40,906,'7.000',349,'1.500',40,43,30,21,20,10,1094,58,122,135,53,110,278,500,253,73,0,0,60,140,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.30','false',1,0),
(559,20616,'Lakin Undine','','undine','12.00','27.00',30,'female','L2Monster','Mystic',40,954,'7.000',365,'1.500',40,43,30,21,20,10,1434,78,145,128,58,114,278,0,253,0,0,0,60,60,'elemental_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,'0.35','false',1,0),
(560,20617,'Sentinel Of Water','','magical_weaver','11.00','20.00',31,'male','L2Monster','Mystic',40,1004,'9.000',381,'1.800',40,43,30,21,20,10,1093,60,129,161,64,118,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(561,20618,'Kanil Succubus','','succubus','10.00','36.00',32,'female','L2Monster','Mystic',40,1056,'9.000',397,'1.800',40,43,30,21,20,10,1216,68,169,138,69,123,278,0,253,0,0,0,60,100,'demonic_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.84','false',1,0),
(562,20619,'Rowin Undine','','undine','12.00','27.00',33,'female','L2Monster','Mystic',40,1109,'9.000',413,'1.800',40,43,30,21,20,10,1252,72,151,173,75,128,278,500,253,0,0,0,60,60,'elemental_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,'0.35','false',1,0),
(563,20620,'Cave Beast','','troll','21.00','35.00',61,'male','L2Monster','Fighter',40,3137,'22.500',1184,'2.700',40,43,30,21,20,10,4304,378,992,344,505,307,278,500,253,0,0,0,55,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(564,20621,'Death Wave','','will_o_wisp','13.00','22.00',62,'male','L2Monster','Mystic',40,3219,'22.500',1217,'2.700',40,43,30,21,20,10,4639,413,1038,353,532,315,278,500,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.10','false',1,0),
(565,20622,'Malruk Soldier','','skeleton_royal_guard','11.00','28.50',63,'male','L2Monster','Fighter',40,3302,'22.500',1251,'2.700',40,43,30,21,20,10,4953,447,950,362,560,323,317,500,289,221,0,0,80,174,'malruk_clan',500,'Local','',0,0,0,7,10,8,0,0,0,'0.52','false',1,0),
(566,20623,'Plando','','virud_lizardman_scout','10.00','22.00',64,'male','L2Monster','Ranger',500,3384,'30.000',1285,'2.700',40,43,30,21,20,10,4953,453,2084,449,589,331,249,500,227,2507,0,0,43,174,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.72','false',1,0),
(567,20624,'Cave Howler','','twin_headed_giant','17.00','39.00',65,'male','L2Monster','Fighter',40,3465,'30.000',1319,'2.700',40,43,30,21,20,10,5037,468,979,460,619,340,278,500,253,0,0,0,45,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(568,20625,'Malruk Knight','','skeleton_knight','10.00','25.00',66,'male','L2Monster','Fighter',40,3546,'30.000',1353,'2.700',40,43,30,21,20,10,5030,473,1020,471,649,348,278,500,253,78,0,0,40,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(569,20626,'Malruk Berserker','','death_knight','12.00','30.00',67,'male','L2Monster','Fighter',40,3626,'30.000',1388,'2.700',40,43,30,21,20,10,7220,687,1415,362,681,356,278,500,253,77,0,0,27,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(570,20627,'Malruk Lord','','death_blader','15.00','45.00',68,'male','L2Monster','Fighter',40,3706,'37.500',1423,'2.700',40,43,30,21,20,10,4964,479,1217,449,713,365,278,500,253,1472,0,0,100,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(571,20628,'Limal Karinness','','bloody_queen','14.00','40.00',69,'female','L2Monster','Mystic',40,3784,'37.500',1458,'2.700',40,43,30,21,20,10,5349,523,1392,418,746,373,278,500,253,0,0,0,80,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(572,20629,'Karik','','karik','25.00','90.00',70,'male','L2Monster','Fighter',40,3862,'37.500',1493,'2.700',40,43,30,21,20,10,6584,652,1445,427,780,382,278,500,253,0,0,0,37,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(573,20630,'Taik Orc','','ketra_orc','12.00','29.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2327,150,273,201,131,164,278,0,253,127,0,0,45,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(574,20631,'Taik Orc Archer','','ketra_orc_archer','12.00','27.00',41,'male','L2Monster','Ranger',500,1593,'5.500',560,'2.100',40,43,30,21,20,10,3152,206,589,195,141,169,249,0,227,14,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.91','true',1,0),
(575,20632,'Taik Orc Warrior','','ketra_orc_warrior','12.00','24.00',42,'male','L2Monster','Fighter',40,1660,'5.500',589,'2.100',40,43,30,21,20,10,3144,209,342,196,152,175,278,500,253,75,0,0,36,174,'orc_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.54','true',1,0),
(576,20633,'Taik Orc Shaman','','ketra_orc_shaman','10.00','23.00',43,'male','L2Monster','Priest',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,3068,207,302,245,163,181,278,0,253,9,0,0,10,174,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.34','true',1,0),
(577,20634,'Taik Orc Captain','','ketra_orc_warrior','12.00','24.00',44,'male','L2Monster','Fighter',40,1799,'11.000',648,'2.100',40,43,30,21,20,10,2943,201,322,253,176,187,278,500,253,75,104,0,36,174,'orc_clan',300,'Local','',0,20,86,7,30,4,4,0,-6,'0.54','false',1,0),
(578,20635,'Carinkain','','mana_vampire','11.00','20.00',45,'male','L2Monster','Mystic',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,2974,207,415,216,188,193,278,500,253,0,0,0,90,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(579,20636,'Forest of Mirrors Ghost','','dwarf_ghost','9.00','16.50',46,'male','L2Monster','Mystic',40,1943,'5.500',707,'2.100',40,43,30,21,20,10,3310,235,442,223,202,199,278,500,253,0,0,0,80,174,'mirrorforest_clan',200,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(580,20637,'Forest of Mirrors Ghost','','elf_ghost','7.00','21.00',47,'male','L2Monster','Mystic',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,3456,248,469,230,216,206,278,500,253,0,0,0,80,174,'mirrorforest_clan',200,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(581,20638,'Forest of Mirrors Ghost','','human_ghost','8.00','22.00',48,'male','L2Monster','Mystic',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,3605,263,498,238,231,212,278,500,253,0,0,0,80,174,'mirrorforest_clan',200,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(582,20639,'Mirror','','mirror','26.00','52.00',49,'male','L2Monster','Mystic',40,2168,'11.000',799,'2.100',40,43,30,21,20,10,4254,314,437,297,247,219,278,0,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(583,20640,'Harit Lizardman','','zenta_lizardman','11.00','32.00',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3636,274,509,278,264,226,278,0,253,88,945,0,37,174,'lizardman_clan',300,'Local','',0,20,100,7,50,1,9,0,-6,'0.28','true',1,0),
(584,20641,'Harit Lizardman Grunt','','zenta_lizardman','11.00','32.00',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,4501,343,539,286,281,232,278,0,253,70,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','true',1,0),
(585,20642,'Harit Lizardman Archer','','zenta_lizardman_scout','11.00','30.00',52,'male','L2Monster','Ranger',500,2402,'6.500',892,'2.400',40,43,30,21,20,10,4214,326,1152,324,300,239,249,500,227,14,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','true',1,0),
(586,20643,'Harit Lizardman Warrior','','zenta_lizardman_warrior','13.00','35.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4332,341,662,276,319,247,278,0,253,291,0,0,40,174,'lizardman_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(587,20644,'Harit Lizardman Shaman','','zenta_lizardman_shaman','13.00','35.00',54,'male','L2Monster','Priest',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,4241,338,699,284,339,254,278,0,253,9,0,0,43,174,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.63','true',1,0),
(588,20645,'Harit Lizardman Matriarch','','zenta_lizardman_matriarch','20.00','40.00',55,'male','L2Monster','Fighter',40,2643,'13.000',987,'2.400',40,43,30,21,20,10,4768,385,609,354,360,261,278,500,253,221,0,0,53,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(589,20646,'Halingka','','saber_toothed_tiger','34.00','28.00',55,'male','L2Monster','Fighter',40,2643,'13.000',987,'2.400',40,43,30,21,20,10,3592,290,737,292,360,261,278,0,253,0,0,0,60,170,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','false',1,0),
(590,20647,'Yintzu','','field_stalker','15.00','30.00',56,'male','L2Monster','Fighter',40,2724,'13.000',1019,'2.400',40,43,30,21,20,10,3605,296,777,301,382,269,278,500,253,0,0,0,70,110,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.41','false',1,0),
(591,20648,'Paliote','','will_o_wisp','13.00','22.00',57,'male','L2Monster','Mystic',40,2806,'13.000',1052,'2.400',40,43,30,21,20,10,4094,340,817,309,405,276,278,0,253,0,0,0,80,140,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.10','false',1,0),
(592,20649,'Hamrut','','poison_spider','27.00','25.50',58,'male','L2Monster','Mystic',40,2889,'13.000',1084,'2.400',40,43,30,21,20,10,4075,344,859,318,428,284,278,500,253,0,0,0,60,140,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.65','false',1,0),
(593,20650,'Kranrot','','crimson_bear','19.00','36.00',59,'male','L2Monster','Fighter',40,2971,'13.000',1117,'2.400',40,43,30,21,20,10,4410,377,902,326,453,291,278,500,253,0,0,0,37,170,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','false',1,0),
(594,20651,'Gamlin','','gamlin','11.00','32.00',60,'male','L2Monster','Fighter',40,3054,'13.000',1150,'2.400',40,43,30,21,20,10,4097,355,782,405,478,299,278,0,253,0,0,0,80,170,'giant_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.46','false',1,0),
(595,20652,'Leogul','','leogul','15.00','35.00',61,'male','L2Monster','Fighter',40,3137,'15.000',1184,'2.700',40,43,30,21,20,10,4320,380,819,416,505,307,278,500,253,0,0,0,80,170,'giant_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.72','false',1,0),
(596,20653,'Lesser Giant','','lesser_giant','21.00','44.00',61,'male','L2Monster','Fighter',40,3137,'22.500',1184,'2.700',40,43,30,21,20,10,4058,357,901,378,505,307,278,0,253,3937,0,0,15,180,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.58','false',0,0),
(597,20654,'Lesser Giant Soldier','','lesser_giant','21.00','44.00',62,'male','L2Monster','Fighter',40,3219,'22.500',1217,'2.700',40,43,30,21,20,10,6224,554,1142,321,532,315,278,0,253,3937,0,0,15,180,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.58','false',1,0),
(598,20655,'Lesser Giant Shooter','','lesser_giant_shooter','21.00','44.00',63,'male','L2Monster','Fighter',500,3302,'22.500',1251,'2.700',40,43,30,21,20,10,5085,459,2194,398,560,323,249,500,227,4028,0,0,80,180,'giant_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.63','false',1,0),
(599,20656,'Lesser Giant Scout','','lesser_giant_shooter','21.00','44.00',63,'male','L2Monster','Ranger',500,3302,'22.500',1251,'2.700',40,43,30,21,20,10,4639,419,2194,338,560,323,249,500,227,4028,0,0,80,180,'giant_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.63','false',1,0),
(600,20657,'Lesser Giant Mage','','lesser_giant_mage','21.00','44.00',64,'male','L2Monster','Mystic',40,3384,'15.000',1285,'2.700',40,43,30,21,20,10,5511,504,1135,371,589,331,278,0,253,3938,0,0,15,180,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(601,20658,'Lesser Giant Elder','','lesser_giant_mage','21.00','44.00',65,'male','L2Monster','Mystic',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,5324,494,1184,380,619,340,278,0,253,3938,0,0,15,180,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(602,20659,'Grave Wanderer','','zombie','13.00','21.00',45,'male','L2Monster','Mystic',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,4123,287,377,238,188,193,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(603,20660,'Archer of Greed','','skeleton_archer','11.00','27.00',46,'male','L2Monster','Ranger',500,1943,'5.500',707,'2.100',40,43,30,21,20,10,4048,287,982,190,202,199,249,500,227,14,0,0,40,174,'',0,'Local','',0,0,0,7,10,8,0,1500,10,'0.80','true',1,0),
(604,20661,'Hatar Ratman Thief','','wererat','14.00','25.00',47,'male','L2Monster','Fighter',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,3823,274,373,253,216,206,317,0,289,946,0,0,80,174,'hatar_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.61','true',1,0),
(605,20662,'Hatar Ratman Boss','','wererat','14.00','25.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,3987,291,396,261,231,212,317,0,289,221,0,0,80,174,'hatar_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.61','true',1,0),
(606,20663,'Hatar Hanishee','','medusa','10.00','25.00',49,'female','L2Monster','Mystic',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,3492,258,529,245,247,219,278,0,253,0,0,0,50,174,'hatar_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(607,20664,'Deprive','','field_stalker','15.00','30.00',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3672,277,560,253,264,226,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(608,20665,'Taik Orc Supply','','ketra_orc','12.00','29.00',51,'male','L2Monster','Priest',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,4501,343,490,315,281,232,278,0,253,69,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(609,20666,'Taik Orc Seeker','','ketra_orc','12.00','29.00',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,4679,362,627,268,300,239,278,0,253,72,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(610,20667,'Farcran','','crimson_bear','19.00','36.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4813,378,602,304,319,247,278,0,253,0,0,0,37,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(611,20668,'Grave Guard','','gargoyle','16.00','50.00',54,'male','L2Monster','Fighter',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,4283,341,578,344,339,254,278,500,253,0,0,0,140,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',1,0),
(612,20669,'Taik Orc Supply Leader','','ketra_orc_warrior','12.00','24.00',55,'male','L2Monster','Priest',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,5340,431,737,292,360,261,278,500,253,75,0,0,36,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',1,0),
(613,20670,'Crimson Drake','','drake','30.00','100.00',61,'male','L2Monster','Mystic',40,3137,'7.500',1184,'2.700',40,43,30,21,20,10,5465,481,992,344,505,307,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','false',1,0),
(614,20671,'Kadios','','devastator','35.00','35.00',62,'male','L2Monster','Fighter',40,3219,'7.500',1217,'2.700',40,43,30,21,20,10,5702,508,1038,353,532,315,278,500,253,0,0,0,25,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','false',1,0),
(615,20672,'Trives','','serpent_slave','17.00','46.00',63,'male','L2Monster','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,5772,521,897,438,560,323,278,0,253,127,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(616,20673,'Falibati','','cave_maiden','25.00','65.00',64,'female','L2Monster','Fighter',40,3384,'7.500',1285,'2.700',40,43,30,21,20,10,6016,551,938,449,589,331,278,500,253,73,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','false',1,0),
(617,20674,'Doom Knight','','death_blader','15.00','45.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,8649,804,1184,380,619,340,278,500,253,1472,0,0,100,174,'doom_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(618,20675,'Tairim','','will_o_wisp','13.00','22.00',50,'male','L2Monster','Mystic',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3817,288,463,306,264,226,278,0,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.10','false',1,0),
(619,20676,'Judge of Marsh','','hanged_man_ripper','35.00','80.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,6205,577,1184,380,619,340,278,500,253,0,0,0,55,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(620,20677,'Tulben','','vampire_bat','10.00','33.50',66,'male','L2Monster','Mystic',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,6968,656,1123,428,649,348,278,0,253,0,0,0,60,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(621,20678,'Tortured Undead','','hungry_spirit','13.00','40.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4085,321,662,276,319,247,278,0,253,0,0,0,15,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(622,20679,'Marsh Stalker','','gargoyle','16.00','50.00',54,'male','L2Monster','Fighter',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,4199,335,636,313,339,254,278,0,253,0,0,0,140,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(623,20680,'Marsh Drake','','drake','30.00','100.00',55,'male','L2Monster','Mystic',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,4443,359,737,292,360,261,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(624,20681,'Vanor Silenos','','heltor_silenos','13.00','29.00',45,'male','L2Monster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,3092,215,377,238,188,193,278,0,253,88,0,0,34,174,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',1,0),
(625,20682,'Vanor Silenos Grunt','','heltor_silenos','13.00','29.00',46,'male','L2Monster','Fighter',40,1943,'5.500',707,'2.100',40,43,30,21,20,10,3077,218,401,245,202,199,278,0,253,158,18,0,34,174,'silenos_clan',300,'Local','',0,20,91,7,50,1,9,0,-6,'0.46','true',1,0),
(626,20683,'Vanor Silenos Scout','','heltor_silenos','13.00','29.00',47,'male','L2Monster','Ranger',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,4004,287,388,279,216,206,278,500,253,5,0,0,34,174,'silenos_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',1,0),
(627,20684,'Vanor Silenos Warrior','','heltor_silenos_warrior','13.00','31.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,4188,306,498,238,231,212,278,0,253,160,0,0,36,174,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.39','true',1,0),
(628,20685,'Vanor Silenos Shaman','','heltor_silenos_shaman','13.00','32.00',49,'male','L2Monster','Priest',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,3492,258,529,245,247,219,278,0,253,9,0,0,29,174,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.22','true',1,0),
(629,20686,'Vanor Silenos Chieftain','','heltor_silenos_chieftain','13.00','31.50',50,'male','L2Monster','Fighter',40,2245,'11.000',830,'2.100',40,43,30,21,20,10,3637,274,463,306,264,226,278,0,253,75,0,0,27,174,'silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(630,20738,'Kobold Looter Bepook','','kobold_bi','15.00','24.00',13,'male','L2Monster','Fighter',40,339,'5.000',147,'1.200',40,43,30,21,20,10,663,26,33,63,11,56,278,500,253,4,0,0,47,110,'partisan_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.54','false',0,1),
(631,20739,'Bepook''s Pet','','wolf','13.00','9.00',10,'male','L2Monster','Fighter',40,257,'1.000',120,'0.900',40,43,30,21,20,10,439,14,27,50,8,49,278,0,253,0,0,0,24,110,'partisan_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,'0.39','true',0,0),
(632,20742,'Mystical Weaver','','magical_weaver','11.00','20.00',22,'male','L2Monster','Mystic',40,611,'3.500',242,'1.500',40,43,30,21,20,10,684,32,62,113,28,83,278,0,253,0,0,0,90,90,'partisan_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',0,0),
(633,20743,'Howler','','werewolf','10.00','26.00',25,'male','L2Monster','Fighter',40,728,'3.500',287,'1.500',40,43,30,21,20,10,843,42,80,127,37,94,278,500,253,0,0,0,50,120,'partisan_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',0,0),
(634,20744,'Red Eye Vampire Bat','','vampire_bat','10.00','33.50',22,'male','L2Monster','Mystic',40,611,'3.500',242,'1.500',40,43,30,21,20,10,684,32,75,93,28,83,278,0,253,0,0,0,60,80,'partisan_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',0,0),
(635,20745,'Gigantiops','','ant_soldier','35.00','17.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,2681,159,174,186,89,137,278,500,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,1),
(636,20746,'Young Gigantiops','','ant','26.00','15.00',31,'male','L2Monster','Fighter',40,1004,'4.500',381,'1.800',40,43,30,21,20,10,2062,114,157,133,64,118,278,0,253,0,0,0,40,139,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',0,0),
(637,20747,'Roxide','','succubus','10.00','36.00',32,'female','L2Monster','Mystic',40,1056,'9.000',397,'1.800',40,43,30,21,20,10,1459,82,169,138,69,123,278,500,253,0,0,0,60,159,'demonic_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.84','false',1,1),
(638,20748,'Roxide Cohort','','spartoi','11.00','27.00',29,'male','L2Monster','Fighter',40,906,'7.000',349,'1.500',40,43,30,21,20,10,1349,72,111,149,53,110,278,0,253,73,0,0,60,159,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(639,20749,'Death Fire','','dre_vanul','14.00','36.00',32,'male','L2Monster','Fighter',40,1056,'9.000',397,'1.800',40,43,30,21,20,10,1459,82,169,138,69,123,278,500,253,0,0,0,80,159,'demonic_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.35','false',1,1),
(640,20750,'Fire Archer','','skeleton_archer','11.00','27.00',29,'male','L2Monster','Ranger',500,906,'7.000',349,'1.500',40,43,30,21,20,10,1397,75,247,149,53,110,249,0,227,14,0,0,40,159,'demonic_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','false',0,0),
(641,20751,'Snipe','','onyx_beast','14.00','14.50',44,'male','L2Monster','Fighter',40,1799,'11.000',648,'2.100',40,43,30,21,20,10,3387,232,390,209,176,187,278,500,253,0,0,0,30,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.24','false',1,1),
(642,20752,'Snipe Cohort','','onyx_beast','14.00','14.50',42,'male','L2Monster','Fighter',40,1660,'11.000',589,'2.100',40,43,30,21,20,10,3290,219,283,237,152,175,278,0,253,0,0,0,30,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.24','false',0,0),
(643,20753,'Dark Lord','','death_blader','15.00','45.00',50,'male','L2Monster','Fighter',40,2245,'11.000',830,'2.100',40,43,30,21,20,10,4282,322,463,306,264,226,278,500,253,1472,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','false',1,1),
(644,20754,'Dark Knight','','death_knight','12.00','30.00',48,'male','L2Monster','Fighter',40,2091,'11.000',768,'2.100',40,43,30,21,20,10,4960,362,498,238,231,212,278,0,253,127,0,0,27,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(645,20755,'Talakin','','ol_mahum_champion','14.00','27.00',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1970,108,120,155,58,114,278,500,253,2,0,0,50,133,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.63','true',1,1),
(646,20756,'Talakin Archer','','ol_mahum_archer','14.00','25.00',28,'male','L2Monster','Ranger',500,859,'3.500',334,'1.500',40,43,30,21,20,10,1884,99,228,143,49,106,249,0,227,14,0,0,50,133,'ol_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','true',0,0),
(647,20757,'Talakin Raider','','ol_mahum','13.50','25.00',27,'male','L2Monster','Fighter',40,813,'3.500',318,'1.500',40,43,30,21,20,10,1380,71,114,114,45,102,278,0,253,3,0,0,50,133,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(648,20758,'Dragon Bearer Chief','','spartoi','11.00','27.00',49,'male','L2Monster','Fighter',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,5255,389,437,297,247,219,278,500,253,123,945,0,60,174,'cave_servant_clan',300,'Local','',0,20,97,7,30,4,4,0,-6,'0.30','true',1,1),
(649,20759,'Dragon Bearer Warrior','','skeleton','11.00','25.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,4944,361,498,238,231,212,278,0,253,2,945,0,60,174,'cave_servant_clan',300,'Local','',0,20,95,7,30,4,4,0,-6,'0.30','true',0,0),
(650,20760,'Dragon Bearer Archer','','skeleton_archer','11.00','27.00',47,'male','L2Monster','Ranger',500,2016,'5.500',738,'2.100',40,43,30,21,20,10,5137,368,862,279,216,206,249,0,227,14,0,0,40,174,'cave_servant_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',0,0),
(651,20761,'Pytan','','bloody_queen','14.00','40.00',69,'female','L2Monster','Mystic',40,3784,'22.500',1458,'2.700',40,43,30,21,20,10,6633,649,1392,418,746,373,278,500,253,0,0,0,80,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,1),
(652,20762,'Pytan Knight','','death_blader','15.00','45.00',68,'male','L2Monster','Fighter',40,3706,'15.000',1423,'2.700',40,43,30,21,20,10,7021,678,1106,494,713,365,278,0,253,1472,0,0,100,174,'malruk_clan',500,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(653,20763,'Lord of the Plains','','zenta_lizardman_matriarch','20.00','40.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,3869,250,217,222,131,164,317,500,289,221,0,0,53,174,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',1,1),
(654,20764,'Shaman of the Plains','','zenta_lizardman_shaman','13.00','35.00',39,'male','L2Monster','Priest',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,3457,220,231,214,121,158,278,0,253,179,0,0,43,174,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.63','true',0,0),
(655,20765,'Warrior of the Plains','','zenta_lizardman_warrior','13.00','35.00',38,'male','L2Monster','Fighter',40,1400,'4.500',497,'1.800',40,43,30,21,20,10,2992,187,261,171,112,153,278,0,253,16,0,0,40,174,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',0,0),
(656,20766,'Scout of the Plains','','zenta_lizardman_scout','11.00','30.00',36,'male','L2Monster','Ranger',500,1279,'4.500',463,'1.800',40,43,30,21,20,10,2659,161,417,193,96,142,249,0,227,14,0,0,37,174,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','true',0,0),
(657,20767,'Timak Orc Troop Leader','','batur_orc_overlord','12.00','24.00',45,'male','L2Monster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,4801,334,415,216,188,193,278,0,253,79,0,0,80,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','true',1,1),
(658,20768,'Timak Orc Troop Shaman','','batur_orc_shaman','11.00','16.00',44,'male','L2Monster','Priest',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,4632,317,390,209,176,187,278,0,253,7,0,0,50,174,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.30','true',0,0),
(659,20769,'Timak Orc Troop Warrior','','batur_orc_warrior','10.00','20.00',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,3684,249,365,202,163,181,278,0,253,123,19,0,80,174,'orc_clan',300,'Local','',0,20,84,7,30,4,4,0,-6,'0.30','true',0,0),
(660,20770,'Timak Orc Troop Archer','','batur_orc_archer','11.00','21.50',41,'male','L2Monster','Ranger',500,1593,'5.500',560,'2.100',40,43,30,21,20,10,4319,283,713,189,141,169,249,0,227,13,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.96','true',0,0),
(661,20771,'Barif','','lesser_giant_mage','21.00','44.00',64,'male','L2Monster','Mystic',40,3384,'15.000',1285,'2.700',40,43,30,21,20,10,6515,596,938,449,589,331,278,500,253,3938,0,0,15,180,'giant_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,1),
(662,20772,'Barif''s Pet','','leogul','15.00','35.00',61,'male','L2Monster','Fighter',40,3137,'15.000',1184,'2.700',40,43,30,21,20,10,6332,557,992,344,505,307,278,0,253,0,0,0,80,170,'giant_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,'0.72','false',0,0),
(663,20773,'Conjurer Bat Lord','','vampire_bat','10.00','33.50',72,'male','L2Monster','Fighter',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,10535,1070,1284,540,849,399,278,500,253,0,0,0,60,174,'giant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,1),
(664,20774,'Conjurer Bat','','vampire_bat','10.00','33.50',70,'male','L2Monster','Mystic',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,11140,1105,1194,517,780,382,278,0,253,0,0,0,60,174,'giant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',0,0),
(665,20775,'Bugbear Raider','','bugbear','17.00','35.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,599,25,48,75,17,67,278,0,253,0,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','true',1,0),
(666,20776,'Dark Succubus','','succubus','10.00','36.00',20,'female','L2Monster','Mystic',40,541,'2.500',213,'1.200',40,43,30,21,20,10,783,35,57,94,23,76,278,0,253,0,0,0,60,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(667,20777,'Hunter Bear','','grizzly','21.00','40.00',14,'male','L2Monster','Fighter',40,364,'2.500',156,'1.200',40,43,30,21,20,10,498,19,37,66,12,59,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(668,20778,'Ragna Orc Overlord','','orc_champion','10.00','23.00',39,'male','L2Monster','Fighter',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,2477,157,231,214,121,158,278,0,253,2,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.76','true',1,0),
(669,20779,'Ragna Orc Seer','','orc_shaman','9.00','22.00',39,'male','L2Monster','Priest',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,2212,141,231,214,121,158,278,0,253,7,0,0,45,174,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.26','true',1,0),
(670,20780,'Bloody Axe Elite','','ol_mahum_champion','14.00','27.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1799,106,174,186,89,137,278,500,253,2,0,0,50,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.63','true',1,0),
(671,20781,'Delu Lizardman Shaman','','virud_lizardman_shaman','10.00','29.00',35,'male','L2Monster','Priest',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1781,105,211,154,89,137,278,0,253,7,0,0,43,174,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',1,0),
(672,20782,'Ol Mahum Novice','','ol_mahum','13.50','25.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,618,26,44,83,17,67,278,500,253,1,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(673,20783,'Dread Wolf','','dire_wolf','13.00','11.00',35,'male','L2Monster','Fighter',40,1220,'2.250',446,'1.800',40,43,30,21,20,10,1635,96,256,127,89,137,278,500,253,0,0,0,24,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(674,20784,'Tasaba Lizardman','','virud_lizardman_scout','10.00','22.00',36,'male','L2Monster','Ranger',500,1279,'2.250',463,'1.800',40,43,30,21,20,10,1852,112,505,159,96,142,249,0,227,2507,0,0,43,140,'lizardman_clan1',300,'Magister','',0,0,0,7,10,8,0,1500,0,'0.72','true',1,0),
(675,20785,'Tasaba Lizardman Shaman','','virud_lizardman_shaman','10.00','29.00',37,'male','L2Monster','Priest',40,1338,'2.250',480,'1.800',40,43,30,21,20,10,1791,110,244,140,104,147,278,0,253,7,0,0,43,140,'lizardman_clan1',300,'Magister','',0,0,0,7,50,1,9,0,10,'0.48','true',1,0),
(676,20786,'Lienrik','','lienrik','12.00','50.00',39,'male','L2Monster','Fighter',40,1462,'2.250',514,'1.800',40,43,30,21,20,10,1990,126,297,146,121,158,317,0,289,0,0,0,100,150,'lienrik_clan',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.46','true',1,0),
(677,20787,'Lienrik Lad','','lienrik','12.00','50.00',40,'male','L2Monster','Fighter',40,1527,'2.250',531,'1.800',40,43,30,21,20,10,2421,156,317,151,131,164,317,500,289,0,0,0,100,174,'lienrik_clan',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.46','true',1,0);
INSERT INTO `npc` VALUES
(678,20788,'Rakul','','rakul','30.00','39.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,2120,125,192,169,89,137,278,0,253,3,0,0,60,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.59','true',1,0),
(679,20789,'Crokian','','crokian','18.00','29.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,1999,121,187,193,96,142,278,500,253,5128,0,0,18,174,'croc_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.78','true',1,0),
(680,20790,'Dailaon','','dailaon','20.00','28.00',37,'male','L2Monster','Fighter',500,1338,'4.500',480,'1.800',40,43,30,21,20,10,2567,158,448,200,104,147,249,0,227,5127,0,0,18,174,'croc_clan',300,'Magister','',0,0,0,7,10,8,0,1500,0,'0.91','true',1,0),
(681,20791,'Crokian Warrior','','crokian','18.00','29.00',38,'male','L2Monster','Fighter',40,1400,'9.000',497,'1.800',40,43,30,21,20,10,2211,138,261,171,112,153,278,500,253,5128,0,0,18,174,'croc_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.78','false',1,0),
(682,20792,'Farhite','','farhite','16.00','31.00',39,'male','L2Monster','Fighter',40,1462,'9.000',514,'1.800',40,43,30,21,20,10,2057,131,280,150,121,158,278,0,253,5131,0,0,15,174,'croc_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,'0.74','false',1,0),
(683,20793,'Nos','','nos','26.00','42.00',40,'male','L2Monster','Fighter',40,1527,'9.000',531,'1.800',40,43,30,21,20,10,2251,145,300,183,131,164,278,500,253,5130,0,0,18,174,'croc_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.78','false',1,0),
(684,20794,'Blade Stakato','','blade_stakato','15.00','36.00',41,'male','L2Monster','Fighter',40,1593,'11.000',560,'2.100',40,43,30,21,20,10,2103,137,265,229,141,169,278,0,253,223,0,0,25,174,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(685,20795,'Blade Stakato Worker','','blade_stakato_worker','13.00','40.00',42,'male','L2Monster','Fighter',40,1660,'11.000',589,'2.100',40,43,30,21,20,10,1988,132,272,215,152,175,317,0,289,226,0,0,25,174,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.76','false',1,0),
(686,20796,'Blade Stakato Warrior','','blade_stakato_soldier','15.00','38.00',43,'male','L2Monster','Fighter',40,1728,'11.000',618,'2.100',40,43,30,21,20,10,2125,143,365,202,163,181,278,500,253,232,0,0,25,174,'stakato_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.74','false',1,0),
(687,20797,'Blade Stakato Drone','','blade_stakato_drone','15.00','39.00',44,'male','L2Monster','Fighter',40,1799,'16.500',648,'2.100',40,43,30,21,20,10,2154,147,390,178,176,187,278,0,253,74,0,0,25,174,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.58','false',1,0),
(688,20798,'Water Giant','','water_giant','13.00','44.00',45,'male','L2Monster','Fighter',40,1870,'11.000',677,'2.100',40,43,30,21,20,10,2612,181,343,262,188,193,278,500,253,5132,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(689,20799,'Queen Undine Lad','','undine','12.00','27.00',46,'female','L2Monster','Mystic',40,1943,'11.000',707,'2.100',40,43,30,21,20,10,2630,186,442,190,202,199,278,0,253,0,0,0,60,174,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.35','false',1,0),
(690,20800,'Eva''s Seeker','','field_stalker','15.00','30.00',47,'male','L2Monster','Fighter',40,2016,'11.000',738,'2.100',40,43,30,21,20,10,2465,176,388,279,216,206,278,0,253,0,0,0,70,174,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.41','false',1,0),
(691,20801,'Theeder Piker','','theeder','9.00','32.00',48,'male','L2Monster','Fighter',80,2091,'11.000',768,'2.100',40,43,30,21,20,10,2972,217,481,288,231,212,237,500,216,302,0,0,80,174,'theeder_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(692,20802,'Theeder Mage','','theeder','9.00','32.00',49,'male','L2Monster','Mystic',40,2168,'11.000',799,'2.100',40,43,30,21,20,10,3025,223,529,208,247,219,278,0,253,192,0,0,80,174,'theeder_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.45','false',1,0),
(693,20803,'Doll Master','','doll_master','20.00','42.00',50,'male','L2Monster','Fighter',40,2245,'16.500',830,'2.100',40,43,30,21,20,10,3949,297,616,230,264,226,278,500,253,0,0,0,80,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(694,20804,'Crokian Lad','','crokian_100_bi','36.00','61.00',41,'male','L2Monster','Fighter',40,1593,'11.000',560,'2.100',40,43,30,21,20,10,2574,168,291,208,141,169,278,500,253,5128,0,0,18,174,'croc_clan2',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.78','false',1,0),
(695,20805,'Dailaon Lad','','dailaon_100_bi','40.00','58.00',42,'male','L2Monster','Fighter',500,1660,'11.000',589,'2.100',40,43,30,21,20,10,2790,186,762,196,152,175,249,0,227,5127,0,0,18,174,'croc_clan2',300,'Magister','',0,0,0,7,10,8,0,1500,0,'0.91','false',1,0),
(696,20806,'Crokian Lad Warrior','','crokian_100_bi','36.00','61.00',43,'male','L2Monster','Fighter',40,1728,'11.000',618,'2.100',40,43,30,21,20,10,2678,181,365,202,163,181,278,500,253,5128,0,0,18,174,'croc_clan2',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.78','false',1,0),
(697,20807,'Farhite Lad','','farhite_50_bi','24.00','48.00',44,'male','L2Monster','Fighter',40,1799,'11.000',648,'2.100',40,43,30,21,20,10,2817,193,390,178,176,187,278,0,253,5131,0,0,15,174,'croc_clan2',300,'Magister','',0,0,0,7,50,1,9,0,10,'0.74','false',1,0),
(698,20808,'Nos Lad','','nos_100_bi','52.00','86.00',45,'male','L2Monster','Fighter',40,1870,'11.000',677,'2.100',40,43,30,21,20,10,3487,242,343,262,188,193,278,500,253,128,0,0,18,174,'croc_clan2',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.78','false',1,0),
(699,20809,'Ghost of the Tower','','human_ghost','8.00','22.00',60,'male','L2Monster','Mystic',40,3054,'19.500',1150,'2.400',40,43,30,21,20,10,4045,351,860,368,478,299,278,500,253,0,0,0,80,143,'tower_ghost_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.39','false',1,0),
(700,20810,'Seer of Hallate','','field_stalker','15.00','30.00',60,'male','L2Monster','Fighter',40,3054,'19.500',1150,'2.400',40,43,30,21,20,10,4045,351,946,335,478,299,278,500,253,0,0,0,70,170,'hallate_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.41','false',1,0),
(701,20811,'Ghastly Warrior','','unpleasant_humming','12.00','26.00',61,'male','L2Monster','Fighter',40,3137,'22.500',1184,'2.700',40,43,30,21,20,10,4769,419,717,416,505,307,317,500,289,0,0,0,21,150,'tower_ghost_clan',400,'Magister','',0,0,0,7,10,8,0,0,0,'0.59','false',1,0),
(702,20812,'Archer of Despair','','skeleton_archer','11.00','27.00',61,'male','L2Monster','Ranger',500,3137,'22.500',1184,'2.700',40,43,30,21,20,10,4708,414,2204,292,505,307,249,500,227,284,0,0,40,160,'tower_ghost_clan',400,'Magister','',0,0,0,7,10,8,0,1500,10,'0.80','false',1,0),
(703,20813,'Crendion','','liviona','15.00','28.00',62,'male','L2Monster','Fighter',40,3219,'22.500',1217,'2.700',40,43,30,21,20,10,4276,381,944,388,532,315,278,500,253,0,0,0,80,160,'tower_ghost_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(704,20814,'Blader of Despair','','spartoi','11.00','27.00',62,'male','L2Monster','Fighter',80,3219,'22.500',1217,'2.700',40,43,30,21,20,10,4938,440,1212,353,532,315,237,500,216,79,0,0,60,143,'tower_ghost_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.30','false',1,1),
(705,20815,'Hound Dog of Hallate','','dire_wolf','13.00','11.00',63,'male','L2Monster','Fighter',40,3302,'30.000',1251,'2.700',40,43,30,21,20,10,4583,413,897,438,560,323,278,500,253,0,0,0,24,165,'hallate_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.39','false',1,0),
(706,20816,'Hallate''s Royal Guard','','skeleton_royal_guard','11.00','28.50',63,'male','L2Monster','Fighter',40,3302,'22.500',1251,'2.700',40,43,30,21,20,10,5098,460,785,438,560,323,317,500,289,946,945,0,80,164,'hallate_clan',400,'Magister',NULL,0,20,131,7,10,8,0,0,-6,'0.52','false',1,1),
(707,20817,'Corrupt Sage','','vale_master','12.00','40.00',64,'male','L2Monster','Mystic',40,3384,'22.500',1285,'2.700',40,43,30,21,20,10,5315,486,1135,315,589,331,278,500,253,210,0,0,70,160,'tower_ghost_clan',400,'Magister','',0,0,0,7,50,1,9,0,10,'0.74','false',1,0),
(708,20818,'Hallate''s Warrior','','skeleton_knight','10.00','25.00',64,'male','L2Monster','Fighter',40,3384,'22.500',1285,'2.700',40,43,30,21,20,10,4926,451,1135,371,589,331,278,500,253,78,0,0,40,160,'hallate_clan',400,'Magister',NULL,0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(709,20819,'Archer of Abyss','','fiend_archer','17.00','55.00',65,'male','L2Monster','Ranger',500,3465,'22.500',1319,'2.700',40,43,30,21,20,10,4889,454,2632,380,619,340,249,500,227,0,0,0,70,165,'tower_ghost_clan',400,'Magister','',0,0,0,7,10,8,0,1500,0,'0.76','false',1,0),
(710,20820,'Hallate''s Knight','','death_knight','12.00','30.00',65,'male','L2Monster','Fighter',40,3465,'30.000',1319,'2.700',40,43,30,21,20,10,7310,679,979,460,619,340,278,500,253,80,0,0,27,160,'hallate_clan',400,'Magister',NULL,0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(711,20821,'Erin Ediunce','','banshee','9.00','23.00',66,'female','L2Monster','Mystic',40,3546,'30.000',1353,'2.700',40,43,30,21,20,10,5335,502,1020,401,649,348,278,500,253,3939,0,0,80,165,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(712,20822,'Hallate''s Maid','','bloody_queen','14.00','40.00',66,'female','L2Monster','Mystic',40,3546,'30.000',1353,'2.700',40,43,30,21,20,10,4964,467,893,471,649,348,317,500,289,0,0,0,80,160,'hallate_clan',400,'Magister',NULL,0,0,0,7,10,8,0,0,0,'0.50','false',1,0),
(713,20823,'Platinum Tribe Soldier','','kel_mahum','13.00','26.00',67,'male','L2Monster','Fighter',40,3626,'30.000',1388,'2.700',40,43,30,21,20,10,5764,549,1126,399,681,356,317,500,289,242,0,0,50,160,'tower_guard_clan',400,'Magister','',0,0,0,7,10,8,0,0,0,'0.52','false',1,0),
(714,20824,'Hallate''s Commander','','death_blader','15.00','45.00',67,'male','L2Monster','Fighter',40,3626,'30.000',1388,'2.700',40,43,30,21,20,10,5184,493,1286,399,681,356,278,500,253,1472,0,0,100,170,'hallate_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,'0.45','false',1,1),
(715,20825,'Hallate''s Inspector','','karik_25_bi','31.00','110.00',68,'male','L2Monster','Fighter',40,3706,'30.000',1423,'2.700',40,43,30,21,20,10,5414,523,1339,408,713,365,278,500,253,0,0,0,37,170,'hallate_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,'0.45','false',1,1),
(716,20826,'Platinum Tribe Archer','','kel_mahum_archer','13.00','27.00',68,'male','L2Monster','Ranger',500,3706,'22.500',1423,'2.700',40,43,30,21,20,10,7650,739,2975,347,713,365,249,500,227,288,0,0,50,160,'tower_guard_clan',400,'Magister','',0,0,0,7,10,8,0,1500,10,'0.91','false',1,0),
(717,20827,'Platinum Tribe Warrior','','kel_mahum_warrior','13.00','28.00',69,'male','L2Monster','Fighter',40,3784,'30.000',1458,'2.700',40,43,30,21,20,10,5991,586,1150,506,746,373,278,500,253,148,0,0,50,160,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(718,20828,'Platinum Tribe Shaman','','kel_mahum_witch_doctor','13.00','25.00',70,'male','L2Monster','Priest',40,3862,'37.500',1493,'2.700',40,43,30,21,20,10,5881,583,1445,427,780,382,278,500,253,202,0,0,50,160,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.28','false',1,0),
(719,20829,'Platinum Tribe Overlord','','kel_mahum_champion','13.00','32.00',71,'male','L2Monster','Fighter',40,3938,'42.500',1529,'3.000',40,43,30,21,20,10,8449,847,1239,529,814,390,278,500,253,147,0,0,50,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.56','false',1,1),
(720,20830,'Guardian Angel','','angel','13.50','36.50',72,'male','L2Monster','Fighter',40,4013,'34.000',1565,'3.000',40,43,30,21,20,10,0,0,1710,406,849,399,278,500,253,148,0,0,30,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(721,20831,'Seal Angel','','angel','13.50','36.50',73,'male','L2Monster','Fighter',40,4086,'42.500',1601,'3.000',40,43,30,21,20,10,0,0,1770,415,885,407,278,500,253,148,0,0,30,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(722,20832,'Zaken''s Pikeman','','skeleton_pikeman','10.00','28.00',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,2720,184,249,252,163,181,278,500,253,292,0,0,50,174,'undead_clan1',300,'Local',NULL,0,0,0,7,30,4,4,0,10,'0.21','true',1,0),
(723,20833,'Zaken''s Archer','','skeleton_archer','11.00','27.00',44,'male','L2Monster','Ranger',500,1799,'5.500',648,'2.100',40,43,30,21,20,10,3025,207,592,260,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,'Local',NULL,0,0,0,7,10,8,0,1500,10,'0.80','true',1,0),
(724,20834,'Mardian','','giant_spider','26.00','26.50',42,'male','L2Monster','Mystic',40,1660,'11.000',589,'2.100',40,43,30,21,20,10,2251,150,342,196,152,175,278,500,253,0,0,0,72,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','false',0,0),
(725,20835,'Zaken''s Seer','','liviona','15.00','28.00',45,'male','L2Monster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,2478,172,283,269,188,193,278,500,253,0,0,0,80,174,NULL,0,'Local',NULL,0,0,0,7,50,1,9,0,10,'0.34','true',1,0),
(726,20836,'Pirate Zombie','','pirates_zombie','10.00','23.00',44,'male','L2Monster','Mystic',40,1799,'11.000',648,'2.100',40,43,30,21,20,10,2832,194,341,209,176,187,317,0,289,225,0,0,11,174,'undead_clan1',300,'Local','',0,0,0,7,10,8,0,0,0,'0.74','false',1,0),
(727,20837,'Tainted Ogre','','ogre','21.00','44.00',45,'male','L2Monster','Fighter',40,1870,'11.000',677,'2.100',40,43,30,21,20,10,2565,178,577,216,188,193,200,500,182,194,0,0,22,174,'undead_clan1',300,'Local','',0,0,0,7,50,1,9,0,0,'0.69','false',0,0),
(728,20838,'Bloody Bat','','vampire_bat','10.00','33.50',45,'male','L2Monster','Mystic',40,1870,'11.000',677,'2.100',40,43,30,21,20,10,2405,167,300,262,188,193,317,0,289,0,0,0,60,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,'0.50','false',0,0),
(729,20839,'Unpleasant Humming','','unpleasant_humming','12.00','26.00',46,'male','L2Monster','Fighter',40,1943,'5.500',707,'2.100',40,43,30,21,20,10,2877,204,301,327,202,199,278,500,253,0,0,0,21,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','true',1,0),
(730,20840,'Death Flyer','','dark_horror','20.00','35.00',47,'male','L2Monster','Fighter',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,2971,213,320,287,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.37','true',1,0),
(731,20841,'Fiend Archer','','fiend_archer','17.00','55.00',48,'male','L2Monster','Ranger',500,2091,'5.500',768,'2.100',40,43,30,21,20,10,3052,223,757,296,231,212,249,500,227,0,0,0,70,174,'demonic_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.76','true',1,0),
(732,20842,'Musveren','','field_stalker','15.00','30.00',49,'male','L2Monster','Fighter',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,2910,215,361,359,247,219,278,0,253,0,0,0,70,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(733,20843,'Zaken''s Royal Guard','','skeleton_royal_guard','11.00','28.50',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3677,277,335,370,264,226,317,500,289,225,945,0,80,174,'undead_clan',300,'Local',NULL,0,20,100,7,10,8,0,0,-6,'0.52','true',1,0),
(734,20844,'Kaim Vanul','','kaim_vanul','24.00','40.00',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3279,250,405,381,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(735,20845,'Pirate''s Zombie Captain','','pirates_zombie_captain','17.00','28.00',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,4954,383,375,393,300,239,317,500,289,232,0,0,14,174,'zaken_clan',300,'Local',NULL,0,0,0,7,10,8,0,0,0,'0.76','true',1,0),
(736,20846,'Doll Blader','','doll_blader','6.00','12.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,3931,309,396,344,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,'Local','',0,0,93,7,10,8,0,0,10,'0.50','true',1,0),
(737,20847,'Vale Master','','vale_master','12.00','40.00',54,'male','L2Monster','Fighter',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,3750,299,477,354,339,254,278,500,253,0,0,0,70,174,'zaken_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.74','true',1,0),
(738,20848,'Light Bringer','','light_bringer','10.00','23.00',46,'male','L2Monster','Fighter',40,1943,'11.000',707,'2.100',40,43,30,21,20,10,2432,172,401,245,202,199,278,500,253,0,0,0,60,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','false',1,0),
(739,20849,'Light Worm','','light_worm','5.00','16.00',41,'male','L2Monster','Fighter',40,1593,'11.000',560,'2.100',40,43,30,21,20,10,1932,126,265,229,141,169,278,500,253,0,0,0,60,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.06','false',1,0),
(740,20850,'Golden Stag Lord','','golden_stag_lord','25.00','30.00',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3152,237,509,278,264,226,278,0,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.63','true',0,0),
(741,20851,'Theeder','','theeder','9.00','32.00',47,'male','L2Monster','Fighter',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,2841,204,498,253,216,206,237,500,216,0,0,0,80,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.45','true',0,0),
(742,20852,'Banshee','','banshee','9.00','23.00',60,'female','L2Monster','Mystic',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,4450,386,828,335,478,299,317,500,289,3939,0,0,80,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,'0.56','true',0,0),
(743,20853,'Kel Mahum','','kel_mahum','13.00','26.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,7824,727,942,418,619,340,317,500,289,242,0,0,50,174,'kel_mahum_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.52','true',0,0),
(744,20854,'Kel Mahum Warrior','','kel_mahum_warrior','13.00','28.00',66,'male','L2Monster','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,7686,723,1235,389,649,348,278,500,253,148,0,0,50,174,'kel_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(745,20855,'Kel Mahum Archer','','kel_mahum_archer','13.00','27.00',67,'male','L2Monster','Ranger',500,3626,'7.500',1388,'2.700',40,43,30,21,20,10,8900,848,2859,339,681,356,249,0,227,288,0,0,50,174,'kel_mahum_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.91','true',0,0),
(746,20856,'Kel Mahum Shaman','','kel_mahum_witch_doctor','13.00','25.00',68,'male','L2Monster','Priest',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,6390,617,1339,347,713,365,278,500,253,202,0,0,50,174,'kel_mahum_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.28','true',0,0),
(747,20857,'Kel Mahum Champion','','kel_mahum_champion','13.00','32.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,8149,808,1445,427,780,382,278,500,253,147,0,0,50,174,'kel_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',0,0),
(748,20858,'Angel','','angel','13.50','36.50',72,'male','L2Monster','Fighter',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,9102,925,1554,446,849,399,278,500,253,148,0,0,30,174,'tower_guard_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',0,0),
(749,20859,'Guardian Angel','','angel','13.50','36.50',72,'male','L2Monster','Fighter',40,4013,'34.000',1565,'3.000',40,43,30,21,20,10,12443,1264,1554,446,849,399,278,500,253,148,0,0,30,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(750,20860,'Seal Angel','','angel','13.50','36.50',73,'male','L2Monster','Fighter',40,4086,'42.500',1601,'3.000',40,43,30,21,20,10,13949,1435,1330,552,885,407,278,500,253,148,0,0,30,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(751,20861,'Oel Mahum Champion','','oel_mahum_champion','23.00','61.00',56,'male','L2Monster','Fighter',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,5533,454,777,301,382,269,278,500,253,127,0,0,67,174,'oel_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(752,20862,'Death Lord','','death_lord','21.00','40.00',75,'male','L2Monster','Fighter',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,7774,820,1720,475,957,425,278,0,253,78,0,0,40,174,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',0,0),
(753,20919,'Maille Lizardman','','virud_lizardman','10.00','23.00',20,'male','L2Monster','Fighter',40,541,'1.250',213,'1.200',40,43,30,21,20,10,641,28,57,94,23,76,278,0,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',1,0),
(754,20920,'Maille Lizardman Scout','','virud_lizardman_scout','10.00','22.00',22,'male','L2Monster','Ranger',500,611,'1.750',242,'1.500',40,43,30,21,20,10,1187,56,153,102,28,83,249,0,227,2507,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.72','true',1,0),
(755,20921,'Maille Lizardman Guard','','virud_lizardman','10.00','23.00',24,'male','L2Monster','Fighter',40,687,'1.750',272,'1.500',40,43,30,21,20,10,858,42,81,111,34,90,278,500,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',1,0),
(756,20922,'Maille Lizardman Warrior','','virud_lizardman_warrior','12.00','30.00',26,'male','L2Monster','Fighter',40,770,'1.750',303,'1.500',40,43,30,21,20,10,951,48,96,120,41,98,278,0,253,16,0,0,52,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.59','true',1,0),
(757,20923,'Maille Lizardman Shaman','','virud_lizardman_shaman','10.00','29.00',28,'male','L2Monster','Priest',40,859,'1.750',334,'1.500',40,43,30,21,20,10,1392,74,113,130,49,106,278,0,253,7,0,0,43,120,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','true',1,0),
(758,20924,'Maille Lizardman Matriarch','','virud_lizardman_matriarch','13.00','37.00',30,'male','L2Monster','Fighter',40,954,'1.750',365,'1.500',40,43,30,21,20,10,1708,94,132,140,58,114,278,500,253,69,627,0,56,130,'lizardman_clan',300,'Local','',0,20,59,7,50,1,9,0,-6,'0.65','true',1,0),
(759,20925,'Giant Araneid','','giant_spider','26.00','26.50',24,'male','L2Monster','Mystic',40,687,'1.750',272,'1.500',40,43,30,21,20,10,875,44,81,94,34,90,278,0,253,0,0,0,72,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.26','true',1,0),
(760,20926,'Poison Araneid','','poison_spider','27.00','25.50',25,'male','L2Monster','Mystic',40,728,'1.750',287,'1.500',40,43,30,21,20,10,1012,50,88,98,37,94,278,0,253,0,0,0,60,140,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.65','true',1,0),
(761,20927,'King of the Araneid','','giant_spider_50_bi','39.00','38.00',27,'male','L2Monster','Mystic',40,813,'1.750',318,'1.500',40,43,30,21,20,10,1453,74,104,106,45,102,278,500,253,0,0,0,72,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.26','true',1,0),
(762,20928,'Hatu Weird Bee','','giant_bee','8.00','24.50',30,'male','L2Monster','Fighter',40,954,'1.750',365,'1.500',40,43,30,21,20,10,1468,80,132,140,58,114,278,500,253,0,0,0,90,120,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.50','true',1,0),
(763,20929,'Hatu Dire Wolf','','dire_wolf','13.00','11.00',32,'male','L2Monster','Fighter',40,1056,'2.250',397,'1.800',40,43,30,21,20,10,1393,78,154,151,69,123,278,0,253,0,0,0,24,110,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.39','true',1,0),
(764,20930,'Hatu Brown Bear','','grizzly','21.00','40.00',34,'male','L2Monster','Fighter',40,1164,'2.250',430,'1.800',40,43,30,21,20,10,2195,128,178,163,82,132,278,500,253,0,0,0,40,143,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.34','true',1,0),
(765,20931,'Hatu Onyx Beast','','onyx_beast','14.00','14.50',36,'male','L2Monster','Fighter',40,1279,'2.250',463,'1.800',40,43,30,21,20,10,2035,124,206,175,96,142,278,0,253,0,0,0,30,174,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.24','true',1,0),
(766,20932,'Hatu Crimson Bear','','crimson_bear','19.00','36.00',38,'male','L2Monster','Fighter',40,1400,'2.250',497,'1.800',40,43,30,21,20,10,2688,168,238,188,112,153,278,0,253,0,0,0,37,174,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','true',1,0),
(767,20933,'Hatu Windsus','','giant_wild_hog','25.00','27.00',40,'male','L2Monster','Fighter',40,1527,'2.250',531,'1.800',40,43,30,21,20,10,3080,198,273,201,131,164,278,500,253,0,0,0,35,174,'hatu_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.54','true',1,0),
(768,20934,'Wasp Worker','','giant_bee_bi','8.00','32.00',35,'male','L2Monster','Fighter',40,1220,'2.250',446,'1.800',40,43,30,21,20,10,1651,98,192,144,89,137,278,0,253,0,0,0,90,174,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.50','true',1,0),
(769,20935,'Wasp Leader','','giant_bee_100_bi','16.00','49.00',37,'male','L2Monster','Fighter',40,1338,'2.250',480,'1.800',40,43,30,21,20,10,1809,112,222,154,104,147,278,500,253,0,0,0,90,174,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.50','true',1,1),
(770,20936,'Tanor Silenos','','heltor_silenos','13.00','29.00',40,'male','L2Monster','Fighter',40,1527,'2.250',531,'1.800',40,43,30,21,20,10,3443,222,273,201,131,164,278,0,253,88,0,0,34,174,'silenos_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,'0.46','true',0,1),
(771,20937,'Tanor Silenos Grunt','','heltor_silenos','13.00','29.00',42,'male','L2Monster','Fighter',40,1660,'2.750',589,'2.100',40,43,30,21,20,10,4498,300,311,215,152,175,278,0,253,158,18,0,34,174,'silenos_clan',300,'Local','',0,20,82,7,50,1,9,0,-6,'0.46','true',0,0),
(772,20938,'Tanor Silenos Scout','','heltor_silenos','13.00','29.00',44,'male','L2Minion','Ranger',40,1799,'2.750',648,'2.100',40,43,30,21,20,10,4937,338,354,230,176,187,278,0,253,5,0,0,34,174,'silenos_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,'0.46','false',0,0),
(773,20939,'Tanor Silenos Warrior','','heltor_silenos_warrior','13.00','31.00',46,'male','L2Monster','Fighter',40,1943,'2.750',707,'2.100',40,43,30,21,20,10,5504,390,401,245,202,199,278,500,253,160,0,0,36,174,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.39','true',1,0),
(774,20940,'Tanor Silenos Shaman','','heltor_silenos_shaman','13.00','32.00',48,'male','L2Monster','Priest',40,2091,'2.750',768,'2.100',40,43,30,21,20,10,6707,490,453,261,231,212,278,0,253,9,0,0,29,174,'silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.22','true',0,0),
(775,20941,'Tanor Silenos Chieftain','','heltor_silenos_chieftain','13.00','31.50',50,'male','L2Monster','Fighter',40,2245,'2.750',830,'2.100',40,43,30,21,20,10,6503,490,509,278,264,226,278,500,253,75,0,0,27,174,'silenos_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,0,'0.39','true',1,1),
(776,20942,'Nightmare Guide','','harpy','10.00','42.00',43,'female','L2Monster','Fighter',40,1728,'2.750',618,'2.100',40,43,30,21,20,10,3282,222,332,189,163,181,278,0,253,0,0,0,60,174,'',0,'DRIVER','',0,0,0,7,50,1,9,0,10,'0.65','true',0,0),
(777,20943,'Nightmare Keeper','','harpy','10.00','42.00',45,'female','L2Monster','Fighter',40,1870,'2.750',677,'2.100',40,43,30,21,20,10,4721,328,377,202,188,193,278,0,253,0,0,0,60,174,'',0,'DRIVER','',0,0,0,7,50,1,9,0,10,'0.65','true',0,0),
(778,20944,'Nightmare Lord','','succubus_100_bi','20.00','75.00',47,'female','L2Monster','Fighter',40,2016,'2.750',738,'2.100',40,43,30,21,20,10,4000,286,427,215,216,206,278,500,253,0,0,0,60,174,'',0,'DRIVER','',0,0,0,7,50,1,9,0,10,'0.84','true',1,1),
(779,20945,'Cadeine','','hobgoblin','12.00','24.00',50,'male','L2Monster','Fighter',40,2245,'2.750',830,'2.100',40,43,30,21,20,10,4483,338,509,278,264,226,278,0,253,127,625,0,45,174,'green_clan',300,'Local','',0,20,100,7,50,1,9,0,-6,'0.41','true',0,0),
(780,20946,'Sanhidro','','troll','21.00','35.00',52,'male','L2Monster','Fighter',40,2402,'3.250',892,'2.400',40,43,30,21,20,10,6896,534,570,295,300,239,278,0,253,0,0,0,55,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.61','true',0,0),
(781,20947,'Connabi','','bugbear','17.00','35.00',54,'male','L2Monster','Fighter',40,2562,'3.250',955,'2.400',40,43,30,21,20,10,7437,592,636,313,339,254,278,0,253,88,0,0,55,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(782,20948,'Bartal','','liviona','15.00','28.00',56,'male','L2Monster','Fighter',40,2724,'3.250',1019,'2.400',40,43,30,21,20,10,7385,606,706,331,382,269,278,0,253,0,0,0,80,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.34','true',0,0),
(783,20949,'Luminun','','twin_headed_giant','17.00','39.00',58,'male','L2Monster','Fighter',40,2889,'3.250',1084,'2.400',40,43,30,21,20,10,8700,734,781,349,428,284,278,0,253,157,0,0,45,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',0,0),
(784,20950,'Innersen','','king_bugbear','15.00','40.00',60,'male','L2Monster','Fighter',40,3054,'3.250',1150,'2.400',40,43,30,21,20,10,9365,812,860,368,478,299,278,500,253,160,0,0,55,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,1),
(785,20951,'Pobby''s Maid','','manadragora','14.00','17.80',53,'female','L2Monster','Fighter',40,2481,'3.250',923,'2.400',40,43,30,21,20,10,5037,396,602,258,319,247,278,0,253,0,0,0,80,174,'green_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,10,'0.28','true',0,0),
(786,20952,'Pobby Escort','','mandragora_b','12.00','25.50',55,'female','L2Monster','Fighter',40,2643,'3.250',987,'2.400',40,43,30,21,20,10,9101,734,670,273,360,261,278,0,253,0,0,0,80,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.13','true',0,0),
(787,20953,'Pobby','','mandragora_a','15.00','26.00',57,'female','L2Monster','Fighter',40,2806,'3.250',1052,'2.400',40,43,30,21,20,10,8452,702,743,289,405,276,278,500,253,0,0,0,80,174,'green_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.20','true',1,1),
(788,20954,'Hungered Corpse','','skeleton','11.00','25.00',60,'male','L2Monster','Fighter',40,3054,'3.250',1150,'2.400',40,43,30,21,20,10,9985,866,860,368,478,299,278,0,253,123,945,0,60,180,'bloody_clan',300,'Local','',0,20,123,7,50,1,9,0,-6,'0.30','false',0,0),
(789,20955,'Ghostly Warrior','','skeleton_pikeman','10.00','28.00',62,'male','L2Monster','Fighter',40,3219,'3.750',1217,'2.700',40,43,30,21,20,10,10662,950,944,388,532,315,278,0,253,299,0,0,50,180,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.21','false',0,0),
(790,20956,'Past Knight','','skeleton_knight','10.00','25.00',64,'male','L2Monster','Fighter',40,3384,'3.750',1285,'2.700',40,43,30,21,20,10,11588,1060,1031,408,589,331,278,500,253,150,103,0,40,174,'bloody_clan',300,'Local','',0,20,133,7,50,1,9,0,-6,'0.17','false',1,0),
(791,20957,'Nihil Invader','','skeleton_royal_guard','11.00','28.50',66,'male','L2Monster','Fighter',40,3546,'3.750',1353,'2.700',40,43,30,21,20,10,12082,1138,1123,428,649,348,278,0,253,946,945,0,80,185,'bloody_clan',300,'Local','',0,20,138,7,50,1,9,0,-6,'0.52','false',0,0),
(792,20958,'Death Agent','','death_blader','15.00','45.00',68,'male','L2Monster','Fighter',40,3706,'3.750',1423,'2.700',40,43,30,21,20,10,9018,872,1217,449,713,365,278,0,253,1472,0,0,100,195,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','false',0,0),
(793,20959,'Dark Guard','','headless_knight','21.00','31.00',70,'male','L2Monster','Fighter',40,3862,'3.750',1493,'2.700',40,43,30,21,20,10,13863,1374,1314,470,780,382,278,500,253,124,0,0,70,170,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(794,20960,'Bloody Ghost','','succubus','10.00','36.00',64,'female','L2Monster','Mystic',40,3384,'3.750',1285,'2.700',40,43,30,21,20,10,7988,732,1031,347,589,331,278,0,253,0,0,0,60,175,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.84','false',0,0),
(795,20961,'Bloody Knight','','doll_blader','6.00','12.00',65,'male','L2Monster','Fighter',40,3465,'3.750',1319,'2.700',40,43,30,21,20,10,11719,1088,1077,355,619,340,278,0,253,5129,5129,0,22,175,'bloody_clan',300,'Local','',0,0,119,7,50,1,9,0,10,'0.50','false',0,0),
(796,20962,'Bloody Priest','','bloody_queen','14.00','40.00',66,'female','L2Monster','Priest',40,3546,'3.750',1353,'2.700',40,43,30,21,20,10,13045,1228,1123,364,649,348,278,0,253,0,0,0,80,185,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.50','false',0,0),
(797,20963,'Bloody Lord','','banshee','9.00','23.00',68,'female','L2Monster','Fighter',40,3706,'3.750',1423,'2.700',40,43,30,21,20,10,9382,906,1217,382,713,365,278,500,253,3939,0,0,80,180,'bloody_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(798,20964,'Huge Footmark','','stone_golem','20.00','31.00',70,'male','L2Monster','Mystic',40,3862,'3.750',1493,'2.700',40,43,30,21,20,10,13513,1340,1314,470,780,382,278,0,253,0,0,0,23,23,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',0,0),
(799,20965,'Chimera Piece','','saber_toothed_tiger','34.00','28.00',72,'male','L2Monster','Fighter',40,4013,'4.250',1565,'3.000',40,43,30,21,20,10,14379,1460,1413,491,849,399,278,0,253,0,0,0,60,174,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','true',1,0),
(800,20966,'Black Shadow','','drake','30.00','100.00',74,'male','L2Monster','Mystic',40,4158,'4.250',1637,'3.000',40,43,30,21,20,10,15493,1616,1513,512,921,416,278,500,253,0,0,0,70,185,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.84','true',1,0),
(801,20967,'Past Creature','','gamlin','11.00','32.00',76,'male','L2Monster','Fighter',40,4297,'4.250',1710,'3.000',40,43,30,21,20,10,16021,1712,1614,534,994,433,278,0,253,0,0,0,80,170,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',0,0),
(802,20968,'Nonexistent Man','','susceptor','20.00','35.00',78,'male','L2Monster','Fighter',40,4428,'4.250',1784,'3.000',40,43,30,21,20,10,15583,1706,1715,555,1069,451,278,0,253,0,0,0,27,150,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',0,0),
(803,20969,'Giant''s Shadow','','lesser_giant_shooter','21.00','44.00',79,'male','L2Monster','Fighter',500,4490,'4.250',1821,'3.000',40,43,30,21,20,10,13043,1446,3921,566,1107,459,249,500,227,4028,0,0,80,190,'giant_clan',300,'Local',NULL,0,0,0,7,10,8,0,1500,0,'0.63','true',1,0),
(804,20970,'Soldier of Ancient Times','','lesser_giant','21.00','44.00',73,'male','L2Monster','Fighter',40,4086,'4.250',1601,'3.000',40,43,30,21,20,10,10913,1122,1463,426,885,407,278,0,253,3937,0,0,15,190,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.58','true',0,0),
(805,20971,'Warrior of Ancient Times','','lesser_giant','21.00','44.00',75,'male','L2Monster','Fighter',40,4229,'4.250',1673,'3.000',40,43,30,21,20,10,15602,1646,1563,445,957,425,278,0,253,3937,0,0,15,185,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.58','true',0,0),
(806,20972,'Shaman of Ancient Times','','lesser_giant_mage','21.00','44.00',75,'male','L2Monster','Mystic',40,4229,'4.250',1673,'3.000',40,43,30,21,20,10,10970,1158,1563,445,957,425,278,0,253,3938,0,0,15,195,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','true',0,0),
(807,20973,'Forgotten Ancient People','','lesser_giant_mage','21.00','44.00',77,'male','L2Monster','Mystic',40,4364,'4.250',1747,'3.000',40,43,30,21,20,10,16958,1836,1664,463,1031,442,278,500,253,3938,0,0,15,185,'giant_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','true',1,0),
(808,20974,'Spiteful Soul Leader','','skeleton_royal_guard_bi','16.00','44.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,11772,1094,1077,418,619,340,278,0,253,946,945,0,80,174,'undead_clan',300,'Magister','',0,20,135,7,30,4,4,0,-6,'0.52','true',1,1),
(809,20975,'Spiteful Soul Wizard','','elf_ghost_50_bi','10.00','32.00',63,'male','L2Monster','Mystic',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,10499,948,987,398,560,323,278,0,253,0,0,0,80,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.41','true',0,0),
(810,20976,'Spiteful Soul Fighter','','human_ghost_50_bi','12.00','33.00',62,'male','L2Monster','Mystic',40,3219,'7.500',1217,'2.700',40,43,30,21,20,10,8911,794,944,388,532,315,278,0,253,0,0,0,80,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.39','true',0,0),
(811,20977,'Elmoradan''s Lady','','banshee_50_bi','13.50','38.00',65,'female','L2Monster','Mystic',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,7513,698,979,460,619,340,278,500,253,3939,0,0,80,160,'tower_ghost_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,'0.56','false',1,1),
(812,20978,'Elmoradan''s Archer Escort','','skeleton_archer','11.00','27.00',64,'male','L2Monster','Ranger',500,3384,'15.000',1285,'2.700',40,43,30,21,20,10,7470,684,2522,315,589,331,249,0,227,284,0,0,40,140,'tower_ghost_clan',400,'Magister',NULL,0,0,0,7,10,8,0,1500,10,'0.80','false',0,0),
(813,20979,'Elmoradan''s Maid','','doll_blader','6.00','12.00',64,'male','L2Monster','Fighter',40,3384,'15.000',1285,'2.700',40,43,30,21,20,10,7141,654,1135,371,589,331,278,0,253,5129,5129,0,22,170,'tower_ghost_clan',400,'Magister',NULL,0,0,137,7,30,4,4,0,0,'0.50','false',0,0),
(814,20980,'Hallate''s Follower Mul','','vale_master','12.00','40.00',68,'male','L2Monster','Fighter',40,3706,'15.000',1423,'2.700',40,43,30,21,20,10,7606,735,1339,408,713,365,278,500,253,210,0,0,70,170,'hallate_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,'0.74','false',1,1),
(815,20981,'Mul''s Wizard','','kaim_vanul_50_bi','36.00','60.00',67,'male','L2Monster','Mystic',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,7564,720,1063,483,681,356,278,0,253,0,0,0,37,160,'hallate_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,'0.45','false',0,0),
(816,20982,'Mul''s Knight','','dre_vanul_100_bi','28.00','75.00',67,'male','L2Monster','Fighter',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,6676,636,1126,399,681,356,317,0,289,0,0,0,80,143,'hallate_clan',400,'Magister',NULL,0,0,0,7,10,8,0,0,0,'0.35','false',0,0),
(817,20983,'Binder','','kel_mahum_champion_50_bi','19.00','48.00',73,'male','L2Monster','Fighter',40,4086,'17.000',1601,'3.000',40,43,30,21,20,10,10342,1064,1609,456,885,407,278,500,253,147,0,0,50,170,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(818,20984,'Bound Warrior','','kel_mahum_warrior','13.00','28.00',72,'male','L2Monster','Fighter',40,4013,'17.000',1565,'3.000',40,43,30,21,20,10,9719,987,1554,446,849,399,278,0,253,148,0,0,50,160,'tower_guard_clan',50,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,1),
(819,20985,'Bound Archer','','kel_mahum_archer','13.00','27.00',72,'male','L2Monster','Ranger',500,4013,'17.000',1565,'3.000',40,43,30,21,20,10,9647,980,3454,379,849,399,249,0,227,288,0,0,50,170,'tower_guard_clan',50,'Magister','',0,0,0,7,10,8,0,1500,10,'0.91','false',0,0),
(820,20986,'Sairon','','doll_blader_50_bi','9.00','20.50',54,'male','L2Monster','Fighter',40,2562,'13.000',955,'2.400',40,43,30,21,20,10,5524,440,636,313,339,254,278,500,253,5129,5129,0,22,174,'demonic_clan',300,'Local','',0,0,112,7,30,4,4,0,0,'0.50','false',1,1),
(821,20987,'Sairon''s Doll','','doll_blader','6.00','12.00',53,'male','L2Monster','Fighter',40,2481,'13.000',923,'2.400',40,43,30,21,20,10,5025,395,602,304,319,247,278,0,253,5129,5129,0,22,174,NULL,0,'Local',NULL,0,0,110,7,30,4,4,0,0,'0.50','false',0,0),
(822,20988,'Sairon''s Puppet','','doll_blader','6.00','12.00',53,'male','L2Monster','Fighter',40,2481,'13.000',923,'2.400',40,43,30,21,20,10,5527,434,602,304,319,247,278,0,253,5129,5129,0,22,174,NULL,0,'Local',NULL,0,0,110,7,30,4,4,0,0,'0.50','false',0,0),
(823,20989,'Lageos','','marsh_stakato_drone_50_bi','13.00','37.00',38,'male','L2Monster','Fighter',40,1400,'4.500',497,'1.800',40,43,30,21,20,10,2749,171,238,188,112,153,278,0,253,182,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(824,20990,'Pageos','','marsh_stakato_soldier','10.00','25.00',38,'male','L2Monster','Fighter',40,1400,'4.500',497,'1.800',40,43,30,21,20,10,2609,163,238,188,112,153,278,0,253,128,0,0,30,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.74','true',0,0),
(825,20991,'Swamp Tribe','','farhite_50_bi','24.00','48.00',45,'male','L2Monster','Fighter',40,1870,'11.000',677,'2.100',40,43,30,21,20,10,5139,357,377,238,188,193,278,500,253,5131,0,0,15,174,'croc_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(826,20992,'Swamp Alligator','','crokian','18.00','29.00',44,'male','L2Monster','Fighter',40,1799,'11.000',648,'2.100',40,43,30,21,20,10,4600,315,354,230,176,187,278,0,253,5128,0,0,18,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.78','false',0,0),
(827,20993,'Swamp Warrior','','dailaon','20.00','28.00',44,'male','L2Monster','Fighter',500,1799,'11.000',648,'2.100',40,43,30,21,20,10,4881,334,788,230,176,187,249,0,227,5127,0,0,18,174,'',0,'Magister','',0,0,0,7,10,8,0,1500,0,'0.91','false',0,0),
(828,20994,'Garden Guard Leader','','doll_master_50_bi','30.00','63.00',50,'male','L2Monster','Fighter',40,2245,'11.000',830,'2.100',40,43,30,21,20,10,6194,466,560,253,264,226,278,500,253,0,0,0,80,174,'theeder_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,1),
(829,20995,'Garden Guard','','theeder','9.00','32.00',48,'male','L2Monster','Fighter',40,2091,'11.000',768,'2.100',40,43,30,21,20,10,4222,308,453,261,231,212,278,0,253,94,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(830,20996,'Spiteful Ghost of Ruins','','zombie','13.00','21.00',50,'male','L2Monster','Mystic',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','false',1,0),
(831,20997,'Soldier of Grief','','unpleasant_humming','12.00','26.00',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3782,288,593,260,281,232,278,0,253,0,0,0,21,150,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.59','false',1,0),
(832,20998,'Cruel Punisher','','hungry_spirit','13.00','40.00',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,4168,322,518,324,300,239,278,0,253,0,0,0,15,120,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','false',1,0),
(833,20999,'Roving Soul','','skeleton','11.00','25.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,75,0,0,60,160,'undead_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','false',1,0),
(834,21000,'Soul of Ruins','','human_ghost','8.00','22.00',54,'male','L2Monster','Mystic',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,4325,345,578,344,339,254,278,500,253,0,0,0,80,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(835,21001,'Wretched Archer','','skeleton_archer','11.00','27.00',55,'male','L2Monster','Ranger',500,2643,'6.500',987,'2.400',40,43,30,21,20,10,5856,473,1639,292,360,261,249,0,227,282,0,0,40,174,'undead_clan',300,'Magister','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(836,21002,'Doom Scout','','skeleton_royal_guard','11.00','28.50',56,'male','L2Monster','Fighter',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,5163,424,679,301,382,269,317,500,289,242,2496,0,80,174,'doom_clan',300,'Magister','',0,20,114,7,10,8,0,0,-6,'0.52','true',1,0),
(837,21003,'Grave Lich','','liviona','15.00','28.00',57,'male','L2Monster','Fighter',40,2806,'6.500',1052,'2.400',40,43,30,21,20,10,4725,393,675,374,405,276,278,0,253,0,0,0,80,174,'undead_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(838,21004,'Dismal Pole','','hanged_man_ripper','35.00','80.00',58,'male','L2Monster','Fighter',80,2889,'6.500',1084,'2.400',40,43,30,21,20,10,5239,443,828,384,428,284,237,500,216,0,0,0,55,174,'undead_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0);
INSERT INTO `npc` VALUES
(839,21005,'Grave Predator','','devastator','35.00','35.00',59,'male','L2Monster','Fighter',40,2971,'6.500',1117,'2.400',40,43,30,21,20,10,5732,490,902,326,453,291,278,500,253,0,0,0,25,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(840,21006,'Doom Servant','','hungry_spirit','13.00','40.00',60,'male','L2Monster','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,5447,473,946,335,478,299,278,500,253,0,0,0,15,174,'doom_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,'0.45','true',1,0),
(841,21007,'Doom Guard','','hungry_spirit','13.00','40.00',61,'male','L2Monster','Fighter',40,3137,'7.500',1184,'2.700',40,43,30,21,20,10,5844,514,992,344,505,307,278,0,253,0,0,0,15,174,'doom_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,'0.45','true',1,0),
(842,21008,'Doom Archer','','skeleton_archer','11.00','27.00',62,'male','L2Monster','Ranger',500,3219,'7.500',1217,'2.700',40,43,30,21,20,10,7471,666,2308,353,532,315,249,500,227,286,0,0,40,174,'doom_clan',300,'Magister','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(843,21009,'Doom Trooper','','skeleton_pikeman','10.00','28.00',63,'male','L2Monster','Fighter',80,3302,'7.500',1251,'2.700',40,43,30,21,20,10,7966,719,1267,362,560,323,237,0,216,301,0,0,50,174,'doom_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.21','true',1,0),
(844,21010,'Doom Warrior','','skeleton_knight','10.00','25.00',64,'male','L2Monster','Fighter',40,3384,'7.500',1285,'2.700',40,43,30,21,20,10,6380,584,993,371,589,331,317,0,289,71,0,0,40,174,'doom_clan',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.17','true',1,0),
(845,21011,'Ol Mahum Van Grunt','','ol_mahum','13.50','25.00',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1308,72,132,140,58,114,278,0,253,5,0,0,50,150,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(846,21012,'Magical Eye','','magical_weaver','11.00','20.00',31,'male','L2Monster','Mystic',40,1004,'4.500',381,'1.800',40,43,30,21,20,10,1736,96,129,161,64,118,278,500,253,0,0,0,90,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(847,21013,'Ol Mahum Van Archer','','ol_mahum_archer','14.00','25.00',32,'male','L2Monster','Ranger',500,1056,'4.500',397,'1.800',40,43,30,21,20,10,1920,108,376,138,69,123,249,0,227,273,0,0,50,150,'wererat_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','true',1,0),
(848,21014,'Lesser Warlike Tyrant','','grave','15.00','29.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1987,114,151,173,75,128,278,500,253,0,0,0,70,150,'kinpin_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(849,21015,'Ol Mahum Van Leader','','ol_mahum_champion','14.00','27.00',34,'male','L2Monster','Fighter',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,2040,119,196,148,82,132,278,500,253,67,0,0,50,150,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.63','true',1,0),
(850,21016,'Warlike Tyrant','','grave','15.00','29.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,2192,130,211,154,89,137,278,0,253,0,0,0,70,174,'kinpin_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(851,21017,'Fallen Orc','','ketra_orc','12.00','29.00',55,'male','L2Monster','Fighter',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,4399,355,737,292,360,261,278,0,253,127,0,0,45,174,'fallen_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(852,21018,'Ancient Gargoyle','','hunter_gargoyle','25.00','65.00',56,'male','L2Monster','Fighter',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,5536,455,642,364,382,269,278,500,253,0,0,0,100,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(853,21019,'Fallen Orc Archer','','ketra_orc_archer','12.00','27.00',57,'male','L2Monster','Ranger',500,2806,'6.500',1052,'2.400',40,43,30,21,20,10,6093,506,1501,374,405,276,249,0,227,279,0,0,45,174,'fallen_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.91','true',1,0),
(854,21020,'Fallen Orc Shaman','','ketra_orc_shaman','10.00','23.00',58,'male','L2Monster','Priest',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,6898,583,710,384,428,284,278,0,253,9,0,0,10,174,'fallen_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.34','true',1,0),
(855,21021,'Sharp Talon Tiger','','saber_toothed_tiger','34.00','28.00',59,'male','L2Monster','Fighter',40,2971,'6.500',1117,'2.400',40,43,30,21,20,10,6353,543,902,277,453,291,278,500,253,0,0,0,60,174,'fallen_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.45','true',1,0),
(856,21022,'Fallen Orc Captain','','ketra_orc_warrior','12.00','24.00',60,'male','L2Monster','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,6462,561,946,285,478,299,278,500,253,160,0,0,36,174,'fallen_clan',300,'DRIVER','',0,0,0,7,50,1,9,0,10,'0.54','true',1,0),
(857,21023,'Sobbing Wind','','sylph','11.00','35.00',26,'female','L2Monster','Mystic',40,770,'3.500',303,'1.500',40,43,30,21,20,10,1056,53,87,132,41,98,278,0,253,0,0,0,60,150,'elemental2_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.56','true',1,0),
(858,21024,'Babbling Wind','','sylph','11.00','35.00',27,'female','L2Monster','Mystic',40,813,'3.500',318,'1.500',40,43,30,21,20,10,1113,57,94,138,45,102,278,0,253,0,0,0,60,150,'elemental2_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.56','true',1,0),
(859,21025,'Giggling Wind','','sylph','11.00','35.00',28,'female','L2Monster','Mystic',40,859,'3.500',334,'1.500',40,43,30,21,20,10,1178,62,102,143,49,106,278,0,253,0,0,0,60,150,'elemental2_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.56','true',1,0),
(860,21026,'Singing Wind','','sylph','11.00','35.00',29,'female','L2Monster','Mystic',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1268,68,111,149,53,110,278,500,253,0,0,0,60,150,'elemental2_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.56','true',1,0),
(861,21034,'Ogre','','ogre','21.00','44.00',38,'male','L2Monster','Fighter',40,1400,'2.250',497,'1.800',40,43,30,21,20,10,3594,224,440,141,112,153,200,500,182,98,0,0,22,174,'lizardman_clan1',300,'Local','',0,0,0,7,50,1,9,0,0,'0.69','true',1,0),
(862,21035,'Catherok','','marsh_stakato_soldier','10.00','25.00',42,'male','L2Monster','Fighter',40,1660,'11.000',589,'2.100',40,43,30,21,20,10,2275,151,342,196,152,175,278,500,253,127,0,0,30,174,'beast_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(863,21036,'Shindebarn','','magical_weaver','11.00','20.00',44,'male','L2Monster','Mystic',40,1799,'11.000',648,'2.100',40,43,30,21,20,10,2869,196,390,209,176,187,278,500,253,0,0,0,90,174,'porta_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(864,21037,'Ossiud','','field_stalker','15.00','30.00',47,'male','L2Monster','Fighter',40,2016,'11.000',738,'2.100',40,43,30,21,20,10,3326,238,469,230,216,206,278,500,253,0,0,0,70,174,'torfe_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.41','false',1,0),
(865,21038,'Liangma','','will_o_wisp','13.00','22.00',49,'male','L2Monster','Mystic',40,2168,'11.000',799,'2.100',40,43,30,21,20,10,2926,216,529,245,247,219,278,500,253,0,0,0,80,174,'undead_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.10','false',1,0),
(866,21039,'Snipe Cohort','','onyx_beast','14.00','14.50',43,'male','L2Monster','Fighter',40,1728,'11.000',618,'2.100',40,43,30,21,20,10,3041,205,302,245,163,181,278,0,253,0,0,0,30,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.24','false',0,0),
(867,21040,'Soldier of Darkness','','death_knight','12.00','30.00',49,'male','L2Minion','Fighter',40,2168,'11.000',799,'2.100',40,43,30,21,20,10,5077,375,581,223,247,219,278,0,253,127,0,0,27,174,'',0,'DRIVER','',0,0,0,7,50,1,9,0,0,'0.71','false',0,0),
(868,21058,'Beast Lord','','saber_toothed_tiger','34.00','28.00',60,'male','L2Monster','Fighter',40,3054,'13.000',1150,'2.400',40,43,30,21,20,10,7880,684,946,335,478,299,278,500,253,0,0,0,60,174,'beast_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.45','false',1,0),
(869,21059,'Beast Guardian','','onyx_beast','14.00','14.50',59,'male','L2Monster','Fighter',40,2971,'13.000',1117,'2.400',40,43,30,21,20,10,6289,537,902,326,453,291,278,0,253,0,0,0,30,174,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.24','false',0,0),
(870,21060,'Beast Seer','','field_stalker','15.00','30.00',59,'male','L2Monster','Fighter',40,2971,'13.000',1117,'2.400',40,43,30,21,20,10,6289,537,745,395,453,291,278,0,253,0,0,0,70,174,'beast_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.41','false',0,0),
(871,21061,'Hallate''s Guardian','','kaim_vanul','24.00','40.00',69,'male','L2Monster','Fighter',40,3784,'30.000',1458,'2.700',40,43,30,21,20,10,6396,625,1392,418,746,373,278,500,253,0,0,0,37,174,'hallate_clan',400,'Magister',NULL,0,0,0,7,50,1,9,0,0,'0.45','false',1,0),
(872,21062,'Messenger Angel','','angel','13.50','36.50',70,'male','L2Monster','Fighter',40,3862,'30.000',1493,'2.700',40,43,30,21,20,10,0,0,1590,388,780,382,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.52','false',0,0),
(873,21063,'Messenger Angel','','angel','13.50','36.50',70,'male','L2Monster','Fighter',40,3862,'30.000',1493,'2.700',40,43,30,21,20,10,13079,1297,1194,517,780,382,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(874,21064,'Platinum Guardian Archer','','kel_mahum_archer','13.00','27.00',71,'male','L2Monster','Ranger',500,3938,'34.000',1529,'3.000',40,43,30,21,20,10,8009,803,3332,371,814,390,249,500,227,288,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,10,8,0,1500,10,'0.91','false',1,0),
(875,21065,'Platinum Guardian Warrior','','kel_mahum_warrior','13.00','28.00',72,'male','L2Monster','Fighter',40,4013,'42.500',1565,'3.000',40,43,30,21,20,10,6036,613,1284,540,849,399,278,500,253,148,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.34','false',1,0),
(876,21066,'Platinum Guardian Shaman','','kel_mahum_witch_doctor','13.00','25.00',73,'male','L2Monster','Priest',40,4086,'42.500',1601,'3.000',40,43,30,21,20,10,6529,672,1609,456,885,407,278,500,253,202,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.28','false',1,0),
(877,21067,'Guardian Archangel','','angel','13.50','36.50',74,'male','L2Monster','Fighter',40,4158,'42.500',1637,'3.000',40,43,30,21,20,10,0,0,1831,423,921,416,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.52','false',0,1),
(878,21068,'Guardian Archangel','','angel','13.50','36.50',74,'male','L2Monster','Fighter',40,4158,'42.500',1637,'3.000',40,43,30,21,20,10,14206,1481,1664,466,921,416,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.52','false',1,1),
(879,21069,'Platinum Guardian Prefect','','kel_mahum_champion','13.00','32.00',74,'male','L2Monster','Fighter',40,4158,'42.500',1637,'3.000',40,43,30,21,20,10,8909,928,1831,423,921,416,278,500,253,147,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(880,21070,'Seal Archangel','','angel','13.50','36.50',75,'male','L2Monster','Fighter',40,4229,'42.500',1673,'3.000',40,43,30,21,20,10,0,0,1892,432,957,425,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.52','false',0,1),
(881,21071,'Seal Archangel','','angel','13.50','36.50',75,'male','L2Monster','Fighter',40,4229,'42.500',1673,'3.000',40,43,30,21,20,10,14733,1554,1421,575,957,425,278,500,253,148,0,0,30,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.52','false',1,1),
(882,21072,'Platinum Guardian Chief','','kel_mahum_witch_doctor','13.00','25.00',75,'male','L2Monster','Fighter',40,4229,'42.500',1673,'3.000',40,43,30,21,20,10,6752,712,1720,475,957,425,278,500,253,202,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.28','false',1,1),
(883,21073,'Guardian Warrior of Elmoreden','','skeleton_knight','10.00','25.00',64,'male','L2Monster','Fighter',40,3384,'15.000',1285,'2.700',40,43,30,21,20,10,7040,644,1135,371,589,331,278,0,253,84,0,0,40,174,'tower_ghost_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.17','false',0,0),
(884,21074,'Bound Shaman','','kel_mahum_witch_doctor','13.00','25.00',72,'male','L2Monster','Priest',40,4013,'17.000',1565,'3.000',40,43,30,21,20,10,9651,980,1284,540,849,399,278,0,253,202,0,0,50,174,'tower_guard_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.28','false',0,0),
(885,21075,'Slaughter Bathin','','death_knight','12.00','30.00',63,'male','L2Monster','Fighter',40,3302,'15.000',1251,'2.700',40,43,30,21,20,10,6995,631,1086,362,560,323,278,500,253,84,0,0,27,174,'hallate_clan',200,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',1,1),
(886,21076,'Bathin''s Knight','','skeleton_knight','10.00','25.00',62,'male','L2Monster','Fighter',40,3219,'15.000',1217,'2.700',40,43,30,21,20,10,6881,613,1038,353,532,315,278,0,253,78,0,0,40,174,'hallate_clan',200,'Magister',NULL,0,0,0,7,50,1,9,0,0,'0.17','false',0,0),
(887,21077,'Bathin''s Wizard','','banshee','9.00','23.00',62,'female','L2Monster','Mystic',40,3219,'15.000',1217,'2.700',40,43,30,21,20,10,6669,594,1038,353,532,315,278,0,253,3939,0,0,80,174,'hallate_clan',200,'Magister',NULL,0,0,0,7,50,1,9,0,0,'0.56','false',0,0),
(888,21078,'Magus Valac','','vale_master','12.00','40.00',70,'male','L2Monster','Mystic',40,3862,'15.000',1493,'2.700',40,43,30,21,20,10,8481,841,1445,427,780,382,278,500,253,198,0,0,70,174,'hallate_clan',200,'Magister','',0,0,0,7,50,1,9,0,0,'0.74','false',1,1),
(889,21079,'Valac''s Creature','','serpent_slave','17.00','46.00',69,'male','L2Monster','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,7707,754,1392,418,746,373,278,0,253,150,0,0,70,174,'hallate_clan',200,'Magister',NULL,0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(890,21080,'Valac''s Guardian Spirit','','shadow','10.00','30.00',69,'male','L2Monster','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,7123,697,1006,506,746,373,317,0,289,0,0,0,80,174,'hallate_clan',200,'Magister',NULL,0,0,0,7,10,8,0,0,0,'0.54','false',0,0),
(891,21081,'Power Angel Amon','','angel','13.50','36.50',75,'male','L2Monster','Fighter',40,4229,'17.000',1673,'3.000',40,43,30,21,20,10,8887,937,1720,475,957,425,278,500,253,4700,0,0,30,174,'tower_guard_clan',200,'Magister','',0,0,0,7,50,1,9,0,0,'0.52','false',1,1),
(892,21082,'Amon''s Captain of the Guards','','kel_mahum_champion','13.00','32.00',74,'male','L2Monster','Fighter',40,4158,'17.000',1637,'3.000',40,43,30,21,20,10,8546,891,1664,466,921,416,278,0,253,150,0,0,50,174,'tower_guard_clan',200,'Magister',NULL,0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(893,21083,'Amon''s Spirits','','pixy','5.00','25.00',74,'female','L2Monster','Fighter',40,4158,'17.000',1637,'3.000',40,43,30,21,20,10,10096,1052,1664,466,921,416,278,0,253,0,0,0,80,174,'tower_guard_clan',200,'Magister',NULL,0,0,0,7,50,1,9,0,0,'0.72','false',0,0),
(894,21084,'Bloody Lady','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,'19.500',1150,'2.400',40,43,30,21,20,10,4112,357,946,335,478,299,278,500,253,0,0,0,80,174,'bloody_clan',400,'stiff_l2wh','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(895,21085,'Bloody Sniper','','fiend_archer','17.00','55.00',71,'male','L2Monster','Ranger',500,3938,'42.500',1529,'3.000',40,43,30,21,20,10,5574,559,3332,437,814,390,249,500,227,0,0,0,70,174,'bloody_clan',400,'Local','',0,0,0,7,10,8,0,1500,0,'0.76','false',1,0),
(896,21086,'Bloody Liviona','','liviona','15.00','28.00',72,'male','L2Monster','Fighter',40,4013,'42.500',1565,'3.000',40,43,30,21,20,10,5566,565,1413,491,849,399,278,500,253,0,0,0,80,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(897,21087,'Bloody Knight','','death_knight','12.00','30.00',73,'male','L2Monster','Fighter',40,4086,'42.500',1601,'3.000',40,43,30,21,20,10,8932,919,1770,415,885,407,278,500,253,137,0,0,27,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(898,21088,'Bloody Banshee','','banshee','9.00','23.00',74,'female','L2Monster','Mystic',40,4158,'42.500',1637,'3.000',40,43,30,21,20,10,5879,612,1513,512,921,416,278,500,253,3939,0,0,80,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(899,21089,'Bloody Lord','','karik','25.00','90.00',75,'male','L2Monster','Fighter',40,4229,'42.500',1673,'3.000',40,43,30,21,20,10,6817,719,1720,475,957,425,278,500,253,0,0,0,37,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(900,21090,'Bloody Guardian','','death_blader','15.00','45.00',75,'male','L2Monster','Fighter',40,4229,'25.500',1673,'3.000',40,43,30,21,20,10,8734,921,1720,475,957,425,278,500,253,1472,0,0,100,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,1),
(901,21091,'Bloody Keeper','','kaim_vanul','24.00','40.00',74,'male','L2Monster','Fighter',40,4158,'17.000',1637,'3.000',40,43,30,21,20,10,8831,920,1513,512,921,416,278,0,253,0,0,0,37,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(902,21092,'Bloody Mystic','','banshee','9.00','23.00',74,'female','L2Monster','Mystic',40,4158,'17.000',1637,'3.000',40,43,30,21,20,10,8627,899,1513,512,921,416,278,0,253,3939,0,0,80,174,'bloody_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(903,21093,'Ratman Sub Chieftain','','wererat','14.00','25.00',19,'male','L2Monster','Fighter',40,508,'2.500',203,'1.200',40,43,30,21,20,10,691,31,58,70,21,73,278,400,253,216,0,0,80,150,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.61','true',1,0),
(904,21094,'Ratman Chieftain','','wererat','14.00','25.00',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,712,32,52,104,23,76,278,0,253,3,0,0,80,155,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(905,21095,'Giant Poison Bee','','giant_bee','8.00','24.50',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,840,39,55,83,25,80,317,0,289,0,0,0,90,90,'',0,'Local','',0,0,0,7,10,8,0,0,10,'0.50','true',1,0),
(906,21096,'Cloudy Beast','','onyx_beast','14.00','14.50',22,'male','L2Monster','Fighter',40,611,'3.500',242,'1.500',40,43,30,21,20,10,837,40,68,87,28,83,278,400,253,0,0,0,30,140,'beast_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.24','true',1,0),
(907,21097,'Young Araneid','','poison_spider','27.00','25.50',23,'male','L2Monster','Mystic',40,648,'3.500',257,'1.500',40,43,30,21,20,10,985,48,75,107,31,87,278,400,253,0,0,0,60,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.65','true',1,0),
(908,21098,'Plain Grizzly','','grizzly','21.00','40.00',24,'male','L2Monster','Fighter',40,687,'3.500',272,'1.500',40,43,30,21,20,10,935,46,81,111,34,90,278,0,253,0,0,0,40,115,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(909,21099,'Cloudy Beast Turen','','onyx_beast','14.00','14.50',25,'male','L2Monster','Fighter',40,728,'3.500',287,'1.500',40,43,30,21,20,10,1012,51,88,98,37,94,278,400,253,0,0,0,30,145,'beast_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.24','true',1,0),
(910,21100,'Langk Lizardman Sentinel','','virud_lizardman','10.00','23.00',19,'male','L2Monster','Fighter',40,508,'2.500',203,'1.200',40,43,30,21,20,10,691,31,53,90,21,73,278,500,253,2,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(911,21101,'Langk Lizardman Shaman','','virud_lizardman_shaman','10.00','29.00',24,'male','L2Monster','Priest',40,687,'3.500',272,'1.500',40,43,30,21,20,10,935,46,81,94,34,90,278,0,253,6,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.48','true',1,0),
(912,21102,'Watchman of the Plains','','magical_weaver','11.00','20.00',30,'male','L2Monster','Mystic',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1335,73,132,119,58,114,278,500,253,0,0,0,90,160,'monster_eye_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.39','true',1,0),
(913,21103,'Roughly Hewn Rock Golem','','stone_golem_bi','20.00','40.30',31,'male','L2Monster','Mystic',40,1004,'4.500',381,'1.800',40,43,30,21,20,10,1397,78,142,146,64,118,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',1,0),
(914,21104,'Delu Lizardman Supplier','','virud_lizardman','10.00','23.00',32,'male','L2Monster','Fighter',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,1754,99,134,151,69,123,317,0,289,223,0,0,43,135,'',0,'Local','',0,0,0,7,10,8,0,0,0,'0.48','true',1,0),
(915,21105,'Delu Lizardman Special Agent','','virud_lizardman_scout','10.00','22.00',33,'male','L2Monster','Ranger',500,1109,'4.500',413,'1.800',40,43,30,21,20,10,2022,116,406,143,75,128,249,0,227,2507,0,0,43,135,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.72','true',1,0),
(916,21106,'Cursed Seer','','magical_weaver','11.00','20.00',34,'male','L2Monster','Mystic',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1714,100,178,138,82,132,278,500,253,0,0,0,90,160,'monster_eye_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.39','true',1,0),
(917,21107,'Delu Lizardman Commander','','virud_lizardman_warrior','12.00','30.00',35,'male','L2Monster','Fighter',40,1220,'9.000',446,'1.800',40,43,30,21,20,10,1814,107,192,169,89,137,278,0,253,93,0,0,52,135,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',1,0),
(918,21108,'Glow Wisp','','will_o_wisp','13.00','22.00',67,'male','L2Monster','Mystic',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,6528,622,1169,439,681,356,278,0,253,0,0,0,80,160,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.10','true',1,0),
(919,21109,'Hames Orc Scout','','ketra_orc','12.00','29.00',68,'male','L2Monster','Ranger',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,8082,781,1065,382,713,365,317,0,289,229,0,0,45,185,'orc_clan',400,'Local','',0,0,0,7,10,8,0,0,10,'0.46','true',1,0),
(920,21110,'Marsh Predator','','devastator','35.00','35.00',69,'male','L2Monster','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,6890,674,1265,460,746,373,278,0,253,0,0,0,25,175,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','true',1,0),
(921,21111,'Lava Wyrm','','wyrm','29.00','72.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,7197,714,1314,470,780,382,278,500,253,0,0,0,70,175,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.19','true',1,0),
(922,21112,'Hames Orc Footman','','ketra_orc','12.00','29.00',71,'male','L2Monster','Fighter',40,3938,'8.500',1529,'3.000',40,43,30,21,20,10,8724,875,1363,481,814,390,278,0,253,233,110,0,45,180,'orc_clan',300,'Local','',0,20,150,7,30,4,4,0,-6,'0.46','true',1,0),
(923,21113,'Hames Orc Sniper','','ketra_orc_archer','12.00','27.00',72,'male','L2Monster','Ranger',500,4013,'8.500',1565,'3.000',40,43,30,21,20,10,9722,988,3140,417,849,399,249,0,227,287,0,0,45,160,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.91','true',1,0),
(924,21114,'Cursed Guardian','','death_blader','15.00','45.00',73,'male','L2Monster','Fighter',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,9231,950,1463,426,885,407,278,0,253,1472,0,0,100,175,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.45','true',1,0),
(925,21115,'Hames Orc Shaman','','ketra_orc_shaman','10.00','23.00',74,'male','L2Monster','Priest',40,4158,'8.500',1637,'3.000',40,43,30,21,20,10,8043,838,1513,435,921,416,278,0,253,186,0,0,10,145,'orc_clan',400,'Local','',0,0,0,7,50,1,9,0,10,'0.34','true',1,0),
(926,21116,'Hames Orc Overlord','','ketra_orc_warrior','12.00','24.00',75,'male','L2Monster','Fighter',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,12699,1340,1720,475,957,425,278,500,253,75,103,0,36,175,'orc_clan',500,'Local','',0,20,159,7,30,4,4,0,-6,'0.54','true',1,0),
(927,21117,'Kasha Imp','','imp_bi','10.00','30.00',19,'male','L2Monster','Fighter',40,508,'2.500',203,'1.200',40,43,30,21,20,10,678,30,53,77,21,73,278,0,253,0,0,0,60,85,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.34','true',1,0),
(928,21118,'Baar Dre Vanul','','dre_vanul','14.00','36.00',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,726,32,57,94,23,76,278,400,253,0,0,0,80,85,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',1,0),
(929,21119,'Hobgoblin','','hobgoblin','12.00','24.00',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,4,0,0,45,110,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',1,0),
(930,21120,'Kasha Imp Turen','','imp_bi','10.00','30.00',22,'male','L2Monster','Fighter',40,611,'3.500',242,'1.500',40,43,30,21,20,10,996,47,75,79,28,83,278,400,253,0,0,0,60,85,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.34','true',1,0),
(931,21121,'Kasha Dire Wolf','','dire_wolf','13.00','11.00',23,'male','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,895,43,75,91,31,87,278,400,253,0,0,0,24,135,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.39','true',1,0),
(932,21122,'Kasha Bugbear','','bugbear','17.00','35.00',24,'male','L2Monster','Fighter',40,687,'3.500',272,'1.500',40,43,30,21,20,10,954,47,81,111,34,90,278,400,253,169,0,0,55,130,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(933,21123,'Baar Dre Vanul Destroyer','','dre_vanul','14.00','36.00',25,'male','L2Monster','Fighter',40,728,'3.500',287,'1.500',40,43,30,21,20,10,1267,63,97,105,37,94,278,400,253,0,0,0,80,85,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',1,0),
(934,21124,'Red Eye Barbed Bat','','vampire_bat','10.00','33.50',18,'male','L2Monster','Mystic',40,476,'2.500',193,'1.200',40,43,30,21,20,10,640,28,48,73,19,70,278,0,253,0,0,0,60,90,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.50','true',1,0),
(935,21125,'Northern Trimden','','poison_spider','27.00','25.50',19,'male','L2Monster','Mystic',40,508,'2.500',203,'1.200',40,43,30,21,20,10,684,31,53,90,21,73,278,400,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.65','true',1,0),
(936,21126,'Kerope Werewolf','','werewolf_bi','11.00','29.70',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,712,32,57,80,23,76,278,0,253,0,0,0,50,125,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.43','true',1,0),
(937,21127,'Northern Goblin','','northern_goblin','21.00','20.00',21,'male','L2Monster','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,764,35,63,98,25,80,278,0,253,152,0,0,30,120,'goblin_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','true',1,0),
(938,21128,'Spine Golem','','stone_golem_bi','20.00','40.30',22,'male','L2Monster','Mystic',40,611,'3.500',242,'1.500',40,43,30,21,20,10,821,39,68,102,28,83,278,0,253,0,0,0,23,23,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',1,0),
(939,21129,'Kerope Werewolf Chief','','werewolf_bi','11.00','29.70',23,'male','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,895,43,82,82,31,87,278,400,253,0,0,0,50,140,'werewolf_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.43','true',1,0),
(940,21130,'Northern Goblin Leader','','northern_goblin','21.00','20.00',24,'male','L2Monster','Fighter',40,687,'3.500',272,'1.500',40,43,30,21,20,10,954,47,81,111,34,90,278,400,253,66,102,0,30,125,'goblin_clan',300,'Local','',0,20,49,7,50,1,9,0,-6,'0.45','true',1,0),
(941,21131,'Enchanted Spine Golem','','stone_golem_bi','20.00','40.30',25,'male','L2Monster','Mystic',40,728,'3.500',287,'1.500',40,43,30,21,20,10,992,50,97,105,37,94,278,0,253,0,0,0,23,29,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',1,0),
(942,21132,'Underground Kobold','','kobold','10.00','15.00',24,'male','L2Monster','Fighter',40,687,'3.500',272,'1.500',40,43,30,21,20,10,779,38,81,94,34,90,278,0,253,0,0,0,47,110,'kobold_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.54','true',1,0),
(943,21133,'Dead Pit Skeleton Archer','','skeleton_archer','11.00','27.00',25,'male','L2Monster','Ranger',500,728,'3.500',287,'1.500',40,43,30,21,20,10,851,43,197,98,37,94,249,0,227,274,0,0,40,130,'undead_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.80','true',1,0),
(944,21134,'Dead Pit Spartoi','','spartoi','11.00','27.00',26,'male','L2Monster','Fighter',40,770,'3.500',303,'1.500',40,43,30,21,20,10,898,45,96,102,41,98,278,400,253,219,0,0,60,145,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.30','true',1,0),
(945,21135,'Underground Kobold Warrior','','kobold','10.00','15.00',27,'male','L2Monster','Fighter',40,813,'3.500',318,'1.500',40,43,30,21,20,10,1103,56,114,114,45,102,278,0,253,0,0,0,47,115,'kobold_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','true',1,0),
(946,21136,'Dead Pit Horror','','dark_horror','20.00','35.00',28,'male','L2Monster','Fighter',40,859,'3.500',334,'1.500',40,43,30,21,20,10,981,52,113,110,49,106,278,0,253,0,0,0,100,100,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.37','true',1,0),
(947,21137,'Iron Ore Golem','','iron_golem','18.00','34.00',29,'male','L2Monster','Mystic',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1057,57,111,149,53,110,278,400,253,0,0,0,20,21,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',1,0),
(948,21138,'Greedy Geist','','hungry_spirit','13.00','40.00',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1134,62,132,119,58,114,278,0,253,0,0,0,15,150,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.45','true',1,0),
(949,21139,'Catacomb Barbed Bat','','vampire_bat','10.00','33.50',23,'male','L2Monster','Mystic',40,648,'14.000',257,'1.500',40,43,30,21,20,10,655,31,75,91,31,87,278,500,253,0,0,0,60,130,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(950,21140,'Catacomb Wisp','','will_o_wisp','13.00','22.00',26,'male','L2Monster','Mystic',40,770,'14.000',303,'1.500',40,43,30,21,20,10,788,39,96,102,41,98,278,500,253,0,0,0,80,120,'c_dungeon_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,'0.10','false',1,0),
(951,21141,'Catacomb Serpent','','serpent_slave','17.00','46.00',28,'male','L2Monster','Fighter',40,859,'14.000',334,'1.500',40,43,30,21,20,10,926,48,113,110,49,106,278,500,253,73,0,0,70,130,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,'0.46','false',1,0),
(952,21142,'Grave Keeper Spartoi','','spartoi','11.00','27.00',29,'male','L2Monster','Fighter',40,906,'14.000',349,'1.500',40,43,30,21,20,10,927,49,111,149,53,110,278,500,253,221,0,0,60,140,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',1,0),
(953,21143,'Catacomb Scavenger Bat','','vampire_bat','10.00','33.50',31,'male','L2Monster','Fighter',40,1004,'18.000',381,'1.800',40,43,30,21,20,10,1042,57,142,124,64,118,278,500,253,0,0,0,60,140,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(954,21144,'Catacomb Shadow','','shadow','10.00','30.00',34,'male','L2Monster','Mystic',40,1164,'18.000',430,'1.800',40,43,30,21,20,10,1254,73,178,138,82,132,278,500,253,0,0,0,80,130,'c_dungeon_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,'0.54','false',1,0),
(955,21145,'Catacomb Stakato Soldier','','blade_stakato_soldier','15.00','38.00',38,'male','L2Monster','Fighter',40,1400,'18.000',497,'1.800',40,43,30,21,20,10,1611,100,238,160,112,153,278,500,253,232,0,0,25,150,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,'0.74','false',1,0),
(956,21146,'Grave Keeper Dark Horror','','dark_horror','20.00','35.00',40,'male','L2Monster','Fighter',40,1527,'18.000',531,'1.800',40,43,30,21,20,10,1735,112,248,222,131,164,278,500,253,0,0,0,100,160,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.37','false',1,0),
(957,21147,'Catacomb Gargoyle','','gargoyle','16.00','50.00',43,'male','L2Monster','Fighter',40,1728,'22.000',618,'2.100',40,43,30,21,20,10,2114,143,332,223,163,181,278,500,253,0,0,0,140,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',1,0),
(958,21148,'Catacomb Liviona','','liviona','15.00','28.00',44,'male','L2Monster','Fighter',40,1799,'22.000',648,'2.100',40,43,30,21,20,10,2100,143,354,196,176,187,278,500,253,0,0,0,80,140,'c_dungeon_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.34','false',1,0),
(959,21149,'Decayed Ancient Pikeman','','skeleton_pikeman','10.00','28.00',46,'male','L2Monster','Fighter',40,1943,'22.000',707,'2.100',40,43,30,21,20,10,2419,171,401,245,202,199,278,500,253,96,0,0,50,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.21','false',1,0),
(960,21150,'Decayed Ancient Soldier','','skeleton_knight','10.00','25.00',49,'male','L2Monster','Fighter',40,2168,'22.000',799,'2.100',40,43,30,21,20,10,2745,203,480,270,247,219,278,500,253,125,0,0,40,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(961,21151,'Decayed Ancient Knight','','skeleton_royal_guard','11.00','28.50',50,'male','L2Monster','Fighter',40,2245,'22.000',830,'2.100',40,43,30,21,20,10,2858,215,509,278,264,226,278,500,253,227,0,0,80,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(962,21152,'Purgatory Wisp','','will_o_wisp','13.00','22.00',53,'male','L2Monster','Mystic',40,2481,'26.000',923,'2.400',40,43,30,21,20,10,3047,239,602,258,319,247,278,500,253,0,0,0,80,150,'c_dungeon_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,'0.10','false',1,0),
(963,21153,'Purgatory Serpent','','serpent_slave','17.00','46.00',56,'male','L2Monster','Fighter',40,2724,'26.000',1019,'2.400',40,43,30,21,20,10,3586,294,706,281,382,269,278,500,253,73,0,0,70,175,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,'0.46','false',1,0),
(964,21154,'Hell Keeper Medusa','','medusa','10.00','25.00',58,'female','L2Monster','Mystic',40,2889,'26.000',1084,'2.400',40,43,30,21,20,10,3753,317,710,384,428,284,278,500,253,0,0,0,50,165,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(965,21155,'Purgatory Conjurer','','vampire_bat','10.00','33.50',59,'male','L2Monster','Mystic',40,2971,'26.000',1117,'2.400',40,43,30,21,20,10,3776,322,820,305,453,291,278,500,253,0,0,0,60,175,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(966,21156,'Purgatory Shadow','','shadow','10.00','30.00',61,'male','L2Monster','Mystic',40,3137,'30.000',1184,'2.700',40,43,30,21,20,10,4036,355,901,321,505,307,278,500,253,0,0,0,80,155,'c_dungeon_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,'0.54','false',1,0),
(967,21157,'Purgatory Tarantula','','poison_spider','27.00','25.50',64,'male','L2Monster','Mystic',40,3384,'30.000',1285,'2.700',40,43,30,21,20,10,4569,418,1031,347,589,331,278,500,253,0,0,0,60,175,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.65','false',1,0),
(968,21158,'Hell Keeper Crimson Doll','','crimson_doll','15.00','38.00',67,'male','L2Monster','Fighter',40,3626,'30.000',1388,'2.700',40,43,30,21,20,10,5133,488,1063,483,681,356,278,500,253,0,0,0,60,180,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.67','false',1,0),
(969,21159,'Purgatory Gargoyle','','gargoyle','16.00','50.00',68,'male','L2Monster','Fighter',40,3706,'30.000',1423,'2.700',40,43,30,21,20,10,5287,510,1217,449,713,365,278,500,253,0,0,0,140,175,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',1,0),
(970,21160,'Purgatory Liviona','','liviona','15.00','28.00',71,'male','L2Monster','Fighter',40,3938,'34.000',1529,'3.000',40,43,30,21,20,10,5468,548,1363,408,814,390,278,500,253,0,0,0,80,160,'c_dungeon_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.34','false',1,0),
(971,21161,'Lesser Ancient Soldier','','medusa','10.00','25.00',73,'female','L2Monster','Fighter',40,4086,'34.000',1601,'3.000',40,43,30,21,20,10,5945,611,1463,502,885,407,278,500,253,0,0,0,50,180,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(972,21162,'Lesser Ancient Scout','','blade_stakato_drone','15.00','39.00',74,'male','L2Monster','Ranger',40,4158,'34.000',1637,'3.000',40,43,30,21,20,10,5940,619,1513,512,921,416,278,500,253,135,0,0,25,160,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.58','false',1,0),
(973,21163,'Lesser Ancient Shaman','','silhouette','8.00','23.00',76,'female','L2Monster','Priest',40,4297,'34.000',1710,'3.000',40,43,30,21,20,10,6265,669,1614,454,994,433,278,500,253,0,0,0,80,200,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,'0.54','false',1,0),
(974,21164,'Guardian Spirit of Ancient Holy Ground','','death_lord','21.00','40.00',79,'male','L2Monster','Fighter',40,4490,'34.000',1821,'3.000',40,43,30,21,20,10,7136,791,1765,566,1107,459,278,500,253,78,0,0,40,190,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(975,21165,'Lesser Ancient Warrior','','shadeless','7.00','28.00',80,'male','L2Monster','Fighter',40,4550,'34.000',1859,'3.000',40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'c_dungeon_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.61','false',1,0),
(976,21166,'Lith Scout','','temple_guard_a_20_sm','12.00','33.60',21,'male','L2Monster','Fighter',40,575,'14.000',227,'1.500',40,43,30,21,20,10,594,27,66,69,25,80,317,0,289,5795,0,0,53,130,'c_dungeon_clan',400,'Local','',0,0,0,7,10,8,0,0,10,'0.48','false',1,0),
(977,21167,'Lith Witch','','temple_savant_a_20_sm','8.00','32.00',24,'male','L2Monster','Mystic',40,687,'14.000',272,'1.500',40,43,30,21,20,10,690,34,98,92,34,90,278,0,253,5797,0,0,25,110,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(978,21168,'Lith Warrior','','temple_guard_b_20_sm','12.00','33.60',27,'male','L2Monster','Fighter',40,813,'14.000',318,'1.500',40,43,30,21,20,10,855,43,126,103,45,102,278,0,253,5796,0,0,53,130,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(979,21169,'Lith Guard','','temple_guard_a','15.00','42.00',30,'male','L2Monster','Fighter',40,954,'14.000',365,'1.500',40,43,30,21,20,10,1133,62,140,99,58,114,317,0,289,5795,0,0,53,140,'c_dungeon_clan',400,'Local','',0,0,0,7,10,8,0,0,10,'0.48','false',1,0),
(980,21170,'Lith Medium','','temple_savant_a','10.00','40.00',33,'male','L2Monster','Fighter',40,1109,'18.000',413,'1.800',40,43,30,21,20,10,1307,75,201,130,75,128,278,0,253,5797,0,0,25,120,'c_dungeon_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(981,21171,'Lith Overlord','','temple_guard_b','15.00','42.00',36,'male','L2Monster','Fighter',40,1279,'18.000',463,'1.800',40,43,30,21,20,10,1669,101,250,145,96,142,278,0,253,5796,0,0,53,140,'c_dungeon_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(982,21172,'Lith Patrolman','','temple_guard_a','15.00','42.00',39,'male','L2Monster','Fighter',40,1462,'18.000',514,'1.800',40,43,30,21,20,10,1972,125,270,137,121,158,317,0,289,5795,0,0,53,150,'c_dungeon_clan',400,'Magister','',0,0,0,7,10,8,0,0,10,'0.48','false',1,0),
(983,21173,'Lith Shaman','','temple_savant_a','10.00','40.00',42,'male','L2Monster','Priest',40,1660,'22.000',589,'2.100',40,43,30,21,20,10,2118,141,377,178,152,175,278,0,253,5798,0,0,25,130,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(984,21174,'Lith Commander','','temple_guard_b','15.00','42.00',45,'male','L2Monster','Fighter',40,1870,'22.000',677,'2.100',40,43,30,21,20,10,2731,190,457,196,188,193,278,0,253,5796,0,0,53,150,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(985,21175,'Lilim Butcher','','lilim_assassin_10_sm','11.00','36.00',48,'male','L2Monster','Ranger',40,2091,'22.000',768,'2.100',40,43,30,21,20,10,3093,226,480,183,231,212,317,0,289,232,232,0,36,170,'c_dungeon_clan',400,'Local','',0,0,83,7,10,8,0,0,10,'0.46','false',1,0),
(986,21176,'Lilim Magus','','lilim_wizard_10_sm','8.00','30.60',51,'female','L2Monster','Mystic',40,2323,'26.000',861,'2.400',40,43,30,21,20,10,3123,238,652,237,281,232,278,0,253,0,0,0,50,140,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.50','false',1,0),
(987,21177,'Lilim Knight Errant','','lilim_knight_10_sm','11.00','45.00',54,'male','L2Monster','Fighter',40,2562,'26.000',955,'2.400',40,43,30,21,20,10,4385,349,769,258,339,254,278,0,253,5800,5799,0,56,170,'c_dungeon_clan',400,'Local','',0,20,109,7,30,4,4,0,-6,'0.46','false',1,0),
(988,21178,'Lilim Marauder','','lilim_assassin_10_sm','11.00','36.00',57,'male','L2Monster','Ranger',40,2806,'26.000',1052,'2.400',40,43,30,21,20,10,4697,390,786,239,405,276,317,0,289,229,229,0,36,180,'c_dungeon_clan',400,'Local','',0,0,102,7,10,8,0,0,10,'0.46','false',1,0),
(989,21179,'Lilim Priest','','lilim_wizard_10_sm','8.00','30.60',60,'female','L2Monster','Priest',40,3054,'26.000',1150,'2.400',40,43,30,21,20,10,4322,375,1041,304,478,299,278,0,253,0,0,0,50,160,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.50','false',1,0),
(990,21180,'Lilim Knight','','lilim_knight_10_sm','11.00','45.00',63,'male','L2Monster','Fighter',40,3302,'30.000',1251,'2.700',40,43,30,21,20,10,6489,586,1194,329,560,323,278,0,253,5800,5799,0,56,180,'c_dungeon_clan',400,'Local','',0,20,131,7,30,4,4,0,-6,'0.46','false',1,0),
(991,21181,'Lilim Assassin','','lilim_assassin_10_bi','13.00','44.00',66,'male','L2Monster','Fighter',40,3546,'30.000',1353,'2.700',40,43,30,21,20,10,6868,646,1189,301,649,348,317,0,289,234,234,0,36,190,'c_dungeon_clan',400,'Local','',0,0,121,7,10,8,0,0,10,'0.46','false',1,0),
(992,21182,'Lilim Soldier','','lilim_wizard_10_bi','10.00','37.50',69,'female','L2Monster','Fighter',40,3784,'30.000',1458,'2.700',40,43,30,21,20,10,5717,559,1531,380,746,373,278,0,253,0,0,0,50,170,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.50','false',1,0),
(993,21183,'Lilim Knight Banneret','','lilim_knight_10_bi','13.00','55.00',72,'male','L2Monster','Fighter',40,4013,'34.000',1565,'3.000',40,43,30,21,20,10,8475,861,1710,406,849,399,278,0,253,5800,5799,0,56,190,'c_dungeon_clan',400,'Local','',0,20,152,7,30,4,4,0,-6,'0.46','false',1,0),
(994,21184,'Lilim Slayer','','lilim_assassin_10_bi','13.00','44.00',75,'male','L2Monster','Ranger',40,4229,'34.000',1673,'3.000',40,43,30,21,20,10,8869,935,1655,367,957,425,317,0,289,236,236,0,36,200,'c_dungeon_clan',400,'Local','',0,0,140,7,10,8,0,0,10,'0.46','false',1,0),
(995,21185,'Lilim Great Mystic','','lilim_wizard_10_bi','10.00','37.50',78,'female','L2Monster','Mystic',40,4428,'34.000',1784,'3.000',40,43,30,21,20,10,7305,799,2075,459,1069,451,278,0,253,0,0,0,50,180,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.50','false',1,0),
(996,21186,'Lilim Court Knight','','lilim_knight_10_bi','13.00','55.00',80,'male','L2Monster','Fighter',40,4550,'34.000',1859,'3.000',40,43,30,21,20,10,10464,1174,2195,476,1144,468,278,0,253,5800,5799,0,56,200,'c_dungeon_clan',400,'Local','',0,20,170,7,30,4,4,0,-6,'0.46','false',1,0),
(997,21187,'Gigant Slave','','tomb_guard_a_20_sm','8.00','32.00',21,'male','L2Monster','Fighter',40,575,'14.000',227,'1.500',40,43,30,21,20,10,594,27,76,69,25,80,278,0,253,5791,0,0,49,130,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(998,21188,'Gigant Acolyte','','tomb_savant_a_20_sm','8.00','32.00',24,'male','L2Monster','Fighter',40,687,'14.000',272,'1.500',40,43,30,21,20,10,690,34,98,92,34,90,278,0,253,5793,0,0,49,110,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(999,21189,'Gigant Overseer','','tomb_guard_b_20_sm','12.00','34.00',27,'male','L2Monster','Fighter',40,813,'14.000',318,'1.500',40,43,30,21,20,10,855,43,126,103,45,102,278,0,253,5792,0,0,49,130,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0);
INSERT INTO `npc` VALUES
(1000,21190,'Gigant Footman','','tomb_guard_a','10.00','40.00',30,'male','L2Monster','Fighter',40,954,'14.000',365,'1.500',40,43,30,21,20,10,1133,62,160,99,58,114,278,0,253,5791,0,0,49,140,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(1001,21191,'Gigant Cleric','','tomb_savant_a','10.00','40.00',33,'male','L2Monster','Priest',40,1109,'18.000',413,'1.800',40,43,30,21,20,10,1307,75,201,130,75,128,278,0,253,5793,0,0,49,120,'c_dungeon_clan',400,'Magister','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1002,21192,'Gigant Officer','','tomb_guard_b','15.00','42.50',36,'male','L2Monster','Fighter',40,1279,'18.000',463,'1.800',40,43,30,21,20,10,1669,101,250,145,96,142,278,0,253,5792,0,0,49,140,'c_dungeon_clan',400,'Magister','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1003,21193,'Gigant Raider','','tomb_guard_a','10.00','40.00',39,'male','L2Monster','Fighter',40,1462,'18.000',514,'1.800',40,43,30,21,20,10,1972,125,308,137,121,158,278,0,253,5791,0,0,49,150,'c_dungeon_clan',400,'Magister','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(1004,21194,'Gigant Confessor','','tomb_savant_a','10.00','40.00',42,'male','L2Monster','Fighter',40,1660,'22.000',589,'2.100',40,43,30,21,20,10,2118,141,377,178,152,175,278,0,253,5794,0,0,49,130,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1005,21195,'Gigant Commander','','tomb_guard_b','15.00','42.50',45,'male','L2Monster','Fighter',40,1870,'22.000',677,'2.100',40,43,30,21,20,10,2731,190,457,196,188,193,278,0,253,5792,0,0,49,150,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1006,21196,'Nephilim Sentinel','','nephilim_slayer_10_sm','11.00','32.40',48,'male','L2Monster','Fighter',40,2091,'22.000',768,'2.100',40,43,30,21,20,10,3093,226,548,183,231,212,278,0,253,0,0,0,65,170,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.63','false',1,0),
(1007,21197,'Nephilim Priest','','nephilim_priest_10_sm','21.00','36.50',51,'male','L2Monster','Priest',40,2323,'26.000',861,'2.400',40,43,30,21,20,10,3391,258,652,237,281,232,278,0,253,0,0,0,50,140,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1008,21198,'Nephilim Swordsman','','nephilim_lord_10_sm','9.00','37.40',54,'male','L2Monster','Fighter',40,2562,'26.000',955,'2.400',40,43,30,21,20,10,4385,349,769,258,339,254,278,0,253,0,0,0,65,170,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.63','false',1,0),
(1009,21199,'Nephilim Guard','','nephilim_slayer_10_sm','11.00','32.40',57,'male','L2Monster','Fighter',40,2806,'26.000',1052,'2.400',40,43,30,21,20,10,4697,390,899,239,405,276,278,0,253,0,0,0,65,180,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.63','false',1,0),
(1010,21200,'Nephilim Bishop','','nephilim_priest_10_sm','21.00','36.50',60,'male','L2Monster','Priest',40,3054,'26.000',1150,'2.400',40,43,30,21,20,10,4694,407,1041,304,478,299,278,0,253,0,0,0,50,160,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1011,21201,'Nephilim Centurion','','nephilim_lord_10_sm','9.00','37.40',63,'male','L2Monster','Fighter',40,3302,'30.000',1251,'2.700',40,43,30,21,20,10,6489,586,1194,329,560,323,278,0,253,0,0,0,65,180,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.63','false',1,0),
(1012,21202,'Nephilim Scout','','nephilim_slayer_10_bi','13.00','39.60',66,'male','L2Monster','Ranger',40,3546,'30.000',1353,'2.700',40,43,30,21,20,10,6868,646,1358,301,649,348,278,0,253,0,0,0,65,190,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.63','false',1,0),
(1013,21203,'Nephilim Archbishop','','nephilim_priest_10_bi','21.00','44.00',69,'male','L2Monster','Priest',40,3784,'30.000',1458,'2.700',40,43,30,21,20,10,6208,607,1531,380,746,373,278,0,253,0,0,0,50,170,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1014,21204,'Nephilim Praetorian','','nephilim_lord_10_bi','11.00','45.30',72,'male','L2Monster','Fighter',40,4013,'34.000',1565,'3.000',40,43,30,21,20,10,8475,861,1710,406,849,399,278,0,253,0,0,0,65,190,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.63','false',1,0),
(1015,21205,'Nephilim Royal Guard','','nephilim_slayer_10_bi','13.00','39.60',75,'male','L2Monster','Fighter',40,4229,'34.000',1673,'3.000',40,43,30,21,20,10,8869,935,1892,367,957,425,278,0,253,0,0,0,65,200,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.63','false',1,0),
(1016,21206,'Nephilim Cardinal','','nephilim_priest_10_bi','21.00','44.00',78,'male','L2Monster','Priest',40,4428,'34.000',1784,'3.000',40,43,30,21,20,10,7933,868,2075,459,1069,451,278,0,253,0,0,0,50,180,'c_dungeon_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1017,21207,'Nephilim Commander','','nephilim_lord_10_bi','11.00','45.30',80,'male','L2Monster','Fighter',40,4550,'34.000',1859,'3.000',40,43,30,21,20,10,10464,1174,2195,476,1144,468,278,0,253,0,0,0,65,200,'c_dungeon_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.63','false',1,0),
(1018,21208,'Hallowed Watchman','','skeleton','11.00','25.00',20,'male','L2Monster','Fighter',40,541,'10.000',213,'1.200',40,43,30,21,20,10,521,23,57,94,23,76,278,0,253,216,111,0,60,130,'c_dungeon_clan',300,'Local','',0,20,43,7,30,4,4,0,-6,'0.30','false',1,0),
(1019,21209,'Hallowed Seer','','binding','12.00','21.00',22,'male','L2Monster','Fighter',40,611,'14.000',242,'1.500',40,43,30,21,20,10,612,29,68,87,28,83,278,500,253,0,0,0,10,110,'c_dungeon_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.54','false',1,0),
(1020,21210,'Vault Guardian','','dre_vanul','14.00','36.00',25,'male','L2Monster','Fighter',40,728,'14.000',287,'1.500',40,43,30,21,20,10,780,39,88,116,37,94,278,500,253,0,0,0,60,130,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(1021,21211,'Vault Seer','','succubus','10.00','36.00',27,'female','L2Monster','Mystic',40,813,'14.000',318,'1.500',40,43,30,21,20,10,830,42,104,106,45,102,278,500,253,0,0,0,60,110,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.84','false',1,0),
(1022,21212,'Hallowed Sentinel','','skeleton_bi','11.00','31.00',30,'male','L2Monster','Fighter',40,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1023,21213,'Hallowed Monk','','binding_20_bi','14.00','25.30',32,'male','L2Monster','Fighter',40,1056,'18.000',397,'1.800',40,43,30,21,20,10,1110,62,154,129,69,123,278,500,253,0,0,0,10,110,'c_dungeon_clan',300,'Magister','',0,0,0,7,50,1,9,0,10,'0.54','false',1,0),
(1024,21214,'Vault Sentinel','','imp_bi','10.00','30.00',35,'male','L2Monster','Fighter',40,1220,'18.000',446,'1.800',40,43,30,21,20,10,1400,83,192,169,89,137,278,500,253,0,0,0,60,140,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(1025,21215,'Vault Monk','','succubus_bi','10.00','43.20',37,'female','L2Monster','Mystic',40,1338,'18.000',480,'1.800',40,43,30,21,20,10,1485,91,222,154,104,147,278,500,253,0,0,0,60,120,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,'0.84','false',1,0),
(1026,21216,'Overlord of the Holy Lands','','skeleton_knight_20_bi','12.00','30.50',40,'male','L2Monster','Fighter',40,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1027,21217,'Hallowed Priest','','banshee_20_bi','10.00','27.50',42,'female','L2Monster','Priest',40,1660,'22.000',589,'2.100',40,43,30,21,20,10,1913,127,311,183,152,175,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.56','false',1,0),
(1028,21218,'Vault Overlord','','death_blader_10_sm','14.00','40.50',45,'male','L2Monster','Fighter',40,1870,'22.000',677,'2.100',40,43,30,21,20,10,2315,161,415,216,188,193,278,500,253,297,0,0,100,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1029,21219,'Vault Priest','','bloody_queen_10_sm','13.00','38.00',47,'female','L2Monster','Priest',40,2016,'22.000',738,'2.100',40,43,30,21,20,10,2396,171,427,215,216,206,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(1030,21220,'Sepulcher Archon','','skeleton_knight_30_bi','13.00','33.00',50,'male','L2Monster','Fighter',40,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1031,21221,'Sepulcher Inquisitor','','banshee_30_bi','11.00','30.00',52,'female','L2Monster','Mystic',40,2402,'26.000',892,'2.400',40,43,30,21,20,10,2933,227,570,251,300,239,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.56','false',1,0),
(1032,21222,'Sepulcher Archon','','death_blader_10_bi','16.00','49.50',55,'male','L2Monster','Fighter',40,2643,'26.000',987,'2.400',40,43,30,21,20,10,3459,279,737,292,360,261,278,500,253,298,0,0,100,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1033,21223,'Sepulcher Inquisitor','','bloody_queen_10_bi','15.00','46.00',57,'female','L2Monster','Mystic',40,2806,'26.000',1052,'2.400',40,43,30,21,20,10,3524,293,743,289,405,276,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(1034,21224,'Sepulcher Guardian','','skeleton_royal_guard_20_bi','13.00','34.50',60,'male','L2Monster','Fighter',40,3054,'26.000',1150,'2.400',40,43,30,21,20,10,3828,332,828,335,478,299,317,0,289,233,0,0,80,190,'c_dungeon_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.52','false',1,0),
(1035,21225,'Sepulcher Sage','','vale_master_10_bi','13.00','44.00',62,'male','L2Monster','Fighter',40,3219,'30.000',1217,'2.700',40,43,30,21,20,10,4169,371,944,330,532,315,278,500,253,311,0,0,70,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.74','false',1,0),
(1036,21226,'Sepulcher Guardian','','death_knight','12.00','30.00',65,'male','L2Monster','Fighter',40,3465,'30.000',1319,'2.700',40,43,30,21,20,10,4831,448,1184,380,619,340,278,500,253,0,0,0,27,190,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(1037,21227,'Sepulcher Sage','','doll_master','20.00','42.00',67,'male','L2Monster','Fighter',40,3626,'30.000',1388,'2.700',40,43,30,21,20,10,5444,518,1169,373,681,356,278,500,253,0,0,0,80,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.56','false',1,0),
(1038,21228,'Sepulcher Guard','','skeleton_royal_guard_30_bi','14.00','37.50',70,'male','L2Monster','Fighter',40,3862,'30.000',1493,'2.700',40,43,30,21,20,10,5211,516,1265,427,780,382,317,0,289,236,0,0,80,200,'c_dungeon_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.52','false',1,0),
(1039,21229,'Sepulcher Preacher','','vale_master_30_bi','15.00','52.00',72,'male','L2Monster','Fighter',40,4013,'34.000',1565,'3.000',40,43,30,21,20,10,5623,571,1413,417,849,399,278,500,253,326,0,0,70,165,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.74','false',1,0),
(1040,21230,'Sepulcher Guard','','death_knight','12.00','30.00',75,'male','L2Monster','Fighter',40,4229,'34.000',1673,'3.000',40,43,30,21,20,10,6432,678,1720,475,957,425,278,500,253,0,0,0,27,200,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(1041,21231,'Sepulcher Preacher','','doll_master_20_bi','24.00','50.40',77,'male','L2Monster','Fighter',40,4364,'34.000',1747,'3.000',40,43,30,21,20,10,6431,696,1664,463,1031,442,278,500,253,0,0,0,80,165,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.56','false',1,0),
(1042,21232,'Barrow Guardian','','skeleton','11.00','25.00',20,'male','L2Monster','Fighter',40,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1043,21233,'Barrow Seer','','binding','12.00','21.00',22,'male','L2Monster','Fighter',40,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1044,21234,'Grave Guardian','','imp','10.00','24.00',25,'male','L2Monster','Fighter',40,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1045,21235,'Grave Seer','','succubus','10.00','36.00',27,'male','L2Monster','Fighter',40,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1046,21236,'Barrow Sentinel','','skeleton_bi','11.00','31.00',30,'male','L2Monster','Fighter',40,954,'14.000',365,'1.500',40,43,30,21,20,10,957,52,132,140,58,114,278,0,253,69,0,0,60,140,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',1,0),
(1047,21237,'Barrow Monk','','binding_20_bi','14.00','25.30',32,'male','L2Monster','Fighter',40,1056,'18.000',397,'1.800',40,43,30,21,20,10,1110,62,154,129,69,123,278,500,253,0,0,0,10,110,'c_dungeon_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.54','false',1,0),
(1048,21238,'Grave Sentinel','','imp_bi','10.00','30.00',35,'male','L2Monster','Fighter',40,1220,'18.000',446,'1.800',40,43,30,21,20,10,1400,83,192,169,89,137,278,500,253,0,0,0,60,140,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(1049,21239,'Grave Monk','','succubus_bi','10.00','43.20',37,'female','L2Monster','Mystic',40,1338,'18.000',480,'1.800',40,43,30,21,20,10,1485,91,222,154,104,147,278,500,253,0,0,0,60,120,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.84','false',1,0),
(1050,21240,'Barrow Overlord','','skeleton_knight_20_bi','12.00','30.50',40,'male','L2Monster','Fighter',40,1527,'18.000',531,'1.800',40,43,30,21,20,10,1701,110,300,183,131,164,278,0,253,129,0,0,40,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(1051,21241,'Barrow Priest','','banshee_20_bi','10.00','27.50',42,'female','L2Monster','Priest',40,1660,'22.000',589,'2.100',40,43,30,21,20,10,1913,127,311,183,152,175,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.56','false',1,0),
(1052,21242,'Grave Overlord','','death_blader_10_sm','14.00','40.50',45,'male','L2Monster','Fighter',40,1870,'22.000',677,'2.100',40,43,30,21,20,10,2315,161,415,216,188,193,278,500,253,297,0,0,100,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1053,21243,'Grave Priest','','bloody_queen_10_sm','13.00','38.00',47,'female','L2Monster','Priest',40,2016,'22.000',738,'2.100',40,43,30,21,20,10,2396,171,427,215,216,206,278,500,253,0,0,0,80,135,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(1054,21244,'Crypt Archon','','skeleton_knight_30_bi','13.00','33.00',50,'male','L2Monster','Fighter',40,2245,'22.000',830,'2.100',40,43,30,21,20,10,2658,200,560,253,264,226,278,0,253,131,0,0,40,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(1055,21245,'Crypt Inquisitor','','banshee_30_bi','11.00','30.00',52,'female','L2Monster','Mystic',40,2402,'26.000',892,'2.400',40,43,30,21,20,10,2933,227,570,251,300,239,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.56','false',1,0),
(1056,21246,'Tomb Archon','','death_blader_10_bi','16.00','49.50',55,'male','L2Monster','Fighter',40,2643,'26.000',987,'2.400',40,43,30,21,20,10,3459,279,737,292,360,261,278,500,253,298,0,0,100,170,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1057,21247,'Tomb Inquisitor','','bloody_queen_10_bi','15.00','46.00',57,'female','L2Monster','Mystic',40,2806,'26.000',1052,'2.400',40,43,30,21,20,10,3524,293,743,289,405,276,278,500,253,0,0,0,80,145,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(1058,21248,'Crypt Guardian','','skeleton_royal_guard_20_bi','13.00','34.50',60,'male','L2Monster','Fighter',40,3054,'26.000',1150,'2.400',40,43,30,21,20,10,3828,332,828,335,478,299,317,0,289,233,0,0,80,190,'c_dungeon_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.52','false',1,0),
(1059,21249,'Crypt Sage','','vale_master_10_bi','13.00','44.00',62,'male','L2Monster','Fighter',40,3219,'30.000',1217,'2.700',40,43,30,21,20,10,4169,371,944,330,532,315,278,500,253,311,0,0,70,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.74','false',1,0),
(1060,21250,'Tomb Guardian','','death_knight','12.00','30.00',65,'male','L2Monster','Fighter',40,3465,'30.000',1319,'2.700',40,43,30,21,20,10,4831,448,1184,380,619,340,278,500,253,0,0,0,27,190,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(1061,21251,'Tomb Sage','','doll_master','20.00','42.00',67,'male','L2Monster','Fighter',40,3626,'30.000',1388,'2.700',40,43,30,21,20,10,5444,518,1169,373,681,356,278,500,253,0,0,0,80,160,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.56','false',1,0),
(1062,21252,'Crypt Guard','','skeleton_royal_guard_30_bi','14.00','37.50',70,'male','L2Monster','Fighter',40,3862,'30.000',1493,'2.700',40,43,30,21,20,10,5211,516,1265,427,780,382,317,0,289,236,0,0,80,200,'c_dungeon_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.52','false',1,0),
(1063,21253,'Crypt Preacher','','vale_master_30_bi','15.00','52.00',72,'male','L2Monster','Fighter',40,4013,'34.000',1565,'3.000',40,43,30,21,20,10,5623,571,1413,417,849,399,278,500,253,326,0,0,70,165,'c_dungeon_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.74','false',1,0),
(1064,21254,'Tomb Guard','','death_knight','12.00','30.00',75,'male','L2Monster','Fighter',40,4229,'34.000',1673,'3.000',40,43,30,21,20,10,6432,678,1720,475,957,425,278,500,253,78,0,0,27,200,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(1065,21255,'Tomb Preacher','','doll_master_20_bi','24.00','50.40',77,'male','L2Monster','Fighter',40,4364,'34.000',1747,'3.000',40,43,30,21,20,10,7190,778,1664,463,1031,442,278,500,253,0,0,0,80,165,'c_dungeon_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,'0.56','false',1,0),
(1066,21256,'Underground Werewolf','','werewolf_bi','11.00','29.70',23,'male','L2Monster','Fighter',40,648,'3.500',257,'1.500',40,43,30,21,20,10,754,36,75,91,31,87,278,400,253,0,0,0,50,135,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.43','true',1,0),
(1067,21257,'Evil Eye Seer','','monster_eye','21.00','43.00',18,'male','L2Monster','Mystic',40,476,'2.500',193,'1.200',40,43,30,21,20,10,646,28,48,73,19,70,278,0,253,0,0,0,90,155,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.30','true',1,0),
(1068,21258,'Fallen Orc Shaman','','ketra_orc_shaman','10.00','23.00',58,'male','L2Monster','PolimorphingShaman',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,0,0,781,297,428,284,278,0,253,9,0,0,10,130,'fallen_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.34','true',1,0),
(1069,21259,'Fallen Orc Shaman','','Saber_toothed_Tiger','34.00','28.00',59,'male','L2Monster','Fighter',40,2971,'6.500',1117,'2.400',40,43,30,21,20,10,12983,1110,820,305,453,291,278,500,253,0,0,0,60,180,'fallen_clan',1000,'SYS','',0,0,0,7,30,4,4,0,10,'0.45','true',0,0),
(1070,21260,'Betrayer Orc Hero','','Ketra_Orc_Warrior','12.00','24.00',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3691,278,509,278,264,226,278,0,253,74,0,0,36,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','true',0,0),
(1071,21261,'Ol Mahum Transcender','','ol_mahum','13.50','25.00',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,4284,323,509,236,264,226,278,0,253,127,0,0,50,130,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.46','true',1,0),
(1072,21262,'Ol Mahum Transcender','','ol_mahum_champion','14.00','27.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,7732,608,602,304,319,247,278,500,253,127,0,0,50,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.63','true',0,0),
(1073,21263,'Ol Mahum Transcender','','oel_mahum','20.00','37.00',55,'male','L2Monster','Fighter',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,11790,952,670,322,360,261,278,500,253,127,0,0,70,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(1074,21264,'Ol Mahum Transcender','','kel_mahum','13.00','26.00',58,'male','L2Monster','Fighter',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,19082,1612,781,349,428,284,278,500,253,127,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',0,0),
(1075,21265,'Cave Ant Larva','','ant_larva','12.00','8.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,1586,96,206,175,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',0,0),
(1076,21266,'Cave Ant Larva','','ant_larva','12.00','8.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',0,0),
(1077,21267,'Cave Ant Larva','','ant_larva','12.00','8.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',0,0),
(1078,21268,'Cave Ant Larva','','ant_larva','12.00','8.00',36,'male','L2Monster','Fighter',40,1279,'9.000',463,'1.800',40,43,30,21,20,10,1475,89,187,193,96,142,278,0,253,0,0,0,40,60,'ant_clan',500,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(1079,21269,'Cave Ant','','ant','26.00','15.00',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,3368,207,222,154,104,147,278,500,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.26','true',0,0),
(1080,21270,'Cave Ant Soldier','','ant_soldier','35.00','17.00',38,'male','L2Monster','Fighter',40,1400,'4.500',497,'1.800',40,43,30,21,20,10,3891,243,238,188,112,153,278,500,253,0,0,0,80,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',0,0),
(1081,21271,'Cave Ant','','ant','26.00','15.00',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,2298,141,222,154,104,147,278,500,253,0,0,0,40,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.26','true',0,0),
(1082,21272,'Cave Ant Soldier','','ant_soldier','35.00','17.00',38,'male','L2Monster','Fighter',40,1400,'4.500',497,'1.800',40,43,30,21,20,10,4085,255,238,188,112,153,278,500,253,0,0,0,80,130,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',0,0),
(1083,21273,'Cave Noble Ant','','noble_ant','20.00','48.00',39,'male','L2Monster','Fighter',40,1462,'9.000',514,'1.800',40,43,30,21,20,10,5918,376,280,177,121,158,278,500,253,0,0,0,80,174,'ant_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(1084,21274,'Kookaburra','','youth_ostrich','8.00','26.40',67,'male','L2Monster','Fighter',40,3626,'3.750',1388,'2.700',40,43,30,21,20,10,8356,796,1169,373,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.54','true',1,0),
(1085,21275,'Kookaburra','','youth_ostrich','8.00','26.40',67,'male','L2Monster','Fighter',40,3626,'3.750',1388,'2.700',40,43,30,21,20,10,8356,796,1415,308,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.54','true',1,0),
(1086,21276,'Kookaburra','','youth_ostrich','8.00','26.40',67,'male','L2Monster','Fighter',40,3626,'3.750',1388,'2.700',40,43,30,21,20,10,8356,796,1063,410,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.54','true',1,0),
(1087,21277,'Kookaburra','','youth_ostrich','8.00','26.40',67,'male','L2Monster','Fighter',40,3626,'3.750',1388,'2.700',40,43,30,21,20,10,5875,560,1169,373,681,356,278,0,253,0,0,0,23,190,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.54','true',1,0),
(1088,21278,'Antelope','','antelope','17.00','34.00',68,'male','L2Monster','Fighter',40,3706,'3.750',1423,'2.700',40,43,30,21,20,10,8608,832,1217,449,713,365,278,0,253,0,0,0,45,185,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1089,21279,'Antelope','','antelope','17.00','34.00',68,'male','L2Monster','Fighter',40,3706,'3.750',1423,'2.700',40,43,30,21,20,10,8608,832,1106,494,713,365,278,0,253,0,0,0,45,165,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1090,21280,'Antelope','','antelope','17.00','34.00',68,'male','L2Monster','Mystic',40,3706,'3.750',1423,'2.700',40,43,30,21,20,10,8608,832,1473,371,713,365,278,0,253,0,0,0,45,165,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1091,21281,'Antelope','','antelope','17.00','34.00',68,'male','L2Monster','Fighter',40,3706,'3.750',1423,'2.700',40,43,30,21,20,10,6052,584,1217,449,713,365,278,0,253,0,0,0,45,165,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1092,21282,'Bandersnatch','','bandersnatch','18.00','25.00',69,'male','L2Monster','Fighter',40,3784,'3.750',1458,'2.700',40,43,30,21,20,10,9040,884,1757,460,746,373,200,150,182,0,0,0,30,170,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.49','true',1,0),
(1093,21283,'Bandersnatch','','bandersnatch','18.00','25.00',69,'male','L2Monster','Fighter',40,3784,'3.750',1458,'2.700',40,43,30,21,20,10,9040,884,2127,380,746,373,200,150,182,0,0,0,30,170,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.49','true',1,0),
(1094,21284,'Bandersnatch','','bandersnatch','18.00','25.00',69,'male','L2Monster','Fighter',40,3784,'3.750',1458,'2.700',40,43,30,21,20,10,9040,884,1598,506,746,373,200,150,182,0,0,0,30,170,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.49','true',1,0),
(1095,21285,'Bandersnatch','','bandersnatch','18.00','25.00',69,'male','L2Monster','Mystic',40,3784,'3.750',1458,'2.700',40,43,30,21,20,10,6356,622,1757,460,746,373,200,0,182,0,0,0,30,170,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.49','true',1,0),
(1096,21286,'Buffalo','','buffalo','22.00','31.00',70,'male','L2Monster','Fighter',40,3862,'3.750',1493,'2.700',40,43,30,21,20,10,9121,904,1825,470,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',1,0),
(1097,21287,'Buffalo','','buffalo','22.00','31.00',70,'male','L2Monster','Fighter',40,3862,'3.750',1493,'2.700',40,43,30,21,20,10,9121,904,1659,517,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',1,0),
(1098,21288,'Buffalo','','buffalo','22.00','31.00',70,'male','L2Monster','Fighter',40,3862,'3.750',1493,'2.700',40,43,30,21,20,10,9121,904,2209,388,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',1,0),
(1099,21289,'Buffalo','','buffalo','22.00','31.00',70,'male','L2Monster','Fighter',40,3862,'3.750',1493,'2.700',40,43,30,21,20,10,6413,636,1825,470,780,382,200,0,182,0,0,0,20,170,'animal_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',1,0),
(1100,21290,'Grendel','','bionic_bear','15.00','39.00',71,'male','L2Monster','Fighter',40,3938,'4.250',1529,'3.000',40,43,30,21,20,10,9572,960,1894,481,814,390,200,150,182,0,0,0,36,160,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1101,21291,'Grendel','','bionic_bear','15.00','39.00',71,'male','L2Monster','Fighter',40,3938,'4.250',1529,'3.000',40,43,30,21,20,10,9572,960,1721,529,814,390,200,150,182,0,0,0,36,160,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1102,21292,'Grendel','','bionic_bear','15.00','39.00',71,'male','L2Monster','Fighter',40,3938,'4.250',1529,'3.000',40,43,30,21,20,10,9572,960,2291,397,814,390,200,150,182,0,0,0,36,160,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1103,21293,'Grendel','','bionic_bear','15.00','39.00',71,'male','L2Monster','Mystic',40,3938,'4.250',1529,'3.000',40,43,30,21,20,10,6730,676,1894,481,814,390,200,0,182,0,0,0,36,160,'animal_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1104,21294,'Canyon Antelope','','antelope','17.00','34.00',68,'male','L2Monster','Fighter',40,3706,'15.000',1423,'2.700',40,43,30,21,20,10,6893,666,1217,449,713,365,278,0,253,0,0,0,45,185,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(1105,21295,'Canyon Antelope Slave','','antelope','17.00','34.00',69,'male','L2Monster','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,7311,715,1265,460,746,373,278,150,253,0,0,0,45,165,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(1106,21296,'Canyon Bandersnatch','','bandersnatch','18.00','25.00',70,'male','L2Monster','Fighter',40,3862,'22.500',1493,'2.700',40,43,30,21,20,10,7244,718,2429,353,780,382,200,150,182,0,0,0,30,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.49','false',1,0),
(1107,21297,'Canyon Bandersnatch Slave','','bandersnatch','18.00','25.00',71,'male','L2Monster','Fighter',40,3938,'25.500',1529,'3.000',40,43,30,21,20,10,7275,730,1721,529,814,390,200,150,182,0,0,0,30,170,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.49','false',1,0),
(1108,21298,'Eye of Restrainer','','monster_eye','21.00','43.00',71,'male','L2Monster','Mystic',40,3938,'17.000',1529,'3.000',40,43,30,21,20,10,7023,705,1239,449,814,390,278,150,253,0,0,0,90,140,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.30','false',1,0),
(1109,21299,'Buffalo Slave','','buffalo_ec','22.00','31.00',72,'male','L2Monster','Fighter',40,4013,'25.500',1565,'3.000',40,43,30,21,20,10,7481,760,2159,446,849,399,200,150,182,0,0,0,20,160,'eye_clan',400,'Local','',0,0,0,7,50,1,9,0,0,'0.46','false',1,0),
(1110,21300,'Eye of Guide','','parasitic_eye_20_sm','20.00','50.50',72,'male','L2Monster','Mystic',40,4013,'25.500',1565,'3.000',40,43,30,21,20,10,7360,747,1168,505,849,399,278,0,253,0,0,0,30,155,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(1111,21301,'Gaze of Nightmare','','field_stalker','15.00','30.00',72,'male','L2Monster','Fighter',40,4013,'34.000',1565,'3.000',40,43,30,21,20,10,6624,673,1061,654,849,399,278,0,253,0,0,0,70,195,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.41','false',1,0),
(1112,21302,'Eye of Watchman','','parasitic_eye','25.00','63.00',73,'male','L2Monster','Mystic',40,4086,'25.500',1601,'3.000',40,43,30,21,20,10,7105,731,1770,352,885,407,278,150,253,0,0,0,30,160,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(1113,21303,'Homunculus','','homunculus_20_sm','10.00','26.00',73,'male','L2Monster','Fighter',40,4086,'25.500',1601,'3.000',40,43,30,21,20,10,7185,739,1947,320,885,407,278,150,253,0,0,0,30,185,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(1114,21304,'Grendel Slave','','bionic_bear','15.00','39.00',74,'male','L2Monster','Fighter',40,4158,'34.000',1637,'3.000',40,43,30,21,20,10,7918,825,2312,466,921,416,200,150,182,0,0,0,36,140,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(1115,21305,'Eye of Pilgrim','','parasitic_eye_20_sm','20.00','50.50',74,'male','L2Monster','Mystic',40,4158,'25.500',1637,'3.000',40,43,30,21,20,10,7775,810,1375,479,921,416,278,0,253,0,0,0,30,165,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(1116,21306,'Disciples of Protection','','apostle_warrior','8.00','30.00',74,'female','L2Monster','Fighter',40,4158,'42.500',1637,'3.000',40,43,30,21,20,10,8441,880,1579,682,921,416,200,150,182,6717,0,0,50,160,'divine_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(1117,21307,'Elder Homunculus','','homunculus','12.00','32.50',75,'male','L2Monster','Fighter',40,4229,'34.000',1673,'3.000',40,43,30,21,20,10,7394,780,1892,367,957,425,278,150,253,0,0,0,30,200,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,0),
(1118,21308,'Disciples of Punishment','','apostle_warrior','8.00','30.00',75,'female','L2Monster','Fighter',40,4229,'42.500',1673,'3.000',40,43,30,21,20,10,7860,829,2389,475,957,425,200,150,182,6717,0,0,50,190,'divine_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(1119,21309,'Disciples of Punishment','','apostle_warrior','8.00','30.00',75,'female','L2Monster','Fighter',40,4229,'42.500',1673,'3.000',40,43,30,21,20,10,8192,864,1795,633,957,425,200,150,182,6717,0,0,50,190,'divine_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(1120,21310,'Disciples of Authority','','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,'42.500',1710,'3.000',40,43,30,21,20,10,8071,863,1775,412,994,433,278,150,253,6718,0,0,50,155,'divine_clan',600,'Local','',0,0,0,7,50,1,9,0,10,'0.48','false',1,0),
(1121,21311,'Disciples of Authority','','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,'42.500',1710,'3.000',40,43,30,21,20,10,7441,795,1334,549,994,433,278,150,253,6718,0,0,50,155,'divine_clan',600,'Local','',0,0,0,7,50,1,9,0,10,'0.48','false',1,0),
(1122,21312,'Eye of Ruler','','parasitic_eye','25.00','63.00',74,'male','L2Monster','Mystic',40,4158,'25.500',1637,'3.000',40,43,30,21,20,10,10752,1121,1375,479,921,416,278,150,253,0,0,0,30,160,'eye_clan',400,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',1,1),
(1123,21313,'Sly Hound Dog','','bandersnatch','18.00','25.00',72,'male','L2Monster','Fighter',40,4013,'25.500',1565,'3.000',40,43,30,21,20,10,10294,1046,2375,406,849,399,200,0,182,0,0,0,30,185,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.49','false',0,0),
(1124,21314,'Hot Springs Bandersnatchling','','bandersnatch','18.00','25.00',73,'male','L2Monster','Fighter',40,4086,'17.000',1601,'3.000',40,43,30,21,20,10,8609,886,2032,502,885,407,200,150,182,0,0,0,30,170,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.49','false',1,0),
(1125,21315,'Hot Springs Buffalo','','buffalo','22.00','31.00',73,'male','L2Monster','Fighter',40,4086,'17.000',1601,'3.000',40,43,30,21,20,10,8971,923,2032,502,885,407,200,0,182,0,0,0,20,170,'',0,'Magister','',0,0,0,7,50,1,9,0,0,'0.46','false',1,0),
(1126,21316,'Hot Springs Flava','','flava','18.00','34.00',74,'male','L2Monster','Fighter',40,4158,'17.000',1637,'3.000',40,43,30,21,20,10,10556,1100,1513,512,921,416,278,150,253,0,0,0,30,165,'',0,'Magister','',0,0,0,7,50,1,9,0,0,'0.45','false',1,0),
(1127,21317,'Hot Springs Atroxspawn','','kailiharim','57.00','39.00',74,'male','L2Monster','Fighter',40,4158,'17.000',1637,'3.000',40,43,30,21,20,10,8846,922,2102,512,921,416,200,150,182,0,0,0,105,175,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1128,21318,'Hot Springs Antelope','','antelope','17.00','34.00',74,'male','L2Monster','Fighter',40,4158,'17.000',1637,'3.000',40,43,30,21,20,10,9247,964,1513,512,921,416,278,0,253,0,0,0,45,185,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(1129,21319,'Hot Springs Nepenthes','','nephenthes','28.00','43.50',75,'male','L2Monster','Fighter',40,4229,'17.000',1673,'3.000',40,43,30,21,20,10,11636,1227,2172,523,957,425,200,150,182,0,0,0,48,170,'',0,'Magister','',0,0,0,7,50,1,9,0,0,'0.47','false',1,0),
(1130,21320,'Hot Springs Yeti','','yeti_20_bi','18.00','32.00',75,'male','L2Monster','Fighter',40,4229,'17.000',1673,'3.000',40,43,30,21,20,10,9470,999,1563,523,957,425,278,0,253,0,0,0,16,170,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1131,21321,'Hot Springs Atrox','','kailiharim','57.00','39.00',76,'male','L2Monster','Fighter',40,4297,'17.000',1710,'3.000',40,43,30,21,20,10,11135,1190,2242,534,994,433,200,150,182,0,0,0,105,175,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1132,21322,'Hot Springs Bandersnatch','','bandersnatch','18.00','25.00',76,'male','L2Monster','Fighter',40,4297,'17.000',1710,'3.000',40,43,30,21,20,10,11135,1190,2242,534,994,433,200,150,182,0,0,0,30,170,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.49','false',1,0),
(1133,21323,'Hot Springs Grendel','','bionic_bear','15.00','39.00',76,'male','L2Monster','Fighter',40,4297,'17.000',1710,'3.000',40,43,30,21,20,10,9753,1042,2242,534,994,433,200,0,182,0,0,0,36,165,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(1134,21324,'Ketra Orc Footman','','ketra_orc','12.00','29.00',77,'male','L2Monster','Fighter',40,4364,'17.000',1747,'3.000',40,43,30,21,20,10,9323,1009,1664,544,1031,442,278,150,253,79,0,0,45,175,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(1135,21325,'Ketra''s War Hound','','bandersnatch','18.00','25.00',77,'male','L2Monster','Fighter',40,4364,'17.000',1747,'3.000',40,43,30,21,20,10,9015,975,2543,495,1031,442,200,150,182,0,0,0,30,185,'ketra_orc_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.49','false',1,0),
(1136,21326,'Grazing Kookaburra','','youth_ostrich','8.00','26.40',77,'male','L2Monster','Fighter',40,4364,'17.000',1747,'3.000',40,43,30,21,20,10,9015,975,1375,560,1031,442,278,150,253,0,0,0,23,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.54','false',1,0),
(1137,21327,'Ketra Orc Raider','','ketra_orc_warrior','12.00','24.00',78,'male','L2Monster','Fighter',40,4428,'17.000',1784,'3.000',40,43,30,21,20,10,10240,1120,2075,459,1069,451,278,150,253,79,6919,0,36,175,'ketra_orc_clan',300,'Local','',0,20,166,7,30,4,4,0,-6,'0.54','false',1,0),
(1138,21328,'Ketra Orc Scout','','ketra_orc_archer','12.00','27.00',78,'male','L2Monster','Ranger',500,4428,'17.000',1784,'3.000',40,43,30,21,20,10,9816,1074,3464,611,1069,451,249,150,227,288,0,0,45,175,'ketra_orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.91','false',1,0),
(1139,21329,'Ketra Orc Shaman','','ketra_orc_shaman','10.00','23.00',79,'male','L2Monster','Priest',40,4490,'17.000',1821,'3.000',40,43,30,21,20,10,9955,1103,1765,481,1107,459,278,150,253,92,0,0,10,150,'ketra_orc_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.34','false',1,0),
(1140,21330,'Grazing Buffalo','','buffalo','22.00','31.00',79,'male','L2Monster','Fighter',40,4490,'17.000',1821,'3.000',40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,20,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.46','false',1,0),
(1141,21331,'Ketra Orc Warrior','','ketra_orc_warrior','12.00','24.00',80,'male','L2Monster','Fighter',40,4550,'17.000',1859,'3.000',40,43,30,21,20,10,9304,1044,1996,524,1144,468,278,150,253,79,6919,0,36,175,'ketra_orc_clan',300,'Local','',0,20,170,7,30,4,4,0,-6,'0.54','false',1,0),
(1142,21332,'Ketra Orc Lieutenant','','ketra_orc_chieftain','11.00','38.50',80,'male','L2Monster','Fighter',40,4550,'17.000',1859,'3.000',40,43,30,21,20,10,10420,1169,2291,634,1144,468,200,150,182,6719,0,0,24,175,'ketra_orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.51','false',1,0),
(1143,21333,'Grazing Windsus','','giant_wild_hog','25.00','27.00',80,'male','L2Monster','Fighter',40,4608,'17.000',1896,'3.000',40,43,30,21,20,10,9976,1133,1540,710,1182,477,278,150,253,0,0,0,35,170,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.54','false',1,0),
(1144,21334,'Ketra Orc Medium','','ketra_orc_shaman','10.00','23.00',80,'male','L2Monster','Priest',40,4608,'17.000',1896,'3.000',40,43,30,21,20,10,14933,1695,1863,499,1182,477,278,150,253,92,0,0,10,150,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.34','false',1,0),
(1145,21335,'Ketra Orc Elite Soldier','','ketra_orc','12.00','29.00',80,'male','L2Monster','Fighter',40,4663,'17.000',1934,'3.000',40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,79,0,0,45,175,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(1146,21336,'Ketra Orc White Captain','','ketra_orc_overload_20_bi','14.00','28.80',80,'male','L2Monster','Fighter',40,4663,'17.000',1934,'3.000',40,43,30,21,20,10,11317,1300,1738,657,1220,485,278,150,253,80,0,0,33,175,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1147,21337,'Grazing Elder Buffalo','','buffalo','22.00','31.00',80,'male','L2Monster','Fighter',40,4716,'17.000',1972,'3.000',40,43,30,21,20,10,10475,1217,2249,736,1258,494,200,150,182,0,0,0,20,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.46','false',1,0),
(1148,21338,'Ketra Orc Seer','','ketra_orc_shaman','10.00','23.00',80,'male','L2Monster','Priest',40,4716,'17.000',1972,'3.000',40,43,30,21,20,10,13783,1602,2155,470,1258,494,278,150,253,213,0,0,10,160,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.34','false',1,0),
(1149,21339,'Ketra Orc General','','ketra_orc_chieftain_20_bi','17.00','46.20',80,'male','L2Monster','Fighter',40,4766,'17.000',2011,'3.000',40,43,30,21,20,10,10494,1234,3372,511,1296,502,200,150,182,6719,0,0,24,175,'ketra_orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.51','false',1,0),
(1150,21340,'Ketra Orc Battalion Commander','','ketra_orc_warlord','12.00','30.00',80,'male','L2Monster','Fighter',40,4766,'17.000',2011,'3.000',40,43,30,21,20,10,10494,1234,2006,619,1296,502,278,150,253,80,6919,0,27,175,'ketra_orc_clan',300,'Local','',0,20,178,7,30,4,4,0,-6,'0.48','false',1,0),
(1151,21341,'Grazing Elder Kookaburra','','youth_ostrich','8.00','26.40',80,'male','L2Monster','Fighter',40,4813,'17.000',2049,'3.000',40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,253,0,0,0,23,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.54','false',1,0),
(1152,21342,'Ketra Orc Grand Seer','','ketra_orc_shaman','10.00','23.00',80,'male','L2Monster','Priest',40,4813,'17.000',2049,'3.000',40,43,30,21,20,10,14456,1720,2052,629,1333,511,278,150,253,213,0,0,10,160,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(1153,21343,'Ketra Commander','','ketra_orc_warlord_20_bi','14.00','36.00',80,'male','L2Monster','Fighter',40,4608,'17.000',1896,'3.000',40,43,30,21,20,10,16400,1862,1630,587,1182,477,317,150,289,80,6919,0,27,175,'ketra_orc_clan',300,'Local','',0,20,172,7,10,8,0,0,-6,'0.48','false',1,0),
(1154,21344,'Ketra Elite Guard','','ketra_orc_overload','12.00','24.00',80,'male','L2Monster','Fighter',40,4550,'17.000',1859,'3.000',40,43,30,21,20,10,11138,1250,2195,476,1144,468,278,0,253,80,0,0,33,180,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1155,21345,'Ketra''s Head Shaman','','ketra_orc_shaman','10.00','23.00',80,'male','L2Monster','Priest',40,4813,'17.000',2049,'3.000',40,43,30,21,20,10,12360,1471,2257,572,1333,511,278,150,253,210,0,0,10,175,'ketra_orc_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,'0.34','false',1,0),
(1156,21346,'Ketra''s Head Guard','','ketra_orc_chieftain','11.00','38.50',80,'male','L2Minion','Fighter',40,4766,'17.000',2011,'3.000',40,43,30,21,20,10,12279,1444,2303,749,1296,502,200,0,182,6719,0,0,24,175,'ketra_orc_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,'0.51','false',0,0),
(1157,21347,'Ketra Prophet','','ketra_orc_shaman','10.00','23.00',80,'male','L2Monster','Priest',40,4899,'17.000',2127,'3.000',40,43,30,21,20,10,18779,2289,2141,650,1406,528,278,150,253,213,0,0,10,175,'ketra_orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(1158,21348,'Prophet''s Guard','','ketra_orc_chieftain','11.00','38.50',80,'male','L2Minion','Fighter',40,4858,'17.000',2088,'3.000',40,43,30,21,20,10,12871,1550,2913,639,1370,519,200,0,182,6719,0,0,24,180,'ketra_orc_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,'0.51','false',0,0);
INSERT INTO `npc` VALUES
(1159,21349,'Prophet''s Aide','','ketra_orc_shaman','10.00','23.00',80,'male','L2Minion','Priest',40,4858,'17.000',2088,'3.000',40,43,30,21,20,10,13071,1574,2097,639,1370,519,278,0,253,210,0,0,10,180,'ketra_orc_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,'0.34','false',0,0),
(1160,21350,'Varka Silenos Recruit','','barka_silenos_hunter','16.00','38.00',77,'male','L2Monster','Fighter',40,4364,'17.000',1747,'3.000',40,43,30,21,20,10,9851,1066,1664,544,1031,442,278,150,253,2504,0,0,44,175,'varka_silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1161,21351,'Varka Silenos Footman','','barka_silenos_warrior','16.00','41.00',77,'male','L2Monster','Fighter',40,4364,'17.000',1747,'3.000',40,43,30,21,20,10,8487,918,1831,495,1031,442,278,150,253,2504,0,0,34,185,'varka_silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1162,21352,'Grazing Antelope','','antelope','17.00','34.00',77,'male','L2Monster','Fighter',40,4364,'17.000',1747,'3.000',40,43,30,21,20,10,9015,975,1375,560,1031,442,278,150,253,0,0,0,45,185,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.46','false',1,0),
(1163,21353,'Varka Silenos Scout','','barka_silenos_hunter','16.00','38.00',78,'male','L2Monster','Ranger',40,4428,'17.000',1784,'3.000',40,43,30,21,20,10,9906,1084,2075,459,1069,451,278,150,253,142,6918,0,44,175,'varka_silenos_clan',300,'Local','',0,20,166,7,30,4,4,0,-6,'0.48','false',1,0),
(1164,21354,'Varka Silenos Hunter','','barka_silenos_archer','8.00','37.50',78,'male','L2Monster','Fighter',500,4428,'17.000',1784,'3.000',40,43,30,21,20,10,9816,1074,3464,611,1069,451,249,150,227,6917,0,0,30,175,'varka_silenos_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.59','false',1,0),
(1165,21355,'Varka Silenos Shaman','','barka_silenos_shaman','14.00','39.50',79,'male','L2Monster','Priest',40,4490,'17.000',1821,'3.000',40,43,30,21,20,10,9492,1052,2451,481,1107,459,200,150,182,6716,0,0,36,150,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.49','false',1,0),
(1166,21356,'Grazing Nepenthes','','nephenthes','28.00','43.50',79,'male','L2Monster','Fighter',40,4490,'17.000',1821,'3.000',40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,48,170,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.47','false',1,0),
(1167,21357,'Varka Silenos Priest','','barka_silenos_priest','9.00','41.50',80,'male','L2Monster','Priest',40,4550,'17.000',1859,'3.000',40,43,30,21,20,10,10277,1153,1996,524,1144,468,278,150,253,6716,0,0,36,175,'varka_silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.47','false',1,0),
(1168,21358,'Varka Silenos Warrior','','barka_silenos_warrior','16.00','41.00',80,'male','L2Monster','Fighter',40,4550,'17.000',1859,'3.000',40,43,30,21,20,10,10771,1209,1649,634,1144,468,278,150,253,142,6918,0,34,175,'varka_silenos_clan',300,'Local','',0,20,170,7,30,4,4,0,-6,'0.48','false',1,0),
(1169,21359,'Grazing Bandersnatch','','bandersnatch','18.00','25.00',80,'male','L2Monster','Fighter',40,4608,'17.000',1896,'3.000',40,43,30,21,20,10,9976,1133,2139,710,1182,477,200,150,182,0,0,0,30,175,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.49','false',1,0),
(1170,21360,'Varka Silenos Medium','','barka_silenos_shaman','14.00','39.50',80,'male','L2Monster','Priest',40,4608,'17.000',1896,'3.000',40,43,30,21,20,10,15892,1804,2588,499,1182,477,200,150,182,6716,0,0,36,150,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.49','false',1,0),
(1171,21361,'Varka Silenos Magus','','barka_silenos_mage_20_bi','11.00','55.20',80,'male','L2Monster','Mystic',40,4663,'17.000',1934,'3.000',40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','false',1,0),
(1172,21362,'Varka Silenos Officer','','barka_silenos_chieftain','18.00','42.50',80,'male','L2Monster','Fighter',40,4663,'17.000',1934,'3.000',40,43,30,21,20,10,11317,1300,2414,657,1220,485,200,150,182,2504,0,0,25,175,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1173,21363,'Grazing Flava','','flava','18.00','34.00',80,'male','L2Monster','Fighter',40,4716,'17.000',1972,'3.000',40,43,30,21,20,10,10475,1217,1619,736,1258,494,278,150,253,0,0,0,30,165,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1174,21364,'Varka Silenos Seer','','barka_silenos_shaman','14.00','39.50',80,'male','L2Monster','Priest',40,4716,'17.000',1972,'3.000',40,43,30,21,20,10,13272,1543,2994,470,1258,494,200,150,182,6716,0,0,36,160,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.49','false',1,0),
(1175,21365,'Varka Silenos Great Magus','','barka_silenos_warrior_20_bi','20.00','49.20',80,'male','L2Monster','Fighter',40,4766,'17.000',2011,'3.000',40,43,30,21,20,10,11525,1355,2428,511,1296,502,278,150,253,2500,0,0,34,175,'varka_silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1176,21366,'Varka Silenos General','','barka_silenos_chieftain','18.00','42.50',80,'male','L2Monster','Fighter',40,4766,'17.000',2011,'3.000',40,43,30,21,20,10,12718,1496,2787,619,1296,502,200,150,182,2500,0,0,25,175,'varka_silenos_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1177,21367,'Grazing Elder Antelope','','antelope','17.00','34.00',80,'male','L2Monster','Fighter',40,4813,'17.000',2049,'3.000',40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,253,0,0,0,45,185,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.46','false',1,0),
(1178,21368,'Varka Silenos Great Seer','','barka_silenos_shaman','14.00','39.50',80,'male','L2Monster','Priest',40,4813,'17.000',2049,'3.000',40,43,30,21,20,10,16964,2019,2851,629,1333,511,200,150,182,6716,0,0,36,160,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.49','false',1,0),
(1179,21369,'Varka''s Commander','','barka_silenos_chieftain_20_bi','22.00','51.00',80,'male','L2Monster','Fighter',40,4608,'17.000',1896,'3.000',40,43,30,21,20,10,15953,1811,2588,587,1182,477,200,150,182,2500,0,0,25,175,'varka_silenos_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1180,21370,'Varka''s Elite Guard','','barka_silenos_warrior','16.00','41.00',80,'male','L2Minion','Fighter',40,4550,'17.000',1859,'3.000',40,43,30,21,20,10,11565,1298,2195,476,1144,468,278,0,253,2500,0,0,34,180,'varka_silenos_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1181,21371,'Varka''s Head Magus','','barka_silenos_shaman','14.00','39.50',80,'male','L2Monster','Priest',40,4813,'17.000',2049,'3.000',40,43,30,21,20,10,12360,1471,3136,572,1333,511,200,150,182,6716,0,0,36,175,'varka_silenos_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,'0.49','false',1,0),
(1182,21372,'Varka''s Head Guard','','barka_silenos_hunter','16.00','38.00',80,'male','L2Minion','Fighter',40,4766,'17.000',2011,'3.000',40,43,30,21,20,10,12279,1444,1658,749,1296,502,278,0,253,2500,6918,0,44,175,'varka_silenos_clan',300,'Local',NULL,0,20,178,7,30,4,4,0,-6,'0.48','false',0,0),
(1183,21373,'Varka''s Prophet','','barka_silenos_shaman_20_bi','17.00','47.50',80,'male','L2Monster','Priest',40,4899,'17.000',2127,'3.000',40,43,30,21,20,10,18082,2204,2973,650,1406,528,200,150,182,6716,0,0,36,175,'varka_silenos_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,0,'0.54','false',1,0),
(1184,21374,'Prophet Guard','','barka_silenos_warrior','16.00','41.00',80,'male','L2Minion','Fighter',40,4858,'17.000',2088,'3.000',40,43,30,21,20,10,12871,1550,2097,639,1370,519,278,0,253,2500,6918,0,34,180,'varka_silenos_clan',300,'Local','',0,20,182,7,30,4,4,0,-6,'0.48','false',0,0),
(1185,21375,'Disciple of Prophet','','barka_silenos_priest','9.00','41.50',80,'male','L2Minion','Priest',40,4858,'17.000',2088,'3.000',40,43,30,21,20,10,12404,1494,2097,639,1370,519,278,0,253,6716,0,0,36,180,'varka_silenos_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.47','false',0,0),
(1186,21376,'Scarlet Stakato Walker','','blade_stakato_worker','13.00','40.00',78,'male','L2Monster','Fighter',40,4428,'42.500',1784,'3.000',40,43,30,21,20,10,7054,772,1886,505,1069,451,278,150,253,235,0,0,25,130,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',1,0),
(1187,21377,'Scarlet Stakato Soldier','','blade_stakato_soldier','15.00','38.00',78,'male','L2Monster','Fighter',40,4428,'42.500',1784,'3.000',40,43,30,21,20,10,6904,755,1886,429,1069,451,278,150,253,148,0,0,25,180,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.74','false',1,0),
(1188,21378,'Scarlet Stakato Noble','','blade_stakato_drone','15.00','39.00',79,'male','L2Monster','Fighter',40,4490,'42.500',1821,'3.000',40,43,30,21,20,10,9829,1089,1941,514,1107,459,278,150,253,235,0,0,25,180,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.58','false',1,0),
(1189,21379,'Tepra Scorpion','','scorpion_20_sm','24.00','52.80',79,'male','L2Monster','Fighter',40,4490,'42.500',1821,'3.000',40,43,30,21,20,10,7098,786,1698,514,1107,459,317,150,289,0,0,0,37,125,'fire_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.54','false',1,0),
(1190,21380,'Tepra Scarab','','scarab','14.00','22.00',79,'male','L2Monster','Fighter',40,4490,'42.500',1821,'3.000',40,43,30,21,20,10,7237,802,1941,514,1107,459,278,150,253,0,0,0,45,175,'fire_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(1191,21381,'Assassin Beetle','','tera_beetle','19.00','54.50',80,'male','L2Monster','Fighter',40,4550,'42.500',1859,'3.000',40,43,30,21,20,10,8414,944,1996,524,1144,468,278,150,253,0,0,0,45,145,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',1,0),
(1192,21382,'Mercenary of Destruction','','skeleton_knight','10.00','25.00',80,'male','L2Monster','Fighter',40,4550,'42.500',1859,'3.000',40,43,30,21,20,10,10380,1165,1996,524,1144,468,278,150,253,150,103,0,40,165,'fire_clan',300,'Local','',0,20,170,7,30,4,4,0,-6,'0.17','false',1,0),
(1193,21383,'Knight of Destruction','','skeleton_royal_guard','11.00','28.50',80,'male','L2Monster','Fighter',40,4550,'42.500',1859,'3.000',40,43,30,21,20,10,10396,1167,1996,524,1144,468,278,150,253,946,945,0,80,185,'fire_clan',300,'Local','',0,20,170,7,30,4,4,0,-6,'0.52','false',1,0),
(1194,21384,'Necromancer of Destruction','','vale_master_20_bi','14.50','48.00',80,'male','L2Monster','Fighter',40,4608,'42.500',1896,'3.000',40,43,30,21,20,10,8915,1012,2050,454,1182,477,278,150,253,0,0,0,70,145,'fire_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.74','false',1,0),
(1195,21385,'Lavastone Golem','','stone_golem','20.00','31.00',80,'male','L2Monster','Mystic',40,4608,'42.500',1896,'3.000',40,43,30,21,20,10,8585,975,2050,534,1182,477,278,150,253,0,0,0,23,40,'fire_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.41','false',1,0),
(1196,21386,'Magma Golem','','lava_golem','22.00','45.00',80,'male','L2Monster','Fighter',40,4608,'42.500',1896,'3.000',40,43,30,21,20,10,9174,1041,2847,534,1182,477,200,150,182,0,0,0,13,60,'fire_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.47','false',1,0),
(1197,21387,'Arimanes of Destruction','','ahrimanes','14.00','57.75',80,'male','L2Monster','Mystic',40,4663,'42.500',1934,'3.000',40,43,30,21,20,10,7314,840,2921,543,1220,485,200,150,182,6722,0,0,35,185,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1198,21388,'Iblis of Destruction','','fiend_archer','17.00','55.00',80,'male','L2Monster','Ranger',40,4663,'51.000',1934,'3.000',40,43,30,21,20,10,9221,1059,2103,543,1220,485,278,150,253,0,0,0,70,150,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',1,0),
(1199,21389,'Balrog of Destruction','','kaim_vanul','24.00','40.00',80,'male','L2Monster','Fighter',40,4716,'51.000',1972,'3.000',40,43,30,21,20,10,9888,1149,2155,553,1258,494,278,150,253,0,0,0,37,155,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1200,21390,'Ashuras of Destruction','','ashuras_30_bi','17.00','49.00',80,'male','L2Monster','Fighter',40,4766,'51.000',2011,'3.000',40,43,30,21,20,10,11408,1342,2207,562,1296,502,278,150,253,0,0,0,41,190,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1201,21391,'Lavasillisk','','lesser_basilisk','12.00','22.00',80,'male','L2Monster','Fighter',40,4716,'51.000',1972,'3.000',40,43,30,21,20,10,7886,916,2155,553,1258,494,278,150,253,0,0,0,35,140,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(1202,21392,'Blazing Ifrit','','ifrit_30_bi','13.00','55.00',80,'male','L2Monster','Mystic',40,4766,'51.000',2011,'3.000',40,43,30,21,20,10,11251,1323,2207,562,1296,502,278,150,253,0,0,0,38,150,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1203,21393,'Magma Drake','','inferno_drake_20_bi','29.00','42.00',80,'male','L2Monster','Mystic',40,4813,'51.000',2049,'3.000',40,43,30,21,20,10,9494,1130,2257,572,1333,511,278,150,253,0,0,0,57,195,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1204,21394,'Lavasaurus','','magmagoil','15.00','75.00',79,'male','L2Monster','Fighter',500,4490,'42.500',1821,'3.000',40,43,30,21,20,10,8988,996,5991,437,1107,459,179,150,163,0,0,0,1,1,'fire_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.48','false',1,0),
(1205,21395,'Elder Lavasaurus','','magmagoil_lad','15.00','75.00',80,'male','L2Monster','Fighter',500,4716,'51.000',1972,'3.000',40,43,30,21,20,10,9760,1134,6652,470,1258,494,179,150,163,0,0,0,1,1,'fire_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.48','false',1,0),
(1206,21396,'Carrion Scarab','','scarab','14.00','22.00',78,'male','L2Monster','Fighter',40,4428,'25.500',1784,'3.000',40,43,30,21,20,10,8182,895,1417,672,1069,451,278,0,253,0,0,0,45,130,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(1207,21397,'Carrion Scarab','','scarab','14.00','22.00',78,'male','L2Monster','Fighter',40,4428,'25.500',1784,'3.000',40,43,30,21,20,10,7103,777,2282,417,1069,451,278,0,253,0,0,0,45,130,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(1208,21398,'Soldier Scarab','','scarab','14.00','22.00',78,'male','L2Monster','Fighter',40,4428,'51.000',1784,'3.000',40,43,30,21,20,10,6744,738,1715,555,1069,451,278,150,253,0,0,0,45,180,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(1209,21399,'Soldier Scarab','','scarab','14.00','22.00',78,'male','L2Monster','Fighter',40,4428,'42.500',1784,'3.000',40,43,30,21,20,10,7736,846,1715,555,1069,451,278,150,253,0,0,0,45,180,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(1210,21400,'Hexa Beetle','','tera_beetle','19.00','54.50',79,'male','L2Monster','Fighter',40,4490,'42.500',1821,'3.000',40,43,30,21,20,10,6611,732,1765,566,1107,459,278,0,253,0,0,0,45,145,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.59','false',1,0),
(1211,21401,'Hexa Beetle','','tera_beetle','19.00','54.50',79,'male','L2Monster','Fighter',40,4490,'34.000',1821,'3.000',40,43,30,21,20,10,7271,806,1941,514,1107,459,278,150,253,0,0,0,45,145,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',1,0),
(1212,21402,'Katraxis','','scorpion_20_sm','24.00','52.80',79,'male','L2Monster','Fighter',40,4490,'34.000',1821,'3.000',40,43,30,21,20,10,7503,831,1544,566,1107,459,317,150,289,0,0,0,37,165,'tomb_clan',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.54','false',0,0),
(1213,21403,'Katraxis','','scorpion_20_sm','24.00','52.80',79,'male','L2Monster','Fighter',40,4490,'42.500',1821,'3.000',40,43,30,21,20,10,6928,767,1544,566,1107,459,317,150,289,0,0,0,37,165,'tomb_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.54','false',0,0),
(1214,21404,'Tera Beetle','','tera_beetle','19.00','54.50',80,'male','L2Monster','Fighter',40,4550,'34.000',1859,'3.000',40,43,30,21,20,10,14906,1673,1649,634,1144,468,278,0,253,0,0,0,45,185,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(1215,21405,'Tera Beetle','','tera_beetle','19.00','54.50',80,'male','L2Monster','Fighter',40,4550,'34.000',1859,'3.000',40,43,30,21,20,10,7146,802,1814,576,1144,468,278,0,253,0,0,0,45,185,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(1216,21406,'Knight of Empire','','skeleton_knight','10.00','25.00',80,'male','L2Monster','Fighter',40,4550,'42.500',1859,'3.000',40,43,30,21,20,10,8454,949,1814,576,1144,468,278,150,253,150,103,0,40,145,'tomb_clan',300,'DRIVER','',0,20,170,7,30,4,4,0,-6,'0.17','false',1,0),
(1217,21407,'Knight of Empire','','skeleton_knight','10.00','25.00',80,'male','L2Monster','Fighter',40,4550,'25.500',1859,'3.000',40,43,30,21,20,10,9017,1012,1814,576,1144,468,278,150,253,150,103,0,40,145,'tomb_clan',300,'Local','',0,20,170,7,30,4,4,0,-6,'0.17','false',1,0),
(1218,21408,'Royal Guard of Empire','','skeleton_pikeman','10.00','28.00',80,'male','L2Monster','Fighter',40,4550,'42.500',1859,'3.000',40,43,30,21,20,10,7358,825,1996,524,1144,468,278,150,253,304,0,0,50,190,'tomb_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.21','false',1,0),
(1219,21409,'Royal Guard of Empire','','skeleton_pikeman','10.00','28.00',80,'male','L2Monster','Fighter',40,4550,'51.000',1859,'3.000',40,43,30,21,20,10,6857,769,1499,698,1144,468,278,150,253,304,0,0,50,190,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.21','false',1,0),
(1220,21410,'Guardian Scarab','','scarab_20_bi','17.00','26.50',80,'male','L2Monster','Fighter',40,4608,'42.500',1896,'3.000',40,43,30,21,20,10,7602,863,1863,587,1182,477,278,0,253,0,0,0,45,195,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(1221,21411,'Guardian Scarab','','scarab_20_bi','17.00','26.50',80,'male','L2Monster','Fighter',40,4608,'34.000',1896,'3.000',40,43,30,21,20,10,7584,861,1863,587,1182,477,278,0,253,0,0,0,45,195,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(1222,21412,'Ustralith','','scorpion','28.00','66.00',80,'male','L2Monster','Fighter',40,4608,'42.500',1896,'3.000',40,43,30,21,20,10,9682,1099,1347,710,1182,477,317,150,289,0,0,0,37,130,'tomb_clan',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.54','false',0,0),
(1223,21413,'Ustralith','','scorpion','28.00','66.00',80,'male','L2Monster','Fighter',40,4608,'42.500',1896,'3.000',40,43,30,21,20,10,7445,845,1793,534,1182,477,317,150,289,0,0,0,37,130,'tomb_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.54','false',0,0),
(1224,21414,'Assassin of Empire','','skeleton_royal_guard','11.00','28.50',80,'male','L2Monster','Fighter',40,4608,'42.500',1896,'3.000',40,43,30,21,20,10,7236,821,1973,485,1182,477,317,0,289,946,945,0,80,175,'tomb_clan',300,'DRIVER','',0,20,172,7,10,8,0,0,-6,'0.52','false',0,0),
(1225,21415,'Assassin of Empire','','skeleton_royal_guard','11.00','28.50',80,'male','L2Monster','Fighter',40,4608,'42.500',1896,'3.000',40,43,30,21,20,10,7299,828,1482,646,1182,477,317,0,289,946,945,0,80,175,'tomb_clan',300,'Local','',0,20,172,7,10,8,0,0,-6,'0.52','false',0,0),
(1226,21416,'Imperial Commander','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4608,'42.500',1896,'3.000',40,43,30,21,20,10,8637,980,1863,587,1182,477,278,150,253,134,6721,0,39,140,'tomb_clan',300,'DRIVER','',0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(1227,21417,'Imperial Commander','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,12557,1425,2255,485,1182,477,278,150,253,134,6721,0,39,140,'tomb_clan',300,'Local','',0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(1228,21418,'Imperial Royal Guard','','death_knight','12.00','30.00',80,'male','L2Monster','Fighter',40,4663,'34.000',1934,'3.000',40,43,30,21,20,10,8030,922,1912,598,1220,485,278,0,253,142,0,0,27,160,'tomb_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(1229,21419,'Imperial Royal Guard','','death_knight','12.00','30.00',80,'male','L2Monster','Fighter',40,4663,'34.000',1934,'3.000',40,43,30,21,20,10,8173,939,1912,598,1220,485,278,0,253,142,0,0,27,160,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(1230,21420,'Ashuras','','ashuras','13.00','37.50',80,'male','L2Monster','Fighter',40,4663,'42.500',1934,'3.000',40,43,30,21,20,10,7704,885,1912,598,1220,485,278,150,253,0,0,0,41,200,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(1231,21421,'Ashuras','','ashuras','13.00','37.50',80,'male','L2Monster','Fighter',40,4663,'42.500',1934,'3.000',40,43,30,21,20,10,7231,830,1912,598,1220,485,278,150,253,0,0,0,41,200,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(1232,21422,'Dancer of Empire','','banshee','9.00','23.00',80,'female','L2Monster','Mystic',40,4663,'51.000',1934,'3.000',40,43,30,21,20,10,6913,794,2103,543,1220,485,278,0,253,0,0,0,80,120,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(1233,21423,'Dancer of Empire','','banshee','9.00','23.00',80,'female','L2Monster','Mystic',40,4663,'51.000',1934,'3.000',40,43,30,21,20,10,7328,842,2103,543,1220,485,278,150,253,0,0,0,80,120,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(1234,21424,'Ashkenas','','ashuras','13.00','37.50',80,'male','L2Monster','Fighter',40,4663,'51.000',1934,'3.000',40,43,30,21,20,10,9288,1067,2544,449,1220,485,278,0,253,0,0,0,41,190,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1235,21425,'Ashkenas','','ashuras','13.00','37.50',80,'male','L2Monster','Fighter',40,4663,'51.000',1934,'3.000',40,43,30,21,20,10,9444,1085,2544,449,1220,485,278,150,253,0,0,0,41,190,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1236,21426,'Abraxion','','erinyes','21.00','50.00',80,'male','L2Monster','Fighter',40,4716,'34.000',1972,'3.000',40,43,30,21,20,10,16312,1896,2722,608,1258,494,200,150,182,0,0,0,31,130,'tomb_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1237,21427,'Abraxion','','erinyes','21.00','50.00',80,'male','L2Monster','Fighter',40,4716,'34.000',1972,'3.000',40,43,30,21,20,10,9587,1114,2722,608,1258,494,200,150,182,0,0,0,31,130,'tomb_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1238,21428,'Hasturan','','erinyes','21.00','50.00',80,'male','L2Monster','Fighter',40,4716,'42.500',1972,'3.000',40,43,30,21,20,10,7324,851,2994,553,1258,494,200,150,182,0,0,0,31,150,'tomb_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1239,21429,'Hasturan','','erinyes','21.00','50.00',80,'male','L2Monster','Fighter',40,4716,'42.500',1972,'3.000',40,43,30,21,20,10,7647,889,2474,669,1258,494,200,150,182,0,0,0,31,150,'tomb_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1240,21430,'Arimanes','','ahrimanes','14.00','57.75',80,'male','L2Monster','Mystic',40,4716,'51.000',1972,'3.000',40,43,30,21,20,10,8801,1023,3293,503,1258,494,200,0,182,6722,0,0,35,210,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1241,21431,'Arimanes','','ahrimanes','14.00','57.75',80,'male','L2Monster','Mystic',40,4716,'51.000',1972,'3.000',40,43,30,21,20,10,7507,872,2249,736,1258,494,200,0,182,6722,0,0,35,210,'tomb_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1242,21432,'Chakram Beetle','','tera_beetle','19.00','54.50',80,'male','L2Monster','Fighter',40,4550,'51.000',1859,'3.000',40,43,30,21,20,10,12155,1364,1814,576,1144,468,278,0,253,0,0,0,45,170,'tomb_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.59','false',1,0),
(1243,21433,'Jamadar Beetle','','tera_beetle_20_sm','15.00','43.60',79,'male','L2Monster','Fighter',40,4490,'51.000',1821,'3.000',40,43,30,21,20,10,11788,1306,1765,566,1107,459,278,0,253,0,0,0,45,175,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(1244,21434,'Seer of Blood','','erinyes','21.00','50.00',82,'male','L2Monster','Fighter',40,4663,'51.000',1934,'3.000',40,43,30,21,20,10,23561,2707,2655,598,1220,485,200,0,182,0,0,0,31,150,'tomb_clan',300,'Magister','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1245,21435,'Guide of Offering','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4550,'51.000',1859,'3.000',40,43,30,21,20,10,11922,1338,1814,576,1144,468,278,0,253,134,6721,0,39,150,'',0,'DRIVER','',0,20,170,7,30,4,4,0,-6,'0.48','false',0,0),
(1246,21436,'Leader of Offering','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4550,'51.000',1859,'3.000',40,43,30,21,20,10,12367,1388,1814,576,1144,468,278,0,253,134,6721,0,39,150,'',0,'DRIVER','',0,20,170,7,30,4,4,0,-6,'0.48','false',0,0),
(1247,21437,'Offering Bug','','scarab','14.00','22.00',79,'male','L2Monster','Fighter',40,4490,'34.000',1821,'3.000',40,43,30,21,20,10,7489,830,1765,566,1107,459,278,0,253,0,0,0,45,180,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(1248,21438,'Heathen Warrior','','skeleton_royal_guard','11.00','28.50',65,'male','L2Monster','Fighter',40,3465,'1.880',1319,'2.700',40,43,30,21,20,10,5966,556,1140,346,619,340,317,150,289,946,945,0,80,175,'undead_clan',300,'Magister','',0,20,135,7,10,8,0,0,-6,'0.52','true',1,0),
(1249,21439,'Heathen Executed','','hungry_spirit','13.00','40.00',66,'male','L2Monster','Fighter',40,3546,'1.880',1353,'2.700',40,43,30,21,20,10,6151,580,1358,301,649,348,278,150,253,0,0,0,15,175,'undead_clan',300,'Magister','',0,0,0,7,30,4,4,0,10,'0.45','true',1,0),
(1250,21440,'Heathen Archer','','skeleton_archer','11.00','27.00',67,'male','L2Monster','Ranger',500,3626,'1.880',1388,'2.700',40,43,30,21,20,10,6735,640,3145,308,681,356,249,0,227,284,0,0,40,155,'undead_clan',300,'Magister','',0,0,0,7,10,8,0,1500,10,'0.80','true',1,0),
(1251,21441,'Heathen Grunt','','skeleton_pikeman','10.00','28.00',68,'male','L2Monster','Fighter',40,3706,'1.880',1423,'2.700',40,43,30,21,20,10,6530,632,1473,371,713,365,278,150,253,96,0,0,50,170,'undead_clan',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.21','true',1,0),
(1252,21442,'Heathen Knight','','skeleton_knight','10.00','25.00',69,'male','L2Monster','Fighter',40,3784,'1.880',1458,'2.700',40,43,30,21,20,10,6723,656,1531,380,746,373,278,150,253,150,103,0,40,165,'undead_clan',300,'Magister','',0,20,145,7,30,4,4,0,-6,'0.17','true',1,0),
(1253,21443,'Raider of Pastureland','','dark_mahum','13.00','26.00',63,'male','L2Monster','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,7006,633,649,530,560,323,317,150,289,153,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.52','true',1,0),
(1254,21444,'Raider of Pastureland','','dark_mahum','13.00','26.00',63,'male','L2Monster','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,5887,532,741,530,560,323,278,150,253,153,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(1255,21445,'Alpen Bandersnatch','','bandersnatch','18.00','25.00',64,'male','L2Monster','Fighter',40,3384,'7.500',1285,'2.700',40,43,30,21,20,10,6076,556,1302,449,589,331,200,150,182,0,0,0,30,170,'nonpet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.49','true',1,0),
(1256,21446,'Raider of Pastureland','','dark_mahum','13.00','26.00',64,'male','L2Monster','Fighter',40,3384,'7.500',1285,'2.700',40,43,30,21,20,10,7476,684,678,543,589,331,317,150,289,160,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.52','true',1,0),
(1257,21447,'Raider of Pastureland','','dark_mahum','13.00','26.00',66,'male','L2Monster','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,7689,724,738,570,649,348,317,150,289,229,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.52','true',1,0),
(1258,21448,'Raider of Pastureland','','dark_mahum','13.00','26.00',66,'male','L2Monster','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,6462,608,843,570,649,348,278,150,253,229,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(1259,21449,'Raider of Pastureland','','dark_mahum','13.00','26.00',68,'male','L2Monster','Fighter',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,8440,815,800,598,713,365,317,150,289,234,0,0,50,165,'nonpet_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.52','true',1,0),
(1260,21450,'Alpen Grendel','','bionic_bear','15.00','39.00',68,'male','L2Monster','Fighter',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,8162,789,1690,449,713,365,200,150,182,0,0,0,36,155,'nonpet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1261,21451,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2FeedableBeast','Fighter',40,3465,'3.750',1319,'2.700',40,43,30,21,20,10,5530,514,1077,418,619,340,278,0,253,0,0,0,13,110,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1262,21452,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2FeedableBeast','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(1263,21453,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2FeedableBeast','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(1264,21454,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2FeedableBeast','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(1265,21455,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2FeedableBeast','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(1266,21456,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2FeedableBeast','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(1267,21457,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2FeedableBeast','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(1268,21458,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2FeedableBeast','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,7312,679,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(1269,21459,'Alpen Kookaburra','','baby_ostrich','7.00','15.00',65,'male','L2FeedableBeast','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,6144,571,890,506,619,340,278,0,253,0,0,0,13,140,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(1270,21460,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2FeedableBeast','Fighter',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(1271,21461,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2FeedableBeast','Fighter',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,7963,740,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(1272,21462,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2FeedableBeast','Fighter',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(1273,21463,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2FeedableBeast','Fighter',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,7367,684,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(1274,21464,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2FeedableBeast','Fighter',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(1275,21465,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2FeedableBeast','Fighter',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,7963,740,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(1276,21466,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2FeedableBeast','Fighter',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(1277,21467,'Alpen Kookaburra','','youth_ostrich','8.00','26.40',65,'male','L2FeedableBeast','Fighter',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,7367,684,1077,418,619,340,278,150,253,0,0,0,23,190,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(1278,21468,'Alpen Kookaburra','','rough_ostrich','10.00','33.00',65,'male','L2FeedableBeast','Fighter',40,3465,'30.000',1319,'2.700',40,43,30,21,20,10,6457,600,1433,314,619,340,278,150,253,0,0,0,23,210,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(1279,21469,'Alpen Kookaburra','','rough_ostrich','10.00','33.00',65,'male','L2FeedableBeast','Fighter',40,3465,'30.000',1319,'2.700',40,43,30,21,20,10,6159,572,1433,314,619,340,278,150,253,0,0,0,23,210,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(1280,21470,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2FeedableBeast','Fighter',40,3626,'3.750',1388,'2.700',40,43,30,21,20,10,5875,560,1169,439,681,356,278,0,253,0,0,0,30,110,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',1,0),
(1281,21471,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2FeedableBeast','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',0,0),
(1282,21472,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2FeedableBeast','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',0,0),
(1283,21473,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2FeedableBeast','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',0,0),
(1284,21474,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2FeedableBeast','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',0,0),
(1285,21475,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2FeedableBeast','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',0,0),
(1286,21476,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2FeedableBeast','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',0,0),
(1287,21477,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2FeedableBeast','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,7769,740,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',0,0),
(1288,21478,'Alpen Buffalo','','baby_buffalo','12.00','15.00',67,'male','L2FeedableBeast','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,6528,622,966,531,681,356,278,0,253,0,0,0,30,130,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.48','false',0,0),
(1289,21479,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2FeedableBeast','Fighter',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.47','false',0,0),
(1290,21480,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2FeedableBeast','Fighter',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,8460,806,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.47','false',0,0),
(1291,21481,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2FeedableBeast','Fighter',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.47','false',0,0),
(1292,21482,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2FeedableBeast','Fighter',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,7828,745,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.47','false',0,0),
(1293,21483,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2FeedableBeast','Fighter',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.47','false',0,0),
(1294,21484,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2FeedableBeast','Fighter',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,8460,806,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.47','false',0,0),
(1295,21485,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2FeedableBeast','Fighter',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.47','false',0,0),
(1296,21486,'Alpen Buffalo','','youth_buffalo','16.00','25.20',67,'male','L2FeedableBeast','Fighter',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,7828,745,1624,439,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.47','false',0,0),
(1297,21487,'Alpen Buffalo','','buffalo','22.00','31.00',67,'male','L2Monster','Fighter',40,3626,'30.000',1388,'2.700',40,43,30,21,20,10,6861,653,2162,329,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','false',0,0),
(1298,21488,'Alpen Buffalo','','buffalo','22.00','31.00',67,'male','L2Monster','Fighter',40,3626,'30.000',1388,'2.700',40,43,30,21,20,10,6544,623,2162,329,681,356,200,150,182,0,0,0,20,170,'pet_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','false',0,0),
(1299,21489,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2FeedableBeast','Fighter',40,3784,'3.750',1458,'2.700',40,43,30,21,20,10,6231,610,1265,460,746,373,278,0,253,0,0,0,28,110,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1300,21490,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2FeedableBeast','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1301,21491,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2FeedableBeast','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1302,21492,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2FeedableBeast','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1303,21493,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2FeedableBeast','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1304,21494,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2FeedableBeast','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1305,21495,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2FeedableBeast','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1306,21496,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2FeedableBeast','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1307,21497,'Alpen Cougar','','baby_tiger','11.00','15.70',69,'male','L2FeedableBeast','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,253,0,0,0,28,130,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1308,21498,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2FeedableBeast','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(1309,21499,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2FeedableBeast','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,8973,878,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(1310,21500,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2FeedableBeast','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(1311,21501,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2FeedableBeast','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,8302,812,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(1312,21502,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2FeedableBeast','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(1313,21503,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2FeedableBeast','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,8973,878,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(1314,21504,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2FeedableBeast','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(1315,21505,'Alpen Cougar','','youth_tiger','16.00','17.20',69,'male','L2FeedableBeast','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,8302,812,1265,460,746,373,278,150,253,0,0,0,60,175,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(1316,21506,'Alpen Cougar','','saber_toothed_tiger','13.00','28.00',69,'male','L2FeedableBeast','Fighter',40,3784,'30.000',1458,'2.700',40,43,30,21,20,10,7276,712,1684,345,746,373,278,150,253,0,0,0,60,200,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0);
INSERT INTO `npc` VALUES
(1317,21507,'Alpen Cougar','','saber_toothed_tiger','12.00','22.00',69,'male','L2FeedableBeast','Fighter',40,3784,'30.000',1458,'2.700',40,43,30,21,20,10,6941,679,1684,345,746,373,278,150,253,0,0,0,60,200,'pet_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(1318,21508,'Splinter Stakato','','blade_stakato','15.00','36.00',66,'male','L2Monster','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,8452,796,1123,364,649,348,278,150,253,235,0,0,25,175,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.46','true',1,0),
(1319,21509,'Splinter Stakato Walker','','blade_stakato_worker','13.00','40.00',67,'male','L2Monster','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,7445,709,1286,339,681,356,278,150,253,0,0,0,25,180,'stakato_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.76','true',1,0),
(1320,21510,'Splinter Stakato Soldier','','blade_stakato_soldier','15.00','38.00',68,'male','L2Monster','Fighter',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,8972,867,1473,371,713,365,278,150,253,148,0,0,25,180,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.74','true',1,0),
(1321,21511,'Splinter Stakato Drone','','blade_stakato_drone','15.00','39.00',69,'male','L2Monster','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,9944,973,1265,460,746,373,278,150,253,132,0,0,25,185,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.58','true',1,0),
(1322,21512,'Splinter Stakato Drone','','blade_stakato_drone','15.00','39.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,12636,1253,1086,569,780,382,278,0,253,132,0,0,25,185,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.58','true',1,0),
(1323,21513,'Needle Stakato','','blade_stakato','15.00','36.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,9507,943,1314,399,780,382,278,150,253,235,0,0,25,185,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.46','true',1,0),
(1324,21514,'Needle Stakato Walker','','blade_stakato_worker','13.00','40.00',71,'male','L2Monster','Fighter',40,3938,'8.500',1529,'3.000',40,43,30,21,20,10,8360,839,1499,371,814,390,278,150,253,0,0,0,25,190,'stakato_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.76','true',1,0),
(1325,21515,'Needle Stakato Soldier','','blade_stakato_soldier','15.00','38.00',72,'male','L2Monster','Fighter',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,10059,1022,1710,406,849,399,278,150,253,148,0,0,25,190,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.74','true',1,0),
(1326,21516,'Needle Stakato Drone','','blade_stakato_drone','15.00','39.00',73,'male','L2Monster','Fighter',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,10340,1064,1463,502,885,407,278,150,253,132,0,0,25,195,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.58','true',1,0),
(1327,21517,'Needle Stakato Drone','','blade_stakato_drone','15.00','39.00',74,'male','L2Monster','Fighter',40,4158,'8.500',1637,'3.000',40,43,30,21,20,10,14121,1472,1250,620,921,416,278,0,253,132,0,0,25,195,'stakato_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.58','true',1,0),
(1328,21518,'Frenzy Stakato Soldier','','blade_stakato_soldier','15.00','38.00',68,'male','L2Monster','Fighter',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,8002,773,1417,337,713,365,317,0,289,235,0,0,25,185,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.74','true',0,0),
(1329,21519,'Frenzy Stakato Drone','','blade_stakato_drone','15.00','39.00',72,'male','L2Monster','Fighter',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,8972,912,1645,369,849,399,317,0,289,235,0,0,25,195,'stakato_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.58','true',0,0),
(1330,21520,'Eye of Splendor','','kel_mahum','13.00','26.00',60,'male','L2Monster','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,7466,648,860,368,478,299,278,0,253,326,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(1331,21521,'Claws of Splendor','','kel_mahum_warrior','13.00','28.00',60,'male','L2Monster','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,7340,637,711,446,478,299,278,0,253,326,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(1332,21522,'Claws of Splendor','','dark_fencer','7.00','13.00',60,'male','L2Monster','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,8748,759,1041,259,478,299,278,0,253,0,0,0,25,155,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.20','true',0,0),
(1333,21523,'Flash of Splendor','','kel_mahum_witch_doctor','13.00','25.00',61,'male','L2Monster','Fighter',40,3137,'7.500',1184,'2.700',40,43,30,21,20,10,7529,663,901,378,505,307,278,150,253,326,0,0,50,150,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(1334,21524,'Blade of Splendor','','kel_mahum','13.00','26.00',61,'male','L2Monster','RndTeleportFighter',40,3137,'7.500',1184,'2.700',40,43,30,21,20,10,8028,707,1200,284,505,307,278,0,253,242,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(1335,21525,'Blade of Splendor','','kel_mahum','13.00','26.00',61,'male','L2Monster','RndTeleportFighter',40,3137,'7.500',1184,'2.700',40,43,30,21,20,10,8028,707,901,378,505,307,278,0,253,242,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',0,0),
(1336,21526,'Wisdom of Splendor','','kel_mahum_warrior','13.00','28.00',62,'male','L2Monster','Fighter',40,3219,'7.500',1217,'2.700',40,43,30,21,20,10,9220,822,944,388,532,315,278,150,253,193,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(1337,21527,'Anger of Splendor','','kel_mahum_champion','13.00','32.00',63,'male','L2Monster','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,8132,734,987,398,560,323,278,0,253,193,0,0,50,150,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(1338,21528,'Anger of Splendor','','dark_fencer','7.00','13.00',63,'male','L2Monster','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,9645,871,987,398,560,323,278,0,253,0,0,0,25,155,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.20','true',0,0),
(1339,21529,'Soul of Splendor','','kel_mahum_witch_doctor','13.00','25.00',63,'male','L2Monster','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,7377,666,987,398,560,323,278,150,253,193,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(1340,21530,'Victory of Splendor','','kel_mahum','13.00','26.00',64,'male','L2Monster','Fighter',40,3384,'7.500',1285,'2.700',40,43,30,21,20,10,8006,733,1031,408,589,331,278,0,253,196,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(1341,21531,'Punishment of Splendor','','kel_mahum_warrior','13.00','28.00',64,'male','L2Monster','RndTeleportFighter',40,3384,'7.500',1285,'2.700',40,43,30,21,20,10,8837,809,1373,306,589,331,278,0,253,242,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(1342,21532,'Shout of Splendor','','kel_mahum_champion','13.00','32.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,9456,879,1077,418,619,340,278,150,253,196,0,0,50,150,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(1343,21533,'Alliance of Splendor','','kel_mahum_witch_doctor','13.00','25.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,7767,722,890,430,619,340,278,0,253,196,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.28','true',1,0),
(1344,21534,'Alliance of Splendor','','dark_fencer','7.00','13.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,10267,954,1303,346,619,340,278,0,253,0,0,0,25,155,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.20','true',0,0),
(1345,21535,'Signet of Splendor','','kel_mahum_warrior','13.00','28.00',66,'male','L2Monster','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,9331,878,1123,428,649,348,278,150,253,189,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(1346,21536,'Crown of Splendor','','kel_mahum_champion','13.00','32.00',66,'male','L2Monster','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,9487,893,1123,428,649,348,278,0,253,189,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(1347,21537,'Fang of Splendor','','kel_mahum_witch_doctor','13.00','25.00',67,'male','L2Monster','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,8905,848,966,451,681,356,278,0,253,189,0,0,50,155,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.28','true',1,0),
(1348,21538,'Fang of Splendor','','dark_fencer','7.00','13.00',67,'male','L2Monster','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,10908,1039,1415,362,681,356,278,0,253,0,0,0,25,155,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.20','true',0,0),
(1349,21539,'Wailing of Splendor','','kel_mahum','13.00','26.00',67,'male','L2Monster','RndTeleportFighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,9685,922,1557,329,681,356,278,0,253,242,0,0,50,170,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(1350,21540,'Wailing of Splendor','','kel_mahum','13.00','26.00',67,'male','L2Monster','RndTeleportFighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,9685,922,1169,439,681,356,278,0,253,242,0,0,50,170,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',0,0),
(1351,21541,'Pilgrim of Splendor','','kel_mahum_witch_doctor','13.00','25.00',63,'male','L2Monster','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,9944,898,987,338,560,323,278,150,253,315,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.28','true',1,0),
(1352,21542,'Disciple of Pilgrim','','kel_mahum_warrior','13.00','28.00',62,'male','L2Monster','Fighter',40,3219,'7.500',1217,'2.700',40,43,30,21,20,10,6932,618,1038,353,532,315,278,0,253,193,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(1353,21543,'Page of Pilgrim','','kel_mahum','13.00','26.00',62,'male','L2Monster','Fighter',40,3219,'7.500',1217,'2.700',40,43,30,21,20,10,7909,705,858,427,532,315,278,0,253,326,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',0,0),
(1354,21544,'Judge of Splendor','','kel_mahum_champion','13.00','32.00',67,'male','L2Monster','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,11331,1079,1169,439,681,356,278,150,253,150,0,0,50,160,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(1355,21545,'Judge of Fire','','kel_mahum_witch_doctor','13.00','25.00',66,'male','L2Monster','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,7855,739,1235,331,649,348,278,0,253,189,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.28','true',0,0),
(1356,21546,'Judge of Light','','kel_mahum','13.00','26.00',66,'male','L2Monster','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,8963,844,1020,471,649,348,278,0,253,196,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',0,0),
(1357,21547,'Corrupted Knight','','skeleton_knight','10.00','25.00',63,'male','L2Monster','RndTeleportFighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,8116,733,987,398,560,323,278,0,253,150,103,0,40,165,'necro_clan',300,'Local','',0,20,131,30,30,4,4,0,-6,'0.17','true',1,0),
(1358,21548,'Resurrected Knight','','skeleton_knight','10.00','25.00',63,'male','L2Monster','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,7019,634,987,398,560,323,278,0,253,150,103,0,40,165,'necro_clan',300,'Local','',0,20,131,30,30,4,4,0,-6,'0.17','true',1,0),
(1359,21549,'Corrupted Guard','','skeleton_royal_guard','11.00','28.50',64,'male','L2Monster','Fighter',40,3384,'7.500',1285,'2.700',40,43,30,21,20,10,8375,767,902,408,589,331,317,0,289,946,0,0,80,175,'necro_clan',300,'Local','',0,0,0,30,10,8,0,0,0,'0.52','true',1,0),
(1360,21550,'Corrupted Guard','','skeleton_royal_guard','11.00','28.50',64,'male','L2Monster','RndTeleportFighter',40,3384,'7.500',1285,'2.700',40,43,30,21,20,10,8543,782,1201,306,589,331,317,150,289,946,945,0,80,175,'necro_clan',300,'Local','',0,20,133,30,10,8,0,0,-6,'0.52','true',1,0),
(1361,21551,'Resurrected Guard','','skeleton_royal_guard','11.00','28.50',66,'male','L2Monster','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,9541,898,982,428,649,348,317,0,289,221,0,0,80,175,'necro_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.52','true',1,0),
(1362,21552,'Resurrected Guard','','skeleton_royal_guard','11.00','28.50',66,'male','L2Monster','RndTeleportFighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,9085,855,1307,322,649,348,317,150,289,221,945,0,80,175,'necro_clan',300,'Local','',0,20,138,7,10,8,0,0,-6,'0.52','true',1,0),
(1363,21553,'Trampled Man','','zombie','13.00','21.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,6267,582,1077,355,619,340,278,0,253,0,0,0,15,40,'necro_clan',300,'Local','',0,0,0,30,30,4,4,0,10,'0.43','true',1,0),
(1364,21554,'Trampled Man','','zombie','13.00','21.00',65,'male','L2Monster','RndTeleportFighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,6267,582,1303,294,619,340,278,0,253,0,0,0,15,40,'necro_clan',300,'Local','',0,0,0,30,30,4,4,0,10,'0.43','true',1,0),
(1365,21555,'Slaughter Executioner','','dark_horror','20.00','35.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,7619,708,979,391,619,340,278,0,253,0,0,0,100,160,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.37','true',1,0),
(1366,21556,'Slaughter Executioner','','dark_horror','20.00','35.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,7435,691,1077,355,619,340,278,0,253,0,0,0,100,160,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.37','true',1,0),
(1367,21557,'Bone Snatcher','','black_magician','8.00','30.00',66,'male','L2Monster','Mystic',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,8774,826,1123,428,649,348,278,0,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1368,21558,'Bone Snatcher','','black_magician','8.00','30.00',66,'male','L2Monster','Mystic',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,8774,826,1123,428,649,348,278,0,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1369,21559,'Bone Maker','','black_magician','8.00','30.00',66,'male','L2Monster','Mystic',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,9596,903,1020,471,649,348,278,150,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1370,21560,'Bone Shaper','','black_magician','8.00','30.00',66,'male','L2Monster','Mystic',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,9596,903,1020,471,649,348,278,150,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1371,21561,'Sacrificed Man','','zombie','13.00','21.00',67,'male','L2Monster','RndTeleportFighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,8057,767,1063,410,681,356,278,150,253,0,0,0,15,40,'necro_clan',300,'Local','',0,0,0,30,30,4,4,0,10,'0.43','true',1,0),
(1372,21562,'Guillotine''s Ghost','','liviona','15.00','28.00',67,'male','L2Monster','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,8344,795,1169,373,681,356,278,150,253,0,0,0,80,150,'necro_clan',300,'Local',NULL,0,0,0,7,50,1,9,0,10,'0.34','true',1,0),
(1373,21563,'Bone Collector','','black_magician','8.00','30.00',67,'male','L2Monster','Mystic',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,9695,923,1286,399,681,356,278,0,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1374,21564,'Skull Collector','','black_magician','8.00','30.00',67,'male','L2Monster','Mystic',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,9223,878,1286,399,681,356,278,150,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1375,21565,'Bone Animator','','black_magician','8.00','30.00',68,'male','L2Monster','Mystic',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,9314,900,1339,408,713,365,278,0,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1376,21566,'Skull Animator','','black_magician','8.00','30.00',68,'male','L2Monster','Mystic',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,10186,984,1339,408,713,365,278,150,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1377,21567,'Bone Slayer','','black_magician','8.00','30.00',68,'male','L2Monster','Mystic',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,12175,1176,1106,494,713,365,278,150,253,178,0,0,19,180,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1378,21568,'Devil Bat','','vampire_bat','10.00','33.50',68,'male','L2Monster','Mystic',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,10440,1009,1473,315,713,365,278,150,253,0,0,0,60,170,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.50','true',1,0),
(1379,21569,'Devil Bat','','vampire_bat','10.00','33.50',68,'male','L2Monster','Mystic',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,8108,783,1217,382,713,365,278,150,253,0,0,0,60,170,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.50','true',1,0),
(1380,21570,'Ghost of Betrayer','','binding','12.00','21.00',69,'male','L2Monster','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,7557,739,1150,506,746,373,278,150,253,0,0,0,10,174,'necro_clan',300,'Local','',0,0,0,30,30,4,4,0,0,'0.54','true',1,0),
(1381,21571,'Ghost of Rebellion Soldier','','skeleton_knight','10.00','25.00',69,'male','L2Monster','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,10718,1049,1265,460,746,373,278,150,253,150,103,0,40,165,'necro_clan',300,'Local','',0,20,145,7,30,4,4,0,-6,'0.17','true',1,0),
(1382,21572,'Bone Sweeper','','black_magician','8.00','30.00',69,'male','L2Monster','Mystic',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,10282,1006,1392,418,746,373,278,0,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1383,21573,'Atrox','','kailiharim','57.00','39.00',69,'male','L2Monster','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,11456,1121,2127,380,746,373,200,150,182,0,0,0,105,185,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1384,21574,'Bone Grinder','','black_magician','8.00','30.00',70,'male','L2Monster','Mystic',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,12902,1279,1194,517,780,382,278,150,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1385,21575,'Bone Grinder','','black_magician','8.00','30.00',70,'male','L2Monster','Mystic',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,7269,721,1314,470,780,382,278,150,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1386,21576,'Ghost of Guillotine','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,9350,927,1590,330,780,382,278,0,253,0,0,0,80,150,'vampire_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.34','true',1,0),
(1387,21577,'Ghost of Guillotine','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,8195,813,1314,399,780,382,278,0,253,0,0,0,80,150,'vampire_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.34','true',1,0),
(1388,21578,'Behemoth Zombie','','giant_zombie','13.00','40.50',71,'male','L2Monster','RndTeleportFighter',40,3938,'8.500',1529,'3.000',40,43,30,21,20,10,10308,1034,1239,529,814,390,278,0,253,0,0,0,20,90,'necro_clan',300,'Local','',0,0,0,30,30,4,4,0,0,'0.48','true',1,0),
(1389,21579,'Ghost of Rebellion Leader','','skeleton_royal_guard','11.00','28.50',71,'male','L2Monster','Fighter',40,3938,'8.500',1529,'3.000',40,43,30,21,20,10,10843,1088,1193,481,814,390,317,0,289,221,945,0,80,175,'necro_clan',300,'Local','',0,20,150,7,10,8,0,0,-6,'0.52','true',1,0),
(1390,21580,'Bone Caster','','black_magician','8.00','30.00',71,'male','L2Monster','Mystic',40,3938,'8.500',1529,'3.000',40,43,30,21,20,10,10154,1019,1499,437,814,390,278,0,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1391,21581,'Bone Puppeteer','','black_magician','8.00','30.00',71,'male','L2Monster','Mystic',40,3938,'8.500',1529,'3.000',40,43,30,21,20,10,11105,1114,1499,437,814,390,278,150,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1392,21582,'Vampire Soldier','','vampire_soldier','8.00','23.50',71,'male','L2Monster','Fighter',40,3938,'8.500',1529,'3.000',40,43,30,21,20,10,11891,1193,1649,397,814,390,278,0,253,234,0,0,60,190,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(1393,21583,'Bone Scavenger','','black_magician','8.00','30.00',72,'male','L2Monster','Fighter',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,11196,1137,1554,446,849,399,278,0,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1394,21584,'Bone Scavenger','','black_magician','8.00','30.00',72,'male','L2Monster','Fighter',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,10442,1061,1284,540,849,399,278,0,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1395,21585,'Vampire Magician','','vampire_witch','6.00','21.50',72,'female','L2Monster','Mystic',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,9628,978,1710,406,849,399,278,150,253,946,0,0,64,180,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(1396,21586,'Vampire Adept','','vampire_wizard','5.50','28.00',72,'female','L2Monster','Mystic',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,11374,1156,1710,406,849,399,278,150,253,99,0,0,46,180,'vampire_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1397,21587,'Vampire Warrior','','vampire_soldier_20_bi','10.00','29.00',72,'male','L2Monster','Fighter',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,11852,1204,1710,406,849,399,278,0,253,234,0,0,60,190,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(1398,21588,'Vampire Wizard','','vampire_witch','6.00','21.50',73,'female','L2Monster','RndTeleportFighter',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,9936,1022,1947,377,885,407,278,0,253,946,0,0,64,180,'vampire_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(1399,21589,'Vampire Wizard','','vampire_witch','6.00','21.50',73,'female','L2Monster','RndTeleportFighter',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,10168,1046,1099,668,885,407,278,0,253,946,0,0,64,180,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(1400,21590,'Vampire Magister','','vampire_wizard','5.50','28.00',73,'female','L2Monster','Mystic',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,9936,1022,1770,415,885,407,278,0,253,99,0,0,46,180,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1401,21591,'Vampire Magister','','vampire_wizard','5.50','28.00',73,'female','L2Monster','Mystic',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,11462,1179,1770,415,885,407,278,0,253,99,0,0,46,180,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1402,21592,'Vampire Magister','','vampire_wizard','5.50','28.00',73,'female','L2Monster','Mystic',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,7750,797,1330,552,885,407,278,0,253,99,0,0,46,180,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1403,21593,'Vampire Warlord','','vampire_warrior','9.00','31.50',73,'male','L2Monster','Fighter',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,13346,1373,2459,415,885,407,200,0,182,6723,0,0,43,190,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.60','true',1,0),
(1404,21594,'Vampire Warlord','','vampire_warrior','9.00','31.50',73,'male','L2Monster','Fighter',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,12571,1294,2459,415,885,407,200,0,182,6723,0,0,43,190,'vampire_clan',300,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','true',1,0),
(1405,21595,'Vampire Warlord','','vampire_warrior','9.00','31.50',73,'male','L2Monster','Fighter',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,9161,943,1847,552,885,407,200,0,182,6723,0,0,43,190,'vampire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.60','true',1,0),
(1406,21596,'Requiem Lord','','black_magician','8.00','30.00',68,'male','L2Monster','Fighter',40,3706,'7.500',1423,'2.700',40,43,30,21,20,10,12038,1163,1106,494,713,365,278,150,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,1),
(1407,21597,'Requiem Behemoth','','giant_zombie','13.00','40.50',67,'male','L2Minion','RndTeleportFighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,8265,787,1286,399,681,356,278,0,253,0,0,0,20,100,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1408,21598,'Requiem Behemoth','','giant_zombie','13.00','40.50',67,'male','L2Minion','RndTeleportFighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,9179,874,1286,399,681,356,278,0,253,0,0,0,20,100,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1409,21599,'Requiem Priest','','black_magician','8.00','30.00',71,'male','L2Monster','Priest',40,3938,'8.500',1529,'3.000',40,43,30,21,20,10,12750,1279,1239,529,814,390,278,150,253,178,0,0,19,185,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,1),
(1410,21600,'Requiem Behemoth','','giant_zombie','13.00','40.50',70,'male','L2Minion','RndTeleportFighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,9022,895,1445,427,780,382,278,0,253,0,0,0,20,100,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1411,21601,'Requiem Behemoth','','giant_zombie','13.00','40.50',70,'male','L2Minion','RndTeleportFighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,10732,1064,1445,427,780,382,278,0,253,0,0,0,20,100,'necro_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1412,21602,'Zaken''s Pikeman','','skeleton_pikeman','10.00','28.00',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,3693,250,332,223,163,181,278,150,253,292,0,0,50,174,'undead_clan1',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.21','true',0,0),
(1413,21603,'Zaken''s Pikeman','','skeleton_pikeman','10.00','28.00',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,5230,354,442,167,163,181,278,150,253,292,0,0,50,174,'undead_clan1',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.21','true',0,0),
(1414,21604,'Zaken''s Elite Pikeman','','skeleton_pikeman_20_bi','12.00','33.60',43,'male','L2Monster','Fighter',40,1728,'22.000',618,'2.100',40,43,30,21,20,10,2114,143,332,223,163,181,278,150,253,292,0,0,50,174,'undead_clan1',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.21','false',1,0),
(1415,21605,'Zaken''s Archer','','skeleton_archer','11.00','27.00',44,'male','L2Monster','Ranger',500,1799,'5.500',648,'2.100',40,43,30,21,20,10,4109,281,788,230,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,'Local',NULL,0,0,0,7,10,8,0,1500,0,'0.80','true',0,0),
(1416,21606,'Zaken''s Archer','','skeleton_archer','11.00','27.00',44,'male','L2Monster','Ranger',500,1799,'5.500',648,'2.100',40,43,30,21,20,10,5818,398,1048,173,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,'Local',NULL,0,0,0,7,10,8,0,1500,0,'0.80','true',0,0),
(1417,21607,'Zaken''s Elite Archer','','skeleton_archer_20_bi','13.00','32.50',44,'male','L2Monster','Ranger',500,1799,'22.000',648,'2.100',40,43,30,21,20,10,2273,155,788,230,176,187,249,0,227,279,0,0,40,174,'undead_clan1',300,'Local',NULL,0,0,0,7,10,8,0,1500,0,'0.80','false',1,0),
(1418,21608,'Zaken''s Watchman','','liviona','15.00','28.00',45,'male','L2Monster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,3365,234,377,202,188,193,278,150,253,0,0,0,80,174,NULL,0,'Local',NULL,0,0,0,7,50,1,9,0,10,'0.34','true',0,0),
(1419,21609,'Zaken''s Watchman','','liviona','15.00','28.00',45,'male','L2Monster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,4766,331,502,152,188,193,278,150,253,0,0,0,80,174,NULL,0,'Local',NULL,0,0,0,7,50,1,9,0,10,'0.34','true',0,0),
(1420,21610,'Zaken''s High Grade Watchman','','liviona_20_bi','18.00','33.60',45,'male','L2Monster','Fighter',40,1870,'22.000',677,'2.100',40,43,30,21,20,10,2174,151,377,202,188,193,278,150,253,0,0,0,80,174,NULL,0,'Local',NULL,0,0,0,7,50,1,9,0,10,'0.34','false',1,0),
(1421,21611,'Unpleasant Humming','','unpleasant_humming','12.00','26.00',46,'male','L2Monster','Fighter',40,1943,'5.500',707,'2.100',40,43,30,21,20,10,3907,277,401,245,202,199,278,150,253,0,0,0,21,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','true',0,0),
(1422,21612,'Unpleasant Humming','','unpleasant_humming','12.00','26.00',46,'male','L2Monster','Fighter',40,1943,'5.500',707,'2.100',40,43,30,21,20,10,5533,392,534,184,202,199,278,150,253,0,0,0,21,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','true',0,0),
(1423,21613,'Unpleasant Shout','','unpleasant_humming_20_bi','13.50','31.20',46,'male','L2Monster','Fighter',40,1943,'22.000',707,'2.100',40,43,30,21,20,10,2360,167,401,245,202,199,278,150,253,0,0,0,21,174,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',1,0),
(1424,21614,'Death Flyer','','dark_horror','20.00','35.00',47,'male','L2Monster','Fighter',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,4035,289,427,253,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.37','true',0,0),
(1425,21615,'Death Flyer','','dark_horror','20.00','35.00',47,'male','L2Monster','Fighter',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,5714,410,568,190,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.37','true',0,0),
(1426,21616,'Gigantic Flyer','','dark_horror_bi','20.00','42.00',47,'male','L2Monster','Fighter',40,2016,'22.000',738,'2.100',40,43,30,21,20,10,2607,187,427,253,216,206,278,0,253,0,0,0,100,174,'undead_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.37','false',1,0),
(1427,21617,'Fiend Archer','','fiend_archer','17.00','55.00',48,'male','L2Monster','Ranger',500,2091,'5.500',768,'2.100',40,43,30,21,20,10,4103,300,1007,222,231,212,249,150,227,0,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,1500,10,'0.76','true',0,0),
(1428,21618,'Fiend Archer','','fiend_archer','17.00','55.00',48,'male','L2Monster','Ranger',500,2091,'5.500',768,'2.100',40,43,30,21,20,10,5811,425,1341,167,231,212,249,150,227,0,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,1500,10,'0.76','true',0,0),
(1429,21619,'Pit Archer','','fiend_archer_20_bi','20.00','66.00',48,'male','L2Monster','Ranger',500,2091,'22.000',768,'2.100',40,43,30,21,20,10,2651,193,1007,222,231,212,249,150,227,0,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,1500,10,'0.76','false',1,0),
(1430,21620,'Musveren','','field_stalker','15.00','30.00',49,'male','L2Monster','Fighter',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,3951,292,480,270,247,219,278,0,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',0,0),
(1431,21621,'Musveren','','field_stalker','15.00','30.00',49,'male','L2Monster','Fighter',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,5595,414,640,202,247,219,278,0,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',0,0),
(1432,21622,'Greater Musveren','','field_stalker_20_bi','18.00','36.00',49,'male','L2Monster','Fighter',40,2168,'22.000',799,'2.100',40,43,30,21,20,10,2553,188,480,270,247,219,278,0,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','false',1,0),
(1433,21623,'Zaken''s Guard','','skeleton_royal_guard','11.00','28.50',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,4994,376,445,278,264,226,317,150,289,225,945,0,80,174,'undead_clan',300,'Local',NULL,0,20,100,7,10,8,0,0,-6,'0.52','true',0,0),
(1434,21624,'Zaken''s Guard','','skeleton_royal_guard','11.00','28.50',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,7072,533,593,209,264,226,317,150,289,225,945,0,80,174,'undead_clan',300,'Local',NULL,0,20,100,7,10,8,0,0,-6,'0.52','true',0,0),
(1435,21625,'Zaken''s Elite Guard','','skeleton_royal_guard_20_bi','13.00','34.50',50,'male','L2Monster','Fighter',40,2245,'22.000',830,'2.100',40,43,30,21,20,10,2858,215,445,278,264,226,317,150,289,225,945,0,80,174,'undead_clan',300,'Local',NULL,0,20,100,7,10,8,0,0,-6,'0.52','false',1,0),
(1436,21626,'Kaim Vanul','','kaim_vanul','24.00','40.00',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,4453,340,539,286,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',0,0),
(1437,21627,'Kaim Vanul','','kaim_vanul','24.00','40.00',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,6306,481,718,215,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',0,0),
(1438,21628,'Kaim Vanul Lad','','kaim_vanul_20_bi','28.00','48.00',51,'male','L2Monster','Fighter',40,2323,'26.000',861,'2.400',40,43,30,21,20,10,2877,219,539,286,281,232,278,0,253,0,0,0,37,174,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1439,21629,'Pirate Zombie Captain','','pirates_zombie_captain','17.00','28.00',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,6727,520,499,295,300,239,317,150,289,232,0,0,14,174,'zaken_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.76','true',0,0),
(1440,21630,'Pirate Zombie Captain','','pirates_zombie_captain','17.00','28.00',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,9526,737,664,221,300,239,317,150,289,232,0,0,14,174,'zaken_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.76','true',0,0),
(1441,21631,'Zombie Captain''s Spiritual Body','','pirates_zombie_captain_20_bi','20.00','33.60',52,'male','L2Monster','Fighter',40,2402,'26.000',892,'2.400',40,43,30,21,20,10,3948,305,499,295,300,239,317,150,289,232,0,0,14,174,'zaken_clan',300,'Local',NULL,0,0,0,7,10,8,0,0,0,'0.76','false',1,0),
(1442,21632,'Doll Blader','','doll_blader','6.00','12.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,5339,420,527,258,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,'Local','',0,0,93,7,10,8,0,0,10,'0.50','true',0,0),
(1443,21633,'Doll Blader','','doll_blader','6.00','12.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,7560,594,701,194,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,'Local','',0,0,93,7,10,8,0,0,10,'0.50','true',0,0),
(1444,21634,'Crimson Doll Blader','','doll_blader_20_bi','7.00','15.00',53,'male','L2Monster','Fighter',40,2481,'26.000',923,'2.400',40,43,30,21,20,10,3450,271,527,258,319,247,317,0,289,5129,5129,0,22,174,'zaken_clan',300,'Local','',0,0,93,7,10,8,0,0,10,'0.50','false',1,0),
(1445,21635,'Vale Master','','vale_master','12.00','40.00',54,'male','L2Monster','Fighter',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,5093,406,636,266,339,254,278,150,253,0,0,0,70,174,'zaken_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.74','true',0,0),
(1446,21636,'Vale Master','','vale_master','12.00','40.00',54,'male','L2Monster','Fighter',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,7212,575,846,199,339,254,278,150,253,0,0,0,70,174,'zaken_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.74','true',0,0),
(1447,21637,'Crimson Vale Master','','vale_master_20_bi','14.50','48.00',54,'male','L2Monster','Fighter',40,2562,'26.000',955,'2.400',40,43,30,21,20,10,3291,262,636,266,339,254,278,150,253,0,0,0,70,174,'zaken_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.74','false',1,0),
(1448,21638,'Dread Wolf','','dire_wolf','13.00','11.00',35,'male','L2Monster','Fighter',40,1220,'2.250',446,'1.800',40,43,30,21,20,10,2303,136,211,154,89,137,278,150,253,0,0,0,24,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(1449,21639,'Tasaba Lizardman','','virud_lizardman_scout','10.00','22.00',36,'male','L2Monster','Ranger',500,1279,'2.250',463,'1.800',40,43,30,21,20,10,2725,164,417,193,96,142,249,0,227,2507,0,0,43,140,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.72','true',1,0),
(1450,21640,'Tasaba Lizardman Shaman','','virud_lizardman_shaman','10.00','29.00',37,'male','L2Monster','Priest',40,1338,'2.250',480,'1.800',40,43,30,21,20,10,2003,124,295,116,104,147,278,0,253,7,0,0,43,140,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.48','true',1,0),
(1451,21641,'Ogre','','ogre','21.00','44.00',38,'male','L2Monster','Fighter',40,1400,'2.250',497,'1.800',40,43,30,21,20,10,3555,222,300,207,112,153,200,150,182,98,0,0,22,174,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.69','true',1,0),
(1452,21642,'Tasaba Lizardman Sniper','','virud_lizardman_scout','10.00','22.00',39,'male','L2Monster','Ranger',500,1462,'2.250',514,'1.800',40,43,30,21,20,10,3263,208,566,165,121,158,249,150,227,2507,0,0,43,140,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.72','true',1,0),
(1453,21643,'Tasaba Lizardman Sniper','','virud_lizardman_scout','10.00','22.00',39,'male','L2Monster','Ranger',500,1462,'2.250',514,'1.800',40,43,30,21,20,10,4146,264,685,137,121,158,249,150,227,2507,0,0,43,140,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.72','true',1,0),
(1454,21644,'Lienrik','','lienrik','12.00','50.00',39,'male','L2Monster','Fighter',40,1462,'2.250',514,'1.800',40,43,30,21,20,10,1990,126,297,146,121,158,317,0,289,0,0,0,100,150,'lienrik_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',1,0),
(1455,21645,'Lienrik Lad','','lienrik','12.00','50.00',40,'male','L2Monster','Fighter',40,1527,'2.250',531,'1.800',40,43,30,21,20,10,3836,248,317,151,131,164,317,150,289,0,0,0,100,174,'lienrik_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',1,0),
(1456,21646,'Grave Scarab','','scarab','14.00','22.00',73,'male','L2Monster','Fighter',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,10206,1050,1463,502,885,407,278,0,253,0,0,0,45,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(1457,21647,'Scavenger Scarab','','scarab','14.00','22.00',73,'male','L2Monster','Fighter',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,8609,886,1463,502,885,407,278,150,253,0,0,0,45,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(1458,21648,'Grave Ant','','ant_soldier','35.00','17.00',74,'male','L2Monster','Fighter',40,4158,'8.500',1637,'3.000',40,43,30,21,20,10,9383,978,1513,512,921,416,278,0,253,0,0,0,80,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(1459,21649,'Scavenger Ant','','ant_soldier','35.00','17.00',74,'male','L2Monster','Fighter',40,4158,'8.500',1637,'3.000',40,43,30,21,20,10,11099,1157,1513,512,921,416,278,150,253,0,0,0,80,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(1460,21650,'Shrine Knight','','skeleton_knight','10.00','25.00',75,'male','L2Monster','Fighter',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,10149,1071,1563,523,957,425,278,0,253,150,103,0,40,165,'',0,'Local','',0,20,159,7,30,4,4,0,-6,'0.17','true',1,0),
(1461,21651,'Shrine Guard','','skeleton_pikeman','10.00','28.00',75,'male','L2Monster','Fighter',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,9695,1023,1563,523,957,425,278,0,253,98,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.21','true',1,0),
(1462,21652,'Scarlet Stakato Noble','','blade_stakato_drone','15.00','39.00',79,'male','L2Monster','Fighter',40,4490,'42.500',1821,'3.000',40,43,30,21,20,10,9382,1039,1544,566,1107,459,317,150,289,235,0,0,25,165,'fire_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.58','false',1,0),
(1463,21653,'Assassin Beetle','','tera_beetle','19.00','54.50',80,'male','L2Monster','Fighter',40,4550,'42.500',1859,'3.000',40,43,30,21,20,10,6804,763,1814,576,1144,468,278,150,253,0,0,0,45,165,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',1,0),
(1464,21654,'Necromancer of Destruction','','vale_master_20_bi','14.50','48.00',80,'male','L2Monster','Fighter',40,4608,'42.500',1896,'3.000',40,43,30,21,20,10,8042,913,1863,587,1182,477,278,150,253,0,0,0,70,140,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(1465,21655,'Arimanes of Destruction','','ahrimanes','14.00','57.75',80,'male','L2Monster','Mystic',40,4663,'42.500',1934,'3.000',40,43,30,21,20,10,7148,821,2655,598,1220,485,200,150,182,6722,0,0,35,185,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1466,21656,'Ashuras of Destruction','','ashuras_30_bi','17.00','49.00',80,'male','L2Monster','Fighter',40,4766,'51.000',2011,'3.000',40,43,30,21,20,10,10463,1230,2006,619,1296,502,278,150,253,0,0,0,41,190,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1467,21657,'Magma Drake','','inferno_drake_20_bi','29.00','42.00',80,'male','L2Monster','Mystic',40,4813,'51.000',2049,'3.000',40,43,30,21,20,10,9062,1078,2052,629,1333,511,278,150,253,0,0,0,57,185,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1468,21658,'Punishment of Splendor','','kel_mahum_warrior','13.00','28.00',64,'male','L2Monster','RndTeleportFighter',40,3384,'7.500',1285,'2.700',40,43,30,21,20,10,8837,809,1031,408,589,331,278,0,253,242,0,0,50,165,'saint_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(1469,21659,'Otherworldly Invader Soldier','','neer_crawler','14.00','22.00',30,'male','L2Monster','Fighter',40,954,'10.500',365,'1.500',40,43,30,21,20,10,1457,79,115,119,58,114,317,0,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.37','false',1,0),
(1470,21660,'Otherworldly Invader Soldier','','neer_crawler','14.00','22.00',35,'male','L2Monster','Fighter',40,1220,'13.500',446,'1.800',40,43,30,21,20,10,2073,122,126,191,89,137,317,150,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.37','false',1,0),
(1471,21661,'Otherworldly Invader Archer','','skeleton_archer','11.00','27.00',33,'male','L2Monster','Ranger',500,1109,'13.500',413,'1.800',40,43,30,21,20,10,1492,85,491,100,75,128,249,150,227,275,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.80','false',1,0),
(1472,21662,'Otherworldly Invader Elite Soldier','','dark_horror','20.00','35.00',35,'male','L2Monster','Fighter',40,1220,'13.500',446,'1.800',40,43,30,21,20,10,1726,102,192,144,89,137,278,150,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.37','false',1,0),
(1473,21663,'Otherworldly Invader Shaman','','dark_horror','20.00','35.00',33,'male','L2Monster','Fighter',40,1109,'13.500',413,'1.800',40,43,30,21,20,10,1884,108,166,134,75,128,278,150,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.37','false',1,0),
(1474,21664,'Otherworldly Invader Priest','','dark_horror','20.00','35.00',30,'male','L2Monster','Priest',40,954,'7.000',365,'1.500',40,43,30,21,20,10,1511,82,132,119,58,114,278,0,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.37','false',1,0),
(1475,21665,'Otherworldly Invader Magus','','dark_horror','20.00','35.00',35,'male','L2Monster','Fighter',40,1220,'13.500',446,'1.800',40,43,30,21,20,10,1362,80,256,108,89,137,278,150,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.37','false',1,0);
INSERT INTO `npc` VALUES
(1476,21666,'Otherworldly Invader Martyrs','','dark_horror','20.00','35.00',30,'male','L2Monster','Fighter',40,954,'10.500',365,'1.500',40,43,30,21,20,10,1018,55,132,119,58,114,278,0,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.37','false',1,0),
(1477,21667,'Otherworldly Invader Warrior','','skeleton','11.00','25.00',33,'male','L2Monster','Fighter',40,1109,'13.500',413,'1.800',40,43,30,21,20,10,1211,69,145,157,75,128,317,150,289,220,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','false',1,0),
(1478,21668,'Otherworldly Invader Soldier','','neer_crawler','14.00','22.00',30,'male','L2Monster','Fighter',40,954,'10.500',365,'1.500',40,43,30,21,20,10,1071,58,115,119,58,114,317,150,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.37','false',1,0),
(1479,21669,'Otherworldly Invader Discipline','','skeleton','11.00','25.00',33,'male','L2Monster','Fighter',40,1109,'13.500',413,'1.800',40,43,30,21,20,10,1275,73,145,157,75,128,317,0,289,220,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','false',1,0),
(1480,21670,'Otherworldly Invader Berserker','','skeleton','11.00','25.00',35,'male','L2Monster','Fighter',40,1220,'13.500',446,'1.800',40,43,30,21,20,10,1785,105,139,205,89,137,317,150,289,220,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','false',1,0),
(1481,21671,'Otherworldly Invader Food','','mimic','8.50','8.50',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1308,72,132,140,58,114,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(1482,21672,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',35,'male','L2Monster','Fighter',40,1220,'27.000',446,'1.800',40,43,30,21,20,10,1599,94,192,169,89,137,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.21','false',1,0),
(1483,21673,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',35,'male','L2Monster','Fighter',40,1220,'27.000',446,'1.800',40,43,30,21,20,10,1629,96,192,169,89,137,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.21','false',1,0),
(1484,21674,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',35,'male','L2Monster','Fighter',40,1220,'1.130',446,'1.800',40,43,30,21,20,10,1525,92,192,169,89,137,278,0,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.21','true',1,0),
(1485,21675,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',30,'male','L2Monster','Fighter',40,954,'1.750',365,'1.500',40,43,30,21,20,10,1555,84,132,140,58,114,278,0,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.21','true',1,0),
(1486,21676,'Otherworldly Invader Warrior','','skeleton','11.00','25.00',33,'male','L2Monster','Fighter',40,1109,'27.000',413,'1.800',40,43,30,21,20,10,1452,83,145,157,75,128,317,150,289,220,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,0,'0.30','false',1,0),
(1487,21677,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',30,'male','L2Monster','Fighter',40,954,'21.000',365,'1.500',40,43,30,21,20,10,1164,63,109,170,58,114,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.21','false',1,0),
(1488,21678,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',33,'male','L2Monster','Fighter',40,1109,'27.000',413,'1.800',40,43,30,21,20,10,1409,80,201,130,75,128,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.21','false',1,0),
(1489,21679,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',30,'male','L2Monster','Fighter',40,954,'21.000',365,'1.500',40,43,30,21,20,10,1148,62,109,170,58,114,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.21','false',1,0),
(1490,21680,'Otherworldly Invader Elite Soldier','','skeleton_pikeman','10.00','28.00',35,'male','L2Monster','Fighter',40,1220,'27.000',446,'1.800',40,43,30,21,20,10,1562,92,232,140,89,137,278,150,253,96,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.21','false',1,0),
(1491,21681,'Otherworldly Invader Magus','','dark_horror','20.00','35.00',33,'male','L2Monster','Fighter',40,1109,'27.000',413,'1.800',40,43,30,21,20,10,1343,77,166,157,75,128,278,0,253,0,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',1,0),
(1492,21682,'Dimension Invader Soldier','','neer_crawler','14.00','22.00',40,'male','L2Monster','Fighter',40,1527,'13.500',531,'1.800',40,43,30,21,20,10,2590,167,238,171,131,164,317,0,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.37','false',1,0),
(1493,21683,'Dimension Invader Soldier','','neer_crawler','14.00','22.00',45,'male','L2Monster','Fighter',40,1870,'16.500',677,'2.100',40,43,30,21,20,10,3427,238,248,269,188,193,317,150,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.37','false',1,0),
(1494,21684,'Dimension Invader Archer','','skeleton_archer','11.00','27.00',43,'male','L2Monster','Ranger',500,1728,'16.500',618,'2.100',40,43,30,21,20,10,2534,171,984,142,163,181,249,150,227,279,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.80','false',1,0),
(1495,21685,'Dimension Invader Elite Soldier','','crimson_doll','15.00','38.00',45,'male','L2Monster','Fighter',40,1870,'16.500',677,'2.100',40,43,30,21,20,10,2853,198,377,202,188,193,278,150,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.67','false',1,0),
(1496,21686,'Dimension Invader Shaman','','crimson_doll','15.00','38.00',43,'male','L2Monster','Fighter',40,1728,'16.500',618,'2.100',40,43,30,21,20,10,3199,216,332,189,163,181,278,150,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.67','false',1,0),
(1497,21687,'Dimension Invader Priest','','crimson_doll','15.00','38.00',40,'male','L2Monster','Fighter',40,1527,'9.000',531,'1.800',40,43,30,21,20,10,2686,173,273,171,131,164,278,0,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.67','false',1,0),
(1498,21688,'Dimension Invader Magus','','crimson_doll','15.00','38.00',45,'male','L2Monster','Fighter',40,1870,'16.500',677,'2.100',40,43,30,21,20,10,2253,156,502,152,188,193,278,150,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.67','false',1,0),
(1499,21689,'Dimension Invader Martyrs','','crimson_doll','15.00','38.00',40,'male','L2Monster','Fighter',40,1527,'13.500',531,'1.800',40,43,30,21,20,10,1809,117,273,171,131,164,278,0,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.67','false',1,0),
(1500,21690,'Dimension Invader Warrior','','skeleton_knight','10.00','25.00',43,'male','L2Monster','Fighter',40,1728,'16.500',618,'2.100',40,43,30,21,20,10,2057,139,332,223,163,181,278,150,253,70,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(1501,21691,'Dimension Invader Soldier','','neer_crawler','14.00','22.00',40,'male','L2Monster','Fighter',40,1527,'13.500',531,'1.800',40,43,30,21,20,10,1905,123,238,171,131,164,317,150,289,0,0,0,50,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.37','false',1,0),
(1502,21692,'Dimension Invader Discipline','','skeleton_knight','10.00','25.00',43,'male','L2Monster','Fighter',40,1728,'16.500',618,'2.100',40,43,30,21,20,10,2166,146,332,223,163,181,278,0,253,70,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(1503,21693,'Dimension Invader Berserker','','skeleton_knight','10.00','25.00',45,'male','L2Monster','Fighter',40,1870,'16.500',677,'2.100',40,43,30,21,20,10,2951,205,312,288,188,193,278,150,253,70,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(1504,21694,'Dimension Invader Food','','mimic','8.50','8.50',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2327,150,273,201,131,164,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(1505,21695,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',45,'male','L2Monster','Fighter',40,1870,'33.000',677,'2.100',40,43,30,21,20,10,2643,183,377,238,188,193,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(1506,21696,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',45,'male','L2Monster','Fighter',40,1870,'33.000',677,'2.100',40,43,30,21,20,10,2693,187,377,238,188,193,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(1507,21697,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',45,'male','L2Monster','Fighter',40,1870,'1.380',677,'2.100',40,43,30,21,20,10,2521,176,377,238,188,193,278,0,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(1508,21698,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',40,'male','L2Monster','Fighter',40,1527,'2.250',531,'1.800',40,43,30,21,20,10,2764,178,273,201,131,164,278,0,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',1,0),
(1509,21699,'Dimension Invader Warrior','','skeleton_knight','10.00','25.00',43,'male','L2Monster','Fighter',40,1728,'33.000',618,'2.100',40,43,30,21,20,10,2466,166,332,223,163,181,278,150,253,70,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(1510,21700,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',40,'male','L2Monster','Fighter',40,1527,'27.000',531,'1.800',40,43,30,21,20,10,2070,133,225,244,131,164,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(1511,21701,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',43,'male','L2Monster','Fighter',40,1728,'33.000',618,'2.100',40,43,30,21,20,10,2392,161,402,184,163,181,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(1512,21702,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',40,'male','L2Monster','Fighter',40,1527,'27.000',531,'1.800',40,43,30,21,20,10,2041,131,225,244,131,164,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(1513,21703,'Dimension Invader Elite Soldier','','headless_knight','21.00','31.00',45,'male','L2Monster','Fighter',40,1870,'33.000',677,'2.100',40,43,30,21,20,10,2583,179,457,196,188,193,278,150,253,135,0,0,70,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(1514,21704,'Dimension Invader Magus','','crimson_doll','15.00','38.00',43,'male','L2Monster','Fighter',40,1728,'33.000',618,'2.100',40,43,30,21,20,10,2281,154,332,223,163,181,278,0,253,0,0,0,60,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.67','false',1,0),
(1515,21705,'Purgatory Invader Soldier','','doll_blader','6.00','12.00',50,'male','L2Monster','Fighter',40,2245,'16.500',830,'2.100',40,43,30,21,20,10,4047,305,445,236,264,226,317,0,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,87,7,10,8,0,0,10,'0.50','false',1,0),
(1516,21706,'Purgatory Invader Soldier','','doll_blader','6.00','12.00',55,'male','L2Monster','Fighter',40,2643,'19.500',987,'2.400',40,43,30,21,20,10,5120,413,440,364,360,261,317,150,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,98,7,10,8,0,0,10,'0.50','false',1,0),
(1517,21707,'Purgatory Invader Archer','','skeleton_archer','11.00','27.00',53,'male','L2Monster','Ranger',500,2481,'19.500',923,'2.400',40,43,30,21,20,10,3850,302,1782,194,319,247,249,150,227,282,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.80','false',1,0),
(1518,21708,'Purgatory Invader Elite Soldier','','banshee','9.00','23.00',55,'female','L2Monster','Mystic',40,2643,'19.500',987,'2.400',40,43,30,21,20,10,4262,344,670,273,360,261,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1519,21709,'Purgatory Invader Shaman','','banshee','9.00','23.00',53,'female','L2Monster','Mystic',40,2481,'19.500',923,'2.400',40,43,30,21,20,10,4861,382,602,258,319,247,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1520,21710,'Purgatory Invader Priest','','banshee','9.00','23.00',50,'female','L2Monster','Priest',40,2245,'11.000',830,'2.100',40,43,30,21,20,10,4198,316,509,236,264,226,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1521,21711,'Purgatory Invader Magus','','banshee','9.00','23.00',55,'female','L2Monster','Mystic',40,2643,'19.500',987,'2.400',40,43,30,21,20,10,3365,271,892,205,360,261,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1522,21712,'Purgatory Invader Martyrs','','banshee','9.00','23.00',50,'female','L2Monster','Mystic',40,2245,'16.500',830,'2.100',40,43,30,21,20,10,2828,213,509,236,264,226,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1523,21713,'Purgatory Invader Warrior','','skeleton_royal_guard','11.00','28.50',53,'male','L2Monster','Fighter',40,2481,'19.500',923,'2.400',40,43,30,21,20,10,3125,245,527,304,319,247,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,107,7,10,8,0,0,-6,'0.52','false',1,0),
(1524,21714,'Purgatory Invader Soldier','','doll_blader','6.00','12.00',50,'male','L2Monster','Fighter',40,2245,'16.500',830,'2.100',40,43,30,21,20,10,2977,224,445,236,264,226,317,150,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,87,7,10,8,0,0,10,'0.50','false',1,0),
(1525,21715,'Purgatory Invader Disciples','','skeleton_royal_guard','11.00','28.50',53,'male','L2Monster','Fighter',40,2481,'19.500',923,'2.400',40,43,30,21,20,10,3291,258,527,304,319,247,317,0,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,107,7,10,8,0,0,-6,'0.52','false',1,0),
(1526,21716,'Purgatory Invader Berserker','','skeleton_royal_guard','11.00','28.50',55,'male','L2Monster','Fighter',40,2643,'19.500',987,'2.400',40,43,30,21,20,10,4409,356,484,389,360,261,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,111,7,10,8,0,0,-6,'0.52','false',1,0),
(1527,21717,'Purgatory Invader Food','','mimic','8.50','8.50',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3636,274,509,278,264,226,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(1528,21718,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',55,'female','L2Monster','Mystic',40,2643,'39.000',987,'2.400',40,43,30,21,20,10,3949,318,670,322,360,261,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1529,21719,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',55,'female','L2Monster','Mystic',40,2643,'39.000',987,'2.400',40,43,30,21,20,10,4023,324,670,322,360,261,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1530,21720,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',55,'female','L2Monster','Mystic',40,2643,'1.630',987,'2.400',40,43,30,21,20,10,3766,304,670,322,360,261,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(1531,21721,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',50,'female','L2Monster','Mystic',40,2245,'2.750',830,'2.100',40,43,30,21,20,10,4319,326,509,278,264,226,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(1532,21722,'Purgatory Invader Warrior','','skeleton_royal_guard','11.00','28.50',53,'male','L2Monster','Fighter',40,2481,'39.000',923,'2.400',40,43,30,21,20,10,3746,294,527,304,319,247,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,107,7,10,8,0,0,-6,'0.52','false',1,0),
(1533,21723,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',50,'female','L2Monster','Mystic',40,2245,'33.000',830,'2.100',40,43,30,21,20,10,3235,243,421,336,264,226,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1534,21724,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',53,'female','L2Monster','Mystic',40,2481,'39.000',923,'2.400',40,43,30,21,20,10,3635,285,729,251,319,247,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1535,21725,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',50,'female','L2Monster','Mystic',40,2245,'33.000',830,'2.100',40,43,30,21,20,10,3189,240,421,336,264,226,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1536,21726,'Purgatory Invader Elite Soldier','','bloody_queen','14.00','40.00',55,'female','L2Monster','Mystic',40,2643,'39.000',987,'2.400',40,43,30,21,20,10,3859,311,811,266,360,261,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1537,21727,'Purgatory Invader Magus','','banshee','9.00','23.00',53,'female','L2Monster','Mystic',40,2481,'39.000',923,'2.400',40,43,30,21,20,10,3465,272,602,258,319,247,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1538,21728,'Forbidden Path Invader Elite Soldier','','doll_blader','6.00','12.00',60,'male','L2Monster','Fighter',40,3054,'19.500',1150,'2.400',40,43,30,21,20,10,5828,506,753,313,478,299,317,0,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,108,7,10,8,0,0,10,'0.50','false',1,0),
(1539,21729,'Forbidden Path Invader Elite Soldier','','doll_blader','6.00','12.00',65,'male','L2Monster','Fighter',40,3465,'22.500',1319,'2.700',40,43,30,21,20,10,7151,664,708,473,619,340,317,150,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,119,7,10,8,0,0,10,'0.50','false',1,0),
(1540,21730,'Forbidden Path Invader Archer','','skeleton_archer','11.00','27.00',63,'male','L2Monster','Ranger',500,3302,'22.500',1251,'2.700',40,43,30,21,20,10,5439,491,2920,254,560,323,249,150,227,284,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.80','false',1,0),
(1541,21731,'Forbidden Path Invader Elite Soldier','','banshee','9.00','23.00',65,'female','L2Monster','Mystic',40,3465,'22.500',1319,'2.700',40,43,30,21,20,10,5952,553,1077,355,619,340,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1542,21732,'Forbidden Path Invader Shaman','','banshee','9.00','23.00',63,'female','L2Monster','Mystic',40,3302,'22.500',1251,'2.700',40,43,30,21,20,10,6868,620,987,338,560,323,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1543,21733,'Forbidden Path Invader Priest','','banshee','9.00','23.00',60,'female','L2Monster','Priest',40,3054,'13.000',1150,'2.400',40,43,30,21,20,10,6045,525,860,313,478,299,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1544,21734,'Forbidden Path Invader Magus','','banshee','9.00','23.00',65,'female','L2Monster','Mystic',40,3465,'22.500',1319,'2.700',40,43,30,21,20,10,4700,436,1433,267,619,340,278,150,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1545,21735,'Forbidden Path Invader Martyrs','','banshee','9.00','23.00',60,'female','L2Monster','Mystic',40,3054,'19.500',1150,'2.400',40,43,30,21,20,10,4072,353,860,313,478,299,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1546,21736,'Forbidden Path Invader Warrior','','skeleton_royal_guard','11.00','28.50',63,'male','L2Monster','Fighter',40,3302,'22.500',1251,'2.700',40,43,30,21,20,10,4415,398,864,398,560,323,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,131,7,10,8,0,0,-6,'0.52','false',1,0),
(1547,21737,'Forbidden Path Invader Soldier','','doll_blader','6.00','12.00',60,'male','L2Monster','Fighter',40,3054,'19.500',1150,'2.400',40,43,30,21,20,10,4287,372,753,313,478,299,317,150,289,5129,5129,0,22,165,'ssq_clan',300,'Local','',0,0,108,7,10,8,0,0,10,'0.50','false',1,0),
(1548,21738,'Forbidden Path Invader Disciple','','skeleton_royal_guard','11.00','28.50',63,'male','L2Monster','Fighter',40,3302,'22.500',1251,'2.700',40,43,30,21,20,10,4650,419,864,398,560,323,317,0,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,131,7,10,8,0,0,-6,'0.52','false',1,0),
(1549,21739,'Forbidden Path Invader Berserker','','skeleton_royal_guard','11.00','28.50',65,'male','L2Monster','Fighter',40,3465,'22.500',1319,'2.700',40,43,30,21,20,10,6158,572,778,506,619,340,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,135,7,10,8,0,0,-6,'0.52','false',1,0),
(1550,21740,'Forbidden Path Invader Food','','mimic','8.50','8.50',60,'male','L2Monster','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,5235,454,860,368,478,299,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(1551,21741,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',65,'female','L2Monster','Mystic',40,3465,'45.000',1319,'2.700',40,43,30,21,20,10,5515,512,1077,418,619,340,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1552,21742,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',65,'female','L2Monster','Mystic',40,3465,'45.000',1319,'2.700',40,43,30,21,20,10,5620,522,1077,418,619,340,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1553,21743,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',65,'female','L2Monster','Mystic',40,3465,'1.880',1319,'2.700',40,43,30,21,20,10,5259,488,1077,418,619,340,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(1554,21744,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,'3.250',1150,'2.400',40,43,30,21,20,10,6220,540,860,368,478,299,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(1555,21745,'Forbidden Path Invader Warrior','','skeleton_royal_guard','11.00','28.50',63,'male','L2Monster','Fighter',40,3302,'45.000',1251,'2.700',40,43,30,21,20,10,5294,478,864,398,560,323,317,150,289,946,946,0,80,165,'ssq_clan',300,'Local','',0,20,131,7,10,8,0,0,-6,'0.52','false',1,0),
(1556,21746,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,'39.000',1150,'2.400',40,43,30,21,20,10,4658,404,711,446,478,299,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1557,21747,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',63,'female','L2Monster','Mystic',40,3302,'45.000',1251,'2.700',40,43,30,21,20,10,5136,463,1194,329,560,323,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1558,21748,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,'39.000',1150,'2.400',40,43,30,21,20,10,4592,398,711,446,478,299,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1559,21749,'Forbidden Path Invader Elite Soldier','','bloody_queen','14.00','40.00',65,'female','L2Monster','Mystic',40,3465,'45.000',1319,'2.700',40,43,30,21,20,10,5390,500,1303,346,619,340,278,150,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1560,21750,'Forbidden Path Invader Magus','','banshee','9.00','23.00',63,'female','L2Monster','Mystic',40,3302,'45.000',1251,'2.700',40,43,30,21,20,10,4897,442,987,338,560,323,278,0,253,3939,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(1561,21751,'Dark Omen Invader Soldier','','giant_zombie','13.00','40.00',70,'male','L2Monster','Mystic',40,3862,'22.500',1493,'2.700',40,43,30,21,20,10,7933,786,1314,470,780,382,278,0,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1562,21752,'Dark Omen Invader Soldier','','giant_zombie','13.00','40.00',75,'male','L2Monster','Mystic',40,4229,'25.500',1673,'3.000',40,43,30,21,20,10,9521,1004,1175,696,957,425,278,150,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1563,21753,'Dark Omen Invader Archer','','skeleton_archer','11.00','27.00',73,'male','L2Monster','Ranger',500,4086,'25.500',1601,'3.000',40,43,30,21,20,10,7303,751,4327,320,885,407,249,150,227,288,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.80','false',1,0),
(1564,21754,'Dark Omen Invader Elite Soldier','','doll_master','20.00','42.00',75,'male','L2Monster','Fighter',40,4229,'25.500',1673,'3.000',40,43,30,21,20,10,7925,836,1368,445,957,425,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1565,21755,'Dark Omen Invader Shaman','','doll_master','20.00','42.00',73,'male','L2Monster','Fighter',40,4086,'25.500',1601,'3.000',40,43,30,21,20,10,9222,949,1280,426,885,407,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1566,21756,'Dark Omen Invader Priest','','doll_master','20.00','42.00',70,'male','L2Monster','Priest',40,3862,'15.000',1493,'2.700',40,43,30,21,20,10,8228,816,1150,399,780,382,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1567,21757,'Dark Omen Invader Magus','','doll_master','20.00','42.00',75,'male','L2Monster','Fighter',40,4229,'25.500',1673,'3.000',40,43,30,21,20,10,6258,660,1821,334,957,425,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1568,21758,'Dark Omen Invader Martyrs','','doll_master','20.00','42.00',70,'male','L2Monster','Fighter',40,3862,'22.500',1493,'2.700',40,43,30,21,20,10,5542,549,1150,399,780,382,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1569,21759,'Dark Omen Invader Warrior','','imperial_warlord_zombie','7.00','30.00',73,'male','L2Monster','Fighter',40,4086,'25.500',1601,'3.000',40,43,30,21,20,10,5929,610,1463,502,885,407,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,155,7,30,4,4,0,-6,'0.48','false',1,0),
(1570,21760,'Dark Omen Invader Soldier','','giant_zombie','13.00','40.00',70,'male','L2Monster','Mystic',40,3862,'22.500',1493,'2.700',40,43,30,21,20,10,5835,578,1314,470,780,382,278,150,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1571,21761,'Dark Omen Invader Disciple','','imperial_warlord_zombie','7.00','30.00',73,'male','L2Monster','Fighter',40,4086,'25.500',1601,'3.000',40,43,30,21,20,10,6243,642,1463,502,885,407,278,0,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,155,7,30,4,4,0,-6,'0.48','false',1,0),
(1572,21762,'Dark Omen Invader Berserker','','imperial_warlord_zombie','7.00','30.00',75,'male','L2Monster','Fighter',40,4229,'25.500',1673,'3.000',40,43,30,21,20,10,8198,864,1292,633,957,425,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,159,7,30,4,4,0,-6,'0.48','false',1,0),
(1573,21763,'Dark Omen Invader Food','','mimic','8.50','8.50',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,7126,707,1314,470,780,382,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(1574,21764,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',75,'male','L2Monster','Fighter',40,4229,'51.000',1673,'3.000',40,43,30,21,20,10,7343,774,1563,523,957,425,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1575,21765,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',75,'male','L2Monster','Fighter',40,4229,'51.000',1673,'3.000',40,43,30,21,20,10,7482,789,1563,523,957,425,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1576,21766,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',75,'male','L2Monster','Fighter',40,4229,'2.130',1673,'3.000',40,43,30,21,20,10,7002,740,1563,523,957,425,278,0,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(1577,21767,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',70,'male','L2Monster','Fighter',40,3862,'3.750',1493,'2.700',40,43,30,21,20,10,8466,840,1314,470,780,382,278,0,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(1578,21768,'Dark Omen Invader Warrior','','imperial_warlord_zombie','7.00','30.00',73,'male','L2Monster','Fighter',40,4086,'51.000',1601,'3.000',40,43,30,21,20,10,7108,731,1463,502,885,407,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,155,7,30,4,4,0,-6,'0.48','false',1,0),
(1579,21769,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',70,'male','L2Monster','Fighter',40,3862,'45.000',1493,'2.700',40,43,30,21,20,10,6341,628,1086,569,780,382,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1580,21770,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',73,'male','L2Monster','Fighter',40,4086,'51.000',1601,'3.000',40,43,30,21,20,10,6896,709,1770,415,885,407,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1581,21771,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',70,'male','L2Monster','Fighter',40,3862,'45.000',1493,'2.700',40,43,30,21,20,10,6251,619,1086,569,780,382,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1582,21772,'Dark Omen Invader Elite Soldier','','death_blader','15.00','45.00',75,'male','L2Monster','Fighter',40,4229,'51.000',1673,'3.000',40,43,30,21,20,10,7176,757,1892,432,957,425,278,150,253,1472,0,0,100,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(1583,21773,'Dark Omen Invader Magus','','doll_master','20.00','42.00',73,'male','L2Monster','Fighter',40,4086,'51.000',1601,'3.000',40,43,30,21,20,10,6575,676,1280,426,885,407,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1584,21774,'Messenger Invader Soldier','','giant_zombie','13.00','40.00',80,'male','L2Monster','Mystic',40,4550,'25.500',1859,'3.000',40,43,30,21,20,10,10362,1163,1814,576,1144,468,278,0,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1585,21775,'Messenger Invader Soldier','','giant_zombie','13.00','40.00',80,'male','L2Monster','Mystic',40,4813,'25.500',2049,'3.000',40,43,30,21,20,10,12230,1455,1542,837,1333,511,278,150,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1586,21776,'Messenger Invader Archer','','skeleton_archer','11.00','27.00',80,'male','L2Monster','Ranger',500,4716,'25.500',1972,'3.000',40,43,30,21,20,10,9442,1097,5796,388,1258,494,249,150,227,289,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,1500,10,'0.80','false',1,0),
(1587,21777,'Messenger Invader Elite Soldier','','doll_master','20.00','42.00',80,'male','L2Monster','Fighter',40,4813,'25.500',2049,'3.000',40,43,30,21,20,10,10179,1211,1796,535,1333,511,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1588,21778,'Messenger Invader Shaman','','doll_master','20.00','42.00',80,'male','L2Monster','Fighter',40,4716,'25.500',1972,'3.000',40,43,30,21,20,10,11921,1386,1714,517,1258,494,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1589,21779,'Messenger Invader Priest','','doll_master','20.00','42.00',80,'male','L2Monster','Priest',40,4550,'17.000',1859,'3.000',40,43,30,21,20,10,10747,1206,1587,490,1144,468,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1590,21780,'Messenger Invader Magus','','doll_master','20.00','42.00',80,'male','L2Monster','Fighter',40,4813,'25.500',2049,'3.000',40,43,30,21,20,10,8038,957,2390,402,1333,511,317,150,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1591,21781,'Messenger Invader Martyrs','','doll_master','20.00','42.00',80,'male','L2Monster','Fighter',40,4550,'25.500',1859,'3.000',40,43,30,21,20,10,7239,812,1587,490,1144,468,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1592,21782,'Messenger Invader Warrior','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4716,'25.500',1972,'3.000',40,43,30,21,20,10,7664,891,1959,608,1258,494,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,176,7,30,4,4,0,-6,'0.48','false',1,0),
(1593,21783,'Messenger Invader Soldier','','giant_zombie','13.00','40.00',80,'male','L2Monster','Mystic',40,4550,'25.500',1859,'3.000',40,43,30,21,20,10,7621,855,1814,576,1144,468,278,150,253,0,0,0,20,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(1594,21784,'Messenger Invader Disciple','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4716,'25.500',1972,'3.000',40,43,30,21,20,10,8071,938,1959,608,1258,494,278,0,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,176,7,30,4,4,0,-6,'0.48','false',1,0),
(1595,21785,'Messenger Invader Berserker','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4813,'25.500',2049,'3.000',40,43,30,21,20,10,10530,1253,1696,761,1333,511,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,180,7,30,4,4,0,-6,'0.48','false',1,0),
(1596,21786,'Messenger Invader Food','','mimic','8.50','8.50',80,'male','L2Monster','Fighter',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,9308,1045,1814,576,1144,468,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(1597,21787,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4813,'51.000',2049,'3.000',40,43,30,21,20,10,9432,1122,2052,629,1333,511,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1598,21788,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4813,'51.000',2049,'3.000',40,43,30,21,20,10,9610,1144,2052,629,1333,511,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1599,21789,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4813,'2.130',2049,'3.000',40,43,30,21,20,10,8994,1072,2052,629,1333,511,278,0,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(1600,21790,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4550,'4.250',1859,'3.000',40,43,30,21,20,10,11058,1242,1814,576,1144,468,278,0,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',1,0),
(1601,21791,'Messenger Invader Warrior','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4716,'51.000',1972,'3.000',40,43,30,21,20,10,9189,1068,1959,608,1258,494,278,150,253,134,6721,0,39,165,'ssq_clan',300,'Local','',0,20,176,7,30,4,4,0,-6,'0.48','false',1,0),
(1602,21792,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4550,'51.000',1859,'3.000',40,43,30,21,20,10,8282,929,1499,698,1144,468,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1603,21793,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4716,'51.000',1972,'3.000',40,43,30,21,20,10,8915,1036,2371,503,1258,494,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1604,21794,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4550,'51.000',1859,'3.000',40,43,30,21,20,10,8165,916,1499,698,1144,468,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1605,21795,'Messenger Invader Elite Soldier','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4813,'51.000',2049,'3.000',40,43,30,21,20,10,9217,1097,2483,520,1333,511,278,150,253,78,0,0,40,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(1606,21796,'Messenger Invader Magus','','doll_master','20.00','42.00',80,'male','L2Monster','Fighter',40,4716,'51.000',1972,'3.000',40,43,30,21,20,10,8499,988,1714,517,1258,494,317,0,289,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',1,0),
(1607,21797,'Spirit of Timiniel','','pixy','5.00','25.00',55,'female','L2Monster','Fighter',40,2643,'3.250',987,'2.400',40,43,30,21,20,10,3959,320,554,331,360,261,278,0,253,0,0,0,80,165,'timiniel_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.72','true',1,0),
(1608,21798,'Ghost of a Gatekeeper','','skeleton_knight','10.00','25.00',76,'male','L2Monster','Fighter',40,4297,'17.000',1710,'3.000',40,43,30,21,20,10,7104,759,1614,534,994,433,278,0,253,150,103,0,40,165,'',0,'DRIVER','',0,20,161,7,30,4,4,0,-6,'0.17','false',1,0),
(1609,21799,'Ghost of a Gatekeeper','','skeleton_knight','10.00','25.00',76,'male','L2Monster','Fighter',40,4297,'25.500',1710,'3.000',40,43,30,21,20,10,8710,931,1614,534,994,433,278,0,253,150,103,0,40,165,'',0,'DRIVER','',0,20,161,7,30,4,4,0,-6,'0.17','false',1,0),
(1610,21800,'Vassal Ghost','','zombie','13.00','21.00',77,'male','L2Monster','Mystic',40,4364,'17.000',1747,'3.000',40,43,30,21,20,10,6616,716,1664,544,1031,442,278,0,253,0,0,0,15,165,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.43','false',1,0),
(1611,21801,'Treasure Chest','','mimic','8.50','8.50',21,'male','L2Chest','Fighter',40,575,'3.500',227,'1.500',40,43,30,21,20,10,630,29,63,98,25,80,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1612,21802,'Treasure Chest','','mimic','8.50','8.50',24,'male','L2Chest','Fighter',40,687,'3.500',272,'1.500',40,43,30,21,20,10,771,38,81,111,34,90,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1613,21803,'Treasure Chest','','mimic','8.50','8.50',27,'male','L2Chest','Fighter',40,813,'3.500',318,'1.500',40,43,30,21,20,10,918,47,104,125,45,102,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1614,21804,'Treasure Chest','','mimic','8.50','8.50',30,'male','L2Chest','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1080,59,132,140,58,114,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1615,21805,'Treasure Chest','','mimic','8.50','8.50',33,'male','L2Chest','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1306,75,166,157,75,128,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1616,21806,'Treasure Chest','','mimic','8.50','8.50',36,'male','L2Chest','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,1555,94,206,175,96,142,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1617,21807,'Treasure Chest','','mimic','8.50','8.50',39,'male','L2Chest','Fighter',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,1825,116,255,195,121,158,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1618,21808,'Treasure Chest','','mimic','8.50','8.50',42,'male','L2Chest','Fighter',40,1660,'5.500',589,'2.100',40,43,30,21,20,10,2116,141,311,215,152,175,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1619,21809,'Treasure Chest','','mimic','8.50','8.50',45,'male','L2Chest','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,2430,169,377,238,188,193,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1620,21810,'Treasure Chest','','mimic','8.50','8.50',48,'male','L2Chest','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,2764,202,453,261,231,212,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1621,21811,'Treasure Chest','','mimic','8.50','8.50',51,'male','L2Chest','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3121,238,539,286,281,232,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1622,21812,'Treasure Chest','','mimic','8.50','8.50',54,'male','L2Chest','Fighter',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,3499,279,636,313,339,254,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1623,21813,'Treasure Chest','','mimic','8.50','8.50',57,'male','L2Chest','Fighter',40,2806,'6.500',1052,'2.400',40,43,30,21,20,10,3898,324,743,340,405,276,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1624,21814,'Treasure Chest','','mimic','8.50','8.50',60,'male','L2Chest','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,4320,375,860,368,478,299,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1625,21815,'Treasure Chest','','mimic','8.50','8.50',63,'male','L2Chest','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,4762,430,987,398,560,323,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1626,21816,'Treasure Chest','','mimic','8.50','8.50',66,'male','L2Chest','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,5227,492,1123,428,649,348,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1627,21817,'Treasure Chest','','mimic','8.50','8.50',69,'male','L2Chest','Fighter',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,5713,559,1265,460,746,373,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1628,21818,'Treasure Chest','','mimic','8.50','8.50',72,'male','L2Chest','Fighter',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,6220,632,1413,491,849,399,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1629,21819,'Treasure Chest','','mimic','8.50','8.50',75,'male','L2Chest','Fighter',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,6750,712,1563,523,957,425,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1630,21820,'Treasure Chest','','mimic','8.50','8.50',78,'male','L2Chest','Fighter',40,4428,'8.500',1784,'3.000',40,43,30,21,20,10,7300,799,1715,555,1069,451,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1631,21821,'Treasure Chest','','mimic','8.50','8.50',81,'male','L2Chest','Fighter',40,4608,'8.500',1896,'3.000',40,43,30,21,20,10,7873,894,1863,587,1182,477,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0),
(1632,21822,'Treasure Chest','','mimic','8.50','8.50',84,'male','L2Chest','Fighter',40,4766,'8.500',2011,'3.000',40,43,30,21,20,10,8467,996,2006,619,1296,502,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.56','false',1,0);
INSERT INTO `npc` VALUES
(1633,21823,'Executor of Sacrificial Offerings','','imperial_warlord_zombie','7.00','30.00',80,'male','L2Monster','Fighter',40,4550,'51.000',1859,'3.000',40,43,30,21,20,10,12042,1351,1814,576,1144,468,278,0,253,134,6721,0,39,190,'tomb_clan',300,'DRIVER','',0,20,170,7,30,4,4,0,-6,'0.48','false',0,0),
(1634,21824,'Alpen Kookaburra','','rough_ostrich','20.00','31.00',65,'male','L2FeedableBeast','Fighter',NULL,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1635,21825,'Alpen Kookaburra','','rough_ostrich','20.00','31.00',65,'male','L2FeedableBeast','Fighter',NULL,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1636,21826,'Alpen Buffalo','','buffalo','20.00','31.00',67,'male','L2FeedableBeast','Fighter',NULL,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1637,21827,'Alpen Buffalo','','buffalo','20.00','31.00',67,'male','L2FeedableBeast','Fighter',NULL,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1638,21828,'Alpen Cougar','','saber_toothed_tiger','20.00','31.00',69,'male','L2FeedableBeast','Fighter',NULL,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1639,21829,'Alpen Cougar','','saber_toothed_tiger','20.00','31.00',69,'male','L2FeedableBeast','Fighter',NULL,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(1640,22001,'Grim Wolf','','dire_wolf','13.00','11.00',25,'male','L2Monster','Fighter',40,728,'3.500',287,'1.500',40,43,30,21,20,10,826,41,80,127,37,94,278,0,253,2,0,0,50,110,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1641,22002,'Grim Grizzly','','grizzly','21.00','40.00',26,'male','L2Monster','Fighter',40,770,'3.500',303,'1.500',40,43,30,21,20,10,1078,54,87,132,41,98,278,500,253,0,0,0,90,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(1642,22003,'Grave Robber Scout','','e_traderB_Fdwarf_mon','6.00','18.00',27,'female','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','true',1,0),
(1643,22004,'Grave Robber Lookout','','dwarf_ghost','10.00','18.70',27,'male','L2Monster','Fighter',40,813,'3.500',318,'1.500',40,43,30,21,20,10,1124,58,114,114,45,102,278,500,253,0,0,0,35,131,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(1644,22005,'Grave Robber Ranger','','e_collector_teacher_Fdwarf_mon','8.00','17.50',28,'female','L2Monster','Ranger',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','true',1,0),
(1645,22006,'Grave Robber Guard','','e_collector_teacher_Mdwarf_mon','8.00','17.50',29,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','true',1,0),
(1646,22007,'Ghost of a Soldier','','orc','10.00','21.00',29,'male','L2Monster','Fighter',40,906,'14.000',349,'1.500',40,43,30,21,20,10,927,49,111,149,53,110,278,500,253,221,0,0,60,140,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(1647,22008,'Grave Robber Fighter','','e_collector_teacher_Mdwarf_mon','8.00','17.50',30,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','true',1,0),
(1648,22009,'Ghost of a Loyal Vassal','','orc_shaman','9.00','22.00',31,'male','L2Monster','Mystic',40,1004,'9.000',381,'1.800',40,43,30,21,20,10,1083,60,157,133,64,118,278,0,253,0,0,0,90,90,'',300,'','',0,0,0,7,30,4,4,0,0,'0.30','true',1,0),
(1649,22010,'Ghost of a General','','orc_fighter','12.00','22.00',32,'male','L2Monster','Fighter',40,1056,'9.000',397,'1.800',40,43,30,21,20,10,1200,67,169,138,69,123,278,0,253,0,0,0,40,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(1650,22011,'Ghost of a Batur Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(1651,22012,'Ghost of a Batur Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(1652,22013,'Ghost of a Morek Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(1653,22014,'Ghost of a Morek Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(1654,22015,'Ghost of a Turka Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(1655,22016,'Ghost of a Turka Chief','','orc_champion','10.00','23.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1451,83,151,173,75,128,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(1656,22017,'Bandit Sweeper','','northern_goblin','4.00','15.00',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1308,72,145,128,58,114,278,0,253,0,0,0,30,120,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.24','true',1,0),
(1657,22018,'Bandit Hound','','dire_wolf','13.00','11.00',31,'male','L2Monster','Fighter',40,1004,'4.500',381,'1.800',40,43,30,21,20,10,1425,79,157,133,64,118,278,500,253,0,0,0,40,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',1,0),
(1658,22019,'Bandit Watchman','','ol_mahum_archer_04te','15.00','32.00',32,'male','L2Monster','Fighter',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,1265,71,169,138,69,123,278,500,253,274,0,0,55,130,'',300,'Magister','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(1659,22020,'Snow Lynx','','onyx_beast','14.00','14.50',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1332,76,182,143,75,128,278,500,253,0,0,0,55,110,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.61','true',1,0),
(1660,22021,'Bandit Undertaker','','northern_goblin_110p','6.00','16.60',34,'male','L2Monster','Fighter',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1667,97,196,148,82,132,278,0,253,0,0,0,80,130,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(1661,22022,'Bandit Assassin','','wererat_01te','14.00','25.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,1484,88,192,169,89,137,278,0,253,0,0,0,80,174,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(1662,22023,'Bandit Warrior','','ol_mahum_04te','20.00','37.00',36,'male','L2Monster','Fighter',40,1279,'9.000',463,'1.800',40,43,30,21,20,10,1984,120,227,159,96,142,278,500,253,0,0,0,80,174,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',1,0),
(1663,22024,'Bandit Inspector','','northern_goblin_120p','7.00','18.50',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,1991,122,194,154,104,147,317,0,289,221,0,0,80,174,'',0,'Local','',0,0,0,7,10,8,0,0,10,'0.61','true',1,0),
(1664,22025,'Frozen Wasteland Werewolf','','werewolf','10.00','26.00',38,'male','L2Monster','Fighter',40,1400,'9.000',497,'1.800',40,43,30,21,20,10,2146,134,238,188,112,153,278,0,253,0,0,0,50,120,'werewolf_clan',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','true',1,0),
(1665,22026,'Bandit Captain','','ol_mahum_champion_04te','14.00','27.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2585,167,273,201,131,164,278,500,253,69,19,0,45,174,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1666,22027,'Forgotten Crewman','','dwarf_ghost','10.00','18.70',39,'male','L2Monster','Fighter',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,1880,120,231,214,121,158,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',1,0),
(1667,22028,'Vagabond of the Ruins','','a_mageguild_teacher_Mhuman_mon','8.00','23.00',40,'male','L2Monster','Fighter',40,1527,'2.250',531,'1.800',40,43,30,21,20,10,2421,156,317,151,131,164,317,500,289,0,0,0,100,174,'',300,'','',0,0,0,7,10,8,0,0,0,'0.46','true',1,0),
(1668,22029,'Ragna Orc','','batur_orc_03te','9.00','21.50',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2585,167,273,201,131,164,278,500,253,0,0,0,45,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1669,22030,'Ragna Orc Shaman','','batur_orc_shaman_a_03te','11.00','16.00',42,'male','L2Monster','Mystic',40,1660,'11.000',589,'2.100',40,43,30,21,20,10,2251,150,342,196,152,175,278,500,253,0,0,0,72,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','true',0,0),
(1670,22031,'Ragna Orc Archer','','batur_orc_archer_03te','11.00','21.50',43,'male','L2Monster','Ranger',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,2263,153,365,202,163,181,278,500,253,300,0,0,40,120,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.59','true',1,0),
(1671,22032,'Ragna Orc Warrior','','batur_orc_warrior_03te','10.00','20.00',44,'male','L2Monster','Fighter',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,3350,229,390,209,176,187,278,0,253,0,0,0,140,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(1672,22033,'Ragna Orc Mage','','batur_orc_shaman_a_01te','11.00','16.00',45,'male','L2Monster','Mystic',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(1673,22034,'Ragna Orc Mage','','batur_orc_shaman_a_01te','11.00','16.00',45,'male','L2Monster','Mystic',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(1674,22035,'Ragna Orc Mage','','batur_orc_shaman_a_01te','11.00','16.00',45,'male','L2Monster','Mystic',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(1675,22036,'Ragna Orc Mage','','batur_orc_shaman_a_01te','11.00','16.00',45,'male','L2Monster','Mystic',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',1,0),
(1676,22037,'Ragna Orc Healer','','batur_orc_shaman_a_03te','11.00','16.00',45,'male','L2Monster','Mystic',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,3004,209,377,238,188,193,278,500,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','true',0,0),
(1677,22038,'Ragna Orc Hero','','batur_orc_overlord_03te','12.00','24.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,3987,291,396,261,231,212,317,0,289,221,0,0,80,174,'',300,'Local','',0,0,0,7,10,8,0,0,0,'0.61','true',1,0),
(1678,22039,'Ragna Orc Commander','','batur_orc_overlord_01te','12.00','24.00',49,'male','L2Monster','Fighter',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,3951,292,480,270,247,219,278,0,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(1679,22040,'Ragna Orc Sniper','','batur_orc_archer_01te','11.00','21.50',47,'male','L2Monster','Ranger',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,4004,287,388,279,216,206,278,500,253,5,0,0,34,174,'',400,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',1,0),
(1680,22041,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te','11.00','16.00',50,'male','L2Monster','Mystic',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',1,0),
(1681,22042,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te','11.00','16.00',50,'male','L2Monster','Mystic',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',1,0),
(1682,22043,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te','11.00','16.00',50,'male','L2Monster','Mystic',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',1,0),
(1683,22044,'Ragna Orc Sorcerer','','batur_orc_shaman_a_01te','11.00','16.00',50,'male','L2Monster','Mystic',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,5349,403,560,253,264,226,278,500,253,0,0,0,15,15,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',1,0),
(1684,22045,'Dark Corpse','','zombie_02te','13.00','21.00',40,'male','L2Monster','Fighter',40,381,'4.500',531,'1.800',40,43,30,21,20,10,2175,141,300,183,131,164,278,500,253,0,0,0,60,150,'undead_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.67','true',1,0),
(1685,22046,'Varangka''s Dre Vanul','','dre_vanul','14.00','36.00',46,'male','L2Monster','Fighter',40,485,'11.000',707,'2.100',40,43,30,21,20,10,2408,170,365,270,202,199,278,0,253,0,0,0,70,174,'',400,'Local','',0,0,0,7,50,1,9,0,0,'0.30','true',1,0),
(1686,22047,'Guardian of the Ghost Town','','monster_eye_05te','21.00','43.00',44,'male','L2Monster','Mystic',40,449,'11.000',648,'2.100',40,43,30,21,20,10,2688,184,322,253,176,187,278,500,253,0,0,0,23,23,'',400,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',1,0),
(1687,22048,'Dark Spider','','giant_spider_04te','26.00','25.50',42,'male','L2Monster','Fighter',40,415,'11.000',589,'2.100',40,43,30,21,20,10,2625,175,342,196,152,175,278,500,253,0,0,0,30,174,'',400,'Local','',0,0,0,7,50,1,9,0,0,'0.24','true',1,0),
(1688,22049,'Varangka''s Succubus','','succubus_05te','10.00','36.00',49,'male','L2Monster','Fighter',40,542,'11.000',799,'2.100',40,43,30,21,20,10,3025,223,529,245,247,219,278,0,253,0,0,0,70,174,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.30','true',1,0),
(1689,22050,'Probe Golem Prodigy IV','','golem_microscout','12.00','43.50',46,'male','L2Monster','Fighter',40,1943,'11.000',707,'2.100',40,43,30,21,20,10,2408,170,365,270,202,199,278,0,253,0,0,0,70,174,'',400,'Local','',0,0,0,7,50,1,9,0,0,'0.30','true',1,0),
(1690,22051,'Spelunking Spider','','giant_spider_05te','26.00','25.50',47,'male','L2Monster','Fighter',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,3212,230,427,253,216,206,278,0,253,0,0,0,55,174,'',300,'Magister','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(1691,22052,'Menacing Jackhammer Golem','','golem_prop','23.00','32.80',47,'male','L2Monster','Fighter',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,3212,230,427,253,216,206,278,0,253,0,0,0,55,174,'',300,'Magister','',0,0,0,7,50,1,9,0,0,'0.28','true',1,0),
(1692,22053,'Horrifying Cannon Golem I','','golem_cannon_catapult','23.50','34.70',48,'male','L2Monster','Fighter',40,2091,'16.500',768,'2.100',40,43,30,21,20,10,3076,224,412,288,231,212,278,500,253,0,0,0,45,174,'',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.58','true',1,0),
(1693,22054,'Horrifying Cannon Golem IV','','golem_cannon_catapult','23.50','34.70',48,'male','L2Monster','Fighter',40,2091,'16.500',768,'2.100',40,43,30,21,20,10,3076,224,412,288,231,212,278,500,253,0,0,0,45,174,'',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.58','true',1,0),
(1694,22055,'Cruel Vice Golem','','golem_repair','23.00','32.80',49,'male','L2Monster','Fighter',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,2910,215,361,359,247,219,278,0,253,0,0,0,70,174,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(1695,22056,'Probe Golem Champion I','','golem_microscout','12.00','43.50',49,'male','L2Monster','Fighter',40,2168,'5.500',799,'2.100',40,43,30,21,20,10,2910,215,361,359,247,219,278,0,253,0,0,0,70,174,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(1696,22057,'Spelunking Ant','','ant_soldier','35.00','17.00',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3030,228,560,253,264,226,278,0,253,0,0,0,45,120,'ant_clan',300,'Magiste','',0,0,0,7,30,4,4,0,0,'0.58','true',1,0),
(1697,22058,'Horrifying Excavator Golem III','','golem_carrier','23.00','32.80',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3820,291,593,260,281,232,278,500,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(1698,22059,'Bloodthirsty Ginzu Golem VII','','golem_guardian_090p','16.00','37.20',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3820,291,593,260,281,232,278,500,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',1,0),
(1699,22060,'Horrifying Cannon Golem','','golem_cannon_catapult_a','23.50','34.70',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,4679,362,627,268,300,239,278,0,253,0,0,0,45,174,'',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1700,22061,'Horrifying Cannon Golem III','','golem_microscout_a','12.00','43.50',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3820,291,593,260,281,232,278,500,253,0,0,0,35,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','true',0,0),
(1701,22062,'Horrifying Jackhammer Golem','','golem_prop','23.00','32.80',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,4679,362,627,268,300,239,278,0,253,0,0,0,45,174,'',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1702,22063,'Ginzu Golem Prodigy X','','golem_guardian_090p','16.00','37.20',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,4679,362,627,268,300,239,278,0,253,0,0,0,45,174,'',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1703,22064,'Bloodthirsty Ginzu Golem II','','golem_guardian_a_090p','16.00','37.20',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,4679,362,627,268,300,239,278,0,253,0,0,0,45,174,'',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1704,22065,'Horrifying Ginzu Golem V','','golem_guardian','18.00','41.50',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4085,321,662,276,319,247,278,0,253,0,0,0,15,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(1705,22066,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(1706,22067,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.30','true',0,0),
(1707,22068,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(1708,22069,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(1709,22070,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(1710,22071,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(1711,22072,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.30','true',0,0),
(1712,22073,'Horrifying Cannon Golem VI','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(1713,22074,'Epic Cannon Golem','','golem_cannon_catapult_a_090p','21.00','30.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(1714,22075,'Epic Cannon Golem Adjunct','','golem_microscout_a','12.00','43.50',52,'male','L2Monster','Fighter',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,4633,358,627,268,300,239,278,0,253,0,0,0,100,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(1715,22076,'Deadly Ginzu Golem V','','golem_guardian','18.00','41.50',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4943,389,527,304,319,247,317,0,289,0,0,0,60,160,'',300,'Magister','',0,0,0,7,10,8,0,0,0,'0.30','true',1,0),
(1716,22077,'Horrifying Ginzu Golem VIII','','golem_guardian_a','18.00','41.50',54,'male','L2Monster','Fighter',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,5093,406,636,266,339,254,278,150,253,0,0,0,70,174,'',300,'Local','',0,0,0,7,30,4,4,0,10,'0.74','true',1,0),
(1717,22078,'Deadly Ginzu Golem VIII','','golem_guardian_a','18.00','41.50',54,'male','L2Monster','Fighter',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,5093,406,636,266,339,254,278,150,253,0,0,0,70,174,'',300,'Local','',0,0,0,7,30,4,4,0,10,'0.74','true',1,0),
(1718,22079,'Lost Bandersnatch','','bandersnatch_c','18.00','25.00',53,'male','L2Monster','Fighter',40,620,'6.500',923,'2.400',40,43,30,21,20,10,4167,328,602,304,319,247,278,0,253,0,0,0,70,174,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1719,22080,'Massive Maze Bandersnatch','','bandersnatch','18.00','25.00',54,'male','L2Monster','Fighter',40,640,'6.500',923,'2.400',40,43,30,21,20,10,4167,328,602,304,319,247,278,0,253,0,0,0,70,174,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1720,22081,'Lost Watcher','','field_stalker','16.00','36.00',53,'male','L2Monster','Mystic',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,4813,378,547,334,319,247,278,0,253,0,0,0,100,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(1721,22082,'Elder Lost Watcher','','field_stalker_110p','15.00','30.00',54,'male','L2Monster','Mystic',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,3569,285,699,284,339,254,278,0,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.19','true',1,0),
(1722,22083,'Baby Panthera','','saber_toothed_tiger_080p','29.00','22.70',55,'male','L2Monster','Fighter',40,1321,'6.500',923,'2.400',40,43,30,21,20,10,4167,328,602,304,319,247,278,0,253,0,0,0,70,174,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1723,22084,'Panthera','','saber_toothed_tiger','28.00','29.00',56,'male','L2Monster','Fighter',40,1362,'6.500',923,'2.400',40,43,30,21,20,10,4167,328,602,304,319,247,278,500,253,0,0,0,70,174,'',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',1,0),
(1724,22085,'Lost Gargoyle','','gargoyle_02te','16.00','50.00',55,'female','L2Monster','Fighter',40,2643,'3.250',987,'2.400',40,43,30,21,20,10,3959,320,554,331,360,261,278,0,253,0,0,0,80,165,'',300,'Local','',0,0,0,7,50,1,9,0,10,'0.72','true',1,0),
(1725,22086,'Lost Gargoyle Youngling','','gargoyle_02te_110p','17.50','56.00',56,'female','L2Monster','Mystic',40,2724,'13.000',1019,'2.400',40,43,30,21,20,10,3605,296,777,301,382,269,278,500,253,0,0,0,70,110,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',1,0),
(1726,22087,'Pronghorn Spirit','','antelope','17.00','34.00',56,'female','L2Monster','Fighter',40,2724,'13.000',1019,'2.400',40,43,30,21,20,10,3605,296,777,301,382,269,278,0,253,0,0,0,70,110,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',0,0),
(1727,22088,'Pronghorn','','antelope_110p','19.00','37.80',57,'female','L2Monster','Fighter',40,2806,'3.250',1052,'2.400',40,43,30,21,20,10,8452,702,743,289,405,276,278,0,253,0,0,0,80,174,'',300,'Local','',0,0,0,7,50,1,9,0,10,'0.20','true',0,0),
(1728,22089,'Ice Tarantula','','giant_spider','26.00','25.50',57,'male','L2Monster','Fighter',40,2806,'3.250',1052,'2.400',40,43,30,21,20,10,8452,702,743,289,405,276,278,0,253,0,0,0,80,174,'',300,'Local','',0,0,0,7,50,1,9,0,10,'0.20','true',0,0),
(1729,22090,'Frost Tarantula','','giant_spider_110p','32.00','28.00',58,'male','L2Monster','Fighter',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',1,0),
(1730,22091,'Lost Iron Golem','','iron_golem_120p','22.00','42.50',58,'male','L2Monster','Fighter',40,1444,'3.500',287,'1.500',40,43,30,21,20,10,826,41,80,127,37,94,278,0,253,0,0,0,20,20,'',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1731,22092,'Frost Iron Golem','','iron_golem_130p','25.00','46.40',59,'male','L2Monster','Fighter',40,1485,'3.500',287,'1.500',40,43,30,21,20,10,826,41,80,127,37,94,278,500,253,0,0,0,20,20,'',300,'Magister','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1732,22093,'Lost Buffalo','','buffalo','22.00','31.00',60,'male','L2Monster','Fighter',40,3054,'13.000',1150,'2.400',40,43,30,21,20,10,4097,355,782,405,478,299,278,0,253,0,0,0,80,170,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',0,0),
(1733,22094,'Frost Buffalo','','buffalo_a_110p','24.00','34.70',61,'male','L2Monster','Fighter',40,3137,'22.500',1184,'2.700',40,43,30,21,20,10,4058,357,901,378,505,307,278,500,253,3937,0,0,15,180,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.58','true',1,0),
(1734,22095,'Ursus Cub','','grizzly','21.00','40.00',61,'male','L2Monster','Fighter',40,1568,'3.750',1184,'2.700',40,43,30,21,20,10,2435,214,1091,313,505,307,278,0,253,131,0,0,60,174,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.30','true',1,0),
(1735,22096,'Ursus','','grizzly_120p','20.00','48.80',62,'male','L2Monster','Fighter',40,1609,'3.750',1217,'2.700',40,43,30,21,20,10,2075,185,1142,321,532,315,278,0,253,0,0,0,70,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.41','true',1,0),
(1736,22097,'Lost Yeti','','yeti','15.00','27.50',62,'male','L2Monster','Fighter',40,3219,'22.500',1217,'2.700',40,43,30,21,20,10,6224,554,1142,321,532,315,278,0,253,3937,0,0,15,180,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.58','true',1,0),
(1737,22098,'Frost Yeti','','yeti_110p','20.00','29.80',63,'male','L2Monster','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,5772,521,897,438,560,323,278,0,253,127,0,0,70,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(1738,22099,'Freya''s Buffalo','','buffalo','22.00','31.00',57,'male','L2Monster','Fighter',40,2806,'6.500',1052,'2.400',40,43,30,21,20,10,4725,393,675,374,405,276,278,0,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(1739,22100,'Freya''s Gardener','','field_stalker','16.00','36.00',58,'male','L2Monster','Fighter',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',0,0),
(1740,22101,'Freya''s Servant','','gargoyle_02te','16.00','50.00',58,'male','L2Monster','Fighter',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',0,0),
(1741,22102,'Freya''s Servant','','gargoyle_02te','16.00','50.00',58,'male','L2Monster','Fighter',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',0,0),
(1742,22103,'Freya''s White Bear','','grizzly','21.00','40.00',57,'male','L2Monster','Fighter',40,2806,'6.500',1052,'2.400',40,43,30,21,20,10,4725,393,675,374,405,276,278,0,253,0,0,0,80,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(1743,22104,'Freya''s Dog','','bandersnatch','18.00','25.00',58,'male','L2Monster','Fighter',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',0,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',0,0),
(1744,22105,'Spiked Stakato','','blade_stakato_120p','18.00','43.20',72,'male','L2Monster','Fighter',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,10535,1070,1284,540,849,399,278,500,253,0,0,0,60,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',0,0),
(1745,22106,'Spiked Stakato Worker','','blade_stakato_worker_120p','22.00','48.30',73,'male','L2Monster','Fighter',40,4086,'42.500',1601,'3.000',40,43,30,21,20,10,0,0,1770,415,885,407,278,500,253,148,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',0,0),
(1746,22107,'Spiked Stakato Guard','','spike_stakato','16.00','22.80',74,'male','L2Monster','Fighter',40,4158,'42.500',1637,'3.000',40,43,30,21,20,10,8909,928,1831,423,921,416,278,500,253,147,0,0,50,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',0,0),
(1747,22108,'Female Spiked Stakato','','spike_stakato_soldier','17.00','30.00',74,'male','L2Monster','Fighter',40,4158,'42.500',1637,'3.000',40,43,30,21,20,10,0,0,1831,423,921,416,278,500,253,148,0,0,30,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.52','true',0,0),
(1748,22109,'Male Spiked Stakato','','marsh_stakato_soldier_120p','18.00','31.00',74,'male','L2Monster','Fighter',40,4158,'42.500',1637,'3.000',40,43,30,21,20,10,0,0,1831,423,921,416,278,500,253,148,0,0,30,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.52','true',0,0),
(1749,22110,'Male Spiked Stakato','','marsh_stakato_soldier_tran','16.00','28.40',74,'male','L2Monster','Fighter',40,4158,'42.500',1637,'3.000',40,43,30,21,20,10,0,0,1831,423,921,416,278,500,253,148,0,0,30,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.52','true',0,0),
(1750,22111,'Spiked Stakato Sorcerer','','blade_stakato_queen_120p','24.00','43.60',75,'male','L2Monster','Fighter',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,7774,820,1720,475,957,425,278,0,253,78,0,0,40,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',0,0),
(1751,22112,'Cannibalistic Stakato Follower','','spike_stakato_worker','17.00','29.80',74,'male','L2Monster','Fighter',40,4158,'42.500',1637,'3.000',40,43,30,21,20,10,0,0,1831,423,921,416,278,500,253,148,0,0,30,174,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.52','true',0,0),
(1752,22113,'Cannibalistic Stakato Leader','','cannibal_stakato_leader_120p','48.80','0.00',75,'male','L2Monster','Fighter',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,7774,820,1720,475,957,425,278,0,253,78,0,0,40,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',0,0),
(1753,22114,'Cannibalistic Stakato Leader','','cannibal_stakato_leader_tran','40.00','42.00',75,'male','L2Monster','Fighter',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,7774,820,1720,475,957,425,278,0,253,78,0,0,40,174,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',0,0),
(1754,22115,'Spiked Stakato Soldier','','blade_stakato_120p','18.00','43.20',76,'male','L2Monster','Fighter',40,4297,'4.250',1710,'3.000',40,43,30,21,20,10,16021,1712,1614,534,994,433,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',0,0),
(1755,22116,'Spiked Stakato Drone','','blade_stakato_drone_120p','28.00','47.30',77,'male','L2Monster','Fighter',40,4364,'34.000',1747,'3.000',40,43,30,21,20,10,6431,696,1664,463,1031,442,278,500,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.56','true',0,0),
(1756,22117,'Spiked Stakato Captain','','marsh_stakato_drone_120p','14.00','29.10',78,'male','L2Monster','Fighter',40,4428,'4.250',1784,'3.000',40,43,30,21,20,10,15583,1706,1715,555,1069,451,278,0,253,0,0,0,27,150,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.43','true',0,0),
(1757,22118,'Spiked Stakato Nurse','','marsh_stakato_queen_120p','26.00','43.80',79,'male','L2Monster','Fighter',40,4490,'17.000',1821,'3.000',40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,20,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',0,0),
(1758,22119,'Spiked Stakato Nurse','','marsh_stakato_queen_tran','16.00','28.40',79,'male','L2Monster','Fighter',40,4490,'17.000',1821,'3.000',40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,20,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',0,0),
(1759,22120,'Spiked Stakato Baby','','spike_stakato_drone','16.00','29.00',79,'male','L2Monster','Fighter',40,4490,'17.000',1821,'3.000',40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,182,0,0,0,20,165,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',0,0),
(1760,22121,'Spiked Stakato Shaman','','blade_stakato_queen_120p','24.00','43.60',80,'male','L2Monster','Mystic',40,4550,'25.500',1859,'3.000',40,43,30,21,20,10,10362,1163,1814,576,1144,468,278,0,253,0,0,0,20,165,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(1761,22122,'Monastic Pilgrim','','angel_080p','12.00','27.80',80,'male','L2Monster','Fighter',40,4550,'34.000',1859,'3.000',40,43,30,21,20,10,7761,871,2195,476,1144,468,278,0,253,148,0,0,48,200,NULL,0,'SYS','',0,0,0,7,50,1,9,0,0,'0.61','false',0,0),
(1762,22123,'Monastic Crusader','','archangel_050p','13.00','37.50',80,'male','L2Monster','Fighter',40,4608,'17.000',1896,'3.000',40,43,30,21,20,10,9976,1133,1540,710,1182,477,278,150,253,97,0,0,35,170,'mos_clan',400,'SYS','',0,0,0,7,50,1,9,0,0,'0.54','false',0,0),
(1763,22124,'Solina Brother','','solina_brother','9.00','23.40',80,'male','L2Monster','Fighter',40,4608,'17.000',1896,'3.000',40,43,30,21,20,10,9976,1133,2139,710,1182,477,200,150,182,8212,0,0,30,175,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,'0.49','false',0,0),
(1764,22125,'Solina Lay Brother','','solina_brother','9.00','23.40',80,'male','L2Monster','Fighter',40,4663,'34.000',1934,'3.000',40,43,30,21,20,10,8173,939,1912,598,1220,485,278,0,253,8212,0,0,27,160,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(1765,22126,'Silent Seeker','','solina_father','11.00','25.40',80,'male','L2Monster','Fighter',40,4663,'34.000',1934,'3.000',40,43,30,21,20,10,8173,939,1912,598,1220,485,278,0,253,8213,0,0,27,160,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(1766,22127,'Silent Brother','','solina_father','11.00','25.40',80,'male','L2Monster','Fighter',40,4608,'17.000',1896,'3.000',40,43,30,21,20,10,9976,1133,2139,710,1182,477,200,150,182,0,0,0,30,175,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,'0.49','false',0,0),
(1767,22128,'Monastery Guardian','','grail_protection','9.00','15.60',80,'male','L2Monster','RndTeleportFighter',40,4716,'17.000',1972,'3.000',40,43,30,21,20,10,10475,1217,1619,736,1258,494,278,150,253,0,0,0,30,165,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,'0.45','true',0,0),
(1768,22129,'Warrior Monk','','monk_warrior','12.00','28.40',80,'male','L2Monster','Fighter',40,4766,'17.000',2011,'3.000',40,43,30,21,20,10,11525,1355,2428,511,1296,502,278,150,253,8211,8210,0,34,175,'mos_clan',400,'SYS','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1769,22130,'Divine Advocate','','apostle_warrior','8.00','30.00',80,'male','L2Monster','Fighter',40,4813,'17.000',2049,'3.000',40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,0,253,6717,0,0,45,185,NULL,0,'SYS','',0,0,0,7,50,1,9,0,10,'0.46','false',0,0),
(1770,22131,'Pilgrim of Light','','apostle_mage','11.00','38.50',80,'male','L2Monster','Mystic',40,4813,'17.000',2049,'3.000',40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,0,253,6718,0,0,45,185,NULL,0,'SYS','',0,0,0,7,50,1,9,0,10,'0.46','false',0,0),
(1771,22132,'Judge of Light','','apostle_grail_a','13.00','47.00',80,'male','L2Monster','Ranger',500,4858,'17.000',2088,'3.000',40,43,30,21,20,10,12871,1550,2913,639,1370,519,200,0,182,0,0,0,24,180,'mos_clan',400,'SYS',NULL,0,0,0,7,50,1,9,0,0,'0.51','false',0,0),
(1772,22133,'Guardian of the Grail','','will_o_wisp','13.00','22.00',80,'male','L2Monster','RndTeleportFighter',40,4858,'17.000',2088,'3.000',40,43,30,21,20,10,12871,1550,2913,639,1370,519,200,0,182,0,0,0,24,180,'mos_clan',400,'SYS',NULL,0,0,0,7,50,1,9,0,0,'0.51','true',0,0),
(1773,22134,'Guardian of the Holy Land','','solina_priest','14.00','34.50',80,'male','L2Monster','Fighter',40,4899,'17.000',2088,'3.000',40,43,30,21,20,10,13871,1750,2963,639,1470,519,200,0,182,8214,0,0,24,180,'mos_clan',400,'SYS',NULL,0,0,0,7,50,1,9,0,0,'0.51','false',0,0),
(1774,22135,'Beholder of Light','','apostle_grail','13.00','47.00',80,'male','L2Monster','Fighter',40,4899,'17.000',2088,'3.000',40,43,30,21,20,10,13871,1750,2963,639,1470,519,200,0,182,6718,0,0,24,180,'mos_clan',400,'SYS',NULL,0,0,0,7,50,1,9,0,0,'0.51','false',0,0),
(1775,22136,'Gatekeeper Zombie','','zombie_gateguard','17.00','30.50',83,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(1776,22137,'Penance Guard','','zombie_gateguard_brd','40.00','30.50',80,'male','L2Monster','NoRndWalkFighter',40,2304,'13.430',1338,'3.090',40,43,30,21,20,10,13824,658,1732,555,800,546,300,0,555,8217,0,0,50,120,'pagan_clan',500,'SYS','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(1777,22138,'Chapel Guard','','zombie_gateguard_brd','40.00','30.50',80,'male','L2Monster','NoRndWalkFighter',40,2406,'13.430',1338,'3.090',40,43,30,21,20,10,14436,688,1732,555,800,546,300,0,555,8217,0,0,50,120,'pagan_clan',500,'SYS','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(1778,22139,'Old Aristocrat''s Soldier','','zombie_enlisted_man','17.00','22.30',80,'male','L2Monster','Mystic',40,4608,'13.430',1380,'3.090',40,43,26,21,20,10,13826,658,1719,1108,1144,780,300,0,555,8216,0,0,50,120,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(1779,22140,'Zombie Worker','','zombie_laborer','11.00','24.60',80,'male','L2Monster','Mystic',40,4550,'13.430',1380,'3.090',40,43,26,21,20,10,13652,650,1886,1108,1144,780,300,0,555,8218,0,0,50,120,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(1780,22141,'Forgotten Victim','','zombie_laborer','11.00','24.60',80,'male','L2Monster','Mystic',40,4550,'13.430',1380,'3.090',40,43,26,21,20,10,13652,650,1886,1108,1144,780,300,0,555,8219,0,0,50,120,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(1781,22142,'Triol''s Layperson','','heretic_privates_a','7.70','28.40',80,'male','L2Monster','NoRndWalkFighter',40,5760,'13.430',1380,'3.090',40,43,26,21,20,10,13826,658,1652,793,1144,780,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1782,22143,'Triol''s Believer','','heretic_privates','7.70','28.40',80,'male','L2Monster','Mystic',40,4663,'13.430',1380,'3.090',40,43,26,21,20,10,11193,533,1652,793,1211,780,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1783,22144,'Resurrected Temple Knight','','zombie_enlisted_man','17.00','22.30',80,'male','L2Monster','Fighter',40,4663,'13.430',1380,'3.090',40,43,26,21,20,10,13991,667,1698,1108,1144,780,300,0,555,0,0,0,61,180,'pagan_clan',500,'SYS','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(1784,22145,'Ritual Sacrifice','','self_blaster','9.00','25.80',81,'male','L2Monster','Fighter',40,4716,'13.430',1380,'3.090',40,43,26,21,20,10,13826,658,1203,556,800,546,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1785,22146,'Triol''s Priest','','heretic_privates','7.70','28.40',84,'male','L2Monster','Mystic',40,4766,'13.430',1380,'3.090',40,43,26,21,20,10,14299,681,1203,556,847,546,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1786,22147,'Ritual Offering','','zombie_enlisted_man','17.00','22.30',83,'male','L2Monster','Fighter',40,4716,'13.430',1380,'3.090',40,43,26,21,20,10,14150,674,1061,556,800,546,400,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1787,22148,'Triol''s Believer','','heretic_privates','7.70','28.40',82,'male','L2Monster','Fighter',40,4663,'13.430',1380,'3.090',40,43,26,21,20,10,11193,533,1203,555,800,546,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1788,22149,'Ritual Offering','','zombie_enlisted_man','17.00','22.30',82,'male','L2Monster','Fighter',40,4663,'13.430',1380,'3.090',40,43,26,21,20,10,13991,667,1061,555,800,546,400,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1789,22150,'Triol''s Believer','','heretic_privates','7.70','28.40',83,'male','L2Monster','Fighter',40,4663,'13.430',1380,'3.090',40,43,26,21,20,10,17489,830,1203,555,800,546,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1790,22151,'Triol''s Priest','','heretic_privates','7.70','28.40',85,'male','L2Monster','Mystic',40,4813,'13.430',1380,'3.090',40,43,26,21,20,10,14441,688,1203,556,800,546,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1791,22152,'Temple Guard','','zombie_em_knight','17.00','22.30',84,'male','L2Monster','Fighter',40,4766,'13.430',1380,'3.090',40,43,26,21,20,10,14300,681,1308,555,800,546,500,0,555,0,8219,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1792,22153,'Temple Guard Captain','','zombie_em_knight','17.00','22.30',84,'male','L2Monster','Fighter',40,4766,'13.430',1380,'3.090',40,43,26,21,20,10,14300,681,1329,555,800,546,350,0,555,8218,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0);
INSERT INTO `npc` VALUES
(1793,22154,'Ritual Sacrifice','','self_blaster','9.00','25.80',85,'male','L2Monster','Fighter',40,4813,'13.430',1380,'3.090',40,43,26,21,20,10,14441,688,1203,473,800,546,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1794,22155,'Triol''s High Priest','','heretic_priest_a','7.70','28.40',85,'male','L2Monster','Fighter',40,4813,'13.430',1380,'3.090',40,43,26,21,20,10,14441,688,1318,555,870,546,300,0,555,8206,8206,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1795,22156,'Triol''s Priest','','heretic_privates','7.70','28.40',86,'male','L2Monster','Mystic',40,4858,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1203,555,800,546,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1796,22157,'Triol''s Priest','','heretic_privates','7.70','28.40',85,'male','L2Monster','Mystic',40,4813,'13.430',1380,'3.090',40,43,26,21,20,10,14441,688,1203,555,800,546,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1797,22158,'Triol''s Believer','','heretic_privates_a','7.70','28.40',85,'male','L2Monster','Fighter',40,4716,'13.430',1380,'3.090',40,43,26,21,20,10,14441,688,1155,555,849,546,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1798,22159,'Triol''s High Priest','','heretic_priest_a','7.70','28.40',86,'male','L2Monster','Fighter',40,4858,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1318,546,800,546,300,0,555,8206,8206,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1799,22160,'Triol''s Priest','','heretic_privates','7.70','28.40',86,'male','L2Monster','Mystic',40,4858,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1203,555,800,546,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1800,22161,'Ritual Sacrifice','','self_blaster','9.00','25.80',85,'male','L2Monster','Fighter',40,4813,'13.430',1380,'3.090',40,43,26,21,20,10,14441,688,1203,555,800,546,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1801,22162,'Triol''s Believer','','heretic_privates_a','7.70','28.40',85,'male','L2Monster','Fighter',40,4813,'13.430',1380,'3.090',40,43,26,21,20,10,14441,688,1318,555,849,546,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1802,22163,'Triol''s High Priest','','heretic_priest','8.00','19.60',86,'male','L2Monster','Fighter',40,4858,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1203,555,800,546,300,0,555,8206,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1803,22164,'Triol''s Believer','','heretic_privates_a','7.70','28.40',86,'male','L2Monster','Fighter',40,4813,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1341,555,910,546,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1804,22165,'Triol''s Priest','','heretic_privates','7.70','28.40',85,'male','L2Monster','Mystic',40,4813,'13.430',1380,'3.090',40,43,26,21,20,10,14441,688,1203,555,800,546,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1805,22166,'Triol''s Believer','','heretic_privates','7.70','28.40',85,'male','L2Monster','Mystic',40,4858,'13.430',1380,'3.090',40,43,26,21,20,10,14441,688,1341,555,910,546,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1806,22167,'Triol''s High Priest','','heretic_priest_a','7.70','28.40',87,'male','L2Monster','Fighter',40,4899,'13.430',1380,'3.090',40,43,26,21,20,10,14699,700,1318,555,800,546,300,0,555,8206,8206,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1807,22168,'Triol''s Priest','','heretic_privates','7.70','28.40',87,'male','L2Monster','Mystic',40,4899,'13.430',1380,'3.090',40,43,26,21,20,10,14699,700,1203,555,800,546,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1808,22169,'Ritual Sacrifice','','self_blaster','9.00','25.80',86,'male','L2Monster','Fighter',40,4858,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1203,555,800,546,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1809,22170,'Triol''s Believer','','heretic_privates_a','7.70','28.40',86,'male','L2Monster','Fighter',40,4813,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1423,555,910,546,300,0,555,8207,8207,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1810,22171,'Triol''s High Priest','','heretic_priest','8.00','19.60',87,'male','L2Monster','Fighter',40,4899,'13.430',1380,'3.090',40,43,26,21,20,10,14699,700,1203,555,800,546,300,0,555,8206,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1811,22172,'Ritual Sacrifice','','self_blaster','9.00','25.80',86,'male','L2Monster','Fighter',40,4858,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1203,555,800,546,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1812,22173,'Triol''s Priest','','heretic_privates','7.70','28.40',86,'male','L2Monster','Mystic',40,4858,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1203,555,800,546,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1813,22174,'Triol''s Priest','','heretic_privates','7.70','28.40',85,'male','L2Monster','Mystic',40,4813,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1203,555,800,546,300,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1814,22175,'Andreas'' Captain of the Royal Guard','','zombie_em_knight','17.00','22.30',85,'male','L2Monster','Fighter',40,1443,'13.430',1380,'3.090',40,43,26,21,20,10,14574,688,1203,555,800,546,500,0,555,8218,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1815,22176,'Andreas'' Royal Guards','','zombie_em_knight','17.00','22.30',85,'male','L2Monster','Fighter',40,1203,'13.430',1380,'3.090',40,43,26,21,20,10,14436,688,1732,775,800,546,300,0,555,8207,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1816,22188,'Andreas'' Captain of the Royal Guard','','heretic_priest_120p','13.00','23.20',87,'male','L2Monster','Fighter',40,4899,'13.430',1380,'3.090',40,43,26,21,20,10,14698,700,1877,672,1096,546,300,0,555,8206,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1817,22189,'Andreas'' Royal Guards','','heretic_privates_120p','13.00','34.00',86,'male','L2Monster','Mystic',40,4858,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1877,672,1096,546,460,0,555,8208,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1818,22190,'Ritual Sacrifice','','self_blaster','9.00','25.80',86,'male','L2Monster','Fighter',40,4808,'13.430',1380,'3.090',40,43,26,21,20,10,14574,694,1318,672,800,546,300,0,555,0,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1819,22191,'Andreas'' Captain of the Royal Guard','','heretic_priest_120p','13.00','23.20',87,'male','L2Monster','Fighter',40,4899,'13.430',1380,'3.090',40,43,26,21,20,10,22049,1050,1203,555,800,546,300,0,555,8206,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1820,22192,'Andreas'' Royal Guards','','heretic_privates_120p','13.00','34.00',86,'male','L2Monster','Fighter',40,4858,'13.430',1380,'3.090',40,43,26,21,20,10,29148,1388,1203,555,800,546,300,0,555,8206,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1821,22193,'Andreas'' Royal Guards','','heretic_privates_120p','13.00','34.00',86,'male','L2Monster','Fighter',40,4858,'13.430',1380,'3.090',40,43,26,21,20,10,29148,1388,1203,555,800,546,600,0,555,8206,0,0,61,180,'pagan_clan',500,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(1822,22194,'Penance Guard','','zombie_gateguard_slp','40.00','22.00',80,'male','L2Monster','NoRndWalkFighter',40,2304,'13.430',1338,'3.090',40,43,30,21,20,10,13824,658,1732,555,800,546,300,0,555,8217,0,0,50,120,'pagan_clan',500,'SYS','',0,0,0,7,30,4,4,0,0,'0.00','false',0,0),
(1823,22195,'Ritual Sacrifice','','self_blaster','20.00','31.00',99,'male','L2Monster','Mystic',80,100000,'13.430',9999,'3.090',40,43,30,21,20,10,3083,500,3109,755,1839,651,278,NULL,333,NULL,NULL,NULL,88,132,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1824,22196,'Velociraptor','','velociraptor','19.00','47.20',86,'male','L2Monster','Fighter',80,251060,'13.430',2296,'3.090',40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',1,0),
(1825,22197,'Velociraptor','','velociraptor','19.00','47.20',86,'male','L2Monster','Fighter',80,125530,'13.430',2296,'3.090',40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1826,22198,'Velociraptor','','velociraptor','19.00','47.20',86,'male','L2Monster','Fighter',80,251060,'13.430',2296,'3.090',40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1827,22199,'Pterosaur','','rhamphorhynchus','36.00','43.70',87,'male','L2Monster','Fighter',80,1014300,'13.430',2339,'3.090',40,43,30,21,20,10,11031,1401,2269,635,1413,531,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',1,0),
(1828,22200,'Ornithomimus','','ornithomimus','15.00','37.20',84,'male','L2Monster','Fighter',80,123050,'13.430',2211,'3.090',40,43,30,21,20,10,11031,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',1,0),
(1829,22201,'Ornithomimus','','ornithomimus','15.00','37.20',84,'male','L2Monster','Fighter',80,123050,'13.430',2211,'3.090',40,43,30,21,20,10,11031,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1830,22202,'Ornithomimus','','ornithomimus','15.00','37.20',84,'male','L2Monster','Fighter',80,123050,'13.430',2211,'3.090',40,43,30,21,20,10,11031,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1831,22203,'Deinonychus','','deinonychus','14.00','14.30',83,'male','L2Monster','Fighter',80,121840,'13.430',2168,'3.090',40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',1,0),
(1832,22204,'Deinonychus','','deinonychus','14.00','14.30',83,'male','L2Monster','Fighter',80,121840,'13.430',2168,'3.090',40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1833,22205,'Deinonychus','','deinonychus','14.00','14.30',83,'male','L2Monster','Fighter',80,121840,'13.430',2168,'3.090',40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1834,22208,'Pachycephalosaurus','','pachycephalosaurus','22.00','40.00',85,'male','L2Monster','Fighter',80,124280,'13.430',2253,'3.090',40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',1,0),
(1835,22209,'Pachycephalosaurus','','pachycephalosaurus','22.00','40.00',85,'male','L2Monster','Fighter',80,124280,'13.430',2253,'3.090',40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1836,22210,'Pachycephalosaurus','','pachycephalosaurus','22.00','40.00',85,'male','L2Monster','Fighter',80,124280,'13.430',2253,'3.090',40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1837,22211,'Wild Strider','','wild_giant_strider','32.00','44.20',85,'male','L2Monster','Fighter',80,124280,'13.430',2253,'3.090',40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',1,0),
(1838,22212,'Wild Strider','','wild_giant_strider','32.00','44.20',85,'male','L2Monster','Fighter',80,124280,'13.430',2253,'3.090',40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1839,22213,'Wild Strider','','wild_giant_strider','32.00','44.20',85,'male','L2Monster','Fighter',80,124280,'13.430',2253,'3.090',40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1840,22214,'Elroki','','Crokian_Officer','25.00','33.00',85,'male','L2Monster','Fighter',80,248570,'13.430',2253,'3.090',40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(1841,22215,'Tyrannosaurus','','tyranosaurus','60.00','89.70',87,'male','L2Monster','Tyrannosaurus',80,3064060,'13.430',2339,'3.090',40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(1842,22216,'Tyrannosaurus','','tyranosaurus','60.00','89.70',87,'male','L2Monster','Tyrannosaurus',80,3064060,'13.430',2339,'3.090',40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(1843,22217,'Tyrannosaurus','','tyranosaurus','60.00','89.70',87,'male','L2Monster','Tyrannosaurus',80,3064060,'13.430',2339,'3.090',40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(1844,22218,'Velociraptor','','velociraptor','19.00','47.20',86,'male','L2Monster','Fighter',80,125530,'13.430',2296,'3.090',40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1845,22219,'Ornithomimus','','ornithomimus','15.00','37.20',84,'male','L2Monster','Fighter',80,123050,'13.430',2211,'3.090',40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1846,22220,'Deinonychus','','deinonychus','14.00','14.30',83,'male','L2Monster','Fighter',80,121840,'13.430',2168,'3.090',40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1847,22221,'Pachycephalosaurus','','pachycephalosaurus','22.00','40.00',84,'male','L2Monster','Fighter',80,123050,'13.430',2211,'3.090',40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1848,22222,'Wild Strider','','wild_giant_strider','32.00','44.20',85,'male','L2Monster','Fighter',80,124280,'13.430',2253,'3.090',40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1849,22223,'Velociraptor','','velociraptor','19.00','47.20',86,'male','L2Monster','Fighter',80,125530,'13.430',2296,'3.090',40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1850,22224,'Ornithomimus','','ornithomimus','15.00','37.20',84,'male','L2Monster','Fighter',80,123050,'13.430',2211,'3.090',40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,NULL,NULL,NULL,88,188,'dino',500,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(1851,22225,'Deinonychus','','deinonychus','14.00','14.30',83,'male','L2Monster','Fighter',80,12184,'13.430',2168,'3.090',40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,0,0,0,88,188,'dino',500,'Magister',0,0,0,0,0,0,0,0,0,0,'0.00','true',0,0),
(1852,22226,'Pachycephalosaurus','','pachycephalosaurus','22.00','40.00',85,'male','L2Monster','Fighter',80,12428,'13.430',2253,'3.090',40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,500,333,0,0,0,88,188,0,0,'Magister',0,0,0,0,0,0,0,0,0,0,'0.00','true',0,0),
(1853,22227,'Wild Strider','','wild_giant_strider','32.00','44.20',85,'male','L2Monster','Fighter',80,12428,'13.430',2253,'3.090',40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,500,333,0,0,0,88,188,0,0,'Magister',0,0,0,0,0,0,0,0,0,0,'0.00','true',0,0),
(1854,25001,'Greyclaw Kutus','Raid Boss','ol_mahum_champion_50_bi','21.00','43.50',23,'male','L2RaidBoss','Fighter',40,95986,'49.420',545,'4.500',60,57,73,76,70,80,714843,67170,61,857,6,348,278,0,1972,67,633,0,50,170,'',0,'Tigra','',0,20,382,7,30,4,20,0,-18,'0.63','false',1,1),
(1855,25002,'Guard of Kutus','Raid Fighter','ol_mahum','13.50','25.00',22,'male','L2Minion','Fighter',40,6613,'18.950',257,'4.500',40,43,30,41,20,10,0,0,74,411,9,167,278,0,253,7,0,0,50,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(1856,25003,'Pawn of Kutus','Raid Fighter','ol_mahum','13.50','25.00',22,'male','L2Minion','Fighter',40,9870,'18.950',257,'4.500',40,43,30,41,20,10,0,0,111,411,22,167,278,0,253,123,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(1857,25004,'Turek Mercenary Captain','Raid Boss','orc_champion_50_bi','15.00','35.00',30,'male','L2RaidBoss','Fighter',40,168366,'130.310',763,'5.400',60,57,73,76,70,80,1424160,129276,226,1127,70,458,278,0,1972,124,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.76','false',1,1),
(1858,25005,'Turek Mercenary Archer','Raid Fighter','orc_archer','14.00','25.00',29,'male','L2Minion','Ranger',500,11414,'50.200',365,'4.500',40,43,30,41,20,10,0,0,604,542,111,220,249,0,227,271,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,'0.80','false',0,0),
(1859,25006,'Turek Mercenary Warrior','Raid Fighter','orc_fighter','12.00','22.00',29,'male','L2Minion','Fighter',40,8518,'50.200',365,'4.500',40,43,30,41,20,10,0,0,203,542,62,220,278,0,253,2,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(1860,25007,'Retreat Spider Cletu','Raid Boss','poison_spider','27.00','25.50',42,'male','L2RaidBoss','Mystic',40,331522,'179.910',1062,'5.400',60,57,73,76,70,80,2299956,251972,746,1728,324,701,278,0,1972,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.65','false',1,1),
(1861,25008,'Cletu''s Retainer','Raid Fighter','giant_spider','26.00','26.50',41,'male','L2Minion','Mystic',40,33216,'69.880',514,'5.400',40,43,30,41,20,10,0,0,662,835,278,339,278,0,253,0,0,0,72,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.26','false',0,0),
(1862,25009,'Cletu''s Pawn','Raid Fighter','giant_spider','26.00','26.50',41,'male','L2Minion','Mystic',40,16608,'69.880',514,'5.400',40,43,30,41,20,10,0,0,662,835,278,339,278,0,253,0,0,0,72,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.26','false',0,0),
(1863,25010,'Furious Thieles','Raid Boss','ti_mi_tran','23.00','90.00',55,'male','L2RaidBoss','Fighter',40,624464,'248.860',2039,'7.200',60,57,73,76,70,80,2988757,448385,2471,2576,1817,1046,278,0,1972,0,0,0,12,50,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.61','false',1,1),
(1864,25011,'Guard of Thieles','Raid Fighter','zenta_lizardman_scout','11.00','30.00',54,'male','L2Minion','Ranger',500,42806,'97.460',987,'7.200',40,43,30,41,20,10,0,0,6746,1252,2944,508,249,0,227,279,0,0,37,170,'',0,'Local','',0,0,0,7,30,4,20,1500,0,'0.93','false',0,0),
(1865,25012,'Follower of Thieles','Raid Fighter','dryad','9.00','20.00',54,'female','L2Minion','Fighter',40,9909,'97.460',987,'7.200',40,43,30,41,20,10,0,0,2277,1252,1656,508,278,0,253,0,0,0,40,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.37','false',0,0),
(1866,25013,'Ghost of Peasant Leader','Raid Boss','skeleton_knight_50_bi','15.00','39.00',50,'male','L2RaidBoss','Fighter',40,507285,'222.490',1722,'7.200',60,57,73,76,70,80,2494222,346727,1510,2226,862,904,278,0,1972,145,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.17','false',1,1),
(1867,25014,'Ghost of Peasant','Raid Fighter','skeleton','11.00','25.00',49,'male','L2Minion','Fighter',40,51380,'86.860',830,'6.300',40,43,30,41,20,10,0,0,2751,1079,3086,438,278,0,253,68,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.30','false',0,0),
(1868,25015,'Ghost of Peasant','Raid Fighter','skeleton_archer','11.00','27.00',49,'male','L2Minion','Ranger',500,25690,'86.860',830,'6.300',40,43,30,41,20,10,0,0,1375,1079,771,438,278,0,253,14,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,'0.80','false',0,0),
(1869,25016,'The 3rd Underwater Guardian','Raid Boss','susceptor_100_bi','40.00','73.00',60,'male','L2RaidBoss','Fighter',40,188376,'295.120',2368,'8.100',60,57,73,76,70,80,3346092,522780,3860,2951,3932,1198,278,0,1972,0,0,0,27,150,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.43','false',0,1),
(1870,25017,'Escort of the 3rd Guardian','Raid Fighter','will_o_wisp','13.00','22.00',59,'male','L2Minion','Fighter',40,24399,'115.940',1150,'7.200',40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.10','false',0,0),
(1871,25018,'Support of the 3rd Guardian','Raid Fighter','will_o_wisp','13.00','22.00',59,'male','L2Minion','Fighter',40,12199,'115.940',1150,'7.200',40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.10','false',0,0),
(1872,25019,'Pan Dryad','Raid Boss','pan_100_bi','42.00','73.00',25,'male','L2RaidBoss','Fighter',40,206185,'53.660',606,'4.500',60,57,73,76,70,80,730469,69595,146,928,30,377,278,0,1972,291,0,0,45,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.58','false',1,1),
(1873,25020,'Breka Warlock Pastu','Raid Boss','batur_orc_shaman_100_bi','22.00','35.00',34,'male','L2RaidBoss','Priest',40,156584,'75.160',893,'5.400',60,57,73,76,70,80,1174184,135023,280,1308,55,531,278,0,1972,8,0,0,50,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.30','false',1,1),
(1874,25021,'Pastu''s Silhouette','Raid Fighter','silhouette','8.00','23.00',33,'female','L2Minion','Fighter',40,15774,'29.040',430,'5.400',40,43,30,41,20,10,0,0,258,630,51,256,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.54','false',0,0),
(1875,25022,'Pastu''s Shadow','Raid Fighter','shadow','10.00','30.00',33,'male','L2Minion','Mystic',40,7887,'29.040',430,'5.400',40,43,30,41,20,10,0,0,258,630,51,256,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.54','false',0,0),
(1876,25023,'Stakato Queen Zyrnna','Raid Boss','marsh_stakato_queen_100_bi','30.00','76.00',34,'female','L2RaidBoss','Fighter',40,208019,'139.580',1415,'6.300',60,57,73,76,70,80,1753455,156895,340,1308,110,531,278,0,1972,150,0,0,50,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.41','false',1,1),
(1877,25024,'Jeruna''s Guard Captain','Raid Fighter','marsh_stakato_drone','9.00','24.00',33,'male','L2Minion','Fighter',40,20909,'53.930',677,'6.300',40,43,30,41,20,10,0,0,626,630,408,256,278,0,253,238,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.39','false',0,0),
(1878,25025,'Jeruna''s Guard','Raid Fighter','marsh_stakato_soldier','10.00','25.00',33,'male','L2Minion','Fighter',40,10454,'53.930',677,'6.300',40,43,30,41,20,10,0,0,313,630,102,256,278,0,253,257,0,0,30,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.74','false',0,0),
(1879,25026,'Katu Van Leader Atui','Raid Boss','ketra_orc_overload','12.00','24.00',49,'male','L2RaidBoss','Fighter',40,352421,'116.920',1660,'6.300',60,57,73,76,70,80,1655129,248433,1147,2160,383,877,278,0,1972,84,0,0,33,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.48','false',1,1),
(1880,25027,'Katu Van Marksman','Raid Fighter','ketra_orc_archer','12.00','27.00',48,'male','L2Minion','Ranger',500,23911,'45.620',799,'6.300',40,43,30,41,20,10,0,0,3102,1047,613,425,249,0,227,279,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,'0.91','false',0,0),
(1881,25028,'Katu Van Raider','Raid Fighter','ketra_orc_warrior','12.00','24.00',48,'male','L2Minion','Fighter',40,17844,'45.620',799,'6.300',40,43,30,41,20,10,0,0,1047,1047,345,425,278,0,253,128,0,0,36,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.54','false',0,0),
(1882,25029,'Atraiban','Raid Boss','field_stalker_200_bi','45.00','96.00',53,'male','L2RaidBoss','Fighter',40,156190,'256.750',1911,'7.200',60,57,73,76,70,80,3145490,461913,2344,2433,1974,988,278,0,1972,0,0,0,70,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.41','false',1,1),
(1883,25030,'Atraiban''s Top Disciple','Raid Fighter','will_o_wisp','13.00','22.00',52,'male','L2Minion','Mystic',40,20135,'100.430',923,'7.200',40,43,30,41,20,10,0,0,2114,1181,1727,479,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.10','false',0,0),
(1884,25031,'Atraiban''s Disciple','Raid Fighter','liviona','15.00','28.00',52,'male','L2Minion','Fighter',40,10067,'100.430',923,'7.200',40,43,30,41,20,10,0,0,2114,1181,1727,479,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.34','false',0,0),
(1885,25032,'Eva''s Guardian Millenu','Raid Boss','banshee_50_bi','13.50','38.00',65,'female','L2RaidBoss','Mystic',40,229722,'348.000',2707,'8.100',60,57,73,76,70,80,1820975,806823,5880,3349,7541,1360,278,0,1972,3939,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.56','false',0,1),
(1886,25033,'Millenu Guard Shaman','Raid Fighter','heltor_silenos_shaman','13.00','32.00',64,'male','L2Minion','Priest',40,20074,'138.400',1319,'8.100',40,43,30,41,20,10,0,0,7473,1634,12940,663,278,0,253,5131,0,0,29,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.22','false',0,0),
(1887,25034,'Mellenu Guard Warrior','Raid Fighter','skeleton_royal_guard','11.00','28.50',64,'male','L2Minion','Fighter',40,30142,'138.400',1319,'8.100',40,43,30,41,20,10,0,0,11210,1634,29118,663,278,0,253,946,945,0,80,170,'',0,'Local','',0,20,534,7,30,4,20,0,0,'0.52','false',0,0),
(1888,25035,'Shilen''s Messenger Cabrio','Raid Boss','vale_master_50_bi','18.00','63.00',70,'male','L2RaidBoss','Fighter',40,888658,'355.000',3058,'9.000',60,57,73,76,70,80,1915900,918808,6981,3764,8986,1528,278,0,1972,189,0,0,70,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.74','false',1,1),
(1889,25036,'Cabrio Captor','Raid Fighter','skeleton_archer','11.00','27.00',69,'male','L2Minion','Ranger',500,62338,'141.600',1493,'8.100',40,43,30,41,20,10,0,0,19755,1840,15424,747,249,0,227,279,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,'0.80','false',0,0),
(1890,25037,'Cabrio Blader','Raid Fighter','doll_blader','6.00','12.00',69,'male','L2Minion','Fighter',40,46520,'141.600',1493,'8.100',40,43,30,41,20,10,0,0,6668,1840,8676,747,278,0,253,5129,5129,0,22,170,'',0,'Tigra','',0,0,582,7,30,4,20,0,0,'0.50','false',0,0),
(1891,25038,'Tirak','Raid Boss','dre_vanul_100_bi','28.00','75.00',28,'male','L2RaidBoss','Fighter',40,116581,'60.420',699,'4.500',60,57,73,76,70,80,750326,74683,96,1044,10,424,278,0,1972,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.35','false',1,1),
(1892,25039,'Tirak''s Guard','Raid Fighter','spartoi','11.00','27.00',27,'male','L2Minion','Fighter',40,11861,'23.250',334,'4.500',40,43,30,41,20,10,0,0,175,502,38,204,278,0,253,68,0,0,60,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.30','false',0,0),
(1893,25040,'Tirak''s Knight','Raid Fighter','skeleton','11.00','25.00',27,'male','L2Minion','Fighter',40,5930,'23.250',334,'4.500',40,43,30,41,20,10,0,0,87,502,9,204,278,0,253,2,945,0,60,170,NULL,0,'Tigra',NULL,0,20,216,7,30,4,20,0,0,'0.30','false',0,0),
(1894,25041,'Remmel','Raid Boss','marsh_stakato_queen_100_bi','30.00','76.00',35,'female','L2RaidBoss','Fighter',40,165289,'77.760',927,'5.400',60,57,73,76,70,80,1018607,103175,200,1356,28,550,278,0,1972,221,109,0,50,170,'',0,'Tigra','',0,20,546,7,30,4,20,0,-18,'0.41','false',1,1),
(1895,25042,'Remmel''s Archer','Raid Fighter','batur_orc_archer','11.00','21.50',34,'male','L2Minion','Ranger',500,11143,'30.060',446,'5.400',40,43,30,41,20,10,0,0,547,654,46,265,249,0,227,275,0,0,45,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.96','false',0,0),
(1896,25043,'Remmel''s Guard','Raid Fighter','marsh_stakato','10.00','20.00',34,'male','L2Minion','Fighter',40,8316,'30.060',446,'5.400',40,43,30,41,20,10,0,0,184,654,26,265,278,0,253,127,0,0,21,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.74','false',0,0),
(1897,25044,'Barion','Raid Boss','skeleton_knight_50_bi','15.00','39.00',47,'male','L2RaidBoss','Fighter',40,319791,'111.160',1296,'6.300',60,57,73,76,70,80,1624139,238098,956,2030,296,824,278,0,1972,70,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.17','false',1,1),
(1898,25045,'Dark Mage''s of Barion','Raid Fighter','batur_orc_shaman','11.00','16.00',46,'male','L2Minion','Priest',40,32280,'43.310',618,'6.300',40,43,30,41,20,10,0,0,861,983,260,399,278,0,253,159,0,0,50,120,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.30','false',0,0),
(1899,25046,'Barion''s Grunt','Raid Fighter','spartoi','11.00','27.00',46,'male','L2Minion','Fighter',40,16140,'43.310',618,'6.300',40,43,30,41,20,10,0,0,861,983,260,399,278,0,253,129,0,0,60,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.30','false',0,0),
(1900,25047,'Karte','Raid Boss','death_knight_50_bi','18.00','45.00',49,'male','L2RaidBoss','Fighter',40,352421,'116.920',1660,'6.300',60,57,73,76,70,80,1412364,185123,769,2160,184,877,278,0,1972,131,0,0,27,170,'',0,'DRIVER','',0,0,0,7,30,4,20,0,-18,'0.71','false',1,1),
(1901,25048,'Karte''s Chief Knight','Raid Fighter','skeleton_knight','10.00','25.00',48,'male','L2Minion','Fighter',40,35688,'45.620',799,'6.300',40,43,30,41,20,10,0,0,1403,1047,664,425,278,0,253,71,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.17','false',0,0),
(1902,25049,'Karte''s Royal Guard','Raid Fighter','spartoi','11.00','27.00',48,'male','L2Minion','Fighter',40,17844,'45.620',799,'6.300',40,43,30,41,20,10,0,0,701,1047,166,425,278,0,253,74,0,0,60,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.30','false',0,0),
(1903,25050,'Verfa','Raid Boss','death_blader_200_bi','45.00','141.00',51,'male','L2RaidBoss','Fighter',40,771340,'105.150',2039,'7.200',60,57,73,76,70,80,1381165,185853,1700,2294,879,931,278,0,1972,1472,0,0,100,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(1904,25051,'Rahha','Raid Boss','Bloody_Queen_Raid','11.00','34.00',65,'female','L2RaidBoss','Mystic',40,818959,'282.910',2707,'8.100',60,57,73,76,70,80,3674504,679343,4656,3349,4297,1360,278,0,1972,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(1905,25052,'Priestess of Rahha','Raid Fighter','medusa','10.00','25.00',64,'female','L2Minion','Priest',40,85286,'112.570',1319,'8.100',40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,253,0,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.52','false',0,0),
(1906,25053,'Fanatics of Rahha','Raid Fighter','harpy','10.00','42.00',64,'female','L2Minion','Fighter',40,42643,'112.570',1319,'8.100',40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,253,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.65','false',0,0),
(1907,25054,'Kernon','Raid Boss','kaim_vanul','24.00','40.00',75,'male','L2RaidBoss','Fighter',40,945900,'357.000',3420,'9.000',60,57,73,76,70,80,2238750,1054472,8986,4188,12912,1701,278,0,1972,0,0,0,37,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(1908,25055,'Taliadon','Raid Fighter','death_blader','15.00','45.00',74,'male','L2Minion','Fighter',40,99324,'142.800',1673,'9.000',40,43,30,41,20,10,0,0,17216,2051,49884,833,278,0,253,1472,0,0,100,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.45','false',0,0),
(1909,25056,'Vemsk','Raid Fighter','death_knight','12.00','30.00',74,'male','L2Minion','Fighter',40,49662,'142.800',1673,'9.000',40,43,30,41,20,10,0,0,8608,2051,12471,833,278,0,253,142,0,0,27,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.71','false',0,0),
(1910,25057,'Biconne of Blue Sky','Raid Boss','lienrik','12.00','50.00',45,'male','L2RaidBoss','Fighter',40,288415,'105.420',2235,'7.200',60,57,73,76,70,80,1358394,171282,538,1905,112,774,278,0,1972,0,0,0,100,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(1911,25058,'Biconne''s Shooter','Raid Fighter','skeleton_archer','11.00','27.00',44,'male','L2Minion','Ranger',500,19455,'41.020',1084,'7.200',40,43,30,41,20,10,0,0,1444,922,176,374,249,0,227,279,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.80','false',0,0),
(1912,25059,'Biconne''s Warrior','Raid Fighter','skeleton_knight','10.00','25.00',44,'male','L2Minion','Fighter',40,3879,'41.020',1084,'7.200',40,43,30,41,20,10,0,0,487,922,99,374,278,0,253,150,0,0,40,160,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.17','false',0,0),
(1913,25060,'Unrequited Kael','Raid Boss','succubus_100_bi','20.00','75.00',24,'female','L2RaidBoss','Mystic',40,99367,'44.150',575,'4.500',60,57,73,76,70,80,606920,51383,57,892,5,362,278,0,1972,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.84','false',1,1),
(1914,25061,'Kael''s Bead','Raid Fighter','will_o_wisp','13.00','22.00',23,'male','L2Minion','Mystic',40,6830,'16.940',272,'4.500',40,43,30,41,20,10,0,0,69,428,8,174,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.10','false',0,0),
(1915,25062,'Kael''s Escort','Raid Fighter','harpy','10.00','42.00',23,'female','L2Minion','Fighter',40,10195,'16.940',272,'4.500',40,43,30,41,20,10,0,0,103,428,19,174,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.65','false',0,0),
(1916,25063,'Chertuba of Great Soul','Raid Boss','ketra_orc_warrior_100_bi','24.00','51.00',35,'male','L2RaidBoss','Fighter',40,330579,'77.760',927,'5.400',60,57,73,76,70,80,1018607,103175,401,1356,113,550,278,0,1972,78,0,0,36,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.54','false',1,1),
(1917,25064,'Wizard of Storm Teruk','Raid Boss','zenta_lizardman_shaman_50_bi','19.00','55.00',40,'male','L2RaidBoss','Priest',40,218810,'91.280',1120,'6.300',60,57,73,76,70,80,1091654,139773,287,1615,42,656,278,0,1972,90,0,0,43,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.63','false',1,1),
(1918,25065,'Teruk''s Escort','Raid Fighter','zenta_lizardman','11.00','32.00',39,'male','L2Minion','Fighter',40,6444,'35.410',531,'5.400',40,43,30,41,20,10,0,0,530,780,157,317,278,0,253,123,0,0,37,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.28','false',0,0),
(1919,25066,'Teruk''s Knight','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',39,'male','L2Minion','Fighter',40,10980,'35.410',531,'5.400',40,43,30,41,20,10,0,0,265,780,39,317,278,0,253,291,0,0,40,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.56','false',0,0),
(1920,25067,'Captain of Red Flag Shaka','Raid Boss','oel_mahum_warrior_50_bi','30.00','60.00',52,'male','L2RaidBoss','Fighter',40,554640,'233.130',1598,'6.300',60,57,73,76,70,80,2909180,424683,1951,2363,1304,959,278,0,1972,71,0,0,70,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.65','false',1,1),
(1921,25068,'Shaka''s Shooter','Raid Fighter','ol_mahum_archer','14.00','25.00',51,'male','L2Minion','Ranger',500,37786,'91.130',768,'6.300',40,43,30,41,20,10,0,0,5307,1147,2104,465,249,0,227,277,0,0,50,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.93','false',0,0),
(1922,25069,'Shaka''s Follower','Raid Fighter','oel_mahum_champion','23.00','61.00',51,'male','L2Minion','Fighter',40,28199,'91.130',768,'6.300',40,43,30,41,20,10,0,0,1791,1147,1183,465,278,0,253,128,633,0,67,170,NULL,0,'Tigra',NULL,0,20,409,7,30,4,20,0,0,'0.46','false',0,0),
(1923,25070,'Enchanted Forest Watcher Ruell','Raid Boss','ti_mi_tran','23.00','90.00',55,'male','L2RaidBoss','Fighter',40,451391,'134.000',2039,'7.200',60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,1972,0,0,0,12,50,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.61','false',1,1),
(1924,25071,'Ruell''s Wind','Raid Fighter','sylph','11.00','35.00',54,'female','L2Minion','Mystic',40,7107,'52.480',987,'7.200',40,43,30,41,20,10,0,0,1676,1252,705,508,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.56','false',0,0),
(1925,25072,'Ruell''s Unicorn','Raid Fighter','unicorn','14.00','30.00',54,'male','L2Minion','Mystic',40,46232,'52.480',987,'7.200',40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,253,0,0,0,46,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.74','false',0,0),
(1926,25073,'Bloody Priest Rudelto','Raid Boss','karik_100_bi','50.00','180.00',69,'male','L2RaidBoss','Priest',40,875948,'354.000',2987,'8.100',60,57,73,76,70,80,1894878,895518,6751,3680,8676,1494,278,0,1972,0,0,0,37,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(1927,25074,'Rudelto''s Banshee','Raid Fighter','banshee','9.00','23.00',68,'female','L2Minion','Mystic',40,91632,'141.200',1458,'8.100',40,43,30,41,20,10,0,0,6447,1798,8379,730,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.56','false',0,0),
(1928,25075,'Rudelto''s Dre Vanul','Raid Fighter','dre_vanul','14.00','36.00',68,'male','L2Minion','Fighter',40,45816,'141.200',1458,'8.100',40,43,30,41,20,10,0,0,6447,1798,8379,730,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.35','false',0,0),
(1929,25076,'Princess Molrang','Raid Boss','poison_toad_100_bi','40.00','20.00',25,'male','L2RaidBoss','Fighter',40,103092,'53.660',606,'4.500',60,57,73,76,70,80,730469,69595,73,928,7,377,278,0,1972,0,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.35','false',1,1),
(1930,25077,'Captain Dogun','Raid Fighter','grizzly','21.00','40.00',24,'male','L2Minion','Fighter',40,10554,'20.600',287,'4.500',40,43,30,41,20,10,0,0,132,446,27,181,278,0,253,0,0,0,40,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.34','false',0,0),
(1931,25078,'Princess'' Guard','Raid Fighter','grizzly','21.00','40.00',24,'male','L2Minion','Fighter',40,5277,'20.600',287,'4.500',40,43,30,41,20,10,0,0,66,446,6,181,278,0,253,0,0,0,40,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.34','false',0,0),
(1932,25079,'Cat''s Eye Bandit','Raid Boss','Ol_Mahum_Raid','15.00','25.00',30,'male','L2RaidBoss','Fighter',40,168366,'121.010',763,'5.400',60,57,73,76,70,80,1329219,122342,206,1127,53,458,278,0,1972,216,0,0,50,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.63','false',1,1),
(1933,25080,'Mercenary','Raid Fighter','orc_shaman','9.00','22.00',29,'male','L2Minion','Priest',40,17036,'46.620',365,'4.500',40,43,30,41,20,10,0,0,185,542,47,220,278,0,253,179,0,0,45,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.26','false',0,0),
(1934,25081,'Cat''s Eye Bandit','Raid Fighter','ol_mahum','13.50','25.00',29,'male','L2Minion','Fighter',40,8518,'46.620',365,'4.500',40,43,30,41,20,10,0,0,185,542,47,220,278,0,253,218,0,0,50,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(1935,25082,'Leader of Cat Gang','Raid Boss','cat_the_cat_50_bi','13.50','26.00',39,'male','L2RaidBoss','Fighter',40,206753,'88.520',1062,'5.400',60,57,73,76,70,80,1078255,134578,268,1561,39,634,278,0,1972,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.61','false',1,1),
(1936,25083,'Cat Gang','Raid Fighter','cutie_cat','8.00','15.00',38,'female','L2Minion','Fighter',40,13903,'34.310',514,'5.400',40,43,30,41,20,10,0,0,330,754,65,306,278,0,253,0,0,0,48,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.34','false',0,0),
(1937,25084,'Cat Gang','Raid Fighter','cat_the_cat','9.00','16.00',38,'male','L2Minion','Fighter',40,20752,'34.310',514,'5.400',40,43,30,41,20,10,0,0,495,754,146,306,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.61','false',0,0),
(1938,25085,'Timak Orc Chief Ranger','Raid Boss','ketra_orc_warrior_100_bi','24.00','51.00',44,'male','L2RaidBoss','Fighter',40,371721,'190.450',1355,'6.300',60,57,73,76,70,80,2352182,262175,893,1845,414,749,278,0,1972,157,0,0,36,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.54','false',1,1),
(1939,25086,'Timak Orc Ranger','Raid Fighter','ketra_orc_archer','12.00','27.00',43,'male','L2Minion','Ranger',500,9259,'74.070',648,'6.300',40,43,30,41,20,10,0,0,2392,892,653,362,249,0,227,14,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,'0.91','false',0,0),
(1940,25087,'Timak Orc Ranger','Raid Fighter','ketra_orc','12.00','29.00',43,'male','L2Minion','Fighter',40,6951,'74.070',648,'6.300',40,43,30,41,20,10,0,0,807,892,367,362,278,0,253,68,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(1941,25088,'Crazy Mechanic Golem','Raid Boss','mechanic_golem_200_bi','15.00','63.00',43,'male','L2RaidBoss','Mystic',40,702418,'199.420',2039,'7.200',60,57,73,76,70,80,2492637,273103,1794,1785,1948,725,278,0,1972,0,0,0,30,150,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.72','false',1,1),
(1942,25089,'Soulless Wild Boar','Raid Boss','giant_wild_hog','25.00','27.00',59,'male','L2RaidBoss','Fighter',40,512194,'144.920',2301,'7.200',60,57,73,76,70,80,2072981,415763,2664,2875,1302,1167,278,0,1972,0,0,0,35,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.54','false',1,1),
(1943,25090,'Soulless Wolf','Raid Fighter','dire_wolf','13.00','11.00',58,'male','L2Minion','Fighter',40,35416,'56.900',1117,'7.200',40,43,30,41,20,10,0,0,3291,1399,2123,568,278,0,253,0,0,0,24,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','false',0,0);
INSERT INTO `npc` VALUES
(1944,25091,'Soulless Bear','Raid Fighter','crimson_bear','19.00','36.00',58,'male','L2Minion','Fighter',40,52860,'56.900',1117,'7.200',40,43,30,41,20,10,0,0,4936,1399,4777,568,278,0,253,0,0,0,37,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.45','false',0,0),
(1945,25092,'Korim','Raid Boss','heltor_silenos_shaman_50_bi','19.50','51.00',70,'male','L2RaidBoss','Priest',40,888658,'288.220',3058,'9.000',60,57,73,76,70,80,3859833,738431,5659,3764,5371,1528,278,0,1972,201,0,0,29,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,'0.22','false',1,1),
(1946,25093,'Korim Chief Guard Kaywon','Raid Fighter','heltor_silenos_warrior','13.00','31.00',69,'male','L2Minion','Fighter',40,93041,'114.980',1493,'8.100',40,43,30,41,20,10,0,0,10724,1840,20400,747,278,0,253,162,0,0,36,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.39','false',0,0),
(1947,25094,'Korim Guards','Raid Fighter','heltor_silenos','13.00','29.00',69,'male','L2Minion','Fighter',40,46520,'114.980',1493,'8.100',40,43,30,41,20,10,0,0,5362,1840,5100,747,278,0,253,86,0,0,34,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(1948,25095,'Elf Renoa','Raid Boss','elf_ghost','7.00','21.00',29,'male','L2RaidBoss','Mystic',40,121941,'62.760',731,'4.500',60,57,73,76,70,80,755659,76955,104,1085,11,440,278,0,1972,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.41','false',1,1),
(1949,25096,'Renoa''s Elpy','Raid Fighter','elpy','13.00','13.00',28,'male','L2Minion','Fighter',40,8296,'24.170',349,'4.500',40,43,30,41,20,10,0,0,126,522,18,212,278,0,253,0,0,0,50,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.60','false',0,0),
(1950,25097,'Renoa''s Hog','Raid Fighter','giant_wild_hog','25.00','27.00',28,'male','L2Minion','Fighter',40,12383,'24.170',349,'4.500',40,43,30,41,20,10,0,0,190,522,41,212,278,0,253,0,0,0,35,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.54','false',0,0),
(1951,25098,'Sejarr''s Servitor','Raid Boss','dark_fencer_200_bi','30.00','43.00',35,'male','L2RaidBoss','Fighter',40,330579,'77.760',927,'5.400',60,57,73,76,70,80,1018607,103175,401,1356,113,550,278,0,1972,0,0,0,25,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.20','false',1,1),
(1952,25099,'Rotten Tree Repiro','Raid Boss','hanged_man_ripper','35.00','80.00',44,'male','L2RaidBoss','Fighter',40,273375,'102.550',1355,'6.300',60,57,73,76,70,80,1344111,167614,493,1845,99,749,278,0,1972,0,0,0,55,55,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.48','false',1,1),
(1953,25100,'Spirit of Sea of Spores','Raid Fighter','pixy','5.00','25.00',43,'female','L2Minion','Fighter',40,27494,'39.880',648,'6.300',40,43,30,41,20,10,0,0,318,892,88,362,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.72','false',0,0),
(1954,25101,'Fighter of Sea of Spores','Raid Fighter','troll','21.00','35.00',43,'male','L2Minion','Fighter',40,13747,'39.880',648,'6.300',40,43,30,41,20,10,0,0,318,892,88,362,278,0,253,0,0,0,55,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.61','false',0,0),
(1955,25102,'Shacram','Raid Boss','minotaur_100_bi','42.00','94.00',45,'male','L2RaidBoss','Fighter',40,576831,'105.420',1722,'7.200',60,57,73,76,70,80,1591877,230991,1603,1905,927,774,278,0,1972,300,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.59','false',1,1),
(1956,25103,'Sorcerer Isirr','Raid Boss','zenta_lizardman_matriarch_50_bi','30.00','63.00',55,'male','L2RaidBoss','Mystic',40,451391,'134.000',2039,'7.200',60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,1972,195,0,0,53,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(1957,25104,'Isirr''s Guard','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',54,'male','L2Minion','Fighter',40,46232,'52.480',987,'7.200',40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,253,221,0,0,40,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.56','false',0,0),
(1958,25105,'Isirr''s Guards','Raid Fighter','zenta_lizardman','11.00','32.00',54,'male','L2Minion','Fighter',40,23116,'52.480',987,'7.200',40,43,30,41,20,10,0,0,1257,1252,396,508,278,0,253,16,0,0,37,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.28','false',0,0),
(1959,25106,'Ghost of the Well Lidia','Raid Boss','bloody_queen_100_bi','28.00','85.00',60,'female','L2RaidBoss','Mystic',40,526218,'150.650',2570,'8.100',60,57,73,76,70,80,2414839,561233,3581,3188,2006,1294,278,0,1972,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(1960,25107,'Lidia''s Archer','Raid Fighter','skeleton_archer','11.00','27.00',59,'male','L2Minion','Ranger',500,36451,'59.880',1251,'8.100',40,43,30,41,20,10,0,0,9897,1554,3306,631,249,0,227,279,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.80','false',0,0),
(1961,25108,'Lidia''s Fighter','Raid Fighter','death_blader','15.00','45.00',59,'male','L2Minion','Fighter',40,27202,'59.880',1251,'8.100',40,43,30,41,20,10,0,0,3340,1554,1859,631,278,0,253,1472,0,0,100,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.45','false',0,0),
(1962,25109,'Antharas Priest Cloe','Raid Boss','succubus_100_bi','20.00','75.00',74,'female','L2RaidBoss','Priest',40,935092,'357.000',3347,'9.000',60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,278,0,1972,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.84','false',1,1),
(1963,25110,'Cloe''s Servitor','Raid Fighter','silhouette','8.00','23.00',73,'female','L2Minion','Fighter',40,65759,'142.400',1637,'9.000',40,43,30,41,20,10,0,0,11127,2008,21420,815,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.54','false',0,0),
(1964,25111,'Cloe''s Servitor','Raid Fighter','shadow','10.00','30.00',73,'male','L2Minion','Mystic',40,98148,'142.400',1637,'9.000',40,43,30,41,20,10,0,0,16691,2008,48198,815,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.54','false',0,0),
(1965,25112,'Agent of Beres,Meana','Raid Boss','medusa_100_bi','20.00','53.00',30,'female','L2RaidBoss','Fighter',40,127782,'65.160',763,'5.400',60,57,73,76,70,80,890100,105037,169,1127,26,458,278,0,1972,0,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.52','false',1,1),
(1966,25113,'Meana''s Maid','Raid Fighter','succubus','10.00','36.00',29,'female','L2Minion','Mystic',40,8678,'25.100',365,'4.500',40,43,30,41,20,10,0,0,203,542,41,220,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.84','false',0,0),
(1967,25114,'Meana''s Guard Doll','Raid Fighter','crimson_doll','15.00','38.00',29,'male','L2Minion','Fighter',40,12952,'25.100',365,'4.500',40,43,30,41,20,10,0,0,305,542,94,220,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.67','false',0,0),
(1968,25115,'Icarus Sample 1','Raid Boss','mana_vampire_200_bi','33.00','51.00',40,'male','L2RaidBoss','Mystic',40,294846,'169.520',1120,'6.300',60,57,73,76,70,80,1910416,217891,520,1615,177,656,278,0,1972,0,0,0,90,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.39','false',1,1),
(1969,25116,'Icarus Sample 2','Raid Fighter','skeleton_archer','11.00','27.00',39,'male','L2Minion','Ranger',500,19779,'65.750',531,'5.400',40,43,30,41,20,10,0,0,1417,780,290,317,249,0,227,273,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,'0.80','false',0,0),
(1970,25117,'Icarus Sample 3','Raid Fighter','magical_weaver','11.00','20.00',39,'male','L2Minion','Mystic',40,5984,'65.750',531,'5.400',40,43,30,41,20,10,0,0,478,780,163,317,278,0,253,0,0,0,90,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','false',0,0),
(1971,25118,'Guilotine,Warden of the Execution Grounds','Raid Boss','skeleton_pikeman_100_bi','20.00','58.00',35,'male','L2RaidBoss','Fighter',40,330579,'77.760',1415,'6.300',60,57,73,76,70,80,1193687,138419,601,1356,236,550,278,0,1972,96,0,0,50,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.21','false',1,1),
(1972,25119,'Messenger of Fairy Queen Berun','Raid Boss','pan_100_bi','42.00','73.00',50,'male','L2RaidBoss','Fighter',40,507285,'274.000',1722,'7.200',60,57,73,76,70,80,1237500,455390,1918,2226,1530,904,278,0,1972,213,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.58','false',1,1),
(1973,25120,'Berun''s Officer','Raid Fighter','pan','14.00','35.00',49,'male','L2Minion','Fighter',40,34424,'106.800',830,'6.300',40,43,30,41,20,10,0,0,2336,1079,2443,438,278,0,253,90,0,0,45,110,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.58','false',0,0),
(1974,25121,'Berun''s Prattler','Raid Fighter','pixy','5.00','25.00',49,'female','L2Minion','Fighter',40,51380,'106.800',830,'6.300',40,43,30,41,20,10,0,0,3504,1079,5498,438,278,0,253,0,0,0,80,120,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.72','false',0,0),
(1975,25122,'Refugee Hopeful Leo','Raid Boss','oel_mahum_witch_doctor_50_bi','22.50','54.00',56,'male','L2RaidBoss','Fighter',40,467209,'136.790',2235,'7.200',60,57,73,76,70,80,1722981,291015,1459,2649,476,1075,278,0,1972,201,0,0,70,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.26','false',1,1),
(1976,25123,'Leo''s Servant','Raid Fighter','lesser_giant','21.00','44.00',55,'male','L2Minion','Fighter',40,47946,'53.600',1084,'7.200',40,43,30,41,20,10,0,0,2694,1288,1740,523,278,0,253,3937,0,0,15,180,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.58','false',0,0),
(1977,25124,'Leo''s Steward','Raid Fighter','lesser_giant_mage','21.00','44.00',55,'male','L2Minion','Mystic',40,23973,'53.600',1084,'7.200',40,43,30,41,20,10,0,0,1347,1288,435,523,278,0,253,3938,0,0,15,180,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.56','false',0,0),
(1978,25125,'Fierce Tiger King Angel','Raid Boss','saber_toothed_tiger_200_bi','72.00','87.00',65,'male','L2RaidBoss','Fighter',40,1637918,'348.000',2707,'8.100',60,57,73,76,70,80,1820975,806823,11761,3349,30166,1360,278,0,1972,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(1979,25126,'Longhorn Golkonda','Raid Boss','minotaur_100_bi','42.00','94.00',79,'male','L2RaidBoss','Fighter',40,1974940,'355.000',3718,'9.000',60,57,73,76,70,80,2346616,1166150,20224,4530,59372,1839,278,0,1972,91,0,0,40,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,'0.59','false',1,1),
(1980,25127,'Langk Matriarch Rashkos','Raid Boss','virud_lizardman_matriarch_50_bi','19.00','57.00',24,'male','L2RaidBoss','Fighter',40,198734,'51.510',763,'5.400',60,57,73,76,70,80,723779,67853,134,892,27,362,278,0,1972,124,0,0,56,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.65','false',1,1),
(1981,25128,'Vuku Grand Seer Gharmash','Raid Boss','batur_orc_shaman_100_bi','22.00','35.00',33,'male','L2RaidBoss','Priest',40,148507,'72.600',860,'5.400',60,57,73,76,70,80,984556,97626,174,1261,24,512,278,0,1972,195,0,0,50,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.30','false',1,1),
(1982,25129,'Vuku Shaman','Raid Fighter','orc_shaman','9.00','22.00',32,'male','L2Minion','Priest',40,10036,'28.030',414,'5.400',40,43,30,41,20,10,0,0,213,607,39,246,278,0,253,7,0,0,45,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.26','false',0,0),
(1983,25130,'Gharmash''s Pet Trimden','Raid Fighter','poison_spider','27.00','25.50',32,'male','L2Minion','Mystic',40,14980,'28.030',414,'5.400',40,43,30,41,20,10,0,0,320,607,89,246,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.65','false',0,0),
(1984,25131,'Carnage Lord Gato','Raid Boss','oel_mahum_50_bi','30.00','57.00',50,'male','L2RaidBoss','Fighter',40,369009,'119.800',1415,'6.300',60,57,73,76,70,80,1670250,297042,1243,2226,429,904,278,0,1972,71,0,0,70,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.48','false',1,1),
(1985,25132,'Gato''s Marksman','Raid Fighter','ol_mahum_archer','14.00','25.00',49,'male','L2Minion','Ranger',500,6112,'46.770',677,'6.300',40,43,30,41,20,10,0,0,3356,1079,682,438,249,0,227,273,0,0,50,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.93','false',0,0),
(1986,25133,'Gato''s Troop Leader','Raid Fighter','ol_mahum_champion','14.00','27.00',49,'male','L2Minion','Fighter',40,4588,'46.770',677,'6.300',40,43,30,41,20,10,0,0,1132,1079,383,438,278,0,253,69,0,0,50,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.63','false',0,0),
(1987,25134,'Leto Chief Talkin','Raid Boss','Zenta_Lizardman_Raid','30.00','37.50',40,'male','L2RaidBoss','Fighter',40,218810,'91.280',1722,'7.200',60,57,73,76,70,80,1279280,187517,427,1615,87,656,278,0,1972,221,0,0,53,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(1988,25135,'Talkin''s Seer','Raid Fighter','virud_lizardman_shaman','10.00','29.00',39,'male','L2Minion','Priest',40,21961,'35.410',830,'6.300',40,43,30,41,20,10,0,0,393,780,80,317,278,0,253,7,0,0,43,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.48','false',0,0),
(1989,25136,'Talkin''s Bodyguard','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',39,'male','L2Minion','Fighter',40,10980,'35.410',830,'6.300',40,43,30,41,20,10,0,0,393,780,80,317,278,0,253,16,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.56','false',0,0),
(1990,25137,'Beleth''s Seer Sephia','Raid Boss','bloody_queen_100_bi','28.00','85.00',55,'female','L2RaidBoss','Mystic',40,451391,'134.000',2039,'7.200',60,57,73,76,70,80,2001376,387789,2034,2576,903,1046,278,0,1972,0,0,0,80,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(1991,25138,'Soul Drinker','Raid Fighter','mana_vampire','11.00','20.00',54,'male','L2Minion','Mystic',40,7107,'52.480',987,'7.200',40,43,30,41,20,10,0,0,2500,1252,1464,508,278,0,253,0,0,0,90,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','false',0,0),
(1992,25139,'Sephia''s Salve','Raid Fighter','kaim_vanul','24.00','40.00',54,'male','L2Minion','Fighter',40,10671,'52.480',987,'7.200',40,43,30,41,20,10,0,0,3750,1252,3295,508,278,0,253,0,0,0,37,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.45','false',0,0),
(1993,25140,'Hekaton Prime','Raid Boss','susceptor','20.00','35.00',65,'male','L2RaidBoss','Fighter',40,818959,'282.910',2707,'8.100',60,57,73,76,70,80,3674504,679343,4656,3349,4297,1360,278,0,1972,0,0,0,27,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.43','false',1,1),
(1994,25141,'Hekaton Cottus','Raid Fighter','gamlin','11.00','32.00',64,'male','L2Minion','Fighter',40,85286,'112.570',1319,'8.100',40,43,30,41,20,10,0,0,8885,1634,16636,663,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(1995,25142,'Hekaton Chires','Raid Fighter','lesser_giant','21.00','44.00',64,'male','L2Minion','Fighter',40,42643,'112.570',1319,'8.100',40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,253,3937,0,0,15,180,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,'0.58','false',0,0),
(1996,25143,'Fire of Wrath Shuriel','Raid Boss','angel','13.50','36.50',78,'male','L2RaidBoss','Fighter',40,977229,'355.000',3718,'9.000',60,57,73,76,70,80,2287584,1166150,10051,4503,14666,1828,278,0,1972,2500,0,0,30,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,'0.52','false',1,1),
(1997,25144,'Shuriel''s Oracle','Raid Fighter','oel_mahum_witch_doctor','15.00','34.00',78,'male','L2Minion','Fighter',40,103799,'142.000',1859,'9.000',40,43,30,41,20,10,0,0,9703,2222,14332,902,278,0,253,201,0,0,70,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,0,'0.26','false',0,0),
(1998,25145,'Shuriel''s Paladin','Raid Fighter','kel_mahum_champion','13.00','32.00',78,'male','L2Minion','Fighter',40,51899,'142.000',1859,'9.000',40,43,30,41,20,10,0,0,9703,2222,14332,902,278,0,253,147,0,0,50,170,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,0,'0.56','false',0,0),
(1999,25146,'Serpent Demon Bifrons','Raid Boss','serpent_slave_50_bi','25.00','72.00',21,'male','L2RaidBoss','Fighter',40,90169,'38.900',485,'4.500',60,57,73,76,70,80,578451,45688,42,789,3,320,278,0,1972,73,0,0,70,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(2000,25147,'Assassin of Bifrons','Raid Fighter','virud_lizardman_scout','10.00','22.00',20,'male','L2Minion','Ranger',500,6241,'14.890',227,'4.500',40,43,30,41,20,10,0,0,90,378,3,153,249,0,227,2507,0,0,43,170,'',0,'Local','',0,0,0,7,30,4,20,1500,0,'0.72','false',0,0),
(2001,25148,'Butcher of Bifrons','Raid Fighter','virud_lizardman_warrior','12.00','30.00',20,'male','L2Minion','Fighter',40,4657,'14.890',227,'4.500',40,43,30,41,20,10,0,0,30,378,2,153,278,0,253,16,0,0,52,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.59','false',0,0),
(2002,25149,'Zombie Lord Crowl','Raid Boss','zombie_100_bi','26.00','45.00',25,'male','L2RaidBoss','Fighter',40,103092,'53.660',606,'4.500',60,57,73,76,70,80,856025,92883,110,928,15,377,278,0,1972,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.43','false',1,1),
(2003,25150,'Evil Spirit Archer','Raid Fighter','skeleton_archer','11.00','27.00',24,'male','L2Minion','Ranger',500,7071,'20.600',287,'4.500',40,43,30,41,20,10,0,0,296,446,25,181,249,0,227,14,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,'0.80','false',0,0),
(2004,25151,'Evil Spirit Warrior','Raid Fighter','skeleton','11.00','25.00',24,'male','L2Minion','Fighter',40,5277,'20.600',287,'4.500',40,43,30,41,20,10,0,0,100,446,14,181,278,0,253,946,0,0,60,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,'0.30','false',0,0),
(2005,25152,'Flame Lord Shadar','Raid Boss','dre_vanul_100_bi','28.00','75.00',35,'male','L2RaidBoss','Fighter',40,165289,'77.760',927,'5.400',60,57,73,76,70,80,1193687,138419,300,1356,59,550,278,0,1972,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.35','false',1,1),
(2006,25153,'Claws of Shadar','Raid Fighter','imp','10.00','24.00',34,'male','L2Minion','Fighter',40,16632,'30.060',446,'5.400',40,43,30,41,20,10,0,0,554,654,220,265,278,0,253,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.34','false',0,0),
(2007,25154,'Whip of Shadar','Raid Fighter','succubus','10.00','36.00',34,'female','L2Minion','Mystic',40,8316,'30.060',446,'5.400',40,43,30,41,20,10,0,0,277,654,55,265,278,0,253,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.84','false',0,0),
(2008,25155,'Shaman King Selu','Raid Boss','batur_orc_overlord_100_bi','24.00','52.00',40,'male','L2RaidBoss','Fighter',40,294846,'182.560',1120,'6.300',60,57,73,76,70,80,2046864,230791,570,1615,234,656,278,0,1972,79,0,0,80,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.28','false',1,1),
(2009,25156,'Fanatic Shaman','Raid Fighter','batur_orc_shaman','11.00','16.00',39,'male','L2Minion','Priest',40,19779,'70.810',531,'5.400',40,43,30,41,20,10,0,0,699,780,383,317,278,0,253,123,19,0,50,170,'',0,'Tigra','',0,20,304,7,30,4,20,0,0,'0.30','false',0,0),
(2010,25157,'Fanatic Soldier','Raid Fighter','batur_orc_warrior','10.00','20.00',39,'male','L2Minion','Fighter',40,29521,'70.810',531,'5.400',40,43,30,41,20,10,0,0,1048,780,862,317,278,0,253,7,0,0,80,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,'0.30','false',0,0),
(2011,25158,'King Tarlk','Raid Boss','king_bugbear_200_bi','45.00','126.00',48,'male','L2RaidBoss','Fighter',40,920790,'211.790',1722,'7.200',60,57,73,76,70,80,2448691,283783,2574,2094,2776,850,278,0,1972,160,0,0,55,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.28','false',1,1),
(2012,25159,'Paniel the Unicorn','Raid Boss','unicorn','14.00','30.00',54,'male','L2RaidBoss','Fighter',40,435256,'131.200',1975,'7.200',60,57,73,76,70,80,1983647,381736,1898,2504,823,1017,278,0,1972,0,0,0,46,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.74','false',1,1),
(2013,25160,'Rapini the Unicorn','Raid Fighter','unicorn_boxer','11.00','18.00',53,'male','L2Minion','Mystic',40,44492,'51.350',955,'7.200',40,43,30,41,20,10,0,0,1736,1216,740,494,278,0,253,0,0,0,27,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.71','false',0,0),
(2014,25161,'Ririf the Unicorn','Raid Fighter','unicorn_mirage','13.00','17.50',53,'male','L2Minion','Mystic',40,22246,'51.350',955,'7.200',40,43,30,41,20,10,0,0,1736,1216,740,494,278,0,253,0,0,0,27,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,'0.69','false',0,0),
(2015,25162,'Giant Marpanak','Raid Boss','lesser_giant_100_bi','42.00','91.00',60,'male','L2RaidBoss','Fighter',40,1461912,'274.040',2368,'8.100',60,57,73,76,70,80,3123036,491139,7025,2951,11841,1198,278,0,1972,3937,0,0,15,180,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.58','false',1,1),
(2016,25163,'Roaring Skylancer','Raid Boss','Drake_Raid','44.00','51.50',70,'male','L2RaidBoss','Fighter',40,888658,'355.000',3058,'9.000',60,57,73,76,70,80,1915900,918808,6981,3764,8986,1528,278,0,1972,0,0,0,70,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.84','false',1,1),
(2017,25166,'Ikuntai','Raid Boss','skeleton_knight_50_bi','15.00','39.00',25,'male','L2RaidBoss','Fighter',40,134813,'99.660',606,'4.500',60,57,73,76,70,80,1278325,108133,133,928,31,377,278,0,1972,150,0,0,40,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.17','false',1,1),
(2018,25167,'Ikuntai''s Servitor','Raid Fighter','silhouette','8.00','23.00',24,'female','L2Minion','Fighter',40,13786,'38.270',287,'4.500',40,43,30,41,20,10,0,0,121,446,28,181,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.54','false',0,0),
(2019,25168,'Pawn of Ikuntai','Raid Fighter','skeleton_pikeman','10.00','28.00',24,'male','L2Minion','Fighter',40,6893,'38.270',287,'4.500',40,43,30,41,20,10,0,0,121,446,28,181,278,0,253,299,0,0,50,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,'0.21','false',0,0),
(2020,25169,'Ragraman','Raid Boss','batur_orc_overlord_100_bi','24.00','52.00',30,'male','L2RaidBoss','Fighter',40,336732,'121.010',763,'5.400',60,57,73,76,70,80,1329219,122342,412,1127,212,458,278,0,1972,72,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.28','false',1,1),
(2021,25170,'Lizardmen Leader Hellion','Raid Boss','zenta_lizardman_matriarch_50_bi','30.00','63.00',38,'male','L2RaidBoss','Fighter',40,195371,'85.780',1028,'5.400',60,57,73,76,70,80,1064286,131051,251,1508,36,612,278,0,1972,223,0,0,53,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(2022,25171,'Hellion''s Archers','Raid Fighter','zenta_lizardman_scout','11.00','30.00',37,'male','L2Minion','Ranger',500,13142,'33.230',497,'5.400',40,43,30,41,20,10,0,0,686,728,60,295,249,0,227,278,0,0,37,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.93','false',0,0),
(2023,25172,'Hellion''s Guards','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',37,'male','L2Minion','Fighter',40,9807,'33.230',497,'5.400',40,43,30,41,20,10,0,0,231,728,34,295,278,0,253,291,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.56','false',0,0),
(2024,25173,'Tiger King Karuta','Raid Boss','saber_toothed_tiger_200_bi','72.00','87.00',45,'male','L2RaidBoss','Fighter',40,288415,'105.420',1415,'6.300',60,57,73,76,70,80,1591877,230991,801,1905,231,774,278,0,1972,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(2025,25174,'Karuta''s Follower','Raid Fighter','heltor_silenos_chieftain','13.00','31.50',44,'male','L2Minion','Fighter',40,7758,'41.020',677,'6.300',40,43,30,41,20,10,0,0,725,922,205,374,278,0,253,127,0,0,27,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.39','false',0,0),
(2026,25175,'Karuta''s Inferiors','Raid Fighter','crimson_bear','19.00','36.00',44,'male','L2Minion','Fighter',40,3879,'41.020',677,'6.300',40,43,30,41,20,10,0,0,725,922,205,374,278,0,253,0,0,0,37,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.45','false',0,0),
(2027,25176,'Black Lily','Raid Boss','Succubus_Raid','12.00','30.70',55,'female','L2RaidBoss','Mystic',40,451391,'134.000',2039,'7.200',60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,1972,0,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(2028,25177,'Guardian Knight of Black Lily','Raid Fighter','death_knight','12.00','30.00',54,'male','L2Minion','Fighter',40,46232,'52.480',987,'7.200',40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,253,75,0,0,27,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.71','false',0,0),
(2029,25178,'Servitor of Black Lily','Raid Fighter','silhouette','8.00','23.00',54,'female','L2Minion','Fighter',40,23116,'52.480',987,'7.200',40,43,30,41,20,10,0,0,1257,1252,396,508,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.54','false',0,0),
(2030,25179,'Guardian of the Statue of Giant Karum','Raid Boss','lesser_giant_50_bi','31.50','69.00',60,'male','L2RaidBoss','Fighter',40,526218,'147.560',2368,'8.100',60,57,73,76,70,80,2091330,424759,2895,2951,1474,1198,278,0,1972,3937,0,0,15,180,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.58','false',1,1),
(2031,25180,'Karum''s Guard','Raid Fighter','lesser_giant_mage','21.00','44.00',59,'male','L2Minion','Mystic',40,36451,'57.970',1150,'7.200',40,43,30,41,20,10,0,0,3509,1437,2314,583,278,0,253,3938,0,0,15,180,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.56','false',0,0),
(2032,25181,'Karum''s Warrior','Raid Fighter','susceptor','20.00','35.00',59,'male','L2Minion','Fighter',40,54404,'57.970',1150,'7.200',40,43,30,41,20,10,0,0,5263,1437,5208,583,278,0,253,0,0,0,27,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.43','false',0,0),
(2033,25182,'Demon Kurikups','Raid Boss','karik_100_bi','50.00','180.00',65,'male','L2RaidBoss','Fighter',40,100502,'152.340',2707,'8.100',60,57,73,76,70,80,2460640,581209,3838,3349,2140,1360,278,0,1972,0,0,0,37,200,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(2034,25183,'Kurikups'' Wife','Raid Fighter','bloody_queen','14.00','40.00',64,'female','L2Minion','Mystic',40,13187,'60.610',1319,'8.100',40,43,30,41,20,10,0,0,3661,1634,2071,663,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.50','false',0,0),
(2035,25184,'Devil Blader of Chaos','Raid Fighter','death_blader','15.00','45.00',64,'male','L2Minion','Fighter',40,6593,'60.610',1319,'8.100',40,43,30,41,20,10,0,0,3661,1634,2071,663,278,0,253,1472,0,0,100,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.45','false',0,0),
(2036,25185,'Tasaba Patriarch Hellena','Raid Boss','zenta_lizardman_matriarch','20.00','40.00',35,'male','L2RaidBoss','Fighter',40,165289,'77.760',927,'5.400',60,57,73,76,70,80,1193687,138419,300,1356,59,550,278,0,1972,225,0,0,53,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(2037,25186,'Hellena''s Marksman','Raid Fighter','zenta_lizardman_scout','11.00','30.00',34,'male','L2Minion','Ranger',500,11143,'30.060',446,'5.400',40,43,30,41,20,10,0,0,821,654,97,265,249,0,227,272,0,0,37,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.93','false',0,0),
(2038,25187,'Helena''s Soldier','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',34,'male','L2Minion','Fighter',40,8316,'30.060',446,'5.400',40,43,30,41,20,10,0,0,277,654,55,265,278,0,253,16,0,0,40,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.56','false',0,0),
(2039,25188,'Apepi','Raid Boss','lienrik','12.00','50.00',30,'male','L2RaidBoss','Fighter',40,255564,'65.160',763,'5.400',60,57,73,76,70,80,759553,78807,227,1127,50,458,278,0,1972,0,0,0,100,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(2040,25189,'Cronos''s Servitor Mumu','Raid Boss','cutie_cat','8.00','15.00',34,'female','L2RaidBoss','Fighter',40,39603,'75.160',893,'5.400',60,57,73,76,70,80,1001975,100648,187,1308,26,531,278,0,1972,0,0,0,48,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.34','false',1,1),
(2041,25190,'Mumu''s Wizard','Raid Fighter','cutie_cat','8.00','15.00',33,'female','L2Minion','Mystic',40,3355,'29.040',430,'5.400',40,43,30,41,20,10,0,0,229,630,43,256,278,0,253,0,0,0,48,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.34','false',0,0),
(2042,25191,'Mumu''s Warrior','Raid Fighter','cat_the_cat','9.00','16.00',33,'male','L2Minion','Fighter',40,5037,'29.040',430,'5.400',40,43,30,41,20,10,0,0,344,630,97,256,278,0,253,0,0,0,80,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.61','false',0,0),
(2043,25192,'Earth Protector Panathen','Raid Boss','farhite','16.00','31.00',43,'male','L2RaidBoss','Fighter',40,258849,'99.710',1296,'6.300',60,57,73,76,70,80,1557899,221896,673,1785,182,725,278,0,1972,183,0,0,15,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.74','false',1,1),
(2044,25193,'Panathen''s Knight','Raid Fighter','nos','26.00','42.00',42,'male','L2Minion','Fighter',40,7218,'38.750',618,'6.300',40,43,30,41,20,10,0,0,1213,864,644,350,278,0,253,5130,0,0,18,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.78','false',0,0),
(2045,25194,'Panathen''s Protectors','Raid Fighter','dailaon','20.00','28.00',42,'male','L2Minion','Fighter',500,13005,'38.750',618,'6.300',40,43,30,41,20,10,0,0,606,864,161,350,278,0,253,5127,0,0,18,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.91','false',0,0),
(2046,25198,'Fafurion''s Herald Lokness','Raid Boss','devastator_200_bi','100.00','105.00',70,'male','L2RaidBoss','Fighter',40,1777317,'355.000',2639,'8.100',60,57,73,76,70,80,1915900,918808,13963,3764,35947,1528,278,0,1972,0,0,0,70,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.84','false',1,1),
(2047,25199,'Water Dragon Seer Sheshark','Raid Boss','kaim_vanul','24.00','40.00',72,'male','L2RaidBoss','Fighter',40,912634,'311.540',2707,'8.100',60,57,73,76,70,80,4674309,805512,7164,3933,8915,1597,278,0,1972,181,0,0,43,200,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.48','false',1,1),
(2048,25200,'Family of Sheshark','Raid Fighter','hunter_gargoyle','25.00','65.00',71,'male','L2Minion','Fighter',40,64111,'124.420',1319,'8.100',40,43,30,41,20,10,0,0,9147,1924,15345,781,278,0,253,0,0,0,100,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(2049,25201,'Guard of Sheshark','Raid Fighter','serpent_slave','17.00','46.00',71,'male','L2Minion','Fighter',40,95688,'124.420',1319,'8.100',40,43,30,41,20,10,0,0,13720,1924,34528,781,278,0,253,6370,0,0,52,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,'0.59','false',0,0),
(2050,25202,'Krokian Padisha Sobekk','Raid Boss','ant_soldier_200_bi','75.00','54.00',74,'male','L2RaidBoss','Fighter',40,935092,'357.000',2777,'8.100',60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,278,0,1972,5130,0,0,18,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.78','false',1,1),
(2051,25203,'Parhit Padisha Sobekk','Raid Fighter','aracne','15.00','26.00',73,'male','L2Minion','Fighter',40,98148,'142.400',1353,'8.100',40,43,30,41,20,10,0,0,8345,2008,12049,815,278,0,253,5131,0,0,15,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.74','false',0,0),
(2052,25204,'Krokian Padisha Sobekk','Raid Fighter','vampire_bat','10.00','33.50',73,'male','L2Minion','Mystic',40,49074,'142.400',1353,'8.100',40,43,30,41,20,10,0,0,8345,2008,12049,815,278,0,253,5128,0,0,18,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.78','false',0,0),
(2053,25205,'Ocean Flame Ashakiel','Raid Boss','saber_toothed_tiger_200_bi','72.00','87.00',76,'male','L2RaidBoss','Fighter',40,956490,'311.810',3274,'9.000',60,57,73,76,70,80,4888056,961047,8153,4273,10359,1735,278,0,1972,98,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.76','false',1,1),
(2054,25206,'Ashakia''s Blade','Raid Fighter','dark_fencer_200_bi','30.00','43.00',75,'female','L2Minion','Fighter',40,100472,'124.790',1601,'9.000',40,43,30,41,20,10,0,0,15569,2094,39730,850,278,0,253,6717,0,0,50,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(2055,25207,'Ashakiel''s Rod','Raid Fighter','unicorn','14.00','30.00',75,'male','L2Minion','Mystic',40,50236,'124.790',1601,'9.000',40,43,30,41,20,10,0,0,7784,2094,9932,850,278,0,253,6718,0,0,50,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.48','false',0,0),
(2056,25208,'Water Couatle Ateka','Raid Boss','lienrik','12.00','50.00',40,'male','L2RaidBoss','Fighter',40,218810,'91.280',1722,'7.200',60,57,73,76,70,80,1279280,187517,427,1615,87,656,278,0,1972,0,0,0,100,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(2057,25209,'Ateka''s Shaman','Raid Fighter','lienrik','12.00','50.00',39,'male','L2Minion','Priest',40,14713,'35.410',830,'6.300',40,43,30,41,20,10,0,0,524,780,143,317,278,0,253,0,0,0,100,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(2058,25210,'Ateka''s Grunt','Raid Fighter','lienrik','12.00','50.00',39,'male','L2Minion','Fighter',40,21961,'35.410',830,'6.300',40,43,30,41,20,10,0,0,786,780,323,317,278,0,253,0,0,0,100,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(2059,25211,'Sebek','Raid Boss','nos','26.00','42.00',36,'male','L2RaidBoss','Fighter',40,174646,'80.400',1975,'7.200',60,57,73,76,70,80,1212311,142855,326,1405,65,570,278,0,1972,5130,0,0,18,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.78','false',1,1),
(2060,25212,'Sebek''s Priest','Raid Fighter','zenta_lizardman_scout','11.00','30.00',35,'male','L2Minion','Priest',500,11763,'31.100',955,'7.200',40,43,30,41,20,10,0,0,879,678,105,275,249,0,227,279,0,0,37,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.93','false',0,0),
(2061,25213,'Sebek''s Fanatic','Raid Fighter','dailaon','20.00','28.00',35,'male','L2Minion','Fighter',500,8778,'31.100',955,'7.200',40,43,30,41,20,10,0,0,296,678,59,275,278,0,253,5127,0,0,18,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.91','false',0,0),
(2062,25214,'Fafurion''s Page Sika','Raid Boss','water_giant','13.00','44.00',40,'male','L2RaidBoss','Fighter',80,218810,'91.280',2368,'8.100',60,57,73,76,70,80,1091654,139773,287,1615,42,656,278,0,1972,5132,0,0,35,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(2063,25215,'Sika''s Wizard','Raid Fighter','undine','12.00','27.00',39,'female','L2Minion','Mystic',40,14713,'35.410',1150,'7.200',40,43,30,41,20,10,0,0,353,780,69,317,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.35','false',0,0),
(2064,25216,'Sika''s Fighter','Raid Fighter','undine','12.00','27.00',39,'female','L2Minion','Mystic',40,21961,'35.410',1150,'7.200',40,43,30,41,20,10,0,0,530,780,157,317,278,0,253,0,0,0,60,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.35','false',0,0),
(2065,25217,'Cursed Clara','Raid Boss','medusa','10.00','25.00',50,'female','L2RaidBoss','Fighter',40,369009,'119.800',1722,'7.200',60,57,73,76,70,80,1425270,224177,833,2226,206,904,278,0,1972,0,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.52','false',1,1),
(2066,25218,'Clara''s Marksman','Raid Fighter','virud_lizardman_scout','10.00','22.00',49,'male','L2Minion','Ranger',500,6112,'46.770',830,'6.300',40,43,30,41,20,10,0,0,2250,1079,328,438,249,0,227,2507,0,0,43,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.72','false',0,0),
(2067,25219,'Clara''s Pawn','Raid Fighter','virud_lizardman_warrior','12.00','30.00',49,'male','L2Minion','Fighter',40,4588,'46.770',830,'6.300',40,43,30,41,20,10,0,0,759,1079,184,438,278,0,253,94,0,0,52,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.59','false',0,0),
(2068,25220,'Death Lord Hallate','Raid Boss','death_lord','21.00','40.00',73,'male','L2RaidBoss','Fighter',40,924022,'356.000',3274,'9.000',60,57,73,76,70,80,2190219,1002134,8449,4017,12049,1631,278,0,1972,78,0,0,40,170,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(2069,25221,'Death Mage Krician','Raid Fighter','death_blader','15.00','45.00',72,'male','L2Minion','Fighter',40,64948,'142.400',1601,'9.000',40,43,30,41,20,10,0,0,10780,1966,20691,798,278,0,253,1472,0,0,100,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.45','false',0,0),
(2070,25222,'Death Fighter Harik','Raid Fighter','death_knight','12.00','30.00',72,'male','L2Minion','Fighter',40,96938,'142.400',1601,'9.000',40,43,30,41,20,10,0,0,16170,1966,46558,798,278,0,253,75,0,0,27,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.71','false',0,0),
(2071,25223,'Soul Collector Acheron','Raid Boss','vale_master_50_bi','18.00','63.00',35,'male','L2RaidBoss','Fighter',40,165289,'77.760',1237,'6.300',60,57,73,76,70,80,1018607,103175,200,1356,28,550,278,0,1972,192,0,0,70,160,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.74','false',1,1),
(2072,25224,'Soul Slasher','Raid Fighter','dark_horror','20.00','35.00',34,'male','L2Minion','Fighter',40,11143,'30.060',589,'6.300',40,43,30,41,20,10,0,0,246,654,46,265,278,0,253,0,0,0,100,140,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.37','false',0,0),
(2073,25225,'Soul Strainer','Raid Fighter','hungry_spirit','13.00','40.00',34,'male','L2Minion','Fighter',40,16632,'30.060',531,'5.400',40,43,30,41,20,10,0,0,369,654,104,265,278,0,253,0,0,0,15,155,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.45','false',0,0),
(2074,25226,'Roaring Lord Kastor','Raid Boss','oel_mahum_witch_doctor_50_bi','22.50','54.00',62,'male','L2RaidBoss','Fighter',40,768537,'299.380',2502,'8.100',60,57,73,76,70,80,3828086,679088,4510,3108,4959,1262,278,0,1972,186,0,0,70,180,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.26','false',1,1),
(2075,25227,'Kastor''s Seer','Raid Fighter','oel_mahum_witch_doctor','15.00','34.00',61,'male','L2Minion','Fighter',40,79678,'118.930',1217,'8.100',40,43,30,41,20,10,0,0,4297,1515,4800,615,278,0,253,9,0,0,70,170,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.26','false',0,0),
(2076,25228,'Kastor''s Prefect','Raid Fighter','oel_mahum_warrior','20.00','38.00',61,'male','L2Minion','Fighter',40,39839,'118.930',1217,'8.100',40,43,30,41,20,10,0,0,4297,1515,4800,615,278,0,253,79,0,0,70,190,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.65','false',0,0),
(2077,25229,'Storm Winged Naga','Raid Boss','wyrm_50_bi','58.00','108.00',75,'male','L2RaidBoss','Fighter',40,1891801,'357.000',3420,'9.000',60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,1972,0,0,0,70,200,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.19','false',1,1),
(2078,25230,'Timak Seer Ragoth','Raid Boss','batur_orc_shaman_50_bi','16.00','25.00',57,'male','L2RaidBoss','Priest',40,482650,'139.530',2169,'7.200',60,57,73,76,70,80,2036961,401639,2325,2723,1079,1106,278,0,1972,201,0,0,50,160,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.30','false',1,1),
(2079,25231,'Ragoth''s Guard','Raid Fighter','batur_orc_warrior','10.00','20.00',56,'male','L2Minion','Fighter',40,49626,'54.710',1052,'7.200',40,43,30,41,20,10,0,0,4299,1324,3954,537,278,0,253,74,657,0,80,175,NULL,0,'Tigra',NULL,0,20,456,7,30,4,20,0,0,'0.30','false',0,0),
(2080,25232,'Ragoth''s Herald','Raid Fighter','batur_orc','9.00','21.50',56,'male','L2Minion','Fighter',40,24813,'54.710',1052,'7.200',40,43,30,41,20,10,0,0,2149,1324,988,537,278,0,253,74,0,0,80,165,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(2081,25233,'Spirit of Andras,the Betrayer','Raid Boss','headless_knight_50_bi','30.00','46.50',69,'male','L2RaidBoss','Fighter',40,1256671,'154.790',3643,'9.000',60,57,73,76,70,80,2558623,621496,8956,3680,10177,1494,278,0,1972,2500,0,0,70,190,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,'0.52','false',1,1),
(2082,25234,'Ancient Weird Drake','Raid Boss','drake_50_bi','45.00','150.00',60,'male','L2RaidBoss','Fighter',40,1052436,'152.340',2707,'8.100',60,57,73,76,70,80,2460640,581209,7676,3349,8563,1360,278,0,1972,0,0,0,70,170,'',0,'SYS','',0,0,0,7,30,4,20,0,-18,'0.84','false',1,1),
(2083,25235,'Vanor Chief Kandra','Raid Boss','heltor_silenos_50_bi','19.00','43.50',72,'male','L2RaidBoss','Fighter',40,912634,'356.000',3202,'9.000',60,57,73,76,70,80,2161728,977072,8186,3933,11639,1597,278,0,1972,135,0,0,34,180,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(2084,25236,'Kandra''s Healer','Raid Fighter','heltor_silenos_shaman','13.00','32.00',71,'male','L2Minion','Priest',40,95688,'142.000',1565,'9.000',40,43,30,41,20,10,0,0,7829,1924,11244,781,278,0,253,200,0,0,29,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.22','false',0,0),
(2085,25237,'Kandra''s Guard','Raid Fighter','heltor_silenos_warrior','13.00','31.00',71,'male','L2Minion','Fighter',40,47844,'142.000',1565,'9.000',40,43,30,41,20,10,0,0,7829,1924,11244,781,278,0,253,228,0,0,36,190,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.39','false',0,0),
(2086,25238,'Abyss Brukunt','Raid Boss','drake_50_bi','45.00','150.00',59,'male','L2RaidBoss','Fighter',40,512194,'153.720',2846,'8.100',60,57,73,76,70,80,2508399,600107,4130,3513,2312,1427,278,0,1972,0,0,0,70,185,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.84','false',1,1),
(2087,25239,'Monstrous Beast of Abyss Brukunt','Raid Fighter','hunter_gargoyle','25.00','65.00',58,'male','L2Minion','Priest',40,52860,'61.230',1388,'8.100',40,43,30,41,20,10,0,0,3923,1715,2213,696,278,0,253,0,0,0,60,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.34','false',0,0),
(2088,25240,'Wild Beast of Abyss Brukunt','Raid Fighter','saber_toothed_tiger','34.00','28.00',58,'male','L2Minion','Fighter',40,26430,'61.230',1388,'8.100',40,43,30,41,20,10,0,0,3923,1715,2213,696,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.45','false',0,0),
(2089,25241,'Harit Hero Tamash','Raid Boss','zenta_lizardman_warrior_50_bi','18.00','53.00',55,'male','L2RaidBoss','Fighter',40,624464,'248.860',2639,'8.100',60,57,73,76,70,80,2988757,448385,2471,2576,1817,1046,278,0,1972,298,0,0,40,175,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.56','false',1,1),
(2090,25242,'Tamash''s Advisor','Raid Fighter','zenta_lizardman_shaman','13.00','35.00',54,'male','L2Minion','Priest',40,13199,'97.460',1285,'8.100',40,43,30,41,20,10,0,0,3036,1252,2944,508,278,0,253,193,0,0,43,155,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.63','false',0,0),
(2091,25243,'Tamash''s Servant','Raid Fighter','zenta_lizardman','11.00','32.00',54,'male','L2Minion','Fighter',40,19818,'97.460',1285,'8.100',40,43,30,41,20,10,0,0,4554,1252,6625,508,278,0,253,234,0,0,37,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.28','false',0,0),
(2092,25244,'Last Lesser Giant Olkuth','Raid Boss','lesser_giant_50_bi','31.50','69.00',75,'male','L2RaidBoss','Fighter',40,1891801,'311.980',3420,'9.000',60,57,73,76,70,80,4832156,847950,15764,4188,39730,1701,278,0,1972,78,0,0,15,140,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.58','false',1,1),
(2093,25245,'Last Lesser Giant Glaki','Raid Boss','lesser_giant_mage_50_bi','30.00','66.00',78,'male','L2RaidBoss','Mystic',40,977229,'288.700',3643,'9.000',60,57,73,76,70,80,4671563,943547,7940,4444,8508,1805,278,0,1972,179,0,0,15,95,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.56','false',1,1),
(2094,25246,'Glaki''s Henchman','Raid Fighter','lesser_giant','21.00','44.00',77,'male','L2Minion','Fighter',40,102704,'115.680',1784,'9.000',40,43,30,41,20,10,0,0,15250,2179,32949,885,278,0,253,169,0,0,15,150,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.58','false',0,0),
(2095,25247,'Glaki''s Servant','Raid Fighter','lesser_giant','21.00','44.00',77,'male','L2Minion','Fighter',40,51352,'115.680',1784,'9.000',40,43,30,41,20,10,0,0,7625,2179,8237,885,278,0,253,166,0,0,15,140,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.58','false',0,0),
(2096,25248,'Doom Blade Tanatos','Raid Boss','death_blader_bi','15.00','32.50',72,'male','L2RaidBoss','Fighter',40,1825269,'289.290',3274,'9.000',60,57,73,76,70,80,4362668,764172,13026,3933,26791,1597,278,0,1972,0,0,0,100,180,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(2097,25249,'Palatanos of Horrific Power','Raid Boss','Jungle_Bleeze','60.00','47.00',75,'male','L2RaidBoss','Fighter',40,945900,'311.980',3420,'9.000',60,57,73,76,70,80,4832156,847950,7882,4188,9932,1701,278,0,1972,0,0,0,55,165,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.48','false',1,1),
(2098,25250,'Man-Eating Plant of Palatanos','Raid Fighter','magical_weaver','11.00','20.00',74,'male','L2Minion','Mystic',40,66547,'124.800',1673,'9.000',40,43,30,41,20,10,0,0,10072,2051,17077,833,278,0,253,0,0,0,90,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','false',0,0),
(2099,25251,'Sapling of Palatanos','Raid Fighter','skeleton_knight','10.00','25.00',74,'male','L2Minion','Fighter',40,99324,'124.800',1673,'9.000',40,43,30,41,20,10,0,0,15109,2051,38427,833,278,0,253,145,629,0,40,175,'',0,'Local','',0,20,629,7,30,4,20,0,0,'0.17','false',0,0);
INSERT INTO `npc` VALUES
(2100,25252,'Palibati Queen Themis','Raid Boss','cave_maiden_50_bi','37.00','98.00',70,'female','L2RaidBoss','Fighter',40,888658,'310.390',3058,'9.000',60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,278,0,1972,234,0,0,70,160,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.43','false',1,1),
(2101,25253,'Handmaiden of Themis','Raid Fighter','succubus','10.00','36.00',69,'female','L2Minion','Mystic',40,62338,'123.830',1493,'8.100',40,43,30,41,20,10,0,0,7862,1840,12062,747,278,0,253,0,0,0,60,150,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.84','false',0,0),
(2102,25254,'Themis''s Sentinel','Raid Fighter','death_blader','15.00','45.00',69,'male','L2Minion','Fighter',40,93041,'123.830',1493,'8.100',40,43,30,41,20,10,0,0,11794,1840,27141,747,278,0,253,1472,0,0,100,170,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.45','false',0,0),
(2103,25255,'Gargoyle Lord Tiphon','Raid Boss','hunter_gargoyle_50_bi','37.00','98.00',65,'male','L2RaidBoss','Fighter',40,1637918,'282.910',2707,'8.100',60,57,73,76,70,80,3674504,679343,9313,3349,17189,1360,278,0,1972,0,0,0,100,180,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.37','false',1,1),
(2104,25256,'Taik High Prefect Arak','Raid Boss','ketra_orc_warrior_50_bi','18.00','37.00',60,'male','L2RaidBoss','Fighter',40,526218,'147.560',2368,'8.100',60,57,73,76,70,80,2091330,424759,2895,2951,1474,1198,278,0,1972,71,0,0,36,175,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.54','false',1,1),
(2105,25257,'Arak''s Archer','Raid Fighter','ketra_orc_archer','12.00','27.00',59,'male','L2Minion','Ranger',500,36451,'57.970',1150,'7.200',40,43,30,41,20,10,0,0,7797,1437,2314,583,249,0,227,283,0,0,45,160,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,1500,0,'0.91','false',0,0),
(2106,25258,'Arak''s Footman','Raid Fighter','ketra_orc','12.00','29.00',59,'male','L2Minion','Fighter',40,27202,'57.970',1150,'7.200',40,43,30,41,20,10,0,0,2632,1437,1302,583,278,0,253,127,0,0,45,175,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(2107,25259,'Zaken''s Butcher Krantz','Raid Boss','ogre_50_bi','30.00','66.00',55,'male','L2RaidBoss','Fighter',40,1248928,'248.860',2039,'7.200',60,57,73,76,70,80,2988757,448385,4942,2576,7268,1046,278,0,1972,297,0,0,22,160,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.82','false',1,1),
(2108,25260,'Iron Giant Totem','Raid Boss','iron_golem_bi','27.00','52.00',45,'male','L2RaidBoss','Mystic',40,392985,'195.770',1722,'7.200',60,57,73,76,70,80,2377188,267898,974,1905,466,774,278,0,1972,0,0,0,20,50,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.41','false',1,1),
(2109,25261,'Totem Guard Archer','Raid Fighter','batur_orc_archer','11.00','21.50',44,'male','L2Minion','Ranger',500,26454,'76.180',830,'6.300',40,43,30,41,20,10,0,0,2613,922,736,374,249,0,227,282,0,0,45,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,'0.96','false',0,0),
(2110,25262,'Totem Guard','Raid Fighter','batur_orc','9.00','21.50',44,'male','L2Minion','Fighter',40,19741,'76.180',830,'6.300',40,43,30,41,20,10,0,0,882,922,414,374,278,0,253,215,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.46','false',0,0),
(2111,25263,'Kernon''s Faithful Servant Kelone','Raid Boss','medusa_100_bi','20.00','53.00',67,'female','L2RaidBoss','Mystic',40,848789,'285.490',2846,'8.100',60,57,73,76,70,80,3745918,701317,5015,3513,4648,1427,278,0,1972,225,0,0,70,165,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,-18,'0.43','false',1,1),
(2112,25264,'Kelone''s Assassin','Raid Fighter','skeleton_royal_guard','11.00','28.50',66,'male','L2Minion','Fighter',40,59369,'113.710',1388,'8.100',40,43,30,41,20,10,0,0,6346,1715,7898,696,278,0,253,229,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.52','false',0,0),
(2113,25265,'Kelone''s Secret Knight','Raid Fighter','drake','11.00','28.00',66,'male','L2Minion','Mystic',40,88610,'113.710',1388,'8.100',40,43,30,41,20,10,0,0,9520,1715,17773,696,278,0,253,0,0,0,70,180,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.84','false',0,0),
(2114,25266,'Bloody Empress Decarbia','Raid Boss','bloody_queen_50_bi','21.00','64.00',75,'female','L2RaidBoss','Mystic',40,945900,'357.000',3420,'9.000',60,57,73,76,70,80,2238750,1054472,8986,4188,12912,1701,278,0,1972,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(2115,25267,'Decarbia''s Royal Guard','Raid Fighter','death_knight','12.00','30.00',74,'male','L2Minion','Fighter',40,49662,'142.800',1673,'9.000',40,43,30,41,20,10,0,0,8608,2051,12471,833,278,0,253,5286,0,0,27,200,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.71','false',0,0),
(2116,25268,'Decarbia''s Escort','Raid Fighter','skeleton_royal_guard','11.00','28.50',74,'male','L2Minion','Fighter',40,99324,'142.800',1673,'9.000',40,43,30,41,20,10,0,0,17216,2051,49884,833,278,0,253,234,0,0,80,210,NULL,0,'Tigra',NULL,0,0,0,7,30,4,20,0,0,'0.52','false',0,0),
(2117,25269,'Beast Lord Behemoth','Raid Boss','Elder_Troll','46.00','71.50',70,'male','L2RaidBoss','Fighter',40,888658,'310.390',3058,'9.000',60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,278,0,1972,0,0,0,55,180,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.61','false',1,1),
(2118,25270,'Behemoth Javeliner','Raid Fighter','virud_lizardman_scout','10.00','22.00',69,'male','L2Minion','Ranger',500,62338,'123.830',1493,'8.100',40,43,30,41,20,10,0,0,17470,1840,12062,747,249,0,227,2507,0,0,43,170,'',0,'Tigra','',0,0,0,7,30,4,20,1500,0,'0.72','false',0,0),
(2119,25271,'Behemoth Flare','Raid Fighter','will_o_wisp','13.00','22.00',69,'male','L2Minion','Mystic',40,46520,'123.830',1493,'8.100',40,43,30,41,20,10,0,0,5897,1840,6785,747,278,0,253,0,0,0,80,165,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.10','false',0,0),
(2120,25272,'Partisan Leader Talakin','Raid Boss','ol_mahum_champion_50_bi','21.00','43.50',28,'male','L2RaidBoss','Fighter',40,233163,'60.420',1415,'6.300',60,57,73,76,70,80,879287,99579,286,1044,86,424,278,0,1972,77,0,0,50,190,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.63','false',1,1),
(2121,25273,'Carnamakos','Raid Boss','iron_golem_bi','27.00','52.00',56,'male','L2RaidBoss','Mystic',40,507285,'273.570',2104,'7.200',60,57,73,76,70,80,3230613,486967,2902,2649,2636,1075,278,0,1972,0,0,0,20,50,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.41','false',0,1),
(2122,25274,'Carnabarun','Raid Fighter','magical_weaver','11.00','20.00',55,'male','L2Minion','Mystic',40,34424,'107.200',1019,'7.200',40,43,30,41,20,10,0,0,3572,1288,4283,523,278,0,253,0,0,0,90,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','false',0,0),
(2123,25275,'Carnassiud','Raid Fighter','field_stalker','15.00','30.00',55,'male','L2Minion','Fighter',40,51380,'107.200',1019,'7.200',40,43,30,41,20,10,0,0,5359,1288,9639,523,278,0,253,0,0,0,70,170,'',0,'Tigra','',0,0,0,7,30,4,20,0,0,'0.41','false',0,0),
(2124,25276,'Death Lord Ipos','Raid Boss','death_lord_50_bi','31.00','61.50',75,'male','L2RaidBoss','Fighter',40,1891801,'357.000',3420,'9.000',60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,1972,78,0,0,40,190,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(2125,25277,'Lilith''s Witch Marilion','Raid Boss','bloody_queen_50_bi','21.00','64.00',50,'female','L2RaidBoss','Mystic',40,507285,'239.600',1722,'7.200',60,57,73,76,70,80,2672375,365590,1658,2226,1143,904,278,0,1972,0,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(2126,25278,'Dead Soul of Stigma','Raid Fighter','mana_vampire','11.00','20.00',49,'male','L2Minion','Mystic',40,51380,'93.540',830,'6.300',40,43,30,41,20,10,0,0,1510,1079,1023,438,278,0,253,0,0,0,90,180,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','false',0,1),
(2127,25279,'Evil Spirit of Stigma','Raid Fighter','magical_weaver','11.00','20.00',49,'male','L2Minion','Mystic',40,25690,'93.540',830,'6.300',40,43,30,41,20,10,0,0,1510,1079,1023,438,278,0,253,0,0,0,90,180,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','false',0,0),
(2128,25280,'Pagan Watcher Cerberon','Raid Boss','kel_mahum_champion_50_bi','19.00','48.00',55,'male','L2RaidBoss','Fighter',40,1248928,'268.010',2039,'7.200',60,57,73,76,70,80,3202235,477279,5426,2576,9639,1046,278,0,1972,75,0,0,50,210,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.56','false',1,1),
(2129,25281,'Anakim''s Nemesis Zakaron','Raid Boss','karik_50_bi','37.00','136.50',70,'male','L2RaidBoss','Fighter',40,1777317,'310.390',3058,'9.000',60,57,73,76,70,80,4135551,777993,12444,3764,28565,1528,278,0,1972,0,0,0,37,215,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(2130,25282,'Death Lord Shax','Raid Boss','death_lord_50_bi','31.00','61.50',75,'male','L2RaidBoss','Fighter',40,1891801,'357.000',3420,'9.000',60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,1972,2500,0,0,40,210,'',0,'Tigra','',0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(2131,25283,'Lilith','Raid Boss','lilith','42.50','55.00',80,'female','L2RaidBoss','Fighter',40,1639146,'354.000',3793,'9.000',60,57,73,76,70,80,2374400,1196456,7986,4615,5367,1874,278,0,1972,0,0,0,45,200,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.50','false',0,1),
(2132,25284,'Lilith''s Agent','Raid Fighter','lilim_wizard','9.00','34.00',79,'female','L2Minion','Mystic',40,115440,'142.000',1859,'9.000',40,43,30,41,20,10,0,0,2316,2265,5386,919,278,0,353,0,0,0,50,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.50','false',0,0),
(2133,25285,'Lilith''s Escort','Raid Fighter','lilim_knight','12.00','50.00',79,'male','L2Minion','Fighter',40,172299,'142.000',1859,'9.000',40,43,30,41,20,10,0,0,19974,2265,59372,919,338,0,253,5800,5799,0,56,220,NULL,0,'Local',NULL,0,20,674,7,30,4,20,0,0,'0.46','false',0,0),
(2134,25286,'Anakim','Raid Boss','anakim','15.50','29.00',80,'female','L2RaidBoss','Fighter',40,1639146,'354.000',3793,'9.000',60,57,73,76,70,80,2374400,1196456,8404,4615,5367,1874,398,0,572,0,0,0,45,200,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.56','false',0,1),
(2135,25287,'Anakim''s Guardian','Raid Fighter','nephilim_priest','23.00','40.50',79,'male','L2Minion','Priest',40,172299,'142.000',1859,'9.000',40,43,30,41,20,10,0,0,3987,2265,4703,919,378,0,253,0,0,0,50,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.48','false',0,0),
(2136,25288,'Anakim''s Royal Guard','Raid Fighter','nephilim_lord','10.00','41.50',79,'male','L2Minion','Fighter',40,86149,'142.000',1859,'9.000',40,43,30,41,20,10,0,0,3987,2265,4703,919,378,0,253,0,0,0,65,220,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.63','false',0,0),
(2137,25289,'Anakim''s Executor','','nephilim_slayer','12.00','36.00',79,'male','L2Monster','Fighter',40,86149,'142.000',1859,'9.000',40,43,30,41,20,10,0,0,3987,2265,4703,919,378,0,253,0,0,0,65,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.63','true',0,0),
(2138,25290,'Daimon the White-Eyed','Raid Boss','hundred_eye','21.00','55.00',78,'male','L2RaidBoss','Fighter',40,977229,'355.000',3718,'9.000',60,57,73,76,70,80,2318004,1136977,9824,4444,14332,1805,409,0,2901,0,0,0,30,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.54','false',0,1),
(2139,25291,'Family of Daimon','Raid Fighter','field_stalker','15.00','30.00',77,'male','L2Monster','Fighter',40,22382,'142.400',1859,'9.000',40,43,30,41,20,10,0,0,12565,2179,24607,885,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.41','true',0,0),
(2140,25292,'Family of Daimon','Raid Fighter','parasitic_eye','25.00','63.00',77,'male','L2Monster','Mystic',40,33607,'142.400',1859,'9.000',40,43,30,41,20,10,0,0,9424,2179,13842,885,278,0,253,0,0,0,30,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','true',0,0),
(2141,25293,'Hestia,Guardian Deity of the Hot Springs','Raid Boss','pixy_bi','10.00','54.00',78,'female','L2RaidBoss','Fighter',40,977229,'288.700',3718,'9.000',60,57,73,76,70,80,4671563,943547,7940,4444,8508,1805,409,0,2901,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.72','false',1,1),
(2142,25294,'Fighter of Hestia','Raid Fighter','yeti','15.00','27.50',77,'male','L2Monster','Fighter',40,102704,'115.680',1859,'9.000',40,43,30,41,20,10,0,0,15250,2179,32949,885,278,0,253,0,0,0,16,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2143,25295,'Follower of Hestia','Raid Fighter','yeti','15.00','27.50',77,'male','L2Monster','Fighter',40,51352,'115.680',1859,'9.000',40,43,30,41,20,10,0,0,7625,2179,8237,885,278,0,253,0,0,0,16,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2144,25296,'Icicle Emperor Bumbalump','Raid Boss','yeti_20_bi','18.00','32.00',74,'male','L2RaidBoss','Fighter',40,935092,'357.000',3718,'9.000',60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,409,0,2901,0,0,0,16,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.48','false',0,1),
(2145,25297,'Icicle Giant','Raid Fighter','stone_golem','20.00','31.00',73,'male','L2Monster','Mystic',40,65759,'142.400',1859,'9.000',40,43,30,41,20,10,0,0,11127,2008,21420,815,278,0,253,0,0,0,23,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.41','true',0,0),
(2146,25298,'Icicle Giant','Raid Fighter','stone_golem','20.00','31.00',73,'male','L2Monster','Mystic',40,98148,'142.400',1859,'9.000',40,43,30,41,20,10,0,0,16691,2008,48198,815,278,0,253,0,0,0,23,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.41','true',0,0),
(2147,25299,'Ketra''s Hero Hekaton','Raid Boss','ketra_orc_chieftain_20_bi','17.00','46.20',80,'male','L2RaidBoss','Fighter',40,714778,'154.670',3718,'9.000',60,57,73,76,70,80,3206477,835990,6959,4615,4585,1874,409,0,2901,6719,0,0,24,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.51','false',1,1),
(2148,25300,'Scout of Hekaton','Raid Fighter','ketra_orc_archer','12.00','27.00',79,'male','L2Monster','Ranger',500,50349,'62.040',1859,'9.000',40,43,30,41,20,10,0,0,19811,2265,7884,919,278,0,253,288,0,0,45,190,'',0,'Local','',0,0,0,7,30,4,20,1500,0,'0.91','true',0,0),
(2149,25301,'Servant of Hekaton','Raid Fighter','ketra_orc','12.00','29.00',79,'male','L2Monster','Fighter',40,37574,'62.040',1859,'9.000',40,43,30,41,20,10,0,0,6687,2265,4435,919,278,0,253,79,0,0,45,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.46','true',0,0),
(2150,25302,'Ketra''s Commander Tayr','Raid Boss','ketra_orc_warlord_20_bi','14.00','36.00',84,'male','L2RaidBoss','Fighter',40,743801,'308.000',138,'10.000',60,57,73,76,70,80,3379556,898478,7856,3466,5408,1408,409,0,3819,80,0,0,43,307,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,'0.48','false',1,1),
(2151,25303,'Tayr''s Aide','Raid Fighter','ketra_orc_shaman','10.00','23.00',83,'male','L2Monster','Priest',40,52409,'61.150',1859,'9.000',40,43,30,41,20,10,0,0,10082,2434,9295,988,278,0,253,213,0,0,10,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.34','true',0,0),
(2152,25304,'Tayr''s Guard','Raid Fighter','ketra_orc','12.00','29.00',83,'male','L2Monster','Fighter',40,78223,'61.150',1859,'9.000',40,43,30,41,20,10,0,0,15123,2434,20916,988,278,0,253,79,6919,0,45,190,NULL,0,'Local',NULL,0,20,707,7,30,4,20,0,0,'0.46','true',0,0),
(2153,25305,'Ketra''s Chief Brakki','Raid Boss','ketra_warbeast','20.00','33.50',87,'male','L2RaidBoss','Fighter',40,1532678,'302.000',138,'10.000',60,57,73,76,70,80,3526019,952059,17006,3640,24162,1478,409,0,3819,0,0,0,42,307,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(2154,25306,'Soul of Fire Nastron','Raid Boss','ifrit','10.00','42.00',87,'male','L2RaidBoss','Fighter',40,534922,'149.340',3718,'9.000',60,57,73,76,70,80,3526018,952059,8503,5200,6040,2112,409,0,2901,0,0,0,38,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.48','false',0,1),
(2155,25307,'Family of Nastron','Raid Fighter','mana_vampire','11.00','20.00',86,'male','L2Monster','Mystic',40,56256,'60.140',1859,'9.000',40,43,30,41,20,10,0,0,16392,2559,23362,1039,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2156,25308,'Family of Nastron','Raid Fighter','mana_vampire','11.00','20.00',86,'male','L2Monster','Mystic',40,28128,'60.140',1859,'9.000',40,43,30,41,20,10,0,0,8196,2559,5840,1039,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2157,25309,'Varka''s Hero Shadith','Raid Boss','barka_silenos_shaman_20_bi','17.00','47.50',80,'male','L2RaidBoss','Priest',40,714778,'154.670',3718,'9.000',60,57,73,76,70,80,3206477,835990,6959,4615,4585,1874,409,0,2901,6716,0,0,36,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.54','false',1,1),
(2158,25310,'Shadith''s Royal Guard Captain','Raid Fighter','barka_silenos_warrior','16.00','41.00',79,'male','L2Monster','Fighter',40,75148,'62.040',1859,'9.000',40,43,30,41,20,10,0,0,13374,2265,17740,919,278,0,253,142,6918,0,34,190,NULL,0,'Local',NULL,0,20,674,7,30,4,20,0,0,'0.48','true',0,0),
(2159,25311,'Shadith''s Sentinel','Raid Fighter','barka_silenos_hunter','16.00','38.00',79,'male','L2Monster','Ranger',40,37574,'62.040',1859,'9.000',40,43,30,41,20,10,0,0,6687,2265,4435,919,278,0,253,2504,0,0,44,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2160,25312,'Varka''s Commander Mos','Raid Boss','barka_silenos_chieftain_20_bi','22.00','51.00',84,'male','L2RaidBoss','Fighter',40,743801,'308.000',138,'10.000',60,57,73,76,70,80,3379556,898478,7856,3466,5408,1408,409,0,3819,2500,0,0,40,307,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,'0.48','false',1,1),
(2161,25313,'Mos'' Aide','Raid Fighter','barka_silenos_priest','9.00','41.50',83,'male','L2Monster','Priest',40,78223,'61.150',1859,'9.000',40,43,30,41,20,10,0,0,7561,2434,5229,988,278,0,253,6716,0,0,36,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.47','true',0,0),
(2162,25314,'Mos'' Guard','Raid Fighter','barka_silenos_hunter','16.00','38.00',83,'male','L2Monster','Fighter',40,39111,'61.150',1859,'9.000',40,43,30,41,20,10,0,0,7561,2434,5229,988,278,0,253,142,0,0,44,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2163,25315,'Varka''s Chief Horus','Raid Boss','barka_silenos_chieftain_20_bi','22.00','51.00',87,'male','L2RaidBoss','Fighter',40,1532678,'302.000',138,'10.000',60,57,73,76,70,80,3526019,952059,17006,3640,24162,1478,409,0,3819,2500,0,0,40,307,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,'0.48','false',1,1),
(2164,25316,'Soul of Water Ashutar','Raid Boss','undine','12.00','27.00',87,'female','L2RaidBoss','Mystic',40,534922,'149.340',3718,'9.000',60,57,73,76,70,80,3526018,952059,8503,5200,6040,2112,409,0,2901,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.35','false',0,1),
(2165,25317,'Family of Ashutar','Raid Fighter','magical_weaver','11.00','20.00',86,'male','L2Monster','Mystic',40,56256,'60.140',1859,'9.000',40,43,30,41,20,10,0,0,16392,2559,23362,1039,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2166,25318,'Family of Ashutar','Raid Fighter','magical_weaver','11.00','20.00',86,'male','L2Monster','Mystic',40,28128,'60.140',1859,'9.000',40,43,30,41,20,10,0,0,8196,2559,5840,1039,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2167,25319,'Ember','Raid Boss','inferno_drake_100_bi','48.00','73.00',85,'male','L2RaidBoss','Fighter',40,1048567,'700.000',138,'10.000',60,57,73,76,70,80,2535975,1356048,11906,3525,18324,1432,409,0,3819,0,0,0,92,307,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,'0.48','false',1,1),
(2168,25320,'Sentinel of Ember','Raid Fighter','lava_golem','22.00','45.00',84,'male','L2Monster','Fighter',40,73883,'139.200',1859,'9.000',40,43,30,41,20,10,0,0,15276,2476,31447,1005,278,0,253,0,0,0,13,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.47','true',0,0),
(2169,25321,'Messenger of Ember','Raid Fighter','ifrit','10.00','42.00',84,'male','L2Monster','Mystic',40,110274,'139.200',1859,'9.000',40,43,30,41,20,10,0,0,11457,2476,17689,1005,278,0,253,0,0,0,38,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2170,25322,'Demon''s Agent Falston','Raid Boss','vampire_warrior','9.00','31.50',66,'male','L2RaidBoss','Fighter',40,834231,'350.000',3718,'9.000',60,57,73,76,70,80,1838232,828036,6092,3431,7808,1393,409,0,2901,6723,0,0,43,190,NULL,0,'DRIVER',NULL,0,0,0,7,30,4,20,0,-18,'0.60','false',1,1),
(2171,25323,'Falston''s Disciple','Raid Fighter','vampire_wizard','5.50','28.00',65,'female','L2Monster','Mystic',40,58282,'139.200',1859,'9.000',40,43,30,41,20,10,0,0,7744,1674,13406,680,278,0,253,99,0,0,46,190,NULL,0,'DRIVER',NULL,0,0,0,7,30,4,20,0,0,'0.46','true',0,0),
(2172,25324,'Servant of Falston','Raid Fighter','black_magician','8.00','30.00',65,'male','L2Monster','Mystic',40,86988,'139.200',1859,'9.000',40,43,30,41,20,10,0,0,11616,1674,30166,680,278,0,253,178,0,0,19,190,'',0,'DRIVER','',0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2173,25325,'Flame of Splendor Barakiel','Raid Boss','apostle_warrior','8.00','30.00',70,'female','L2RaidBoss','Fighter',40,888658,'310.390',3718,'9.000',60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,409,0,2901,6717,0,0,50,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(2174,25326,'Barakiel''s Disciple','Raid Fighter','apostle_mage','11.00','38.50',69,'male','L2Monster','Mystic',40,93041,'123.830',1859,'9.000',40,43,30,41,20,10,0,0,11794,1840,27141,747,278,0,253,6718,0,0,50,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2175,25327,'Barakiel''s Acolyte','Raid Fighter','apostle_mage','11.00','38.50',69,'male','L2Monster','Mystic',40,46520,'123.830',1859,'9.000',40,43,30,41,20,10,0,0,5897,1840,6785,747,278,0,253,6718,0,0,50,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2176,25328,'Eilhalder von Hellmann','Raid Boss','vampire_lord','7.50','25.80',71,'male','L2RaidBoss','Fighter',40,900867,'355.000',3718,'9.000',60,57,73,76,70,80,2142425,952990,7927,3848,11244,1562,409,0,2901,0,0,0,15,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.56','false',1,1),
(2177,25329,'Violet','Raid Fighter','vampire_witch','6.00','21.50',70,'female','L2Monster','Mystic',40,63242,'142.000',1859,'9.000',40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,253,946,0,0,64,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','true',0,0),
(2178,25330,'Kurstin','Raid Fighter','vampire_witch','6.00','21.50',70,'female','L2Monster','Mystic',40,63242,'142.000',1859,'9.000',40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,253,946,0,0,64,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','true',0,0),
(2179,25331,'Mina','Raid Fighter','vampire_witch','6.00','21.50',70,'female','L2Monster','Mystic',40,63242,'142.000',1859,'9.000',40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,253,946,0,0,64,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','true',0,0),
(2180,25332,'Dorian','Raid Fighter','vampire_soldier','8.00','23.50',70,'male','L2Monster','Fighter',40,94391,'142.000',1859,'9.000',40,43,30,41,20,10,0,0,13791,1882,35947,764,278,0,253,234,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.45','true',0,0),
(2181,25333,'Anakazel','Invaders'' Leader','dre_vanul_bi_one','21.00','54.00',28,'male','L2Monster','Fighter',40,193763,'51.790',3718,'9.000',60,57,73,76,70,80,629182,56542,163,1044,32,424,409,0,2901,0,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.35','true',1,0),
(2182,25334,'Anakazel','Invaders'' Leader','dre_vanul_bi_one','21.00','54.00',38,'male','L2Monster','Fighter',40,306698,'73.530',3718,'9.000',60,57,73,76,70,80,892440,99116,425,1508,113,612,409,0,2901,0,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.35','true',1,0),
(2183,25335,'Anakazel','Invaders'' Leader','kaim_vanul_20_bi','28.00','48.00',48,'male','L2Monster','Fighter',40,494363,'97.750',3718,'9.000',60,57,73,76,70,80,1173349,137957,1205,2094,514,850,409,0,2901,0,0,0,37,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.45','true',1,0),
(2184,25336,'Anakazel','Invaders'' Leader','kaim_vanul_20_bi','28.00','48.00',58,'male','L2Monster','Fighter',40,705074,'121.930',3718,'9.000',60,57,73,76,70,80,1470377,229005,2848,2798,1790,1136,409,0,2901,0,0,0,37,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.45','true',1,0),
(2185,25337,'Anakazel','Invaders'' Leader','karik','25.00','90.00',68,'male','L2Monster','Fighter',40,865808,'132.250',3718,'9.000',60,57,73,76,70,80,1812663,349493,4854,3596,3563,1460,409,0,2901,0,0,0,37,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.45','true',1,0),
(2186,25338,'Anakazel','Invaders'' Leader','karik','25.00','90.00',78,'male','L2Monster','Fighter',40,977523,'133.250',3718,'9.000',60,57,73,76,70,80,2238492,462266,7410,4444,6271,1805,409,0,2901,0,0,0,37,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.45','true',1,0),
(2187,25339,'Shadow of Halisha','Ruler of Sepulcher','halisha_a','23.00','60.00',81,'female','L2RaidBoss','Mystic',500,503921,'129.650',3718,'9.000',60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,2901,6720,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,1500,-18,'0.48','false',1,1),
(2188,25340,'Knight of Shadow','','vale_master','12.00','40.00',80,'male','L2Minion','Fighter',40,12829,'52.150',1859,'9.000',40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.74','false',0,0),
(2189,25341,'Knight of Shadow','','eligor','21.00','35.00',80,'male','L2Minion','Fighter',40,6414,'52.150',1859,'9.000',40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,35,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.48','false',0,0),
(2190,25342,'Shadow of Halisha','Ruler of Sepulcher','halisha_b','23.00','60.00',81,'female','L2RaidBoss','Mystic',500,503921,'129.650',3718,'9.000',60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,2901,6720,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,1500,-18,'0.48','false',1,1),
(2191,25343,'Knight of Shadow','','vale_master','12.00','40.00',80,'male','L2Minion','Fighter',40,12829,'52.150',1859,'9.000',40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.74','false',0,0),
(2192,25344,'Knight of Shadow','','fiend_archer','17.00','55.00',80,'male','L2Minion','Ranger',500,8544,'52.150',1859,'9.000',40,43,30,41,20,10,0,0,12691,2419,3381,982,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,1500,0,'0.76','false',0,0),
(2193,25345,'Knight of shadow','','lilim_wizard','9.00','34.00',80,'female','L2Minion','Fighter',40,8544,'52.150',1859,'9.000',40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,253,0,0,0,50,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','false',0,0),
(2194,25346,'Shadow of Halisha','Ruler of Sepulcher','halisha_c','23.00','60.00',81,'female','L2RaidBoss','Mystic',500,503921,'129.650',3718,'9.000',60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,2901,6720,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,1500,-18,'0.48','false',1,1),
(2195,25347,'Knight of Shadow','','lilim_wizard','9.00','34.00',80,'female','L2Minion','Fighter',40,8544,'52.150',1859,'9.000',40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,253,0,0,0,50,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','false',0,0),
(2196,25348,'Knight of Shadow','','death_lord','21.00','40.00',80,'male','L2Minion','Fighter',40,12829,'52.150',1859,'9.000',40,43,30,41,20,10,0,0,8567,2419,7608,982,278,0,253,78,0,0,40,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','false',0,0),
(2197,25349,'Shadow of Halisha','Ruler of Sepulcher','halisha_d','23.00','60.00',81,'female','L2RaidBoss','Mystic',500,503921,'129.650',3718,'9.000',60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,2901,6720,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,1500,-18,'0.48','false',1,1),
(2198,25350,'Knight of Shadow','','lilim_wizard','9.00','34.00',80,'female','L2Minion','Fighter',40,8544,'52.150',1859,'9.000',40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,253,0,0,0,50,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','false',0,0),
(2199,25351,'Knight of Shadow','','vale_master','12.00','40.00',80,'male','L2Minion','Fighter',40,12829,'52.150',1859,'9.000',40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.74','false',0,0),
(2200,25352,'Giant Wasteland Basilisk','Raid Boss','lesser_basilisk','12.00','22.00',30,'male','L2RaidBoss','Fighter',40,127782,'55.850',3718,'9.000',60,57,73,76,70,80,636918,59660,96,1127,9,458,409,0,2901,0,0,0,35,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.39','false',1,1),
(2201,25353,'Giant Wasteland Basilisk','Raid Fighter','lesser_basilisk_sm','12.00','22.00',29,'male','L2Monster','Fighter',40,12952,'21.520',1859,'9.000',40,43,30,41,20,10,0,0,174,542,35,220,278,0,253,0,0,0,35,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2202,25354,'Gargoyle Lord Sirocco','Raid Boss','gargoyle_bi','16.00','65.00',35,'male','L2RaidBoss','Fighter',40,165289,'77.760',3718,'9.000',60,57,73,76,70,80,1193687,138419,300,1356,59,550,409,0,2901,0,0,0,140,190,'',0,'stiff_fix_outofdate_from_306','1145636093',0,0,0,7,30,4,20,0,-18,'0.37','false',1,1),
(2203,25355,'Sirocco''s Gargoyle','Raid Fighter','gargoyle','16.00','50.00',34,'male','L2Monster','Fighter',40,8316,'30.060',1859,'9.000',40,43,30,41,20,10,0,0,277,654,55,265,278,0,253,0,0,0,140,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.37','true',0,0),
(2204,25356,'Sirocco''s Guards','Raid Fighter','gargoyle','16.00','50.00',34,'male','L2Monster','Fighter',40,16632,'30.060',1859,'9.000',40,43,30,41,20,10,0,0,554,654,220,265,278,0,253,0,0,0,140,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.37','true',0,0),
(2205,25357,'Sukar Wererat Chief','Raid Boss','wererat','14.00','25.00',21,'male','L2RaidBoss','Fighter',40,90169,'38.900',3718,'9.000',60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,2901,216,0,0,80,190,'',0,'stiff_fix_outofdate_from_414','1145636093',0,0,0,7,30,4,20,0,-18,'0.61','false',1,1),
(2206,25358,'Sukar Wererat Guard','Raid Fighter','wererat_sm','14.00','18.70',20,'male','L2Monster','Fighter',40,9314,'14.890',1859,'9.000',40,43,30,41,20,10,0,0,60,378,8,153,278,0,253,216,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.61','true',0,0),
(2207,25359,'Sukar Wererat Priest','Raid Fighter','wererat_sm','14.00','18.70',20,'male','L2Monster','Priest',40,9314,'14.890',1859,'9.000',40,43,30,41,20,10,0,0,30,378,2,153,278,0,253,179,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.61','true',0,0),
(2208,25360,'Tiger Hornet','Raid Boss','giant_bee_bi','8.00','32.00',26,'male','L2RaidBoss','Fighter',40,107186,'47.890',3718,'9.000',60,57,73,76,70,80,621174,53601,67,966,6,392,409,0,2901,0,0,0,90,190,'',0,'stiff_fix_outofdate_from_493','1145636094',0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(2209,25361,'Yellow Hornet','Raid Fighter','giant_bee','8.00','24.50',25,'male','L2Monster','Fighter',40,10950,'18.400',1859,'9.000',40,43,30,41,20,10,0,0,122,464,23,188,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','true',0,0),
(2210,25362,'Tracker Leader Sharuk','Raid Boss','virud_lizardman_warrior','12.00','30.00',23,'male','L2RaidBoss','Fighter',40,95986,'42.360',3718,'9.000',60,57,73,76,70,80,599426,50860,52,857,4,348,409,0,2901,291,0,0,52,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.59','false',1,1),
(2211,25363,'Sharuk''s Tracker','Raid Fighter','virud_lizardman','10.00','23.00',22,'male','L2Monster','Fighter',40,4935,'16.240',1859,'9.000',40,43,30,41,20,10,0,0,47,411,4,167,278,0,253,2,0,0,43,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2212,25364,'Sharuk''s Marksman','Raid Fighter','virud_lizardman_scout','10.00','22.00',22,'male','L2Monster','Ranger',500,6613,'16.240',1859,'9.000',40,43,30,41,20,10,0,0,140,411,7,167,278,0,253,2507,0,0,43,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,1500,0,'0.72','true',0,0),
(2213,25365,'Patriarch Kuroboros','Raid Boss','virud_lizardman_warrior_bi','12.00','34.50',26,'male','L2RaidBoss','Fighter',40,214372,'47.890',3718,'9.000',60,57,73,76,70,80,621174,53601,135,966,25,392,409,0,2901,93,0,0,52,190,'',0,'stiff_fix_outofdate_from_332','1145636093',0,0,0,7,30,4,20,0,-18,'0.59','false',1,1),
(2214,25366,'Kuroboros'' Priest','Raid Boss','virud_lizardman_matriarch','13.00','37.00',23,'male','L2RaidBoss','Priest',40,95986,'42.360',3718,'9.000',60,57,73,76,70,80,599426,50860,52,857,4,348,409,0,2901,2,0,0,56,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.65','false',1,1),
(2215,25367,'Kuroboros'' Follower','Raid Fighter','virud_lizardman','10.00','23.00',22,'male','L2Monster','Fighter',40,9870,'16.240',1859,'9.000',40,43,30,41,20,10,0,0,94,411,17,167,278,0,253,1,102,0,43,190,NULL,0,'Local',NULL,0,20,185,7,30,4,20,0,0,'0.48','true',0,0),
(2216,25368,'Kuroboros'' Discipline','Raid Fighter','virud_lizardman_shaman','10.00','29.00',22,'male','L2Monster','Priest',40,9870,'16.240',1859,'9.000',40,43,30,41,20,10,0,0,47,411,4,167,278,0,253,179,0,0,43,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2217,25369,'Soul Scavenger','Raid Boss','dark_horror_bi','20.00','42.00',25,'male','L2RaidBoss','Fighter',40,103092,'46.000',3718,'9.000',60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,2901,0,0,0,100,190,'',0,'stiff_fix_outofdate_from_409','1145636093',0,0,0,7,30,4,20,0,-18,'0.37','false',1,1),
(2218,25370,'Corpse Scavenger','Raid Fighter','skeleton_bi','11.00','31.00',24,'male','L2Monster','Fighter',40,10554,'17.660',1859,'9.000',40,43,30,41,20,10,0,0,112,446,21,181,278,0,253,946,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.30','true',0,0),
(2219,25371,'Anima Scavenger','Raid Fighter','spartoi','11.00','27.00',24,'male','L2Monster','Fighter',40,5277,'17.660',1859,'9.000',40,43,30,41,20,10,0,0,56,446,5,181,278,0,253,946,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.30','true',0,0),
(2220,25372,'Discarded Guardian','Raid Boss','stone_golem_bi','20.00','40.30',20,'male','L2RaidBoss','Mystic',40,175392,'37.230',3718,'9.000',60,57,73,76,70,80,436632,37265,61,757,8,307,409,0,2901,0,0,0,23,190,'',0,'stiff_fix_outofdate_from_384','1145636093',0,0,0,7,30,4,20,0,-18,'0.41','false',1,1),
(2221,25373,'Malex Herald of Dagoniel','Raid Boss','dre_vanul_bi_one','14.00','43.20',21,'male','L2RaidBoss','Fighter',40,90169,'38.900',3718,'9.000',60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,2901,0,0,0,80,190,'',0,'stiff_fix_outofdate_from_344','1145636093',0,0,0,7,30,4,20,0,-18,'0.35','false',1,1),
(2222,25374,'Abyss Flyer','Raid Fighter','vampire_bat','10.00','33.50',20,'male','L2Monster','Mystic',40,9314,'14.890',1859,'9.000',40,43,30,41,20,10,0,0,60,378,8,153,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','true',0,0),
(2223,25375,'Zombie Lord Farakelsus','Raid Boss','zombie_bi','13.00','27.50',20,'male','L2RaidBoss','Fighter',40,87696,'37.230',3718,'9.000',60,57,73,76,70,80,436632,37265,30,757,2,307,409,0,2901,0,0,0,15,190,'',0,'stiff_fix_outofdate_from_459','1145636093',0,0,0,7,30,4,20,0,-18,'0.43','false',1,1),
(2224,25376,'Warrior Zombie of Farakelsus','Raid Fighter','zombie','13.00','21.00',19,'male','L2Monster','Mystic',40,9080,'14.240',1859,'9.000',40,43,30,41,20,10,0,0,54,363,7,147,278,0,253,0,0,0,15,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.43','true',0,0),
(2225,25377,'Priest Zombie of Farakelsus','Raid Fighter','zombie','13.00','21.00',19,'male','L2Monster','Priest',40,9080,'14.240',1859,'9.000',40,43,30,41,20,10,0,0,27,363,1,147,278,0,253,0,0,0,15,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.43','true',0,0),
(2226,25378,'Madness Beast','Raid Boss','onyx_beast_bi','14.00','18.70',20,'male','L2RaidBoss','Fighter',40,87696,'37.230',3718,'9.000',60,57,73,76,70,80,436632,37265,30,757,2,307,409,0,2901,0,0,0,30,190,'',0,'stiff_fix_outofdate_from_366','1145636093',0,0,0,7,30,4,20,0,-18,'0.24','false',1,1),
(2227,25379,'Dementia Beast','Raid Fighter','onyx_beast','14.00','14.50',19,'male','L2Monster','Fighter',40,9080,'14.240',1859,'9.000',40,43,30,41,20,10,0,0,54,363,7,147,278,0,253,0,0,0,30,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.24','true',0,0),
(2228,25380,'Kaysha Herald of Icarus','Raid Boss','succubus_bi','10.00','43.20',21,'female','L2RaidBoss','Mystic',40,90169,'38.900',3718,'9.000',60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,2901,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.84','false',1,1),
(2229,25381,'Nightmare Flyer','Raid Fighter','vampire_bat_bi','10.00','42.00',19,'male','L2Monster','Mystic',40,9080,'14.240',1859,'9.000',40,43,30,41,20,10,0,0,54,363,7,147,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','true',0,0),
(2230,25382,'Hostile Flyer','Raid Fighter','vampire_bat','10.00','33.50',19,'male','L2Monster','Mystic',40,4540,'14.240',1859,'9.000',40,43,30,41,20,10,0,0,27,363,1,147,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.50','true',0,0),
(2231,25383,'Revenant of Sir Calibus','Raid Boss','death_knight_bi','12.00','30.00',34,'male','L2RaidBoss','Fighter',40,156584,'64.420',3718,'9.000',60,57,73,76,70,80,840195,76283,158,1308,20,531,409,0,2901,75,0,0,27,190,'',0,'stiff_fix_outofdate_from_687','1145636094',0,0,0,7,30,4,20,0,-18,'0.71','false',1,1),
(2232,25384,'Servant of Calibus','Raid Fighter','spartoi','11.00','27.00',33,'male','L2Monster','Fighter',40,15774,'24.890',1859,'9.000',40,43,30,41,20,10,0,0,292,630,75,256,278,0,253,946,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.30','true',0,0),
(2233,25385,'Evil Spirit Tempest','Raid Boss','dre_vanul_bi_one','21.00','54.00',36,'male','L2RaidBoss','Fighter',40,174646,'68.910',3718,'9.000',60,57,73,76,70,80,867472,80701,185,1405,24,570,409,0,2901,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.35','false',1,1),
(2234,25386,'Ghost of the Execution Grounds','Raid Fighter','skeleton_bi','11.00','31.00',35,'male','L2Monster','Fighter',40,17556,'26.660',1859,'9.000',40,43,30,41,20,10,0,0,336,678,87,275,278,0,253,128,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.30','true',0,0),
(2235,25387,'Malignant Spirit of the Execution Grounds','Raid Fighter','skeleton','11.00','25.00',35,'male','L2Monster','Fighter',40,8778,'26.660',1859,'9.000',40,43,30,41,20,10,0,0,168,678,21,275,278,0,253,946,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.30','true',0,0),
(2236,25388,'Red Eye Captain Trakia','Raid Boss','oel_mahum_bi','30.00','55.00',35,'male','L2RaidBoss','Fighter',40,165289,'66.650',3718,'9.000',60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,2901,70,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.48','false',1,1),
(2237,25389,'Red Eye Archer','Raid Fighter','ol_mahum_archer','14.00','25.00',34,'male','L2Monster','Ranger',500,11143,'25.770',1859,'9.000',40,43,30,41,20,10,0,0,464,654,36,265,278,0,253,279,0,0,50,190,'',0,'Local','',0,0,0,7,30,4,20,1500,0,'0.93','true',0,0),
(2238,25390,'Red Eye Guards','Raid Fighter','ol_mahum_champion','14.00','27.00',34,'male','L2Monster','Fighter',40,8316,'25.770',1859,'9.000',40,43,30,41,20,10,0,0,156,654,20,265,278,0,253,128,0,0,50,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.63','true',0,0),
(2239,25391,'Nurka''s Messenger','Raid Boss','ol_mahum_champion_bi','21.00','40.50',33,'male','L2RaidBoss','Fighter',40,297015,'62.230',3718,'9.000',60,57,73,76,70,80,825587,73993,295,1261,75,512,409,0,2901,127,0,0,50,190,NULL,0,'stiff_fix_outofdate_from_693','1145636094',0,0,0,7,30,4,20,0,-18,'0.63','false',1,1),
(2240,25392,'Captain of Queen''s Royal Guards','Raid Boss','marsh_stakato_queen','15.00','37.00',32,'female','L2RaidBoss','Fighter',40,141034,'60.060',3718,'9.000',60,57,73,76,70,80,810271,71493,137,1215,17,493,409,0,2901,129,0,0,130,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.41','false',1,1),
(2241,25393,'Marsh Stakato Noble','Raid Fighter','marsh_stakato_drone','9.00','24.00',31,'male','L2Monster','Fighter',40,14247,'23.170',1859,'9.000',40,43,30,41,20,10,0,0,246,585,61,237,278,0,253,223,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2242,25394,'Premo Prime','Raid Boss','twin_headed_giant','17.00','39.00',38,'male','L2RaidBoss','Fighter',40,390743,'73.530',3718,'9.000',60,57,73,76,70,80,892440,99116,425,1508,113,612,409,0,2901,88,0,0,45,190,'',0,'stiff_fix_outofdate_from_697','1145636094',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(2243,25395,'Archon Suscepter','Raid Boss','susceptor_prime','45.00','72.00',45,'male','L2RaidBoss','Fighter',40,288415,'90.360',3718,'9.000',60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,2901,0,0,0,78,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.52','false',1,1),
(2244,25396,'Kusion Suscepter','Raid Fighter','susceptor','20.00','35.00',44,'male','L2Monster','Fighter',40,6649,'35.160',1859,'9.000',40,43,30,41,20,10,0,0,413,922,76,374,278,0,253,0,0,0,27,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.43','true',0,0),
(2245,25397,'Gustos Suscepter','Raid Fighter','susceptor','20.00','35.00',44,'male','L2Monster','Fighter',40,29037,'35.160',1859,'9.000',40,43,30,41,20,10,0,0,826,922,307,374,278,0,253,0,0,0,27,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.43','true',0,0),
(2246,25398,'Eye of Beleth','Raid Boss','monster_eye','21.00','43.00',35,'male','L2RaidBoss','Mystic',40,165289,'66.650',3718,'9.000',60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,2901,0,0,0,90,190,'',0,'stiff_fix_outofdate_from_701','1145636094',0,0,0,7,30,4,20,0,-18,'0.30','false',1,1),
(2247,25399,'Apprentice of Watchman','Raid Fighter','mana_vampire','11.00','20.00',34,'male','L2Monster','Mystic',40,11143,'25.770',1859,'9.000',40,43,30,41,20,10,0,0,209,654,36,265,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2248,25400,'Page of Watchman','Raid Fighter','magical_weaver','11.00','20.00',34,'male','L2Monster','Mystic',40,16632,'25.770',1859,'9.000',40,43,30,41,20,10,0,0,156,654,20,265,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2249,25401,'Skyla','Raid Boss','zenta_lizardman_matriarch_bi','30.00','63.00',32,'male','L2RaidBoss','Fighter',40,141034,'60.060',3718,'9.000',60,57,73,76,70,80,810271,71493,137,1215,17,493,409,0,2901,215,0,0,53,190,'',0,'stiff_fix_outofdate_from_703','1145636094',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(2250,25402,'Retainer of Skyla','Raid Fighter','zenta_lizardman','11.00','32.00',31,'male','L2Monster','Fighter',40,14247,'23.170',1859,'9.000',40,43,30,41,20,10,0,0,246,585,61,237,278,0,253,221,0,0,37,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.28','true',0,0),
(2251,25403,'Follower of Skyla','Raid Fighter','zenta_lizardman_shaman','13.00','35.00',31,'male','L2Monster','Priest',40,9545,'23.170',1859,'9.000',40,43,30,41,20,10,0,0,164,585,27,237,278,0,253,180,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.63','true',0,0),
(2252,25404,'Corsair Captain Kylon','Raid Boss','pirates_zombie_captain','16.00','44.00',33,'male','L2RaidBoss','Fighter',40,148507,'62.230',3718,'9.000',60,57,73,76,70,80,825587,73993,147,1261,18,512,409,0,2901,231,0,0,14,190,'',0,'stiff_fix_outofdate_from_705','1145636094',0,0,0,7,30,4,20,0,-18,'0.76','false',1,1),
(2253,25405,'Kylon''s Pirate','Raid Fighter','skeleton_bi_one','16.00','40.00',32,'male','L2Monster','Fighter',40,14980,'24.030',1859,'9.000',40,43,30,41,20,10,0,0,271,607,69,246,278,0,253,946,945,0,60,190,NULL,0,'Local',NULL,0,20,251,7,30,4,20,0,0,'0.30','true',0,0),
(2254,25406,'Kylon''s Mate','Raid Fighter','skeleton_knight_50_bi','15.00','39.00',32,'male','L2Monster','Fighter',40,14980,'24.030',1859,'9.000',40,43,30,41,20,10,0,0,271,607,69,246,278,0,253,130,103,0,40,190,NULL,0,'Local',NULL,0,20,251,7,30,4,20,0,0,'0.17','true',0,0);
INSERT INTO `npc` VALUES
(2255,25407,'Lord Ishka','Raid Boss','death_blader_bi','22.00','67.00',60,'male','L2RaidBoss','Fighter',40,526218,'126.480',3718,'9.000',60,57,73,76,70,80,1496444,237315,1642,2951,547,1198,409,0,2901,1472,0,0,100,190,'',0,'stiff_fix_outofdate_from_707','1145636094',0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(2256,25408,'Ishka''s Elite Officer','Raid Fighter','skeleton_royal_guard','11.00','28.50',59,'male','L2Monster','Fighter',40,54404,'49.690',1859,'9.000',40,43,30,41,20,10,0,0,2999,1437,1951,583,278,0,253,946,945,0,80,190,NULL,0,'Local',NULL,0,20,485,7,30,4,20,0,0,'0.52','true',0,0),
(2257,25409,'Ishka''s Elite Soldier','Raid Fighter','skeleton_knight_20_bi','12.00','30.50',59,'male','L2Monster','Fighter',40,54404,'49.690',1859,'9.000',40,43,30,41,20,10,0,0,2999,1437,1951,583,278,0,253,150,103,0,40,190,NULL,0,'Local',NULL,0,20,485,7,30,4,20,0,0,'0.17','true',0,0),
(2258,25410,'Road Scavenger Leader','Raid Boss','wererat_bi','21.00','38.00',40,'male','L2RaidBoss','Fighter',40,218810,'91.280',3718,'9.000',60,57,73,76,70,80,1279280,187517,427,1615,87,656,409,0,2901,88,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.61','false',1,1),
(2259,25411,'Road Scavenger Henchman','Raid Fighter','kobold_bi','15.00','24.00',39,'male','L2Monster','Fighter',40,21961,'35.410',1859,'9.000',40,43,30,41,20,10,0,0,786,780,323,317,278,0,253,0,0,0,47,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.54','true',0,0),
(2260,25412,'Necrosentinel Royal Guard','Raid Boss','skeleton_royal_guard','11.00','28.50',47,'male','L2RaidBoss','Fighter',40,319791,'95.280',3718,'9.000',60,57,73,76,70,80,1162159,134535,546,2030,111,824,409,0,2901,946,946,0,80,190,'',0,'Local','',0,0,746,7,30,4,20,0,-18,'0.52','false',1,1),
(2261,25413,'Necrosentinel Archer','Raid Fighter','skeleton_archer','11.00','27.00',46,'male','L2Monster','Ranger',500,21628,'37.130',1859,'9.000',40,43,30,41,20,10,0,0,1454,983,172,399,278,0,253,279,0,0,40,190,'',0,'Local','',0,0,0,7,30,4,20,1500,0,'0.80','true',0,0),
(2262,25414,'Necrosentinel Soldier','Raid Fighter','skeleton_knight','10.00','25.00',46,'male','L2Monster','Fighter',40,16140,'37.130',1859,'9.000',40,43,30,41,20,10,0,0,490,983,97,399,278,0,253,150,103,0,40,190,'',0,'Local','',0,20,364,7,30,4,20,0,0,'0.17','true',0,0),
(2263,25415,'Nakondas','Raid Boss','drake_bi','37.00','125.00',35,'male','L2RaidBoss','Fighter',40,218810,'66.650',3718,'9.000',60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,2901,0,0,0,70,190,'',0,'stiff_fix_outofdate_from_713','1145636094',0,0,0,7,30,4,20,0,-18,'0.84','false',1,1),
(2264,25416,'Nakondas'' Slave','Raid Fighter','wyrm','29.00','72.00',34,'male','L2Monster','Fighter',40,14713,'25.770',1859,'9.000',40,43,30,41,20,10,0,0,209,654,36,265,278,0,253,0,0,0,70,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.19','true',0,0),
(2265,25417,'Nakondas'' Chain','Raid Fighter','succubus','10.00','36.00',34,'female','L2Monster','Mystic',40,21961,'25.770',1859,'9.000',40,43,30,41,20,10,0,0,156,654,20,265,278,0,253,0,0,0,60,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.84','true',0,0),
(2266,25418,'Dread Avenger Kraven','Raid Boss','death_knight_bi','12.00','30.00',44,'male','L2RaidBoss','Fighter',40,273375,'87.900',3718,'9.000',60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,2901,75,0,0,27,190,'',0,'stiff_fix_outofdate_from_715','1145636094',0,0,0,7,30,4,20,0,-18,'0.71','false',1,1),
(2267,25419,'Dread Panther','Raid Fighter','onyx_beast','14.00','14.50',43,'male','L2Monster','Fighter',40,27494,'34.190',1859,'9.000',40,43,30,41,20,10,0,0,756,892,272,362,278,0,253,0,0,0,30,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.24','true',0,0),
(2268,25420,'Orfen''s Handmaiden','Raid Boss','riba','25.00','72.00',48,'female','L2RaidBoss','Fighter',40,335987,'114.040',3718,'9.000',60,57,73,76,70,80,1639757,244248,1060,2094,345,850,409,0,2901,0,0,0,60,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(2269,25421,'Trisalim Escort','Raid Fighter','poison_spider_bi','40.00','38.00',47,'male','L2Monster','Mystic',40,22758,'44.460',1859,'9.000',40,43,30,41,20,10,0,0,1259,1015,526,412,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.65','true',0,0),
(2270,25422,'Page of Rotting Tree','Raid Fighter','hanged_man_ripper','35.00','80.00',47,'male','L2Monster','Fighter',40,33967,'44.460',1859,'9.000',40,43,30,41,20,10,0,0,945,1015,296,412,278,0,253,0,0,0,55,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2271,25423,'Fairy Queen Timiniel','Raid Boss','pixy_bi','10.00','54.00',56,'female','L2RaidBoss','Fighter',40,539706,'136.790',3718,'9.000',60,57,73,76,70,80,1722981,291015,1459,2649,476,1075,409,0,2901,0,0,0,80,190,'timiniel_clan',300,'stiff_fix_outofdate_from_719','1145636094',0,0,0,7,30,4,20,0,-18,'0.72','false',1,1),
(2272,25424,'Timiniel''s Royal Guards','Raid Fighter','pixy','5.00','25.00',55,'female','L2Monster','Fighter',40,27947,'53.600',1859,'9.000',40,43,30,41,20,10,0,0,1347,1288,435,523,278,0,253,0,0,0,80,190,'timiniel_clan',300,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.72','true',0,0),
(2273,25425,'Timiniel''s Royal Guard Captain','Raid Fighter','pixy','5.00','25.00',55,'female','L2Monster','Fighter',40,55894,'53.600',1859,'9.000',40,43,30,41,20,10,0,0,2694,1288,1740,523,278,0,253,0,0,0,80,190,'timiniel_clan',300,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.72','true',0,0),
(2274,25426,'Betrayer of Urutu Freki','Raid Boss','werewolf_bi','11.00','29.70',25,'male','L2RaidBoss','Fighter',40,103092,'46.000',3718,'9.000',60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,2901,0,0,0,50,190,'',0,'stiff_fix_outofdate_from_721','1145636094',0,0,0,7,30,4,20,0,-18,'0.43','false',1,1),
(2275,25427,'Freki''s Vampire Bat','Raid Fighter','vampire_bat','10.00','33.50',24,'male','L2Monster','Mystic',40,10554,'17.660',1859,'9.000',40,43,30,41,20,10,0,0,112,446,21,181,278,0,253,0,0,0,60,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.50','true',0,0),
(2276,25428,'Freki''s Wild Bear','Raid Fighter','grizzly','21.00','40.00',24,'male','L2Monster','Fighter',40,10554,'17.660',1859,'9.000',40,43,30,41,20,10,0,0,112,446,21,181,278,0,253,0,0,0,40,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.34','true',0,0),
(2277,25429,'Mammon Collector Talos','Raid Boss','ashuras','13.00','37.50',25,'male','L2RaidBoss','Fighter',40,103092,'46.000',3718,'9.000',60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,2901,0,0,0,41,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(2278,25430,'Talos'' Cohort','Raid Fighter','dre_vanul','14.00','36.00',22,'male','L2Monster','Fighter',40,9870,'16.240',1859,'9.000',40,43,30,41,20,10,0,0,94,411,17,167,278,0,253,0,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.35','true',0,0),
(2279,25431,'Flamestone Golem','Raid Boss','lava_golem','22.00','45.00',44,'male','L2RaidBoss','Fighter',40,273375,'87.900',3718,'9.000',60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,2901,0,0,0,13,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.47','false',1,1),
(2280,25432,'Elemental of Flame','Raid Fighter','mana_vampire','11.00','20.00',43,'male','L2Monster','Mystic',40,27494,'34.190',1859,'9.000',40,43,30,41,20,10,0,0,378,892,68,362,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2281,25433,'Elemental of Spark','Raid Fighter','magical_weaver','11.00','20.00',43,'male','L2Monster','Mystic',40,13747,'34.190',1859,'9.000',40,43,30,41,20,10,0,0,378,892,68,362,278,0,253,0,0,0,90,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2282,25434,'Bandit Leader Barda','Raid Boss','oel_mahum_warrior_50_bi','30.00','60.00',55,'male','L2RaidBoss','Fighter',40,451391,'114.860',3718,'9.000',60,57,73,76,70,80,1432099,216652,1156,2576,336,1046,409,0,2901,121,0,0,70,190,'',0,'stiff_fix_outofdate_from_866','1145636094',0,0,0,7,30,4,20,0,-18,'0.65','false',1,1),
(2283,25435,'Barda''s Bandit','Raid Fighter','oel_mahum','20.00','37.00',54,'male','L2Monster','Fighter',40,46232,'44.980',1859,'9.000',40,43,30,41,20,10,0,0,2132,1252,1228,508,278,0,253,145,0,0,70,190,NULL,0,'stiff_fix_outofdate_from_867','1145636094',0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2284,25436,'Barda''s Shaman','Raid Fighter','oel_mahum_witch_doctor','15.00','34.00',54,'male','L2Monster','Priest',40,30975,'44.980',1859,'9.000',40,43,30,41,20,10,0,0,1421,1252,546,508,278,0,253,201,0,0,70,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.26','true',0,0),
(2285,25437,'Timak Orc Gosmos','Raid Boss','batur_orc_overlord_100_bi','24.00','52.00',45,'male','L2RaidBoss','Fighter',40,576831,'90.360',3718,'9.000',60,57,73,76,70,80,1139085,129941,912,1905,346,774,409,0,2901,145,0,0,80,190,'',0,'stiff_fix_outofdate_from_868','1145636094',0,0,0,7,30,4,20,0,-18,'0.28','false',1,1),
(2286,25438,'Thief Kelbar','Raid Boss','wererat_100_bi','25.00','50.00',44,'male','L2RaidBoss','Fighter',40,273375,'87.900',3718,'9.000',60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,2901,239,0,0,80,190,'',0,'stiff_fix_outofdate_from_870','1145636095',0,0,0,7,30,4,20,0,-18,'0.61','false',1,1),
(2287,25439,'Kelbar''s Inferior','Raid Fighter','wererat_bi','21.00','38.00',43,'male','L2Monster','Fighter',40,27494,'34.190',1859,'9.000',40,43,30,41,20,10,0,0,756,892,272,362,278,0,253,130,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.61','true',0,0),
(2288,25440,'Kelbar''s Wizard','Raid Fighter','wererat','14.00','25.00',43,'male','L2Monster','Fighter',40,18421,'34.190',1859,'9.000',40,43,30,41,20,10,0,0,504,892,121,362,278,0,253,99,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.61','true',0,0),
(2289,25441,'Evil Spirit Cyrion','Raid Boss','drake_50_bi','45.00','150.00',45,'male','L2RaidBoss','Fighter',40,288415,'90.360',3718,'9.000',60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,2901,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.84','false',1,1),
(2290,25442,'Evil Creature of Forest','Raid Fighter','crimson_bear','19.00','36.00',44,'male','L2Monster','Fighter',40,14518,'35.160',1859,'9.000',40,43,30,41,20,10,0,0,413,922,76,374,278,0,253,0,0,0,37,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.45','true',0,0),
(2291,25443,'Anger of Forest','Raid Fighter','giant_wild_hog','25.00','27.00',44,'male','L2Monster','Fighter',40,29037,'35.160',1859,'9.000',40,43,30,41,20,10,0,0,826,922,307,374,278,0,253,0,0,0,35,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.54','true',0,0),
(2292,25444,'Enmity Ghost Ramdal','Raid Boss','dark_horror_100_bi','40.00','70.00',65,'male','L2RaidBoss','Fighter',40,588136,'130.580',3718,'9.000',60,57,73,76,70,80,1760714,332726,2176,3349,794,1360,409,0,2901,0,0,0,100,190,'',0,'stiff_fix_outofdate_from_874','1145636095',0,0,0,7,30,4,20,0,-18,'0.37','false',1,1),
(2293,25445,'Enmity Ghosts','Raid Fighter','crimson_doll','15.00','38.00',64,'male','L2Monster','Fighter',40,30636,'51.950',1859,'9.000',40,43,30,41,20,10,0,0,2077,1634,769,663,278,0,253,0,0,0,60,190,'',0,'stiff_fix_outofdate_from_875','1145636095',0,0,0,7,30,4,20,0,0,'0.67','true',0,0),
(2294,25446,'Shooter of Enmity','Raid Fighter','skeleton_archer','11.00','27.00',64,'male','L2Minion','Ranger',500,41052,'51.950',1859,'9.000',40,43,30,41,20,10,0,0,6153,1634,1367,663,278,0,253,279,0,0,40,190,'',0,'Magister','',0,0,0,7,30,4,20,1500,0,'0.80','false',0,0),
(2295,25447,'Immortal Savior Mardil','Raid Boss','banshee_50_bi','13.50','38.00',71,'female','L2RaidBoss','Mystic',40,645953,'133.310',3718,'9.000',60,57,73,76,70,80,2068252,367642,2947,3848,1195,1562,409,0,2901,3939,0,0,80,190,'',0,'stiff_fix_outofdate_from_876','1145636095',0,0,0,7,30,4,20,0,-18,'0.56','false',1,1),
(2296,25448,'Immortal Savior','Raid Fighter','binding','12.00','21.00',70,'male','L2Monster','Fighter',40,33847,'53.210',1859,'9.000',40,43,30,41,20,10,0,0,2611,1882,992,764,278,0,253,0,0,0,10,190,'',0,'stiff_fix_outofdate_from_877','1145636095',0,0,0,7,30,4,20,0,0,'0.54','true',0,0),
(2297,25449,'Immortal Guide','Raid Fighter','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,67694,'53.210',1859,'9.000',40,43,30,41,20,10,0,0,2611,1882,992,764,278,0,253,0,0,0,80,190,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.34','true',0,0),
(2298,25450,'Cherub Galaxia','Raid Boss','archangel_50_bi','22.00','120.00',79,'male','L2RaidBoss','Fighter',40,987470,'355.000',3718,'9.000',60,57,73,76,70,80,2377821,1136977,9883,4471,14504,1816,409,0,2901,97,0,0,50,190,'',0,'stiff_fix_outofdate_from_878','1145636095',0,0,0,7,30,4,20,0,-18,'0.76','false',1,1),
(2299,25451,'Galaxia''s Guards','Raid Fighter','angel','13.50','36.50',78,'male','L2Minion','Fighter',40,69545,'142.400',1859,'9.000',40,43,30,41,20,10,0,0,12640,2192,24904,890,278,0,253,148,0,0,30,190,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,0,'0.52','false',0,0),
(2300,25452,'Messenger of Angel','Raid Fighter','angel','13.50','36.50',79,'male','L2Minion','Fighter',40,104887,'142.400',1859,'9.000',40,43,30,41,20,10,0,0,9537,2206,14177,895,278,0,253,148,0,0,30,190,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.52','false',0,0),
(2301,25453,'Meanas Anor','Raid Boss','wyrm_50_bi','58.00','108.00',70,'male','L2RaidBoss','Fighter',40,888658,'288.220',3718,'9.000',60,57,73,76,70,80,3859833,738431,5659,3764,5371,1528,409,0,2901,0,0,0,70,190,'',0,'stiff_fix_outofdate_from_881','1145636095',0,0,0,7,30,4,20,0,-18,'0.19','false',1,1),
(2302,25454,'Wyvern of Marsh','Raid Fighter','wyrm','29.00','72.00',69,'male','L2Monster','Fighter',40,62338,'114.980',1859,'9.000',40,43,30,41,20,10,0,0,7149,1840,9066,747,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.19','true',0,0),
(2303,25455,'Succubus of Marsh','Raid Fighter','succubus','10.00','36.00',69,'female','L2Monster','Mystic',40,93041,'114.980',1859,'9.000',40,43,30,41,20,10,0,0,5362,1840,5100,747,278,0,253,0,0,0,60,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.84','true',0,0),
(2304,25456,'Mirror of Oblivion','Raid Boss','mirror_50_bi','12.00','22.00',49,'male','L2RaidBoss','Mystic',40,352421,'100.220',3718,'9.000',60,57,73,76,70,80,1184339,140317,652,2160,143,877,409,0,2901,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.39','false',1,1),
(2305,25457,'Shards of Oblivion','Raid Fighter','human_ghost','8.00','22.00',48,'male','L2Monster','Mystic',40,3808,'39.100',1859,'9.000',40,43,30,41,20,10,0,0,595,1047,128,425,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2306,25458,'Shadow of Oblivion','Raid Fighter','elf_ghost','7.00','21.00',48,'male','L2Monster','Mystic',40,7617,'39.100',1859,'9.000',40,43,30,41,20,10,0,0,595,1047,128,425,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.41','true',0,0),
(2307,25459,'Shards of Oblivion','Raid Fighter','dwarf_ghost','9.00','16.50',48,'male','L2Monster','Mystic',40,3808,'39.100',1859,'9.000',40,43,30,41,20,10,0,0,595,1047,128,425,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.39','true',0,0),
(2308,25460,'Deadman Ereve','Raid Boss','death_blader_200_bi','45.00','141.00',51,'male','L2RaidBoss','Fighter',40,385670,'105.150',3718,'9.000',60,57,73,76,70,80,1381165,185853,850,2294,219,931,409,0,2901,194,0,0,100,190,'',0,'stiff_fix_outofdate_from_887','1145636095',0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(2309,25461,'Ereve''s Knight','Raid Fighter','skeleton_knight','10.00','25.00',50,'male','L2Monster','Fighter',40,39195,'41.080',1859,'9.000',40,43,30,41,20,10,0,0,1395,1113,638,452,278,0,253,70,0,0,40,190,NULL,0,'stiff_fix_outofdate_from_888','1145636095',0,0,0,7,30,4,20,0,0,'0.17','true',0,0),
(2310,25462,'Ereve''s Squire','Raid Fighter','skeleton_pikeman','10.00','28.00',50,'male','L2Monster','Fighter',40,39195,'41.080',1859,'9.000',40,43,30,41,20,10,0,0,1395,1113,638,452,278,0,253,98,0,0,50,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.21','true',0,0),
(2311,25463,'Harit Guardian Garangky','Raid Boss','saber_toothed_tiger','72.00','87.00',56,'male','L2RaidBoss','Fighter',40,467209,'117.250',3718,'9.000',60,57,73,76,70,80,1444796,221098,1237,2649,368,1075,409,0,2901,0,0,0,60,190,'',0,'stiff_fix_outofdate_from_890','1145636095',0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(2312,25464,'Garangky Guard Captain','Raid Fighter','zenta_lizardman_warrior','13.00','35.00',55,'male','L2Monster','Fighter',40,47946,'45.940',1859,'9.000',40,43,30,41,20,10,0,0,2284,1288,1347,523,278,0,253,303,0,0,40,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.56','true',0,0),
(2313,25465,'Garangky Guard Shaman','Raid Fighter','zenta_lizardman_shaman','13.00','35.00',55,'male','L2Monster','Priest',40,47946,'45.940',1859,'9.000',40,43,30,41,20,10,0,0,1142,1288,336,523,278,0,253,206,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.63','true',0,0),
(2314,25466,'Garangky Guard','Raid Fighter','zenta_lizardman','11.00','32.00',55,'male','L2Monster','Fighter',40,47946,'45.940',1859,'9.000',40,43,30,41,20,10,0,0,2284,1288,1347,523,278,0,253,77,0,0,37,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.28','true',0,0),
(2315,25467,'Gorgolos','Raid Boss','field_stalker_200_bi','45.00','96.00',64,'male','L2RaidBoss','Fighter',40,576851,'129.880',3718,'9.000',60,57,73,76,70,80,1744167,326947,2103,3268,769,1327,409,0,2901,0,0,0,70,190,'',0,'stiff_fix_outofdate_from_894','1145636095',0,0,0,7,30,4,20,0,-18,'0.41','false',1,1),
(2316,25468,'Cursed Life','Raid Fighter','field_stalker','15.00','30.00',63,'male','L2Monster','Fighter',40,30008,'51.650',1859,'9.000',40,43,30,41,20,10,0,0,2006,1594,744,647,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.41','true',0,0),
(2317,25469,'Cursed Soul','Raid Fighter','field_stalker','15.00','30.00',63,'male','L2Monster','Fighter',40,60016,'51.650',1859,'9.000',40,43,30,41,20,10,0,0,4012,1594,2979,647,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.41','true',0,0),
(2318,25470,'Last Titan Utenus','Raid Boss','lesser_giant_mage','21.00','44.00',66,'male','L2RaidBoss','Mystic',40,598898,'131.200',3718,'9.000',60,57,73,76,70,80,1777636,338244,2252,3431,821,1393,409,0,2901,3938,0,0,15,190,'',0,'stiff_fix_outofdate_from_896','1145636095',0,0,0,7,30,4,20,0,-18,'0.56','false',1,1),
(2319,25471,'Utenus''s Wizard','Raid Fighter','lesser_giant','21.00','44.00',65,'male','L2Monster','Mystic',40,41855,'52.230',1859,'9.000',40,43,30,41,20,10,0,0,2866,1674,1412,680,278,0,253,0,0,0,15,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.58','true',0,0),
(2320,25472,'Utenus''s Guard','Raid Fighter','leogul','15.00','35.00',65,'male','L2Monster','Fighter',40,62470,'52.230',1859,'9.000',40,43,30,41,20,10,0,0,4299,1674,3178,680,278,0,253,0,0,0,80,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.72','true',0,0),
(2321,25473,'Grave Robber Kim','Raid Boss','batur_orc_warrior_100_bi','20.00','42.00',52,'male','L2RaidBoss','Fighter',40,402319,'107.600',3718,'9.000',60,57,73,76,70,80,1393971,205212,914,2363,242,959,409,0,2901,160,0,0,80,190,'',0,'stiff_fix_outofdate_from_898','1145636095',0,0,0,7,30,4,20,0,-18,'0.30','false',1,1),
(2322,25474,'Kim''s Gang','Raid Fighter','batur_orc','9.00','21.50',51,'male','L2Monster','Fighter',40,40965,'42.060',1859,'9.000',40,43,30,41,20,10,0,0,1679,1147,879,465,278,0,253,89,0,0,80,190,NULL,0,'stiff_fix_outofdate_from_899','1145636095',0,0,0,7,30,4,20,0,0,'0.46','true',0,0),
(2323,25475,'Ghost Knight Kabed','Raid Boss','headless_knight_50_bi','30.00','46.50',55,'male','L2RaidBoss','Fighter',40,451391,'114.860',3718,'9.000',60,57,73,76,70,80,1393657,221098,1156,2576,336,1046,409,0,2901,145,0,0,70,190,'',0,'stiff_fix_outofdate_from_900','1145636095',0,0,0,7,30,4,20,0,-18,'0.52','false',1,1),
(2324,25476,'Kabed''s Soldier','Raid Fighter','skeleton_knight','10.00','25.00',54,'male','L2Monster','Fighter',40,23116,'44.980',1859,'9.000',40,43,30,41,20,10,0,0,1066,1252,307,508,278,0,253,125,0,0,40,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.17','true',0,0),
(2325,25477,'Kabed''s Archer','Raid Fighter','skeleton_archer','11.00','27.00',54,'male','L2Monster','Ranger',500,30975,'44.980',1859,'9.000',40,43,30,41,20,10,0,0,3158,1252,546,508,278,0,253,279,0,0,40,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,1500,0,'0.80','true',0,0),
(2326,25478,'Shilen''s Priest Hisilrome','Raid Boss','cave_maiden','25.00','65.00',65,'female','L2RaidBoss','Priest',40,588136,'130.580',3718,'9.000',60,57,73,76,70,80,1760714,332726,2176,3349,794,1360,409,0,2901,230,0,0,70,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.43','false',1,1),
(2327,25479,'Hisilrome''s Servitor','Raid Fighter','serpent_slave','17.00','46.00',64,'male','L2Monster','Fighter',40,41052,'51.950',1859,'9.000',40,43,30,41,20,10,0,0,2769,1634,1367,663,278,0,253,68,0,0,70,190,NULL,0,'stiff_fix_outofdate_from_903','1145636095',0,0,0,7,30,4,20,0,0,'0.46','true',0,0),
(2328,25480,'Hisilrome''s Page','Raid Fighter','lienrik','12.00','50.00',64,'male','L2Monster','Fighter',40,61272,'51.950',1859,'9.000',40,43,30,41,20,10,0,0,2077,1634,769,663,278,0,253,0,0,0,100,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.46','true',0,0),
(2329,25481,'Magus Kenishee','Raid Boss','banshee_50_bi','13.50','38.00',53,'female','L2RaidBoss','Mystic',40,66938,'110.040',3718,'9.000',60,57,73,76,70,80,1406722,209570,996,2433,274,988,409,0,2901,3939,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.56','false',1,1),
(2330,25482,'Shadow of Kenishee','Raid Fighter','shadow','10.00','30.00',52,'male','L2Monster','Mystic',40,8629,'43.040',1859,'9.000',40,43,30,41,20,10,0,0,1806,1181,969,479,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.54','true',0,0),
(2331,25483,'Phantom of Kenishee','Raid Fighter','silhouette','8.00','23.00',52,'female','L2Monster','Fighter',40,8629,'43.040',1859,'9.000',40,43,30,41,20,10,0,0,903,1181,242,479,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.54','true',0,0),
(2332,25484,'Zaken''s Chief Mate Tillion','Raid Boss','skeleton_knight_50_bi','15.00','39.00',50,'male','L2RaidBoss','Fighter',40,61148,'102.690',3718,'9.000',60,57,73,76,70,80,1195137,169534,706,2226,159,904,409,0,2901,160,0,0,40,190,NULL,0,'stiff_fix_outofdate_from_906','1145636095',0,0,0,7,30,4,20,0,-18,'0.17','false',1,1),
(2333,25485,'Tillion''s Inferior','Raid Fighter','skeleton_bi','11.00','31.00',49,'male','L2Monster','Fighter',40,7866,'40.090',1859,'9.000',40,43,30,41,20,10,0,0,1288,1079,572,438,278,0,253,131,0,0,60,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.30','true',0,0),
(2334,25486,'Tillion''s Bat','Raid Fighter','vampire_bat','10.00','33.50',49,'male','L2Monster','Mystic',40,7866,'40.090',1859,'9.000',40,43,30,41,20,10,0,0,1288,1079,572,438,278,0,253,0,0,0,60,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,0,'0.50','true',0,0),
(2335,25487,'Water Spirit Lian','Raid Boss','pixy_bi','15.00','81.00',40,'female','L2RaidBoss','Fighter',40,218810,'78.240',3718,'9.000',60,57,73,76,70,80,915400,105938,243,1615,32,656,409,0,2901,0,0,0,80,190,'',0,'stiff_fix_outofdate_from_909','1145636095',0,0,0,7,30,4,20,0,-18,'0.72','false',1,1),
(2336,25488,'Spirit of Gildor','Raid Fighter','pixy','5.00','25.00',39,'female','L2Monster','Fighter',40,14713,'30.350',1859,'9.000',40,43,30,41,20,10,0,0,299,780,54,317,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.72','true',0,0),
(2337,25489,'Guardian of Gildor','Raid Fighter','pixy','5.00','25.00',39,'female','L2Monster','Fighter',40,21961,'30.350',1859,'9.000',40,43,30,41,20,10,0,0,449,780,121,317,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.72','true',0,0),
(2338,25490,'Gwindorr','Raid Boss','serpent_slave','17.00','46.00',40,'male','L2RaidBoss','Fighter',40,218810,'78.240',3718,'9.000',60,57,73,76,70,80,915400,105938,243,1615,32,656,409,0,2901,129,0,0,70,190,'',0,'stiff_fix_outofdate_from_911','1145636095',0,0,0,7,30,4,20,0,-18,'0.46','false',1,1),
(2339,25491,'Guard of Gwindorr','Raid Fighter','virud_lizardman_scout','10.00','22.00',39,'male','L2Monster','Ranger',500,3678,'30.350',1859,'9.000',40,43,30,41,20,10,0,0,665,780,54,317,278,0,253,2507,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,1500,0,'0.72','true',0,0),
(2340,25492,'Follower of Gwindorr','Raid Fighter','virud_lizardman','10.00','23.00',39,'male','L2Monster','Fighter',40,10980,'30.350',1859,'9.000',40,43,30,41,20,10,0,0,224,780,30,317,278,0,253,2,0,0,43,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.48','true',0,0),
(2341,25493,'Eva''s Spirit Niniel','Raid Boss','cutie_cat','8.00','15.00',55,'female','L2RaidBoss','Fighter',40,451391,'114.860',3718,'9.000',60,57,73,76,70,80,1432097,216652,1156,2576,336,1046,409,0,2901,0,0,0,48,190,NULL,0,'stiff_fix_outofdate_from_913','1145636095',0,0,0,7,30,4,20,0,-18,'0.34','false',1,1),
(2342,25494,'Spirit of Niniel','Raid Fighter','pixy','5.00','25.00',54,'female','L2Monster','Fighter',40,6091,'44.980',1859,'9.000',40,43,30,41,20,10,0,0,2187,1252,1685,508,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.72','true',0,0),
(2343,25495,'Spirit of Niniel','Raid Fighter','pixy','5.00','25.00',54,'female','L2Monster','Fighter',40,23116,'44.980',1859,'9.000',40,43,30,41,20,10,0,0,1094,1252,420,508,278,0,253,0,0,0,80,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.72','true',0,0),
(2344,25496,'Fafurion''s Envoy Pingolpin','Raid Boss','riba','25.00','72.00',52,'female','L2RaidBoss','Fighter',40,402319,'107.600',3718,'9.000',60,57,73,76,70,80,1393971,205212,914,2363,242,959,409,0,2901,0,0,0,60,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.45','false',1,1),
(2345,25497,'Fafurion''s Envoy','Raid Fighter','marsh_stakato_soldier','10.00','25.00',51,'male','L2Monster','Fighter',40,8373,'42.060',1859,'9.000',40,43,30,41,20,10,0,0,1679,1147,879,465,278,0,253,76,0,0,30,190,NULL,0,'stiff_fix_outofdate_from_916','1145636095',0,0,0,7,30,4,20,0,0,'0.74','true',0,0),
(2346,25498,'Fafurion''s Henchman Istary','Raid Boss','farhite_50_bi','24.00','48.00',45,'male','L2RaidBoss','Fighter',40,51869,'90.360',3718,'9.000',60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,2901,5131,0,0,15,190,NULL,0,'Local',NULL,0,0,0,7,30,4,20,0,-18,'0.74','false',1,1),
(2347,25499,'Alligator of Istary','Raid Fighter','crocodile','28.00','11.50',44,'male','L2Monster','Fighter',40,6649,'35.160',1859,'9.000',40,43,30,41,20,10,0,0,826,922,307,374,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.41','true',0,0),
(2348,25500,'Alligator of Istary','Raid Fighter','crocodile','28.00','11.50',44,'male','L2Monster','Fighter',40,14518,'35.160',1859,'9.000',40,43,30,41,20,10,0,0,413,922,76,374,278,0,253,0,0,0,70,190,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.41','true',0,0),
(2349,25501,'Boss Akata','Raid Boss','e_collector_teacher_Mdwarf_mon_130p','11.00','23.60',30,'male','L2RaidBoss','Fighter',40,127782,'55.850',3718,'9.000',60,57,73,76,70,80,636918,59660,96,1127,9,458,409,0,2901,0,0,0,35,190,'',0,'Local','',0,0,0,7,30,4,20,0,-18,'0.39','false',1,1),
(2350,25502,'Akata''s Thug','Raid Fighter','e_traderB_Fdwarf_mon_120p','8.00','22.00',30,'male','L2Minion','Fighter',40,9093,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(2351,25503,'Akata''s Lackey','Raid Fighter','e_collector_teacher_Fdwarf_mon_120p','9.00','21.40',30,'male','L2Minion','Fighter',40,6786,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(2352,25504,'Nellis'' Vengeful Spirit','Raid Boss','a_mageguild_teacher_Mhuman_mon_120p','10.00','28.10',39,'male','L2RaidBoss','Fighter',40,206753,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,1),
(2353,25505,'Nellis'' Follower','Raid Fighter','dwarf_ghost','10.00','18.70',38,'male','L2Minion','Fighter',40,20752,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(2354,25506,'Rayito the Looter','Raid Boss','ol_mahum_champion_05te_120p','16.00','33.20',37,'male','L2RaidBoss','Fighter',40,184670,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,1),
(2355,25507,'Rayito''s Henchman','Raid Fighter','ol_mahum_05te_110p','14.50','28.00',36,'male','L2Minion','Fighter',40,18550,'13.430',4000,'3.090',40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,134,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(2356,25508,'Rayito''s Henchman','Raid Fighter','northern_goblin_110p','6.00','16.60',36,'male','L2Minion','Fighter',40,12428,'13.430',4000,'3.090',40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,135,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(2357,25509,'Dark Shaman Varangka','Raid Boss','batur_orc_shaman_a_01te_120p','13.00','20.80',53,'male','L2RaidBoss','Fighter',40,418874,'0.000',NULL,'0.000',40,57,73,76,70,80,440000,40000,8000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,1),
(2358,25510,'Varangka''s Descendant','Raid Fighter','batur_orc_overlord_01te_110p','13.00','26.90',52,'male','L2Minion','Fighter',40,42733,'0.000',NULL,'0.000',40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(2359,25511,'Varangka''s Page','Raid Fighter','batur_orc_shaman_a_01te_110p','12.00','18.80',52,'male','L2Minion','Fighter',40,21366,'0.000',NULL,'0.000',40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(2360,25512,'Gigantic Chaos Golem','Raid Boss','chaos_golem','31.00','51.80',52,'male','L2RaidBoss','Fighter',40,804638,'0.000',NULL,'0.000',40,57,73,76,70,80,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,1),
(2361,25514,'Queen Shyeed','Raid Boss','cannibal_stakato_leader_tran_120p','45.00','50.80',80,'male','L2RaidBoss','Fighter',40,714778,'368.11',3718,'9.81',60,57,73,76,70,80,3206477,835990,6959,4615,4585,1874,409,0,768,0,0,0,58,307,'',0,'Magister','',0,0,0,7,0,0,0,0,0,'0.00','false',0,1),
(2362,25515,'Spiked Stakato','Raid Fighter','spike_stakato_110p','13.00','21.00',79,'male','L2Minion','Fighter',40,50349,'96.62',1859,'9.81',40,43,30,41,20,10,0,0,10082,2434,9295,988,278,0,333,0,0,0,40,209,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.41','false',0,0),
(2363,25516,'Spiked Stakato','Raid Fighter','spike_stakato_worker_110p','13.00','22.20',79,'male','L2Minion','Fighter',40,75148,'98.02',1859,'9.81',40,43,30,41,20,10,0,0,10082,2434,9295,988,278,0,333,0,0,0,40,209,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.41','false',0,0),
(2364,25517,'Master Anays','Raid Boss','solina_priest_120p','16.00','41.80',87,'male','L2RaidBoss','Fighter',40,1069643,'355.43',3718,'9.81',60,57,73,76,70,80,3526018,952059,17006,5200,24162,2112,409,500,768,0,0,0,42,307,'',0,'Magister','',0,0,0,7,0,0,0,0,0,'0.00','false',0,1),
(2365,25518,'Splendor Disciple','Raid Fighter','apostle_grail','13.00','47.00',86,'male','L2Minion','Fighter',40,56245,'95.02',1859,'9.81',40,43,30,41,20,10,0,0,16392,2559,23362,1039,278,500,333,0,0,0,99,209,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.41','false',0,0),
(2366,25519,'Splendor Worshiper','Raid Fighter','apostle_grail_a','13.00','47.00',86,'male','L2Minion','Fighter',40,75369,'95.02',2110,'9.81',40,43,30,41,20,10,0,0,11325,2315,18521,1075,278,500,333,0,0,0,99,209,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.41','false',0,0),
(2367,25523,'Plague Golem','Raid Boss','stone_golem_bi','20.00','40.30',73,'male','L2RaidBoss','Fighter',40,1848045,'0.000',NULL,'0.000',40,57,73,76,70,80,440000,40000,9000,5000,6000,6000,300,500,333,8218,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,1),
(2368,25524,'Flamestone Giant','Raid Boss','lava_golem','22.00','45.00',76,'male','L2RaidBoss','Fighter',40,956490,'742.11',3247,'9.81',60,57,73,76,70,80,4888056,961047,8153,4273,10359,1735,278,0,768,0,0,0,81,275,'',0,'Magister','',0,0,0,7,0,0,0,0,0,'0.00','false',0,1),
(2369,25525,'Flame Spirit','Raid Fighter','mana_vampire','11.00','20.00',75,'male','L2Minion','Fighter',40,100472,'197.17',1601,'9.81',40,43,30,21,20,10,0,0,15569,2094,39730,850,278,0,333,0,0,0,55,187,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.41','false',0,0),
(2370,25526,'Charged Spirit','Raid Fighter','magical_weaver','11.00','20.00',75,'male','L2Minion','Fighter',40,50236,'197.17',1601,'9.81',40,43,30,21,20,10,0,0,7784,2094,9932,850,278,0,333,0,0,0,55,187,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.41','false',0,0),
(2371,25527,'Uruka','Raid Boss','Crokian_Elder','30.00','42.51',87,'male','L2RaidBoss','Fighter',40,1532678,'13.430',9999,'3.090',40,57,73,76,70,80,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(2372,29001,'Queen Ant','','queen_ant','45.00','53.00',40,'female','L2Boss','Fighter',40,229898,'208.000',667,'2.100',60,57,73,76,70,80,2179536,140740,329,1615,77,655,278,0,1972,0,0,0,80,230,'queen_ant_clan',1000,'Local','',0,0,0,300,30,7,40,0,-18,'0.37','false',1,1),
(2373,29002,'Queen Ant Larva','','ant_larva','12.00','8.00',38,'male','L2Monster','Fighter',40,935,'3.500',349,'1.500',40,43,30,21,20,10,0,1,126,140,53,110,282,0,257,0,0,0,40,60,'queen_ant_clan',4500,'Local','',0,0,0,7,30,7,40,0,0,'0.35','true',0,0),
(2374,29003,'Nurse Ant','','ant','26.00','15.00',35,'male','L2Monster','Priest',40,6320,'108.000',446,'1.800',40,43,30,41,20,10,0,1,947,678,889,275,278,0,253,0,0,0,40,130,'queen_ant_clan',700,'Local','',0,0,0,7,30,7,40,0,0,'0.26','true',0,0),
(2375,29004,'Guard Ant','','ant','26.00','15.00',37,'male','L2Monster','Fighter',40,6861,'115.000',480,'1.800',40,43,30,41,20,10,0,1,269,728,62,295,278,500,253,0,0,0,40,230,'queen_ant_clan',700,'Local','',0,0,0,7,30,7,40,0,0,'0.26','true',1,0),
(2376,29005,'Royal Guard Ant','','ant','26.00','15.00',39,'male','L2Monster','Fighter',40,11140,'122.000',514,'1.800',40,43,30,41,20,10,0,1,1827,780,2576,316,278,0,253,0,0,0,40,230,'queen_ant_clan',700,'Local','',0,0,0,7,30,7,40,0,0,'0.26','true',0,0),
(2377,29006,'Core','','core','140.00','75.00',50,'male','L2Boss','Fighter',40,162561,'273.000',575,'1.500',60,57,73,76,70,80,2041407,153786,535,2226,500,904,278,0,1972,0,0,0,50,110,'curma_core_clan',2500,'Local','',0,0,0,10,30,7,40,0,-18,'0.60','false',1,1),
(2378,29007,'Death Knight','','death_knight','12.00','30.00',50,'male','L2Monster','Fighter',40,21830,'166.000',830,'2.100',40,43,30,41,20,10,0,1,683,1113,195,452,278,1050,253,75,0,0,27,110,'curma_core_clan',2300,'Local','',0,0,0,7,30,7,40,0,0,'0.71','true',0,0),
(2379,29008,'Death Wraith','','death_blader','15.00','45.00',55,'male','L2Monster','Fighter',40,25298,'185.000',987,'2.400',40,43,30,41,20,10,0,1,812,1288,2170,522,278,950,253,1472,0,0,100,230,'curma_core_clan',700,'Local','',0,0,0,7,30,7,40,0,0,'0.45','true',0,0),
(2380,29009,'Dicor','','mandragora_b','12.00','25.50',47,'female','L2Monster','Fighter',40,19819,'154.000',738,'2.100',40,43,30,41,20,10,0,1,577,1015,162,412,278,650,253,0,0,0,80,120,'curma_core_clan',800,'Local','',0,0,0,7,30,7,40,0,0,'0.13','true',1,0),
(2381,29010,'Validus','','grave','15.00','29.00',46,'male','L2Monster','Fighter',40,19165,'150.000',707,'2.100',40,43,30,41,20,10,0,1,545,984,154,400,278,750,253,0,0,0,70,110,'curma_core_clan',1200,'Local','',0,0,0,7,30,7,40,0,0,'0.30','true',1,0),
(2382,29011,'Susceptor','','susceptor','20.00','35.00',49,'male','L2Monster','Fighter',40,21154,'162.000',799,'2.100',40,43,30,41,20,10,0,1,647,1080,184,438,278,850,253,0,0,0,27,150,'curma_core_clan',1500,'Local','',0,0,0,7,30,7,40,0,0,'0.43','true',1,0),
(2383,29012,'Perum','','iron_golem','18.00','34.00',48,'male','L2Monster','Mystic',40,20483,'158.000',768,'2.100',40,43,30,41,20,10,0,1,611,1048,173,425,278,750,253,0,0,0,20,20,'curma_core_clan',800,'Local','',0,0,0,7,30,7,40,0,0,'0.41','true',1,0),
(2384,29013,'Premo','','troll','21.00','35.00',45,'male','L2Monster','Fighter',40,18519,'146.000',677,'2.100',40,43,30,41,20,10,0,1,514,952,144,386,278,0,253,0,0,0,55,110,'curma_core_clan',1200,'Local','',0,0,0,7,30,7,40,0,0,'0.61','true',1,0),
(2385,29014,'Orfen','','orfen','35.00','143.00',50,'female','L2Boss','Fighter',40,622493,'273.000',1660,'2.100',60,57,73,76,70,80,2041407,153786,553,2226,124,904,278,500,1972,0,0,0,60,230,'orfen_clan',3000,'Tigra','',0,0,0,300,30,7,40,0,-18,'0.71','false',1,1),
(2386,29015,'Raikel','','raikel','37.00','64.00',48,'male','L2Monster','Fighter',40,10241,'158.000',768,'2.100',40,43,30,41,20,10,0,1,489,1048,109,425,278,0,253,0,0,0,60,230,'orfen_clan',2500,'Local','',0,0,0,7,30,7,40,0,0,'0.54','true',1,0),
(2387,29016,'Raikel Leos','','raikel','37.00','64.00',49,'male','L2Monster','Fighter',40,10576,'162.000',799,'2.100',40,43,30,41,20,10,0,1,1752,1080,4358,438,278,0,253,0,0,0,60,230,'orfen_clan',2700,'Local','',0,0,0,7,30,15,40,0,0,'0.54','true',0,0),
(2388,29017,'Riba','','riba','25.00','72.00',48,'female','L2Monster','Fighter',40,10241,'158.000',768,'2.100',40,43,30,41,20,10,0,1,489,1048,109,425,278,0,253,0,0,0,60,230,'orfen_clan',2700,'Local','',0,0,0,7,30,7,40,0,0,'0.45','true',1,0),
(2389,29018,'Riba Iren','','riba','25.00','72.00',49,'female','L2Monster','Fighter',40,21154,'162.000',799,'2.100',40,43,30,41,20,10,0,1,1752,1080,4358,438,278,0,253,0,0,0,60,230,'orfen_clan',2900,'Local','',0,0,0,7,30,7,40,0,0,'0.45','true',1,0),
(2390,29019,'Antharas','','antaras','300.00','300.00',79,'male','L2Boss','Fighter',40,19635000,'1000.000',22197,'99.000',60,57,73,76,70,80,262721136,29116376,13308,8064,28099,1641,333,0,2362,0,0,0,50,186,'',0,'Local','',0,0,0,14,30,4,40,0,-18,'0.60','false',1,1),
(2391,29020,'Baium','','baium','65.00','174.00',75,'male','L2Boss','Fighter',40,3698520,'281.000',3347,'3.000',60,57,73,76,70,80,10253419,1081544,6559,6282,4378,4601,333,1000,2362,0,0,0,80,120,'',0,'Local','',0,0,0,13,30,4,40,0,-25,'0.60','false',1,1),
(2392,29021,'Archangel','','archangel','15.00','80.00',74,'male','L2Minion','Fighter',40,295325,'158.000',3274,'3.000',60,57,73,76,70,80,6571,343,1564,8326,5772,6100,333,0,2362,93,0,0,50,170,'',0,'Local','',0,0,0,7,30,4,40,0,-25,'0.76','false',0,0),
(2393,29022,'Zaken','','zaken','16.00','32.00',60,'male','L2Boss','Fighter',40,858518,'336.000',1975,'2.400',60,57,73,76,70,80,4879728,423589,7273,2951,19762,1197,333,1000,2362,0,0,0,42,170,'',0,'Local','',0,0,0,300,30,4,40,0,-18,'0.59','false',1,1),
(2394,29023,'Doll Blader','','doll_blader','6.00','12.00',58,'male','L2Monster','Fighter',40,2888,'6.500',1065,'2.400',40,43,30,21,20,25,0,0,779,383,428,359,278,150,253,5129,0,0,22,150,'',0,'Local','',0,0,0,7,30,4,40,0,0,'0.50','true',0,0),
(2395,29024,'Vale master','','vale_master','12.00','40.00',59,'male','L2Monster','Fighter',40,2970,'6.500',1102,'2.400',40,43,30,21,20,25,0,0,818,395,452,369,278,150,253,0,0,0,70,155,'',0,'Local','',0,0,0,7,30,4,40,0,0,'0.74','true',0,0),
(2396,29025,'Baium','','baium_npc','65.00','82.00',75,'male','L2Npc','npc',40,3698520,'8.500',3347,'3.000',60,57,73,76,70,80,0,0,3483,523,9402,850,409,0,2901,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,-18,'0.60','false',1,0),
(2397,29026,'Pirate Zombie Captain','','pirates_zombie_captain','17.00','28.00',60,'male','L2Monster','Fighter',40,3054,'6.500',1029,'2.400',40,43,30,21,20,25,0,0,750,405,477,379,317,150,289,232,0,0,14,140,'',0,'Local','',0,0,0,7,10,8,40,0,0,'0.76','true',0,0),
(2398,29027,'Pirate Zombie','','pirates_zombie','10.00','23.00',57,'male','L2Monster','Mystic',40,2806,'6.500',747,'2.100',40,43,30,21,20,25,0,0,649,373,404,349,317,150,289,225,0,0,11,140,'',0,'Local','',0,0,0,7,10,8,40,0,0,'0.74','true',0,0),
(2399,29028,'Valakas','','valakas','190.00','335.00',85,'male','L2Boss','Fighter',40,16660000,'1200.000',22197,'99.000',60,57,73,76,70,80,284286410,27215401,14375,7999,36620,1999,333,0,2362,0,0,0,120,300,'valakas_clan',300,'Local','',0,0,0,21,30,4,40,0,-18,'0.60','false',1,1),
(2400,29029,'Lavasaurus Elder','Family of Valakas','golem','13.00','75.00',83,'male','L2Monster','Mystic',500,4868,'50.000',1972,'4.000',40,43,30,21,20,10,0,0,4354,628,1258,510,249,500,227,0,0,0,1,1,'valakas_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.48','true',0,0),
(2401,29030,'Fenril Hound Kerinne','Family of Valakas','bandersnatch_20_bi','21.00','30.00',81,'male','L2Monster','Fighter',40,256613,'176.000',3793,'10.000',60,57,73,76,70,80,2407887,1226568,10699,4700,10558,1908,409,0,2901,0,0,0,30,200,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,-18,'0.49','true',1,0),
(2402,29031,'Kerinne''s Ifrit','','ifrit','10.00','42.00',80,'male','L2Monster','Mystic',40,33984,'35.200',1859,'4.000',40,43,30,21,20,10,0,0,10275,2307,6886,937,278,0,253,0,0,0,38,170,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(2403,29032,'Kerinne''s Golem','','lava_golem','22.00','45.00',80,'male','L2Monster','Fighter',40,4697,'50.000',1859,'4.000',40,43,30,21,20,10,0,0,10275,2307,6886,937,278,0,253,0,0,0,13,60,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.47','true',0,0),
(2404,29033,'Fenril Hound Freki','Family of Valakas','bandersnatch_20_bi','21.00','30.00',82,'male','L2Monster','Fighter',40,257118,'175.500',3869,'10.000',60,57,73,76,70,80,2434088,1257012,10997,4784,10896,1943,409,0,2901,0,0,0,30,200,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,-18,'0.49','true',1,0),
(2405,29034,'Freki''s Ifrit','','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,34071,'36.000',1896,'4.000',40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,253,0,0,0,38,170,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(2406,29035,'Freki''s Golem','','lava_golem','22.00','45.00',81,'male','L2Monster','Fighter',40,34071,'36.000',1896,'4.000',40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,13,60,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.47','true',0,0),
(2407,29036,'Fenril Hound Uruz','Family of Valakas','bandersnatch_20_bi','21.00','30.00',83,'male','L2Monster','Fighter',40,514943,'349.000',3945,'10.000',60,57,73,76,70,80,2466262,1289662,22594,4869,11233,1977,409,0,2901,0,0,0,30,200,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,-18,'0.49','true',1,0);
INSERT INTO `npc` VALUES
(2408,29037,'Fenril Hound Kinaz','Family of Valakas','bandersnatch_20_bi','21.00','30.00',84,'male','L2Monster','Fighter',40,257674,'174.000',4022,'10.000',60,57,73,76,70,80,2504880,1322688,11600,4952,11569,2011,409,0,2901,0,0,0,30,200,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,-18,'0.49','true',1,0),
(2409,29038,'Kinaz''s Ifrit','','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,34071,'36.000',1896,'4.000',40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,253,0,0,0,38,170,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(2410,29039,'Kinaz''s Ifrit','','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,34071,'36.000',1896,'4.000',40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,38,170,'fire_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(2411,29040,'Wings of Flame,Ixion','Gatekeeper of Valakas','inferno_drake_20_bi','29.00','42.00',85,'male','L2Monster','Fighter',40,515450,'346.000',4099,'10.000',60,57,73,76,70,80,2535975,1356048,23813,5036,11902,2045,409,0,2901,0,0,0,57,200,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,-18,'0.48','true',1,0),
(2412,29041,'Inferno Golem','','lava_golem','22.00','45.00',81,'male','L2Monster','Fighter',40,34071,'36.000',1896,'4.000',40,43,30,21,20,10,0,0,21134,2350,28532,954,278,0,253,0,0,0,13,60,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.47','true',0,0),
(2413,29042,'Inferno Golem','','lava_golem','22.00','45.00',81,'male','L2Monster','Fighter',40,34071,'36.000',1896,'4.000',40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,13,60,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.47','true',0,0),
(2414,29043,'Howling Ifrit','','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,34071,'36.000',1896,'4.000',40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,253,0,0,0,38,170,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(2415,29044,'Howling Ifrit','','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,34071,'36.000',1896,'4.000',40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,253,0,0,0,38,170,'fire_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(2416,29045,'Frintezza','','frintessa','45.00','42.70',90,'female','L2Boss','Fighter',40,753984,'13.430',1380,'3.090',40,43,30,21,20,10,1470000,13232,6427,4349,673,2933,300,0,333,0,0,0,38,170,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(2417,29046,'Scarlet van Halisha','','follower_of_frintessa','45.00','90.70',85,'male','L2Boss','Fighter',40,1666000,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,1),
(2418,29047,'Scarlet van Halisha','','follower_of_frintessa_tran','92.00','112.80',90,'male','L2Boss','Fighter',40,2380000,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,1),
(2419,29048,'Evil Spirit','','Evilate','40.00','100.00',87,'male','L2Monster','Fighter',40,98750,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(2420,29049,'Evil Spirit','','Evilate','40.00','100.00',87,'male','L2Monster','Fighter',40,98750,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(2421,29050,'Breath of Halisha','','portrait_spirit','23.00','40.00',85,'male','L2Monster','Fighter',40,15798,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(2422,29051,'Breath of Halisha','','portrait_spirit_winged','23.00','40.00',85,'male','L2Monster','Fighter',40,15798,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(2423,29052,'','','Organ_Dummy','1.00','35.00',0,NULL,NULL,NULL,NULL,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(2424,29053,'','','Follower_Dummy','1.00','58.00',0,NULL,NULL,NULL,NULL,NULL,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(2425,29054,'Benom','Triol''s Leader','benom','20.00','56.00',75,'male','L2RaidBoss','Fighter',40,1352750,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','true',0,0),
(2426,29055,'Teleportation Cubic','','teleport_npc','40.00','80.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(2427,29056,'Ice Fairy Sirra','Raid Boss','ice_fairy','16.00','35.60',60,'male','L2RaidBoss','Fighter',40,188376,'295.120',2368,'8.100',60,57,73,76,70,80,3446092,525780,3860,2251,2006,1195,278,0,1972,0,0,0,50,275,'',0,'Magister','',0,0,0,7,30,4,20,0,-18,'0.43','false',0,1),
(2428,29057,'Sirra''s Page','Raid Fighter','sylph_110p','12.00','39.70',59,'male','L2Minion','Fighter',40,12199,'115.940',1150,'7.200',40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,253,0,0,0,50,278,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.10','false',0,0),
(2429,29058,'Sirra''s Beholder','Raid Fighter','field_stalker_20_bi','18.00','36.00',59,'male','L2Minion','Fighter',40,6099,'115.940',1150,'7.200',40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,253,0,0,0,50,278,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.10','false',0,0),
(2430,29059,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2431,29060,'Captain of the Ice Queen''s Royal Guard','Raid Boss','gargoyle_02te_120p','19.00','61.00',59,'male','L2RaidBoss','Fighter',40,157517,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,1),
(2432,29061,'Teleportation Cubic','','teleport_npc_frin','40.00','80.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(2433,29062,'High Priestess van Halter','Raid Boss','heretic_priest_110p','9.00','21.30',87,'male','L2RaidBoss','Fighter',40,257369,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,1),
(2434,29063,'Andreas'' Acolyte','Raid Fighter','heretic_privates','7.70','28.40',86,'male','L2Minion','Fighter',40,22780,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(2435,29064,'Andreas'' Acolyte','Raid Fighter','heretic_privates_a','7.70','28.40',85,'male','L2Minion','Fighter',40,34219,'0.000',NULL,'0.000',NULL,NULL,NULL,NULL,NULL,NULL,0,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(2436,29065,'Sailren','Sealed Evil Power','sailren','100.00','82.10',87,'male','L2RaidBoss','Fighter',40,1532678,'149.300',3718,'9.000',60,57,73,76,70,80,4526019,852059,17006,5200,24162,2112,409,0,2901,0,0,0,26,190,'0',0,'Magister','0',0,0,0,7,30,4,20,0,-18,'0.50','false',1,1),
(2437,29066,'Antharas','','antaras','300.00','300.00',79,'male','L2Boss','Fighter',40,13090000,'1000.000',22197,'99.000',60,57,73,76,70,80,2627211,291163,13308,8064,28099,1641,333,0,2362,0,0,0,50,186,'',0,'Magister','',0,0,0,14,30,4,40,0,-18,'0.60','false',1,1),
(2438,29067,'Antharas','','antaras','300.00','300.00',79,'male','L2Boss','Fighter',40,13090000,'1000.000',22197,'99.000',60,57,73,76,70,80,2627211,291163,13308,8064,28099,1641,333,0,2362,0,0,0,50,186,'',0,'Magister','',0,0,0,14,30,4,40,0,-18,'0.60','false',1,1),
(2439,29068,'Antharas','','antaras','300.00','300.00',79,'male','L2Boss','Fighter',40,13090000,'1000.000',22197,'99.000',60,57,73,76,70,80,2627211,291163,13308,8064,28099,1641,333,0,2362,0,0,0,50,186,'',0,'Magister','',0,0,0,14,30,4,40,0,-18,'0.60','false',1,1),
(2440,29069,'Behemoth Dragon','','antaras_ex_a','63.00','54.00',78,'male','L2Monster','Fighter',40,350092,'5.500',799,'2.100',40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.52','true',0,0),
(2441,29070,'Dragon Bomber','','antaras_ex_b_80p','37.00','28.00',78,'male','L2Monster','Fighter',40,2380,'5.500',799,'2.100',40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.52','true',0,0),
(2442,29071,'Dragon Bomber','','antaras_ex_b_80p','37.00','28.00',78,'male','L2Monster','Fighter',40,2380,'5.500',799,'2.100',40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.52','true',0,0),
(2443,29072,'Dragon Bomber','','antaras_ex_b_80p','37.00','28.00',78,'male','L2Monster','Fighter',40,2380,'5.500',799,'2.100',40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.52','true',0,0),
(2444,29073,'Dragon Bomber','','antaras_ex_b_80p','37.00','28.00',78,'male','L2Monster','Fighter',40,2380,'5.500',799,'2.100',40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.52','true',0,0),
(2445,29074,'Dragon Bomber','','antaras_ex_b_80p','37.00','28.00',78,'male','L2Monster','Fighter',40,2380,'5.500',799,'2.100',40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.52','true',0,0),
(2446,29075,'Dragon Bomber','','antaras_ex_b_80p','37.00','28.00',78,'male','L2Monster','Fighter',40,2380,'5.500',799,'2.100',40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.52','true',0,0),
(2447,29076,'Dragon Bomber','','antaras_ex_b','42.00','34.50',78,'male','L2Monster','Fighter',40,2380,'5.500',799,'2.100',40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Magister','',0,0,0,7,30,4,20,0,0,'0.52','true',0,0),
(2448,29077,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2449,29078,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2450,29079,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2451,29080,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2452,29081,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2453,29082,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2454,29083,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2455,29084,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2456,29085,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2457,29086,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2458,29087,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2459,29088,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2460,29089,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2461,29090,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2462,29091,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2463,29092,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2464,29093,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2465,29094,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(2466,29095,'Gordon','Knight of Destruction','Cruel_Rider','43.00','46.60',87,'male','L2RaidBoss','Fighter',40,2139287,'302.000',138,'10.000',60,57,73,76,70,80,3626219,962159,17006,3640,24162,1478,409,0,3819,2500,0,0,40,307,NULL,0,'Magister',NULL,0,0,0,7,30,4,20,0,-18,'0.48','false',1,1),
(2467,29096,'Lord of Splendor Anays','Raid Boss','solina_priest_120p','16.00','41.80',87,'male','L2RaidBoss','Fighter',40,1069643,'488.220',14718,'18.000',60,57,73,76,70,80,6859833,1438431,7659,4764,6571,2828,409,0,3819,8214,0,0,60,160,NULL,0,'SYS','0',0,0,0,7,30,4,20,0,-18,'0.19','false',1,1),
(2468,29097,'Splendor Disciple','Raid Fighter','apostle_grail','13.00','47.00',86,'male','L2Minion','Fighter',40,56245,'296.000',6245,'9.000',60,57,73,76,70,80,159833,31431,5759,3944,2671,2891,278,0,333,8221,0,0,30,190,NULL,0,'SYS','0',0,0,0,7,30,4,20,0,-14,'0.19','false',0,0),
(2469,29098,'Splendor Worshiper','Raid Fighter','apostle_grail_a','13.00','47.00',86,'male','L2Minion','Ranger',500,75369,'265.000',3541,'9.000',60,57,73,76,70,80,291373,60391,5150,3984,2671,2891,278,0,333,0,0,0,30,190,NULL,0,'SYS','0',0,0,0,7,30,4,20,0,-14,'0.19','false',0,0),
(2470,18001,'Blood Queen','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,4536,394,860,368,478,299,278,500,253,0,0,0,80,160,'cave_servant_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(2471,18002,'Blood Queen','','bloody_queen','14.00','40.00',60,'female','L2Monster','Mystic',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,4536,394,860,368,478,299,278,500,253,0,0,0,80,160,'cave_servant_clan',400,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(2472,18003,'Bearded Keltir','','keltir','13.00','10.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,29,2,4,39,3,32,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,8,0,0,0,'0.37','true',0,0),
(2473,18004,'Susceptor Prime','','susceptor_prime','45.00','72.00',49,'male','L2Monster','Fighter',50,2168,'5.500',799,'2.100',40,43,30,21,20,10,0,1,480,270,247,219,282,0,257,0,0,0,78,170,'',0,'Local','',0,0,0,7,30,4,20,0,0,'0.52','true',0,0),
(2474,18005,'Mimic','','mimic','8.50','8.50',52,'male','L2Monster','Fighter',40,2479,'6.500',892,'2.400',40,43,30,21,20,10,3244,251,588,304,300,239,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','true',0,0),
(2475,18006,'Maruk Lord','','death_blader','15.00','45.00',68,'male','L2Monster','Fighter',40,3825,'7.500',1423,'2.700',40,43,30,21,20,10,6057,586,1256,464,713,365,278,500,253,1472,0,0,100,170,'malruk_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',0,0),
(2476,18007,'Limal Karinness','','bloody_queen','14.00','40.00',69,'female','L2Monster','Mystic',40,3784,'7.500',1458,'2.700',40,43,30,21,20,10,5951,582,1392,460,821,373,278,500,253,0,0,0,80,140,'malruk_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',0,0),
(2477,18008,'Karik','','karik','25.00','90.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,6370,632,1445,470,858,382,278,500,253,0,0,0,37,200,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',0,0),
(2478,18009,'Offering of Branded Elder','','orc_fighter_bi','12.00','26.40',34,'male','L2FestivalMonster','Fighter',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1754,102,178,163,82,132,278,1000,253,127,0,0,45,30,'mercenary_siege_clan',500,'Local','',0,0,0,3,30,4,4,0,0,'0.46','false',0,0),
(2479,18010,'Offering of the Branded','','orc','10.00','21.00',32,'male','L2FestivalMonster','Fighter',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,1523,86,134,129,69,123,237,1000,216,218,0,0,45,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.48','false',0,0),
(2480,18011,'Offering of Branded Archer','','orc_archer','14.00','25.00',28,'male','L2FestivalMonster','Ranger',500,859,'3.500',334,'1.500',40,43,30,21,20,10,1001,53,251,110,49,106,249,1000,227,14,0,0,45,60,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.80','false',0,0),
(2481,18012,'Offering of Branded Warrior','','orc_champion','10.00','23.00',29,'male','L2FestivalMonster','Fighter',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1026,55,122,135,53,110,278,1000,253,125,0,0,45,110,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.76','false',0,0),
(2482,18013,'Offering of Branded Follower','','orc_fighter','12.00','22.00',29,'male','L2FestivalMonster','Fighter',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1227,66,107,115,53,110,237,1000,216,316,0,0,45,150,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.26','false',0,0),
(2483,18014,'Offering of Branded Berserker','','orc_champion_20_bi','12.00','27.60',37,'male','L2FestivalMonster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,2276,140,222,182,104,147,278,1000,253,292,0,0,43,115,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.48','false',0,0),
(2484,18015,'Offering of Branded Zealot','','orc_fighter_bi','12.00','26.40',34,'male','L2FestivalMonster','Fighter',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1650,96,156,138,82,132,237,1000,216,158,0,0,45,155,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2485,18016,'Offering of Branded Marksman','','orc_archer_20_bi','16.00','30.00',32,'male','L2FestivalMonster','Ranger',500,1056,'4.500',397,'1.800',40,43,30,21,20,10,1265,71,342,129,69,123,249,1000,227,273,0,0,45,130,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.80','false',0,0),
(2486,18017,'Offering of Branded Disciple','','batur_orc','9.00','21.50',34,'male','L2FestivalMonster','Fighter',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1650,96,178,163,82,132,278,1000,253,129,0,0,80,165,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.46','false',0,0),
(2487,18018,'Offering of Branded Saint','','batur_orc_20_bi','10.00','25.30',39,'male','L2FestivalMonster','Fighter',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,2171,138,255,195,121,158,278,1000,253,72,0,0,80,165,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.46','false',0,0),
(2488,18019,'Apostate''s Offering Elder','','orc_champion_20_bi','12.00','27.60',45,'male','L2FestivalMonster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,3013,210,377,238,188,193,278,1000,253,72,0,0,45,30,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.76','false',0,0),
(2489,18020,'Apostate''s Offering','','orc_fighter','12.00','22.00',43,'male','L2FestivalMonster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,2751,186,291,189,163,181,237,1000,216,223,0,0,45,30,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2490,18021,'Apostate''s Offering Archer','','batur_orc_archer','11.00','21.50',39,'male','L2FestivalMonster','Ranger',500,1462,'4.500',514,'1.800',40,43,30,21,20,10,1879,119,566,165,121,158,249,1000,227,275,0,0,45,60,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2491,18022,'Apostate''s Offering Warrior','','batur_orc_warrior','10.00','20.00',40,'male','L2FestivalMonster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,1920,124,273,201,131,164,278,1000,253,127,0,0,80,115,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.30','false',0,0),
(2492,18023,'Apostate''s Offering Follower','','batur_orc','9.00','21.50',40,'male','L2FestivalMonster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2296,148,238,171,131,164,237,1000,216,316,0,0,50,155,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.30','false',0,0),
(2493,18024,'Apostate''s Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',48,'male','L2FestivalMonster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,3832,280,453,261,231,212,278,1000,253,297,0,0,37,120,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2494,18025,'Apostate''s Offering Zealot','','batur_orc_20_bi','10.00','25.30',45,'male','L2FestivalMonster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,2891,201,330,202,188,193,237,1000,216,172,0,0,80,160,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2495,18026,'Apostate''s Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',43,'male','L2FestivalMonster','Ranger',500,1728,'5.500',618,'2.100',40,43,30,21,20,10,2285,154,739,189,163,181,249,1000,227,277,0,0,45,135,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2496,18027,'Apostate''s Offering Disciple','','batur_orc_overlord','12.00','24.00',45,'male','L2FestivalMonster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,2891,201,377,238,188,193,278,1000,253,74,0,0,80,170,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2497,18028,'Apostate''s Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',50,'male','L2FestivalMonster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3570,269,509,278,264,226,278,1000,253,133,0,0,80,170,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2498,18029,'Witch''s Offering Elder','','batur_orc_warrior_20_bi','12.00','24.00',56,'male','L2FestivalMonster','Mystic',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,4666,383,706,331,382,269,278,1000,253,133,0,0,80,30,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.30','false',0,0),
(2499,18030,'Witch''s Offering','','batur_orc','9.00','21.50',54,'male','L2FestivalMonster','Mystic',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,4339,346,556,266,339,254,237,1000,216,226,0,0,80,30,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2500,18031,'Witch''s Offering Archer','','batur_orc_archer','11.00','21.50',50,'male','L2FestivalMonster','Mystic',500,2245,'5.500',830,'2.100',40,43,30,21,20,10,3090,233,1132,236,264,226,249,1000,227,278,0,0,45,70,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2501,18032,'Witch''s Offering Warrior','','batur_orc_warrior','10.00','20.00',51,'male','L2FestivalMonster','Mystic',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3121,238,539,286,281,232,278,1000,253,72,0,0,80,120,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.30','false',0,0),
(2502,18033,'Witch''s Offering Follower','','batur_orc','9.00','21.50',51,'male','L2FestivalMonster','Mystic',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3732,285,472,243,281,232,237,1000,216,316,0,0,50,160,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.30','false',0,0),
(2503,18034,'Witch''s Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',59,'male','L2FestivalMonster','Mystic',40,2971,'6.500',1117,'2.400',40,43,30,21,20,10,5789,495,820,359,453,291,278,1000,253,301,0,0,52,125,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.59','false',0,0),
(2504,18035,'Witch''s Offering Zealot','','batur_orc_20_bi','10.00','25.30',56,'male','L2FestivalMonster','Mystic',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,4478,368,618,281,382,269,237,1000,216,91,0,0,80,165,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2505,18036,'Witch''s Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',54,'male','L2FestivalMonster','Mystic',500,2562,'6.500',955,'2.400',40,43,30,21,20,10,3604,287,1413,266,339,254,249,1000,227,282,0,0,45,140,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2506,18037,'Witch''s Offering Disciple','','batur_orc_overlord','12.00','24.00',56,'male','L2FestivalMonster','Mystic',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,4478,368,706,331,382,269,278,1000,253,135,0,0,80,175,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2507,18038,'Witch''s Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',61,'male','L2FestivalMonster','Mystic',40,3137,'7.500',1184,'2.700',40,43,30,21,20,10,5313,468,901,378,505,307,278,1000,253,79,0,0,80,175,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2508,18039,'Dark Omen Offering Elder','','batur_orc_warrior_20_bi','12.00','24.00',67,'male','L2FestivalMonster','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,6679,636,1169,439,681,356,278,1000,253,79,0,0,80,30,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.30','false',0,0),
(2509,18040,'Dark Omen Offering','','batur_orc','9.00','21.50',65,'male','L2FestivalMonster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,6286,584,942,355,619,340,237,1000,216,234,0,0,80,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2510,18041,'Dark Omen Offering Archer','','batur_orc_archer','11.00','21.50',61,'male','L2FestivalMonster','Ranger',500,3137,'7.500',1184,'2.700',40,43,30,21,20,10,4599,405,2004,321,505,307,249,1000,227,283,0,0,45,70,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2511,18042,'Dark Omen Offering Warrior','','batur_orc_warrior','10.00','20.00',62,'male','L2FestivalMonster','Fighter',40,3219,'7.500',1217,'2.700',40,43,30,21,20,10,4612,411,944,388,532,315,278,1000,253,133,0,0,80,125,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.30','false',0,0),
(2512,18043,'Dark Omen Offering Follower','','batur_orc','9.00','21.50',62,'male','L2FestivalMonster','Fighter',40,3219,'7.500',1217,'2.700',40,43,30,21,20,10,5516,492,826,330,532,315,237,1000,216,316,0,0,50,165,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.30','false',0,0),
(2513,18044,'Dark Omen Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',70,'male','L2FestivalMonster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,8149,808,1314,470,780,382,278,1000,253,97,0,0,52,130,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.59','false',0,0),
(2514,18045,'Dark Omen Offering Zealot','','batur_orc_20_bi','10.00','25.30',67,'male','L2FestivalMonster','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,6410,610,1023,373,681,356,237,1000,216,2503,0,0,80,170,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2515,18046,'Dark Omen Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',65,'male','L2FestivalMonster','Ranger',500,3465,'7.500',1319,'2.700',40,43,30,21,20,10,5222,485,2393,355,619,340,249,1000,227,286,0,0,45,145,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2516,18047,'Dark Omen Offering Disciple','','batur_orc_overlord','12.00','24.00',67,'male','L2FestivalMonster','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,6410,610,1169,439,681,356,278,1000,253,142,0,0,80,180,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2517,18048,'Dark Omen Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',72,'male','L2FestivalMonster','Fighter',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,7402,752,1413,491,849,399,278,1000,253,2500,0,0,80,180,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2518,18049,'Offering of Forbidden Path Elder','','batur_orc_overlord_20_bi','14.00','28.80',78,'male','L2FestivalMonster','Fighter',40,4428,'8.500',1784,'3.000',40,43,30,21,20,10,9052,991,1715,555,1069,451,278,1000,253,2500,0,0,80,30,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2519,18050,'Offering of Forbidden Path','','batur_orc_warrior','10.00','20.00',76,'male','L2FestivalMonster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,8594,919,1412,454,994,433,237,1000,216,236,0,0,80,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.30','false',0,0),
(2520,18051,'Offering of Forbidden Path Archer','','ketra_orc_archer','12.00','27.00',80,'male','L2FestivalMonster','Ranger',500,4663,'8.500',1934,'3.000',40,43,30,21,20,10,8310,955,4248,508,1220,485,249,1000,227,287,0,0,45,70,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.91','false',0,0),
(2521,18052,'Offering of Forbidden Path Warrior','','ketra_orc_warrior','12.00','24.00',80,'male','L2FestivalMonster','Fighter',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,7680,862,1814,576,1144,468,278,1000,253,79,0,0,36,130,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.54','false',0,0),
(2522,18053,'Offering of Forbidden Path Follower','','ketra_orc','12.00','29.00',80,'male','L2FestivalMonster','Fighter',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,9185,1031,1587,490,1144,468,237,1000,216,316,0,0,10,180,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.34','false',0,0),
(2523,18054,'Offering of Forbidden Path Berserker','','ketra_orc_warrior_20_bi','14.00','28.80',81,'male','L2FestivalMonster','Fighter',40,4608,'8.500',1896,'3.000',40,43,30,21,20,10,10912,1239,1863,587,1182,477,278,1000,253,305,0,0,40,135,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.56','false',0,0),
(2524,18055,'Offering of Forbidden Path Zealot','','ketra_orc_20_bi','14.00','34.80',78,'male','L2FestivalMonster','Fighter',40,4428,'8.500',1784,'3.000',40,43,30,21,20,10,8687,951,1500,472,1069,451,237,1000,216,175,0,0,45,195,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2525,18056,'Offering of Forbidden Path Marksman','','ketra_orc_archer_20_bi','14.00','32.40',76,'male','L2FestivalMonster','Ranger',500,4297,'8.500',1710,'3.000',40,43,30,21,20,10,7139,763,3587,454,994,433,249,1000,227,289,0,0,45,150,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.91','false',0,0),
(2526,18057,'Offering of Forbidden Path Disciple','','ketra_orc_overload','12.00','24.00',78,'male','L2FestivalMonster','Fighter',40,4428,'8.500',1784,'3.000',40,43,30,21,20,10,8687,951,1715,555,1069,451,278,1000,253,151,0,0,33,195,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.48','false',0,0),
(2527,18058,'Offering of Forbidden Path Saint','','ketra_orc_overload_20_bi','14.00','28.80',80,'male','L2FestivalMonster','Fighter',40,4716,'8.500',1972,'3.000',40,43,30,21,20,10,9837,1144,1959,608,1258,494,278,1000,253,2500,0,0,33,195,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.48','false',0,0),
(2528,18059,'Offering of Branded Elder','','orc_fighter_bi','12.00','26.40',34,'male','L2FestivalMonster','Fighter',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1720,100,178,163,82,132,278,1000,253,127,0,0,45,30,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.46','false',0,0),
(2529,18060,'Offering of the Branded','','orc','10.00','21.00',32,'male','L2FestivalMonster','Fighter',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,1523,86,134,129,69,123,237,1000,216,218,0,0,45,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.48','false',0,0),
(2530,18061,'Offering of Branded Archer','','orc_archer','14.00','25.00',28,'male','L2FestivalMonster','Ranger',500,859,'3.500',334,'1.500',40,43,30,21,20,10,1001,53,251,110,49,106,249,1000,227,14,0,0,45,60,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.80','false',0,0),
(2531,18062,'Offering of Branded Warrior','','orc_champion','10.00','23.00',29,'male','L2FestivalMonster','Fighter',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1026,55,122,135,53,110,278,1000,253,125,0,0,45,110,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.76','false',0,0),
(2532,18063,'Offering of Branded Follower','','orc_fighter','12.00','22.00',29,'male','L2FestivalMonster','Fighter',40,906,'3.500',349,'1.500',40,43,30,21,20,10,1227,66,107,115,53,110,237,1000,216,316,0,0,45,150,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.26','false',0,0),
(2533,18064,'Offering of Branded Berserker','','orc_champion_20_bi','12.00','27.60',37,'male','L2FestivalMonster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,2276,140,222,182,104,147,278,1000,253,292,0,0,43,115,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.48','false',0,0),
(2534,18065,'Offering of Branded Zealot','','orc_fighter_bi','12.00','26.40',34,'male','L2FestivalMonster','Fighter',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1650,96,156,138,82,132,237,1000,216,158,0,0,45,155,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2535,18066,'Offering of Branded Marksman','','orc_archer_20_bi','16.00','30.00',32,'male','L2FestivalMonster','Ranger',500,1056,'4.500',397,'1.800',40,43,30,21,20,10,1265,71,342,129,69,123,249,1000,227,273,0,0,45,130,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.80','false',0,0),
(2536,18067,'Offering of Branded Disciple','','batur_orc','9.00','21.50',34,'male','L2FestivalMonster','Fighter',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,1650,96,178,163,82,132,278,1000,253,129,0,0,80,165,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.46','false',0,0),
(2537,18068,'Offering of Branded Saint','','batur_orc_20_bi','10.00','25.30',39,'male','L2FestivalMonster','Fighter',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,2171,138,255,195,121,158,278,1000,253,72,0,0,80,165,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.46','false',0,0),
(2538,18069,'Apostate''s Offering Elder','','orc_champion_20_bi','12.00','27.60',45,'male','L2FestivalMonster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,3013,210,377,238,188,193,278,1000,253,72,0,0,45,30,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.76','false',0,0),
(2539,18070,'Apostate''s Offering','','orc_fighter','12.00','22.00',43,'male','L2FestivalMonster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,2751,186,291,189,163,181,237,1000,216,223,0,0,45,30,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2540,18071,'Apostate''s Offering Archer','','batur_orc_archer','11.00','21.50',39,'male','L2FestivalMonster','Ranger',500,1462,'4.500',514,'1.800',40,43,30,21,20,10,1879,119,566,165,121,158,249,1000,227,275,0,0,45,60,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2541,18072,'Apostate''s Offering Warrior','','batur_orc_warrior','10.00','20.00',40,'male','L2FestivalMonster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,1920,124,273,201,131,164,278,1000,253,127,0,0,80,115,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.30','false',0,0),
(2542,18073,'Apostate''s Offering Follower','','batur_orc','9.00','21.50',40,'male','L2FestivalMonster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2296,148,238,171,131,164,237,1000,216,316,0,0,50,155,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.30','false',0,0),
(2543,18074,'Apostate''s Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',48,'male','L2FestivalMonster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,3832,280,453,261,231,212,278,1000,253,297,0,0,37,120,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2544,18075,'Apostate''s Offering Zealot','','batur_orc_20_bi','10.00','25.30',45,'male','L2FestivalMonster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,2891,201,330,202,188,193,237,1000,216,172,0,0,80,160,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2545,18076,'Apostate''s Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',43,'male','L2FestivalMonster','Ranger',500,1728,'5.500',618,'2.100',40,43,30,21,20,10,2285,154,739,189,163,181,249,1000,227,277,0,0,45,135,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2546,18077,'Apostate''s Offering Disciple','','batur_orc_overlord','12.00','24.00',45,'male','L2FestivalMonster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,2891,201,377,238,188,193,278,1000,253,74,0,0,80,170,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2547,18078,'Apostate''s Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',50,'male','L2FestivalMonster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,3570,269,509,278,264,226,278,1000,253,133,0,0,80,170,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2548,18079,'Witch''s Offering Elder','','batur_orc_warrior_20_bi','12.00','24.00',56,'male','L2FestivalMonster','Mystic',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,4666,383,706,331,382,269,278,1000,253,133,0,0,80,30,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.30','false',0,0),
(2549,18080,'Witch''s Offering','','batur_orc','9.00','21.50',54,'male','L2FestivalMonster','Mystic',40,2562,'6.500',955,'2.400',40,43,30,21,20,10,4339,346,556,266,339,254,237,1000,216,226,0,0,80,30,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2550,18081,'Witch''s Offering Archer','','batur_orc_archer','11.00','21.50',50,'male','L2FestivalMonster','Mystic',500,2245,'5.500',830,'2.100',40,43,30,21,20,10,3090,233,1132,236,264,226,249,1000,227,278,0,0,45,70,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2551,18082,'Witch''s Offering Warrior','','batur_orc_warrior','10.00','20.00',51,'male','L2FestivalMonster','Mystic',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3121,238,539,286,281,232,278,1000,253,72,0,0,80,120,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.30','false',0,0),
(2552,18083,'Witch''s Offering Follower','','batur_orc','9.00','21.50',51,'male','L2FestivalMonster','Mystic',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,3732,285,472,243,281,232,237,1000,216,316,0,0,50,160,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.30','false',0,0),
(2553,18084,'Witch''s Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',59,'male','L2FestivalMonster','Mystic',40,2971,'6.500',1117,'2.400',40,43,30,21,20,10,5789,495,820,359,453,291,278,1000,253,301,0,0,52,125,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.59','false',0,0),
(2554,18085,'Witch''s Offering Zealot','','batur_orc_20_bi','10.00','25.30',56,'male','L2FestivalMonster','Mystic',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,4478,368,618,281,382,269,237,1000,216,91,0,0,80,165,NULL,0,'Local',NULL,0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2555,18086,'Witch''s Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',54,'male','L2FestivalMonster','Mystic',500,2562,'6.500',955,'2.400',40,43,30,21,20,10,3604,287,1413,266,339,254,249,1000,227,282,0,0,45,140,NULL,0,'Local',NULL,0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2556,18087,'Witch''s Offering Disciple','','batur_orc_overlord','12.00','24.00',56,'male','L2FestivalMonster','Mystic',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,4478,368,706,331,382,269,278,1000,253,135,0,0,80,175,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2557,18088,'Witch''s Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',61,'male','L2FestivalMonster','Mystic',40,3137,'7.500',1184,'2.700',40,43,30,21,20,10,5313,468,901,378,505,307,278,1000,253,79,0,0,80,175,NULL,0,'Local',NULL,0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2558,18089,'Dark Omen Offering Elder','','batur_orc_warrior_20_bi','12.00','24.00',67,'male','L2FestivalMonster','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,6679,636,1169,439,681,356,278,1000,253,79,0,0,80,30,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.30','false',0,0),
(2559,18090,'Dark Omen Offering','','batur_orc','9.00','21.50',65,'male','L2FestivalMonster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,6286,584,942,355,619,340,237,1000,216,234,0,0,80,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2560,18091,'Dark Omen Offering Archer','','batur_orc_archer','11.00','21.50',61,'male','L2FestivalMonster','Ranger',500,3137,'7.500',1184,'2.700',40,43,30,21,20,10,4599,405,2004,321,505,307,249,1000,227,283,0,0,45,70,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2561,18092,'Dark Omen Offering Warrior','','batur_orc_warrior','10.00','20.00',62,'male','L2FestivalMonster','Fighter',40,3219,'7.500',1217,'2.700',40,43,30,21,20,10,4612,411,944,388,532,315,278,1000,253,133,0,0,80,125,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.30','false',0,0);
INSERT INTO `npc` VALUES
(2562,18093,'Dark Omen Offering Follower','','batur_orc','9.00','21.50',62,'male','L2FestivalMonster','Fighter',40,3219,'7.500',1217,'2.700',40,43,30,21,20,10,5516,492,826,330,532,315,237,1000,216,316,0,0,50,165,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.30','false',0,0),
(2563,18094,'Dark Omen Offering Berserker','','batur_orc_warrior_20_bi','12.00','24.00',70,'male','L2FestivalMonster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,8149,808,1314,470,780,382,278,1000,253,97,0,0,52,130,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.59','false',0,0),
(2564,18095,'Dark Omen Offering Zealot','','batur_orc_20_bi','10.00','25.30',67,'male','L2FestivalMonster','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,6410,610,1023,373,681,356,237,1000,216,2503,0,0,80,170,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2565,18096,'Dark Omen Offering Marksman','','batur_orc_archer_20_bi','13.00','25.30',65,'male','L2FestivalMonster','Ranger',500,3465,'7.500',1319,'2.700',40,43,30,21,20,10,5222,485,2393,355,619,340,249,1000,227,286,0,0,45,145,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.96','false',0,0),
(2566,18097,'Dark Omen Offering Disciple','','batur_orc_overlord','12.00','24.00',67,'male','L2FestivalMonster','Fighter',40,3626,'7.500',1388,'2.700',40,43,30,21,20,10,6410,610,1169,439,681,356,278,1000,253,142,0,0,80,180,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2567,18098,'Dark Omen Offering Saint','','batur_orc_overlord_20_bi','14.00','28.80',72,'male','L2FestivalMonster','Fighter',40,4013,'8.500',1565,'3.000',40,43,30,21,20,10,7402,752,1413,491,849,399,278,1000,253,2500,0,0,80,180,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2568,18099,'Offering of Forbidden Path Elder','','batur_orc_overlord_20_bi','14.00','28.80',78,'male','L2FestivalMonster','Fighter',40,4428,'8.500',1784,'3.000',40,43,30,21,20,10,9052,991,1715,555,1069,451,278,1000,253,2500,0,0,80,30,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.28','false',0,0),
(2569,18100,'Offering of Forbidden Path','','batur_orc_warrior','10.00','20.00',76,'male','L2FestivalMonster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,8594,919,1412,454,994,433,237,1000,216,236,0,0,80,30,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.30','false',0,0),
(2570,18101,'Offering of Forbidden Path Archer','','ketra_orc_archer','12.00','27.00',80,'male','L2FestivalMonster','Ranger',500,4663,'8.500',1934,'3.000',40,43,30,21,20,10,8310,955,4248,508,1220,485,249,1000,227,287,0,0,45,70,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.91','false',0,0),
(2571,18102,'Offering of Forbidden Path Warrior','','ketra_orc_warrior','12.00','24.00',80,'male','L2FestivalMonster','Fighter',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,7680,862,1814,576,1144,468,278,1000,253,79,0,0,36,130,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.54','false',0,0),
(2572,18103,'Offering of Forbidden Path Follower','','ketra_orc','12.00','29.00',80,'male','L2FestivalMonster','Fighter',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,9185,1031,1587,490,1144,468,237,1000,216,316,0,0,10,180,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.34','false',0,0),
(2573,18104,'Offering of Forbidden Path Berserker','','ketra_orc_warrior_20_bi','14.00','28.80',80,'male','L2FestivalMonster','Fighter',40,4608,'8.500',1896,'3.000',40,43,30,21,20,10,10912,1239,1863,587,1182,477,278,1000,253,305,0,0,40,135,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.56','false',0,0),
(2574,18105,'Offering of Forbidden Path Zealot','','ketra_orc_20_bi','14.00','34.80',78,'male','L2FestivalMonster','Fighter',40,4428,'8.500',1784,'3.000',40,43,30,21,20,10,8687,951,1500,472,1069,451,237,1000,216,175,0,0,45,195,'',0,'Local','',0,0,0,3,10,8,0,0,10,'0.46','false',0,0),
(2575,18106,'Offering of Forbidden Path Marksman','','ketra_orc_archer_20_bi','14.00','32.40',76,'male','L2FestivalMonster','Ranger',500,4297,'8.500',1710,'3.000',40,43,30,21,20,10,7139,763,3587,454,994,433,249,1000,227,289,0,0,45,150,'',0,'Local','',0,0,0,3,10,8,0,1500,10,'0.91','false',0,0),
(2576,18107,'Offering of Forbidden Path Disciple','','ketra_orc_overload','12.00','24.00',78,'male','L2FestivalMonster','Fighter',40,4428,'8.500',1784,'3.000',40,43,30,21,20,10,8687,951,1715,555,1069,451,278,1000,253,151,0,0,33,195,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.48','false',0,0),
(2577,18108,'Offering of Forbidden Path Saint','','ketra_orc_overload_20_bi','14.00','28.80',83,'male','L2FestivalMonster','Fighter',40,4716,'8.500',1972,'3.000',40,43,30,21,20,10,9837,1144,1959,608,1258,494,278,1000,253,2500,0,0,33,195,'',0,'Local','',0,0,0,3,30,4,4,0,0,'0.48','false',0,0),
(2578,18109,'Treasures of the Festival','','coffer_a','12.00','9.50',30,'male','L2FestivalMonster','Fighter',0,999,'3.500',365,'1.500',40,43,30,21,20,10,90,0,0,140,0,114,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,'0.56','false',0,0),
(2579,18110,'Treasures of the Festival','','coffer_a','12.00','9.50',41,'male','L2FestivalMonster','Fighter',0,1488,'5.500',560,'2.100',40,43,30,21,20,10,168,0,0,208,0,169,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,'0.56','false',0,0),
(2580,18111,'Treasures of the Festival','','coffer_a','12.00','9.50',52,'male','L2FestivalMonster','Fighter',0,2058,'6.500',892,'2.400',40,43,30,21,20,10,270,0,0,295,0,239,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,'0.56','false',0,0),
(2581,18112,'Treasures of the Festival','','coffer_a','12.00','9.50',63,'male','L2FestivalMonster','Fighter',0,2640,'7.500',1251,'2.700',40,43,30,21,20,10,396,0,0,398,0,323,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,'0.56','false',0,0),
(2582,18113,'Treasures of the Festival','','coffer_a','12.00','9.50',72,'male','L2FestivalMonster','Fighter',0,3063,'8.500',1565,'3.000',40,43,30,21,20,10,518,0,0,491,0,399,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,'0.56','false',0,0),
(2583,18114,'Treasures of the Festival','','coffer_a','12.00','9.50',30,'male','L2FestivalMonster','Fighter',0,999,'3.500',365,'1.500',40,43,30,21,20,10,90,0,0,140,0,114,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,'0.56','false',0,0),
(2584,18115,'Treasures of the Festival','','coffer_a','12.00','9.50',41,'male','L2FestivalMonster','Fighter',0,1488,'5.500',560,'2.100',40,43,30,21,20,10,168,0,0,208,0,169,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,'0.56','false',0,0),
(2585,18116,'Treasures of the Festival','','coffer_a','12.00','9.50',52,'male','L2FestivalMonster','Fighter',0,2058,'6.500',892,'2.400',40,43,30,21,20,10,270,0,0,295,0,239,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,'0.56','false',0,0),
(2586,18117,'Treasures of the Festival','','coffer_a','12.00','9.50',63,'male','L2FestivalMonster','Fighter',0,2640,'7.500',1251,'2.700',40,43,30,21,20,10,396,0,0,398,0,323,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,'0.56','false',0,0),
(2587,18118,'Treasures of the Festival','','coffer_a','12.00','9.50',72,'male','L2FestivalMonster','Fighter',0,3063,'8.500',1565,'3.000',40,43,30,21,20,10,518,0,0,491,0,399,0,0,0,0,0,0,80,195,'',0,'Local','',0,0,0,7,0,0,0,0,0,'0.56','false',0,0),
(2588,18119,'Corpse of Deadman','','zombie_corpse','13.00','21.00',63,'male','L2DeadMan','Mystic',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,0,0,987,398,560,323,278,0,253,0,0,0,15,0,'',0,'Local','',0,0,0,240,30,4,4,0,0,'0.43','false',1,0),
(2589,18120,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2590,18121,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2591,18122,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','RndTeleportFighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2592,18123,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2593,18124,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2594,18125,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','RndTeleportFighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2595,18126,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2596,18127,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2597,18128,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','RndTeleportFighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2598,18129,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2599,18130,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2600,18131,'Halisha''s Officer','','imperial_warlord_zombie_20_bi','9.00','36.00',81,'male','L2Monster','RndTeleportFighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,253,134,6721,0,39,150,'tomb1_clan',600,'Local',NULL,0,20,172,7,30,4,4,0,-6,'0.48','false',1,0),
(2601,18132,'Imperial Healer','','tera_beetle','19.00','54.50',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9949,1129,1540,782,807,635,278,0,253,0,0,0,45,170,'tomb1_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',1,0),
(2602,18133,'Imperial Mosaic','','scorpion','28.00','66.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9190,1043,1630,587,1182,477,237,0,216,0,0,0,37,170,'tomb1_clan',600,'Local','',0,0,0,7,10,8,0,0,0,'0.54','false',1,0),
(2603,18134,'Imperial Mosaic','','scorpion','28.00','66.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,6906,784,1630,587,1182,477,237,0,216,0,0,0,37,170,'tomb1_clan',600,'Local','',0,0,0,7,10,8,0,0,0,'0.54','false',1,0),
(2604,18135,'Imperial Mosaic','','scorpion','28.00','66.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9149,1039,1630,587,1182,477,237,0,216,0,0,0,37,170,'tomb1_clan',600,'Local','',0,0,0,7,10,8,0,0,0,'0.54','false',1,0),
(2605,18136,'Imperial Mosaic','','scorpion','28.00','66.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9190,1043,1482,710,977,577,237,0,216,0,0,0,37,170,'tomb1_clan',600,'Local','',0,0,0,7,10,8,0,0,0,'0.54','false',1,0),
(2606,18137,'Imperial Mosaic','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,6812,773,1863,587,1182,477,278,0,253,0,0,0,45,180,'tomb1_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2607,18138,'Imperial Mosaic','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9069,1029,1863,587,1182,477,278,0,253,0,0,0,45,180,'tomb1_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2608,18139,'Imperial Mosaic','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,8935,1014,1863,587,1182,477,278,0,253,0,0,0,45,180,'tomb1_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2609,18140,'Imperial Mosaic','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9065,1029,1694,710,977,577,278,0,253,0,0,0,45,180,'tomb1_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2610,18141,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'34.000',1896,'3.000',40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2611,18142,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'34.000',1896,'3.000',40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2612,18143,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'34.000',1896,'3.000',40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2613,18144,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'34.000',1896,'3.000',40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2614,18145,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'34.000',1896,'3.000',40,43,30,21,20,10,7399,840,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2615,18146,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'34.000',1896,'3.000',40,43,30,21,20,10,7568,859,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2616,18147,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'34.000',1896,'3.000',40,43,30,21,20,10,7046,800,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2617,18148,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'34.000',1896,'3.000',40,43,30,21,20,10,8203,931,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2618,18149,'Beetle of Grave','','scarab','14.00','22.00',81,'male','L2Monster','Fighter',40,4608,'34.000',1896,'3.000',40,43,30,21,20,10,7247,823,2480,485,2095,394,278,0,253,0,0,0,45,180,'tomb2_clan',600,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',1,0),
(2619,18150,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Npc','npc',40,4608,'8.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(2620,18151,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Npc','npc',40,4608,'8.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(2621,18152,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Npc','npc',40,4608,'8.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(2622,18153,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Npc','npc',40,4608,'8.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(2623,18154,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Npc','npc',40,4608,'8.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(2624,18155,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Npc','npc',40,4608,'8.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(2625,18156,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Npc','npc',40,4608,'8.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(2626,18157,'Victim','','a_tombkeeperA','7.00','23.00',81,'female','L2Npc','npc',40,4608,'8.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,50,100,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(2627,18158,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2628,18159,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2629,18160,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2630,18161,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2631,18162,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2632,18163,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2633,18164,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2634,18165,'Executioner of Halisha','','erinyes','21.00','50.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,253,0,0,0,31,150,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2635,18166,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7005,795,2255,534,1731,433,278,0,253,142,0,0,27,110,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(2636,18167,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,6906,784,1694,710,977,577,278,0,253,142,0,0,27,110,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(2637,18168,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7099,806,1863,587,1182,477,278,0,253,142,0,0,27,110,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(2638,18169,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,6872,780,1694,710,977,577,278,0,253,142,0,0,27,110,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(2639,18170,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,6879,781,2170,485,2095,394,237,0,216,0,0,0,80,160,'tomb3_clan',600,'Local','',0,0,0,7,10,8,0,0,0,'0.56','false',1,0),
(2640,18171,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7147,811,1347,782,807,635,237,0,216,0,0,0,80,160,'tomb3_clan',600,'Local','',0,0,0,7,10,8,0,0,0,'0.56','false',1,0),
(2641,18172,'Imperial Guard','','death_knight','12.00','30.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,6812,773,1630,587,1182,477,237,0,216,0,0,0,80,160,'tomb3_clan',600,'Local','',0,0,0,7,10,8,0,0,0,'0.56','false',1,0),
(2642,18173,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(2643,18174,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(2644,18175,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(2645,18176,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(2646,18177,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(2647,18178,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(2648,18179,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(2649,18180,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(2650,18181,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(2651,18182,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','true',1,0),
(2652,18183,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(2653,18184,'Halisha''s Foreman','','kaim_vanul','24.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,253,0,0,0,37,160,'tomb4_clan',600,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(2654,18185,'Evil Astrologer','','doll_blader','6.00','12.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9413,1069,1694,710,977,577,278,0,253,5129,5129,0,22,150,'tomb4_clan',600,'Local','',0,0,184,7,30,4,4,0,0,'0.50','false',1,0),
(2655,18186,'Evil Astrologer','','doll_blader','6.00','12.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9467,1075,1694,710,977,577,278,0,253,5129,5129,0,22,150,'tomb4_clan',600,'Local','',0,0,184,7,30,4,4,0,0,'0.50','false',1,0),
(2656,18187,'Knight of Darkness','','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9190,1043,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(2657,18188,'Knight of Darkness','','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,6906,784,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(2658,18189,'Knight of Darkness','','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9149,1039,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(2659,18190,'Knight of Darkness','','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9190,1043,2255,534,1731,433,278,0,253,78,0,0,40,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(2660,18191,'Witch of dust','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,6812,773,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2661,18192,'Witch of dust','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9069,1029,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2662,18193,'Witch of dust','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,8935,1014,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2663,18194,'Witch of dust','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9065,1029,2255,534,1731,433,278,0,253,3939,0,0,80,160,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2664,18195,'Signet of Emperor','','ant_larva','12.00','8.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,6946,788,3001,401,3068,325,278,0,253,0,0,0,40,60,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',1,0),
(2665,18196,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2666,18197,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2667,18198,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2668,18199,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2669,18200,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2670,18201,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2671,18202,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2672,18203,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2673,18204,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2674,18205,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2675,18206,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2676,18207,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2677,18208,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2678,18209,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2679,18210,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2680,18211,'Charm of Corner','','magmagoil_lad','15.00','75.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,253,0,0,0,1,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2681,18212,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2682,18213,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2683,18214,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2684,18215,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2685,18216,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2686,18217,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2687,18218,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2688,18219,'Archon of Halisha','','ahrimanes','14.00','57.75',81,'male','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,253,6722,0,0,35,185,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2689,18220,'Shaman of Darkness','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9467,1075,2050,587,1431,477,278,0,253,3939,0,0,80,160,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2690,18221,'Shaman of Darkness','','banshee','9.00','23.00',81,'female','L2Monster','Mystic',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9721,1103,2050,587,1431,477,278,0,253,3939,0,0,80,160,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2691,18222,'Assassin of Darkness','','ashuras','13.00','37.50',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9210,1045,2480,485,2095,394,278,0,253,0,0,0,41,190,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(2692,18223,'Assassin of Darkness','','ashuras','13.00','37.50',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,6906,784,1863,587,1182,477,278,0,253,0,0,0,41,190,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(2693,18224,'Assassin of Darkness','','ashuras','13.00','37.50',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9303,1056,2480,485,2095,394,278,0,253,0,0,0,41,190,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(2694,18225,'Assassin of Darkness','','ashuras','13.00','37.50',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9210,1045,1863,587,1182,477,278,0,253,0,0,0,41,190,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(2695,18226,'Caster of Darkness','','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,6812,773,2480,485,2095,394,278,0,253,0,0,0,70,155,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(2696,18227,'Caster of Darkness','','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11706,1329,1863,587,1182,477,278,0,253,0,0,0,70,155,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(2697,18228,'Caster of Darkness','','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,8801,999,2480,485,2095,394,278,0,253,0,0,0,70,155,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(2698,18229,'Caster of Darkness','','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,9065,1029,1863,587,1182,477,278,0,253,0,0,0,70,155,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(2699,18230,'Signet of Emperor','','ant_larva','12.00','8.00',81,'male','L2Monster','Fighter',40,4608,'25.500',1896,'3.000',40,43,30,21,20,10,7495,851,3001,401,3068,325,278,0,253,0,0,0,40,60,'tomb5_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',1,0),
(2700,18231,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2701,18232,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2702,18233,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2703,18234,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2704,18235,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2705,18236,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2706,18237,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2707,18238,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2708,18239,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2709,18240,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2710,18241,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2711,18242,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2712,18243,'Statue of Protection','','temple_guard_a','15.00','42.00',81,'male','L2Monster','Fighter',40,4608,'51.000',1896,'3.000',40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,253,5795,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2713,18244,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb1_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2714,18245,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb1_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2715,18246,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb1_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2716,18247,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb2_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2717,18248,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb2_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2718,18249,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb2_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2719,18250,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2720,18251,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2721,18252,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb3_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0);
INSERT INTO `npc` VALUES
(2722,18253,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,253,0,0,0,90,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2723,18254,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,1694,710,977,577,278,0,253,0,0,0,90,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2724,18255,'Watchman of Grave','','mana_vampire','11.00','20.00',81,'male','L2Monster','Mystic',40,3456,'25.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,253,0,0,0,90,1,'tomb4_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2725,18256,'Halisha''s Treasure Box','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,1,'0.000',1,'0.000',40,43,30,21,20,10,0,0,2,1,1,1,1,0,1,0,0,0,80,1,NULL,0,'Local',NULL,0,0,0,7,0,0,0,0,0,'0.56','true',0,0),
(2726,18257,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Chest','Fighter',40,4969,'3.000',2049,'3.000',40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2727,18258,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Chest','Fighter',40,4969,'3.000',2049,'3.000',40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2728,18259,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Chest','Fighter',40,4969,'3.000',2049,'3.000',40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2729,18260,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Chest','Fighter',40,4969,'3.000',2049,'3.000',40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2730,18261,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Chest','Fighter',40,4969,'3.000',2049,'3.000',40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2731,18262,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Chest','Fighter',40,4969,'3.000',2049,'3.000',40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2732,18263,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Chest','Fighter',40,4969,'3.000',2049,'3.000',40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2733,18264,'Treasure Chest','','mimic','8.50','8.50',85,'male','L2Chest','Fighter',40,4969,'3.000',2049,'3.000',40,43,30,21,20,10,0,0,2052,649,1333,527,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2734,18265,'Treasure Chest','','mimic','8.50','8.50',21,'male','L2Chest','Fighter',40,594,'1.500',227,'1.500',40,43,30,21,20,10,0,0,63,101,25,82,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2735,18266,'Treasure Chest','','mimic','8.50','8.50',24,'male','L2Chest','Fighter',40,710,'1.500',272,'1.500',40,43,30,21,20,10,0,0,81,115,34,93,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2736,18267,'Treasure Chest','','mimic','8.50','8.50',27,'male','L2Chest','Fighter',40,840,'1.500',318,'1.500',40,43,30,21,20,10,0,0,104,129,45,105,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2737,18268,'Treasure Chest','','mimic','8.50','8.50',30,'male','L2Chest','Fighter',40,985,'1.500',365,'1.500',40,43,30,21,20,10,0,0,132,145,58,118,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2738,18269,'Treasure Chest','','mimic','8.50','8.50',33,'male','L2Chest','Fighter',40,1145,'1.800',413,'1.800',40,43,30,21,20,10,0,0,166,162,75,132,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2739,18270,'Treasure Chest','','mimic','8.50','8.50',36,'male','L2Chest','Fighter',40,1320,'1.800',463,'1.800',40,43,30,21,20,10,0,0,206,181,96,147,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2740,18271,'Treasure Chest','','mimic','8.50','8.50',39,'male','L2Chest','Fighter',40,1510,'1.800',514,'1.800',40,43,30,21,20,10,0,0,255,201,121,163,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2741,18272,'Treasure Chest','','mimic','8.50','8.50',42,'male','L2Chest','Fighter',40,1713,'2.100',589,'2.100',40,43,30,21,20,10,0,0,311,222,152,181,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2742,18273,'Treasure Chest','','mimic','8.50','8.50',45,'male','L2Chest','Fighter',40,1930,'2.100',677,'2.100',40,43,30,21,20,10,0,0,377,245,188,199,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2743,18274,'Treasure Chest','','mimic','8.50','8.50',48,'male','L2Chest','Fighter',40,2159,'2.100',768,'2.100',40,43,30,21,20,10,0,0,453,270,231,219,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2744,18275,'Treasure Chest','','mimic','8.50','8.50',51,'male','L2Chest','Fighter',40,2398,'2.400',861,'2.400',40,43,30,21,20,10,0,0,539,296,281,240,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2745,18276,'Treasure Chest','','mimic','8.50','8.50',54,'male','L2Chest','Fighter',40,2645,'2.400',955,'2.400',40,43,30,21,20,10,0,0,636,323,339,262,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2746,18277,'Treasure Chest','','mimic','8.50','8.50',57,'male','L2Chest','Fighter',40,2897,'2.400',1052,'2.400',40,43,30,21,20,10,0,0,743,351,405,285,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2747,18278,'Treasure Chest','','mimic','8.50','8.50',60,'male','L2Chest','Fighter',40,3153,'2.400',1150,'2.400',40,43,30,21,20,10,0,0,860,380,478,309,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(2748,18279,'Treasure Chest','','mimic','8.50','8.50',63,'male','L2Chest','Fighter',40,3408,'2.700',1251,'2.700',40,43,30,21,20,10,0,0,987,411,560,334,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2749,18280,'Treasure Chest','','mimic','8.50','8.50',66,'male','L2Chest','Fighter',40,3661,'2.700',1353,'2.700',40,43,30,21,20,10,0,0,1123,442,649,359,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2750,18281,'Treasure Chest','','mimic','8.50','8.50',69,'male','L2Chest','Fighter',40,3906,'2.700',1458,'2.700',40,43,30,21,20,10,0,0,1265,474,746,385,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2751,18282,'Treasure Chest','','mimic','8.50','8.50',72,'male','L2Chest','Fighter',40,4142,'3.000',1565,'3.000',40,43,30,21,20,10,0,0,1413,507,849,412,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2752,18283,'Treasure Chest','','mimic','8.50','8.50',75,'male','L2Chest','Fighter',40,4365,'3.000',1673,'3.000',40,43,30,21,20,10,0,0,1563,540,957,438,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2753,18284,'Treasure Chest','','mimic','8.50','8.50',78,'male','L2Chest','Fighter',40,4571,'3.000',1784,'3.000',40,43,30,21,20,10,0,0,1715,573,1069,465,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2754,18285,'Treasure Chest','','mimic','8.50','8.50',81,'male','L2Chest','Fighter',40,4757,'3.000',1896,'3.000',40,43,30,21,20,10,0,0,1863,606,1182,492,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2755,18286,'Treasure Chest','','mimic','8.50','8.50',84,'male','L2Chest','Fighter',40,4920,'3.000',2011,'3.000',40,43,30,21,20,10,0,0,2006,639,1296,519,278,0,253,0,0,0,80,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2756,18287,'Otherworldly Invader Food','','mimic','8.50','8.50',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,0,0,166,157,75,128,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2757,18288,'Otherworldly Invader Food','','mimic','8.50','8.50',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2758,18289,'Dimension Invader Food','','mimic','8.50','8.50',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,0,0,332,223,163,181,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2759,18290,'Dimension Invader Food','','mimic','8.50','8.50',45,'male','L2Monster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2760,18291,'Purgatory Invader Food','','mimic','8.50','8.50',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,0,0,602,304,319,247,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2761,18292,'Purgatory Invader Food','','mimic','8.50','8.50',55,'male','L2Monster','Fighter',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2762,18293,'Forbidden Path Invader Food','','mimic','8.50','8.50',63,'male','L2Monster','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,0,0,987,398,560,323,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2763,18294,'Forbidden Path Invader Food','','mimic','8.50','8.50',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2764,18295,'Dark Omen Invader Food','','mimic','8.50','8.50',73,'male','L2Monster','Fighter',40,4086,'8.500',1601,'3.000',40,43,30,21,20,10,0,0,1463,502,885,407,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2765,18296,'Dark Omen Invader Food','','mimic','8.50','8.50',75,'male','L2Monster','Fighter',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2766,18297,'Messenger Invader Food','','mimic','8.50','8.50',83,'male','L2Monster','Fighter',40,4716,'8.500',1972,'3.000',40,43,30,21,20,10,0,0,1959,608,1258,494,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2767,18298,'Messenger Invader Food','','mimic','8.50','8.50',85,'male','L2Monster','Fighter',40,4813,'8.500',2049,'3.000',40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,80,165,'ssq_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','true',1,0),
(2768,18299,'Flame of the Branded','','big_boom','6.00','13.00',35,'male','L2Monster','Fighter',40,1220,'13.500',446,'1.800',40,43,30,21,20,10,1631,96,192,169,89,137,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(2769,18300,'Offering of the Branded,Evoked Spirit','','orc','10.00','21.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1751,100,166,157,75,128,278,0,253,158,0,0,45,155,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(2770,18301,'Flame of Apostates','','big_boom','6.00','13.00',46,'male','L2Monster','Fighter',40,1943,'16.500',707,'2.100',40,43,30,21,20,10,2817,199,401,245,202,199,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(2771,18302,'Offering of Apostates,Evoked Spirit','','orc_fighter','12.00','22.00',44,'male','L2Monster','Fighter',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,3113,213,354,230,176,187,278,0,253,172,0,0,45,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2772,18303,'Flame of the Witch','','big_boom','6.00','13.00',57,'male','L2Monster','Mystic',40,2806,'19.500',1052,'2.400',40,43,30,21,20,10,4326,359,743,340,405,276,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(2773,18304,'Offering of the Witch,Evoked Spirit','','batur_orc','9.00','21.50',55,'male','L2Monster','Mystic',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,4864,393,670,322,360,261,278,0,253,91,0,0,80,165,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2774,18305,'Flame of Dark Omen','','big_boom','6.00','13.00',68,'male','L2Monster','Fighter',40,3706,'22.500',1423,'2.700',40,43,30,21,20,10,6157,594,1217,449,713,365,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(2775,18306,'Offering of Dark Omen,Evoked Spirit','','batur_orc','9.00','21.50',66,'male','L2Monster','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,7004,659,1123,428,649,348,278,0,253,2503,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2776,18307,'Flame of Forbidden Path','','big_boom','6.00','13.00',79,'male','L2Monster','Fighter',40,4490,'25.500',1821,'3.000',40,43,30,21,20,10,8311,921,1765,566,1107,459,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(2777,18308,'Offering of /Forbidden Path,Evoked Spirit','','batur_orc_warrior','10.00','20.00',77,'male','L2Monster','Fighter',40,4364,'8.500',1747,'3.000',40,43,30,21,20,10,9533,1032,1664,544,1031,442,278,0,253,175,0,0,80,175,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',0,0),
(2778,18309,'Flame of the Branded','','big_boom','6.00','13.00',35,'male','L2Monster','Fighter',40,1220,'13.500',446,'1.800',40,43,30,21,20,10,1631,96,192,169,89,137,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(2779,18310,'Offering of the Branded,Evoked Spirit','','orc','10.00','21.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,1751,100,166,157,75,128,278,0,253,158,0,0,45,155,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(2780,18311,'Flame of Apostates','','big_boom','6.00','13.00',46,'male','L2Monster','Fighter',40,1943,'16.500',707,'2.100',40,43,30,21,20,10,2817,199,401,245,202,199,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(2781,18312,'Offering of Apostates,Evoked Spirit','','orc_fighter','12.00','22.00',44,'male','L2Monster','Fighter',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,3113,213,354,230,176,187,278,0,253,172,0,0,45,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2782,18313,'Flame of the Witch','','big_boom','6.00','13.00',57,'male','L2Monster','Mystic',40,2806,'19.500',1052,'2.400',40,43,30,21,20,10,4326,359,743,340,405,276,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(2783,18314,'Offering of the Witch,Evoked Spirit','','batur_orc','9.00','21.50',55,'male','L2Monster','Mystic',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,4864,393,670,322,360,261,278,0,253,91,0,0,80,165,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2784,18315,'Flame of Dark Omen','','big_boom','6.00','13.00',68,'male','L2Monster','Fighter',40,3706,'22.500',1423,'2.700',40,43,30,21,20,10,6157,594,1217,449,713,365,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(2785,18316,'Offering of Dark Omen,Evoked Spirit','','batur_orc','9.00','21.50',66,'male','L2Monster','Fighter',40,3546,'7.500',1353,'2.700',40,43,30,21,20,10,7004,659,1123,428,649,348,278,0,253,2503,0,0,80,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2786,18317,'Flame of Forbidden Path','','big_boom','6.00','13.00',79,'male','L2Monster','Fighter',40,4490,'25.500',1821,'3.000',40,43,30,21,20,10,8311,921,1765,566,1107,459,278,0,253,0,0,0,48,30,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(2787,18318,'Offering of Forbidden Path,Evoked Spirit','','batur_orc_warrior','10.00','20.00',77,'male','L2Monster','Fighter',40,4364,'8.500',1747,'3.000',40,43,30,21,20,10,9533,1032,1664,544,1031,442,278,0,253,175,0,0,80,175,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',0,0),
(2788,18319,'Caught Frog','','poison_toad','20.00','10.00',10,'male','L2PenaltyMonster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,421,14,22,52,8,49,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.35','false',0,0),
(2789,18320,'Caught Undine','','undine','12.00','27.00',20,'female','L2PenaltyMonster','Mystic',40,541,'2.500',213,'1.200',40,43,30,21,20,10,843,37,57,80,23,76,278,0,253,0,0,0,60,120,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.35','false',0,0),
(2790,18321,'Caught Rakul','','rakul','30.00','39.00',30,'male','L2PenaltyMonster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,1550,85,132,119,58,114,278,0,253,156,0,0,60,130,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.59','false',0,0),
(2791,18322,'Caught Sea Giant','','water_giant','13.00','44.00',40,'male','L2PenaltyMonster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,2755,178,273,171,131,164,278,0,253,131,0,0,35,140,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.45','false',0,0),
(2792,18323,'Caught Sea Horse Soldier','','theeder','9.00','32.00',50,'male','L2PenaltyMonster','Fighter',80,2245,'5.500',830,'2.100',40,43,30,21,20,10,4305,324,509,236,264,226,237,0,216,291,0,0,80,150,'',0,'Local','',0,0,0,7,30,4,0,0,10,'0.45','false',0,0),
(2793,18324,'Caught Homunculus','','homunculus','12.00','32.50',60,'male','L2PenaltyMonster','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,6200,538,860,313,478,299,278,0,253,0,0,0,30,160,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.50','false',0,0),
(2794,18325,'Caught Flava','','flava','18.00','34.00',70,'male','L2PenaltyMonster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,8438,837,1314,399,780,382,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.45','false',0,0),
(2795,18326,'Caught Gigantic Eye','','hundred_eye','21.00','55.00',80,'male','L2PenaltyMonster','Mystic',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,11022,1237,1814,490,1144,468,278,0,253,0,0,0,30,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.54','false',0,0),
(2796,18327,'Freya''s Servant','','gargoyle_02te','16.00','50.00',58,'male','L2Monster','Fighter',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,5822,492,751,318,428,284,317,0,289,223,0,0,70,174,'',300,'Local','',0,0,0,7,10,8,0,0,0,'0.46','true',0,0),
(2797,18328,'Hall Alarm Device','','grave_keeper_key','8.00','21.00',80,'etc','L2Npc','npc',40,158000,'2.000',989,'0.900',40,43,30,21,20,10,0,0,652,753,358,295,423,0,385,0,0,0,50,120,'',0,'Local','',0,0,0,7,0,4,3,0,0,'0.60','false',0,0),
(2798,18329,'Hall Keeper Captain','','death_lord','21.00','40.00',80,'male','L2Monster','Fighter',40,4716,'17.000',1972,'3.000',40,43,30,21,20,10,10475,1217,1619,736,1258,494,278,150,253,0,0,0,30,165,'hall_keeper_clan',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',0,0),
(2799,18330,'Hall Keeper Wizard','','vale_master','12.00','40.00',80,'male','L2Monster','Mystic',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,11022,1237,1814,490,1144,468,278,0,253,0,0,0,30,180,'hall_keeper_clan',0,'Local','',0,0,0,7,50,1,9,0,10,'0.54','true',0,0),
(2800,18331,'Hall Keeper Guard','','death_knight','12.00','30.00',80,'male','L2Monster','Fighter',40,4663,'17.000',1934,'3.000',40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'hall_keeper_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','true',0,0),
(2801,18332,'Hall Keeper Patrol','','headless_knight','21.00','31.00',80,'male','L2Monster','Fighter',40,4608,'17.000',1896,'3.000',40,43,30,21,20,10,9976,1133,1540,710,1182,477,278,150,253,0,0,0,35,170,'hall_keeper_clan',0,'Local','',0,0,0,7,50,1,9,0,0,'0.54','true',0,0),
(2802,18333,'Hall Keeper Suicidal Soldier','','self_blaster','9.00','25.80',80,'male','L2Monster','Fighter',40,4550,'34.000',1859,'3.000',40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'hall_keeper_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.61','true',0,0),
(2803,18334,'Dark Choir Captain','','erinyes_cmd','21.00','50.00',85,'male','L2Monster','Fighter',40,4813,'17.000',2049,'3.000',40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,253,0,0,0,23,190,'dark_choir_clan',0,'Local','',0,0,0,7,30,4,4,0,10,'0.54','true',0,0),
(2804,18335,'Dark Choir Prima Donna','','portrait_spirit','23.00','40.00',80,'male','L2Monster','Mystic',40,4663,'17.000',1934,'3.000',40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','true',0,0),
(2805,18336,'Dark Choir Lancer','','death_blader','15.00','45.00',80,'male','L2Monster','Fighter',40,4663,'17.000',1934,'3.000',40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','true',0,0),
(2806,18337,'Dark Choir Archer','','skeleton_archer_20_bi','13.00','32.50',80,'male','L2Monster','Ranger',500,4663,'17.000',1934,'3.000',40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','true',0,0),
(2807,18338,'Dark Choir Witch Doctor','','portrait_spirit_winged','23.00','40.00',80,'male','L2Monster','Mystic',40,4663,'17.000',1934,'3.000',40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,253,6716,0,0,36,175,'dark_choir_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.45','true',0,0),
(2808,18339,'Dark Choir Player','','skeleton','11.00','25.00',80,'male','L2Monster','Fighter',40,4550,'34.000',1859,'3.000',40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'dark_choir_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.61','true',0,0),
(2809,18340,'Hall Keeper Suicidal Soldier','','self_blaster','9.00','25.80',80,'male','L2Monster','Fighter',40,4550,'34.000',1859,'3.000',40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.61','true',0,0),
(2810,18341,'Hall Keeper Suicidal Soldier','','self_blaster','9.00','25.80',80,'male','L2Monster','Fighter',40,4550,'34.000',1859,'3.000',40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,253,0,0,0,48,200,'',300,'Local','',0,0,0,7,50,1,9,0,0,'0.61','true',0,0),
(2811,18342,'Gremlin','','gremlin','10.00','15.00',1,'male','L2Monster','Fighter',40,62,'2.000',44,'0.900',40,43,30,21,20,10,29,2,9,39,3,32,278,0,253,0,0,0,20,50,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',1,0),
(2812,18343,'Gatekeeper Zombie','','zombie_gateguard','17.00','30.50',80,'male','L2Monster','GatekeeperZombie',40,4716,'17.000',1972,'3.000',40,43,30,21,20,10,10475,1217,2249,736,1258,494,200,500,182,8217,0,0,20,165,'pagan_clan',1000,'SYS','',0,0,0,7,50,1,9,0,0,'0.46','false',0,0),
(2813,18344,'Ancient Egg','','dinosaur_nest','43.00','33.50',80,'male','L2Monster','NoRndWalkFighter',0,3,'4.740',3,'3.090',40,43,30,21,20,10,0,0,1,606,1,1182,300,0,333,0,0,0,0,0,'NULL',0,'Local','NULL',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(2814,18345,'Sprigant','','Arachnoid','45.00','67.00',80,'male','L2Monster','NoRndWalkFighter',40,1179,'13.430',2057,'3.090',40,43,30,21,20,10,0,0,2129,615,2129,511,300,500,333,0,0,0,0,0,'NULL',0,'Local','NULL',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(2815,18346,'Sprigant','','Arachnoid','45.00','67.00',80,'male','L2Monster','NoRndWalkFighter',40,1179,'13.430',2057,'3.090',40,43,30,21,20,10,0,0,2129,615,2129,511,300,500,333,0,0,0,0,0,'NULL',0,'Local','NULL',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',1,0),
(2816,27001,'Orc Sniper','','orc_archer','14.00','25.00',10,'male','L2Monster','Ranger',500,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,51,61,8,49,249,0,227,14,0,0,45,110,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',0,0),
(2817,27002,'Orc Fighter','','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,0,0,27,66,10,54,278,0,253,1,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2818,27003,'Spirit Of Mirrors','Quest Monster','poison_toad','20.00','10.00',9,'male','L2Monster','Fighter',40,226,'2.000',111,'0.900',40,43,30,21,20,10,0,0,20,58,7,47,278,0,253,0,0,0,50,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',1,0),
(2819,27004,'Spirit Of Mirrors','Quest Monster','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(2820,27005,'Spirit Of Mirrors','Quest Monster','werewolf','10.00','26.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','false',1,0),
(2821,27006,'Bhato Bloodspear','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2822,27007,'Tanuki Skullcrusher','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2823,27008,'Kraacul Blackskull','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2824,27009,'Taarq Blackskull','','orc_archer','14.00','25.00',11,'male','L2Monster','Ranger',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.80','true',0,0),
(2825,27016,'Nerkas','Quest Monster','dre_vanul','14.00','36.00',22,'male','L2Monster','Fighter',40,611,'3.500',242,'1.500',40,43,30,21,20,10,0,0,68,102,28,83,278,0,253,0,0,0,80,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',1,0),
(2826,27017,'Plague Zombie','Quest Monster','zombie','13.00','21.00',14,'male','L2Monster','Mystic',40,364,'2.500',156,'1.200',40,43,30,21,20,10,0,0,33,73,12,59,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','false',1,0),
(2827,27018,'Orc Warrior','','orc_fighter','12.00','22.00',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2828,27019,'Orc Warrior Leader','','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,0,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2829,27020,'Varool Foulclaw','Quest Monster','wererat','14.00','25.00',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(2830,27021,'Kirunak','Quest Monster','dre_vanul','14.00','36.00',22,'male','L2Monster','Fighter',40,611,'3.500',242,'1.500',40,43,30,21,20,10,0,0,68,102,28,83,278,0,253,0,0,0,80,80,'kirunak_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',1,0),
(2831,27022,'Merkenis','Quest Monster','succubus','10.00','36.00',22,'female','L2Monster','Mystic',40,611,'3.500',242,'1.500',40,43,30,21,20,10,0,0,68,102,28,83,278,0,253,0,0,0,60,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','false',1,1),
(2832,27024,'Undead Priest','Quest Monster','zombie','13.00','21.00',17,'male','L2Monster','Priest',40,446,'2.500',184,'1.200',40,43,30,21,20,10,0,0,48,75,17,67,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','false',1,0),
(2833,27029,'Phantom Salamander','Quest Monster','salamander','16.00','6.80',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,0,0,48,75,17,67,278,500,253,0,0,0,64,96,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.20','false',0,0),
(2834,27030,'Water Seer','Quest Monster','monster_eye','21.00','43.00',17,'male','L2Monster','Mystic',40,446,'2.500',184,'1.200',40,43,30,21,20,10,0,0,48,75,17,67,278,500,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',1,0),
(2835,27031,'Ol Mahum Sentry','Quest Monster','ol_mahum','13.50','25.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,0,0,48,75,17,67,278,0,253,2,0,0,50,110,'ol_mahum_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(2836,27032,'Lizardman Warrior','Quest Monster','virud_lizardman_warrior','12.00','30.00',13,'male','L2Monster','Fighter',80,339,'2.500',147,'1.200',40,43,30,21,20,10,0,0,33,63,11,56,237,500,216,16,0,0,52,130,'',0,'Local','',0,0,0,7,30,4,0,0,0,'0.59','false',0,0),
(2837,27033,'Lizardman Scout','Quest Monster','virud_lizardman','10.00','23.00',12,'male','L2Monster','Ranger',40,315,'2.500',138,'1.200',40,43,30,21,20,10,0,0,30,60,10,54,278,500,253,1,0,0,43,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2838,27034,'Lizardman','Quest Monster','virud_lizardman','10.00','23.00',11,'male','L2Monster','Fighter',80,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,27,58,9,52,237,500,216,291,0,0,43,130,'',0,'Local','',0,0,0,7,30,4,0,0,0,'0.48','false',0,0),
(2839,27035,'Tamil','Quest Monster','bugbear','17.00','35.00',19,'male','L2Monster','Fighter',40,508,'2.500',203,'1.200',40,43,30,21,20,10,0,0,58,82,21,73,278,500,253,4,0,0,55,130,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.28','false',0,0),
(2840,27036,'Calpico','Quest Monster','orc_fighter','12.00','22.00',13,'male','L2Monster','Fighter',40,339,'2.500',147,'1.200',40,43,30,21,20,10,0,0,33,63,11,56,278,0,253,2,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,1),
(2841,27037,'Calpico''s Goons','Quest Monster','orc','10.00','21.00',10,'male','L2Monster','Fighter',40,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,25,55,8,49,278,0,253,1,0,0,45,110,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2842,27038,'Cat''s Eye Bandit','Quest Monster','ol_mahum','13.50','25.00',15,'male','L2Monster','Fighter',40,390,'2.500',165,'1.200',40,43,30,21,20,10,0,0,32,76,14,62,317,0,289,218,0,0,50,110,NULL,0,'Local',NULL,0,0,0,7,10,8,0,0,0,'0.46','false',1,0),
(2843,27041,'Baranka''s Messenger','Quest Monster','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,0,0,25,73,10,54,278,0,253,2,0,0,45,110,'orc_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.46','false',1,1),
(2844,27042,'Orc Escort','Quest Monster','orc_fighter','12.00','22.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,0,0,25,73,10,54,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(2845,27043,'Varangka''s Tracker','Quest Monster','vampire_bat','10.00','33.50',11,'male','L2Monster','Mystic',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,23,70,9,52,278,500,253,0,0,0,60,80,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(2846,27044,'Kasha Bear Totem Spirit','Quest Monster','grizzly','21.00','40.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,0,0,40,91,17,67,278,500,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(2847,27045,'Kuruka Ratman Leader','Quest Monster','wererat','14.00','25.00',18,'male','L2Monster','Fighter',40,476,'2.500',193,'1.200',40,43,30,21,20,10,0,0,44,95,19,70,278,500,253,1,0,0,80,120,'wererat_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(2848,27046,'Sumi','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2849,27047,'Wanuk','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2850,27048,'Chewba','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2851,27049,'Heitafu','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2852,27050,'Picubo','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2853,27051,'Bumbum','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2854,27052,'Minsku','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2855,27053,'Chuchu','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2856,27054,'Umbar Orc','Quest Monster','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(2857,27055,'Zakan','Orc Betrayer','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,2,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2858,27056,'Durka Spirit','Quest Monster','magical_weaver','11.00','20.00',18,'male','L2Monster','Mystic',40,476,'2.500',193,'1.200',40,43,30,21,20,10,0,0,48,87,19,70,278,500,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2859,27058,'Honey Bear','Quest Monster','grizzly','21.00','40.00',17,'male','L2Monster','Fighter',40,446,'2.500',184,'1.200',40,43,30,21,20,10,0,0,48,75,17,67,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(2860,27059,'Uoph','Kaboo Chief','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(2861,27060,'Kracha','Kaboo Chief','orc_archer','14.00','25.00',11,'male','L2Monster','Ranger',500,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,56,64,9,52,249,0,227,275,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(2862,27061,'Batoh','Kaboo Chief','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,86,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',1,0),
(2863,27062,'Tanukia','Kaboo Chief','orc_fighter','12.00','22.00',8,'male','L2Monster','Fighter',40,197,'2.000',102,'0.900',40,43,30,21,20,10,0,0,18,55,6,45,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(2864,27063,'Tanukia''s Warhound','Quest Monster','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,'2.000',68,'0.900',40,43,30,21,20,10,0,0,12,46,4,37,278,0,253,0,0,0,24,110,'orc_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2865,27064,'Turel','Kaboo Chief','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',1,0),
(2866,27065,'Roko','Kaboo Chief','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,'2.000',102,'0.900',40,43,30,21,20,10,0,0,41,55,6,45,249,0,227,275,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(2867,27066,'Roko''s Warhound','Quest Monster','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,'2.000',68,'0.900',40,43,30,21,20,10,0,0,12,46,4,37,278,0,253,0,0,0,24,110,'orc_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2868,27067,'Kamut','Kaboo Chief','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,86,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,50,1,9,0,0,'0.46','true',1,0),
(2869,27068,'Murtika','Kaboo Chief','orc_archer','14.00','25.00',8,'male','L2Monster','Ranger',500,197,'2.000',102,'0.900',40,43,30,21,20,10,0,0,41,55,6,45,249,0,227,275,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.80','true',1,0),
(2870,27069,'Murtika''s Warhound','Quest Monster','wolf','13.00','9.00',4,'male','L2Monster','Fighter',40,107,'2.000',68,'0.900',40,43,30,21,20,10,0,0,12,46,4,37,278,0,253,0,0,0,24,110,'orc_clan',300,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2871,27070,'Tumran Orc Brigand','Quest Monster','orc_fighter','12.00','22.00',11,'male','L2Monster','Fighter',40,292,'2.500',129,'1.200',40,43,30,21,20,10,0,0,25,64,9,52,278,0,253,2,0,0,45,110,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(2872,27077,'Unicorn Of Eva','Quest Monster','unicorn','14.00','30.00',30,'male','L2Monster','Mystic',40,954,'3.500',365,'1.500',40,43,30,21,20,10,0,0,145,128,58,114,278,0,253,0,0,0,46,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(2873,27078,'Trimden Lord','Quest Monster','poison_spider','27.00','25.50',39,'male','L2Monster','Fighter',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.65','false',0,0),
(2874,27079,'Black Willow Lurker','Quest Monster','hanged_man_ripper','35.00','80.00',39,'male','L2Monster','Fighter',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,55,55,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2875,27080,'Pashika Son Of Voltar','Quest Monster','batur_orc_warrior','10.00','20.00',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,0,0,222,182,104,147,278,500,253,2,0,0,80,120,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(2876,27081,'Vultus Son Of Voltar','Quest Monster','batur_orc_warrior','10.00','20.00',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,0,0,222,182,104,147,278,500,253,2,0,0,80,120,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(2877,27082,'Enku Orc Overlord','Quest Monster','batur_orc_warrior','10.00','20.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,0,0,182,143,75,128,278,500,253,2,0,0,80,120,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(2878,27083,'Makum Bugbear Thug','Quest Monster','bugbear','17.00','35.00',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,0,0,244,165,104,147,278,500,253,2,0,0,55,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2879,27086,'Revenant of Tantos Chief','Quest Monster','batur_orc_overlord','12.00','24.00',39,'male','L2Monster','Fighter',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,0,0,231,214,121,158,278,0,253,66,0,0,80,140,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2880,27088,'Harpy Matriarch','Quest Monster','harpy','10.00','42.00',34,'female','L2Monster','Fighter',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,0,0,178,163,82,132,278,500,253,0,0,0,60,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.65','false',0,0),
(2881,27089,'Road Collector','Quest Monster','wererat','14.00','25.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,206,175,96,142,278,500,253,12,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(2882,27090,'Serpent Demon Kadesh','Quest Monster','serpent_slave','17.00','46.00',41,'male','L2Monster','Fighter',40,1593,'5.500',560,'2.100',40,43,30,21,20,10,0,0,291,208,141,169,278,0,253,73,0,0,70,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(2883,27092,'Neer Bodyguard','Quest Monster','neer_crawler','14.00','22.00',33,'male','L2Monster','Fighter',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,0,0,182,143,75,128,278,500,253,0,0,0,50,90,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(2884,27093,'Delu Chief Kalkis','Quest Monster','virud_lizardman_matriarch','13.00','37.00',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,0,0,244,165,104,147,278,0,253,12,0,0,56,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.65','false',1,0),
(2885,27094,'Delu Lizardman Assassin','Quest Monster','virud_lizardman','10.00','23.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,227,159,96,142,278,500,253,2,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(2886,27095,'Singing Flower Phantasm','Quest Monster','mandragora_b','12.00','25.50',44,'female','L2Monster','Fighter',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,0,0,322,253,176,187,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.13','false',1,0),
(2887,27096,'Singing Flower Nightmare','Quest Monster','mandragora_b','12.00','25.50',44,'female','L2Monster','Fighter',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,0,0,322,253,176,187,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.13','false',1,0),
(2888,27097,'Singing Flower Darkling','Quest Monster','mandragora_b','12.00','25.50',44,'female','L2Monster','Fighter',40,1799,'5.500',648,'2.100',40,43,30,21,20,10,0,0,322,253,176,187,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.13','false',1,0),
(2889,27098,'Ghost Fire','Quest Monster','will_o_wisp','13.00','22.00',42,'male','L2Monster','Mystic',40,1660,'5.500',589,'2.100',40,43,30,21,20,10,0,0,311,215,152,175,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.10','false',1,0),
(2890,27099,'Nameless Revenant','Quest Monster','zombie','13.00','21.00',38,'male','L2Monster','Mystic',40,1400,'4.500',497,'1.800',40,43,30,21,20,10,0,0,261,171,112,153,278,0,253,0,0,0,15,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','false',1,0);
INSERT INTO `npc` VALUES
(2891,27100,'Skeletal Mercenary','Quest Monster','skeleton_knight','10.00','25.00',39,'male','L2Monster','Fighter',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,0,0,280,177,121,158,278,0,253,69,0,0,40,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(2892,27101,'Drevanul Prince Zeruel','Quest Monster','dre_vanul','14.00','36.00',42,'male','L2Monster','Fighter',40,1660,'5.500',589,'2.100',40,43,30,21,20,10,0,0,342,196,152,175,278,0,253,0,0,0,80,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(2893,27102,'Pako The Cat','Quest Monster','cat_the_cat','9.00','16.00',38,'male','L2Monster','Fighter',40,1400,'4.500',497,'1.800',40,43,30,21,20,10,0,0,238,188,112,153,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(2894,27103,'Unicorn Racer','Quest Monster','unicorn_boxer','11.00','18.00',38,'male','L2Monster','Mystic',40,1400,'4.500',497,'1.800',40,43,30,21,20,10,0,0,238,188,112,153,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',1,0),
(2895,27104,'Shadow Turen','Quest Monster','shadow','10.00','30.00',39,'male','L2Monster','Mystic',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',1,0),
(2896,27105,'Mimi The Cat','Quest Monster','cutie_cat','8.00','15.00',39,'female','L2Monster','Fighter',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,0,0,255,195,121,158,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(2897,27106,'Unicorn Phantasm','Quest Monster','unicorn_mirage','13.00','17.50',40,'male','L2Monster','Mystic',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,0,0,273,201,131,164,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',1,0),
(2898,27107,'Silhouette Tilfo','Quest Monster','silhouette','8.00','23.00',40,'female','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,0,0,273,201,131,164,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',1,0),
(2899,27108,'Stenoa Gorgon Queen','Quest Monster','cave_maiden','25.00','65.00',37,'female','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,0,0,244,165,104,147,278,0,253,127,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','false',1,0),
(2900,27109,'Handmaiden Of Stenoa','Quest Monster','medusa','10.00','25.00',33,'female','L2Monster','Mystic',40,1109,'4.500',413,'1.800',40,43,30,21,20,10,0,0,182,143,75,128,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(2901,27110,'Shyslassys','Quest Monster','medusa','10.00','25.00',36,'female','L2Monster','Mystic',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,187,193,96,142,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(2902,27111,'Cave Basilisk','Quest Monster','lesser_basilisk','34.00','25.00',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,0,0,120,155,58,114,278,0,253,0,0,0,35,54,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2903,27112,'Gorr','Quest Monster','medusa','10.00','25.00',36,'female','L2Monster','Mystic',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,227,159,96,142,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(2904,27113,'Baraham','Quest Monster','medusa','10.00','25.00',36,'female','L2Monster','Mystic',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,227,159,96,142,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(2905,27114,'Succubus Queen','Quest Monster','succubus','10.00','36.00',34,'female','L2Monster','Mystic',40,1164,'4.500',430,'1.800',40,43,30,21,20,10,0,0,196,148,82,132,278,0,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','false',1,1),
(2906,27115,'Claw Of Succubus','Quest Monster','succubus','10.00','36.00',28,'female','L2Monster','Mystic',40,859,'3.500',334,'1.500',40,43,30,21,20,10,0,0,124,118,49,106,278,0,253,0,0,0,60,100,'demonic_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','false',0,0),
(2907,27116,'Lava Salamander','Quest Monster','salamander','16.00','6.80',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,174,186,89,137,278,0,253,0,0,0,64,96,'elemental3_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.20','false',1,0),
(2908,27117,'Nahir','Quest Monster','dre_vanul','14.00','36.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,174,186,89,137,278,0,253,0,0,0,80,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',1,0),
(2909,27118,'Black Willow','Quest Monster','hanged_man_ripper','35.00','80.00',30,'male','L2Monster','Fighter',40,954,'3.500',365,'1.500',40,43,30,21,20,10,0,0,145,128,58,114,278,0,253,0,0,0,55,55,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(2910,27119,'Spirit of Sir Herod','Quest Monster','skeleton_royal_guard','11.00','28.50',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,69,0,0,80,120,'skeleton_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(2911,27120,'Luell Of Zephyr Winds','Quest Monster','sylph','11.00','35.00',37,'female','L2Monster','Mystic',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,0,0,222,182,104,147,278,0,253,0,0,0,60,60,'elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2912,27121,'Actea Of Verdant Wilds','Quest Monster','dryad','9.00','20.00',37,'female','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,0,0,222,182,104,147,278,0,253,0,0,0,40,110,'elemental1_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(2913,27122,'Leto Lizardman Agent','Quest Monster','zenta_lizardman','11.00','32.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,1,0,0,37,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2914,27123,'Leto Lizardman Leader','Quest Monster','zenta_lizardman_warrior','13.00','35.00',38,'male','L2Monster','Fighter',40,1400,'4.500',497,'1.800',40,43,30,21,20,10,0,0,238,188,112,153,278,0,253,66,0,0,40,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2915,27124,'Leto Lizardman Assassin','Quest Monster','zenta_lizardman','11.00','32.00',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,0,0,244,165,104,147,278,500,253,217,0,0,37,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2916,27125,'Leto Lizardman Sniper','Quest Monster','zenta_lizardman_scout','11.00','30.00',36,'male','L2Monster','Ranger',500,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,417,193,96,142,249,0,227,14,0,0,37,150,'lizardman_clan',300,'Local','',0,0,0,7,10,8,0,1500,0,'0.93','false',0,0),
(2917,27126,'Leto Lizardman Wizard','Quest Monster','zenta_lizardman_shaman','13.00','35.00',39,'male','L2Monster','Priest',40,1462,'4.500',514,'1.800',40,43,30,21,20,10,0,0,280,177,121,158,278,0,253,7,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.63','false',0,0),
(2918,27127,'Leto Lizardman Lord','Quest Monster','zenta_lizardman_matriarch','20.00','40.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,69,0,0,53,140,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(2919,27128,'Aruraune','Quest Monster','mandragora_b','12.00','25.50',40,'female','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,0,0,273,201,131,164,278,500,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.13','false',0,0),
(2920,27129,'Ol Mahum Inspector','Quest Monster','ol_mahum','13.50','25.00',38,'male','L2Monster','Fighter',40,1400,'4.500',497,'1.800',40,43,30,21,20,10,0,0,261,171,112,153,278,500,253,2,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(2921,27130,'Ol Mahum Betrayer','Quest Monster','ol_mahum','13.50','25.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,187,193,96,142,278,0,253,12,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(2922,27131,'Crimson Werewolf','Quest Monster','werewolf','10.00','26.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,206,175,96,142,278,500,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(2923,27132,'Krudel Lizardman','Quest Monster','virud_lizardman','10.00','23.00',36,'male','L2Monster','Fighter',80,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,206,175,96,142,237,500,216,291,0,0,43,130,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.48','false',0,0),
(2924,27133,'Evil Eye Lord','Quest Monster','monster_eye','21.00','43.00',37,'male','L2Monster','Fighter',40,1338,'4.500',480,'1.800',40,43,30,21,20,10,0,0,244,165,104,147,278,500,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',1,0),
(2925,27134,'Tatoma','Quest Monster','king_bugbear','15.00','40.00',32,'male','L2Monster','Fighter',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,0,0,140,167,69,123,278,500,253,88,0,0,55,130,'orc_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2926,27135,'Grima','Quest Monster','devastator','35.00','35.00',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,0,0,560,253,264,226,278,500,253,0,0,0,25,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(2927,27136,'Succubus Of Seduction','Quest Monster','succubus','10.00','36.00',40,'female','L2Monster','Mystic',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,0,0,0,60,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','false',0,0),
(2928,27137,'Demon King','Quest Monster','dre_vanul','14.00','36.00',50,'male','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,0,0,463,306,264,226,278,500,253,0,0,0,80,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(2929,27138,'Great Demon King','Quest Monster','death_knight','12.00','30.00',60,'male','L2Monster','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,0,0,946,335,478,299,278,500,253,127,0,0,27,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(2930,27139,'Secret Keeper Tree','Quest Monster','ti_mi_tran','23.00','90.00',47,'male','L2Monster','Fighter',40,2016,'5.500',738,'2.100',40,43,30,21,20,10,0,0,388,279,216,206,278,0,253,0,0,0,12,12,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(2931,27140,'Breka Overlord Haka','Quest Monster','batur_orc_overlord','12.00','24.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,187,193,96,142,278,500,253,66,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2932,27141,'Breka Overlord Jaka','Quest Monster','batur_orc_overlord','12.00','24.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,187,193,96,142,278,500,253,66,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2933,27142,'Breka Overlord Marka','Quest Monster','batur_orc_overlord','12.00','24.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,187,193,96,142,278,500,253,66,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2934,27143,'Windsus Aleph','Quest Monster','giant_wild_hog','25.00','27.00',42,'male','L2Monster','Fighter',40,1660,'5.500',589,'2.100',40,43,30,21,20,10,0,0,342,196,152,175,278,500,253,0,0,0,35,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(2935,27144,'Tarlk Raider Athu','Quest Monster','king_bugbear','15.00','40.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2936,27145,'Tarlk Raider Lanka','Quest Monster','king_bugbear','15.00','40.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2937,27146,'Tarlk Raider Triska','Quest Monster','king_bugbear','15.00','40.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2938,27147,'Tarlk Raider Motura','Quest Monster','king_bugbear','15.00','40.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2939,27148,'Tarlk Raider Kalath','Quest Monster','king_bugbear','15.00','40.00',48,'male','L2Monster','Fighter',40,2091,'5.500',768,'2.100',40,43,30,21,20,10,0,0,498,238,231,212,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2940,27149,'Gremlin Filcher','Quest Monster','gremlin','10.00','15.00',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,0,0,25,73,10,54,278,500,253,0,0,0,20,50,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(2941,27150,'Black Legion Stormtrooper','Quest Monster','skeleton_royal_guard','11.00','28.50',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,0,0,365,202,163,181,278,500,253,217,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(2942,27151,'Delu Lizardman Headhunter','Quest Monster','virud_lizardman_scout','10.00','22.00',28,'male','L2Monster','Fighter',500,859,'3.500',334,'1.500',40,43,30,21,20,10,0,0,276,118,49,106,249,500,227,2507,0,0,43,130,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.72','false',0,0),
(2943,27152,'Marsh Stakato Marquess','Quest Monster','marsh_stakato_queen','15.00','37.00',35,'female','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,211,154,89,137,278,500,253,0,0,0,130,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','false',0,0),
(2944,27153,'Alexandro Sanches','Dark Lord','imp','10.00','24.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,0,0,10,48,3,35,278,0,253,0,0,0,60,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(2945,27154,'Bonaparterius','Abyss King','goblin','10.00','16.50',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,0,0,10,48,3,35,278,0,253,4,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.32','true',0,0),
(2946,27155,'Ramsebalius','Evil Overlord','orc','10.00','21.00',3,'male','L2Monster','Fighter',40,90,'2.000',60,'0.900',40,43,30,21,20,10,0,0,12,40,3,35,278,0,253,2,0,0,45,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','true',0,0),
(2947,27156,'Leto Shaman Ketz','Quest Monster','zenta_lizardman_shaman','13.00','35.00',40,'male','L2Monster','Priest',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,159,0,0,43,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.63','false',0,0),
(2948,27157,'Leto Chief Narak','Quest Monster','zenta_lizardman_matriarch','20.00','40.00',41,'male','L2Monster','Fighter',40,1593,'5.500',560,'2.100',40,43,30,21,20,10,0,0,265,229,141,169,278,500,253,221,0,0,53,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(2949,27158,'Timak Raider Kaikee','Quest Monster','batur_orc','9.00','21.50',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,0,0,365,202,163,181,278,500,253,66,0,0,80,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(2950,27159,'Timak Overlord Okun','Quest Monster','batur_orc_overlord','12.00','24.00',46,'male','L2Monster','Fighter',40,1943,'5.500',707,'2.100',40,43,30,21,20,10,0,0,442,223,202,199,278,500,253,127,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2951,27160,'Gok Magok','Grandis Chief','twin_headed_giant','17.00','39.00',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,0,0,302,245,163,181,278,500,253,0,0,0,45,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(2952,27161,'Taik Overlord Kakran','Quest Monster','ketra_orc_warrior','12.00','24.00',45,'male','L2Monster','Fighter',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,0,0,415,216,188,193,278,500,253,69,0,0,36,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(2953,27162,'Hatar Chieftain Kubel','Quest Monster','medusa','10.00','25.00',52,'female','L2Monster','Mystic',40,2402,'6.500',892,'2.400',40,43,30,21,20,10,0,0,518,324,300,239,278,500,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(2954,27163,'Vanor Elder Kerunos','Quest Monster','heltor_silenos_chieftain','13.00','31.50',51,'male','L2Monster','Fighter',40,2323,'6.500',861,'2.400',40,43,30,21,20,10,0,0,490,315,281,232,278,500,253,179,0,0,27,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2955,27164,'Karul Chief Orooto','Quest Monster','bugbear','17.00','35.00',43,'male','L2Monster','Fighter',40,1728,'5.500',618,'2.100',40,43,30,21,20,10,0,0,365,202,163,181,278,500,253,88,0,0,55,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(2956,27165,'Abyssal Jewel 1','Quest Monster','mirror','26.00','52.00',60,'male','L2Monster','Mystic',40,3054,'58.500',1150,'2.400',40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,0,0,0,80,165,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(2957,27166,'Abyssal Jewel 2','Quest Monster','mirror','26.00','52.00',60,'male','L2Monster','Mystic',40,3054,'58.500',1150,'2.400',40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,0,0,0,80,165,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(2958,27167,'Abyssal Jewel 3','Quest Monster','mirror','26.00','52.00',60,'male','L2Monster','Mystic',40,3054,'58.500',1150,'2.400',40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,0,0,0,80,165,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2959,27168,'Jewel Guardian Mara','Quest Monster','succubus','10.00','36.00',53,'female','L2Monster','Mystic',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,0,0,662,276,319,247,278,500,253,0,0,0,60,100,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.84','false',0,0),
(2960,27169,'Jewel Guardian Musfel','Quest Monster','dre_vanul','14.00','36.00',53,'male','L2Monster','Fighter',40,2481,'6.500',923,'2.400',40,43,30,21,20,10,0,0,547,334,319,247,278,500,253,0,0,0,80,80,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(2961,27170,'Jewel Guardian Pyton','Quest Monster','serpent_slave','17.00','46.00',58,'male','L2Monster','Fighter',40,2889,'6.500',1084,'2.400',40,43,30,21,20,10,0,0,710,384,428,284,278,500,253,223,0,0,70,110,'abyss_jewel_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(2962,27171,'Sacrifice Of The Sacrificed','Quest Monster','magical_weaver','11.00','20.00',20,'male','L2Monster','Mystic',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,63,86,23,76,278,0,253,0,0,0,90,90,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(2963,27172,'Harit Lizardman Zealot','Quest Monster','zenta_lizardman_warrior','13.00','35.00',55,'male','L2Monster','Fighter',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,737,292,360,261,278,500,253,16,0,0,40,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(2964,27173,'Box Of Athrea 1','Quest Monster','coffer_a','12.00','9.50',50,'etc','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(2965,27174,'Box Of Athrea 2','Quest Monster','coffer_a','12.00','9.50',50,'etc','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(2966,27175,'Box Of Athrea 3','Quest Monster','coffer_a','12.00','9.50',50,'etc','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(2967,27176,'Box Of Athrea 4','Quest Monster','coffer_a','12.00','9.50',50,'etc','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(2968,27177,'Box Of Athrea 5','Quest Monster','coffer_a','12.00','9.50',50,'etc','L2Monster','Fighter',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,0,0,463,306,264,226,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(2969,27178,'Blitz Wyrm','Quest Monster','wyrm','29.00','72.00',60,'male','L2Monster','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,0,0,946,335,478,299,278,500,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.19','false',0,0),
(2970,27179,'Grave Keymaster','Quest Monster','gargoyle','16.00','50.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,979,460,619,340,278,0,253,0,0,0,140,140,'grave_guard_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(2971,27180,'Imperial Slave','Quest Monster','binding','12.00','21.00',56,'male','L2Monster','Fighter',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,642,364,382,269,278,500,253,0,0,0,10,140,'grave_keeper_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(2972,27181,'Imperial Gravekeeper','Quest Monster','death_blader','15.00','45.00',60,'male','L2Monster','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,1472,0,0,100,170,'grave_keeper_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(2973,27182,'Ark Guardian Elberoth','Quest Monster','archangel','15.00','80.00',60,'male','L2Monster','Fighter',40,3054,'6.500',1150,'2.400',40,43,30,21,20,10,0,0,782,405,478,299,278,0,253,6370,0,0,50,200,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(2974,27183,'Ark Guardian Shadowfang','Quest Monster','kel_mahum_archer','13.00','27.00',60,'male','L2Monster','Ranger',500,3054,'6.500',1150,'2.400',40,43,30,21,20,10,0,0,2313,259,478,299,249,0,227,288,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,10,'0.91','false',0,0),
(2975,27184,'Angel Killer','Quest Monster','death_lord','21.00','40.00',60,'male','L2Monster','Fighter',40,3054,'58.500',1150,'2.400',40,43,30,21,20,10,0,0,711,446,478,299,278,0,253,130,0,0,40,200,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(2976,27185,'Fairy Tree of Wind','Quest Monster','human_tree','35.00','90.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,273,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',100,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',1,0),
(2977,27186,'Fairy Tree of Star','Quest Monster','human_tree','35.00','90.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,554,389,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',100,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(2978,27187,'Fairy Tree of Twilight','Quest Monster','human_tree','35.00','90.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,737,292,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',100,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(2979,27188,'Fairy Tree of Abyss','Quest Monster','human_tree','35.00','90.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,0,'q421_tree_clan',100,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(2980,27189,'Soul of Tree Guardian','Quest Monster','elf_ghost','7.00','21.00',50,'male','L2Monster','Mystic',40,2245,'2.750',830,'2.100',40,43,30,21,20,10,0,0,509,236,264,226,278,500,253,0,0,0,80,140,'q421_tree_clan',100,'Local','',0,0,0,7,30,4,4,0,10,'0.41','false',0,0),
(2981,27190,'Ol Mahum Support Troop','Quest Monster','ol_mahum_champion','14.00','27.00',26,'male','L2Monster','Fighter',40,770,'3.500',303,'1.500',40,43,30,21,20,10,0,0,96,120,41,98,278,500,253,69,0,0,50,150,'orc_clan',200,'Local','',0,0,0,7,30,4,4,0,0,'0.63','false',0,0),
(2982,27191,'Malcom','Quest Monster','grizzly','21.00','40.00',25,'male','L2Monster','Fighter',40,728,'3.500',287,'1.500',40,43,30,21,20,10,0,0,103,116,37,94,237,500,216,0,0,0,40,159,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(2983,27192,'Succubus Handmaiden','Quest Monster','succubus','10.00','36.00',18,'female','L2Monster','Mystic',40,476,'2.500',193,'1.200',40,43,30,21,20,10,0,0,48,87,19,70,278,500,253,0,0,0,60,134,'',0,'stiff_fix_outofdate_from_1028','1145636095',0,0,0,7,30,4,4,0,0,'0.84','false',0,0),
(2984,27193,'Goblin Servant','Quest Monster','goblin','10.00','16.50',12,'male','L2Monster','Fighter',40,315,'2.500',138,'1.200',40,43,30,21,20,10,0,0,27,56,10,54,278,500,253,0,0,0,40,120,'',0,'stiff_fix_outofdate_from_1029','1145636095',0,0,0,7,30,4,4,0,10,'0.32','false',0,0),
(2985,27194,'Julie the Ripper','Quest Monster','doll_blader','6.00','12.00',40,'male','L2Monster','Fighter',40,1527,'9.000',531,'1.800',40,43,30,21,20,10,0,0,289,141,131,164,317,500,289,5129,5129,0,22,174,'',0,'stiff_fix_outofdate_from_1030','1145636095',0,0,60,7,10,8,0,0,10,'0.50','false',0,0),
(2986,27195,'Male Ant','Quest Monster','noble_ant','20.00','48.00',32,'male','L2Monster','Fighter',40,1056,'4.500',397,'1.800',40,43,30,21,20,10,0,0,154,151,69,123,278,0,253,0,0,0,80,150,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(2987,27196,'Bluebacked Alligator','Quest Monster','crocodile','28.00','11.50',40,'male','L2Monster','Fighter',40,1527,'9.000',531,'1.800',40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,0,0,0,70,110,'croc_clan',200,'Local','',0,0,0,7,30,4,4,0,0,'0.41','false',0,0),
(2988,27197,'Bejewelled Alligator','Quest Monster','crocodile','28.00','11.50',40,'male','L2Monster','Fighter',40,1527,'13.500',531,'1.800',40,43,30,21,20,10,0,0,248,222,131,164,278,500,253,0,0,0,70,110,'croc_clan',200,'Local','',0,0,0,7,30,4,4,0,0,'0.41','false',0,0),
(2989,27199,'Crimson Werewolf','Quest Monster','werewolf','10.00','26.00',36,'male','L2Monster','Fighter',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,0,0,0,50,120,'werewolf_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.43','false',1,0),
(2990,27200,'Krudel Lizardman','Quest Monster','virud_lizardman','10.00','23.00',36,'male','L2Monster','Fighter',80,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,206,175,96,142,237,0,216,291,0,0,43,130,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.48','false',1,0),
(2991,27201,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(2992,27202,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(2993,27203,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(2994,27204,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(2995,27205,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(2996,27206,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(2997,27207,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(2998,27208,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(2999,27209,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(3000,27210,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(3001,27211,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(3002,27212,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(3003,27213,'','','bugbear','17.00','35.00',10,'male','L2Monster','Fighter',80,257,'2.000',120,'0.900',40,43,30,21,20,10,0,0,22,61,8,49,237,0,216,291,0,0,55,180,'elemental1_clan',300,'Local','',0,0,0,7,30,4,0,0,0,'0.28','false',0,0),
(3004,27214,'Guardian of Forbidden Knowledge','Quest Monster','apostle_warrior','8.00','30.00',76,'female','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'guard_of_secrets_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(3005,27215,'Guardian of Forbidden Knowledge','Quest Monster','apostle_warrior','8.00','30.00',76,'female','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'guard_of_secrets_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(3006,27216,'Guardian of Forbidden Knowledge','Quest Monster','apostle_warrior','8.00','30.00',76,'female','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'guard_of_secrets_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(3007,27217,'Soul of Well','Quest Monster','dark_horror','20.00','35.00',63,'male','L2Monster','Fighter',40,3302,'7.500',1251,'2.700',40,43,30,21,20,10,0,0,987,338,560,323,278,150,253,0,0,0,100,180,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.37','false',0,0),
(3008,27218,'Triol''s Pawn','Quest Monster','dre_vanul','14.00','36.00',65,'male','L2Monster','Fighter',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,150,253,0,0,0,80,180,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(3009,27219,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3010,27220,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3011,27221,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3012,27222,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3013,27223,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3014,27224,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3015,27225,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3016,27226,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3017,27227,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3018,27228,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3019,27229,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3020,27230,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3021,27231,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3022,27232,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3023,27233,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3024,27234,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3025,27235,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3026,27236,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3027,27237,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3028,27238,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3029,27239,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3030,27240,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3031,27241,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3032,27242,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3033,27243,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3034,27244,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3035,27245,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3036,27246,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3037,27247,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3038,27248,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3039,27249,'Archon of Halisha','Quest Monster','ahrimanes','14.00','57.75',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,150,182,6722,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3040,27250,'Fallen Angel Allector','Quest Monster','karik','25.00','90.00',76,'male','L2Monster','Fighter',40,4297,'17.000',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,37,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(3041,27251,'Fallen Angel Allector','Quest Monster','karik','25.00','90.00',76,'male','L2Monster','Fighter',40,4297,'17.000',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,37,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(3042,27252,'Fallen Angel Allector','Quest Monster','karik','25.00','90.00',76,'male','L2Monster','Fighter',40,4297,'17.000',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,37,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(3043,27253,'Hell Fire','Quest Monster','will_o_wisp','13.00','22.00',76,'male','L2Monster','Mystic',40,4297,'4.250',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,170,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.10','false',0,0),
(3044,27254,'Unknown Stopper','Quest Monster','fiend_archer','17.00','55.00',81,'male','L2Monster','Ranger',500,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,227,0,0,0,70,180,'',0,'Local','',0,0,0,7,10,8,0,1500,10,'0.76','false',0,0),
(3045,27255,'Unknown Stopper','Quest Monster','fiend_archer','17.00','55.00',81,'male','L2Monster','Ranger',500,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,227,0,0,0,70,180,'',0,'Local','',0,0,0,7,10,8,0,1500,10,'0.76','false',0,0),
(3046,27256,'Unknown Stopper','Quest Monster','fiend_archer','17.00','55.00',81,'male','L2Monster','Ranger',500,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,227,0,0,0,70,180,'',0,'Local','',0,0,0,7,10,8,0,1500,10,'0.76','false',0,0),
(3047,27257,'Archangel Iconoclasis','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.48','false',0,0),
(3048,27258,'Archangel Iconoclasis','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.48','false',0,0),
(3049,27259,'Archangel Iconoclasis','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.48','false',0,0),
(3050,27260,'Archangel Iconoclasis','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.48','false',0,0),
(3051,27261,'Bead of Sacred Flame','Quest Monster','will_o_wisp','13.00','22.00',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.10','false',0,0),
(3052,27262,'Death Lord Hallate','Quest Monster','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,78,0,0,40,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0);
INSERT INTO `npc` VALUES
(3053,27263,'Death Lord Hallate','Quest Monster','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,78,0,0,40,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(3054,27264,'Death Lord Hallate','Quest Monster','death_lord','21.00','40.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,78,0,0,40,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(3055,27265,'Lich King Icarus','Quest Monster','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,499,1182,477,278,150,253,205,0,0,70,180,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.74','false',0,0),
(3056,27266,'Fallen Angel Haures','Quest Monster','doll_master','20.00','42.00',76,'male','L2Monster','Fighter',40,4297,'17.000',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',0,0),
(3057,27267,'Fallen Angel Haures','Quest Monster','doll_master','20.00','42.00',76,'male','L2Monster','Fighter',40,4297,'17.000',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,0,0,0,80,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',0,0),
(3058,27268,'Guard of Haures','Quest Monster','neer_crawler','14.00','22.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1412,454,994,433,317,0,289,0,0,0,50,180,'',0,'Local','',0,0,0,7,10,8,0,0,10,'0.37','false',0,0),
(3059,27269,'Fallen Angel Naverius','Quest Monster','banshee','9.00','23.00',76,'female','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,3939,0,0,80,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',0,0),
(3060,27270,'Fallen Angel Naverius','Quest Monster','banshee','9.00','23.00',76,'female','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,3939,0,0,80,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',0,0),
(3061,27271,'Chimera Golem','Quest Monster','lava_golem','22.00','45.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,13,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.47','false',0,0),
(3062,27272,'Hallate''s Dancer Lillian','Quest Monster','banshee','9.00','23.00',76,'female','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,3939,0,0,80,180,NULL,0,'Local',NULL,0,0,0,7,50,1,9,0,10,'0.56','false',0,0),
(3063,27273,'Assassin Pezel','Quest Monster','skeleton_royal_guard','11.00','28.50',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1630,587,1182,477,317,150,289,242,0,0,80,180,'',0,'Local','',0,0,0,7,10,8,0,0,0,'0.52','false',0,0),
(3064,27274,'Fallen Angel Tanakia','Quest Monster','halisha_d','23.00','60.00',81,'female','L2Monster','Fighter',500,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.48','false',0,0),
(3065,27275,'Fallen Angel Tanakia','Quest Monster','halisha_d','23.00','60.00',81,'female','L2Monster','Fighter',500,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.48','false',0,0),
(3066,27276,'Fallen Angel Tanakia','Quest Monster','halisha_d','23.00','60.00',81,'female','L2Monster','Fighter',500,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.48','false',0,0),
(3067,27277,'Fallen Angel Tanakia','Quest Monster','halisha_d','23.00','60.00',81,'female','L2Monster','Fighter',500,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,227,286,0,0,43,180,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.48','false',0,0),
(3068,27278,'Shadow of Beleth','Quest Monster','vale_master','12.00','40.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,205,0,0,70,180,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.74','false',0,0),
(3069,27279,'Cursed Kesadein','Quest Monster','doll_master','20.00','42.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1630,499,1182,477,317,150,289,0,0,0,80,180,'',0,'Local','',0,0,0,7,10,8,0,0,10,'0.56','false',0,0),
(3070,27280,'Fallen Angel Narcissus','Quest Monster','karik','25.00','90.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,37,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(3071,27281,'Fallen Angel Metellus','Quest Monster','karik','25.00','90.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,37,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',0,0),
(3072,27282,'Reverse Angel Odiel','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3073,27283,'Grandpapa Askalius','Quest Monster','susceptor_prime','45.00','72.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,78,180,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.52','false',0,0),
(3074,27284,'Flame Evil Spirit Azira','Quest Monster','ifrit','10.00','42.00',81,'male','L2Monster','Mystic',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,38,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3075,27285,'Lizard''s Totem Sharuhi','Quest Monster','serpent_slave','17.00','46.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,72,0,0,70,180,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(3076,27286,'Fallen Knight Adhil','Quest Monster','a_guard_MHuman','8.00','24.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,79,107,0,50,180,'',0,'Local','',0,20,161,7,30,4,4,0,-6,'0.60','false',0,0),
(3077,27287,'Bound Elf Panacea','Quest Monster','a_guard_MElf','8.00','23.50',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,145,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3078,27288,'Sword Player Biel','Quest Monster','a_patriarch_MElf','8.00','22.50',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,74,74,0,50,180,'',0,'Local','',0,0,167,7,30,4,4,0,0,'0.60','false',0,0),
(3079,27289,'Ancient Sword Master Iron','Quest Monster','lilim_knight_10_bi','13.00','55.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,5800,5799,0,56,180,'',0,'Local','',0,20,161,7,30,4,4,0,-6,'0.46','false',0,0),
(3080,27290,'White Wing Commander','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3081,27291,'White Wing Fighter','Quest Monster','apostle_warrior','8.00','30.00',76,'female','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,80,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(3082,27292,'Fallen Noble Orc Muhark','Quest Monster','ketra_orc_warrior','12.00','24.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,7834,0,0,36,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(3083,27293,'Khavatari Uruz','Quest Monster','ketra_orc_warrior','12.00','24.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,0,0,0,36,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(3084,27294,'Overlord Atrus','Quest Monster','ketra_orc_chieftain','11.00','38.50',76,'male','L2Monster','Fighter',40,4297,'34.000',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,6719,0,0,24,180,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.51','false',0,0),
(3085,27295,'Sharuhi Mouth Mudaha','Quest Monster','ketra_orc_chieftain','11.00','38.50',76,'male','L2Monster','Fighter',40,4297,'34.000',1710,'3.000',40,43,30,21,20,10,0,0,2242,534,994,433,200,0,182,6719,0,0,24,180,'',0,'Local','',0,0,0,7,50,1,9,0,0,'0.51','false',0,0),
(3086,27296,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3087,27297,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3088,27298,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3089,27299,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3090,27300,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3091,27301,'Monument Watcher Ezekiel','Quest Monster','archangel','15.00','80.00',76,'male','L2Monster','Fighter',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,534,994,433,278,0,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3092,27302,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3093,27303,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3094,27304,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3095,27305,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3096,27306,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3097,27307,'Monument Defender Azrael','Quest Monster','archangel','15.00','80.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,97,0,0,50,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',0,0),
(3098,27308,'Assassin Frost','Quest Monster','vampire_soldier','8.00','23.50',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1630,587,1182,477,317,150,289,229,0,0,60,180,'',0,'Local','',0,0,0,7,10,8,0,0,0,'0.45','false',0,0),
(3099,27309,'Minervia Van Hacken','Quest Monster','vampire_witch','6.00','21.50',81,'female','L2Monster','Mystic',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1630,499,1182,477,317,150,289,229,0,0,64,180,'',0,'Local','',0,0,0,7,10,8,0,0,10,'0.50','false',0,0),
(3100,27310,'Kitanis Van Hacken','Quest Monster','vampire_lord','7.50','25.80',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,15,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(3101,27311,'Judgment Hound Dog Kelvas','Quest Monster','eligor','21.00','35.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,253,0,0,0,35,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3102,27312,'Mysterious Servitor','Quest Monster','shadeless','7.00','28.00',81,'male','L2Monster','Fighter',40,4608,'76.500',1896,'3.000',40,43,30,21,20,10,0,0,1863,499,1182,477,278,150,253,0,0,0,48,180,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.61','false',0,0),
(3103,27313,'Vision Guardian Shakiel','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.48','false',0,0),
(3104,27314,'Vision Guardian Shakiel','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.48','false',0,0),
(3105,27315,'Vision Guardian Shakiel','Quest Monster','apostle_mage','11.00','38.50',76,'male','L2Monster','Mystic',40,4297,'8.500',1710,'3.000',40,43,30,21,20,10,0,0,1614,454,994,433,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.48','false',0,0),
(3106,27316,'Fallen Chieftain Vegus','Quest Monster','ketra_orc_warrior','12.00','24.00',55,'male','L2Monster','Fighter',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,273,360,261,278,0,253,161,0,0,36,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.54','false',1,0),
(3107,27317,'Restrainer of Glory','Quest Monster','kel_mahum_champion','13.00','32.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,399,780,382,278,0,253,161,0,0,50,180,'',0,'Local','',0,0,0,7,50,1,9,0,10,'0.56','false',1,0),
(3108,27318,'Wendy''s Guardian','Quest Monster','golem_guardian_090p','16.00','37.20',46,'male','L2Monster','Fighter',40,1943,'11.000',707,'2.100',40,43,30,21,20,10,2408,170,365,270,202,199,278,0,253,0,0,0,70,174,'',400,'Local','',0,0,0,7,50,1,9,0,0,'0.30','false',0,0),
(3109,27319,'Black Leopard','Quest Monster','onyx_beast','14.00','14.50',18,'male','L2Monster','Fighter',40,476,'3.500',287,'1.500',40,43,30,21,20,10,1012,51,88,98,37,94,278,400,253,0,0,0,30,145,'beast_clan',300,'Local','',0,0,0,7,30,4,4,0,10,'0.24','false',1,0),
(3110,27320,'Timora Orc','Quest Monster','batur_orc','9.00','21.50',20,'male','L2Monster','Fighter',40,541,'2.500',203,'1.200',40,43,30,21,20,10,565,25,53,90,21,73,278,0,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(3111,27321,'Bruin Lizardman','Quest Monster','virud_lizardman','10.00','23.00',20,'male','L2Monster','Fighter',40,541,'2.500',203,'1.200',40,43,30,21,20,10,565,25,53,90,21,73,278,0,253,291,0,0,43,130,'lizardman_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(3112,27322,'Picot Araneid','Quest Monster','giant_spider_50_bi','39.00','38.00',27,'male','L2Monster','Mystic',40,813,'1.750',318,'1.500',40,43,30,21,20,10,1453,74,104,106,45,102,278,500,253,0,0,0,72,130,'lizardman_clan',300,'Local','',0,0,0,7,50,1,9,0,10,'0.26','false',1,0),
(3113,30001,'Lector','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3114,30002,'Jackson','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3115,30003,'Silvia','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3116,30004,'Katerina','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3117,30005,'Wilford','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3118,30006,'Roxxy','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3119,30008,'Roien','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3120,30009,'Newbie Helper','','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3121,30010,'Auron','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3122,30014,'Celma','Master','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3123,30017,'Gallint','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3124,30019,'Newbie Helper','','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3125,30022,'Zigaunt','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3126,30026,'Bitz','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3127,30027,'Gwinter','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3128,30028,'Pintage','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3129,30029,'Minia','Master','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3130,30030,'Vivyan','Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3131,30031,'Biotin','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3132,30032,'Yohanes','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3133,30033,'Baulro','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3134,30034,'Iris','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3135,30035,'Harrys','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3136,30036,'Petron','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3137,30037,'Levian','High Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3138,30039,'Gilbert','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3139,30040,'Leon','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3140,30041,'Arnold','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3141,30042,'Abellos','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3142,30043,'Johnstone','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3143,30044,'Chiperan','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3144,30045,'Kenyos','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3145,30046,'Hanks','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3146,30047,'Firon','Wharf Manager','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3147,30048,'Darin','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3148,30049,'Bonnie','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3149,30050,'Elias','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3150,30051,'Cristel','','a_common_peopleA_FHuman','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3151,30054,'Rant','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3152,30055,'Rolfe','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3153,30057,'Aldo','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3154,30058,'Holvas','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3155,30059,'Trisha','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3156,30060,'Sabrin','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3157,30061,'Casey','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3158,30062,'Sonia','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3159,30063,'Lara','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3160,30064,'Terry','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3161,30065,'Arnelle','Master','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3162,30066,'Pabris','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3163,30067,'Glyvka','Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3164,30068,'Shegfield','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3165,30069,'Rollant','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3166,30070,'Sylvain','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3167,30071,'Lucas','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3168,30072,'Metty','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3169,30073,'Jacob','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3170,30074,'Harlan','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3171,30075,'Xaber','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3172,30076,'Liam','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3173,30078,'Pano','Grocer','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3174,30079,'Barder','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3175,30080,'Clarissa','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3176,30081,'Helvetia','Grocer','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3177,30082,'Denkus','Grocer','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3178,30083,'Pochi','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3179,30084,'Graham','Weapons Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3180,30085,'Stanford','Weapons Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3181,30086,'Taurin','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3182,30087,'Peta','Armor Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3183,30088,'Radia','Armor Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3184,30090,'Sandra','Jeweler','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3185,30091,'Ellie','Jeweler','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3186,30092,'Collob','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3187,30093,'Groot','Magic Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3188,30094,'Gentler','Magic Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3189,30095,'Randolf','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3190,30097,'Galladucci','Trader','a_traderA_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3191,30098,'Alexandria','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3192,30103,'Valkon','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3193,30104,'Parman','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3194,30105,'Genwitter','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3195,30106,'Dufner','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3196,30107,'Goldian','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3197,30108,'Macken','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3198,30109,'Hannavalt','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3199,30110,'Iker','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3200,30111,'Dieter','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3201,30112,'Maurius','Magister','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3202,30113,'Juris','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3203,30114,'Roa','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3204,30115,'Jurek','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3205,30116,'Dustin','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3206,30117,'Primos','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3207,30118,'Pupina','Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3208,30119,'Isabellin','Priestess','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3209,30120,'Maximilian','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3210,30121,'Jeronin','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3211,30122,'Bane','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3212,30123,'Vesa','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3213,30124,'Zerome','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3214,30125,'Belton','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3215,30126,'Rath','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3216,30128,'Atanas','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3217,30129,'Mitraell','Hierarch','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0);
INSERT INTO `npc` VALUES
(3218,30130,'Undrias','Abyssal Celebrant','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3219,30131,'Newbie Helper','','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3220,30132,'Cecktinon','Abyssal Celebrant','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3221,30133,'Kartia','Abyssal Celebrant','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3222,30134,'Jasmine','Gatekeeper','a_teleporter_FDarkElf','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3223,30135,'Iria','Trader','a_trader_Fdarkelf','8.00','24.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3224,30136,'Payne','Trader','a_trader_MDarkElf','8.00','22.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3225,30137,'Vollodos','Trader','a_trader_MDarkElf','8.00','22.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3226,30138,'Minaless','Trader','a_trader_Fdarkelf','8.00','24.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3227,30139,'Dorankus','Warehouse Keeper','a_trader_MDarkElf','8.00','22.50',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3228,30140,'Erviante','Warehouse Keeper','a_trader_MDarkElf','8.00','22.50',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3229,30141,'Talloth','Tetrarch','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3230,30143,'Trudy','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3231,30144,'Harne','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3232,30145,'Vlasty','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3233,30146,'Mirabel','Gatekeeper','a_common_people_FElf','8.00','25.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3234,30147,'Unoren','Trader','a_trader_MElf','8.00','25.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3235,30148,'Ariel','Trader','a_trader_FElf','8.00','24.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3236,30149,'Creamees','Trader','a_trader_MElf','8.00','25.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3237,30150,'Herbiel','Trader','a_trader_MElf','8.00','25.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3238,30151,'Chad','Warehouse Freightman','a_trader_MElf','8.00','25.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3239,30152,'Julia','Warehouse Keeper','a_common_people_FElf','8.00','25.50',70,'female','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3240,30153,'Markius','Warehouse Keeper','a_trader_MElf','8.00','25.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3241,30154,'Asterios','Hierarch','a_patriarch_MElf','8.00','22.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3242,30155,'Ellenia','Master','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3243,30156,'Cobendell','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3244,30157,'Greenis','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3245,30158,'Esrandell','Magister','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3246,30162,'Karin','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3247,30163,'Rex','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3248,30164,'Ian','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3249,30165,'Ralford','Trader','a_trader_FElf','8.00','24.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3250,30166,'Wesley','Magic Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3251,30169,'Marty','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3252,30170,'Radic','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3253,30171,'Galios','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3254,30174,'Arkenias','Grand Magister','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3255,30175,'Fairen','Grand Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3256,30176,'Valleria','Grand Magister','a_mageguild_master_FHuman','8.00','23.00',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3257,30177,'Valentina','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3258,30178,'Zenkin','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3259,30179,'Raudia','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3260,30180,'Sara','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3261,30181,'Galibredo','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3262,30182,'Cliff','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3263,30183,'Hagger','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3264,30184,'Rigol','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3265,30185,'Taniac Blackbird','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3266,30186,'Bhan','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3267,30187,'Klaus Blackbird','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3268,30188,'Vadin','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3269,30189,'Rovia','Magister','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3270,30190,'Phanovia','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3271,30191,'Hollint','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3272,30192,'Darya','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3273,30194,'Gideon','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3274,30195,'Brecson','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3275,30196,'Mouen','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3276,30197,'Hector','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3277,30198,'Jerin','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3278,30199,'Yates','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3279,30200,'Stan','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3280,30201,'Pinaps','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3281,30207,'Arodin','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3282,30208,'Damion','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3283,30209,'Colleen','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3284,30210,'Norman','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3285,30216,'Wheeler','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3286,30217,'Berros','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3287,30218,'Kendell','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3288,30219,'Veltress','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3289,30220,'Starden','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3290,30221,'Rayen','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3291,30222,'Alshupes','','a_common_people_MElf','6.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3292,30223,'Arujien','','a_trader_MElf','8.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3293,30224,'Rayla','Sentry Knight','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,79,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3294,30230,'Edroc','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3295,30231,'Garette','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3296,30232,'Sorint','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3297,30233,'Esmeralda','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3298,30253,'Simplon','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3299,30254,'Harmony','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3300,30255,'Haprock','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3301,30256,'Bella','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3302,30283,'Altran','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3303,30284,'Alberius','Sentinel Knight','a_guard_MElf','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,150,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3304,30285,'Gartrandell','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3305,30288,'Rains','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3306,30289,'Raymond','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3307,30290,'Xenos','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3308,30291,'Alex','Captain','a_guard_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,68,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3309,30293,'Manuel','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3310,30294,'Varan','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3311,30297,'Tobias','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3312,30298,'Pinter','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3313,30300,'Pushkin','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3314,30301,'Hally','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3315,30305,'Vellior','Tetrarch','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3316,30307,'Karrod','Blacksmith','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3317,30311,'Sir Collin Windawood','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3318,30312,'Rockswell','Lighthouse Keeper','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3319,30313,'Asha','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3320,30314,'Nestle','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3321,30315,'Poesia','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3322,30316,'Raut','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3323,30317,'Kluto','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3324,30320,'Richlin','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3325,30321,'Sydnia','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3326,30322,'Ballin','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3327,30325,'Audiberti','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3328,30326,'Leona','Master','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3329,30327,'Sorius','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3330,30328,'Reisa','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3331,30329,'Virgil','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3332,30330,'Sidra','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3333,30331,'Thoma','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3334,30332,'Bathis','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3335,30333,'Praga','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3336,30334,'Babenco','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3337,30335,'Brynn','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3338,30336,'Curtis','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3339,30337,'Moretti','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3340,30338,'Melville','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3341,30342,'Varsak','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3342,30344,'Rohmer','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3343,30345,'Ramoniell','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3344,30346,'Kayleen','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3345,30347,'Marion','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3346,30348,'Nelsya','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3347,30349,'Jenna','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3348,30350,'Carlon','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3349,30351,'Astaron','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3350,30352,'Karina','','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3351,30353,'Jughead','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3352,30354,'Jewel','','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3353,30355,'Roselyn','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3354,30356,'Altima','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3355,30357,'Kristin','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3356,30358,'Thifiell','Tetrarch','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3357,30359,'Kaitar','Tetrarch','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3358,30360,'Harant','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3359,30361,'Rizraell','','a_common_people_FElf','8.00','25.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3360,30362,'Andellia','','a_common_people_FElf','8.00','25.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3361,30363,'Aios','Blacksmith','a_trader_MElf','8.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3362,30368,'Lilith','','a_common_people_FElf','8.00','25.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3363,30369,'Baenedes','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3364,30370,'Nerupa','','aracne','15.00','26.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(3365,30371,'Thalia','','a_common_people_FElf','8.00','25.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3366,30373,'Ramos','Grand Master','a_fighterguild_master_Mhuman_old','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3367,30374,'Rhodiell','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3368,30375,'Adonius','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3369,30376,'Nell','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3370,30377,'Talbot','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3371,30378,'Estella','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3372,30379,'Bezique','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,280,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3373,30380,'Plink','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3374,30381,'Alvah','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3375,30382,'Leikan','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3376,30383,'Scott','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3377,30384,'Linus','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3378,30385,'Weisz','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3379,30386,'Luis','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3380,30387,'Clancy','Wharf Manager','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3381,30391,'Parina','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3382,30400,'Newbie Helper','','a_guard_MElf','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3383,30401,'Newbie Helper','','a_guard_MElf','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3384,30402,'Newbie Helper','','a_guard_MElf','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3385,30403,'Newbie Helper','','a_guard_MElf','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3386,30404,'Newbie Helper','','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3387,30405,'Marius','','a_trader_MElf','8.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0);
INSERT INTO `npc` VALUES
(3388,30406,'Matheo','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3389,30407,'Mesella','','a_common_peopleA_FHuman','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3390,30408,'Lionel','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3391,30409,'Earth Snake','','lesser_basilisk','34.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,35,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(3392,30410,'Wasteland Lizardman','','virud_lizardman','10.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,43,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(3393,30411,'Flame Salamander','','salamander','16.00','6.80',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,96,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.20','false',1,0),
(3394,30412,'Wind Sylph','','sylph','11.00','35.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,60,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(3395,30413,'Water Undine','','undine','12.00','27.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,60,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',1,0),
(3396,30414,'Rosella','','a_common_people_FElf','8.00','25.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3397,30415,'Charkeren','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3398,30416,'Triskel','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3399,30417,'Sir Klaus Vasper','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3400,30418,'Annika','','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3401,30419,'Arkenia','Witch','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3402,30420,'Tyra','','a_trader_Fdarkelf','8.00','24.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3403,30421,'Varika','Witch','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3404,30422,'Kalinta','Abyssal Celebrant','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3405,30423,'Northwind','','a_trader_MElf','8.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3406,30424,'Allana','','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3407,30425,'Neti','','a_common_peopleA_FHuman','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3408,30426,'Prias','','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3409,30427,'Siff','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3410,30428,'Perrin','','a_casino_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3411,30429,'Tiramisa','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3412,30430,'Trionell','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3413,30431,'Eriel','Sentinel','a_guard_MElf','8.00','23.50',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,130,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3414,30432,'Irene','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3415,30433,'Kathaway','Sentry','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,132,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3416,30434,'Samed','','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3417,30435,'Leopold','','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3418,30436,'Sarien','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3419,30437,'Rolento','Trader','a_traderA_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3420,30452,'Kurt','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3421,30458,'Poitan','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3422,30459,'Wandius','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3423,30460,'Cardien','Master','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3424,30461,'Mirien','Magister','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3425,30462,'Tronix','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3426,30463,'Ixia','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3427,30464,'Clayton','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3428,30465,'Herven','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3429,30466,'Bright','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3430,30469,'Jonas','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3431,30471,'Rupio','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3432,30472,'Rosheria','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3433,30473,'Bandellos','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3434,30474,'Angus','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3435,30475,'Stapin','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3436,30476,'Kaira','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3437,30477,'Sir Ortho Lancer','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3438,30478,'Reikin','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3439,30483,'Mozella','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3440,30484,'Ponti','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3441,30485,'Capella','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3442,30486,'Hanna','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3443,30487,'Penelope','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3444,30497,'Edmond','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3445,30498,'Moke','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3446,30499,'Tapoy','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3447,30500,'Osborn','High Prefect','e_guard_MOrc','8.00','27.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3448,30501,'Kasman','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3449,30502,'Umos','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3450,30503,'Rikadio','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3451,30504,'Mendio','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3452,30505,'Drikus','High Prefect','e_guard_MOrc','8.00','27.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3453,30506,'Buka','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3454,30507,'Racoy','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3455,30508,'Castor','High Prefect','e_guard_MOrc','8.00','27.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3456,30509,'Dowki','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3457,30510,'Somak','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3458,30511,'Gesto','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3459,30512,'Kusto','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3460,30513,'Penatus','High Prefect','e_guard_MOrc','8.00','27.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3461,30514,'Vokian','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3462,30515,'Manakia','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3463,30516,'Reep','Trader','a_traderA_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3464,30517,'Shari','Trader','e_traderA_FDwarf','8.00','19.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3465,30518,'Garita','Trader','a_traderA_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3466,30519,'Mion','Trader','e_traderA_FDwarf','8.00','19.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3467,30520,'Reed','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3468,30521,'Murdoc','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3469,30522,'Airy','Warehouse Keeper','e_traderA_FDwarf','8.00','19.00',70,'female','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3470,30523,'Gouph','Collector','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3471,30524,'Pippi','Collector','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3472,30525,'Bronk','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3473,30526,'Brunon','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3474,30527,'Silvera','Blacksmith','e_smith_Fdwarf','8.00','17.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3475,30528,'Laferon','Foreman','e_guard_MDwarf','8.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3476,30529,'Maron','Miner','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3477,30530,'Newbie Helper','','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3478,30531,'Lockirin','Iron Gate''s','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3479,30532,'Spiron','Golden Wheel''s','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3480,30533,'Balanki','Silver Scale''s','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3481,30534,'Keef','Bronze Key''s','e_collector_master_MDwarf','8.00','18.40',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3482,30535,'Filaur','Gray Pillar Member','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3483,30536,'Arin','Black Anvil''s','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3484,30537,'Daichir','Priest of the Earth','e_clergyman_MDwarf','8.00','17.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3485,30538,'Zimenf','Priest of the Earth','e_clergyman_MDwarf','8.00','17.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3486,30539,'Chichirin','Priestess of the Earth','e_traderA_FDwarf','8.00','19.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3487,30540,'Wirphy','Gatekeeper','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3488,30541,'Paion','Protector','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,282,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3489,30542,'Runant','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3490,30543,'Ethan','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3491,30544,'Cromwell','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3492,30545,'Proton','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3493,30546,'Dinkey','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3494,30547,'Tardyon','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3495,30548,'Nathan','Defender','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,296,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3496,30549,'Ghouliff Droopstone','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3497,30550,'Gauri Twinklerock','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3498,30551,'Tink Wandergold','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3499,30552,'Kiril Sparkystone','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3500,30553,'Maryse Redbonnet','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3501,30554,'Bolter','Miner','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3502,30555,'Torocco','Carrier','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3503,30556,'Toma','Master','e_collector_master_MDwarf','8.00','18.40',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3504,30557,'Torai','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3505,30558,'Jakal','Trader','e_trader_MOrc','8.00','23.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3506,30559,'Kunai','Trader','e_trader_FOrc','8.00','24.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3507,30560,'Uska','Trader','e_trader_MOrc','8.00','23.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3508,30561,'Papuma','Trader','e_trader_MOrc','8.00','23.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3509,30562,'Grookin','Warehouse Keeper','e_trader_MOrc','8.00','23.50',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3510,30563,'Imantu','Warehouse Freightman','e_trader_MOrc','8.00','23.50',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3511,30564,'Sumari','Blacksmith','e_trader_MOrc','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3512,30565,'Kakai','Flame Lord','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3513,30566,'Varkees','Atuba Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,81,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3514,30567,'Tantus','Neruga Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,175,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3515,30568,'Hatos','Urutu Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3516,30569,'Brukurse','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3517,30570,'Karukia','Prefect','e_trader_FOrc','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3518,30571,'Tanapi','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3519,30572,'Livina','Seer','e_clergyman_FOrc','6.50','28.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3520,30573,'Vulkus','Flame Guardian','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3521,30575,'Newbie Helper','','e_clergyman_FOrc','6.50','28.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3522,30576,'Tamil','Gatekeeper','e_teleporter_FOrc','8.00','32.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3523,30577,'Rukain','Praetorian','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,279,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3524,30578,'Nakusin','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3525,30579,'Tamai','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','Guard',1100,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3526,30580,'Parugon','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3527,30581,'Orinak','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3528,30582,'Tiku','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3529,30583,'Petukai','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3530,30584,'Vapook','Centurion','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,91,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3531,30585,'Tataru Zu Hestui','','e_common_people_MOrc','8.00','26.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3532,30586,'Anai Zu Neruga','','e_trader_FOrc','8.00','24.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3533,30587,'Gantaki Zu Urutu','','e_common_people_MOrc','8.00','26.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3534,30588,'Takia Zu Duda-Mara','','e_trader_FOrc','8.00','24.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3535,30589,'Kazkin Zu Gandi','','e_trader_MOrc','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3536,30590,'Rosheek','Khavatari','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3537,30591,'Toruku','Khavatari','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3538,30592,'Hestui Totem Spirit','','grizzly','21.00','40.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(3539,30593,'Duda-Mara Totem Spirit','','giant_spider','26.00','26.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,72,130,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','false',1,0),
(3540,30594,'Ranspo','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3541,30595,'Opix','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3542,30596,'Harkel','Partisan Doorman','ol_mahum','13.50','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(3543,30597,'Piotur','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3544,30598,'Newbie Guide','','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3545,30599,'Newbie Guide','','a_guard_MElf','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3546,30600,'Newbie Guide','','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3547,30601,'Newbie Guide','','e_guard_MDwarf','8.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3548,30602,'Newbie Guide','','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3549,30608,'Maria','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3550,30609,'Creta','Astrologer','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3551,30610,'Cronos','Elder','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3552,30611,'Triff','Drunkard','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3553,30612,'Casian','Elder','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3554,30613,'Alders Spirit','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(3555,30614,'Metheus','Brother','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3556,30615,'Voltar','Breka Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,173,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',1,0),
(3557,30616,'Kepra','Enku Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,162,0,0,45,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.76','false',1,0),
(3558,30617,'Burai','Turek Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,172,0,0,45,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','false',1,0);
INSERT INTO `npc` VALUES
(3559,30618,'Harak','Leunt Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,172,0,0,45,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(3560,30619,'Driko','Vuku Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,183,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',1,0),
(3561,30620,'Emily','','a_common_peopleA_FHuman','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3562,30621,'Nikola','Maestro','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3563,30622,'Box Of Titan','','coffer_b','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3564,30623,'Kaien','Duelist','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,135,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3565,30624,'Ascalon','Veteran','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,16,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3566,30625,'Mason','','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3567,30626,'Hamil','Sagittarius','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3568,30627,'Tree','','human_tree','35.00','90.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3569,30628,'Strong Wooden Chest','','box','18.00','14.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3570,30629,'Rukal','Bard','a_common_people_MElf','6.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3571,30630,'Orim','Shadow','a_hardins_pupil_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3572,30631,'Roderik','Warden','a_guard_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3573,30632,'Endrigo','Warden','a_guard_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3574,30633,'Evert','Fisher','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3575,30634,'Galatea','High Summoner','a_mageguild_master_FHuman','8.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3576,30635,'Almors','Summoner','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3577,30636,'Camoniell','Summoner','a_trader_FElf','8.00','24.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3578,30637,'Belthus','Summoner','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3579,30638,'Basilla','Summoner','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3580,30639,'Celestiel','Summoner','a_patriarch_MElf','8.00','22.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3581,30640,'Brynthea','Summoner','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3582,30641,'Takuna','Duda-Mara Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3583,30642,'Chianta','Gandi Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,175,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3584,30643,'First Orc','','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3585,30644,'Kash','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3586,30645,'Martien','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3587,30646,'Raldo','Champion','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3588,30647,'Chest Of Shyslassys','','coffer_c','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3589,30648,'Santiago','Hermit','a_traderA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3590,30649,'Ancestor Martankus','','orc_head','110.00','103.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3591,30650,'Gerald','Priest of the Earth','e_traderA_FDwarf','8.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3592,30651,'Dorf','Wanderer','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3593,30652,'Uruha','','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3594,30653,'Sir Aron Tanford','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3595,30654,'Sir Kiel Nighthawk','','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,74,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3596,30655,'Isael Silvershadow','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3597,30656,'Spirit Of Sir Talianus','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(3598,30657,'Seresin','Cardinal','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3599,30658,'Gupu','Father','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3600,30659,'Orphan Girl','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3601,30660,'Windy Shaoring','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3602,30661,'Mysterious Dark Elf','','a_casino_FDarkElf','8.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3603,30662,'Piper Longbow','','a_common_people_FElf','8.00','25.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3604,30663,'Slein Shining Blade','','a_guard_MElf','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,69,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3605,30664,'Kein Flying Knife','','a_guard_MElf','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,217,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3606,30665,'Kristina','Saint','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3607,30666,'Sla','Preacher','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3608,30667,'Ramus','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3609,30668,'Katari','','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3610,30669,'Kakan','','e_trader_FOrc','8.00','24.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3611,30670,'Nyakuri','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3612,30671,'Croto','Chief','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3613,30672,'Dubabah','Jailer','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3614,30673,'Lorain','Researcher','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3615,30674,'Daurin Hammercrush','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3616,30675,'Corpse Of Kamur','','e_trader_Morc_death','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3617,30676,'Croop','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3618,30677,'Flutter','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3619,30678,'Helton','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3620,30679,'Roameria','Master','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3621,30680,'Egnos','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3622,30681,'Karia','High Prefect','e_trader_FOrc','8.00','24.00',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3623,30682,'Pekiron','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3624,30683,'Daunt','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3625,30684,'Viktor','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3626,30685,'Baxt','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3627,30686,'Silva','Warehouse Freightman','e_traderA_FDwarf','8.00','19.00',70,'female','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3628,30687,'Vergara','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3629,30688,'Duning','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3630,30689,'Siria','Grand Master','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3631,30690,'Luther','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3632,30691,'Aren Athebalt','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3633,30692,'Stedmiel','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3634,30693,'Queenien','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3635,30694,'Scraide','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3636,30695,'Moses','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3637,30696,'Page','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3638,30697,'Videlrien','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3639,30698,'Evelyn','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3640,30699,'Medown','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3641,30700,'Prestan','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3642,30701,'Errickin','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3643,30702,'Bernard','Guild President','a_casino_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3644,30703,'Colin','Guild President','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3645,30704,'Garvarentz','High Prefect','e_guard_MOrc','8.00','27.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3646,30705,'Chakiris','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3647,30706,'Lazenby','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3648,30707,'Raigen','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3649,30708,'Nasign','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3650,30709,'Norton','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3651,30710,'Weston','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3652,30711,'Byron','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3653,30712,'Makhis','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3654,30713,'Gardner','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3655,30714,'Paros','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3656,30715,'Marina','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3657,30716,'Cecile','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3658,30717,'Gauen','Magister','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3659,30718,'Joan','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3660,30719,'Mariell','Gatekeeper','a_common_people_FElf','8.00','25.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3661,30720,'Kaiena','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3662,30721,'Ladd','Magister','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3663,30722,'Merian','Gatekeeper','a_teleporter_FDarkElf','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3664,30723,'Roy','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3665,30724,'Tavillian','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3666,30725,'Yening','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3667,30726,'Tebose','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3668,30727,'Verona','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3669,30728,'Leirynn','Militiaman','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,93,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3670,30729,'Borys','Drunkard','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3671,30730,'Jax','Bodyguard','a_guard_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,232,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3672,30731,'Martin','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3673,30732,'Ol Mahum Pilgrim','','ol_mahum','13.50','25.00',36,'male','L2Npc','npc',40,1279,'4.500',463,'1.800',40,43,30,21,20,10,0,0,206,175,96,142,278,0,253,1,0,0,50,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','false',0,0),
(3674,30733,'Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3675,30734,'Supply Box On Wharf','','box','18.00','14.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3676,30735,'Sophya','Mercenary Captain','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3677,30736,'Redfoot','Mercenary','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3678,30737,'Morgan','Guildsman','a_traderA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3679,30738,'Matild','Alchemist','e_traderA_FDwarf','8.00','19.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3680,30739,'Keltir','Royal Servant','fox','9.50','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,23,110,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(3681,30740,'Toad','Royal Servant','poison_toad','20.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,100,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(3682,30741,'Rabbit','Royal Servant','rabbit','5.00','4.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3683,30742,'Rupina','Fairy of Love','pixy','5.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(3684,30743,'Wisdom Chest','','coffer_c','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3685,30744,'Grey','Guild Member','a_traderA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3686,30745,'Tor','Guild Member','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3687,30746,'Cybellin','','a_teleporter_FDarkElf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3688,30747,'Mimyu','Fairy','pixy','5.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.72','false',1,0),
(3689,30748,'Exarion','Drake','drake','30.00','100.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','false',1,0),
(3690,30749,'Zwov','Drake','drake','30.00','100.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','false',1,0),
(3691,30750,'Kalibran','Drake','drake','30.00','100.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.84','false',1,0),
(3692,30751,'Suzet','Wyrm','wyrm','29.00','72.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.19','false',1,0),
(3693,30752,'Shamhai','Wyrm','wyrm','29.00','72.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,70,70,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.19','false',1,0),
(3694,30753,'Gabrielle','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3695,30754,'Gilmore','Antharas Watchman','skeleton_knight','10.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,150,0,0,40,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(3696,30755,'Theodric','Antharas Watchman','skeleton_knight','10.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,127,0,0,40,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(3697,30756,'Sir Kristof Rodemai','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3698,30757,'Statue Of Offering','','castle_kent_statue_jewel','25.00','98.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3699,30758,'Athrea','Witch','a_hardins_pupil_FHuman','8.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3700,30759,'Kalis','Witch','a_hardins_pupil_FHuman','8.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3701,30760,'Sir Gustav Athebaldt','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3702,30761,'Corpse Of Fritz','','e_guard_MDwarf_death','13.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3703,30762,'Corpse Of Lutz','','e_guard_MDwarf_death','13.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3704,30763,'Corpse Of Kurtz','','e_guard_MDwarf_death','13.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3705,30764,'Balthazar','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3706,30765,'Imperial Coffer','','coffer_d','12.00','9.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3707,30766,'Cleo','Witch','a_hardins_pupil_FHuman','8.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3708,30767,'Auctioneer','','a_maidB_FHuman','8.00','22.50',70,'female','L2Auctioneer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3709,30768,'Auctioneer','','a_trader_FElf','8.00','24.00',70,'female','L2Auctioneer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3710,30769,'Auctioneer','','a_maidB_FHuman','8.00','21.50',70,'female','L2Auctioneer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3711,30770,'Auctioneer','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Auctioneer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3712,30771,'Auctioneer','','e_trader_FOrc','8.00','24.00',70,'female','L2Auctioneer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3713,30772,'Wilson','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3714,30773,'Todd','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3715,30827,'Lundy','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3716,30828,'Waters','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3717,30829,'Cooper','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3718,30830,'Joey','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3719,30831,'Nelson','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3720,30832,'Hardin','','a_hardin_MHuman','8.00','22.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3721,30833,'Kaspar','Magister','a_hardins_pupil_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3722,30834,'Cema','Magic Trader','a_hardins_pupil_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3723,30835,'Icarus','Lich King','liviona','12.00','40.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,212,0,0,70,15,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(3724,30836,'Minerva','Gatekeeper','a_teleporter_FDarkElf','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3725,30837,'Woodrow','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3726,30838,'Woodley','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3727,30839,'Holly','Trader','a_traderA_FHuman','8.00','23.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3728,30840,'Lorenzo','Trader','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3729,30841,'Carson','Trader','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3730,30842,'Alexis','Trader','a_trader_FElf','8.00','24.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0);
INSERT INTO `npc` VALUES
(3731,30843,'Romp','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3732,30844,'Walderal','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3733,30845,'Klump','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3734,30846,'Wilbert','Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3735,30847,'Ferris','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3736,30848,'Elisa','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3737,30849,'Sedrick','Grand Master','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3738,30850,'Aiken','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3739,30851,'Kendra','Master','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3740,30852,'Sinden','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3741,30853,'Raien','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3742,30854,'Drikiyan','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3743,30855,'Desmond','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3744,30856,'Winonin','Magister','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3745,30857,'Orven','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3746,30858,'Ross','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3747,30859,'Vivyan','Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3748,30860,'Flownia','Priestess','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3749,30861,'Leonard','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3750,30862,'Oltlin','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3751,30863,'Ghest','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3752,30864,'Hanellin','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3753,30865,'Ladanza','High Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3754,30866,'Marestella','Prefect','e_trader_FOrc','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3755,30867,'Reva','Seer','e_trader_MOrc','8.00','23.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3756,30868,'Sir Eric Rodemai','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3757,30869,'Lemper','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3758,30870,'Kurtiz','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3759,30871,'Bret','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3760,30872,'Conroy','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3761,30873,'Coleman','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3762,30874,'Aldis','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3763,30875,'Carlton','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3764,30876,'Eastan','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3765,30877,'Grayson','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3766,30878,'Angelina','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3767,30879,'Felton','Wharf Manager','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3768,30880,'Viktor Van Dake','Border Outpost Captain','a_royal_guardA_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,5817,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3769,30881,'Sanders','Border Outpost Aide','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3770,30882,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,5817,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3771,30883,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(3772,30884,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3773,30885,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,5817,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(3774,30886,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,5817,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3775,30887,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(3776,30888,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,5817,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3777,30889,'Frontier Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,5817,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,14,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(3778,30890,'Espen','Trader','a_trader_MElf','8.00','25.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3779,30891,'Verona','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3780,30892,'Enverun','Trader','a_traderA_MHuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3781,30893,'Payel','Trader','a_trader_FElf','8.00','24.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3782,30894,'Natools','Warehouse Chief','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3783,30895,'Kluck','Warehouse Freightman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3784,30896,'Mia','Warehouse Keeper','e_traderA_FDwarf','8.00','19.00',70,'female','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3785,30897,'Roman','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3786,30898,'Morning','Blacksmith','e_smith_Fdwarf','8.00','17.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3787,30899,'Flauen','Gatekeeper','a_common_people_FElf','8.00','25.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3788,30900,'Marcus','Grand Master','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3789,30901,'Arti','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3790,30902,'Karuna','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3791,30903,'Traus','Master','a_guard_MElf','8.00','23.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3792,30904,'Naiel','Master','a_common_people_FElf','8.00','25.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3793,30905,'Squillari','High Priest','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3794,30906,'Ranton','Priest','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3795,30907,'Minevia','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3796,30908,'Tanios','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3797,30909,'Anabel','Magister','a_trader_FElf','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3798,30910,'Xairakin','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3799,30911,'Brikus','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3800,30912,'Xenovia','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3801,30913,'Tushku','High Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3802,30914,'Sorbo','Prefect','e_trader_FOrc','8.00','24.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3803,30915,'Takina','Seer','e_mageguild_teacher_FOrc','8.00','28.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3804,30916,'Gosta','Captain','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,129,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3805,30917,'Dupuis','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3806,30918,'Kent','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3807,30919,'Rodic','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3808,30920,'Kraisen','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3809,30921,'Timos','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3810,30922,'Cage','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,102,0,50,160,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3811,30923,'Dunst','Guard','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3812,30924,'Nedy','Wharf Manager','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3813,30925,'Morelyn','High Priestess','a_trader_FElf','8.00','24.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3814,30926,'Restina','Priestess','a_trader_FElf','8.00','24.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3815,30927,'Alicia','Priestess','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3816,30928,'Fenster','Mercenary','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3817,30929,'Patrin','Antique Dealer','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3818,30930,'Rogent','Antique Appraiser','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3819,30931,'Bentley','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3820,30932,'Benica','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3821,30933,'Braki','','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3822,30934,'Marsha','Collector','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3823,30935,'Trumpin','Collector','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3824,30936,'Malcom1','Frog Prince','poison_toad','20.00','10.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','true',0,0),
(3825,30937,'Malcom2','Wild Boar Prince','giant_wild_hog','25.00','27.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,35,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','true',0,0),
(3826,30938,'Malcom3','Orc Prince','ketra_orc','12.00','29.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,45,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.46','true',0,0),
(3827,30939,'Malcom4','Prince of Darkness','skeleton_royal_guard','11.00','28.50',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','true',0,0),
(3828,30940,'Malcom5','Gremlin Prince','gremlin','10.00','15.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,20,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(3829,30941,'Malcom6','Prince of Wild Beast','saber_toothed_tiger','34.00','28.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','true',0,0),
(3830,30942,'Malcom7','Monster Eye Prince','monster_eye','21.00','43.00',70,'male','L2Monster','Mystic',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','true',0,0),
(3831,30943,'Malcom8','Rabbit Prince','rabbit','5.00','4.50',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','true',0,0),
(3832,30944,'Malcom9','Human Prince','a_casino_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3833,30945,'Malcom10','Prince','e_collector_master_MDwarf','8.00','18.40',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3834,30946,'Lucianne Tanford','','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3835,30947,'Rerikya','','e_trader_FOrc','8.00','24.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3836,30948,'Meridien','','a_common_people_FElf','8.00','25.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3837,30949,'Keplon','Researcher','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3838,30950,'Euclie','Researcher','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3839,30951,'Pithgon','Researcher','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3840,30952,'Dimensional Vortex 1','','broadcasting_tower','13.00','54.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3841,30953,'Dimensional Vortex 2','','broadcasting_tower','13.00','54.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3842,30954,'Dimensional Vortex 3','','broadcasting_tower','13.00','54.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3843,30955,'Gillian''s Revenant','','zombie','13.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,15,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(3844,30956,'Nanarin','Musician','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,325,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3845,30957,'Swan','Bard','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3846,30958,'Galion','','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3847,30959,'Barbado','Musician','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5133,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3848,30960,'Beer Chest','','box','18.00','14.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3849,30961,'Cloth Chest','','coffer_d','12.00','9.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3850,30962,'Statue of Water','','coffer_d','12.00','9.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3851,30963,'Statue of Fire','','coffer_d','12.00','9.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3852,30964,'Statue of Wind','','coffer_d','12.00','9.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3853,30965,'Statue of Earth','','coffer_d','12.00','9.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3854,30966,'Statue of Darkness','','coffer_d','12.00','9.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3855,30967,'Statue of Light','','coffer_d','12.00','9.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3856,30968,'Jennifer','Lady Orc','e_trader_FOrc','8.00','24.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3857,30969,'Iason Heine','','a_chamberlain_MHuman','9.50','22.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3858,30970,'Dorothy','Locksmith','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3859,30971,'Orpheus','Mad Doctor','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3860,30972,'Orpheus Resurrecter','','susceptor','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(3861,30973,'Medium Jar','','pot','10.00','15.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3862,30974,'Oliver','Resurrected Adventurer','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3863,30975,'Clarine','Resurrected Adventurer','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3864,30976,'Resurrected Town Maiden','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3865,30977,'Holy Ark of Secrecy1','','coffer_a','12.00','9.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3866,30978,'Holy Ark of Secrecy2','','coffer_b','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3867,30979,'Holy Ark of Secrecy3','','coffer_c','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3868,30980,'Ark Guardian''s Corpse','','angel_death','25.00','36.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3869,30981,'Black Judge','','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3870,30982,'Sleeping Ant Larva1','','ant_larva','12.00','8.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(3871,30983,'Sleeping Ant Larva2','','ant_larva','12.00','8.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(3872,30984,'Sleeping Ant Larva3','','ant_larva','12.00','8.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(3873,30985,'Sleeping Ant Larva4','','ant_larva','12.00','8.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(3874,30986,'Sleeping Ant Larva5','','ant_larva','12.00','8.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(3875,30987,'Sleeping Ant Larva6','','ant_larva','12.00','8.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(3876,30988,'Verce','Leathersmith','a_patriarch_MElf','8.00','22.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3877,30989,'Chest of Bifrons','','coffer_c','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3878,30990,'Lottery Ticket Seller','','a_casino_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3879,30991,'Lottery Ticket Seller','','a_trader_MElf','8.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3880,30992,'Lottery Ticket Seller','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3881,30993,'Lottery Ticket Seller','','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3882,30994,'Lottery Ticket Seller','','e_trader_MOrc','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3883,30995,'Race Manager','','e_teleporter_FDwarf','8.00','21.30',70,'female','L2RaceManager','RaceManager',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3884,31001,'Claudia Athebalt','','a_mageguild_master_FHuman','8.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3885,31002,'Reorin','Maestro','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3886,31003,'Here I Come','','cat_the_cat','9.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(3887,31004,'Half Moon Love','','cutie_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(3888,31005,'Everlasting','','mechanic_golem','5.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(3889,31006,'Dark Side of the Moon','','silhouette','8.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(3890,31007,'Wind Rider','','unicorn_boxer','11.00','18.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(3891,31008,'Shooting Star','','unicorn_mirage','13.00','17.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(3892,31009,'Cyclone Thunder','','dark_fencer','7.00','13.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,25,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.20','false',0,0),
(3893,31010,'Hungry Baby','','hatchling','9.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.27','false',0,0),
(3894,31011,'Salty Dog','','pet_wolf','13.00','11.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(3895,31012,'Raging Revolution','','silver_cat','7.00','15.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(3896,31013,'Valentine Blue','','blue_eye','11.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(3897,31014,'Light My Fire','','big_boom','6.00','13.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3898,31015,'Red Bullet','','fox','9.50','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,23,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(3899,31016,'Shining Silver','','rabbit','5.00','4.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3900,31017,'Over the top','','ant_larva','12.00','8.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',0,0),
(3901,31018,'Royal Straight','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(3902,31019,'All Seven','','wererat','14.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0);
INSERT INTO `npc` VALUES
(3903,31020,'Nasty Green','','dryad','9.00','20.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(3904,31021,'Shortcut','','goblin','10.00','16.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.32','false',0,0),
(3905,31022,'Typhoon Tiger','','giant_bee','8.00','24.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',0,0),
(3906,31023,'Red Hot','','salamander','16.00','6.80',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.20','false',0,0),
(3907,31024,'Galaxy Express','','onyx_beast','14.00','14.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.24','false',0,0),
(3908,31025,'Best Condition','','manadragora','14.00','17.80',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',0,0),
(3909,31026,'Albatross','','orc','10.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,45,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(3910,31027,'Coffer of the Dead','','coffer_b','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3911,31028,'Chest of Kernon','','coffer_c','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3912,31029,'Chest of Golkonda','','coffer_c','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3913,31030,'Chest of Hallate','','coffer_c','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3914,31031,'Broadcasting Tower','','broadcasting_tower','13.00','54.00',70,'etc','L2Observation','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3915,31032,'Guard','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','GuardRndWalkAndAnim',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3916,31033,'Sentinel','','a_guard_MElf','8.00','23.50',80,'male','L2Guard','GuardRndWalkAndAnim',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,276,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3917,31034,'Sentry','','a_guard_FDarkelf','8.00','25.00',80,'female','L2Guard','GuardRndWalkAndAnim',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,277,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3918,31035,'Defender','','e_guard_MDwarf','8.00','19.00',80,'male','L2Guard','GuardRndWalkAndAnim',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3919,31036,'Centurion','','e_guard_MOrc','8.00','27.00',80,'male','L2Guard','GuardRndWalkAndAnim',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,273,0,0,50,160,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(3920,31042,'Kantabilon','Melody Maestro','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3921,31043,'Octavia','Melody Maestro','e_traderA_FDwarf','8.00','19.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3922,31044,'Galman','Valley Trader','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3923,31045,'Kitzka','Valley Trader','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3924,31046,'Marsden','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3925,31047,'Kell','Symbol Maker','a_mageguild_teacher_FHuman','8.00','23.50',70,'male','L2SymbolMaker','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3926,31048,'McDermott','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3927,31049,'Pepper','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3928,31050,'Thora','Symbol Maker','a_mageguild_teacher_FHuman','8.00','23.50',70,'male','L2SymbolMaker','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3929,31051,'Keach','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3930,31052,'Heid','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3931,31053,'Kidder','Symbol Maker','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2SymbolMaker','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3932,31067,'Rood','Pet Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3933,31074,'Corpse of Hutaku','','e_trader_Morc_death','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3934,31075,'Sales Cat of Ivory Tower','','cat_the_cat','9.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(3935,31076,'Newbie Guide','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3936,31077,'Newbie Guide','','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3937,31078,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3938,31079,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3939,31080,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3940,31081,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3941,31082,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3942,31083,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3943,31084,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3944,31085,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3945,31086,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3946,31087,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3947,31088,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3948,31089,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3949,31090,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3950,31091,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3951,31092,'Black Marketeer of Mammon','','black_market_trader_MDwarf','8.00','18.00',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3952,31093,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(3953,31094,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(3954,31095,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3955,31096,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3956,31097,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3957,31098,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3958,31099,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3959,31100,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3960,31101,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3961,31102,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3962,31103,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3963,31104,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3964,31105,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3965,31106,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3966,31107,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3967,31108,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3968,31109,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3969,31110,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3970,31111,'Gatekeeper Spirit','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3971,31112,'Gatekeeper Spirit','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3972,31113,'Merchant of Mammon','','black_market_trader_MDwarf_set','22.00','18.00',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3973,31114,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3974,31115,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3975,31116,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3976,31117,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3977,31118,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3978,31119,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3979,31120,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3980,31121,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3981,31122,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3982,31123,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3983,31124,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3984,31125,'Gatekeeper Ziggurat','','teleport_npc_sm','7.00','15.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(3985,31126,'Blacksmith of Mammon','','e_smith_master_MDwarf','8.00','17.00',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3986,31127,'Festival Guide','Level 31 and Below','priest_of_dawn','8.00','30.50',70,'male','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3987,31128,'Festival Guide','Level 42 and Below','priest_of_dawn','8.00','30.50',70,'male','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3988,31129,'Festival Guide','Level 53 and Below','priest_of_dawn','8.00','30.50',70,'male','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3989,31130,'Festival Guide','Level 64 and Below','priest_of_dawn','8.00','30.50',70,'male','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3990,31131,'Festival Guide','No Level Limit','priest_of_dawn','8.00','30.50',70,'male','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3991,31132,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3992,31133,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3993,31134,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3994,31135,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3995,31136,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(3996,31137,'Festival Guide','Level 31 and Below','priest_of_dusk','8.00','22.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3997,31138,'Festival Guide','Level 42 and Below','priest_of_dusk','8.00','22.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3998,31139,'Festival Guide','Level 53 and Below','priest_of_dusk','8.00','22.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(3999,31140,'Festival Guide','Level 64 and Below','priest_of_dusk','8.00','22.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4000,31141,'Festival Guide','No Level Limit','priest_of_dusk','8.00','22.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4001,31142,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4002,31143,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3889,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4003,31144,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4004,31145,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4005,31146,'Festival Witch','','a_guard_FDarkelf','8.00','25.00',70,'female','L2FestivalGuide','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4006,31147,'Sobling','Head Researcher','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4007,31148,'Pirate''s Chest','','coffer_c','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4008,31149,'Alchemist''s Mixing Urn','','pot','10.00','15.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4009,31168,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4010,31169,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4011,31170,'Crest of Dawn','','flag_ssq','0.01','0.01',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4012,31171,'Crest of Dusk','','flag_ssq','0.01','0.01',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4013,31172,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4014,31173,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4015,31174,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4016,31175,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4017,31176,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4018,31177,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4019,31178,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4020,31179,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4021,31180,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4022,31181,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4023,31182,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4024,31183,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4025,31184,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4026,31185,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4027,31186,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4028,31187,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4029,31188,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4030,31189,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4031,31190,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4032,31191,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4033,31192,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4034,31193,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4035,31194,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4036,31195,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4037,31196,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4038,31197,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4039,31198,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4040,31199,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4041,31200,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4042,31201,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4043,31202,'Maximus','','pet_wolf','13.00','11.50',70,'male','L2Npc','RndWalkAndAnim',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(4044,31203,'Moon Dancer','','pet_wolf','13.00','11.50',70,'male','L2Npc','RndWalkAndAnim',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(4045,31204,'Georgio','','pet_wolf','13.00','11.50',70,'male','L2Npc','RndWalkAndAnim',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(4046,31205,'Katz','','hatchling','9.00','10.00',70,'male','L2Npc','RndWalkAndAnim',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.27','false',1,0),
(4047,31206,'Ten Ten','','hatchling','9.00','10.00',70,'male','L2Npc','RndWalkAndAnim',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.27','false',1,0),
(4048,31207,'Sardinia','','hatchling','9.00','10.00',70,'male','L2Npc','RndWalkAndAnim',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.27','false',1,0),
(4049,31208,'La Grange','','hatchling','9.00','10.00',70,'male','L2Npc','RndWalkAndAnim',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.27','false',1,0),
(4050,31209,'Misty Rain','','pet_wolf','13.00','11.50',70,'male','L2Npc','RndWalkAndAnim',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(4051,31210,'Race Track Gatekeeper','','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4052,31211,'Race Track Guide','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4053,31212,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4054,31213,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4055,31214,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4056,31215,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4057,31216,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4058,31217,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4059,31218,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4060,31219,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4061,31220,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4062,31221,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4063,31222,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4064,31223,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4065,31224,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4066,31225,'Arena Manager','','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4067,31226,'Arena Director','','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4068,31227,'Orion the Cat','Event Manager','cat_the_cat','9.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(4069,31228,'Roy the Cat','Event Manager','cat_the_cat','9.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(4070,31229,'Winnie the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4071,31230,'Louie the Cat','Event Manager','silver_cat','7.00','15.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4072,31231,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4073,31232,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0);
INSERT INTO `npc` VALUES
(4074,31233,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4075,31234,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4076,31235,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4077,31236,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4078,31237,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4079,31238,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4080,31239,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4081,31240,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4082,31241,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4083,31242,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4084,31243,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4085,31244,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4086,31245,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4087,31246,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','true',0,0),
(4088,31247,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(4089,31248,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(4090,31249,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(4091,31250,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(4092,31251,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(4093,31252,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(4094,31253,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(4095,31254,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','true',0,0),
(4096,31255,'Orion the Cat','Event Manager','cat_the_cat','9.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','true',0,0),
(4097,31256,'Leon','Trader','a_traderC_Mhuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4098,31257,'Veronica','Trader','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4099,31258,'Helmut','Trader','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4100,31259,'Janne','Trader','a_common_peopleC_Fhuman','7.00','21.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4101,31260,'Judith','Trader','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4102,31261,'Renee','Trader','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4103,31262,'Rupert','Trader','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4104,31263,'Liesel','Trader','a_common_peopleC_Fhuman','7.00','21.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4105,31264,'Olsun','Symbol Maker','a_traderC_Mhuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4106,31265,'Annette','Pet Manager','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4107,31266,'Kaiser','','youth_tiger','16.00','17.20',70,'male','L2Npc','RndWalkAndAnim',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,60,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.45','false',1,0),
(4108,31267,'Lietta','Warehouse Keeper','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4109,31268,'Hakon','Warehouse Keeper','e_warehouse_master_MDwarf','8.00','17.50',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4110,31269,'Mona','Warehouse Chief','e_traderB_FDwarf','6.00','18.00',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4111,31270,'Stefano','Warehouse Freightman','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4112,31271,'Hilda','Blacksmith','e_smith_Fdwarf','8.00','17.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,87,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4113,31272,'Noel','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4114,31273,'Borodin','Blueprint Seller','e_mine_teacher_MDwarf','8.00','18.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4115,31274,'Fundin','Mineral Trader','a_smith_MDwarf','7.00','16.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4116,31275,'Tatiana','Gatekeeper','e_teleporter_Fhuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4117,31276,'Bernhard','Grand Master','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4118,31277,'Felix','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,125,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4119,31278,'Bronwyn','Master','a_fighterguild_teacher_MElf','7.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4120,31279,'Gregory','High Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,193,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4121,31280,'Bastian','Priest','a_temple_teacher_Mhuman','7.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4122,31281,'Cerenas','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4123,31282,'Justin','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4124,31283,'Alminas','Magister','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4125,31284,'Elena','Spellbook Seller','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4126,31285,'Samael','Grand Master','a_patriarch_MDarkElf','6.00','23.80',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4127,31286,'Drakon','Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,143,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4128,31287,'Kamilen','Magister','a_casino_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,204,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4129,31288,'Aklan','High Prefect','e_patriarch_MOrc','8.00','26.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4130,31289,'Lakan','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4131,31290,'Skahi','Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4132,31291,'Terava','Amulet Seller','e_clergyman_FOrc','6.50','28.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4133,31292,'Andrei','Captain','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,133,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4134,31293,'Gunter','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4135,31294,'Sven','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4136,31295,'Henrik','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4137,31296,'Cadmon','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4138,31297,'Bayard','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4139,31298,'Ulrich','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4140,31299,'Eugen','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4141,31300,'Drumond','Trader','e_traderB_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4142,31301,'Nils','Trader','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4143,31302,'Vladimir','Trader','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4144,31303,'Alisha','Trader','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4145,31304,'Astrid','Trader','a_traderC_Fhuman','7.00','21.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4146,31305,'Candice','Trader','e_traderA_FDwarf','8.00','19.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4147,31306,'Natasha','Trader','a_traderB_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4148,31307,'Weber','Trader','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4149,31308,'Achim','Symbol Maker','a_traderC_Mhuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4150,31309,'Woods','Pet Manager','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4151,31310,'Rafael','','strider','23.00','31.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.25','false',0,0),
(4152,31311,'Hugin','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4153,31312,'Durin','Warehouse Keeper','a_traderA_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4154,31313,'Lunin','Warehouse Keeper','e_traderB_MDwarf','8.00','17.50',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4155,31314,'Donal','Warehouse Chief','e_warehouse_master_MDwarf','8.00','17.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4156,31315,'Daisy','Warehouse Freightman','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4157,31316,'Vincenz','Blacksmith','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4158,31317,'Lombert','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4159,31318,'Greta','Blueprint Seller','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4160,31319,'Hans','Mineral Trader','e_traderB_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4161,31320,'Ilyana','Gatekeeper','e_teleporter_Fhuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4162,31321,'Siegmund','Grand Master','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4163,31322,'Erian','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,125,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4164,31323,'Beryl','Master','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4165,31324,'Andromeda','Grand Master','a_casino_FDarkElf','8.00','23.00',70,'female','L2WeddingManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,316,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4166,31325,'Themis','Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,227,627,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4167,31326,'Lambac','High Prefect','e_patriarch_MOrc','8.00','26.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4168,31327,'Tazki','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4169,31328,'Innocentin','High Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,193,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4170,31329,'Eliyah','Priest','a_temple_teacher_Mhuman','7.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4171,31330,'Wagner','Priest','a_patriarch_MElf','8.00','22.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4172,31331,'Valdis','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4173,31332,'Amelia','Magister','a_mageguild_teacher_FHuman','8.00','23.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4174,31333,'Rumiel','Magister','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4175,31334,'Tifaren','Grand Magister','a_teleporter_FDarkElf','8.00','25.00',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4176,31335,'Kayan','Magister','a_clergyman_MDarkElf','8.00','22.30',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,317,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4177,31336,'Rahorakti','Grand Seer','e_clergyman_MOrc','8.00','29.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4178,31337,'Mekara','Seer','e_mageguild_teacher_FOrc','8.00','28.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4179,31338,'Anton','Spellbook Seller','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4180,31339,'Hakran','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4181,31340,'Mathias','Captain','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,133,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4182,31341,'Richtor','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4183,31342,'Dimitri','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4184,31343,'Bellard','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4185,31344,'Schmidt','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4186,31345,'Ian','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4187,31346,'Sirius','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4188,31347,'Burke','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4189,31348,'Agripel','High Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4190,31349,'Benedict','Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4191,31350,'Dominic','Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4192,31351,'Volker','Wharf Manager','a_traderC_Mhuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4193,31356,'Remy','Porter','a_traderB_MHuman','8.00','24.50',70,'male','L2Npc','Remy',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4194,31357,'Leandro','Secretary','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','Leandro',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4195,31358,'Kasiel','Bard','a_trader_MElf','8.00','25.00',70,'male','L2Npc','Kasiel',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4196,31359,'Jaradine','Mother Tree Guardian','a_patriarch_MElf','8.00','22.50',70,'male','L2Npc','Jaradine',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4197,31360,'Alhena','Tetrarch Agent','a_casino_FDarkElf','8.00','23.00',70,'female','L2Npc','Alhena',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,315,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4198,31361,'Kreed','Tetrarch Executioner','a_trader_MDarkElf','8.00','22.50',70,'male','L2Npc','Kreed',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4199,31362,'Tate','Carrier','a_traderA_MDwarf','8.00','17.00',70,'male','L2Npc','Tate',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4200,31363,'Rogin','Deliveryman','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Npc','Rogin',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4201,31364,'Rokar','Guardian of Flame','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','Rokar',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,203,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4202,31365,'Yakand','Guardian of Flame','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','Yakand',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,203,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4203,31366,'Feed Seller','','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4204,31367,'Voice of Glory','','kel_mahum_witch_doctor','13.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,193,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.28','false',1,0),
(4205,31368,'Mikellan','Monk of Silence','a_temple_teacher_Mhuman','7.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4206,31369,'Mennon','Monk of Silence','a_temple_teacher_Mhuman','7.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4207,31370,'Kadun Zu Ketra','Hierarch','ketra_orc_chieftain','11.00','38.50',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6719,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.51','false',1,0),
(4208,31371,'Wahkan','Ketra''s Messenger','ketra_orc','12.00','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,175,0,0,45,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.46','false',1,0),
(4209,31372,'Asefa','Soul Guide','ketra_orc_shaman','10.00','23.00',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,205,0,0,10,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4210,31373,'Atan','Grocer','ketra_orc_warrior','12.00','24.00',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',1,0),
(4211,31374,'Jaff','Warehouse Keeper','ketra_orc_warrior','12.00','24.00',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',1,0),
(4212,31375,'Jumara','Trader','ketra_orc_warrior','12.00','24.00',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',1,0),
(4213,31376,'Kurfa','Gatekeeper','ketra_orc_shaman','10.00','23.00',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,205,0,0,10,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4214,31377,'Ashas Varka Durai','Hierarch','barka_silenos_chieftain','18.00','42.50',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,139,0,0,25,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(4215,31378,'Naran Ashanuk','Varka''s Messenger','barka_silenos_warrior','16.00','41.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,173,0,0,34,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(4216,31379,'Udan Mardui','Soul Guide','barka_silenos_shaman','14.00','39.50',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6716,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.49','false',1,0),
(4217,31380,'Diyabu','Grocer','barka_silenos_hunter','16.00','38.00',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,44,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(4218,31381,'Hagos','Warehouse Keeper','barka_silenos_warrior','16.00','41.00',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,34,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(4219,31382,'Shikon','Trader','barka_silenos_hunter','16.00','38.00',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,44,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(4220,31383,'Teranu Mardui','Gatekeeper','barka_silenos_shaman','14.00','39.50',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6716,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.49','false',1,0),
(4221,31384,'Gatekeeper of Fire Dragon','','skeleton_knight','10.00','25.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,84,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.17','true',1,0),
(4222,31385,'Heart of Volcano','','heart_of_warding','17.00','75.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4223,31386,'Violet','Trader','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4224,31387,'Kurstin','','a_traderB_FHuman','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4225,31388,'Mina','','a_traderB_FHuman','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4226,31389,'Dorian','','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,297,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4227,31390,'Dummy - Boy A','Ch4 Test','a_traderA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4228,31391,'Dummy  - Boy B','Ch4 Test','a_traderA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4229,31392,'Dummy  - Boy C','Ch4 Test','a_traderA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4230,31393,'Dummy - Boy D','Ch4 Test','a_traderA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4231,31394,'Dummy - Boy E','Ch4 Test','a_traderA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4232,31395,'Dummy - Lady F','Ch4 Test','a_teleporter_FHuman','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4233,31396,'Dummy - Lady G','Ch4 Test','a_teleporter_FHuman','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4234,31397,'Dummy - Lady H','Ch4 Test','a_teleporter_FHuman','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4235,31398,'Dummy - Lady I','Ch4 Test','a_teleporter_FHuman','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4236,31399,'Dummy - Lady J','Ch4 Test','a_teleporter_FHuman','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4237,31400,'Dummy - Sword Guard','Ch4 Test','a_guard_MHuman','8.00','24.00',80,'male','L2Npc','npc',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,2,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4238,31401,'Dummy - Bow Guard','Ch4 Test','a_guard_MHuman','8.00','24.00',80,'female','L2Npc','npc',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,14,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4239,31404,'Monster Race Guide','Town of Gludio','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4240,31405,'Monster Race Guide','Town of Dion','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4241,31406,'Monster Race Guide','Town of Giran','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4242,31407,'Monster Race Guide','Heine','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0);
INSERT INTO `npc` VALUES
(4243,31408,'Monster Race Guide','Town of Oren','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4244,31409,'Monster Race Guide','Hunters Village','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4245,31410,'Monster Race Guide','Town of Aden','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4246,31411,'Monster Race Guide','Town of Goddard','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4247,31412,'Monster Race Guide','Rune Township','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4248,31413,'Antonio','Spellbook Seller','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4249,31414,'Lynn','Spellbook Seller','a_common_people_FElf','8.00','25.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4250,31415,'Triya','Spellbook Seller','a_mageguild_teacher_MDarkElf','8.00','22.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4251,31416,'Aren','Spellbook Seller','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4252,31417,'Berynel','Spellbook Seller','a_common_people_MElf','6.00','21.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4253,31418,'Rouke','Spellbook Seller','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4254,31419,'Lorel','Spellbook Seller','a_common_people_MElf','6.00','21.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4255,31420,'Tomanel','Spellbook Seller','a_casino_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4256,31421,'Ratriya','Spellbook Seller','a_common_people_FElf','8.00','25.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4257,31422,'Migel','Spellbook Seller','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4258,31423,'Romas','Spellbook Seller','a_traderB_MHuman','8.00','24.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4259,31424,'Shantra','Amulet Seller','e_clergyman_FOrc','6.50','28.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4260,31425,'Koram','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4261,31426,'Jaka','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4262,31427,'Urgal','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4263,31428,'Shafa','Amulet Seller','e_clergyman_FOrc','6.50','28.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4264,31429,'Shitara','Amulet Seller','e_clergyman_FOrc','6.50','28.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4265,31430,'Donai','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4266,31431,'Karai','Amulet Seller','e_mageguild_teacher_MOrc','7.00','27.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4267,31432,'Reeya','Blueprint Seller','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4268,31433,'Ronaldo','Blueprint Seller','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4269,31434,'Shaling','Blueprint Seller','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4270,31435,'Daeger','Blueprint Seller','e_traderA_master_MDwarf','8.00','18.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4271,31436,'Dani','Blueprint Seller','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4272,31437,'Luka','Blueprint Seller','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4273,31438,'Lara','Blueprint Seller','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4274,31439,'Rogen','Mineral Trader','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4275,31440,'Lanna','Mineral Trader','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4276,31441,'Gordo','Mineral Trader','e_traderB_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4277,31442,'Kiki','Mineral Trader','e_traderB_FDwarf','6.00','18.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4278,31443,'Raban','Mineral Trader','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4279,31444,'Cona','Mineral Trader','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4280,31445,'Shutner','Mineral Trader','e_traderB_MDwarf','8.00','17.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4281,31452,'Ghost of Wigoth','','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4282,31453,'Nameless Spirit','','a_king_MHuman','8.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4283,31454,'Ghost of Wigoth','','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4284,31455,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4285,31456,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4286,31457,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4287,31458,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4288,31459,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4289,31460,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4290,31461,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4291,31462,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4292,31463,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4293,31464,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4294,31465,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4295,31466,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4296,31467,'Key Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4297,31468,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4298,31469,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4299,31470,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4300,31471,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4301,31472,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4302,31473,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4303,31474,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4304,31475,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4305,31476,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4306,31477,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4307,31478,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4308,31479,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4309,31480,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4310,31481,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4311,31482,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4312,31483,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4313,31484,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4314,31485,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4315,31486,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4316,31487,'Mysterious Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4317,31488,'Rift Post Recruit','','a_royal_guardB_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4318,31489,'Rift Post Private','','a_royal_guardB_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,304,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4319,31490,'Rift Post Officer','','a_royal_guardB_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,79,111,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4320,31491,'Rift Post Captain','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,660,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4321,31492,'Rift Post Commander','','a_lord_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,80,655,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4322,31493,'Rift Post Hero','','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,135,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4323,31494,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4324,31495,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4325,31496,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4326,31497,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4327,31498,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4328,31499,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4329,31500,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4330,31501,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4331,31502,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4332,31503,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4333,31504,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4334,31505,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4335,31506,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4336,31507,'Dimensional Gate Keeper','','rift_keeper','38.00','120.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4337,31508,'Altar of Saints','','holy_altar','14.00','45.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4338,31509,'Altar of Saints','','holy_altar','14.00','45.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4339,31510,'Altar of Saints','','holy_altar','14.00','45.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4340,31511,'Altar of Saints','','holy_altar','14.00','45.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4341,31512,'Evil Altar','','evil_altar','11.00','45.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4342,31513,'Evil Altar','','evil_altar','11.00','45.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4343,31514,'Evil Altar','','evil_altar','11.00','45.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4344,31515,'Evil Altar','','evil_altar','11.00','45.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4345,31516,'Evil Altar','','evil_altar','11.00','45.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4346,31517,'Hierarch','','a_hardin_MHuman','8.00','22.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4347,31518,'Mysterious Necromancer','','a_hardins_pupil_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4348,31519,'Enfeux','','saints_coffin','20.00','60.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4349,31520,'Leikar','Maid','a_maidA_FHuman','8.00','20.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4350,31521,'Jeremy','Chef','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4351,31522,'Mysterious Wizard','','a_hardin_MHuman','8.00','22.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4352,31523,'Tombstone','','old_tomb_stone','20.00','30.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4353,31524,'Ghost of von Hellmann','','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4354,31525,'Ghost of von Hellmann''s Page','','dark_horror','20.00','35.00',70,'male','L2Npc','GhostOfVonHellmannsPage',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4355,31526,'Broken Bookshelf','','old_bookshelf','15.00','33.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4356,31527,'Well','','umul','33.00','37.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4357,31528,'Ghost of Priest','','elf_ghost','7.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','false',0,0),
(4358,31529,'Ghost of Adventurer','','human_ghost','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(4359,31530,'Box','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4360,31531,'Tombstone','','old_tomb_stone','20.00','30.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4361,31532,'Maid of Lidia','','vampire_witch','6.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,64,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(4362,31533,'Broken Bookshelf','','old_bookshelf','15.00','33.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4363,31534,'Broken Bookshelf','','old_bookshelf','15.00','33.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4364,31535,'Broken Bookshelf','','old_bookshelf','15.00','33.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4365,31536,'Coffin','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4366,31537,'Tunatun','Beast Herder','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4367,31538,'Ghost of Adventurer','','a_traderA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4368,31539,'Vulcan','Blacksmith of Flame','a_smith_MDwarf','7.00','16.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4369,31540,'Klein','Watcher of Valakas','skeleton_royal_guard','11.00','28.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',1,0),
(4370,31541,'Daimon''s Altar','','gianteye_altar','60.00','50.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4371,31542,'Yeti''s Table','','yetis_dinner_table','25.00','15.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Magister',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4372,31543,'Pulin','','e_bath_MDwarf','6.00','16.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4373,31544,'Naff','','e_bath_MDwarf','6.00','16.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4374,31545,'Crocus','','e_bath_MDwarf','6.00','16.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4375,31546,'Kuber','','e_bath_MDwarf','6.00','16.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4376,31547,'Beolin','','e_bath_MDwarf','6.00','16.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4377,31548,'Mysterious Ancient Tablet','','old_tablet','32.00','46.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4378,31549,'Mysterious Ancient Tablet','','old_tablet','32.00','46.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4379,31550,'Mysterious Ancient Tablet','','old_tablet','32.00','46.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4380,31551,'Mysterious Ancient Tablet','','old_tablet','32.00','46.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4381,31552,'Mysterious Ancient Tablet','','old_tablet','32.00','46.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4382,31553,'Pierce','Mercenary Captain','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,135,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4383,31554,'Kahman','Mercenary','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4384,31555,'Abercrombie','Mercenary Supplier','e_collector_teacher_MDwarf','8.00','17.50',70,'male','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4385,31556,'Selina','Mercenary Medic','a_traderC_Fhuman','7.00','21.50',70,'female','L2NpcFriend','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,659,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4386,31557,'Mercenary Sentry','','a_royal_guardB_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,298,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4387,31558,'Ketra''s Holy Altar','','orcish_totem','25.00','47.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4388,31559,'Box of Asefa','','coffer_d','12.00','22.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4389,31560,'Varka''s Holy Altar','','silenos_totem','28.00','55.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4390,31561,'Udan Mardui''s Box','','coffer_b','12.00','9.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4391,31562,'Klufe','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4392,31563,'Perelin','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4393,31564,'Mishini','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4394,31565,'Ogord','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4395,31566,'Ropfi','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4396,31567,'Bleaker','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4397,31568,'Pamfus','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4398,31569,'Cyano','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4399,31570,'Lanosco','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4400,31571,'Hufs','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4401,31572,'O''Fulle','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4402,31573,'Monakan','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4403,31574,'Willie','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4404,31575,'Litulon','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4405,31576,'Berix','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4406,31577,'Linnaeus','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4407,31578,'Hilgendorf','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4408,31579,'Klaus','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4409,31580,'Galadrid','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,132,110,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4410,31581,'Anastia','Magister','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4411,31582,'Mordred','Dark Knight','vampire_soldier','8.00','23.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,137,634,0,60,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.45','false',1,0),
(4412,31583,'Feynn','Blacksmith','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,168,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4413,31584,'Valentine','Brewer','e_traderB_MDwarf','8.00','17.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4414,31585,'Sparky the Cat','Keats Servitor','cat_the_cat','9.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0);
INSERT INTO `npc` VALUES
(4415,31586,'Sparky the Cat','Keats Servitor','cat_the_cat','9.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(4416,31587,'Gedrik','Gemcutter','e_traderB_master_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4417,31588,'Agnes','Saint of Light','a_teleporter_FElf','8.50','23.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4418,31589,'Duda-Mara Totem Spirit','','giant_spider','26.00','26.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,72,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.26','false',1,0),
(4419,31590,'Truth Scholar Devianne','','a_teleporter_FHuman','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,192,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4420,31591,'Sunset Guide Luna','','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,633,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',0,0),
(4421,31592,'Telson','Chief Golem Crafter','e_mine_master_MDwarf','8.00','19.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4422,31593,'Dorothy','Golem of Telson','mechanic_golem','5.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(4423,31594,'Mond','Chief Inspector','e_celebrant_MDwarf','8.00','19.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4424,31595,'Leona Blackbird','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,79,110,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',0,0),
(4425,31596,'Tobald','Master','e_guard_MDwarf','8.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,187,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4426,31597,'Tobald','Master','e_guard_MDwarf','8.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,187,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4427,31598,'Medina Blackheart','','a_trader_Fdarkelf','8.00','24.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,206,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4428,31599,'Disgraced Knight Waldstein','','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,81,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4429,31600,'Pamela Aprodia','','a_casino_FDarkElf','8.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4430,31601,'Pamela Aprodia','','a_guard_FDarkelf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4431,31602,'Sharona Artemia','Bodyguard','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,232,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4432,31603,'Black Cat','Hunter Guild Member','a_common_people_FDarkElf','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,227,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4433,31604,'Grimst','Information Broker','a_casino_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4434,31605,'Kinsley','Head Summoner','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,212,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4435,31606,'Alice de Catrina','Kinsley''s Servitor','queen_of_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(4436,31607,'Sake Dun Zu Hestui','','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,298,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4437,31608,'Belinda','Summoner','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4438,31609,'Aurora the Unicorn','Belinda Servitor','unicorn_boxer','11.00','18.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,27,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(4439,31610,'Shiken Gloomdrake','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,80,633,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',0,0),
(4440,31611,'Scryde Heartseeker','','a_common_people_MDarkElf','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,81,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4441,31612,'Eternity Wanderer Staris','','a_trader_MElf','8.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,150,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4442,31613,'Noctisse','Summoner','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,204,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4443,31614,'Radyss','Head Summoner','a_patriarch_MElf','8.00','22.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4444,31615,'Hermit','','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4445,31616,'Hermit','','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,8,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4446,31617,'Aria Firstmatter','','a_guard_FDarkelf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,236,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4447,31618,'Moon Voice Irene','','a_common_people_FElf','8.00','25.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,109,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4448,31619,'Erica Ken Weber','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,236,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4449,31620,'Verdure Elder Elikia','','a_patriarch_MElf','8.00','22.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,189,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4450,31621,'Abyss Saint Elcardia','','a_guard_FDarkelf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,206,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4451,31622,'Keats','Cursed Summoner','poison_toad','20.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.35','false',1,0),
(4452,31623,'Bavarin','Information Broker','e_bath_MDwarf','6.00','16.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4453,31624,'Donath','Master Chef','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4454,31625,'Yeti','Donath Kitchen Help','yeti_cute','5.00','10.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5129,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4455,31626,'Duncan','Chef','a_smith_MDwarf','7.00','16.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5129,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4456,31627,'Mist','Information Broker','e_bath_MDwarf','6.00','16.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4457,31628,'Lilly','Mist''s Granddaughter','e_traderA_FDwarf','8.00','19.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4458,31629,'Kaleidos the Unicorn','','blue_eye','11.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(4459,31630,'Kaleidos the Unicorn','','blue_eye','11.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(4460,31631,'Eric Ramsheart','','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,79,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4461,31632,'Mysterious Servitor','','shadeless','7.00','28.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(4462,31633,'Winter Hunter Kadyth','','a_guard_MElf','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4463,31634,'Winter Hunter Kadyth','','a_guard_MElf','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4464,31635,'Winter Hunter Kadyth','','a_guard_MElf','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4465,31636,'Flame Successor Akkan','','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,305,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4466,31637,'Khavatari Kashu','','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,267,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4467,31638,'Starling Knight Kastien','','a_guard_MElf','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,142,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4468,31639,'Kain Van Halter','','a_traderA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2626,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4469,31640,'Pilgrim of Darkness','','a_hardins_pupil_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,318,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4470,31641,'Pilgrim of Darkness','','a_hardins_pupil_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,318,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4471,31642,'Tarkai Zu Duda-Mara','','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,210,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4472,31643,'Silver Feyshar','','a_patriarch_MElf','8.00','22.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,148,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4473,31644,'Dawn Witness Franz','','a_sanctuary_master_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,205,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4474,31645,'Hindemith Truevoice','','a_traderD_Mhuman','7.00','21.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,195,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4475,31646,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4476,31647,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4477,31648,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4478,31649,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4479,31650,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4480,31651,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4481,31652,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4482,31653,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4483,31654,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4484,31655,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4485,31656,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4486,31657,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4487,31658,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4488,31659,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4489,31660,'Tablet of Vision','','codex_stone','7.00','24.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4490,31661,'Forgotten Monument','','old_tablet','32.00','46.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4491,31662,'Forgotten Monument','','old_tablet','32.00','46.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4492,31663,'Forgotten Monument','','old_tablet','32.00','46.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4493,31664,'Forgotten Monument','','old_tablet','32.00','46.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4494,31665,'Corpse of Dwarf','','e_guard_MDwarf_death','13.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4495,31666,'Lumen','Spellbook Seller','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4496,31667,'Raik','Amulet Seller','e_trader_MOrc','8.00','23.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4497,31668,'Tangen','Blueprint Seller','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4498,31669,'Onyx','Mineral Trader','e_mine_teacher_MDwarf','8.00','18.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4499,31670,'Burns','Spellbook Seller','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4500,31671,'Patrol','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',1100,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,120,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(4501,31672,'Patrol','','a_guard_MHuman','8.00','24.00',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4502,31673,'Patrol','','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',1100,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,4031,576,1144,468,249,0,227,275,0,0,50,120,'',0,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(4503,31674,'Patrol','','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4504,31675,'Viktor Van Deik','Border Outpost Captain','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4505,31676,'Gregory Athebaldt','Border Outpost Captain','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4506,31677,'Border Patrol','','a_guard_MHuman','8.00','24.00',80,'male','L2Npc','npc',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4507,31678,'Border Patrol','','a_guard_MHuman','8.00','24.00',80,'male','L2Npc','npc',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4508,31679,'Eustace Van Essen','Frontier Guard Captain','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4509,31680,'Fleming Van Issen','Frontier Guard Captain','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,128,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4510,31681,'Frontier Guard','','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Npc','npc',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4511,31682,'Frontier Guard','','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Npc','npc',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,94,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4512,31683,'Eye of Argos','','argos_eye','120.00','307.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4513,31684,'Eye of Udan Mardui','','mana_vampire','11.00','20.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(4514,31685,'Asefa''s Eye','','magical_weaver','11.00','20.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,90,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',0,0),
(4515,31686,'Gatekeeper of Fire Dragon','','skeleton_knight','10.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,84,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(4516,31687,'Gatekeeper of Fire Dragon','','skeleton_knight','10.00','25.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,84,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.17','false',1,0),
(4517,31688,'Grand Olympiad Manager','','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2OlympiadManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4518,31689,'Olympiad Finisher','','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,70,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4519,31690,'Monument of Heroes','','heroes_obelisk_human','21.00','69.00',70,'etc','L2OlympiadManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4520,31691,'Training Dummy','','training_doll','9.00','22.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4521,31692,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4522,31693,'Priest of Dusk','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4523,31694,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4524,31695,'Priest of Dusk','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4525,31696,'Platis','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4526,31697,'Eindarkner','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4527,31698,'Arisha','Gatekeeper','e_teleporter_Fhuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4528,31699,'Stanislava','Gatekeeper','e_teleporter_Fhuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4529,31700,'Saint''s Follower','','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4530,31701,'Saint''s Follower','','a_common_people_MElf','6.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4531,31702,'Saint''s Follower','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4532,31703,'Saint''s Follower','','a_common_peopleC_Fhuman','7.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4533,31704,'Saint''s Follower','','a_common_peopleA_FHuman','8.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4534,31705,'Daimon the White-Eyed','','hundred_eye','21.00','55.00',70,'male','L2Npc','DaimonTheWhiteEyed',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',1,0),
(4535,31706,'Miki the Cat','','cat_the_cat','9.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(4536,31707,'Ketra Van Grunt','','ketra_orc_chieftain','11.00','38.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6719,0,0,24,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.51','false',1,0),
(4537,31708,'Ketra Van Shaman','','ketra_orc_shaman','10.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,92,0,0,10,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4538,31709,'Ketra Van Captain','','ketra_orc_warlord','12.00','30.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,80,0,0,27,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(4539,31710,'Ketra Van Commander','','barka_silenos_chieftain','18.00','42.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,2500,0,0,25,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(4540,31711,'Ketra Van Shaman','','barka_silenos_shaman','14.00','39.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,6716,0,0,36,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.49','false',1,0),
(4541,31712,'Varka Raider','','barka_silenos_warrior','16.00','41.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,142,0,0,34,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',1,0),
(4542,31713,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4543,31714,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4544,31715,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4545,31716,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4546,31717,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4547,31718,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4548,31719,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4549,31720,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4550,31721,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4551,31722,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4552,31723,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4553,31724,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4554,31725,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4555,31726,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4556,31727,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4557,31728,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4558,31729,'Adventurer Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4559,31730,'Adventurer Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4560,31731,'Adventurer Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4561,31732,'Adventurer Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4562,31733,'Adventurer Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4563,31734,'Adventurer Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4564,31735,'Adventurer Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4565,31736,'Adventurer Guildsman','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4566,31737,'Adventurer Guildsman','','e_trader_FOrc','8.00','24.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4567,31738,'Adventurer Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4568,31739,'Talien','','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,4202,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4569,31740,'Caradine','','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,285,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4570,31741,'Ossian','','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4571,31742,'Virgil','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4572,31743,'Kassandra','','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4573,31744,'Ogmar','','e_common_people_MOrc','8.00','26.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4574,31745,'Lady of the Lake','','a_teleporter_FElf','8.50','23.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4575,31746,'Fallen Unicorn','','death_unicorn','14.00','30.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,46,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.74','false',1,0),
(4576,31747,'Pure White Unicorn','','unicorn','14.00','30.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,46,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.74','false',0,0),
(4577,31748,'Cornerstone of Restraining','','grave_keeper','8.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4578,31750,'Mysterious Woman','','a_teleporter_FElf','8.50','23.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4579,31751,'Mysterious Dark Knight','','death_lord','21.00','40.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,78,0,0,40,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.50','false',1,0),
(4580,31752,'Corpse of Angel','','angel_death','25.00','36.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4581,31755,'Halaster','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4582,31756,'Mr. Cat','Test Server Helper','cat_the_cat','9.00','16.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(4583,31757,'Miss Queen','Test Server Helper','queen_of_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(4584,31758,'Rafi','','hatchling','9.00','10.00',70,'male','L2Trainer','RndWalkAndAnim',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.27','false',1,0);
INSERT INTO `npc` VALUES
(4585,31759,'Teleport Cube','','teleport_npc','40.00','80.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4586,31760,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(4587,31761,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(4588,31762,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(4589,31763,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(4590,31764,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(4591,31765,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(4592,31766,'Miss Queen','Adventurers'' Guide','queen_of_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(4593,31767,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4594,31768,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4595,31769,'Monument of Heroes','','heroes_obelisk_elf','24.00','77.50',70,'etc','L2OlympiadManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4596,31770,'Monument of Heroes','','heroes_obelisk_darkelf','25.00','77.00',70,'etc','L2OlympiadManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4597,31771,'Monument of Heroes','','heroes_obelisk_orc','21.00','72.50',70,'etc','L2OlympiadManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4598,31772,'Monument of Heroes','','heroes_obelisk_dwarf','23.00','80.00',70,'etc','L2OlympiadManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4599,31773,'Sonin','Warehouse Keeper','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4600,31774,'Beryl the Cat','Event Manager','queen_of_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(4601,31775,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4602,31776,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4603,31777,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4604,31778,'Adventure Guildsman','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4605,31779,'Adventure Guildsman','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4606,31780,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4607,31781,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4608,31782,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4609,31783,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4610,31784,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4611,31785,'Adventure Guildsman','','e_trader_FOrc','8.00','24.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4612,31786,'Adventure Guildsman','','e_trader_FOrc','8.00','24.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4613,31787,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4614,31788,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4615,31789,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4616,31790,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4617,31791,'Adventure Guildsman','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4618,31792,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4619,31793,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4620,31794,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4621,31795,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4622,31796,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4623,31797,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4624,31798,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4625,31799,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4626,31800,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4627,31801,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4628,31802,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4629,31803,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4630,31804,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4631,31805,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4632,31806,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4633,31807,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4634,31808,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4635,31809,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4636,31810,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4637,31811,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4638,31812,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4639,31813,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4640,31814,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4641,31815,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4642,31816,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4643,31817,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4644,31818,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4645,31819,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4646,31820,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4647,31821,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4648,31822,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4649,31823,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4650,31824,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4651,31825,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4652,31826,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4653,31827,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4654,31828,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4655,31829,'Adventure Guildsman','','a_trader_MDarkElf','8.00','22.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,151,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4656,31830,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4657,31831,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4658,31832,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4659,31833,'Adventure Guildsman','','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,231,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4660,31834,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4661,31835,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4662,31836,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4663,31837,'Adventure Guildsman','','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,224,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4664,31838,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4665,31839,'Adventure Guildsman','','a_common_people_MElf','6.00','21.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,130,0,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4666,31840,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'DRIVER','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4667,31841,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,48,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4668,31842,'Teleport Cube','','teleport_cube','30.00','65.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,7,3,0,0,'0.60','false',0,0),
(4669,31843,'Teleport Cube','','teleport_cube','30.00','65.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(4670,31844,'Aracna','','aracne','15.00','26.00',50,'female','L2Monster','Fighter',40,3381,'5.500',1660,'2.100',60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,64,120,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',0,0),
(4671,31845,'Bloody Pixy','','pixy','5.00','25.00',80,'female','L2Guard','GuardRndWalkAndAnim',40,4550,'5.500',1660,'2.100',60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,80,120,'all_elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.72','false',1,0),
(4672,31846,'Satyros','','pan','14.00','35.00',50,'male','L2Monster','Fighter',40,3381,'5.500',1660,'2.100',60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,291,0,0,45,110,'all_elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.58','true',0,0),
(4673,31847,'Pan','','pan','14.00','35.00',50,'male','L2Monster','Fighter',40,3381,'5.500',1660,'2.100',60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,291,0,0,45,110,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.58','true',0,0),
(4674,31848,'Pixy','','pixy','5.00','25.00',50,'female','L2Guard','GuardRndWalkAndAnim',40,4550,'5.500',1660,'2.100',60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,80,120,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.72','false',1,0),
(4675,31849,'Red Arachne','','aracne','15.00','26.00',50,'female','L2Monster','Fighter',40,3381,'5.500',1660,'2.100',60,57,73,76,70,80,0,0,1135,278,2360,452,409,0,2901,0,0,0,64,120,'all_elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.50','true',0,0),
(4676,31850,'Blight Treant','','ti_mi_riran','23.00','90.00',80,'male','L2Guard','GuardRndWalkAndAnim',40,4550,'5.500',1660,'2.100',60,57,73,76,70,80,0,0,1032,278,2360,452,409,0,2901,0,0,0,12,12,'all_elemental2_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(4677,31851,'Treant','','ti_mi_tran','23.00','90.00',80,'male','L2Guard','GuardRndWalkAndAnim',40,4550,'5.500',1660,'2.100',60,57,73,76,70,80,0,0,1032,278,2360,452,409,0,2901,0,0,0,12,12,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(4678,31852,'Pixy Murika','','pixy','5.00','25.00',50,'female','L2Guard','GuardRndWalkAndAnim',40,2245,'5.500',830,'2.100',40,43,30,21,20,10,0,0,509,278,264,226,278,0,253,0,0,0,80,120,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.72','false',1,0),
(4679,31853,'Treant Bremec','','ti_mi_tran','23.00','90.00',80,'male','L2Guard','GuardRndWalkAndAnim',40,4550,'5.500',1660,'2.100',60,57,73,76,70,80,0,0,1032,278,2360,452,409,0,2901,0,0,0,12,12,'all_elemental_clan',300,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',1,0),
(4680,31854,'Event Manager','','a_traderB_MHuman','7.00','21.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4681,31855,'Event Manager','','a_trader_FElf','8.00','24.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4682,31856,'Event Manager','','a_clergyman_FDarkElf','8.00','25.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4683,31857,'Event Manager','','e_traderA_FDwarf','8.00','19.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4684,31858,'Event Manager','','e_trader_FOrc','8.00','24.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4685,31859,'Teleport Cube','','teleport_cube','30.00','65.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(4686,31860,'Orion the Cat','Event Manager','e_trader_FOrc','8.00','18.00',70,'male','L2ClassMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4687,31861,'Gatekeeper','','a_teleporter_FHuman','8.00','25.00',56,'female','L2CastleTeleporter','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(4688,31862,'Angelic Vortex','','alive_castle_aden_controltower_jewel','7.00','35.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4689,31863,'Santa Trainee','','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4690,31864,'Santa Trainee','','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4691,31865,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Npc','npc',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4692,31866,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Npc','npc',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4693,31867,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Npc','npc',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4694,31868,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Npc','npc',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4695,31869,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Npc','npc',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4696,31870,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Npc','npc',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4697,31871,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Npc','npc',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4698,31872,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Npc','npc',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4699,31873,'Guardian of Border','','teleport_npc_sm','7.00','15.00',35,'etc','L2Npc','npc',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4700,31874,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Npc','npc',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4701,31875,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Npc','npc',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4702,31876,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Npc','npc',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4703,31877,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Npc','npc',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4704,31878,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Npc','npc',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4705,31879,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Npc','npc',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4706,31880,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Npc','npc',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4707,31881,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Npc','npc',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4708,31882,'Guardian of Border','','teleport_npc_sm','7.00','15.00',45,'etc','L2Npc','npc',40,1870,'5.500',677,'2.100',40,43,30,21,20,10,0,0,377,238,188,193,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4709,31883,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4710,31884,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4711,31885,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4712,31886,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4713,31887,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4714,31888,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4715,31889,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4716,31890,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4717,31891,'Guardian of Border','','teleport_npc_sm','7.00','15.00',55,'etc','L2Npc','npc',40,2643,'6.500',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4718,31892,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Npc','npc',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4719,31893,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Npc','npc',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4720,31894,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Npc','npc',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4721,31895,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Npc','npc',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4722,31896,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Npc','npc',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4723,31897,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Npc','npc',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4724,31898,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Npc','npc',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4725,31899,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Npc','npc',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4726,31900,'Guardian of Border','','teleport_npc_sm','7.00','15.00',65,'etc','L2Npc','npc',40,3465,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4727,31901,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Npc','npc',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4728,31902,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Npc','npc',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4729,31903,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Npc','npc',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4730,31904,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Npc','npc',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4731,31905,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Npc','npc',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4732,31906,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Npc','npc',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4733,31907,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Npc','npc',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4734,31908,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Npc','npc',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4735,31909,'Guardian of Border','','teleport_npc_sm','7.00','15.00',75,'etc','L2Npc','npc',40,4229,'8.500',1673,'3.000',40,43,30,21,20,10,0,0,1563,523,957,425,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4736,31910,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Npc','npc',40,4813,'8.500',2049,'3.000',40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4737,31911,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Npc','npc',40,4813,'8.500',2049,'3.000',40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4738,31912,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Npc','npc',40,4813,'8.500',2049,'3.000',40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4739,31913,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Npc','npc',40,4813,'8.500',2049,'3.000',40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4740,31914,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Npc','npc',40,4813,'8.500',2049,'3.000',40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4741,31915,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Npc','npc',40,4813,'8.500',2049,'3.000',40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4742,31916,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Npc','npc',40,4813,'8.500',2049,'3.000',40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4743,31917,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Npc','npc',40,4813,'8.500',2049,'3.000',40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4744,31918,'Guardian of Border','','teleport_npc_sm','7.00','15.00',85,'etc','L2Npc','npc',40,4813,'8.500',2049,'3.000',40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,253,0,0,0,50,1,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4745,31919,'Ghost Chamberlain of Elmoreden','','a_tombkeeperA','7.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4746,31920,'Ghost Chamberlain of Elmoreden','','a_tombkeeperA','7.00','23.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4747,31921,'Conquerors'' Sepulcher Manager','','grave_keeper','8.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4748,31922,'Emperors'' Sepulcher Manager','','grave_keeper','8.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4749,31923,'Great Sages'' Sepulcher Manager','','grave_keeper','8.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4750,31924,'Judges'' Sepulcher Manager','','grave_keeper','8.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4751,31925,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4752,31926,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0);
INSERT INTO `npc` VALUES
(4753,31927,'Count''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4754,31928,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4755,31929,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4756,31930,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4757,31931,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4758,31932,'Count''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4759,31933,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4760,31934,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4761,31935,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4762,31936,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4763,31937,'Count''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4764,31938,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4765,31939,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4766,31940,'Baron''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4767,31941,'Viscount''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4768,31942,'Count''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4769,31943,'Marquis'' Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4770,31944,'Duke''s Hall Gatekeeper','','rift_keeper_25_sm','9.50','29.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4771,31945,'Auzendorff','Trader','e_traderB_MDwarf','8.00','17.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4772,31946,'Hombre','Trader','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4773,31947,'Owaki','Trader','e_trader_MOrc','8.00','23.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4774,31948,'Adrian','Trader','a_traderC_Mhuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4775,31949,'Rouge','Trader','a_traderC_Fhuman','7.00','21.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4776,31950,'Mailland','Trader','e_traderB_FDwarf','6.00','18.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4777,31951,'Jose','Trader','a_traderD_Fhuman','8.00','22.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4778,31952,'Pele','Trader','a_common_peopleC_Fhuman','7.00','21.50',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4779,31953,'Rankar','Symbol Maker','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2SymbolMaker','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4780,31954,'Saroyan','Pet Manager','a_traderD_Mhuman','7.00','21.50',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4781,31955,'Ruby','','baby_tiger','11.00','15.70',70,'male','L2Npc','RndWalkAndAnim',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4782,31956,'Rydel','Warehouse Keeper','e_warehouse_keeper_FDwarf','6.00','18.00',70,'female','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4783,31957,'Cherbal','Warehouse Keeper','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4784,31958,'Yasheni','Warehouse Chief','e_warehouse_master_MDwarf','8.00','17.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4785,31959,'Axel','Warehouse Freightman','e_warehouse_master_MDwarf','8.00','17.50',70,'male','L2Warehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4786,31960,'Byron','Blacksmith','e_smith_Fdwarf','8.00','17.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4787,31961,'Newyear','Head Blacksmith','e_smith_master_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4788,31962,'Altair','Blueprint Seller','a_traderA_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4789,31963,'Hitchi','Mineral Trader','e_traderB_master_MDwarf','8.00','17.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4790,31964,'Bilia','Gatekeeper','a_teleporter_FHuman','8.00','25.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4791,31965,'Hector','Grand Master','a_fighterguild_master_Mhuman','8.00','23.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,76,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4792,31966,'Karamon','Master','a_fighterguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4793,31967,'Euline','Master','a_fighterguild_teacher_FElf','8.00','22.50',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4794,31968,'Baryl','High Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4795,31969,'Evelyn','Priest','a_mageguild_master_FHuman','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4796,31970,'Sinis','Priest','a_mageguild_teacher_MElf','7.00','22.20',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4797,31971,'Otillo','Magister','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4798,31972,'Atraxia','Magister','a_mageguild_teacher_FElf','7.00','21.20',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4799,31973,'Raheel','Spellbook Seller','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4800,31974,'Drizzit','Grand Master','a_guild_master_MDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4801,31975,'Aerina','Master','a_fighterguild_teacher_MDarkElf','8.00','23.00',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4802,31976,'Talia','Magister','a_mageguild_teacher_FDarkElf','8.00','23.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4803,31977,'Shaka','High Prefect','e_patriarch_MOrc','8.00','26.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4804,31978,'Tazeer','Prefect','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,161,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4805,31979,'Moira','Seer','e_clergyman_FOrc','6.50','28.00',70,'female','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4806,31980,'Rumba','Amulet Seller','e_clergyman_FOrc','6.50','28.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4807,31981,'Vishotsky','Captain','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,133,632,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4808,31982,'Glen','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4809,31983,'Friggar','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4810,31984,'Sherring','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4811,31985,'Kosmos','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4812,31986,'Erstack','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4813,31987,'Gotter','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4551,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4814,31988,'Singa','Guard','e_elmore_guard_Mhuman','8.00','23.50',80,'male','L2Guard','Guard',40,4550,'8.500',1859,'3.000',40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,253,126,628,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4815,31989,'Batidae','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,7560,0,0,50,120,NULL,0,'Local',NULL,0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4816,31990,'Siger','Blacksmith','a_smith_MDwarf','7.00','16.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,168,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4817,31991,'Adventure Guildsman','','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4818,31992,'Adventure Guildsman','','a_fighterguild_teacher_FHuman','9.50','22.40',70,'female','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,129,102,0,50,120,'',0,'Tigra','',0,20,147,7,30,4,4,0,-6,'0.60','false',0,0),
(4819,31993,'Adventure Guildsman','','e_common_people_MDwarf','8.00','17.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,99,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4820,31994,'Adventure Guildsman','','e_common_people_MOrc','8.00','26.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4821,31995,'Adventure Guildsman','','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,156,20,0,50,120,'',0,'Tigra','',0,20,147,7,30,4,4,0,-6,'0.60','false',0,0),
(4822,31996,'Javier','Grand Magister','a_mageguild_master_MHuman','8.00','24.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4823,31997,'Priest of Dawn','','priest_of_dawn','8.00','30.50',70,'male','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,5802,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4824,31998,'Dusk Priestess','','priest_of_dusk','8.00','22.00',70,'female','L2SignsPriest','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,5801,0,0,50,120,'',0,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(4825,31999,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4826,32000,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4827,32001,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4828,32002,'Preacher of Doom','','dark_horror','20.00','35.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,100,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.37','false',0,0),
(4829,32003,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4830,32004,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4831,32005,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4832,32006,'Orator of Revelations','','liviona','15.00','28.00',70,'male','L2CabaleBuffer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4833,32007,'Galba','Fishing Guild Member','a_fisherA_Mhuman','8.00','24.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4834,32008,'Gremory','Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Trainer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4835,32009,'Devorin','Nurse','e_common_people_FDwarf','7.00','17.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4836,32010,'Flauron','Priest','a_temple_master_Mhuman','8.00','24.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4837,32011,'Imperial Tomb Guide','','a_tombkeeperA','7.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4838,32012,'Tantan','Retired Adventurer','a_old_people_Mhuman','9.00','17.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4839,32013,'Suki','Wild Maiden','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4840,32014,'Ivan','Runaway Youth','a_traderD_Mhuman','7.00','21.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4841,32015,'Scout''s Corpse','','e_guard_MDwarf_death','13.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4842,32016,'Torrant','Beacon Tower Manager','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4843,32017,'Karuda','','e_guard_MOrc','8.00','27.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4844,32018,'Misa','','a_maidB_FHuman','8.00','22.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4845,32019,'Suspicious Man','','a_sanctuary_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4846,32020,'Rafforty','','a_common_peopleC_Mhuman','10.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4847,32021,'Ice Sculpture','','ice_sculpture_c','16.00','20.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4848,32022,'Kierre','','ice_sculpture_b','12.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4849,32023,'Ice Shelf','','ice_shelf','35.00','14.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4850,32024,'Mulia','Clan Trader','e_smith_master_MDwarf','8.00','17.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4851,32025,'Ilia','Clan Trader','e_smith_Fdwarf','8.00','17.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4852,32026,'Hestui Guard','','e_fighterguild_teacher_MOrc','8.00','28.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4853,32027,'Holy Brazier','','grail_brazier_b','30.00','31.00',78,'male','L2Npc','npc',40,3862,'7.500',44285,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4854,32028,'Holy Grail','','holy_grail','6.20','7.00',70,'male','L2Npc','npc',40,3862,'7.500',3862,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4855,32029,'Freya''s Steward','','a_common_people_MElf','6.00','21.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4856,32030,'Garden Sculpture','','ice_sculpture_c','16.00','20.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4857,32031,'Ice Fairy Sculpture','','ice_sculpture_b','12.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4858,32032,'Strange Machine','','strange_mechanical_instrument','16.00','15.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4859,32033,'Doctor Chaos','','doctor_chaos','9.00','15.60',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4860,32034,'Temple Gatekeeper','','heretical_sanctuary_gatekeeper_a','80.00','181.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4861,32035,'Temple Gatekeeper','','heretical_sanctuary_openner_a','28.00','70.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4862,32036,'Temple Gatekeeper','','heretical_sanctuary_gatekeeper_b','80.00','203.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4863,32037,'Temple Gatekeeper','','heretical_sanctuary_openner_b','28.00','70.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4864,32038,'Ritual Offering','','a_traderA_Mhuman_deco','8.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4865,32039,'Triol''s Mirror','','heretical_devil_mirror','28.00','70.00',70,'male','L2TriolsMirror','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4866,32040,'Triol''s Mirror','','heretical_devil_mirror','28.00','70.00',70,'male','L2TriolsMirror','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4867,32041,'Yumi','Collector','e_collector_teacher_FDwarf','8.00','17.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4868,32042,'Weathermaster','','pavel_weather_controller','14.50','18.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4869,32043,'Weathermaster','','pavel_weather_controller','14.50','18.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4870,32044,'Weathermaster','','Evilate_weather','16.00','18.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4871,32045,'Doctor Chaos'' Secret Bookshelf','','Evilate_doc_chaos','25.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4872,32046,'Suspicious-Looking Pile of Stones','','susceptor_env','20.00','35.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4873,32047,'Wendy','','e_teleporter_FDwarf','8.00','21.30',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4874,32048,'Event Gatekeeper','','cutie_cat','8.00','15.00',70,'female','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4875,32049,'Rooney','Blacksmith of Wind','a_smith_MDwarf','7.00','16.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4876,32050,'Parts Box','','box','18.00','14.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4877,32051,'Altar Gatekeeper','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4878,32052,'Obi','Railroad Worker','e_mine_teacher_MDwarf','8.00','18.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4879,32053,'Abey','Railroad Worker','e_mine_teacher_FDwarf','8.00','18.50',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4880,32054,'Ghost of a Railroad Engineer','','dwarf_ghost','10.00','18.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4881,32055,'Ghost of an Ancient Railroad Engineer','','dwarf_ghost','10.00','18.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4882,32056,'Aren','Khavatari','e_mageguild_teacher_FOrc','8.00','28.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4883,32057,'Totem Spirit of Gandi','','onyx_beast','14.00','14.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4884,32058,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4885,32059,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4886,32060,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4887,32061,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4888,32062,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4889,32063,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4890,32064,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4891,32065,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4892,32066,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4893,32067,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4894,32068,'Triol''s Revelation','','trioll_altar','9.00','33.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4895,32069,'Gutenhagen','Collector','e_guard_MDwarf','8.00','19.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4896,32070,'Adolph','','a_child_people_Mhuman','5.00','12.30',70,'male','L2Npc','EdwinFollower',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,26,45,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4897,32071,'Linda','','a_child_people_Fhuman','5.00','12.30',70,'female','L2Npc','EdwinFollower',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,24,50,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4898,32072,'Edwin','','a_old_people_Mhuman','9.00','17.30',70,'male','L2Npc','Edwin',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,6,32,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4899,32073,'Old Female Drifter','','a_old_people_Fhuman','9.00','17.30',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4900,32074,'Gludio Territory Manager','Guild President','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4901,32075,'Sandy the Cat','Tournament Helper','queen_of_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',0,0),
(4902,32076,'Box','','box','18.00','14.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4903,32077,'Ice Sculpture','','ice_sculpture_c','16.00','20.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4904,32078,'Ice Sculpture','','ice_sculpture_c','16.00','20.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4905,32079,'Ice Sculpture','','ice_sculpture_c','16.00','20.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.56','false',1,0),
(4906,32082,'Dion Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4907,32083,'Giran Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4908,32084,'Oren Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4909,32085,'Aden Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4910,32086,'Innadril Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4911,32087,'Schuttgart Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4912,32088,'Goddard Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4913,32089,'Rune Territory Manager','Adventure Guildsman','a_mageguild_teacher_MHuman','8.00','23.00',70,'male','L2Adventurer','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Tigra','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4914,32090,'Dead Leopard''s Carcass','','onyx_beast_ns','14.00','14.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',1,0),
(4915,32091,'Omega''s Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4916,32092,'Alder','Warehouse Chief','e_warehouse_master_MDwarf','8.00','17.50',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4917,32093,'Bolin','Head Blacksmith','e_common_people_MDwarf','8.00','17.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4918,32094,'Schule','Grand Master','a_fighterguild_master_FHuman','8.00','21.50',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4919,32095,'Marie','High Priest','a_sanctuary_teacher_FHuman','8.00','22.50',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4920,32096,'Helminter','Grand Master','a_fighterguild_teacher_FDarkElf','8.00','23.00',70,'male','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0);
INSERT INTO `npc` VALUES
(4921,32097,'Finker','High Prefect','e_trader_FOrc','8.00','24.00',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4922,32098,'Celes','Grand Magister','a_mageguild_master_FHuman','8.00','23.00',70,'female','L2VillageMaster','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(4923,32099,'Tony the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4924,32100,'Tony the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4925,32101,'Tony the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4926,32102,'Tony the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4927,32103,'Telling the Cat','Event Manager','cutie_cat','8.00','15.00',70,'female','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,48,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(4928,32104,'Vervato','','Crokian_Sorcerer','25.00','33.00',70,'male','L2Npc','Mystic',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4929,32105,'Dinn','','a_traderC_Mhuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4930,32106,'Singsing','','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4931,32107,'Teleport Cube','','teleport_npc','40.00','80.00',70,'male','L2Merchant','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(4932,32108,'','','rhamphorhynchus_npc','1.00','30.00',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(4933,32109,'Shilen''s Stone Statue','','primeval_raid_teleporter','24.00','72.50',70,'male','L2Merchant','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4934,32110,'','','clear_npc','0.10','0.10',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(4935,32111,'Orahochin','','Crokian_Sorcerer','25.00','33.00',70,'male','L2Merchant','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4936,32112,'Gariachin','','Crokian_Sorcerer','25.00','33.00',70,'male','L2Merchant','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4937,32113,'Marquez','','a_wharfinger_MHuman','8.00','23.00',70,'male','L2Merchant','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4938,32114,'Mushika','','Crokian_Elder','25.00','33.00',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4939,32115,'Asamah','','Crokian_Vice_Elder','45.00','41.50',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4940,32116,'Kirikachin','','Crokian_Vice_Elder','45.00','41.50',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4941,32117,'Karakawei','','Crokian_Sorcerer','25.00','33.00',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4942,32118,'Mantarasa Egg','','dinosaur_nest','43.00','33.50',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,0,0,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4943,32119,'Ulu Kaimu','','Evilate_doc_chaos','25.00','33.50',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(4944,32120,'Balu Kaimu','','Evilate_doc_chaos','25.00','33.50',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(4945,32121,'Chuta Kaimu','','Evilate_doc_chaos','25.00','33.50',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(4946,32122,'Warrior''s Grave','','Evilate_weather','16.00','18.50',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',1,0),
(4947,32123,'Valakas','','valakas_f','190.00','335.00',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,0,0,0,0,0,0,0,0,'0.00','false',0,0),
(4948,32124,'Great Soul','','Soul_Collector_Npc','14.00','25.00',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(4949,32125,'Great Soul','','Soul_Collector_Npc','14.00','25.00',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(4950,32126,'Priest Guard','','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(4951,32127,'Priest Guard','','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(4952,32128,'Guardian Wizard of the Cloth','','a_traderB_FHuman','8.00','25.00',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(4953,32129,'','','valakas_f_dummy','8.00','10.00',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(4954,32130,'Looney the Cat','Event Manager','king_of_cat','8.00','16.01',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(4955,32131,'Bonny','Event Manager','e_smith_Fdwarf','8.00','17.50',70,'male','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(4956,32132,'Alchemist''s Servitor','','NPC.training_doll_150p','13.00','40.00',70,'etc','L2Npc','npc',40,3862,'11.850',1493,'2.780',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,'',0,'Local','',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(4957,35010,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','SiegeGuardFighter',40,2317,'6.500',3830,'2.400',40,43,30,21,20,10,0,0,1683,687,546,233,416,0,379,128,628,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,20,0,7,30,4,4,0,0,'0.60','false',0,0),
(4958,35011,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','SiegeGuardFighter',80,2317,'6.500',3830,'2.400',40,43,30,21,20,10,0,0,1798,787,546,233,357,0,325,93,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(4959,35012,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','SiegeGuardRanger',1100,2245,'6.500',3830,'2.400',40,43,30,21,20,10,0,0,1889,544,546,233,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,10,8,0,1500,10,'0.60','false',0,0),
(4960,35013,'Mercenary','','a_royal_guardA_MHuman','8.00','24.00',50,'female','L2SiegeGuard','SiegeGuardMystic',800,2245,'6.500',4245,'5.200',40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4961,35014,'Mercenary','','a_royal_guardA_MHuman','8.00','24.00',50,'male','L2SiegeGuard','SiegeGuardMystic',800,2245,'6.500',4245,'5.200',40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,179,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4962,35015,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','SiegeGuardFighter',40,2245,'8.500',3830,'6.500',40,43,30,21,20,10,0,0,1683,687,546,233,416,0,379,128,628,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,20,0,7,30,4,4,0,0,'0.60','false',0,0),
(4963,35016,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','SiegeGuardFighter',80,2317,'8.500',3830,'6.500',40,43,30,21,20,10,0,0,1798,787,546,233,357,0,325,93,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(4964,35017,'Mercenary','','a_guard_MHuman','8.00','24.00',50,'male','L2SiegeGuard','SiegeGuardRanger',1100,2245,'8.500',3830,'6.500',40,43,30,21,20,10,0,0,1889,544,546,233,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,10,8,0,1500,10,'0.60','false',0,0),
(4965,35018,'Mercenary','','a_royal_guardA_MHuman','8.00','24.00',50,'female','L2SiegeGuard','SiegeGuardMystic',800,2245,'8.500',4245,'7.200',40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4966,35019,'Mercenary','','a_royal_guardA_MHuman','8.00','24.00',50,'male','L2SiegeGuard','SiegeGuardMystic',800,2245,'8.500',4245,'7.200',40,43,30,21,20,10,0,0,683,517,1546,233,416,0,379,179,0,0,50,195,'mercenary_siege_clan',1200,'help','2006-10-07',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4967,35020,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','SiegeGuardFighter',40,3986,'2.700',1493,'2.700',40,43,30,21,20,10,0,0,1763,485,1610,394,416,0,379,150,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4968,35021,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','SiegeGuardFighter',80,3986,'2.700',1493,'2.700',40,43,30,21,20,10,0,0,2058,485,1610,394,357,0,325,97,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(4969,35022,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','SiegeGuardRanger',1100,3986,'2.700',1493,'2.700',40,43,30,21,20,10,0,0,2292,412,1610,394,322,0,293,288,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,'0.60','false',0,0),
(4970,35023,'Mercenary of Dawn','','a_royal_guardA_MHuman','8.00','24.00',70,'female','L2SiegeGuard','SiegeGuardMystic',40,3986,'2.700',2240,'4.100',40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4971,35024,'Mercenary of Dawn','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2SiegeGuard','SiegeGuardMystic',40,3986,'2.700',2240,'4.100',40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,196,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4972,35025,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','SiegeGuardFighter',40,3986,'2.700',1493,'2.700',40,43,30,21,20,10,0,0,1763,485,1610,394,416,0,379,150,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4973,35026,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','SiegeGuardFighter',80,3986,'2.700',1493,'2.700',40,43,30,21,20,10,0,0,2058,485,1610,394,357,0,325,97,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(4974,35027,'Mercenary of Dawn','','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeGuard','SiegeGuardRanger',1100,3986,'2.700',1493,'2.700',40,43,30,21,20,10,0,0,2292,412,1610,394,322,0,293,288,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,'0.60','false',0,0),
(4975,35028,'Mercenary of Dawn','','a_royal_guardA_MHuman','8.00','24.00',70,'female','L2SiegeGuard','SiegeGuardMystic',40,3986,'2.700',2240,'4.100',40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4976,35029,'Mercenary of Dawn','','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2SiegeGuard','SiegeGuardMystic',40,3986,'2.700',2240,'4.100',40,43,30,21,20,10,0,0,1763,536,1610,394,416,0,379,196,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4977,35030,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,3153,'2.400',1150,'2.400',40,43,30,21,20,10,0,0,1154,380,988,309,416,0,379,132,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4978,35031,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',80,3153,'2.400',1150,'2.400',40,43,30,21,20,10,0,0,1347,380,988,309,357,0,325,301,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(4979,35032,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardRanger',1100,3818,'2.400',1150,'2.400',40,43,30,21,20,10,0,0,1501,323,988,309,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,'0.60','false',0,0),
(4980,35033,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman','8.00','24.00',60,'female','L2SiegeGuard','SiegeGuardMystic',40,3153,'2.400',1726,'3.600',40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4981,35034,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardMystic',40,3153,'2.400',1726,'3.600',40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4982,35035,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,3153,'2.400',1150,'2.400',40,43,30,21,20,10,0,0,1154,380,988,309,416,0,379,132,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4983,35036,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',80,3153,'2.400',1150,'2.400',40,43,30,21,20,10,0,0,1347,380,988,309,357,0,325,301,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(4984,35037,'Elite Mercenary Guild Member','','a_guard_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardRanger',1100,3054,'2.400',1150,'2.400',40,43,30,21,20,10,0,0,1501,323,988,309,322,0,293,280,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,'0.60','false',0,0),
(4985,35038,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman','8.00','24.00',60,'female','L2SiegeGuard','SiegeGuardMystic',40,3153,'2.400',1726,'3.600',40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,316,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4986,35039,'Elite Mercenary Guild Member','','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardMystic',40,3153,'2.400',1726,'3.600',40,43,30,21,20,10,0,0,1154,420,988,309,416,0,379,325,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4987,35040,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','SiegeGuardFighter',40,2728,'2.400',987,'2.400',40,43,30,21,20,10,0,0,899,332,744,270,416,0,379,66,20,0,50,195,'mercenary_siege_clan',1200,'Local','',0,20,0,7,30,4,4,0,0,'0.60','false',0,0),
(4988,35041,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','SiegeGuardFighter',80,2728,'2.400',987,'2.400',40,43,30,21,20,10,0,0,1050,332,744,270,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(4989,35042,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','SiegeGuardRanger',1100,2728,'2.400',987,'2.400',40,43,30,21,20,10,0,0,1169,282,744,270,322,0,293,274,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,'0.60','false',0,0),
(4990,35043,'Greater Recruit','','a_royal_guardA_MHuman','8.00','24.00',55,'female','L2SiegeGuard','SiegeGuardMystic',40,2728,'2.400',1481,'3.600',40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,7,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4991,35044,'Greater Recruit','','a_royal_guardA_MHuman','8.00','24.00',55,'male','L2SiegeGuard','SiegeGuardMystic',40,2728,'2.400',1481,'3.600',40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,154,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4992,35045,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','SiegeGuardFighter',40,2728,'2.400',987,'2.400',40,43,30,21,20,10,0,0,899,332,744,270,416,0,379,66,20,0,50,195,'mercenary_siege_clan',1200,'Local','',0,20,0,7,30,4,4,0,0,'0.60','false',0,0),
(4993,35046,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','SiegeGuardFighter',80,2728,'2.400',987,'2.400',40,43,30,21,20,10,0,0,1050,332,744,270,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(4994,35047,'Greater Recruit','','a_guard_MHuman','8.00','24.00',55,'male','L2SiegeGuard','SiegeGuardRanger',1100,2728,'2.400',987,'2.400',40,43,30,21,20,10,0,0,1169,282,744,270,322,0,293,274,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,'0.60','false',0,0),
(4995,35048,'Greater Recruit','','a_royal_guardA_MHuman','8.00','24.00',55,'female','L2SiegeGuard','SiegeGuardMystic',40,2728,'2.400',1481,'3.600',40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,7,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4996,35049,'Greater Recruit','','a_royal_guardA_MHuman','8.00','24.00',55,'male','L2SiegeGuard','SiegeGuardMystic',40,2728,'2.400',1481,'3.600',40,43,30,21,20,10,0,0,899,367,744,270,416,0,379,154,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(4997,35050,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','SiegeGuardFighter',40,1930,'2.100',677,'2.100',40,43,30,21,20,10,0,0,506,245,390,199,416,0,379,66,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(4998,35051,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','SiegeGuardFighter',80,1930,'2.100',677,'2.100',40,43,30,21,20,10,0,0,591,245,390,199,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(4999,35052,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','SiegeGuardRanger',1100,1930,'2.100',677,'2.100',40,43,30,21,20,10,0,0,658,209,390,199,322,0,293,14,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,'0.60','false',0,0),
(5000,35053,'Recruit','','a_royal_guardA_MHuman','8.00','24.00',45,'female','L2SiegeGuard','SiegeGuardMystic',40,1930,'2.100',1016,'3.200',40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,6,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(5001,35054,'Recruit','','a_royal_guardA_MHuman','8.00','24.00',45,'male','L2SiegeGuard','SiegeGuardMystic',40,1930,'2.100',1016,'3.200',40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,99,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(5002,35055,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','SiegeGuardFighter',40,1930,'2.100',677,'2.100',40,43,30,21,20,10,0,0,506,245,390,199,416,0,379,66,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5003,35056,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','SiegeGuardFighter',80,1930,'2.100',677,'2.100',40,43,30,21,20,10,0,0,591,245,390,199,357,0,325,16,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5004,35057,'Recruit','','a_guard_MHuman','8.00','24.00',45,'male','L2SiegeGuard','SiegeGuardRanger',1100,1930,'2.100',677,'2.100',40,43,30,21,20,10,0,0,658,209,390,199,322,0,293,14,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,10,'0.60','false',0,0),
(5005,35058,'Recruit','','a_royal_guardA_MHuman','8.00','24.00',45,'female','L2SiegeGuard','SiegeGuardMystic',40,1930,'2.100',1016,'3.200',40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,6,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(5006,35059,'Recruit','','a_royal_guardA_MHuman','8.00','24.00',45,'male','L2SiegeGuard','SiegeGuardMystic',40,1930,'2.100',1016,'3.200',40,43,30,21,20,10,0,0,506,271,390,199,416,0,379,99,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,10,'0.60','false',0,0),
(5007,35060,'Nephilim Mercenary','','a_guard_MHuman','8.00','24.00',75,'male','L2SiegeGuard','SiegeGuardFighter',40,189460,'178.300',855,'2.300',84,71,73,76,70,80,0,0,5261,1047,3228,425,526,0,3727,0,0,0,65,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,5,0,-4,'0.63','false',0,0),
(5008,35061,'Nephilim Mercenary','','a_royal_guardA_MHuman','8.00','24.00',72,'male','L2SiegeGuard','SiegeGuardMystic',40,185726,'178.000',800,'2.300',84,71,73,76,70,80,0,0,4792,983,2909,399,613,0,4347,7,0,0,50,195,'mercenary_siege_clan',1200,'Local','',0,0,0,7,30,4,5,0,-4,'0.48','false',0,0),
(5009,35062,'Headquarters','','flag_a','15.00','58.00',1,'etc','L2Npc','npc',40,158000,'2.000',989,'0.900',40,43,30,21,20,10,0,0,652,753,358,295,423,0,385,0,0,0,50,120,'',0,'Local','',35062,0,0,7,0,4,3,0,0,'0.60','false',0,0),
(5010,35063,'Gludio Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5011,35064,'Baron Lewin Waldner','','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,'7.500',3958,'2.700',40,43,30,21,20,10,0,0,4308,418,619,340,278,0,253,79,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5012,35065,'Cronenberg','Sir','a_royal_guardA_MHuman','8.00','24.00',62,'male','L2SiegeGuard','SiegeGuardFighter',40,51515,'7.500',3653,'2.700',40,43,30,21,20,10,384,1,3777,388,532,315,278,0,253,142,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5013,35066,'Royal Knight','Gludio','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'gludio_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5014,35067,'Court Sorcerer','Gludio','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5015,35068,'Court Sorcerer','Gludio','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5016,35069,'Court Guard','Gludio','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5017,35070,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5018,35071,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5019,35072,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5020,35073,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5021,35074,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5022,35075,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5023,35076,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5024,35077,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5025,35078,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5026,35079,'Royal Knight','Gludio','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'gludio_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5027,35080,'Court Sorcerer','Gludio','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5028,35081,'Court Sorcerer','Gludio','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5029,35082,'Court Guard','Gludio','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5030,35083,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5031,35084,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5032,35085,'Guard','Gludio','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5033,35086,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5034,35087,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5035,35088,'Guard','Gludio','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5036,35089,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5037,35090,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5038,35091,'Guard','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'gludio_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5039,35092,'Gatekeeper','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'gludio_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5040,35093,'Gatekeeper','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'gludio_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5041,35094,'Gatekeeper','Gludio','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'gludio_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5042,35095,'Mass Gatekeeper','Gludio','a_guard_MHuman','8.00','24.00',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5043,35096,'Outer Doorman','Gludio','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5044,35097,'Inner Doorman','Gludio','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5045,35098,'Blacksmith','Gludio','e_smith_master_MDwarf','8.00','17.00',70,'male','L2CastleBlacksmith','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5046,35099,'Warehouse Keeper','Gludio','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2CastleWarehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5047,35100,'Sayres','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5048,35101,'Grad','Wyvern Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2WyvernManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5049,35102,'Greenspan','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5050,35103,'Manor Manager','Gludio','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5051,35104,'Tyron','Sir','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5052,35105,'Dion Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5053,35106,'Duke Byron Ashton','','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,'7.500',3958,'2.700',40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5054,35107,'Ivano','Sir','a_royal_guardA_MHuman','8.00','24.00',62,'male','L2SiegeGuard','SiegeGuardFighter',40,51515,'7.500',3653,'2.700',40,43,30,21,20,10,384,1,3777,388,532,315,278,0,253,142,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5055,35108,'Royal Knight','Dion','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'dion_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5056,35109,'Court Sorcerer','Dion','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5057,35110,'Court Sorcerer','Dion','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5058,35111,'Court Guard','Dion','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5059,35112,'Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5060,35113,'Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5061,35114,'Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5062,35115,'Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5063,35116,'Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5064,35117,'Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5065,35118,'Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5066,35119,'Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5067,35120,'Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5068,35121,'Royal Knight','Dion','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'dion_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5069,35122,'Court Sorcerer','Dion','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5070,35123,'Court Sorcerer','Dion','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5071,35124,'Court Guard','Dion','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5072,35125,'Court Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5073,35126,'Court Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5074,35127,'Court Guard','Dion','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5075,35128,'Court Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5076,35129,'Court Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5077,35130,'Court Guard','Dion','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5078,35131,'Court Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5079,35132,'Court Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0);
INSERT INTO `npc` VALUES
(5080,35133,'Court Guard','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'dion_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5081,35134,'Gatekeeper','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5082,35135,'Gatekeeper','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5083,35136,'Gatekeeper','Dion','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5084,35137,'Mass Gatekeeper','Dion','a_guard_MHuman','8.00','24.00',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5085,35138,'Outer Doorman','Dion','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5086,35139,'Inner Doorman','Dion','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5087,35140,'Blacksmith','Dion','e_smith_master_MDwarf','8.00','17.00',70,'male','L2CastleBlacksmith','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5088,35141,'Warehouse Keeper','Dion','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2CastleWarehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5089,35142,'Crosby','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5090,35143,'Hodler','Wyvern Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2WyvernManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5091,35144,'Mercenary Manager Sanford','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5092,35145,'Manor Manager','Dion','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5093,35146,'Gibbson','Herald','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5094,35147,'Giran Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5095,35148,'Baron Carmon Esthus','','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,'7.500',3958,'2.700',40,43,30,21,20,10,0,0,4308,418,619,340,278,0,253,79,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5096,35149,'Ulric','Sir','a_royal_guardA_MHuman','8.00','24.00',62,'male','L2SiegeGuard','SiegeGuardFighter',40,51515,'7.500',3653,'2.700',40,43,30,21,20,10,0,0,3777,388,532,315,278,0,253,142,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5097,35150,'Royal Knight','Giran','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'giran_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5098,35151,'Court Sorcerer','Giran','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5099,35152,'Court Sorcerer','Giran','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5100,35153,'Court Guard','Giran','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5101,35154,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5102,35155,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5103,35156,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5104,35157,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5105,35158,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5106,35159,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5107,35160,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5108,35161,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5109,35162,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5110,35163,'Royal Knight','Giran','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'giran_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5111,35164,'Court Sorcerer','Giran','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5112,35165,'Court Sorcerer','Giran','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5113,35166,'Court Guard','Giran','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5114,35167,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5115,35168,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5116,35169,'Guard','Giran','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5117,35170,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5118,35171,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5119,35172,'Guard','Giran','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5120,35173,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5121,35174,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5122,35175,'Guard','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'giran_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5123,35176,'Gatekeeper','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'giran_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5124,35177,'Gatekeeper','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'giran_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5125,35178,'Gatekeeper','Giran','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'giran_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5126,35179,'Mass Gatekeeper','Giran','a_guard_MHuman','8.00','24.00',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5127,35180,'Outer Doorman','Giran','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5128,35181,'Inner Doorman','Giran','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5129,35182,'Blacksmith','Giran','a_smith_MDwarf','7.00','16.50',70,'male','L2CastleBlacksmith','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5130,35183,'Warehouse Keeper','Giran','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2CastleWarehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5131,35184,'Saul','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5132,35185,'Bryce','Wyvern Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2WyvernManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5133,35186,'Arvid','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5134,35187,'Manor Manager','Giran','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5135,35188,'Holmes','Sir','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5136,35189,'Oren Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5137,35190,'Balthus Van Dyke','Duke','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,'7.500',3958,'2.700',40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5138,35191,'Quant','Sir','a_royal_guardA_MHuman','8.00','24.00',62,'male','L2SiegeGuard','SiegeGuardFighter',40,51515,'7.500',3653,'2.700',40,43,30,21,20,10,0,0,3777,388,532,315,278,0,253,142,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5139,35192,'Royal Knight','Oren','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'oren_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5140,35193,'Court Sorcerer','Oren','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5141,35194,'Court Sorcerer','Oren','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5142,35195,'Court Guard','Oren','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5143,35196,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5144,35197,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5145,35198,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5146,35199,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5147,35200,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5148,35201,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5149,35202,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5150,35203,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5151,35204,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5152,35205,'Royal Knight','Oren','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'oren_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5153,35206,'Court Sorcerer','Oren','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5154,35207,'Court Sorcerer','Oren','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5155,35208,'Court Guard','Oren','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5156,35209,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5157,35210,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5158,35211,'Guard','Oren','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5159,35212,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5160,35213,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5161,35214,'Guard','Oren','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5162,35215,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5163,35216,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5164,35217,'Guard','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5165,35218,'Gatekeeper','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'oren_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5166,35219,'Gatekeeper','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'oren_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5167,35220,'Gatekeeper','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'oren_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5168,35221,'Mass Gatekeeper','Oren','a_guard_MHuman','8.00','24.00',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5169,35222,'Outer Doorman','Oren','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5170,35223,'Inner Doorman','Oren','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5171,35224,'Blacksmith','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2CastleBlacksmith','npc',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5172,35225,'Warehouse Keeper','Oren','a_guard_MHuman','8.00','24.00',56,'male','L2CastleWarehouse','npc',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5173,35226,'Brasseur','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5174,35227,'Finrod','Wyvern Manager','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2WyvernManager','npc',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,0,0,1721,368,478,299,278,0,253,76,2497,0,50,120,'oren_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',0,0),
(5175,35228,'Morrison','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5176,35229,'Manor Manager','Oren','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,'6.500',3254,'2.400',40,43,30,21,20,10,0,0,1562,349,428,284,278,0,253,0,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5177,35230,'Manor Manager','Oren','a_trader_MElf','8.00','25.00',70,'male','L2ManorManager','npc',80,3862,'6.500',3254,'2.400',40,43,30,21,20,10,0,0,1562,349,428,284,237,0,216,0,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5178,35231,'Manor Manager','Oren','a_common_people_MDarkElf','8.00','23.00',70,'male','L2ManorManager','npc',80,3862,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,0,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5179,35232,'Sherwood','Messenger','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5180,35233,'Aden Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,721,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,189,23,76,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5181,35234,'Amadeo Cadmus','King','a_lord_MHuman','8.00','23.00',75,'male','L2SiegeGuard','SiegeGuardFighter',40,84582,'8.500',6694,'3.000',40,43,30,21,20,10,562,1,9383,523,957,425,278,0,253,80,0,0,50,120,'oren_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5182,35235,'Royal Knight','Aden','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2SiegeGuard','SiegeGuardFighter',40,38622,'7.500',5975,'2.700',40,43,30,21,20,10,0,0,3943,470,780,382,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5183,35236,'Court Sorcerer','Aden','a_royal_guardA_MHuman','8.00','24.00',68,'male','L2SiegeGuard','SiegeGuardMystic',40,37063,'7.500',5693,'2.700',40,43,30,21,20,10,0,0,3652,449,713,365,278,0,253,7,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(5184,35237,'Court Sorcerer','Aden','a_royal_guardA_MHuman','8.00','24.00',68,'male','L2SiegeGuard','SiegeGuardMystic',40,37063,'7.500',5693,'2.700',40,43,30,21,20,10,0,0,3652,449,713,365,278,0,253,92,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(5185,35238,'Court Guard','Aden','a_royal_guardB_MHuman','8.00','24.00',68,'male','L2SiegeGuard','SiegeGuardFighter',80,37063,'7.500',5693,'2.700',40,43,30,21,20,10,0,0,3652,449,713,365,237,0,216,1376,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5186,35239,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','SiegeGuardFighter',80,35465,'7.500',5415,'2.700',40,43,30,21,20,10,436,1,3369,428,649,348,237,0,216,300,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5187,35240,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','SiegeGuardFighter',40,35465,'7.500',5415,'2.700',40,43,30,21,20,10,436,1,3369,428,649,348,278,0,253,132,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5188,35241,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','SiegeGuardRanger',1100,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5189,35242,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardFighter',80,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5190,35243,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardFighter',40,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5191,35244,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardRanger',1100,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5192,35245,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','SiegeGuardFighter',80,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5193,35246,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','SiegeGuardFighter',40,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5194,35247,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','SiegeGuardRanger',1100,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5195,35248,'Royal Knight','Aden','a_royal_guardA_MHuman','8.00','24.00',70,'male','L2SiegeGuard','SiegeGuardFighter',40,38622,'7.500',5975,'2.700',40,43,30,21,20,10,490,1,3943,470,780,382,278,0,253,142,633,0,50,120,'aden_siege_clan',1200,'Local','',0,20,147,7,30,4,4,0,-6,'0.60','false',1,0),
(5196,35249,'Court Sorcerer','Aden','a_royal_guardA_MHuman','8.00','24.00',68,'male','L2SiegeGuard','SiegeGuardMystic',40,37063,'7.500',5693,'2.700',40,43,30,21,20,10,462,1,3652,449,713,365,278,0,253,326,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5197,35250,'Court Sorcerer','Aden','a_royal_guardA_MHuman','8.00','24.00',68,'female','L2SiegeGuard','SiegeGuardMystic',40,37063,'7.500',5693,'2.700',40,43,30,21,20,10,462,1,3652,449,713,365,278,0,253,325,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5198,35251,'Court Guard','Aden','a_royal_guardB_MHuman','8.00','24.00',68,'male','L2SiegeGuard','SiegeGuardFighter',80,37063,'7.500',5693,'2.700',40,43,30,21,20,10,462,1,3652,449,713,365,237,0,216,300,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5199,35252,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','SiegeGuardFighter',80,35465,'7.500',5415,'2.700',40,43,30,21,20,10,436,1,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5200,35253,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','SiegeGuardFighter',40,35465,'7.500',5415,'2.700',40,43,30,21,20,10,436,1,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5201,35254,'Guard','Aden','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','SiegeGuardRanger',1100,35465,'7.500',5415,'2.700',40,43,30,21,20,10,436,1,7486,428,649,348,249,0,227,285,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5202,35255,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardFighter',80,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5203,35256,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardFighter',40,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5204,35257,'Guard','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardRanger',1100,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5205,35258,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','SiegeGuardFighter',80,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5206,35259,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','SiegeGuardFighter',40,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5207,35260,'Guard','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','SiegeGuardRanger',1100,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,7486,428,649,348,249,0,227,14,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5208,35261,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,3633,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5209,35262,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,3633,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5210,35263,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,3633,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5211,35264,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,3633,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5212,35265,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',56,'male','L2CastleTeleporter','npc',40,3633,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,662,382,268,282,0,257,0,0,0,50,120,'aden_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5213,35266,'Mass Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5214,35267,'Outer Doorman','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5215,35268,'Inner Doorman','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5216,35269,'Hall Doorman','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5217,35270,'Inner Doorman','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5218,35271,'Gatekeeper','Aden','a_guard_MHuman','8.00','24.00',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5219,35272,'Blacksmith','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2CastleBlacksmith','npc',80,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5220,35273,'Warehouse Keeper','Aden','a_guard_FDarkelf','8.00','25.00',66,'female','L2CastleWarehouse','npc',40,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,3369,428,649,348,278,0,253,2,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5221,35274,'Logan','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5222,35275,'Kruger','Wyvern Manager','a_guard_MHuman','8.00','24.00',66,'male','L2WyvernManager','npc',80,35465,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,3369,428,649,348,237,0,216,16,0,0,50,120,'aden_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5223,35276,'Eldon','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5224,35277,'Manor Manager','Aden','a_guard_MHuman','8.00','24.00',66,'male','L2ManorManager','npc',1100,3862,'7.500',5415,'2.700',40,43,30,21,20,10,0,0,7486,428,649,0,0,0,227,0,0,0,50,120,'aden_siege_clan',1200,'SYS','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5225,35278,'Messenger Ruford','Messenger','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,135,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5226,35279,'Innadril Holy Artifact','','castle_kent_statue_jewel','25.00','98.00',20,'etc','L2Artefact','npc',40,541,'2.500',213,'1.200',40,43,30,21,20,10,0,0,57,94,23,76,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5227,35280,'Baron Lionel Hunter','','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,'7.500',3958,'2.700',40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5228,35281,'Schaht','Sir','a_royal_guardA_MHuman','8.00','24.00',62,'male','L2SiegeGuard','SiegeGuardFighter',40,51515,'7.500',3653,'2.700',40,43,30,21,20,10,384,1,3777,388,532,315,278,0,253,142,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5229,35282,'Royal Knight','Innadril','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'innadrile_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5230,35283,'Court Sorcerer','Innadril','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5231,35284,'Court Sorcerer','Innadril','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5232,35285,'Court Guard','Innadril','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5233,35286,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5234,35287,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5235,35288,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5236,35289,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5237,35290,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5238,35291,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0);
INSERT INTO `npc` VALUES
(5239,35292,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5240,35293,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5241,35294,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5242,35295,'Royal Knight','Innadril','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'innadrile_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5243,35296,'Court Sorcerer','Innadril','a_royal_guardA_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5244,35297,'Court Sorcerer','Innadril','a_royal_guardA_MHuman','8.00','24.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5245,35298,'Court Guard','Innadril','a_royal_guardB_MHuman','8.00','24.00',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5246,35299,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5247,35300,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,2499,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5248,35301,'Guard','Innadril','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,276,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5249,35302,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5250,35303,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5251,35304,'Guard','Innadril','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5252,35305,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5253,35306,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5254,35307,'Guard','Innadril','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'innadrile_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5255,35308,'Gatekeeper','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5256,35309,'Gatekeeper','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5257,35310,'Gatekeeper','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5258,35311,'Mass Gatekeeper','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5259,35312,'Outer Doorman','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5260,35313,'Inner Doorman','Innadril','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5261,35314,'Blacksmith','Innadril','a_smith_MDwarf','7.00','16.50',70,'male','L2CastleBlacksmith','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5262,35315,'Warehouse Keeper','Innadril','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2CastleWarehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5263,35316,'Neurath','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5264,35317,'Tate','Wyvern Manager','a_traderB_MHuman','8.00','24.50',70,'male','L2WyvernManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5265,35318,'Solinus','Mercenary Manager','a_common_peopleA_MHuman','8.00','21.50',70,'male','L2MercManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5266,35319,'Manor Manager','Innadril','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5267,35320,'Raybell','Sir','a_guard_MHuman','8.00','24.00',70,'male','L2SiegeNpc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5268,35322,'Altar of Fire','','godad_holything','24.00','65.00',20,'etc','L2Artefact','npc',40,558,'1.200',213,'1.200',40,43,30,21,20,10,0,0,57,97,23,79,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5269,35323,'Altar of Water','','godad_holything','24.00','65.00',20,'etc','L2Artefact','npc',40,558,'1.200',213,'1.200',40,43,30,21,20,10,0,0,57,97,23,79,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5270,35324,'Heinz','Royal Guard Captain','teleport_cube','30.00','65.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5271,35325,'Duke Mora Ken Abygail','','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','SiegeGuardFighter',40,55449,'7.500',3958,'2.700',40,43,30,21,20,10,422,1,4308,418,619,340,278,0,253,79,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5272,35326,'Royal Knight','Goddard','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'godad_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5273,35327,'Court Sorcerer','Goddard','a_patriarch_MElf','8.00','22.50',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5274,35328,'Court Sorcerer','Goddard','a_mageguild_master_FHuman','8.00','23.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5275,35329,'Guard','Goddard','e_elmore_guard_Mhuman','8.00','23.50',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,0,0,1562,349,428,284,237,0,216,1376,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5276,35330,'Bodyguard','Goddard','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5277,35331,'Bodyguard','Goddard','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5278,35332,'Bodyguard','Goddard','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5279,35333,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5280,35334,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5281,35335,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5282,35336,'Bodyguard','Goddard','e_guard_MOrc','8.00','27.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5283,35337,'Bodyguard','Goddard','e_guard_MOrc','8.00','27.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5284,35338,'Bodyguard','Goddard','a_guard_MHuman','8.00','24.00',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,280,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5285,35339,'Royal Knight','Goddard','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'godad_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',1,0),
(5286,35340,'Court Sorcerer','Goddard','a_patriarch_MElf','8.00','22.50',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5287,35341,'Court Sorcerer','Goddard','a_mageguild_master_FHuman','8.00','23.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,193,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',1,0),
(5288,35342,'Guard','Goddard','e_elmore_guard_Mhuman','8.00','23.50',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,0,0,1562,349,428,284,237,0,216,1376,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5289,35343,'Bodyguard','Goddard','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,237,0,216,93,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',1,0),
(5290,35344,'Bodyguard','Goddard','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5291,35345,'Bodyguard','Goddard','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5292,35346,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5293,35347,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,278,0,253,2,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5294,35348,'Bodyguard','Goddard','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,3139,331,382,269,249,0,227,14,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',0,0),
(5295,35349,'Bodyguard','Goddard','e_guard_MOrc','8.00','27.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5296,35350,'Bodyguard','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',40,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,1412,331,382,269,278,0,253,76,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5297,35351,'Bodyguard','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',1100,21799,'6.500',3059,'2.400',40,43,30,21,20,10,314,1,3139,331,382,269,249,0,227,280,0,0,50,120,'godad_siege_clan',1200,'Local','',0,0,0,7,10,8,0,1500,0,'0.60','false',1,0),
(5298,35352,'Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'godad_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5299,35353,'Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'godad_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5300,35354,'Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'godad_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5301,35355,'Mass Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5302,35356,'Outer Doorman','Goddard','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5303,35357,'Inner Doorman','Goddard','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5304,35358,'Inner Doorman','Goddard','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5305,35359,'Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5306,35360,'Gatekeeper','Goddard','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5307,35361,'Blacksmith','Goddard','a_smith_MDwarf','7.00','16.50',70,'male','L2CastleBlacksmith','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5308,35362,'Warehouse Keeper','Goddard','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2CastleWarehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5309,35363,'Alfred','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5310,35364,'Hadley','Wyvern Manager','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2WyvernManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5311,35365,'Rowell','Manager of Mercenary','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2MercManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5312,35366,'Manor Manager','Goddard','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5313,35367,'Daven','Messenger','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2SiegeNpc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,74,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5314,35368,'Bloody Lord Nurka','','oel_mahum','20.00','37.00',55,'male','L2Monster','Fighter',40,1264000,'40.000',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,282,0,257,72,0,0,70,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,'0.48','true',1,0),
(5315,35369,'Partisan Healer','','batur_orc_shaman','11.00','16.00',40,'male','L2Monster','Priest',40,1527,'4.500',531,'5.000',40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,7,0,0,50,120,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,'0.30','true',1,0),
(5316,35370,'Partisan Court Guard','','ol_mahum_champion','14.00','27.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,69,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,'0.63','true',1,0),
(5317,35371,'Partisan Court Guard','','ol_mahum_archer','14.00','25.00',40,'male','L2Monster','Ranger',1100,1527,'4.500',531,'1.800',40,43,30,21,20,10,0,0,333,201,131,164,254,0,231,14,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,1500,0,'0.93','true',1,0),
(5318,35372,'Partisan Soldier','','ol_mahum','13.50','25.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,2,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,'0.46','true',1,0),
(5319,35373,'Partisan Sorcerer','','batur_orc_shaman','11.00','16.00',35,'male','L2Monster','Mystic',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,7,0,0,50,120,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,'0.30','true',1,0),
(5320,35374,'Partisan Archer','','ol_mahum_archer','14.00','25.00',35,'male','L2Monster','Ranger',1100,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,427,169,89,137,254,0,231,14,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,1500,0,'0.93','true',1,0),
(5321,35375,'Bloody Lord Nurka','','oel_mahum','20.00','37.00',55,'male','L2Monster','Fighter',40,1264000,'60.000',987,'2.400',40,43,30,21,20,10,0,0,670,322,360,261,282,0,257,72,0,0,70,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,'0.48','true',0,0),
(5322,35376,'Partisan Healer','','batur_orc_shaman','11.00','16.00',40,'male','L2Monster','Priest',40,1527,'4.500',531,'5.000',40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,7,0,0,50,120,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,'0.30','true',0,0),
(5323,35377,'Partisan Court Guard','','ol_mahum_champion','14.00','27.00',40,'male','L2Monster','Fighter',40,1527,'4.500',531,'1.800',40,43,30,21,20,10,0,0,273,201,131,164,282,0,257,69,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,'0.63','true',0,0),
(5324,35378,'Partisan Court Guard','','ol_mahum_archer','14.00','25.00',40,'male','L2Monster','Ranger',1100,1527,'4.500',531,'1.800',40,43,30,21,20,10,0,0,333,201,131,164,254,0,231,14,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,1500,0,'0.93','true',0,0),
(5325,35379,'Partisan Soldier','','ol_mahum','13.50','25.00',35,'male','L2Monster','Fighter',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,2,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,'0.46','true',0,0),
(5326,35380,'Partisan Sorcerer','','batur_orc_shaman','11.00','16.00',35,'male','L2Monster','Mystic',40,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,192,169,89,137,282,0,257,7,0,0,50,120,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,0,0,'0.30','true',0,0),
(5327,35381,'Partisan Archer','','ol_mahum_archer','14.00','25.00',35,'male','L2Monster','Ranger',1100,1220,'4.500',446,'1.800',40,43,30,21,20,10,0,0,235,169,89,137,254,0,231,14,0,0,50,110,'partisan_clan',300,'Local','',0,0,0,7,30,4,3,1500,0,'0.93','true',0,0),
(5328,35382,'Brakel','Partisan Herald','ol_mahum_champion','14.00','27.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.63','false',1,0),
(5329,35383,'Tamutak','Ol Mahum Steward','ol_mahum_champion','14.00','27.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.63','false',1,0),
(5330,35384,'Black','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5331,35385,'Renny','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'4.500',414,'1.800',40,43,30,21,20,10,0,0,171,162,75,128,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5332,35386,'Boyer','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5333,35387,'Baback','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'4.500',514,'1.800',40,43,30,21,20,10,0,0,263,201,121,158,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5334,35388,'Tim','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5335,35389,'Loring','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'5.500',618,'2.100',40,43,30,21,20,10,0,0,343,230,163,181,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5336,35390,'Dillon','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5337,35391,'Latif','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'5.500',738,'2.100',40,43,30,21,20,10,0,0,440,262,216,206,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5338,35392,'Bremmer','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5339,35393,'Faolan','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'6.500',892,'2.400',40,43,30,21,20,10,0,0,588,304,300,239,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5340,35394,'Kalis','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5341,35395,'Kogan','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'3.500',242,'1.500',40,43,30,21,20,10,0,0,71,106,28,83,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5342,35396,'Winker','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5343,35397,'Merton','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'3.500',318,'1.500',40,43,30,21,20,10,0,0,107,129,45,102,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5344,35398,'Ruben','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5345,35399,'Luce','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'4.500',381,'1.800',40,43,30,21,20,10,0,0,147,151,64,118,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5346,35400,'Horner','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5347,35401,'Amiel','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'4.500',414,'1.800',40,43,30,21,20,10,0,0,171,162,75,128,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5348,35402,'Borna','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'4.500',446,'1.800',40,43,30,21,20,10,0,0,198,175,89,137,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5349,35403,'Ron','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5350,35404,'Jamal','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'5.500',589,'2.100',40,43,30,21,20,10,0,0,321,222,152,175,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5351,35405,'Flynn','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5352,35406,'Jabilo','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'5.500',677,'2.100',40,43,30,21,20,10,0,0,389,245,188,193,278,0,253,0,0,0,80,156,'',0,'Local','',0,0,0,7,10,4,4,0,0,'0.56','false',1,0),
(5353,35407,'Seth','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5354,35408,'Dietrich','','headless_knight','21.00','31.00',67,'male','L2DCSiegeBoss','Fighter',40,16388,'7.500',2777,'2.700',60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,'0.52','false',0,0),
(5355,35409,'Mikhail','','headless_knight','21.00','31.00',67,'male','L2DCSiegeBoss','Fighter',40,16388,'7.500',2777,'2.700',60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,'0.52','false',0,0),
(5356,35410,'Gustav','','headless_knight','21.00','31.00',70,'male','L2DCSiegeBoss','Fighter',40,8092000,'7.500',2987,'2.700',60,57,73,76,70,80,0,0,3987,469,1732,381,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,'0.52','false',1,0),
(5357,35411,'Doom Servant','','hungry_spirit','13.00','40.00',65,'male','L2Monster','Fighter',40,9571,'7.500',1150,'2.700',40,43,30,21,20,10,0,0,2151,417,617,338,278,150,253,0,0,0,15,120,'gustav_clan',1000,'Local','',0,0,0,7,50,1,40,0,0,'0.45','true',1,0),
(5358,35412,'Doom Guard','','hungry_spirit','13.00','40.00',66,'male','L2Monster','Fighter',50,10639,'7.500',1184,'2.700',40,43,30,21,20,10,0,0,2243,427,649,347,278,0,253,0,0,0,15,120,'gustav_clan',1000,'Local','',0,0,0,7,50,1,40,0,0,'0.45','true',1,0),
(5359,35413,'Doom Archer','','skeleton_archer','11.00','27.00',67,'male','L2Monster','Ranger',1100,10879,'7.500',1217,'2.700',40,43,30,21,20,10,0,0,5191,438,680,356,249,0,227,286,0,0,40,140,'gustav_clan',700,'Local','',0,0,0,7,10,8,40,1500,0,'0.80','true',1,0),
(5360,35414,'Doom Trooper','','skeleton_pikeman','10.00','28.00',68,'male','L2Monster','Fighter',80,11118,'7.500',1251,'2.700',40,43,30,21,20,10,0,0,2839,449,713,364,238,0,217,301,0,0,50,155,'gustav_clan',1000,'Local','',0,0,0,7,30,4,40,0,0,'0.21','true',1,0),
(5361,35415,'Doom Warrior','','skeleton_knight','10.00','25.00',69,'male','L2Monster','Fighter',40,11353,'7.500',1285,'2.700',40,43,30,21,20,10,0,0,2529,459,745,373,317,150,289,71,0,0,40,160,'gustav_clan',1000,'Local','',0,0,0,7,10,8,40,0,0,'0.17','true',1,0),
(5362,35416,'Doom Knight','','death_blader','15.00','45.00',70,'male','L2Monster','Fighter',40,11586,'7.500',1319,'2.700',40,43,30,21,20,10,0,0,2297,469,779,381,278,150,253,1472,0,0,100,170,'gustav_clan',1000,'Local','',0,0,0,7,30,4,40,0,0,'0.45','true',1,0),
(5363,35417,'Doorman of Hell','','dwarf_ghost','10.00','18.70',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.48','false',0,0),
(5364,35418,'Doorman of Hell','','dwarf_ghost','10.00','18.70',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.48','false',0,0),
(5365,35419,'Hephaeston','Wyvern Manager','human_ghost','8.00','22.00',70,'male','L2WyvernManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5366,35420,'Loken','Messenger','human_ghost','8.00','22.00',70,'male','L2DCSiegeMessenger','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,74,0,0,80,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.39','false',1,0),
(5367,35421,'Biggerstaff','Steward','elf_ghost','7.00','21.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,80,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.41','true',1,0),
(5368,35422,'Flag of Winner','','azit_a','100.00','72.00',56,'etc','L2Deco','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5369,35423,'Red Flag','','azit_b','75.00','55.00',56,'etc','L2Deco','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5370,35424,'Yellow Flag','','azit_b','75.00','55.00',56,'etc','L2Deco','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5371,35425,'Green Flag','','azit_b','75.00','55.00',56,'etc','L2Deco','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5372,35426,'Blue Flag','','azit_b','75.00','55.00',56,'etc','L2Deco','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5373,35427,'Purple Flag','','azit_b','75.00','55.00',56,'etc','L2Deco','npc',40,2725,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,50,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5374,35428,'Oel Mahum Berserker','','oel_mahum_warrior','20.00','38.00',60,'male','L2Monster','Fighter',40,125202,'196.000',3420,'10.000',60,57,73,76,70,80,0,0,680,1476,5200,598,333,0,2362,0,0,0,70,140,'',0,'Local','',0,0,0,7,30,4,40,0,-18,'0.65','true',1,0),
(5375,35429,'Oel Mahum Scout','','oel_mahum_warrior','20.00','38.00',60,'male','L2Monster','Fighter',40,56341,'196.000',3420,'10.000',60,57,73,76,70,80,0,0,680,1476,5200,598,333,0,2362,0,0,0,70,140,'',0,'Local','',0,0,0,7,30,4,40,0,-18,'0.65','true',1,0),
(5376,35430,'Oel Mahum Leader','','oel_mahum_witch_doctor','15.00','34.00',60,'male','L2Monster','Fighter',40,62601,'196.000',3420,'10.000',60,57,73,76,70,80,0,0,680,2953,5200,299,333,0,2362,0,0,0,70,140,'',0,'Local','',0,0,0,7,30,4,40,0,-18,'0.26','true',1,0),
(5377,35431,'Oel Mahum Cleric','','oel_mahum_witch_doctor','15.00','34.00',60,'male','L2Monster','Priest',40,62601,'196.000',3420,'10.000',60,57,73,76,70,80,0,0,680,738,5200,1197,333,0,2362,0,0,0,70,140,'',0,'Local','',0,0,0,7,30,4,40,0,-18,'0.26','true',1,0),
(5378,35432,'Oel Mahum Thief','','oel_mahum_40_sm','12.00','19.00',60,'male','L2Monster','Fighter',40,50080,'156.800',3420,'10.000',60,57,73,76,70,80,0,0,544,1181,5200,538,333,0,2362,0,0,0,70,140,'',0,'Local','',0,0,0,7,30,4,40,0,-18,'0.48','true',1,0),
(5379,35433,'Inner Doorman','','oel_mahum','20.00','37.00',70,'male','L2Npc','npc',40,5149,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.48','false',1,0),
(5380,35434,'Inner Doorman','','oel_mahum','20.00','37.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.48','false',1,0),
(5381,35435,'Outer Doorman','','oel_mahum','20.00','37.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.48','false',1,0),
(5382,35436,'Outer Doorman','','oel_mahum','20.00','37.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,941,780,382,282,0,257,0,0,0,70,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.48','false',1,0),
(5383,35437,'Messenger','','oel_mahum','20.00','37.00',56,'male','L2Npc','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,268,282,0,257,0,0,0,70,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.48','false',1,0),
(5384,35438,'Chamberlain','','oel_mahum','20.00','37.00',56,'male','L2ClanHallManager','npc',40,2724,'6.500',152641,'300.000',40,43,30,21,20,10,0,0,706,331,382,268,282,0,2530,0,0,0,70,120,'dion_siege_clan',600,'Local','',0,0,0,7,30,4,3,0,0,'0.48','false',1,0),
(5385,35439,'Carey','Clan Hall Manager','a_maidB_FHuman','8.00','22.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5386,35440,'Daniel','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5387,35441,'Dianne','Clan Hall Manager','a_maidA_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5388,35442,'Jacques','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5389,35443,'Crissy','Clan Hall Manager','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5390,35444,'Joff','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5391,35445,'Albert','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5392,35446,'Niels','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5393,35447,'Korgen','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5394,35448,'Rudy','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5395,35449,'DiMaggio','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5396,35450,'Gellar','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5397,35451,'Emma','Clan Hall Manager','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5398,35452,'Theobolt','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5399,35453,'Adrienne','Clan Hall Manager','a_maidA_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5400,35454,'Rosconne','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0);
INSERT INTO `npc` VALUES
(5401,35455,'Bianca','Clan Hall Manager','a_maidB_FHuman','8.00','22.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5402,35456,'Stewart','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5403,35457,'Gladys','Clan Hall Manager','a_maidA_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5404,35458,'Theron','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5405,35459,'Regina','Clan Hall Manager','a_maidB_FHuman','8.00','22.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5406,35460,'Trey','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5407,35461,'Aida','Clan Hall Manager','a_traderC_Fhuman','7.00','21.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5408,35462,'Kalmer','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5409,35463,'Helga','Clan Hall Manager','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5410,35464,'Volfrem','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5411,35465,'Millicent','Clan Hall Manager','a_common_peopleB_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5412,35466,'Gerard','Clan Hall Gatekeeper','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5413,35467,'Branhillde','Clan Hall Manager','a_traderC_Fhuman','7.00','21.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5414,35468,'Lambert','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5415,35469,'Gods'' Altar','','rune_holything','46.00','72.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5416,35470,'Astair van Halter','King','a_lord_MHuman','8.00','23.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5417,35471,'Royal Knight','Rune','a_royal_guardA_MHuman','8.00','24.00',68,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'rune_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',0,0),
(5418,35472,'Court Sorcerer','Rune','a_patriarch_MElf','8.00','22.50',68,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(5419,35473,'Court Sorcerer','Rune','a_mageguild_master_FHuman','8.00','23.00',68,'female','L2SiegeGuard','Mystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(5420,35474,'Court Guard','Rune','e_elmore_guard_Mhuman','8.00','23.50',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5421,35475,'Guard','Rune','e_guard_MDwarf','8.00','19.00',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5422,35476,'Guard','Rune','e_guard_MDwarf','8.00','19.00',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5423,35477,'Guard','Rune','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5424,35478,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5425,35479,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5426,35480,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5427,35481,'Guard','Rune','e_guard_MOrc','8.00','27.00',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5428,35482,'Guard','Rune','e_guard_MOrc','8.00','27.00',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5429,35483,'Guard','Rune','a_guard_MHuman','8.00','24.00',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5430,35484,'Royal Knight','Rune','a_royal_guardA_MHuman','8.00','24.00',68,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'rune_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',0,0),
(5431,35485,'Court Sorcerer','Rune','a_patriarch_MElf','8.00','22.50',68,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(5432,35486,'Court Sorcerer','Rune','a_mageguild_master_FHuman','8.00','23.00',68,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(5433,35487,'Court Guard','Rune','e_elmore_guard_Mhuman','8.00','23.50',68,'male','L2SiegeGuard','SiegeGuardFighter',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(5434,35488,'Guard','Rune','e_guard_MDwarf','8.00','19.00',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5435,35489,'Guard','Rune','e_guard_MDwarf','8.00','19.00',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5436,35490,'Guard','Rune','a_guard_MElf','8.00','23.50',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5437,35491,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5438,35492,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5439,35493,'Guard','Rune','a_guard_FDarkelf','8.00','25.00',66,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5440,35494,'Guard','Rune','e_guard_MOrc','8.00','27.00',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5441,35495,'Guard','Rune','e_elmore_guard_Mhuman','8.00','23.50',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5442,35496,'Guard','Rune','e_elmore_guard_Mhuman','8.00','23.50',66,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'rune_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5443,35497,'Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5444,35498,'Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5445,35499,'Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5446,35500,'Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5447,35501,'Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5448,35502,'Group Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5449,35503,'Outer Doorman','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5450,35504,'Inner Doorman','Rune','e_elmore_guard_Mhuman','8.00','23.50',0,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5451,35505,'Inner Doorman','Rune','e_elmore_guard_Mhuman','8.00','23.50',0,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5452,35506,'Dungeon Gatekeeper','Rune','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2Merchant','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'rune_siege_clan',600,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5453,35507,'Blacksmith','Rune','a_smith_MDwarf','7.00','16.50',70,'male','L2CastleBlacksmith','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5454,35508,'Warehouse Keeper','Rune','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2CastleWarehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5455,35509,'Frederick','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5456,35510,'Titus','Wyvern Manager','a_fighterguild_teacher_MHuman','8.00','17.00',70,'male','L2WyvernManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5457,35511,'Gompus','Mercenary Manager','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2MercManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5458,35512,'Manor Manager','Rune','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5459,35513,'Sherman','Messenger','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2SiegeNpc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1335,470,780,382,278,0,253,135,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5460,35514,'Altar of Wind','','godad_holything','24.00','65.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5461,35515,'Altar of Earth','','godad_holything','24.00','65.00',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5462,35516,'Verus','Royal Guard Captain','big_boom','6.00','13.00',60,'male','L2Pet','npc',40,51515,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5463,35517,'Swain Ken Orwen','Count','a_lord_MHuman','8.00','23.00',65,'male','L2SiegeGuard','SiegeGuardRanger',900,3862,'7.500',2987,'2.700',60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,'Local','',0,0,0,7,30,4,4,750,0,'0.60','false',0,0),
(5464,35518,'Royal Knight','Schuttgart','a_royal_guardA_MHuman','8.00','24.00',60,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'6.500',3452,'2.400',40,43,30,21,20,10,360,1,1721,368,478,299,278,0,253,76,2497,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,20,123,7,30,4,4,0,-6,'0.60','false',0,0),
(5465,35519,'Court Sorcerer','Schuttgart','a_patriarch_MElf','8.00','22.50',58,'male','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(5466,35520,'Court Sorcerer','Schuttgart','a_mageguild_master_FHuman','8.00','23.00',58,'female','L2SiegeGuard','SiegeGuardMystic',40,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,278,0,253,325,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,50,1,9,0,0,'0.60','false',0,0),
(5467,35521,'Court Guard','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',58,'male','L2SiegeGuard','SiegeGuardFighter',80,23114,'6.500',3254,'2.400',40,43,30,21,20,10,336,1,1562,349,428,284,237,0,216,94,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5468,35522,'Guard','Schuttgart','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5469,35523,'Guard','Schuttgart','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5470,35524,'Guard','Schuttgart','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5471,35525,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5472,35526,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5473,35527,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5474,35528,'Guard','Schuttgart','e_guard_MOrc','8.00','27.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5475,35529,'Guard','Schuttgart','silver_cat','7.00','15.00',42,'male','L2SiegeGuard','SiegeGuardFighter',40,1992,'5.500',679,'2.100',40,43,30,21,20,25,0,0,374,215,152,202,278,0,253,0,0,0,48,180,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5476,35530,'Guard','Schuttgart','blue_eye','11.00','16.00',42,'male','L2SiegeGuard','SiegeGuardFighter',40,1992,'5.500',679,'2.100',40,43,30,21,20,25,0,0,374,215,152,202,278,0,253,0,0,0,48,180,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5477,35531,'Royal Knight','Schuttgart','shadeless','7.00','28.00',42,'male','L2SiegeGuard','SiegeGuardFighter',40,24436,'5.500',679,'2.100',40,43,30,21,20,25,0,0,374,215,152,202,278,0,253,0,0,0,48,180,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5478,35532,'Court Sorcerer','Schuttgart','headless_knight','21.00','22.50',67,'male','L2SiegeGuard','SiegeGuardMystic',900,23114,'7.500',2777,'2.700',60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,'0.52','false',0,0),
(5479,35533,'Court Sorcerer','Schuttgart','headless_knight','21.00','22.50',67,'male','L2SiegeGuard','SiegeGuardMystic',900,23114,'7.500',2777,'2.700',60,57,73,76,70,80,0,0,3548,438,1510,356,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,'0.52','false',0,0),
(5480,35534,'Court Guard','Schuttgart','headless_knight','21.00','31.00',70,'male','L2SiegeGuard','SiegeGuardFighter',40,8092000,'7.500',2987,'2.700',60,57,73,76,70,80,0,0,3987,469,1732,381,333,0,2362,0,0,0,70,180,'',0,'Local','',0,0,0,1,30,4,40,0,-18,'0.52','false',0,0),
(5481,35535,'Guard','Schuttgart','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,93,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5482,35536,'Guard','Schuttgart','e_guard_MDwarf','8.00','19.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,2,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5483,35537,'Guard','Schuttgart','a_guard_MElf','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,14,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5484,35538,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5485,35539,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,2,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5486,35540,'Guard','Schuttgart','a_guard_FDarkelf','8.00','25.00',56,'female','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,14,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5487,35541,'Guard','Schuttgart','e_guard_MOrc','8.00','27.00',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,16,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5488,35542,'Guard','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardFighter',80,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,76,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5489,35543,'Guard','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',56,'male','L2SiegeGuard','SiegeGuardRanger',900,21799,'6.500',3059,'2.400',40,43,30,21,20,10,0,0,1412,331,382,269,237,0,216,280,0,0,50,120,'schuttgart_siege_clan',1200,'Local','',0,0,0,7,30,4,0,0,0,'0.60','false',0,0),
(5490,35544,'Gatekeeper','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'schuttgart_siege_clan',600,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5491,35545,'Gatekeeper','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,2724,'6.500',1019,'2.400',40,43,30,21,20,10,0,0,706,331,382,269,278,0,253,0,0,0,50,0,'schuttgart_siege_clan',600,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5492,35546,'Gatekeeper','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,5817,'7.500',2987,'2.700',60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,290,0,0,0,50,160,'',0,'Magister','',0,0,0,7,30,4,4,750,0,'0.60','false',0,0),
(5493,35547,'Group Gatekeeper','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleTeleporter','npc',40,2724,'7.500',2987,'2.700',60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,'Magister','',35547,0,0,7,30,4,4,750,0,'0.60','false',1,0),
(5494,35548,'Outer Doorman','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'female','L2CastleDoormen','npc',40,3862,'7.500',2987,'2.700',60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,'Magister','',0,0,0,7,30,4,4,750,0,'0.60','false',1,0),
(5495,35549,'Inner Doorman','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleDoormen','npc',40,3862,'7.500',2987,'2.700',60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,'Magister','',0,0,0,7,30,4,4,750,0,'0.60','false',1,0),
(5496,35550,'Inner Doorman','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleDoormen','npc',40,3862,'7.500',2987,'2.700',60,57,73,76,70,80,0,0,2703,470,6964,764,409,0,2901,14,0,0,50,160,'',0,'Magister','',0,0,0,7,30,4,4,750,0,'0.60','false',1,0),
(5497,35551,'Doorman','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5498,35552,'Doorman','Schuttgart','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5499,35553,'Blacksmith','Schuttgart','a_smith_MDwarf','7.00','16.50',70,'male','L2CastleBlacksmith','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,89,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5500,35554,'Warehouse Keeper','Schuttgart','a_warehouse_keeper_MDwarf','8.00','17.00',70,'male','L2CastleWarehouse','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5501,35555,'August','Chamberlain','a_chamberlain_MHuman','9.50','22.50',70,'male','L2CastleChamberlain','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5502,35556,'Gallic','Wyvern Manager','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2WyvernManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5503,35557,'Kendrew','Mercenary Manager','a_common_peopleC_Mhuman','8.00','23.50',70,'male','L2MercManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5504,35558,'Manor Manager','Schuttgart','a_chamberlain_MHuman','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5505,35559,'Daguerre','Messenger','e_elmore_guard_Mhuman','8.00','23.50',70,'male','L2SiegeNpc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5506,35560,'Mass Gatekeeper','','oel_mahum','20.00','37.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5507,35561,'Mass Gatekeeper','','oel_mahum','20.00','37.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5508,35562,'Mass Gatekeeper','','oel_mahum','20.00','37.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5509,35563,'Mass Gatekeeper','','oel_mahum','20.00','37.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5510,35564,'Mass Gatekeeper','','oel_mahum','20.00','37.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5511,35565,'Mass Gatekeeper','','oel_mahum','20.00','37.00',70,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5512,35566,'Ronald','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5513,35567,'Emil','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5514,35568,'Wayne','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5515,35569,'Daniel','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5516,35570,'Patty','Clan Hall Manager','a_traderC_Fhuman','7.00','21.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5517,35571,'Dale','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5518,35572,'Jimmy','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5519,35573,'Shawn','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5520,35574,'Michael','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5521,35575,'Ryan','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5522,35576,'Jack','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5523,35577,'Harry','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5524,35578,'Karuto','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5525,35579,'Egon','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5526,35580,'Carol','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5527,35581,'Osho','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5528,35582,'Stanley','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5529,35583,'Walter','Clan Hall Gatekeeper','a_common_peopleB_MHuman','8.00','22.00',70,'male','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5530,35584,'Billy','Clan Hall Manager','a_casino_MHuman','8.00','23.00',70,'male','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5531,35585,'Alice','Clan Hall Gatekeeper','a_traderC_Fhuman','7.00','21.50',70,'female','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5532,35586,'Serena','Clan Hall Manager','a_maidA_FHuman','8.00','20.50',70,'female','L2ClanHallManager','npc',40,3862,'7.500',152641,'300.000',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,2530,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5533,35587,'Neria','Clan Hall Gatekeeper','a_traderC_Fhuman','7.00','21.50',70,'female','L2ClanHallDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5534,35588,'Hot Springs Gourd','','drop_gourd_50_bi','30.00','31.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5535,35589,'Hot Springs Gourd','','drop_gourd_50_bi','30.00','31.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5536,35590,'Hot Springs Gourd','','drop_gourd_50_bi','30.00','31.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5537,35591,'Hot Springs Gourd','','drop_gourd_50_bi','30.00','31.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5538,35592,'Enraged Yeti','','yeti','15.00','27.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5539,35593,'Treasure Chest','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5540,35594,'Treasure Chest','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5541,35595,'Treasure Chest','','mimic','8.50','8.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5542,35596,'Hot Springs Yeti','Maitre ''D','yeti_cute','5.00','10.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5543,35597,'Hot Springs Yeti','Maitre ''D','yeti_cute','5.00','10.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5544,35598,'Hot Springs Yeti','Maitre ''D','yeti_cute','5.00','10.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5545,35599,'Hot Springs Yeti','Maitre ''D','yeti_cute','5.00','10.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5546,35600,'Manager','','yeti_cute','5.00','10.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5547,35601,'Doorman','','yeti_cute','5.00','10.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5548,35602,'Doorman','','yeti_cute','5.00','10.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5549,35603,'Coordinator','','yeti','15.00','27.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5550,35604,'Messenger','','yeti_cute','5.00','10.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5551,35605,'Angout','Steward','yeti','15.00','27.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5552,35606,'Victor''s Flag','','azit_contest_pile_winner','63.50','97.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5553,35607,'Red Flag','','azit_contest_pile_a','52.00','195.50',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5554,35608,'Yellow Flag','','azit_contest_pile_b','51.80','108.25',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5555,35609,'Green Flag','','azit_contest_pile_c','51.80','108.25',70,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5556,35610,'Blue Flag','','azit_contest_pile_d','51.80','108.25',56,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5557,35611,'Purple Flag','','azit_contest_pile_e','51.80','108.25',56,'etc','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5558,35612,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5559,35613,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5560,35614,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5561,35615,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5562,35616,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5563,35617,'Group Gatekeeper','','kel_mahum','13.00','26.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0);
INSERT INTO `npc` VALUES
(5564,35618,'Frenzied Cougar','','saber_toothed_tiger','28.00','0.00',60,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5565,35619,'Frenzied Buffalo','','buffalo','22.00','31.00',60,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5566,35620,'Frenzied Kookaburra','','rough_ostrich','10.00','33.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5567,35621,'Frenzied Buffalo Baby','','baby_buffalo','12.00','15.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5568,35622,'Frenzied Baby Cougar','','baby_tiger','11.00','15.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5569,35623,'Inner Doorman','','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5570,35624,'Inner Doorman','','kel_mahum_champion','13.00','32.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5571,35625,'Outer Doorman','','a_guard_MHuman','8.00','24.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5572,35626,'Outer Doorman','','kel_mahum_champion','13.00','32.00',70,'male','L2CastleDoormen','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5573,35627,'Messenger','','kel_mahum_champion','13.00','32.00',56,'male','L2SiegeNpc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(5574,35628,'Quigby','Farm Manager','kel_mahum_champion','13.00','32.00',56,'male','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(5575,35629,'Lidia von Hellmann','','lidia_von_helmann','10.00','25.40',73,'female','L2Npc','npc',40,1869456,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5576,35630,'Alfred von Hellmann','','vampire_warrior','9.00','31.50',72,'male','L2Npc','npc',40,11353,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5577,35631,'Giselle von Hellmann','','vampire_wizard','5.50','28.80',72,'male','L2Npc','npc',40,11118,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5578,35632,'Vampire Adept','','vampire_witch','6.00','21.50',68,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5579,35633,'Vampire Soldier','','vampire_soldier','8.00','23.50',68,'male','L2Npc','npc',40,10639,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5580,35634,'Vampire Caster','','vampire_witch','6.00','21.50',70,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5581,35635,'Vampire Magister','','vampire_wizard','5.50','28.80',71,'male','L2Npc','npc',40,11118,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5582,35636,'Vampire Warlord','','vampire_warrior','9.00','31.50',72,'male','L2Npc','npc',40,11353,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5583,35637,'Vampire Leader','','vampire_lord','7.50','25.80',73,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5584,35638,'Valens','Wyvern Manager','vampire_soldier','8.00','23.50',70,'male','L2WyvernManager','npc',40,10639,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5585,35639,'Jacquard','Messenger','vampire_soldier','8.00','23.50',70,'male','L2SiegeNpc','npc',40,10639,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5586,35640,'Bandello','Steward','vampire_soldier','8.00','23.50',70,'male','L2Npc','npc',40,10639,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5587,35641,'Fortress Guard','','vampire_soldier','8.00','23.50',70,'male','L2Npc','npc',40,10639,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5588,35642,'Fortress Guard','','vampire_soldier','8.00','23.50',70,'male','L2Npc','npc',40,10639,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5589,35643,'Gate','','farm_hedge','184.00','24.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5590,35644,'Manor Manager','Schuttgart','a_traderA_MDwarf','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5591,35645,'Manor Manager','Schuttgart','e_trader_MOrc','9.50','22.50',70,'male','L2ManorManager','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',1,0),
(5592,35646,'Vampire Caster','','vampire_witch','6.00','21.50',70,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5593,35647,'Vampire Leader','','vampire_lord','7.50','25.80',73,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5594,35648,'Court Magician','Gludio','Elite_Mage','6.50','21.96',70,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5595,35649,'Court Magician','Dion','Elite_Mage','6.50','21.96',70,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5596,35650,'Court Magician','Giran','Elite_Mage','6.50','21.96',70,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5597,35651,'Court Magician','Oren','Elite_Mage','6.50','21.96',70,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5598,35652,'Court Magician','Aden','Elite_Mage','6.50','21.96',70,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5599,35653,'Court Magician','Innadril','Elite_Mage','6.50','21.96',70,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5600,35654,'Court Magician','Goddard','Elite_Mage','6.50','21.96',70,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5601,35655,'Court Magician','Rune','Elite_Mage','6.50','21.96',70,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5602,35656,'Court Magician','Schuttgart','Elite_Mage','6.50','21.96',70,'male','L2Npc','npc',40,11586,'7.500',1493,'2.700',40,43,30,21,20,10,0,0,1314,470,780,382,278,0,253,0,0,0,50,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(5603,14001,'Reanimated Man','','skeleton','11.00','25.00',46,'male','L2Pet','npc',40,2914,'5.500',816,'2.100',40,43,30,21,20,25,0,0,482,245,202,230,278,0,253,0,0,0,60,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5604,14002,'Reanimated Man','','skeleton','11.00','25.00',54,'male','L2Pet','npc',40,3843,'6.500',1102,'2.400',40,43,30,21,20,25,0,0,763,313,339,293,278,0,253,0,0,0,60,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5605,14003,'Reanimated Man','','skeleton','11.00','25.00',62,'male','L2Pet','npc',40,4829,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,1133,388,532,363,278,0,253,0,0,0,60,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5606,14004,'Reanimated Man','','skeleton','11.00','25.00',66,'male','L2Pet','npc',40,5319,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,1347,428,649,401,278,0,253,0,0,0,60,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5607,14005,'Reanimated Man','','skeleton','11.00','25.00',70,'male','L2Pet','npc',40,5793,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1577,470,780,440,278,0,253,0,0,0,60,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5608,14006,'Reanimated Man','','skeleton','11.00','25.00',74,'male','L2Pet','npc',40,6238,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,1816,512,921,480,278,0,253,0,0,0,60,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5609,14007,'Reanimated Man','','skeleton','11.00','25.00',76,'male','L2Pet','npc',40,6446,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1937,534,994,500,278,0,253,0,0,0,60,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5610,14008,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2068,555,1069,520,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5611,14009,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2078,555,1069,520,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5612,14010,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2088,555,1069,520,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5613,14011,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2099,555,1069,520,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5614,14012,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2109,555,1069,520,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5615,14013,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2119,555,1069,520,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5616,14014,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2130,555,1069,520,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5617,14015,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2140,555,1069,520,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5618,14016,'Reanimated Man','','skeleton','11.00','25.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2150,555,1069,520,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5619,14017,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2173,558,1082,523,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5620,14018,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2184,558,1082,523,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5621,14019,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2194,558,1082,523,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5622,14020,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2204,558,1082,523,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5623,14021,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2215,558,1082,523,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5624,14022,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2225,558,1082,523,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5625,14023,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2236,558,1082,523,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5626,14024,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2246,558,1082,523,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5627,14025,'Reanimated Man','','skeleton','11.00','25.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2256,558,1082,523,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5628,14026,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2280,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5629,14027,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2290,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5630,14028,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2301,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5631,14029,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2311,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5632,14030,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2322,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5633,14031,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2332,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5634,14032,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2343,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5635,14033,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2353,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5636,14034,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2363,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5637,14035,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2374,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5638,14036,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2384,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5639,14037,'Reanimated Man','','skeleton','11.00','25.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2395,562,1095,526,278,0,253,0,0,0,60,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.30','false',0,0),
(5640,14038,'Corrupted Man','','zombie','13.00','21.00',42,'male','L2Pet','npc',40,2506,'5.500',1019,'2.100',40,43,30,21,20,25,0,0,374,215,152,202,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5641,14039,'Corrupted Man','','zombie','13.00','21.00',50,'male','L2Pet','npc',40,3389,'5.500',1435,'2.100',40,43,30,21,20,25,0,0,611,278,264,260,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5642,14040,'Corrupted Man','','zombie','13.00','21.00',58,'male','L2Pet','npc',40,4361,'6.500',1876,'2.400',40,43,30,21,20,25,0,0,937,349,428,327,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5643,14041,'Corrupted Man','','zombie','13.00','21.00',64,'male','L2Pet','npc',40,5108,'7.500',2223,'2.700',40,43,30,21,20,25,0,0,1238,408,589,382,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5644,14042,'Corrupted Man','','zombie','13.00','21.00',68,'male','L2Pet','npc',40,5594,'7.500',2462,'2.700',40,43,30,21,20,25,0,0,1460,449,713,421,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5645,14043,'Corrupted Man','','zombie','13.00','21.00',72,'male','L2Pet','npc',40,6058,'8.500',2707,'3.000',40,43,30,21,20,25,0,0,1695,491,849,460,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5646,14044,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2068,555,1069,520,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5647,14045,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2078,555,1069,520,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5648,14046,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2088,555,1069,520,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5649,14047,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2099,555,1069,520,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5650,14048,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2109,555,1069,520,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5651,14049,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2119,555,1069,520,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5652,14050,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2130,555,1069,520,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5653,14051,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2140,555,1069,520,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5654,14052,'Corrupted Man','','zombie','13.00','21.00',78,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2150,555,1069,520,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5655,14053,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2173,558,1082,523,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5656,14054,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2184,558,1082,523,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5657,14055,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2194,558,1082,523,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5658,14056,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2204,558,1082,523,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5659,14057,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2215,558,1082,523,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5660,14058,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2225,558,1082,523,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5661,14059,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2236,558,1082,523,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5662,14060,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2246,558,1082,523,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5663,14061,'Corrupted Man','','zombie','13.00','21.00',79,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2256,558,1082,523,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5664,14062,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2280,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5665,14063,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2290,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5666,14064,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2301,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5667,14065,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2311,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5668,14066,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2322,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5669,14067,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2332,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5670,14068,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2343,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5671,14069,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2353,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5672,14070,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2363,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5673,14071,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2374,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5674,14072,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2384,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5675,14073,'Corrupted Man','','zombie','13.00','21.00',80,'male','L2Pet','npc',40,7130,'8.500',3086,'3.000',40,43,30,21,20,25,0,0,2395,562,1095,526,278,0,333,0,0,0,15,154,'',0,'SYS','',0,0,0,7,30,4,4,0,0,'0.43','false',0,0),
(5676,14074,'Cursed Man','','doll_master','20.00','42.00',58,'male','L2Pet','npc',80,3489,'7.800',1251,'2.400',40,43,30,21,20,25,0,0,1015,349,428,327,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5677,14075,'Cursed Man','','doll_master','20.00','42.00',62,'male','L2Pet','npc',80,3888,'9.000',1404,'2.700',40,43,30,21,20,25,0,0,1227,388,532,363,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5678,14076,'Cursed Man','','doll_master','20.00','42.00',66,'male','L2Pet','npc',80,4282,'9.000',1561,'2.700',40,43,30,21,20,25,0,0,1459,428,649,401,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5679,14077,'Cursed Man','','doll_master','20.00','42.00',70,'male','L2Pet','npc',80,4664,'9.000',1722,'2.700',40,43,30,21,20,25,0,0,1708,470,780,440,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5680,14078,'Cursed Man','','doll_master','20.00','42.00',72,'male','L2Pet','npc',80,4846,'10.200',1804,'3.000',40,43,30,21,20,25,0,0,1837,491,849,460,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5681,14079,'Cursed Man','','doll_master','20.00','42.00',74,'male','L2Pet','npc',80,5022,'10.200',1888,'3.000',40,43,30,21,20,25,0,0,1967,512,921,480,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5682,14080,'Cursed Man','','doll_master','20.00','42.00',76,'male','L2Pet','npc',80,5189,'10.200',1972,'3.000',40,43,30,21,20,25,0,0,2098,534,994,500,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5683,14081,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2229,555,1069,520,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5684,14082,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2245,555,1069,520,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5685,14083,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2261,555,1069,520,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5686,14084,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2277,555,1069,520,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5687,14085,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2293,555,1069,520,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5688,14086,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2309,555,1069,520,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5689,14087,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2325,555,1069,520,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5690,14088,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2341,555,1069,520,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5691,14089,'Cursed Man','','doll_master','20.00','42.00',78,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2357,555,1069,520,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5692,14090,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2388,558,1082,523,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5693,14091,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2404,558,1082,523,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5694,14092,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2420,558,1082,523,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5695,14093,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2436,558,1082,523,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5696,14094,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2452,558,1082,523,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5697,14095,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2468,558,1082,523,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5698,14096,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2484,558,1082,523,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5699,14097,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2500,558,1082,523,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5700,14098,'Cursed Man','','doll_master','20.00','42.00',79,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2517,558,1082,523,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5701,14099,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2548,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5702,14100,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2564,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5703,14101,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2580,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5704,14102,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2596,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5705,14103,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2613,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5706,14104,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2629,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5707,14105,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2645,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5708,14106,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2661,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5709,14107,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2678,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5710,14108,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2694,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5711,14109,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2710,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5712,14110,'Cursed Man','','doll_master','20.00','42.00',80,'male','L2Pet','npc',80,5358,'10.200',2057,'3.000',40,43,30,21,20,25,0,0,2726,562,1095,526,278,0,333,0,0,0,80,176,'',0,'Local','',0,0,0,7,30,8,4,0,0,'0.56','false',0,0),
(5713,14111,'Kat the Cat','','cat_the_cat','9.00','16.00',22,'male','L2Pet','npc',40,978,'3.500',279,'1.500',40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5714,14112,'Kat the Cat','','cat_the_cat','9.00','16.00',32,'male','L2Pet','npc',40,1689,'4.500',458,'1.800',40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5715,14113,'Kat the Cat','','cat_the_cat','9.00','16.00',42,'male','L2Pet','npc',40,2656,'5.500',679,'2.100',40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5716,14114,'Kat the Cat','','cat_the_cat','9.00','16.00',50,'male','L2Pet','npc',40,3592,'5.500',957,'2.100',40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5717,14115,'Kat the Cat','','cat_the_cat','9.00','16.00',58,'male','L2Pet','npc',40,4622,'6.500',1251,'2.400',40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5718,14116,'Kat the Cat','','cat_the_cat','9.00','16.00',27,'male','L2Pet','npc',40,1302,'3.500',367,'1.500',40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5719,14117,'Kat the Cat','','cat_the_cat','9.00','16.00',37,'male','L2Pet','npc',40,2142,'4.500',553,'1.800',40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5720,14118,'Kat the Cat','','cat_the_cat','9.00','16.00',46,'male','L2Pet','npc',40,3108,'5.500',816,'2.100',40,43,30,21,20,25,0,0,401,245,202,230,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5721,14119,'Kat the Cat','','cat_the_cat','9.00','16.00',54,'male','L2Pet','npc',40,4099,'6.500',1102,'2.400',40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5722,14120,'Kat the Cat','','cat_the_cat','9.00','16.00',60,'male','L2Pet','npc',40,4887,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5723,14121,'Kat the Cat','','cat_the_cat','9.00','16.00',62,'male','L2Pet','npc',40,5151,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5724,14122,'Kat the Cat','','cat_the_cat','9.00','16.00',64,'male','L2Pet','npc',40,5414,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5725,14123,'Kat the Cat','','cat_the_cat','9.00','16.00',66,'male','L2Pet','npc',40,5674,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5726,14124,'Kat the Cat','','cat_the_cat','9.00','16.00',68,'male','L2Pet','npc',40,5930,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5727,14125,'Kat the Cat','','cat_the_cat','9.00','16.00',70,'male','L2Pet','npc',40,6179,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5728,14126,'Kat the Cat','','cat_the_cat','9.00','16.00',72,'male','L2Pet','npc',40,6421,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5729,14127,'Kat the Cat','','cat_the_cat','9.00','16.00',74,'male','L2Pet','npc',40,6654,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5730,14128,'Kat the Cat','','cat_the_cat','9.00','16.00',76,'male','L2Pet','npc',40,6876,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,80,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5731,14129,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5732,14130,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5733,14131,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5734,14132,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5735,14133,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5736,14134,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5737,14135,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5738,14136,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5739,14137,'Kat the Cat','','cat_the_cat','9.00','16.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5740,14138,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5741,14139,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5742,14140,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0);
INSERT INTO `npc` VALUES
(5743,14141,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5744,14142,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5745,14143,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5746,14144,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5747,14145,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5748,14146,'Kat the Cat','','cat_the_cat','9.00','16.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5749,14147,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5750,14148,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5751,14149,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5752,14150,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5753,14151,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5754,14152,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5755,14153,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5756,14154,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5757,14155,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5758,14156,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5759,14157,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5760,14158,'Kat the Cat','','cat_the_cat','9.00','16.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,80,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(5761,14159,'Mew the Cat','','cutie_cat','8.00','15.00',27,'female','L2Pet','npc',40,1302,'3.500',367,'1.500',40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5762,14160,'Mew the Cat','','cutie_cat','8.00','15.00',37,'female','L2Pet','npc',40,2142,'4.500',553,'1.800',40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5763,14161,'Mew the Cat','','cutie_cat','8.00','15.00',47,'female','L2Pet','npc',40,3227,'5.500',851,'2.100',40,43,30,21,20,25,0,0,427,253,216,237,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5764,14162,'Mew the Cat','','cutie_cat','8.00','15.00',54,'female','L2Pet','npc',40,4099,'6.500',1102,'2.400',40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5765,14163,'Mew the Cat','','cutie_cat','8.00','15.00',22,'female','L2Pet','npc',40,978,'3.500',279,'1.500',40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5766,14164,'Mew the Cat','','cutie_cat','8.00','15.00',32,'female','L2Pet','npc',40,1689,'4.500',458,'1.800',40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5767,14165,'Mew the Cat','','cutie_cat','8.00','15.00',42,'female','L2Pet','npc',40,2656,'5.500',679,'2.100',40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5768,14166,'Mew the Cat','','cutie_cat','8.00','15.00',50,'female','L2Pet','npc',40,3592,'5.500',957,'2.100',40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5769,14167,'Mew the Cat','','cutie_cat','8.00','15.00',58,'female','L2Pet','npc',40,4622,'6.500',1251,'2.400',40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5770,14168,'Mew the Cat','','cutie_cat','8.00','15.00',60,'female','L2Pet','npc',40,4887,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5771,14169,'Mew the Cat','','cutie_cat','8.00','15.00',62,'female','L2Pet','npc',40,5151,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5772,14170,'Mew the Cat','','cutie_cat','8.00','15.00',64,'female','L2Pet','npc',40,5414,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5773,14171,'Mew the Cat','','cutie_cat','8.00','15.00',66,'female','L2Pet','npc',40,5674,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5774,14172,'Mew the Cat','','cutie_cat','8.00','15.00',68,'female','L2Pet','npc',40,5930,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5775,14173,'Mew the Cat','','cutie_cat','8.00','15.00',70,'female','L2Pet','npc',40,6179,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5776,14174,'Mew the Cat','','cutie_cat','8.00','15.00',72,'female','L2Pet','npc',40,6421,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5777,14175,'Mew the Cat','','cutie_cat','8.00','15.00',74,'female','L2Pet','npc',40,6654,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5778,14176,'Mew the Cat','','cutie_cat','8.00','15.00',76,'female','L2Pet','npc',40,6876,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5779,14177,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5780,14178,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5781,14179,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5782,14180,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5783,14181,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5784,14182,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5785,14183,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5786,14184,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5787,14185,'Mew the Cat','','cutie_cat','8.00','15.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5788,14186,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5789,14187,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5790,14188,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5791,14189,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5792,14190,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5793,14191,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5794,14192,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5795,14193,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5796,14194,'Mew the Cat','','cutie_cat','8.00','15.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5797,14195,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5798,14196,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5799,14197,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5800,14198,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5801,14199,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5802,14200,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5803,14201,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5804,14202,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5805,14203,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5806,14204,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5807,14205,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5808,14206,'Mew the Cat','','cutie_cat','8.00','15.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5809,14207,'Kai the Cat','','silver_cat','7.00','15.00',42,'male','L2Pet','npc',40,1992,'5.500',679,'2.100',40,43,30,21,20,25,0,0,342,215,152,202,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5810,14208,'Kai the Cat','','silver_cat','7.00','15.00',46,'male','L2Pet','npc',40,2331,'5.500',816,'2.100',40,43,30,21,20,25,0,0,442,245,202,230,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5811,14209,'Kai the Cat','','silver_cat','7.00','15.00',50,'male','L2Pet','npc',40,2694,'5.500',957,'2.100',40,43,30,21,20,25,0,0,560,278,264,260,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5812,14210,'Kai the Cat','','silver_cat','7.00','15.00',54,'male','L2Pet','npc',40,3074,'6.500',1102,'2.400',40,43,30,21,20,25,0,0,699,313,339,293,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5813,14211,'Kai the Cat','','silver_cat','7.00','15.00',58,'male','L2Pet','npc',40,3467,'6.500',1251,'2.400',40,43,30,21,20,25,0,0,859,349,428,327,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5814,14212,'Kai the Cat','','silver_cat','7.00','15.00',60,'male','L2Pet','npc',40,3665,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,946,368,478,345,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5815,14213,'Kai the Cat','','silver_cat','7.00','15.00',62,'male','L2Pet','npc',40,3863,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,1038,388,532,363,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5816,14214,'Kai the Cat','','silver_cat','7.00','15.00',64,'male','L2Pet','npc',40,4060,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,1135,408,589,382,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5817,14215,'Kai the Cat','','silver_cat','7.00','15.00',66,'male','L2Pet','npc',40,4255,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,1235,428,649,401,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5818,14216,'Kai the Cat','','silver_cat','7.00','15.00',68,'male','L2Pet','npc',40,4447,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,1339,449,713,421,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5819,14217,'Kai the Cat','','silver_cat','7.00','15.00',70,'male','L2Pet','npc',40,4634,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1445,470,780,440,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5820,14218,'Kai the Cat','','silver_cat','7.00','15.00',72,'male','L2Pet','npc',40,4816,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,1554,491,849,460,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5821,14219,'Kai the Cat','','silver_cat','7.00','15.00',74,'male','L2Pet','npc',40,4990,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,1664,512,921,480,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5822,14220,'Kai the Cat','','silver_cat','7.00','15.00',76,'male','L2Pet','npc',40,5157,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1775,534,994,500,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5823,14221,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1886,555,1069,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5824,14222,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1895,555,1081,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5825,14223,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1905,555,1093,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5826,14224,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1914,555,1105,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5827,14225,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1924,555,1117,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5828,14226,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1933,555,1129,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5829,14227,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1943,555,1141,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5830,14228,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1952,555,1153,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5831,14229,'Kai the Cat','','silver_cat','7.00','15.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1962,555,1165,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5832,14230,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1983,558,1192,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5833,14231,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1992,558,1204,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5834,14232,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2002,558,1216,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5835,14233,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2011,558,1228,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5836,14234,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2021,558,1240,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5837,14235,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2030,558,1253,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5838,14236,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2040,558,1265,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5839,14237,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2049,558,1277,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5840,14238,'Kai the Cat','','silver_cat','7.00','15.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2059,558,1289,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5841,14239,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5842,14240,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5843,14241,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5844,14242,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5845,14243,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5846,14244,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5847,14245,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5848,14246,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5849,14247,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5850,14248,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5851,14249,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5852,14250,'Kai the Cat','','silver_cat','7.00','15.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.34','false',0,0),
(5853,14251,'Feline Queen','','queen_of_cat','8.00','15.00',58,'female','L2Pet','npc',40,2889,'6.500',1251,'2.400',40,43,30,21,20,25,0,0,313,349,428,327,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5854,14252,'Feline Queen','','queen_of_cat','8.00','15.00',60,'female','L2Pet','npc',40,3054,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,340,368,478,345,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5855,14253,'Feline Queen','','queen_of_cat','8.00','15.00',62,'female','L2Pet','npc',40,3219,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,368,388,532,363,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5856,14254,'Feline Queen','','queen_of_cat','8.00','15.00',64,'female','L2Pet','npc',40,3384,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,397,408,589,382,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5857,14255,'Feline Queen','','queen_of_cat','8.00','15.00',66,'female','L2Pet','npc',40,3546,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,427,428,649,401,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5858,14256,'Feline Queen','','queen_of_cat','8.00','15.00',68,'female','L2Pet','npc',40,3706,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,457,449,713,421,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5859,14257,'Feline Queen','','queen_of_cat','8.00','15.00',70,'female','L2Pet','npc',40,3862,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,487,470,780,440,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5860,14258,'Feline Queen','','queen_of_cat','8.00','15.00',72,'female','L2Pet','npc',40,4013,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,517,491,849,460,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5861,14259,'Feline Queen','','queen_of_cat','8.00','15.00',74,'female','L2Pet','npc',40,4158,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,547,512,921,480,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5862,14260,'Feline Queen','','queen_of_cat','8.00','15.00',76,'female','L2Pet','npc',40,4297,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,577,534,994,500,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5863,14265,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5864,14266,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5865,14267,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5866,14268,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5867,14269,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5868,14270,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5869,14271,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5870,14272,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5871,14273,'Feline Queen','','queen_of_cat','8.00','15.00',78,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5872,14274,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5873,14275,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5874,14276,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5875,14277,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5876,14278,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5877,14279,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5878,14280,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5879,14281,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5880,14282,'Feline Queen','','queen_of_cat','8.00','15.00',79,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5881,14283,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5882,14284,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5883,14285,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5884,14286,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5885,14287,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5886,14288,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5887,14289,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5888,14290,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5889,14291,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5890,14292,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5891,14293,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5892,14294,'Feline Queen','','queen_of_cat','8.00','15.00',80,'female','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,26,180,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.48','false',0,0),
(5893,14295,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',22,'male','L2Pet','npc',40,978,'3.500',279,'1.500',40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5894,14296,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',32,'male','L2Pet','npc',40,1689,'4.500',458,'1.800',40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5895,14297,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',42,'male','L2Pet','npc',40,2656,'5.500',679,'2.100',40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5896,14298,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',50,'male','L2Pet','npc',40,3592,'5.500',957,'2.100',40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5897,14299,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',58,'male','L2Pet','npc',40,4622,'6.500',1251,'2.400',40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5898,14300,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',27,'male','L2Pet','npc',40,1302,'3.500',367,'1.500',40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5899,14301,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',37,'male','L2Pet','npc',40,2142,'4.500',553,'1.800',40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5900,14302,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',46,'male','L2Pet','npc',40,3108,'5.500',816,'2.100',40,43,30,21,20,25,0,0,401,245,202,230,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5901,14303,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',54,'male','L2Pet','npc',40,4099,'6.500',1102,'2.400',40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5902,14304,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',60,'male','L2Pet','npc',40,4887,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5903,14305,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',62,'male','L2Pet','npc',40,5151,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5904,14306,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',64,'male','L2Pet','npc',40,5414,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5905,14307,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',66,'male','L2Pet','npc',40,5674,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5906,14308,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',68,'male','L2Pet','npc',40,5930,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5907,14309,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',70,'male','L2Pet','npc',40,6179,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5908,14310,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',72,'male','L2Pet','npc',40,6421,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5909,14311,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',74,'male','L2Pet','npc',40,6654,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5910,14312,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',76,'male','L2Pet','npc',40,6876,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5911,14313,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5912,14314,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5913,14315,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5914,14316,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5915,14317,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5916,14318,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5917,14319,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5918,14320,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5919,14321,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5920,14322,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5921,14323,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0);
INSERT INTO `npc` VALUES
(5922,14324,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5923,14325,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5924,14326,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5925,14327,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5926,14328,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5927,14329,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5928,14330,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5929,14331,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5930,14332,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5931,14333,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5932,14334,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5933,14335,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5934,14336,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5935,14337,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5936,14338,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5937,14339,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5938,14340,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5939,14341,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5940,14342,'Boxer the Unicorn','','unicorn_boxer','11.00','18.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(5941,14343,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',27,'male','L2Pet','npc',40,1302,'3.500',367,'1.500',40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5942,14344,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',37,'male','L2Pet','npc',40,2142,'4.500',553,'1.800',40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5943,14345,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',47,'male','L2Pet','npc',40,3227,'5.500',851,'2.100',40,43,30,21,20,25,0,0,427,253,216,237,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5944,14346,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',54,'male','L2Pet','npc',40,4099,'6.500',1102,'2.400',40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5945,14347,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',22,'male','L2Pet','npc',40,978,'3.500',279,'1.500',40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5946,14348,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',32,'male','L2Pet','npc',40,1689,'4.500',458,'1.800',40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5947,14349,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',42,'male','L2Pet','npc',40,2656,'5.500',679,'2.100',40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5948,14350,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',50,'male','L2Pet','npc',40,3592,'5.500',957,'2.100',40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5949,14351,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',58,'male','L2Pet','npc',40,4622,'6.500',1251,'2.400',40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5950,14352,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',60,'male','L2Pet','npc',40,4887,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5951,14353,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',62,'male','L2Pet','npc',40,5151,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5952,14354,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',64,'male','L2Pet','npc',40,5414,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5953,14355,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',66,'male','L2Pet','npc',40,5674,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5954,14356,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',68,'male','L2Pet','npc',40,5930,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5955,14357,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',70,'male','L2Pet','npc',40,6179,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5956,14358,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',72,'male','L2Pet','npc',40,6421,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5957,14359,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',74,'male','L2Pet','npc',40,6654,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5958,14360,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',76,'male','L2Pet','npc',40,6876,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,27,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5959,14361,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5960,14362,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5961,14363,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5962,14364,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5963,14365,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5964,14366,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5965,14367,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5966,14368,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5967,14369,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5968,14370,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5969,14371,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5970,14372,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5971,14373,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5972,14374,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5973,14375,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5974,14376,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5975,14377,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5976,14378,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5977,14379,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5978,14380,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5979,14381,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5980,14382,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5981,14383,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5982,14384,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5983,14385,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5984,14386,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5985,14387,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5986,14388,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5987,14389,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5988,14390,'Mirage the Unicorn','','unicorn_mirage','13.00','17.50',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(5989,14391,'Merrow the Unicorn','','blue_eye','11.00','16.00',42,'male','L2Pet','npc',40,1992,'5.500',679,'2.100',40,43,30,21,20,25,0,0,342,215,152,202,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(5990,14392,'Merrow the Unicorn','','blue_eye','11.00','16.00',46,'male','L2Pet','npc',40,2331,'5.500',816,'2.100',40,43,30,21,20,25,0,0,442,245,202,230,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(5991,14393,'Merrow the Unicorn','','blue_eye','11.00','16.00',50,'male','L2Pet','npc',40,2694,'5.500',957,'2.100',40,43,30,21,20,25,0,0,560,278,264,260,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(5992,14394,'Merrow the Unicorn','','blue_eye','11.00','16.00',54,'male','L2Pet','npc',40,3074,'6.500',1102,'2.400',40,43,30,21,20,25,0,0,699,313,339,293,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(5993,14395,'Merrow the Unicorn','','blue_eye','11.00','16.00',58,'male','L2Pet','npc',40,3467,'6.500',1251,'2.400',40,43,30,21,20,25,0,0,859,349,428,327,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(5994,14396,'Merrow the Unicorn','','blue_eye','11.00','16.00',60,'male','L2Pet','npc',40,3665,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,946,368,478,345,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(5995,14397,'Merrow the Unicorn','','blue_eye','11.00','16.00',62,'male','L2Pet','npc',40,3863,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,1038,388,532,363,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(5996,14398,'Merrow the Unicorn','','blue_eye','11.00','16.00',64,'male','L2Pet','npc',40,4060,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,1135,408,589,382,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(5997,14399,'Merrow the Unicorn','','blue_eye','11.00','16.00',66,'male','L2Pet','npc',40,4255,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,1235,428,649,401,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(5998,14400,'Merrow the Unicorn','','blue_eye','11.00','16.00',68,'male','L2Pet','npc',40,4447,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,1339,449,713,421,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(5999,14401,'Merrow the Unicorn','','blue_eye','11.00','16.00',70,'male','L2Pet','npc',40,4634,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1445,470,780,440,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6000,14402,'Merrow the Unicorn','','blue_eye','11.00','16.00',72,'male','L2Pet','npc',40,4816,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,1554,491,849,460,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6001,14403,'Merrow the Unicorn','','blue_eye','11.00','16.00',74,'male','L2Pet','npc',40,4990,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,1664,512,921,480,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6002,14404,'Merrow the Unicorn','','blue_eye','11.00','16.00',76,'male','L2Pet','npc',40,5157,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1775,534,994,500,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6003,14405,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1886,555,1069,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6004,14406,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1895,555,1081,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6005,14407,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1905,555,1093,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6006,14408,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1914,555,1105,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6007,14409,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1924,555,1117,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6008,14410,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1933,555,1129,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6009,14411,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1943,555,1141,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6010,14412,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1952,555,1153,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6011,14413,'Merrow the Unicorn','','blue_eye','11.00','16.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1962,555,1165,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6012,14414,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1983,558,1192,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6013,14415,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1992,558,1204,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6014,14416,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2002,558,1216,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6015,14417,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2011,558,1228,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6016,14418,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2021,558,1240,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6017,14419,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2030,558,1253,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6018,14420,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2040,558,1265,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6019,14421,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2049,558,1277,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6020,14422,'Merrow the Unicorn','','blue_eye','11.00','16.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2059,558,1289,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6021,14423,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6022,14424,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6023,14425,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6024,14426,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6025,14427,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6026,14428,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6027,14429,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6028,14430,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6029,14431,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6030,14432,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6031,14433,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6032,14434,'Merrow the Unicorn','','blue_eye','11.00','16.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,10,'0.71','false',0,0),
(6033,14435,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',58,'male','L2Pet','npc',40,2889,'6.500',1251,'2.400',40,43,30,21,20,25,0,0,313,349,428,327,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(6034,14436,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',60,'male','L2Pet','npc',40,3054,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,340,368,478,345,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(6035,14437,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',62,'male','L2Pet','npc',40,3219,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,368,388,532,363,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(6036,14438,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',64,'male','L2Pet','npc',40,3384,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,397,408,589,382,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(6037,14439,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',66,'male','L2Pet','npc',40,3546,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,427,428,649,401,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(6038,14440,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',68,'male','L2Pet','npc',40,3706,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,457,449,713,421,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(6039,14441,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',70,'male','L2Pet','npc',40,3862,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,487,470,780,440,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(6040,14442,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',72,'male','L2Pet','npc',40,4013,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,517,491,849,460,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(6041,14443,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',74,'male','L2Pet','npc',40,4158,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,547,512,921,480,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(6042,14444,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',76,'male','L2Pet','npc',40,4297,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,577,534,994,500,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.71','false',0,0),
(6043,14449,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6044,14450,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6045,14451,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6046,14452,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6047,14453,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6048,14454,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6049,14455,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6050,14456,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6051,14457,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',78,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6052,14458,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6053,14459,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6054,14460,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6055,14461,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6056,14462,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6057,14463,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6058,14464,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6059,14465,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6060,14466,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',79,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6061,14467,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6062,14468,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6063,14469,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6064,14470,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6065,14471,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6066,14472,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6067,14473,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6068,14474,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6069,14475,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6070,14476,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6071,14477,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6072,14478,'Unicorn Seraphim','','angelic_unicorn','9.00','25.50',80,'male','L2Pet','npc',40,4428,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,27,140,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.71','false',0,0),
(6073,14479,'Shadow','','shadow','10.00','30.00',22,'male','L2Pet','npc',40,978,'3.500',279,'1.500',40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6074,14480,'Shadow','','shadow','10.00','30.00',32,'male','L2Pet','npc',40,1689,'4.500',458,'1.800',40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6075,14481,'Shadow','','shadow','10.00','30.00',42,'male','L2Pet','npc',40,2656,'5.500',679,'2.100',40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6076,14482,'Shadow','','shadow','10.00','30.00',50,'male','L2Pet','npc',40,3592,'5.500',957,'2.100',40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6077,14483,'Shadow','','shadow','10.00','30.00',58,'male','L2Pet','npc',40,4622,'6.500',1251,'2.400',40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6078,14484,'Shadow','','shadow','10.00','30.00',27,'male','L2Pet','npc',40,1302,'3.500',367,'1.500',40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6079,14485,'Shadow','','shadow','10.00','30.00',37,'male','L2Pet','npc',40,2142,'4.500',553,'1.800',40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6080,14486,'Shadow','','shadow','10.00','30.00',46,'male','L2Pet','npc',40,3108,'5.500',816,'2.100',40,43,30,21,20,25,0,0,401,245,202,230,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6081,14487,'Shadow','','shadow','10.00','30.00',54,'male','L2Pet','npc',40,4099,'6.500',1102,'2.400',40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6082,14488,'Shadow','','shadow','10.00','30.00',60,'male','L2Pet','npc',40,4887,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6083,14489,'Shadow','','shadow','10.00','30.00',62,'male','L2Pet','npc',40,5151,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6084,14490,'Shadow','','shadow','10.00','30.00',64,'male','L2Pet','npc',40,5414,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6085,14491,'Shadow','','shadow','10.00','30.00',66,'male','L2Pet','npc',40,5674,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6086,14492,'Shadow','','shadow','10.00','30.00',68,'male','L2Pet','npc',40,5930,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6087,14493,'Shadow','','shadow','10.00','30.00',70,'male','L2Pet','npc',40,6179,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6088,14494,'Shadow','','shadow','10.00','30.00',72,'male','L2Pet','npc',40,6421,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6089,14495,'Shadow','','shadow','10.00','30.00',74,'male','L2Pet','npc',40,6654,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6090,14496,'Shadow','','shadow','10.00','30.00',76,'male','L2Pet','npc',40,6876,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6091,14497,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6092,14498,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6093,14499,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6094,14500,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6095,14501,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6096,14502,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6097,14503,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0);
INSERT INTO `npc` VALUES
(6098,14504,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6099,14505,'Shadow','','shadow','10.00','30.00',78,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6100,14506,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6101,14507,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6102,14508,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6103,14509,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6104,14510,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6105,14511,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6106,14512,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6107,14513,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6108,14514,'Shadow','','shadow','10.00','30.00',79,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6109,14515,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6110,14516,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6111,14517,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6112,14518,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6113,14519,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6114,14520,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6115,14521,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6116,14522,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6117,14523,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6118,14524,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6119,14525,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6120,14526,'Shadow','','shadow','10.00','30.00',80,'male','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6121,14527,'Silhouette','','silhouette','8.00','23.00',27,'female','L2Pet','npc',40,1302,'3.500',367,'1.500',40,43,30,21,20,25,0,0,104,125,45,117,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6122,14528,'Silhouette','','silhouette','8.00','23.00',37,'female','L2Pet','npc',40,2142,'4.500',553,'1.800',40,43,30,21,20,25,0,0,222,182,104,170,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6123,14529,'Silhouette','','silhouette','8.00','23.00',47,'female','L2Pet','npc',40,3227,'5.500',851,'2.100',40,43,30,21,20,25,0,0,427,253,216,237,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6124,14530,'Silhouette','','silhouette','8.00','23.00',54,'female','L2Pet','npc',40,4099,'6.500',1102,'2.400',40,43,30,21,20,25,0,0,636,313,339,293,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6125,14531,'Silhouette','','silhouette','8.00','23.00',22,'female','L2Pet','npc',40,978,'3.500',279,'1.500',40,43,30,21,20,25,0,0,68,102,28,96,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6126,14532,'Silhouette','','silhouette','8.00','23.00',32,'female','L2Pet','npc',40,1689,'4.500',458,'1.800',40,43,30,21,20,25,0,0,154,151,69,142,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6127,14533,'Silhouette','','silhouette','8.00','23.00',42,'female','L2Pet','npc',40,2656,'5.500',679,'2.100',40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6128,14534,'Silhouette','','silhouette','8.00','23.00',50,'female','L2Pet','npc',40,3592,'5.500',957,'2.100',40,43,30,21,20,25,0,0,509,278,264,260,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6129,14535,'Silhouette','','silhouette','8.00','23.00',58,'female','L2Pet','npc',40,4622,'6.500',1251,'2.400',40,43,30,21,20,25,0,0,781,349,428,327,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6130,14536,'Silhouette','','silhouette','8.00','23.00',60,'female','L2Pet','npc',40,4887,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6131,14537,'Silhouette','','silhouette','8.00','23.00',62,'female','L2Pet','npc',40,5151,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6132,14538,'Silhouette','','silhouette','8.00','23.00',64,'female','L2Pet','npc',40,5414,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6133,14539,'Silhouette','','silhouette','8.00','23.00',66,'female','L2Pet','npc',40,5674,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6134,14540,'Silhouette','','silhouette','8.00','23.00',68,'female','L2Pet','npc',40,5930,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6135,14541,'Silhouette','','silhouette','8.00','23.00',70,'female','L2Pet','npc',40,6179,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6136,14542,'Silhouette','','silhouette','8.00','23.00',72,'female','L2Pet','npc',40,6421,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6137,14543,'Silhouette','','silhouette','8.00','23.00',74,'female','L2Pet','npc',40,6654,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6138,14544,'Silhouette','','silhouette','8.00','23.00',76,'female','L2Pet','npc',40,6876,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,80,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6139,14545,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6140,14546,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6141,14547,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6142,14548,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6143,14549,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6144,14550,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6145,14551,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6146,14552,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6147,14553,'Silhouette','','silhouette','8.00','23.00',78,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6148,14554,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6149,14555,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6150,14556,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6151,14557,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6152,14558,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6153,14559,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6154,14560,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6155,14561,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6156,14562,'Silhouette','','silhouette','8.00','23.00',79,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6157,14563,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6158,14564,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6159,14565,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6160,14566,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6161,14567,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6162,14568,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6163,14569,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6164,14570,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6165,14571,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6166,14572,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6167,14573,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6168,14574,'Silhouette','','silhouette','8.00','23.00',80,'female','L2Pet','npc',40,7085,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,253,0,0,0,80,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.54','false',0,0),
(6169,14575,'Soulless','','shadeless','7.00','28.00',42,'male','L2Pet','npc',40,1992,'5.500',679,'2.100',40,43,30,21,20,25,0,0,342,215,152,202,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6170,14576,'Soulless','','shadeless','7.00','28.00',46,'male','L2Pet','npc',40,2331,'5.500',816,'2.100',40,43,30,21,20,25,0,0,442,245,202,230,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6171,14577,'Soulless','','shadeless','7.00','28.00',50,'male','L2Pet','npc',40,2694,'5.500',957,'2.100',40,43,30,21,20,25,0,0,560,278,264,260,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6172,14578,'Soulless','','shadeless','7.00','28.00',54,'male','L2Pet','npc',40,3074,'6.500',1102,'2.400',40,43,30,21,20,25,0,0,699,313,339,293,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6173,14579,'Soulless','','shadeless','7.00','28.00',58,'male','L2Pet','npc',40,3467,'6.500',1251,'2.400',40,43,30,21,20,25,0,0,859,349,428,327,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6174,14580,'Soulless','','shadeless','7.00','28.00',60,'male','L2Pet','npc',40,3665,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,946,368,478,345,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6175,14581,'Soulless','','shadeless','7.00','28.00',62,'male','L2Pet','npc',40,3863,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,1038,388,532,363,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6176,14582,'Soulless','','shadeless','7.00','28.00',64,'male','L2Pet','npc',40,4060,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,1135,408,589,382,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6177,14583,'Soulless','','shadeless','7.00','28.00',66,'male','L2Pet','npc',40,4255,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,1235,428,649,401,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6178,14584,'Soulless','','shadeless','7.00','28.00',68,'male','L2Pet','npc',40,4447,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,1339,449,713,421,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6179,14585,'Soulless','','shadeless','7.00','28.00',70,'male','L2Pet','npc',40,4634,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1445,470,780,440,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6180,14586,'Soulless','','shadeless','7.00','28.00',72,'male','L2Pet','npc',40,4816,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,1554,491,849,460,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6181,14587,'Soulless','','shadeless','7.00','28.00',74,'male','L2Pet','npc',40,4990,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,1664,512,921,480,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6182,14588,'Soulless','','shadeless','7.00','28.00',76,'male','L2Pet','npc',40,5157,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1775,534,994,500,278,0,253,0,0,0,48,190,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6183,14589,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1886,555,1069,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6184,14590,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1895,555,1081,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6185,14591,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1905,555,1093,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6186,14592,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1914,555,1105,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6187,14593,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1924,555,1117,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6188,14594,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1933,555,1129,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6189,14595,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1943,555,1141,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6190,14596,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1952,555,1153,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6191,14597,'Soulless','','shadeless','7.00','28.00',78,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1962,555,1165,520,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6192,14598,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1983,558,1192,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6193,14599,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,1992,558,1204,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6194,14600,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2002,558,1216,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6195,14601,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2011,558,1228,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6196,14602,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2021,558,1240,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6197,14603,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2030,558,1253,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6198,14604,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2040,558,1265,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6199,14605,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2049,558,1277,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6200,14606,'Soulless','','shadeless','7.00','28.00',79,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2059,558,1289,523,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6201,14607,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6202,14608,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6203,14609,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6204,14610,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6205,14611,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6206,14612,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6207,14613,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6208,14614,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6209,14615,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6210,14616,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6211,14617,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6212,14618,'Soulless','','shadeless','7.00','28.00',80,'male','L2Pet','npc',40,5314,'8.500',2057,'3.000',40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,253,0,0,0,48,190,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.61','false',0,0),
(6213,14619,'Nightshade','','knight_of_shadow','10.00','35.50',58,'male','L2Pet','npc',40,5778,'5.500',1251,'2.400',40,43,30,21,20,25,0,0,313,349,428,327,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6214,14620,'Nightshade','','knight_of_shadow','10.00','35.50',60,'male','L2Pet','npc',40,6109,'5.500',1327,'2.400',40,43,30,21,20,25,0,0,340,368,478,345,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6215,14621,'Nightshade','','knight_of_shadow','10.00','35.50',62,'male','L2Pet','npc',40,6439,'5.500',1404,'2.700',40,43,30,21,20,25,0,0,368,388,532,363,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6216,14622,'Nightshade','','knight_of_shadow','10.00','35.50',64,'male','L2Pet','npc',40,6768,'6.500',1482,'2.700',40,43,30,21,20,25,0,0,397,408,589,382,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6217,14623,'Nightshade','','knight_of_shadow','10.00','35.50',66,'male','L2Pet','npc',40,7093,'6.500',1561,'2.700',40,43,30,21,20,25,0,0,427,428,649,401,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6218,14624,'Nightshade','','knight_of_shadow','10.00','35.50',68,'male','L2Pet','npc',40,7412,'6.500',1641,'2.700',40,43,30,21,20,25,0,0,457,449,713,421,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6219,14625,'Nightshade','','knight_of_shadow','10.00','35.50',70,'male','L2Pet','npc',40,7724,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,487,470,780,440,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6220,14626,'Nightshade','','knight_of_shadow','10.00','35.50',72,'male','L2Pet','npc',40,8026,'7.500',1804,'3.000',40,43,30,21,20,25,0,0,517,491,849,460,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6221,14627,'Nightshade','','knight_of_shadow','10.00','35.50',74,'male','L2Pet','npc',40,8317,'7.500',1888,'3.000',40,43,30,21,20,25,0,0,547,512,921,480,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6222,14628,'Nightshade','','knight_of_shadow','10.00','35.50',76,'male','L2Pet','npc',40,8595,'7.500',1972,'3.000',40,43,30,21,20,25,0,0,577,534,994,500,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6223,14633,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6224,14634,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6225,14635,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6226,14636,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6227,14637,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6228,14638,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6229,14639,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6230,14640,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6231,14641,'Nightshade','','knight_of_shadow','10.00','35.50',78,'male','L2Pet','npc',40,8857,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,595,555,1069,520,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6232,14642,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6233,14643,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6234,14644,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6235,14645,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6236,14646,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6237,14647,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6238,14648,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6239,14649,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6240,14650,'Nightshade','','knight_of_shadow','10.00','35.50',79,'male','L2Pet','npc',40,8981,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,598,558,1082,523,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6241,14651,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6242,14652,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6243,14653,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6244,14654,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6245,14655,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6246,14656,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6247,14657,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6248,14658,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6249,14659,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6250,14660,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6251,14661,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6252,14662,'Nightshade','','knight_of_shadow','10.00','35.50',80,'male','L2Pet','npc',40,9101,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,602,562,1095,526,278,0,253,0,0,0,30,170,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.59','false',0,0),
(6253,14663,'Mechanic Golem','','mechanic_golem','5.00','19.00',30,'male','L2Pet','npc',40,1049,'3.500',421,'1.500',40,43,30,21,20,25,0,0,132,140,58,132,278,0,253,0,0,0,30,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(6254,14664,'Mechanic Golem','','mechanic_golem','5.00','19.00',38,'male','L2Pet','npc',40,1540,'4.500',573,'1.800',40,43,30,21,20,25,0,0,238,188,112,176,278,0,253,0,0,0,30,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(6255,14665,'Mechanic Golem','','mechanic_golem','5.00','19.00',45,'male','L2Pet','npc',40,2057,'5.500',781,'2.100',40,43,30,21,20,25,0,0,377,238,188,223,278,0,253,0,0,0,30,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(6256,14666,'Mechanic Golem','','mechanic_golem','5.00','19.00',51,'male','L2Pet','npc',40,2555,'6.500',993,'2.400',40,43,30,21,20,25,0,0,539,286,281,268,278,0,253,0,0,0,30,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(6257,14667,'Mechanic Golem','','mechanic_golem','5.00','19.00',57,'male','L2Pet','npc',40,3087,'6.500',1213,'2.400',40,43,30,21,20,25,0,0,743,340,405,318,278,0,253,0,0,0,30,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(6258,14668,'Mechanic Golem','','mechanic_golem','5.00','19.00',62,'male','L2Pet','npc',40,3541,'7.500',1404,'2.700',40,43,30,21,20,25,0,0,944,388,532,363,278,0,253,0,0,0,30,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(6259,14669,'Mechanic Golem','','mechanic_golem','5.00','19.00',66,'male','L2Pet','npc',40,3901,'7.500',1561,'2.700',40,43,30,21,20,25,0,0,1123,428,649,401,278,0,253,0,0,0,30,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(6260,14670,'Mechanic Golem','','mechanic_golem','5.00','19.00',70,'male','L2Pet','npc',40,4248,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1314,470,780,440,278,0,253,0,0,0,30,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(6261,14671,'Mechanic Golem','','mechanic_golem','5.00','19.00',74,'male','L2Pet','npc',40,4574,'8.500',1888,'3.000',40,43,30,21,20,25,0,0,1513,512,921,480,278,0,253,0,0,0,30,150,'',0,'Saboteur (Orphus.com)','',0,0,0,7,30,4,4,0,0,'0.72','false',0,0),
(6262,14672,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1723,555,1069,520,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6263,14673,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1732,555,1069,520,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6264,14674,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1740,555,1069,520,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6265,14675,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1749,555,1069,520,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6266,14676,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1757,555,1069,520,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6267,14677,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1766,555,1069,520,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6268,14678,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1775,555,1069,520,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6269,14679,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1783,555,1069,520,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6270,14680,'Mechanic Golem','','mechanic_golem','5.00','19.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1792,555,1069,520,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6271,14681,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1811,558,1082,523,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6272,14682,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1820,558,1082,523,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6273,14683,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1828,558,1082,523,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6274,14684,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1837,558,1082,523,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6275,14685,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1846,558,1082,523,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6276,14686,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1854,558,1082,523,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6277,14687,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1863,558,1082,523,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0);
INSERT INTO `npc` VALUES
(6278,14688,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1871,558,1082,523,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6279,14689,'Mechanic Golem','','mechanic_golem','5.00','19.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1880,558,1082,523,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6280,14690,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1900,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6281,14691,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1909,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6282,14692,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1917,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6283,14693,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1926,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6284,14694,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1935,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6285,14695,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1943,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6286,14696,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1952,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6287,14697,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1961,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6288,14698,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1969,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6289,14699,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1978,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6290,14700,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1987,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6291,14701,'Mechanic Golem','','mechanic_golem','5.00','19.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1995,562,1095,526,278,0,253,0,0,0,30,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.72','false',0,0),
(6292,14702,'Big Boom','','big_boom','6.00','13.00',60,'male','L2Pet','npc',40,3054,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6293,14703,'Big Boom','','big_boom','6.00','13.00',64,'male','L2Pet','npc',40,3384,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6294,14704,'Big Boom','','big_boom','6.00','13.00',68,'male','L2Pet','npc',40,3706,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6295,14705,'Big Boom','','big_boom','6.00','13.00',72,'male','L2Pet','npc',40,4013,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6296,14706,'Big Boom','','big_boom','6.00','13.00',76,'male','L2Pet','npc',40,4297,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,48,140,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6297,14707,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6298,14708,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6299,14709,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6300,14710,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6301,14711,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6302,14712,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6303,14713,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6304,14714,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6305,14715,'Big Boom','','big_boom','6.00','13.00',78,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6306,14716,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6307,14717,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6308,14718,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6309,14719,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6310,14720,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6311,14721,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6312,14722,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6313,14723,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6314,14724,'Big Boom','','big_boom','6.00','13.00',79,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6315,14725,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6316,14726,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6317,14727,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6318,14728,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6319,14729,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6320,14730,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6321,14731,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6322,14732,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6323,14733,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6324,14734,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6325,14735,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6326,14736,'Big Boom','','big_boom','6.00','13.00',80,'male','L2Pet','npc',40,4550,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,253,0,0,0,48,140,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6327,14737,'Siege Golem','','siege_golem','60.00','140.00',55,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,2592,1205,360,1242,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6328,14738,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3036,1397,484,1440,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6329,14739,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3066,1397,484,1440,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6330,14740,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3096,1397,484,1440,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6331,14741,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3126,1397,484,1440,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6332,14742,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3156,1397,484,1440,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6333,14743,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3186,1397,484,1440,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6334,14744,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3216,1397,484,1440,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6335,14745,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3246,1397,484,1440,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6336,14746,'Siege Golem','','siege_golem','60.00','140.00',78,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3276,1397,484,1440,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6337,14747,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3326,1406,490,1449,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6338,14748,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3356,1406,490,1449,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6339,14749,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3386,1406,490,1449,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6340,14750,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3417,1406,490,1449,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6341,14751,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3447,1406,490,1449,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6342,14752,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3477,1406,490,1449,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6343,14753,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3507,1406,490,1449,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6344,14754,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3538,1406,490,1449,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6345,14755,'Siege Golem','','siege_golem','60.00','140.00',79,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3568,1406,490,1449,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6346,14756,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3619,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6347,14757,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3650,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6348,14758,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3680,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6349,14759,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3711,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6350,14760,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3741,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6351,14761,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3772,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6352,14762,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3802,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6353,14763,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3832,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6354,14764,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3863,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6355,14765,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3893,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6356,14766,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3924,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6357,14767,'Siege Golem','','siege_golem','60.00','140.00',80,'male','L2Pet','npc',80,790000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,3954,1414,496,1457,165,0,150,0,0,0,40,40,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6358,14768,'Wild Hog Cannon','','range_golem','93.00','90.00',60,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,888,709,478,730,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6359,14769,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1012,794,601,818,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6360,14770,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1022,794,601,818,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6361,14771,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1032,794,601,818,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6362,14772,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1042,794,601,818,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6363,14773,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1052,794,601,818,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6364,14774,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1062,794,601,818,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6365,14775,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1072,794,601,818,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6366,14776,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1082,794,601,818,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6367,14777,'Wild Hog Cannon','','range_golem','93.00','90.00',78,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1092,794,601,818,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6368,14778,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1108,799,608,823,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6369,14779,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1118,799,608,823,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6370,14780,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1128,799,608,823,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6371,14781,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1139,799,608,823,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6372,14782,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1149,799,608,823,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6373,14783,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1159,799,608,823,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6374,14784,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1169,799,608,823,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6375,14785,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1179,799,608,823,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6376,14786,'Wild Hog Cannon','','range_golem','93.00','90.00',79,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1189,799,608,823,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6377,14787,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1206,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6378,14788,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1216,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6379,14789,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1226,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6380,14790,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1237,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6381,14791,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1247,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6382,14792,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1257,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6383,14793,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1267,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6384,14794,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1277,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6385,14795,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1287,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6386,14796,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1297,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6387,14797,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1308,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6388,14798,'Wild Hog Cannon','','range_golem','93.00','90.00',80,'male','L2Pet','npc',40,3153,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,1318,804,615,828,278,0,253,0,0,0,10,10,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6389,14799,'Dark Panther','','dark_fencer','7.00','13.00',42,'male','L2Pet','npc',40,1826,'5.500',679,'2.100',40,43,30,21,20,25,0,0,311,215,152,202,278,0,253,0,0,0,25,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.20','false',0,0),
(6390,14800,'Dark Panther','','dark_fencer','7.00','13.00',51,'male','L2Pet','npc',40,2555,'6.500',993,'2.400',40,43,30,21,20,25,0,0,539,286,281,268,278,0,253,0,0,0,25,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.20','false',0,0),
(6391,14801,'Dark Panther','','dark_fencer','7.00','13.00',60,'male','L2Pet','npc',40,3359,'6.500',1327,'2.400',40,43,30,21,20,25,0,0,860,368,478,345,278,0,253,0,0,0,25,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.20','false',0,0),
(6392,14802,'Dark Panther','','dark_fencer','7.00','13.00',64,'male','L2Pet','npc',40,3722,'7.500',1482,'2.700',40,43,30,21,20,25,0,0,1031,408,589,382,278,0,253,0,0,0,25,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.20','false',0,0),
(6393,14803,'Dark Panther','','dark_fencer','7.00','13.00',68,'male','L2Pet','npc',40,4076,'7.500',1641,'2.700',40,43,30,21,20,25,0,0,1217,449,713,421,278,0,253,0,0,0,25,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.20','false',0,0),
(6394,14804,'Dark Panther','','dark_fencer','7.00','13.00',72,'male','L2Pet','npc',40,4414,'8.500',1804,'3.000',40,43,30,21,20,25,0,0,1413,491,849,460,278,0,253,0,0,0,25,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.20','false',0,0),
(6395,14805,'Dark Panther','','dark_fencer','7.00','13.00',76,'male','L2Pet','npc',40,4727,'8.500',1972,'3.000',40,43,30,21,20,25,0,0,1614,534,994,500,278,0,253,0,0,0,25,150,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.20','false',0,0),
(6396,14806,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1723,555,1069,520,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6397,14807,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1732,555,1069,520,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6398,14808,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1740,555,1069,520,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6399,14809,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1749,555,1069,520,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6400,14810,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1757,555,1069,520,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6401,14811,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1766,555,1069,520,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6402,14812,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1775,555,1069,520,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6403,14813,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1783,555,1069,520,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6404,14814,'Dark Panther','','dark_fencer','7.00','13.00',78,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1792,555,1069,520,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6405,14815,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1811,558,1082,523,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6406,14816,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1820,558,1082,523,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6407,14817,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1828,558,1082,523,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6408,14818,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1837,558,1082,523,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6409,14819,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1846,558,1082,523,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6410,14820,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1854,558,1082,523,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6411,14821,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1863,558,1082,523,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6412,14822,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1871,558,1082,523,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6413,14823,'Dark Panther','','dark_fencer','7.00','13.00',79,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1880,558,1082,523,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6414,14824,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1900,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6415,14825,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1909,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6416,14826,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1917,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6417,14827,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1926,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6418,14828,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1935,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6419,14829,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1943,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6420,14830,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1952,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6421,14831,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1961,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6422,14832,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1969,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6423,14833,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1978,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6424,14834,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1987,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6425,14835,'Dark Panther','','dark_fencer','7.00','13.00',80,'male','L2Pet','npc',40,5025,'8.500',2143,'3.000',40,43,30,21,20,25,0,0,1995,562,1095,526,278,0,253,0,0,0,25,150,'',0,'Local','',0,0,0,7,50,4,4,0,0,'0.20','false',0,0),
(6426,14836,'Feline King','','king_of_cat','6.00','16.01',80,'male','L2Pet','npc',40,5461,'13.430',2143,'3.090',40,43,30,21,20,25,0,0,2606,795,1662,840,278,0,333,0,0,0,52,198,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(6427,14837,'Magnus the Unicorn','','unicorn_magnus','13.50','17.00',80,'male','L2Pet','npc',40,5461,'13.430',2143,'3.090',40,43,30,21,20,25,0,0,2369,795,3510,840,278,0,333,0,0,0,52,198,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(6428,14838,'Spectral Lord','','spectral_knight','12.50','33.50',80,'male','L2Pet','npc',40,4550,'13.430',2143,'3.090',40,43,30,21,20,25,0,0,1994,576,1671,538,278,0,333,0,0,0,52,198,NULL,NULL,'Local',NULL,0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0.00','false',0,0),
(6429,14839,'Swoop Cannon','','toad_cannon','45.00','47.50',68,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6430,14840,'Swoop Cannon','','toad_cannon','45.00','47.50',69,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6431,14841,'Swoop Cannon','','toad_cannon','45.00','47.50',70,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6432,14842,'Swoop Cannon','','toad_cannon','45.00','47.50',71,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6433,14843,'Swoop Cannon','','toad_cannon','45.00','47.50',72,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6434,14844,'Swoop Cannon','','toad_cannon','45.00','47.50',73,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6435,14845,'Swoop Cannon','','toad_cannon','45.00','47.50',74,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6436,14846,'Swoop Cannon','','toad_cannon','45.00','47.50',75,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6437,14847,'Swoop Cannon','','toad_cannon','45.00','47.50',76,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6438,14848,'Swoop Cannon','','toad_cannon','45.00','47.50',77,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6439,14849,'Swoop Cannon','','toad_cannon','45.00','47.50',78,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6440,14850,'Swoop Cannon','','toad_cannon','45.00','47.50',79,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6441,14851,'Swoop Cannon','','toad_cannon','45.00','47.50',80,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6442,14852,'Swoop Cannon','','toad_cannon','45.00','47.50',81,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6443,14853,'Swoop Cannon','','toad_cannon','45.00','47.50',82,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6444,14854,'Swoop Cannon','','toad_cannon','45.00','47.50',83,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6445,14855,'Swoop Cannon','','toad_cannon','45.00','47.50',84,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6446,14856,'Swoop Cannon','','toad_cannon','45.00','47.50',85,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6447,14857,'Swoop Cannon','','toad_cannon','45.00','47.50',86,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6448,14858,'Swoop Cannon','','toad_cannon','45.00','47.50',87,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6449,14859,'Swoop Cannon','','toad_cannon','45.00','47.50',88,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6450,14860,'Swoop Cannon','','toad_cannon','45.00','47.50',89,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6451,14861,'Swoop Cannon','','toad_cannon','45.00','47.50',90,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6452,14862,'Swoop Cannon','','toad_cannon','45.00','47.50',91,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6453,14863,'Swoop Cannon','','toad_cannon','45.00','47.50',92,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6454,14864,'Swoop Cannon','','toad_cannon','45.00','47.50',93,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6455,14865,'Swoop Cannon','','toad_cannon','45.00','47.50',94,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6456,14866,'Swoop Cannon','','toad_cannon','45.00','47.50',95,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0);
INSERT INTO `npc` VALUES
(6457,14867,'Swoop Cannon','','toad_cannon','45.00','47.50',96,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6458,14868,'Swoop Cannon','','toad_cannon','45.00','47.50',97,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6459,14869,'Swoop Cannon','','toad_cannon','45.00','47.50',98,'male','L2Pet','npc',40,79000,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,122,1314,428,1354,165,0,333,0,0,0,44,44,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.69','false',0,0),
(6460,16013,'Trained Buffalo','','buffalo','22.00','31.00',67,'male','L2TamedBeast','Fighter',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,0,0,1169,439,681,356,278,0,253,0,0,0,20,170,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,'0.46','false',0,0),
(6461,16014,'Trained Buffalo','','buffalo','22.00','31.00',67,'male','L2TamedBeast','Fighter',40,3626,'15.000',1388,'2.700',40,43,30,21,20,10,0,0,1169,439,681,356,278,0,253,0,0,0,20,170,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,'0.46','false',0,0),
(6462,16015,'Trained Cougar','','saber_toothed_tiger','12.00','22.00',69,'male','L2TamedBeast','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,0,0,1265,460,746,373,278,0,253,0,0,0,60,175,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,'0.45','false',0,0),
(6463,16016,'Trained Cougar','','saber_toothed_tiger','12.00','22.00',69,'male','L2TamedBeast','Fighter',40,3784,'15.000',1458,'2.700',40,43,30,21,20,10,0,0,1265,460,746,373,278,0,253,0,0,0,60,175,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,'0.45','false',0,0),
(6464,16017,'Trained Kookaburra','','pet_ostrich','10.00','33.00',65,'male','L2TamedBeast','Fighter',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,23,190,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,'0.50','false',0,0),
(6465,16018,'Trained Kookaburra','','pet_ostrich','10.00','33.00',65,'male','L2TamedBeast','Fighter',40,3465,'15.000',1319,'2.700',40,43,30,21,20,10,0,0,1077,418,619,340,278,0,253,0,0,0,23,190,'pet_clan',400,'Local','',0,0,0,15,30,4,4,0,0,'0.50','false',0,0),
(6466,16019,'Tiny Baby Buffalo','','baby_buffalo','12.00','15.00',0,'male','L2Pet','npc',40,751,'1.500',331,'1.500',40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.48','false',1,0),
(6467,16020,'Tame Tiny Baby Buffalo','','baby_buffalo','12.00','15.00',0,'male','L2Pet','npc',40,751,'1.500',331,'1.500',40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.48','false',0,0),
(6468,16021,'Tiny Baby Cougar','','baby_tiger','11.00','15.70',0,'male','L2Pet','npc',40,751,'1.500',331,'1.500',40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,28,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.48','false',1,0),
(6469,16022,'Tame Tiny Baby Cougar','','baby_tiger','11.00','15.70',0,'male','L2Pet','npc',40,751,'1.500',331,'1.500',40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,28,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.48','false',0,0),
(6470,16023,'Tiny Baby Kookaburra','','baby_ostrich','7.00','15.00',0,'male','L2Pet','npc',40,751,'1.500',331,'1.500',40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.48','false',1,0),
(6471,16024,'Tame Tiny Baby Kookaburra','','baby_ostrich','7.00','15.00',0,'male','L2Pet','npc',40,751,'1.500',331,'1.500',40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.48','false',0,0),
(6472,12077,'Wolf','','pet_wolf','13.00','11.50',15,'male','L2Pet','npc',40,195,'2.500',164,'1.200',40,43,30,21,20,25,0,0,9,19,3,17,282,0,257,0,0,0,24,125,'',0,'Local','',0,0,0,1200,7,4,4,0,0,'0.39','false',0,0),
(6473,12311,'Hatchling of the Wind','','hatchling','9.00','10.00',35,'male','L2Pet','npc',40,610,'4.500',433,'1.800',40,43,30,21,20,25,0,0,48,42,22,39,282,0,257,0,0,0,80,140,'',0,'Local','',0,0,0,1200,7,4,4,0,0,'0.27','false',0,0),
(6474,12312,'Hatchling of the Stars','','hatchling','9.00','10.00',35,'male','L2Pet','npc',40,610,'4.500',433,'1.800',40,43,30,21,20,25,0,0,48,42,22,39,282,0,257,0,0,0,80,140,'',0,'Local','',0,0,0,1200,7,4,4,0,0,'0.27','false',0,0),
(6475,12313,'Hatchling of Twilight','','hatchling','9.00','10.00',35,'male','L2Pet','npc',40,610,'4.500',433,'1.800',40,43,30,21,20,25,0,0,48,42,22,39,282,0,257,0,0,0,80,140,'',0,'Local','',0,0,0,1200,7,4,4,0,0,'0.27','false',0,0),
(6476,12526,'Wind Strider','','strider','23.00','31.00',55,'male','L2Pet','npc',40,2728,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,703,332,360,301,282,0,257,0,0,0,80,170,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.25','false',0,0),
(6477,12527,'Star Strider','','strider','23.00','31.00',55,'male','L2Pet','npc',40,2728,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,703,332,360,301,282,0,257,0,0,0,80,170,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.25','false',0,0),
(6478,12528,'Twilight Strider','','strider','23.00','31.00',55,'male','L2Pet','npc',40,2728,'6.500',1138,'2.400',40,43,30,21,20,25,0,0,703,332,360,301,282,0,257,0,0,0,80,170,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.25','false',0,0),
(6479,12564,'Sin Eater','','imp','10.00','24.00',15,'male','L2Pet','npc',40,195,'2.500',164,'1.200',40,1,30,21,20,25,0,0,9,19,3,17,282,0,257,0,0,0,60,125,'',0,'Local','',0,0,0,1200,7,4,4,0,0,'0.34','false',0,0),
(6480,12621,'Wyvern','','wyvern','60.00','80.00',70,'male','L2Monster','Fighter',40,3862,'7.500',1722,'2.700',40,43,30,21,20,25,0,0,1335,470,780,440,282,0,257,0,0,0,80,170,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.60','true',0,0),
(6481,12780,'Baby Buffalo','','baby_buffalo','12.00','15.00',25,'male','L2Pet','npc',40,751,'1.500',331,'1.500',40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,30,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.48','false',0,0),
(6482,12781,'Baby Kookaburra','','baby_ostrich','7.00','15.00',25,'male','L2Pet','npc',40,751,'1.500',331,'1.500',40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,13,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.50','false',0,0),
(6483,12782,'Baby Cougar','','baby_tiger','11.00','15.70',25,'male','L2Pet','npc',40,751,'1.500',331,'1.500',40,43,30,21,20,25,0,0,88,119,37,112,282,0,257,0,0,0,28,120,'',0,'Local','',0,0,0,1200,30,4,4,0,0,'0.48','false',0,0),
(6484,12774,'Young Squash','','drop_gourd_50_sm','10.00','10.50',1,'etc','L2Monster','Fighter',40,10,'0.900',0,'0.000',40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6485,12775,'High Quality Squash','','drop_gourd','20.00','21.00',1,'etc','L2Monster','Fighter',40,20,'0.900',0,'0.000',40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6486,12776,'Low Quality Squash','','drop_gourd_25_sm','15.00','16.00',1,'etc','L2Monster','Fighter',40,20,'0.900',0,'0.000',40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6487,12777,'Large Young Squash','','drop_gourd','20.00','21.00',1,'etc','L2Monster','Fighter',40,25,'0.900',0,'0.000',40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6488,12778,'High Quality Large Squash','','drop_gourd_50_bi','30.00','31.50',1,'etc','L2Monster','Fighter',40,50,'0.900',0,'0.000',40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6489,12779,'Low Quality Large Squash','','drop_gourd_25_bi','25.00','26.50',1,'etc','L2Monster','Fighter',40,50,'0.900',0,'0.000',40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6490,13001,'Heart of Warding','','heart_of_warding','17.00','75.00',70,'etc','L2Merchant','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1314,470,780,382,282,0,257,0,0,0,50,120,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',1,0),
(6491,13002,'Life Control Tower','','alive_castle_aden_controltower_jewel','7.00','35.00',20,'etc','L2ControlTower','npc',40,10000,'50.000',213,'1.200',40,43,30,21,20,10,40,0,57,837,23,674,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(6492,13003,'Life Control Tower','','dead_castle_aden_controltower_jewel','7.00','35.00',20,'etc','L2FakeTower','npc',40,10000,'50.000',213,'1.200',40,43,30,21,20,10,40,0,57,837,23,674,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(6493,13004,'Flame Control Tower','','alive_castle_aden_controltower_jewel','7.00','35.00',20,'etc','L2ControlTower','npc',40,10000,'50.000',213,'1.200',40,43,30,21,20,10,40,0,57,837,23,674,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(6494,13005,'Flame Control Tower','','dead_castle_aden_controltower_jewel','7.00','35.00',20,'etc','L2FakeTower','npc',40,10000,'50.000',213,'1.200',40,43,30,21,20,10,40,0,57,837,23,674,282,0,257,0,0,0,50,0,'',0,'Local','',0,0,0,7,30,4,3,0,0,'0.60','false',0,0),
(6495,13006,'Christmas Tree','','x_mas_tree','0.00','0.00',70,'male','L2XmassTree','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6496,13007,'Special Christmas Tree','','x_mas_tree_50_bi','0.00','0.00',70,'male','L2XmassTree','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6497,13014,'','','clear_npc','00.10','00.10',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6498,13015,'','','Evilate_weather','16.00','18.50',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6499,13016,'King Squash','','drop_gourd','20.00','21.00',1,'etc','L2Monster','Fighter',40,75,'0.900',0,'0.000',40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6500,13017,'Emperor Squash','','drop_gourd_50_bi','30.00','31.50',1,'etc','L2Monster','Fighter',40,100,'0.900',0,'0.000',40,43,30,21,20,10,0,0,4,41000,3,33000,278,0,253,0,0,0,30,80,'',0,'Local','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),
(6501,13018,'','','skill_dummy_00_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6502,13019,'','','skill_dummy_00_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6503,13020,'','','skill_dummy_00_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6504,13021,'','','skill_dummy_00_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6505,13022,'','','skill_dummy_00_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6506,13023,'','','skill_dummy_00_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6507,13024,'','','skill_dummy_00_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6508,13025,'','','skill_dummy_01_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6509,13026,'','','skill_dummy_01_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6510,13027,'','','skill_dummy_01_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6511,13028,'','','skill_dummy_01_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6512,13029,'','','skill_dummy_01_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6513,13030,'','','skill_dummy_01_a','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6514,13031,'Huge Cursed Pig','','E_pig_ball','15.00','18.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6515,13032,'Huge Cursed Pig','','E_pig_ball','15.00','18.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6516,13033,'Huge Cursed Pig','','E_pig_ball','15.00','18.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6517,13034,'Super Huge Cursed Pig','','E_pig_ball_H','29.00','38.70',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6518,13035,'Golden Cursed Pig','','E_pig_ball','15.00','18.30',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6519,13036,'Alchemist''s Chest','','mimic_even','8.50','8.50',1,'etc','L2Monster','Fighter',40,205,'0.900',0,'0.000',40,43,30,21,20,10,0,0,4,41,3,33,278,0,253,0,0,0,30,80,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.60','false',0,0),

-- The Kamael NPC,MOBS
(6520,13037,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6521,13038,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6522,13039,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6523,13040,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6524,13041,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6525,13042,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6526,13043,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6527,13044,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6528,13045,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6529,13046,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6530,13047,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6531,13048,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6532,13049,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6533,13050,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6534,13051,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6535,13052,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6536,13053,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6537,13054,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6538,13055,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6539,13056,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6540,13057,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6541,13058,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6542,13059,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6543,13060,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6544,13061,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6545,13062,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6546,13063,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6547,13064,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6548,13065,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6549,13066,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6550,13067,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6551,13068,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6552,13069,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6553,13070,'Trap','','trap_mark','5.00','10.00',70,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6554,13071,'Virtual Image','','Decoy_Medium','8.50','25.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6555,13072,'Virtual Image','','Decoy_Medium','8.50','25.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6556,13073,'Virtual Image','','Decoy_Medium','8.50','25.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6557,13074,'Virtual Image','','Decoy_Medium','8.50','25.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6558,13075,'Virtual Image','','Decoy_Medium','8.50','25.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6559,13076,'Virtual Image','','Decoy_Medium','8.50','25.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6560,13077,'Onyx Beast','','onyx_beast','14.00','14.50',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6561,13078,'Doom Wraith','','death_blader_tr','13.00','25.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6562,13079,'Grail Apostle','','apostle_grail_tr','10.00','35.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6563,13080,'Grail Apostle','','apostle_warrior','8.00','30.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6564,13081,'Unicorn','','Unicorn_tr','15.00','28.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6565,13082,'Lilim Knight','','lilim_knight_tr','12.00','25.50',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6566,13083,'Golem Guardian','','golem_guardian_tr','13.00','25.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6567,13084,'Inferno Drake','','inferno_drake_tr','24.00','35.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6568,13085,'Dragon Bomber','','antaras_ex_b_tr','16.00','24.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6569,13086,'Zariche','','Avatar_Z','12.00','31.57',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6570,13087,'Akamanah','','Avatar_A','10.00','32.73',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6571,13088,'Final Form','','Specular_Form','9.00','38.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6572,13089,'Final Form','','Specular_Form_F','10.00','32.76',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6573,13090,'Native','','a_common_peopleC_Mhuman','8.00','23.50',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6574,13091,'Yeti','','yeti','15.00','27.50',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6575,13092,'Buffalo','','buffalo','22.00','31.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6576,13093,'Pig','','E_pig_ball','15.00','18.30',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6577,13094,'Zombie','','zombie_laborer','11.00','24.60',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6578,13095,'Pixy','','pixy','5.00','25.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6579,13096,'Rabbit','','rabbit','5.00','4.50',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0),
(6580,13097,'','','skill_dummy_00_a','5.00','10.00',30,'male','L2Npc','npc',40,3862,'7.500',1493,'2.700',40,43,30,21,20,10,490,0,1335,470,780,382,278,0,253,0,0,0,30,120,'',0,'Magister','',0,0,0,7,30,4,4,0,0,'0.52','false',0,0);